
// FILE: assets/js/util/Constants.js
function PMConstants() {
    this.ACTIVE   = 'A';
    this.INACTIVE = 'I';
    
    this.TYPE_PROJECT_MEETING = 'M';
    this.TYPE_PROJECT_MEETING_OCCURRENCES = 'O';
    this.TYPE_PROJECT_CONTROL_STANDARD = 'P';
    this.TYPE_PROJECT_CONTROL_PRODUCT = 'R';
    this.TYPE_PROJECT_CONTROL_RELEASE = 'B';
    this.TYPE_PROJECT_CONTROL_SUB_RELEASE = 'I';
    this.TYPE_PROJECT_CONTROL_ISSUE = 'E';
    this.TYPE_PROJECT_CONTROL_ERROR = 'S';
    this.TYPE_PROJECT_CONTROL_TIME_LINE = 'L';

    this.ARRAY_TYPE_PROJECT_NOT_MEETING = [
        this.TYPE_PROJECT_CONTROL_STANDARD ,
        this.TYPE_PROJECT_CONTROL_PRODUCT ,
        this.TYPE_PROJECT_CONTROL_RELEASE ,
        this.TYPE_PROJECT_CONTROL_SUB_RELEASE ,
        this.TYPE_PROJECT_CONTROL_ISSUE ,
        this.TYPE_PROJECT_CONTROL_ERROR
    ];
    this.BEGIN_TASK_STATUS_ISSUE = 'B';
    
    this.CONTROL_TASK_TYPE_BACKLOG     = 'B';
    this.CONTROL_TASK_TYPE_IN_PROGRESS = 'I';
    this.CONTROL_TASK_TYPE_DONE        = 'D';
    this.CONTROL_TASK_TYPE_TO_DO       = 'T';
    this.CONTROL_TASK_TYPE_HOMOLOGATED = 'H';

    this.CONTROL_TASK_STATUS_BACKLOG = 'B';

    this.DEFAULT_FRAMING = [
        this.CONTROL_TASK_TYPE_BACKLOG, 
        this.CONTROL_TASK_TYPE_IN_PROGRESS,
        this.CONTROL_TASK_TYPE_DONE,
        this.CONTROL_TASK_TYPE_TO_DO
    ];
}

Configuration(function (ContextRegister) {
    ContextRegister.register('PMConstants', PMConstants);
});


// FILE: assets/js/util/DateManager.js
/**
 * Created by tuliomagalhaes on 15/10/2014.
 */
function DateManager(requestDataSourceEngine,ScreenService){

    var WEEK =["Sunday","Monday","Tuesday","Wednesday","Thursday", "Friday","Saturday"];
    var WEEK_BR_LABEL =[ 'DOM','SEG','TER','QUA','QUI','SEX','SAB'];
    var Utilities;
    var SHOULD_START = 'DI';
    var SHOULD_END = 'DT';
    var DO_NOT_START_BEFORE = 'IA';
    var DO_NOT_START_AFTER = 'ID';
    var DO_NOT_END_BEFORE = 'TA';
    var DO_NOT_END_AFTER = 'TD';
    var AS_SOON_AS_POSSIBLE = 'MB';
    var AS_LATE_AS_POSSIBLE = 'MT';

    this.getweekBrLabelByWeekNumber = function(weekNumber){
       return WEEK_BR_LABEL[weekNumber];
    };
    /** returns the difference between two moments in the format (HHH: mm)
     *
     * @param  dateBegin format DD/MM/YYYY HH:mm:ss
     * @param  dateEnd format DD/MM/YYYY HH:mm:ss
     * @returns string
     */
    this.diffDateAppropriation = function(dateBegin,dateEnd){
        var diffMiliseconds = moment(dateEnd,"DD/MM/YYYY HH:mm:ss").diff(moment(dateBegin,"DD/MM/YYYY HH:mm:ss"));
        return Math.floor( moment.duration(diffMiliseconds).asHours()) + moment.utc(diffMiliseconds).format(":mm");

    }; /** returns the difference between two moments in the format (HH: mm)
     *
     * @param  dateBegin format DD/MM/YYYY HH:mm:ss
     * @param  dateEnd format DD/MM/YYYY HH:mm:ss
     * @returns string
     */
    this.diffDateAppropriationInHHmm = function(dateBegin,dateEnd){
        var diffMiliseconds = moment(dateEnd,"DD/MM/YYYY HH:mm:ss").diff(moment(dateBegin,"DD/MM/YYYY HH:mm:ss"));
        return  moment.utc(diffMiliseconds).format("HH:mm");

    };
    /**
     *
     * @param {moment}date
     * @param {[]|Object[]} exceptions
     * @returns {boolean}
     */
    function calendarExceptions(date,exceptions){
        var validateExceptions = true;
        //exceptions.forEach(function(exception){
        //    if(exception.TYPE_NAME === "E"){
        //        var exceptionBegin  =  moment(exception.BEGIN_DATE_LIST,'DD/MM/YYYY');
        //        var exceptionEnd    =  moment(exception.END_DATE_LIST,'DD/MM/YYYY');
        //        if( date.valueOf() >= exceptionBegin._d.valueOf() && date.valueOf() <= exceptionEnd._d.valueOf()){
        //            validateExceptions = false;
        //        }
        //    }
        //});
        return validateExceptions;
    }
    /**
     *
     * @param {moment} begin
     * @param {moment} end
     * @param {[]}  calendarWeek
     * @param {[]|Object[]} exceptions
     * @returns {number}
     */
    function calculateDateDifferenceCalendar(begin,end,calendarWeek,exceptions){

        var total = 0;
        while(begin < end){
            if((calendarWeek.indexOf(begin.day()) != -1 ) && calendarExceptions(begin,exceptions)) {
                total++;
            }
            begin._d.addDays(1);
        }
        while(!((calendarWeek.indexOf(begin.day()) != -1  ) && calendarExceptions(begin,exceptions))){
            begin._d.addDays(1);
        }
        return total+1;
    }

    this.calculateDateDifference = function(row,exceptions,calendarWeek) {
        var start = row.START;
        var end = row.END;
        if (start !== '' && end !== '') {
            start = moment(start, 'YYYY-MM-DD');
            end = moment(end, 'YYYY-MM-DD');
            if (start <= end) {
                row.TOTAL_TIME = calculateDateDifferenceCalendar(start, end, calendarWeek, exceptions) + "D";
                row.END = start.format('YYYY-MM-DD');
            }
        }
        return  row.TOTAL_TIME;
    };

    function applyDateDifferenceCalendar(begin,difference,calendarWeek,exceptions){
        begin = moment(begin, 'YYYY-MM-DD');

        while(difference>0){
            begin._d.addDays(1);
            if( (calendarWeek.indexOf(begin.day()) != -1 )&& calendarExceptions(begin,exceptions)) {
                difference--;
            }
        }
        return begin.format('YYYY-MM-DD');
    }
    function applyDateDifferenceCalendarByEnd(end,difference,calendarWeek,exceptions){
        end = moment(end, 'YYYY-MM-DD');

        while(difference>0){
            end._d.addDays(-1);
            if( (calendarWeek.indexOf(end.day()) != -1 ) && calendarExceptions(end,exceptions)) {
                difference--;
            }
        }
        return end.format('YYYY-MM-DD');
    }

    function applyHourDifference(totalHours,hoursDay,exceptions,begin,calendarWeek){

        begin = moment(begin, 'YYYY-MM-DD');

        var checkPeriodException = function(exception) {
            if(exception){
                if(exception.TYPE_NAME === "Workweek"){
                    var exceptionBegin  =  moment(exception.BEGIN_DATE_LIST,'DD/MM/YYYY');
                    var exceptionEnd    =  moment(exception.END_DATE_LIST,'DD/MM/YYYY');
                    if( begin.valueOf() >= exceptionBegin._d.valueOf() && begin.valueOf() <= exceptionEnd._d.valueOf()){
                        hoursDayCurrent = 0;
                        //separating date time
                        var exceptionBeginHour = exception.BEGIN_DATE_LIST.split(' ')[1];
                        var exceptionEndHour = exception.END_DATE_LIST.split(' ')[1];
                        //
                        if(beginHour <= exceptionBeginHour){
                            hoursDayCurrent += exceptionBeginHour.substr(0, 2) - beginHour.substr(0, 2) ;
                        }
                        if(endHour >= exceptionEndHour){
                            hoursDayCurrent += endHour.substr(0, 2) - exceptionEndHour.substr(0, 2) ;
                        }
                    }
                }
            }
        };

        while(totalHours>0){
            //checks the day of the week on the calendar and the exception type "Exception"
            if(calendarWeek.indexOf(begin.day()) != -1 && calendarExceptions(begin,exceptions)) {
                var hoursDayCurrent = hoursDay;
                //verifies that type of exception "Workweek"
                exceptions.forEach(checkPeriodException);
                totalHours-=hoursDayCurrent;
            }
            if(totalHours>0){
                begin._d.addDays(1);
            }
        }
        return  begin.format('YYYY-MM-DD');
    }
    function applyHourDifferenceByEnd(totalHours,hoursDay,exceptions,begin,calendarWeek){

        begin = moment(begin, 'YYYY-MM-DD');

        var checkPeriodException = function(exception){
            if(exception.TYPE_NAME === "Workweek"){
                var exceptionBegin  =  moment(exception.BEGIN_DATE_LIST,'DD/MM/YYYY');
                var exceptionEnd    =  moment(exception.END_DATE_LIST,'DD/MM/YYYY');
                if( begin.valueOf() >= exceptionBegin._d.valueOf() && begin.valueOf() <= exceptionEnd._d.valueOf()){
                    hoursDayCurrent = 0;
                    //separating date time
                    var exceptionBeginHour = exception.BEGIN_DATE_LIST.split(' ')[1];
                    var exceptionEndHour = exception.END_DATE_LIST.split(' ')[1];
                    //
                    if(beginHour <= exceptionBeginHour){
                        hoursDayCurrent += exceptionBeginHour.substr(0, 2) - beginHour.substr(0, 2) ;
                    }
                    if(endHour >= exceptionEndHour){
                        hoursDayCurrent += endHour.substr(0, 2) - exceptionEndHour.substr(0, 2) ;
                    }
                }
            }
        };

        while(totalHours>0){
            //checks the day of the week on the calendar and the exception type "Exception"
            if( (calendarWeek.indexOf(begin.day()) != -1 )&& calendarExceptions(begin,exceptions)) {
                var hoursDayCurrent = hoursDay;
                //verifies that type of exception "Workweek"
                exceptions.forEach(checkPeriodException);
                totalHours-=hoursDayCurrent;
            }
            if(totalHours>0){
                begin._d.addDays(-1);
            }
        }
        return  begin.format('YYYY-MM-DD');
    }

    var getValuesPrecursorTask = function (precursor,precursorField) {
        var beginTaskPrecursor = null;
        var endTaskPrecursor = null;
        var previousTime = null;
        var dataPrecursor = precursorField.dataSource.data;
        dataPrecursor.forEach(function (data) {
                if (data.ID == precursor) {
                    beginTaskPrecursor = data.BEGIN_TASK;
                    endTaskPrecursor = data.END_TASK;
                    previousTime = parseInt(data.PREVIOUS_TIME);
                }
            }
        );
        return {beginTaskPrecursor: beginTaskPrecursor, endTaskPrecursor: endTaskPrecursor, previousTime: previousTime};
    };
    var getBeginParentTask = function (parent,parentField) {
        var beginTask = null;
        var data = parentField.dataSource.data;
        data.forEach(function (data) {
                if (data.ID == parent) {
                    beginTask = data.BEGIN_TASK;
                }
            }
        );
        return beginTask;
    };
    this.setDatePrecursor = function(task,startField, endField, durationField, precursorField, precursorType,
                                     parentField, exceptionField, exceptionDateField,dateBeginProject,resources,project,
                                     latency) {

        var precursor = Utilities.getValueInSelectField(precursorField);
        var parent =  Utilities.getValueInSelectField(parentField);

        if (precursor && precursorType) {
            var  __ret = getValuesPrecursorTask(precursor,precursorField);
            var beginTaskPrecursor = __ret.beginTaskPrecursor;
            var endTaskPrecursor = __ret.endTaskPrecursor;
            var previousTime = __ret.previousTime;
            if (precursorType == 'TI') {
                if(previousTime === 0){
                    endTaskPrecursor = moment(endTaskPrecursor,Utilities.FORMAT_DATE_DEFAULT_ONLY_DATE).add(1, 'days').
                        format(Utilities.FORMAT_DATE_DEFAULT_ONLY_DATE);
                }
                startField.value(endTaskPrecursor);
                self.calendarStart(task,startField, endField, durationField, precursor, precursorType, parent,
                    exceptionField, exceptionDateField,resources,project,latency);
            } else if (precursorType == 'II') {
                startField.value(beginTaskPrecursor);
                self.calendarStart(task,startField, endField, durationField, precursor, precursorType, parent,
                    exceptionField, exceptionDateField,resources,project,latency);
            } else if (precursorType == 'TT') {
                endField.value(endTaskPrecursor);
                self.calendarEnd(task,startField, endField, durationField, precursor, precursorType, parent,
                    exceptionField, exceptionDateField,resources,project,latency);
            } else if (precursorType == 'IT') {
                endField.value(beginTaskPrecursor);
                self.calendarEnd(task,startField, endField, durationField, precursor, precursorType, parent,
                    exceptionField, exceptionDateField,resources,project,latency);

            }
        } else {
            precursorType = null;
            precursor = null;
            if (parent) {
                startField.value(getBeginParentTask(parent,parentField));
            } else {
                startField.value(dateBeginProject);
            }
        }
    };
    this.setVisibleDateException = function(row,widget){
        var fieldDate = widget.getField('DATE_EXCEPTION');
        if(row.DATE_EXCEPTION_ABBREVIATION == 'MB' || row.DATE_EXCEPTION_ABBREVIATION == 'MT'){
            fieldDate.isVisible = false;
            row.DATE_EXCEPTION = null;
        }else{
            fieldDate.isVisible = true;
        }
    };
    this.calendarStart = function(task,startField, endField, durationField, precursor, precursorType, parent,
                                  exceptionField, exceptionDateField,resources,project,latency){
        var row = {};
        row.task = task;
        row.begin = startField.value();
        row.end = endField.value();
        row.duration = durationField.value();
        row.precursor = precursor ? precursor : null;
        row.precursorType = precursorType;
        row.resources = resources;
        row.project = project;
        row.parent = parent ? parent : null;
        row.exception = Utilities.getValueInSelectField(exceptionField);
        row.exceptionDate = exceptionDateField.value();
        row.latency = latency;
        row.changed = true;
        return requestDataSourceEngine.setDataSource('/calculationBasedStartTask', [row]).then(function(reponse){
            if(reponse.dataset.calculationDate[0]){
                var row = reponse.dataset.calculationDate[0];
                startField.value(row.dateBegin);
                endField.value(row.dateEnd);
                exceptionDateField.value(row.exceptionDate);
                Utilities.setOutData(exceptionField,row.exception);
                self.setVisibleDateException(exceptionField.widget.currentRow,exceptionField.widget);
            }
        },function(error){
            ScreenService.showMessage(error);
        });
    };
    this.calendarEnd = function(task,startField, endField, durationField, precursor, precursorType, parent,
                                exceptionField, exceptionDateField,resources,project,latency){
        var row = {};
        row.task = task;
        row.begin = startField.value();
        row.end = endField.value();
        row.duration = durationField.value();
        row.precursor = precursor ? precursor : null;
        row.precursorType = precursorType;
        row.parent = parent ? parent : null;
        row.resources = resources;
        row.project = project;
        row.exception = Utilities.getValueInSelectField(exceptionField);
        row.exceptionDate = exceptionDateField.value();
        row.latency = latency;
        row.changed = true;
        return requestDataSourceEngine.setDataSource('/calculationBasedEndTask', [row]).then(function(reponse){
            if(reponse.dataset.calculationDate[0]){
                var row = reponse.dataset.calculationDate[0];
                startField.value(row.dateBegin);
                endField.value(row.dateEnd);
                exceptionDateField.value(row.exceptionDate);
                Utilities.setOutData(exceptionField,row.exception);
                self.setVisibleDateException(exceptionField.widget.currentRow,exceptionField.widget);
            }
        },function(error){
            ScreenService.showMessage(error);
        });
    };
    this.calendarStartProject = function(task,startField, endField, durationField, parent, exceptionField,
                                         exceptionDateField,group){
        var row = {};
        row.task = task;
        row.begin = startField.value();
        row.end = endField.value();
        row.duration = durationField.value();
        row.parent = parent ? parent : null;
        row.exception = Utilities.getValueInSelectField(exceptionField);
        row.exceptionDate = exceptionDateField.value();
        row.group = group;
        row.changed = true;
        return requestDataSourceEngine.setDataSource('/calculationBasedStartProject', [row]).then(function(reponse){
            if(reponse.dataset.calculationDate[0]){
                var row = reponse.dataset.calculationDate[0];
                endField.value(row.dateEnd);
                exceptionDateField.value(row.exceptionDate);
                Utilities.setOutData(exceptionField,row.exception);
                self.setVisibleDateException(exceptionField.widget.currentRow,exceptionField.widget);
            }
        },function(error){
            ScreenService.showMessage(error);
        });
    };
    this.calendarEndProject = function(task,startField, endField, durationField, parent, exceptionField,
                                       exceptionDateField,group){
        var row = {};
        row.task = task;
        row.begin = startField.value();
        row.end = endField.value();
        row.duration = durationField.value();
        row.parent = parent ? parent : null;
        row.exception = Utilities.getValueInSelectField(exceptionField);
        row.exceptionDate = exceptionDateField.value();
        row.group = group;
        row.changed = true;
        return requestDataSourceEngine.setDataSource('/calculationBasedEndProject', [row]).then(function(reponse){
            if(reponse.dataset.calculationDate[0]){
                var row = reponse.dataset.calculationDate[0];
                startField.value(row.dateBegin);
                exceptionDateField.value(row.exceptionDate);
                Utilities.setOutData(exceptionField,row.exception);
                self.setVisibleDateException(exceptionField.widget.currentRow,exceptionField.widget);
            }
        },function(error){
            ScreenService.showMessage(error);
        });
    };

    var _setExceptionDateOfDateEnd = function (exceptionField, exceptionDateField, endTask) {
        Utilities.setOutData(exceptionField, SHOULD_END);
        exceptionDateField.value(endTask);
    };

    this.newTaskFieldOnChangeEnd = function(taskId,startField, endField, durationField, precursorField, precursorType,
                                            parentField, exceptionField, exceptionDateField,dateBeginProject,resources,
                                            project,latency) {

        var exception = Utilities.getValueInSelectField(exceptionField);
        var endTask = startField.value();
        if (exception == AS_SOON_AS_POSSIBLE) {
            _setExceptionDateOfDateEnd(exceptionField, exceptionDateField, endTask);
        }
    };
    this.setBeginDateByParent = function(taskId,startField, endField, durationField, precursorField, precursorType,
                                         parentField, exceptionField, exceptionDateField,dateBeginProject,
                                         resources,project,latency) {

        var exception = Utilities.getValueInSelectField(exceptionField);
        var parent = Utilities.getValueInSelectField(parentField);
        if(!exception){
            exception = AS_SOON_AS_POSSIBLE;
            Utilities.setOutData(exceptionField,exception);
        }
        if (exception == AS_SOON_AS_POSSIBLE) {
            if (parent) {
                var dateParent = getBeginParentTask(parent, parentField);
                startField.value(dateParent);
            }else{
                startField.value(dateBeginProject);
            }
        }
    };
    this.setExceptionTask = function(taskId,startField, endField, durationField, precursorField, precursorType,
                                              parentField, exceptionField, exceptionDateField,dateBeginProject,
                                              resources,project,latency) {

        var exception = Utilities.getValueInSelectField(exceptionField);
        var exceptionDate = exceptionDateField.value();
        var parent = Utilities.getValueInSelectField(parentField);
        if(!exception){
            exception = AS_SOON_AS_POSSIBLE;
            Utilities.setOutData(exceptionField,exception);
        }
        if (exception == AS_SOON_AS_POSSIBLE) {
            self.setBeginDateByParent(taskId,startField, endField, durationField, precursorField, precursorType,
                                                 parentField, exceptionField, exceptionDateField,dateBeginProject);

        }
        self.setDateByExceptionTask(taskId,startField, endField, durationField, precursorField, precursorType,
                                    parentField, exceptionField, exceptionDateField,dateBeginProject,resources,
                                    project, latency);
    };

    var _setExceptionDateOfDateStart = function (exceptionField, exceptionDateField, beginTask) {
        Utilities.setOutData(exceptionField, SHOULD_START);
        exceptionDateField.value(beginTask);
    };

    this.newTaskFieldOnChangeStart = function(taskId,startField, endField, durationField, precursorField, precursorType,
                                              parentField, exceptionField, exceptionDateField,dateBeginProject,resources,project,latency){

        var exception = Utilities.getValueInSelectField(exceptionField);
        var parent = Utilities.getValueInSelectField(parentField);
        var precursor = Utilities.getValueInSelectField(precursorField);
        var beginTask = startField.value();
        if(exception == AS_SOON_AS_POSSIBLE) {
            if (precursor && precursorType) {
                var __ret = getValuesPrecursorTask(precursor, precursorField);
                var beginTaskPrecursor = __ret.beginTaskPrecursor ? __ret.beginTaskPrecursor : startField;
                var endTaskPrecursor = __ret.endTaskPrecursor ? __ret.endTaskPrecursor : endField; 
                var previousTime = __ret.previousTime ? __ret.previousTime : 0;
                if (precursorType == 'TI') {
                    if (parseInt(previousTime) === 0 ) {
                        endTaskPrecursor = moment(endTaskPrecursor, Utilities.FORMAT_DATE_DEFAULT_ONLY_DATE).add(1, 'days').
                            format(Utilities.FORMAT_DATE_DEFAULT_ONLY_DATE);
                    }
                    if (beginTask != endTaskPrecursor) {
                        _setExceptionDateOfDateStart(exceptionField, exceptionDateField, beginTask);
                    }
                } else if (precursorType == 'II') {
                    if (beginTask != beginTaskPrecursor) {
                        _setExceptionDateOfDateStart(exceptionField, exceptionDateField, beginTask);
                    }
                } else if (precursorType == 'TT') {
                    if (endField != endTaskPrecursor) {
                        _setExceptionDateOfDateStart(exceptionField, exceptionDateField, beginTask);
                    }
                } else if (precursorType == 'IT') {
                    if (endField != beginTaskPrecursor) {
                        _setExceptionDateOfDateStart(exceptionField, exceptionDateField, beginTask);
                    }
                }
            } else if (parent) {
                var beginParent = getBeginParentTask(parent, parentField);
                if (beginTask != beginParent) {
                    _setExceptionDateOfDateStart(exceptionField, exceptionDateField, beginTask);
                }
            }
        }
    };
    this.setExceptionProject = function(taskId,startField, endField, durationField, parentField, exceptionField,
                                        exceptionDateField){

        var exception = Utilities.getValueInSelectField(exceptionField);
        var parent = Utilities.getValueInSelectField(parentField);
        var beginTask = startField.value();
        if(exception == AS_SOON_AS_POSSIBLE) {
            if (parent) {
                var beginParent = getBeginParentTask(parent, parentField);
                if (beginTask != beginParent) {
                    _setExceptionDateOfDateStart(exceptionField, exceptionDateField, beginTask);
                }
            }
        }
    };

    this.setDateByExceptionTask = function(taskId,startField, endField, durationField, precursorField, precursorType,
                                           parentField, exceptionField, exceptionDateField,dateBeginProject,resources,
                                           project, latency) {
        var begin = startField.value();
        var end = endField.value();
        var beginDateTime = moment(begin, Utilities.FORMAT_DATE_DEFAULT_ONLY_DATE);
        var endDDateTime = moment(end, Utilities.FORMAT_DATE_DEFAULT_ONLY_DATE);
        var precursor = Utilities.getValueInSelectField(precursorField);
        var abbreviationException = Utilities.getValueInSelectField(exceptionField);
        var parent = Utilities.getValueInSelectField(parentField);
        var exceptionDate = exceptionDateField.value();
        var exceptionDateTime = moment(end, Utilities.FORMAT_DATE_DEFAULT_ONLY_DATE);
        if (abbreviationException == SHOULD_START && exceptionDate) {
            startField.value(exceptionDate);
            self.calendarStart(taskId, startField, endField, durationField, precursor, precursorType, parent,
                exceptionField, exceptionDateField,resources,project, latency);

        } else if (abbreviationException == SHOULD_END && exceptionDate) {
            endField.value(exceptionDate);
            self.calendarEnd(taskId, startField, endField, durationField, precursor, precursorType, parent,
                exceptionField, exceptionDateField,resources,project, latency);

        } else if (abbreviationException == DO_NOT_START_BEFORE && exceptionDate) {
            if (precursor) {
                self.setDatePrecursor(taskId, startField, endField, durationField, precursorField, precursorType,
                    parentField, exceptionField, exceptionDateField,dateBeginProject,resources,project, latency);
            }
            if (moment(exceptionDate, Utilities.FORMAT_DATE_DEFAULT_ONLY_DATE) >
                moment(begin, Utilities.FORMAT_DATE_DEFAULT_ONLY_DATE)) {
                startField.value(exceptionDate);
            }
            self.calendarStart(taskId, startField, endField, durationField, precursor, precursorType, parent,
                exceptionField, exceptionDateField,resources,project,latency);
        } else if (abbreviationException == DO_NOT_START_AFTER && exceptionDate) {
            if (precursor) {
                self.setDatePrecursor(taskId, startField, endField, durationField, precursorField, precursorType,
                    parentField, exceptionField, exceptionDateField,dateBeginProject,resources,project,latency);
            }
            if (moment(exceptionDate, Utilities.FORMAT_DATE_DEFAULT_ONLY_DATE) <
                moment(begin, Utilities.FORMAT_DATE_DEFAULT_ONLY_DATE)) {
                startField.value(exceptionDate);
            }
            self.calendarStart(taskId, startField, endField, durationField, precursor, precursorType, parent,
                exceptionField, exceptionDateField,resources,project,latency);
        } else if (abbreviationException == DO_NOT_END_BEFORE && exceptionDate) {
            if (precursor) {
                self.setDatePrecursor(taskId, startField, endField, durationField, precursorField, precursorType,
                    parentField, exceptionField, exceptionDateField, dateBeginProject,resources,project,latency);
            }
            if (moment(exceptionDate, Utilities.FORMAT_DATE_DEFAULT_ONLY_DATE) >
                moment(end, Utilities.FORMAT_DATE_DEFAULT_ONLY_DATE)) {
                endField.value(exceptionDate);
            }
            self.calendarEnd(taskId, startField, endField, durationField, precursor, precursorType, parent,
                exceptionField, exceptionDateField,resources,project,latency);
        } else if (abbreviationException == DO_NOT_END_AFTER && exceptionDate) {
            if (precursor) {
                self.setDatePrecursor(taskId, startField, endField, durationField, precursorField, precursorType,
                    parentField, exceptionField, exceptionDateField, dateBeginProject,resources,project,latency);
            }
            if (moment(exceptionDate, Utilities.FORMAT_DATE_DEFAULT_ONLY_DATE) <
                moment(end, Utilities.FORMAT_DATE_DEFAULT_ONLY_DATE)) {
                endField.value(exceptionDate);
            }
            self.calendarEnd(taskId, startField, endField, durationField, precursor, precursorType, parent,
                exceptionField, exceptionDateField,resources,project,latency);
        } else if (abbreviationException == AS_SOON_AS_POSSIBLE) {
            if (precursor) {
                self.setDatePrecursor(taskId, startField, endField, durationField, precursorField, precursorType,
                    parentField, exceptionField, exceptionDateField, dateBeginProject,resources,project,latency);
            } else {
                self.calendarStart(taskId, startField, endField, durationField, precursor, precursorType, parent,
                    exceptionField, exceptionDateField,resources,project,latency);
            }

        } else if (abbreviationException == AS_LATE_AS_POSSIBLE) {
            if (precursor) {
                self.setDatePrecursor(taskId, startField, endField, durationField, precursorField, precursorType,
                    parentField, exceptionField, exceptionDateField, dateBeginProject,resources,project);
            } else {
                self.calendarEnd(taskId, startField, endField, durationField, precursor, precursorType, parent,
                    exceptionField, exceptionDateField,resources,project,latency);
            }
        }
    };  
    this.setDateByExceptionProject= function(projectId,startField, endField, durationField, parentField, exceptionField, 
                                             exceptionDateField,group) {
        var begin = startField.value();
        var end = endField.value();
        var abbreviationException = Utilities.getValueInSelectField(exceptionField);
        var parent = Utilities.getValueInSelectField(parentField);
        var exceptionDate = exceptionDateField.value();
        if (abbreviationException == SHOULD_START && exceptionDate) {
            startField.value(exceptionDate);
            self.calendarStartProject(projectId, startField, endField, durationField, parent, exceptionField, 
                exceptionDateField,group);

        } else if (abbreviationException == SHOULD_END && exceptionDate) {
            endField.value(exceptionDate);
            self.calendarEndProject(projectId, startField, endField, durationField, parent,
                exceptionField, exceptionDateField,group);

        } else if (abbreviationException == DO_NOT_START_BEFORE && exceptionDate) {
           
            if (moment(exceptionDate, Utilities.FORMAT_DATE_DEFAULT_ONLY_DATE) >
                moment(begin, Utilities.FORMAT_DATE_DEFAULT_ONLY_DATE)) {
                startField.value(exceptionDate);
            }
            self.calendarStartProject(projectId, startField, endField, durationField,  parent,
                exceptionField, exceptionDateField,group);
        } else if (abbreviationException == DO_NOT_START_AFTER && exceptionDate) {
          
            if (moment(exceptionDate, Utilities.FORMAT_DATE_DEFAULT_ONLY_DATE) <
                moment(begin, Utilities.FORMAT_DATE_DEFAULT_ONLY_DATE)) {
                startField.value(exceptionDate);
            }
            self.calendarStartProject(projectId, startField, endField, durationField,  parent,
                exceptionField, exceptionDateField,group);
        } else if (abbreviationException == DO_NOT_END_BEFORE && exceptionDate) {
            
            if (moment(exceptionDate, Utilities.FORMAT_DATE_DEFAULT_ONLY_DATE) >
                moment(end, Utilities.FORMAT_DATE_DEFAULT_ONLY_DATE)) {
                endField.value(exceptionDate);
            }
            self.calendarEndProject(projectId, startField, endField, durationField,  parent,
                exceptionField, exceptionDateField,group);
        } else if (abbreviationException == DO_NOT_END_AFTER && exceptionDate) {
            
            if (moment(exceptionDate, Utilities.FORMAT_DATE_DEFAULT_ONLY_DATE) <
                moment(end, Utilities.FORMAT_DATE_DEFAULT_ONLY_DATE)) {
                endField.value(exceptionDate);
            }
            self.calendarEndProject(projectId, startField, endField, durationField,  parent,
                exceptionField, exceptionDateField,group);
        } else if (abbreviationException == AS_SOON_AS_POSSIBLE) {           
            self.calendarStartProject(projectId, startField, endField, durationField,  parent,
                    exceptionField, exceptionDateField,group);
            
        } else if (abbreviationException == AS_LATE_AS_POSSIBLE) {            
            self.calendarEndProject(projectId, startField, endField, durationField,  parent,
                    exceptionField, exceptionDateField,group);
            
        }
    };
    
    this.setUtilities = function(UtilitiesBase){
        Utilities = UtilitiesBase;
    };
    var self = this;

}

Configuration(function(ContextRegister) {
    ContextRegister.register('DateManager', DateManager);
});


// FILE: assets/js/util/FieldsMetaData.js
function FieldsMetaData() {
    this.getProjectFromMergeRequestInAppropriation = function(projectId) {
        return {
            "name": "PROJECT_NAME_" + projectId,
            "label": "Projeto",
            "template": "field/text-edit.html",
            "pmIsGenerated": true,
            "pmProjectId": projectId,
            "pmIsGeneration": true,
            "class": 4,
            "isVisible": true,
            "readOnly": true
        };
    };
    
    this.getIdObjFromViewResponseWidget = function (row) {
        return {
            "name": "ID_" + row.ID,
            "label": "Id",
            "validations": {
                "required": {}
            },
            "isVisible": false,
            "readOnly": true,
            "showOnForm": true,
            "showOnView": true,
            "showOnList": true,
            "fieldGroup": 'FIELD_GROUP_NAME_' + row.ID,
            "class": 2,
            "template": "field/text-edit.html"
        };
    };

    this.getNameObjFromViewResponseWidget = function (row) {
        return {
            "name": "NAME_" + row.ID,
            "label": "Name",
            "validations": {
                "required": {}
            },
            "isVisible": false,
            "readOnly": true,
            "showOnForm": true,
            "fieldGroup": 'FIELD_GROUP_NAME_' + row.ID,
            "showOnView": true,
            "showOnList": true,
            "class": 10,
            "template": "field/text-edit.html"
        };
    };

    this.getResponseObjFromViewResponseWidget = function (row) {
        return {
            "name": "RESPONSE_" + row.ID,
            "label": "Response",
            "validations": {
                "required": {}
            },
            "isVisible": true,
            "readOnly": true,
            "fieldGroup": 'FIELD_GROUP_NAME_' + row.ID,
            "showOnForm": true,
            "showOnView": true,
            "showOnList": true,
            "template": "field/textarea.html"
        };
    };

    this.getResourceNameFromMergeRequestInAppropriation = function(projectId) {
        return {
            "name": "RESOURCE_NAME_" + projectId,
            "label": "Recurso",
            "class": 4,
            "isVisible": true,
            "sameLine": true,
            "template": "zh-select-autocomplete#field/select-autocomplete.html",
            "pmIsGenerated": true,
            "pmProjectId": projectId,
            "descriptionField": "NAME",
            "searchableFields": ["NAME"],
            "valueField": "ID",
            "pmIsGeneration": true,
            "showSelectAs": "tree",
            "hasPagination": false,
            "events": [
                {
                    "name": "FieldOnChange",
                    "code": "AppropriationController.fieldOnChangeEventResource(args);"
                },
                {
                    "name": "FieldBeforeSelectOpen",
                    "code": "Utilities.initializeFieldSelectAutocomplete('MERGE_REQUEST', 'RESOURCE_NAME_" + projectId + "')"
                }
            ],
            "dataSource": {
                "name": "/taskResource",
                "rest": true,
                "localStorage": false,
                "data": [],
                "lazyLoad": true
            },
            "inData": {
                "RESOURCE": "ID"
            },
            "outData": {
                "ID": "RESOURCE_" + projectId,
                "NAME": "RESOURCE_NAME_" + projectId,
                "RATING": "RESOURCE_RATING_" + projectId
            },
            "dataSourceFilter": [ {
                "name": "PROJECT",
                "value": projectId,
                "operator": "="
            } ]
        };
    };

    this.getTaskNameFromMergeRequestInAppropriation = function(projectId) {
        return {
            "name": "TASK_NAME_" + projectId,
            "label": "Tarefa Superior",
            "class": 4,
            "sameLine": true,
            "isVisible": true,
            "template": "zh-select-autocomplete#field/select-autocomplete.html",
            "pmIsGenerated": true,
            "pmProjectId": projectId,
            "descriptionField": "NAME",
            "searchableFields": ["NAME"],
            "hasPagination": false,
            "valueField": "ID",
            "showSelectAs": "tree",
            "pmIsGeneration": true,
            "breadcrumbProperty": "NAME",
            "parentProperty": "PARENT",
            "primaryProperty": "ID",
            "expandingProperty": "NAME",
            "events": [
                {
                    "name": "FieldBeforeSelectOpen",
                    "code": "Utilities.initializeFieldSelectAutocomplete('MERGE_REQUEST', 'TASK_NAME_" + projectId + "')"
                }
            ],
            "outData": {
                "ID": "TASK_" + projectId,
                "NAME": "TASK_NAME_" + projectId
            },
            "dataSource": {
                "rest": true,
                "localStorage": false,
                "name": "/taskParent",
                "data": [],
                "lazyLoad": true
            },
            "dataSourceFilter" : [ {
                name: "projectId",
                operator: '=',
                value: projectId
            }, {
                name: "allTasks",
                operator: '=',
                value: 0
            }, {
                name: "IS_PARENT",
                operator: '=',
                value: 'Y'
            } ]
        };
    };

    this.getTaskResourceFromGenerateTaskInProject = function (taskId,projectId) {
        return {
            "name": "RESOURCE_" + taskId,
            "label": "Recursos",
            "isVisible": true,
            "showOnForm": true,
            "showOnList": false,
            "showOnView": false,
            "pmTaskId": taskId,
            "pmIsGeneration": true,
            "fieldGroup": "TASKS",
            "template": "field/select-multiple.html",
            "class": 3,
            "events": [
                {
                    "name": "FieldOnChange",
                    "code": "ProjectController.fieldOnChangeEventTaskResource(args);"
                }
            ],
            "descriptionField": "NAME",
            "valueField": "ID",
            "dataSource": {
                "name": "/taskResource",
                "rest": true,
                "localStorage": false,
                "data": []
            },
            "dataSourceFilter": [
                {
                    "name": "PROJECT",
                    "value": projectId,
                    "operator": "="
                },
                {
                    "name": "TASK_CLASSIFICATION",
                    "value": "@getLocalVar('taskClassificationControl') ? getLocalVar('taskClassificationControl') : 0@",
                    "operator": "="
                }
            ]
        };
    };

    this.getTaskRemoveFromGenerateTaskInProject = function (taskId) {
        return {
            "name": "removeTaskMergeGeneration_" + taskId,
            "label": null,
            "isVisible": true,
            "showOnForm": true,
            "showOnList": false,
            "showOnView": false,
            "pmTaskId": taskId,
            "pmIsGeneration": true,
            "tooltip": "Apagar",
            "fieldGroup": "TASKS",
            "template": "field/label-with-icon.html",
            "icon": "trash",
            "class": 1,
            "events": [
                {
                    "name": "FieldOnClick",
                    "code": "ProjectController.fieldOnClickEventRemoveTaskMergeGeneration(args);"
                }
            ]
        };
    };

    this.getTaskNameFromGenerateTaskInProject = function (taskId) {
        return {
            "name": "TASK_NAME_" + taskId,
            "label": "Tarefa",
            "size": 22,
            "class": 3,
            "sameLine": true,
            "isVisible": true,
            "readOnly": true,
            "fieldGroup": "TASKS",
            "template": "field/text-edit.html",
            "events": [],
            "pmIsGeneration": true,
            "pmTaskId": taskId
        };
    };

    this.getTimePLannedFromGenerateTaskInProject = function (taskId) {
        return {
            "name": "TIME_PLANNED_" + taskId,
            "label": "Pontos Estimados",
            "validations": {
                "required": {}
            },
            "size": 22,
            "class": 2,
            "sameLine": true,
            "isVisible": true,
            "readOnly": false,
            "fieldGroup": "TASKS",
            "template": "field/text-edit.html",
            "events": [],
            "pmIsGeneration": true,
            "pmTaskId": taskId
        };
    };

    this.getProjectNameFromGenerateTaskInProject = function (taskId) {
        return {
            "name": "PROEJCT_NAME_" + taskId,
            "label": "Project",
            "size": 22,
            "class": 2,
            "sameLine": true,
            "isVisible": true,
            "readOnly": true,
            "fieldGroup": "TASKS",
            "template": "field/text-edit.html",
            "events": [],
            "pmIsGeneration": true,
            "pmTaskId": taskId
        };
    };

    this.getParentNameFromGenerateTaskInProject = function (taskId,projectId) {
        return {
            "name": "PARENT_NAME_" + taskId,
            "label": "Tarefa superior",
            "showOnForm": true,
            "class": 2,
            "isVisible": true,
            "fieldGroup": "TASKS",
            "template": "zh-select-autocomplete#field/select-autocomplete.html",
            "descriptionField": "NAME",
            "searchableFields": ["NAME"],
            "pmIsGeneration": true,
            "pmTaskId": taskId,
            "hasPagination": false,
            "searchWithPagination": false,
            "valueField": "ID",
            "showSelectAs": "tree",
            "parentProperty": "PARENT",
            "primaryProperty": "ID",
            "expandingProperty": "NAME",
            "events": [
                {
                    "name": "FieldOnChange",
                    "code": "ProjectController.fieldOnChangeEventParentName(args);"
                }
            ],
            "breadcrumbProperty": "NAME",
            "outData": {
                "ID": "PARENT_" + taskId,
                "NAME": "PARENT_NAME_" + taskId
            },
            "dataSource": {
                "name": "/taskParent",
                "rest": true,
                "localStorage": false,
                "data": []
            },
            "dataSourceFilter": [
                {
                    "name": "PROJECT",
                    "value": projectId,
                    "operator": "="
                },
                {
                    "name": "TASK",
                    "value": taskId,
                    "operator": "="
                }
            ]
        };
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('FieldsMetaData', FieldsMetaData);
});

// FILE: assets/js/util/FilterService.js
function FilterService (Query, ZHPromise){
    var _filterType = {};

    var _buildFilterTypeMap = function(fields) {
        fields.forEach(function(field) {
            if(field.isVisible && field.aclIsVisible){
                if (field.template && field.template.indexOf('between-dates.html') !== -1 || field.template.indexOf('interval.html') !== -1) {
                    _filterType[field.name] = "BETWEEN";
                } else if (field.template && (field.template.indexOf('number.html') !== -1 || field.template.indexOf('datetime.html') !== -1 || field.PMFieldNumber)) {
                    _filterType[field.name] = "=";
                } else if (field.outData && field.template && field.template.indexOf('select.html') !== -1) {
                    _filterType[field.outData[field.valueField]] = "=";
                } else if (field.template && field.template.indexOf('select-multiple.html') !== -1){
                    _filterType[field.name] = "IN";
                } else {
                    _filterType[field.name] = "LIKE";
                }
            }
        });
    };

    var _filterTypeFlow = {
        "BETWEEN": function(query, value) {
            query.between([value.start, value.end]);
        },
        "LIKE": function(query, value) {
            query.like('%' + value + '%');
        },
        "=": function(query, value) {
            query.equals(value);
        },
        "IN": function(query, value) {
            query.in(value);
        }
    };

    this.buildFilter = function(fields, row) {
        _buildFilterTypeMap(fields);
        var query = Query.build();
        for (var key in row) {
            if (row[key] && _filterType[key] && (!Array.isArray(row[key]) || row[key].length > 0)) {
                query.where(key);
                _filterTypeFlow[_filterType[key]](query, row[key]);
            }
        }
        return query.where();
    };

    this.parentFilter = function(parentWidget, childWidget){
        if(parentWidget && childWidget && childWidget.fields && childWidget.currentRow){
            if(!parentWidget.dataSourceFilter){
                parentWidget.dataSourceFilter = [];
                parentWidget.innerFilters = [];
            } else if(!parentWidget.innerFilters){
                parentWidget.innerFilters = parentWidget.dataSourceFilter || [];
            }
            parentWidget.dataSourceFilter = parentWidget.innerFilters.concat(this.buildFilter(childWidget.fields, childWidget.currentRow));
            return parentWidget.reload();
        } else {
            var deferred = ZHPromise.defer();
            deferred.reject("Invalid params");
            return deferred;
        }
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('FilterService', FilterService);
});

// FILE: assets/js/util/LocalStorage.js
function LocalStorage(){
    
    this.jsonStringify = function (item) {
        return JSON.stringify(item);
    };

    this.jsonParse = function (item) {
        return JSON.parse(item);
    };

    this.setItem = function (key, item, jsonStringify) {
        jsonStringify = jsonStringify || true;
        if(jsonStringify){
            localStorage.setItem(key, this.jsonStringify(item));
        } else {
            localStorage.setItem(key, item);
        }
    };

    this.getItem = function (key, jsonParse) {
        jsonParse = jsonParse || true;
        if(jsonParse){
            return localStorage.getItem(key) ? this.jsonParse(localStorage.getItem(key)) : '0';
        } else {
            return localStorage.getItem(key);
        }
    };


}
Configuration(function(ContextRegister){
    ContextRegister.register('LocalStorage', LocalStorage);
});

// FILE: assets/js/util/Messages.js
function Messages() {
    /* + ----------------------------------- +
     * | Error messages                      |
     * + ----------------------------------- + */
    this.ERR_CONFLICT                         = 'Existem conflitos em sua branch. Resolva-os e continue sua tarefa.';
    this.ERR_CONFLICT_MASTER                  = 'Existem conflitos em sua branch "master". Resolva-os e tente novamente.';
    this.ERR_CONFLICT_STASH                   = 'Stash não realizado. Resolva os conflitos.';
    this.ERR_PUSH_MASTER                      = 'Ocorreu um erro ao homologar suas modificações. Por favor, tente novamente';
    this.ERR_MERGE_MASTER                     = 'Não foi possivel fazer o merge no master. Tente novamente';
    this.ERR_PRODUCT_NOT_SELECTED             = 'Não foi possivel criar um rótulo exclusivo, Pois o produto da issue não foi selecionado';
    this.ERR_REQUIRED_FIELDS                  = 'Os campos com asterisco (*) devem ser preenchidos.';
    this.ERR_START_DATE_AFTER_FINAL_DATE      = 'A data inicial não pode ser posterior à data final.';
    this.ERR_START_DATE                       = 'Por favor preencha campo início.';
    this.ERR_FINAL_DATE                       = 'Por favor preencha campo fim.';
    this.ERR_TOTAL                            = 'Por favor preencha tempo total.';
    this.ERR_NAME                             = 'Por favor preencha o campo de nome.';
    this.ERR_SPONSOR                          = 'Por favor preencha o campo cliente.';
    this.ERR_MANAGER                          = 'Por favor preencha campo gerente.';
    this.ERR_GROUP                            = 'Por favor preencha campo grupo.';
    this.ERR_TOTAL                            = 'Por favor preencha tempo total.';
    this.ERR_NOT_MODEL_BUDGET_RESGISTERED     = 'Não existem modelos de orçamento cadastrados!';
    this.ERR_NOT_BUDGET_RESGISTERED           = 'É necessário incluir pelo menos um item para gerar o orçamento';
    this.ERR_NOT_DOCUMENT                     = 'Não existe documento anexado!';
    this.ERR_IS_VALID                         = 'Campos obrigatórios não preenchidos !';
    this.ERR_SUPERIOR_TASK_SAME_PRECURSOR     = 'A tarefa superior não pode ser a mesma da predecessora.';
    this.ERR_NEW_TASK_CREATED_ERROR           = 'Ocorreu um erro ao abrir a tarefa que foi gerada para atualizar os registros do branch master.';
    this.ERR_NOT_GENERATE_LINKS_MERGE_REQUEST = 'Não foi possível gerar os links para comparação com o master.';
    this.ERR_NOT_DELETE_ISSUE_USER_LOGADO     = 'Não foi possivel apagar a issue, porque essa issue não foi criada pelo usuário logado.';
    this.ERR_SAVE_IDENTITY_USER_EMAIL_UK      = 'Email informado já registrado no Zeedhi Identity.';
    this.ERR_SAVE_RESOURCE_T_EMAIL_UK         = 'Email informado já registrado para outro recurso.';
    this.ERR_PATH_NOT_FOUND                   = 'encontrar o caminho especificado';
    this.ERR_START_TASKS                      = 'Você já possui tarefas iniciadas. Pause ou conclua suas tarefas para iniciar a próxima.';
    this.ERR_START_TASK                       = 'A tarefa %1 ja esta iniciada. Conclua ou pause-a para iniciar outra tarefa.';
    this.ERR_NOT_GIT_REPOSITORY               = 'Not a git repository';
    this.UNEXPECTED_ERROR_SIMPLE              = 'Ocorreu um erro inesperado.';
    this.UNEXPECTED_ERROR                     = 'Ocorreu um erro inesperado. Por favor, tente novamente. Caso o erro persista, entre em contato com o administrador do sistema.';
    this.COMMIT_FAILED                        = 'Commit não realizado. Tente novamente.';
    this.RESET_FAILED                         = 'Reset não realizado. Tente novamente.';
    this.ERR_NOT_GIT_REPOSITORY               = 'Not a git repository';
    this.ERR_PATH_NOT_FOUND                   = 'encontrar o caminho especificado';
    this.ERR_CANT_DEL_APPROPRIATED_PROJECT    = 'Você não pode excluir um projeto que tenha tarefas já apropriadas.';
    this.ERR_CANT_DEACTIVATE_APPROPRIATED_PROJECT = 'Você não pode deixar inativo um projeto que tenha tarefas já apropriadas.';
    this.ERR_CANT_GENERATE_SCHEDULE           = 'Não foi possível gerar o cronograma.';
    this.ERR_CANT_OPEN_GENERATED_SCHEDULE     = 'Não foi possível abrir o cronograma gerado. Popup foi bloqueado.';
    this.ERR_PATH_USED_BY_OTHER_REPOSITORY    = 'Não foi possível salvar o local de conexão.<br/>O caminho "%1" contém o repositório cuja URL é "%2".';
    this.ERR_PATH_USED_NOT_GIT_REPOSITORY     = 'Não foi possível salvar o local de conexão.<br/>O caminho "%1" já existe, não é um repositório git e não está vazio.';
    this.ERR_REMOTE_REPOSITORY_NOT_EXISTS     = 'A URL "%1" do repositório remoto "%2" não está acessível. Verifique a existência da mesma ou suas permissões.';
    this.ERR_CHANGE_CONTROL_STATUS_ALREADY_EXISTING = 'Já existe um status com esse controle. Caso queira salvar esse status, altere o controle da tarefa "';
    this.ERR_CANT_MODIFY_APPROPRIATION_IS_NOT_RESOURCE = 'Essa apropriação não pode ser alterado pois você não está alocado essa tarefa.';
    this.ERR_NEED_SELECT_PROJECT              = 'Você precisa selecionar pelo menos um projeto para completar esta ação.';
    this.ERR_CANT_COPY_TASKS                  = 'Erro ao tentar copiar a(s) tarefa(s). ';
    this.ERR_REPOSITORY_CHANGED               = 'O(s) repositório(s) abaixo têm arquivo(s) modificado(s) e não têm local(is) de conexão cadastrado(s): <br>';
    this.ERR_CALC_PROJECT                     = 'Não foi possível realizar o cálculo do seu projeto. Por favor, tente novamente mais tarde';
    this.OPERATION_BLOCKED                    = '<strong> Operação bloqueada!</strong><br/>Para prosseguir, a(s) diferença(s) de apropriação(ões) do(s) dia(s) a seguir deve(m) ser 0: ';
    this.OPERATION_BLOCKED_INIT               = ' <strong> Algumas operações estão bloqueadas! </strong><br/>Para desbloqueá-las, a(s) diferença(s) de apropriação(ões) do(s) dia(s) a seguir deve(m) ser 0: ';
    this.OPERATION_BLOCKED_END                = ' <br/> Deseja ir para tela de controle de tempo? ';
    this.ERR_STASH_APPLY                      = 'O(s) arquivo(s) modificado(s) pelo stash está(ão) modificado(s) localmente, não é possivel realizar o stash apply!';
    this.ERR_COPY_CALENDAR_EXCEPTION          = 'Erro ao copiar exeções! tente novamente mais tarde';
    this.ERR_CREATE_MEETING                   = 'Para criar uma reunião é preciso criar um tipo de projeto com o controle "Reunião" e outro com o tipo "Ocorrência de reunião". <br> Menu => Configuração => Opções de Projetos => Tipos';
    this.ERR_CREATE_MEETING_OCCURRENCES       = 'Para criar Ocorrência(s) da reunião é preciso criar um tipo de projeto com o controle "Ocorrência de reunião". <br> Menu => Configuração => Opções de Projetos => Tipos';
    this.ERR_IS_NOT_SCHEDULE                  = 'Para criar Ocorrência(s) da reunião é preciso criar um tipo de projeto com o controle "Ocorrência de reunião". <br> Menu => Configuração => Opções de Projetos => Tipos';
    this.ERR_IS_TASK_STATUS                   = 'O status dessa ocorrência de reunião não pode ser alterado porque a reunião está cancelada ou concluída.';
    this.ERR_DELETE_FK                        = 'Erro! Essa categoria está sendo usada em tarefa(s)';
    this.ERR_CLIENTE_WINDOWS                  = 'O seu Project Services está conectado em um sistema operacional Windows, mas não existe caminho cadastrado para ele!';
    this.ERR_CLIENTE_NOT_WINDOWS              = 'O seu Project Services está conectado em um sistema operacional que não é Windows, mas não existe caminho cadastrado para ele!';
    this.ERR_CLASS_IN_HOMOLOGATION_ISSUE      = 'Em projetos "Em homologação" só é possível criar novas tarefas com categorias de erro ou teste e a(s) issue(s) selecinada(s) esta(ão) em outra categoria';
    this.ERR_WEBSOCKET                        = 'Erro inesperado do WebSocket';
    this.ERR_APPR_AFTER_CONCLUSION            = "Data da apropriação não pode ser posterior ao término da tarefa (";
    this.ERR_REPLICATION_STATUS               = 'Esta tarefa não pode ser replicada! Para ser replicada ela deve estar "Não iniciada" ou "Pausada"!';
    this.ERR_REPLICATION_IS_VERSION_DEV       = 'Tarefas de projetos de erro que possuam versão de desenvolvimento não podem ser replicadas.';
    this.ERR_REPLICATION_GENERATED            = 'Esta tarefa não pode ser replicada porque foi gerada. Apenas tarefas não geradas e geradas do tipo "Erro" podem executar essa ação.';
    this.ERR_REPOSITORY                       = 'O projeto não possui repositório(s) e diretório(s).';
    this.ERR_REPOSITORY_MULT_PROJECTS_WINDOWS = 'O(s) projeto(s) "%1" não possuem repositório(s) e diretório(s) para o sistema operacional Windows.<br/>Para prosseguir, é necessário que todos tenham pelo menos um cadastrado.';
    this.ERR_REPOSITORY_MULT_PROJECTS_LINUX   = 'O(s) projeto(s) "%1" não possuem repositório(s) e diretório(s) para sistemas operacionais que não são Windows.<br/>Para prosseguir, é necessário que todos tenham pelo menos um cadastrado.';
    this.ERR_REPOSITORY_CONFIRMATION          = '<BR> Deseja ir para a tela de criação de diretórios? ';
    this.ERR_DIRECTORY_NOT_WINDOWS            = ' possui diretório apenas para o sistema operacional Windows.';
    this.ERR_DIRECTORY_WINDOWS                = ' não possui diretório para o sistema operacional Windows.';
    this.ERR_PLAY_IN_HOMOLOGATION             = 'Essa tarefa não pode ser iniciada porque o projeto está em homologação!';
    this.ERR_PLAY_ALLOW_PLAY_TASK             = 'Essa tarefa não pode ser iniciada porque tem issue que está em um enquadramento que não permite!';
    this.ERR_STOP_IN_HOMOLOGATION             = 'Essa tarefa não pode ser finalizada porque o projeto está em homologação!';
    this.ERR_TYPE_COMMENT_SPECIFICATION       = 'O tipo de comentário para especificação não foi criado!<BR>Procure o(s) Administrador(es) do sistema!';
    this.ERR_TYPE_COMMENT_ACCEPT              = 'O tipo de comentário para Aprovação não foi criado!<BR>Procure o(s) Administrador(es) do sistema!';
    this.ERR_COMMENT_CLOSED                   = 'Não é possível adicionar comentário para uma Issue com o status Encerrada pelo solicitante';
    this.ERR_CLASSIFICATION_CUSTOMER_APPROVAL = 'A categoria de tarefas para aprovação não foi criado!<BR>Procure o(s) Administrador(es) do sistema!';
    this.ERR_TASK_STATUS_CUSTOMER_APPROVAL    = 'A situação de tarefas para aprovação não foi criado!<BR>Procure o(s) Administrador(es) do sistema!';
    this.ERR_IS_VALIDATE_CONTACT              = 'É necessário preencher pelo menos um destes campos: "Nome", "Telefone", "E-mail" ou "Endereço".';
    this.ERR_NOT_TASK_STATUS                  = 'Para adicionar uma categoria de tarefa é necessário que exista um status de tarefa  relacionado com esse enquadramento de issue!';
    this.ERR_NOT_TASK_STATUS_TYPE_PROJECT     = 'Para adicionar um tipo de projeto é necessário que exista um status de tarefa relacionado com esse enquadramento de issue!';
    this.ERR_FINISH_SPECIFICATION_TASK        = 'Para concluir a tarefa de Especificação, é necessário criar outra(s) tarefa(s) para solucionar a issue!';
    this.ERR_UPLOAD_FILE_SIZE                 = 'O tamanho do(s) arquivo(s) não é(são) válido(s)!';
    this.ERR_UPLOAD_FILE_EXTENSION            = 'A extensão do(s) arquivo(s) não é(são) válida(s)!';
    this.ERR_MERGE_PROJECT_PREVIOUS           = 'Para concluir essa tarefa é necessário finalizar os projetos listados abaixo: <BR>';
    this.ERR_UPLOAD_FILE_EXTENSION_OR_SIZE    = 'O tamanho e/ou a extensão do(s) arquivo(s) não são válidos!';
    this.ERR_ALOC_TASK_CONCLUEND              = 'Os recursos não serão alocados porque as seguintes tarefas encontram-se concluídas:<br/>';
    this.ERR_ISSUES_PROJECTS_VERSIONS_DIFFERENT   = 'Os projetos(Erro)/issues abaixo pertencem ao mesmo produto e não podem ter versões de desenvolvimento diferentes:<br/><br/>';
    this.ERR_ISSUES_WITH_VERSION_PROJECT_NOT_ERROR   = 'As issues abaixo possuem versão, portanto, só é possivel gerar tarefas em projetos de erro com a mesma versão :<br/><br/>';
    this.ERR_PROJECT_WITH_TASK_VERSION_DIFFERENT = 'Não é possivel criar tarefas para projetos que possuem tarefas e não possuem a mesma versão da issue:<br/><br/>';
    this.ERR_ISSUES_WITH_PRODUCT_DIFFERENT = 'Não é possivel criar tarefas para issues de produtos diferentes que possuem versão de desenvolvimento.';
    this.ERR_PROJECTS_SAME_PRODUCT_VERSION_DIFFERENT = 'Não é possivel criar tarefas para projetos com versões de desenvolvimento diferentes que pertence ao mesmo produto.';
    this.ISSUES_AND_TASKS_WITH_DIFFERENTS_VERSIONS = 'Não é possivel relacionar issues e tarefas que possuem versões diferentes.';
    this.ERR_PROJECT_SUBRELEASE_FINALIZED     = 'O projeto não pode ser cancelado porque possui Subrelease finalizada.';
    this.ERR_NOT_MOVE_TASK_INITIALIZED     = 'As tarefas abaixos não podem ser movidas para um projeto que possui tipo diferente do projeto original porque já foram iniciadas:';
    this.ERR_CHOICE_PARENT_PROJECT     = 'O projeto "__PARENT_PROJECT__" não pode ser selecionado porque não é de sua responsabilidade ou de seu gerente.';
    this.ERR_CHOICE_PARENT_PROJECT_IS_CHILDREN     = 'O projeto "__PARENT_PROJECT__" não pode ser selecionado porque ele é filho ou filho de algum filho do projeto atual.';
    this.ERR_RESOURCE_NOT_ALLOWED_CONCLUDE     = 'O usuário logado não está autorizado a concluir esta tarefa. <br> Somente os recursos relacionados a categoria desta tarefa estão autorizados a concluí-la.';
    this.ERR_TASK_FINISHED_OR_INACTIVATED     = 'Não é possivel mover tarefas concluídas ou inativas';
    this.ERR_TASK_CONCLUDED     = 'Não é possível alterar a pontuação de tarefas pai ou concluídas.';
    this.ERR_SUBRELEASE_FINISHED     = 'Não é possível criar tarefa neste projeto pois a subrelease já foi finalizada';
    this.ERR_PROJECT_NOT_ALLOW_TASK     = 'Não é possível criar tarefas para este projeto';



    /* + ----------------------------------- +
     * | Successful messages                 |
     * + ----------------------------------- + */
    this.SUC_TASK_SUCCESSFUL_SAVED        = 'Tarefa salva com sucesso.';
    this.SUC_SUCCESSFUL_SAVED             = 'Registro salvo com sucesso.';
    this.SUC_SUCCESSFUL_SAVED_POINTS      = 'Pontos alterados com sucesso!';
    this.SUC_TASK_SUCCESSFUL_GENERATED    = 'Tarefa(s) gerada(s) com sucesso!';
    this.SUC_STASH_APPLY_SUCCEED          = 'Stash aplicado com sucesso.';
    this.SUC_ACCESS_PROFILE_CONTROL_SAVED = 'Perfil(is) salvos com sucesso.';
    this.SUC_CATEGORY_DELETE              = 'Categoria excluída!';
    this.SUC_TASK_FEATURE_DELETE          = 'Tipo de tarefa excluído!';
    this.SUC_TASK_FEATURE_SAVE            = 'Tipo de tarefa salvo!';
    this.SUC_CATEGORY_SAVE                = 'Categoria salva!';
    this.SUC_BUDGET_ITEMS_SAVE            = 'Item de Orçamento salvo!';
    this.SUC_AUTO_FRAMING_SAVE            = 'Enquadramento automático definido com sucesso';
    this.SUC_BUDGETS_SAVE                 = 'Orçamento salvo!';
    this.COMMIT_SUCCEED                   = 'Commit realizado com sucesso.';
    this.RESET_SUCCEED                    = 'Reset realizado com sucesso.';
    this.STASH_SUCCEED                    = 'Stash reaizado com sucesso.';
    this.SUC_COPY_CALENDAR_EXCEPTION      = 'Exeções copiadas com sucesso.';
    this.SUC_COPY_CALENDAR_WEEK           = 'Semanas de trabalho copiadas com sucesso.';
    this.SUC_ORDER_SAVE                   = 'Ordem salva!';
    this.SUC_CALC_PROJECT                 = 'Datas recalculadas com sucesso!';
    this.SUC_PERFIL_RESOURCE_ADD          = 'Perfil de acesso adicionado!';
    this.SUC_ERRO_CLASSIFICATION_DELETE   = 'Natureza de Erro excluída com sucesso';
    this.SUC_ERRO_CLASSIFICATION_SAVE     = 'Natureza de Erro salvo com sucesso';
    this.SUC_REPLANNING_REASON_SAVE       = 'Motivo de planejamento salvo com sucesso';
    this.SUC_REPLANNING_REASON_DELETE     = 'Motivo de planejamento excluído com sucesso';

    /* + ----------------------------------- +
     * | Description messages                |
     * + ----------------------------------- + */
    this.DES_TASK_GENERATED_REPLICACAO    = 'Tarefa gerada automaticamente para replicar o código.';
    this.DES_TASK_GENERATED_MERGE_REQUEST = 'Tarefa gerada automaticamente para realizar o Merge Request.';
    this.DES_TASK_MERGE_REQUEST           = 'Tarefa gerada para realizar o Merge Request.';
    this.DES_INIT_LINK_MERGE_REQUEST      = 'Links para comparação:<br/>';
    this.DES_PLACEHOLDER_NAME_GEN_TASK    = 'Caso não informado, assumirá o nome da tarefa geradora.';
    this.DES_TASK_TEST_LINK               = 'Clique %1 para acessar o ambiente de teste relacionado à essa tarefa.';
    this.DES_ADD_RESOURCE_PROJECT         = 'Deseja incluir o recurso em projetos relacionados também?';
    this.DES_DELETE_RESOURCE_PROJECT      = 'Deseja excluir o recurso dos projetos relacionados a árvore deste projeto?';
    this.DES_DELETE_ATA_MEETING           = 'Deseja apagar esta ata?';
    this.DES_DELETE_ATA_DOCUMENTS         = 'Deseja apagar o arquivo?';
    this.COM_MODEL_CREATE                 = 'Deseja criar projeto a partir de modelo?';
    this.NEW_FILE_ON_GIT_DIFF             = ' (Arquivo não encontrado no versionamento do repositório)';

    /* + ----------------------------------- +
     * | Alert messages                      |
     * + ----------------------------------- + */
    this.ALE_TASK_EDITING_BUDGE_WIDGET       = 'Essa issue não está em especificação por isso não será possivel editar o orçamento!';
    this.ALE_KEEP_MANAGER_AS_RESOURCE        = 'Deseja manter o gerente antigo como recurso do projeto?';
    this.ALE_KEEP_SPONSOR_AS_RESOURCE        = 'Deseja manter o cliente antigo como recurso do projeto?';
    this.ALE_PROJECT_FINISH_PLANNING         = 'Deseja finalizar o planejamento (registro de baseline) do projeto "';
    this.ALE_PROJECT_FINISH_PLANNING_ERROR   = 'Deseja finalizar o planejamento do projeto "';
    this.ALE_WRONG_APPROPRIATION             = 'Sua tarefa precisa estar 100% concluida para ser encerrada.';
    this.ALE_DIRTY_DIRECTORY                 = 'Existem arquivos não resolvidos na sua branch corrente. Resolva-os e tente iniciar a tarefa novamente.';
    this.ALE_DIRTY_DIRECTORY_WITH_PLAY       = 'Existem arquivos não resolvidos na sua branch corrente. Resolva-os para que a tarefa possa ser iniciada.';
    this.ALE_DIRTY_DIRECTORY_WITH_STASH      = 'Existem arquivos não resolvidos na sua branch corrente. Resolva-os para que possa aplicar o stash';
    this.ALE_MERGE_TASK_WITH_CONFLICT        = 'Não foi possível iniciar essa tarefa pois a branch possui conflitos. Por favor, gere uma tarefa do tipo CONFLITO para o solicitante resolvê-lo.';
    this.ALE_NEW_TASK_CREATED                = 'Atenção!<br/>Foi gerada uma nova tarefa para replicar o código.<br/>Por favor, finalize-a.';
    this.ALE_NEW_TASK_CREATED_CONFLICT       = 'Atenção!<br/>Durante a geração de uma nova tarefa para replicar o código, foram identificados conflitos.<br/>Por favor, resolva-os e finalize essa tarefa.';
    this.ALE_BRANCH_NOT_FOUND_REPOSITORY     = 'O branch "%1" não foi encontrado em nenhum dos repositórios.';
    this.ALE_RESOURCE_NOT_FOUND              = 'O(s) recurso(s) "%1" não pertence(m) ao projeto. Deseja adicioná-lo(s) ?';
    this.ALE_TASK_NOT_CONCLUDE               = 'É necessário que a tarefa esteja concluída para realizar a geração.';
    this.ALE_DELETE_APROPRIATION             = 'Deseja apagar a apropriação?';
    this.ALE_DELETE_DOCUMENT                 = 'Deseja apagar o documento?';
    this.ALE_DELETE_RESOURCE_FROM_PROJECT    = 'Deseja remover o recurso do projeto?';
    this.ALE_DELETE_TASK_RELATIONSHIP        = 'Deseja remover o relacionamento com a tarefa?';
    this.ALE_DELETE_FOLLWER                  = 'Essa ação irá lhe remover de seguidor e por consequência a relevância, caso tenha. Deseja continuar ?';
    this.ALE_SAVE_SAME_STRUCTURE_AS_PARENT   = 'Uma estrutura não pode ser superior a ela mesma ou ter uma das suas filhas como superior, por favor selecione outra.';
    this.ALE_DELETE_CONTACT                  = 'Deseja apagar o contato?';
    this.ALE_DELETE_ACCESS_PROFILES          = 'Deseja apagar o perfil selecionado?';
    this.ALE_DELETE_ACCESS_REPOSITORY        = 'Deseja excluir o repositório selecionado?';
    this.ALE_DELETE_ACCESS_CHILD_REPOSITORY  = 'Deseja excluir o(s) repositório(s) selecionados para os projetos-filhos?';
    this.ALE_DELETE_TYPE_PROJECT             = 'Deseja remover o tipo de projeto selecionado?';
    this.ALE_DELETE_CATEGORY                 = 'Deseja remover a categoria de projeto selecionado?';
    this.ALE_DELETE_TASK_CATEGORY            = 'Deseja remover a categoria de tarefa selecionada?';
    this.ALE_DELETE_TASK_TYPE                = 'Deseja remover o tipo de tarefa selecionada?';
    this.ALE_DELETE_TASK_STATUS              = 'Deseja remover o status de tarefa selecionado?';
    this.ALE_DELETE_TASK                     = 'Deseja remover a tarefa selecionada?';
    this.ALE_DELETE_STATUS                   = 'Deseja remover o status de projeto selecionado?';
    this.ALE_DELETE_ACCESS_PROFILES          = 'Deseja apagar o(s) perfil(is) selecionado(s)?';
    this.ALE_DELETE_LABELS                   = 'O rótulo será excluído das issues relacionadas a ele. Deseja continuar?';
    this.ALE_DELETE_ALLOCATION               = 'Você irá remover todos os recursos alocados nas tarefas selecionadas. Deseja prosseguir?';
    this.ALE_DELETE_TASK                     = 'Deseja remover a tarefa selecionada?';
    this.ALE_PROJECT_SERVICES_DISCONNECTED   = "Project Services desconectado! Conecte-o e tente novamente.";
    this.ALE_PROJECT_SERV_DISC_MERGE_MASTER  = "O cliente do websocket que realiza a atualização da branch master está desconectado. Por favor, procure o setor reponsável para resolução do problema.";
    this.ALE_PLAYED_TASK                     = "A conclusão dessa tarefa deve ser realizada pela opção 'Minhas Tarefas', através do botão finalizar.";
    this.ALE_INVALID_APPROPRIATION           = 'Essa apropriação não pode ser alterada porque você não está alocado nessa tarefa.';
    this.ALE_NOT_GENERATE_TASK_TEST          = 'Só é possível gerar tarefas a partir de Testes na tela de "Minhas tarefas".';
    this.ALE_NOT_GENERATE_TASK_ORIGIN        = 'Essa tarefa não pode ser utilizada para geração porque o Merge Request relacionado gerou novas tarefas. Por favor, selecione a última tarefa gerada.';
    this.ALE_NOT_GENERATE_TASK_MERGE_REQUEST = 'Não é possível gerar tarefas a partir de Merge Requests.';
    this.ALE_NOT_GENERATE_TASK_ERR_MERGE_REQUEST = 'Não é possível gerar tarefas a partir de erro de Merge Requests.';
    this.ALE_NOT_GENERATE_TASK_REPLICATION   = 'Não é possível gerar tarefas a partir de Replicações de Código.';
    this.ALE_NOT_GENERATE_TASK_ERRO_MR       = 'Não foi possível realizar a geração, pois o Merge Request relacionado a essa tarefa já foi encerrado.<br/>Por favor, crie uma nova tarefa.';
    this.ALE_NOT_GENERATE_TASK_ERRO_MR_D     = 'Pause a tarefa para realizar a geração.';
    this.ALE_NOT_CREATE_LINKS_GIT_LAB        = 'Inicie a tarefa para visualizar as modificações do código (diff).';
    this.ALE_NOT_GENERATE_TEST_TASKS         = 'A(s) tarefa(s) a seguir não pode(m) gerar Tarefas de Teste.';
    this.ALE_NOT_GIT_STATUS_IN_BRANCH        = 'Não foram encontrados arquivos modificados em sua branch corrente.';
    this.ALE_NOT_GEN_TEST_BEC_ERROR_TASK     = 'Foi gerada uma tarefa do tipo ERRO a partir dessa tarefa. Por favor, gere um novo teste a partir da mesma.';
    this.ALE_NOT_CONCLUDED_TASK_ALOCATIONS   = 'Atenção!<br/>Essa tarefa não pode ser encerrada porque o(s) recurso(s) %1 está(ão) com a mesma em andamento.';
    this.ALE_NOT_PLAY_MERGE_REQUEST_TASK     = 'Não foi possível iniciar a tarefa pois existe(m) tarefa(s) gerada(s) a partir da mesma que não estão concluídas.';
    this.ALE_NOT_PLAY_TEST_BLOCKED           = 'Essa tarefa não pode ser iniciada porque o ambiente de teste corresponte não está disponível. <br> O teste de outra Sub-release, desse mesmo produto, pode estar em andamento. <br> Para prosseguir com esse teste, gere o ambiente correspondente novamente.';
    this.ALE_NOT_CONC_MERGE_REQUEST_TASK     = 'Não foi possível encerrar a tarefa pois existe(m) tarefa(s) gerada(s) a partir da mesma que não estão concluídas.';
    this.ALE_CHANGE_CONTROL_TASK_STATUS      = 'Caso altere, afetará todas as tarefas já ligadas a esse controle!';
    this.ALE_CONTINUE                        = 'Deseja continuar?';
    this.ALE_DELETE_ISSUE_STATUS             = 'Deseja excluir esse Issue Status?';
    this.ALE_DELETE_COMMENT_TYPE_ID          = 'Deseja excluir esse tipo de comentário?';
    this.ALE_DELETE_STRUCUTRE_TYPE           = 'Deseja excluir esse tipo de estrutura?';
    this.ALE_RECALCULATE_DATES_PROJECT       = 'Caso continue, todas as datas do projeto serão recalculadas.';
    this.ALE_NOT_PENDENT_STASH               = 'Não existem stashes pendentes.';
    this.ALE_DELETE_LOCALCONNECTION          = 'Deseja deletar o local de conexão?';
    this.ALE_INCOHERENT_VERSION              = 'Atenção!<br/>A versão do PM foi atualizada. Existem informações gravadas no cache do seu browser que serão atualizadas em breve.';
    this.ALE_PROJECT_TASK_INITIALIZED        = 'A(s) tarefa(s) abaixo está(ão) iniciada(s) para este projeto. Para inserir um novo local de conexão, por favor pause ou conclua a(s) mesma(s).<br/>%1';
    this.ALE_PROJECT_TASK_INITIALIZED_DEL    = 'A(s) tarefa(s) abaixo está(ão) iniciada(s) para este projeto. Para excluir um local de conexão, por favor pause ou conclua a(s) mesma(s).<br/>%1';
    this.ALE_CONFLICT_UPDATE_MAIN_BRANCH     = 'Atenção!<br/>Após a conclusão de sua tarefa, foi realizada a tentativa de atualizar a branch %1 local, porém forem encontrados conflitos. Antes de prosseguir para novas tarefas, por favor resolva-os.';
    this.ALE_ERROR_UPDATE_MAIN_BRANCH        = 'Atenção!<br/>Após a conclusão de sua tarefa, foi realizada a tentativa de atualizar a branch %1 local, porém ocorreram erros no processo. Antes de prosseguir para novas tarefas, por favor verifique seu repositório.';
    this.ALE_DIFFERENT_RESOURCES_PT1         = 'Os seguintes recursos não existem no projeto de destino, mas existem nas tarefas que estão sendo manuseadas: <br/><br/>';
    this.ALE_DIFFERENT_RESOURCES_PT2         = '<br/><br/>Você deseja incluí-los no projeto de destino?';
    this.ALE_CLOSE_ISSUE                     = 'Finalizar issue?';
    this.ALE_REDO_BUDGET                     = 'Deseja refazer a proposta do SM com a última especificação anexada ?';
    this.SUC_REDO_BUDGET                     = 'Proposta do SM refeita com sucesso!';
    this.ALE_CLIENT_ACCEPT                   = 'Aprovar especificação?';
    this.ALE_CLIENT_REFUSE                   = 'Recusar especificação?';
    this.ALE_REOPEN_ISSUE                    = 'Recusar solução da issue?';
    this.ALE_ARE_YOU_SURE_DELETE_SPONSORS    = 'Você deseja apagar o(s) cliente(s) selecionado(s)?';
    this.ALE_NOT_ASSOCIATE_TWO_CONCLUDED_ST  = 'Não é possível associar o controle "Concluído" em mais de um status. O status "%1" já possui o mesmo.';
    this.ALE_REMOVE_MEETING                  = 'Deseja apagar essa reunião?';
    this.ALE_SEND_MAIL_AVAILABLE_ISSUE       = 'Deseja enviar um e-mail para notificar os seguidores e criador da issue?';
    this.ALE_REMOVE_SCHEDULE                 = 'Deseja apagar essa Pauta?';
    this.ALE_ARE_YOU_SURE_DELETE_RESOURCE    = 'Você deseja apagar o recurso selecionado?';
    this.ALE_ARE_YOU_SURE_REMOVE_RESOURCE    = 'Você deseja remover o recurso selecionado?';
    this.ALE_NOT_EXISTS_LOG                  = 'Log de execução inexistente.';
    this.ALE_DIRECTORIES_NOT_IN_TASK_BRANCH  = 'Atenção!<br/>Os seguintes diretórios não se encontram na branch da tarefa ("%1").<br/><br/>%2';
    this.ALE_NOT_COPY_GENERATED_TASKS        = 'As seguintes tarefas foram geradas e não podem ser copiadas.<br/><br/>%2';
    this.ALE_NOT_MOVE_CONCLUDED_TASKS        = 'As seguintes tarefas foram encerradas e não podem ser movidas.<br/><br/>%2';
    this.ALE_TASKS_REPOSITORIES_NOT_FOUND    = 'Atenção!<br/>As tarefas não podem ser movidas porque as listadas abaixo alteraram os repositórios que o projeto "%1" não possui.<br/><br/>%2';
    this.ALE_REMOVE_MANAGER_FROM_RELATED_PROJECT = 'Deseja remover o(s) gerente(s) antigo(s) dos projetos filhos?';
    this.ALE_ADD_MANAGER_FROM_RELATED_PROJECT = 'Deseja incluir os gerentes deste projeto como gerentes dos projetos filhos?';
    this.ALE_REMOVE_SPONSOR_FROM_RELATED_PROJECT = 'Deseja excluir o recurso de projetos relacionados também?';
    this.ALE_MODEL_PARENT_IS_NOT_VALIDADE    = 'Esse modelo ja possui um filho!';
    this.ALE_REPLICATION_RESOURCE            = 'Deseja replicar os recursos para as outras tarefas?<BR>(Só serão adicionados nos projeto que possuem os recursos).';
    this.ALE_EMPTY_MNEMONICS                 = 'Existem mnemônicos inalterados.<BR>Deseja prosseguir?';
    this.ALE_REPLICATION_TASK_PARENT         = 'Deseja replicar a tarefa superior para as outras tarefas?<BR>(Só para as tarefas do mesmo projeto).';
    this.ALE_UPDATE_RESOURCE                 = 'Deseja atualizar os recursos das outras tarefas?<BR>(Só serão adicionados nos projeto que possuem os recursos).';
    this.ALE_START_TASK                      = 'Deseja iniciar a tarefa "__TASK_NAME__"?';
    this.ALE_DELETE_ATTACHMENT               = 'Deseja apagar o arquivo?';
    this.ALE_DELETE_ATTACHMENT_ALL_RELATED_TASK  = 'Deseja excluir o anexo de todas as tarefas relacionadas?';
    this.NOT_CHECKED_ROW_TASK                = 'Selecione pelo menos uma tarefa para realizar a ação';
    this.NOT_CHECKED_ROW_ISSUE               = 'Selecione pelo menos uma issue para realizar a ação';
    this.ALE_CHANGE_MEETING_STATUS           = 'Ao concluir ou cancelar uma reunião, essa mudança será replicada para sua(s) ocorrência(s).<BR> Deseja continuar?';
    this.NOT_CHECKED_ROW_LOCAL_CONNECTION    = 'Por favor selecione ao menos um local de conexão para realizar a ação';
    this.ALE_COPY_REPOSITORY_HEAD            =  'Os locais de conexão do seguintes repositórios: <br/><br/>';
    this.ALE_COPY_REPOSITORY_TAIL            =  '<br/>Não podem ser copiados, pois não existem no projeto selecionado.<br/>Deseja continuar?';
    this.ALE_CONFIRM_COPY_REPOSITORY_HEAD    =  'Os seguintes locais de conexão podem ser sobrescritos:<br/><br/>';
    this.ALE_CONFIRM_COPY_REPOSITORY_TAIL    =  '<br/>Deseja continuar?';
    this.ALE_EMPTY_COPY_REPOSITORY           =  'Os repósitorios selecionados não existem no projeto.<br/>Não é possível copiar!';
    this.ALE_DIFF_REPOSITORY_FROM_STASH      =  'O projeto da tarefa que gerou o stash tem repositório(s) que esta tarefa não tem ou a mesma não possui diretório registrado:<BR>';
    this.ALE_WINDOWS_DIRECTORY_BAD_SLASH     =  'Você está salvando o diretório windows utilizando as barras "/", isso pode acarretar problemas. Deseja trocar as barras para "\\"?';
    this.ALE_DELETE_CLASSIFICATION_ISSUE_STATUS = 'Deseja excluir esse relacionamento de status de issue com categoria ?';
    this.ALE_DELETE_PROJECT_TYPE_ISSUE_STATUS = 'Deseja excluir esse relacionamento de status de issue com tipo de projeto ?';
    this.ALE_DELETE_CLAS_BUD_ITEM            = 'Deseja excluir esse relacionamento de item de orçamento com categoria ?';
    this.ALE_DELETE_BUDGET_ITEMS             = 'Deseja excluir esse Item de Orçamento?';
    this.ALE_DELETE_DOCUMENT_TEMPLATE        = 'Deseja excluir esse Item de modelo de documento?';
    this.ALE_INATIVE_BUDGET_ITEMS            = 'Esse Item de Orçamento não pode ser excluído porque já está em uso. Deseja inativá-lo?';
    this.ALE_CONFIRM_MARK_AS_READ            = 'Deseja realmente marcar {{totalIssuesMarked}} issue(s) como lida(s)?';
    this.ALE_NOT_DIFFERENT_ISSUE             = 'Não é possivel gerar tarefas de issues com status ou categorias diferentes!';
    this.ALE_NOT_DIFFERENT_ISSUE_RELATION    = 'Não é possivel Relacionar tarefa de issues com status ou categorias diferentes!';
    this.ALE_NOT_GENERATE_MERGE              = 'A(s) tarefa(s) a seguir não pode(m) gerar Tarefas de Merge: ';
    this.ALE_NOT_GENERATE_MERGE_HAS_MERGE    = 'A(s) tarefa(s) a seguir não pode(m) gerar Tarefas de Merge, pois já possuem merge gerado: ';
    this.ALE_DELETE_ERROR_CLASSIFICATION     = 'Deseja excluir essa Natureza de erro';
    this.ALE_IS_APPLY_CALENDAR_CHILDREN_PROJECT  = 'Deseja replicar o calendário base ao(s) projeto(s) filho(s)?<br/> (Essa opção substituirá o calendário dos projetos filhos caso existam.)';
    this.ALE_SAVE_EXCEPTION_CHILDREN_PROJECT  = 'Deseja replicar a exceção ao(s) calendário(s) do(s) projeto(s) filho(s)?<br/> (Caso algum projeto filho não tenha calendário associado, será criado um com base no calendário base do projeto pai e a excessão adicionada.)';
    this.ALE_SAVE_WORKWEEK_CHILDREN_PROJECT  = 'Deseja replicar a semana de trabalho ao(s) calendário(s) do(s) projeto(s) filho(s)?<br/> (Caso algum projeto filho não tenha calendário associado, será criado um com base no calendário base do projeto pai e a excessão adicionada.)';
    this.ALE_LOG_NOT_SAVED  = 'Falha ao salvar log';
    this.ALE_MOVE_CONCLUDED_TASK_CHILD  = 'Você está tentando mover tarefas pai que possuem tarefas filhas concluídas. Essas tarefas filhas não serão movidas para o projeto destino.<br> Deseja continuar?';
    this.ALE_UNRELATED_TASK_WARNING     =  'Os projetos abaixo possuem tipo diferente do projeto atual. As tarefas criadas neles não serão relacionadas. Para os demais projetos selecionados, o processo normal será executado. Deseja prosseguir?<br/> <br/> %1';
    this.ALE_PROJECT_ISSUE_WITHOUT_VERSION = 'Os projetos/issues abaixo não possuem versão. Todos eles receberão a versão  <font color="#555">%versionDev%</font>. Deseja prosseguir?<br/> <br/>';
    this.ALE_DIFFERENT_VERSIONS            = 'As tarefas selecionadas precisam estar na mesma versão de desenvolvimento!';
    this.ALE_PROJECT_IN_PROGRESS           = 'O projeto em que a tarefa será salva está em andamento.<BR> Deseja continuar?';
    this.ALE_PROJECT_IN_PROGRESS_BY_BOARD_ISSUE = 'Os projetos abaixo estão andamento:<br/><br/> %1 .<BR> Deseja continuar?';
    this.ALE_MENAGER_NOT_RELATED_STRUCTURES = 'Não há estruturas disponíveis que contemplem todos os gerentes.';
    this.ALE_RELATED_STRUCTURE_NO_LONGER_USABLE = 'Devido às alterações realizadas no campo "Gerente", a estrutura atual não poderá ser utilizada.';
    this.ALE_PROJECT_NOT_ALLOW_TASK             = 'O(s) projeto(s) selecionado(s) não permitem criar tarefa';

    this.NOTIF_DELETE_BUDGET_ITEMS             = 'Item de Orçamento exluído !';
    this.NOTIF_INATIVE_BUDGET_ITEMS            = 'Item de Orçamento inativado !';
    this.NOTIF_BUDGET_CREATED_CONTINUE_PROCESS            = 'Orçamento criado com sucesso!. <br> Deseja continuar o processo de finalização da tarefa ?';
    this.NOTIF_MAINTENANCE_BUDGET_CONTINUE_PROCESS            = 'Valor da manutenção criada com sucesso!. <br> Deseja continuar o processo de finalização da tarefa ?';
    this.ERR_NOT_ENOUGH_WORDS = "A resposta precisa de pelo menos, 50 caracteres ";
    this. ERR_ISSUE_RESPONSE = "A issue a seguir não possui uma resposta apropriada";
    this.ALE_CONFIRM_CHANGE_LTS_REMOVAL = "Atenção!<br/>O suporte à atualizações das versões selecionadas será retirado. Esse processo é permanente.<br/>Deseja prosseguir?";
    this.ALE_CONFIRM_LTS_REMOVAL = "Deseja remover versões LTS intermediárias?";
    this.ALE_CONFIRM_PROCEED_WITHOUT_REMOVAL = "Deseja prosseguir sem nenhuma alteração nas versões LTS?";
    this.ALE_LTS_UPDATED = "Atualização de LTS realizada com sucesso!";
    /* + ----------------------------------- +
     * | Load messages                       |
     * + ----------------------------------- + */
    this.LOAD_DEFAULT                     = 'Aguarde...';
    this.LOAD_STARTING_TASK               = 'Iniciando a tarefa...';
    this.LOAD_STARTING_TASK_REPLICATION   = 'Iniciando a tarefa de REPLICAÇÃO...';
    this.LOAD_PAUSING_TASK                = 'Pausando a tarefa...';
    this.LOAD_ENDING_TASK                 = 'Encerrando a tarefa...';
    this.LOAD_ENDING_PROCESS              = 'Finalizando o processo...';
    this.LOAD_SEARCHING_STATUS_TASK       = 'Buscando arquivos modificados...';
    this.LOAD_CREATING_LINKS              = 'Criando links para Diff...';
    this.LOAD_VALIDATING_REPOSITORIES     = 'Validando repositórios...';
    this.LOAD_CHANGING_CURRENT_BRANCH     = 'Alterando a branch corrente para %1...';
    this.LOAD_CREATING_UP_NEW_BRANCH      = 'Atualizando a branch da tarefa...';
    this.LOAD_CREATING_BRANCH_FINAL       = 'Criando a branch FINAL da tarefa...';
    this.LOAD_EXECUTING_ADD_COMMIT        = 'Adicionando e executando o commit dos arquivos...';
    this.LOAD_EXECUTING_RESET             = 'Executando o reset dos arquivos...';
    this.LOAD_EXECUTING_STASH             = 'Executando o stash dos arquivos...';
    this.LOAD_UPDATING_FILES              = 'Atualizando arquivos da branch da tarefa...';
    this.LOAD_CREAT_UP_BRANCH_BKP_SERVER  = 'Atualizando a branch BKP no servidor...';
    this.LOAD_CREAT_BRANCH_FINAL_SERVER   = 'Criando a branch FINAL no servidor...';
    this.LOAD_CREATING_REPLICATION_TASK   = 'Criando a tarefa de REPLICAÇÃO...';
    this.LOAD_STARTING_MERGE_MASTER       = 'Iniciando o merge com a branch master...';
    this.LOAD_UPDATING_MASTER_WITH_BRANCH = 'Atualizando o master com os registros da branch...';
    this.LOAD_REMOVING_BKP_BRANCHES       = 'Removendo as branches BKP...';
    this.LOAD_REMOVING_REPLICATION_BRANCH = 'Removendo as branches de REPLICAÇÃO...';
    this.LOAD_APPLYING_STASH              = 'Aplicando o stash...';
    this.LOAD_REMOVING_STASHES_BRANCHES   = 'Removendo branch do stash...';
    this.LOAD_RELOAD_VERSION              = 'Reiniciando o sistema...';
    this.LOAD_CREATING_DEVOPS_BRANCH      = 'Criando a branch na Sub-release do DevOps...';
    this.LOAD_SAVING_APPROPRIATION        = 'Salvando a apropriação...';
    this.LOAD_UPDATING_LOCAL_MASTER       = 'Atualizando a branch master local...';
    this.LOAD_CREATING_MERGE_REQUEST_TASK = 'Criando a(s) tarefa(s) para realizar o Merge Request...';
    this.LOAD_GENERATING_NEW_TASK         = 'Gerando a(s) nova(s) tarefa(s)...';
    this.LOAD_GENERATING_MEETING_PLANNING = 'Criando ocorrência(s) de reunião. (Essa ação pode demorar...)';
    this.LOAD_RECALC_TASKS                = 'Recalculating dates ';

    /* + ------------------------------------ +
     * | Calendar                             |
     * + ------------------------------------ + */
    this.ERRO_IN_EDIT_CALENDAR = 'Essa exceção deve ser alterado em seu calendário de origem';
    this.ERRO_IN_DELETE_HOUR_WEEK = 'A semana de trabalho "Padrão" não pode ser excluída.';
    this.ERRO_IN_SAVE_HOUR_WEEK = 'Não é possível salvar uma nova semana de trabalho "Padrão". Por favor, utilize a existente.';
    this.ALO_IS_NOT_POSSIBLE_ADD_EXCEPTION_PART_1 = 'Para adicionar exceções ao calendário do ';
    this.ALO_IS_NOT_POSSIBLE_ADD_EXCEPTION_PART_2 = ' é necessário informar o calendário base.';
    this.ALO_IS_NOT_POSSIBLE_ADD_HOUR_WEEK_PART_1 = 'Para adicionar uma semana de trabalho ao calendário do ';
    this.ALO_IS_NOT_POSSIBLE_ADD_HOUR_WEEK_PART_2 = ' é necessário informar o calendário base.';
    this.ALO_DELETE_EXCEPTION = 'Deseja apagar a exceção?';
    this.ALO_DELETE_HOUR_WEEK = 'Deseja apagar a semana de trabalho?';
    this.ALO_DELETE_CALENDAR = 'Deseja apagar o calendário?';

   /* + ------------------------------------ +
    * | Type relationship task               |
    * + ------------------------------------ + */
    this.DATA_TYPE_RELATIONSHIP_TASK = [
        { VALUE: 'C', DESCRIPTION: 'Conflito' },
        { VALUE: 'E', DESCRIPTION: 'Erro' },
        { VALUE: 'T', DESCRIPTION: 'Teste' },
        { VALUE: 'M', DESCRIPTION: 'Merge Request'}
    ];

    this.DATA_TYPE_RELATIONSHIP_TASK_MR = [
        { VALUE: 'C', DESCRIPTION: 'Conflito' },
        { VALUE: 'G', DESCRIPTION: 'Erro (Merge Request)' }
    ];

    this.DATA_TYPE_RELATIONSHIP_TASK_TEST = [
        { VALUE: 'E', DESCRIPTION: 'Erro' }
    ];

    this.FULL_DATA_TYPE_RELATIONSHIP_TASK = [
        { VALUE: 'C', DESCRIPTION: 'Conflito'             },
        { VALUE: 'D', DESCRIPTION: 'Conflito (DevOps)'    },
        { VALUE: 'E', DESCRIPTION: 'Erro'                 },
        { VALUE: 'G', DESCRIPTION: 'Erro (Merge Request)' },
        { VALUE: 'M', DESCRIPTION: 'Merge Request'        },
        { VALUE: 'R', DESCRIPTION: 'Replicação de código' },
        { VALUE: 'T', DESCRIPTION: 'Teste'                },
        { VALUE: 'O', DESCRIPTION: 'Origem'               },
        { VALUE: 'A', DESCRIPTION: 'Relacionada'          }
    ];

    this.TYPE_GENERATED_TASK = ["C", "E", "R", "M", "G", "T", "O", "D", "A"];
    this.TYPE_GENERATED_TASK_WITHOUT_ORIGIN = ["C", "E", "R", "M", "G", "T", "D", "A"];
    this.TYPE_GENERATED_TASK_WITHOUT_ORIGIN_AND_RELATED = ["C", "E", "R", "M", "G", "T", "D"];

    this.ERR_CONTAINER_MEETING_PLANNING = {
        1:this.ERR_CREATE_MEETING,
        2:this.ERR_CREATE_MEETING_OCCURRENCES,
        3:this.ERR_IS_NOT_SCHEDULE,
        4:this.ERR_IS_TASK_STATUS
    };
    this.ERR_CONTAINER_TASK_CONFIGURATION = {
        1:this.ERR_DELETE_FK
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Messages', Messages);
});


// FILE: assets/js/util/PmDirectives.js
ZeedhiDirectives.directive('zhStylePm', function(ZhUtil, ApplicationContext, ZhLogger) {
    return {
        link: function($scope, element, attrs, controller) {
            setTimeout(function () {
                var property = attrs.zhStylePm || 'row';
                var component = attrs.zhStylePmComponent || 'field';

                function evaluateCondition(propertyValue, condition) {
                    //@todo: Somebody doesn't like this
                    var result = false;
                    ApplicationContext.registerInstance('row', propertyValue || {});

                    try {
                        result = ZhUtil.evaluate("@" + condition + "@");
                    } catch (e) {
                        ZhLogger.error("Error while evaluating ZhStyle condition function", e);
                    }

                    ApplicationContext.removeInstance('row');
                    return result;
                }

                function callFunction(functionStr, propertyValue) {
                    //@todo: Somebody doesn't like this
                    var func;
                    ApplicationContext.registerInstance('row', propertyValue);
                    ApplicationContext.registerInstance('element', element);

                    try {
                        result = ZhUtil.evaluate(functionStr);
                    } catch (e) {
                        ZhLogger.error("Error while evaluating ZhStyle styling function", e);
                    }

                    ApplicationContext.removeInstance('row');
                    ApplicationContext.removeInstance('element');
                }

                function customizeByCss(condition, cssClass) {
                    // Any modification on class property must be done post digest because angular can change it if "{{ }} binds" exist.
                    $scope.$$postDigest(function() {
                        if (condition) {
                            element.addClass(cssClass);
                        } else {
                            element.removeClass(cssClass);
                        }
                    });
                }

                function customizeByFunction(condition, functionStr, propertyValue) {
                    if (condition) {
                        callFunction(functionStr, propertyValue);
                    }
                }


                $scope.$watchCollection(property, function(propertyValue) {

                    var customStyles = [];

                    if ($scope[component] && $scope[component].styles) {
                        customStyles = $scope[component].styles;
                    } else if ($scope.widget && $scope.widget.styles) {
                        customStyles = $scope.widget.styles;
                    }

                    customStyles.forEach(function(customization) {
                        var conditionResult = evaluateCondition(propertyValue, customization.condition);

                        // Simple way, add a CSS class to the element
                        if (customization.cssClass) {
                            customizeByCss(conditionResult, customization.cssClass);
                        }

                        // Advanced way, execute a function passing the element and the row as parameters
                        if (customization.stylingFunctionPM) {
                            customizeByFunction(conditionResult, customization.stylingFunction, propertyValue);
                        }

                    });
                });
            }, 3000);
        }
    };
});

// FILE: assets/js/util/PmLocalVars.js
function PmLocalVars(localStorageEngine){

    localStorageEngine.setLocalVar = memoryStorage.setLocalVar;
    localStorageEngine.getLocalVar = memoryStorage.getLocalVar;
    getLocalVar = memoryStorage.getLocalVar;
    setLocalVar = memoryStorage.setLocalVar;


    this.getLocalVarResponsibleId = function(){
        return localStorageEngine.getLocalVar('responsibleId');
    };

    this.setLocalVarResponsibleId = function(value){
        return localStorageEngine.setLocalVar('responsibleId', value);
    };

    this.getProjectStatusControl = function(){
        return localStorageEngine.getLocalVar('projectStatusControl');
    };

    this.setProjectStatusControl = function(value){
        return localStorageEngine.setLocalVar('projectStatusControl',value);
    };

    this.setLocalVarProjectStatus = function(value){
        return localStorageEngine.setLocalVar('projectStatus', value);
    };

    this.getLocalVarProjectStatus= function(){
        return localStorageEngine.getLocalVar('projectStatus');
    };

    this.setLocalVarLogin = function(value){
        return localStorageEngine.setLocalVar('login', value);
    };

    this.getLocalVarLogin= function(){
        return localStorageEngine.getLocalVar('login');
    };

    this.setLocalVarProjectType = function(value){
        return localStorageEngine.setLocalVar('projectType', value);
    };

    this.getLocalVarProjectType = function(){
        return localStorageEngine.getLocalVar('projectType');
    };

    this.setLocalVarProjectParent = function(value){
        return localStorageEngine.setLocalVar('projectParent', value);
    };

    this.getLocalVarProjectParent = function(){
        return localStorageEngine.getLocalVar('projectParent');
    };


    this.getResponsibleId = function(){
        return this.getLocalVarResponsibleId();
    };
    this.setResponsibleId = function(value){
        return this.setLocalVarResponsibleId(value);
    };

    this.getLocalVarProjectStart = function(){
        return localStorageEngine.getLocalVar('projectStart');
    };
    this.setLocalVarProjectStart = function(value){
        return localStorageEngine.setLocalVar('projectStart', value);
    };

    this.getLocalVarCountry = function(){
        return localStorageEngine.getLocalVar('country');
    };
    this.setLocalVarCountry = function(value){
        return localStorageEngine.setLocalVar('country', value);
    };

    this.getLocalVarState = function(){
        return localStorageEngine.getLocalVar('state');
    };
    this.setLocalVarState = function(value){
        return localStorageEngine.setLocalVar('state', value);
    };

    this.getDescriptionControl = function(){
        return localStorageEngine.getLocalVar('descriptionControl');
    };
    this.setDescriptionControl = function(value){
        return localStorageEngine.setLocalVar('descriptionControl', value);
    };

    this.getAppropriationIdControl = function(){
        return localStorageEngine.getLocalVar('appropriationId');
    };
    this.setAppropriationIdControl = function(value){
        return localStorageEngine.setLocalVar('appropriationId', value);
    };

    this.getAllocationId = function(){
        return localStorageEngine.getLocalVar('allocationID');
    };
    this.setAllocationId = function(value){
        return localStorageEngine.setLocalVar('allocationID', value);
    };
    this.getTaskAllocationId = function(){
        return localStorageEngine.getLocalVar('taskAllocationID');
    };

    this.setTaskProjectId = function(value){
        return localStorageEngine.setLocalVar('task_projectId', value);
    };

    this.getUserProfiles= function(){
        return localStorageEngine.getLocalVar('userProfiles');
    };

    this.setUserProfiles = function(value){
        return localStorageEngine.setLocalVar('userProfiles', value);
    };

    this.getTaskProjectId= function(){
        return localStorageEngine.getLocalVar('task_projectId');
    };

    this.setTaskAllocationId = function(value){
        return localStorageEngine.setLocalVar('taskAllocationID', value);
    };

    this.getLocalVarStructureIds = function(){
        return localStorageEngine.getLocalVar('structureIds');
    };
    this.setLocalVarStructureIds = function(value){
        return localStorageEngine.setLocalVar('structureIds', value);
    };

    this.getLocalVarNewTaskParent = function(){
        return localStorageEngine.getLocalVar('newTaskParent');
    };
    this.setLocalVarNewTaskParent = function(value){
        return localStorageEngine.setLocalVar('newTaskParent', value);
    };

    this.getIsModel = function(){
        return localStorageEngine.getLocalVar('isModel');
    };
    this.setIsModel = function(value){
        return localStorageEngine.setLocalVar('isModel', value);
    };

    this.getProjectId = function(){
        return localStorageEngine.getLocalVar('projectId');
    };
    this.setProjectId = function(value){
        return localStorageEngine.setLocalVar('projectId', value);
    };

    this.getStructureIds = function(){
        return this.getLocalVarStructureIds();
    };
    this.setStructureIds = function(value){
        return this.setLocalVarStructureIds(value);
    };

    this.getProjectInIssue = function(){
        return localStorageEngine.getLocalVar('projectInIssue');
    };
    this.setProjectInIssue = function(value){
        return localStorageEngine.setLocalVar('projectInIssue', value);
    };

    this.getProjectIssueId = function(){
        return localStorageEngine.getLocalVar('PROJECT_ISSUE_ID');
    };
    this.setProjectIssueId = function(value){
        return localStorageEngine.setLocalVar('PROJECT_ISSUE_ID', value);
    };

    this.getSelectedProjectIssueId = function(){
        return localStorageEngine.getLocalVar('SELECTED_PROJECT_ISSUE_ID');
    };
    this.setSelectedProjectIssueId = function(value){
        return localStorageEngine.setLocalVar('SELECTED_PROJECT_ISSUE_ID', value);
    };

    this.getComment = function(){
        return localStorageEngine.getLocalVar('comment');
    };
    this.setComment = function(value){
        return localStorageEngine.setLocalVar('comment', value);
    };

    this.getTaskParameters = function(){
        return localStorageEngine.getLocalVar('taskParameters');
    };
    this.setTaskParameters = function(value){
        return localStorageEngine.setLocalVar('taskParameters', value);
    };

    this.getMaxOrderToView = function(){
        return localStorageEngine.getLocalVar('maxOrderToView');
    };
    this.setMaxOrderToView = function(value){
        return localStorageEngine.setLocalVar('maxOrderToView', value);
    };

    this.getIssueStatusId = function(){
        return localStorageEngine.getLocalVar('issueStatusId');
    };
    this.setIssueStatusId = function(value){
        return localStorageEngine.setLocalVar('issueStatusId', value);
    };

    this.getProductFilter = function(){
        return localStorageEngine.getLocalVar('productFilter');
    };

    this.setProductFilter = function(value){
        return localStorageEngine.setLocalVar('productFilter', value);
    };

    this.getProductGridFilter = function(){
        return localStorageEngine.getLocalVar('productGridFilter');
    };

    this.setProductGridFilter = function(value){
        return localStorageEngine.setLocalVar('productGridFilter', value);
    };

    this.getManagerProject = function(){
        return localStorageEngine.getLocalVar('managerProject');
    };
    this.getManagerProject= function(value){
        return localStorageEngine.setLocalVar('managerProject', value);
    };

    this.getMaxOrderToFrame = function(){
        return localStorageEngine.getLocalVar('maxOrderToFrame');
    };
    this.setMaxOrderToFrame = function(value){
        return localStorageEngine.setLocalVar('maxOrderToFrame', value);
    };

    this.getLocalVarDay = function(){
        return localStorageEngine.getLocalVar('day');
    };
    this.setLocalVarDay = function(value){
        return localStorageEngine.setLocalVar('day', value);
    };

    this.getLocalVarResource = function(){
        return localStorageEngine.getLocalVar('resource');
    };
    this.setLocalVarResource = function(value){
        return localStorageEngine.setLocalVar('resource', value);
    };
    
    this.getFilterByDashboard = function(){
        return localStorageEngine.getLocalVar('filterByDashboard');
    };
    this.setFilterByDashboard = function(value){
        return localStorageEngine.setLocalVar('filterByDashboard', value);
    };

    this.getLocalVarIdBusinessPartner = function(){
        return localStorageEngine.getLocalVar('idBusinessPartner');
    };
    this.setLocalVarIdBusinessPartner = function(value){
        return localStorageEngine.setLocalVar('idBusinessPartner', value);
    };

    this.getIdBusinessPartner = function(){
        return this.getLocalVarIdBusinessPartner();
    };
    this.setIdBusinessPartner = function(value){
        return this.setLocalVarIdBusinessPartner|(value);
    };

    this.getLocalVarTaskId = function(){
        return localStorageEngine.getLocalVar('taskId');
    };
    this.setLocalVarTaskId = function(value){
        return localStorageEngine.setLocalVar('taskId', value);
    };

    this.getRepositoriesId = function(){
        return localStorageEngine.getLocalVar('repositoriesId');
    };
    this.setRepositoriesId = function(value){
        return localStorageEngine.setLocalVar('repositoriesId', value);
    };

    this.getLocalVarIssueDependentId = function(){
        return localStorageEngine.getLocalVar('issueDependentId');
    };
    this.setLocalVarIssueDependentId = function(value){
        return localStorageEngine.setLocalVar('issueDependentId', value);
    };

    this.getExistsBacklogControl= function(){
        return localStorageEngine.getLocalVar('EXISTS_BACKLOG_CONTROL');
    };
    this.setExistsBacklogControl= function(value){
        return localStorageEngine.setLocalVar('EXISTS_BACKLOG_CONTROL', value);
    };

    this.getTaskId = function(){
        return this.getLocalVarTaskId();
    };
    this.setTaskId = function(value){
        return this.setLocalVarTaskId(value);
    };

    this.getBoardName = function(){
         return localStorageEngine.getLocalVar('boardName');
    };
    this.setBoardName = function(value){
        return localStorageEngine.setLocalVar('boardName', value);
    };

    this.getBoardId = function(){
         return localStorageEngine.getLocalVar('boardId');
    };
    this.getBoard = function(){
         return localStorageEngine.getLocalVar('board');
    };
    this.setBoardId = function(value){
        return localStorageEngine.setLocalVar('boardId', value);
    };
    this.setBoard = function(value){
        return localStorageEngine.setLocalVar('board', value);
    };
    this.getCheckedBoardId = function(){
         return localStorageEngine.getLocalVar('checkedboardId');
    };
    this.setCheckedBoardId = function(value){
        return localStorageEngine.setLocalVar('checkedboardId', value);
    };
    
    this.getAllIdsMyProducts = function(){
         return localStorageEngine.getLocalVar('allIdsMyProducts');
    };
    this.setAllIdsMyProducts = function(value){
        return localStorageEngine.setLocalVar('allIdsMyProducts', value);
    };

    this.getProject = function(){
        return localStorageEngine.getLocalVar('project');
    };
    this.setProject = function(value){
        return localStorageEngine.setLocalVar('project', value);
    };
    
    this.getProduct = function(){
        return localStorageEngine.getLocalVar('product');
    };
    this.setProduct = function(value){
        return localStorageEngine.setLocalVar('product', value);
    };

    this.getProjectName = function(){
        return localStorageEngine.getLocalVar('projectName');
    };
    this.setProjectName = function(value){
        return localStorageEngine.setLocalVar('projectName', value);
    };

    this.getScheduleId = function(){
        return localStorageEngine.getLocalVar('scheduleId');
    };
    this.setScheduleId = function(value){
        return localStorageEngine.setLocalVar('scheduleId', value);
    };

    this.getTaskLabelTypeId = function(){
        return localStorageEngine.getLocalVar('taskLabelTypeId');
    };
    this.setTaskLabelTypeId = function(value){
        return localStorageEngine.setLocalVar('taskLabelTypeId', value);
    };

    this.getCalendarId = function(){
        return localStorageEngine.getLocalVar('calendarId');
    };
    this.setCalendarId = function(value){
        return localStorageEngine.setLocalVar('calendarId', value);
    };

    this.getCalendarExceptionId = function(){
        return localStorageEngine.getLocalVar('calendarExceptionId');
    };
    this.setCalendarExceptionId = function(value){
        return localStorageEngine.setLocalVar('calendarExceptionId', value);
    };
    
    this.getCurrentRow = function(){
        return localStorageEngine.getLocalVar('currentRow');
    };
    this.setCurrentRow = function(value){
        return localStorageEngine.setLocalVar('currentRow', value);
    };
    
    this.getLoginPromise = function(){
        return localStorageEngine.getLocalVar('loginPromise');
    };
    this.setLoginPromise = function(value){
        return localStorageEngine.setLocalVar('loginPromise', value);
    };

    this.getMeetingId = function(){
        return localStorageEngine.getLocalVar('meetingId');
    };
    this.setMeetingId  = function(value){
        return localStorageEngine.setLocalVar('meetingId', value);
    };

    this.getIssueClassification = function(){
        return localStorageEngine.getLocalVar('issueClassification');
    };
    this.setIssueClassification= function(value){
        return localStorageEngine.setLocalVar('issueClassification', value);
    };

    this.getissueClassifications = function(){
        return localStorageEngine.getLocalVar('issueClassifications');
    };
    this.setIssueClassifications = function(value){
        return localStorageEngine.setLocalVar('issueClassifications', value);
    };

    this.getStructureId = function(){
        return localStorageEngine.getLocalVar('structureId');
    };
    this.setStructureId = function(value){
        return localStorageEngine.setLocalVar('structureId', value);
    };

    this.getTaskPaths = function(){
        return localStorageEngine.getLocalVar('TASK_PATHS');
    };
    this.setTaskPaths = function(value){
        value = JSON.parse(JSON.stringify(value));
        return localStorageEngine.setLocalVar('TASK_PATHS', value);
    };

    this.getUserCurrentProfile = function(){
        return localStorageEngine.getLocalVar('userCurrentProfile');
    };

    this.setUserCurrentProfile = function(value){
        return localStorageEngine.setLocalVar('userCurrentProfile', value);
    };

    this.getProfiles = function(){
        return localStorageEngine.getLocalVar('profiles');
    };

    this.setProfiles = function(value){
        return localStorageEngine.setLocalVar('profiles', value);
    };

    this.getProjectResource = function(){
        return localStorageEngine.getLocalVar('projectResource');
    };

    this.setProjectResource = function(value){
        return localStorageEngine.setLocalVar('projectResource', value);
    };

    this.getProjectResourceId = function(){
        return localStorageEngine.getLocalVar('projectResourceId');
    };
    this.setResourceT = function(value){
        return localStorageEngine.setLocalVar('RESOURCE_T', value);
    };

    this.getResourceT = function(){
        return localStorageEngine.getLocalVar('RESOURCE_T');
    };

    this.setProjectResourceId = function(value){
        return localStorageEngine.setLocalVar('projectResourceId', value);
    };

    this.getLastDateViewComments = function(){
        return localStorageEngine.getLocalVar('lastDateViewComments');
    };

    this.setLastDateViewComments = function(value){
        return localStorageEngine.setLocalVar('lastDateViewComments', value);
    };

    this.setIssue = function(value){
        localStorageEngine.setLocalVar('issue', [value]);
    };
    this.setIssueWithArray = function(value){
        localStorageEngine.setLocalVar('issue', value);
    };

    this.getIssue = function(){
        return localStorageEngine.getLocalVar('issue');
    };

    this.setLocalConnectionProject = function(value){
        localStorageEngine.setLocalVar('localConnectionProject', value);
    };

    this.getLocalConnectionProject = function(){
        return localStorageEngine.getLocalVar('localConnectionProject');
    };
    
    this.setLastWindow = function(value){
        localStorageEngine.setLocalVar('lastWindow', value);
    };

    this.getLastWindow = function(){
        return localStorageEngine.getLocalVar('lastWindow');
    };

    this.setLastWidget = function(value){
        localStorageEngine.setLocalVar('lastWidget', value);
    };

    this.getLastWidget = function(){
        return localStorageEngine.getLocalVar('lastWidget');
    };
    
    /************************************************************
     * Saves into local storage a value which indicates when the
     * last selected project (Project screen or any other) has any
     * task which has one or more appropriations.
     * @param value
     ************************************************************/
    this.setLocalVarClickedProjectHasAppropriatedTask = function(value){
        localStorageEngine.setLocalVar('clickedProjectHasAppropriatedTask', value);
    };

    /************************************************************
     * Gets value from Local Storage.
     ************************************************************/
    this.getLocalVarClickedProjectHasAppropriatedTask = function(){
        return localStorageEngine.getLocalVar('clickedProjectHasAppropriatedTask');
    };

    /************************************************************
     * Gets from Local Storage a value which indicates the last
     * clicked project id.
     ************************************************************/
    this.getClickedProjectId = function(){
        return localStorageEngine.getLocalVar('clickedProjectId');
    };

    /************************************************************
     * Sets into Local Storage a value which indicates the last
     * clicked project id.
     ************************************************************/
    this.setClickedProjectId = function(value){
        localStorageEngine.setLocalVar('clickedProjectId', value);
    };

    /************************************************************
     * Saves into local storage a value which indicates the clicked
     * project.
     * @param value
     ************************************************************/
    this.setClickedProjectName = function(value){
        localStorageEngine.setLocalVar('clickedProjectName', value);
    };

    /************************************************************
     * Gets from Local Storage a value which indicates the clicked
     * project.
     ************************************************************/
    this.getClickedProjectName = function(){
        return localStorageEngine.getLocalVar('clickedProjectName');
    };

    /************************************************************
     * Saves into local storage a value which indicates if the
     * last clicked project allows his tasks to be finished or
     * not.
     * @param value
     ************************************************************/
    this.setClickedProjectAllowEndTasks = function(value){
        localStorageEngine.setLocalVar('clickedProjectAllowEndTasks', value);
    };

    /************************************************************
     * Gets value from Local Storage.
     ************************************************************/
    this.getClickedProjectAllowEndTasks = function(){
        return localStorageEngine.getLocalVar('clickedProjectAllowEndTasks');
    };

    /************************************************************
     * Saves into local storage a value which indicates if the
     * last clicked project uses time planning.
     * @param value
     ************************************************************/
    this.setClickedProjectUseTimePlanning = function(value){
        localStorageEngine.setLocalVar('clickedProjectUseTimePlanning', value);
    };

    /************************************************************
     * Gets value from Local Storage.
     ************************************************************/
    this.getClickedProjectUseTimePlanning = function(){
        return localStorageEngine.getLocalVar('clickedProjectUseTimePlanning');
    };

    this.setProjectExternalType = function(value){
        localStorageEngine.setLocalVar('projectExternalType', value);
    };

    this.getProjectExternalType = function(){
        return localStorageEngine.getLocalVar('projectExternalType');
    };

    /************************************************************
     * Saves into local storage a value which indicates the last
     * task name clicked.
     * @param value
     ************************************************************/
    this.setClickedTaskName = function(value){
        localStorageEngine.setLocalVar('clickedTaskName', value);
    };

    /************************************************************
     * Gets value from Local Storage.
     ************************************************************/
    this.getClickedTaskName = function(){
        return localStorageEngine.getLocalVar('clickedTaskName');
    };

    /************************************************************
     * Saves today date into local storage.
     ************************************************************/
    this.setTodayDate = function(today){
        localStorageEngine.setLocalVar('todayDate', today);
    };

    /************************************************************
     * Gets today date from local storage.
     ************************************************************/
    this.getTodayDate = function(){
        return localStorageEngine.getLocalVar('todayDate');
    };

    /************************************************************
     * Saves today weekday date into local storage.
     ************************************************************/
    this.setTodayWeekdayDate = function(weekday){
        localStorageEngine.setLocalVar('todayWeekdayDate', weekday);
    };

    /************************************************************
     * Gets today weekday date from local storage.
     ************************************************************/
    this.getTodayWeekdayDate = function(){
        return localStorageEngine.getLocalVar('todayWeekdayDate');
    };

    /************************************************************
     * Sets which tab is opening a swipe.
     ************************************************************/
    this.setWhichTabIsOpeningSwipe = function(value){
        localStorageEngine.setLocalVar('whichTabIsOpeningSwipe', value);
    };

    /************************************************************
     * Gets which tab is opening a swipe.
     ************************************************************/
    this.getWhichTabIsOpeningSwipe = function(){
        return localStorageEngine.getLocalVar('whichTabIsOpeningSwipe');
    };

    /************************************************************
     * Gets current logged user's name.
     ************************************************************/
    this.getUserName = function(){
        return localStorageEngine.getLocalVar('userName');
    };

    /************************************************************
     * Sets current logged user's name.
     ************************************************************/
    this.setUserName = function(userName){
        localStorageEngine.setLocalVar('userName', userName);
    };

    /************************************************************
     * Gets current logged user's external id.
     ************************************************************/
    this.getResourceExternalId = function(){
        return localStorageEngine.getLocalVar('resourceExternalId');
    };

    /************************************************************
     * Sets current logged user's external id.
     ************************************************************/
    this.setResourceExternalId = function(externalId){
        localStorageEngine.setLocalVar('resourceExternalId', externalId);
    };

    /************************************************************
     * Gets current logged organization's external id.
     ************************************************************/
    this.getOrganizationExternalId = function(){
        return localStorageEngine.getLocalVar('ex_organization');
    };

    this.getOrganization = function(){
        return localStorageEngine.getLocalVar('organization');
    };

    /************************************************************
     * Sets current logged organization's external id.
     ************************************************************/
    this.setOrganizationExternalId = function(externalId){
        localStorageEngine.setLocalVar('resourceExternalId', externalId);
    };

    /************************************************************
     * Sets if is task dated.
     ************************************************************/
    this.setIsTaskDated = function(value){
        localStorageEngine.setLocalVar('isTaskDated', value);
    };

    /************************************************************
     * Gets if is task dated.
     ************************************************************/
    this.getIsTaskDated = function(){
        return localStorageEngine.getLocalVar('isTaskDated');
    };

    /***********************************************************************
     * Sets the sponsor what was clicked.
     ***********************************************************************/
    this.setSponsorListSelectedRow = function(value){
        localStorageEngine.setLocalVar('/sponsorListSelectedRow', value);
    };

    /***********************************************************************
     * Gets the sponsor what was clicked.
     ***********************************************************************/
    this.getSponsorListSelectedRow = function(){
        return localStorageEngine.getLocalVar('/sponsorListSelectedRow');
    };

    /***********************************************************************
     * Sets the sponsor what was clicked.
     ***********************************************************************/
    this.setSponsor = function(value){
        localStorageEngine.setLocalVar('/sponsor', value);
    };

    /***********************************************************************
     * Gets the sponsor what was clicked.
     ***********************************************************************/
    this.getSponsor = function(){
        return localStorageEngine.getLocalVar('/sponsor');
    };

    this.setCopyCalled = function(value){
        localStorageEngine.setLocalVar('copyCalled', value);
    };

    this.getCopyCalled = function(){
        return localStorageEngine.getLocalVar('copyCalled');
    };

    this.setCalledGenerateTask = function(value){
        localStorageEngine.setLocalVar('calledGenerateTask', value);
    };

    this.getCalledGenerateTask = function(){
        return localStorageEngine.getLocalVar('calledGenerateTask');
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('PmLocalVars', PmLocalVars);
});


// FILE: assets/js/util/SessionStorage.js
function SessionStorage(){
    this.jsonStringify = function (item) {
        return JSON.stringify(item);
    };

    this.jsonParse = function (item) {
        return JSON.parse(item);
    };

    this.setItem = function (key, item, jsonStringify) {
        jsonStringify = jsonStringify || true;
        if(jsonStringify){
            sessionStorage.setItem(key, this.jsonStringify(item));
        } else {
            sessionStorage.setItem(key, item);
        }
    };

    this.getItem = function (key, jsonParse) {
        jsonParse = jsonParse || true;
        if(jsonParse){
            return this.jsonParse(sessionStorage.getItem(key));
        } else {
            return sessionStorage.getItem(key);
        }
    };


}
Configuration(function(ContextRegister){
    ContextRegister.register('SessionStorage', SessionStorage);
});

// FILE: assets/js/util/Template.js
function Template(){
    this.toEditMode = function(widget){
        widget.edit();
        widget.template = 'widget/form.html';
    };

    this.toViewMode = function(widget){
        widget.view();
        widget.template = 'widget/form-view.html';
    };
}
Configuration(function(ContextRegister){
    ContextRegister.register('Template', Template);
});

// FILE: assets/js/util/Utilities.js
function Utilities(DateManager, templateManager, ScreenService,PmLocalVars,Messages,requestDataSourceEngine,PMConstants,
                   Template, ZHPromise, GitQueue, FieldsMetaData, ZhPreferences, ZhFilterPreferences, Query, LibUtilities) {
    // dont remove - To fix bug on page "Reuniões" -> field interval without displayFormat
    displayFormat = "DD/MM/YYYY";
    var milliseconds;
    var calendarProjectHour;
    var SHORT_WEEKDAY_BR = ['DOM', 'SEG', 'TER', 'QUA', 'QUI', 'SEX', 'SAB'];
    this.FORMAT_DATE_DEFAULT_ONLY_DATE = 'DD/MM/YYYY';
    this.MESSAGE_TYPE_CONFIRMATION = 'CONFIRMATION';

    var self = this;
    this.constants = PMConstants;
    this.dataManager = DateManager;
    this.localVar = PmLocalVars;
    this.messages = Messages;
    this.fieldsMetaData = FieldsMetaData;
    this.defaultTemplates = {
        formView: 'widget/form-view.html',
        form: 'widget/form.html'
    };
    DateManager.setUtilities(this);
    this.template = Template;

    /*************************************************************
     * Gets the current system time using Moment.
     * @returns {*}
     *************************************************************/
    this.getCurrentDate = function(){
        return moment().format('DD/MM/YYYY');
    };

    this.clone = function(value){
        return JSON.parse(JSON.stringify(value));
    };
    /*************************************************************
     * Gets the current system date and time using Moment
     * @returns {*}
     *************************************************************/
    this.getCurrentDateAndHour = function(){
        return moment().format('DD/MM/YYYY HH:mm:ss');
    };

    /*************************************************************
     * Gets a date (doesn't matter if format is dd/mm/yyyy or
     * dd-mm-yyyy), and always returns dd-mm-yyyy.
     * @param dateTime
     * @returns {*}
     *************************************************************/
    this.formatDateTime = function(dateTime) {
        if(dateTime !== ""){
            var date = moment(dateTime, "DD-MM-YYYY HH:mm");
            return date.format("DD-MM-YYYY HH:mm");
        }
    };

    /*************************************************************
     * Gets a dateTime (format: dd/mm/yyyy) and returns its inverse
     * (format: yyyy-mm-dd or yyyy/mm/dd)
     *************************************************************/
    this.invertDateTimeToYearMonthDay = function(dateTime, startDivider, finalDivider){
        finalDivider = finalDivider || startDivider;
        return dateTime.split(startDivider).reverse().join(finalDivider);
    };

    this.isNumber = function(n) {
        return !isNaN(parseFloat(n)) && isFinite(n);

    };

    /*************************************************************
     * There is a bug in Zeedhi where, sometimes, args.owner.field
     * isn't the field itself. So, if args.owner.field doesn't exist,
     * the method returns only args.owner.
     * @param args
     * @returns {owner|*|eventObj.owner}
     *************************************************************/
    this.getFieldByArgs = function (args) {
        var field = args.owner;
        if (args.owner.field) {
            field = args.owner.field;
        }
        return field;
    };

    this.byteLength = function(str) {
        var s = str.length;
        for (var i=str.length-1; i>=0; i--) {
            var code = str.charCodeAt(i);
            if (code > 0x7f && code <= 0x7ff) s++;
            else if (code > 0x7ff && code <= 0xffff) s+=2;
            if (code >= 0xDC00 && code <= 0xDFFF) i--;
        }
        return s;
    };

    this.compareTwoStringDatesDefault = function( date1, date2)
    {
        date1 = moment(date1,self.FORMAT_DATE_DEFAULT_ONLY_DATE).format("YYYYMMDD");
        date2 = moment(date2,self.FORMAT_DATE_DEFAULT_ONLY_DATE).format("YYYYMMDD");
        return date1 == date2;
    };
    /*************************************************************
     * -----
     * @param formatMobiscroll
     * @returns {string}
     *************************************************************/
    this.getFormatMomentByFormatMobicroll = function(formatMobiscroll){

        var formatMoment = formatMobiscroll.split('MM').map(function(data){return data.split('M').join('MMM');}).join('MMMM');
        formatMoment = formatMoment.split('m').join('M');
        formatMoment = formatMoment.split('y').join('YY');
        formatMoment = formatMoment.split('i').join('m');
        formatMoment = formatMoment.split('d').map(function(data){return data.split('D').join('d');}).join('D');

        return formatMoment;

    };

    /*************************************************************
     * Gets a dateTime (dd-mm-yyyy hh:mm or dd/mm/yyyy hh:mm) and
     * returns only its time.
     * @param dateTime
     * @returns {*}
     *************************************************************/
    this.parseDateTimeToTime = function(dateTime){
        if(dateTime !== ""){
            var time = moment(dateTime, "DD-MM-YYYY HH:mm" );
            return time.format("HH:mm");
        }
    };

    /*************************************************************
     * Calculates total of time, which means the difference between
     * endHour and beginHour, and returns an object containing these
     * datas.
     * @param beginHour
     * @param endHour
     * @returns {{}}
     *************************************************************/
    this.calculateTotalTime = function(beginHour, endHour){
        milliseconds = (moment(beginHour, "DD/MM/YYYY HH:mm").diff(moment(endHour,"DD/MM/YYYY HH:mm")))*(-1);
        var period;
        var data = {};
        if(milliseconds<0){
            period = "00:00";
            beginHour = endHour;
            data.period = period;
            data.hour = beginHour;
        }else{
            var hours = parseInt(milliseconds/3600000);
            var minutes = (milliseconds/60000);
            if(minutes>=60){
                minutes = (minutes%60);
            }
            if(minutes<10){
                minutes = '0'+minutes;
            }
            if(hours<10){
                hours= '0'+hours;
            }
            data.period = hours+":"+minutes;
            data.hour = null;
        }

        if(data.period == "NaN:NaN"){
            data.period = "00:00";
        }

        return data;
    };

    this.calculateBeginTime = function(endHour, total){
        //subtraia uma quatidade de horas à determinada data
        var auxHour = "00:00";
        var minutes = (((moment(total, "HH:mm").diff(moment(auxHour, "HH:mm"))))/60000);
        var beginHour = moment(endHour, "DD/MM/YYYY HH:mm").subtract(minutes, 'minutes');
        beginHour = beginHour.format("DD/MM/YYYY HH:mm");
        return beginHour;
    };

    this.ribbonStyles = function(element,row){
        element.find(".kanban-task-ribbon").css("background-color", row.COLOR);
        element.find(".kanban-task-ribbon .before").css("border-top-color", row.COLOR);
        element.find(".kanban-task-ribbon .after").css("border-right-color", row.COLOR);
    };

    this.addPaddingLastUpdate = function (element, row) {
        element.find(".pm-kanban-last-update-item").css("padding-right", "30px");
        element.find(".pm-kanban-situacao").css("padding-right", "30px");
    };

    this.isSmallDescDiv = function(element, row) {
        var e = element.find('.kanban-desc');
        row.isSmall = e[0].clientHeight <= 60;
    };

    this.calculateEndTime = function(beginHour, total){
        //adicione uma quantidade de horas à uma determinada data
        var auxHour = "00:00";
        var minutes = (((moment(total, "HH:mm").diff(moment(auxHour, "HH:mm"))))/60000);
        var endHour = moment(beginHour, "DD/MM/YYYY HH:mm").add(minutes, 'minutes');
        endHour = endHour.format("DD/MM/YYYY HH:mm");
        return endHour;

    };

    this.calculatePeriod = function(beginHour, endHour, calendarHour){
        calendarProjectHour = calendarHour;
        milliseconds = moment(beginHour,"DD/MM/YYYY HH:mm:ss").diff(moment(endHour,"DD/MM/YYYY HH:mm:ss"));
        var periodData = moment.duration(milliseconds);
        var period = Math.floor(periodData.asHours()) + moment.utc(milliseconds).format(":mm:ss");

        var hours = (milliseconds/3600000);
        var minutes = (milliseconds/60000);
        var calendarMinutes = calendarHour*60;
        var durationMinutes = (minutes%calendarMinutes);
        var totalHours;
        var totalMinutes;

        if(milliseconds==(-(calendarHour*3600000))) { // um dia de trabalho
            period = calendarHour+':00';
        }

        if(milliseconds<(-(calendarHour*3600000))){//maior que o dia de trabalho

            var days = ((milliseconds/(3600000))/calendarHour);
            var durationDays = (parseInt(hours/calendarHour))*(-1);
            if((durationMinutes*(-1))>60){
                totalHours = (parseInt(durationMinutes/60))*(-1);
                totalMinutes = (durationMinutes%60)*(-1);
                if(totalMinutes<10){
                    totalMinutes+='0';
                }
                period = durationDays+'D'+' '+totalHours+'H'+totalMinutes;
            }else{
                period = durationDays+'D';
            }
        }
        if(milliseconds>(-(calendarHour*3600000)))
        {
            if((durationMinutes*(-1))>60){
                totalHours = (parseInt(durationMinutes/60))*(-1);
                totalMinutes = (durationMinutes%60)*(-1);
                if(totalMinutes<10){
                    totalMinutes +='0';
                }
                period = totalHours+':'+totalMinutes;
            }else{
                if(minutes*(-1) == 60){
                    period = '01:00';
                }else{
                    period = '00:'+ (-(minutes));
                }
            }
        }


        return period;
    };

    this.parseHourToSeconds = function(hours) {
    	hours = hours.split(':');
    	return  hours[0] * 3600 + hours[1] * 60;
    };
    
    this.parseSecondsToHourString = function(seconds, dashboardFormat) {
        var minutes = Math.floor(seconds / 60);
        var hoursToString = Math.floor(minutes/60).toString();
        minutesToString = (minutes % 60).toString();
        minutesToString = (minutesToString.length <= 1) ? '0' + minutesToString : minutesToString;
        hoursToString = (hoursToString.length <= 1) ? '0' + hoursToString : hoursToString;
        if(dashboardFormat){
            return (seconds < 60) ? '00H' + minutesToString + 'm' : hoursToString + 'H' + minutesToString + 'm';
        } else {
            return (seconds < 60) ? '00:' + minutesToString : hoursToString + ':' + minutesToString;
        }
    };

    this.formatValueToPercent = function(value) {
    	value = Math.abs(value);
        return value + '%';
    };

    this.calculateHour = function(beginHour, endHour){
        var duration = moment(beginHour,"DD/MM/YYYY HH:mm:ss").diff(moment(endHour,"DD/MM/YYYY HH:mm:ss"));
        duration = (((duration/1000)/60))*(-1);
        var hour = parseInt(duration/60);
        var minutes = (duration%60);
        if(minutes<10)
            minutes+='0';
        duration = hour+':'+minutes;
        return duration;
    };

    this.formatValueToHours = function(differenceTime){
        var totalMinutes = (differenceTime/1000)/60;
        var hour = parseInt(totalMinutes/60)*(-1);
        var minutes = (totalMinutes%60)*(-1);
        hour = hour+':'+minutes;
        return hour;

    };
    this.formatSecondsToHours = function(seconds){
        var totalMinutes = (seconds)/60;
        var hour = parseInt(totalMinutes/60);
        var minutes = (totalMinutes%60);
        if(hour < 10){
            hour = '0'+hour;
        }
        if(minutes <10){
            minutes = '0'+minutes;
        }
        hour = hour+':'+minutes;
        return hour;

    };

    this.keepOpenList = function (widget) {
        var dataSetOdd = widget.dataSource.data;
        ScreenService.showLoader();
        return widget.reload().then(function(data){
            ScreenService.hideLoader();
            var dataSet = widget.dataSource.data;
            function setOpen(taskNew) {
                if (dataSetOdd[key].ID == taskNew.ID) {
                    taskNew._opened = dataSetOdd[key]._opened;
                }
            }
            if (Array.isArray(dataSetOdd)) {
                for (var key in dataSetOdd) {
                    if (dataSetOdd[key]._opened) {
                        dataSet.forEach(setOpen);
                    }
                }
            }
            widget.dataSource.data = dataSet;
        }).catch(ScreenService.hideLoader);
    };

    this.calculateBeginTime = function(endHour, total){
        //subtraia uma quatidade de horas Ã  determinada data
        var auxHour = "00:00";
        var minutes = (((moment(total, "HH:mm").diff(moment(auxHour, "HH:mm"))))/60000);
        var beginHour = moment(endHour, "DD/MM/YYYY HH:mm").subtract(minutes, 'minutes');
        beginHour = beginHour.format("DD/MM/YYYY HH:mm");
        return beginHour;
    };

    this.calculateEndTime = function(beginHour, total){
        //adicione uma quantidade de horas Ã  uma determinada data
        var auxHour = "00:00";
        var minutes = (((moment(total, "HH:mm").diff(moment(auxHour, "HH:mm"))))/60000);
        var endHour = moment(beginHour, "DD/MM/YYYY HH:mm").add(minutes, 'minutes');
        endHour = endHour.format("DD/MM/YYYY HH:mm");
        return endHour;
    };

    this.getCurrentDate = function(){
        var today = new moment();
        return today.format('DD/MM/YYYY');
    };

    this.getLastFiveDayPeriod= function(){
        var today = moment();
        var period = {};
        period.end = today.format('DD/MM/YYYY');
        period.start =  today.subtract(6, 'days').format('DD/MM/YYYY');
        return period;
    };
    this.getLastThirdyDayPeriod= function(){
        var today = moment();
        var period = {};
        period.end = today.format('DD/MM/YYYY');
        period.start =  today.subtract(31, 'days').format('DD/MM/YYYY');
        return period;
    };
    this.getLastFiveDayPeriodButNotToday = function(){
        var today = moment();
        var period = {};
        period.end = today.subtract(1, 'days').format('DD/MM/YYYY');
        period.start =  today.subtract(5, 'days').format('DD/MM/YYYY');
        return period;
    };
    this.getLastCurrentWeekPeriodButNotToday = function(){
        var today = moment();
        var period = {};
        period.end = today.subtract(1, 'days').format('DD/MM/YYYY');
        period.start =  today.startOf('week').format('DD/MM/YYYY');
        return period;
    };
    this.getLastCurrentMonthPeriodButNotToday = function(){
        var today = moment();
        var period = {};
        period.end = today.subtract(1, 'days').format('DD/MM/YYYY');
        period.start =  today.startOf('month').format('DD/MM/YYYY');
        return period;
    };

    this.setVisibleByValueAllFields = function(widget){
        if(widget.currentRow){
            widget.fields.forEach(function(field){
                field.isVisible = (!!field.value());
                if(Array.isArray(field.value())){
                    field.isVisible = field.value().length > 0;
                }
            });
        }
    };

    this.fieldDurationToHour = function(fieldValue,hoursDay){
        var duration = 0;
        fieldValue = String(fieldValue);
        fieldValue = fieldValue.toUpperCase();
        var fieldValueArray = fieldValue.replace('D', 'D|').replace('H', 'H|').replace('M', 'M|').split("|");
        fieldValueArray.forEach(function(value){
            if( value.indexOf("D") != -1){
                duration +=  value.replace(/\D/g, '') * hoursDay;
            } else if( value.indexOf("H") != -1 ) {
                duration +=  parseInt(value.replace(/\D/g, ''));
            } else if( value.indexOf("M") != -1 ){
                duration +=  value.replace(/\D/g, '')/60;
            }
        });

        return duration;
    };
    this.durationToSeconds = function(fieldValue) {
        var duration = 0;
        fieldValue = String(fieldValue);
        fieldValue = fieldValue.toUpperCase();
        var fieldValueArray = fieldValue.replace('D', 'D|').replace('H', 'H|').replace('M', 'M|').replace('S', 'S|').split("|");
        fieldValueArray.forEach(function (value) {
            if (value.indexOf("D") != -1) {
                duration += value.replace(/\D/g, '') * 28800;
            } else if (value.indexOf("H") != -1) {
                duration += value.replace(/\D/g, '') * 3600;
            } else if (value.indexOf("M") != -1) {
                duration += value.replace(/\D/g, '') * 60;
            } else if (value.indexOf("S") != -1) {
                duration += parseInt(value.replace(/\D/g, ''));
            }
        });

        return duration;
    };

    this.secondsToDurationHour = function(seconds,notSeconds) {
        var time = '';
        var hours = seconds / 3600;
        if (hours >= 1) {
            time += Math.trunc(hours) + 'H';
        }
        var minutes = (hours - Math.trunc(hours)) * 60;
        seconds = (minutes - Math.trunc(minutes)) * 60;
        seconds = Math.round(seconds);
        if (seconds == 60) {
            minutes += 1;
            seconds = 0;
        }
        if (minutes >= 1) {
            time += Math.trunc(minutes) + 'm';
        }
        if (!notSeconds && seconds >= 1) {
            time += seconds + 's';
        }
        return time;
    };

    this.recursiveReload = function(widget){
        self.reloadWidgets(widget);
        self.reloadFields(widget);
        if(widget.dataSource){
            if(!widget.notRecursiveReload){
                return widget.reload();
            }
        }
    };

    this.reloadWidgets = function(widget){
        if(widget.widgets){
            widget.widgets.forEach(function(eachWidget){
                self.recursiveReload(eachWidget);
            });
        }
    };

    this.reloadFields = function(widget){
        var defer = ZHPromise.defer();
        if(widget.fields){
            widget.fields.forEach(function(eachField){
                self.recursiveReload(eachField);
            });
            defer.resolve();
        }
        return defer;
    };

    /*************************************************************
     * This method is useful when you're adding an item to a Widget
     * which contains checkboxes.
     * It gets the widget, reloads it and, since after reload all
     * those checked items are unchecked, the method checks all of
     * them again and marks the new one, too.
     *************************************************************/
    this.reloadCheckedListPlusOne = function(checkedList, one){
        var checkedIds = [''+one];
        checkedList.dataSource.getCheckedRows().forEach(function(checkedRow){
            checkedIds.push(checkedRow.ID);
        });
        checkedList.reload().then(function(){
            checkedList.dataSource.data.forEach(function(item, index, data){
                if(checkedIds.indexOf(item.ID) >= 0){
                    data[index].__isSelected = true;
                }
            });
            checkedList.updateCheckedRows();
        });
    };

    this.removeAllFieldsPmGeneration = function(widget){
        widget.fields = widget.fields.filter(function(field){
            return !field.pmIsGeneration;
        });
    };

    this.refreshWidgetActive = function(){
        templateManager.container.getActiveWidget().reload();
    };
    this.getActiveWidget = function(){
        return templateManager.container.getActiveWidget();
    };

    this.validateEditInLine = function(widget){
        if(event && !event.target.className) {
            return true;
        }
        return widget.mode !== 'edit' && (event && (event.target.className.indexOf('editable-content') === -1 && event.target.className.indexOf('inline-editable') === -1));
    };


    /************************************************************
     * Clears Widget fields, due the fact that if user inserts
     * something and reopen Widget, the data keep in there.
     * @param widget
     ************************************************************/
    this.clearWidgetCacheFields = function(widget){
        widget.fields.forEach(function(field){
            field.value('');
        });
    };


    this.arraySwap = function (array ,x,y) {
        var b = array[x];
        array[x] = array[y];
        array[y] = b;
        return array;
    };


    /************************************************************
     * Downloads an attachment - a file.
     * @param id
     ************************************************************/
    this.downloadAttachment = function(id) {
        var serviceUrl = window.serviceUrl;
        window.open(serviceUrl + "/downLoadAttachment?requestType=DataSet&dataset[0][ID]="+id);
    };
    var translation = function(field,columns){
        if(!field.dataSource.dataPM){
            field.dataSource.dataPM = angular.copy( field.dataSource.data);
        }
        if(!columns){
            columns = [field.descriptionField];
        }

        field.dataSource.data = angular.copy( field.dataSource.dataPM);
        field.dataSource.data.forEach(function(row){
            columns.forEach(function(column){
                row[column] = ScreenService.i18n(row[column]);
            });
            return row;
        });
    };

    this.translateDataSource = function(field,notReload,columns) {
        if (!notReload) {
            field.reload().then(function () {
                field.dataSource.dataPM = angular.copy( field.dataSource.data);
                translation(field, columns);
            });
        } else {
            translation(field, columns);
        }
    };


    /************************************************************
     * Generic method applied to 'Back' actions closing a Swipe.
     * @param target
     * @param reload
     ************************************************************/
    this.backToWidgetClosingSwipe = function(target, reload){
        ScreenService.closeSwipe().then(function(data){
            backToWidget(target, reload);
        });
    };


    /************************************************************
     * Generic method applied to 'Back' actions closing a Popup.
     * @param target
     * @param reload
     ************************************************************/
    this.backToWidgetClosingPopup = function(target, reload){
        ScreenService.closePopup().then(function(data){
            backToWidget(target, reload);
        });
    };


    /************************************************************
     * Generic method applied to 'Back' actions.
     * @param target
     * @param reload
     ************************************************************/
    var backToWidget = function(target, reload){
        reload = reload || false;
        if(typeof reload === "boolean"){
            if(reload){
                target.reload();
            }
        }
        target.activate();
    };

    /************************************************************
     * The user can create a project type which does not allow
     * finish those tasks that are in those projects who uses
     * this type.
     * So, Project Management needs to hide/show the percent
     * fields along the system when a task is in a project which
     * has this type.
     ************************************************************/
    this.CONST_ALLOWENDTASK_NEGATIVE = 'N';

    this.hidePercentFieldWhenTaskEndNotAllowed = function(allowEndTasks, field){
        if(allowEndTasks == self.CONST_ALLOWENDTASK_NEGATIVE) {
            field.value(0);
            field.showOnForm = false;
            field.showOnView = false;
        } else {
            field.showOnForm = true;
            field.showOnView = true;
        }
    };

    /************************************************************
     * Builds a custom error message (applied only to Project
     * Management) for error treatments in methods.
     *
     * contextRegistered: the context which is calling this object (e.g. AppropriationService)
     * methodName: the method which is calling this object (e.g. hideColumnsByTimePlanning())
     * expectedType: the expected type (e.g. string, object, boolean, etc)
     * argPosition: the position of argument (e.g. 1st argument, 2nd argument, etc)
     *
     * Example of phrase generated:
     * (AppropriationService): hideColumnsByTimePlanning() expected 2nd argument as string, got undefined
     ************************************************************/
    this.buildErrorMessage = {
        invalidArgument: function(contextRegistered, methodName, expectedType, value, argPosition){
            return console.error('(' + contextRegistered + '): ' + methodName + '() expected ' + argPosition + ' argument as ' + expectedType + ', got ' + typeof(value));
        }
    };

    this.getCurrentRowInFieldSelect = function(field){
        var value = self.getValueInSelectField(field);
        var row = null;
        if(value){
            row = self.findInDataSource(field,[value],field.valueField)[0];
        }
         return row;
    };

    /************************************************************
     * Find specific elements in a specified dataSource
     ************************************************************/
    this.findInDataSource = function(field,values,index){
        return field.dataSource.data.filter(function(row){
            var found = false;
            values.forEach(function(value){
                if(row[index] == value){
                    found = true;
                }
            });
            return found;
        });
    };
    
    this.filterRowsInDataSourceUnwanted = function(dataSource, values, index){
        return dataSource.data.filter(function(row){
            return values.indexOf(row[index]) == -1;
        });
    };

    this.isNotEmptyArray = function(array) {
        return array.length > 0;
    };

    this.createPathsForMessage = function(paths, pathsString){
        paths.forEach(function (path) {
            pathsString += "<u>" + path + "</u><br/>";
        });
        return pathsString;
    };

    this.createArrayByDataSetAndIndex = function(dataSet,index){
        var array = [];
        dataSet.forEach(function(row){
            array.push(row[index]);
        });
        return array;
    };

    this.transliterateString = function(text) {
        var transliterationTable = {
            "á" : "a",  "Á" : "A",  "à" : "a",  "À" : "A",  "a" : "a",
            "A" : "A",  "â" : "a",  "Â" : "A",  "å" : "a",  "Å" : "A",
            "ã" : "a",  "Ã" : "A",  "ä" : "ae", "Ä" : "AE", "æ" : "ae",
            "Æ" : "AE", "c" : "c",  "C" : "C",  "ç" : "c",  "Ç" : "C",
            "d" : "d",  "D" : "D",  "Ð" : "Dh", "ð" : "dh", "é" : "e",
            "É" : "E",  "è" : "e",  "È" : "E",  "e" : "e",  "E" : "E",
            "ê" : "e",  "Ê" : "E",  "ë" : "e",  "Ë" : "E",  "ƒ" : "F",
            "g" : "g",  "G" : "G",  "h" : "h",  "H" : "H",  "í" : "i",
            "Í" : "I",  "ì" : "i",  "Ì" : "I",  "î" : "i",  "Î" : "I",
            "ï" : "i",  "Ï" : "I",  "i" : "i",  "I" : "I",  "j" : "j",
            "J" : "J",  "k" : "k",  "K" : "K",  "l" : "l",  "L" : "L",
            "n" : "n",  "N" : "N",  "ñ" : "n",  "Ñ" : "N",  "ó" : "o",
            "Ó" : "O",  "ò" : "o",  "Ò" : "O",  "ô" : "o",  "Ô" : "O",
            "o" : "o",  "O" : "O",  "õ" : "o",  "Õ" : "O",  "ø" : "oe",
            "Ø" : "OE", "ö" : "oe", "Ö" : "OE", "r" : "r",  "R" : "R",
            "s" : "s",  "S" : "S",  "š" : "s",  "Š" : "S",  "ß" : "SS",
            "t" : "t",  "T" : "T",  "ú" : "u",  "Ú" : "U",  "ù" : "u",
            "Ù" : "U",  "u" : "u",  "U" : "U",  "û" : "u",  "Û" : "U",
            "ü" : "ue", "Ü" : "UE", "w" : "w",  "W" : "W",  "ý" : "y",
            "Ý" : "Y",  "y" : "y",  "Y" : "Y",  "ÿ" : "y",  "Ÿ" : "Y",
            "z" : "z",  "Z" : "Z",  "ž" : "z",  "Ž" : "Z",  "þ" : "th",
            "Þ" : "Th", "µ" : "u"
        };
        var newText = "";
        if(text){
            for(var i = 0; i < text.length; i++){
                newText += transliterationTable[text[i]] || text[i];
            }
        }
        return newText;
    };
    this.clearValueSelect = function(field){
        field.widget.currentRow[field.name] = "";
        for (var prop in field.outData) {
            field.widget.currentRow[field.outData[prop]] = "";
        }
    };

    this.setOutData = function (field, value) {
        var vField = field.valueField;
        if (value) {
            var matchRows = field.dataSource.data.filter(function (item) {
                return item[vField] == value;
            });
            if (matchRows.length > 0) {
                Object.keys(field.outData).forEach(function (key) {
                    field.widget.currentRow[field.outData[key]] = matchRows[0][key];
                });
            } else {
                field.widget.currentRow[field.outData[field.valueField]] = '';
            }
        }
    };
    
    this.setAllFieldsSelectByValueInCurrentRow = function(widget){
       widget.fields.forEach(function(field){
           if(field.template == "field/select.html"){
               var value = widget.currentRow[field.outData[field.valueField]];
               if(value && field){
                   self.setOutData(field,value);
               }else if(field){
                   self.clearValueSelect(field);
               }
           }
       });
    };

    this.fixBugMasterDetail= function(widget){
        widget.currentWidget = null;
        widget.activate();
    };

    this.goBackViewMasterDetail= function(widget) {
        widget.list();
        ScreenService.closeSwipe();
        return widget.reload();
    };

    this.getUserData = function() {
        return requestDataSourceEngine.getDataSource('/findUserData').then(function(response){
            return response.dataset.findUserData[0];
        });
    };

    this.deteleViewMasterDetail= function(widget) {
        return widget.dataSource.remove([widget.currentRow]).then(function(){
            ScreenService.closeSwipe();
            return widget.reload();
        });
    };



    this.deleteRowViewMasterDetail = function(widget) {
        return widget.remove(widget.currentRow).then(function(){
            ScreenService.closeSwipe();
            return widget.reload();
        });
    };

    this.cancelEditMasterDetail= function(widget) {
        var primaryProperty = widget.primaryProperty ? widget.primaryProperty : 'ID';
        var primaryValue = widget.currentRow[primaryProperty];
        if(primaryValue){
            widget.list();
            ScreenService.showLoader();
            return widget.reload().then(function () {
                ScreenService.hideLoader();
                widget.view();
                return widget.dataSource.data.some(function (row) {
                    if (row[primaryProperty] == primaryValue) {
                        widget.setCurrentRow(row);
                        return true;
                    }
                });
            }).catch(ScreenService.hideLoader);
        }else{
            this.goBackViewMasterDetail(widget);
        }
    };

    this.getValueInSelectField = function(field){
        return field.widget.currentRow[field.outData[field.valueField]];
    };

    this.setValueInSelectField = function(field,value){
        field.widget.currentRow[field.outData[field.valueField]] = value;
        if(field.hasPagination !== false){
            this.bugPaginationOnSelectOnModeView(field,value).then(function(){
                self.setOutData(field, value);
            });
        }else {
            this.setOutData(field, value);
        }
    };
    /************************************************************
     * This method is normally used in filter popups and sets
     * default values to specified select-multiple.
     ************************************************************/
    this.setDefaultValuesToSelectMultipleField = function(field,value,index){
        var data = this.findInDataSource(field,value,index);
        field.value(this.createArrayByDataSetAndIndex(data,field.valueField));
    };
    
    this.getDefaultValuesToSelectMultipleField = function(field,value,index){
        var data = this.findInDataSource(field,value,index);
        return this.createArrayByDataSetAndIndex(data,field.valueField);
    };
    
    this.setDefaultValueToSelectMultipleFieldFilteringData = function(field, values, indexToFilter, indexToValues){
        return field.reload().then(function(){
            var rows = self.filterRowsInDataSourceUnwanted(field.dataSource, values, indexToFilter);
            field.value(self.createArrayByDataSetAndIndex(rows, indexToValues));
        });
    };
    
    this.getDefaultValueToSelectMultipleFilter = function(field, values, indexToFilter, indexToValues){
        var rows = self.filterRowsInDataSourceUnwanted(field.dataSource, values, indexToFilter);
        return self.createArrayByDataSetAndIndex(rows, indexToValues);
    };

    /************************************************************
     * Mark off checked rows of a widget.
     ************************************************************/
    this.markOffWidgetCheckedRows = function(widget){
        widget.dataSource.checkedRows = [];
        widget.dataSource.clearCheckedRows();
    };

    /************************************************************
     * Applies to string objects a method which capitalizes first
     * letter of strings.
     ************************************************************/
    String.prototype.capitalize = function(){
        return this.charAt(0).toUpperCase() + this.slice(1).toLowerCase();
    };

    /***************************************************************************************
     * Applies to string objects a method which capitalizes first
     * letter of all words (separated by space) in a string.
     ***************************************************************************************/
    String.prototype.capitalizeEachWord = function(){
        return this.replace(/\w\S*/g, function(value){
            return value.charAt(0).toUpperCase() + value.substr(1).toLowerCase();
        });
    };

    /*************************************************************
     * Gets the current time and the current weekday abreviated
     * (MON dd/mm/yyyy).
     *************************************************************/
    this.getCurrentDateWithShortWeekday = function(formatDivider){
        formatDivider = formatDivider || '/';
        var date    = new Date();
        var day     = date.getDate();
        var month   = date.getMonth()+1;
        var year    = date.getFullYear();
        var weekDay = date.getDay();

        day = day < 10 ? '0'+day : day;
        month = month < 10 ? '0'+month : month;

        return SHORT_WEEKDAY_BR[weekDay] + ' ' + day+formatDivider+month+formatDivider+year;
    };

    this.uniqueArray = function(array){
        return array.reduce(function(prev, cur) {
            return (prev.indexOf(cur) < 0) ? prev.concat([cur]) : prev;
        }, []);
    };

    /***********************************************************************
     * Hides fields that have not content.
     ***********************************************************************/
    this.hideFieldsWhenNoContent = function(widget){
        widget.fields.forEach(function(field){
            if(widget.currentRow){
                field.isVisible = (!!field.value());
                if(Array.isArray(field.value())){
                    field.isVisible = field.value().length > 0;
                }
            }
        });
    };

    this.hideFieldsOnViewWhenNoContent = function(widget){
        widget.fields.filter(function(field){
            return field.pmShowOnViewIfValue;
        }).forEach(function(field){
            if(widget.currentRow){
                field.showOnView = (!!field.value());
                if(Array.isArray(field.value())){
                    field.showOnView = field.value().length > 0;
                }
            }
        });
    };

    /**
     * Returns the current row with the changed property.
     * @param widget
     * @returns {*}
     */
    this.getWidgetCurrentRowAsChanged = function(widget){
        var row = widget.currentRow;
        row.changed = true;
        return row;
    };

    /**
     * Clear given current row properties.
     * @param currentRow
     * @param properties
     */
    this.clearCurrentRowProperties = function(currentRow, properties){
        if(!currentRow){
            throw new Error("currentRow can not be null.");
        }
        properties.forEach(function(property){
            if(currentRow.hasOwnProperty(property)){
                currentRow.property = null;
            }
        });
    };

    /**
     * Clears widget fields values.
     * @param widget
     * @param fieldNames
     */
    this.clearAndReloadWidgetFieldsValues = function(widget, fieldNames){
        if(!widget){
            throw new Error("widget can not be null.");
        }
        fieldNames.forEach(function(fieldName){
            var field = widget.getField(fieldName);
            if(field){
                field.reload();
                field.value('');
            }
        });
    };

    this.arrayFromPropertyOfObjectList = function(listObjects, property){
        var filtered = [];
        listObjects.forEach(function(obj){
            if(obj.hasOwnProperty(property)){
                filtered.push(obj[property]);
            }
        });
        return filtered;
    };
    this.windowResizeKanban = function(time){
        setTimeout(function(){
            window.dispatchEvent(new Event('resize'));
        }, time);
    };

    this.genericBackEvent = function(widget, isPopup) {
        if (isPopup) {
            ScreenService.closePopup().then(function () {
                return widget.reload();
            }).then(function () {
                widget.activate();
            });
        } else {
            ScreenService.closeSwipe().then(function () {
                return widget.reload();
            }).then(function () {
                widget.activate();
            });
        }
    };

    this.isArrayValuesUniqueSameValues = function(array1,array2) {
        var validate = true;
        if (array1.length != array2.length) {
            validate = false;
        } else {
            array1.some(function (elementArray) {
                if (~array2.indexOf(elementArray)) {
                    validate = false;
                    return true;
                }
            });
        }
        return validate;
    };

    this.getDiffInArrays =function(array1,array2) {
        var diff1 = array1.filter(function (elementArray) {
            return !~array2.indexOf(elementArray);
        });
        var diff2 = array2.filter(function (elementArray) {
            return !~array1.indexOf(elementArray);
        });

        return [diff1,diff2];
    };

    this.removeArrayInOtherArray = function(arraySubtraction,array){
        return array.filter(function(item){
            return arraySubtraction.indexOf(item) == -1;
        });
    };

    this.getRowInDataSource = function (dataSource, primaryProprety, primaryValue) {
        var currentRow = null;
        dataSource.data.some(function (row) {
            if (row[primaryProprety] == primaryValue) {
                currentRow = row;
                return true;
            }
        });
        return currentRow;
    };

    this.getDescriptionFieldByPrimaryValue = function (field,  primaryValue) {
        return self.getRowInDataSource(field.dataSource, field.valueField, primaryValue)[field.descriptionField];
    };

    this.genericEventAfterSaveMasterDetail = function(response,widget, primaryProprety){
        primaryProprety = primaryProprety ? primaryProprety :"ID";
        widget.currentRow[primaryProprety] = response.dataset[widget.dataSource.name.split('/')[1]][0][primaryProprety];
        widget.currentRow.__is_new = false;
        self.genericCancelEvent(widget, primaryProprety);
    };

    this.genericCancelEvent = function(widget, primaryProprety) {
        var promise = null;
        primaryProprety = primaryProprety ? primaryProprety :"ID";
        var primaryValue = widget.currentRow[primaryProprety];
        if (widget.currentRow.__is_new) {
            ScreenService.closeSwipe();
            promise = widget.reload();
        } else {
            ScreenService.showLoader();
            promise = widget.reload().then(function() {
                ScreenService.hideLoader();
                widget.view();
                return widget.dataSource.data.some(function (row) {
                    if (row[primaryProprety] == primaryValue) {
                        widget.setCurrentRow(row);
                        return true;
                    }
                });
            }).catch(ScreenService.hideLoader);
        }
        templateManager.updateTemplate();
        return promise;
    };

    this.fixMasterDetailSaveBug = function(widget, primaryKey){
        if(!primaryKey){
            primaryKey = 'ID';
        }
        widget.dataSource.data.forEach(function(row){
            if(row[primaryKey] != widget.currentRow[primaryKey]){
                row.changed = false;
            }
        });
    };

    this.genericCancelEventIsNotMasterDetail = function(widget,widgetList) {
        if (widget.currentRow.__is_new) {
            ScreenService.closeSwipe().then(function(){
                widgetList.activate();
            });
        } else {
            widget.reload().then(function(){
                widget.view();
                widget.template = widget.templateToView;
            });
        }
        templateManager.updateTemplate();
    };

    this.genericBackEventIsNotMasterDetail = function(widget, isPopup) {
        if (isPopup) {
            return ScreenService.closePopup().then(function () {
                widget.activate();
            });
        } else {
            return ScreenService.closeSwipe().then(function () {
                widget.activate();
            });
        }
    };

    this.genericDeleteEvent = function (widget){
        return widget.dataSource.remove([widget.currentRow]).then(function(data){
            return ScreenService.closeSwipe().then(function(){
                return widget.reload();
            });
        });
    };

    this.fixBugOpenSwipeTabbed = function(tabbedWidget){
        if(!tabbedWidget.currentWidget){
            tabbedWidget.currentWidget = tabbedWidget.widgets[0];
        }
        tabbedWidget.template = tabbedWidget.formTemplate;
    };

    this.mergeDataSetPagnation = function (field, filterMerge, valueFieldIndex, notFilter) {
        if(filterMerge){
            var filter = [];
            if(field.dataSourceFilter && !notFilter){
                filter = filter.concat(field.dataSourceFilter,filterMerge);
            }else{
                filter = filterMerge;
            }
            return requestDataSourceEngine.getDataSource(field.dataSource.name, filter).then(function (response) {
                var fieldValues = response.dataset[field.dataSource.name.split('/')[1]];
                fieldValues.forEach(function (fieldvalue) {
                    var validate = field.dataSource.data.filter(function (data) {
                        return data[valueFieldIndex] == fieldvalue[valueFieldIndex];
                    });
                    if (!validate.length) {
                        field.dataSource.data.push(fieldvalue);
                    }
                });
                templateManager.updateTemplate();
            });
        }
    };
    
    this.setDataSourceAfterSave = function(widget, filter, valueIndex){
        var widgetDataSource = widget.dataSource.data;
        return requestDataSourceEngine.getDataSource(widget.dataSource.name, filter).then(function (response) {
            var sponsorDataUpdated = response.dataset[widget.dataSource.name.split('/')[1]];
            var isRow = widgetDataSource.some(function(data, index){
                if(data[valueIndex] == sponsorDataUpdated[0][valueIndex]){
                    widgetDataSource[index] = sponsorDataUpdated[0];
                    return true;
                }
            });
            if(!isRow) {
                widgetDataSource.push(sponsorDataUpdated[0]);
            }
        });    
    };
    
    this.getDataInRequestDataSourceByValue = function (field,value) {
        if(value){
            var valueFieldIndex = field.valueField;
            var filterMerge = [
                {
                    "operator": "IN",
                    "name": valueFieldIndex,
                    "value": value
                }
            ];
            var filter = [];
            if (field.dataSourceFilter) {
                filter = filter.concat(field.dataSourceFilter, filterMerge);
            } else {
                filter = filterMerge;
            }
            return requestDataSourceEngine.getDataSource(field.dataSource.name, filter).then(function (response) {
                return response.dataset[field.dataSource.name.slice(1)];
            });
        }
    };

    this.bugPaginationOnSelectMultiplyOnModeView = function(field){
        var valueFieldIndex = field.valueField;
        var filter = [
            {
                "operator": "IN",
                "name": valueFieldIndex,
                "value": field.value() && field.value().length > 0 ? field.value() : [0]
            }
        ];
        return this.mergeDataSetPagnation(field, filter, valueFieldIndex);
    };

    this.bugPaginationOnSelectOnModeView = function(field,value){
        var valueFieldIndex = field.valueField;
        if(!value){
            value = field.widget.currentRow[field.outData[field.valueField]];
        }
        var filter = [
            {
                "operator": "=",
                "name": valueFieldIndex,
                "value": value || 0
            }
        ];
        return this.mergeDataSetPagnation(field, filter, valueFieldIndex);
    };

    this.isEmpty = function (value) {
        return !value || value.length === 0;
    };

    this.clearCheckedRowsAndReload = function(widget){
        widget.activate();
        widget.reload();
        widget.dataSource.clearCheckedRows();
        widget.dataSource.updateCheckedRows();
    };

    this.bugPaginationOnSelectMultiplyOnModeList = function(field){
        var data = field.widget.dataSource.data;
        var ids = data.reduce(function(actual, row){
            return actual.concat(row[field.name]);
        }, []);
        var valueFieldIndex = field.valueField;
        var filter = [
            {
                "operator": "IN",
                "name": valueFieldIndex,
                "value": this.uniqueArray(ids)
            }
        ];
        requestDataSourceEngine.getDataSource(field.dataSource.name, filter).then(function(response){
            var fieldValues = response.dataset[field.dataSource.name.slice( 1 )];
            fieldValues.forEach(function(fieldvalue){
                var validate = field.dataSource.data.filter(function(data){
                    return data[valueFieldIndex] == fieldvalue[valueFieldIndex];
                });
                if(!validate.length){
                    field.dataSource.data.push(fieldvalue);
                }
            });
            templateManager.updateTemplate();
        });
    };

    this.showMessageErrorOfBackEnd = function(response,errorMessages,errorMessageDefault,showMessageBackEndTrue) {
        ScreenService.hideLoader();
        ScreenService.hideLoader();
        var message = errorMessageDefault ? errorMessageDefault : this.messages.UNEXPECTED_ERROR;
        if(showMessageBackEndTrue){
            if (response && response.data && response.data.error) {
                message = response.data.error.split("Exception:").pop();
            }
        } else {
            if (response && response.data && response.data.error) {
                var errorCode = response.data.error.split("Code:").pop();
                if (errorMessages && errorCode && errorMessages[errorCode]) {
                    message = errorMessages[errorCode] ? errorMessages[errorCode] : message;
                }
            }
        }
        return ScreenService.showMessage(message,'ERROR');
    };

    this.showMessageBackEndTrue = function(response) {
        return self.showMessageErrorOfBackEnd(response,null,null,true);
    };

    this.showMessageBackEndTruewithThrow = function(response) {
        return self.showMessageErrorOfBackEnd(response,null,null,true).then(function(){
            throw 'Erro backEnd';
        });
    };
    
    this.fixWidgetToViewAfterSaveRow = function(widget){
        widget.view();
        widget.template = widget.templateToView;
        widget.activate();
        widget.currentRow.__is_new = false;
        widget.currentRow.changed = false;
        widget.setCurrentRow(widget.currentRow);
    };

    this.startFilter = function(widget, currentRow, isApplyOriginalFilter) {
        ZhPreferences.getDefaultWidgetPreferences(widget.id).then(function(result) {
            if (result && result.DEFAULT_FILTER) {
                ZhPreferences.getPreferences('filter', Query.build().where('WIDGET_ID').equals(widget.id)).then(function(filters) {
                    var defaultFilter = filters.filter(function(filter) {
                        return filter.ID == result.DEFAULT_FILTER;
                    })[0];
                    var filter = {
                        ID: defaultFilter.LABEL_TO_PREFERENCE || 'EDITED',
                        FILTER_ROW: JSON.parse(defaultFilter.FILTER_ROW)
                    };
                    ZhFilterPreferences.applyFilter(widget, filter).then(function() {
                        widget.appliedFilter = widget.appliedFilter || filter;
                        widget.appliedFilter.ID = result.DEFAULT_FILTER;
                        if(defaultFilter.LABEL_TO_PREFERENCE) {
                            widget._filterInfo[0].value = defaultFilter.LABEL_TO_PREFERENCE;
                        }
                    });
                });
            } else if(isApplyOriginalFilter) {
                ZhFilterPreferences.applyOriginalFilter(widget);
            } else {
                ZhFilterPreferences.openFilterWidget(widget, currentRow);
            }
        });
    };

    this.applyFilter = function (widget, filter){
        ZhFilterPreferences.applyFilter(widget, filter).then(function () {
            widget.appliedFilter = widget.appliedFilter || filter;
            widget._filterInfo[0].value = filter.ID;
        }); 
    };

    this.buildDefaultFilterByFilterProperties = function(widget){
        var defaultFilter = {};
        widget.fields.forEach(function(field){
            if(field.filterProperties && field.filterProperties.defaultValue){
                if(field.filterProperties.name){
                    defaultFilter[field.filterProperties.name] = field.filterProperties.defaultValue;
                } else {
                    defaultFilter[field.name] = field.filterProperties.defaultValue;
                }
            }
        });
        return defaultFilter;
    };
    
    this.isAppliedFilter = function(widget){
        return !!widget.pmAppliedFilter;
    };
    
    this.setFilterInit = function (widget) {
        widget.pmAppliedFilter = true;
    };
    
    this.applyDefaultFilterOnEnter = function (widget, isApplyOriginalFilter) {
        if (widget.inListMode()) {
            if (widget.pmAppliedFilter) {
                widget.reload();
            } else if (widget.currentRowDefaultFilter) {
                self.startFilter(widget, widget.currentRowDefaultFilter, isApplyOriginalFilter);
            } else { 
                self.startFilter(widget, widget.currentRow, isApplyOriginalFilter);
            } 
        }
    };

    this.appropriationValidationOfPreviousDay = function(init) {
        return requestDataSourceEngine.getDataSource('/appropriationValidationOfPreviousDay').then(function (response) {
            var appropriationOfPreviousDay = response.dataset.appropriationValidationOfPreviousDay[0];
            if (!appropriationOfPreviousDay.PREVIOUS_DAY_APPROPRIATION_OK) {
                var message = init? Messages.OPERATION_BLOCKED_INIT : Messages.OPERATION_BLOCKED;
                appropriationOfPreviousDay.DATES.forEach(function(data){
                    message +="<br/>" + data;
                });
                if(init){
                    message += Messages.OPERATION_BLOCKED_END;
                }
                ScreenService.confirmMessage(message,'ERROR',function(){ScreenService.openWindow('product#timeControl');});
                throw 'Operação bloqueada!';
            }
        });
    };

    this.closeSideMenu = function(){
        if(ScreenService.isSideMenuOpen()){
            ScreenService.toggleSideMenu();
        }
    };

    this.doSyncPm = function(functions) {
        return functions.reduce(function(lastPromise, nextFunction) {
            return lastPromise.then(function() {
                return nextFunction();
            });
        }, ZHPromise.when());
    };

    this.doSyncPmNotStop = function(functions) {
        var error = [];
        var promise = functions.reduce(function (lastPromise, nextFunction) {
            return lastPromise.then(function () {
                return nextFunction();
            }).catch(function (e) {
                error.push(e);
                return error;
            });
        }, ZHPromise.when());

        var defer = ZHPromise.defer();
        var resolve = function (success) { defer.resolve(success); };
        var reject = function (error) { defer.reject(error); };
        var setPromise = function() {
            if (error.length > 0) {
                reject(error);
            } else {
                resolve();
            }
        };

        promise.then(setPromise).catch(setPromise);
        return defer.promise;
    };
    this.validateExecuteInWindows = function(){
        return GitQueue.loginBrowser(PmLocalVars.getLocalVarLogin()).then(function () {
            return GitQueue.validateExecuteInWindows();
        }).catch(function(){
            ScreenService.hideLoader();
            ScreenService.hideLoader();
            ScreenService.restoreDefaultLoadingMessage();
            throw Messages.ERR_WEBSOCKET;
        });
    };

    this.getDirectorySeparator = function(path) {
        var ds = '/';
        if(path.indexOf('\\') != -1) {
            ds = '\\';
        }
        return ds;
    };

    this.getCurrentDateInMilliseconds = function(){
        return new Date().getTime();
    };

    this.getCurrentFormattedDateForAttachment = function(){
        return moment().format('YYYY-MM-DDTHH:MM:SSZ');
    };

    this.inArray = function(elem,array) {
        return -1 != (Util.isArray(array) ?  array.indexOf(elem) : -1);
    };

    this.inString = function(string,searchString) {
        return -1 != (Util.isString(string) ?  string.indexOf(searchString) : -1);
    };

    this.setValueInSelectMultiple = function(field,values) {
        field.value(field.dataSource.data.filter(function (row) {
            return self.inArray(row[field.valueField], values);
        }).map(function (row) {
            return row[field.valueField];
        }));
    };

    this.getOwnerFixBug = function(args){
        return args.owner.owner;
    };

    this.appropriationValidation = function() {
        return requestDataSourceEngine.setDataSource('/appropriationValidation',[{'changed' :true}]);
    };

    this.isStatusDefault = function(status){
        return status.CONTROL === 'B';
    };

    this.isStatusInitial = function(status){
        return status.CONTROL === 'N';
    };
    
    this.fixBugReloadWidgetInViewMode = function(widget){
        widget.list();
        ScreenService.showLoader();
        return widget.reload().then(function(){
            widget.moveToFirst();
            ScreenService.hideLoader();
            widget.view();
        }).catch(ScreenService.hideLoader);
    };
    
    this.loadFramingIds = function(widget, framingIds){
         widget.dataSourceFilter.forEach(function(element){
                if(element.name == 'FRAMING'){
                    framingIds = element.value;
                }
            });
            widget.PMFramingValues = framingIds;
    };

    this.allValuesSameInArray = function(array) {
        for (var i = 1; i < array.length; i++) {
            if (array[i] !== array[0]){
                return false;
            }
        }
        return true;
    };
    
    this.reloadTaskTypes = function(widget){
        var filter = [];
        var framingIds = [];
        var framingField;
        var isThisColumn = function(column){
		    return column.id === this.column && column.label == this.label;
        };
        if (widget.appliedFilter && widget.appliedFilter.FILTER_ROW && widget.appliedFilter.FILTER_ROW.FRAMING){
            self.loadFramingIds(widget,framingIds);
        }else if(widget.appliedFilter && widget.appliedFilter.FILTER_ROW && widget.appliedFilter.FILTER_ROW.filters){
            self.loadFramingIds(widget,framingIds); 
        }else if(widget.PMFramingValues) {
            self.loadFramingIds(widget,framingIds);
        }else{
            widget.fields.forEach(function(element){
                if(element.name == 'FRAMING' || element.name == 'TYPE_TASK_NAME'){
                    framingField = element;
                }
            });
            self.loadFramingIds(widget,framingIds);
        }
        filter.push({
                "name": "ID",
                "operator": "IN",
                "value": widget.PMFramingValues
        });
        widget.columns = widget.columns || [];
        
		return requestDataSourceEngine.getDataSource('/getTaskTypes', filter).then(function(data){
            var actualColumns = {};
            widget.PMTaskType = data.dataset.taskTypes;
			data.dataset.taskTypes.forEach(function(taskType){
				var filter = {
					'column': parseInt(taskType.column),
                    'label': taskType.columnLabel
				};
				var alreadyColumned = widget.columns.filter(isThisColumn, filter);
				if(!alreadyColumned.length){
					widget.columns.push({
						'id': parseInt(taskType.column),
						'label': taskType.columnLabel
					});
				}
                actualColumns[taskType.column] = taskType.columnLabel;
			});

            // Update columns on label or on remove of it
            widget.columns = widget.columns.filter(function(column){
                return actualColumns.hasOwnProperty(column.id) && column.label == actualColumns[column.id];
            });

            templateManager.updateTemplate();
            //TODO não remover por causa do kanban
            self.windowResizeKanban(300);
		});
	};
	
	var taskTypeControlTag = {'E': 'ERR', 'C': 'CON', 'T': 'TST', 'M': 'MGR', 'G': 'EMR', 'R': 'REP', 'D': 'CDO', 'A': 'RLC'};
	
	this.includeTaskTypeInTaskName = function (taskName, typeRelationship, version, productVersionId, originProductVersionId) {
        var typeRelationshipTag = taskTypeControlTag[typeRelationship];

        if (typeRelationship == 'R') {
            if (version) {
                typeRelationshipTag += '-' + version;
            } else if (productVersionId) {
                typeRelationshipTag += '-STABLE';
            } else if (originProductVersionId) {
                typeRelationshipTag += '-MASTER';
            }
        }

	    if (taskName.indexOf(' -- [') != -1){
         	var tagIndex;
         	var tagChanged;
         	var splittedTaskName = taskName.split(' -- [');
         	var tempName = splittedTaskName[0];
         	var taskTypesName = splittedTaskName[1];
         	taskTypesName = taskTypesName.substring(0, taskTypesName.length - 1);
            var splittedTaskTypesName = taskTypesName.split('][');
            var splittedTaskTypesNameString = splittedTaskTypesName.join(',');

            if (splittedTaskTypesNameString.indexOf(typeRelationshipTag) != -1) {
         	 	splittedTaskTypesName.some(function(element, index){
                    if (element.includes(typeRelationshipTag) &&
                        !(element.includes('-') && element.includes('.'))) {
                        tagIndex = index;
                    }
             	});

                if(tagIndex) {
                    var tagToBeChanged = splittedTaskTypesName[tagIndex];
                    splittedTaskTypesName.splice(tagIndex, 1);

                    if (tagToBeChanged.length == 3) {
                        tagChanged = tagToBeChanged + '2';
                    } else if (tagToBeChanged.length > 3) {
                        var tagQtd = parseInt(tagToBeChanged.slice(3)) + 1;
                        tagChanged = typeRelationshipTag + tagQtd;
                    }

                    splittedTaskTypesName.unshift(tagChanged);
                    taskName = tempName + ' -- [' + splittedTaskTypesName.join('][') + ']';
                } else {
                    taskName = tempName + ' -- [' + typeRelationshipTag + ']' +  '[' + taskTypesName + ']';
                }
	        } else {
	            taskName = tempName + ' -- [' + typeRelationshipTag + ']' +  '[' + taskTypesName + ']';
	        }
     	} else {
         	taskName = taskName + ' -- [' + typeRelationshipTag + ']';
     	}

	    return taskName;
	};
    
    this.setStatusEnabledWidgets = function (widgets, status) {
        widgets.forEach(function (widget) {
            if (!widget.ignoreChangeEnabled){
                widget.enabled = status;
            }
        });
    };

    this.allWidgetChildrenIsEnabled = function (widget) {
        var status = false;
        widget.widgets.forEach(function (widgetChildren) {
            if (widgetChildren.enabled) {
                status = true;
                return status;
            }
        });
    };

    this.initializeFieldSelectAutocomplete = function (widgetName, field) {
        var widget = templateManager.container.getWidget(widgetName);
        widget.getField(field).initializeField();
    };

    this.allValuesSameInArray = function(array) {
        for (var i = 1; i < array.length; i++) {
            if (array[i] !== array[0]){
                return false;
            }
        }
        return true;
    };

    this.removeDuplicateValuesInArray = function (array) {
        return array.filter(function (elem, i, array) {
            return array.indexOf(elem) === i;
        });
    };

    this.fixBugTabbedNavigation = function (timeout) {
        timeout = timeout || 300; 
        var scrollContainer = $('.zh-tab-scroller');
        setTimeout(function () {
            if (scrollContainer[0].scrollLeft > 0) {
                $("span.icon-scroll-left").show();
            } else {
                $("span.icon-scroll-left").hide();
            }

            if (scrollContainer[0].scrollWidth - scrollContainer[0].scrollLeft > scrollContainer[0].clientWidth) {
                $("span.icon-scroll-right").show();
            } else {
                $("span.icon-scroll-right").hide();
            }
        }, 300, false);
    };

    this.getUrlPmNext = function(route) {
        var token     = localStorage.getItem('LOGIN_TOKEN');
        var hash      = localStorage.getItem('LOGIN_HASH') || '0';
        var user      = localStorage.getItem('LOGIN_USER');
        var languange = localStorage.getItem('LOGIN_LANGUAGE');
        var productId = window.projectId;

        // Clear PM session timeout to use only PM Next session timeout.
        clearTimeout(LibUtilities.expiredSessionMethod);
        
        return ProjectManagementConfig.pmNextUrl + "/" + route + "?header=0&menu=0" + 
            "&token=" + token + 
            "&hash=" + hash + 
            "&user=" + user + 
            "&languange=" + languange +
            "&productId=" + productId +
            "&isZhAngular=1";
    };
}

Configuration(function(ContextRegister) {
	ContextRegister.register('Utilities', Utilities);
});



// FILE: assets/js/util/Validation.js
/**
 * Created by jhoterdanchaves on 09/07/14.
 */
function Validation() {
    this.isValidMail = function(email) {
        var regex = new RegExp(/^[a-zA-Z0-9.!#$%&'*+\/=?^_`{|}~-]+@[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)*$/);
        return regex.exec(email);
    };

    this.isValidName = function(name) {
        var regex = new RegExp(/^[a-zA-ZàáâäãåąčćęèéêëėįìíîïłńòóôöõøùúûüųūÿýżźñçčšžÀÁÂÄÃÅĄĆČĖĘÈÉÊËÌÍÎÏĮŁŃÒÓÔÖÕØÙÚÛÜŲŪŸÝŻŹÑßÇŒÆČŠŽ∂ð ,.'-]+$/);
        return regex.exec(name);
    };

    this.isEmpty = function (value) {
        return !value || value.length === 0;
    };

    this.isEmptyString = function(string) {
        return this.isEmpty(string) || !string.trim();
    };

    this.equals = function (item,value){

    	if(item == value){
    		return true;	
    	}
    	return false;    	
    };


}

Configuration(function(ContextRegister) {
    ContextRegister.register('Validation', Validation);
});


// FILE: assets/js/Repository/Calendar.js
/**
 * Created by tuliomagalhaes on 18/07/14.
 */

Configuration(function(RepositoryFactory, ContextRegister, Query) {
    var CalendarExceptionListRepository = RepositoryFactory.factory('/calendarExceptionList', 'LOCAL');

    CalendarExceptionListRepository.clearRepository = function(){
        return this.remove(Query.build());
    };

    CalendarExceptionListRepository.deleteException = function(idException) {
        var query = Query.build().where('ID').equals(idException);
        return this.remove(query);
    };


    ContextRegister.register('CalendarExceptionListRepository', CalendarExceptionListRepository);
});

// FILE: assets/js/Repository/Git.js
Configuration(function(RepositoryFactory, ContextRegister, Query) {
    var GitRepository = RepositoryFactory.factory('/git', 'LOCAL');

    ContextRegister.register('GitRepository', GitRepository);
});


// FILE: assets/js/Repository/Login.js
/**
 * Created by jhoterdanchaves on 13/06/14.
 */

Configuration(function(RepositoryFactory, ContextRegister, Query) {
    var LoginRepository = RepositoryFactory.factory('/login', 'LOCAL');

    LoginRepository.findByEmailAndPassword = function(email, password) {

        return this.download(Query.build()
            .where('email').equals(email)
            .where('password').equals(password));

    };

    LoginRepository.clearRepository = function(){
    	return this.remove(Query.build());
    };


    ContextRegister.register('LoginRepository', LoginRepository);
});


// FILE: assets/js/Repository/Project.js
/**
 * Created by eugeniofonseca on 01/07/14.
 */

Configuration(function(RepositoryFactory, ContextRegister,Query) {

    var ProjectBasicRepository  = RepositoryFactory.factory('/projectData', 'LOCAL');
    var ProjectCalendarRepository = RepositoryFactory.factory('/projectCalendarData', 'LOCAL');
    var ProjectResourceRepository = RepositoryFactory.factory('/projectResourceData', 'LOCAL');
    var ProjectTaskRepository = RepositoryFactory.factory('/projectTaskData','LOCAL');

    ProjectBasicRepository.clearRepository = function(){
        return this.remove(Query.build());
    };

    ProjectCalendarRepository.clearRepository = function(){
        return this.remove(Query.build());
    };

    ProjectResourceRepository.clearRepository = function(){
        return this.remove(Query.build());
    };

    ProjectTaskRepository.clearRepository = function(){
        return this.remove(Query.build());
    };

    ContextRegister.register('ProjectBasicRepository', ProjectBasicRepository);
    ContextRegister.register('ProjectCalendarRepository', ProjectCalendarRepository);
    ContextRegister.register('ProjectResourceRepository', ProjectResourceRepository);
    ContextRegister.register('ProjectTaskRepository', ProjectTaskRepository);


});


// FILE: assets/js/Repository/SignupWizard.js
/**
 * Created by jhoterdanchaves on 16/06/14.
 */
Configuration(function(RepositoryFactory, ContextRegister, Query) {

    var OrganizationInitRepository  = RepositoryFactory.factory('/organizationInit', 'LOCAL');
        OrganizationInitRepository.clearRepository = function(){
            return this.remove(Query.build());
        };

    var BusinessPartnerInitRepository  = RepositoryFactory.factory('/businessPartnerInit', 'LOCAL');
        BusinessPartnerInitRepository.clearRepository = function(){
            return this.remove(Query.build());
        };

    ContextRegister.register('OrganizationInitRepository', OrganizationInitRepository);
    ContextRegister.register('BusinessPartnerInitRepository', BusinessPartnerInitRepository);
});



// FILE: assets/js/Repository/Sponsor.js
/**
 * Created by tuliomagalhaes on 20/06/14.
 */

Configuration(function(RepositoryFactory, ContextRegister, Query) {
    var ContactListRepository = RepositoryFactory.factory('/contactList', 'LOCAL');
    var SponsorProjectDataRepository = RepositoryFactory.factory('/sponsorProjectData', 'LOCAL');

    ContactListRepository.clearRepository = function(){
        return this.remove(Query.build());
    };
    SponsorProjectDataRepository.clearRepository = function(){
        return this.remove(Query.build());
    };

    ContactListRepository.deleteContact = function(idContact) {
        var query = Query.build().where('ID').equals(idContact);
        return this.remove(query);

    };


    ContextRegister.register('ContactListRepository', ContactListRepository);
    ContextRegister.register('SponsorProjectDataRepository', SponsorProjectDataRepository);
});


// FILE: assets/js/Repository/Task.js
/**
 * Created by tuliomagalhaes on 24/07/14.
 */

Configuration(function(RepositoryFactory, ContextRegister, Query) {
    var SubTaskRepository = RepositoryFactory.factory('/SubTask', 'LOCAL');

    SubTaskRepository.clearRepository = function(){
        return this.remove(Query.build());
    };

    ContextRegister.register('SubTaskRepository', SubTaskRepository);
});

// FILE: assets/js/Repository/TaskBranch.js
Configuration(function(RepositoryFactory, ContextRegister, Query) {
    var TaskBranchRepository = RepositoryFactory.factory('/taskBranch', 'LOCAL');

    TaskBranchRepository.saveInServer = function(){
        return this.remove(Query.build());
    };

    ContextRegister.register('TaskBranchRepository', TaskBranchRepository);
});

// FILE: assets/js/Service/AccessProfileControl.js
/**
 * Created by phillipesilva on 16/12/2015.
 */
function AccessProfileControlService() {
    var MANAGER_CONTROL = 'M';
    var CLIENT_CONTROL  = 'C';

    var getBasicDataSource = function() {
        return [
            {
                "CONTROL": "M",
                "LABEL": "Gerente",
                "PROFILE": []
            }, {
                "CONTROL": "C",
                "LABEL": "Cliente",
                "PROFILE": []
            }
        ];
    };

    this.getDataSourceData = function(profiles, identityProfiles) {
        var managerProfiles = [];
        var clientProfiles = [];

        profiles.dataset.profile.forEach(function (profile) {
            identityProfiles.dataset.accessProfile.forEach(function (identityProfile) {
                if (identityProfile.NRPERFILACESSO == profile.EXTERNAL_ID) {
                    if (profile.CONTROL == MANAGER_CONTROL) {
                        managerProfiles.push(identityProfile.NRPERFILACESSO);
                    } else if (profile.CONTROL == CLIENT_CONTROL) {
                        clientProfiles.push(identityProfile.NRPERFILACESSO);
                    }
                }
            });
        });

        return getBasicDataSource().map(function (dataPos) {
            if (dataPos.CONTROL == MANAGER_CONTROL) {
                dataPos.PROFILE = managerProfiles;
            } else if (dataPos.CONTROL == CLIENT_CONTROL) {
                dataPos.PROFILE = clientProfiles;
            }

            return dataPos;
        });
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('AccessProfileControlService', AccessProfileControlService);
});


// FILE: assets/js/Service/Acl.js
function AclService(){

	var elementTypes = {
		'X': 'Agrupador',
		'G': 'Grupo de Menu',
		'M': 'Menu',
		'C': 'Tela',
		'W': 'Componente',
		'F': 'Campo',
		'A': 'Botão'
	};

	var ruleTypes = {
		'A': 'Leitura/Escrita',
		'R': 'Somente Leitura',
		'I': 'Esconder'
	}; 

	this.translateElementType = function(typeIndex){
		return elementTypes[typeIndex];
	
	};
	this.translateRuleType = function(typeIndex){
		return ruleTypes[typeIndex];
	};

	this.buildRuleDataSource = function(){
		rules = [];
		for(var id in ruleTypes){
			rules.push({'ID': id, 'NAME': ruleTypes[id]});
		}
		return rules;
	};

	this.togglePermission = function(rule, change){
		if(change === 'VIEWABLE'){
			if(rule === 'I'){
				return 'R';
			}
			return 'I';
		}
		if(rule === 'A'){
			return 'R';
		}
		return 'A';
	};

	this.getViewableIcon = function(rule){
		if(rule === 'I'){
			return 'search icon-black';
		}
		return 'search';
	};

	this.getEditableIcon = function(rule){
		if(rule === 'A'){
			return 'pencil';
		}
		return 'pencil icon-black';
	};
}

Configuration(function(ContextRegister) {
    ContextRegister.register('AclService', AclService);
});

// FILE: assets/js/Service/Appropriation.js
function AppropriationService(Utilities, GitQueue, ZHPromise, requestDataSourceEngine, ApplicationContext, templateManager, ScreenService, Messages, localStorageEngine){
    var self = this;
    var validationUrlMergeMaster = true;
    var dirNotTaskBranch = [];
    var STABLE_BRANCH = 'stable';
    var MASTER_BRANCH = 'master';
    var MAIN_BRANCH   = MASTER_BRANCH;
    var MAIN_BRANCHES = [MASTER_BRANCH, STABLE_BRANCH];
    var REGISTERED_NAME = 'AppropriationService';
    var TYPE_RELATIONSHIP_REPLICATION     = 'R';
    var TYPE_RELATIONSHIP_MERGE_REQUEST   = 'M';
    var TYPE_RELATIONSHIP_ERROR           = 'E';
    var TYPE_RELATIONSHIP_CONFLICT        = 'C';
    var TYPE_RELATIONSHIP_CONFLICT_DEVOPS = 'D';

    this.gitBranchResult = {};

    var getLogWidget = function() {
        return templateManager.container.getWidget('LOG');
    };
    var getLogFieldFromLogWidget = function() {
        return getLogWidget().getField('LOG_FIELD');
    };
    var getCurrentRowFromLogWidget = function() {
        return getLogWidget().currentRow;
    };

    //Log Functions
    var setLogScroll = function() {
        var logField = getLogFieldFromLogWidget();
        if(logField && logField.element) {
            var logFieldElement = logField.element[0];
            templateManager.updateTemplate();
            logFieldElement.scrollTop = logFieldElement.scrollHeight;
        }
    };

    var setLogValue = function(data) {
        if(data.value && data.value !== '' && getLogFieldFromLogWidget().element) {
            var rowLogWidget = getLogWidget().currentRow;
            rowLogWidget.LOG_FIELD_SAVE = rowLogWidget.LOG_FIELD_SAVE + '\n' + data.value.trim();
            var logFieldValue = rowLogWidget.LOG_FIELD + '\n' + data.value.trim();
            rowLogWidget.LOG_FIELD = logFieldValue.slice(-5000);
            setLogScroll();
        }
    };

    var setLogDescription = function(log) {
        var logRow = getCurrentRowFromLogWidget();
        logRow.LOG_FIELD += log;
        logRow.LOG_FIELD_SAVE = logRow.LOG_FIELD_SAVE ? logRow.LOG_FIELD_SAVE + log : log;
        setLogScroll();
    };

    //Log descriptions
    var DESC_LOG_STATUS = '\n\n-- Status -- Repository: %2 --';
    var DESC_LOG_STATUS_NO_BREAK_LINE = '-- Status -- Repository: %2 --';
    var DESC_LOG_RESET = '\n\n-- Reset -- Repository: %2 --';
    var DESC_LOG_RESET_HARD = '\n\n-- Reset Hard -- Repository: %2 --';
    var DESC_LOG_ADD = '\n\n-- Add -- Repository: %2 --';
    var DESC_LOG_COMMIT = '\n\n-- Commit -- Repository: %2 --';
    var DESC_LOG_CURRENT_REMOTE = '\n\n-- Current Git Remote -- Repository: %2 --';
    var DESC_LOG_CURRENT_BRANCH = '\n\n-- Current Branch -- Repository: %2 --';
    var DESC_LOG_CURRENT_BRANCH_NO_BREAK_LINE = '-- Current Branch -- Repository: %2 --';
    var DESC_LOG_STASH = '\n\n-- Stash -- Repository: %2 --';
    var DESC_LOG_STASH_WITH_BRANCH = '\n\n-- Stash With Branch: "%1" -- Repository: %2 --';
    var DESC_LOG_CREATE_PATH = '\n\n-- Create Path -- Repository: %2 --';
    var DESC_LOG_REMOVE_PATH = '\n\n-- Remove Path -- Repository: %2 --';
    var DESC_LOG_BRANCH = '\n\n-- Branch -- Repository: %2 --';
    var DESC_LOG_BRANCH_EXEC = '\nExecuting command git branch...';
    var DESC_LOG_CREATE_FILE = '\n\n-- Create File: "%1" -- Repository: %2 --';
    var DESC_LOG_PULL = '\n\n-- Pull: "%1" -- Repository: %2 --';
    var DESC_LOG_PULL_TAGS = '\n\n-- Pull Tags -- Repository: %1 --';
    var DESC_LOG_PUSH = '\n\n-- Push: "%1" -- Repository: %2 --';
    var DESC_LOG_MERGE = '\n\n-- Merge: "%1" -- Repository: %2 --';
    var DESC_LOG_REMOVE_BRANCH = '\n\n-- Remove Branch: "%1" -- Repository: %2 --';
    var DESC_LOG_CREATE_BRANCH = '\n\n-- Create Branch: "%1" -- Repository: %2 --';
    var DESC_LOG_CLONE = '\n\n-- Clone: "%1" -- Repository: %2 --';
    var DESC_LOG_CHECKOUT = '\n\n-- Checkout: "%1" -- Repository: %2 --';
    var DESC_LOG_INI_MERGE_MASTER = '\n\n--- Atualização da branch master (Início) ---';
    var DESC_LOG_END_MERGE_MASTER = '\n\n--- Atualização da branch master (Fim) ---';

    this.calculateProgress = function(planTime, percent, hours) {
        var estimatedTime, status, result = 0;

        planTime = parseFloat(planTime);
        percent = parseFloat(percent);
        hours = parseFloat(hours);
        if(planTime > 0 && percent !== 0) {
            estimatedTime = (planTime * percent) / 100;
            status = (hours - estimatedTime) / estimatedTime * 100;
            result = Math.round(status);
        }
        return result;
    };

    this.updateMainBranchProject = function(directories, taskInfo, currentTaskStatus){
        var defer = ZHPromise.defer();
        var resolve = function (success) {
            defer.resolve(success);
        };
        var reject = function (error) {
            defer.reject(error);
        };

        var functions = [];
        if (MAIN_BRANCH == STABLE_BRANCH &&
            ((taskInfo.errorFixTask ||
            (taskInfo.typeRelationship == TYPE_RELATIONSHIP_MERGE_REQUEST &&
            taskInfo.mergeRequestStable)) &&
            currentTaskStatus == 'CONCLUDE')) {
            directories.forEach(function (dir) {
                functions.push(_pushMainBranchProject.bind(AppropriationService, dir, taskInfo.finalBranchName));
            });
        }

        Utilities.doSyncPm(functions)
            .then(resolve)
            .catch(reject);

        return defer.promise;
    };

    var _pushMainBranchProject = function(repoInfo,branchName){
        var defer = ZHPromise.defer();
        var reject = function (e) {
            e.branch = 'taskBranch';
            defer.reject(e);
        };
        var resolve = function () {
            defer.resolve();
        };

        var mergeBranchTask = function() {
            setLogDescription(DESC_LOG_MERGE.replace('%1', branchName).replace('%2', repoInfo.repository));
            GitQueue.merge(repoInfo.dir, branchName)
                .progress(setLogValue)
                .error(reject)
                .then(pushMainBranchProject);
        };

        var pushMainBranchProject  = function() {
            setLogDescription(DESC_LOG_PULL.replace('%1', repoInfo.MASTER_BRANCH).replace('%2', repoInfo.repository));
            GitQueue.push(repoInfo.dir, repoInfo.MASTER_BRANCH)
                .progress(setLogValue)
                .error(reject)
                .then(checkoutBranch);
        };
        var checkoutBranch = function() {
            setLogDescription(DESC_LOG_PULL.replace('%1', branchName).replace('%2', repoInfo.repository));
            GitQueue.checkout(repoInfo.dir, branchName)
                .progress(setLogValue)
                .error(reject)
                .then(resolve);
        };
        _checkoutBranchProject(repoInfo)
            .catch(reject)
            .then(mergeBranchTask);


        return defer.promise;
    };


    this.addProgressInDataSource = function(taskDuration, appropriations ) {
        taskDuration = parseInt(taskDuration) * 3600;
        appropriations.forEach(function(appropriation, key) {
            appropriations[key].TOTAL = appropriations[key].TOTAL.replace("-", "");
            var progress = this.calculateProgress(taskDuration,
                appropriations[key].PERCENT_COMPLETED,
                Utilities.parseHourToSeconds(appropriations[key].TOTAL));
            appropriations[key].__progress = progress;
            appropriations[key].PROGRESS = Utilities.formatValueToPercent(progress);
        }.bind(this));
    };

    var _pullAllBranches = function (repoInfo, branchName, oldBranchName, branchBkpName, notPullOldBranch) {
        var defer = ZHPromise.defer();
        var rejectedInTaskBranch = function (e) {
            e.branch = 'taskBranch';
            defer.reject(e);
        };
        var resolve = function (e) {
            defer.resolve(e);
        };
        var pullMainBranch = function() {
            setLogDescription(DESC_LOG_PULL.replace('%1', MAIN_BRANCH).replace('%2', repoInfo.repository));
            GitQueue.pull(repoInfo.dir, MAIN_BRANCH)
                .progress(setLogValue)
                .error(rejectedInTaskBranch)
                .then(resolve);
        };
        var pullMainBranchProject = function() {
            if(repoInfo.MASTER_BRANCH && (MAIN_BRANCH == STABLE_BRANCH)){
                setLogDescription(DESC_LOG_PULL.replace('%1', repoInfo.MASTER_BRANCH).replace('%2', repoInfo.repository));
                GitQueue.pull(repoInfo.dir, repoInfo.MASTER_BRANCH)
                    .progress(setLogValue)
                    .error(rejectedInTaskBranch)
                    .then(pullMainBranch);
            } else {
                pullMainBranch();
            }
        };
        var pullOldBranch = function() {
            if(oldBranchName && oldBranchName != 'INEXISTENT_BRANCH' && !notPullOldBranch) {
                setLogDescription(DESC_LOG_PULL.replace('%1', oldBranchName).replace('%2', repoInfo.repository));
                GitQueue.pull(repoInfo.dir, oldBranchName)
                    .progress(setLogValue)
                    .error(pullMainBranchProject)
                    .then(pullMainBranchProject);
            } else {
                pullMainBranchProject();
            }
        };
        var pullBkpBranch = function() {
            if(branchBkpName && branchBkpName != branchName) {
                setLogDescription(DESC_LOG_PULL.replace('%1', branchBkpName).replace('%2', repoInfo.repository));
                GitQueue.pull(repoInfo.dir, branchBkpName)
                    .progress(setLogValue)
                    .error(pullOldBranch)
                    .then(pullOldBranch);
            } else {
                pullOldBranch();
            }
        };

        setLogDescription(DESC_LOG_PULL.replace('%1', branchName).replace('%2', repoInfo.repository));
        GitQueue.pull(repoInfo.dir, branchName)
            .progress(setLogValue)
            .error(pullBkpBranch)
            .then(pullBkpBranch);

        return defer.promise;
    };

    var _createAndCheckoutBranch = function (repoInfo, branchName) {
        var defer = ZHPromise.defer();
        var reject = function (e) { defer.reject(e); };
        var resolve = function () { defer.resolve(); };

        var checkout = function() {
            setLogDescription(DESC_LOG_CHECKOUT.replace('%1', branchName).replace('%2', repoInfo.repository));
            Utilities.validateExecuteInWindows().then(function (isWindows) {
                repoInfo.dir = isWindows ? repoInfo.LOCAL_DIRECTORY : repoInfo.LINUX_DIRECTORY;
                GitQueue.checkout(repoInfo.dir, branchName)
                    .progress(setLogValue)
                    .error(reject)
                    .then(resolve);
            });
        };

        setLogDescription(DESC_LOG_CREATE_BRANCH.replace('%1', branchName).replace('%2', repoInfo.repository));
        GitQueue.createBranch(repoInfo.dir, branchName)
            .progress(setLogValue)
            .error(checkout)
            .then(checkout);

        return defer.promise;
    };

    var _createAndCheckoutAndPullBranch = function (repoInfo, branchName, oldBranchName, branchBkpName) {
        return _createAndCheckoutBranch(repoInfo, branchName).then(function() {
            return _pullAllBranches(repoInfo, branchName, oldBranchName, branchBkpName);
        });
    };

    var _checkoutAndPullBranchMergeMaster = function (repoInfo, branchName) {
        var defer = ZHPromise.defer();
        var reject = function (e) { defer.reject(e); };
        var resolve = function (s) { defer.resolve(s); };

        setLogDescription(DESC_LOG_CREATE_BRANCH.replace('%1', branchName).replace('%2', repoInfo.repository));
        GitQueue.createBranch(repoInfo.dir, branchName)
            .progress(setLogValue)
            .error(reject)
            .then(function() {
                setLogDescription(DESC_LOG_CHECKOUT.replace('%1', branchName).replace('%2', repoInfo.repository));
                GitQueue.checkout(repoInfo.dir, branchName)
                    .progress(setLogValue)
                    .error(reject)
                    .then(function() {
                        setLogDescription(DESC_LOG_PULL.replace('%1', branchName).replace('%2', repoInfo.repository));
                        GitQueue.pull(repoInfo.dir, branchName)
                            .progress(setLogValue)
                            .error(reject)
                            .then(resolve);
                    });
            });
        return defer.promise;
    };

    var _checkoutBranch = function (repoInfo, branchName) {
        var defer = ZHPromise.defer();
        var resolve = function () { defer.resolve(); };

        Utilities.validateExecuteInWindows().then(function (isWindows) {
            repoInfo.dir = isWindows ? repoInfo.LOCAL_DIRECTORY : repoInfo.LINUX_DIRECTORY;
            setLogDescription(DESC_LOG_CHECKOUT.replace('%1', branchName).replace('%2', repoInfo.repository));
            GitQueue.checkout(repoInfo.dir, branchName)
                .progress(setLogValue)
                .error(resolve)
                .then(resolve);
        }).catch(resolve);
        
        return defer.promise;
    };

    var _mergeBranchPushMaster = function (repoInfo, branchName) {
        var defer = ZHPromise.defer();
        var reject = function (e) { defer.reject(e); };
        var resolve = function (e) { defer.resolve(e); };

        setLogDescription(DESC_LOG_CHECKOUT.replace('%1', MAIN_BRANCH).replace('%2', repoInfo.repository));
        GitQueue.checkout(repoInfo.dir, MAIN_BRANCH)
            .progress(setLogValue)
            .error(reject)
            .then(function() {
                setLogDescription(DESC_LOG_MERGE.replace('%1', branchName).replace('%2', repoInfo.repository));
                GitQueue.merge(repoInfo.dir, branchName)
                    .progress(setLogValue)
                    .error(reject)
                    .then(function(){
                        setLogDescription(DESC_LOG_PUSH.replace('%1', MAIN_BRANCH).replace('%2', repoInfo.repository));
                        GitQueue.push(repoInfo.dir, MAIN_BRANCH)
                            .progress(setLogValue)
                            .error(reject)
                            .then(resolve);
                    });
            });

        return defer.promise;
    };

    var _removePath = function (repoInfo) {
        var defer = ZHPromise.defer();
        var reject = function (e) { defer.reject(e); };
        var resolve = function (e) { defer.resolve(e); };

        setLogDescription(DESC_LOG_REMOVE_PATH.replace('%2', repoInfo.repository));
        GitQueue.remove(repoInfo.dir)
            .progress(setLogValue)
            .error(reject)
            .then(resolve);

        return defer.promise;
    };

    var _pullBranchPushMaster = function (repoInfo, branchName) {
        var defer = ZHPromise.defer();
        var reject = function (e) {
            defer.reject(e);
        };
        var resolve = function (e) {
            defer.resolve(e);
        };
        GitQueue
            .pull(repoInfo.dir, branchName)
            .error(reject)
            .then(function(){
                GitQueue
                .pull(repoInfo.dir, MAIN_BRANCH)
                .push(repoInfo.dir, MAIN_BRANCH)
                .error(reject)
                .then(resolve);
            });


        return defer.promise;
    };

    var _pushBranch = function (repoInfo, branchName) {
        var defer = ZHPromise.defer();
        var reject = function (e) {
            defer.reject(e);
        };
        var resolve = function (e) {
            defer.resolve(e);
        };
        var pushBranch = function() {
            setLogDescription(DESC_LOG_PUSH.replace('%1', branchName).replace('%2', repoInfo.repository));
            self.gitBranchResult[repoInfo.dir].push(branchName);
            GitQueue.push(repoInfo.dir, branchName)
                .progress(setLogValue)
                .error(reject)
                .then(resolve);
        };

        setLogDescription(DESC_LOG_PULL.replace('%1', branchName).replace('%2', repoInfo.repository));
        GitQueue.pull(repoInfo.dir, branchName)
            .progress(setLogValue)
            .error(pushBranch)
            .then(pushBranch);

        return defer.promise;
    };

    var _pullBranchPullMasterPush = function (repoInfo, branchName, oldBranchName) {
        var defer = ZHPromise.defer();
        var reject = function (e) {
            defer.reject(e);
        };
        var rejectPullBranch = function (e) {
            if(e.data.search("ouldn't find remote") !== -1) {
                pushBranch();
            } else {
                if(e.data.search('hint') === -1){
                    reject(e);
                 } else {
                    pushBranch();
                 }
             }

        };
        var resolve = function (e) {
            defer.resolve(e);
        };

        var pushBranch = function() {
            setLogDescription(DESC_LOG_PUSH.replace('%1', branchName).replace('%2', repoInfo.repository));
            self.gitBranchResult[repoInfo.dir].push(branchName);
            GitQueue.push(repoInfo.dir, branchName)
                .progress(setLogValue)
                .error(reject)
                .then(resolve);
        };
        var pullBranch = function() {
            setLogDescription(DESC_LOG_PULL.replace('%1', branchName).replace('%2', repoInfo.repository));
            GitQueue.pull(repoInfo.dir, branchName)
                .progress(setLogValue)
                .error(rejectPullBranch)
                .then(pushBranch);
        };

        setLogDescription(DESC_LOG_PULL.replace('%1', MAIN_BRANCH).replace('%2', repoInfo.repository));
        GitQueue.pull(repoInfo.dir, MAIN_BRANCH)
            .progress(setLogValue)
            .error(reject)
            .then(function(){
                if(oldBranchName && oldBranchName != 'INEXISTENT_BRANCH') {
                    setLogDescription(DESC_LOG_PULL.replace('%1', oldBranchName).replace('%2', repoInfo.repository));
                    GitQueue.pull(repoInfo.dir, oldBranchName)
                        .progress(setLogValue)
                        .error(pullBranch)
                        .then(pullBranch);
                } else {
                    pullBranch();
                }
            });

        return defer.promise;
    };

    var _pullBranchPullMainProjectPush = function (repoInfo, branchName, oldBranchName) {
        var defer = ZHPromise.defer();
        var reject = function (e) {
            defer.reject(e);
        };
        var rejectPullBranch = function (e) {
            if(e.data.search("ouldn't find remote") !== -1) {
                pushBranch();
            } else {
                if(e.data.search('hint') === -1){
                    reject(e);
                 } else {
                    pushBranch();
                 }
             }

        };
        var resolve = function (e) {
            defer.resolve(e);
        };

        var pushBranch = function() {
            setLogDescription(DESC_LOG_PUSH.replace('%1', branchName).replace('%2', repoInfo.repository));
            self.gitBranchResult[repoInfo.dir].push(branchName);
            GitQueue.push(repoInfo.dir, branchName)
                .progress(setLogValue)
                .error(reject)
                .then(resolve);
        };
        var pullBranch = function() {
            setLogDescription(DESC_LOG_PULL.replace('%1', branchName).replace('%2', repoInfo.repository));
            GitQueue.pull(repoInfo.dir, branchName)
                .progress(setLogValue)
                .error(rejectPullBranch)
                .then(pushBranch);
        };
        
        var validateMainProject = function(e) {
            if(e.data.indexOf("ouldn't find remote ref") != -1) {
                _checkoutBranchProject(repoInfo).then(function(){
                    setLogDescription(DESC_LOG_CHECKOUT.replace('%1', branchName).replace('%2', repoInfo.repository));
                    GitQueue.checkout(repoInfo.dir, branchName)
                        .progress(setLogValue)
                        .error(reject)
                        .then(pullOldBranch);
                }).catch(reject);
            }else{
                reject(e);
            }
        };

        var pullOldBranch = function() {
            if(oldBranchName && oldBranchName != 'INEXISTENT_BRANCH') {
                setLogDescription(DESC_LOG_PULL.replace('%1', oldBranchName).replace('%2', repoInfo.repository));
                GitQueue.pull(repoInfo.dir, oldBranchName)
                    .progress(setLogValue)
                    .error(pullBranch)
                    .then(pullBranch);
            } else {
                pullBranch();
            }
        };

        setLogDescription(DESC_LOG_PULL.replace('%1', repoInfo.MASTER_BRANCH).replace('%2', repoInfo.repository));
        GitQueue.pull(repoInfo.dir, repoInfo.MASTER_BRANCH)
            .progress(setLogValue)
            .error(validateMainProject)
            .then(pullOldBranch);

        return defer.promise;
    };

    var _resetHardAll = function (repoInfo) {
        var defer = ZHPromise.defer();
        var reject = function(e) {
            defer.reject(e);
        };
        var resolve = function(){
            defer.resolve();
        };

        setLogDescription(DESC_LOG_RESET_HARD.replace('%2', repoInfo.repository));
        GitQueue.resetHard(repoInfo.dir)
            .progress(setLogValue)
            .error(reject)
            .then(resolve);

        return defer.promise;
    };

    var _pullBranchInAnotherBranchPullMasterPush = function (repoInfo, branchName) {
        var defer = ZHPromise.defer();
        var reject = function (e) {
            defer.reject(e);
        };
        var resolve = function (e) {
            defer.resolve(e);
        };

        GitQueue.pull(repoInfo.dir, MAIN_BRANCH)
            .progress(setLogValue)
            .error(reject)
            .then(function(){
                GitQueue.pull(repoInfo.dir, branchName)
                    .progress(setLogValue)
                    .error(reject)
                    .then(function(){
                        self.gitBranchResult[repoInfo.dir].push(branchName);
                        GitQueue.push(repoInfo.dir, branchName)
                            .progress(setLogValue)
                            .error(reject)
                            .then(resolve);
                    });

            });


        return defer.promise;
    };

    var _commit = function (repoInfo) {
        var defer = ZHPromise.defer();
        var reject = function (e) { defer.reject(e); };
        var resolve = function () { defer.resolve(); };

        if (repoInfo.files.length > 0) {
            setLogDescription(DESC_LOG_COMMIT.replace('%2', repoInfo.repository));
            GitQueue.commit(repoInfo.dir, repoInfo.commitMessage)
                .progress(setLogValue)
                .error(function(e) {
                    if(e.data.indexOf('nothing to commit') != -1) {
                        resolve();
                    } else {
                        reject(e);
                    }
                })
                .then(resolve);
        } else {
            resolve();
        }

        return defer.promise;
    };

    var addFiles = function(directory, files) {
        var deferAdd = ZHPromise.defer();
        var resolve = function (success) { deferAdd.resolve(success); };
        var reject = function (error) { deferAdd.reject(error); };
        GitQueue.add(directory, files, 0)
            .progress(setLogValue)
            .error(reject)
            .then(resolve);
        return deferAdd.promise;
    };

    var _add = function (repoInfo) {
        if (repoInfo.files.length > 0) {
            var files = repoInfo.files.map(function (file) {
                file.name = file.name.replace(repoInfo.dir, '').slice(1);
                return file;
            });

            var arrFiles = [];
            var maxFilesInPosition = 2000;
            while(files.length > 0) {
                arrFiles.push(files.splice(0, maxFilesInPosition));
            }

            var defer = ZHPromise.defer();
            var resolve = function (success) { defer.resolve(success); };
            var reject = function (error) { defer.reject(error); };

            var functions = [];
            arrFiles.forEach(function (files) {
                functions.push(addFiles.bind(AppropriationService, repoInfo.dir, files));
            });

            setLogDescription(DESC_LOG_ADD.replace('%2', repoInfo.repository));
            Utilities.doSyncPm(functions).then(function () {
                resolve();
            }).catch(function (e) {
                reject(e);
            });

            return defer.promise;
        }
    };

    var _checkStatusAndCheckout = function (repoInfo, notValidateMasterBranch) {
        var defer = ZHPromise.defer();
        var reject = function (e) {
            defer.reject(e);
        };
        var resolve = function () {
            defer.resolve();
        };
        var logRow = getCurrentRowFromLogWidget();

        var createMasterBranch = function(dir, masterBranch) {
            var deferCreate = ZHPromise.defer();
            var rejectCreate = function (e) { deferCreate.reject(e); };
            var resolveCreate = function () { deferCreate.resolve(); };
            var checkoutMasterBranch = function() {
                setLogDescription(DESC_LOG_CHECKOUT.replace('%1', masterBranch).replace('%2', repoInfo.repository));
                GitQueue.checkout(dir, masterBranch)
                    .progress(setLogValue)
                    .error(createFileMasterBranch)
                    .then(createFileMasterBranch);
            };
            var createFileMasterBranch = function() {
                setLogDescription(DESC_LOG_CREATE_FILE.replace('%1', 'README.md').replace('%2', repoInfo.repository));
                GitQueue.createFile(dir, 'README.md', 'Created By PM!')
                    .progress(setLogValue)
                    .error(addMasterBranch)
                    .then(addMasterBranch);
            };
            var addMasterBranch = function() {
                setLogDescription(DESC_LOG_ADD.replace('%2', repoInfo.repository));
                GitQueue.add(dir, ['README.md'], 0)
                    .progress(setLogValue)
                    .error(commitMasterBranch)
                    .then(commitMasterBranch);
            };
            var commitMasterBranch = function() {
                setLogDescription(DESC_LOG_COMMIT.replace('%2', repoInfo.repository));
                GitQueue.commit(dir, 'First commit')
                    .progress(setLogValue)
                    .error(pushMasterBranch)
                    .then(pushMasterBranch);
            };
            var pushMasterBranch = function() {
                setLogDescription(DESC_LOG_PUSH.replace('%1', masterBranch).replace('%2', repoInfo.repository));
                GitQueue.push(dir, masterBranch)
                    .progress(setLogValue)
                    .error(rejectCreate)
                    .then(resolveCreate);
            };

            setLogDescription(DESC_LOG_CREATE_BRANCH.replace('%1', masterBranch).replace('%2', repoInfo.repository));
            GitQueue.createBranch(dir, masterBranch)
                .progress(setLogValue)
                .error(checkoutMasterBranch)
                .then(checkoutMasterBranch);

            return deferCreate.promise;
        };
        var verifyMasterBranch = function(masterBranch) {
            var deferMaster = ZHPromise.defer();
            var rejectMaster = function (e) {
                deferMaster.reject(e);
            };
            setLogDescription(DESC_LOG_BRANCH.replace('%2', repoInfo.repository));
            setLogDescription(DESC_LOG_BRANCH_EXEC);
            self.checkExistsBranch(repoInfo.dir, masterBranch)
                .then(function(result) {
                    if(result) {
                        deferMaster.resolve();
                    } else {
                        createMasterBranch(repoInfo.dir, masterBranch)
                            .then(function() {
                                deferMaster.resolve();
                            }).catch(rejectMaster);
                    }
                }).catch(rejectMaster);

            return deferMaster.promise;
        };
        var runMasterBranches = function() {
            var functions = [];
            MAIN_BRANCHES.forEach(function (branch) {
                functions.push(verifyMasterBranch.bind(_checkStatusAndCheckout, branch));
            });

            Utilities.doSyncPm(functions)
                .then(resolve)
                .catch(reject);
        };

        if(!logRow.LOG_FIELD) {
            setLogDescription(DESC_LOG_STATUS_NO_BREAK_LINE.replace('%2', repoInfo.repository));
        } else {
            setLogDescription(DESC_LOG_STATUS.replace('%2', repoInfo.repository));
        }
        GitQueue.status(repoInfo.dir)
            .progress(setLogValue)
            .error(function (error) {
                if(!error.connectionError) {
                    setLogDescription(DESC_LOG_CREATE_PATH.replace('%2', repoInfo.repository));
                    GitQueue.createPath(repoInfo.dir)
                        .progress(setLogValue)
                        .error(reject)
                        .then(function () {
                            setLogDescription(DESC_LOG_CLONE.replace('%1', repoInfo.repository).replace('%2', repoInfo.repository));
                            GitQueue.clone(repoInfo.dir, repoInfo.repository)
                                .progress(setLogValue)
                                .error(reject)
                                .then(function () {
                                    if(notValidateMasterBranch) {
                                        resolve();
                                    } else {
                                        runMasterBranches();
                                    }
                                });
                        });
                } else {
                    reject(error);
                }
            }).then(function() {
                if(notValidateMasterBranch) {
                    resolve();
                } else {
                    runMasterBranches();
                }
            });

        return defer.promise;
    };

    var _validateUrlServerPathMergeMaster = function (repoInfo) {
        var defer = ZHPromise.defer();
        var validateUrl = function (url) {
            if(url != repoInfo.repository) {
                validationUrlMergeMaster = false;
            }
            defer.resolve();
        };
        var errorExecute = function() {
            validationUrlMergeMaster = false;
            defer.resolve();
        };

        setLogDescription(DESC_LOG_CURRENT_REMOTE.replace('%2', repoInfo.repository));
        GitQueue.currentGitRemote(repoInfo.dir)
            .progress(setLogValue)
            .error(errorExecute)
            .then(validateUrl);

        return defer.promise;
    };

    var _validateCurrentBranch = function (repoInfo, taskInfo) {
        var defer = ZHPromise.defer();
        var reject = function (e) { defer.reject(e); };
        var resolve = function (currentBranch) {
            var validateConflictDevOps = true;
            if(taskInfo.typeRelationship == TYPE_RELATIONSHIP_CONFLICT_DEVOPS) {
                validateConflictDevOps = currentBranch.trim() != taskInfo.oldBranchName &&
                                         currentBranch.trim() != taskInfo.oldBranchName.replace('TASK_', 'TASK_BKP_');
            }
            if(currentBranch.trim() != taskInfo.branchName && validateConflictDevOps) {
                dirNotTaskBranch.push(repoInfo);
            }
            defer.resolve();
        };
        var logRow = getCurrentRowFromLogWidget();

        if(!logRow.LOG_FIELD) {
            setLogDescription(DESC_LOG_CURRENT_BRANCH_NO_BREAK_LINE.replace('%2', repoInfo.repository));
        } else {
            setLogDescription(DESC_LOG_CURRENT_BRANCH.replace('%2', repoInfo.repository));
        }
        GitQueue.currentBranch(repoInfo.dir)
            .progress(setLogValue)
            .error(reject)
            .then(resolve);

        return defer.promise;
    };

    var _checkoutAndPullMaster = function (repoInfo) {
        var defer = ZHPromise.defer();
        var reject = function (e) {
            e.branch = MASTER_BRANCH;
            defer.reject(e);
        };
        var resolve = function () {
            defer.resolve();
        };

        setLogDescription(DESC_LOG_CHECKOUT.replace('%1', MAIN_BRANCH).replace('%2', repoInfo.repository));
        GitQueue.checkout(repoInfo.dir, MAIN_BRANCH)
            .progress(setLogValue)
            .error(reject)
            .then(function() {
                setLogDescription(DESC_LOG_PULL.replace('%1', MAIN_BRANCH).replace('%2', repoInfo.repository));
                GitQueue.pull(repoInfo.dir, MAIN_BRANCH)
                    .progress(setLogValue)
                    .error(reject)
                    .then(resolve);
            });

        return defer.promise;
    };

    var _checkoutBranchProject = function(repoInfo){
        var branchName = repoInfo.MASTER_BRANCH;
        var defer = ZHPromise.defer();
        var reject = function (e) {
            e.branch = 'taskBranch';
            defer.reject(e);
        };
        var resolve = function () {
            defer.resolve();
        };

        var pushMainBranchProject  = function() {
            setLogDescription(DESC_LOG_PULL.replace('%1', branchName).replace('%2', repoInfo.repository));
            self.gitBranchResult[repoInfo.dir].push(branchName);
            GitQueue.push(repoInfo.dir, branchName)
                .progress(setLogValue)
                .error(reject)
                .then(resolve);
        };

        var pullMainBranchProject = function() {
            setLogDescription(DESC_LOG_PULL.replace('%1', branchName).replace('%2', repoInfo.repository));
            GitQueue.pull(repoInfo.dir, branchName)
                .progress(setLogValue)
                .error(pushMainBranchProject)
                .then(resolve);
        };

        var checkout = function() {
            setLogDescription(DESC_LOG_CHECKOUT.replace('%1', branchName).replace('%2', repoInfo.repository));
            GitQueue.checkout(repoInfo.dir, branchName)
                .progress(setLogValue)
                .error(reject)
                .then(pullMainBranchProject);
        };
        if(branchName){
            setLogDescription(DESC_LOG_CREATE_BRANCH.replace('%1', branchName).replace('%2', repoInfo.repository));
            GitQueue.createBranch(repoInfo.dir, branchName)
                .progress(setLogValue)
                .error(checkout)
                .then(checkout);
        } else {
            resolve();
        }

        return defer.promise;
    };

    var _checkoutMaster = function (repoInfo) {
        var defer = ZHPromise.defer();
        var reject = function (e) {
            e.branch = 'taskBranch';
            defer.reject(e);
        };
        var resolve = function () {
            defer.resolve();
        };

        setLogDescription(DESC_LOG_CHECKOUT.replace('%1', MAIN_BRANCH).replace('%2', repoInfo.repository));
        GitQueue.checkout(repoInfo.dir, MAIN_BRANCH)
            .progress(setLogValue)
            .error(reject)
            .then(resolve);

        return defer.promise;
    };

    var _checkoutMasterBranch = function (repoInfo) {
        var defer = ZHPromise.defer();
        var reject = function (e) { defer.reject(e); };
        var resolve = function () { defer.resolve(); };

        setLogDescription(DESC_LOG_CHECKOUT.replace('%1', MASTER_BRANCH).replace('%2', repoInfo.repository));
        GitQueue.checkout(repoInfo.dir, MASTER_BRANCH)
            .progress(setLogValue)
            .error(reject)
            .then(resolve);

        return defer.promise;
    };

    var _pullTags = function (repoInfo, notReset) {
        var defer = ZHPromise.defer();
        var resolve = function () { defer.resolve(); };

        var resetError = function() {
            setLogDescription(DESC_LOG_RESET_HARD.replace('%2', repoInfo.repository));
            GitQueue.resetHard(repoInfo.dir)
                .progress(setLogValue)
                .error(resolve)
                .then(resolve);
        };

        setLogDescription(DESC_LOG_PULL_TAGS.replace('%1', repoInfo.repository));
        GitQueue.pullGeneric(repoInfo.dir)
            .progress(setLogValue)
            .error(function() {
                if(notReset) {
                    resolve();
                } else {
                    resetError();
                }
            }).then(resolve);

        return defer.promise;
    };

    var verifyRepositoryAndCheckoutMergeBranch = function (task, dirInfo, resource, branchToCheckout, branchToMerge) {
        return verifyChangedRepositoryTask(task, dirInfo.ID, resource).then(function (validation) {
            if (dirInfo.files.length > 0 || validation)
                return _checkoutAndMergeBranch(dirInfo, branchToCheckout, branchToMerge);
        });
    };

    var _checkoutAndMergeBranch = function (repoInfo, branchToCheckout, branchToMerge) {
        var defer = ZHPromise.defer();
        var reject = function (e) { defer.reject(e); };
        var resolve = function () { defer.resolve(); };

        setLogDescription(DESC_LOG_CHECKOUT.replace('%1', branchToCheckout).replace('%2', repoInfo.repository));
        GitQueue.createBranch(repoInfo.dir, branchToCheckout)
            .checkout(repoInfo.dir, branchToCheckout)
            .progress(setLogValue)
            .error(reject)
            .then(function() {
                setLogDescription(DESC_LOG_MERGE.replace('%1', branchToMerge).replace('%2', repoInfo.repository));
                GitQueue.merge(repoInfo.dir, branchToMerge)
                    .progress(setLogValue)
                    .error(reject)
                    .then(resolve);
            });

        return defer.promise;
    };

    var _pullMaster = function (repoInfo) {
        var defer = ZHPromise.defer();
        var reject = function (e) {
            e.branch = MAIN_BRANCH;
            e.pullMain = true;
            defer.reject(e);
        };
        var resolve = function () {
            defer.resolve();
        };

        setLogDescription(DESC_LOG_PULL.replace('%1', MAIN_BRANCH).replace('%2', repoInfo.repository));
        GitQueue.pull(repoInfo.dir, MAIN_BRANCH)
            .progress(setLogValue)
            .error(reject)
            .then(resolve);

        return defer.promise;
    };
    var _validateUrlServerPathMergeMasterInRepositories = function (directories) {
        var defer = ZHPromise.defer();
        var resolve = function (success) { defer.resolve(success); };
        var reject = function (error) { defer.reject(error); };

        var functions = [];
        directories.forEach(function (dir) {
            functions.push(_validateUrlServerPathMergeMaster.bind(AppropriationService, dir));
        });

        Utilities.doSyncPm(functions)
            .then(resolve)
            .catch(reject);

        return defer.promise;
    };

    this._checkStatusAndCheckoutInRepositories = function (directories, notValidateMasterBranch) {
        var defer = ZHPromise.defer();
        var resolve = function (success) { defer.resolve(success); };
        var reject = function (error) { defer.reject(error); };

        var functions = [];
        directories.forEach(function (dir) {
            functions.push(_checkStatusAndCheckout.bind(AppropriationService, dir, notValidateMasterBranch));
        });

        Utilities.doSyncPm(functions)
            .then(resolve)
            .catch(reject);

        return defer.promise;
    };

    var _checkoutAndPullMasterInRepositories = function (directories) {
        var defer = ZHPromise.defer();
        var resolve = function (success) { defer.resolve(success); };
        var reject = function (error) { defer.reject(error); };

        var functions = [];
        directories.forEach(function (dir) {
            functions.push(_checkoutAndPullMaster.bind(AppropriationService, dir));
        });

        Utilities.doSyncPm(functions)
            .then(resolve)
            .catch(reject);

        return defer.promise;
    };

    var _checkoutMasterInRepositories = function (directories) {
        var defer = ZHPromise.defer();
        var resolve = function (success) { defer.resolve(success); };
        var reject  = function (error)   { defer.reject(error);    };

        var functions = [];
        directories.forEach(function (dir) {
            functions.push(_checkoutMaster.bind(AppropriationService, dir));
        });

        Utilities.doSyncPm(functions)
            .then(resolve)
            .catch(reject);

        return defer.promise;
    };

    var _checkoutMasterBranchInRepositories = function (directories) {
        var defer = ZHPromise.defer();
        var resolve = function (success) { defer.resolve(success); };
        var reject  = function (error)   { defer.reject(error);    };

        var functions = [];
        directories.forEach(function (dir) {
            functions.push(_checkoutMasterBranch.bind(AppropriationService, dir));
        });

        Utilities.doSyncPm(functions)
            .then(resolve)
            .catch(reject);

        return defer.promise;
    };

    var _checkoutBranchProjectInRepositories = function (directories) {
        var defer = ZHPromise.defer();
        var resolve = function (success) {
            defer.resolve(success);
        };
        var reject = function (error) {
            defer.reject(error);
        };

        var functions = [];
        if (MAIN_BRANCH == STABLE_BRANCH) {
            directories.forEach(function (dir) {
                functions.push(_checkoutBranchProject.bind(AppropriationService, dir));
            });
        }

        Utilities.doSyncPm(functions)
            .then(resolve)
            .catch(reject);

        return defer.promise;
    };

    var _pullTagsInRepositories = function (directories, notReset) {
        var defer = ZHPromise.defer();
        var resolve = function (success) {
            defer.resolve(success);
        };
        var reject = function (error) {
            defer.reject(error);
        };

        var functions = [];
        if (self.isTagMainBranch()) {
            directories.forEach(function (dir) {
                functions.push(_pullTags.bind(AppropriationService, dir, notReset));
            });
        }

        Utilities.doSyncPm(functions)
            .then(resolve)
            .catch(reject);

        return defer.promise;
    };

    var _checkoutAndMergeBranchInRepositories = function (directories, branchToCheckout, branchToMerge, task, resource) {
        var defer = ZHPromise.defer();
        var resolve = function (success) { defer.resolve(success); };
        var reject = function (error) { defer.reject(error); };

        var functions = [];
        directories.forEach(function (dirInfo) {
            if(task) {
                functions.push(verifyRepositoryAndCheckoutMergeBranch.bind(AppropriationService, task, dirInfo, resource, branchToCheckout, branchToMerge));
            } else {
                if(dirInfo.files.length > 0)
                    functions.push(_checkoutAndMergeBranch.bind(AppropriationService, dirInfo, branchToCheckout, branchToMerge));
            }
        });

        Utilities.doSyncPm(functions)
            .then(resolve)
            .catch(reject);

        return defer.promise;
    };

    this.pullMasterInRepositories = function (directories) {
        var defer = ZHPromise.defer();
        var resolve = function (success) { defer.resolve(success); };
        var reject = function (error) { defer.reject(error); };

        var functions = [];
        directories.forEach(function (dir) {
            functions.push(_pullMaster.bind(AppropriationService, dir));
        });

        Utilities.doSyncPm(functions)
            .then(resolve)
            .catch(reject);

        return defer.promise;
    };

    var _pullBranchPushMasterInRepositories = function (directories, branchName) {
        var promises = directories.map(function (dirInfo) {
            if(dirInfo.files.length>0)
                return _pullBranchPushMaster(dirInfo, branchName);
        });
        return ZHPromise.all(promises);
    };

    var verifyChangedRepositoryTask = function(task, repository, resource) {
        var filter = [{
            "operator": "=",
            "name": "TASK",
            "value": task
        }, {
            "operator": "IN",
            "name": "REPOSITORY",
            "value": repository
        },         {
            "operator": "=",
            "name": "RESOURCE_T",
            "value": resource
        }];

        return requestDataSourceEngine.getDataSource('/changedFilesCrud', filter).then(function(data) {
            return data.dataset.changedFiles.length > 0;
        });
    }; 
    
    
   this.allocateMultipleTasks = function(rows) {
       var filter = {
            "changed": true,
            "CHECKED_ROWS": rows
        };
        return requestDataSourceEngine.setDataSource('/allocateCurrentUserInTasks', [filter]).then(function(data) {
            return data.dataset.allocatedUser[0];
        });
    };
    
    this.getInfoTask = function(rows) {
        var filter = [{
            "operator": "=",
            "name": "TASK",
            "value": rows
        }];

        return requestDataSourceEngine.getDataSource('/findTaskForTimeControlById', filter).then(function(data) {
            return data.dataset.findTask[0];
        });
    };
    
    this.validateMergeTaskConclude = function (taskId) {
        var filter = [
            {
                "operator": "=",
                "name": "TASK",
                "value": taskId
            }
        ];
        return requestDataSourceEngine.getDataSource('/validateMergeTaskConclude', filter).then(function (response) {
            return response.dataset.validateMergeTaskConclude;
        });
    };
    
    
    this.getTaskIssue = function (taskId) {
        var filter = [
            {
                "operator": "=",
                "name": "TASK_ID",
                "value": taskId
            }
        ];
        return requestDataSourceEngine.getDataSource('/issueAppropriation', filter).then(function (response) {
            return response.dataset.issuesRelatedToTask;
        });
    };

    var verifyRepositoryAndPushBranch = function (task, dirInfo, resource, branchName) {
        return verifyChangedRepositoryTask(task, dirInfo.ID, resource).then(function (validation) {
            if (dirInfo.files.length > 0 || validation)
                return _pushBranch(dirInfo, branchName);
        });
    };

    var _pushBranchInRepositories = function(directories, branchName, task, resource) {
        var defer = ZHPromise.defer();
        var resolve = function (success) { defer.resolve(success); };
        var reject = function (error) { defer.reject(error); };
        var functions = [];

        directories.forEach(function(dirInfo){
            if(task) {
                functions.push(verifyRepositoryAndPushBranch.bind(AppropriationService, task, dirInfo, resource, branchName));
            } else {
                if(dirInfo.files.length > 0)
                    functions.push(_pushBranch.bind(AppropriationService, dirInfo, branchName));
            }
        });

        Utilities.doSyncPm(functions)
            .then(resolve)
            .catch(reject);

        return defer.promise;
    };

    var _resetHardAllInRepositories = function (directories) {
        var defer = ZHPromise.defer();
        var resolve = function (success) { defer.resolve(success); };
        var reject = function (error) { defer.reject(error); };
        var functions = [];

        directories.forEach(function(dirInfo){
            functions.push(_resetHardAll.bind(AppropriationService, dirInfo));
        });

        Utilities.doSyncPm(functions)
            .then(resolve)
            .catch(reject);

        return defer.promise;
    };

    var verifyRepositoryAndPullBranch = function (task, dirInfo, resource, branchName, oldBranchName, taskInfo) {
        return verifyChangedRepositoryTask(task, dirInfo.ID, resource).then(function (validation) {
            if (dirInfo.files.length > 0 || validation){
                if (taskInfo &&
                    MAIN_BRANCH == STABLE_BRANCH &&
                    (taskInfo.errorFixTask ||
                    (taskInfo.typeRelationship == TYPE_RELATIONSHIP_MERGE_REQUEST &&
                    taskInfo.mergeRequestStable))) {
                   return _pullBranchPullMainProjectPush(dirInfo, branchName, oldBranchName);
                }else{
                    return _pullBranchPullMasterPush(dirInfo, branchName, oldBranchName);
                }
            }
        });
    };

    var setErrorMergeAllRepositories = function (e) {
        var objectError = null;
        e.forEach(function (error) {
            if (objectError) {
                if (error && error.data) {
                    if (objectError.data) {
                        objectError.data += "<br/><br/>" + error.data;
                    } else {
                        objectError.data = error.data;
                    }
                }
            } else {
                objectError = error;
            }
        });
        return objectError;
    };
    var _pullBranchPullMasterPushInRepositories = function (directories, branchName, oldBranchName, task, resource, taskInfo) {
        var defer = ZHPromise.defer();
        var resolve = function (success) {
            defer.resolve(success);
        };
        var reject = function (error) {
            defer.reject(error);
        };
        var functions = [];

        directories.forEach(function (dirInfo) {
            if (task) {
                functions.push(verifyRepositoryAndPullBranch.bind(AppropriationService, task, dirInfo, resource, branchName, oldBranchName,taskInfo));
            } else {
                if(dirInfo.files.length > 0)
                    functions.push(_pullBranchPullMasterPush.bind(AppropriationService, dirInfo, branchName, oldBranchName));
            }
        });

        Utilities.doSyncPmNotStop(functions)
            .then(resolve)
            .catch(function(e){
                reject(setErrorMergeAllRepositories(e));
            });

        return defer.promise;
    };

    var verifyRepositoryAndPullAnotherBranch = function (task, dirInfo, resource, branchName) {
        return verifyChangedRepositoryTask(task, dirInfo.ID, resource).then(function (validation) {
            if (dirInfo.files.length > 0 || validation)
                return _pullBranchInAnotherBranchPullMasterPush(dirInfo, branchName);
        });
    };

    var _pullBranchInAnotherBranchPullMasterPushInRepositories = function (directories, branchName, task, resource) {
        var defer = ZHPromise.defer();
        var resolve = function (success) { defer.resolve(success); };
        var reject = function (error) { defer.reject(error); };
        var functions = [];

        directories.forEach(function (dirInfo) {
            if(task) {
                functions.push(verifyRepositoryAndPullAnotherBranch.bind(task, dirInfo, resource, branchName));
            } else {
                if(dirInfo.files.length > 0)
                    functions.push(_pullBranchInAnotherBranchPullMasterPush.bind(dirInfo, branchName));
            }
        });

        Utilities.doSyncPm(functions)
            .then(resolve)
            .catch(reject);

        return defer.promise;
    };
    var _checkoutAndPullBranchInRepositories = function (directories, branchName, oldBranchName, branchBkpName) {
        var defer = ZHPromise.defer();
        var resolve = function (success) { defer.resolve(success); };
        var reject = function (error) { defer.reject(error); };

        var functions = [];
        directories.forEach(function (dir) {
            functions.push(_createAndCheckoutAndPullBranch.bind(AppropriationService, dir, branchName, oldBranchName, branchBkpName));
        });

        Utilities.doSyncPm(functions)
            .then(resolve)
            .catch(reject);

        return defer.promise;
    };
    var _createAndCheckoutBranchInRepositories = function (directories, branchName) {
        var defer = ZHPromise.defer();
        var resolve = function (success) { defer.resolve(success); };
        var reject = function (error) { defer.reject(error); };

        var functions = [];
        directories.forEach(function (dir) {
            functions.push(_createAndCheckoutBranch.bind(AppropriationService, dir, branchName));
        });

        Utilities.doSyncPm(functions)
            .then(resolve)
            .catch(reject);

        return defer.promise;
    };
    var _pullAllBranchesInRepositories = function (directories, branchName, oldBranchName, branchBkpName, notPullOldBranch) {
        var defer = ZHPromise.defer();
        var resolve = function (success) { defer.resolve(success); };
        var reject = function (error) { defer.reject(error); };

        var functions = [];
        directories.forEach(function (dir) {
            functions.push(_pullAllBranches.bind(AppropriationService, dir, branchName, oldBranchName, branchBkpName, notPullOldBranch));
        });

        Utilities.doSyncPmNotStop(functions)
            .then(resolve)
            .catch(function(e){
                reject(setErrorMergeAllRepositories(e));
            });

        return defer.promise;
    };
    var _checkoutAndPullBranchInRepositoriesMergeMaster = function (directories, branchName) {
        var defer = ZHPromise.defer();
        var resolve = function (success) { defer.resolve(success); };
        var reject = function (error) { defer.reject(error); };

        var functions = [];
        directories.forEach(function (dir) {
            functions.push(_checkoutAndPullBranchMergeMaster.bind(AppropriationService, dir, branchName));
        });

        Utilities.doSyncPm(functions)
            .then(resolve)
            .catch(reject);

        return defer.promise;
    };
    this.checkoutBranchInRepositories = function (directories, branchName) {
        var defer = ZHPromise.defer();
        var resolve = function (success) { defer.resolve(success); };
        var reject = function (error) { defer.reject(error); };

        var functions = [];
        directories.forEach(function (dir) {
            functions.push(_checkoutBranch.bind(AppropriationService, dir, branchName));
        });

        Utilities.doSyncPm(functions)
            .then(resolve)
            .catch(reject);

        return defer.promise;
    };

    var _mergeBranchPushMasterInRepositories = function (directories, branchName) {
        var defer = ZHPromise.defer();
        var resolve = function (success) { defer.resolve(success); };
        var reject = function (error) { defer.reject(error); };

        var functions = [];
        directories.forEach(function (dir) {
            functions.push(_mergeBranchPushMaster.bind(AppropriationService, dir, branchName));
        });

        Utilities.doSyncPm(functions)
            .then(resolve)
            .catch(reject);

        return defer.promise;
    };

    var _removeRepositories = function (directories) {
        var defer = ZHPromise.defer();
        var resolve = function (success) { defer.resolve(success); };
        var reject = function (error) { defer.reject(error); };

        var functions = [];
        directories.forEach(function (dir) {
            functions.push(_removePath.bind(AppropriationService, dir));
        });

        Utilities.doSyncPm(functions)
            .then(resolve)
            .catch(reject);

        return defer.promise;
    };

    var _stashApplyInRepositories = function (directories) {
        var promiseStashApply = directories.map(function (dir) {
            return _stashApply(dir);
        });
        return ZHPromise.all(promiseStashApply);
    };

    /**
     * @param data array of data object
     * @param fn function to provide a promise
     */
    var _arrayPromisefy = function (data, fn) {
        var defer = ZHPromise.defer();
        var resolve = function (success) { defer.resolve(success); };
        var reject = function (error) { defer.reject(error); };

        var functions = [];
        data.forEach(function (item) {
            functions.push(fn.bind(AppropriationService, item));
        });

        Utilities.doSyncPm(functions)
            .then(resolve)
            .catch(reject);

        return defer.promise;
    };

    //Some commit can fail
    var _commitInRepoistories = function (directories) {
        var defer = ZHPromise.defer();
        _arrayPromisefy(directories, _commit).then(function () {
            defer.resolve();
        }, function (e) {
            defer.reject(e);
        });
        return defer.promise;
    };

    this.gitStop = function (branchName, _promiseDirectoryInfo) {
        return this.gitPause(branchName, _promiseDirectoryInfo);
    };

    this.mergeMaster = function (finalBranchName, unchangedTaskPaths, _promiseCloneRepositoryInServerPromise, taskInfo, loginClientBrowser) {
        setLogDescription(DESC_LOG_INI_MERGE_MASTER);

        self.loginBrowser(ProjectManagementConfig.wsEmailMergeMaster);
        var defer = ZHPromise.defer();
        var directories, directoriesFull;
        var promiseDirectory = _promiseCloneRepositoryInServerPromise();
        var reject  = function(e) {
            setLogDescription(DESC_LOG_END_MERGE_MASTER);
            defer.reject(e);
        };
        var resolve = function() {
            setLogDescription(DESC_LOG_END_MERGE_MASTER);
            defer.resolve({});
        };

        promiseDirectory.then(function (_directories) {
            directories = _directories;
            return _validateUrlServerPathMergeMasterInRepositories(directories);
        }).then(function () {
            if(!validationUrlMergeMaster) {
                return _removeRepositories(directories).then(function () {
                    return self._checkStatusAndCheckoutInRepositories(directories, true);
                });
            } else {
                return self._checkStatusAndCheckoutInRepositories(directories, true);
            }
        }).then(function () {
            directoriesFull = directories;
            return _checkExistsBranch(directoriesFull, finalBranchName).then(function(directoriesFiltered) {
                directories = directoriesFiltered;
                return _checkoutAndPullMasterInRepositories(directories);
            });
        }).then(function () {
            return _checkoutAndPullBranchInRepositoriesMergeMaster(directories, finalBranchName);
        }).then(function () {
            return _mergeBranchPushMasterInRepositories(directories, finalBranchName);
        }).then(function () {
            if(taskInfo.typeRelationship == 'R' || taskInfo.mergeGeneratedByReplication == 'Y') {
                self.loginBrowser(loginClientBrowser);
                return _removeRemoteBranchInRepositories(localStorageEngine.getLocalVar('TASK_PATHS'), finalBranchName, null, null, true)
                    .then(resolve);
            } else {
                resolve();
            }
        }).catch(function (e) {
            _removeRepositories(directories).then(function () {
                self.loginBrowser(loginClientBrowser);
                return self.checkoutBranchInRepositories(unchangedTaskPaths, taskInfo.branchName);
            }).then(reject).catch(reject);
        });

        return defer.promise;
    };

    this.gitPlay = function (branchName, _promiseDirectoryInfo, taskInfo) {
        var infoTaskRow = templateManager.container.getWidget('INFO_TASK').currentRow;
        MAIN_BRANCH = taskInfo.mainBranch;
        var defer = ZHPromise.defer();
        var directories;
        var promiseDirectory = _promiseDirectoryInfo();

        promiseDirectory.then(function (_directories) {
            directories = _directories;
            if(infoTaskRow.PRODUCT_VERSION_ID) {
                return _checkoutMasterBranchInRepositories(directories);
            }
            return ZHPromise.when();
        }).then(function () {
            if(infoTaskRow.PRODUCT_VERSION_ID) {
                return _pullTagsInRepositories(directories);
            }
            return ZHPromise.when();
        }).then(function () {
            return _checkoutMasterInRepositories(directories);
        }).then(function () {
            return _checkoutBranchProjectInRepositories(directories);
        }).then(function () {
            return _createAndCheckoutBranchInRepositories(directories, branchName);
        }).then(function () {
            var notPullOldBranch = taskInfo.typeRelationship == TYPE_RELATIONSHIP_CONFLICT_DEVOPS;
            return _pullAllBranchesInRepositories(directories, branchName, taskInfo.oldBranchName, null, notPullOldBranch);
        }).then(function () {
            defer.resolve({});
        }).catch(function (e) {
            defer.reject(e);
        });

        return defer.promise;
    };

    this.loginBrowser = function (email) {
        GitQueue.loginBrowser(email);
    };

    var _status = function (dir) {
        var defer = ZHPromise.defer();
        var reject = function (error) { defer.reject(error); };
        var resolve = function(success) { defer.resolve(success); };

        setLogDescription(DESC_LOG_STATUS.replace('%2', dir.repository));
        GitQueue.status(dir.dir)
            .progress(setLogValue)
            .error(reject)
            .then(resolve);

        return defer.promise;
    };

    var _statusAllFiles = function(dir){
        var defer = ZHPromise.defer();
        var reject = function (error) { defer.reject(error); };
        var resolve = function(success) { defer.resolve(success); };

        setLogDescription(DESC_LOG_STATUS.replace('%2', dir.repository));
        GitQueue.statusAllFiles(dir.dir)
            .progress(setLogValue)
            .error(reject)
            .then(resolve);

        return defer.promise;
    };

    var _stashWithBranch = function(repoInfo, taskBranchName, stashBranchName){
        var defer = ZHPromise.defer();
        var reject = function (e) {
            defer.reject(e);
        };
        var resolve = function () {
            defer.resolve();
        };

        setLogDescription(DESC_LOG_STASH.replace('%2', repoInfo.repository));
        GitQueue.removeLocalBranch(repoInfo.dir, stashBranchName)
            .stash(repoInfo.dir)
            .progress(setLogValue)
            .then(function(){
                setLogDescription(DESC_LOG_STASH_WITH_BRANCH.replace('%1', stashBranchName).replace('%2', repoInfo.repository));
                return GitQueue.stashWithBranch(repoInfo.dir, stashBranchName)
                    .progress(setLogValue);
            }).then(function(){
                setLogDescription(DESC_LOG_ADD.replace('%2', repoInfo.repository));
                return GitQueue.add(repoInfo.dir, ['.'], 1)
                    .progress(setLogValue);
            }).then(function(){
                setLogDescription(DESC_LOG_COMMIT.replace('%2', repoInfo.repository));
                return GitQueue.commit(repoInfo.dir, "stash")
                    .progress(setLogValue);
            }).then(function(){
                setLogDescription(DESC_LOG_PUSH.replace('%1', stashBranchName).replace('%2', repoInfo.repository));
                self.gitBranchResult[repoInfo.dir].push(stashBranchName);
                return GitQueue.push(repoInfo.dir, stashBranchName)
                    .progress(setLogValue);
            }).then(function(){
                setLogDescription(DESC_LOG_CHECKOUT.replace('%1', taskBranchName).replace('%2', repoInfo.repository));
                return GitQueue.checkout(repoInfo.dir, taskBranchName)
                    .progress(setLogValue);
            })
            .then(resolve)
            .catch(reject);

        return defer.promise;
    };

    var _stashApply = function (dir){
        return GitQueue
            .stashApply(dir.dir);
    };

    this.gitModifiedFiles = function (_promiseDirectoryInfo) {
        var defer = ZHPromise.defer();

        this.gitStatus(_promiseDirectoryInfo).then(function (directoriesStatus) {
            var newDirectoriesStatus = directoriesStatus.map(function (ds) {
                ds.files = getStatusFiles(ds.status);
                ds.hasChanges = ds.files.length > 0;
                return ds;
            });

            defer.resolve(newDirectoriesStatus);
        }).catch(function(e) {
            defer.reject(e);
        });

        return defer.promise;
    };

    this.getMasterFiles = function(_promiseStashDirectoryInfo, _promiseCommitDirectoryInfo, _promiseStatusDirectoryInfo){
        var defer = ZHPromise.defer();
        var directories;
        _promiseStatusDirectoryInfo().then(function(_directories){
            var statusPromisies = _directories.map(function(directory){
                return _status(directory).then(function(sttus){
                    allFilesFromStatus = status.split(/\n/);
                });
            });
        });
    };

    this.gitStatus = function (_promiseDirectoryInfo) {
        var defer = ZHPromise.defer();
        var directoriesStatus = [];
        var ignoredFiles = [];
        var allFilesFromStatus = [];
        var statusWithoutIgnored = [];
        var aux;
        _promiseDirectoryInfo().then(function (_directories) {
            var statusPromisies = _directories.map(function (directory) {
                return _status(directory).then(function (status) {
                    allFilesFromStatus = status.split(/\n/);
                    allFilesFromStatus.forEach(function(file){
                        if(file.search('!!')!==(-1)){
                            ignoredFiles.push(file.substr(3));
                        }
                    });
                }).catch(function (e) {
                    defer.reject(e);
                });
            });
        }).catch(function (e) {
            defer.reject(e);
        });
        _promiseDirectoryInfo().then(function (_directories) {
            var statusAllFiles = _directories.map(function (directory) {
                return function() {
                    return _statusAllFiles(directory).then(function (status) {
                        statusWithoutIgnored = status.split(/\n/);
                        statusWithoutIgnored = statusWithoutIgnored.filter(function (file) {
                            return ignoredFiles.indexOf(file.substr(3)) == (-1);
                        });

                        statusWithoutIgnored = statusWithoutIgnored.toString().replace(/,/g, '\n');
                        directoriesStatus.push({
                            dir: directory.dir,
                            repository_ids: directory.ID,
                            status: statusWithoutIgnored,
                            repository: directory.repository
                        });
                    }).catch(function (e) {
                        defer.reject(e);
                    });
                };
            });
            Util.doSync(statusAllFiles, function () {
                defer.resolve(directoriesStatus);
            });
        }).catch(function (e) {
            defer.reject(e);
        });

        return defer.promise;
    };

    var validateStatus = function(status) {
        return status.search('working directory clean') !== -1;
    };

    this.gitStatusAllFiles = function (_promiseDirectoryInfo) {
        var defer = ZHPromise.defer();
        var directoriesStatus = [];
        _promiseDirectoryInfo().then(function (_directories) {
            var statusPromisies = _directories.map(function (directory) {
                return _statusAllFiles(directory).then(function (status) {
                    directoriesStatus.push({dir: directory.dir, status: status, repository: directory.repository});
                }).catch(function (e) {
                    defer.reject(e);
                });
            });
            return ZHPromise.all(statusPromisies);
        }).then(function () {
            defer.resolve(directoriesStatus);
        }).catch(function (e) {
            defer.reject(e);
        });

        return defer.promise;
    };

    this.gitReset = function(_promiseDirectoryInfo){

        var defer = ZHPromise.defer();
        var directories;
        _promiseDirectoryInfo().then(function (_directories){
            return _resetFiles(_directories);
        }).catch(function(e){
            defer.reject(e);
        }).then(function(){
            defer.resolve({});
        });
       return defer.promise;
    };

    this.gitCommit = function(_promiseDirectoryInfo) {
        var defer = ZHPromise.defer();
         _promiseDirectoryInfo().then(function(_directories) {
                directories = _directories;
                return self._checkStatusAndCheckoutInRepositories(directories);
            })
            .then(function() {
                return _addFilesInRepoistories(directories);
            })
            .then(function() {
                return _commitInRepoistories(directories);
            }).then(function() {
                defer.resolve();
            })
            .catch(function(e){
                defer.reject(e);
            });
    };

    var validateCommit = function(directories) {
        var validation = false;

        directories.forEach(function(directory) {
            if(directory.files.length > 0) {
                validation = true;
            }
        });

        return validation;
    };

    this.stash = function(_promiseDirectoryInfo, taskInfo) {
        var defer = ZHPromise.defer();
        return _gitStashWithBranch(_promiseStashDirectoryInfo, taskInfo.branchName)
        .catch(function(e) {
            defer.reject(e);
        }).then(function(){
            defer.resolve();
        });
    };

    this.stashWithBranch = function(_promiseDirectoryInfo, taskInfo) {
        var defer = ZHPromise.defer();
        return _gitStashWithBranch(_promiseDirectoryInfo, taskInfo.branchName)
            .catch(function(e) {
                defer.reject(e);
            }).then(function(){
               defer.resolve();
            });
    };

    this.pullMaster = function(_promiseDirectoryInfo, taskInfo) {
        var branchName = taskInfo.branchName;
        var oldBranchName = taskInfo.oldBranchName;
        var defer = ZHPromise.defer();
        var directories;
        _promiseDirectoryInfo().then(function(_directories) {
            directories = _directories;
            return _pullBranchPullMasterPushInRepositories(directories);
        })
        .then(function() {
            defer.resolve();
        }).catch(function(e){
            defer.reject(e);
        });
    };

    var _resolveCommit = function() {
        var defer = ZHPromise.defer();
        return defer.resolve();
    };

    this.gitResetPullMaster = function (_promiseDirectoryInfo) {
        var defer = ZHPromise.defer();
        var directories;
        _promiseDirectoryInfo().then(function(_directories){
            directories = _directories;
            return _resetHardAllInRepositories(directories);
        })
        .then(function(){
            return _checkoutMasterInRepositories(directories);
        })
        .then(function(){
            defer.resolve();
        })
        .catch(function(e){
            defer.reject(e);
        });
        return defer.promise;
    };

    var validateGenerateReplicationTask = function(directory, commitFiles) {
        var filter = [{
            "operator": "=",
            "name": "TASK",
            "value": templateManager.container.getWidget('INFO_TASK').currentRow.ID
        }, {
            "operator": "=",
            "name": "RESOURCE_T",
            "value": templateManager.container.getWidget('INFO_TASK').currentRow.RESOURCE_T
        }];

        return requestDataSourceEngine.getDataSource('/changedFilesCrud', filter).then(function(data) {
            return data.dataset.changedFiles.length > 0 || commitFiles.length > 0;
        });
    };

    var createReplicationBranch = function (taskReplicationId, taskReplicationName, directory, finalBranchName, taskId, resource) {
        var replicationName = Utilities.transliterateString(taskReplicationName);
        replicationName = replicationName.replace(/(\r\n|\n|\r)/gm, "_").replace(/\W/g, "_").replace(/[_]+/g, '_');
        var branchReplicationName = 'TASK_BKP_' + taskReplicationId + '_' + replicationName;
        var rowTaskBranch = {
            "ID": null,
            "TASK": taskReplicationId,
            "NAME": branchReplicationName,
            "DESCRIPTION": null,
            "STATUS": null,
            "changed": true,
            "ORGANIZATION": Utilities.localVar.getOrganization(),
            "isMessage": false,
            "__is_new": true
        };
        return requestDataSourceEngine.setDataSource('/taskBranches', [rowTaskBranch]).then(function () {
            ScreenService.hideLoader();
            ScreenService.restoreDefaultLoadingMessage();
            return _checkoutAndPullBranchInRepositories(directory, branchReplicationName, finalBranchName);
        }).then(function () {
            return _pushBranchInRepositories(directory, branchReplicationName, taskId, resource);
        }).then(function () {
            return _checkoutMasterInRepositories(directory);
        });
    };

    var validateReplicationTask = function(taskId, directory, taskInfo, currentTaskStatus, taskIdReplication, parent, finalBranchName, resource, commitFiles) {
        var infoTaskRow = templateManager.container.getWidget('INFO_TASK').currentRow;
        var filterRelationship = [
            { "operator": "=", "name": "TASK", "value": infoTaskRow.ID },
            { "operator": "=", "name": "TYPE", "value": TYPE_RELATIONSHIP_REPLICATION }
        ];
        return requestDataSourceEngine.getDataSource('/generatedTaskRelationship', filterRelationship).then(function (data) {
            return validateGenerateReplicationTask(directory, commitFiles).then(function (validateReplication) {
                if (((data.dataset.generatedTaskRelationship.length > 0 || !validateReplication) &&
                    (taskInfo.typeRelationship != TYPE_RELATIONSHIP_MERGE_REQUEST && !infoTaskRow.PRODUCT_VERSION_ID && !infoTaskRow.ORIGIN_PRODUCT_VERSION_ID_DEV)) || infoTaskRow.IS_LTS_REPLICATION === 'N') {
                    return _checkoutMasterInRepositories(directory).then(function () {
                        if(data.dataset.generatedTaskRelationship.length > 0) {
                            var taskReplicationId = data.dataset.generatedTaskRelationship[0].TASK_RELATIONSHIP;
                            var taskReplicationName = data.dataset.generatedTaskRelationship[0].TASK_RELATIONSHIP_NAME;
                            return createReplicationBranch(taskReplicationId, taskReplicationName, directory, finalBranchName, taskId, resource)
                                .then(function() {
                                    return {
                                        ID: taskReplicationId,
                                        TASK_NAME: taskReplicationName
                                    };
                            });
                        } else {
                            return false;
                        }
                    });
                } else {
                    ScreenService.changeLoadingMessage(Messages.LOAD_CREATING_REPLICATION_TASK);
                    ScreenService.showLoader();
                    return self.updateMainBranchProject(localStorageEngine.getLocalVar('TASK_PATHS'),taskInfo,currentTaskStatus).then(function(){
                        return createReplicationTask(taskInfo, currentTaskStatus, taskIdReplication, parent, resource);
                    }).then(function (taskReplicationInfo) {
                        return createReplicationBranch(taskReplicationInfo.ID, taskReplicationInfo.TASK_NAME, directory, finalBranchName, taskId, resource)
                            .then(function() {
                                return taskReplicationInfo;
                            });
                    });
                }
            });
        });
    };

    this.gitPull = function(taskInfo, _promiseDirectoryInfo) {
        MAIN_BRANCH = taskInfo.mainBranch;
        var listTasksWidget = templateManager.container.getWidget('LIST_TASKS');
        var defer = ZHPromise.defer();
        var resolve = function (success) { defer.resolve(success); };
        var reject = function (error) { defer.reject(error); };
        var branchName = taskInfo.branchName;
        var oldBranchName = taskInfo.oldBranchName;
        var directories;
        var errors = [];
        var taskId = listTasksWidget.currentRow.TASK_ID;
        var resource = listTasksWidget.currentRow.RESOURCE_T;

        _promiseDirectoryInfo().then(function (_directories) {
            directories = _directories;
            return _pullBranchPullMasterPushInRepositories(directories, branchName, oldBranchName, taskId, resource, taskInfo);
        }).then(resolve).catch(function (e) {
            errors.push(e);
            reject(errors);
        });

        return defer.promise;
    };

    this.gitPullAndCheckout = function(taskInfo, _promiseDirectoryInfo, _promiseResetDirectoryInfo, _promiseStashDirectoryInfo, _promiseStatusDirectoryInfo, finalBranchName, currentTaskStatus, commitFiles) {
        MAIN_BRANCH = taskInfo.mainBranch;
        var infoTasksWidget = templateManager.container.getWidget('INFO_TASK');
        var resolve = function (success) { defer.resolve(success); };
        var reject = function (error) { defer.reject(error); };
        var branchName = taskInfo.branchName;
        var oldBranchName = taskInfo.oldBranchName;
        var defer = ZHPromise.defer();
        var directories, directory;
        var errors = [];
        var taskId = infoTasksWidget.currentRow.TASK_ID;
        var taskIdReplication = infoTasksWidget.currentRow.TASK_ID;
        var resource = infoTasksWidget.currentRow.RESOURCE_T;
        var parent = infoTasksWidget.currentRow.PARENT;
        if (taskInfo.typeRelationship == TYPE_RELATIONSHIP_REPLICATION   || taskInfo.typeRelationship == TYPE_RELATIONSHIP_CONFLICT ||
            taskInfo.typeRelationship == TYPE_RELATIONSHIP_MERGE_REQUEST || taskInfo.typeRelationship == TYPE_RELATIONSHIP_ERROR ||
            taskInfo.typeRelationship == TYPE_RELATIONSHIP_CONFLICT_DEVOPS) {
            taskId = taskInfo.taskGenerator;
        }
        _promiseDirectoryInfo().then(function (_directories) {
            directories = _directories;
            if(taskInfo.typeRelationship == TYPE_RELATIONSHIP_CONFLICT_DEVOPS) {
                if(!self.isTagMainBranch()) {
                    MAIN_BRANCH = MASTER_BRANCH;
                }
                oldBranchName = oldBranchName.replace('TASK_', 'TASK_BKP_');
                return _checkoutAndMergeBranchInRepositories(directories, oldBranchName, branchName, taskId, resource).then(function() {
                    branchName = taskInfo.oldBranchName.replace('TASK_', 'TASK_BKP_');
                    oldBranchName = 'INEXISTENT_BRANCH';
                    return _pullBranchPullMasterPushInRepositories(directories, branchName, oldBranchName, taskId, resource, taskInfo);
                });
            } else {
                return _pullBranchPullMasterPushInRepositories(directories, branchName, oldBranchName, taskId, resource, taskInfo);
            }
        }).then(function () {
            if (!finalBranchName) {
                _promiseStatusDirectoryInfo().then(function (_directory) {
                    directory = _directory;
                    return _checkoutMasterInRepositories(directory);
                }).then(resolve).catch(reject);
            } else {
                _promiseStatusDirectoryInfo().then(function (_directory) {
                    directory = _directory;
                    return _checkoutAndPullBranchInRepositories(directory, finalBranchName, oldBranchName, branchName);
                }).then(function () {
                    var validateRepositories = validateAllRepositoriesWithoutFiles(directory);
                    if (!validateRepositories) {
                        setDirectoriesFilesLength(directory);
                    }
                    return _checkExistsBranch(directory, branchName).then(function (directoriesFiltered) {
                        directory = directoriesFiltered;
                        return _pushBranchInRepositories(directory, finalBranchName, taskId, resource);
                    });
                }).then(function () {
                    return _removeRemoteBranchInRepositories(directory, branchName, taskId, resource, false);
                }).then(function () {
                    _promiseStatusDirectoryInfo().then(function (directory) {
                        var isLts = infoTasksWidget.currentRow.IS_LTS;
                        isLts = isLts && isLts === 'Y';
                        if (currentTaskStatus === 'CONCLUDE' && isLts &&
                            (taskInfo.errorFixTask || self.isTagMainBranch() ||
                            (taskInfo.typeRelationship === TYPE_RELATIONSHIP_MERGE_REQUEST && taskInfo.mergeRequestStable))
                        ) {
                            return validateReplicationTask(taskId, directory, taskInfo, currentTaskStatus, taskIdReplication, parent,
                                finalBranchName, resource, commitFiles, infoTasksWidget);
                        } else {
                            return _checkoutMasterInRepositories(directory);
                        }
                    }).then(function (taskReplicationInfo) {
                        resolve(taskReplicationInfo);
                    }).catch(reject);
                }).catch(reject);
            }
        }).catch(function (e) {
            errors.push(e);
            reject(errors);
        });

        return defer.promise;
    };

    var buildReplicationTaskRows = function (parent, resource, nextLTS) {
        var infoTaskRow = templateManager.container.getWidget('INFO_TASK').currentRow;
        var date = infoTaskRow.ESTIMATED_END_DATE.split("/").reverse().join("-");
        var taskStatus = 3;
        var taskParameters = Utilities.localVar.getTaskParameters();
        if(taskParameters && taskParameters.INITIAL_TASK_STATUS_ID ) {
            taskStatus = taskParameters.INITIAL_TASK_STATUS_ID;
        } else {
            var taskStatusRow = ApplicationContext.AppropriationController.getTaskStatusRowByControl('N');
            taskStatus = taskStatusRow.ID;
        }

        return infoTaskRow.DIRECTORIES_VALIDATION.PROJECTS.map(function (project) {
            var projectId = project.PROJECT_ID;

            return {
                RESOURCE: [resource],
                PARENT: parent,
                TYPE_RELATIONSHIP: TYPE_RELATIONSHIP_REPLICATION,
                DESCRIPTION: Messages.DES_TASK_GENERATED_REPLICACAO,
                START: date,
                END: date,
                NAME: Utilities.includeTaskTypeInTaskName(infoTaskRow.TASK_NAME, TYPE_RELATIONSHIP_REPLICATION, nextLTS.VERSION,
                    infoTaskRow.PRODUCT_VERSION_ID, infoTaskRow.ORIGIN_PRODUCT_VERSION_ID_DEV),
                PROJECT: projectId,
                TASK_STATUS: taskStatus,
                PRODUCT_VERSION_ID: nextLTS.PRODUCT_VERSION_ID,
                TOTAL_TIME: '1D',
                TASK_CLASSIFICATION: infoTaskRow.CLASSIFICATION,
                __is_new: true,
                changed: true
            };
        });
    };

    var createReplicationTask = function(taskInfo, currentTaskStatus, taskId, parent, resource) {
        if (currentTaskStatus == 'CONCLUDE' &&
            (taskInfo.errorFixTask || self.isTagMainBranch() ||
            (taskInfo.typeRelationship == TYPE_RELATIONSHIP_MERGE_REQUEST && taskInfo.mergeRequestStable))
        ) {
            return getNextLTSVersion().then(function(nextLTS) {
                var productVersionId = templateManager.container.getWidget('INFO_TASK').currentRow.PRODUCT_VERSION_ID;
                var tasks = buildReplicationTaskRows(parent, resource, nextLTS, productVersionId);
                var row = {
                    TASKS: tasks,
                    FINISHED_TASK: taskId,
                    changed: true
                };
                return self.saveMultipleTasks(row).then(function(dataNewTaskReturn) {
                    var newTaskId = dataNewTaskReturn.dataset.ID[0].toString();
                    if(nextLTS.VERSION || productVersionId) {
                        return self.duplicateChangedFilesForNewTask(taskId, newTaskId, taskInfo.typeRelationship).then(function() {
                            return {
                                ID: newTaskId,
                                TASK_NAME: tasks[0].NAME
                            };
                        });
                    } else {
                        return {
                            ID: newTaskId,
                            TASK_NAME: tasks[0].NAME
                        };
                    }
                });
            });
        } else {
            return {
                ID: null,
                TASK_NAME: null
            };
        }
    };

    var getNextLTSVersion = function() {
        var filter = [ {
            "operator": "=",
            "name": "PRODUCT_VERSION_ID",
            "value": templateManager.container.getWidget('INFO_TASK').currentRow.PRODUCT_VERSION_ID
        } ];
        return requestDataSourceEngine.getDataSource('/findNextLTSFromVersion', filter).then(function (data) {
            var nextLTS = data.dataset.findNextLTSFromVersion;
            if(nextLTS.length > 0) {
                return {
                    PRODUCT_VERSION_ID: nextLTS[0].ID,
                    VERSION: nextLTS[0].VERSION
                };
            }
            return {
                PRODUCT_VERSION_ID: null,
                VERSION: null
            };
        });
    };

    this.gitPause = function(taskInfo, _promiseDirectoryInfo, _promiseResetDirectoryInfo, _promiseStashDirectoryInfo) {
        var infoTaskRow = templateManager.container.getWidget('INFO_TASK').currentRow;
        MAIN_BRANCH = taskInfo.mainBranch;
        var defer = ZHPromise.defer();
        var directories;
        var errors = [];
        _promiseDirectoryInfo().then(function (_directories) {
            directories = _directories;
            if(infoTaskRow.PRODUCT_VERSION_ID) {
                return _pullTagsInRepositories(directories, true);
            }
            return ZHPromise.when();
        }).then(function () {
            return self._checkStatusAndCheckoutInRepositories(directories);
        }).then(function () {
            return _addFilesInRepoistories(directories);
        }).then(function () {
            if (validateCommit(directories)) {
                return _commitInRepoistories(directories);
            }
            return 'NOT COMMIT';
        }).then(function () {
            return _resolveCommit();
        }).catch(function (e) {
            errors.push(e);
            return;
        }).then(function () {
            _promiseResetDirectoryInfo().then(function (_directories) {
                return _resetFiles(_directories);
            }).catch(function (e) {
                errors.push(e);
                return;
            }).then(function () {
                return _gitStashWithBranch(_promiseStashDirectoryInfo, taskInfo.branchName)
                    .catch(function (e) {
                        errors.push(e);
                        return;
                    }).then(function () {
                        if (errors.length === 0) {
                            defer.resolve();
                        } else {
                            defer.reject(errors);
                        }
                    });
            });
        });

        return defer.promise;
    };

    this.gitResetAndStashFiles = function(_promiseResetDirectoryInfo, _promiseStashDirectoryInfo, stashBranchName) {
        var defer = ZHPromise.defer();
        var errors = [];

        _promiseResetDirectoryInfo().then(function(_directories) {
            ScreenService.changeLoadingMessage(Messages.LOAD_EXECUTING_RESET);
            return _resetFiles(_directories);
        }).catch(function(e) {
            errors.push(e);
            return null;
        }).then(function() {
            ScreenService.changeLoadingMessage(Messages.LOAD_EXECUTING_STASH);
            return _gitStashWithBranch(_promiseStashDirectoryInfo, MAIN_BRANCH, stashBranchName)
                .catch(function(e) {
                   errors.push(e);
                   return null;
                }).then(function(){
                    if(errors.length === 0 ) {
                        defer.resolve();
                    } else{
                        defer.reject(errors);
                    }
               });
        });

        return defer.promise;
    };

    function setDirectoriesFilesLength(directories) {
        directories.map(function(dir){
            dir.files.length = 1;
        });
    }

    var validateAllRepositoriesWithoutFiles = function(directories) {
        var validate = false;

        directories.forEach(function(dir){
            if(dir.files.length > 0) {
                validate = true;
            }
        });

        return validate;
    };

    this.saveMasterFiles = function (directoriesStatus, currentTask, paths) {
        var dir;
        var currentDir;
        var repository ;
        var row      = {};
        var repoInfo = {};
        var conflictingDirectories = directoriesStatus.filter(function(directory) {
            return directory.status.length > 0;
        });

        var promisies = conflictingDirectories.map(function(directoryStatus){
            paths.forEach(function(path){
                if(path.repository === directoryStatus.repository) {
                    row.REPOSITORY = path.ID;
                }
            });

            currentDir  = directoryStatus.dir;
            row.FILES   = directoryStatus.files;
            row.TASK    = currentTask;
            row.changed = true;

            return requestDataSourceEngine.setDataSource('/findMasterFiles', [row]).then(function(data) {
                var defer = ZHPromise.defer();
                repoInfo.dir   = currentDir;
                repoInfo.files = data.dataset.findMasterFiles;
                if(repoInfo.files.length > 0) {
                    row.FILES = repoInfo.files;
                    row.FILE_TYPE = 'S';
                    row.REPOSITORY = null;
                    saveMasterFilesChanged(row).then(function(){
                        defer.resolve();
                    }).catch(function(e){
                        defer.reject(e);
                    });
                } else {
                    defer.resolve();
                }

                return defer.promise;
            });
        });

        return ZHPromise.all(promisies);
    };

    var saveMasterFilesChanged = function(row) {
        var defer = ZHPromise.defer();
        requestDataSourceEngine.setDataSource('/saveChangedFiles', [row]).then(function(data){
            defer.resolve();
        }).catch(function(e){
            defer.reject(e);
        });
        return defer.promise;
    };

    this.resetMasterFiles = function (directoriesStatus, currentTask, paths) {
        var dir;
        var currentDir;
        var repository ;
        var row      = {};
        var repoInfo = {};
        var conflictingDirectories = directoriesStatus.filter(function(directory) {
            return directory.status.length > 0;
        });

        var promisies = conflictingDirectories.map(function(directoryStatus){
            paths.forEach(function(path){
                if(path.repository === directoryStatus.repository) {
                    row.REPOSITORY = path.ID;
                }
            });

            currentDir     = directoryStatus.dir;
            row.FILES      = directoryStatus.files;
            row.TASK       = currentTask;
            row.changed    = true;

            return requestDataSourceEngine.setDataSource('/findMasterFiles', [row]).then(function(data) {
                var defer = ZHPromise.defer();
                repoInfo.dir   = currentDir;
                repoInfo.files = data.dataset.findMasterFiles;
                if(repoInfo.files.length > 0) {
                    _restHead(repoInfo).then(function() {
                    var deferReset = ZHPromise.defer();
                    var rejectReset = function(e) {
                        deferReset.reject(e);
                    };
                    var resolveReset = function() {
                        deferReset.resolve();
                    };

                    _rese(repoInfo).then(function(){
                        resolveReset();
                    }).catch(function(e){
                        rejectReset();
                    });
                    return deferReset.promise;
                    }).then(function() {
                        defer.resolve();
                    }).catch(function(e){
                        defer.reject(e);
                    });
                } else {
                    defer.resolve();
                }

                return defer.promise;
            });
        });

        return ZHPromise.all(promisies);
    };

    var _resetHead = function (repoInfo) {
        if(repoInfo.files.length > 0) {
            return GitQueue
                .resetHead(repoInfo.dir, repoInfo.files);
        }
    };

    var _reset = function (repoInfo) {
        if (repoInfo.files.length > 0) {
            var files = repoInfo.files.map(function (file) {
                file.name = file.name.replace(repoInfo.dir, '').slice(1);
                return file;
            });

            setLogDescription(DESC_LOG_RESET.replace('%2', repoInfo.repository));
            return GitQueue.reset(repoInfo.dir, files, 0)
                .progress(setLogValue);
        }
    };

    this.gitStashApplyInCurrentBranch = function(_promiseResetDirectoryInfo){
        var defer = ZHPromise.defer();
        var directories;
        _promiseResetDirectoryInfo()
            .then(function(_directories){
                directories = _directories;
                return _stashApplyInRepositories(directories);
            }).then(function(){
                defer.resolve();
            }).catch(function(e){
                defer.reject();
            });
            return defer.promise;
    };

    this.gitStashApply = function (_promiseDirectoryInfo, branchForStash, currentBranch) {
        var defer = ZHPromise.defer();
        var directories;
        var promiseDirectory = _promiseDirectoryInfo;
        _promiseDirectoryInfo()
            .then(function (_directories) {
                directories = _directories;
                return _checkoutAndPullMasterInRepositories(_directories);
            }).then(function () {
                return _checkoutAndPullBranchInRepositories(directories, branchForStash);
            }).then(function () {
                return _stashApplyInRepositories(directories);
            }).then(function () {
                return _addFilesInRepoistories(directories);
            }).then(function () {
                return _commitInRepoistories(directories);
            }).then(function () {
                return _pullBranchPullMasterPushInRepositories(directories, branchForStash);
            }).then(function () {
                return _checkoutAndPullBranchInRepositories(directories, currentBranch);
            }).then(function (e) {
                defer.resolve({});
            }).catch(function (e) {
                defer.reject();
            });

        return defer.promise;
    };

    var _gitStashWithBranch = function(_promiseDirectoryInfo, taskBranchName, stashBranchName) {
        var defer = ZHPromise.defer();
        var resolve = function (success) { defer.resolve(success); };
        var reject = function (error) { defer.reject(error); };
        var functions = [];

        _promiseDirectoryInfo().then(function (_directories) {
            _directories.forEach(function (directory) {
                if (directory.files.length > 0) {
                    if (stashBranchName) {
                        directory.stashBranchName = stashBranchName;
                    }
                    functions.push(_stashWithBranch.bind(AppropriationService, directory, taskBranchName, directory.stashBranchName));
                }
            });

            Utilities.doSyncPm(functions)
                .then(resolve)
                .catch(reject);
        });

        return defer.promise;
    };

    var _resetFiles = function(directories){
        var defer = ZHPromise.defer();
        _arrayPromisefy(directories, _reset).then(function () {
            defer.resolve();
        }, function(){
            defer.resolve();
        });
        return defer.promise;
    };

    var _removeRemoteBranch = function(directory, branchName) {
        var defer = ZHPromise.defer();
        var resolve = function() { defer.resolve(); };

        setLogDescription(DESC_LOG_REMOVE_BRANCH.replace('%1', branchName).replace('%2', directory.repository));
        return Utilities.validateExecuteInWindows().then(function (isWindows) {
            directory.dir = isWindows ? directory.LOCAL_DIRECTORY : directory.LINUX_DIRECTORY;
            GitQueue.removeRemoteBranch(directory.dir, branchName)
                .progress(setLogValue)
                .error(resolve)
                .then(resolve);

            return defer.promise;
        });
    };

    var _addFilesInRepoistories = function (directories) {
        var defer = ZHPromise.defer();
        var reject = function(error) {
            if(error.data.indexOf('did not match any file') !== -1) {
                defer.resolve();
            } else {
                defer.reject(error);
            }
        };
        var resolve = function() {
            defer.resolve();
        };

        _arrayPromisefy(directories, _add)
            .then(resolve)
            .catch(reject);

        return defer.promise;
    };

    var _verifyRepositoryAndRemoveBranch = function (task, dir, resource, branchName) {
        return verifyChangedRepositoryTask(task, dir.ID, resource).then(function (validation) {
            if (dir.files.length > 0 || validation)
                return _removeRemoteBranch(dir, branchName);
        });
    };

    var _removeRemoteBranchInRepositories = function(directories, branchName, task, resource, replication) {
        var defer = ZHPromise.defer();
        var resolve = function (success) { defer.resolve(success); };
        var reject = function (error) { defer.reject(error); };
        var functions = [];

        directories.forEach(function (dir) {
            if (replication) {
                functions.push(_removeRemoteBranch.bind(AppropriationService, dir, branchName));
            } else if (task) {
                functions.push(_verifyRepositoryAndRemoveBranch.bind(AppropriationService, task, dir, resource, branchName));
            } else {
                if (dir.files.length > 0)
                    functions.push(_removeRemoteBranch.bind(AppropriationService, dir, branchName));
            }
        });

        Utilities.doSyncPm(functions)
            .then(resolve)
            .catch(reject);

        return defer.promise;
    };

    var getStatusFiles = function (status) {
        var files = status.split('\n');
        files = files.map(function(file){
            return decodeFile(file);
        });
        return files.filter(function(file){
            return file.FILE_NAME !== "";
        });
    };

    var decodeFile = function (file) {
        file = file.trim();
        var status = file.substr(0,file.indexOf(' '));
        var name  = file.substr(file.indexOf(' ')+1);
        return {
            FILE_NAME: name.replace(/\"/g,''),
            FILE_STATUS: GIT[status],
            FILE_STATUS_MIN: status
        };
    };

    this.getCurrentBranch = function(){
        return GitQueue.currentBranch();
    };

    var _checkExistsBranch = function(directories, branchToVerify) {
        var defer = ZHPromise.defer();
        var resolve = function (success) { defer.resolve(success); };
        var reject = function (error) { defer.reject(error); };
        var directoriesWithValidation = [];

        var validateExistsBranch = function (dir) {
            var deferBranch = ZHPromise.defer();
            var resolveBranch = function (success) { deferBranch.resolve(success); };
            var rejectBranch = function (error) { deferBranch.reject(error); };
            dir.branchExists = false;

            setLogDescription(DESC_LOG_BRANCH.replace('%2', dir.repository));
            setLogDescription(DESC_LOG_BRANCH_EXEC);
            execGitBranch(dir.dir)
                .then(function (branches) {
                    branches.forEach(function (branch) {
                        if (branch == branchToVerify) {
                            dir.branchExists = true;
                        }
                    });
                    directoriesWithValidation.push(dir);
                    resolveBranch();
                }).catch(rejectBranch);

            return deferBranch.promise;
        };

        var functions = [];
        directories.forEach(function (dir) {
            functions.push(validateExistsBranch.bind(_checkExistsBranch, dir));
        });

        Utilities.doSyncPm(functions)
            .then(function() {
                directoriesWithValidation = directoriesWithValidation.filter(function(dir) {
                    return dir.branchExists;
                });
                resolve(directoriesWithValidation);
            })
            .catch(reject);

        return defer.promise;
    };

    var execGitBranch = function (path) {
        var defer = ZHPromise.defer();
        var reject = function (error) {
            defer.reject(error);
        };
        var resolve = function (success) {
            defer.resolve(success);
        };

        if(self.gitBranchResult.hasOwnProperty(path)) {
            resolve(self.gitBranchResult[path]);
        } else {
            GitQueue.branch(path)
                .error(reject)
                .then(function(branches) {
                    self.gitBranchResult[path] = branches;
                    resolve(branches);
                });
        }

        return defer.promise;
    };

    this.checkExistsBranch = function(path, branchToVerify) {
        var defer  = ZHPromise.defer();
        var reject = function (error) {
            defer.reject(error);
        };

        execGitBranch(path)
            .then(function(branches) {
                var result = branches.indexOf(branchToVerify) != -1;
                defer.resolve(result);
            }).catch(reject);

        return defer.promise;
    };

    this.listBranches = function(paths) {
        var defer  = ZHPromise.defer();
        var reject = function (error) {
            defer.reject(error);
        };

        var branchesList = [];

        var listBranchPromises = paths.map(function(path){
            return execGitBranch(path)
                .then(function(branches) {
                    branches.forEach(function(branch){
                        if(branchesList.indexOf(branch) == -1)
                            branchesList.push(branch);
                    });
                }).catch(reject);
        });

        ZHPromise.all(listBranchPromises).then(function(){
            defer.resolve(branchesList);
        }).catch(function(e){
            reject(e);
        });

        return defer.promise;

    };

    this.gitPullAndRemove = function(directories, branchName){

        var promises = directories.map(function (directory) {
            var deferPullAndRemove = ZHPromise.defer();
            var reject = function(error){
                deferPullAndRemove.reject(error);
            };
            var resolve = function() {
                deferPullAndRemove.resolve();
            };

            GitQueue.pull(directory.dir, branchName)
                .then(function(){
                    return GitQueue.removeRemoteBranch(directory.dir, branchName);
                })
                .error(reject)
                .then(resolve);

            return deferPullAndRemove.promise;
        });

        return ZHPromise.all(promises);
    };

    this.gitStashApplyWithBranch = function(directories, stashBranchName) {
        return _checkExistsBranch(directories, stashBranchName).then(function (directoriesFiltered) {
            var promises = directoriesFiltered.map(function (directory) {
                var defer = ZHPromise.defer();
                var reject = function (error) {
                    defer.reject(error);
                };
                var resolve = function () {
                    defer.resolve();
                };

                GitQueue.pullNoCommit(directory.dir, stashBranchName)
                    .then(function () {
                        return GitQueue.removeRemoteBranch(directory.dir, stashBranchName);
                    })
                    .then(resolve)
                    .catch(reject);

                return defer.promise;
            });

            return ZHPromise.all(promises);
        });
    };

    this.removeRemoteBranchesMR = function(directories, branchName) {
        var defer = ZHPromise.defer();
        var resolve = function (success) { defer.resolve(success); };
        var reject = function (error) { defer.reject(error); };
        var functions = [];

        directories.forEach(function (dir) {
            functions.push(_removeRemoteBranch.bind(AppropriationService, dir, branchName));
        });

        Utilities.doSyncPm(functions)
            .then(resolve)
            .catch(reject);

        return defer.promise;
    };

    this.setHourAppropriation = function(newAppropriation,useTimePlanning){
        this.getBeginHourAppropriation().then(function(beginDateString){
            if(beginDateString){
                var endDateString = Utilities.getCurrentDateAndHour();
                var hour = Utilities.dataManager.diffDateAppropriationInHHmm(beginDateString,endDateString);
                if(useTimePlanning == 'Y'){
                    newAppropriation.getField('END_HOUR').value(endDateString);
                }else{
                    beginDateString = beginDateString.split(' ')[0];
                }
                newAppropriation.getField('BEGIN_HOUR').value(beginDateString);
                newAppropriation.getField('TOTAL').value(hour);
            }
        });

    };

    this.getBeginHourAppropriation = function(){
        var filter = [
            {
                "operator": "=",
                "name": "TASK",
                "value": Utilities.localVar.getLocalVarTaskId()
            }
        ];

        return requestDataSourceEngine.getDataSource('/getBeginHourAppropriation', filter).then(function(data) {
            return data.dataset.dataBeginAppropriation.PLAY_DATE;
        });
    };

    /************************************************************
     * Hides or shows percent field in appropriation swipe when
     * the task being appropriated can not be finished.
     * @param field
     ************************************************************/
    this.manipulatePercentFieldByAllowEndTask = function(field){
        if(!Util.isObject(field)) return Utilities.buildErrorMessage.invalidArgument(REGISTERED_NAME, "manipulatePercentFieldByAllowEndTask", "field object", field, "1st");
        field.isVisible = (Utilities.localVar.getClickedProjectAllowEndTasks() !== 'N');
    };

    /************************************************************
     * Hides or shows end hour field in appropriations swipe
     * when the task being appropriated does not use time planning.
     * @param field
     ************************************************************/
    this.manipulateEndHourFieldByUseTimePlanning = function(field){
        if(!Util.isObject(field)) return Utilities.buildErrorMessage.invalidArgument(REGISTERED_NAME, "manipulateEndHourFieldByUseTimePlanning", "field object", field, "1st");
        field.isVisible = (Utilities.localVar.getClickedProjectUseTimePlanning() !== 'N');
    };

    /************************************************************
     * Manipulates begin hour field in appropriations swipe when
     * the task being appropriated does not use time planning.
     * @param field
     ************************************************************/
    this.manipulateBeginHourFieldByUseTimePlanning = function(field, onlyChangeLabel){
        onlyChangeLabel = onlyChangeLabel || false;
        if(!Util.isObject(field)) return Utilities.buildErrorMessage.invalidArgument(REGISTERED_NAME, "manipulateBeginHourFieldByUseTimePlanning", "field object", field, "1st");
        if(typeof(onlyChangeLabel) !== 'boolean') return Utilities.buildErrorMessage.invalidArgument(REGISTERED_NAME, "manipulateBeginHourFieldByUseTimePlanning", "boolean", field, "2st");

        if(onlyChangeLabel){
            if(Utilities.localVar.getClickedProjectUseTimePlanning() === 'N') {
                field.label = 'Data da apropriação';
                field.template = "field/calendar.html";
                field['datetime-preset'] = 'date';
                field.displayFormat = "DD/MM/YYYY";
                return true;
            } else {
                field.label = 'Início';
                field.template = "field/datetime.html";
                field['datetime-preset'] = 'datetime';
                field.displayFormat = "DD/MM/YYYY hh:mm";
            }
        }
        field.isVisible = (Utilities.localVar.getClickedProjectUseTimePlanning() !== 'N');
    };

    /************************************************************
     * Manipulates duration field in task basic info swipe when
     * the task being appropriated does not use time planning.
     * @param field
     ************************************************************/
    this.manipulateDurationFieldByUseTimePlanning = function(field){
        if(!Util.isObject(field)) return Utilities.buildErrorMessage.invalidArgument(REGISTERED_NAME, "manipulateDurationFieldByUseTimePlanning", "field object", field, "1st");
        field.isVisible = (Utilities.localVar.getClickedProjectUseTimePlanning() !== 'N');
    };

    /************************************************************
     * Shows or hides the columns of appropriations list when the
     * task does not use time planning.
     * @param fields
     ************************************************************/
    this.hideAppropriationColumnsByTimePlanning = function(fields) {
        if(!Util.isArray(fields)) return Utilities.buildErrorMessage.invalidArgument(REGISTERED_NAME, "hideAppropriationColumnsByTimePlanning", "array of fields", fields[0], "1st");
        var time = Utilities.localVar.getClickedProjectUseTimePlanning();
        fields.forEach(function(field){
            field.isVisible = (time !== 'N');
        });
    };

    /************************************************************
     * Shows or hides the columns of appropriations list when the
     * task can not be finished.
     * @param fields
     ************************************************************/
    this.hideAppropriationColumnsByAllowEndTasks = function(fields){
        if(!Util.isArray(fields)) return Utilities.buildErrorMessage.invalidArgument(REGISTERED_NAME, "hideAppropriationColumnsByTimePlanning", "array of fields", fields[0], "1st");
        var allow = Utilities.localVar.getClickedProjectAllowEndTasks();
        fields.forEach(function(field){
            field.isVisible = (allow !== 'N');
        });
    };

    /************************************************************
     * Changes the begin hour column name of appropriations list
     * when the task does not have time planning.
     * @param field
     ************************************************************/
    this.changeLabelAppropriationBeginHourColumnByTimePlanning = function(field){
        if(!Util.isObject(field)) return Utilities.buildErrorMessage.invalidArgument(REGISTERED_NAME, "changeLabelAppropriationBeginHourColumnByTimePlanning", "field object", field, "1st");
        if(Utilities.localVar.getClickedProjectUseTimePlanning() === 'N'){
            field.label = "Data da apropriação";
            field.template = "field/calendar.html";
        } else {
            field.label = "Início";
            field.temmplate = "field/datetime.html";
        }
        field.dateFormat = 'DD/MM/YYYY';
    };

    /************************************************************
     * Appropriation widgets has some fields like "Task name" that
     * are being appropriated. This function applies values to them
     * getting it from Local Storage.
     ************************************************************/
    this.applyProjectAndTaskInfoInNewAppropriationWidget = function(projectIdField, projectNameField, taskNameField){
        projectIdField  .value(Utilities.localVar.getClickedProjectId());
        projectNameField.value(Utilities.localVar.getClickedProjectName());
        taskNameField   .value(Utilities.localVar.getClickedTaskName());
    };

    this.createTaskBranchInDevOps = function(taskId, infoTaskRow, forceCreateBranch) {
        if(infoTaskRow.MR_GENERATED_BY_REPLICATION == 'Y' && !infoTaskRow.PRODUCT_VERSION_ID && !infoTaskRow.ORIGIN_PRODUCT_VERSION_ID_DEV) {
            return ZHPromise.when();
        } else {
            var rows = [{
                TASK: taskId,
                CURRENT_TASK_ID: infoTaskRow.TASK_ID,
                ORIGIN_PRODUCT_VERSION_ID: infoTaskRow.ORIGIN_PRODUCT_VERSION_ID_DEV,
                SUBRELEASE: infoTaskRow.SUBRELEASE_ID,
                changed: true,
                forceCreateBranch: forceCreateBranch
            }];

            return requestDataSourceEngine.setDataSource('/createTaskBranchInDevOps', rows);
        }
    };

    this.setDefaultMergeRequestDescription = function (descriptionField, branchToMerge, isSetEmptyDescription, newAppropriationWidget, firstTaskResponse) {
        if(isSetEmptyDescription) {
            var description = newAppropriationWidget.oldDescriptionFieldAppropriation || '';
            descriptionField.value(description);
        } else {
            descriptionField.value(firstTaskResponse);
        }
    };

    this.manipulateMobileTotalField = function(field) {
        if(Util.isMobile()) {
            field.template = 'field/datetime.html';
            field['datetime-preset'] = "time";
            field['datetime-maxDate'] = "2100-01-01 23:59";
            field['datetime-minDate'] = "1900-01-01 00:00";
            templateManager.updateTemplate();
        }
    };

    this.duplicateChangedFilesForNewTask = function(taskId, newTaskId, typeRelationship) {
        var params = [ {
            TASK_ID: taskId,
            NEW_TASK_ID: newTaskId,
            TYPE_RELATIONSHIP: typeRelationship,
            changed: true
        } ];

        return requestDataSourceEngine.setDataSource('/duplicateChangedFilesForNewTask', params);
    };

    this.validateCurrentBranch = function(directories, taskInfo) {
        var defer = ZHPromise.defer();
        var resolve = function () { defer.resolve(dirNotTaskBranch); };
        var reject = function (error) { defer.reject(error); };
        var functions = [];
        dirNotTaskBranch = [];

        directories.forEach(function (dir) {
            functions.push(_validateCurrentBranch.bind(AppropriationService, dir, taskInfo));
        });

        Utilities.doSyncPm(functions)
            .then(resolve)
            .catch(reject);

        return defer.promise;
    };

    this.saveMultipleTasks = function(row) {
        return requestDataSourceEngine.setDataSource('/saveMultipleProjectTask', [row]);
    };

    this.isTagMainBranch = function() {
        return !MAIN_BRANCHES.includes(MAIN_BRANCH);
    };
}
Configuration(function(ContextRegister) {
    ContextRegister.register('AppropriationService', AppropriationService);
});

// FILE: assets/js/Service/Calendar.js
/**
 * Created by tuliomagalhaes on 30/06/14.
 */

function CalendarService(requestDataSourceEngine,CalendarExceptionListRepository,ScreenService,templateManager, Utilities){


    this.entity = null;
    this.editRow = null;
    this.windowBack = null;
    this.businessPartner = null;
    this.asset = null;
    this.cost = null;
    var self = this;
    var DEFAULT_WEEK_NAME = 'Padrão';

    this.onEnterCalendar = function(args){
        args.owner.getWidget('CALENDAR').newRow();
        if(this.editRow){
            args.owner.getWidget('CALENDAR').currentRow = this.editRow;

        }
    };

    this.copyHolidayToNewCalendar = function(checkedrows, ids){
        var row = [{
            selectedHolidays: checkedrows,
            calendarReceiverId: ids,
            changed: true
        }];
        return requestDataSourceEngine.setDataSource("/copyCalendarDetail", row);
    };

    this.copWorkWeekToNewCalendar = function(checkedrows, ids){
        var row = [{
            selectedWeeks: checkedrows,
            calendarReceiverId: ids,
            changed: true
        }];
        return requestDataSourceEngine.setDataSource("/copyWeek", row);
    };

    this.saveCalendar = function(args){
        var idEntity = getLocalVar(this.entity.toLowerCase());
        var loginInfo = getLocalVar("login");
        var row = args.row;
        row.ORGANIZATION = loginInfo[0].organization;
        row.USER = loginInfo[0].idBusinessPartner;
        row.ID = idEntity;
        row.BUSINESS_PARTNER = this.businessPartner;
        row.ASSET = this.asset;
        row.COST = this.cost;
        row.ENTITY = this.entity;
        row.changed = true;
        requestDataSourceEngine.setDataSource('/saveEditCalendar',[row]).then(function(data){
            self.backWindow();
        });
    };

    this.backWindow = function(){
        openWindow(self.windowBack);
        self.entity = null;
        self.editRow = null;
        self.windowBack = null;
        self.businessPartner = null;
        self.asset = null;
        self.cost = null;

    };

    function gethourByString(strDate){
        var date = moment(strDate);
        return date.format('HH:mm');
    }

    this.setImportEdit=function(args){
        var data = args.owner.field.dataSource.data;
        var rowCurrent=args.row;
        if(rowCurrent.IMPORT)
        {
            rowCurrent.BEGIN_WEEK = "";
            rowCurrent.BEGIN_WEEK_NAME = "";
            rowCurrent.END_WEEK = "";
            rowCurrent.END_WEEK_NAME = "";
            rowCurrent.HOUR = "";
            rowCurrent.NAME = "";
            rowCurrent.BEGIN_HOUR = "";
            rowCurrent.END_HOUR = "";
            rowCurrent.MONTHLY_DAYS = "";
            rowCurrent.WEEKLY_HOURS = "";
        }
        data.forEach(function(row) {
            if(row.id == parseInt(rowCurrent.IMPORT))
            {
                rowCurrent.BEGIN_WEEK = row.beginWeek;
                args.owner.field.widget.getField('BEGIN_WEEK_NAME').dataSource.data.forEach(function(weekDay){
                    if(weekDay.VALUE === row.beginWeek){
                        rowCurrent.BEGIN_WEEK_NAME = weekDay.NAME;
                    }
                });
                rowCurrent.END_WEEK = row.endWeek;
                args.owner.field.widget.getField('END_WEEK_NAME').dataSource.data.forEach(function(weekDay){
                    if(weekDay.VALUE === row.endWeek){
                        rowCurrent.END_WEEK_NAME = weekDay.NAME;
                    }
                });
                rowCurrent.HOUR = row.hour;
                rowCurrent.NAME = row.name;
                rowCurrent.STATUS = 'A';
                rowCurrent.BEGIN_HOUR = gethourByString(row.beginHour.date);
                rowCurrent.END_HOUR = gethourByString(row.endHour.date);
                rowCurrent.MONTHLY_DAYS = row.monthlyDays;
                rowCurrent.WEEKLY_HOURS = row.weeklyHours;


            }
        });
    } ;
    this.setImport=function(args){
        var data = args.owner.field.dataSource.data;
        var rowCurrent=args.row;
        var widget=  args.owner.field.getParent().container.getWidget('LIST_EXCEPTION');
        if(rowCurrent.IMPORT === "")
        {
            rowCurrent.BEGIN_WEEK = "";
            rowCurrent.END_WEEK = "";
            rowCurrent.HOUR = "";
            rowCurrent.NAME = "";
            rowCurrent.STATUS = "";
            CalendarExceptionListRepository.clearRepository().then(
                widget.reload()
            );
        }
        data.forEach(function(row) {
            if(row.id == parseInt(rowCurrent.IMPORT))
            {
                rowCurrent.BEGIN_WEEK = row.beginWeek;
                rowCurrent.END_WEEK = row.endWeek;
                rowCurrent.HOUR = row.hour;
                rowCurrent.NAME = row.name;
                rowCurrent.STATUS = 'A';
                CalendarExceptionListRepository.clearRepository().then(
                    CalendarExceptionListRepository.save(row.exception)
                        .then(function(){
                            widget.reload();
                        }
                    )
                );
            }
        });
    };

    //novo calendário

    var WORK = 'W';
    var DAY_OFF = 'O';
    var NEW_EXCEPTION_DAILY = 'D';
    var NEW_EXCEPTION_WEEKLY = 'W';
    var NEW_EXCEPTION_MONTHLY = 'M';
    var NEW_EXCEPTION_YEARLY = 'Y';
    var CONTROL_NEW_EXCEPTION_FIELDS = ['D', 'W', 'M', 'Y'];
    var dateDefaultFormat = 'DD/MM/YYYY';
    var addDaysDefaultFormat = 'days';
    var addWeeksDefaultFormat = 'weeks';




    var getFieldIdFromCalendarListWidget = function (widgetCalendarList) {
        return widgetCalendarList.getField('ID');
    };

    var getFieldYearDayFromNewExceptionWidget = function (widgetNewException) {
        return widgetNewException.getField('YEAR_DAY');
    };
    var getFieldYearDayExceptionYearFromNewExceptionWidget = function (widgetNewException) {
        return widgetNewException.getField('YEAR_DAY_EXCEPTION_YEAR');
    };
    var getFieldYearDayExceptionMonthFromNewExceptionWidget = function (widgetNewException) {
        return widgetNewException.getField('YEAR_DAY_EXCEPTION_MONTH');
    };
    var getFieldRecurrenceTypeFromNewExceptionWidget = function (widgetNewException) {
        return widgetNewException.getField('RECURRENCE_TYPE');
    };
    var getFieldTypeFromNewExceptionWidget = function (widgetNewException) {
        return widgetNewException.getField('TYPE');
    };
    var getFieldWeekDayExceptionYearFromNewExceptionWidget = function (widgetNewException) {
        return widgetNewException.getField('WEEK_DAY_EXCEPTION_YEAR');
    };
    var getFieldWeekDayExceptionMonthFromNewExceptionWidget = function (widgetNewException) {
        return widgetNewException.getField('WEEK_DAY_EXCEPTION_MONTH');
    };
    var getFieldExceptionDataEndFromNewExceptionWidget = function (widgetNewException) {
        return widgetNewException.getField('EXCEPTION_DATA_END');
    };
    var getFieldExceptionQuantitativeFromNewExceptionWidget = function (widgetNewException) {
        return widgetNewException.getField('EXCEPTION_QUANTITATIVE');
    };
    var getFieldBeginDateFromNewExceptionWidget = function (widgetNewException) {
        return widgetNewException.getField('BEGIN_DATE');
    };
    var getFieldEndDateFromNewExceptionWidget = function (widgetNewException) {
        return widgetNewException.getField('END_DATE');
    };
    var getFieldOccurrencesFromNewExceptionWidget = function (widgetNewException) {
        return widgetNewException.getField('OCCURRENCES');
    };
    var getFieldEveryFromNewExceptionWidget = function (widgetNewException) {
        return widgetNewException.getField('EVERY');
    };
    var getFieldMonthlyDayFromNewExceptionWidget = function (widgetNewException) {
        return widgetNewException.getField('MONTHLY_DAY');
    };
    var getFieldOrderDayMonthFromNewExceptionWidget = function (widgetNewException) {
        return widgetNewException.getField('ORDER_DAY_MONTH');
    };
    var getFieldOrderDayYearFromNewExceptionWidget = function (widgetNewException) {
        return widgetNewException.getField('ORDER_DAY_YEAR');
    };
    var getFieldWeekDayFromNewExceptionWidget = function (widgetNewException) {
        return widgetNewException.getField('WEEK_DAY');
    };

    this.calendarStyles = function (element, row) {
    };

    var  __setVisibleInNewCalendar = function(isNew,widgetCalendar,widgetExceptionList,widgetHourWeekList) {
        widgetCalendar.isVisible = !isNew;
        widgetExceptionList.isVisible = !isNew;
        if (widgetHourWeekList){
            widgetHourWeekList.isVisible = !isNew;
        }
    };

    this.calendarListActionEventNew = function (widgetCalendarList,widgetCalendar,widgetExceptionList) {
        Utilities.localVar.setCalendarId(0);
        widgetCalendarList.newRow();
        __setVisibleInNewCalendar(true,widgetCalendar,widgetExceptionList);
    };

    this.calendarListActionEventDelete = function (widgetCalendarList) {
        widgetCalendarList.unSelectAll();
        widgetCalendarList.dataSource.checkedRows = widgetCalendarList.currentRow;
        widgetCalendarList.removeCheckedRows();
        ScreenService.closeSwipe();
    };

    this.calendarListActionEventEdit = function (widgetCalendarList,widgetCalendar,widgetExceptionList,widgetHourWeekList) {
        __setVisibleInNewCalendar(true,widgetCalendar,widgetExceptionList,widgetHourWeekList);
        widgetCalendarList.edit();
    };

    this.calendarListActionEventCancel = function (widgetCalendarList) {
        __goBackToCalendarList(widgetCalendarList);
    };

    this.calendarListActionEventCancelForm = function (widgetCalendarList) {
        __goBackToCalendarList(widgetCalendarList);
    };
    this.calendarListWidgetAfterMoveRow = function (widgetCalendarList,widgetCalendar,widgetExceptionList, widgetHourWeekList) {
        __setVisibleInNewCalendar(false,widgetCalendar,widgetExceptionList,widgetHourWeekList);
        Utilities.localVar.setCalendarId(getFieldIdFromCalendarListWidget(widgetCalendarList).value());
    };
    var  __goBackToCalendarList = function(widgetCalendarList) {
        widgetCalendarList.currentWidget = widgetCalendarList;
        ScreenService.goBack();
        widgetCalendarList.activate();
        widgetCalendarList.reload();
        widgetCalendarList.list();
    };

    this.calendarActionEventCancel = function (widgetCalendarList) {
        __goBackToCalendarList(widgetCalendarList);
    };

    this.calendarListActionEventSave = function (widgetCalendarList, widgetCalendar,widgetExceptionList) {
        if (!widgetCalendarList.isValid()) {
            ScreenService.showMessage(Utilities.messages.ERR_REQUIRED_FIELDS);
            return false;
        }
        widgetCalendarList.saveRow().then(function (response) {
            widgetCalendarList.currentRow.ID = response.dataset.defaultCalendar.ID;
            widgetCalendarList.currentRow.__is_new = false;
            ScreenService.showLoader();
            widgetCalendarList.reload().then(function () {
                ScreenService.hideLoader();
                widgetCalendarList.view();
            }).catch(ScreenService.hideLoader);
            __setVisibleInNewCalendar(false,widgetCalendar,widgetExceptionList);
            Utilities.localVar.setCalendarId(response.dataset.defaultCalendar.ID);
        });
    };
    
    // fuctions for exception
    this.exceptionListActionEventCancel = function (widgetCalendarList) {
        __goBackToCalendarList(widgetCalendarList);
    };
    
    var __setDateTodayDefault = function (fields) {
        var today = moment();
        fields.filter(function (field) {
            return field.defaultDateToday;
        }).forEach(function (field) {
            if (!field.value()) {
                var format = field["datetime-dateFormat"];
                if (!format) {
                    format = "DD/MM/YYYY";
                } else {
                    format = Utilities.getFormatMomentByFormatMobicroll(format);
                }
                field.value(today.format(format));
            }
        });
    };
    var __setValueDefault = function (fields) {
        fields.forEach(function (field) {
            if (!field.value() && field.defaultValue) {
                field.value(field.defaultValue);
            }
        });
    };

    this.exceptionListActionEventNew = function (widgetTabbedException,widgetNewException) {
        widgetNewException.dataSource.data = [];
        widgetNewException.newRow();
        widgetNewException.currentRow.EDIT = true;
        widgetNewException.template = widgetNewException.formTemplate;
        __setDateTodayDefault(widgetNewException.fields);
        __setFieldsByExceptionType(getFieldRecurrenceTypeFromNewExceptionWidget(widgetNewException),widgetNewException);
        widgetNewException.activate();
        self.readOnlyException(getFieldYearDayExceptionYearFromNewExceptionWidget(widgetNewException), getFieldWeekDayExceptionYearFromNewExceptionWidget(widgetNewException),widgetNewException);
        self.readOnlyException(getFieldExceptionDataEndFromNewExceptionWidget(widgetNewException), getFieldExceptionQuantitativeFromNewExceptionWidget(widgetNewException),widgetNewException);
        ScreenService.openSwipe(widgetTabbedException);
        widgetTabbedException.formTemplate = widgetTabbedException.template;
    };
    var clearException = function (widgetNewException) {
        var fieldGroupsControl = widgetNewException.fieldGroups.filter(function (fieldGroup) {
            return CONTROL_NEW_EXCEPTION_FIELDS.indexOf(fieldGroup.control) > -1;
        });
        widgetNewException.fields.forEach(function (field) {
            if (fieldGroupsControl.indexOf(field.fieldGroup) > -1) {
                field.validations = false;
            }
        });
    };

    var __setFieldsByExceptionType = function (recurrenceField,widgetNewException) {
        var recurrence = recurrenceField.value();
        var fieldGroup = null;
        if (!recurrence) {
            recurrenceField.value(NEW_EXCEPTION_DAILY);
            recurrence = NEW_EXCEPTION_DAILY;
        }
        widgetNewException.fieldGroups.forEach(function (group) {
            if (group.control == recurrence) {
                group.isVisible = true;
                fieldGroup = group;
            } else if (group.control) {
                group.isVisible = false;
            }
        });
        clearException(widgetNewException);

        var fields = widgetNewException.fields.filter(function (field) {
            return field.fieldGroup == fieldGroup.name;
        });
        fields.forEach(function (field) {
            if (field.isRequiredWhenExceptionPM) {
                field.validations = {"required": {}};
            }
        });
        if (fieldGroup.control == NEW_EXCEPTION_MONTHLY || fieldGroup.control == NEW_EXCEPTION_YEARLY) {
            var weekField = null;
            var yearField = null;
            if(fieldGroup.control == NEW_EXCEPTION_MONTHLY ){
                weekField = getFieldWeekDayExceptionMonthFromNewExceptionWidget(widgetNewException);
                yearField = getFieldYearDayExceptionMonthFromNewExceptionWidget(widgetNewException);
            }else {
                weekField = getFieldWeekDayExceptionYearFromNewExceptionWidget(widgetNewException);
                yearField = getFieldYearDayExceptionYearFromNewExceptionWidget(widgetNewException);
            }
            if (weekField.value() == 'Y') {
                __setReadOnlyWithValidateBySubGroups(yearField.name, weekField.name, widgetNewException, fieldGroup.name);
            } else {
                __setReadOnlyWithValidateBySubGroups(weekField.name, yearField.name, widgetNewException, fieldGroup.name);
            }
        }
    };

    this.exceptionListFieldOnChangeRecurrenceType = function (recurrenceField,widgetNewException) {
        __setFieldsByExceptionType(recurrenceField,widgetNewException);
    };

    var __setVisibleWorkTime = function (type,widgetNewException) {
        widgetNewException.fieldGroups.forEach(function (group) {
            if (group.name == 'WORKTIME') {
                if (type == WORK) {
                    group.isVisible = true;
                } else {
                    group.isVisible = false;
                }
            }
        });
    };

    this.newExceptionFieldOnChangeBeginDate = function (widgetNewException) {
        var fieldYearDay = getFieldYearDayFromNewExceptionWidget(widgetNewException);
        var fieldEndDate = getFieldEndDateFromNewExceptionWidget(widgetNewException);
        var fieldBeginDate = getFieldBeginDateFromNewExceptionWidget(widgetNewException);
        var beginDate = moment(fieldBeginDate.value(),Utilities.FORMAT_DATE_DEFAULT_ONLY_DATE);
        fieldYearDay.setValue(beginDate.format(Utilities.getFormatMomentByFormatMobicroll(fieldYearDay['datetime-dateFormat'])));
        fieldEndDate.setValue(fieldBeginDate.value());

    };
    this.exceptionListFieldOnChangeType = function (type,widgetNewException) {
        __setVisibleWorkTime(type,widgetNewException);
    };
    this.newExceptionActionEventCancelForm = function (widgetExceptionList) {
        ScreenService.goBack();
        widgetExceptionList.activate();
        widgetExceptionList.list();
    };

    this.newExceptionActionEventCancel = function (newExceptionWidget,exceptionListWidget) {
        Utilities.genericCancelEvent(newExceptionWidget);
        if(newExceptionWidget.currentRow.__is_new){
            exceptionListWidget.activate();
        }else {
            newExceptionWidget.template = newExceptionWidget.templateToView;
        }
    };

    var __setReadOnlyWithValidateBySubGroups = function (groupReadOnly, groupNotReadOnly, widget, validate) {
        widget.fields.forEach(function (field) {
            if (field.subGroup == groupNotReadOnly) {
                field.readOnly = false;
                if (validate && validate == field.fieldGroup) {
                    field.validations = {"required": {}};
                }
            } else if (field.subGroup == groupReadOnly) {
                field.readOnly = true;
                if (validate && validate == field.fieldGroup) {
                    field.validations = false;
                }
            }
        });
    };
    var __checkedCheckbox = function (field) {
        if (field.valueToTrue == field.value()) {
            field.checked = true;
        } else {
            field.checked = false;
        }
    };
    this.readOnlyException = function (fieldOrigin, fieldOther,widgetNewException) {

        if (fieldOrigin.value() == 'Y') {
            __setReadOnlyWithValidateBySubGroups(fieldOther.name, fieldOrigin.name, widgetNewException, fieldOrigin.fieldGroup);
            fieldOther.value('N');
        } else {
            if (fieldOther.value() == 'N') {
                fieldOrigin.value('Y');
            }
        }
        __checkedCheckbox(fieldOrigin);
        __checkedCheckbox(fieldOther);
    };

    this.exceptionListFieldOnChangeYearDayExceptionYear = function (yearField,widgetNewException) {
        var name = getFieldWeekDayExceptionYearFromNewExceptionWidget(widgetNewException).name;
        var weekField = widgetNewException.fields.filter(function (item) {
            return (item.name === name && item.fieldGroup == yearField.fieldGroup);
        })[0];
        self.readOnlyException(yearField, weekField,widgetNewException);

    };
    this.exceptionListFieldOnChangeYearDayExceptionMonth = function (yearField,widgetNewException) {
        var name = getFieldWeekDayExceptionMonthFromNewExceptionWidget(widgetNewException).name;
        var weekField = widgetNewException.fields.filter(function (item) {
            return (item.name === name && item.fieldGroup == yearField.fieldGroup);
        })[0];
        self.readOnlyException(yearField, weekField,widgetNewException);

    };
    this.exceptionListFieldOnChangeWeekDayExceptionYear = function (weekField,widgetNewException) {
        var name = getFieldYearDayExceptionYearFromNewExceptionWidget(widgetNewException).name;
        var yearField = widgetNewException.fields.filter(function (item) {
            return (item.name === name && item.fieldGroup == weekField.fieldGroup);
        })[0];
        self.readOnlyException(weekField, yearField,widgetNewException);

    };
    this.exceptionListFieldOnChangeWeekDayExceptionMonth = function (weekField,widgetNewException) {
        var name = getFieldYearDayExceptionMonthFromNewExceptionWidget(widgetNewException).name;
        var yearField = widgetNewException.fields.filter(function (item) {
            return (item.name === name && item.fieldGroup == weekField.fieldGroup);
        })[0];
        self.readOnlyException(weekField, yearField,widgetNewException);

    };
    this.exceptionListFieldOnChangeExceptionQuantitative = function (widgetNewException) {
        var dataEndField = getFieldExceptionDataEndFromNewExceptionWidget(widgetNewException);
        var quantitativeField = getFieldExceptionQuantitativeFromNewExceptionWidget(widgetNewException);
        getFieldEndDateFromNewExceptionWidget(widgetNewException).value(null);
        self.readOnlyException(quantitativeField, dataEndField, widgetNewException);

    };
    this.exceptionListFieldOnChangeExceptionDataEnd = function (widgetNewException) {
        var dataEndField = getFieldExceptionDataEndFromNewExceptionWidget(widgetNewException);
        var quantitativeField = getFieldExceptionQuantitativeFromNewExceptionWidget(widgetNewException);
        getFieldOccurrencesFromNewExceptionWidget(widgetNewException).value(null);
        self.readOnlyException(dataEndField, quantitativeField,widgetNewException);

    };
    var __setMonthAndYearException = function(yearDayExceptionField,WeekDayExceptionField,OrderDayException){
        if(OrderDayException.value()){
            WeekDayExceptionField.value('Y');
            yearDayExceptionField.value('N');
        }else{
            WeekDayExceptionField.value('N');
            yearDayExceptionField.value('Y');
        }
    };
    this.setFieldsNewException = function (widgetNewException) {
        __setVisibleWorkTime(getFieldTypeFromNewExceptionWidget(widgetNewException).value(),widgetNewException);
        __setDateTodayDefault(widgetNewException.fields);
        __setMonthAndYearException(getFieldYearDayExceptionYearFromNewExceptionWidget(widgetNewException),
            getFieldWeekDayExceptionYearFromNewExceptionWidget(widgetNewException),
            getFieldOrderDayYearFromNewExceptionWidget(widgetNewException));
        __setMonthAndYearException(getFieldYearDayExceptionMonthFromNewExceptionWidget(widgetNewException),
            getFieldWeekDayExceptionMonthFromNewExceptionWidget(widgetNewException),
            getFieldOrderDayMonthFromNewExceptionWidget(widgetNewException));
        __setValueDefault(widgetNewException.fields);
        widgetNewException.activate();
        self.readOnlyException(getFieldYearDayExceptionYearFromNewExceptionWidget(widgetNewException), getFieldWeekDayExceptionYearFromNewExceptionWidget(widgetNewException),widgetNewException);
        self.readOnlyException(getFieldExceptionDataEndFromNewExceptionWidget(widgetNewException), getFieldExceptionQuantitativeFromNewExceptionWidget(widgetNewException),widgetNewException);
        __setFieldsByExceptionType(getFieldRecurrenceTypeFromNewExceptionWidget(widgetNewException),widgetNewException);
    };

    this.exceptionListWidgetAfterMoveRow = function (id,widgetTabbedException,widgetNewException) {
        Utilities.localVar.setCalendarExceptionId(id);
        var newExceptionWidget = widgetNewException;
        newExceptionWidget.list();
        ScreenService.showLoader();
        newExceptionWidget.reload().then(function () {
            ScreenService.hideLoader();
            newExceptionWidget.moveToFirst();
            self.setFieldsNewException(newExceptionWidget);
            widgetTabbedException.formTemplate = widgetTabbedException.template;
            ScreenService.openSwipe(widgetTabbedException).then(function () {
                newExceptionWidget.view();
                newExceptionWidget.template = newExceptionWidget.templateToView;
                templateManager.updateTemplate();
            });
        }).catch(ScreenService.hideLoader);
    };
    
    this.newExceptionActionEventSave = function (widgetNewException, widgetExceptionList) {
        var newExceptionWidget = widgetNewException;
        if (newExceptionWidget.isValid() && newExceptionWidget.currentRow.EDIT) {
            newExceptionWidget.currentRow.changed = true;
            newExceptionWidget.saveRow().then(function(response){
                var calendarDetailId = response.dataset.calendarDetail.ID;
                newExceptionWidget.currentRow.ID = calendarDetailId;
                ScreenService.showLoader();
                widgetExceptionList.reload().then(function(){
                    ScreenService.hideLoader();
                    widgetExceptionList.setCurrentRow(Utilities.getRowInDataSource(widgetExceptionList.dataSource, 'ID', calendarDetailId));
                    Utilities.fixWidgetToViewAfterSaveRow(widgetNewException);
                }).catch(ScreenService.hideLoader);
            });
        } else if(!newExceptionWidget.currentRow.EDIT){
            ScreenService.showMessage(Utilities.messages.ERRO_IN_EDIT_CALENDAR);
        }
    };
    
    this.newExceptionActionEventEdit = function (widgetNewException) {
        var newExceptionWidget = widgetNewException;
        if(newExceptionWidget.currentRow.EDIT){
            newExceptionWidget.edit();
            newExceptionWidget.template = newExceptionWidget.formTemplate;
        }else{
            ScreenService.showMessage(Utilities.messages.ERRO_IN_EDIT_CALENDAR);
        }
    };

    function add__is_newInAllRows(checkedRows) {
        return checkedRows.map(function (data) {
            if (!data.__is_new) {
                data.__is_new = false;
            }
            return data;
        });
    }

    this.validateDefaultWeekInCurrentRow = function(widget, isSave) {
        if(isSave) {
            return widget.currentRow.NAME != DEFAULT_WEEK_NAME || widget.currentRow.VALIDATION_NAME == DEFAULT_WEEK_NAME;
        }
        return widget.currentRow.NAME != DEFAULT_WEEK_NAME;
    };

    this.validateExistsDefaultWeekInDataSource = function(widget) {
        var validate = true;
        widget.dataSource.data.forEach(function(row) {
            if(row.NAME == DEFAULT_WEEK_NAME) {
                validate = false;
            }
        });
        return validate;
    };

    this.exceptionListActionEventDelete = function (widgetHourWeekList) {
        var exceptionListWidget = widgetHourWeekList;
        var checkedRows = [exceptionListWidget.currentRow];
        var exceptionCalendarBasic = checkedRows.filter(function(row){
            return !row.EDIT;
        });
        if(!exceptionCalendarBasic.length) {
            exceptionListWidget.dataSource.checkedRows = add__is_newInAllRows(checkedRows);
            widgetHourWeekList.removeCheckedRows();
            widgetHourWeekList.unSelectAll();
            ScreenService.closeSwipe().then(function(){
                widgetHourWeekList.list();
                widgetHourWeekList.activate();
            });
        }else{
            ScreenService.showMessage(Utilities.messages.ERRO_IN_EDIT_CALENDAR);
        }
    };

    this.exceptionListDeleteOnlyOneRow = function (listWidget, widgetForm){
        listWidget.unSelectAll();
        listWidget.dataSource.checkedRows = [widgetForm.currentRow];
        this.exceptionListActionEventDelete(listWidget);
        __goBackToCalendarList(listWidget);
        widgetForm.dataSource.clearCheckedRows();
    };


    //week
    this.hourWeekListActionEventCancel = function (widgetCalendarList) {
        __goBackToCalendarList(widgetCalendarList);
    };
    this.newHourWeekActionEventCancelForm = function (widgetNewHourWeek,widgetHourWeekList) {
        ScreenService.goBack();
        widgetNewHourWeek.list();
        widgetHourWeekList.activate();
    };
    this.newHourWeekActionEventEdit = function (widgetNewHourWeek) {
        var newExceptionWidget = widgetNewHourWeek;
        if(newExceptionWidget.currentRow.EDIT){
            newExceptionWidget.edit();
            newExceptionWidget.template = newExceptionWidget.formTemplate;
        }else{
            ScreenService.showMessage(Utilities.messages.ERRO_IN_EDIT_CALENDAR);
        }
    };
    
    this.newHourWeekActionEventSave = function (widgetNewHourWeek,widgetHourWeekList) {
        if(widgetNewHourWeek.isValid() && widgetNewHourWeek.currentRow.EDIT){
            widgetNewHourWeek.saveRow().then(function(response){
                var calendarDetailId = response.dataset[widgetNewHourWeek.dataSource.name.split('/')[1]].ID;
                widgetNewHourWeek.currentRow.ID = calendarDetailId;
                ScreenService.showLoader();
                widgetHourWeekList.reload().then(function(){
                    ScreenService.hideLoader();
                    widgetHourWeekList.setCurrentRow(Utilities.getRowInDataSource(widgetHourWeekList.dataSource, 'ID', calendarDetailId));
                    Utilities.fixWidgetToViewAfterSaveRow(widgetNewHourWeek);
                }).catch(ScreenService.hideLoader);
            });
        }else if(!widgetNewHourWeek.currentRow.EDIT){
            ScreenService.showMessage(Utilities.messages.ERRO_IN_EDIT_CALENDAR);
        }
    };

    var __setVisibleGroupFieldDates = function setVisibleGroupFieldDates(newExceptionWidget) {
        var visible = false;
        if (newExceptionWidget.currentRow.BEGIN_DATE) {
            visible = true;
        }
        newExceptionWidget.fields.forEach(function (field) {
            if (field.fieldGroup == 'DATES'  && field.name != 'NAME'){
                field.isVisible = visible;

            }
        });
    };

    var __setAllWorkTimeFieldsByTypeField = function (newExceptionWidget) {
        newExceptionWidget.fields.forEach(function (field) {
            if (field.fieldLinkNamePM) {
                __setFieldWorkTimeByTypeField(field);
            }
        });
    };

    var __setFieldWorkTimeByTypeField =function (field) {
        var fieldWorkTime = field.widget.getField(field.fieldLinkNamePM);
        if (field.value() == 'O') {
            fieldWorkTime.value('0');
            fieldWorkTime.readOnly = true;
        } else {
            fieldWorkTime.readOnly = false;
        }
    };

    this.hourWeekListWidgetAfterMoveRow = function (row,widgetHourWeekTabbed,widgetNewHourWeek) {
        Utilities.localVar.setCalendarExceptionId(row.ID);
        var widgetTabbedException = widgetHourWeekTabbed;
        var newExceptionWidget = widgetNewHourWeek;
        ScreenService.showLoader();
        Utilities.fixBugReloadWidgetInViewMode(newExceptionWidget).then(function(){
            newExceptionWidget.moveToFirst();
            widgetTabbedException.formTemplate = widgetTabbedException.template;
            __setVisibleGroupFieldDates(newExceptionWidget);
            newExceptionWidget.fields.forEach(function (field) {
                if (field.fieldGroup == 'DATES'  && field.name != 'NAME'){
                    if(newExceptionWidget.currentRow.BEGIN_DATE) {
                        field.validations = {"required": {}};
                    }else{
                        field.validations = false;
                    }
                }
            });
            __setAllWorkTimeFieldsByTypeField(newExceptionWidget);
            
            ScreenService.hideLoader();
            ScreenService.openSwipe(widgetTabbedException).then(function () {
                newExceptionWidget.view();
                newExceptionWidget.template = newExceptionWidget.templateToView;
                templateManager.updateTemplate();
            });
        }).catch(ScreenService.hideLoader);
    };
    
    this.hourWeekListActionEventNew = function (widgetHourWeekTabbed,widgetNewHourWeek) {
        ScreenService.openSwipe(widgetHourWeekTabbed).then(function(){
            widgetHourWeekTabbed.formTemplate = widgetHourWeekTabbed.template;
            widgetNewHourWeek.newRow();
            widgetNewHourWeek.currentRow.EDIT = true;
            var now = Utilities.getCurrentDate();
            widgetNewHourWeek.fields.forEach(function (field) {
                if (field.fieldGroup == 'DATES' && field.name != 'NAME') {
                    field.validations = {"required": {}};
                    field.value(now);
                }
            });
            __setVisibleGroupFieldDates(widgetNewHourWeek);
            __setAllWorkTimeFieldsByTypeField(widgetNewHourWeek);
            widgetNewHourWeek.template = widgetNewHourWeek.formTemplate;
        });
    };
    
    this.setFieldWorkTimeByTypeField = function (field) {
        var fieldWorkTime = field.widget.getField(field.fieldLinkNamePM);
        if (field.value() == 'O') {
            fieldWorkTime.value('0');
            fieldWorkTime.readOnly = true;
        } else {
            fieldWorkTime.readOnly = false;
        }
    };

    this.hourWeekListActionEventDelete = function (widgetHourWeekList) {
        var hourWeekListWidget = widgetHourWeekList;
        var checkedRows = hourWeekListWidget.dataSource.getCheckedRows();
        var weekBasic = checkedRows.filter(function(row){
            return !row.BEGIN_DATE;
        });
        if(!weekBasic.length){
            var weekCalendarBasic = checkedRows.filter(function(row){
                return !row.EDIT;
            });
            if(!weekCalendarBasic.length){
                hourWeekListWidget.dataSource.checkedRows = add__is_newInAllRows(checkedRows);
                hourWeekListWidget.removeCheckedRows();
            }else{
                ScreenService.showMessage(Utilities.messages.ERRO_IN_EDIT_CALENDAR);
            }
        }else{
            ScreenService.showMessage('Não é posivel apagar a semana de trabalho padrão');
        }
    };
    // calendar events

    this.calendarWidgetAfterMoveRow = function (dataPM,rowMove) {
        var row = dataPM.filter(function(data){
            return data.DATA == rowMove;
        })[0];

        var exception = '';
        var name = row.NAME;
        if(row.IS_EXCEPTION == 'Y'){
            exception = 'exceção';
        }else if(row.IS_EXCEPTION == 'N'){
            exception = 'semana de trabalho';
        }else{
            exception = 'semana de trabalho';
            name = 'padrão';
        }

        var type = row.TYPE;
        if(type == 'O'){
            type = 'NÃO ÚTIL';
        }else{
            type = 'ÚTIL (periodo de trabalho de '+row.DAILY_HOURS+')';
        }
        ScreenService.alertNotification('O dia '+row.DATA+' é um dia '+type+' de acordo com a '+exception+' "'+name+'"',10000);
    };

    this.calendarWidgetOnMonthClick = function (args) {
        console.log(args);
    };

    this.calendarWidgetAfterLoadDataSource = function (widgetCalendar) {
        var widget = widgetCalendar;
        widget.dataSource.dataPM = angular.copy( widget.dataSource.data);
        widget.dataSource.data = widget.dataSource.data.filter(function(date){
            return date.TYPE == 'O';
        });
    };

    this.getMonthFromWidgetCalendar = function(widgetCalendar){
        var month = null;
        if(widgetCalendar && widgetCalendar.getMonth){
            month = widgetCalendar.getMonth()+1;
        }
        return month;
    };

    this.getYearFromWidgetCalendar = function(widgetCalendar){
        var year = null;
        if(widgetCalendar && widgetCalendar.getYear){
            year = widgetCalendar.getYear();
        }
        return year;
    };

}
Configuration(function(ContextRegister){
    ContextRegister.register('CalendarService',CalendarService);
});

// FILE: assets/js/Service/CalendarInit.js
/**
 * Created by jhoterdanchaves on 02/07/14.
 */

function CalendarInitService(){

}


// FILE: assets/js/Service/Comment.js
function CommentService (Utilities, ScreenService){

    this.saveComment = function(widget, closePopupAndReloadCommentWidgets, reopenIssue){
        if(widget.isValid()) {
            widget.saveRow().then(function () {
                if (widget.currentRow.calledByReopenIssue) {
                    reopenIssue().then(function () {
                        closePopupAndReloadCommentWidgets();
                    });
                } else {
                    closePopupAndReloadCommentWidgets();
                }
            });
        } else {
            ScreenService.showMessage(Utilities.messages.ERR_REQUIRED_FIELDS, 'ERROR');
        }
    };

}
Configuration(function(ContextRegister){
    ContextRegister.register('CommentService',CommentService);
});

// FILE: assets/js/Service/Dashboard.js
function PMDashboardService(requestDataSourceEngine, restEngine, Utilities) {

    var self = this;

    /***************************************************
     ************* CARDS INFORMATION  ******************
     ***************************************************/

     this.getTotalIssuesWithCommentsUnread = function () {
         return requestDataSourceEngine.getDataSource("/totalCommentsUnread", []).then(function (data) {
             return data.dataset.total;
         });
     };

     this.getAllStatusTask = function () {
         return requestDataSourceEngine.getDataSource("/findAllStatusTask", []).then(function (data) {
             return data.dataset.findAllStatusTask;
         });
     };

     this.getIssueStatus = function () {
         return requestDataSourceEngine.getDataSource("/findIssueStatus", []).then(function (data) {
             return data.dataset.findIssueStatus;
         });
     };

     this.getTotalDelayedTasks = function () {
         return requestDataSourceEngine.getDataSource("/findTotalDelayedTasksByCurrentUser", []).then(function (data) {
             return data.dataset.totalDelayedTasksByCurrentUser;
         });
     };

     this.getTotalPendingTasks = function () {
         return requestDataSourceEngine.getDataSource("/findTotalPendingTasksByCurrentUser", []).then(function (data) {
             return data.dataset.totalPendingTasksByCurrentUser;
         });
     };

     this.getTotalDaysWithAppropriationDifference = function () {
         return requestDataSourceEngine.getDataSource("/findTotalDaysWithAppropriationDifference", []).then(function (data) {
             return data.dataset.totalDaysWithAppropriationDifference;
         });
     };

     this.getTotalIssuesWithPendingConclusion = function () {
         return requestDataSourceEngine.getDataSource("/findTotalIssuesWithPendingConclusion", []).then(function (data) {
             return data.dataset.totalIssuesWithPendingConclusion;
         });
     };

     this.getTotalBacklogIssuesByCurrentUser = function () {
         return requestDataSourceEngine.getDataSource("/totalBackLogIssuesByCurrentUser", []).then(function (data) {
             return data.dataset.totalBackLogIssuesByCurrentUser;
         });
     };

    /***************************************************
     ************* BURNDOWN METHODS  ********************
     ***************************************************/

    this.getOpenSprintByUser = function () {
        return requestDataSourceEngine.getDataSource("/findOpenSprintByUser", []).then(function (response) {
            return response;
        });
    };
    
    /** Rotas para o zmart */
    this.findBiggerStructureInZmart = function () {
        return requestDataSourceEngine.getDataSource("/findBiggerStructureInZmart", []).then(function (response) {
            return response.dataset.findBiggerStructureInZmart[0];
        });
    };
    
    /** Rotas para o zmart */
    this.findbuildWidgetByViewIdInZmart = function (filters) {
        var row = {
            "requestType": "Row",
            "row": {
                "drillDownFilters": {
                    "MODEL_NAME": filters.MODEL,
                    "NAME_EQUIPE": filters.STRUCTURE
                },
                "serieColors": 0,
                "structureId": [],
                "structureName": [],
                "viewId": ''
            }
        };
        return restEngine.post('/findbuildWidgetByViewIdInZmart', row).then(function (response) {
            return response;
        });
    };
    
    this.getDashboardMetadata = function () {
        return this.getOpenSprintByUser().then(function (response){
            openSprintsOfUserStructures = response.dataset.findOpenSprintByUser;
            if(openSprintsOfUserStructures.length > 0){
                return self.findbuildWidgetByViewIdInZmart(openSprintsOfUserStructures[0]).then(function (response) {
                    var dashboardMetadata = response.dataset.findbuildWidgetByViewIdInZmart[0];
                    return {
                        "dashboardMetadata": dashboardMetadata,
                        "openSprintsOfUserStructures": openSprintsOfUserStructures
                    };
                }).catch(Utilities.showMessageBackEndTrue);
            }
            return {};
        }).catch(Utilities.showMessageBackEndTrue);
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('PMDashboardService', PMDashboardService);
});

// FILE: assets/js/Service/Git.js
/**
 * Created by phillipesilva on 09/11/2015.
 */
function GitService(GitQueue, ZHPromise){
    this.lsRemote = function(path, url) {
        var defer   = ZHPromise.defer();
        var reject  = function (error) {
            defer.reject(error);
        };
        var resolve = function (success) {
            defer.resolve(success);
        };

        GitQueue.lsRemote(path, url)
                .error(reject)
                .then(resolve);

        return defer.promise;
    };

    this.currentGitRemote = function(path) {
        var defer   = ZHPromise.defer();
        var reject  = function (error) {
            defer.reject(error);
        };
        var resolve = function (success) {
            defer.resolve(success);
        };

        GitQueue.status(path)
                .error(resolve)
                .then(function() {
                    GitQueue.currentGitRemote(path)
                            .error(reject)
                            .then(resolve);
                });

        return defer.promise;
    };

    this.currentGitDiff = function(path,branchBase,branchToCompare,fileName) {
        var defer   = ZHPromise.defer();
        var reject  = function (error) {
            defer.reject(error);
        };
        var resolve = function (success) {
            defer.resolve(success);
        };

        GitQueue.status(path)
                .error(resolve)
                .then(function() {
                    GitQueue.currentGitDiff(path,branchBase,branchToCompare,fileName)
                            .error(reject)
                            .then(resolve);
                });

        return defer.promise;
    };

    this.ls = function(path) {
        var defer   = ZHPromise.defer();
        var reject  = function (error) {
            defer.reject(error);
        };
        var resolve = function (success) {
            defer.resolve(success);
        };

        GitQueue.ls(path)
                .error(reject)
                .then(resolve);

        return defer.promise;
    };

    this.createFile = function(path, fileName, fileContents) {
        var defer   = ZHPromise.defer();
        var reject  = function (error) {
            defer.reject(error);
        };
        var resolve = function (success) {
            defer.resolve(success);
        };

        GitQueue.createPath(path)
                .createFile(path, fileName, fileContents, true)
                .error(reject)
                .then(resolve);

        return defer.promise;
    };

    this.cat = function(path, fileName) {
        var defer   = ZHPromise.defer();
        var reject  = function (error) {
            defer.reject(error);
        };
        var resolve = function (success) {
            defer.resolve(success);
        };

        GitQueue.cat(path, fileName)
                .error(function(error) {
                    if(error.data.indexOf('pode encontrar o arquivo') != -1 ||
                       error.data.indexOf('such file or directory') != -1) {
                        resolve('');
                    } else {
                        reject(error);
                    }
                })
                .then(resolve);

        return defer.promise;
    };

    this.validateExecuteInWindows = function() {
        var defer   = ZHPromise.defer();
        var reject  = function (error) {
            defer.reject(error);
        };
        var resolve = function (success) {
            defer.resolve(success);
        };

        GitQueue.validateExecuteInWindows()
                .error(reject)
                .then(resolve);

        return defer.promise;
    };
}
Configuration(function(ContextRegister) {
    ContextRegister.register('GitService', GitService);
});

// FILE: assets/js/Service/Issue.js
function IssueService(requestDataSourceEngine, Utilities, ScreenService){

    this.markManyAsRead = function(selectedIssues){
        var ids = getOnlyIdsFromIssueList(selectedIssues);
        var filter = buildZeedhiFilter([[ids, "ISSUES_IDS", "="]]);
        return requestDataSourceEngine.getDataSource("/selectedIssuesAsRead", filter);
    };

    this.removeCurrentUserFollower = function(issueId){
        var row = {};
        row.ISSUE_ID = issueId;
        row.changed = true;
        return requestDataSourceEngine.setDataSource('/removeCurrentUserFollower',[row]);
    };


    this.findBudgetProduct = function(issueId){
         var filter = [{
            "name": "ISSUE_ID",
            "value": issueId,
            "operator": "="
        }];
        return requestDataSourceEngine.getDataSource('/getBudgetProduct', filter).then(function(result) {
           return result.dataset.issue;
        });
    };

    this.findBudgetProductByTask = function(taskId){
         var filter = [{
            "name": "TASK_ID",
            "value": taskId,
            "operator": "="
        }];
        return requestDataSourceEngine.getDataSource('/getBudgetProductByTask', filter).then(function(result) {
           return result.dataset.issue;
        });
    };

    this.generateDocument = function(documentTemplateId,issueId){
        var serviceUrl = window.serviceUrl;
        window.open(serviceUrl + "/generateIssueBudget?requestType=DataSet&dataset[0][DOCUMENT_TEMPLATE_ID]="+
        documentTemplateId +"&dataset[0][ISSUE_ID]="+issueId);
    };

    var getOnlyIdsFromIssueList = function(issueList){
        var ids = [];
        issueList.forEach(function(issue){
            if(issue.hasOwnProperty('ID')){
                ids.push(issue.ID);
            } else if(issue.hasOwnProperty('id')){
                ids.push(issue.id);
            }
        });
        return ids;
    };
    var buildZeedhiFilter = function(filterValues){
        var finalFilter = [];
        filterValues.forEach(function(filter){
            if( ! filter[0] || ! filter[1]) throw console.error("Invalid arguments.");
            var object = {};
            object.value = filter[0];
            object.name = filter[1];
            object.operator = filter[2] || "=";
            finalFilter.push(object);
        });
        return finalFilter;
    };

    this.sendIssuesAndLabelsToRelationship = function(issues, labels){
        var request = [{
            issues: issues,
            labels: labels,
            changed: true
        }];
        return requestDataSourceEngine.setDataSource("/labelsAndIssuesRelationship", request);
    };

    this.saveProductBudget = function(row, issueId){
        var request = [{
            PRODUCT_ID: row.PRODUCT_ID,
            CDITEMTRAB: row.CDITEMTRAB,
            ISSUE_ID: issueId,
            changed: true
        }];
        return requestDataSourceEngine.setDataSource("/saveProductBudget", request);
    };

    this.saveIssuePriorities = function(priority, issues){
        var request = [{
            priority: priority,
            issues: issues,
            changed: true
        }];
        return requestDataSourceEngine.setDataSource("/saveIssuesPriority", request);
    };

    this.saveIssueRelationship = function(rows){
        return requestDataSourceEngine.setDataSource('/issueRelationship', rows);
    };

    this.saveTaskClassification = function(rows){
        return requestDataSourceEngine.setDataSource('/taskClassification', rows);
    };

    this.saveNewIssue = function(rows){
        return requestDataSourceEngine.setDataSource("/saveNewIssue", rows);
    };

    this.saveTaskRelationship = function(rows){
        return requestDataSourceEngine.setDataSource('/taskRelationship', rows);
    };

    this.sendOutComment = function(row){
        return requestDataSourceEngine.setDataSource('/sendOutComment', [row]);
    };

    this.saveCreateTasksByIssues= function(rows){
        return requestDataSourceEngine.setDataSource('/createTasksByIssues',rows);
    };

    this.saveEditedIssueByIssues= function(rows){
        return requestDataSourceEngine.setDataSource("/saveEditedIssue", rows);
    };

    //Used in TaskTracking.js
    this.getFullLogFileContents = function(logFileName) {
        var filter = [{
            "name": "FILE_NAME",
            "value": logFileName,
            "operator": "="
        }];
        return requestDataSourceEngine.getDataSource('/getFullLog', filter).then(function(fullLog) {
            var log = fullLog.dataset.logFileContents[0];
            return log.length > 0 ? log : false;
        });
    };

    this.findUserData = function(){
        return requestDataSourceEngine.getDataSource('/findUserData').then(function(response){
            return response.dataset.findUserData[0];
        });
    };


    this.findCommentTypeByControl = function(control) {
        var filter = [{
            "name": "CONTROL",
            "value": control,
            "operator": "="
        }];
        return requestDataSourceEngine.getDataSource('/commentType', filter).then(function(response) {
                return response.dataset.commentType[0] ?  response.dataset.commentType[0] : null;
        });
    };


    this.findCommentTypeByTypeTaskId = function(id) {
        var filter = [{
            "name": "ID",
            "value": id,
            "operator": "="
        }];
        return requestDataSourceEngine.getDataSource('/commentTypeByTypeTaskId', filter).then(function(response) {
            return response.dataset.commentType[0] ?  response.dataset.commentType[0] : null;
        });
    };
    
    this.findLTSProductVersionToRemove = function(id) {
       var filter = [
            {
                name: 'PROJECTS',
                operator: '=',
                value: id
            }
        ];
        return requestDataSourceEngine.getDataSource('/findLTSProductVersionToRemove', filter).then(function(response) {
            return response.dataset.findLTSProductVersionToRemove;
        });
    };
    
    this.removeLTSFromVersions = function(versions) {
    	versions.forEach(function(version){
			version.changed = true;
		});
		return requestDataSourceEngine.setDataSource('/findLTSProductVersionToRemove', versions);
	};

    this.validateSpecificationRequirements = function() {
        return requestDataSourceEngine.getDataSource('/validateSpecificationRequirements').then(function(response) {
                return response.dataset.validateSpecificationRequirements[0] ?  response.dataset.validateSpecificationRequirements[0] : null;
        });
    };

    this.validateFinishSpecificationTask = function(row) {
        row.changed = true;
        return requestDataSourceEngine.setDataSource('/validateFinishSpecificationTask', [row]);
    };

    this.getTaskClassificationByIssue = function(issueId){
        var filter = [
            {
                name: 'ISSUE_ID',
                operator: '=',
                value: issueId
            }
        ];
        return requestDataSourceEngine.getDataSource('/taskClassificationByIssue', filter).then(function(response){
            return response.dataset.taskClassificationByIssue;
        });
    };

    this.getTaskClassificationByIssues = function(issueIds){
        var filter = [
            {
                name: 'ISSUE_IDS',
                operator: '=',
                value: issueIds
            }
        ];
        return requestDataSourceEngine.getDataSource('/taskClassificationByIssues', filter).then(function(response){
            return response.dataset.taskClassificationByIssues;
        });
    };

    this.clientAccept  = function(row){
        row.changed = true;
        return requestDataSourceEngine.setDataSource('/clientAccept', [row]);
    };

    this.clientRefuse  = function(row){
        row.changed = true;
        return requestDataSourceEngine.setDataSource('/clientRefuse', [row]);
    };

    this.findEntranceComment = function(issueId,typeTask){
        var filter = [
            {
                name: 'ISSUE_ID',
                operator: '=',
                value: issueId
            },
            {
                name: 'TYPE_TASK',
                operator: '=',
                value: typeTask
            }
        ];
        return requestDataSourceEngine.getDataSource('/validateEntranceComment', filter).then(function(response){
            return response.dataset.validateEntranceComment;
        });
    };

    this.viewComments = function(){
        var row = {};
        var issue = Utilities.localVar.getIssue();
        row.ISSUE = Array.isArray(issue)?issue[0]:issue;
        row.changed = true;
        requestDataSourceEngine.setDataSource('/viewComments',[row], undefined, undefined, undefined, undefined, true).then(function(response){
            if(Array.isArray(response)){
                Utilities.localVar.setLastDateViewComments(null);
            }else{
                Utilities.localVar.setLastDateViewComments(response.dataset.lastDate[0]);
            }
        });
    };

    this.validateDevVersionBetweenProjectAndIssue = function (issuesInfo, projectsInfo, createTaskIssueWidget) {
        if(issuesInfo){

            var msgDifferentVersionInSameProduct = '';
            var projectsWithoutVersion = [];
            var issuesWithoutVersion = [];

            var issueVersionDev = issuesInfo.find(function (i) {
                return i.PRODUCT_VERSION_ID_DEV;
            });


            projectsInfo = Object.values(projectsInfo);

            if(validateProjectsOfTheSameProduct(projectsInfo)){
                var projectIssue = issuesInfo[0].PROJECT;
                var projectVersionDev = projectsInfo.find(function (p) {
                    return p.projectProductId == projectIssue && p.productVersionId;
                });

                issuesInfo.forEach(function (issue) {
                    projectsInfo.forEach(function (project) {
                        var issueVersion = issue.VERSION_DEV ? issue.VERSION_DEV : 'Última versão';
                        var projectVersion = project.productVersionLabel ? project.productVersionLabel : 'Última versão';
                        if (issue.PROJECT == project.projectProductId &&
                            (project.externalType == 'E' || project.externalType == 'B') &&
                            (issue.PRODUCT_VERSION_ID_DEV != project.productVersionId && (issue.PRODUCT_VERSION_ID_DEV && project.productVersionId))) {
                                msgDifferentVersionInSameProduct += getMsgDifferentVersionInSameProduct(issue, project, issueVersion, projectVersion);
                        }

                        if (project.externalType == 'E' && !project.productVersionId && issueVersionDev) {
                            projectsWithoutVersion.push(project.projectName);
                        }

                        if (project.externalType == 'E' && !issue.PRODUCT_VERSION_ID_DEV && (issueVersionDev || project.productVersionId)) {
                            issuesWithoutVersion.push(issue.NAME);
                        }
                    });
                });

                createTaskIssueWidget.projectsWithoutVersion = projectsWithoutVersion;
                createTaskIssueWidget.issuesWithoutVersion = issuesWithoutVersion;
                createTaskIssueWidget.issueVersionDev = issueVersionDev ? issueVersionDev : '';
                createTaskIssueWidget.projectVersionDev = projectVersionDev ? projectVersionDev : '';
                createTaskIssueWidget.allVersionDev = issueVersionDev ? issueVersionDev.VERSION_DEV : projectVersionDev ? projectVersionDev.productVersionLabel : '';
                createTaskIssueWidget.projectProductIssueId = issuesInfo[0].PROJECT;
                return showMsgValidateDevVersionBetweenProjectAndIssue(msgDifferentVersionInSameProduct);
            } else {
                return false;
            }
        }
    };

    var showMsgValidateDevVersionBetweenProjectAndIssue = function (msgDifferentVersionInSameProduct) {
        if (msgDifferentVersionInSameProduct) {
            ScreenService.showMessage(Utilities.messages.ERR_ISSUES_PROJECTS_VERSIONS_DIFFERENT + msgDifferentVersionInSameProduct, 'error');
            return false;
        }
        return true;
    };

    var getMsgDifferentVersionInSameProduct = function (issue, project, issueVersion, projectVersion) {
        return  "<p align='left'> " +
                    "<strong>Issue:</strong> " + issue.NAME + " - <strong><font color='#555'>" + issueVersion + "</font></strong>" +
                    "<br/>" +
                    "<strong>Projeto:</strong> " + project.projectName + " - <strong><font color='#555'>" + projectVersion + "</font></strong>" +
                "</p>" +
                "<br/>";
    };

    var getMsgProjectNotError = function (issue, issueVersion) {
        return  "<li align='left'> " +
                    "<strong>Issue:</strong> " + issue.NAME +
                    " - <strong><font color='#555'>" + issueVersion + "</font></strong>" +
                "</li>" +
                "<br/>";
    };

    this.isIssuesBelongingSameProduct = function (issues, taskRelationship) {
        var projectIds = issues.map(function (issue) {
            return issue.PROJECT;
        });
        if (taskRelationship) {
            if (!Utilities.allValuesSameInArray(projectIds)) {
                var message = Utilities.messages.ERR_ISSUES_WITH_PRODUCT_DIFFERENT.replace('criar', 'relacionar');
                ScreenService.showMessage(message, 'error');
                return false;
             }
        } else {
            var isDevVersions = issues.some(function (i) {
               return i.PRODUCT_VERSION_ID_DEV;
            });
            if (!Utilities.allValuesSameInArray(projectIds) && isDevVersions) {
                ScreenService.showMessage(Utilities.messages.ERR_ISSUES_WITH_PRODUCT_DIFFERENT, 'error');
                return false;
            }
        }
        return true;
    };

    var validateProjectsOfTheSameProduct = function (projectsInfo) {
        var aux = [];
        var error = false;
        projectsInfo.forEach(function (project) {
            if (aux.includes(project.projectProductId)) {
                error = true;
            } else {
                aux.push(project.projectProductId);
            }
        });
        if(error){
            getMessageErrorProjectsOfTheSameProduct();
            return false;
        } else {
            return true;
        }
    };

    var getMessageErrorProjectsOfTheSameProduct = function(){
        ScreenService.showMessage(Utilities.messages.ERR_PROJECTS_SAME_PRODUCT_VERSION_DIFFERENT);
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('IssueService', IssueService);
});




// FILE: assets/js/Service/Login.js
/**
 * Created by jhoterdanchaves on 13/06/14.
 */
function LoginService(LoginRepository, requestDataSourceEngine) {
    this.login = function(email, password){
        return LoginRepository.findByEmailAndPassword(email, password);
    };

    this.clear = function (){
    	LoginRepository.clearRepository();
    };

    this.logout = function(){
    	return requestDataSourceEngine.getDataSource('/logout');
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('LoginService', LoginService);
});

// FILE: assets/js/Service/Meeting.js
/**
 * Created by tuliomagalhaes on 20/06/14.
 */

function MeetingService(requestDataSourceEngine,templateManager){

    var self = this;

}

Configuration(function(ContextRegister) {
    ContextRegister.register('MeetingService', MeetingService);
});

// FILE: assets/js/Service/MeetingPlanning.js
/**
 * Created by tuliomagalhaes on 20/06/14.
 */

function MeetingPlanningService(Utilities,ScreenService,requestDataSourceEngine,templateManager){

    var self = this;


    var WORK = 'W';
    var DAY_OFF = 'O';
    var NEW_EXCEPTION_DAILY = 'D';
    var NEW_EXCEPTION_WEEKLY = 'W';
    var NEW_EXCEPTION_MONTHLY = 'M';
    var NEW_EXCEPTION_YEARLY = 'Y';
    var CONTROL_NEW_EXCEPTION_FIELDS = ['D', 'W', 'M', 'Y'];
    var dateDefaultFormat = 'DD/MM/YYYY';
    var addDaysDefaultFormat = 'days';
    var addWeeksDefaultFormat = 'weeks';

    var getFieldIdFromCalendarListWidget = function (widgetCalendarList) {
        return widgetCalendarList.getField('ID');
    };

    var getFieldYearDayFromInfoMeetingWidget = function (widgetInfoMeeting) {
        return widgetInfoMeeting.getField('YEAR_DAY');
    };
    var getFieldYearDayExceptionYearFromInfoMeetingWidget = function (widgetInfoMeeting) {
        return widgetInfoMeeting.getField('YEAR_DAY_EXCEPTION_YEAR');
    };
    var getFieldYearDayExceptionMonthFromInfoMeetingWidget = function (widgetInfoMeeting) {
        return widgetInfoMeeting.getField('YEAR_DAY_EXCEPTION_MONTH');
    };
    var getFieldRecurrenceTypeFromInfoMeetingWidget = function (widgetInfoMeeting) {
        return widgetInfoMeeting.getField('RECURRENCE_TYPE');
    };
    var getFieldTypeFromInfoMeetingWidget = function (widgetInfoMeeting) {
        return widgetInfoMeeting.getField('TYPE');
    };
    var getFieldWeekDayExceptionYearFromInfoMeetingWidget = function (widgetInfoMeeting) {
        return widgetInfoMeeting.getField('WEEK_DAY_EXCEPTION_YEAR');
    };
    var getFieldWeekDayExceptionMonthFromInfoMeetingWidget = function (widgetInfoMeeting) {
        return widgetInfoMeeting.getField('WEEK_DAY_EXCEPTION_MONTH');
    };
    var getFieldExceptionDataEndFromInfoMeetingWidget = function (widgetInfoMeeting) {
        return widgetInfoMeeting.getField('EXCEPTION_DATA_END');
    };
    var getFieldExceptionQuantitativeFromInfoMeetingWidget = function (widgetInfoMeeting) {
        return widgetInfoMeeting.getField('EXCEPTION_QUANTITATIVE');
    };
    var getFieldBeginDateFromInfoMeetingWidget = function (widgetInfoMeeting) {
        return widgetInfoMeeting.getField('BEGIN_DATE');
    };
    var getFieldEndDateFromInfoMeetingWidget = function (widgetInfoMeeting) {
        return widgetInfoMeeting.getField('END_DATE');
    };
    var getFieldOccurrencesFromInfoMeetingWidget = function (widgetInfoMeeting) {
        return widgetInfoMeeting.getField('OCCURRENCES');
    };
    var getFieldEveryFromInfoMeetingWidget = function (widgetInfoMeeting) {
        return widgetInfoMeeting.getField('EVERY');
    };
    var getFieldMonthlyDayFromInfoMeetingWidget = function (widgetInfoMeeting) {
        return widgetInfoMeeting.getField('MONTHLY_DAY');
    };
    var getFieldOrderDayMonthFromInfoMeetingWidget = function (widgetInfoMeeting) {
        return widgetInfoMeeting.getField('ORDER_DAY_MONTH');
    };
    var getFieldOrderDayYearFromInfoMeetingWidget = function (widgetInfoMeeting) {
        return widgetInfoMeeting.getField('ORDER_DAY_YEAR');
    };
    var getFieldWeekDayFromInfoMeetingWidget = function (widgetInfoMeeting) {
        return widgetInfoMeeting.getField('WEEK_DAY');
    };

    // fuctions for exception

    var __setDateTodayDefault = function (fields) {
        var today = moment();
        fields.filter(function (field) {
            return field.defaultDateToday;
        }).forEach(function (field) {
            if (!field.value()) {
                var format = field["datetime-dateFormat"];
                if (!format) {
                    format = "DD/MM/YYYY";
                } else {
                    format = Utilities.getFormatMomentByFormatMobicroll(format);
                }
                field.value(today.format(format));
            }
        });
    };
    var __setValueDefault = function (fields) {
        fields.forEach(function (field) {
            if (!field.value() && field.defaultValue) {
                field.value(field.defaultValue);
            }
        });
    };

    this.createMeetingActionEventNew = function (createMeetingWidget) {
        createMeetingWidget.dataSource.data = [];
        createMeetingWidget.newRow();
        createMeetingWidget.currentRow.EDIT = true;
        createMeetingWidget.template = createMeetingWidget.formTemplate;
        __setDateTodayDefault(createMeetingWidget.fields);
        __setFieldsByExceptionType(getFieldRecurrenceTypeFromInfoMeetingWidget(createMeetingWidget),createMeetingWidget);
        createMeetingWidget.activate();
        self.readOnlyException(getFieldYearDayExceptionYearFromInfoMeetingWidget(createMeetingWidget), getFieldWeekDayExceptionYearFromInfoMeetingWidget(createMeetingWidget),createMeetingWidget);
        self.readOnlyException(getFieldExceptionDataEndFromInfoMeetingWidget(createMeetingWidget), getFieldExceptionQuantitativeFromInfoMeetingWidget(createMeetingWidget),createMeetingWidget);
        ScreenService.openPopup(createMeetingWidget);
    };
    var clearException = function (createMeetingWidget) {
        var fieldGroupsControl = createMeetingWidget.fieldGroups.filter(function (fieldGroup) {
            return CONTROL_NEW_EXCEPTION_FIELDS.indexOf(fieldGroup.control) > -1;
        });
        createMeetingWidget.fields.forEach(function (field) {
            if (fieldGroupsControl.indexOf(field.fieldGroup) > -1) {
                field.validations = false;
            }
        });
    };

    var __setFieldsByExceptionType = function (recurrenceField,widgetInfoMeeting) {
        var recurrence = recurrenceField.value();
        var fieldGroup = null;
        if (!recurrence) {
            recurrenceField.value(NEW_EXCEPTION_DAILY);
            recurrence = NEW_EXCEPTION_DAILY;
        }
        widgetInfoMeeting.fieldGroups.forEach(function (group) {
            if (group.control == recurrence) {
                group.isVisible = true;
                fieldGroup = group;
            } else if (group.control) {
                group.isVisible = false;
            }
        });
        clearException(widgetInfoMeeting);

        var fields = widgetInfoMeeting.fields.filter(function (field) {
            return field.fieldGroup == fieldGroup.name;
        });
        fields.forEach(function (field) {
            if (field.isRequiredWhenExceptionPM) {
                field.validations = {"required": {}};
            }
        });
        if (fieldGroup.control == NEW_EXCEPTION_MONTHLY || fieldGroup.control == NEW_EXCEPTION_YEARLY) {
            var weekField = null;
            var yearField = null;
            if(fieldGroup.control == NEW_EXCEPTION_MONTHLY ){
                weekField = getFieldWeekDayExceptionMonthFromInfoMeetingWidget(widgetInfoMeeting);
                yearField = getFieldYearDayExceptionMonthFromInfoMeetingWidget(widgetInfoMeeting);
            }else {
                weekField = getFieldWeekDayExceptionYearFromInfoMeetingWidget(widgetInfoMeeting);
                yearField = getFieldYearDayExceptionYearFromInfoMeetingWidget(widgetInfoMeeting);
            }
            if (weekField.value() == 'Y') {
                __setReadOnlyWithValidateBySubGroups(yearField.name, weekField.name, widgetInfoMeeting, fieldGroup.name);
            } else {
                __setReadOnlyWithValidateBySubGroups(weekField.name, yearField.name, widgetInfoMeeting, fieldGroup.name);
            }
        }
    };

    this.createMeetingFieldOnChangeRecurrenceType = function (recurrenceField,widgetInfoMeeting) {
        __setFieldsByExceptionType(recurrenceField,widgetInfoMeeting);
    };

    this.createMeetingPlanningFieldOnChangeBeginDate = function (widgetInfoMeeting) {
        var fieldYearDay = getFieldYearDayFromInfoMeetingWidget(widgetInfoMeeting);
        var fieldEndDate = getFieldEndDateFromInfoMeetingWidget(widgetInfoMeeting);
        var fieldBeginDate = getFieldBeginDateFromInfoMeetingWidget(widgetInfoMeeting);
        var beginDate = moment(fieldBeginDate.value(),Utilities.FORMAT_DATE_DEFAULT_ONLY_DATE);
        fieldYearDay.setValue(beginDate.format(Utilities.getFormatMomentByFormatMobicroll(fieldYearDay['datetime-dateFormat'])));
        fieldEndDate.setValue(fieldBeginDate.value());

    };

    this.InfoMeetingActionEventCancelForm = function (widgetcreateMeeting) {
        ScreenService.goBack();
        widgetcreateMeeting.activate();
        widgetcreateMeeting.list();
    };
    var __setReadOnlyWithValidateBySubGroups = function (groupReadOnly, groupNotReadOnly, widget, validate) {
        widget.fields.forEach(function (field) {
            if (field.subGroup == groupNotReadOnly) {
                field.readOnly = false;
                if (validate && validate == field.fieldGroup) {
                    field.validations = {"required": {}};
                }
            } else if (field.subGroup == groupReadOnly) {
                field.readOnly = true;
                if (validate && validate == field.fieldGroup) {
                    field.validations = false;
                }
            }
        });
    };
    var __checkedCheckbox = function (field) {
        if (field.valueToTrue == field.value()) {
            field.checked = true;
        } else {
            field.checked = false;
        }
    };
    this.readOnlyException = function (fieldOrigin, fieldOther,widgetInfoMeeting) {

        if (fieldOrigin.value() == 'Y') {
            __setReadOnlyWithValidateBySubGroups(fieldOther.name, fieldOrigin.name, widgetInfoMeeting, fieldOrigin.fieldGroup);
            fieldOther.value('N');
        } else {
            if (fieldOther.value() == 'N') {
                fieldOrigin.value('Y');
            }
        }
        __checkedCheckbox(fieldOrigin);
        __checkedCheckbox(fieldOther);
    };

    this.createMeetingFieldOnChangeYearDayExceptionYear = function (yearField,widgetInfoMeeting) {
        var name = getFieldWeekDayExceptionYearFromInfoMeetingWidget(widgetInfoMeeting).name;
        var weekField = widgetInfoMeeting.fields.filter(function (item) {
            return (item.name === name && item.fieldGroup == yearField.fieldGroup);
        })[0];
        self.readOnlyException(yearField, weekField,widgetInfoMeeting);

    };
    this.createMeetingFieldOnChangeYearDayExceptionMonth = function (yearField,widgetInfoMeeting) {
        var name = getFieldWeekDayExceptionMonthFromInfoMeetingWidget(widgetInfoMeeting).name;
        var weekField = widgetInfoMeeting.fields.filter(function (item) {
            return (item.name === name && item.fieldGroup == yearField.fieldGroup);
        })[0];
        self.readOnlyException(yearField, weekField,widgetInfoMeeting);

    };
    this.createMeetingFieldOnChangeWeekDayExceptionYear = function (weekField,widgetInfoMeeting) {
        var name = getFieldYearDayExceptionYearFromInfoMeetingWidget(widgetInfoMeeting).name;
        var yearField = widgetInfoMeeting.fields.filter(function (item) {
            return (item.name === name && item.fieldGroup == weekField.fieldGroup);
        })[0];
        self.readOnlyException(weekField, yearField,widgetInfoMeeting);

    };
    this.createMeetingFieldOnChangeWeekDayExceptionMonth = function (weekField,widgetInfoMeeting) {
        var name = getFieldYearDayExceptionMonthFromInfoMeetingWidget(widgetInfoMeeting).name;
        var yearField = widgetInfoMeeting.fields.filter(function (item) {
            return (item.name === name && item.fieldGroup == weekField.fieldGroup);
        })[0];
        self.readOnlyException(weekField, yearField,widgetInfoMeeting);

    };
    this.createMeetingFieldOnChangeExceptionQuantitative = function (widgetInfoMeeting) {
        var dataEndField = getFieldExceptionDataEndFromInfoMeetingWidget(widgetInfoMeeting);
        var quantitativeField = getFieldExceptionQuantitativeFromInfoMeetingWidget(widgetInfoMeeting);
        getFieldEndDateFromInfoMeetingWidget(widgetInfoMeeting).value(' ');
        self.readOnlyException(quantitativeField, dataEndField, widgetInfoMeeting);

    };
    this.createMeetingFieldOnChangeExceptionDataEnd = function (widgetInfoMeeting) {
        var dataEndField = getFieldExceptionDataEndFromInfoMeetingWidget(widgetInfoMeeting);
        var quantitativeField = getFieldExceptionQuantitativeFromInfoMeetingWidget(widgetInfoMeeting);
        getFieldOccurrencesFromInfoMeetingWidget(widgetInfoMeeting).value(' ');
        self.readOnlyException(dataEndField, quantitativeField,widgetInfoMeeting);

    };
    var __setMonthAndYearException = function(yearDayExceptionField,WeekDayExceptionField,OrderDayException){
        if(OrderDayException.value()){
            WeekDayExceptionField.value('Y');
            yearDayExceptionField.value('N');
        }else{
            WeekDayExceptionField.value('N');
            yearDayExceptionField.value('Y');
        }
    };
    this.setFieldsInfoMeeting = function (widgetInfoMeeting) {
        __setDateTodayDefault(widgetInfoMeeting.fields);
        __setMonthAndYearException(getFieldYearDayExceptionYearFromInfoMeetingWidget(widgetInfoMeeting),
            getFieldWeekDayExceptionYearFromInfoMeetingWidget(widgetInfoMeeting),
            getFieldOrderDayYearFromInfoMeetingWidget(widgetInfoMeeting));
        __setMonthAndYearException(getFieldYearDayExceptionMonthFromInfoMeetingWidget(widgetInfoMeeting),
            getFieldWeekDayExceptionMonthFromInfoMeetingWidget(widgetInfoMeeting),
            getFieldOrderDayMonthFromInfoMeetingWidget(widgetInfoMeeting));
        __setValueDefault(widgetInfoMeeting.fields);
        widgetInfoMeeting.activate();
        self.readOnlyException(getFieldYearDayExceptionYearFromInfoMeetingWidget(widgetInfoMeeting), getFieldWeekDayExceptionYearFromInfoMeetingWidget(widgetInfoMeeting),widgetInfoMeeting);
        self.readOnlyException(getFieldExceptionDataEndFromInfoMeetingWidget(widgetInfoMeeting), getFieldExceptionQuantitativeFromInfoMeetingWidget(widgetInfoMeeting),widgetInfoMeeting);
        __setFieldsByExceptionType(getFieldRecurrenceTypeFromInfoMeetingWidget(widgetInfoMeeting),widgetInfoMeeting);
    };

    this.createMeetingWidgetAfterMoveRow = function (id,widgetTabbedException,widgetInfoMeeting) {
        Utilities.localVar.setMeetingId(id);
        var InfoMeetingWidget = widgetInfoMeeting;
        InfoMeetingWidget.reload().then(function () {
            InfoMeetingWidget.moveToFirst();
            self.setFieldsInfoMeeting(InfoMeetingWidget);
            widgetTabbedException.formTemplate = widgetTabbedException.template;
            ScreenService.openSwipe(widgetTabbedException).then(function () {
                InfoMeetingWidget.view();
                InfoMeetingWidget.template = InfoMeetingWidget.templateToView;
                templateManager.updateTemplate();
            });
        });
    };

    this.InfoMeetingActionEventSave = function (widgetInfoMeeting,widgetcreateMeeting) {
        var InfoMeetingWidget = widgetInfoMeeting;
        if (InfoMeetingWidget.isValid() && InfoMeetingWidget.currentRow.EDIT) {
            InfoMeetingWidget.currentRow.changed = true;
            InfoMeetingWidget.saveRow().then(function(){
                    ScreenService.goBack();
                    widgetcreateMeeting.activate();
                    InfoMeetingWidget.list();
                    widgetcreateMeeting.reload();
                }
            );
        }else if(!InfoMeetingWidget.currentRow.EDIT){
            ScreenService.showMessage(Utilities.messages.ERRO_IN_EDIT_CALENDAR);
        }
    };
    this.InfoMeetingActionEventEdit = function (widgetInfoMeeting) {
        var InfoMeetingWidget = widgetInfoMeeting;
        if(InfoMeetingWidget.currentRow.EDIT){
            InfoMeetingWidget.edit();
            InfoMeetingWidget.template = InfoMeetingWidget.formTemplate;
        }else{
            ScreenService.showMessage(Utilities.messages.ERRO_IN_EDIT_CALENDAR);
        }
    };

    function add__is_newInAllRows(checkedRows) {
        return checkedRows.map(function (data) {
            if (!data.__is_new) {
                data.__is_new = false;
            }
            return data;
        });
    }

    this.createMeetingActionEventDelete = function (widgetHourWeekList) {
        var createMeetingWidget = widgetHourWeekList;
        var checkedRows = createMeetingWidget.dataSource.getCheckedRows();
        var exceptionCalendarBasic = checkedRows.filter(function(row){
            return !row.EDIT;
        });
        if(!exceptionCalendarBasic.length) {
            createMeetingWidget.dataSource.checkedRows = add__is_newInAllRows(checkedRows);
            widgetHourWeekList.removeCheckedRows();
        }else{
            ScreenService.showMessage(Utilities.messages.ERRO_IN_EDIT_CALENDAR);
        }
    };

    this.createMeetingDeleteOnlyOneRow = function (listWidget, widgetForm){
        listWidget.unSelectAll();
        listWidget.dataSource.checkedRows = [widgetForm.currentRow];
        this.createMeetingActionEventDelete(listWidget);
    };

    this.createMeetingPlanningActionEventSave = function (createMeetingPlanningWidget) {
        if (createMeetingPlanningWidget.isValid()) {
            createMeetingPlanningWidget.currentRow.changed = true;
            ScreenService.changeLoadingMessage(Utilities.messages.LOAD_GENERATING_MEETING_PLANNING);
            return createMeetingPlanningWidget.saveRow();
        }
    };


    this.newUploadDocumentMeetingProject = function(row){
        if(!row.projectId){
            row.projectId = Utilities.localVar.getMeetingId();
        }
        return requestDataSourceEngine.setDataSource('/newUploadDocumentProject', [row]);
    };

    this.getAllFollowerInMeeting = function(projectId) {

        var filter = [
            {
                "operator": "=",
                "name": "PROJECT",
                "value": projectId ? projectId : 0
            }
        ];
        return requestDataSourceEngine.getDataSource('/getFollowerInMeeting', filter);
    };
    
    this.getAllStatusTask = function(){
        return requestDataSourceEngine.getDataSource('/findAllStatusTask', []).then(function(response){
            return response.dataset.findAllStatusTask;
        });
    };

    this.getTaskStatus = function(){
        return requestDataSourceEngine.getDataSource('/taskstatus', []).then(function(response){
            return response.dataset.taskstatus;
        });
    };

    this.findIssueStatus = function(){
        return requestDataSourceEngine.getDataSource('/findIssueStatus', []).then(function (response) {
            return response.dataset.findIssueStatus;
        });
    };

    this.getNextTaskOrderByTypeAndSchedule = function(scheduleId,type) {

        var filter = [
            {
                "operator": "=",
                "name": "TYPE",
                "value": type
            },
            {
                "operator": "=",
                "name": "TASK",
                "value": scheduleId
            }
        ];
        return requestDataSourceEngine.getDataSource('/getNextTaskOrderByTypeAndSchedule', filter).then(function(response){
            return response.dataset.getNextTaskOrderByTypeAndSchedule[0];
        });
    };


    this.saveOrder = function(rows) {
        return requestDataSourceEngine.setDataSource('/saveTaskOrder', rows);
    };

    this.saveScheduleListOrder = function(rows) {
        return requestDataSourceEngine.setDataSource('/saveScheduleListOrder', rows);
    };
    
    this.saveIssueListScheduleFromProject = function(rows) {
        return requestDataSourceEngine.setDataSource('/findIssueListScheduleFromProject', [rows]);
    };

    this.getLabelsByMeeting = function(row) {
        var filter = [
            {
                "operator": "=",
                "name": "MEETING",
                "value": Utilities.localVar.getMeetingId()
            },
            {
                "name": "TYPE",
                "value": Utilities.localVar.getTaskLabelTypeId(),
                "operator": "="
            }
        ];

        return requestDataSourceEngine.getDataSource('/labelsByMeeting', filter).then(function(response){
            return response.dataset.labelsByMeeting;
        });

    };

    this.findInfoMeeting = function (projectId) {

        var filter = [
            {
                "operator": "=",
                "name": "ID",
                "value": projectId ? projectId : 0
            }
        ];
        return requestDataSourceEngine.getDataSource('/findInfoMeeting', filter);
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('MeetingPlanningService', MeetingPlanningService);
});

// FILE: assets/js/Service/ProjectList.js
/**
 * Created by tuliomagalhaes on 25/08/14.
 */

function ProjectServiceList(requestDataSourceEngine,ScreenService,ProjectTaskRepository,ProjectResourceRepository,
                            templateManager,CalendarService,DateManager, localStorageEngine, restEngine,Validation,
                            Utilities, Messages, ZHPromise){
        
    /*jshint -W087 */

    var CalendarConst = {
        HOURSDAY : 8,
        WEEK : [1,2,3,4,5]
    };
    var ARRAY_ASSOC_WEEK = {
        SU: 0,
        MO: 1,
        TU: 2,
        WE: 3,
        TH: 4,
        FR: 5,
        SA: 6
    };

    var ARRAY_WEEK = [
        'SU', 'MO', 'TU', 'WE', 'TH', 'FR', 'SA'
    ];
    var projectDataListOld;
    var container = null;
    var popUp;
    var idCount = 0;
    var editProjectForm;
    var hoursDay = CalendarConst.HOURSDAY;
    var calendarWeek = CalendarConst.WEEK;
    this.projectId = 0;
    var ProjectController;
    var REGISTERED_NAME = "ProjectServiceList";

    var getWidgetBasicInformationResource = function () {
        return templateManager.container.getWidget('BASIC_INFORMATION_RESOURCE');
    };

    var getWidgetProjectResourceList = function (){
        return templateManager.container.getWidget('RESOURCE_LIST');
    };

    var getWidgetProjectTasks = function (){
        return templateManager.container.getWidget('PROJECTTASKS');
    };

    var getWidgetProjectProjectTabbedList = function (){
        return templateManager.container.getWidget('TABBED_PROJECT_LISTS');
    };

    this.calendarProject = function(currentRowCalendar,widgetProject) {
        hoursDay = currentRowCalendar.HOUR && hoursDay !== "0" ? currentRowCalendar.HOUR : CalendarConst.HOURSDAY;
        var week = [];
        if(currentRowCalendar.DAYS){
            ARRAY_WEEK.forEach(function(values,index){
                if(currentRowCalendar[values] == 'Y'){
                    week.push(index);
                }
            });
        }else{
            week = CalendarConst.WEEK;
        }
        if(week == []){
            week = CalendarConst.WEEK;
        }
        calendarWeek = week;
    };
    var getWidgetProjectTaskList = function (){
        return templateManager.container.getWidget('PROJECTTASKS');
    };
    this.setDateByExceptionTask = function(taskId,startField, endField, durationField, precursorField, precursorType,
                                           parentField, exceptionField, exceptionDateField,dateBeginProject,resources,
                                           project,latency){
        DateManager.setDateByExceptionTask(taskId,startField, endField, durationField, precursorField, precursorType,
            parentField, exceptionField, exceptionDateField,dateBeginProject,resources,project,latency);
    };
    this.newTaskFieldOnChangeStart = function(taskId,startField, endField, durationField, precursorField, precursorType,
                                           parentField, exceptionField, exceptionDateField,dateBeginProject,resources,
                                           project,latency){
        DateManager.newTaskFieldOnChangeStart(taskId,startField, endField, durationField, precursorField, precursorType,
            parentField, exceptionField, exceptionDateField,dateBeginProject,resources,project,latency);
    };
    this.newTaskFieldOnChangeEnd = function(taskId,startField, endField, durationField, precursorField, precursorType,
                                           parentField, exceptionField, exceptionDateField,dateBeginProject,resources,
                                           project,latency){
        DateManager.newTaskFieldOnChangeEnd(taskId,startField, endField, durationField, precursorField, precursorType,
            parentField, exceptionField, exceptionDateField,dateBeginProject,resources,project,latency);
    };
    this.setBeginDateByParent = function(taskId,startField, endField, durationField, precursorField, precursorType,
                                           parentField, exceptionField, exceptionDateField,dateBeginProject,resources,
                                           project,latency){
        DateManager.setBeginDateByParent(taskId,startField, endField, durationField, precursorField, precursorType,
            parentField, exceptionField, exceptionDateField,dateBeginProject,resources,project,latency);
    };

    this.setDateExceptionTask = function(taskId,startField, endField, durationField, precursorField, precursorType,
                                         parentField, exceptionField, exceptionDateField,dateBeginProject,resources,
                                         project, latency){
        DateManager.setExceptionTask(taskId,startField, endField, durationField, precursorField, precursorType,
            parentField, exceptionField, exceptionDateField,dateBeginProject,resources,project, latency);
    };

    //calc calendar project

    this.basicProjectFieldOnChangeStart = function(projectId,startField, endField, durationField, parentField,
                                                   exceptionField, exceptionDateField){
        DateManager.setExceptionProject(projectId,startField, endField, durationField, parentField, exceptionField,
            exceptionDateField);
    };
    this.basicProjectFieldOnChangeEnd = function(projectId,startField, endField, durationField, parentField,
                                                   exceptionField, exceptionDateField){
        DateManager.setExceptionProject(projectId,startField, endField, durationField, parentField, exceptionField,
            exceptionDateField);
    };
    this.setDateByExceptionProject = function(projectId,startField, endField, durationField, parentField,
                                              exceptionField, exceptionDateField,group){
        DateManager.setDateByExceptionProject(projectId,startField, endField, durationField, parentField,
            exceptionField, exceptionDateField,group);
    };


    this.setVisibleDateException = function(row,widget){
        var fieldDate = widget.getField('DATE_EXCEPTION');
        fieldDate.validations = null;
        if(row.DATE_EXCEPTION_ABBREVIATION == 'MB' || row.DATE_EXCEPTION_ABBREVIATION == 'MT'){
            fieldDate.isVisible = false;
            row.DATE_EXCEPTION = null;
        }else{
            fieldDate.isVisible = true;
            if(!fieldDate.readOnly){
                fieldDate.validations =  {"required": {}};
            }
        }
    };

    this.setCalendar = function(widgetCalendar){
        widgetCalendar.reload().then(function(){
            if(widgetCalendar.currentRow){
                self.calendarProject(widgetCalendar.currentRow);
            }
        });
    };
    /**
     *
     * @param  exceptions
     * @param {} fieldResource
     * @returns {*}
     */
    function joinExceptionsTask(exceptions,fieldResource){
        var idResources = fieldResource.value();
        if(Array.isArray(idResources)){
            idResources.forEach(
                function(idResource) {
                    if (idResource) {
                        fieldResource.dataSource.data.forEach(function (resource) {
                            if (resource.ID == idResource) {
                                exceptions = exceptions.concat(resource.EXCEPTION);
                            }
                        });
                    }
                }
            );
        }else{
            exceptions = [];
        }
        return exceptions;
    }
    /**
     *
     * @param row
     * @param exceptions
     * @param fieldResource
     */
    this.parseTimeTypeTask = function(row,exceptions,fieldResource){
        exceptions = angular.copy(exceptions);
        exceptions = joinExceptionsTask(exceptions,fieldResource);
        this.parseTimeType(row,exceptions);
    };

    this.setDatePrecursor = function(precursor,type,widget,row,exceptions,dateProjectBegin){
        var beginTask = widget.getField('START');
        var endTask = widget.getField('END');
        if(precursor){
            var typePrecursor = widget.getField('TYPE');
            if((type === null) || (type == 'TI') || (type === "")){
                typePrecursor.value('TI');
                var date = moment(precursor.END_TASK, 'YYYY-MM-DD');
                if(precursor.DURATION%hoursDay === 0){
                    date.add('days',1);
                }
                beginTask.value(date.format(Utilities.FORMAT_DATE_DEFAULT_ONLY_DATE));
                beginTask.readOnly = true;
                endTask.readOnly = false;
                this.parseTimeType(row,exceptions);
                this.parseDatesTask(row,exceptions);
            }else if(type == 'TT'){
                endTask.value(precursor.END_TASK);
                beginTask.readOnly = false;
                endTask.readOnly = true;
                this.parseTimeTypeByEnd(row,exceptions);
                this.parseDates(row,exceptions);
            }else if(type == 'II'){
                beginTask.value(precursor.BEGIN_TASK);
                beginTask.readOnly = true;
                endTask.readOnly = false;
                this.parseTimeType(row,exceptions);
                this.parseDatesTask(row,exceptions);
            }else if(type == 'IT'){
                endTask.value(precursor.BEGIN_TASK);
                beginTask.readOnly = false;
                endTask.readOnly = true;
                this.parseTimeTypeByEnd(row,exceptions);
                this.parseDates(row,exceptions);
            }else{
                beginTask.readOnly = false;
                endTask.readOnly = false;
            }

        }else{
            if(row.PARENT){
                widget.getField('PARENT').dataSource.data.forEach(function(taskParent){
                    if(row.PARENT==taskParent.ID){
                        row.START = taskParent.BEGIN_TASK;
                    }
                });
            }else{
                row.START = dateProjectBegin;
            }
            this.parseTimeType(row,exceptions);
            this.parseDatesTask(row,exceptions);
            beginTask.readOnly = false;
            endTask.readOnly = false;
        }

    };

    this.dateTaskParent= function(owner,dataTasks,row,exceptions){
        if(!owner.field.widget.getField('PRECURSOR').value()){
            var idTaskParent = owner.field.dataSource.data[owner.context.value].ID;
            var taskParent;
            dataTasks.forEach(function(row){
                if(row.ID == idTaskParent){
                    taskParent = row;
                }
            });
            owner.field.widget.getField('START').value(taskParent.BEGIN_DATE);
            this.parseTimeType(row,exceptions);
        }
    };

    this.deleteProjectBasic = function(args){
        var row = args.row;
        row.changed = true;
        ScreenService.confirmMessage('Deseja apagar o projeto '+row.NAME+' ?',null,function() {
            requestDataSourceEngine.setDataSource('/deleteProject',[row]).then(function(data) {
                var currentWidgetList = args.owner.widget.container.getWidget('TABBED_PROJECT_LISTS').currentWidget;
                Utilities.keepOpenList(currentWidgetList);
                ScreenService.closeSwipe().then(function(){
                    currentWidgetList.activate();
                    Utilities.localVar.setProject(0);
                });
            }).catch(Utilities.showMessageBackEndTrue);
        },null);

    };

    this.taskForEditById = function(idTask){
        var row = {
            'ID':idTask,
            'changed':true
        };
        return requestDataSourceEngine.setDataSource('/dataEditTask',[row]);
    };

    var taskDateValid = function (row, widgetBasic, validation, widgetFromTask) {
        var begin = moment(row.START, 'DD/MM/YYYY');
        var end = moment(row.END, 'DD/MM/YYYY');
        if (row.PARENT == row.PRECURSOR && !Validation.isEmpty(row.PRECURSOR)) {
            ScreenService.showMessage(Messages.ERR_SUPERIOR_TASK_SAME_PRECURSOR, null, "exclamation");
            validation = false;
        } else if (begin > end) {
            ScreenService.showMessage(Messages.ERR_START_DATE_AFTER_FINAL_DATE, null, "exclamation");
            validation = false;
        }
        return validation;
    };

    this.validateNewTask = function(row, widgetFromTask, widgetBasic){
        var validation = true;
        var taskTimePlanningSymbol = widgetFromTask.currentRow.USETIMEPLANNING;

        if (!widgetFromTask.isValid()) {
            ScreenService.showMessage(Messages.ERR_IS_VALID, null, "exclamation");
            validation = false;
        } else if(taskTimePlanningSymbol != 'N'){
            validation = taskDateValid(row, widgetBasic, validation, widgetFromTask);
        }
        return validation;
    };

    this.parseHourOrDayEdit=function(str){
        str=str.toUpperCase();
        if(str.indexOf("D") === true){
            str = parseInt(str.replace("D",""))*hoursDay;
        }
        return  str;
    };

    this.getDatesRestrictionsMinAndMax = function(projectId){
        var filter = [
            {
                "operator": "=",
                "name": "PROJECT",
                "value": projectId?projectId:0
            }
        ];
        return requestDataSourceEngine.getDataSource("/getDatesMinAndMaxByProjectId" ,filter).then(function(response){
            return response.dataset.getDatesMinAndMaxByProjectId[0];
        });
    };

    /**
     * Creates a new task or saves an existent.
     * @param widgetFromTask
     * @param widgetBasic
     * @param widgetListTask
     * @param isGeneratedTask
     */
    this.editProjectSaveTask = function(widgetFromTask, widgetBasic, widgetListTask, isGeneratedTask,currentWidgetListProject) {
        var deferred = ZHPromise.defer();
        var row = widgetFromTask.currentRow;
        if (this.validateNewTask(row, widgetFromTask, widgetBasic)) {
            if (!row.hasOwnProperty('PROJECT') && !row.PROJECT) {
                row.PROJECT = localStorageEngine.getLocalVar('project');
            }
            row.changed = true;
            requestDataSourceEngine.setDataSource('/saveNewProjectTask', [row]).then(function (data) {
                if (isGeneratedTask) {
                    if (data.dataset) {
                        widgetFromTask.taskGeneratedRow.TASK_RELATIONSHIP = data.dataset.ID[0];
                        row.__is_new = false;
                        return requestDataSourceEngine.setDataSource('/generatedTaskRelationship', [widgetFromTask.taskGeneratedRow]).then(function () {
                            widgetFromTask.list();

                            try {
                                Utilities.keepOpenList(widgetListTask);
                                if (currentWidgetListProject) {
                                    currentWidgetListProject.reload();
                                }
                                widgetFromTask.widgetGeneratedTasks.getField('TASK_RELATIONSHIP').reload();
                                ScreenService.successNotification('Tarefa gerada com sucesso!');
                            } catch (e) {
                            }
                            deferred.resolve(data);

                            return ScreenService.closeSwipe().then(function(){
                                ScreenService.closePopup(widgetFromTask.widgetGenerate);
                            });
                        });
                    }
                } else {
                    try {
                        if (data.dataset) {
                            ScreenService.successNotification('Tarefa salva com sucesso!');
                        }
                        Utilities.keepOpenList(widgetListTask);
                        row.ID = data.dataset.ID[0];
                        Utilities.localVar.setTaskId(row.ID);
                        if (currentWidgetListProject) {
                            currentWidgetListProject.reload();
                        }
                        if(row.PARENT_CHANGE || !row.ID){
                            Utilities.localVar.setLocalVarNewTaskParent({
                                'PARENT_NAME' : row.PARENT_NAME,
                                'PARENT' : row.PARENT
                            });
                        }
                        widgetFromTask.view();
                        widgetFromTask.template = widgetFromTask.templateToView;
                        deferred.resolve(data);
                    } catch (e) {
                        deferred.reject(e);
                    }
                }
            }).catch(function(response){
                Utilities.showMessageErrorOfBackEnd(response,null,null,true);
                deferred.reject();
            });
        } else {
            deferred.reject();
        }
        return deferred.promise;
    };

    this.saveGenerateTasks = function(tasks) {
        var promises = tasks.map(function(task) {
            var defer = ZHPromise.defer();
            requestDataSourceEngine.setDataSource('/saveNewProjectTask', [task]).then(function(data){
                task.RELATIONSHIP.TASK_RELATIONSHIP = data.dataset.ID[0];

                requestDataSourceEngine.setDataSource('/generatedTaskRelationship', [task.RELATIONSHIP]).then(function(){
                    defer.resolve(task);
                }).catch(function(e){
                    defer.reject(e);
                });
            }).catch(function(e){
                defer.reject(e);
            });

            return defer.promise;
        });

        return ZHPromise.all(promises);
    };

    this.generateTasksFromProjectTask = function(row) {
        return requestDataSourceEngine.setDataSource('/generateTasksFromProjectTask', [row]);

    };

    this.editProjectDeleteTask = function(widget){
        var row = {};
        var loginInfo = localStorageEngine.getLocalVar("login");
        row.ORGANIZATION = loginInfo[0].organization;
        row.PROJECT =  Utilities.localVar.getProject();
        row.TASKS = [widget.currentRow];
        row.changed = true;
        ScreenService.confirmMessage(Utilities.messages.ALE_DELETE_TASK,null,function() {
            requestDataSourceEngine.setDataSource('/deleteProjectTask', [row]).then(function (data) {
                ScreenService.closeSwipe();
                getWidgetProjectTaskList().activate();
                getWidgetProjectTaskList().reload();
            }).catch(Utilities.showMessageBackEndTrue);
        });
    };

    this.openPopUp = function(args){
        var widget = args.owner.widget.widgets[0];
        widget.reload();
        ScreenService.openPopup(widget);
    };

    this.finishPlanning = function(projectId){
        var row = {
            'ID':projectId,
            'changed':projectId
        };
        return requestDataSourceEngine.setDataSource('/projectFinishPlanning',[row]);
    };

    this.editResourceDelete = function(args){
        var row = {};
        var basicInformationResourceWidget = getWidgetBasicInformationResource();
        var projectResourceListWidget = getWidgetProjectResourceList();
        var currentRow = basicInformationResourceWidget.currentRow;
        currentRow.ID_BASE = Utilities.localVar.getProjectResource();
        row.CHECKED_ROWS = [currentRow];
        row.PROJECT = localStorageEngine.getLocalVar('project');
        row.changed = true;
        var widgetList = basicInformationResourceWidget;
        function deleteResourceProject(widgetList,row){
            requestDataSourceEngine.setDataSource('/deleteProjectResource',[row]).then(function(){
                    ScreenService.closeSwipe().then(function(){
                        widgetList.unSelectAll();
                        projectResourceListWidget.reload().then(function(){
                            projectResourceListWidget.activate();
                        });
                    });
                });
        }
        ScreenService.showCustomDialog(Utilities.messages.DES_DELETE_RESOURCE_PROJECT, Utilities.MESSAGE_TYPE_CONFIRMATION, null,
            [
                {
                    "label": "Sim",
                    "code":function(){
                        row.recursive = true;
                        deleteResourceProject(widgetList,row);
                    }
                },
                {
                    "label": "Não",
                    "code":function(){
                        row.recursive = false;
                        deleteResourceProject(widgetList,row);
                    }
                }
            ]
        );
    };

    this.resourceListClicked = function(checkedRows,widgetList){
        var row ={};
        row.RESOURCES = checkedRows;
        row.PROJECT = localStorageEngine.getLocalVar('project');
        row.changed = true;
        function addResourceProject(widgetList,row){
            requestDataSourceEngine.setDataSource('/editProjectResource',[row]).then(function(data){
                widgetList.reload();
                widgetList.widgets[0].unSelectAll();
                widgetList.container.restoreDefaultMode();
                ScreenService.closePopup();
            });
        }
        ScreenService.showCustomDialog(Utilities.messages.DES_ADD_RESOURCE_PROJECT, Utilities.MESSAGE_TYPE_CONFIRMATION,null,
            [
                {
                    "label": "Sim",
                    "code":function(){
                        row.recursive = true;
                        addResourceProject(widgetList,row);
                    }
                },
                {
                    "label": "Não",
                    "code":function(){
                        row.recursive = false;
                        addResourceProject(widgetList,row);
                    }
                },
                {
                    "label": "Cancelar",
                    "code":''
                }
            ]
        );
    };

    this.parseDates = function(row, exceptions){
        row.START = row.START.split("/").reverse().join("-");
        row.END = row.END.split("/").reverse().join("-");
        row.TOTAL_TIME = DateManager.calculateDateDifference(row, exceptions, calendarWeek);
        row.START = row.START.split("-").reverse().join("/");
        row.END = row.END.split("-").reverse().join("/");
    };

    this.parseDatesTask = function(row, exceptions){
        this.parseDates(row, exceptions);
        this.parseTimeTypeByEnd(row, exceptions);

    };

    this.getDateBegin = function(row,beginTaskPrecursor,endTaskPrecursor,beginTaskParent,endTaskParent,exceptions,previousTime){
        DateManager.getDateBegin(row,beginTaskPrecursor,endTaskPrecursor,beginTaskParent,endTaskParent,hoursDay,calendarWeek,exceptions,previousTime);
    };

    this.parseManager = function(widget){
        var groupField = widget.getField('GROUP_NAME');

        return groupField.reload().then(function(data){
            var groups = groupField.dataSource.data;
            var parent;
            groups.forEach(function(group){
                parent = null;
                groups.forEach(function(possibleParent){
                    if(possibleParent.ID === group.PARENT){
                        parent = possibleParent.ID;
                    }
                });
                group.PARENT = parent;
            });
            templateManager.updateTemplate();
        });
    };

    this.parseDataNumber = function(number){
        return (number >= 10? number : "0"+number);
    };

    this.onEnterProject = function(args) {
        args.e.stopPropagation();
        var widgetProjectList = args.owner;
        widgetProjectList.dataSourceFilter = [];
        Utilities.keepOpenList(widgetProjectList);
        widgetProjectList.activate();
    };

    this.doSaveProjectStatus = function(row, widget) {
        self.saveProjectStatus(row).then(function (response) {
            if(response.dataset) {
                widget.currentRow.ID = response.dataset.projectStatus[0].ID;
            }
            widget.view();
        }).catch(Utilities.showMessageBackEndTrue);
    };
    
    this.findTaskResponsesRelatedSameProject = function (project_id) {
        var filter = [
            {
                name: 'PROJECT_ID',
                operator: '=',
                value: project_id
            }
        ];
        return requestDataSourceEngine.getDataSource('/findTaskResponsesRelatedSameProject', filter);
    };
    
    this.findTaskResponsesRelatedSameIssue = function (issue_id) {
        var filter = [
            {
                name: 'ISSUE_ID',
                operator: '=',
                value: issue_id
            }
        ];
        return requestDataSourceEngine.getDataSource('/findTaskResponsesRelatedSameIssue', filter);
    };
    
    this.sendMailConcludedProject = function (row) {
        
        var filter = [
            {
                name: 'ROW',
                operator: '=',
                value: row
            }
        ];
        
        return requestDataSourceEngine.getDataSource('/sendMailConcludedProject', filter).then(function(data){
                ScreenService.closePopup();
            });
    };


    this.onEnterProjectList = function(args, initFilterProjects) {
        ScreenService.closeSwipe();
        args.e.stopPropagation();
        var widgetProjectList = args.owner;
        widgetProjectList.container.getWidget('NEW_RESOURCES').reload();
        widgetProjectList.activate();
        editProjectForm = [];
        localStorageEngine.setLocalVar('project',null);
        localStorageEngine.setLocalVar('projectEdit',null);
        var basicWidget = widgetProjectList.container.getWidget('BASIC');
        this.parseManager(basicWidget);
    };

    this.editProjectBasic = function(args){
        editProjectForm = args.row;
        localStorageEngine.setLocalVar("MANAGERID",args.row.MANAGER_ID);
        args.owner.widget.edit();
        args.owner.widget.template = "widget/form.html";
    };

    this.dateProjectValid = function (row, validate) {
        var begin = moment(row.START, Utilities.FORMAT_DATE_DEFAULT_ONLY_DATE);
        var end = moment(row.END, Utilities.FORMAT_DATE_DEFAULT_ONLY_DATE);
       if (!row.START) {
            ScreenService.showMessage(Messages.ERR_START_DATE, 'ALERT');
            validate = false;
        } else if (!row.END) {
            ScreenService.showMessage(Messages.ERR_FINAL_DATE, 'ALERT');
            validate = false;
        } else if (!row.TOTAL_TIME) {
            ScreenService.showMessage(Messages.ERR_TOTAL, 'ALERT');
            validate = false;
        } else if (begin > end && validate) {
            ScreenService.showMessage(Messages.ERR_START_DATE_AFTER_FINAL_DATE, null, "exclamation");
            validate = false;
        }
        return validate;
    };
    this.validateFields = function(row){
        var validate = true;
        if (!row.NAME) {
            ScreenService.showMessage(Messages.ERR_NAME, 'ALERT');
            validate = false;
        } else if (!row.SPONSOR_NAME) {
            ScreenService.showMessage(Messages.ERR_SPONSOR, 'ALERT');
            validate = false;
        } else if (!row.MANAGER) {
            ScreenService.showMessage(Messages.ERR_MANAGER, 'ALERT');
            validate = false;
        } else if (!row.GROUP_NAME) {
            ScreenService.showMessage(Messages.ERR_GROUP, 'ALERT');
            validate = false;
        } else if(row.USETIMEPLANNING != 'N'){
            validate = this.dateProjectValid(row, validate);
        }
        return validate;
    };

    this.validateProject = function(row) {
        var validate = true;
        if (!row.NAME) {
            ScreenService.showMessage(Messages.ERR_NAME, 'ALERT');
            validate = false;
        } else if (!row.SPONSOR_NAME) {
            ScreenService.showMessage(Messages.ERR_SPONSOR, 'ALERT');
            validate = false;
        } else if (!row.MANAGER) {
            ScreenService.showMessage(Messages.ERR_MANAGER, 'ALERT');
            validate = false;
        } else if (!row.GROUP_NAME) {
            ScreenService.showMessage(Messages.ERR_GROUP, 'ALERT');
            validate = false;
        } else if (row.USETIMEPLANNING != 'N') {
            validate = this.dateProjectValid(row, validate);
        }

        return validate;
    };

    this.saveBasic = function(widget, widgetList){
        var row = widget.currentRow;
        row.changed = true;
        var save = function(row){
            widget.dataSource.data = [row];
            return widget.saveRow().then(function(data) {
            
                ScreenService.successNotification('Projeto salvo com sucesso!');
                templateManager.updateTemplate();
                widget.view();
                widget.currentRow.ID = data.dataset.ProjectId[0];
                localStorageEngine.setLocalVar('NewSprrintProject',data.dataset.ProjectId[0]);
                localStorageEngine.setLocalVar('projectVersionDev', widget.currentRow.VERSION_DEV);
                localStorageEngine.setLocalVar('projectVersionDevId', widget.currentRow.PRODUCT_VERSION_DEV_ID);
                widget.template = widget.formTemplate;
                widgetList.reload();
            }, function(data) {
                Utilities.showMessageErrorOfBackEnd(data,null,null,true);
                throw data;
            });
        };

        var messageSponsor =  function(row) {
            if (row.BEGIN_SPONSOR != row.SPONSOR) {
                return ScreenService.showCustomDialog(Utilities.messages.ALE_KEEP_SPONSOR_AS_RESOURCE, 'CONFIRMATION', null,
                    [
                        {
                            "label": "Sim",
                            "code": function (e, deferred) {
                                row.MERGE_SPONSOR = true;
                                save(row).then(function () {
                                    deferred.resolve(e);
                                });
                            }
                        },
                        {
                            "label": "Não",
                            "code": function (e, deferred) {
                                row.MERGE_SPONSOR = false;
                                ScreenService.showCustomDialog(Utilities.messages.ALE_REMOVE_SPONSOR_FROM_RELATED_PROJECT, 'CONFIRMATION', null,
                                    [
                                        {
                                            "label": "Sim",
                                            "code": function (e, deferred) {
                                                row.RECURSIVE_SPONSOR = true;
                                                save(row).then(function () {
                                                    deferred.resolve(e);
                                                });
                                            }
                                        },
                                        {
                                            "label": "Não",
                                            "code": function (e, deferred) {
                                                row.RECURSIVE_SPONSOR = false;
                                                save(row).then(function () {
                                                    deferred.resolve(e);
                                                });
                                            }
                                        },
                                        {
                                            "label": "Cancelar",
                                            "code": function(e, deferred) {
                                                row.MERGE_OLD_MANAGER = [];
                                                row.MERGE_NEW_MANAGER = [];
                                                row.RECURSIVE_SPONSOR = false;
                                                row.MERGE_SPONSOR = false;
                                                deferred.reject(e);
                                            }
                                        }
                                    ]
                                ).then(function () {
                                    deferred.resolve(e);
                                });
                            }
                        },
                        {
                            "label": "Cancelar",
                            "code": function(e, deferred) {
                                row.MERGE_OLD_MANAGER = [];
                                row.MERGE_NEW_MANAGER = [];
                                row.RECURSIVE_SPONSOR = false;
                                row.MERGE_SPONSOR = false;
                                deferred.reject(e);
                            }
                        }
                    ]
                );
            } else {
                return save(row);
            }
        };
        
        var messageAddManager = function () {
            if(newManagers.length > 0){
                return ScreenService.showCustomDialog(Utilities.messages.ALE_ADD_MANAGER_FROM_RELATED_PROJECT, 'CONFIRMATION', null,
                    [
                        {
                            "label": "Sim",
                            "code": function (e, deferred) {
                                row.MERGE_NEW_MANAGER = newManagers;
                                messageSponsor(row).then(function () {
                                    deferred.resolve(e);
                                });
                            }
                        },
                        {
                            "label": "Não",
                            "code": function (e, deferred) {
                                row.MERGE_NEW_MANAGER = [];
                                messageSponsor(row).then(function () {
                                    deferred.resolve(e);
                                });
                            }
                        },
                        {
                            "label": "Cancelar",
                            "code": function(e, deferred) {
                                row.MERGE_OLD_MANAGER = [];
                                row.MERGE_NEW_MANAGER = [];
                                deferred.reject(e);
                            }
                        }
                    ]
                );
            }else{
                return messageSponsor(row);
            }
        };
        
        if(this.validateFields(row) ) {
            if(row.ID) {
                if(!Utilities.isArrayValuesUniqueSameValues(row.BEGIN_MANAGER,row.MANAGER)) {
                    var diffManagers = Utilities.getDiffInArrays(row.BEGIN_MANAGER,row.MANAGER);
                    var oldManagers = diffManagers[0];
                    var newManagers = diffManagers[1];
                    if(oldManagers.length > 0) {
                        return ScreenService.showCustomDialog(Utilities.messages.ALE_REMOVE_MANAGER_FROM_RELATED_PROJECT,'CONFIRMATION',null,
                            [
                                {
                                    "label": "Sim",
                                    "code":function(e, deferred){
                                        row.MERGE_OLD_MANAGER = oldManagers;
                                        messageAddManager(row).then(function(){
                                            deferred.resolve(e);
                                        });
                                    }
                                },
                                {
                                    "label": "Não",
                                    "code": function(e, deferred) {
                                        row.MERGE_OLD_MANAGER = [];
                                        messageAddManager(row).then(function(){
                                            deferred.resolve(e);
                                        });
                                    }
                                },
                                {
                                    "label": "Cancelar",
                                    "code": function(e, deferred) {
                                        row.MERGE_OLD_MANAGER = [];
                                        row.MERGE_NEW_MANAGER = [];
                                        deferred.reject(e);
                                    }
                                }
                            ]
                        );

                    } else {
                        return messageAddManager();
                    }
                } else {
                    return messageSponsor(row);
                }
            } else {
                return save(row);
            }
        }
    };

    this.getBasicProjectInfo = function(projectId) {
        var filter = [
            {
                "operator": "=",
                "name": "PROJECT",
                "value": projectId
            }
        ];
        return requestDataSourceEngine.getDataSource('/basicProjectForm', filter).then(function(response){
            return response.dataset.basicProjectForm[0];
        }).catch(function(response){
            Utilities.showMessageBackEndTrue(response);
            throw response;
        });
    };
    
    
    this.getHeadSprintProject = function(projectId) {
        var filter = [
            {
                "operator": "=",
                "name": "PROJECT",
                "value": projectId
            }
        ];
        return requestDataSourceEngine.getDataSource('/getHeadSprintProject', filter).then(function(response){
            return response.dataset.headSprintProject[0];
        }).catch(function(response){
            Utilities.showMessageBackEndTrue(response);
            throw response;
        });
    };
    
    this.getTailSprintProject = function(projectId) {
        var filter = [
            {
                "operator": "=",
                "name": "PROJECT",
                "value": projectId
            }
        ];
        return requestDataSourceEngine.getDataSource('/getTailSprintProject', filter).then(function(response){
            return response.dataset.tailSprintProject[0];
        }).catch(function(response){
            Utilities.showMessageBackEndTrue(response);
            throw response;
        });
    };
    
    this.getBasicModelProject = function(projectModelId) {
        var filter = [
            {
                "operator": "=",
                "name": "PROJECT",
                "value": projectModelId
            }
        ];
        return requestDataSourceEngine.getDataSource('/getBasicModelProject', filter).then(function(response){
            return response.dataset.getBasicModelProject[0];
        }).catch(function(response){
            Utilities.showMessageBackEndTrue(response);
            throw response;
        });
    };


    this.getAllResourcesAllowedToConcludeTask = function(currentRow) {
        var filter = [
            {
                "operator": "=",
                "name": "TASK",
                "value": currentRow.ID
            }
        ];
        return requestDataSourceEngine.getDataSource('/getAllowedResourcesToCompleateTheTask', filter).then(function(response){
            return response.dataset.findAllTaskRelatedResource[0];
        });
    };
    this.setDateParentProject = function(field,row){
        var dateBegin = null;
        field.dataSource.data.forEach(function(project){
            if(project.ID == row.UPPER_PROJECT){
                if(project.USETIMEPLANNING == 'Y'){
                    dateBegin = project.BEGIN_DATE;
                }
            }
        });
        if(dateBegin){
            field.widget.getField('START').value(dateBegin);
            field.widget.getField('END').value(dateBegin);
            row.BEGINPARENT = dateBegin;
        }else{
            row.BEGINPARENT = null;
        }

    };

    this.projectOnListClicked = function(args){
        var widgetForm = args.owner.container.widgets[1];
        widgetForm.showForm = true;
        widgetForm.formTemplate = "widget/tabbedWidget.html";
        var widgetold = widgetForm.container.getActiveWidget();
        ScreenService.openSwipe(widgetForm);
        widgetForm.widgets.forEach(function(widget){
            widget.isVisible = true;
        });
        widgetold.activate();
        widgetold.reload();
        localStorageEngine.setLocalVar('project',args.row.ID);
        this.projectId = args.row.ID;

    };

    this.loadProjectsWithSameManager = function(copy) {
        var filter = [
            {
                name: 'projectId',
                operator: '=',
                value: copy ? 0 : localStorageEngine.getLocalVar('project')
            }
        ];

        // adding others filters
        if(typeof arguments[1] != "undefined"){
            arguments[1].forEach(function(obj){
                filter.push(obj);
            });
        }
        return localStorageEngine.remove("/projectSameManager", []).then(function(){
            return localStorageEngine.download("/projectSameManager", filter);
        });
    };

    this.clearTaskList = function() {
        return localStorageEngine.setDataSource("/taskParent", []);
    };

    this.getClassification = function(filter) {
        return requestDataSourceEngine.getDataSource("/classification", filter);
    };

    this.loadTasksByProject = function(projectId, selectedTasksIds) {
        var filter = [
            {
                name: "projectId",
                operator: '=',
                value: projectId
            },
            {
                name: "allTasks",
                operator: '=',
                value: 0
            },
            {
                name: "selectedTasksIds",
                operator: "=",
                value: selectedTasksIds
            }
        ];
        return localStorageEngine.download("/taskParent", filter);
    };


    function __onlyParent(task) {
        if(task._parent) {
            if(task._parent.__isSelected) {
                return false;
            } else {
                return __onlyParent(task._parent);
            }
        } else {
            return true;
        }
    }

    this.validateRepositoriesMoveTask = function(targetProject, tasksToMove) {
        var filter = [ {
            "operator": "=",
            "name": "PROJECT",
            "value": targetProject
        }, {
            "operator": "=",
            "name": "TASKS",
            "value": tasksToMove
        } ];

        return requestDataSourceEngine.getDataSource('/validateRepositoriesMoveTask', filter);
    };

    this.moveTask = function (targetProject, targetTask, replanningReasonId, tasksToMove, addDifferentResources, differentResourcesIds, taskIdsNotMoved) {
        var parentTasks = tasksToMove.filter(__onlyParent);
        var tasksToRequest = [];
        parentTasks.forEach(function(task) {
            tasksToRequest.push(task.ID);
        });
        return restEngine.post("/moveTask",
            {
                requestType: "DataSet",
                dataset: [
                    {targetProject: targetProject},
                    {targetTask: targetTask},
                    tasksToRequest,
                    {projectId:  Utilities.localVar.getProject()},
                    {addDifferentResources: addDifferentResources},
                    {differentResourcesIds: differentResourcesIds},
                    {replanningReasonId: replanningReasonId},
                    {taskIdsNotMoved: taskIdsNotMoved}
                ]
            }
        );
    };

    this.copyTask = function (targetProject, targetTask, tasksToMove, addDifferentResources, differentResourcesIds, useMnemonic) {
        useMnemonic = useMnemonic || false;
        var parentTasks = tasksToMove.filter(__onlyParent);
        var tasksToRequest = [];
        parentTasks.forEach(function(task) {
            var infoIdTask = {};
            infoIdTask.VERSION_ID =  task.VERSION_DEV_ID;
            infoIdTask.TASK_ID = task.ID;
            tasksToRequest.push(infoIdTask);
        });
        return restEngine.post("/copyTask",
            {
                requestType: "DataSet",
                dataset: [
                    {targetProject: targetProject},
                    {targetTask: targetTask},
                    tasksToRequest,
                    {projectId: Utilities.localVar.getProject()},
                    {addDifferentResources: addDifferentResources},
                    {differentResourcesIds: differentResourcesIds},
                    {useMnemonic: useMnemonic}
                ]
            }
        );
    };

    this.openNewSubProject = function(row,calendar,listExceptions,listResources){
        row.CALENDAR = calendar;
        row.LIST_EXCEPTION = listExceptions;
        row.LIST_RESOURCES = listResources;
        localStorageEngine.setLocalVar('projectEdit',row);
    };

    this.newTaskStatus = function(row){
        return requestDataSourceEngine.setDataSource('/newTaskStatus', [row]);
    };

    this.newTaskType = function(row){
        return requestDataSourceEngine.setDataSource('/newTaskType', [row]);
    };

    this.newUploadDocumentTask = function(row){
        if(!row.projectId){
            row.projectId = localStorageEngine.getLocalVar('project');
        }
        if(!row.taskId){
            row.taskId = localStorageEngine.getLocalVar('taskProject');
        }
        return requestDataSourceEngine.setDataSource('/newUploadDocumentTask', [row]);
    };

    this.newUploadDocumentProject = function(row) {
        row.projectId = localStorageEngine.getLocalVar('project');
        return requestDataSourceEngine.setDataSource('/newUploadDocumentProject', [row]);
    };

    this.downLoadAttachment = function(row){
        Utilities.downloadAttachment(row.ID);
    };
    
    this.checkIfRelatedTasksHasSameAttachment = function(attachmentId){
        
        var filter = [
            {
                "operator": "=",
                "name": "ATTACHMENT",
                "value": attachmentId
            }
        ];
        
        return requestDataSourceEngine.getDataSource("/checkIfRelatedTasksHasSameAttachment", filter).then( function(response) {
            var data = response.dataset.relatedTasks;
            return data;
        });
    };

    this.deleteAttachment = function(dataSet){
        return restEngine.post("/deleteAttachment",
            {
                requestType: "DataSet",
                dataset: dataSet
            }
        );
    };

    this.setProjectController = function(projectController){
        ProjectController = projectController;
    };

    this.recalculateProject = function(max,callBack){
        var projectId = Utilities.localVar.getProject();
        var filter = [
            {
                "operator": "=",
                "name": "PROJECT",
                "value": projectId
            }
        ];
        ScreenService.changeLoadingMessage(ScreenService.i18n(Utilities.messages.LOAD_RECALC_TASKS)+max+'/'+max);
        ScreenService.showLoader();
        return requestDataSourceEngine.getDataSource("/recalculateProject" ,filter,null,null,null,null,null,600000).then(function() {
            callBack();
            ScreenService.hideLoader();
            return true;
        }).catch(function(){
            ScreenService.hideLoader();
            ScreenService.restoreDefaultLoadingMessage();
            return false;
        });
    };

    this.recalculateTasks = function(taskId, index, max) {
        var filter = [
            {
                "operator": "=",
                "name": "TASK_ID",
                "value": taskId
            }
        ];
        ScreenService.changeLoadingMessage(ScreenService.i18n(Utilities.messages.LOAD_RECALC_TASKS)+index+'/'+max);
        ScreenService.showLoader();
        return requestDataSourceEngine.getDataSource("/recalculateTasks" ,filter,null,null,null,null,null,600000).then(function() {
            ScreenService.hideLoader();
            return true;
        }).catch(function(){
            ScreenService.hideLoader();
            ScreenService.restoreDefaultLoadingMessage();
            return false;
        });
    };
    this.getHoursDay = hoursDay;

    /*  Saves a project status */
    this.saveProjectStatus = function(currentRow){
        var row = currentRow;
            row.changed = true;
        return requestDataSourceEngine.setDataSource('/projectStatus', [row]);
    };

    /*  Saves a project status */
    this.saveTaskEstimatedPointsInLine = function(currentRow){
        return requestDataSourceEngine.setDataSource('/taskEstimatedPoints', currentRow);
    };
    
    this.changeMnemonicName = function(currentRow, row){
        row.changed = true;
        row.NEWNAME = currentRow.NEWNAME;
        row.OLDNAME = currentRow.NAME;
        return requestDataSourceEngine.setDataSource('/changeMnemonicName', [row]);
    };

    this.removeProjectStatus = function(row){
        return requestDataSourceEngine.setDataSource('/projectStatus/remove', [row]);
    };

    /************************************************************
     * Shows or hides the columns of project tasks list when the
     * task does not use time planning.
     * @param fields
     ************************************************************/
    this.hideProjectTasksColumnsByTimePlanning = function(fields) {
        if(!Util.isArray(fields)){
            return Utilities.buildErrorMessage.invalidArgument(REGISTERED_NAME, "hideProjectTasksColumnsByTimePlanning",
                "array of fields", fields[0], "1st");
        }

        var time = Utilities.localVar.getClickedProjectUseTimePlanning();
        fields.forEach(function(field){
            field.isVisible = (time !== 'N');
        });
    };

    /************************************************************
     * Shows or hides the columns of project tasks list when the
     * task can not be finished.
     * @param fields
     ************************************************************/
    this.hideProjectTasksColumnsByAllowEndTasks = function(fields){
        if(!Util.isArray(fields)) return Utilities.buildErrorMessage.invalidArgument(REGISTERED_NAME, "hideProjectTasksColumnsByAllowEndTasks", "array of fields", fields[0], "1st");
        var allow = Utilities.localVar.getClickedProjectAllowEndTasks();
        fields.forEach(function(field){
            field.isVisible = (allow !== 'N');
        });
    };

    /************************************************************
     * Changes the begin hour column name of appropriations list
     * when the task does not have time planning.
     * @param field
     ************************************************************/
    this.changeLabelProjectTasksBeginHourColumnByTimePlanning = function(field){
        if(!Util.isObject(field)) return Utilities.buildErrorMessage.invalidArgument(REGISTERED_NAME, "changeLabelProjectTasksBeginHourColumnByTimePlanning", "field object", field, "1st");
        if(Utilities.localVar.getClickedProjectUseTimePlanning() === 'N'){
            field.label = "Data da apropriação";
        } else {
            field.label = "Início";
        }
    };


    this.getProfileByCurrentUser = function(){
        return requestDataSourceEngine.getDataSource('/getProfileByCurrentUser');
    };

    /************************************************************
     * Get a list of resources that are included (allocated) in
     * a task, but are not allocated in a project.
     * * @param originTaskIds
     * @param targetProjectId
     ************************************************************/
    this.differentResourcesBetweenTargetProjectOriginTask = function(originTaskIds, targetProjectId){
        var filter = [
            {
                "operator": "=",
                "name": "taskIds",
                "value": originTaskIds
            },
            {
                "operator": "=",
                "name": "projectId",
                "value": parseInt(targetProjectId)
            }
        ];

        return requestDataSourceEngine.getDataSource('/differentResourcesBetweenProjectAndTask', filter);
    };

    this.findMergeRequestTasks = function(tasksIds){
        var filter = [
            {
                "operator": "IN",
                "name": "TASK",
                "value": tasksIds
            }
        ];

        return requestDataSourceEngine.getDataSource('/findMergeRequestByTask', filter);
    };

    this.setRelatedTasks = function(tasksIds){
        var filter = [
            {
                "operator": "IN",
                "name": "TASK",
                "value": tasksIds
            }
        ];

        return requestDataSourceEngine.getDataSource('/getRelatedTasks', filter).then(function(response){
            return response.dataset.getRelatedTasks;
        });
    };

    var self = this;
    
    this.needTaskReplanningReason = function(originProjectId){
        var filter = [
            {
                "operator": "=",
                "name": "ORINGIN_PROJECT_ID",
                "value": originProjectId
            }
        ];
        return requestDataSourceEngine.getDataSource('/needTaskReplanningReason', filter);
    };
    
    this.validateConcludedTaskToMove = function (tasks, projectId, targetProjectId) {
        var filter = [
            {
                "operator": "=",
                "name": "TASKS",
                "value": tasks
            },
            {
                "operator": "=",
                "name": "PROJECT_ID",
                "value": projectId
            },
            {
                "operator": "=",
                "name": "TARGET_PROJECT_ID",
                "value": targetProjectId
            }
        ];
        return requestDataSourceEngine.getDataSource('/validateConcludedTaskToMove', filter).then(function(response){
            return response.dataset.validateConcludedTaskToMove;
        }).catch(Utilities.showMessageBackEndTrue);
    };

    this.validateConcludedSubrelease = function (projectId) {
        var filter = [
            {
                "operator": "=",
                "name": "PROJECT_IDS",
                "value": projectId
            }
        ];
        return requestDataSourceEngine.getDataSource('/validateConcludedSubrelease', filter).then(function(response){
            return response.dataset.validateConcludedSubrelease;
        }).catch(Utilities.showMessageBackEndTrue);
    };

    this.hasErrorTypeChildrenProjects = function (projectId) {
        var filter = [
            {
                "name": "PROJECT_ID",
                "operator": "=",
                "value": projectId
            }
        ];
        return requestDataSourceEngine.getDataSource('/hasErrorTypeChildrenProjects', filter);
    };

    this.projectHasTaskNotIsParent = function (projectId) {
        var filter = [
            {
                "name": "PROJECT_ID",
                "operator": "=",
                "value": projectId
            },
            {
                "name": "IS_PARENT",
                "operator": "=",
                "value": 'N'
            }
        ];
        return requestDataSourceEngine.getDataSource('/projectHasTask', filter).then(function (response){
            return response.dataset.projectHasTask[0];
        });
    };

    this.projectHasMnemonic = function (idValue, isCopyTask ) {
        var filter = [
            {
                "name": "ID",
                "operator": "=",
                "value": idValue
            },
            {
                "name": "isCopyTask",
                "operator": "=",
                "value": isCopyTask
            }
        ];
        return requestDataSourceEngine.getDataSource('/findProjectsMnemonics', filter).then(function (response){
            return response.dataset.projectHasMnemonic;
        });
    };

    this.hasProjectWithLtsSubReleaseFinalized = function (projectId) {
        var filter = [{
                "name": "PROJECT_ID",
                "operator": "=",
                "value": projectId
            }
        ];
        return requestDataSourceEngine.getDataSource('/hasProjectWithLtsSubReleaseFinalized', filter).then(function (response) {
            return response.dataset.hasProjectWithLtsSubReleaseFinalized[0];
        });
    };

    this.hasErrorTypeChildrenProjectsAndHasProjectWithLtsSubReleaseFinalized = function(){
        var filter = [{
            "name": "PROJECT_ID",
            "operator": "=",
            "value": projectId
        }];
        return requestDataSourceEngine.getDataSource('/hasErrorTypeChildrenProjectsAndHasProjectWithLtsSubReleaseFinalized', filter).then(function (response) {
            return response.dataset.hasErrorTypeChildrenProjectsAndHasProjectWithLtsSubReleaseFinalized[0];
        });
    };

    this.taskHasBranch = function (tasks, targetProjectId, projectId) {
        var filter = [
            {
                "operator": "=",
                "name": "TASKS",
                "value": tasks
            },
            {
                "operator": "=",
                "name": "TARGET_PROJECT_ID",
                "value": targetProjectId
            },
            {
                "operator": "=",
                "name": "PROJECT_ID",
                "value": projectId
            }
        ];
        return requestDataSourceEngine.getDataSource('/taskHasBranch', filter);
    };

    this.validateParentProjectChoiceByUser = function(row){
        var filter = [
            {
                "name": "PROJECT_ID",
                "operator": "=",
                "value": row.ID
            },
            {
                "name": "PARENT_PROJECT_ID",
                "operator": "=",
                "value": row.UPPER_PROJECT
            }
        ];
        return requestDataSourceEngine.getDataSource('/validateParentProjectChoiceByUser', filter);
    };

    this.productProjectHasAllowReplicationLts = function(projectParent){
        var filter = [
            {
                "name": "PROJECT_ID",
                "operator": "=",
                "value": projectParent
            }
        ];
        return requestDataSourceEngine.getDataSource('/productProjectHasAllowReplicationLts', filter);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ProjectServiceList', ProjectServiceList);
});


// FILE: assets/js/Service/ProjectListAgile.js
/**
 * Created by tuliomagalhaes on 25/08/14.
 */

function ProjectServiceListAgile(requestDataSourceEngine,ScreenService,ProjectTaskRepository,ProjectResourceRepository,templateManager,CalendarService,DateManager, localStorageEngine, restEngine,Validation, Messages){
    var CalendarConst = {
        HOURSDAY : 24,
        BEGINWEEKBASIC : "Sunday",
        ENDWEEKBASIC : "Saturday",
        BEGINHOUR : '00:00',
        ENDHOUR : '23:59'
    };
    var projectDataListOld;
    var container = null;
    var popUp;
    var idCount = 0;
    var editProjectForm;
    var hoursDay = CalendarConst.HOURSDAY;
    var beginWeek = CalendarConst.BEGINWEEKBASIC;
    var endWeek = CalendarConst.ENDWEEKBASIC;
    var beginHour = CalendarConst.BEGINHOUR;
    var endHour = CalendarConst.ENDHOUR;
    this.projectId = 0;
    var ProjectController;

    this.calendarHourCheck = function(currentRowCalendar){
        /*currentRowCalendar.HOUR ?        hoursDay = currentRowCalendar.HOUR         : hoursDay = CalendarConst.HOURSDAY;
        currentRowCalendar.BEGIN_HOUR ?  beginHour = currentRowCalendar.BEGIN_HOUR  : beginHour = CalendarConst.BEGINHOUR;
        currentRowCalendar.END_HOUR ?    endHour = currentRowCalendar.END_HOUR      : endHour = CalendarConst.ENDHOUR;
        currentRowCalendar.BEGIN_WEEK ?  beginWeek = currentRowCalendar.BEGIN_WEEK  : beginWeek = CalendarConst.BEGINWEEKBASIC;
        currentRowCalendar.END_WEEK ?    endWeek = currentRowCalendar.END_WEEK      : endWeek = CalendarConst.ENDWEEKBASIC;*/

        if(currentRowCalendar.HOUR){
            hoursDay = currentRowCalendar.HOUR;
        }else{
            hoursDay = CalendarConst.HOURSDAY;
        }
        if(currentRowCalendar.BEGIN_HOUR){
            beginHour = currentRowCalendar.BEGIN_HOUR;
        }else{
            beginHour = CalendarConst.BEGINHOUR;
        }
        if( currentRowCalendar.END_HOUR){
            endHour = currentRowCalendar.END_HOUR;
        }else{
            endHour = CalendarConst.ENDHOUR;
        }
        if(currentRowCalendar.BEGIN_WEEK){
            beginWeek = currentRowCalendar.BEGIN_WEEK;
        }else{
            beginWeek = CalendarConst.BEGINWEEKBASIC;
        }
        if(currentRowCalendar.END_WEEK){
            endWeek = currentRowCalendar.END_WEEK;
        }else{
            endWeek = CalendarConst.ENDWEEKBASIC;
        }

    };



    this.goBackProject = function(){
        ScreenService.openWindow('product#projects');
    };

    this.parseTimeTypeByEnd = function(row,exceptions){
        row.START = row.START.split("/").reverse().join("-");
        row.END = row.END.split("/").reverse().join("-");
        row.START = DateManager.parseTimeTypeByEnd(hoursDay,beginWeek,endWeek,beginHour,endHour,row,exceptions);
        row.START = row.START.split("-").reverse().join("/");
        row.END = row.END.split("-").reverse().join("/");
    };

    this.parseTimeType = function(row,exceptions){
        row.START = row.START.split("/").reverse().join("-");
        row.END = row.END.split("/").reverse().join("-");
        row.END = DateManager.parseTimeType(hoursDay,beginWeek,endWeek,beginHour,endHour,row,exceptions);
        row.START = row.START.split("-").reverse().join("/");
        row.END = row.END.split("-").reverse().join("/");
    };
    /**
     *
     * @param  exceptions
     * @param {} fieldResource
     * @returns {*}
     */
    function joinExceptionsTask(exceptions,fieldResource){
        var idResource = fieldResource.value();
        if(idResource){
            fieldResource.dataSource.data.forEach(function(resource){
                if(resource.ID== idResource){
                    exceptions.push(resource);
                }
            });
        }
        return exceptions;
    }
    /**
     *
     * @param row
     * @param exceptions
     * @param fieldResource
     */
    this.parseTimeTypeTask = function(row,exceptions,fieldResource){
        exceptions = angular.copy(exceptions);
        exceptions = joinExceptionsTask(exceptions,fieldResource);
        this.parseTimeType(row,exceptions);
    };

    this.setDatePrecursor = function(precursor,type,widget,row,exceptions,dateProjectBegin){
        var beginTask = widget.getField('START');
        var endTask = widget.getField('END');
        if(precursor){
            var typePrecursor = widget.getField('TYPE');
            if((type === null) || (type === 'TI') || (type === '')){
                typePrecursor.value('TI');
                if(precursor.DURATION%hoursDay === 0){
                    var date = moment(precursor.END_TASK, 'YYYY-MM-DD');
                    date.add('days',1);
                    date.format('YYYY-MM-DD');
                    beginTask.value(date.format('YYYY-MM-DD'));
                }else{
                    beginTask.value(precursor.END_TASK);
                }
                beginTask.readOnly = true;
                endTask.readOnly = false;
                this.parseTimeType(row,exceptions);
                this.parseDatesTask(row,exceptions);
            }else if(type == 'TT'){
                endTask.value(precursor.END_TASK);
                beginTask.readOnly = false;
                endTask.readOnly = true;
                this.parseTimeTypeByEnd(row,exceptions);
                this.parseDates(row,exceptions);
            }else if(type == 'II'){
                beginTask.value(precursor.BEGIN_TASK);
                beginTask.readOnly = true;
                endTask.readOnly = false;
                this.parseTimeType(row,exceptions);
                this.parseDatesTask(row,exceptions);
            }else if(type == 'IT'){
                endTask.value(precursor.BEGIN_TASK);
                beginTask.readOnly = false;
                endTask.readOnly = true;
                this.parseTimeTypeByEnd(row,exceptions);
                this.parseDates(row,exceptions);
            }else{
                beginTask.readOnly = false;
                endTask.readOnly = false;
            }

        }else{
            if(row.PARENT){
                widget.getField('PARENT').dataSource.data.forEach(function(taskParent){
                    if(row.PARENT==taskParent.ID){
                        row.START = taskParent.BEGIN_TASK;
                    }
                });
            }else{
                row.START = dateProjectBegin;
            }
            this.parseTimeType(row,exceptions);
            this.parseDatesTask(row,exceptions);
            beginTask.readOnly = false;
            endTask.readOnly = false;
        }

    };

    this.dateTaskParent= function(owner,dataTasks,row,exceptions){
        if(!owner.field.widget.getField('PRECURSOR').value()){
            var idTaskParent = owner.field.dataSource.data[owner.context.value].ID;
            var taskParent;
            dataTasks.forEach(function(row){
                if(row.ID == idTaskParent){
                    taskParent = row;
                }
            });
            owner.field.widget.getField('START').value(taskParent.BEGIN_DATE.split("/").reverse().join("-"));
            this.parseTimeType(row,exceptions);
        }
    };

    this.moveRowExceptionList = function(args){
        ScreenService.openPopup(args.owner.widgets[0]);
        args.owner.widgets[0].currentRow = args.row;
    };

    this.addExceptionList = function(args){
        ScreenService.openPopup(args.owner.widget.widgets[0]);
        args.owner.widget.widgets[0].newRow();
        args.owner.widget.widgets[0].currentRow.STATUS = 'A';
        args.owner.widget.widgets[0].list();
    };

    this.saveException = function(row,widgetException,calendarEntityId){
        var loginInfo = localStorageEngine.getLocalVar("login");
        row.END_DATE = moment(row.END_DATE_LIST,'DD/MM/YYYY HH:mm' ).format('YYYY-MM-DD HH:mm');
        row.BEGIN_DATE = moment(row.BEGIN_DATE_LIST,'DD/MM/YYYY HH:mm' ).format('YYYY-MM-DD HH:mm');
        row.CALENDAR_ENTITY = calendarEntityId;
        row.ORGANIZATION = loginInfo[0].organization;
        row.USER = loginInfo[0].idBusinessPartner;
        row.changed = true;
        requestDataSourceEngine.setDataSource('/saveEditException',[row]).then(function(data){

            widgetException.dataSource.data = data.dataset.Exception;
            ScreenService.closePopup();
        });
    };
    this.saveExceptionLocal = function(row,widgetException){
        widgetException.dataSource.data.push(row);
        ScreenService.closePopup();
    };

    this.editCalendar = function(args){
        ScreenService.openWindow('product#edit_calendar');
        CalendarService.entity = 'Project';
        CalendarService.editRow = args.owner.widget.currentRow;
        CalendarService.windowBack = 'projects';
    };

    this.deleteProjectBasic = function(args){
        var row = args.row;
        row.changed = true;
        ScreenService.confirmMessage('Deseja apagar o projeto '+row.NAME+' ?',null,function(){
            requestDataSourceEngine.setDataSource('/deleteProject',[row]).then(function(data){
                var projectDataListOld = args.owner.widget.container.getWidget('PROJECT_LIST').dataSource.data;
                args.owner.widget.container.widgets[0].reload().then(function(){
                    var projectDataList = args.owner.widget.container.getWidget('PROJECT_LIST').dataSource.data;
                    if (Array.isArray(projectDataList))
                        for (var key in projectDataListOld) {
                            if (projectDataListOld[key]._opened) {
                                if(projectDataList[key]) {
                                    projectDataList[key]._opened = projectDataListOld[key]._opened;
                                }
                            }
                        }
                });
                args.owner.widget.container.unSelectAll();
                ScreenService.closeSwipe();
            });
        },null);

    };

    this.taskForEditById = function(idTask){
        var row = {
            'ID':idTask,
            'changed':true
        };
        return requestDataSourceEngine.setDataSource('/dataEditTask',[row]);
    };

    this.validateNewTask = function(row,widgetFromTask,widgetBasic){
        var validation = true;
        var begin = moment(row.START, 'YYYY-MM-DD');
        var end = moment(row.END, 'YYYY-MM-DD');
        var beginProjectString= widgetBasic.currentRow.START.split("/").reverse().join("-");
        var beginProject = moment(beginProjectString, 'YYYY-MM-DD');
        if( row.PARENT == row.PRECURSOR && !Validation.isEmpty(row.PRECURSOR)){
            ScreenService.showMessage(Messages.ERR_SUPERIOR_TASK_SAME_PRECURSOR, null, "exclamation");
            validation = false;
        }else if( Validation.isEmpty(row.NAME)|| Validation.isEmpty(row.START)|| Validation.isEmpty(row.END) ){
            ScreenService.showMessage(Messages.ERR_REQUIRED_FIELDS, null, "exclamation");
            validation = false;
        }else if(begin>end){
            ScreenService.showMessage(Messages.ERR_SUPERIOR_TASK_SAME_PRECURSOR,null,"exclamation");
            validation = false;
        }else if(begin<beginProject){
            ScreenService.showMessage("Data ínicial não pode ser antes da data de ínicial do projeto ("+beginProject.format('DD/MM/YYYY')+")",null,"exclamation");
            validation = false;
        }else if(row.START!=beginProjectString){
            if(!row.PARENT  && !row.PRECURSOR){
                ScreenService.showMessage("Tarefas sem predecessora ou tem que iniciar com o projeto ("+beginProject.format('DD/MM/YYYY')+")",null,"exclamation");
                validation = false;
            }else if(row.PARENT && !row.PRECURSOR){
                widgetFromTask.parent.parent.dataSource.data.forEach(function(data){
                    if(data.ID == row.PARENT){
                        if(data.BEGIN_DATE.split("/").reverse().join("-") != row.START ){
                            ScreenService.showMessage("Tarefas com tarefa superior tem que ínicial  com a mesma ("+data.BEGIN_DATE+")",null,"exclamation");
                            validation = false;
                        }
                    }
                });
            }
        }
        return validation;
    };

    this.parseHourOrDayEdit=function(str){
        str=str.toUpperCase();
        if((str.indexOf("D")!== false)){
            str = parseInt(str.replace("D",""))*hoursDay;
        }
        return  str;
    };
    this.createProject = function(containerNewProject){
        var row = containerNewProject.getWidget('BASIC').currentRow;
        row.START = row.START.split("/").reverse().join("-");
        row.END = row.END.split("/").reverse().join("-");
        row.RESOURCE = containerNewProject.getWidget('RESOURCE_LIST').dataSource.data;
        if(row.RESOURCE.length === 0){
            row.RESOURCE = [{'ID':row.SPONSOR},{'ID':row.MANAGER}];
        }
        row.CALENDAR = containerNewProject.getWidget('CALENDAR').currentRow;
        row.EXCEPTION = containerNewProject.getWidget('LIST_EXCEPTION').dataSource.data;
        row.changed=true;
        row.ADVANCED_INFORMATION = containerNewProject.getWidget('ADVANCED_INFORMATION').currentRow;

        if(this.validateFields(row)){
            row.TASKS = [];
            requestDataSourceEngine.setDataSource('/projectData',[row]).then(function(){
                ScreenService.openWindow('product#projects');
            });

        }
    };

    this.editProjectSaveTask = function(widgetFromTask,widgetBasic,widgetListTask){
        var row = widgetFromTask.currentRow;
        row.START = row.START.split("/").reverse().join("-");
        row.END = row.END.split("/").reverse().join("-");
        if(this.validateNewTask(row,widgetFromTask,widgetBasic)){
            var loginInfo = localStorageEngine.getLocalVar("login");
            row.ORGANIZATION = loginInfo[0].organization;
            row.USER = loginInfo[0].idBusinessPartner;
            row.PROJECT = widgetBasic.currentRow.ID;
            row.changed = true;
            requestDataSourceEngine.setDataSource('/saveNewProjectTask',[row]).then(function(data){
                widgetFromTask.list();
                try{
                    var tasks = data.dataset.Task;
                    var basic = data.dataset.Basic[0];
                    var tasksWidget =widgetListTask.dataSource.data;
                    if (Array.isArray(tasksWidget)) {
                        for (var key in tasksWidget) {
                            if (tasksWidget[key]._opened) {
                                if(tasks[key]) {
                                    tasks[key]._opened = tasksWidget[key]._opened;
                                }
                            }
                        }
                    }
                    widgetListTask.dataSource.data = tasks;
                    widgetBasic.currentRow = basic;
                }catch(e){
                }
                ScreenService.closeSwipe();
                widgetListTask.activate();
            });
        }else{
            row.START = row.START.split("-").reverse().join("/");
            row.END = row.END.split("-").reverse().join("/");
        }
    };

    this.editProjectDeleteTask= function(args){
        var row = {};
        var loginInfo = localStorageEngine.getLocalVar("login");
        row.ORGANIZATION = loginInfo[0].organization;
        row.PROJECT = this.projectId;
        row.TASKS = args.owner.widget.dataSource.checkedRows;
        row.changed = true;
        ScreenService.confirmMessage('Apagar todas tarefas selecinadas ?',null,function() {
            requestDataSourceEngine.setDataSource('/deleteProjectTask', [row]).then(function (data) {
                var tasksWidget = args.owner.widget.dataSource.data;
                var tasks = data.dataset.Task;
                if (Array.isArray(tasksWidget)) {
                    for (var key in tasksWidget) {
                        if (tasksWidget[key]._opened) {
                            if (tasks[key]) {
                                tasks[key]._opened = tasksWidget[key]._opened;
                            }
                        }
                    }
                }
                args.owner.widget.dataSource.data = tasks;
                args.owner.widget.dataSource.checkedRows = [];
            });
        });

    };

    this.openPopUp = function(args){
        var widget = args.owner.widget;
        ScreenService.openPopup(widget.widgets[0]);

    };

    this.editResourceDelete = function(args){
        var row = {};
        row.CHECKED_ROWS = args.owner.widget.dataSource.checkedRows;
        var loginInfo = localStorageEngine.getLocalVar("login");
        row.ORGANIZATION = loginInfo[0].organization;
        row.PROJECT = this.projectId;
        row.changed = true;
        requestDataSourceEngine.setDataSource('/deleteProjectResource',[row]).then(function(data){
            args.owner.widget.dataSource.data = data.dataset.Resource;
            args.owner.widget.unSelectAll();
            args.owner.widget.container.restoreDefaultMode();
        });
    };

    this.resourceListClicked = function(checkedRows,widgetList){
        var row ={};
        row.RESOURCES = checkedRows;
        row.PROJECT =this.projectId;
        row.changed=true;
        requestDataSourceEngine.setDataSource('/editProjectResource',[row]).then(function(data){
            widgetList.dataSource.data = data.dataset.Resource;
            widgetList.widgets[0].unSelectAll();
            widgetList.container.restoreDefaultMode();
            ScreenService.closePopup();
        });
    };

    this.setCalendarTask = function(owner,row){
      /*  if(owner.context.value){
            var dataResource = owner.field.dataSource.data[owner.context.value];
            row.HOUR = dataResource['HOUR'];
            row.BEGIN_WEEK = dataResource['BEGIN_WEEK'];
            row.END_WEEK = dataResource['END_WEEK'];
            row.BEGIN_HOUR = dataResource['BEGIN_HOUR'];
            row.END_HOUR = dataResource['END_HOUR'];
        }else{
            row.HOUR = null;
            row.BEGIN_WEEK = null;
            row.END_WEEK = null;
            row.BEGIN_HOUR = null;
            row.END_HOUR = null;
        }
        owner.field.value(dataResource['ID']);
        this.parseTimeTypeTask(row,dataResource['EXCEPTION'],owner.field);
*/
    };

    this.parseDates = function(row,exceptions){
        row.START = row.START.split("/").reverse().join("-");
        row.END = row.END.split("/").reverse().join("-");
        row.TOTAL_TIME = DateManager.calculateDateDifference(row,exceptions,beginWeek,endWeek);
        row.START = row.START.split("-").reverse().join("/");
        row.END = row.END.split("-").reverse().join("/");
    };
    this.parseDatesTask = function(row,exceptions){
        this.parseDates(row,exceptions);
        this.parseTimeTypeByEnd(row,exceptions);

    };
    this.getDateBegin = function(row,beginTaskPrecursor,endTaskPrecursor,beginTaskParent,endTaskParent,exceptions){
        DateManager.getDateBegin(row,beginTaskPrecursor,endTaskPrecursor,beginTaskParent,endTaskParent,hoursDay,beginWeek,endWeek,beginHour,endHour,exceptions);
    };

    this.parseManager = function(MANAGER){

        localStorageEngine.setLocalVar("MANAGERID",MANAGER);
        var manager = this.getSelectedManager(MANAGER);
        if(manager !== null){
            this.parseDateInterval(manager.DATES,true);
        }
        var groupField = container.widgets[0].getField('GROUP_NAME');
        groupField.reload().then(function(data){
            var groups = data.dataset.groupProject;
            var parent;
            groups.forEach(function(group){
                parent = null;
                groups.forEach(function(possibleParent){
                    if(possibleParent.ID === group.PARENT){
                        parent = possibleParent.ID;
                    }
                });
                group.PARENT = parent;
            });
            templateManager.updateTemplate();
        });
    };

    this.parseDataNumber = function(number){
        return (number >= 10? number : "0"+number);
    };


    this.parseDateInterval = function(manager,bShowMessage){
        // 0 = no matches
        // 1 = matches, but there are holes in the schedule
        // 2 = total match
        // eugênio
        firstEndingDate = -1; // Stores the difference between the project's initial date and the first date when the manager
        // will not be available
        dateInterval = 0; // Stores one of the cases listed above

        startField = container.widgets[0].fields[6].value(); // Field 'START'
        endField = container.widgets[0].fields[7].value(); // Field 'END'
        if(startField !== '' && endField !== '' && manager.length !== 0){
            // All comparisons between the dates will use those dates notation in milliseconds.
            projectBegins = new Date(startField).getTime();
            projectEnds = new Date(endField).getTime();
            for(var index in manager){ // LOOP START - Determinates if the manager will be able to manage the project based on it's
                // availability dates, also finds out if it has holes or if he will leave before the project's
                // final date.
                begin = new Date(manager[index].BEGIN).getTime();
                end = new Date(manager[index].END).getTime();
                // CONDITION1 BEGIN - Detects if the manager will leave before the project's conclusion during this availability date set
                if(begin <= projectBegins && end < projectEnds && end >= projectBegins){
                    dateInterval = 1;
                    if((firstEndingDate > 0 && end - projectBegins < firstEndingDate) || firstEndingDate == -1){
                        firstEndingDate = end - projectBegins;
                    }
                    readyToGo = true;
                    // CONDITION1 ENDS HERE
                } else if(begin <= projectBegins && end >= projectEnds){
                    // CONDITION2 BEGIN Detects if the manager will stay during all the project within this availability date set
                    dateInterval = 2;
                    readyToGo = true;
                    break;
                } else {
                    readyToGo = false;
                }
            } // LOOP END
            // MESSAGE BEGIN - Show Message block
            if(bShowMessage){
                if(dateInterval === 1){
                    date = new Date(projectBegins+firstEndingDate);
                    ScreenService.showMessage("Este gerente não estará disponivel em "+date.getDateBr(),null,"exclamation");
                }else if(dateInterval === 0){
                    ScreenService.showMessage("Não há datas disponíveis para esse gerente.",null,"exclamation");
                }
            }
            // MESSAGE END - Show Message block
        } else {
            readyToGo = true;
        }
        return dateInterval;
    };

    this.getSelectedManager = function(id){
        var fieldData = container.widgets[0].fields[4].dataSource.data;
        for(var index in fieldData){
            if(fieldData[index].ID == id){
                return fieldData[index];
            }
        }
    };

    this.fieldNameById = function(field,id){
        var widget = container.getWidget('TASK_LIST');
        var fieldData = widget.widgets[0].getField(field).dataSource.data;
        for(var index in fieldData){
            if(fieldData[index].ID == id){
                return fieldData[index].NAME;
            }
        }
    };

    this.saveTask = function(){
        var widget = container.getWidget('TASK_LIST');
        var rowNewAvail = widget .widgets[0].currentRow;
        rowNewAvail.ID = ++idCount;
        rowNewAvail.TASK_PARENT_NAME = this.fieldNameById('PARENTTASK',rowNewAvail.PARENTTASK);
        rowNewAvail.TASK_SUPERIOR_NAME = this.fieldNameById('SUPERIORTASK',rowNewAvail.SUPERIORTASK);
        rowNewAvail.TASK_RESOURCES_NAME = this.fieldNameById('RESOURCES',rowNewAvail.RESOURCES);


        ProjectTaskRepository.save(rowNewAvail)
            .then(function(){
                widget.reload();
                templateManager.update();
            }
        );
        popUp = null;
        rowNewAvail.ID = '_'+rowNewAvail.ID;
        widget.widgets[0].getField('SUPERIORTASK').dataSource.data.push(rowNewAvail);
    };

    this.onEnterNewProject = function(args){
        container = args.owner;
        var widgetBasic = container.getWidget('BASIC');
        var widgetCalendar = container.getWidget('CALENDAR');
        var widgetException = container.getWidget('LIST_EXCEPTION');
        var widgetResource = container.getWidget('RESOURCE_LIST');
        widgetBasic.newRow();
        widgetCalendar.newRow();
        var rowBasic = widgetBasic.currentRow;
        widgetException.dataSource.data = [];
        widgetResource.dataSource.data = [];
        container.getWidget('NEW_RESOURCES').reload();
        rowBasic.STATUS ='Y';
        rowBasic.START = moment().format('DD/MM/YYYY');
        rowBasic.END = moment().format('DD/MM/YYYY');
        rowBasic.TOTAL_TIME = "1D";
        container.currentWidget = widgetBasic;
        widgetBasic.activate();
        var projectParent = localStorageEngine.getLocalVar('projectEdit');
        if(projectParent){
            rowBasic.UPPER_PROJECT= projectParent.ID;
            rowBasic.UPPER_PROJECT_NAME= projectParent.NAME;
            var dateBeginParent = projectParent.START;
            rowBasic.START = dateBeginParent ;
            rowBasic.END = dateBeginParent ;
            rowBasic.BEGINPARENT = dateBeginParent ;
            rowBasic.MANAGER = projectParent.MANAGER_ID ;
            rowBasic.MANAGER_NAME = projectParent.MANAGER ;
            rowBasic.GROUP = projectParent.GROUP_ID ;
            rowBasic.GROUP_NAME = projectParent.GROUP ;
            rowBasic.SPONSOR = projectParent.SPONSOR_ID ;
            rowBasic.SPONSOR_NAME = projectParent.SPONSOR ;
            widgetCalendar.currentRow = projectParent.CALENDAR;
            widgetException.dataSource.data = projectParent.LIST_EXCEPTION;
            projectParent.LIST_RESOURCES.forEach(function(resource){
                resource.ID = resource.ID_RESOURCE;
            });
            widgetResource.dataSource.data = projectParent.LIST_RESOURCES;
        }
        rowBasic.DATE_EXCEPTION='';
        rowBasic.DATE_EXCEPTION_TYPE=7;
        rowBasic.DATE_EXCEPTION_NAME='O Mais Breve Possível';
        hoursDay = 24;
        idCount = 0;
        widgetBasic.currentRow = rowBasic;
        ProjectController.projectExceptionVisibility(widgetBasic);
        ProjectController.reloadFieldsProject(widgetBasic);
        container.getWidget('ADVANCED_INFORMATION').newRow();
    };



    this.onEnterProjectList = function(args){
        container = args.owner;
        projectDataListOld = container.dataSource.data;
        container.reload().then(function(){
            var projectDataList = container.dataSource.data;
            for (var key in projectDataListOld) {
                if (projectDataListOld[key]._opened) {
                    if(projectDataList[key]) {
                        projectDataList[key]._opened = projectDataListOld[key]._opened;
                    }
                }
            }
        });
        container.container.widgets[1].widgets[1].widgets[0].reload();
        editProjectForm = [];
        localStorageEngine.setLocalVar('project',null);
        localStorageEngine.setLocalVar('projectEdit',null);


    };

    this.onEnterProjectEdit = function(args){
        container =  args.owner;
        var widget = container.widgets[0];
        args.owner.widgets[0].newRow();
        var data = {
            "ID":editProjectForm.ID,
            "END": editProjectForm.END,
            "GROUP": editProjectForm.GROUP_ID,
            "GROUP_NAME": editProjectForm.GROUP,
            "MANAGER":editProjectForm.MANAGER_ID,
            "MANAGER_NAME":editProjectForm.MANAGER,
            "NAME": editProjectForm.NAME,
            "PLACE_HOLDER": "",
            "SPONSOR":editProjectForm.SPONSOR_ID,
            "SPONSOR_NAME":editProjectForm.SPONSOR,
            "START": editProjectForm.START,
            "STATUS": editProjectForm.STATUS  == 'A'?'Y':'N' ,
            "TOTAL_TIME": editProjectForm.TOTAL_TIME,
            "UPPER_PROJECT": editProjectForm.UPPERPROJECT_ID,
            "UPPER_PROJECT_NAME": editProjectForm.UPPER_PROJECT,
            "BEGINPARENT":editProjectForm.BEGINPARENT,
            "BEGIN_WEEK":editProjectForm.BEGIN_WEEK,
            "END_WEEK":editProjectForm.END_WEEK,
            "DATE_EXCEPTION":editProjectForm.DATE_EXCEPTION,
            "DATE_EXCEPTION_TYPE":editProjectForm.DATE_EXCEPTION_TYPE,
            "DATE_EXCEPTION_NAME":editProjectForm.DATE_EXCEPTION_NAME,
            "DATE_EXCEPTION_ABBREVIATION":editProjectForm.DATE_EXCEPTION_ABBREVIATION,
            "EXCEPTION":editProjectForm.EXCEPTION

        };
        widget.currentRow = data;
        ProjectController.reloadFieldsProject(widget);
        ProjectController.projectExceptionVisibility(widget);
    };

    this.editProjectBasic = function(args){
        editProjectForm = args.row;
        localStorageEngine.setLocalVar("MANAGERID",args.row.MANAGER_ID);
        ScreenService.openWindow('product#edit_project');
    };

    this.editProjectAdvanced = function(widget){
        __initialRow = angular.copy(widget.currentRow);
        widget.edit();
        widget.template = widget.formTemplate;
    };
    this.listProjectAdvanced = function(widget) {
        ScreenService.closeSwipe();
        widget.list();
    };

    this.validateFields = function(row){
        var validate = true;
        var begin = moment(row.START);
        var end = moment(row.END);
        var beginParent = moment(row.BEGINPARENT, 'YYYY-MM-DD');
        if(!row.NAME){
            ScreenService.showMessage("Por favor preencha o campo de nome.",'ALERT');
            validate =  false;
        }else if(!row.SPONSOR_NAME){
            ScreenService.showMessage("Por favor preencha o campo cliente.",'ALERT');
            validate =  false;
        }else if(!row.MANAGER_NAME){
            ScreenService.showMessage("Por favor preencha campo gerente.",'ALERT');
            validate =  false;
        }else if(!row.GROUP_NAME){
            ScreenService.showMessage("Por favor preencha campo grupo.",'ALERT');
            validate =  false;
        }else if(!row.START){
            ScreenService.showMessage("Por favor preencha campo inicio.",'ALERT');
            validate =  false;
        }else if(!row.END){
            ScreenService.showMessage("Por favor preencha campo end.",'ALERT');
            validate =  false;
        }else if(!row.TOTAL_TIME){
            ScreenService.showMessage("Por favor preencha tempo total.",'ALERT');
            validate =  false;
        }else if(begin>end && validate){
            ScreenService.showMessage(Messages.ERR_START_DATE_AFTER_FINAL_DATE, null, "exclamation");
            validate =  false;
        }else if(row.UPPER_PROJECT_NAME && !row.DATE_EXCEPTION_NAME){
            ScreenService.showMessage(Messages.ERR_START_DATE_AFTER_FINAL_DATE, null, "exclamation");
            validate =  false;
        }

        return validate;
    };

    this.setDateException = function(row,widget,paramenter){
        var dateException;
        if(row.UPPER_PROJECT_NAME) {
            if (row.DATE_EXCEPTION_ABBREVIATION == 'MB') {
                row.DATE_EXCEPTION = row.START;
                widget.getField('DATE_EXCEPTION_NAME').dataSource.data.forEach(function (data) {
                        if (data.ABBREVIATION == 'IA' && paramenter == 'START') {
                            row.DATE_EXCEPTION_ABBREVIATION = data.ABBREVIATION;
                            row.DATE_EXCEPTION_TYPE = data.ID;
                            row.DATE_EXCEPTION_NAME = data.NAME;
                        }else if(data.ABBREVIATION == 'TD' && paramenter == 'END'){
                            row.DATE_EXCEPTION_ABBREVIATION = data.ABBREVIATION;
                            row.DATE_EXCEPTION_TYPE = data.ID;
                            row.DATE_EXCEPTION_NAME = data.NAME;
                        }
                    }
                );
                ProjectController.setVisibleDateException(row, widget);
            } else if (row.DATE_EXCEPTION_ABBREVIATION == 'IA') {
                var begin = moment(row.START, 'DD/MM/YYYY');
                 dateException = moment(row.DATE_EXCEPTION, 'DD/MM/YYYY');
                if (begin < dateException || !dateException) {
                    row.DATE_EXCEPTION = row.START;
                }
            }else if (row.DATE_EXCEPTION_ABBREVIATION == 'TD') {
                var end = moment(row.END, 'DD/MM/YYYY');
                 dateException = moment(row.DATE_EXCEPTION, 'DD/MM/YYYY');
                if (end > dateException || !dateException) {
                    row.DATE_EXCEPTION = row.END;
                }
            }
        }
        row.START = row.START.split("/").reverse().join("-");
        row.END = row.END.split("/").reverse().join("-");
        row.TOTAL_TIME = DateManager.calculateDateDifference(row,row.EXCEPTION,beginWeek,endWeek);
        row.START = row.START.split("-").reverse().join("/");
        row.END = row.END.split("-").reverse().join("/");
    };

    this.saveBasic = function(args){
        var loginInfo = localStorageEngine.getLocalVar("login");
        var row = args.owner.widget.currentRow;
        row.START = row.START.split("/").reverse().join("-");
        row.END = row.END.split("/").reverse().join("-");
        if(row.DATE_EXCEPTION) {
            row.DATE_EXCEPTION = row.DATE_EXCEPTION.split("/").reverse().join("-");
        }
        row.ORGANIZATION = loginInfo[0].organization;
        row.USER = loginInfo[0].idBusinessPartner;
        row.changed=true;
        if(this.validateFields(row) ){
            requestDataSourceEngine.setDataSource('/editProjectBasic',[row]).then(function(){
                ScreenService.openWindow('product#projects');
            });
        }else{

        }
    };

    this.setDateParentProject = function(owner,row,exceptions){
        var dateBegin;
        owner.field.dataSource.data.forEach(function(project){
            if(project.ID == row.UPPER_PROJECT){
                dateBegin = project.BEGIN_DATE;
            }
        });
        dateBegin = dateBegin.split("/").reverse().join("-");
        owner.field.widget.getField('START').value(dateBegin);
        owner.field.widget.getField('END').value(dateBegin);
        row.BEGINPARENT = dateBegin;
        this.parseDates(row,exceptions);

    };

    this.projectOnListClicked = function(args){
        var advancedInformation = args.owner.container.getWidget('ADVANCED_INFORMATION');
        var widgetForm = args.owner.container.widgets[1];
        widgetForm.showForm = true;
        widgetForm.formTemplate = "widget/tabbedWidget.html";
        var widgetold = widgetForm.container.getActiveWidget();
        ScreenService.openSwipe(widgetForm);
        widgetold.activate();
        localStorageEngine.setLocalVar('project',args.row.ID);
        this.projectId = args.row.ID;
        var credentials =[];
        credentials[0]={};
        credentials[0].operator = '=';
        credentials[0].name = 'id';
        credentials[0].value = args.row.ID;
        container = args.owner.container;
        advancedInformation.reload();
        requestDataSourceEngine.getDataSource('/fullProjectData',this.updateEditSwipe,credentials);
    };

    this.updateEditSwipe = function(data){
        var basic       = data.Basic[0];
        var advanced    = data.Advanced[0];
        if(basic.STATUS == 'A'){
            basic.ATIVO = 'Ativo';
        } else {
            basic.ATIVO = 'Inativo';
        }
        if(basic.HOUR){
            hoursDay = basic.HOUR;
            beginWeek = basic.BEGIN_WEEK;
            endWeek = basic.END_WEEK;
            beginHour = basic.BEGIN_HOUR;
            endHour = basic.END_HOUR;
        }else{
            hoursDay = CalendarConst.HOURSDAY;
            basic.BEGIN_WEEK = beginWeek = CalendarConst.BEGINWEEKBASIC ;
            basic.END_WEEK  = endWeek = CalendarConst.ENDWEEKBASIC;
            beginHour = basic.BEGIN_HOUR  = CalendarConst.BEGINHOUR;
            endHour = basic.END_HOUR= CalendarConst.ENDHOUR;
        }

        if(advanced){
            if(advanced.STATUS == 'A'){
                advanced.ATIVO = 'Ativo';
            } else {
                advanced.ATIVO = 'Inativo';
            }
        }
        container.widgets[1].widgets[0].currentRow = basic;
        container.widgets[1].widgets[1].currentRow = advanced;
        container.widgets[1].widgets[0].fields.forEach(function (field) {
            field.isVisible = (!!field.value());
        });
    };
    this.openNewWindow = function(){
        ScreenService.openWindow('product#new_project');
    };

    this.loadProjectsWithSameManager = function(copy) {
        var filter = [
            {
                name: 'projectId',
                operator: '=',
                value: copy ? 0 : localStorageEngine.getLocalVar('project')
            }
        ];
        return localStorageEngine.download("/projectSameManager", filter);
    };

    this.clearTaskList = function() {
        return localStorageEngine.setDataSource("/taskParent", []);
    };

    this.loadTasksByProject = function(projectId) {
        var filter = [
            {
                name: "projectId",
                operator: '=',
                value: projectId
            },
            {
                name: "allTasks",
                operator: '=',
                value: 0
            }
        ];
        return localStorageEngine.download("/taskParent", filter);
    };


    function __onlyParent(task) {
        if(task._parent) {
            if(task._parent.__isSelected) {
                return false;
            } else {
                return __onlyParent(task._parent);
            }
        } else {
            return true;
        }
    }
            
    this.moveTask = function (targetProject, targetTask, tasksToMove) {
        var parentTasks = tasksToMove.filter(__onlyParent);
        var tasksToRequest = [];
        parentTasks.forEach(function(task) {
            tasksToRequest.push(task.ID);
        });
        return restEngine.post("/moveTask",
            {
                requestType: "DataSet",
                dataset: [
                    {targetProject: targetProject},
                    {targetTask: targetTask},
                    tasksToRequest,
                    {projectId: this.projectId}
                ]
            }
        );
    };
    this.copyTask = function (targetProject, targetTask, tasksToMove) {
        var parentTasks = tasksToMove.filter(__onlyParent);
        var tasksToRequest = [];
        parentTasks.forEach(function(task) {
            tasksToRequest.push(task.ID);
        });
        return restEngine.post("/copyTask",
            {
                requestType: "DataSet",
                dataset: [
                    {targetProject: targetProject},
                    {targetTask: targetTask},
                    tasksToRequest,
                    {projectId: this.projectId}
                ]
            }
        );
    };
    this.openNewSubProject = function(row,calendar,listExceptions,listResources){
        row.CALENDAR = calendar;
        row.LIST_EXCEPTION = listExceptions;
        row.LIST_RESOURCES = listResources;
        localStorageEngine.setLocalVar('projectEdit',row);
    };

    this.setPrecursor = function(owner,widget,row,exceptions,dateProjectBegin){
        var precursor;
        var type;
        if(owner.field.name == 'PRECURSOR'){
            precursor = owner.field.dataSource.data[owner[0].value];
            type = widget.getField('TYPE').value();
        }else{
            type = owner.field.dataSource.data[owner[0].value];
            if (type){
                type = type.id;
                precursor = widget.getField('PRECURSOR').value();
                widget.getField('PRECURSOR').dataSource.data.forEach(function(data){
                    if(data.ID == precursor ){
                        precursor = data;
                    }
                });
            }
        }
        dateProjectBegin = dateProjectBegin.split("/").reverse().join("-");
        this.setDatePrecursor(precursor,type,widget,row,exceptions,dateProjectBegin);
    };

    var __initialRow = {};

    this.saveProjectRepository = function(widget){
        var self = this;
        var basic = widget.container.getWidget('PROJECT_TABBED').widgets[0];
        var row = widget.currentRow || {};
        row.changed = true;
        row.REPOSITORY = row.NAME;
        row.PROJECT_ID = basic.currentRow.ID;

        requestDataSourceEngine.setDataSource('/projectRepository',[row]).then(function(){
            if(row.STATUS === 'A'){
                row.ATIVO = 'Ativo';
            } else {
                row.ATIVO = 'Inativo';
            }
            row.NAME = row.REPOSITORY;
            __initialRow = widget.currentRow;
            self.listProjectAdvanced(widget);
        });
    };

    this.advancedInformationActionEventSave = function(args){
        self.saveProjectRepository(args.owner.widget);
    };

    this.newTaskStatus = function(row){
        return requestDataSourceEngine.setDataSource('/newTaskStatus',[row]);
    };
    this.newTaskType = function(row){
        return requestDataSourceEngine.setDataSource('/newTaskType',[row]);
    };
    this.setProjectController = function(projectController){
        ProjectController = projectController;
    };
    var self = this;
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ProjectServiceListAgile', ProjectServiceListAgile);
});

// FILE: assets/js/Service/Resource.js
/**
 * Created by Eugênio Fonseca
 */

function ResourceService(requestDataSourceEngine, localStorageEngine, ScreenService, templateManager, CalendarService, Utilities) {

    this.getAllocatedResourcesByID = function(IDs){
        var filter = [
            {
                name: 'IDs',
                operator: '=',
                value: IDs
            }
        ];
        return requestDataSourceEngine.getDataSource('/resourcesAllocated', filter);
    };

    this.saveResource = function(resource){
        return requestDataSourceEngine.setDataSource('/resource', [resource]);
    };

    this.saveIdentityUser = function(resource){
      return requestDataSourceEngine.setDataSource('/user', [resource]);
    };

    this.deleteIdentityUser = function(resource){
        return requestDataSourceEngine.setDataSource('/user/remove', [resource]);
    };

    this.saveAvailability = function(availability){
        return requestDataSourceEngine.setDataSource('/resourceAvailability', [availability]);
    };

    this.saveCost = function(cost){
        return requestDataSourceEngine.setDataSource('/resourceCost', [cost]);
    };


    this.openPopupResetResourcePassword = function(editPasswordWidget,email){
        editPasswordWidget.currentRow.NEW_PASSWORD = '';
        editPasswordWidget.currentRow.CONFIRM_PASSWORD = '';
        editPasswordWidget.currentRow.EMAIL = email;
        ScreenService.openPopup(editPasswordWidget);
    };


    this.editResourcePassword = function(currentRow) {
        var newPassword      = currentRow.NEW_PASSWORD;
        var confirmPassword  = currentRow.CONFIRM_PASSWORD;
        var email  = currentRow.EMAIL;

        if(newPassword.length < 6 || newPassword.length > 20){
            ScreenService.showMessage('A senha deve conter entre 6 e 20 caracteres.');
            return false;
        }
        else if(newPassword !== confirmPassword){
            ScreenService.showMessage('As senhas digitadas não são iguais.');
            return false;
        }
        var filter = [ {
            name: 'PASSWORD',
            operator: '=',
            value: newPassword
        }, {
            name: 'EMAIL',
            operator: '=',
            value: email
        }, {
            name: 'IDENTIFICATION',
            operator: '=',
            value: 'R'
        } ];
        ScreenService.showLoader();
        requestDataSourceEngine.getDataSource("/lib_updatePassword", filter).then(function() {
            ScreenService.hideLoader();
            ScreenService.closePopup();
        }).catch(Utilities.showMessageBackEndTrue);
    };

    this.getStructuresByResourceId = function(responsibleId){
        var row = {};
            row.responsibleId = responsibleId;
            row.changed = true;
        return requestDataSourceEngine.setDataSource("/findStructureByResourceId", [row]).then(function(data) {
            return data.dataset.structures;
        });
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ResourceService', ResourceService);
});


// FILE: assets/js/Service/SignupWizard.js
/**
 * Created by jhoterdanchaves on 16/06/14.
 */
function SignupWizardService(OrganizationInitRepository, BusinessPartnerInitRepository, ZHPromise, localStorageEngine) {

    this.register = function (){
        var dataOrganization, dataBusinessPartner;

        var promiseOrganization = OrganizationInitRepository.findAll().then(function(data){
            dataOrganization = data[0];
        });

        var promiseBusinessPartner = BusinessPartnerInitRepository.findAll().then(function(data){
            dataBusinessPartner = data[0];
        });

        return ZHPromise.all([promiseOrganization, promiseBusinessPartner]).then(function(){
            return localStorageEngine.saveInServer('/signup', null, [dataOrganization, dataBusinessPartner]).then(function(response){
                var dataSet = response.dataset;
                if(dataSet){
                    for(var key in dataSet){
                        localStorageEngine.setDataSource('/' + key, dataSet[key]);
                    }
                    return true;
                }
                return false;
            });
        });
    };

    this.clearSignupData = function(){
        var clearInit = OrganizationInitRepository.clearRepository();
        var clearBusinessPartner = BusinessPartnerInitRepository.clearRepository();
        return ZHPromise.all([clearInit, clearBusinessPartner]);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('SignupWizardService', SignupWizardService);
});


// FILE: assets/js/Service/Sponsor.js
/**
 * Created by tuliomagalhaes on 20/06/14.
 */

function SponsorService(requestDataSourceEngine,ContactListRepository,CalendarExceptionListRepository,
                        ScreenService,templateManager,CalendarService,Utilities){

    var row = [];
    var contact = 0;
    var calendar = 0;
    var newContact = false;
    var newCalendar = false;
    var containerSponsor;
    var contactDelete;
    var calendarDelete;
    var buttonDelete;
    var sponsorWidget;
    var editSponsorWidget;
    var newSponsorWidget;

    this.saveException = function(args){
        var loginInfo = getLocalVar("login");
        var row = args.row;
        row.CALENDAR_ENTITY = args.owner.widget.getParent().widgets[1].widgets[3].currentRow.ID;
        row.ORGANIZATION = loginInfo[0].organization;
        row.USER = loginInfo[0].idBusinessPartner;
        row.changed = true;
        requestDataSourceEngine.setDataSource('/saveEditException',[row]).then(function(data){
            var dataSet =args.owner.widget.getParent().widgets[1].widgets[4].dataSource.data;
            if(!(row.ID)){
                row.END_DATE_LIST=row.END_DATE.split("-").reverse().join("/");
                row.BEGIN_DATE_LIST=row.BEGIN_DATE.split("-").reverse().join("/");
                dataSet.push(row);
                ScreenService.closePopup();

            }else{
                dataSet.forEach(function(datas){
                    if(row.ID == datas.ID)  {
                        row = datas;
                    }
                });
            }
            ScreenService.closePopup();
        });
    };

    this.moveRowExceptionList = function(args){
        ScreenService.openPopup(args.owner.widgets[0]);
        args.owner.widgets[0].currentRow = args.row;
    };

    this.addExceptionList = function(args){
        ScreenService.openPopup(args.owner.widget.widgets[0]);
        args.owner.widget.widgets[0].newRow();
        args.owner.widget.widgets[0].currentRow.STATUS = 'A';
        args.owner.widget.widgets[0].list();
    };

    this.openNewWindow = function(){
        openWindow('new_sponsor');
        setLocalVar('/sponsor',null);
    };

    this.reloadStateByCountry= function(country,fieldState){
        var param =[];
        param[0]={};
        param[0].operator = '=';
        param[0].name = 'id';
        param[0].value = country;
        requestDataSourceEngine.getDataSource('/state',
            function(data){
                fieldState.dataSource.data = data;
            },param);
    };

    this.reloadCityByState = function(state,fieldCity){
        var param =[];
        param[0]={};
        param[0].operator = '=';
        param[0].name = 'id';
        param[0].value = state;
        requestDataSourceEngine.getDataSource('/city',
            function(data){
                fieldCity.dataSource.data = data;
            },param);
    };

    this.saveEditSponsor = function(currentRow){
        return requestDataSourceEngine.setDataSource('PM#/saveSponsor',[currentRow]).then(function(response){
            return response;
        });
    };

    this.openEditWindow = function(){
        openWindow('edit_sponsor');
    };

    this.moveRowContactList = function(args, isBack){
        var widget = args.owner.widget;
        setLocalVar('contact',args.row.CONTACT);
        widget.reload().then(function(){
            if(isBack){
                widget.moveToFirst();
            }
            var row = widget.currentRow;
            var cityField = widget.getField('CITY_NAME');
            var stateField = widget.getField('STATE_NAME');
            if(row.STATE){
                self.reloadCityByState(row.STATE,cityField);
            }
            if(row.COUNTRY){
                self.reloadStateByCountry(row.COUNTRY,stateField);
            }
            if(isBack){
                widget.view();
            }else {
                widget.edit();
            }
        });
    };

    this.addContactList = function(args){
        ScreenService.openSwipe(args.owner.widget.widgets[0]);
        setLocalVar('country',null);
        setLocalVar('state',null);
        args.owner.widget.widgets[0].newRow();
        args.owner.widget.widgets[0].list();
        args.owner.widget.widgets[0].currentRow.STATUS = 'true';
    };

    this.saveContactList = function(row) {
        row.SPONSOR = getLocalVar('/sponsor');
        row.changed = true;
        requestDataSourceEngine.setDataSource('PM#/formContact', [row]).then(function (data) {
            templateManager.container.getWidget('CONTACT').reload();
        });

    };

    this.setImport=function(args){
        var data = args.owner.field.dataSource.data;
        var rowCurrent = args.row;
        var widget=  args.owner.field.getParent().container.widgets[1].widgets[4];
        if(rowCurrent.IMPORT === "")
        {
            rowCurrent.BEGIN_WEEK = "";
            rowCurrent.END_WEEK = "";
            rowCurrent.HOUR = "";
            rowCurrent.NAME = "";
            rowCurrent.STATUS = "";
            CalendarExceptionListRepository.clearRepository().then(
                widget.reload()
            );
        }
        data.forEach(function(row) {
            if(row.id == parseInt(rowCurrent.IMPORT))
            {
                rowCurrent.BEGIN_WEEK = row.beginWeek;
                rowCurrent.END_WEEK = row.endWeek;
                rowCurrent.HOUR = row.hour;
                rowCurrent.NAME = row.name;
                rowCurrent.STATUS = true;
                CalendarExceptionListRepository.clearRepository().then(
                    CalendarExceptionListRepository.save(row.exception)
                        .then(function(){
                            widget.reload();
                            templateManager.update();
                        }
                    )
                );
            }
        });
    };

    this.onChangeGender= function(args){
        if(args.owner.field.value()=='false'){
            args.owner.field.getParent().getField('NICK_NAME').isVisible = true;

        }else{
            args.owner.field.getParent().getField('NICK_NAME').isVisible = false;
        }
    };

    this.validateCreate = function(row){
        var validate = true;
        if(!row.NAME.trim()){
            validate = false;
            ScreenService.showMessage('Por favor digite o nome do Patrocinador');
        }else if(!row.TYPE_NAME.trim()){
            validate = false;
            ScreenService.showMessage('Por favor escolha um tipo');
        }else if(row.LOGIN){
            if(row.PASSWORD != row.PASSWORD_CONFIRM)
            {
                validate = false;
                ScreenService.showMessage('Senha e confirmar senha não confere');
            }
        }
        return validate;
    };

    this.validaException = function(row){
        var validate = true;
        if(!row.NAME.trim() ){
            ScreenService.showMessage('Por favor digite o nome do evento!');
            validate = false;
        }else if(!row.TYPE_NAME){
            ScreenService.showMessage('Por favor selecione um tipo!');
            validate = false;
        }else if(!row.BEGIN_DATE_LIST){
            ScreenService.showMessage('Por favor digite uma data inicial!');
            validate = false;
        }else if(!row.END_DATE_LIST){
            ScreenService.showMessage('Por favor digite uma data final!');
            validate = false;
        }
        return validate;
    };

    this.createContactLocal= function(widget,widgetList){
        var rowNewContact = widget.currentRow;
        if(typeof(rowNewContact.ID) === "number" ){
            ContactListRepository.save(rowNewContact)
                .then(function(){
                    widgetList.reload().then(function(){
                        ScreenService.closePopup();
                        templateManager.updateTemplate();
                    });
                    ScreenService.showMessage('Contato modificado com sucesso!');
                }
            );
        }else{
            rowNewContact.ID=contact;
            contact++;
            ContactListRepository.save(rowNewContact)
                .then(function(){
                    widgetList.reload().then(function(){
                        ScreenService.closePopup();
                        templateManager.updateTemplate();
                    });
                    ScreenService.showMessage('Contato adcionado com sucesso!');
                }
            );
        }
        newContact = false;

    };
    this.saveExceptionLocal = function(widget,widgetList){
        var rowNewCalendar = widget.currentRow;
        if(this.validaException(rowNewCalendar)){
            //rowNewCalendar.BEGIN_DATE=rowNewCalendar.BEGIN_DATE.split("-").reverse().join("/");
            //rowNewCalendar.END_DATE=rowNewCalendar.BEGIN_DATE.split("-").reverse().join("/");
            if(typeof(rowNewCalendar.ID) === "number"  ){
                CalendarExceptionListRepository.save(rowNewCalendar)
                    .then(function(){
                        widgetList.reload().then(function(){
                            ScreenService.closePopup();
                        });
                        ScreenService.showMessage('Exceção modificada com sucesso!');
                    }
                );
            }else{
                rowNewCalendar.ID=calendar;
                calendar++;
                CalendarExceptionListRepository.save(rowNewCalendar)
                    .then(function(){
                        widgetList.reload().then(function(){
                            ScreenService.closePopup();
                        });
                        ScreenService.showMessage('Exceção adcionada com sucesso!');
                    }
                );
            }
            newCalendar = false;
        }
    };

    this.create =function(container){

        row = container.getWidget('BASIC').currentRow;
        row.ADVANCED = container.getWidget('ADVANCED').currentRow;
        if (row.ADVANCED.DOCUMENT_NUMBER) {
            if (row.ADVANCED.DOCUMENT_NUMBER.trim()) {
                row.ADVANCED.DOCUMENT_NUMBER = row.ADVANCED.DOCUMENT_NUMBER.replace(/\W/g, "");
            }
        }
        // row.CALENDAR = container.getWidget('CALENDAR').currentRow;
        row.CALENDARDELETE = calendarDelete;
        row.CONTACTDELETE = contactDelete;
        var self = this;
        ContactListRepository.findAll().then(function (dataContact) {
            row.CONTACT = dataContact;
            CalendarExceptionListRepository.findAll().then(function (dataCalendar) {
                row.EXCEPTION = dataCalendar;
                row.changed = true;
                if (self.validateCreate(row)) {
                    requestDataSourceEngine.setDataSource('PM#/saveSponsor', [row]);
                    row = [];
                    //ScreenService.openWindow('Sponsor');
                }
            });
        });

    };
    
    this.cancel=function(){
        ScreenService.openWindow('sponsor');
    };

    this.editCalendar = function(args){
        ScreenService.openWindow('edit_calendar');
        CalendarService.windowBack = 'sponsor';

        CalendarService.entity = 'Sponsor';
        CalendarService.editRow = args.owner.widget.currentRow;
    };

    this.editSponsorSetData = function(data){
        var basicWidget = containerSponsor.getWidget('BASIC');
        var advancedWidget = containerSponsor.getWidget('ADVANCED');
        // var calendarWidget = containerSponsor.getWidget('CALENDAR');
        //use promise
        //var contactWidget = containerSponsor.getWidget('CONTACT');
        //var listExceptionWidget = containerSponsor.getWidget('LIST_EXCEPTION');
        if(data.basicSponsor[0].STATUS=='A'){
            data.basicSponsor[0].STATUS="true";
        }else{
            data.basicSponsor[0].STATUS="false";
        }

        if(data.advancedSponsor [0].DOCUMENT_TYPE=='J'){
            data.advancedSponsor [0].GENDER = 'true';
            advancedWidget.getField('NICK_NAME').isVisible = true;

        }else{
            data.advancedSponsor [0].GENDER = 'false';
            advancedWidget.getField('NICK_NAME').isVisible = false;
        }
        basicWidget .currentRow = data.basicSponsor[0];
        advancedWidget .currentRow = data.advancedSponsor[0];

        if(data.calendarSponsor[0]){
            if(data.calendarSponsor[0].STATUS=='A'){
                data.calendarSponsor[0].STATUS=true;
            }else{
                data.calendarSponsor[0].STATUS=false;
            }
            // calendarWidget.currentRow = data.calendarSponsor[0];
        }else{
            // calendarWidget.newRow();
        }
        if(data.contactSponsor){
            ContactListRepository.clearRepository().then(function(){
                contact=1;
                data.contactSponsor.forEach(function(row){
                    row.ID=contact;
                    contact++;
                });
                ContactListRepository.save(data.contactSponsor).then(function(){
                    containerSponsor.getWidget('CONTACT').reload();
                });
            });
        }
        CalendarExceptionListRepository.clearRepository().then(function(){
            calendar=1;
            data.exceptionSponsor.forEach(function(row){
                row.ID=calendar;
                calendar++;
            });
            CalendarExceptionListRepository.save(data.exceptionSponsor).then(function(){
                // containerSponsor.getWidget('LIST_EXCEPTION').reload();
            });
        });

    };
    this.onEnterSponsor = function(args){
        containerSponsor = args.owner;
        newSponsorWidget = containerSponsor;
        var sponsor = getLocalVar('/sponsor');
        buttonDelete= false;
        var basicWidget = containerSponsor.getWidget('BASIC');
        var advancedWidget = containerSponsor.getWidget('ADVANCED');
        // var calendarWidget = containerSponsor.getWidget('CALENDAR');
        var contactWidget = containerSponsor.getWidget('CONTACT');
        // var listExceptionWidget = containerSponsor.getWidget('LIST_EXCEPTION');
        calendarDelete=[];
        contactDelete=[];
        ContactListRepository.clearRepository().then(function(){
            containerSponsor.getWidget('CONTACT').reload();
        });
        CalendarExceptionListRepository.clearRepository().then(function(){
            // containerSponsor.getWidget('LIST_EXCEPTION').reload();
        });
        basicWidget.newRow();
        advancedWidget.newRow();
        // calendarWidget.newRow();
        basicWidget.currentRow.STATUS = 'true';
        contact = 0;
        calendar = 0;



    };
    this.onEnterSponsorEdit = function(args){
        containerSponsor = args.owner;
        editSponsorWidget = containerSponsor;
        var sponsor = getLocalVar('/sponsor');
        buttonDelete= false;
        var basicWidget = containerSponsor.getWidget('BASIC');
        var advancedWidget = containerSponsor.getWidget('ADVANCED');
        calendarDelete=[];
        contactDelete=[];
        var sponsorParam =[];
        sponsorParam[0]={};
        sponsorParam[0].operator = '=';
        sponsorParam[0].name = 'id';
        sponsorParam[0].value = sponsor;
        requestDataSourceEngine.getDataSource('/editSponsorData',this.editSponsorForm,sponsorParam);

    };
    this.editSponsorForm = function(data){
        var basicWidget = editSponsorWidget.widgets[0];
        var advancedWidget = editSponsorWidget.widgets[1];
        basicWidget.newRow();
        //use promise
        if(data.basicSponsor[0].STATUS=='A'){
            data.basicSponsor[0].STATUS="true";
        }else{
            data.basicSponsor[0].STATUS="false";
        }

        if(data.advancedSponsor[0].DOCUMENT_TYPE=='J'){
            data.advancedSponsor[0].GENDER = 'true';
            advancedWidget.getField('NICK_NAME').isVisible = true;

        }else{
            data.advancedSponsor[0].GENDER = 'false';
            advancedWidget.getField('NICK_NAME').isVisible = false;
        }
        basicWidget.currentRow = data.basicSponsor[0];
        advancedWidget.currentRow = data.advancedSponsor[0];


    };
    this.saveSponsorQuick = function(args){
        var rowQuick = args.owner.widget.widgets[0].currentRow;
        if(this.validateCreate(rowQuick)){
            requestDataSourceEngine.setDataSource('/newSponsorQuick',[rowQuick]).then(function(){
                args.owner.widget.reload();
            });
        }

    };
    this.newSponsor = function(){
        ContactListRepository.clearRepository();
        CalendarExceptionListRepository.clearRepository();
        setLocalVar('/sponsor',null);

    };
    this.saveNewProjectSponsorFromPopup = function(row){
        return requestDataSourceEngine.setDataSource('/saveSponsor', [row]);
    };
    this.moveRowSponsorList = function(args){
        setLocalVar('/sponsor',args.row.ID);
        openWindow('new_sponsor');
    };
    this.buttonDelete = function(ative){
        buttonDelete = ative;
    };
    this.moveRowContactLocal=function(widget,row){

        if(row.STATUS == "A" || row.STATUS == "true"){
            row.STATUS = true;
        }else{
            row.STATUS = false;
        }
        widget.setCurrentRow(row);
    };
    
    this.moveRowContact = function(args){
     ScreenService.openPopup(args.owner.widgets[0]);
        if(args.owner.name === "CONTACT" ){
            if(args.row.STATUS == "A" || args.row.STATUS == "true"){
                args.row.STATUS = true;
            }else{
                args.row.STATUS = false;
            }
            newContact = 1;
        }else{
            if(args.row.STATUS_EXCEPTION == "A" || args.row.STATUS_EXCEPTION === true){
                args.row.STATUS_EXCEPTION = true;
            }else{
                args.row.STATUS_EXCEPTION = false;
            }
            args.row.BEGIN_DATE = args.row.BEGIN_DATE.split("/").reverse().join("-");
            args.row.END_DATE = args.row.END_DATE.split("/").reverse().join("-");
        }
        args.owner.widgets[0].setCurrentRow(args.row);

    };
    this.deleteContact = function(row){
        if(newSponsorWidget){
            containerSponsor = newSponsorWidget;
        }
        ContactListRepository.deleteContact(row.ID)
            .then(function(){
                ScreenService.showMessage('Contado Apagado!');
                containerSponsor.widgets[2].reload();
        });
        newContact= false;
        if(row.CONTACT){
            contactDelete.push(row.CONTACT);
        }
    };
    this.deleteContact = function(row){
        if(newSponsorWidget){
            containerSponsor = newSponsorWidget;
        }
        ContactListRepository.deleteContact(row.ID)
            .then(function(){
                ScreenService.showMessage('Contado Apagado!');
                containerSponsor.widgets[2].reload();
        });
        newContact= false;
        if(row.CONTACT){
            contactDelete.push(row.CONTACT);
        }
    };

    this.goBackSponsor = function(){
        openWindow('sponsor');
    };
    var self = this;

}

Configuration(function(ContextRegister) {
    ContextRegister.register('SponsorService', SponsorService);
});

// FILE: assets/js/Service/Structure.js
function StructureService(requestDataSourceEngine,ScreenService){

    var container = null;
    var StructureController = null;

    this.setStructureController = function(controller){
        StructureController = controller;
    };


    this.validateFields = function(row){
        if(row.NAME === '' || row.STRUCTURE_TYPE === ''){
            return false;
        }
        return true;
    };

    this.fieldNameById = function(field,id){
        var widget = container.widgets[0];
        var fieldData = widget.fields[field].dataSource.data;
        for(var index in fieldData){
            if(fieldData[index].ID == id){
                return fieldData[index].NAME;
            }
        }
    };

    this.openListScreenPopUp = function(args){
        ScreenService.openPopup(args.owner.widget.widgets[0]);
        args.owner.widget.widgets[0].newRow();
        args.owner.widget.actions[0].showAsAction = "edit";
    };

    this.openSwipeInfoStructure = function(args) {
        container = args.owner.container;
        var credentials = [];
        credentials[0] = {};
        credentials[0].operator = '=';
        credentials[0].name = 'id';
        credentials[0].value = args.row.ID;
        ScreenService.showLoader();
        requestDataSourceEngine.getDataSource('/findEditStructure', StructureController.setDataViewStructure, credentials)
            .then(ScreenService.hideLoader)
            .catch(ScreenService.hideLoader);
    };

    this.saveStructure = function(row) {
        row.changed = true;
        if(this.validateFields(row)){
           return requestDataSourceEngine.setDataSource('/saveStructure',[row]);
        }
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('StructureService', StructureService);
});

// FILE: assets/js/Service/Task.js
/**
 * Created by tuliomagalhaes on 14/07/14.
 */

function TaskService(requestDataSourceEngine,SubTaskRepository,ScreenService, Messages,Utilities){

    var row= [];
    var subTask = false;
    var idSubTask = 0;
    var hoursDay = 8;
    var containerTask;

    this.TASK_STATUS = null;

    this.onEnterNewTask = function (args){
        containerTask = args.owner;
        SubTaskRepository.clearRepository().then(function(){
            containerTask .getWidget('SUBTASKS').getField('LIST_SUBTASK').reload();
        });
        setLocalVar('project',3);
        setLocalVar('dateProject',{'END_DATE':'11/07/2014','BEGIN_DATE':'07/07/2014'});
        var widgetBasic = containerTask .getWidget('BASIC');
        widgetBasic.newRow();
        containerTask .getWidget('SUBTASKS').getField('LIST_SUBTASK').reload();
        widgetBasic.currentRow.STATUS = true;
        widgetBasic.currentRow.BEGIN_DATE = getLocalVar('dateProject').BEGIN_DATE.split("/").reverse().join("-");
        var widgetReference = containerTask .getWidget('REFERENCE');
        widgetReference.newRow();
        widgetReference.currentRow.TIME_BREAK_UNIT = 'dias';
        widgetReference.currentRow.UNIT = 'D';
        widgetReference.currentRow.TIME_BREAK = '1';
        widgetReference.currentRow.TIME_OCCURRENCE = 'Ocorrêcia';
        var widgetSubTasks = containerTask .getWidget('SUBTASKS');
        widgetSubTasks.newRow();
    };

    this.onEnterEditTask = function(args){
        containerTask = args.owner;
        var credentials =[];
        credentials[0]={};
        credentials[0].OPERATOR = '=';
        credentials[0].name = 'organization';
        credentials[0].value = getLocalVar('organization');
        credentials[1]={};
        credentials[1].OPERATOR = '=';
        credentials[1].name = 'id';
        credentials[1].value = getLocalVar('/taskToEdit');

        requestDataSourceEngine.getDataSource('/taskInfo',this.applyEditData,credentials);
    };

    this.applyEditData = function(data){
        data[0].PERCENT_COMPLETED += "%";
        containerTask.widgets[0].newRow();
        containerTask.widgets[0].moveToFirst();
        containerTask.widgets[0].currentRow = data[0];
        for(var key in containerTask.widgets[0].fields){
            containerTask.widgets[0].fields[key].reload();
        }
        this.calculateDateDifferenceTask();
    };

    this.validateSubTask = function(row){
        if(row.NAME.trim().length !== 0 && row.BEGIN.trim().length !== 0 && row.END.trim().length !== 0){
            if(new Date(row.BEGIN) <= new Date(row.END)){
                if(new Date(row.BEGIN) >= new Date(containerTask .getWidget('BASIC').currentRow.BEGIN_DATE)){
                    return true;
                }else{
                    ScreenService.showMessage('A data inicial tem que ser depois da data inicial da task principal');
                    return false;
                }
            }else{
                ScreenService.showMessage(Messages.ERR_START_DATE_AFTER_FINAL_DATE);
                return false;
            }
        }else{
            ScreenService.showMessage(Messages.ERR_REQUIRED_FIELDS);
            return false;
        }

    };
    this.validateTask = function(row){
        if(row.NAME.trim().length !== 0 && row.BEGIN_DATE.trim().length !== 0 && row.END_DATE.trim().length !== 0 ){
            if(new Date(row.BEGIN_DATE) <= new Date(row.END_DATE)){
                var dateProject = getLocalVar('dateProject');
                var dateBegin =dateProject.BEGIN_DATE.split("/").reverse().join("-");
                var dateEnd =dateProject.END_DATE.split("/").reverse().join("-");
                if(new Date (row.BEGIN_DATE) <= new Date (dateEnd)){
                    if(new Date (row.END_DATE) >= new Date (dateBegin)){
                        if(new Date (row.BEGIN_DATE) >= new Date (dateBegin)){
                            if(new Date (row.END_DATE) <= new Date (dateEnd)){
                                return true;
                            }else{
                                return confirm('A data final da tarefa é depois do final do projeto, para continuar a data do final do projeto vai ser alterada para '+row.END_DATE.split("-").reverse().join("/"));
                            }
                        }else{
                            return confirm('A data inicial da tarefa é antes do início do projeto, para continuar a data do inicial do projeto vai ser alterada para '+row.BEGIN_DATE.split("-").reverse().join("/"));
                        }
                    }else{
                        return confirm('A data inicial e final são antes do final do projeto, para continuar a data do inicial do projeto vai ser alterada para '+row.BEGIN_DATE.split("-").reverse().join("/")+'e a final para '+row.END_DATE.split("-").reverse().join("/"));
                    }
                }else{
                    return confirm('A data inicial e final são depois do final do projeto, para continuar a data do inicial do projeto vai ser alterada para '+row.BEGIN_DATE.split("-").reverse().join("/")+'e a final para '+row.END_DATE.split("-").reverse().join("/"));
                }
            }else{
                ScreenService.showMessage(Messages.ERR_START_DATE_AFTER_FINAL_DATE);
                return false;
            }
        }else{
            ScreenService.showMessage(Messages.ERR_REQUIRED_FIELDS);
            return false;
        }
    };
    this.dateTask= function(row){
        if(new Date(row.END) > new Date(containerTask .getWidget('BASIC').currentRow.END_DATE)){
            containerTask .getWidget('BASIC').currentRow.END_DATE=row.END;
        }
    };
    this.saveTask = function (){

        if(subTask){
            var widget = containerTask .getWidget('SUBTASKS');
            var rowNewTask = widget .widgets[0].currentRow;
            if(this.validateSubTask(rowNewTask)){
                this.dateTask(rowNewTask);
                rowNewTask.ID = idSubTask;
                rowNewTask.PERCENT_COMPLETED = 0;
                rowNewTask.BEGIN = rowNewTask.BEGIN.split("-").reverse().join("/");
                rowNewTask.END = rowNewTask.END.split("-").reverse().join("/");
                var dataResouce = widget.widgets[0].getField("RESOURCE").dataSource.data;
                dataResouce.forEach(function(row) {
                    if(row.ID == rowNewTask.RESOURCE  )
                        rowNewTask.NAME_RESOUCE = row.NAME ;
                });
                containerTask .getWidget('SUBTASKS').widgets[0].getField('PRECURSOR').dataSource.data.push(
                    {
                        'id':rowNewTask.ID+'LOCAL',
                        'name':rowNewTask.NAME
                    }
                );
                SubTaskRepository.save(rowNewTask)
                    .then(function(){
                        widget.getField('LIST_SUBTASK').reload();
                    }
                );
                idSubTask++;
                subTask = false;
                ScreenService.showMessage(Messages.SUC_SUCCESSFUL_SAVED);
            }else{
                subTask = false;
            }
        }else{
            row = containerTask .getWidget('BASIC').currentRow;
            row.changed=true;
            row.ORGANIZATION = getLocalVar('organization');
            row.USER = getLocalVar('idBusinessPartner');
            row.PROJECT = getLocalVar('project');
            row.REFERENCE = containerTask .getWidget('REFERENCE').currentRow;
            if(this.validateTask(row)){
                SubTaskRepository.findAll().then(function(dataSubTask){
                    row.SUBTASKS = dataSubTask;
                    requestDataSourceEngine.setDataSource('/newTask',[row]);
                    ScreenService.showMessage(Messages.SUC_TASK_SUCCESSFUL_SAVED);
                });
            }
        }

    };

    this.timeBreak = function (current,apagar,widget,value){
        if(widget.currentRow[current] !== true ){
            widget.currentRow[apagar] = false;
        }
        widget.currentRow[value]="";
    };

    this.addSubTask = function (){
        var currentRow = containerTask .getWidget('SUBTASKS').widgets[0].currentRow;
        containerTask .getWidget('SUBTASKS').widgets[0].getField('PARENT').reload();
        currentRow.STATUS = true;
        currentRow.BEGIN = getLocalVar('dateProject').BEGIN_DATE.split("/").reverse().join("-");
        subTask = true;
    };

    this.unitBreak = function (args){
        var value = '';
        if(args.row.UNIT == 'D'){
            value = ' dia';
        }else if(args.row.UNIT == 'W'){
            value =' semana';
        }else if(args.row.UNIT == 'M'){
            value = ' mês';
        }else {
            value = ' ano';
        }
        if(args.row.TIME_BREAK != '1'){
            if(args.row.UNIT == 'M'){
                value = 'meses';
            }else{
                value = value+'s';
            }
        }
        args.row.TIME_BREAK_UNIT = value;
    };
    this.calculateDateDifferenceSubTask= function(){
        var widgetSubTask = containerTask .getWidget('SUBTASKS').widgets[0];
        var time =  widgetSubTask.getField('TOTAL_TIME');
        var begin =  widgetSubTask.getField('BEGIN').value();
        var end =  widgetSubTask.getField('END').value();
        this.calculateDateDifference(time,begin,end);
    };
    this.calculateDateDifferenceTask= function(){
        var widgetTask = containerTask .getWidget('BASIC');
        var time = widgetTask.getField('TOTAL_TIME');
        var begin = widgetTask.getField('BEGIN_DATE').value();
        var end = widgetTask.getField('END_DATE').value();
        this.calculateDateDifference(time,begin,end);
    };
    this.calculateDateDifference = function(time,start,end){
        if(start !== '' && end !== ''){
            start = start.split("-");
            end   = end.split("-");
            start = new Date(start[0],start[1],start[2]);
            end   = new Date(end[0],end[1],end[2]);
            var difference = parseInt((end.getTime()-start.getTime())/86400000);
            if(difference >= 0){
                if(difference <= 1){
                    time.value((difference*8)+'H');

                }else{
                    time.value(difference+'D');
                }
            }
        }
    };
    this.applyDateDifference = function(difference,time,begin,end){
        var start =begin.value();
        if(start !== '' && difference !== '' && difference >= 0){
            start = start.split("-");
            start = new Date(start[0],start[1],start[2]);
            var result = new Date(start.getTime() + difference*86400000);
            var resultHTML5String =  result.getFullYear()+"-"+
                this.parseDataNumber(result.getMonth())+"-"+
                this.parseDataNumber(result.getDate());
            end.value(resultHTML5String);
        }
    };

    this.parseDataNumber = function(number){
        return (number >= 10? number : "0"+number);
    };

    this.applyHourDifference = function(totalHours,time,begin,end){
        this.applyDateDifference(Math.floor(totalHours/hoursDay),time,begin,end);
    };
    this.parseTimeTypeSubTask = function(){
        var widgetSubTask = containerTask .getWidget('SUBTASKS').widgets[0];
        var time = widgetSubTask.getField('TOTAL_TIME');
        var begin = widgetSubTask.getField('BEGIN');
        var end = widgetSubTask.getField('END');
        this.parseTimeType(time,begin,end);
    };
    this.parseTimeTypeTask = function(){
        var widgetTask = containerTask .getWidget('BASIC');
        var time = widgetTask.getField('TOTAL_TIME');
        var begin = widgetTask.getField('BEGIN_DATE');
        var end = widgetTask.getField('END_DATE');
        this.parseTimeType(time,begin,end);
    };
    this.parseTimeType = function(time,begin,end){
        var fieldValue = time.value();
        if(fieldValue.indexOf("h") < 0 && fieldValue.indexOf("H") < 0){
            fieldValue = fieldValue.replace(/\D/g,'');
            this.applyDateDifference(fieldValue,time,begin,end);
            time.value(fieldValue+'D');
        }else{
            fieldValue = fieldValue.replace(/\D/g,'');
            this.applyHourDifference(fieldValue,time,begin,end);
        }
    };

    this.goToNewTask = function(){
        openWindow("product#new_task");
    };

    this.goToEditTask = function(){
        setLocalVar("/taskToEdit",containerTask.widgets[1].widgets[0].currentRow.ID);
        setLocalVar("/taskToEditProject",containerTask.widgets[1].widgets[0].currentRow.PROJECT_ID);
        openWindow("product#edit_task");
    };

    this.onEnter = function (args){
        containerTask = args.owner.getParent();
        containerTask.widgets[0].reload();
    };

    this.onListClicked = function(args){
        var credentials =[];
        credentials[0]={};
        credentials[0].OPERATOR = '=';
        credentials[0].name = 'organization';
        credentials[0].value = getLocalVar('organization');
        credentials[1]={};
        credentials[1].OPERATOR = '=';
        credentials[1].name = 'id';
        credentials[1].value = args.row.ID;
        setLocalVar("/resourceListSelectedRow",args.row.ID);
        requestDataSourceEngine.getDataSource('/taskPrettyInfo',this.applyData,credentials);
    };

    this.applyData = function(data){
        for (var key in data[0]) {
            if(key != 'ID' && key != 'PROJECT_ID'){
                containerTask.widgets[1].widgets[0].getField(key).isVisible = data[0][key] ? true : false;
            }
        }
        data[0].PERCENT_COMPLETED += "%";
        data[0].STATUS = data[0].STATUS == "A" ? "Ativo" : "Inativo";
        containerTask.widgets[1].widgets[0].newRow();
        containerTask.widgets[1].widgets[0].moveToFirst();
        containerTask.widgets[1].widgets[0].currentRow = data[0];
        containerTask.widgets[1].showForm = true;
        containerTask.widgets[1].formTemplate = "widget/tabbedWidget.html";
        ScreenService.openSwipe(containerTask.widgets[1]);
    };

    this.deleteTask = function(){
        var loginInfo = getLocalVar("login");
        row = containerTask.widgets[1].widgets[0].currentRow;
        row.ORGANIZATION = loginInfo[0].organization;
        row.changed=true;
        requestDataSourceEngine.setDataSource('/deleteTask',[row]).then(function(){
            openWindow("product#task");
        });
    };


    this.initTask = function(task){
        var row = {};
        row.TASK_ID = task.ID.replace(/\D/g,'');
        row.TASK_STATUS_CONTROL = this.TASK_STATUS.EM_DESENVOLVIMENTO;//4;
        row.INIT_DATE = Utilities.getCurrentDateAndHour();//4;
        row.ALLOCATION = task.ALLOCATION;
        row.RESOURCE = task.RESOURCE_T;
        row.changed = true;
        return requestDataSourceEngine.setDataSource('/updateTaskStatus', [row]);
    };

    this.pauseTask = function(task){
        var row = {};
        row.TASK_ID = task.ID.replace(/\D/g,'');
        row.TASK_STATUS_CONTROL = this.TASK_STATUS.PAUSADA;//5;
        row.ALLOCATION = task.ALLOCATION;
        row.RESOURCE = task.RESOURCE_T;
        row.changed = true;
        return requestDataSourceEngine.setDataSource('/updateTaskStatus', [row]);
    };

    this.concludeTask = function(task){
        var row = {};
        row.TASK_ID = task.ID.replace(/\D/g,'');
        row.TASK_STATUS_CONTROL = this.TASK_STATUS.CONCLUIDA; //6;
        row.ALLOCATION = task.ALLOCATION;
        row.TASK_RESPONSE = task.TASK_RESPONSE;
        row.RESOURCE = task.RESOURCE_T;
        row.changed = true;
        return requestDataSourceEngine.setDataSource('/updateTaskStatus', [row]);
    };
    this.findTaskStatusByControl = function(control,id){
        id = id?id:0;
        control = control?control:'NOT_CONTROL';
        var filter = [
            {
                name: 'CONTROL',
                operator: 'LIKE',
                value: control
            },
            {
                name: 'ID',
                operator: '<>',
                value: id
            }
        ];
        return requestDataSourceEngine.getDataSource('/taskstatus', filter).then(function(response){
            var taskStatus = response.dataset.taskstatus;
            if(taskStatus.length){
                var nameStatus = '';
                taskStatus.forEach(function(data,index,allTaskStatus){
                    if(index  == allTaskStatus.length-1){
                        nameStatus += data.LABEL;
                    }else{
                        nameStatus += data.LABEL+', ';
                    }
                });

                ScreenService.showMessage(Utilities.messages.ERR_CHANGE_CONTROL_STATUS_ALREADY_EXISTING+nameStatus+'". '+Utilities.messages.ALE_CHANGE_CONTROL_TASK_STATUS,'E');
                return false;
            }else{
                return true;
            }
        });

    };
    /*  Defines parameters for created tasks on Project
        Management.
     */
    this.updateTaskOptionsParameters = function(widget){
        var row = {};
            row.PROPERTY_ID             = widget.currentRow.PROPERTY_ID;
            row.INITIAL_TASK_STATUS_ID  = widget.currentRow.INITIAL_TASK_STATUS_ID;
            row.FINAL_TASK_STATUS_ID    = widget.currentRow.FINAL_TASK_STATUS_ID;
            row.changed = true;
        return requestDataSourceEngine.setDataSource('/taskOptionsParameter', [row]);
    };

    /**********************************************
     * Called from 'Priorities' tab, on Issue's
     * window. His function starts to update or
     * create a new priority for issues.
     **********************************************/
    this.updateIssuePriorities = function(currentRow){
        currentRow.COLOR = tinycolor(currentRow.COLOR).toHexString();
        var row = {};
            row.ID      = currentRow.ID;
            row.LABEL   = currentRow.LABEL;
            row.COLOR   = currentRow.COLOR;
            row.changed = true;
        return requestDataSourceEngine.setDataSource('/issuePriorities', [row]);
    };


    /**********************************************
     *  Treatments for insertion of colors.
     *  This is temporally, since we'll get
     *  a colorpicker soon.
     **********************************************/
    var validateColorField = function(rowValue){

        // Remove all blank spaces
        rowValue = rowValue.replace(/ /g,'');

        // If value has not a hashtag
        if(rowValue.indexOf('#') === -1){
            rowValue = '#'+rowValue;
        }

        // If value has not 6 chars, but only 3 (e.g. #fff);
        if(rowValue.length === 4){
            var str = rowValue.slice(1);
            rowValue = rowValue+str;
        }

        rowValue = rowValue.toUpperCase();
        return rowValue;
    };

    this.closeIssue = function(issues){
        var row  = {};
        row.changed = true;
        row.ISSUES = issues;
        return requestDataSourceEngine.setDataSource('/closeIssues', [row]);
    };

    this.redoBudget = function(row){
        row.changed = true;
        return requestDataSourceEngine.setDataSource('/redoBudget', [row]);
    };

    this.reopenIssue = function(issues){
        var row  = {};
        row.changed = true;
        row.ISSUES = issues;
        return requestDataSourceEngine.setDataSource('/reopenIssue', [row]);
    };

    this.validateTaskToBeStarted = function(taskId){
        var filter = [{
            name: 'TASK_ID',
            operator: '=',
            value: taskId
        }];

        return requestDataSourceEngine.getDataSource('/validateTaskToBeStarted', filter).then(function(response){
            return response.dataset.validateTaskToBeStarted;
        });
    };

    this.getProjectsInfoCreateTasksByIssue = function (projectIds) {
        var filter = [
            {
                "name": "PROJECT_IDS",
                "operator": "=",
                "value": projectIds
            },
            {
                "name": "IS_PARENT",
                "operator": "=",
                "value": 'N'
            }
        ];
        return requestDataSourceEngine.getDataSource('/getProjectsInfoCreateTasksByIssue', filter).then(function (response) {
            return response.dataset.getProjectsInfoCreateTasksByIssue;
        });
    };

    this.setAsVisibleSingleComments = function (issues) {
        var filter = [
            {
                "name": "ISSUES",
                "operator": "=",
                "value": issues
            }
        ];
        return requestDataSourceEngine.getDataSource('/searchForSingleComments', filter).then(function (response) {
            return response.dataset.getProjectsInfoCreateTasksByIssue;
        });
    };

    this.findItemtrabRelatedToIssuesByTaskId = function (taskId) {
        var filter = [
            {
                "name": "TASK_ID",
                "operator": "=",
                "value": taskId
            }
        ];
        return requestDataSourceEngine.getDataSource('/findItemtrabRelatedToIssuesByTaskId', filter);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('TaskService',TaskService);
});


// FILE: assets/js/Service/UnreadComments.js
function UnreadCommentsService(requestDataSourceEngine){
    
    var self = this;
    
    this.getBoardIdOfIssue = function(issueId){
        var filter = {name: "issue", operator: "=", value: issueId};
        return requestDataSourceEngine.getDataSource('/issue', [filter]).then(function(data){
            return data.dataset.issue[0].BOARD;
        });
    };
    
    this.markManyAsRead = function(selectedIssues){
        var ids = getOnlyIdsFromIssueList(selectedIssues);
        var filter = buildZeedhiFilter([[ids, "ISSUES_IDS", "="]]);
        return requestDataSourceEngine.getDataSource("/selectedIssuesAsRead", filter);
    };
    
    var getOnlyIdsFromIssueList = function(issueList){
        var ids = [];
        issueList.forEach(function(issue){
            if(issue.hasOwnProperty('ID')){
                ids.push(issue.ID);
            } else if(issue.hasOwnProperty('id')){
                ids.push(issue.id);
            } else if(issue.hasOwnProperty('ISSUE_ID')){
                ids.push(issue.ISSUE_ID);
            }
        });
        return ids;
    };
    var buildZeedhiFilter = function(filterValues){
        var finalFilter = [];
        filterValues.forEach(function(filter){
            if( ! filter[0] || ! filter[1]) throw console.error("Invalid arguments.");
            var object = {};
            object.value = filter[0];
            object.name = filter[1];
            object.operator = filter[2] || "=";
            finalFilter.push(object);
        });
        return finalFilter;
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('UnreadCommentsService', UnreadCommentsService);
});

// FILE: assets/js/Service/issueConfiguration.js
function IssueConfigurationService(requestDataSourceEngine) {
    var self = this;
    
    this.updateIssuePriorities = function(currentRow){
        currentRow.COLOR = tinycolor(currentRow.COLOR).toHexString();
        var row = {};
            row.ID      = currentRow.ID;
            row.LABEL   = currentRow.LABEL;
            row.COLOR   = currentRow.COLOR;
            row.changed = true;
        return requestDataSourceEngine.setDataSource('/issuePriorities', [row]);
    };

    this.saveAddTaskClassification = function(dataSet,issueStatusId){
        dataSet.forEach(function(row){
            row.changed = true;
            row.taskType = issueStatusId;
        });
        return requestDataSourceEngine.setDataSource('/addTaskClassification', dataSet);
    };

    this.saveAddBudgetItemInClassification = function(dataSet,ClassificationId){
        dataSet.forEach(function(row){
            row.changed = true;
            row.CLASSIFICATION = ClassificationId;
        });
        return requestDataSourceEngine.setDataSource('/addBudgetItemInClassification', dataSet);
    };

    this.saveAddProjectType = function(dataSet,issueStatusId){
        dataSet.forEach(function(row){
            row.changed = true;
            row.taskType = issueStatusId;
        });
        return requestDataSourceEngine.setDataSource('/addProjectType', dataSet);
    };

    this.validateAddTaskClassification = function (issueStatusId) {
        var filter = [
            {
                name: 'TASK_TYPE',
                operator: '=',
                value: issueStatusId
            }
        ];
        return requestDataSourceEngine.getDataSource('/validateAddTaskClassification', filter).then(function(response){
           return response.dataset.validateAddTaskClassification[0];
        });
    };

    this.validateAddProjectType = function (issueStatusId) {
        var filter = [
            {
                name: 'TASK_TYPE',
                operator: '=',
                value: issueStatusId
            }
        ];
        return requestDataSourceEngine.getDataSource('/validateAddProjectType', filter).then(function(response){
           return response.dataset.validateAddProjectType[0];
        });
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('IssueConfigurationService', IssueConfigurationService);
});


// FILE: assets/js/Service/taskConfiguration.js
function TaskConfigurationService(requestDataSourceEngine){

    this.updateTaskOptionsParameters = function(widget){
        var row = {};
        row.PROPERTY_ID             = widget.currentRow.PROPERTY_ID;
        row.INITIAL_TASK_STATUS_ID  = widget.currentRow.INITIAL_TASK_STATUS_ID;
        row.FINAL_TASK_STATUS_ID    = widget.currentRow.FINAL_TASK_STATUS_ID;
        row.changed = true;
        return requestDataSourceEngine.setDataSource('/taskOptionsParameter', [row]);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('TaskConfigurationService',TaskConfigurationService);
});


// FILE: assets/js/Service/userData.js
function UserDataService(ScreenService, requestDataSourceEngine, LoginService, Utilities, localStorageEngine, Validation, templateManager, GitService) {

	var popupRepositoryFieldValue = '';

	this.onEnterUserData = function(args) {
		var resource = args.owner.dataSource.data[0].RESOURCE_ID;
		templateManager.userData.image = args.owner.dataSource.data[0].PHOTO_VIEW;
		if(!args.owner.dataSource.data[0].PHOTO_VIEW) {
			args.owner.dataSource.data[0].PHOTO_VIEW = "./images/user.jpg";
		}
		localStorageEngine.setLocalVar('resource', resource);
		args.owner.moveToFirst();
		templateManager.updateTemplate();
	};

    /*	Called when user changes project. */
    this.onChangeProject = function(widget, firstTimeChanging){
        var project = widget.currentRow.PROJECT_ID;
        localStorageEngine.setLocalVar('resourceProject', project);
        widget.getField('REPOSITORY').reload();
        if(!firstTimeChanging){
            widget.getField('REPOSITORY').value('');
        }
    };


	this.saveLocalConnection = function(widget){
        var row = widget.currentRow;
        row.changed = true;
		return requestDataSourceEngine.setDataSource("PM#/saveDirectory", [row]).then(function(response){
            row.PATH_ID =  response.dataset.resourceProjectsPaths[0];
            return response;
        });
	};

	this.openPasswordEdit = function(args) {
		var editPassWidget = args.owner.widget.container.getWidget("EDIT_PASSWORD");
		ScreenService.openPopup(editPassWidget);
	};

	this.editPassword = function(owner) {
		var currentPassword = owner.widget.getField("PASSWORD").value();
		var newPassword = owner.widget.getField("NEW_PASSWORD").value();
		var confirmPassword = owner.widget.getField("CONFIRM_PASSWORD").value();
		if(newPassword == confirmPassword) {
			if(newPassword.length >= 6 && newPassword.length  <= 20) {
				if(currentPassword != newPassword) {
					var row = {};
					row.TOKEN = localStorageEngine.getLocalVar('token');
					row.PASSWORD = owner.widget.getField("NEW_PASSWORD").value();
					row.changed = true;
					requestDataSourceEngine.setDataSource("PM#/identityPassword", [row]).then(function(data){
						requestDataSourceEngine.setDataSource("PM#/changePassword", [owner.widget.currentRow]).then(function(data) {
                            if(data.notifications && data.notifications[0].message == "Senha alterada com sucesso") {
                                owner.widget.setCurrentRow({});
                                ScreenService.closePopup();
                            }
						});
					});
				}
				else {
					ScreenService.showMessage("A nova senha deve ser diferente da atual", "ALERT");
				}
			}
			else {
				ScreenService.showMessage("A senha deve conter entre 6 e 20 caracteres", "ALERT");
			}
		}
		else {
			ScreenService.showMessage("As senhas não correspondem", "ALERT");
		}

	};

	this.onEnterEditPassword = function(owner) {
		owner.newRow();
	};

	this.openEditUser = function(args) {
		var widget = args.owner.widget.container.getWidget("editUserData");
		widget.edit();
		ScreenService.openSwipe(widget);
	};

	this.buildIdentityData  = function(widget){
        var row          = {};
        row.NAME         = widget.currentRow.NAME;
        var name         = widget.currentRow.NAME.split(" ");
        row.FIRSTNAME    = name[0];
        row.LASTNAME     = name[name.length - 1];
        row.EMAIL        = widget.currentRow.EMAIL;
        row.PASSWORD     = widget.currentRow.PASSWORD;
        row.STATUS       = widget.currentRow.STATUS;
        row.TOKEN        = localStorageEngine.getLocalVar('token');
        row.changed      = true;
        return row;
    };

    this.saveIdentityInformation = function(identityData){
        return requestDataSourceEngine.setDataSource("PM#/changeIdentityUser", [identityData]);
    };

    this.saveUserProfile = function(name, email, photoView, photoUpload){
        var dataSet = {
            NAME: name,
            EMAIL: email,
            PHOTO_VIEW: photoView,
            PHOTO_UPLOAD: photoUpload,
            changed: true
        };
        return requestDataSourceEngine.setDataSource("PM#/saveEditedUserData", [dataSet]);
    };
    
    var validateEmptyPath = function(path, validationReturn) {
        return GitService.ls(path).then(function (dataLs) {
            if (dataLs === '') {
                validationReturn.VALIDATION = true;
            }

            return validationReturn;
        });
    };

    this.validateRepositoryPath = function(path, url) {
        return GitService.lsRemote('/', url).then(function() {
            return GitService.currentGitRemote(path).then(function(data) {
                var validationReturn = {
                    VALIDATION: false,
                    URL: data
                };

                var emptyPathValidation = null;
                if(typeof data == 'object') {
                    if(!data.hasOwnProperty('connectionError') && (data.data.indexOf('pode encontrar o caminho') != -1 || data.data.indexOf("can't cd to") != -1)) {
                        validationReturn.VALIDATION = true;
                    } else if(data.data.indexOf('Not a git repository') != -1) {
                        emptyPathValidation = validateEmptyPath(path, validationReturn);
                    }
                } else if(data == url) {
                    validationReturn.VALIDATION = true;
                }

                return emptyPathValidation || validationReturn;
            });
        });
    };

    this.validateProjectInitializedTasks = function(projectId) {
        var filter = [
            { "operator": "=", "name": "PROJECT", "value": projectId }
        ];
        return requestDataSourceEngine.getDataSource('PM#/projectTasksInitialized', filter).then(function(data) {
            if(data.dataset.tasksInitialized.length > 0) {
                var tasks = '';
                data.dataset.tasksInitialized.forEach(function(task) {
                    tasks += '"' + task.NAME + '"; ';
                });
                return tasks.slice(0, -2);
            } else {
                return false;
            }
        });
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('UserDataService', UserDataService);
});


// FILE: assets/js/Controller/AccessProfile.js
function AccessProfileController(templateManager, Utilities){
    var getAccessProfileWidget = function() {
        return templateManager.container.getWidget('accessProfileWidget');
    };
    
    this.accessProfileContainerAfterinit = function () {
        getAccessProfileWidget().sourceUrl = Utilities.getUrlPmNext('modules/acl/perfil-de-acesso');
    };
}

Configuration(function(ContextRegister) {
	ContextRegister.register('AccessProfileController', AccessProfileController);
});

// FILE: assets/js/Controller/AccompanyingIssues.js
function AccompanyingIssuesController(ScreenService, templateManager, Utilities, IssueService, ZHPromise,
         CommentService, TaskService, localStorageEngine, requestDataSourceEngine, ProjectServiceList, ZhFilterPreferences){

    var self = this;

    var getIssuesMainWidget = function(){
        return templateManager.container.getWidget('ISSUES_MAIN');
    };

    var getIssuesMainFilterWidget = function(){
        return getIssuesMainWidget().appliedFilter;
    };

    var getIssuesMainGridFilterWidget = function(){
        return getIssuesMainGridWidget().appliedFilter;
    };

    var getWidgetIssueUpload = function(){
        return templateManager.container.getWidget('ISSUE_UPLOAD');
    };

    var getWidgetDocumentsComment = function(){
        return templateManager.container.getWidget('DOCUMENTS_COMMENT');
    };

    var getWidgetTabbedBoardIssue = function () {
        return templateManager.container.getWidget('TABBED_BOARD_ISSUE');
    };

    var getWidgetComments = function(){
        return templateManager.container.getWidget('COMMENTS');
    };

    var getFieldFollowerFromWidgetIssueMainGrid = function(){
        return getIssuesMainGridWidget().getField('FA--RESOURCE_T');
    };

    var getWidgetNewComment = function(){
        return templateManager.container.getWidget('NEW_COMMENT');
    };

    var getWidgetMyIssuesTabbed = function(){
        return templateManager.container.getWidget('MY_ISSUES_TABBED');
    };

    var getFieldDocumentFromNewCommentWidget =  function(){
        return getWidgetNewComment().getField('DOCUMENT');
    };

    var getIssueMainWidget = function(){
        return templateManager.container.getWidget('ISSUE_MAIN');
    };

    var getIssuesMainGridWidget = function(){
        return templateManager.container.getWidget('ISSUES_MAIN_GRID');
    };

    var getTabbedIssueWidget = function(){
        return templateManager.container.getWidget('TABBED_ISSUE');
    };

    var getFieldTaskStatusFromWidgetIssuesMainGrid = function() {
        return getIssuesMainGridWidget().getField('I--TASK_STATUS');
    };

    var getFieldFramingFromIssuesMainWidget = function(){
        return getIssuesMainWidget().getField('FRAMING');
    };

    var getFieldProjectFromIssuesMainFilterWidget = function(){
        return getIssuesMainFilterWidget().getField('I--PROJECT');
    };

    var getFieldProjectFromIssuesMainGridFilterWidget = function(){
        return getIssuesMainGridFilterWidget().getField('I--PROJECT');
    };

    var getFieldLabelFromIssuesMainFilterWidget = function(){
        return getIssuesMainFilterWidget().getField('TL--LABEL');
    };

    var getFieldLabelFromIssuesMainGridFilterWidget = function(){
        return getIssuesMainGridFilterWidget().getField('TL--LABEL');
    };

    var getFieldFollowerFromWidgetIssueMain = function(){
        return getIssuesMainWidget().getField('FA--RESOURCE_T');
    };

    var getFieldTaskStatusFromWidgetIssuesMain = function() {
        return getIssuesMainWidget().getField('I--TASK_STATUS');
    };

    var getNewLabelWidget = function(){
        return templateManager.container.getWidget('NEW_LABEL');
    };

    var getIssuesLabelsRelationshipWidget = function(){
        return templateManager.container.getWidget('ISSUES_LABELS_RELATIONSHIP');
    };

    var getIssuesFieldFromIssuesLabelsRelationshipWidget = function(){
        return getIssuesLabelsRelationshipWidget().getField('ISSUES');
    };

    var getLabelsFieldFromIssuesLabelsRelationshipWidget = function(){
        return getIssuesLabelsRelationshipWidget().getField('LABELS');
    };

    var getFieldFollowersFromWidgetIssueMain = function(){
        return getIssueMainWidget().getField('FOLLOWERS');
    };

    var getFieldCdItemtrabFromWidgetIssueMain = function(){
        return getIssueMainWidget().getField('CDITEMTRAB');
    };

    var getLabelsRelatedUserFieldFromIssueMainWidget = function(){
        return getIssueMainWidget().getField('LABELS');
    };

    var getFieldIdFromGridIssuesMainWidget = function(){
        return getIssuesMainGridWidget().getField('id');
    };

    var getActionStopFollowerFromIssueMain = function(){
        return getIssueMainWidget().getAction('STOP_FOLLOWER');
    };

    this.issueUploadActionEventBackView = function(args) {
        ScreenService.closeSwipe();
    };

    this.issuesMainKanbanOnTaskClick = function(args){
        var issuesMainWidget = getIssuesMainWidget();
        var issueMainWidget = getIssueMainWidget();
        var tabbedIssue = getTabbedIssueWidget();
        var currentWidget = tabbedIssue.currentWidget || issueMainWidget;

        saveClickedIssueLocalStorage(args.e.item.id);

        if(currentWidget.mode == "edit") {
            setWidgetAsViewMode(currentWidget);
        }

        ScreenService.openSwipe(tabbedIssue).then(function(){
            updateWidgetDataSource(issueMainWidget).then(function() {
                if (currentWidget != issueMainWidget){
                    return currentWidget.reload();
                }
            }).then(function(){
                issuesMainWidget.descriptionOrder = issueMainWidget.currentRow.ID + ' - ' + issueMainWidget.currentRow.LABEL;
            });

        });
    };
    

    this.issuesMainGridWidgetOnEnter = function(args){
        ScreenService.showLoader();
        Utilities.localVar.getLoginPromise().then(function(){
            ScreenService.hideLoader();
            var widget = getIssuesMainGridWidget();
            if (Utilities.isAppliedFilter(widget)){
                widget.reload();
            } else {
                setDefaultFilterValues(widget);
            }
        }).catch(ScreenService.hideLoader);
    };

    this.issuesMainGridFilterAfterApply = function(){
        Utilities.setFilterInit(getIssuesMainGridWidget());
    };

    this.issuesMainWidgetOnEnter = function(args){
        ScreenService.showLoader();
        Utilities.localVar.getLoginPromise().then(function(){
            ScreenService.hideLoader();
            var widget = getIssuesMainWidget();
            if (Utilities.isAppliedFilter(widget)) {
                widget.reload();
            } else {
                setDefaultFilterValues(widget);
            }
        }).catch(ScreenService.hideLoader);
    };

    this.issueLogWidgetOnEnterTab = function(args){
        args.owner.reload();
    };

    var setDefaultFilterValues = function(widget){
        var followerFieldFromIssuesMain = {};
        var taskStatusFromBoardIssue = {};
        var userId = Utilities.localVar.getLocalVarIdBusinessPartner();
        if(widget.isPMGridIssue){
            followerFieldFromIssuesMain = getFieldFollowerFromWidgetIssueMainGrid();
            taskStatusFromBoardIssue = getFieldTaskStatusFromWidgetIssuesMainGrid();
        } else {
            followerFieldFromIssuesMain = getFieldFollowerFromWidgetIssueMain();
            taskStatusFromBoardIssue = getFieldTaskStatusFromWidgetIssuesMain();
        }

        var taskParameters = Utilities.localVar.getTaskParameters();
        var valueParameterFinal = taskParameters ? taskParameters.FINAL_TASK_STATUS_ID : 0;

        widget.currentRow['I--CREATED_AT'] = Utilities.getLastThirdyDayPeriod();

        return Utilities.setDefaultValueToSelectMultipleFieldFilteringData(
            taskStatusFromBoardIssue, [valueParameterFinal], 'ID', 'ID'
        ).then(function(){
            return Utilities.setDefaultValueToSelectMultipleFieldFilteringData(
                getFieldFramingFromIssuesMainWidget(), Utilities.constants.CONTROL_TASK_TYPE_HOMOLOGATED, 'CONTROL', 'ID'
            );
        }).then(function(){
            followerFieldFromIssuesMain.value([userId]);
            ZhFilterPreferences.setOriginalFilter(widget.id, widget.currentRow);
            Utilities.applyDefaultFilterOnEnter(widget, true);
            self.initFilterAccompanyingIssue = false;
        });
    };

    this.issueMainActionEventBack = function (args) {
        backToMainWidget();
    };

    var removeCurrentUserFollower = function(issueId,issueWidget) {
        IssueService.removeCurrentUserFollower(issueId,issueWidget).then(function(){
            ScreenService.showLoader();
            issueWidget.reload().then(function() {
                ScreenService.hideLoader();
                issueWidget.moveToFirst();
            }).catch(ScreenService.hideLoader);
        });
    };

    this.issueMainActionEventStopFollower = function (args) {
        var issueWidget = getIssueMainWidget();
        var issueId = issueWidget.currentRow.ID;
        var functionBind = removeCurrentUserFollower.bind(this,issueId,issueWidget);
        ScreenService.confirmMessage(Utilities.messages.ALE_DELETE_FOLLWER, 'question',functionBind);
    };

    this.issueMainWidgetAfterLoadDataSource = function (args) {
        var issueWidget = getIssueMainWidget();
        var stopFollowerWidget = getActionStopFollowerFromIssueMain();
        if(issueWidget.dataSource.data[0]){
            var followers = issueWidget.dataSource.data[0].FOLLOWERS;
            var userId = Utilities.localVar.getLocalVarIdBusinessPartner();
            stopFollowerWidget.isVisible = followers.some(function(follower){
                return follower == userId;
            });
        }
    };

    var backToMainWidget = function () {
        var widget = getWidgetMyIssuesTabbed().currentWidget;
        ScreenService.closeSwipe();
        widget.list();
        widget.activate();
        widget.reload();
    };

    this.issuesMainGridWidgetAfterMoveRow = function(args){
        saveClickedIssueLocalStorage(getFieldIdFromGridIssuesMainWidget().value());

        var tabbedIssue = getTabbedIssueWidget();
        tabbedIssue.descriptionOrder = getIssuesMainGridWidget().descriptionOrder;
        var currentWidget = tabbedIssue.currentWidget || getIssueMainWidget();
        var issueMainWidget = getIssueMainWidget();
        var issuesMainWidget = getIssuesMainWidget();
        var issuesMainGridWidget = getIssuesMainGridWidget();
        if(currentWidget.mode == "edit") {
            setWidgetAsViewMode(currentWidget);
        }
        ScreenService.openSwipe(tabbedIssue).then(function(){
            updateWidgetDataSource(issueMainWidget).then(function(){
                if (currentWidget != issueMainWidget) {
                    return currentWidget.reload();
                }
                return ZHPromise.when();
            }).then(function(){
                issuesMainWidget.descriptionOrder = issueMainWidget.currentRow.ID + ' - ' + issueMainWidget.currentRow.LABEL;
            });
        });
    };

    this.issueMainActionEventEdit = function(args){
        var issueMainWidget = args.owner.widget;
        setWidgetAsEditMode(issueMainWidget);
    };

    this.issuesMainWidgetAfterLoadDataSource = function(widget, movable){
		widget.dataSource.data.forEach(function(item, index, dataSource){
			dataSource[index].movable = movable;
		});
		Utilities.reloadTaskTypes(widget).then(function (){
            widget.dataSource.data = Util.clone(widget.dataSource.data);
            templateManager.updateTemplate();
        });
    };

    this.issuesMainWidgetOnEnterOnce = function(args){
        Utilities.reloadTaskTypes(getIssuesMainWidget());
    };

    var setWidgetAsEditMode = function(widget){
        widget.edit();
        widget.template = "widget/form.html";
    };

    this.newLabelActionEventBack = function(){
        ScreenService.closePopup();
    };

    this.issueMainActionEventSave = function(args){
        saveWidgetRow(getIssueMainWidget());
    };

    this.issueMainActionEventCancel = function(args){
        var widget = getIssueMainWidget();
        Utilities.genericCancelEvent(widget);
        widget.template = widget.templateToView;
    };

    var kanbanStart = false;
    var listStart = false;

    this.issueMainFieldOnAddLabels = function(args){
        var widget = getNewLabelWidget();
        widget.newRow();
        ScreenService.openPopup(widget);
    };

    this.newCommentGridActionEventSave = function(args){
        CommentService.saveComment(getNewCommentGridWidget(), closePopupAndReloadCommentWidgetsForGrid, reopenIssueForGrid);
    };

    this.commentsGridWidgetOnEnterTab = function(){
        self.viewComments();
        self.filterCommentsGrid();
    };

    this.issueUploadWidgetOnEnterTab = function(){
        getWidgetIssueUpload().reload();
    };

    this.filterCommentsGrid = function(){
        var widget = getCommentsGridWidget();
        if(widget.innerFilters){
            widget.dataSourceFilter = widget.innerFilters;
        }
        widget.reload();
    };

    this.viewComments = function(){
        var row = {};
        var issue = localStorageEngine.getLocalVar('issue');
        row.ISSUE = Array.isArray(issue) ? issue[0] : issue;
        row.changed = true;
        requestDataSourceEngine.setDataSource('/viewComments',[row], undefined, undefined, undefined, undefined, true).then(function(response){
            if(Array.isArray(response)){
                localStorageEngine.setLocalVar('lastDateViewComments',null);
            }else{
                localStorageEngine.setLocalVar('lastDateViewComments',response.dataset.lastDate[0]);
            }
        });
    };

    var closePopupAndReloadCommentWidgetsForGrid = function() {
        ScreenService.closePopup();
        getCommentsGridWidget().reload();
        getNewCommentGridWidget().reload();
    };

    var reopenIssueForGrid = function() {
        var issue = localStorageEngine.getLocalVar('issue');
        return TaskService.reopenIssue(issue).then(function (data) {
            var issueMainWidget = getIssueMainGridWidget();
            return issueMainWidget.reload().then(function () {
                ScreenService.closeSwipe();
                issueMainWidget.activate();
                return data;
            });
        });
    };

    this.issuesMainGridFilterBeforeApply = function(args){
        Utilities.setFilterInit(getIssuesMainWidget());
        Utilities.reloadTaskTypes(getIssuesMainWidget());
    };

    this.newLabelActionEventSave = function(args){
        var widget = args.owner.widget;
        if( ! widget.isValid()){
            ScreenService(Utilities.messages.ERR_REQUIRED_FIELDS);
            return false;
        }
        createLabel();
    };

    var setDefaultValuesInFieldTaskStatus = function(field, values){
        field.reload().then(function(){
            var rows = Utilities.filterRowsInDataSourceUnwanted(field.dataSource, values, 'CONTROL');
            field.filterProperties.defaultValue = Utilities.createArrayByDataSetAndIndex(rows, 'ID');
        });
    };

    this.issuesLabelsRelationshipActionEventCancel = function(args){
        backToWidgetClosingPopup(getIssuesMainWidget());
    };

    this.issuesLabelsRelationshipActionEventSave = function(args){
        var widget = args.owner.widget;
        if(widget.isValid()) {
            sendIssuesAndLabelsToRelationship();
        }
    };

    var sendIssuesAndLabelsToRelationship = function(){
        var selectedIssues = getIssuesFieldFromIssuesLabelsRelationshipWidget().value();
        var selectedLabels = getLabelsFieldFromIssuesLabelsRelationshipWidget().value();
        IssueService.sendIssuesAndLabelsToRelationship(selectedIssues, selectedLabels).then(function(successful){
            ScreenService.closePopup();
        });
    };

    this.issuesMainActionEventApplyLabels = function(args){
        if(getIssuesMainWidget().hasCheckedRows()) {
            applySelectedIssuesToIssuesField();
            getLabelsFieldFromIssuesLabelsRelationshipWidget().reload();
            openPopupForLabelsRelationship();
        }else{
            ScreenService.showMessage(Utilities.messages.NOT_CHECKED_ROW_ISSUE);
        }
    };

    this.issuesMainGridActionEventApplyLabels = function(args){
        if(getIssuesMainGridWidget().hasCheckedRows()) {
            applySelectedIssuesToIssuesFieldWhenGrid();
            getLabelsFieldFromIssuesLabelsRelationshipWidget().reload();
            openPopupForLabelsRelationship();
        }else{
            ScreenService.showMessage(Utilities.messages.NOT_CHECKED_ROW_ISSUE);
        }
    };

    var applySelectedIssuesToIssuesField = function(){
        var field = getIssuesFieldFromIssuesLabelsRelationshipWidget();
        var selectedIssuesOnKanban = getIssuesMainWidget().getCheckedRows();
        field.dataSource.data = selectedIssuesOnKanban;
        field.value(Utilities.arrayFromPropertyOfObjectList(selectedIssuesOnKanban, "id"));
    };

    var applySelectedIssuesToIssuesFieldWhenGrid = function(){
        var field = getIssuesFieldFromIssuesLabelsRelationshipWidget();
        var selectedIssuesOnKanban = getIssuesMainGridWidget().getCheckedRows();
        field.dataSource.data = selectedIssuesOnKanban;
        field.value(Utilities.arrayFromPropertyOfObjectList(selectedIssuesOnKanban, "id"));
    };

    var openPopupForLabelsRelationship = function(){
        ScreenService.openPopup(getIssuesLabelsRelationshipWidget());
    };

    var createLabel = function(){
        var newLabelWidget = getNewLabelWidget();
        newLabelWidget.IS_PROJECT = 'N';
        newLabelWidget.saveRow().then(function(){
            ScreenService.closePopup();
            getLabelsRelatedUserFieldFromIssueMainWidget().reload();
        });
    };

    var saveClickedIssueLocalStorage = function(issueId){
        Utilities.localVar.setIssue(issueId);
    };

    var setWidgetAsViewMode = function(widget){
        widget.view();
        widget.template = Utilities.defaultTemplates.formView;
    };

    var saveWidgetRow = function(widget){
        widget.currentRow.IS_SAVING_ONLY_RELATED = true;
        widget.saveRow().then(function(){
            ScreenService.showLoader();
            widget.reload().then(function(){
                ScreenService.hideLoader();
                setWidgetAsViewMode(widget);
                widget.activate();
            }).catch(ScreenService.hideLoader);
        });
    };

    var backToWidgetClosingPopup = function(widget){
        ScreenService.closePopup();
        widget.activate();
    };

    var backToWidget = function(widget){
        Utilities.genericBackEventIsNotMasterDetail(widget);
    };

    var updateWidgetDataSource = function(widget){
        widget.list();
        ScreenService.showLoader();
        return widget.reload().then(function(){
            ScreenService.hideLoader();
            widget.moveToFirst();
            Utilities.bugPaginationOnSelectMultiplyOnModeView(getFieldFollowersFromWidgetIssueMain());
            Utilities.bugPaginationOnSelectMultiplyOnModeView(getFieldCdItemtrabFromWidgetIssueMain());
        }).catch(ScreenService.hideLoader);
    };

    this.issueMainFieldOnClickLabels = function(args){
        var field = args.owner.field;
        field.reload();
    };

    this.issueUploadActionEventBack = function(args){
        backToMainWidget();
    };

    this.issueGridUploadActionEventBack = function(args){
        backToMainWidget();
    };

    this.issueGridUploadActionEventBackView = function(args){
        ScreenService.closeSwipe();
    };

    this.commentsActionEventBack = function(args){
        backToMainWidget();
    };

    this.commentsActionEventAddComments = function(args) {
        widget = getIssueMainWidget();
        if (widget.currentRow.FINISHED === 'Y') {
            ScreenService.showMessage(Utilities.messages.ERR_COMMENT_CLOSED);
        } else {
            IssueService.findCommentTypeByControl("C").then(function(commentType){
                var commentTypeId = commentType ? commentType.ID : 0;
                var commentDescription = commentType ? commentType.COMMENT_DESCRIPTION : null;
                getFieldDocumentFromNewCommentWidget().validations = commentType && commentType.ATTACHMENT_REQUIRED == 'Y' ? {"required": {}} : {};
                self.addComment(null, false, commentTypeId,commentDescription);
            });
        }
    };

    this.addComment = function(args, calledByReopenIssue,commentTypeId,commentDescription){
        commentTypeId = commentTypeId ? commentTypeId : 0;
        var newCommentWidget = getWidgetNewComment();
        newCommentWidget.dataSource.data = [];
        newCommentWidget.newRow();
        newCommentWidget.list();
        newCommentWidget.currentRow.COMMENT_TYPE_ID = commentTypeId;
        newCommentWidget.currentRow.TASK = getLocalVar('issue')[0];
        newCommentWidget.currentRow.calledByReopenIssue = calledByReopenIssue;
        newCommentWidget.currentRow.DESCRIPTION = commentDescription;
        ScreenService.openPopup(newCommentWidget);
    };

    this.commentsWidgetAfterMoveRow = function(args){
        var currentRow = getWidgetComments().currentRow;
        Utilities.localVar.setComment(currentRow.ID);
        getWidgetDocumentsComment().reload();
    };

    this.commentsActionEventBackView = function(args){
        ScreenService.closeSwipe();
        getWidgetComments().reload();
    };

    this.issueLogActionEventBack = function(args){
        backToMainWidget();
    };

    this.issueMainWidgetOnEnter = function(args){
        var fieldFollowers = getFieldFollowersFromWidgetIssueMain();
        Utilities.bugPaginationOnSelectMultiplyOnModeView(fieldFollowers);
    };

    this.projectFieldFromIssuesMainFieldOnChange = function(args) {
        Utilities.localVar.setProductFilter(getFieldProjectFromIssuesMainFilterWidget().value());
        var labelField = getFieldLabelFromIssuesMainFilterWidget();
        labelField.reload();
        labelField.value([]);
    };

    this.projectFieldFromIssuesMainGridFieldOnChange = function(args) {
        Utilities.localVar.setProductGridFilter(getFieldProjectFromIssuesMainGridFilterWidget().value());
        var labelField = getFieldLabelFromIssuesMainGridFilterWidget();
        labelField.reload();
        labelField.value([]);
    };

    this.issueUploadActionEventDownload = function(args){
        var row = getWidgetIssueUpload().currentRow;
        ProjectServiceList.downLoadAttachment(row);
    };

    this.commentsWidgetOnEnterTab = function(args){
        getWidgetComments().reload();
        self.viewComments();
    };

    this.newCommentActionEventSave = function(args){
        CommentService.saveComment(getWidgetNewComment(), closePopupAndReloadCommentWidgets, reopenIssue);
    };


    var closePopupAndReloadCommentWidgets = function() {
        ScreenService.closePopup(true);
        getWidgetComments().reload();
        getWidgetNewComment().reload();
    };

    var reopenIssue = function() {
        var issue = Utilities.localVar.getIssue();
        return TaskService.reopenIssue(issue).then(function (data) {
            var issueMainWidget = getIssueMainWidget();
            return issueMainWidget.reload().then(function () {
                ScreenService.closeSwipe();
                issueMainWidget.activate();
                return data;
            });
        });
    };
}

Configuration(function(ContextRegister){
    ContextRegister.register('AccompanyingIssuesController', AccompanyingIssuesController);
});


// FILE: assets/js/Controller/Acl.js
function AclController(AclService, templateManager, localStorageEngine, ScreenService, ZHPromise, Validation, Utilities, requestDataSourceEngine) {
	var PROFILE_CONTROL = {
		GERENTE: 'M',
		CLIENTE: 'C'
	};
	var self = this;
	this.afterLoadDataSource = function(widget){
		var elements = widget.dataSource.data;
		for(i=0; i<elements.length; i++) {
			widget.dataSource.data[i].TYPE = AclService.translateElementType(elements[i].ELEMENT_TYPE);
			widget.dataSource.data[i].RULE_NAME = AclService.translateRuleType(elements[i].RULE);
		}
		templateManager.updateTemplate();  
	};

	function startInfoWidget(infoWidget){
		infoWidget.view();
		infoWidget.template = infoWidget.formTemplate;
	}

	this.onSelectProfile = function(widget){
		var container = widget.container;
		localStorageEngine.setLocalVar('profile', widget.currentRow.ID);
		ScreenService.openSwipe(container.getWidget('TABBED_FOR_ACL'));
		container.getActiveWidget().reload();
	};

	this.onEditProfile = function(widget){
		widget.edit();
		widget.template = widget.formTemplate;
	};

    function goListActivating(widget){
		if(ScreenService.isSwipeOpen(1)){
            widget.container.getWidget('ELEMENT_LIST').activate();
        }
		else{
			widget.activate();
        	localStorageEngine.setLocalVar('profile', null);
		}
		widget.list(true);
		templateManager.updateTemplate();
    }

	this.goList = function(reload){
		var mainWidget = templateManager.container.widgets[0];
		if(reload){
			mainWidget.reload().then(function(){
				goListActivating(mainWidget);
			});
		}
		else{
			goListActivating(mainWidget);
		}
	};

	this.saveProfileInfo = function(widget){
		if(widget.isValid()){
			widget.saveRow().then(function(){
				widget.reload();
				self.goList(true);
			});
		}
	};

	this.onEnterTab = function(widget){
		if(widget.name === 'PROFILE'){
			startInfoWidget(widget);
		}
		else{
			widget.list();
		}
		widget.activate();
	};

	var setControlVisibility = function(widget) {
		var control = widget.dataSource.data[0].CONTROL;
		if(control !== PROFILE_CONTROL.GERENTE && control !== PROFILE_CONTROL.CLIENTE) {
			widget.fields[2].isVisible = false;
			templateManager.updateTemplate();
		} else {
			widget.fields[2].isVisible = true;
			templateManager.updateTemplate();
		}
        
	};

	this.onLoadProfile = function(widget){
		widget.moveToFirst();
		//setControlVisibility(widget);

	};

	this.onChangeElementType = function(widget){
		localStorageEngine.setLocalVar('elementType', widget.currentRow.TYPE);
		var elementField = widget.getField('ELEMENT_NAME');
		elementField.reload().then(function(){
			elementField.value(null);
			onLoadElementDataSource(elementField.dataSource.data);
			templateManager.updateTemplate();
		});
	};

	this.onAddProfile = function(widget){
		var newProfileWidget = widget.container.getWidget('PROFILE');
		ScreenService.openSwipe(newProfileWidget);
		newProfileWidget.newRow();
		newProfileWidget.template = newProfileWidget.formTemplate;
	};

	this.onEnterContainer = function(container){
		container.widgets[0].reload().then(function(){
			templateManager.updateTemplate();
		});
	};

	this.onRemoveProfile = function(widget){
		var checkedProfiles = widget.dataSource.getCheckedRows();
		var defaultProfiles = [];
		var associatedProfiles = [];
		var promises = [];
		for(var index = 0; index < checkedProfiles.length; index++) {
			var profile = checkedProfiles[index];
			if(profile.CONTROL){
				defaultProfiles.push(profile.NAME);
				checkedProfiles.splice(index, 1);
				index--;
			}
			else if(profile.ASSOCIATION_COUNT){
				associatedProfiles.push(profile.NAME);
			}
		}
		if(defaultProfiles.length){
			promises.push(ScreenService.confirmMessage(	'Os perfis ' + defaultProfiles.join(', ') +
														' não serão deletados pois são perfis padrão. Deseja continuar?'));
		}
		if(associatedProfiles.length){
			promises.push(ScreenService.confirmMessage(	'Os perfis ' + associatedProfiles.join(', ') +
														' são associados a recursos e essa ligação será deletada. Deseja continuar?'));
		}
		if(checkedProfiles.length){
			ZHPromise.all(promises).then(function(){
				widget.dataSource.remove(checkedProfiles).then(function(){
					widget.reload();
				});
			});
		}
		else{
			ScreenService.showMessage('Nenhum perfil foi deletado pois todos selecionados são perfis padrão.');
		}
	};

	this.onChangeRulePermission = function(action){
		var widget = action.widget;
		widget.currentRow.RULE = AclService.togglePermission(widget.currentRow.RULE, action.name);
		widget.currentRow.PROFILE = localStorageEngine.getLocalVar('profile');
		widget.saveRow().then(function(){
			Utilities.keepOpenList(widget);
		});
	};

	this.onAddProfileResources = function(widget){
		var profileResourcesAddWidget = widget.container.getWidget('PROFILE_RESOURCE_ADD');
		ScreenService.openPopup(profileResourcesAddWidget);
		profileResourcesAddWidget.reload();
	};

	function isSameResource(resource){
		return resource.ID === this.resourceId;
	}

	this.onLoadProfileResourcesAdd = function(widget){
		var profileResources = widget.container.getWidget('PROFILE_RESOURCE_LIST').dataSource.data;
		var dataSource =  widget.dataSource.data;
		var length = dataSource.length;
		var filter = {};
		var alreadyAssociated;
		var profile = localStorageEngine.getLocalVar('profile');
		for (var i = length - 1; i >= 0; i--) {
			filter.resourceId = dataSource[i].ID;
			alreadyAssociated = profileResources.filter(isSameResource, filter);
			dataSource[i].PROFILE = profile;
			dataSource[i].changed = true;
			if(alreadyAssociated[0]){
				dataSource.splice(i, 1);
			}
		}
	};

	this.onSaveProfileResources = function(widget){
		requestDataSourceEngine.setDataSource('/profileResources', widget.dataSource.getCheckedRows()).then(function(){
			ScreenService.closePopup();
			widget.container.getWidget('PROFILE_RESOURCE_LIST').reload();
		});
	};

	this.onRemoveProfileResources = function(widget){
		widget.removeCheckedRows();
	};

	this.onLoadProfileResources = function(widget){
		var profile = localStorageEngine.getLocalVar('profile');
		widget.dataSource.data.forEach(function(resource, index, resources){
			resources[index].PROFILE = profile;
		});
	};
}

Configuration(function(ContextRegister) {
    ContextRegister.register('AclController', AclController);
});



// FILE: assets/js/Controller/AclLabels.js
function AclLabelsController(templateManager, Utilities){
    var getAclLabelsWidget = function() {
        return templateManager.container.getWidget('aclLabelsWidget');
    };

    this.aclLabelsContainerAfterinit = function () {
        getAclLabelsWidget().sourceUrl = Utilities.getUrlPmNext('acl-labels');
    };
}

Configuration(function(ContextRegister) {
	ContextRegister.register('AclLabelsController', AclLabelsController);
});


// FILE: assets/js/Controller/Appropriation.js
function AppropriationController(GitQueue, GitService, TaskService, ZHPromise, requestDataSourceEngine, localStorageEngine,
                                 ScreenService, AppropriationService, Utilities, DateManager, templateManager, Messages,
                                 metaDataFactory, ProjectServiceList, IssueService,LibUtilities) {

    /*jshint -W087 */

    var CONFLICT_TYPES = {};
    CONFLICT_TYPES.DD = "both deleted";
    CONFLICT_TYPES.AU = "added by us";
    CONFLICT_TYPES.UD = "deleted by them";
    CONFLICT_TYPES.UA = "added by them";
    CONFLICT_TYPES.DU = "deleted by us";
    CONFLICT_TYPES.AA = "both added";
    CONFLICT_TYPES.UU = "both modified";
    var TASK_STATUS = {
        NAO_INICIADA: 'N',
        EM_DESENVOLVIMENTO: 'D',
        PAUSADA: 'P',
        CONCLUIDA: 'C'
    };
    var OK_STATUS = 'ok';
    var pauseFiles = {};
    var returnToTimeByActivity = false;
    var currentTaskStatus;
    var unmodifiedDirectories;
    var masterFilesToCommit = [];
    var returnToInfoTaskWidget = false;
    var commit = [];
    var reset = [];
    var stash = [];
    var createMergeRequest = false;
    var generateTask = false;
    var filesWithStatus = [];
    var id = null;
    var renamed_Status = "Renomeado";
    var untracked_Status = "Adicionado";
    var modified_Status = "Modificado";
    var differenceTime = null;
    var list_tasks = null;
    var self = this;
    var ALLOWENDTASK_NEGATIVE = 'N';
    var USETIMEPLANNING_NEGATIVE = 'N';
    var PROJECT_EXTERNALTYPE_ERROR = 'E';
    var TYPE_RELATIONSHIP_REPLICATION     = 'R';
    var TYPE_RELATIONSHIP_MERGE_REQUEST   = 'M';
    var TYPE_RELATIONSHIP_ERROR           = 'E';
    var TYPE_RELATIONSHIP_ERROR_MR        = 'G';
    var TYPE_RELATIONSHIP_CONFLICT        = 'C';
    var TYPE_RELATIONSHIP_CONFLICT_DEVOPS = 'D';
    var TYPE_RELATIONSHIP_TEST            = 'T';
    var TYPE_RELATIONSHIP_RELATED_TASK    = 'A';
    var CLASSIFICATION_SPECIFICATION      = 'S';
    var DESC_LOG_COMMITED_FILES = '-- Arquivos para commit --';
    var DESC_LOG_RESETED_FILES  = '\n\n-- Arquivos para reset --';
    var DESC_LOG_STASHED_FILES  = '\n\n-- Arquivos para stash --';
    var allCurrentTaskStatus = ['PAUSE','COMMIT','CONCLUDE','STATUS'];

    TaskService.TASK_STATUS = TASK_STATUS;

    var isProductAssociation = function() {
        return !!getInfoTaskWidget().currentRow.SUBRELEASE_ID;
    };

    /************************************************************
     * Widget getters
     ************************************************************/
    var getWidgetInfoTask = function(){
        return templateManager.container.getWidget('INFO_TASK');
    };

    var getWidgetUnatendedTasks = function(){
        return templateManager.container.getWidget('UNATENDED_TASKS');
    };
    var getWidgetTaskIssues = function(){
        return templateManager.container.getWidget('TASK_ISSUES');
    };
    var getIssueCommentWidget = function(){
        return templateManager.container.getWidget('TASK_ISSUES_COMMENTS');
    };

    var getDocumentsWidget = function(){
        return templateManager.container.getWidget('DOCUMENTS');
    };
    var getPopupDiffWidget = function(){
        return templateManager.container.getWidget('POPUP_DIFF');
    };
    var getIssueTabbedWidget = function(){
        return templateManager.container.getWidget('TASK_ISSUES_TABBED');
    };
    var getIssueAttachmentsWidget = function(){
        return templateManager.container.getWidget('TASK_ISSUES_ATTACHMENTS');
    };
    var getListTasksWidget = function(){
        return templateManager.container.getWidget('LIST_TASKS');
    };
    var getTimeByActivityWidget = function(){
        return templateManager.container.getWidget('TIME_BY_ACTIVITY');
    };
    var getStripeNavigatorWidget = function () {
        return templateManager.container.getWidget('STRIPE_NAVIGATOR');
    };
    var getWidgetCommitCommentPopup = function () {
        return templateManager.container.getWidget('COMMIT_COMMENT_POPUP');
    };
    var getLogWidget = function () {
        return templateManager.container.getWidget('LOG');
    };

    var getWidgetIssueMain = function(){
        return templateManager.container.getWidget('ISSUE_MAIN');
    };

    var getWidgetSpecificationCommentPopup = function(){
        return templateManager.container.getWidget('SPECIFICATION_COMMENT_POPUP');
    };

    var getWidgetCreateNewTask = function(){
        return templateManager.container.getWidget('CREATE_TASK_ISSUE');
    };

    var getWidgetBudget = function(){
        return templateManager.container.getWidget('TABBED_BUDGET');
    };

    var getWidgetMaintenance = function(){
        return templateManager.container.getWidget('MAINTENANCE');
    };


     var getWidgetBudgetCustom = function(){
        return templateManager.container.getWidget('BUDGET');
    };

    var getClassificationNameWidgetCreateTask = function(){
        return getWidgetCreateNewTask().getField('CLASSIFICATION_NAME');
    };

    var getFieldAllProjectsFromWidgetCreateTaskIssue = function(){
        return getWidgetCreateNewTask().getField('ALL_PROJECTS');
    };


    var getFieldIssuesFromWidgetCreateTaskIssue = function(){
        return getWidgetCreateNewTask().getField('ISSUES');
    };

    var getFieldFollowersFromWidgetIssueMain = function(){
        return getWidgetIssueMain().getField('FOLLOWERS');
    };
    var getFieldStashDescriptionFromWidgetCommitCommentPopup= function(){
        return getWidgetCommitCommentPopup().getField('STASH_DESCRIPTION');
    };
    var getFieldCommentFromWidgetCommitCommentPopup = function(){
        return getWidgetCommitCommentPopup().getField('COMMENT');
    };
    var getFieldCommentTypeFromWidgetSpecificationCommentPopup= function(){
        return getWidgetSpecificationCommentPopup().getField('COMMENT_TYPE');
    };

    var getFieldCdItemtrabFromWidgetSpecificationCommentPopup = function(){
        return getWidgetSpecificationCommentPopup().getField('CDITEMTRAB');
    };

    var getFieldDocumentFromWidgetSpecificationCommentPopup= function(){
        return getWidgetSpecificationCommentPopup().getField('DOCUMENT');
    };

    var getFieldCommentFromWidgetSpecificationCommentPopup= function(){
        return getWidgetSpecificationCommentPopup().getField('COMMENT');
    };

    /************************************************************
     * Field getters
     ************************************************************/
    var getFieldPercentCompletedFromTimeByActivityWidget = function(){
        return getTimeByActivityWidget().getField('PERCENT_COMPLETED');
    };

    var getFieldBeginHourFromTimeByActivityWidget = function(){
        return getTimeByActivityWidget().getField('BEGIN_HOUR');
    };

    var getFieldTaskNameFromMergeRequestWidget = function(){
        return getWidgetMergeRequest().getField('TASK_NAME');
    };

    var getFieldTaskNameWithProjectFromMergeRequestWidget = function(projectId){
        return getWidgetMergeRequest().getField('TASK_NAME_' + projectId);
    };

    var getFieldResourceNameFromMergeRequestWidget = function(){
        return getWidgetMergeRequest().getField('RESOURCE_NAME');
    };

    var getFieldResourceFromMergeRequestWidget = function(){
        return getWidgetMergeRequest().getField('RESOURCE');
    };

    var getFieldResourceFromGenerateTaskWidget = function(){
        return getWidgetGenerateTask().getField('RESOURCE');
    };

    var getFieldDescriptionFromMergeRequestWidget = function(){
        return getWidgetMergeRequest().getField('DESCRIPTION');
    };

    var getFieldEndHourFromTimeByActivityWidget = function(){
        return getTimeByActivityWidget().getField('END_HOUR');
    };

    var getFieldProgressFromTimeByActivityWidget = function(){
        return getTimeByActivityWidget().getField('PROGRESS');
    };

    var getFieldDurationFromInfoTaskWidget = function(){
        return getInfoTaskWidget().getField('DURATION');
    };

    var getFieldEstimatedBeginDateFromInfoTaskWidget = function(){
        return getInfoTaskWidget().getField('ESTIMATED_BEGIN_DATE');
    };

    var getFieldEstimatedEndDateFromInfoTaskWidget = function(){
        return getInfoTaskWidget().getField('ESTIMATED_END_DATE');
    };

    var getFieldTaskResponseFromInfoTaskWidget = function(){
        return getInfoTaskWidget().getField('TASK_RESPONSE');
    };

    var getFieldUrlToTestFromInfoTaskWidget = function(){
        return getInfoTaskWidget().getField('URL_TO_TEST');
    };

    var getFieldPercentCompletedFromNewAppropriationWidget = function(){
        return getNewAppropriationWidget().getField('PERCENT_COMPLETED');
    };

    var getFieldBeginHourFromNewAppropriationWidget = function(){
        return getNewAppropriationWidget().getField('BEGIN_HOUR');
    };

    var getFieldEndHourFromNewAppropriationWidget = function(){
        return getNewAppropriationWidget().getField('END_HOUR');
    };

    var getFieldTaskNameFromNewAppropriationWidget = function(){
        return getNewAppropriationWidget().getField('TASK_NAME');
    };

    var getFieldProjectNameFromNewAppropriationWidget = function(){
        return getNewAppropriationWidget().getField('PROJECT_NAME');
    };

    var getFieldProjectIdFromNewAppropriationWidget = function(){
        return getNewAppropriationWidget().getField('PROJECT_ID');
    };

    var getFieldDescriptionFromNewAppropriationWidget = function(){
        return getNewAppropriationWidget().getField('DESCRIPTION');
    };

    var getFieldTotalFromNewAppropriationWidget = function(){
        return getNewAppropriationWidget().getField('TOTAL');
    };

    var getLogFieldFromLogWidget = function() {
        return getLogWidget().getField('LOG_FIELD');
    };

    var getFieldTaskClassificationLabelFromGenerateTask = function() {
        return getWidgetGenerateTask().getField('TASK_CLASSIFICATION_LABEL');
    };

    var getFieldTaskStatusNameFromGenerateTask = function() {
        return getWidgetGenerateTask().getField('TASK_STATUS_NAME');
    };

    var getFieldTypeRelationshipFromGenerateTask = function() {
        return getWidgetGenerateTask().getField('TYPE_RELATIONSHIP');
    };

    var getFieldErrorClassificationFromGenerateTask = function() {
        return getWidgetGenerateTask().getField('ERROR_CLASSIFICATION');
    };

    /************************************************************
     * Field getters
     ************************************************************/
    var getBackActionFromLogWidget = function(){
        return getLogWidget().getAction('back');
    };

    var getActionStopFromInfoTask = function(){
        return getWidgetInfoTask().getAction('stop');
    };



    var getActionSaveProductFromBudgetTabbedWidget = function () {
        return getWidgetBudget().getAction('SAVE_PRODUCT_BUDGET');
    };

    var getActionSaveBudgetTabbedWidget = function () {
        return getWidgetBudget().getAction('SAVE_BUDGET');
    };


     var getActionSaveMaintenanceBudgetTabbedWidget = function () {
        return getWidgetBudget().getAction('GENERATE_BUDGET');
    };

    /************************************************************
     * Defines actions visibility due the fact that, if task cant
     * be started, actions like "Play" should not appear.
     ************************************************************/
    var _setActionVisibilityByCanStarted = function (array, canStart, typeRelationship) {
        array.forEach(function (item) {
            if (canStart === 'N') {
                item.isVisible = false;
            } else {
                if (item.name === 'diff_merge_request' || item.name === 'generate_task') {
                    item.isVisible = (typeRelationship === TYPE_RELATIONSHIP_MERGE_REQUEST);
                } else if (item.name !== 'pause') {
                    item.isVisible = true;
                }
            }
        });
    };

    /************************************************************
     * Clear some fields in Appropriation widget, due the fact
     * that sometimes they have cache and keeps old text on them.
     ************************************************************/
    var _clearAppropriationFields = function () {
        var widget = templateManager.container.getWidget('NEW_APPROPRIATION');
        var fields = widget.fields;
        fields.forEach(function (field) {
            if (field.hasOwnProperty('cleared') && field.cleared) {
                field.value('');
            }
        });
    };

    /************************************************************
     * Hides "+" action on Appropriations widget, because user
     * cant add appropriations if task is already completed.
     ************************************************************/
    function showActionsIncompleteTasks(percentCompleted, widget) {
        var actionAddApropriation = widget.actions[0];
        if (parseInt(percentCompleted) === 100) {
            actionAddApropriation.showAsAction = 'hidden';
        } else {
            actionAddApropriation.showAsAction = 'always';
        }
    }

    /************************************************************
     * Called when user clicks on 'clock' icon.
     * @param widget
     ************************************************************/
    var newAppropriation = function (widget) {
        var widgetTasks = widget.container.getWidget('LIST_TASKS');
        var widgetTabbed = widget.container.getWidget('TABBED_APPROPRIATION');
        var widgetTimeActivity = widget.container.getWidget('TIME_BY_ACTIVITY');
        var widgetInfoTask = widget.container.getWidget('INFO_TASK');
        var widgetNewAppropriation = widget.container.getWidget('NEW_APPROPRIATION');

        localStorageEngine.setLocalVar('taskID', widgetTasks.currentRow.ID);
        localStorageEngine.setLocalVar('taskId', widgetTasks.currentRow.ID.replace('T', ""));

        localStorageEngine.setLocalVar('taskAllocationID', widgetTasks.currentRow.ALLOCATION);

        ZHPromise.all([widgetInfoTask.reload(), widgetTimeActivity.reload()]).then(function () {
            var length = widgetTimeActivity.dataSource.data.length;
            _clearAppropriationFields();
            ScreenService.openSwipe(widgetNewAppropriation);
            widgetNewAppropriation.newRow();
            widgetNewAppropriation.getField('TASK_NAME').isVisible = true;
            if (length > 0) {
                widgetNewAppropriation.currentRow.PERCENT_COMPLETED = widgetTimeActivity.dataSource.data[length - 1].PERCENT_COMPLETED;
            }
            AppropriationService.addProgressInDataSource(widgetTasks.currentRow.DURATION, widgetTimeActivity.dataSource.data);
            showActionsIncompleteTasks(widgetTasks.currentRow.PERCENT_COMPLETED, widgetTimeActivity);
        });
    };

    this.stripeAfterMoveRow = function (args) {
        var date = args.row.ESTIMATED_BEGIN_DATE;
        list_tasks = args.owner.container.getWidget('LIST_TASKS');
        return this.loadTaskAppropriationFromDate(date);
    };

    this.timesheetContainerAfterinit = function (args) {
        getStripeNavigatorWidget().reload();
        getListTasksWidget().activate();
    };

    this.loadTaskFromDate = function (date) {
        return this.loadTaskAppropriationFromDate(date);
    };

     this.budgetTabWidgetOnEnterTab = function(){
        var widget = getWidgetInfoTask();
        IssueService.findBudgetProductByTask(widget.currentRow.ID).then(function (result) {

           if(result){
               localStorageEngine.setLocalVar('issue', result[0].ISSUE_ID);
               getWidgetBudgetCustom().reload();
               getWidgetBudget().currentRow = result[0];
               getWidgetBudget().reload();
           }
        });

    };

     this.maintenanceTabWidgetOnEnterTab = function () {
       getActionSaveBudgetTabbedWidget().isVisible = false;
       getActionSaveMaintenanceBudgetTabbedWidget().isVisible = true;
       getWidgetBudget().reload();
       getWidgetMaintenance().reload().then(function (result) {
                   getWidgetMaintenance().currentRow = result.dataset.MaintenanceCost[0];
                }).catch(Utilities.showErrorMessage);
    };

    this.budgetWidgetOnEnterTab = function () {
       getActionSaveMaintenanceBudgetTabbedWidget().isVisible = false;
       getWidgetBudget().reload();

    };


    var openMergeRequestPopup = function(taskInfo) {
        var widgetMergeRequest = getWidgetMergeRequest();
        var fields = widgetMergeRequest.fields;
        var projects = getWidgetInfoTask().currentRow.DIRECTORIES_VALIDATION.PROJECTS;
        var allProjectIds = [];
        var promises = projects.map(function(project) {
            var projectId = project.PROJECT_ID;
            allProjectIds.push(projectId);
            if(validateFieldCreated(fields, projectId)) {
                var projectName = project.PROJECT_NAME;
                var infoString = localStorage.getItem(projectId);
                var taskNameField = self.getTaskNameFieldMergeRequest(projectId, widgetMergeRequest);
                var resourceNameField = self.getResourceNameFieldMergeRequest(projectId, widgetMergeRequest);
                var projectField = self.getProjectFieldMergeRequest(projectId, widgetMergeRequest);

                widgetMergeRequest.fields.unshift(taskNameField);
                widgetMergeRequest.fields.unshift(resourceNameField);
                widgetMergeRequest.fields.unshift(projectField);
                projectField.value(projectName);

                return taskNameField.reload().then(function () {
                    return resourceNameField.reload();
                }).then(function () {
                    if (infoString) {
                        var infoArray = infoString.split("|");
                        var task = infoArray[0];
                        var resource = infoArray[1];
                        if (Utilities.isNotEmptyArray(Utilities.findInDataSource(taskNameField, [task], 'ID'))) {
                            Utilities.setValueInSelectField(taskNameField, task);
                        }
                        if (Utilities.isNotEmptyArray(Utilities.findInDataSource(resourceNameField, [resource], 'ID'))) {
                            Utilities.setValueInSelectField(resourceNameField, resource);
                        }
                    }
                });
            }
        });

        ZHPromise.all(promises).then(function() {
            widgetMergeRequest.fields = pmGenerationProjectIdFilter(fields, allProjectIds);
            widgetMergeRequest.taskInfo = taskInfo;
            getFieldDescriptionFromMergeRequestWidget().setValue('');
            ScreenService.hideLoader();
            ScreenService.restoreDefaultLoadingMessage();
            ScreenService.openPopup(widgetMergeRequest);
        }).catch(function() {
            ScreenService.hideLoader();
            ScreenService.restoreDefaultLoadingMessage();
        });
    };

    var _loadTaskAppropriationFromDate = Util.buildDebounceMethod(function(date){
        var dateFromTask = date ? date : moment().format('DD/MM/YYYY');
        localStorageEngine.setLocalVar('dateFromTask', dateFromTask);
        var filter = [{
            operator: '=',
            name: 'ESTIMATED_BEGIN_DATE',
            value: dateFromTask
        }];
        ScreenService.showLoader();
        return requestDataSourceEngine.getDataSource('/tasksFullDataByUserOnDemand', filter).then(function(dataTasks) {
            var tasks = dataTasks.dataset.tasksFullDataByUserOnDemand;
            ScreenService.hideLoader();
            self.updateTaskAppropriation(tasks);
            self.updateTaskTable(tasks);
        }).catch(ScreenService.hideLoader);
    }, 1000, true);

    this.loadTaskAppropriationFromDate = function (date) {
        return _loadTaskAppropriationFromDate(date);
    };

   var newAppropriationActionEventCancelFromTimeActive = function (args) {
        Utilities.genericCancelEvent(getWidgetNewAppropriation()).then(function (response) {
            getWidgetNewAppropriation().view();
            getWidgetNewAppropriation().activate();
        });
    };
    var timebyactiveActionEventCancelFromTimeActive = function (args) {
        Utilities.genericCancelEvent(getWidgetNewAppropriation()).then(function (response) {
            getWidgetNewAppropriation().view();
            getTimeByActivityWidget().activate();
        });
    };
    var newAppropriationActionEventCancelFromInfoTask = function (args) {
        getWidgetNewAppropriation().view();
        ScreenService.closeSwipe().then(function (){
            getWidgetInfoTask().activate();
        });
    };

    this.newAppropriationActionEventCancel = function (args) {
        if (returnToInfoTaskWidget === true) {
            newAppropriationActionEventCancelFromInfoTask();
        } else if (returnToTimeByActivity === true){
            timebyactiveActionEventCancelFromTimeActive();
        } else {
            newAppropriationActionEventCancelFromTimeActive();
        }
    };


    this.infoTaskActionEventBack = function(args){
        ScreenService.closeSwipe().then(function(){
            getListTasksWidget().activate();
        });
    };

    this.initStripe = function (stripe) {
        var todayString = Utilities.getCurrentDate();
        var dateToday = stripe.dataSource.data.filter(function(date){
            return date.ESTIMATED_BEGIN_DATE == todayString;
        });
        if(dateToday.length <= 0){
            stripe.dataSource.data.unshift({
                'ESTIMATED_BEGIN_DATE': todayString
            });
        }
        stripe.moveToFirst();
        this.loadTaskFromDate(stripe.currentRow.ESTIMATED_BEGIN_DATE);
    };


    this.onEnterMain = function (args) {
        args.owner.activate();
        getStripeNavigatorWidget().reload().then(function () {
            try {
                self.loadTaskFromDate(args.owner.container.getWidget('STRIPE_NAVIGATOR').currentRow.ESTIMATED_BEGIN_DATE);
            } catch (e) {

            }
        });
    };

    /* Called when user clicks on "Controle de Tempo" */
    var onEnterTabbed = function (widget) {
        widget.activate();
    };

    this.parseDates = function (args) {
        var difference = moment(args.row.END_HOUR, "DD/MM/YYYY HH:mm").diff(moment(args.row.BEGIN_HOUR, "DD/MM/YYYY HH:mm"));
        if (difference < 0 && args.row.END_HOUR !== '') {
            args.row.END_HOUR = args.row.BEGIN_HOUR;
        }
        if (difference > 0) {
            this.bringTaskCalendarHourByAllocation(args);
        }

    };

    this.bringTaskCalendarHourByAllocation = function (args) {
        if(getFieldBeginHourFromNewAppropriationWidget()["datetime-preset"] != "date") {
            var allocation = localStorageEngine.getLocalVar('taskAllocationID');
            var row = {};
            row.ALLOCATION = allocation;
            row.changed = true;
            differenceTime = (moment(args.row.END_HOUR, "DD/MM/YYYY HH:mm").diff(moment(args.row.BEGIN_HOUR, "DD/MM/YYYY HH:mm"))) * (-1);
            if (args.row.BEGIN_HOUR !== '' && args.row.END_HOUR !== '') {
                var period = Utilities.calculateTotalTime(args.row.BEGIN_HOUR, args.row.END_HOUR);
                args.row.TOTAL = period.period;
            }
        }
    };

    this.totalFieldOnChange = function(args){
        Util.doAsync(function () {
            self.calculatePeriodByTotal(args.row);
            self.bringTaskCalendarHourByAllocation(args);
            getNewAppropriationWidget().activate();
            templateManager.updateTemplate();
        });
    };

    this.calculateTimeTask = function (args) {
        var period = Utilities.calculatePeriod(args.row.BEGIN_HOUR, args.row.END_HOUR);
        var allocation = localStorageEngine.getLocalVar('taskAllocationID');
        var calendarHour = this.bringTaskCalendarHourByAllocation(allocation);

    };

    this.conclusionMask = function (args, data) {
        var dataLenght = (data.length) - 1;
        var percent = args.row.PERCENT_COMPLETED;
        var count;
        if (percent !== '') {
            if (args.row.ID !== "") {

                for (count = 0; count <= dataLenght; count++) {
                    if (data[count].ID < args.row.ID && parseInt(data[count].PERCENT_COMPLETED) > args.row.PERCENT_COMPLETED)
                        args.row.PERCENT_COMPLETED = parseInt(data[count].PERCENT_COMPLETED) + 1;
                }
                for (count = dataLenght; count >= 0; count--) {
                    if (data[count].ID > args.row.ID && parseInt(data[count].PERCENT_COMPLETED) < args.row.PERCENT_COMPLETED)
                        args.row.PERCENT_COMPLETED = parseInt(data[count].PERCENT_COMPLETED) - 1;
                }
            } else {
                if (data[dataLenght] !== undefined) {
                    if (parseInt(percent) < parseInt(data[dataLenght].PERCENT_COMPLETED))
                        args.row.PERCENT_COMPLETED = data[dataLenght].PERCENT_COMPLETED;
                }

            }
            if (parseInt(percent) > 100)
                args.row.PERCENT_COMPLETED = 100;
        }
    };

    /************************************************************
     * Called when user clicks on '+' action.
     * @param widget
     ************************************************************/
    this.addAppropriation = function (widget) {
        returnToTimeByActivity = true;
        returnToInfoTaskWidget = false;
        currentTaskStatus = '';
        var length = widget.dataSource.data.length - 1;
        var newAppropriationWidget = widget.widgets[0];
        newAppropriationWidget.editing = true;
        newAppropriationWidget.newRow();
        if (widget.dataSource.data.length > 0) {
            newAppropriationWidget.currentRow.PERCENT_COMPLETED = widget.dataSource.data[length].PERCENT_COMPLETED;
            if (newAppropriationWidget.currentRow.BEGIN_HOUR == 'undefined' || newAppropriationWidget.currentRow.BEGIN_HOUR === null)
                newAppropriationWidget.currentRow.BEGIN_HOUR = '';
            if (newAppropriationWidget.currentRow.END_HOUR == 'undefined' || newAppropriationWidget.currentRow.END_HOUR === null)
                newAppropriationWidget.currentRow.END_HOUR = '';
        }

        // Needed for clear cache from fields
        _clearAppropriationFields();

        // If this task has not TIME_PLANNING, user can not modify percentage
        widget.widgets[0].getField('PERCENT_COMPLETED').isVisible = !!hasTaskTimePlanning();

        setPercentFieldVisibilityByEndTask(widget.widgets[0].getField('PERCENT_COMPLETED'));

        localStorageEngine.setLocalVar('CALL_APPR_WIDG_BY_TIME_BY_ACT', true);
        ScreenService.openSwipe(widget.widgets[0]);
    };

    this.cleanDates = function (args) {
        var begin = args.owner.field.widget.currentRow.BEGIN_HOUR;
        var end = args.owner.field.widget.currentRow.END_HOUR;
        var total = args.owner.field.widget.currentRow.TOTAL;
        var period;
        if (begin !== '' && end !== '') {
            this.parseDates(args);
        } else {
            period = DateManager.calculateAppropriationPeriod(begin, end, total);
            if (begin === '') {
                args.owner.field.widget.currentRow.BEGIN_HOUR = period;
            } else {
                args.owner.field.widget.currentRow.END_HOUR = period;
            }
        }

    };

    this.deleteAppropriation = function (args) {
        var row = {};
        row.APPROPRIATION = args.owner.widget.dataSource.data[0];
        row.changed = true;
        requestDataSourceEngine.setDataSource('/deleteAppropriation', [row]).then(function () {
            ScreenService.goBack();
            args.owner.widget.list();
            args.owner.widget.container.getWidget("TIME_BY_ACTIVITY").reload();
            args.owner.widget.container.getWidget("TIME_CONTROL").reload();
            args.owner.widget.container.getWidget("graphic_pie").reload();
        }.bind(this));
    };

    this.deleteAppropriationMyTasks = function (args) {
        ScreenService.confirmMessage(Utilities.messages.ALE_DELETE_APROPRIATION, 'question', function(){
            var stripe = templateManager.container.getWidget('STRIPE_NAVIGATOR');
            var row = {};
            row.APPROPRIATION = args.owner.widget.dataSource.data[0];
            row.changed = true;
            requestDataSourceEngine.setDataSource('/deleteAppropriation', [row]).then(function () {
                var filter = [{
                    "name": "dateTimeControl",
                    "operator": "=",
                    "value": moment().format('DD/MM/YYYY')
                }];
                requestDataSourceEngine.getDataSource("/findPercentAppropriated", function (data) {
                    ScreenService.setNotificationHint("appropriation", data[0].hint);
                }, filter);
                ScreenService.closeSwipe();
                getTimeByActivityWidget().reload();
                getTimeByActivityWidget().activate();
                args.owner.widget.list();
                self.loadTaskAppropriationFromDate(stripe.currentRow.ESTIMATED_BEGIN_DATE);
                self.loadTaskFromDate(stripe.currentRow.ESTIMATED_BEGIN_DATE);
            }.bind(this));
        });
    };

    this.newAppropriationActionEventEdit = function(args){
        self.editAppropriation(args);
    };

    this.newAppropriationActionEventDeleteAppropriation = function(args){
        self.deleteAppropriationMyTasks(args);
    };

    this.newAppropriationActionEventBack = function(args){
        self.backNewAppropriation(getNewAppropriationWidget());
    };

    this.CustomizationGoBack = function(args){
        ScreenService.closePopup();
        getWidgetInfoTask().activate();
       //getWidgetNewAppropriation().edit();
    };

     this.budgetActionEventSaveManut = function(){
        var widget = getWidgetMaintenance();
        widget.currentRow.ISSUE_ID = localStorageEngine.getLocalVar('issue');
        widget.dataSource.save().then(function(){
            ScreenService.hideLoader();
            ScreenService.successNotification(Utilities.messages.SUC_BUDGETS_SAVE);
            widget.reload();
            ScreenService.closePopup();
            var message = Utilities.messages.NOTIF_MAINTENANCE_BUDGET_CONTINUE_PROCESS;
            ScreenService.showCustomDialog(message, 'CONFIRMATION', null,
                [
                    {
                        "label": "Sim",
                        "code": function () {
                            ScreenService.closePopup();
                            self.infoTaskActionEventStop();
                        }
                    },
                    {
                        "label": "Não",
                        "code": function () {}
                    }
                ]
            );
        }).catch(function(){
            ScreenService.hideLoader();
        });
    };


    this.editAppropriation = function (args) {
        var widget = getWidgetNewAppropriation();
        widget.edit();
        var filter = [{
            "name": "dateTimeControl",
            "operator": "=",
            "value": moment().format('DD/MM/YYYY')
        }];
        localStorageEngine.setLocalVar('CALL_APPR_WIDG_BY_TIME_BY_ACT', true);
        requestDataSourceEngine.getDataSource("/findPercentAppropriated", function (data) {
            ScreenService.setNotificationHint("appropriation", data[0].hint);
        }, filter);
        id = widget.currentRow.ID;
    };

    this.backNewAppropriation = function (widget) {
        commit = [];
        reset = [];
        stash = [];
        filesWithStatus = [];
        AppropriationService.gitBranchResult = {};
        var widgetTask = getListTasksWidget();
        var timeByActivityWidget = getAppropriationsWidget();
        var widgetInfoTask = getWidgetInfoTask();
        if (returnToInfoTaskWidget === true) {
            ScreenService.goBack();
            widgetInfoTask.activate();
            widgetInfoTask.formTemplate = "widget/form-view.html";
            templateManager.updateTemplate();
        } else {
            timeByActivityWidget.activate();
            timeByActivityWidget.formTemplate = 'widget/grid.html';
            if (timeByActivityWidget.dataSource.data.length > 0) {
                this.loadTaskAppropriationFromDate(widget.container.getWidget('STRIPE_NAVIGATOR').currentRow.ESTIMATED_BEGIN_DATE);
                var widgetTaskDataLength = (widgetTask.dataSource.data.length) - 1;
                if(widgetTask.dataSource.data[widgetTaskDataLength].APPROPRIATION){
                    var appropriationsLength = (widgetTask.dataSource.data[widgetTaskDataLength].APPROPRIATION.length) - 1;
                    if (appropriationsLength >= 0) {
                        showActionsIncompleteTasks(widgetTask.dataSource.data[widgetTaskDataLength].APPROPRIATION[appropriationsLength].PERCENT_COMPLETED, timeByActivityWidget);
                    }
                }
            }
            widget.list();
            ScreenService.goBack();
            templateManager.updateTemplate();
            timeByActivityWidget.activate();
        }
    };

    this.recalculateTaskProgress = function (task) {
        var row = task;
        row.changed = true;
        requestDataSourceEngine.setDataSource('/recalculateTaskProgress', [row]);
    };

    this.updateTaskAppropriation = function (task) {
        var currentTask = localStorageEngine.getLocalVar('taskID');
        var listAppropriations = getTimeByActivityWidget();
        var listTask = getListTasksWidget();
        //validate with tulio.
        for (var key in task) {
            if (task[key].ID == currentTask) {
                listTask.dataSource.data[key] = task[key];
                var row = {};
                row.ID = task[key].ID;
                if (task[key].APPROPRIATION.length > 0) {
                    row.PERCENT_COMPLETED = parseInt(task[key].APPROPRIATION[task[key].APPROPRIATION.length - 1].PERCENT_COMPLETED);
                    task[key].PERCENT_COMPLETED = task[key].APPROPRIATION[task[key].APPROPRIATION.length - 1].PERCENT_COMPLETED;
                } else {
                    row.PERCENT_COMPLETED = 0;
                    listTask.currentRow.PERCENT_COMPLETED = 0 + '%';
                    listTask.dataSource.data[key].PERCENT_COMPLETED = 0 + '%';
                }
                row.changed = true;

                listAppropriations.dataSource.data = task[key].APPROPRIATION;
                var length = listAppropriations.dataSource.data.length - 1;

                AppropriationService.addProgressInDataSource(task[key].DURATION, listAppropriations.dataSource.data);
                if (length >= 0) {
                    listTask.currentRow.PERCENT_COMPLETED = listAppropriations.dataSource.data[length].PERCENT_COMPLETED;
                }
                showActionsIncompleteTasks(listTask.currentRow.PERCENT_COMPLETED, listAppropriations);

                requestDataSourceEngine.setDataSource('/recalculateTaskProgress', [row]);
            }
        }

        templateManager.updateTemplate();
        listAppropriations.reload();
    };

    this.updateTaskTable = function (data) {
        var listTasks = getListTasksWidget();
        listTasks.dataSource.data = data;
        listTasks.dataSource.data.forEach(function(task) {
            if(task.PERCENT_COMPLETED){
                task.PERCENT_COMPLETED += '%';
            }
        });
    };

    this.appropriationAfterSelectRow = function (widget) {
        if (widget.dataSource.checkedRows.length > 1) {
            widget.actions[2].isVisible = false;
        } else {
            widget.actions[2].isVisible = true;
        }
    };

    this.appropriationAfterMoveRow = function (args) {
        returnToInfoTaskWidget = false;
        returnToTimeByActivity = false;
        Utilities.localVar.setDescriptionControl(false);
        var widgetForm = getNewAppropriationWidget();
        var id = getAppropriationsWidget().currentRow.ID;
        if (id) {
            Utilities.localVar.setAppropriationIdControl(id);
            ScreenService.openSwipe(widgetForm).then(function () {
                widgetForm.list();
                ScreenService.showLoader();
                widgetForm.reload().then(function () {
                    ScreenService.hideLoader();
                    widgetForm.moveToFirst();
                    widgetForm.view();
                    widgetForm.lastActiveWidget = args.owner;
                }).catch(ScreenService.hideLoader);
            });
            widgetForm.getField('TASK_NAME').isVisible = true;
        } else {
            ScreenService.showMessage(Utilities.ERR_CANT_MODIFY_APPROPRIATION_IS_NOT_RESOURCE);
        }
    };

    this.saveAppropriation = function (widget, widgetTimeActivity) {
        var total = widget.currentRow.TOTAL;
        widget.currentRow.TOTAL = Utilities.parseHourToSeconds(widget.currentRow.TOTAL);
        if (widget.currentRow.BEGIN_HOUR === null)
            widget.currentRow.BEGIN_HOUR = "";
        if (widget.currentRow.END_HOUR === null)
            widget.currentRow.END_HOUR = "";
        if (widget.isValid()) {
            widget.currentRow.BEGIN_HOUR = Utilities.formatDateTime(widget.currentRow.BEGIN_HOUR);
            widget.currentRow.END_HOUR = Utilities.formatDateTime(widget.currentRow.END_HOUR);
            widget.currentRow.ALLOCATION = localStorageEngine.getLocalVar('taskAllocationID');
            widget.currentRow.TASK = localStorageEngine.getLocalVar('taskID');
            widget.currentRow.ID = id;

            var percentCompleted = parseInt(widget.currentRow.PERCENT_COMPLETED);
            if (percentCompleted === 100) {
                if (!widget.currentRow.END_HOUR) {
                    widget.currentRow.END_DATE = moment().format('DD-MM-YYYY');
                } else {
                    widget.currentRow.END_DATE = widget.currentRow.END_HOUR;
                }
            }
            return requestDataSourceEngine.setDataSource('/appropriation', [widget.currentRow]).then(function (response) {
                widget.currentRow.TOTAL = total;
                widget.currentRow.ID = response.dataset.appropriation[0].ID;
                ScreenService.goBack();
                widget.list();
                widget.container.getWidget("graphic_pie").reload();
                widget.container.getWidget("TIME_CONTROL").reload();
                widget.container.getWidget("TIME_BY_ACTIVITY").reload();
            }.bind(this));
        }
    };

    var validateConcludeTask = function(widget) {
        var result = true;
        if (currentTaskStatus === 'CONCLUDE' && widget.currentRow.PERCENT_COMPLETED < 100) {
            result = false;
        }
        if (widget.currentRow.PERCENT_COMPLETED === 100) {
            currentTaskStatus = 'CONCLUDE';
        }

        return result;
    };

    var setNotificationHint = function () {
        var filter = [{
            "name": "dateTimeControl",
            "operator": "=",
            "value": moment().format('DD/MM/YYYY')
        }];
        requestDataSourceEngine.getDataSource("/findPercentAppropriated", function (data) {
            ScreenService.setNotificationHint("appropriation", data[0].hint);
        }, filter);
    };

    var prepareAppropriationToBeSaved = function () {
        var newAppropriationTab = getNewAppropriationWidget();
        var total = newAppropriationTab.currentRow.TOTAL;
        if (currentTaskStatus === "CONCLUDE") {
            newAppropriationTab.currentRow.PERCENT_COMPLETED = 100;
        }
        newAppropriationTab.currentRow.PERCENT_COMPLETED = parseInt(newAppropriationTab.currentRow.PERCENT_COMPLETED);
        newAppropriationTab.currentRow.BEGIN_HOUR = Utilities.formatDateTime(newAppropriationTab.currentRow.BEGIN_HOUR);
        newAppropriationTab.currentRow.END_HOUR = Utilities.formatDateTime(
            newAppropriationTab.currentRow.END_HOUR === (null || undefined) ? "" : newAppropriationTab.currentRow.END_HOUR
        );
        newAppropriationTab.currentRow.ALLOCATION = localStorageEngine.getLocalVar('taskAllocationID');
        newAppropriationTab.currentRow.TASK = localStorageEngine.getLocalVar('taskID');
        newAppropriationTab.copyCurrentRow = Util.clone(newAppropriationTab.currentRow);
        newAppropriationTab.copyCurrentRow.TOTAL = Utilities.parseHourToSeconds(total);

        return newAppropriationTab;
    };

    var reloadTaskWidget = function () {
        var stripeWidget = templateManager.container.getWidget('STRIPE_NAVIGATOR');
        if (stripeWidget.currentRow.ESTIMATED_BEGIN_DATE) {
            self.loadTaskFromDate(stripeWidget.currentRow.ESTIMATED_BEGIN_DATE);
        }
    };

    var saveAppropriation = function () {
        var newAppropriation = getNewAppropriationWidget();
        var row = {};
        if (newAppropriation.isValid()) {
            newAppropriation = prepareAppropriationToBeSaved();
            row = newAppropriation.copyCurrentRow;
            if(getWidgetInfoTask().currentRow.ALLOWENDTASK === 'N') {
                newAppropriation.currentRow.PERCENT_COMPLETED = 1;
            }
            return requestDataSourceEngine.setDataSource('/appropriation', [row]).then(function (response) {
                newAppropriation.currentRow.ID = response.dataset.appropriation[0].ID;
                var percentCompleted = newAppropriation.currentRow.PERCENT_COMPLETED;
                if (percentCompleted === 100) {
                    return TaskService.concludeTask(getInfoTaskWidget().currentRow).then(function (response) {
                        currentTaskStatus = '';
                        newAppropriation.currentRow.PERCENT_COMPLETED = 1;
                        setNotificationHint();
                        reloadTaskWidget();
                        return response;
                    });
                } else {
                    currentTaskStatus = '';
                    setNotificationHint();
                    reloadTaskWidget();
                    return response;
                }
            });
        }
        return;
    };

    var validatePlayedTask = function (taskId, percentCompleted) {
        var defer = ZHPromise.defer();
        taskId = taskId.replace("T", "");
        taskId = parseInt(taskId);
        var filter = [{
            "operator": "=",
            "name": "TASK",
            "value": taskId
        }];
        if (parseInt(percentCompleted) < 100) {
            defer.resolve();

        } else {
            requestDataSourceEngine.getDataSource("/hasBranch", filter).then(function (data) {
                if (data.dataset.hasBranch.length > 0) {
                    defer.reject('hasBranch');
                } else {
                    defer.resolve();
                }
            }).catch(function (e) {
                defer.reject(e);
            });

        }
        return defer.promise;
    };

    var getTabbedAppropriationWidget = function () {
        return templateManager.container.getWidget('TABBED_APPROPRIATION');
    };

    var saveOnlyAppropriation = function (taskId, percentCompleted) {
        validatePlayedTask(taskId, percentCompleted).then(function () {
            currentTaskStatus = '';
            var widgetGenerate = getWidgetGenerateTask();
            var infoTaskWidget = getInfoTaskWidget();
            saveAppropriation().then(function () {
                if (generateTask) {
                    generateTask = false;
                    self.createNewTask(infoTaskWidget.currentRow.TASK_ID, getDataNewTaskToGenerate(widgetGenerate)).then(function () {
                        ScreenService.closeSwipe(0);
                        infoTaskWidget.list();
                        getListTasksWidget().activate();
                        ScreenService.hideLoader();
                        ScreenService.restoreDefaultLoadingMessage();
                    }).catch(function () {
                        ScreenService.hideLoader();
                        ScreenService.restoreDefaultLoadingMessage();
                    });
                } else {
                    var newAppropriationWidget = getWidgetNewAppropriation();
                    var listAppropriationsWidget = getAppropriationsWidget();
                    listAppropriationsWidget.reload().then(function(){
                        listAppropriationsWidget.setCurrentRow(Utilities.getRowInDataSource(listAppropriationsWidget.dataSource, 'ID', newAppropriationWidget.currentRow.ID));
                        newAppropriationWidget.list();
                        ScreenService.hideLoader();
                        ScreenService.restoreDefaultLoadingMessage();
                    }).catch(function () {
                        ScreenService.hideLoader();
                        ScreenService.restoreDefaultLoadingMessage();
                    });
                }
            }).catch(function () {
                ScreenService.hideLoader();
                ScreenService.restoreDefaultLoadingMessage();
            });
        }).catch(function (e) {
            ScreenService.hideLoader();
            ScreenService.restoreDefaultLoadingMessage();
            ScreenService.closeSwipe();
            if (e === 'hasBranch') {
                ScreenService.showMessage(Messages.ALE_PLAYED_TASK);
                ScreenService.closeSwipe();
                ScreenService.openSwipe(getTabbedAppropriationWidget());
                getInfoTaskWidget().activate();
            } else {
                getAppropriationsWidget().activate();
            }
        });
    };

    var getWidgetNewAppropriation = function () {
        return templateManager.container.getWidget('NEW_APPROPRIATION');
    };

    var getWidgetGenerateTask = function () {
        return templateManager.container.getWidget('GENERATE_TASK');
    };

    var getFieldTypeRelationshipFromGenerateTaskidget = function () {
        return getWidgetGenerateTask().getField('TYPE_RELATIONSHIP');
    };

    var getWidgetMergeRequest = function () {
        return templateManager.container.getWidget('MERGE_REQUEST');
    };

    var getTaskPaths = function () {
        return getWidgetInfoTask().currentRow.PATHS;
    };

    var getTaskId = function () {
        return getWidgetInfoTask().currentRow.ID;
    };

    var getUnchangedTaskPaths = function () {
        return getWidgetInfoTask().currentRow.PATHS_UNCHANGED;
    };

    var getCommitMessage = function () {
        var  description = '';
        if(currentTaskStatus == 'COMMIT'){
            description =  getWidgetCommitCommentPopup().currentRow.COMMENT;
        }else{
            description = getNewAppropriationWidget().currentRow.DESCRIPTION;
        }

        var translate_re = /[öäüÖÄÜãÃõÕºª~,]/g;
        return typeof description == "undefined" ? "" : description.replace(/(\n)/gm, " ").replace(/[\\"\/']/g, '_').replace(translate_re, '');
    };

    var validateEqualRepositoriesFiles = function(dirRepositoryIds, fileRepositoryIds) {
        var validation = true;
        fileRepositoryIds.forEach(function(repositoryId) {
            if(dirRepositoryIds.indexOf(repositoryId) == -1) {
                validation = false;
            }
        });
        return validation;
    };

    var factoryCommitPromise = function() {

        filesWithStatus = uniques(filesWithStatus);
        var defer = ZHPromise.defer();
        var paths = getTaskPaths();
        var gitMessage = getCommitMessage();
        var ds = '\\';
        GitQueue.validateExecuteInWindows().then(function (isWindows) {
            paths.forEach(function (path) {
                path.dir = isWindows ? path.LOCAL_DIRECTORY : path.LINUX_DIRECTORY;
            });
            var promiseResult = paths.map(function (path) {
                path.commitMessage = gitMessage;
                path.files = filesWithStatus.filter(function (file) {
                    if (file.gitStatus === 'C' && path.repository === file.FILE_REPOSITORY &&
                        validateEqualRepositoriesFiles(path.ID, file.FILE_REPOSITORY_IDS))
                        return true;
                }).map(function (file) {
                    return {
                        name: file.DIR,
                        status: file.FILE_STATUS
                    };
                });

                for (var index in masterFilesToCommit) {
                    if (path.repository === index) {
                        for (var i = 0; i < masterFilesToCommit[index].length; i++) {
                            if (masterFilesToCommit[index][i].FILE_STATUS !== 'Apagado') {
                                if (path.dir.indexOf('/') != -1) {
                                    ds = '/';
                                }
                                path.files.push({
                                    name: path.dir + ds + masterFilesToCommit[index][i].FILE_NAME,
                                    status: masterFilesToCommit[index][i].FILE_STATUS
                                });
                            }
                        }
                    }
                }
                return path;
            });
            defer.resolve(promiseResult);
        });
        return defer.promise;
    };

     this.getTrashRemoveField = function (projectId, widget) {
        return metaDataFactory.factoryField(this.getRemoveActionObj(projectId), widget);
    };


    this.getProjectNameField = function (projectId, widget) {
        return metaDataFactory.factoryField(this.getProjectNameObj(projectId), widget);
    };

    this.getVersionDevField = function (projectId, widget) {
        return metaDataFactory.factoryField(this.getVersionDevObj(projectId), widget);
    };

    this.getProjectTypeNameField = function (projectId, widget) {
        return metaDataFactory.factoryField(this.getProjectTypeNameObj(projectId), widget);
    };

    this.getTaskTypeNameField = function (projectId, widget) {
        return metaDataFactory.factoryField(this.getTaskTypeNameObj(projectId), widget);
    };

    this.getEstimatedTimeField = function (projectId, widget) {
        return metaDataFactory.factoryField(this.getEstimatedTimeObj(projectId), widget);
    };

    this.getParentNameField = function (projectId, widget) {
        return metaDataFactory.factoryField(this.getParentNameSelectObj(projectId), widget);
    };

    this.getResourceField = function (projectId, widget) {
        return metaDataFactory.factoryField(this.getResourceSelectMultipleObj(projectId), widget);
    };
    this.getDesciptionAction = function (projectId, widget) {
        return metaDataFactory.factoryField(this.getDesciptionActionSelectObj(projectId), widget);
    };
    this.getDesciptionField = function (issueId, projectId, name, widget) {
        return metaDataFactory.factoryField(this.getDesciptionFieldSelectObj(issueId, projectId), widget);
    };
    this.getDesciptionFielGroup = function (issueId, name, widget) {
        return metaDataFactory.factoryField(this.getDesciptionFieldGroupSelectObj(issueId, name), widget);
    };

    this.getRemoveActionObj = function (projectId) {
        return {
            "name": "removeTaskGeneration_" + projectId,
            "label": null,
            "isVisible": true,
            "showOnForm": true,
            "showOnList": false,
            "showOnView": false,
            "pmProjectId": projectId,
            "pmIsGeneration": true,
            "tooltip": "Apagar",
            "fieldGroup": "TASKS",
            "template": "field/label-with-icon.html",
            "icon": "trash",
            "class": 1,
            "events": [
                {
                    "name": "FieldOnClick",
                    "code": "BoardIssuesController.fieldOnClickEventRemoveTaskGeneration(args);"
                }
            ]
        };
    };

    this.getProjectNameObj = function (projectId) {
        return {
            "name": "PROJECT_NAME_" + projectId,
            "label": "Projeto",
            "isVisible": true,
            "showOnForm": true,
            "showOnList": false,
            "showOnView": false,
            "pmProjectId": projectId,
            "readOnly": true,
            "pmIsGeneration": true,
            "fieldGroup": "TASKS",
            "template": "field/text-edit.html",
            "icon": "trash",
            "class": 3,
            "events": []
        };
    };

    this.getVersionDevObj = function (projectId) {
        return {
            "name": "VERSION_DEV_" + projectId,
            "label": "Versão",
            "isVisible": true,
            "showOnForm": true,
            "showOnList": false,
            "showOnView": false,
            "pmProjectId": projectId,
            "readOnly": false,
            "pmIsGeneration": true,
            "fieldGroup": "TASKS",
            "showSelectAs": "grid",
            "template": "zh-select-autocomplete#field/select-autocomplete.html",
            "class": 2,
            "descriptionField": "VERSION",
            "valueField": "ID",
            "searchableFields": [
                "VERSION",
                "IS_LTS"
            ],
            "displayedFields": [
                "VERSION",
                "IS_LTS"
            ],
            "fields": [
                {
                    "name": "ID",
                    "label": "ID",
                    "isVisible": true,
                    "showOnList": true
                },
                {
                    "name": "VERSION",
                    "label": "Versão",
                    "isVisible": true,
                    "showOnList": true
                },
                {
                    "name": "IS_LTS",
                    "label": "LTS",
                    "isVisible": true,
                    "showOnList": true
                }
            ],
            "outData": {
                "ID": "PRODUCT_VERSION_DEV_ID_" + projectId,
                "VERSION": "VERSION_DEV_" + projectId
            },
            "dataSource": {
                "name": "/findProductVersionLtsWithoutBuild",
                "rest": true,
                "localStorage": false,
                "data": [],
                "lazyLoad": true
            },
            "dataSourceFilter": [
                {
                    "name": "PROJECT_ID",
                    "operator": "=",
                    "value": "@getLocalVar('PROJECT_ID') ? getLocalVar('PROJECT_ID') : 0@"
                }
            ],
            "events": [
                {
                    "name": "FieldOnChange",
                    "code": "BoardIssuesController.createTaskIssueFieldOnChangeVersionDev(args)"
                }
            ]
        };
    };

    this.getProjectTypeNameObj = function (projectId) {
        return {
            "name": "PROJECT_TYPE_NAME_" + projectId,
            "label": "Tipo",
            "isVisible": true,
            "showOnForm": true,
            "showOnList": false,
            "showOnView": false,
            "pmProjectId": projectId,
            "readOnly": true,
            "pmIsGeneration": true,
            "fieldGroup": "TASKS",
            "template": "field/text-edit.html",
            "icon": "trash",
            "class": 2,
            "events": []
        };
    };
    this.getTaskTypeNameObj = function (projectId) {
        return {
            "name": "TASK_FEATURES_"+ projectId,
            "label": "Pontos Estimados",
            "class": 2,
            "sameLine": false,
            "isVisible": true,
            "showOnForm": true,
            "showOnList": false,
            "showOnView": false,
            "pmProjectId": projectId,
            "pmIsGeneration": true,
            "fieldGroup": "TASKS",
            "readOnly": false,
            "fields": [
                {
                    "name": "DESCRIPTION",
                    "label": "Nome",
                    "showOnList": true
                },
                {
                    "name": "TIME_BASE",
                    "label": "Tempo base",
                    "showOnList": true
                }
            ],
            "showSelectAs": "grid",
            "outData": {
                "TIME_BASE": "TIME_PLANNED_"+ projectId,
                "DESCRIPTION": "TASK_FEATURES_"+ projectId,
                "ID": "TASK_FEATURES_ID_"+ projectId
            },
            "template": "zh-select-autocomplete#field/select-autocomplete.html",
            "descriptionField": "DESCRIPTION",
            "searchableFields": ["DESCRIPTION"],
            "valueField": "ID",
            "showAddButton": false,
            "dataSource": {
                "name": "/taskFeatures",
                "rest": true,
                "localStorage": true,
                "data": []
            },
            "events": []
        };
    };
    this.getDesciptionActionSelectObj = function (projectId) {
        return {
            "name": "CHANGE_DESCRIPTION_" + projectId,
            "isVisible": true,
            "showOnForm": true,
            "showOnList": true,
            "showOnView": true,
            "label": "Editar descrição",
            "pmProjectId": projectId,
            "pmIsGeneration": true,
            "fieldGroup": "TASKS",
            "template": "field/button.html",
            "icon": "tasks",
            "class": "1 change_desc",
            "events": [
                {
                    "name": "FieldOnClick",
                    "code": "BoardIssuesController.fieldOnClickEventDescription(args);"
                }
            ]
        };
    };

    this.getDesciptionFieldSelectObj = function (issueId, projectId) {
        return {
            "name": "DESCRIPTION_" + issueId + "_" + projectId,
            "label": "Descrição",
            "template": "field/textarea.html",
            "maxWidth": "10%",
            "textRows": 5,
            "pmProjectId": projectId,
            "fieldGroup": "ISSUES_" +issueId,
            "pmIssueId": issueId,
            "pmIsGeneration": true,
            "isVisible": true,
            "showOnList": false,
            "showOnView": true,
            "validations": {
                "required": {}
            },
            "class": 12
        };
    };

    this.getDesciptionFieldGroupSelectObj = function (issueId, name) {
        return {
            "name": "ISSUES_" + issueId,
            "label": name,
            "collapsible": true,
            "opened": true
        };
    };

    this.getEstimatedTimeObj = function (projectId) {
        return {
            "name": "TIME_PLANNED_"+ projectId,
            "label": "Pontos estimados",
            "class": 1,
            "placeholder": "Pontos para um recurso experiente",
            "isVisible": false,
            "showOnForm": true,
            "showOnList": false,
            "showOnView": false,
            "pmProjectId": projectId,
            "mask": {
                "type": "number"
            },
            "pmIsGeneration": true,
            "fieldGroup": "TASKS",
            "template": "field/text-edit.html",
            "events": []
        };
    };

    this.getParentNameSelectObj = function (projectId) {
        return {
            "name": "PARENT_NAME_" + projectId,
            "label": "Tarefa superior",
            "showOnForm": true,
            "class": 2,
            "isVisible": true,
            "fieldGroup": "TASKS",
            "template": "zh-select-autocomplete#field/select-autocomplete.html",
            "descriptionField": "NAME",
            "searchableFields": ["NAME"],
            "pmIsGeneration": true,
            "pmProjectId": projectId,
            "hasPagination": false,
            "searchWithPagination": false,
            "valueField": "ID",
            "showSelectAs": "tree",
            "parentProperty": "PARENT",
            "primaryProperty": "ID",
            "expandingProperty": "NAME",
            "breadcrumbProperty": "NAME",
            "outData": {
                "ID": "PARENT_" + projectId,
                "NAME": "PARENT_NAME_" + projectId
            },
            "dataSource": {
                "name": "/findAllTaskByProject",
                "rest": true,
                "localStorage": false,
                "data": []
            },
            "dataSourceFilter": [
                {
                    "name": "projectInIssue",
                    "operator": "=",
                    "value": projectId
                }
            ]
        };
    };

    this.getResourceSelectMultipleObj = function (projectId) {
        return {
            "name": "RESOURCE_" + projectId,
            "label": "Recursos",
            "isVisible": true,
            "showOnForm": true,
            "showOnList": false,
            "showOnView": false,
            "pmProjectId": projectId,
            "pmIsGeneration": true,
            "fieldGroup": "TASKS",
            "template": "field/select-multiple.html",
            "class": 2,
            "events": [
                {
                    "name": "FieldOnChange",
                    "code": "BoardIssuesController.fieldOnChangeEventResource(args);"
                }
            ],
            "descriptionField": "NAME",
            "valueField": "ID",
            "hasPagination": false,
            "searchWithPagination": false,
            "dataSource": {
                "name": "/taskResource",
                "rest": true,
                "localStorage": false,
                "data": []
            },
            "dataSourceFilter": [
                {
                    "name": "PROJECT",
                    "value": projectId,
                    "operator": "="
                }
            ]
        };
    };

    var removeAllFieldsPmGeneration = function(widget){
        widget.fields = widget.fields.filter(function(field){
            return !field.pmIsGeneration;
        });
    };

    var factoryCommitMasterFilesPromise = function () {
        filesWithStatus = uniques(filesWithStatus);
        var defer = ZHPromise.defer();
        var paths = getTaskPaths();
        var gitMessage = getCommitMessage();
        var promiseResult = paths.map(function (path) {
            path.commitMessage = gitMessage;
            path.files = filesWithStatus.filter(function (file) {
                if (file.gitStatus === 'C' && path.repository === file.FILE_REPOSITORY)
                    return true;
            }).map(function (file) {
                if (path.repository === file.FILE_REPOSITORY)
                    return file.DIR;
            });

            return path;
        });
        defer.resolve(promiseResult);
        return defer.promise;
    };

    var factoryResetPromise = function () {
        filesWithStatus = uniques(filesWithStatus);
        var defer = ZHPromise.defer();
        var paths = getTaskPaths();
        var gitMessage = getCommitMessage();
        var promiseResult = paths.map(function (path) {
            path.commitMessage = gitMessage;
            path.files = filesWithStatus.filter(function (file) {
                if (file.gitStatus === 'R')
                    return file.FILE_REPOSITORY === path.repository &&
                           validateEqualRepositoriesFiles(path.ID, file.FILE_REPOSITORY_IDS);
            }).map(function (file) {
                return {
                    name: file.DIR,
                    status: file.FILE_STATUS
                };
            });
            return path;
        });
        defer.resolve(promiseResult);
        return defer.promise;
    };

    var getStashBranchName = function(){
        var taskId = getTaskId();
        var stashDesc = templateManager.container.getWidget('NEW_APPROPRIATION').getField('STASH_DESCRIPTION').value();
        if(localStorageEngine.getLocalVar('DIRTY_DIRECTORY')) {
            stashDesc = getStashNamePopupWidget().getField('STASH_DESCRIPTION').value();
        }else if(currentTaskStatus == 'COMMIT'){
            stashDesc = getFieldStashDescriptionFromWidgetCommitCommentPopup().value();

        }
        stashDesc = Utilities.transliterateString(stashDesc);
        stashDesc = stashDesc.replace(/(\r\n|\n|\r)/gm, "_").replace(/\W/g, "_").replace(/[_]+/g, '_');
        var userId = localStorageEngine.getLocalVar('idBusinessPartner');
        var branchName = 'TASK_BKP_STASH_'  + userId + '_' + taskId + '_' +stashDesc;
        return branchName;
    };

    var factoryStashPromise = function () {
        filesWithStatus = uniques(filesWithStatus);
        var defer = ZHPromise.defer();
        var paths = getTaskPaths();
        var gitMessage = getCommitMessage();
        var stashBranchName = getStashBranchName();
        var promiseResult = paths.map(function (path) {
            path.commitMessage = gitMessage;
            path.stashBranchName = stashBranchName;
            path.files = filesWithStatus.filter(function (file) {
                if (file.gitStatus === 'S')
                    return file.FILE_REPOSITORY === path.repository &&
                           validateEqualRepositoriesFiles(path.ID, file.FILE_REPOSITORY_IDS);
            }).map(function (file) {
                return file.FILE_NAME;
            });
            return path;
        });
        defer.resolve(promiseResult);
        return defer.promise;
    };

    var validateCommitAlert = function (commitFailed) {
        if (commit.length > 0) {
            if (commitFailed) {
                ScreenService.errorNotification(Messages.COMMIT_FAILED);
                ScreenService.closeSwipe();
                getInfoTaskWidget().activate();
            } else {
                ScreenService.successNotification(Messages.COMMIT_SUCCEED, 7000);
            }
            commit = [];
        }

    };

    var validateResetAlert = function (resetFailed) {
        if (reset.length > 0) {
            if (resetFailed) {
                ScreenService.errorNotification(Messages.RESET_FAILED);
            } else {
                ScreenService.successNotification(Messages.RESET_SUCCEED, 7000);
            }
            reset = [];
        }

    };

    var validateStashAlert = function (stashFailed) {
        if (stash.length > 0) {
            if (stashFailed) {
                ScreenService.errorNotification(Messages.ERR_CONFLICT_STASH);
            } else {
                ScreenService.successNotification(Messages.STASH_SUCCEED, 7000);
                localStorageEngine.setLocalVar('pendentStash', true);
            }
            stash = [];
        }

    };

    var changeToPause = function (task, notReloadInfoTask) {
        return TaskService.pauseTask(task).then(function () {
            self.loadTaskAppropriationFromDate(getStripeNavigatorWidget().currentRow.ESTIMATED_BEGIN_DATE);
            getListTasksWidget().reload();
            if(!notReloadInfoTask) {
                getInfoTaskWidget().reload();
                getInfoTaskWidget().list();
            }
            getListTasksWidget().activate();
            ScreenService.hideLoader();
            ScreenService.restoreDefaultLoadingMessage();
            currentTaskStatus = '';
            return;
        });
    };

    var changeToConclude = function (task, notReloadInfoTask) {
        task.TASK_RESPONSE = getDescriptionFieldFromNewAppropriationWidget().value();

        return TaskService.concludeTask(task).then(function () {
            var infoTaskWidget  = getInfoTaskWidget();
            var listTasksWidget = getListTasksWidget();

            self.loadTaskAppropriationFromDate(getStripeNavigatorWidget().currentRow.ESTIMATED_BEGIN_DATE);
            listTasksWidget.reload();

            if(!notReloadInfoTask) {
                infoTaskWidget.reload();
                infoTaskWidget.list();
            }

            listTasksWidget.activate();
            ScreenService.hideLoader();
            ScreenService.restoreDefaultLoadingMessage();
            currentTaskStatus = '';
            return;
        });
    };

    var changeToStart = function (task) {
        var status = 'D';
        return TaskService.initTask(task).then(function () {
            self.loadTaskAppropriationFromDate(getStripeNavigatorWidget().currentRow.ESTIMATED_BEGIN_DATE);
            var infoTaskWidget = getInfoTaskWidget();
            return showActionsByTaskStatus(infoTaskWidget, status).then(function () {
                templateManager.updateTemplate();
                return infoTaskWidget.reload().then(function() {
                    if(getListTasksWidget().currentRow) {
                        getListTasksWidget().descriptionOrder = '' + infoTaskWidget.currentRow.ID + ' ' + infoTaskWidget.currentRow.TASK_NAME;
                        getListTasksWidget().currentRow.TASK_STATUS_LABEL = infoTaskWidget.currentRow.TASK_STATUS_LABEL;
                        getListTasksWidget().currentRow.TASK_STATUS = infoTaskWidget.currentRow.TASK_STATUS;
                    }
                    ScreenService.hideLoader();
                    ScreenService.restoreDefaultLoadingMessage();
                    currentTaskStatus = '';
                    return;
                });
            });
        });
    };

    var changeTaskStatus = function (notReloadInfoTask) {
        var task = getInfoTaskWidget().currentRow;
        var appropriation = getNewAppropriationWidget();
        var percentCompleted = parseInt(appropriation.currentRow.PERCENT_COMPLETED);
        if (currentTaskStatus === 'PAUSE') {
            if (percentCompleted < 100)
                return changeToPause(task, notReloadInfoTask);
            else
                return changeToConclude(task, notReloadInfoTask);
        }
        if (currentTaskStatus === 'CONCLUDE') {
            return changeToConclude(task, notReloadInfoTask);
        }
        if (currentTaskStatus === 'START') {
            return changeToStart(task);
        }
    };

    var validateErrors = function (addFailed, commitFailed, resetFailed, stashFailed) {
        if (commitFailed || addFailed) {
            ScreenService.hideLoader();
            getListTasksWidget().list();
            getInfoTaskWidget().activate();
        } else {
            if (commit.length > 0)
                saveAppropriation();
            if (resetFailed && !stashFailed) {
                ScreenService.hideLoader();
                getInfoTaskWidget().activate();
                self.gitStatus(getInfoTaskWidget());
                if (stash.length > 0) {
                    ScreenService.setNotificationHint("stashApply", '1');
                    localStorageEngine.setLocalVar('pendentStash', true);
                }

            }
            if ((!resetFailed && stashFailed) || (resetFailed && stashFailed)) {
                ScreenService.hideLoader();
                getListTasksWidget().list();
                getInfoTaskWidget().activate();
            }
        }

        validateCommitAlert(commitFailed);
        validateResetAlert(resetFailed);
        validateStashAlert(stashFailed);

    };

    var buildProjectData = function () {
        var row = {};
        row.changed = true;
        row.PROJECT = templateManager.container.getWidget('INFO_TASK').currentRow.PROJECT_ID.replace(/\D/g, '');
        return row;
    };

    this.createNewTask = function (generatorTask, dataNewTask) {
        var widgetTaskRow = getInfoTaskWidget().currentRow;
        var widgetMergeRequest = templateManager.container.getWidget('MERGE_REQUEST');
        var widgetGenerate = getWidgetGenerateTask();
        var endTaskDate = widgetTaskRow.ESTIMATED_END_DATE;
        var startTaskDate = widgetTaskRow.ESTIMATED_END_DATE;
        var resource = widgetTaskRow.RESOURCE_T;
        var totalTime = '1D';
        var parent = widgetTaskRow.PARENT;
        var descriptionTask = dataNewTask.DESCRIPTION;

        if (dataNewTask.TYPE_RELATIONSHIP == TYPE_RELATIONSHIP_MERGE_REQUEST || dataNewTask.TASK_INFO.mergeRequestStable) {
            resource = dataNewTask.resources;
            parent = dataNewTask.PARENT;
            var description = widgetMergeRequest.currentRow.DESCRIPTION;

            if(description && description.trim() !== '') {
                descriptionTask = description;
            }
        }

        if(dataNewTask.TASK_INFO.hasOwnProperty('start')) {
            startTaskDate = dataNewTask.TASK_INFO.start;
            endTaskDate = dataNewTask.TASK_INFO.end;
            totalTime = dataNewTask.TASK_INFO.totalTime;
            parent = dataNewTask.TASK_INFO.parent;
            resource = dataNewTask.TASK_INFO.resource;
        }
        var classification = dataNewTask.TASK_CLASSIFICATION ? dataNewTask.TASK_CLASSIFICATION : widgetTaskRow.CLASSIFICATION;

        var projectId = dataNewTask.TYPE_RELATIONSHIP == TYPE_RELATIONSHIP_ERROR ? widgetGenerate.currentRow.PROJECT : widgetTaskRow.PROJECT_ID.replace(/\D/g, '');

        var row = {
            START: endTaskDate.split("/").reverse().join("-"),
            END: startTaskDate.split("/").reverse().join("-"),
            DATE_EXCEPTION: null,
            DATE_EXCEPTION_TYPE: "MB",
            DESCRIPTION: descriptionTask,
            NAME: Utilities.includeTaskTypeInTaskName(widgetTaskRow.TASK_NAME, dataNewTask.CLASSIFICATION_CONTROL),
            PROJECT: projectId,
            PARENT: parent,
            RESOURCE: [resource],
            TASK_STATUS: dataNewTask.TASK_STATUS,
            TOTAL_TIME: totalTime,
            TASK_CLASSIFICATION: classification,
            TASK_GENERATOR: generatorTask,
            TASK_GENERATOR_RELATIONSHIP: dataNewTask.TYPE_RELATIONSHIP,
            isMessage: false,
            __createdLocal: true,
            __is_new: true,
            changed: true
        };

        return requestDataSourceEngine.setDataSource('/saveNewProjectTask', [row]).then(function (data) {
            return data.dataset.ID[0];
        });
    };

    var cleanWindowAndActivateListTasksWidget = function() {
        ScreenService.hideLoader();
        ScreenService.closePopup(true);
        getListTasksWidget().activate();
        ScreenService.restoreDefaultLoadingMessage();
    };

    var updateMasterRepositories = function() {
        var defer = ZHPromise.defer();
        AppropriationService.pullMasterInRepositories(localStorageEngine.getLocalVar('TASK_PATHS')).then(function () {
            updateLogFilePause().then(function() {
                cleanWindowAndActivateListTasksWidget();
                defer.resolve();
            });
        }).catch(function (e) {
            updateLogFilePause().then(function() {
                showErrorPullMainBranch(e);
                defer.reject();
            });
        });

        return defer.promise;
    };

    var setPopupDiffDataSource = function(mergeCheck ,fileName, paths) {
        var branchBase;
        if (mergeCheck) {
            branchBase = "origin/master";
        } else {
            branchBase = " ";
        }
        var popupDiffWidget = getPopupDiffWidget();
        var gitWidget = getGitPopupWidget();
        var dataSource = [];
        var arrayPromise = paths.map(function (path) {
            return getTaskInfo().then(function (taskInfo) {
                var branchToCompare = taskInfo.branchName;
                return GitService.currentGitDiff(path.dir, branchBase, branchToCompare, fileName).then(function (diff) {
                    diff.forEach(function(obj){
                        if(obj.CODE === ""){
                            obj.CODE = " ";
                        }
                    });
                    dataSource = dataSource.concat(diff);
                }).catch(function (error) {
                    console.log(error);
                });
            });
        });
        ZHPromise.all(arrayPromise).then(function () {
            if (dataSource.length == 1) {
                if(dataSource[0].CODE === "") {
                    dataSource[0].FILE += Utilities.messages.NEW_FILE_ON_GIT_DIFF;
                    dataSource[0].STATUS = "ADDED";
                }
            } else {
                var newFiles = verifyNewFiles(gitWidget.dataSource.data);
                dataSource = dataSource.concat(newFiles);
            }
            popupDiffWidget.dataSource.data = dataSource;
            ScreenService.openPopup(getPopupDiffWidget());
            ScreenService.hideLoader();
        });
    };

    var verifyNewFiles = function(dataList){
        var newFiles = [];
        dataList.forEach(function(data){
            if(data.FILE_STATUS == "Adicionado"){
                newFiles.push({
                    STATUS : "ADDED",
                    FILE:  data.DIR+Utilities.messages.NEW_FILE_ON_GIT_DIFF
                });
            }
        });
        return newFiles;
    };

    var playReplicationTask = function(taskReplicationInfo) {
        var widgetInfoTask = getInfoTaskWidget();
        Utilities.localVar.setLocalVarTaskId(taskReplicationInfo.ID);
        localStorageEngine.setLocalVar('taskID', 'T' + taskReplicationInfo.ID);

        ScreenService.showLoader();
        widgetInfoTask.reload().then(function () {
            widgetInfoTask.moveToFirst();
            Utilities.localVar.setTaskAllocationId(widgetInfoTask.currentRow.ALLOCATION);
            Utilities.localVar.setClickedTaskName(widgetInfoTask.currentRow.TASK_NAME);
            getTaskInfo().then(function (taskInfo) {
                doGitPlay(taskInfo, true, widgetInfoTask);
            }).catch(function (e) {
                defaultError(e.data.error);
            });
        }).catch(ScreenService.hideLoader);
    };

    var executeFinishErrorFixTask = function(taskInfo, taskReplicationInfo, infoTaskWidget) {
        cleanAndFinish(currentTaskStatus, true).then(function () {
            var taskId = taskInfo.taskGenerator;
            if (taskReplicationInfo) {
                if (isProductAssociation()) {
                    if (taskInfo.typeRelationship != TYPE_RELATIONSHIP_MERGE_REQUEST) {
                        taskInfo.taskGenerator = taskInfo.trueTaskId;
                    }
                    if (taskInfo.typeRelationship == TYPE_RELATIONSHIP_ERROR || taskInfo.typeRelationship == TYPE_RELATIONSHIP_ERROR_MR) {
                        taskId = taskInfo.trueTaskId;
                    }
                    AppropriationService.createTaskBranchInDevOps(taskId, infoTaskWidget.currentRow).then(function () {
                        updateMasterRepositories().then(function () {
                            playReplicationTask(taskReplicationInfo);
                        });
                    }).catch(function () {
                        updateLogFilePause().then(function () {
                            ScreenService.hideLoader();
                            ScreenService.restoreDefaultLoadingMessage();
                        });
                    });
                } else {
                    updateMasterRepositories().then(function () {
                        playReplicationTask(taskReplicationInfo);
                    });
                }
            } else if ((taskInfo.errorFixTask || taskInfo.mergeRequestStable) &&
                       AppropriationService.isTagMainBranch() &&
                (infoTaskWidget.currentRow.IS_LTS == 'N' || infoTaskWidget.currentRow.PROJECT_IS_LTS_REPLICATION == 'N')) {
                AppropriationService.createTaskBranchInDevOps(taskId, infoTaskWidget.currentRow).then(function () {
                    updateMasterRepositories();
                }).catch(function () {
                    updateLogFilePause().then(function () {
                        ScreenService.hideLoader();
                        ScreenService.restoreDefaultLoadingMessage();
                    });
                });
            } else {
                if (isProductAssociation() && taskInfo.typeRelationship == TYPE_RELATIONSHIP_MERGE_REQUEST) {
                    if (taskInfo.typeRelationship == TYPE_RELATIONSHIP_ERROR || taskInfo.typeRelationship == TYPE_RELATIONSHIP_ERROR_MR) {
                        taskId = taskInfo.trueTaskId;
                    }
                    AppropriationService.createTaskBranchInDevOps(taskId, infoTaskWidget.currentRow).then(function () {
                        updateMasterRepositories();
                    }).catch(function () {
                        updateLogFilePause().then(function () {
                            ScreenService.hideLoader();
                            ScreenService.restoreDefaultLoadingMessage();
                        });
                    });
                } else {
                    updateMasterRepositories();
                }
            }
        }).catch(defaultErrorPause);
    };

    var getInitialTaskStatus = function () {
        var taskStatus = 3;
        var taskParameters = Utilities.localVar.getTaskParameters();
        if (taskParameters && taskParameters.INITIAL_TASK_STATUS_ID) {
            taskStatus = taskParameters.INITIAL_TASK_STATUS_ID;
        } else {
            var taskStatusRow = getTaskStatusRowByControl('N');
            taskStatus = taskStatusRow.ID;
        }
        return taskStatus;
    };

    var buildTaskRows = function (projects, mergeRequestRow, infoTaskRow) {
        var date = infoTaskRow.ESTIMATED_END_DATE.split("/").reverse().join("-");
        var taskStatus = getInitialTaskStatus();
        var description = mergeRequestRow.DESCRIPTION;
        var descriptionTask = Utilities.messages.DES_TASK_GENERATED_MERGE_REQUEST;
        if (description && description.trim() !== '') {
            descriptionTask += '\n\n' + description;
        }

        return projects.map(function (project) {
            var projectId = project.PROJECT_ID;

            return {
                RESOURCE: mergeRequestRow['RESOURCE_' + projectId] ? [mergeRequestRow['RESOURCE_' + projectId]] : [],
                PARENT: mergeRequestRow['TASK_' + projectId],
                TYPE_RELATIONSHIP: TYPE_RELATIONSHIP_MERGE_REQUEST,
                DESCRIPTION: descriptionTask,
                START: date,
                END: date,
                NAME: Utilities.includeTaskTypeInTaskName(infoTaskRow.TASK_NAME, 'M'),
                PROJECT: projectId,
                TASK_STATUS: taskStatus,
                PRODUCT_VERSION_ID: infoTaskRow.PRODUCT_VERSION_ID,
                TOTAL_TIME: '1D',
                TASK_CLASSIFICATION: infoTaskRow.CLASSIFICATION,
                __is_new: true,
                changed: true
            };
        });
    };

    var executeFinishWithCreateMergeRequest = function() {
        var widgetMergeRequest = getWidgetMergeRequest();
        var mergeRequestRow = widgetMergeRequest.currentRow;
        var infoTaskRow = getInfoTaskWidget().currentRow;
        var projects = infoTaskRow.DIRECTORIES_VALIDATION.PROJECTS;
        var relatedTask = infoTaskRow.DIRECTORIES_VALIDATION.IS_RELATED_TASK;
        var tasks = buildTaskRows(projects, mergeRequestRow, infoTaskRow);
        var taskListWidget = getListTasksWidget();
        var row = {
            TASKS: tasks,
            IS_RELATED_TASK: relatedTask,
            FINISHED_TASK: getCurrentTaskId(),
            changed: true
        };

        ScreenService.changeLoadingMessage(Messages.LOAD_CREATING_MERGE_REQUEST_TASK);
        ScreenService.showLoader();
        AppropriationService.saveMultipleTasks(row).then(function () {
            ScreenService.hideLoader();
            ScreenService.restoreDefaultLoadingMessage();
            getListTasksWidget().reload();
            cleanAndFinish(currentTaskStatus).then(function () {
                if(taskListWidget.currentRow.USEGITAUTOMATICALLY !== 'Y') {
                    cleanWindowAndActivateListTasksWidget();
                } else {
                    updateMasterRepositories();
                }
            });
        }).catch(function (e) {
            updateLogFilePause().then(function() {
                defaultError(e);
                ScreenService.hideLoader();
                ScreenService.restoreDefaultLoadingMessage();
            });
        });
    };

    var executeFinishWithGenerateTask = function() {
        var widgetGenerate = getWidgetGenerateTask();
        var widgetInfoTask = getInfoTaskWidget();
        var directoriesValidation = widgetInfoTask.currentRow.DIRECTORIES_VALIDATION;

        ScreenService.changeLoadingMessage(Messages.LOAD_GENERATING_NEW_TASK);
        ScreenService.showLoader();
        AppropriationService.saveMultipleTasks(getDataNewTaskToGenerateMultiple(widgetGenerate, directoriesValidation.PROJECTS, directoriesValidation.IS_RELATED_TASK))
            .then(function (data) {
            var newTaskId = data.dataset.ID[0];
            AppropriationService.duplicateChangedFilesForNewTask(widgetInfoTask.currentRow.TASK_ID, newTaskId, widgetInfoTask.currentRow.TYPE_RELATIONSHIP).then(function() {
                cleanAndFinish(currentTaskStatus).then(function () {
                    getListTasksWidget().reload();
                    generateTask = false;
                    updateMasterRepositories();
                });
            }).catch(function () {
                updateLogFilePause().then(function() {
                    ScreenService.hideLoader();
                    ScreenService.restoreDefaultLoadingMessage();
                });
            });
        }).catch(function (e) {
            updateLogFilePause().then(function() {
                defaultError(e);
                ScreenService.hideLoader();
                ScreenService.restoreDefaultLoadingMessage();
            });
        });
    };

    var executeFinishDefault = function(taskInfo, infoTaskWidget) {
        if (isProductAssociation() && currentTaskStatus == 'CONCLUDE' &&
            taskInfo.typeRelationship != TYPE_RELATIONSHIP_REPLICATION) {
            var taskId = taskInfo.taskGenerator;
            if(taskInfo.typeRelationship == TYPE_RELATIONSHIP_ERROR || taskInfo.typeRelationship  == TYPE_RELATIONSHIP_ERROR_MR){
                taskId = taskInfo.trueTaskId;
            }

            AppropriationService.createTaskBranchInDevOps(taskId, infoTaskWidget.currentRow).then(function () {
                cleanAndFinish(currentTaskStatus).then(function () {
                    updateMasterRepositories();
                });
            }).catch(function () {
                updateLogFilePause().then(function() {
                    ScreenService.hideLoader();
                    ScreenService.restoreDefaultLoadingMessage();
                });
            });
        } else {
            cleanAndFinish(currentTaskStatus).then(function () {
                updateMasterRepositories();
            });
        }
    };

    var createLogFile = function(logFileName, logFileContents) {
        var defer = ZHPromise.defer();
        var reject = function() {
            ScreenService.alertNotification(Messages.ALE_LOG_NOT_SAVED, 10000);
            defer.resolve();
        };
        var params = self.buildLog(logFileName);
        var filter = [{
            "name": "FILE_NAME",
            "value": logFileName,
            "operator": "="
        }];
        var getFullLogAndSaveLog = function(){
            return requestDataSourceEngine.getDataSource('/getFullLog', filter).then(function(fullLog) {
                var log = fullLog.dataset.logFileContents[0];
                params = self.prepareFileSizeAndContent(params, log, logFileContents);
                return requestDataSourceEngine.setDataSource('/saveLog', params);
            });
        };

        getFullLogAndSaveLog().then(function(){
            defer.resolve();
        }).catch(function(){
            getFullLogAndSaveLog().then(function(){
                defer.resolve();
            }).catch(reject);
        });

        return defer.promise;
    };

    this.buildLog = function(logFileName){
        var dateInMilliseconds = Utilities.getCurrentDateInMilliseconds();
        var date = Utilities.getCurrentFormattedDateForAttachment();
        return [ {
            __createdLocal: true,
            '__is_new': true,
            changed: true,
            'projectId': Utilities.localVar.getProject(),
            DOCUMENT : [{
                'name': logFileName,
                'b64File': '',
                'lastModified': dateInMilliseconds,
                'lastModifiedDate': date,
                'size': 0,
                'type': 'text/plain',
                'webkitRelativePath': ''
            }],
            'taskId': Utilities.localVar.getLocalVarTaskId()
        } ];
    };

    this.prepareFileSizeAndContent = function(params, log, logFileContents){
        if(log.length > 0) {
            params[0].DOCUMENT[0].b64File = 'data:text/plain;base64,' + window.btoa(log.replace(/[\u00A0-\u2666]/g, '')+logFileContents.replace(/[\u00A0-\u2666]/g, ''));
        }else{
            params[0].DOCUMENT[0].b64File = 'data:text/plain;base64,' + window.btoa(logFileContents.replace(/[\u00A0-\u2666]/g, ''));
        }
        params[0].DOCUMENT[0].size = Utilities.byteLength(log+logFileContents);
        return params;
    };

    var getFullLogFileContents = function(logFileName) {
        var filter = [{
            "name": "FILE_NAME",
            "value": logFileName,
            "operator": "="
        }];
        return requestDataSourceEngine.getDataSource('/getFullLog', filter).then(function(fullLog) {
            var log = fullLog.dataset.logFileContents[0];
            return log.length > 0 ? log : false;
        });
    };

    var updateLogFilePause = function(notLogPauseFiles,isStatus) {
        var logFileName = getLogFileName();
        var typeLog = '';
        if(isStatus){
            typeLog = 'Commit';
        }else{
            typeLog = currentTaskStatus == 'CONCLUDE' || getNewAppropriationWidget().currentRow.PERCENT_COMPLETED == 100 ? 'Encerrar' : 'Pausar';
        }
        var logFileContents = getLogFileContents(typeLog);

        if(!notLogPauseFiles) {
            if(pauseFiles.commit) {
                logFileContents += DESC_LOG_COMMITED_FILES;
                pauseFiles.commit.forEach(function (commitFile) {
                    logFileContents += '\n' + 'Arquivo: ' + commitFile.DIR + ' | Repositório: ' + commitFile.FILE_REPOSITORY;
                });
            }
            if(pauseFiles.reset) {
                logFileContents += DESC_LOG_RESETED_FILES;
                pauseFiles.reset.forEach(function (resetFile) {
                    logFileContents += '\n' + 'Arquivo: ' + resetFile.DIR + ' | Repositório: ' + resetFile.FILE_REPOSITORY;
                });
            }
            if(pauseFiles.stash) {
                logFileContents += DESC_LOG_STASHED_FILES;
                pauseFiles.stash.forEach(function (stashFile) {
                    logFileContents += '\n' + 'Arquivo: ' + stashFile.DIR + ' | Repositório: ' + stashFile.FILE_REPOSITORY;
                });
            }
            logFileContents += '\n\n';
        }

        return createLogFile(logFileName, logFileContents);
    };

    var finishAndCreateNewTask = function(taskInfo, taskReplicationInfo) {
        ScreenService.restoreDefaultLoadingMessage();
        var infoTaskWidget = getInfoTaskWidget();
        if ((taskInfo.errorFixTask ||
            (taskInfo.typeRelationship == TYPE_RELATIONSHIP_MERGE_REQUEST && taskInfo.projectUseMergeRequest)) &&
            currentTaskStatus == 'CONCLUDE') {
            executeFinishErrorFixTask(taskInfo, taskReplicationInfo, infoTaskWidget);
        } else if ((taskInfo.mergeRequest || taskInfo.mergeRequestStable) &&
                    currentTaskStatus == 'CONCLUDE' && createMergeRequest) {
            executeFinishWithCreateMergeRequest();
        } else if (generateTask) {
            executeFinishWithGenerateTask();
        } else {
            executeFinishDefault(taskInfo, infoTaskWidget);
        }
    };

    var cleanAndFinish = function (newCurrentTaskStatus, notReloadInfoTask) {
        stash = []; commit = []; reset = []; filesWithStatus = [];
        return saveAppropriation().then(function () {
            ScreenService.closeSwipe(0);
            currentTaskStatus = newCurrentTaskStatus;
            getWidgetGenerateTask().oldDescriptionFieldTaskGenerate = '';
            getWidgetNewAppropriation().oldDescriptionFieldAppropriation = '';
            return changeTaskStatus(notReloadInfoTask);
        });
    };

    var finishAppropriation = function (commitFailed, resetFailed, stashFailed, branchName, taskInfo, taskReplicationInfo) {
        validateTaskBranch(taskInfo.typeRelationship, taskInfo.taskGenerator, branchName).then(function () {
            if (stash.length > 0) {
                ScreenService.setNotificationHint("stashApply", '1');
                localStorageEngine.setLocalVar('pendentStash', true);
            }

            if(!pauseFiles.commit) {
                pauseFiles.commit = commit;
                pauseFiles.reset = reset;
                pauseFiles.stash = stash;
            }

            validateCommitAlert(commitFailed);
            validateResetAlert(resetFailed);
            validateStashAlert(stashFailed);

            if(taskInfo.typeRelationship == TYPE_RELATIONSHIP_ERROR_MR && currentTaskStatus == 'CONCLUDE') {
                updateRelationshipMergeRequestTask(getCurrentTaskId()).then(function () {
                    finishAndCreateNewTask(taskInfo, taskReplicationInfo);
                }).catch(defaultErrorPause);
            } else {
                finishAndCreateNewTask(taskInfo, taskReplicationInfo);
            }
        });
    };

    var isFromTest = function(taskId){
        var filter = [
            {
                "operator": "=",
                "name": "task_id",
                "value": taskId
            }
        ];

        return requestDataSourceEngine.getDataSource('/findErrorTaskFromErrorMerge', filter);
    };

    var updateRelationshipMergeRequestTask = function(task) {
        var defer = ZHPromise.defer();
        var reject = function(error) {
            defer.reject(error);
        };
        var infoTasksWidget = getInfoTaskWidget();
        var row = {
            TASK: task,
            changed: true
        };
        var originTaskId = infoTasksWidget.currentRow.BRANCH_INFO.BRANCH_TASK;

        isFromTest(task).then(function(isErrorTask) {
            requestDataSourceEngine.setDataSource('/updateRelationshipMergeRequest', [row]).then(function (data) {
                if (typeof data === 'object') {
                    if (isErrorTask.dataset.findIfIsFromTest.length > 0) {
                        defer.resolve();
                    } else {
                        AppropriationService.createTaskBranchInDevOps(originTaskId, infoTasksWidget.currentRow, true).then(function () {
                            defer.resolve();
                        }).catch(reject);
                    }
                } else {
                    reject(data);
                }
            }).catch(reject);
        }).catch(reject);

        return defer.promise;
    };

    this.saveNewTaskMergeRequest = function (args) {
        var widgetMergeRequest = getWidgetMergeRequest();
        var widgetInfoTask = getWidgetInfoTask();
        var taskListWidget = getListTasksWidget();
        
        if(widgetMergeRequest.isValid()){
            if(taskListWidget.currentRow.USEGITAUTOMATICALLY !== 'Y'){
                executeFinishWithCreateMergeRequest();
            }else{
                var projects = widgetInfoTask.currentRow.DIRECTORIES_VALIDATION.PROJECTS;
                projects.forEach(function(project) {
                    var projectId = project.PROJECT_ID;
                    var infoString = widgetMergeRequest.currentRow['TASK_' + projectId] + "|" +
                        widgetMergeRequest.currentRow['RESOURCE_' + projectId];
                    localStorage.setItem(projectId, infoString);
                });
                ScreenService.showLoader();
                doGitPauseProcess(widgetMergeRequest.taskInfo, 'Y');
            }
            
        }
    };

    this.mergeRequestActionEventCancel = function(args){
        var newAppropriation = getWidgetNewAppropriation();
        ScreenService.closePopup();
        newAppropriation.activate();
    };

    var getCommitedAndStashedFiles = function () {
        var modifiedFiles = [];
        var paths = getInfoTaskWidget().currentRow.PATHS;
        filesWithStatus.map(function (file) {
            if ((file.gitStatus === 'C' || file.gitStatus === 'S') && file.isDir === false) {
                paths.map(function (path) {
                    if (file.FILE_REPOSITORY === path.repository) {
                        var newFile = {};
                        newFile.REPOSITORY_ID = path.ID;
                        newFile.NAME = file.DIR.replace(path.dir, "");
                        modifiedFiles.push(newFile);
                    }
                });
            }
        });
        return modifiedFiles;
    };





    var saveChangedFiles = function () {
        var requestSaveChangedFiles = function(row) {
            return requestDataSourceEngine.setDataSource('/saveChangedFiles', [row]);
        };

        var defer = ZHPromise.defer();
        var files = getCommitedAndStashedFiles();
        var row = {};
        row.changed = true;
        row.FILE_TYPE = 'L';
        row.TASK = getCurrentTaskId();

        var arrFiles = [];
        var maxFilesInPosition = 2000;
        while(files.length > 0) {
            arrFiles.push(files.splice(0, maxFilesInPosition));
        }

        var functions = [];
        arrFiles.forEach(function (files) {
            row.FILES = files;
            functions.push(requestSaveChangedFiles.bind(saveChangedFiles, row));
        });

        Utilities.doSyncPm(functions).then(function () {
            defer.resolve();
        }).catch(function (e) {
            defer.reject(e);
        });

        return defer.promise;
    };

    var uniqueArray = function (a) {
        a.filter(function (item, pos) {
            return a.indexOf(item) == pos;
        });
    };

    var uniques = function (arr) {
        var a = [];
        for (var i = 0, l = arr.length; i < l; i++)
            if (a.indexOf(arr[i]) === -1 && arr[i] !== '')
                a.push(arr[i]);
        return a;
    };

    var validateFieldCreated = function(fields,projectId){
        var generationFields = fields.filter(function(field){
            return field.pmProjectId == projectId;
        });
        return generationFields.length === 0;
    };

    var pmGenerationProjectIdFilter = function(array,projectIds){
        return array.filter(function (field) {
            return !field.pmIsGenerated || Utilities.inArray(field.pmProjectId, projectIds);
        });
    };



    var verifyCreateMergeRequest = function (taskInfo, data) {
        return ((taskInfo.mergeRequest ||
                 taskInfo.mergeRequestStable) &&
                currentTaskStatus == 'CONCLUDE' &&
                taskInfo.typeRelationship != TYPE_RELATIONSHIP_MERGE_REQUEST
               ) &&
               ((data.dataset.changedFiles.length > 0 || commit.length > 0) ||
                taskInfo.typeRelationship == TYPE_RELATIONSHIP_REPLICATION ||
                taskInfo.typeRelationship == TYPE_RELATIONSHIP_CONFLICT_DEVOPS
               );
    };

    var validateGenerateMergeRequestTask = function(taskInfo) {
        var infoTaskWidget = getWidgetInfoTask();
        var taskId = infoTaskWidget.currentRow.ID.replace(/\D/g, '');
        if(infoTaskWidget.currentRow.DIRECTORIES_VALIDATION.IS_RELATED_TASK) {
            taskId = taskInfo.taskGenerator;
        }
        var filter = [ {
            "operator": "=",
            "name": "TASK",
            "value": taskId
        }, {
            "operator": "=",
            "name": "RESOURCE_T",
            "value": infoTaskWidget.currentRow.RESOURCE_T
        } ];

        return requestDataSourceEngine.getDataSource('/changedFilesCrud', filter).then(function(data) {
            return ProjectServiceList.findMergeRequestTasks([taskInfo.trueTaskId]).then(function(mergeTaskData){
                if(verifyCreateMergeRequest(taskInfo, data) && !mergeTaskData.dataset.findMergeRequestByTask.length) {
                    createMergeRequest = true;
                    return true;
                } else {
                    createMergeRequest = false;
                    return false;
                }
            });
        });
    };

    var pauseTestTaskAndValidateGenerateTask = function() {
        var oldCurrentStatus = currentTaskStatus;
        var directoriesValidation = getInfoTaskWidget().currentRow.DIRECTORIES_VALIDATION;
        saveAppropriation().then(function () {
            if (getWidgetInfoTask().currentRow.ALLOWENDTASK === 'N') {
                currentTaskStatus = 'PAUSE';
            } else {
                currentTaskStatus = oldCurrentStatus;
            }
            if (generateTask) {
                var widgetGenerate = getWidgetGenerateTask();
                generateTask = false;
                AppropriationService.saveMultipleTasks(getDataNewTaskToGenerateMultiple(widgetGenerate, directoriesValidation.PROJECTS, directoriesValidation.IS_RELATED_TASK))
                    .then(function () {
                    changeTaskStatus().then(function () {
                        ScreenService.closeSwipe(0);
                        getListTasksWidget().activate();
                        ScreenService.restoreDefaultLoadingMessage();
                    });
                }).catch(function (e) {
                    defaultError(e);
                    ScreenService.hideLoader();
                });
            } else {
                changeTaskStatus().then(function () {
                    ScreenService.closeSwipe(0);
                    getListTasksWidget().activate();
                    ScreenService.restoreDefaultLoadingMessage();
                });
            }
        });
    };

    var errorDoPauseProcess = function (e) {
        if (e.hasOwnProperty('message')) {
            defaultError(e.message);
        } else if (e.data.hasOwnProperty('error')) {
            defaultError(e.data.error);
        } else {
            defaultError();
        }
        ScreenService.restoreDefaultLoadingMessage();
    };

    this.commitCommentPopupActionEventBack = function(){
        ScreenService.closePopup(true);
        getInfoTaskWidget().activate();
    };

    this.commitCommentPopupActionEventCommit = function(){
        var widget = getWidgetCommitCommentPopup();
        if (widget.isValid()) {
            doCommitProcess();
        }
    };

    var openPopupCommitComment = function () {

        var widget = getWidgetCommitCommentPopup();
        var isCommit = commit.filter(function(commitFile){
            return stash.every(function(stashFile){
                return stashFile.DIR != commitFile.DIR;
            });
        }).filter(function(commitFile){
            return reset.every(function(resetFile){
                return resetFile.DIR != commitFile.DIR;
            });
        }).length > 0;
        var isStash = stash.length > 0;

        getFieldStashDescriptionFromWidgetCommitCommentPopup().isVisible = isStash;
        getFieldCommentFromWidgetCommitCommentPopup().isVisible = isCommit;
        widget.dataSource.data = [];
        widget.newRow();
        if(isCommit || isStash){
            ScreenService.openPopup(widget);
        }else{
            doCommitProcess();
        }
    };

    var doCommitProcess = function () {
        getTaskInfo().then(function (taskInfo) {
            execDoGitCommit(taskInfo);
        }).catch(errorDoPauseProcess);
    };

    /***************************************************************************
     * Pause a task, commit its files and saves its appropriation.
     ***************************************************************************/
    var doPauseProcess = function (task) {
        var row = buildProjectData();
        var infoTaskWidget = getWidgetInfoTask();
        var taskListWidget = getListTasksWidget();
        requestDataSourceEngine.setDataSource('/isMergeRequestProject', [row]).then(function (data) {
            ScreenService.showLoader();
            getTaskInfo().then(function (taskInfo) {
                if(taskListWidget.currentRow && taskListWidget.currentRow.USEGITAUTOMATICALLY != 'Y') {
                    ScreenService.hideLoader();
                    if(data.dataset.isMergeRequestProject == 'Y' && taskInfo.typeRelationship != 'M' && currentTaskStatus == 'CONCLUDE') {
                        openMergeRequestPopup(taskInfo);
                    } else {
                        pauseTestTaskAndValidateGenerateTask();
                    }
                } else if(taskInfo.typeRelationship === TYPE_RELATIONSHIP_TEST ||
                          infoTaskWidget.currentRow.EXTERNALTYPE === 'S' ||
                          infoTaskWidget.currentRow.CLASSIFICATION_CONTROL === CLASSIFICATION_SPECIFICATION) {
                    ScreenService.hideLoader();
                    pauseTestTaskAndValidateGenerateTask();
                } else {
                    validateGenerateMergeRequestTask(taskInfo).then(function(validationMR) {
                        if (validationMR) {
                            openMergeRequestPopup(taskInfo);
                        } else {
                            doGitPauseProcess(taskInfo, data.dataset.isMergeRequestProject[0]);
                        }
                    }).catch(errorDoPauseProcess);
                }
            }).catch(errorDoPauseProcess);
        });
        self.recalculateTaskProgress(task || infoTaskWidget.currentRow);
        return self.loadTaskFromDate(getTaskDate());
    };

    var doGitPauseProcess = function (taskInfo, isMergeRequestProject) {
        if (currentTaskStatus === 'CONCLUDE' && taskInfo.typeRelationship == TYPE_RELATIONSHIP_MERGE_REQUEST) {
            validatePlayConcludeMergeRequestTask().then(function (validateMR) {
                if (validateMR) {
                    execDoGitPause(taskInfo, isMergeRequestProject);
                } else {
                    ScreenService.hideLoader();
                    ScreenService.restoreDefaultLoadingMessage();
                    ScreenService.showMessage(Messages.ALE_NOT_CONC_MERGE_REQUEST_TASK);
                }
            }).catch(function (e) {
                if (typeof e === 'object' && e.connectionError) {
                    ScreenService.hideLoader();
                } else if (e.data.hasOwnProperty('error')) {
                    defaultError(e.data.error);
                }
                ScreenService.hideLoader();
                ScreenService.restoreDefaultLoadingMessage();
            });
        } else {
            execDoGitPause(taskInfo, isMergeRequestProject);
        }
    };

    var hideLoaderAndShowMessage = function (message) {
        ScreenService.hideLoader();
        ScreenService.closeSwipe();
        ScreenService.restoreDefaultLoadingMessage();
        if(message) {
            ScreenService.showMessage(message);
        }
    };

    var successGitPullAndCheckout = function(mergeMaster, finalBranchUpdate, paths, taskInfo, commitFailed, resetFailed, stashFailed, taskReplicationInfo) {
        if (currentTaskStatus === 'CONCLUDE' && mergeMaster && !AppropriationService.isTagMainBranch() && !getInfoTaskWidget().currentRow.ORIGIN_PRODUCT_VERSION_ID_DEV) {
            taskInfo.mergeGeneratedByReplication = getInfoTaskWidget().currentRow.MR_GENERATED_BY_REPLICATION;
            return AppropriationService.mergeMaster(finalBranchUpdate, getUnchangedTaskPaths(), factoryCloneRepositoryInServerPromise(paths), taskInfo, localStorageEngine.getLocalVar('login')).then(function () {
                GitQueue.loginBrowser(localStorageEngine.getLocalVar('login'));
                finishAppropriation(commitFailed, resetFailed, stashFailed, finalBranchUpdate || taskInfo.branchName, taskInfo, taskReplicationInfo);
            }).catch(function (e) {
                getBackActionFromLogWidget().isVisible = true;
                GitQueue.loginBrowser(localStorageEngine.getLocalVar('login'));
                getInfoTaskWidget().reload();
                if(!e || !e.connectionError) {
                    updateLogFilePause().then(function() {
                        hideLoaderAndShowMessage(Messages.ERR_MERGE_MASTER);
                    });
                } else {
                    ScreenService.showMessage(Messages.ALE_PROJECT_SERV_DISC_MERGE_MASTER);
                    AppropriationService.checkoutBranchInRepositories(getUnchangedTaskPaths(), taskInfo.branchName).then(function() {
                        updateLogFilePause().then(function() {
                            hideLoaderAndShowMessage();
                        });
                    }).catch(function() {
                        updateLogFilePause().then(function() {
                            hideLoaderAndShowMessage();
                        });
                    });
                }
            });
        } else {
            finishAppropriation(commitFailed, resetFailed, stashFailed, finalBranchUpdate || taskInfo.branchName, taskInfo, taskReplicationInfo);
        }
    };

    var errorGitPullAndCheckout = function(e, paths) {
        AppropriationService.gitModifiedFiles(factoryRepositoryPromise(paths))
            .then(function (directoriesStatus) {
                AppropriationService.saveMasterFiles(directoriesStatus, getCurrentTaskId(), paths)
                    .then(function () {
                        if (hasConflictException(e))
                            callConflictMessage();
                        else
                            callGenericErrorMessage(e);
                    })
                    .catch(function (e) {
                        if (hasConflictException(e))
                            callConflictMessage();
                        else
                            callGenericErrorMessage(e);
                    });
            })
            .catch(function (e) {
                if (hasConflictException(e))
                    callConflictMessage();
                else
                    callGenericErrorMessage(e);
            });
    };

    var defaultErrorPause = function (e) {
        getBackActionFromLogWidget().isVisible = true;
        updateLogFilePause(pauseFiles.commit === undefined).then(function() {
            if(typeof e === 'string') {
                defaultError(e);
            } else if (e.hasOwnProperty('message')) {
                defaultError(e.message);
            } else if (e.data.hasOwnProperty('error')) {
                defaultError(e.data.error);
            }
        });
    };

    var execDoGitCommit = function(taskInfo) {
        var paths = getInfoTaskWidget().currentRow.PATHS;
        var finalBranchUpdate = false;
        var pauseFiles = {};

        validateConcludeTaskByAllocation().then(function(validateAllocations) {
            if(validateAllocations.IS_VALID) {
                var logWidget = getLogWidget();
                var backAction = getBackActionFromLogWidget();
                ScreenService.hideLoader();
                backAction.isVisible = false;
                logWidget.newRow();
                ScreenService.openPopup(logWidget);
                Utilities.validateExecuteInWindows().then(function (isWindows) {
                    paths.forEach(function (path) {
                        path.dir = isWindows ? path.LOCAL_DIRECTORY : path.LINUX_DIRECTORY;
                    });
                    Utilities.localVar.setTaskPaths(Utilities.clone(paths));
                    AppropriationService.validateCurrentBranch(paths, taskInfo).then(function (dirValidations) {
                        if (dirValidations.length > 0) {
                            updateLogFilePause(true).then(function () {
                                var directories = dirValidations.map(function (dir) {
                                    return dir.dir;
                                }).join('"<br/>"');
                                var message = Messages.ALE_DIRECTORIES_NOT_IN_TASK_BRANCH.replace('%1', taskInfo.branchName)
                                    .replace('%2', '"' + directories + '"');
                                ScreenService.closePopup(true);
                                getInfoTaskWidget().activate();
                                ScreenService.showMessage(message, 'INFORMATION');
                            });
                        } else {
                            pauseFiles.commit = commit;
                            pauseFiles.reset = reset;
                            pauseFiles.stash = stash;

                            AppropriationService.gitPause(taskInfo, factoryCommitPromise, factoryResetPromise, factoryStashPromise,
                                    factoryRepositoryPromise(paths), finalBranchUpdate).then(function () {
                                    saveChangedFiles().then(function () {
                                        AppropriationService.gitPull(taskInfo, factoryCommitPromise).then(function(){
                                            ScreenService.closePopup(true);
                                            getInfoTaskWidget().activate();
                                            updateLogFilePause(false,true);
                                        }).catch(function (e) {
                                                backAction.isVisible = true;
                                                updateLogFilePause().then(function () {
                                                    ScreenService.closeSwipe();
                                                    errorGitPullAndCheckout(e, paths);
                                                });
                                            });
                                    }).catch(defaultErrorPause);
                                }).catch(function (e) {
                                    backAction.isVisible = true;
                                    updateLogFilePause().then(function () {
                                        ScreenService.closeSwipe();
                                        validatePauseErros(e);
                                    });
                                });
                        }
                    }).catch(defaultErrorPause);
                });
            } else {
                var resourceNames = [];
                validateAllocations.ALLOCATIONS.forEach(function(allocation) {
                    resourceNames.push('"' + allocation.RESOURCE_NAME + '"');
                });

                resourceNames = resourceNames.join(', ');
                ScreenService.restoreDefaultLoadingMessage();
                ScreenService.hideLoader();
                ScreenService.showMessage(Messages.ALE_NOT_CONCLUDED_TASK_ALOCATIONS.replace('%1', resourceNames));
            }
        }).catch(function (e) {
            if (e.hasOwnProperty('message')) {
                defaultError(e.message);
            } else if (e.data.hasOwnProperty('error')) {
                defaultError(e.data.error);
            }
            ScreenService.restoreDefaultLoadingMessage();
        });
    };

    var execDoGitPause = function(taskInfo, isMergeRequestProject) {
        var paths = getInfoTaskWidget().currentRow.PATHS;
        var commitFailed = false;
        var resetFailed = false;
        var stashFailed = false;
        var finalBranchName = false;
        var mergeMaster = false;
        var pauseFiles = {};

        validateConcludeTaskByAllocation().then(function(validateAllocations) {
            if(validateAllocations.IS_VALID) {
                if (currentTaskStatus === 'CONCLUDE' &&
                    (isMergeRequestProject === 'N' && !taskInfo.errorFixTask) ||
                    (taskInfo.typeRelationship == TYPE_RELATIONSHIP_MERGE_REQUEST && !taskInfo.mergeRequestStable) ||
                    (taskInfo.typeRelationship == TYPE_RELATIONSHIP_REPLICATION)
                ) {
                    mergeMaster = true;
                }
                if (currentTaskStatus === 'CONCLUDE' &&
                    (isMergeRequestProject === 'N' ||
                    taskInfo.typeRelationship == TYPE_RELATIONSHIP_MERGE_REQUEST ||
                    (taskInfo.typeRelationship == TYPE_RELATIONSHIP_REPLICATION))) {
                    finalBranchName = taskInfo.finalBranchName;
                }
                var finalBranchUpdate = finalBranchName;

                var logWidget = getLogWidget();
                var backAction = getBackActionFromLogWidget();
                ScreenService.hideLoader();
                backAction.isVisible = false;
                logWidget.newRow();
                ScreenService.openPopup(logWidget);
                Utilities.validateExecuteInWindows().then(function (isWindows) {
                    paths.forEach(function (path) {
                        path.dir = isWindows ? path.LOCAL_DIRECTORY : path.LINUX_DIRECTORY;
                    });
                    Utilities.localVar.setTaskPaths(Utilities.clone(paths));
                    AppropriationService.validateCurrentBranch(paths, taskInfo).then(function (dirValidations) {
                        if (dirValidations.length > 0) {
                            updateLogFilePause(true).then(function () {
                                var directories = dirValidations.map(function (dir) {
                                    return dir.dir;
                                }).join('"<br/>"');
                                var message = Messages.ALE_DIRECTORIES_NOT_IN_TASK_BRANCH.replace('%1', taskInfo.branchName)
                                    .replace('%2', '"' + directories + '"');
                                ScreenService.closePopup(true);
                                ScreenService.showMessage(message, 'INFORMATION');
                                getNewAppropriationWidget().activate();
                            }).catch();
                        } else {
                            pauseFiles.commit = commit;
                            pauseFiles.reset = reset;
                            pauseFiles.stash = stash;

                            AppropriationService.gitPause(taskInfo, factoryCommitPromise, factoryResetPromise, factoryStashPromise,
                                factoryRepositoryPromise(paths), finalBranchUpdate).then(function () {
                                    saveChangedFiles().then(function () {
                                        AppropriationService.gitPullAndCheckout(taskInfo, factoryCommitPromise, factoryResetPromise, factoryStashPromise,
                                            factoryRepositoryPromise(paths), finalBranchUpdate, currentTaskStatus, commit).then(function (taskReplicationInfo) {
                                                successGitPullAndCheckout(mergeMaster, finalBranchUpdate, paths, taskInfo, commitFailed, resetFailed, stashFailed, taskReplicationInfo);
                                            }).catch(function (e) {
                                                backAction.isVisible = true;
                                                updateLogFilePause().then(function () {
                                                    ScreenService.closeSwipe();
                                                    errorGitPullAndCheckout(e, paths);
                                                });
                                            });
                                    }).catch(defaultErrorPause);
                                }).catch(function (e) {
                                    backAction.isVisible = true;
                                    updateLogFilePause().then(function () {
                                        ScreenService.closeSwipe();
                                        validatePauseErros(e);
                                    });
                                });
                        }
                    }).catch(defaultErrorPause);
                });
            } else {
                var resourceNames = [];
                validateAllocations.ALLOCATIONS.forEach(function(allocation) {
                    resourceNames.push('"' + allocation.RESOURCE_NAME + '"');
                });

                resourceNames = resourceNames.join(', ');
                ScreenService.restoreDefaultLoadingMessage();
                ScreenService.hideLoader();
                ScreenService.showMessage(Messages.ALE_NOT_CONCLUDED_TASK_ALOCATIONS.replace('%1', resourceNames));
            }
        }).catch(function (e) {
            if (e.hasOwnProperty('message')) {
                defaultError(e.message);
            } else if (e.data.hasOwnProperty('error')) {
                defaultError(e.data.error);
            }
            ScreenService.restoreDefaultLoadingMessage();
        });
    };

    var showErrorPullMainBranch = function(error) {
        cleanWindowAndActivateListTasksWidget();
        if(error.data.includes('CONFLICT') || error.data.includes('CONFLITO')) {
            ScreenService.showMessage(Messages.ALE_CONFLICT_UPDATE_MAIN_BRANCH.replace('%1', error.branch));
        } else {
            ScreenService.showMessage(Messages.ALE_ERROR_UPDATE_MAIN_BRANCH.replace('%1', error.branch));
        }
    };

    var validateConcludeTaskByAllocation = function() {
        var validate = {
            IS_VALID: true,
            ALLOCATIONS: false
        };

        var filter = [{
            "operator": "=",
            "name": "TASK",
            "value": getCurrentTaskId()
        }, {
            "operator": "=",
            "name": "RESOURCE",
            "value": getInfoTaskWidget().currentRow.RESOURCE_T
        }];
        return requestDataSourceEngine.getDataSource('/findStartedAllocationsByTask', filter).then(function (data) {
            var allocations = data.dataset.startedAllocationsByTask;
            if(allocations.length > 0 && currentTaskStatus === 'CONCLUDE') {
                validate.IS_VALID = false;
                validate.ALLOCATIONS = allocations;
            }

            return validate;
        });
    };

    var hasConflictException = function(e){
        var hasConflict = false;
        if(Array.isArray(e)){
            hasConflict = e.some(function(exception){
                return /.*CONFLICT.*/.test(exception.data);
            });
        } else if(typeof e == "object") {
            hasConflict = /.*CONFLICT.*/.test(e.data);
        }

        return hasConflict;
    };

    var callGenericErrorMessage = function(e) {
        var message = '';
        if(Array.isArray(e) && e.length == 1){
            message = e[0].data;
        } else if (e.hasOwnProperty('message')) {
            message  = e.message;
        } else if (e.hasOwnProperty('data')) {
            if(e.data.hasOwnProperty('error'))
                message = e.data.error;
            else
                message = e.data.replace("Command failed: ", "").replace("error: ");
        }

        defaultError(message);
    };

    var callConflictMessage = function (openNewTask) {
        var widget = getInfoTaskWidget();
        var gitPopupWidget = getGitPopupWidget();
        gitPopupWidget.label = 'Arquivos modificados por outros usuários';
        gitPopupWidget.showCheckbox = false;
        ScreenService.hideLoader();
        ScreenService.restoreDefaultLoadingMessage();
        if (currentTaskStatus !== 'START' && !openNewTask) {
            ScreenService.closeSwipe();
        }
        filesWithStatus = [];
        currentTaskStatus = 'STATUS';
        self.gitStatus(widget);
        ScreenService.showMessage(Messages.ERR_CONFLICT);
    };

    var validatePauseErros = function (error) {
        var commitFailed = false;
        var resetFailed = false;
        var stashFailed = false;
        var addFailed = false;
        error.forEach(function (gitError) {
            if (gitError.action === 'add') {
                addFailed = true;
                commitFailed = true;
            }
            if (gitError.action === 'commit') {
                commitFailed = true;
            }
            if (gitError.action === 'reset') {
                resetFailed = true;
            }
            if (gitError.action === 'stash') {
                stashFailed = true;
            }
            validateErrors(addFailed, commitFailed, resetFailed, stashFailed);
        });
        ScreenService.hideLoader();
        ScreenService.restoreDefaultLoadingMessage();
        currentTaskStatus = '';
        ScreenService.closeSwipe();
        filesWithStatus = [];
    };





    this.newAppropriationActionEventSave = function(args){

       saveAppropriationAndCommit(args.owner.widget, args.owner.widget.parent);
    };

    this.createTaskWidgetOnEnter = function(args){
        // getWidgetCreateNewTask().reload();

         if(!getWidgetCreateNewTask().currentRow.ISSUES){
             var issuesCurrent = [];

            AppropriationService.getTaskIssue(localStorageEngine.getLocalVar('taskId')).then(function (result) {
                        result.forEach(function (issue) {
                            issuesCurrent.push(issue.ID);
                        });
                        getFieldIssuesFromWidgetCreateTaskIssue().value(issuesCurrent);
                        getFieldIssuesFromWidgetCreateTaskIssue().reload();

                        var fieldClassificationName = getClassificationNameWidgetCreateTask();
                        fieldClassificationName.readOnly = true;
                        getWidgetCreateNewTask().currentRow.CLASSIFICATION = result[0].ISSUE_CLASSIFICATION_ID;
                        getWidgetCreateNewTask().currentRow.CLASSIFICATION_NAME = result[0].ISSUE_CLASSIFICATION;
                        getWidgetCreateNewTask().currentRow.changed = true;
                      //  Utilities.setOutData(fieldClassificationName, result[0].ISSUE_CLASSIFICATION_ID);


            });


        }
    };



    this.pmGenerationProjectIdFilter = function(array,projectIds){
        return array.filter(function (field) {
            return !field.pmIsGeneration || Utilities.inArray(field.pmProjectId, projectIds);
        });
    };


    this.createTaskIssueActionEventCreate = function() {
        var widget = getWidgetCreateNewTask();
        var createTasksByIssues = function () {
            var row = Utilities.getWidgetCurrentRowAsChanged(getWidgetCreateNewTask());
            var issueVersionDev = widget.issueVersionDev;
            var projectVersionDev = widget.projectVersionDev;
            row.ALL_VERSION_DEV_ID = issueVersionDev ? issueVersionDev.PRODUCT_VERSION_ID_DEV : projectVersionDev ? projectVersionDev.productVersionId : null;
            row.ALL_VERSION_DEV = issueVersionDev ? issueVersionDev.VERSION_DEV : projectVersionDev ? projectVersionDev.productVersionLabel : null;
            row.PROJECT_PRODUCT_ISSUE_ID = row.ALL_VERSION_DEV ? widget.projectProductIssueId : null;

            var checkedRows = getFieldAllProjectsFromWidgetCreateTaskIssue().dataSource.getCheckedRows();
            var projectMsg = '';

            var data = checkedRows.filter(function (row) {
                return row.EXTERNALTYPE == 'B' && row.CONTROL == 'D';
            }).map(function(row){
                projectMsg += '<li>' + row.ID + ' - ' + row.NAME + '</li>';
                return {ID: row.ID, NAME: row.NAME};
            });

            var msg = Utilities.messages.ALE_PROJECT_IN_PROGRESS_BY_BOARD_ISSUE.replace('%1', projectMsg);

            if(data.length) {
                ScreenService.confirmMessage(msg, 'question', function(){
                    IssueService.saveCreateTasksByIssues([row]).then(function () {

                        ScreenService.closePopup(true);
                        self.infoTaskActionEventStop();
                      //  Utilities.clearCheckedRowsAndReload(tabbedBoardIssueWidget.currentWidget);
                    }).catch(function (response) {
                        Utilities.showMessageErrorOfBackEnd(response, null, null, true);
                    });
                });
            } else {
                IssueService.saveCreateTasksByIssues([row]).then(function () {

                    ScreenService.closePopup(true);
                    self.infoTaskActionEventStop();
                  //  Utilities.clearCheckedRowsAndReload(tabbedBoardIssueWidget.currentWidget);
                }).catch(function (response) {
                    Utilities.showMessageErrorOfBackEnd(response, null, null, true);
                });
            }



        };

        if(widget.isValid()){

            if (!Util.isBlank(widget.projectsWithoutVersion) || !Util.isBlank(widget.issuesWithoutVersion)) {
                ScreenService.confirmMessage(createMsgProjectIssueWithoutVersion(), 'question', function () {
                    createTasksByIssues();
                });
            } else {
                createTasksByIssues();
            }
        }
    };


     this.createTaskIssueFieldOnChangeAllProjects = function () {
        getClassificationNameWidgetCreateTask().reload();
        var widget = getWidgetCreateNewTask();
       // getWidgetCreateNewTask().activate();
        var fields = widget.fields;
        var allProjectsField = getFieldAllProjectsFromWidgetCreateTaskIssue();
        var allProjectsForTask = allProjectsField.value();
        var issuesInfo = getFieldIssuesFromWidgetCreateTaskIssue().dataSource.data;


        ScreenService.showLoader();
        TaskService.getProjectsInfoCreateTasksByIssue(allProjectsForTask).then(function (dataset) {
            ScreenService.hideLoader();
            if (IssueService.validateDevVersionBetweenProjectAndIssue(issuesInfo, dataset, widget)) {
                allProjectsForTask.forEach(function (projectId) {
                    if (validateFieldCreated(fields, projectId)) {
                        localStorageEngine.setLocalVar('PROJECT_ID', projectId);
                        var projectNameField = self.getProjectNameField(projectId, widget);
                        var versionDevField = self.getVersionDevField(projectId, widget);
                        var projectTypeNameField = self.getProjectTypeNameField(projectId, widget);
                        var taskTypeNameField = self.getTaskTypeNameField(projectId, widget);
                        var estimatedTime = self.getEstimatedTimeField(projectId, widget);
                        var parentNameField = self.getParentNameField(projectId, widget);
                        var resourceField = self.getResourceField(projectId, widget);
                        var descriptionAciton = self.getDesciptionAction(projectId, widget);
                        var removeField = self.getTrashRemoveField(projectId, widget);
                        fields.push(projectTypeNameField);
                        fields.push(versionDevField);
                        fields.push(taskTypeNameField);
                        fields.push(estimatedTime);
                        fields.push(parentNameField);
                        fields.push(resourceField);
                        fields.push(descriptionAciton);
                        fields.push(removeField);
                        versionDevField.reload();
                        projectNameField.value(Utilities.getDescriptionFieldByPrimaryValue(allProjectsField, projectId));
                        projectTypeNameField.label = 'Tipo - ' + Utilities.getRowInDataSource(allProjectsField.dataSource, allProjectsField.valueField, projectId)[allProjectsField.projectTypeName];
                        projectTypeNameField.value(projectNameField.value());
                        setOperationsFieldVersionDev(widget, dataset, projectId, versionDevField);
                    }
                });
                widget.fields = self.pmGenerationProjectIdFilter(fields, allProjectsForTask);
                widget.selectedProjectsInfo = dataset;
                widget.selectedIsuuesInfo = issuesInfo;
            } else {
                removeAllFieldsPmGeneration(getWidgetCreateNewTask());
            }
        }).catch(ScreenService.hideLoader);
    };

     var setOperationsFieldVersionDev = function (widget, dataset, projectId, versionDevField) {
        widget.currentRow['PRODUCT_VERSION_DEV_ID_' + projectId] = dataset[projectId].productVersionId;
        widget.currentRow['VERSION_DEV_' + projectId] = dataset[projectId].productVersionId ? dataset[projectId].productVersionLabel: 'Última versão';
        if(dataset[projectId].projectStatusControl === 'D' || dataset[projectId].isTasksNotIsParent){
            versionDevField.readOnly = true;
        } else {
            versionDevField.readOnly = false;
        }
    };

    /***************************************************************************
     * Saves appropriation and commit changed files.
     ***************************************************************************/
    var saveAppropriationAndCommit = function (widget, widgetTimeActivity) {
        widget.oldDescriptionFieldAppropriation = widget.currentRow.DESCRIPTION || '';
        if(currentTaskStatus === 'PAUSE') {
            ScreenService.changeLoadingMessage(Messages.LOAD_PAUSING_TASK);
        } else if(currentTaskStatus === 'CONCLUDE') {
            ScreenService.changeLoadingMessage(Messages.LOAD_ENDING_TASK);
        }

        ScreenService.showLoader();

        if (!widget.isValid()) {
            ScreenService.showMessage(Messages.ERR_REQUIRED_FIELDS);
            ScreenService.hideLoader();
        } else {
            if (validateConcludeTask(widget)) {
                var task = getListTasksWidget().currentRow;
                if (localStorageEngine.getLocalVar('CALL_APPR_WIDG_BY_TIME_BY_ACT')) {
                    saveOnlyAppropriation(task.ID, getNewAppropriationWidget().currentRow.PERCENT_COMPLETED);
                } else {
                    var infoTaskWidget = getInfoTaskWidget();
                    if(generateTask && infoTaskWidget.currentRow.TYPE_RELATIONSHIP == TYPE_RELATIONSHIP_MERGE_REQUEST) {
                        var newAppropriation = getNewAppropriationWidget();
                        if(newAppropriation.currentRow.PERCENT_COMPLETED == 100) {
                            newAppropriation.currentRow.PERCENT_COMPLETED = 98;
                        }
                        currentTaskStatus = "PAUSE";
                    }
                    doPauseProcess(task);
                    ScreenService.hideLoader();
                }
            } else {
                ScreenService.showMessage(Messages.ALE_WRONG_APPROPRIATION);
                ScreenService.hideLoader();
                ScreenService.restoreDefaultLoadingMessage();
            }
        }
    };

    this.calculatePeriodByEndHour = function (row) {
        if (row.BEGIN_HOUR !== '') {
            var data = Utilities.calculateTotalTime(row.BEGIN_HOUR, row.END_HOUR);
            row.TOTAL = data.period;
            if (data.hour !== null) {
                row.END_HOUR = data.hour;
                row.BEGIN_HOUR = data.hour;
            }
        } else {
            if (row.TOTAL !== '') {
                row.BEGIN_HOUR = Utilities.calculateBeginTime(row.END_HOUR, row.TOTAL);
            }
        }
        getNewAppropriationWidget().activate();
    };

    this.calculatePeriodByTotal = function (row) {
        if (row.BEGIN_HOUR !== '') {
            row.END_HOUR = Utilities.calculateEndTime(row.BEGIN_HOUR, row.TOTAL);
        } else {
            if (row.END_HOUR !== '') {
                row.BEGIN_HOUR = Utilities.calculateBeginTime(row.END_HOUR, row.TOTAL);
            }
        }

    };

    /* @from: event, OnFieldChange
     * @field: BEGIN_HOUR
     * @description: calculates the value of END_HOUR field from BEGIN_HOUR and
     * TOTAL fields.
     */
    this.calculatePeriodByBeginHour = function (row) {
        var timePlanning = templateManager.container.getWidget('INFO_TASK').currentRow.USE_TIME_PLANNING;
        if (row.TOTAL !== '') {
            if (timePlanning === 'Y') { // if current task has time planning
                row.END_HOUR = Utilities.calculateEndTime(row.BEGIN_HOUR, row.TOTAL);
            } // otherwise, keep END_HOUR as null
        } else {
            if (row.END_HOUR !== '') {
                row.TOTAL = Utilities.calculateTotalTime(row.BEGIN_HOUR, row.END_HOUR);
            }
        }
        getNewAppropriationWidget().activate();
    };

    var getInfoTaskWidget = function () {
        return templateManager.container.getWidget('INFO_TASK');
    };

    var validateTwoStartedTasks = function (openNewTask,trueTaskId) {
        var defer = ZHPromise.defer();
        if (openNewTask) {
            defer.resolve();
        } else {
            var filter = [{
                "operator": "=",
                "name": "TASK",
                "value": trueTaskId
            }];
            requestDataSourceEngine.getDataSource('/resourceTasks',filter).then(function (data) {
                var tasks = data.dataset.resourceTasks;
                if (tasks.length > 0) {
                    defer.reject(tasks);
                } else {
                    defer.resolve();
                }
            }).catch(function () {
                ScreenService.showMessage();
                defer.reject();
            });
        }

        return defer.promise;
    };

    var showErrorRepository = function (message) {
        messageErrorRepository(message);
        ScreenService.restoreDefaultLoadingMessage();
        ScreenService.hideLoader();
        ScreenService.hideLoader();
    };

    var validateRepositoryOnlyProject = function (paths) {
        var result = true;
        if (paths.length > 0) {
            for (var key in paths) {
                if (paths[key].dir === null && paths[key].repository !== null) {
                    var repository = paths[key].repository;
                    var messageError = 'O repositório ' + repository;
                    if (paths[key].isWindows) {
                        messageError += Utilities.messages.ERR_DIRECTORY_WINDOWS;
                    } else {
                        messageError += Utilities.messages.ERR_DIRECTORY_NOT_WINDOWS;
                    }
                    showErrorRepository(messageError);
                    result = false;
                    break;
                } else if (paths[key].repository === null && paths[key].dir === null) {
                    showErrorRepository(Utilities.messages.ERR_REPOSITORY);
                    result = false;
                    break;
                }
            }
        } else {
            showErrorRepository(Utilities.messages.ERR_REPOSITORY);
            result = false;
        }
        return result;
    };

    var validateRepositoryMultipleProjects = function (directoriesValidation, isWindows) {
        var result = true;
        var projects = [];
        directoriesValidation.PROJECTS.forEach(function (project) {
            if (isWindows && project.COUNT_LOCAL_DIRECTORY == '0') {
                projects.push(project.PROJECT_NAME);
            } else if (!isWindows && project.COUNT_LINUX_DIRECTORY == '0') {
                projects.push(project.PROJECT_NAME);
            }
        });

        if(projects.length > 0) {
            var message = Utilities.messages.ERR_REPOSITORY_MULT_PROJECTS_LINUX;
            if(isWindows) {
                message = Utilities.messages.ERR_REPOSITORY_MULT_PROJECTS_WINDOWS;
            }
            var projectsMessage = '<strong>' + projects.join('", "') + '</strong>';
            showErrorRepository(message.replace('%1', projectsMessage));
            result = false;
        }
        return result;
    };

    var validateRepositoryAndDirectory = function (paths, directoriesValidation, isWindows) {
        var result = true;
        if(directoriesValidation && directoriesValidation.IS_RELATED_TASK) {
            result = validateRepositoryMultipleProjects(directoriesValidation, isWindows);
        } else {
            result = validateRepositoryOnlyProject(paths);
        }
        return result;
    };

    var messageErrorRepository = function(message){
        message += Utilities.messages.ERR_REPOSITORY_CONFIRMATION;
        ScreenService.showCustomDialog(message, 'CONFIRMATION', null,
            [
                {
                    "label": "Sim",
                    "code": function () {
                        localStorage.setItem('openLocalConnection', true);
                        var userDataMenu = templateManager.project.getMenu('userData');
                        var args = { owner: {
                            msContainerName: userDataMenu.msContainerName,
                            url: userDataMenu.url
                        } };
                        LibUtilities.openMicroServiceUrl(args);
                    }
                },
                {
                    "label": "Não",
                    "code": function () {}
                }
            ]
        );
    };

    var getCurrentTaskName = function () {
        return templateManager.container.getWidget('INFO_TASK').currentRow.TASK_NAME;
    };

    var getCurrentTaskId = function () {
        return templateManager.container.getWidget('INFO_TASK').currentRow.TASK_ID.replace(/\D/g, '');
    };

    var setCurrentTaskId = function (taskId) {
         templateManager.container.getWidget('INFO_TASK').currentRow.TASK_ID = taskId;
    };

    function createFinalBranchName() {
        var taskName = getCurrentTaskName();
        var taskId   = getCurrentTaskId();
        taskName = Utilities.transliterateString(taskName);
        taskName = taskName.replace(/(\r\n|\n|\r)/gm, "_").replace(/\W/g, "_").replace(/[_]+/g, '_');
        return 'TASK_' + taskId + '_' + taskName;
    }

    function createBranchName() {
        var taskName = getCurrentTaskName();
        var taskId   = getCurrentTaskId();
        taskName = Utilities.transliterateString(taskName);
        taskName = taskName.replace(/(\r\n|\n|\r)/gm, "_").replace(/\W/g, "_").replace(/[_]+/g, '_');
        return 'TASK_BKP_' + taskId + '_' + taskName;
    }

    var factoryCloneRepositoryInServerPromise = function (paths) {
        var serverPath = ProjectManagementConfig.serverPathMergeMaster;
        return function () {
            var newPaths = paths;
            var userId = localStorageEngine.getLocalVar('idBusinessPartner');
            newPaths.forEach(function (path) {
                var strReplace = 'c:\\';
                if(path.dir.toLowerCase().indexOf('c:/') != -1) {
                    strReplace = 'c:/';
                }

                path.dir = serverPath + '/' + userId + '/' + path.dir.toLowerCase().replace(strReplace, '').replace(/\\/g, '/');
            });
            var defer = ZHPromise.defer();
            defer.resolve(newPaths);
            return defer.promise;
        };
    };

    var factoryRepositoryPromise = function (paths) {
        return function () {
            var defer = ZHPromise.defer();
            defer.resolve(paths);
            return defer.promise;
        };
    };

    function showActionsByTaskStatus(widget, statusName, canStart) {
        var filterRelationship = [{
            "operator": "=",
            "name": "TASK_RELATIONSHIP",
            "value": getCurrentTaskId()
        }, {
            "operator": "IN",
            "name": "TYPE",
            "value": Messages.TYPE_GENERATED_TASK_WITHOUT_ORIGIN_AND_RELATED
        }];
        if(getInfoTaskWidget().isActive() || getListTasksWidget().isActive()) {
            ScreenService.showLoader();
        }
        return requestDataSourceEngine.getDataSource('/generatedTaskRelationship', filterRelationship).then(function (data) {
            if(getInfoTaskWidget().isActive() || getListTasksWidget().isActive()) {
                ScreenService.hideLoader();
            }
            var typeRelationship = false;
            if (data.dataset.generatedTaskRelationship.length > 0) {
                typeRelationship = data.dataset.generatedTaskRelationship[0].TYPE;
            }

            var pauseAction = widget.getAction(GIT.PAUSE);
            var playAction = widget.getAction(GIT.PLAY);
            var stopAction = widget.getAction(GIT.STOP);
            var stashApplyAction = widget.getAction('stash_apply');
            var mergeRequestAction = widget.getAction('diff_merge_request');
            var generateTaskAction = widget.getAction('generate_task');
            var statusAction = widget.getAction('search');
            var logAction = widget.getAction('log');

            if (canStart === 'N') {
                playAction.isVisible = false;
                pauseAction.isVisible = false;
                stopAction.isVisible = false;
                mergeRequestAction.isVisible = false;
                generateTaskAction.isVisible = false;
                statusAction.isVisible = false;
                logAction.isVisible = false;
            } else {
                switch (statusName) {
                    case TASK_STATUS.EM_DESENVOLVIMENTO:
                        playAction.isVisible = false;
                        pauseAction.isVisible = true;
                        stopAction.isVisible = true;
                        stashApplyAction.isVisible = true;
                        statusAction.isVisible = true;
                        logAction.isVisible = true;
                        break;
                    case TASK_STATUS.PAUSADA:
                        playAction.isVisible = true;
                        stopAction.isVisible = false;
                        pauseAction.isVisible = false;
                        stashApplyAction.isVisible = false;
                        statusAction.isVisible = true;
                        logAction.isVisible = true;
                        break;
                    case TASK_STATUS.CONCLUIDA:
                        playAction.isVisible = false;
                        pauseAction.isVisible = false;
                        stopAction.isVisible = false;
                        stashApplyAction.isVisible = false;
                        break;
                    default:
                        playAction.isVisible = true;
                        pauseAction.isVisible = false;
                        stopAction.isVisible = false;
                        stashApplyAction.isVisible = false;
                        statusAction.isVisible = true;
                        logAction.isVisible = true;
                        break;
                }

                if (typeRelationship == TYPE_RELATIONSHIP_TEST) {
                    mergeRequestAction.isVisible = false;
                    generateTaskAction.isVisible = statusName == TASK_STATUS.EM_DESENVOLVIMENTO;

                } else if (typeRelationship == TYPE_RELATIONSHIP_MERGE_REQUEST) {
                    mergeRequestAction.isVisible = typeRelationship == TYPE_RELATIONSHIP_MERGE_REQUEST;
                    generateTaskAction.isVisible = true;
                } else {
                    mergeRequestAction.isVisible = false;
                    generateTaskAction.isVisible = false;
                }

                if(widget.currentRow.IN_HOMOLOGATION == 'Y'){
                    stopAction.isVisible = false;
                }

                if(widget.currentRow.EXTERNALTYPE === 'S' ||
                    widget.currentRow.CLASSIFICATION_CONTROL === CLASSIFICATION_SPECIFICATION ||
                    typeRelationship == TYPE_RELATIONSHIP_TEST) {
                    statusAction.isVisible = false;
                    logAction.isVisible = false;
                    stashApplyAction.isVisible = false;
                }

                return typeRelationship;
            }
        }).catch(function (e) {
            if (e.data.hasOwnProperty('error')) {
                defaultError(e.data.error);
            }
        });
    }

    var getTaskDate = function () {
        return templateManager.container.getWidget('STRIPE_NAVIGATOR').currentRow.ESTIMATED_BEGIN_DATE;
    };

    var defaultError = function (error) {
        ScreenService.hideLoader();
        ScreenService.hideLoader();
        ScreenService.restoreDefaultLoadingMessage();
        if(error) {
            if(typeof error == 'object') {
                ScreenService.showMessage('Ocorreu um erro inesperado.<br/>"' + error.data + '"'+"<br/><strong>Para mais informações, verifique o log.</strong>");
            } else {
                ScreenService.showMessage('Ocorreu um erro inesperado.<br/>"' + error + '"'+"<br/><strong>Para mais informações, verifique o log.</strong>");
            }
        } else {
            ScreenService.showMessage('Ocorreu um erro inesperado.<br/><strong>Para mais informações, verifique o log.</strong>');
        }
    };

    var getTaskInfo = function () {
        var filterRelationship = [{
            "operator": "=",
            "name": "TASK_RELATIONSHIP",
            "value": getCurrentTaskId()
        }, {
            "operator": "IN",
            "name": "TYPE",
            "value": Messages.TYPE_GENERATED_TASK_WITHOUT_ORIGIN
        }];
        return requestDataSourceEngine.getDataSource('/generatedTaskRelationship', filterRelationship).then(function (data) {
            var taskInfo = {
                oldBranchName: "INEXISTENT_BRANCH"
            };
            taskInfo.trueTaskId = getCurrentTaskId();

            if (data.dataset.generatedTaskRelationship.length > 0) {
                taskInfo.taskGenerator = data.dataset.generatedTaskRelationship[0].TASK;
                taskInfo.typeRelationship = data.dataset.generatedTaskRelationship[0].TYPE;
            } else {
                taskInfo.taskGenerator = getCurrentTaskId();
                taskInfo.typeRelationship = null;
            }

            data.dataset.generatedTaskRelationship.forEach(function(relationship) {
                if(relationship.TYPE == TYPE_RELATIONSHIP_MERGE_REQUEST) {
                    taskInfo.taskGenerator = relationship.TASK;
                    taskInfo.typeRelationship = relationship.TYPE;
                }
            });

            var branchInfo = getInfoTaskWidget().currentRow.BRANCH_INFO;
            var branchName = null;

            if(branchInfo) {
                branchName = branchInfo.BRANCH_NAME;
                taskInfo.taskGenerator = branchInfo.BRANCH_TASK;
            }

            if (branchName) {
                if (taskInfo.typeRelationship == TYPE_RELATIONSHIP_CONFLICT ||
                    taskInfo.typeRelationship == TYPE_RELATIONSHIP_MERGE_REQUEST ||
                    taskInfo.typeRelationship == TYPE_RELATIONSHIP_RELATED_TASK) {
                    if(branchName.indexOf('TASK_BKP_') === -1) {
                        taskInfo.branchName = branchName.replace('TASK_', 'TASK_BKP_');
                        taskInfo.finalBranchName = branchName;
                    } else {
                        taskInfo.branchName = branchName;
                        taskInfo.finalBranchName = branchName.replace('TASK_BKP_', 'TASK_');
                    }

                    return getMainBranch(taskInfo.typeRelationship).then(function (dataMain) {
                        taskInfo.mainBranch = dataMain.mainBranch;
                        taskInfo.errorFixTask = dataMain.errorFixTask;
                        taskInfo.mergeRequest = dataMain.mergeRequest;
                        taskInfo.mergeRequestStable = dataMain.mergeRequestStable;
                        taskInfo.projectUseMergeRequest = dataMain.projectUseMergeRequest;

                        if (dataMain.mergeRequestStable) {
                            taskInfo.resourceGeneratorTask = getInfoTaskWidget().currentRow.RESOURCE_GENERATOR_TASK;
                        }
                        return taskInfo;
                    });
                } else if (taskInfo.typeRelationship == TYPE_RELATIONSHIP_ERROR ||
                           taskInfo.typeRelationship == TYPE_RELATIONSHIP_REPLICATION ||
                           taskInfo.typeRelationship == TYPE_RELATIONSHIP_ERROR_MR ||
                           taskInfo.typeRelationship == TYPE_RELATIONSHIP_CONFLICT_DEVOPS) {
                    if (branchName ){
                        if (taskInfo.typeRelationship == TYPE_RELATIONSHIP_REPLICATION ||
                            (branchInfo && branchInfo.BRANCH_TASK == getInfoTaskWidget().currentRow.MAIN_RELATED_ID)) {
                            taskInfo.branchName = branchName;
                        } else {
                            taskInfo.branchName = createBranchName();
                        }
                    } else {
                        taskInfo.branchName = createBranchName();
                    }
                    if(taskInfo.typeRelationship == TYPE_RELATIONSHIP_CONFLICT_DEVOPS ||
                       taskInfo.typeRelationship == TYPE_RELATIONSHIP_REPLICATION) {
                        taskInfo.finalBranchName = branchName.replace('TASK_BKP_', 'TASK_');
                    } else {
                        taskInfo.finalBranchName = createFinalBranchName();
                    }
                    taskInfo.oldBranchName = branchName;
                } else {
                    taskInfo.finalBranchName = createFinalBranchName();
                    taskInfo.branchName = branchName;
                }
            } else {
                taskInfo.branchName = createBranchName();
                taskInfo.finalBranchName = createFinalBranchName();
            }

            return getMainBranch(taskInfo.typeRelationship).then(function (dataMain) {
                taskInfo.mainBranch = dataMain.mainBranch;
                taskInfo.errorFixTask = dataMain.errorFixTask;
                taskInfo.mergeRequest = dataMain.mergeRequest;
                taskInfo.mergeRequestStable = dataMain.mergeRequestStable;
                taskInfo.projectUseMergeRequest = dataMain.projectUseMergeRequest;

                if (dataMain.mergeRequestStable) {
                    var filterTask = [{
                        "operator": "=",
                        "name": "ID",
                        "value": taskInfo.taskGenerator
                    }];
                    return requestDataSourceEngine.getDataSource('/dataEditTask', filterTask).then(function (data) {
                        taskInfo.resourceGeneratorTask = data.dataset.taskData[0].RESOURCE;
                        return taskInfo;
                    });
                } else {
                    return taskInfo;
                }
            });
        });
    };

    var validateErrorFixTask = function (projectWithTypes, typeRelationship, versionTag, originProductVersionId) {
        return projectWithTypes[0].EXTERNALTYPE == PROJECT_EXTERNALTYPE_ERROR &&
               projectWithTypes[0].USEMERGEREQUEST == 'N' &&
               (typeRelationship != TYPE_RELATIONSHIP_REPLICATION || versionTag || originProductVersionId);
    };

    var validateErrorFixTaskWithMergeRequest = function (projectWithTypes) {
        return (projectWithTypes[0].EXTERNALTYPE == PROJECT_EXTERNALTYPE_ERROR && projectWithTypes[0].USEMERGEREQUEST == 'Y');
    };

    var validateMergeRequestTask = function (projectWithTypes, typeRelationship) {
        return (projectWithTypes[0].USEMERGEREQUEST == 'Y' &&
                typeRelationship != TYPE_RELATIONSHIP_MERGE_REQUEST && typeRelationship != TYPE_RELATIONSHIP_CONFLICT &&
                typeRelationship != TYPE_RELATIONSHIP_REPLICATION   && typeRelationship != TYPE_RELATIONSHIP_ERROR_MR) ||
               (typeRelationship == TYPE_RELATIONSHIP_CONFLICT && getInfoTaskWidget().currentRow.CONTROL_TASK_MR == TYPE_RELATIONSHIP_CONFLICT) ||
               (typeRelationship == TYPE_RELATIONSHIP_CONFLICT_DEVOPS && getInfoTaskWidget().currentRow.CONTROL_TASK_MR == TYPE_RELATIONSHIP_CONFLICT_DEVOPS);
    };

    var getMainBranch = function (typeRelationship) {
        var infoTaskRow = getWidgetInfoTask().currentRow;
        var returnMain = {
            mainBranch: 'master',
            errorFixTask: false,
            mergeRequest: false,
            mergeRequestStable: false,
            projectUseMergeRequest: false
        };
        var filterPrj = [{
            "operator": "=",
            "name": "ID",
            "value": infoTaskRow.PROJECT_ID.replace(/\D/g, '')
        }];

        return requestDataSourceEngine.getDataSource('/projectWithTypes', filterPrj).then(function (data) {
            var projectWithTypes = data.dataset.projectWithTypes;
            if (projectWithTypes.length > 0) {
                returnMain.projectUseMergeRequest = projectWithTypes[0].USEMERGEREQUEST == 'Y';
                if (validateErrorFixTask(projectWithTypes, typeRelationship, infoTaskRow.VERSION_TAG, infoTaskRow.ORIGIN_PRODUCT_VERSION_ID_DEV)) {
                    returnMain.mainBranch = 'stable';
                    returnMain.errorFixTask = true;
                } else if (validateErrorFixTaskWithMergeRequest(projectWithTypes, typeRelationship)) {
                    if(typeRelationship == TYPE_RELATIONSHIP_REPLICATION) {
                        if(infoTaskRow.ORIGIN_PRODUCT_VERSION_ID_DEV || infoTaskRow.PRODUCT_VERSION_ID) {
                            returnMain.errorFixTask = true;
                        }
                        if(infoTaskRow.ORIGIN_PRODUCT_VERSION_ID_DEV) {
                            returnMain.mainBranch = 'stable';
                        }
                    } else if(infoTaskRow.ORIGIN_PRODUCT_VERSION_ID_DEV ||
                             (infoTaskRow.MR_GENERATED_BY_REPLICATION == 'N' && infoTaskRow.ERROR_MR_GEN_BY_REPLICATION == 'N')) {
                        if(infoTaskRow.CONFLICT_REPLICATION == 'N'){
                            returnMain.mainBranch = 'stable';
                        }
                        if(typeRelationship != TYPE_RELATIONSHIP_ERROR_MR &&
                           typeRelationship != TYPE_RELATIONSHIP_CONFLICT) {
                            returnMain.mergeRequestStable = true;
                        }
                    } else {
                        returnMain.mergeRequest = true;
                    }
                } else if (validateMergeRequestTask(projectWithTypes, typeRelationship)) {
                    returnMain.mergeRequest = true;
                }
            }
            if(infoTaskRow.VERSION_TAG) {
                returnMain.mainBranch = infoTaskRow.VERSION_TAG;
            } else if(typeRelationship == TYPE_RELATIONSHIP_CONFLICT_DEVOPS) {
                returnMain.mainBranch = 'stable';
            }
            return returnMain;
        });
    };

    var openNewTaskSwipe = function (task) {
        var widgetListTasks = getListTasksWidget();
        var widgetTabbTask = templateManager.container.getWidget('TABBED_APPROPRIATION');

        var filter = [{
            "operator": "=",
            "name": "ESTIMATED_BEGIN_DATE",
            "value": getLocalVar('dateFromTask') ? getLocalVar('dateFromTask') : moment().format('DD/MM/YYYY')
        }, {
            "operator": "=",
            "name": "ID",
            "value": task.PROJECT_ID
        }];

        ScreenService.showLoader();
        return requestDataSourceEngine.getDataSource('/tasksFullDataByUserOnDemand', filter).then(function (data) {
            ScreenService.hideLoader();
            var dataTasks = data.dataset.tasksFullDataByUserOnDemand;
            dataTasks = dataTasks.filter(function (dataTask) {
                return dataTask.TASK_ID == task.TASK_ID;
            });
            widgetListTasks.currentRow = dataTasks[0];
            ScreenService.openSwipe(widgetTabbTask);
        }).catch(ScreenService.hideLoader);
    };

    var verifyModifiedFilesBeforeInit = function () {
        var task = getInfoTaskWidget().currentRow;
        var defer = ZHPromise.defer();
        var result = true;
        var reject = function (e) {
            if((typeof e === 'object' && e.hasOwnProperty('data')) &&
               (e.data.search(Messages.ERR_NOT_GIT_REPOSITORY) !== -1 || e.data.search(Messages.ERR_PATH_NOT_FOUND) !== -1)) {
                defer.resolve();
            } else {
                defer.reject(e);
            }
        };

        AppropriationService._checkStatusAndCheckoutInRepositories(task.PATHS).then(function () {
            AppropriationService.gitModifiedFiles(factoryRepositoryPromise(task.PATHS)).then(function (directoriesStatus) {
                directoriesStatus.map(function (dir) {
                    if (dir.status.length > 0) {
                        result = false;
                    }
                });
                if (result) {
                    defer.resolve();
                } else {
                    defer.reject( { DIRECTORIES : directoriesStatus } );
                }
            }).catch(reject);
        }).catch(reject);

        return defer.promise;
    };

    var createLinksDiffGitLab = function (taskInfo) {
        var branchName = taskInfo.branchName;
        var infoTaskWidget = getInfoTaskWidget();
        var links = [];
        var prefix, link;
        var baseLinkHtml = '<a href="%1" style="color: #4D76A2" target="_blank"><u>%2</u></a>';
        var repositoriesFull = infoTaskWidget.currentRow.PATHS;

        return Utilities.validateExecuteInWindows().then(function (isWindows) {
            var repositoriesPromises = repositoriesFull.map(function (repository) {
                if(infoTaskWidget.currentRow.VERSION_TAG) {
                    repository.branchToCompare = infoTaskWidget.currentRow.VERSION_TAG;
                } else if (taskInfo.mergeRequestStable) {
                    repository.branchToCompare = repository.MASTER_BRANCH;
                } else {
                    repository.branchToCompare = 'master';
                }
                repository.PATH = isWindows ? repository.LOCAL_DIRECTORY : repository.LINUX_DIRECTORY;
                return AppropriationService.checkExistsBranch(repository.PATH, branchName).then(function (validate) {
                    repository.validate = validate;
                    return repository;
                });
            });
            return ZHPromise.all(repositoriesPromises).then(function (repositories) {
                repositories.forEach(function (repository) {
                    if (repository.validate) {
                        prefix = repository.repository.replace('git@', '').replace('.git', '').replace(':', '/');
                        link = 'http://' + prefix + '/compare/' + repository.branchToCompare + '...' + branchName;
                        links.push({
                            repositoryName: repository.NAME,
                            repositoryURL: repository.repository,
                            link: baseLinkHtml.replace('%1', link).replace('%2', branchName)
                        });
                    }
                });

                return links;
            }).catch(defaultError);
        });
    };

    this.issueMainActionEventBack = function(args){
        ScreenService.closeSwipe().then(function(){
            getWidgetTaskIssues().activate();
        });
    };

    var createMessageDiffGitLab = function (dataLinks) {
        var message = Messages.DES_INIT_LINK_MERGE_REQUEST;
        var urlHtml;

        dataLinks.forEach(function (dataLink) {
            message += '<br/>' + dataLink.repositoryName + ':<br/>' + dataLink.link + '<br/>';
        });

        return message;
    };

    this.infoTaskActionEventDiffMergeRequest = function(args){
        self.showLinksDiffGitLab();
    };

    this.infoTaskActionEventBack = function(args){
        Utilities.genericBackEventIsNotMasterDetail(getListTasksWidget());
    };

    this.timeByActivityActionEventBack = function(args){
        Utilities.genericBackEventIsNotMasterDetail(getListTasksWidget());
    };

    this.taskIssuesActionEventBack = function(args){
        Utilities.genericBackEventIsNotMasterDetail(getListTasksWidget());
    };

    this.GitPopupActionEventDiff = function(args){
        ScreenService.showLoader();
        var fileName = " ";
        var mergeCheck = false;
        var paths = Utilities.localVar.getTaskPaths();
        Utilities.validateExecuteInWindows().then(function (isWindows) {
            paths.forEach(function (path) {
                path.dir = isWindows ? path.LOCAL_DIRECTORY : path.LINUX_DIRECTORY;
            });
            setPopupDiffDataSource(mergeCheck ,fileName, paths);
        });
    };

    this.GitPopupAfterMoveRow = function(args){
        ScreenService.showLoader();
        var parentDir = args.owner.currentRow.PARENT_DIR;
        var fileName = args.owner.currentRow.FILE_NAME;
        var mergeCheck = false;
        var path;
        if(parentDir !== null) {
            path = [{"dir": parentDir}];
        }else {
            path = [{"dir": fileName}];
        }
        setPopupDiffDataSource(mergeCheck ,fileName, path);
    };

    this.showLinksDiffGitLab = function () {
        ScreenService.showLoader();
        var taskStatus = getInfoTaskWidget().currentRow.TASK_STATUS;
        if(taskStatus === 'D') {
            getTaskInfo().then(function (taskInfo) {
                createLinksDiffGitLab(taskInfo).then(function (links) {
                    if (links.length > 0) {
                        var message = createMessageDiffGitLab(links);
                        ScreenService.showMessage(message);
                    } else {
                        ScreenService.showMessage(Messages.ALE_BRANCH_NOT_FOUND_REPOSITORY.replace('%1', taskInfo.branchName));
                    }
                    ScreenService.hideLoader();
                }).catch(function (e) {
                    if (e.connectionError === true) {
                        ScreenService.hideLoader();
                    } else if (e.data.hasOwnProperty('error')) {
                        defaultError(e.data.error);
                    }
                });
            });
        } else {
            ScreenService.showMessage(Messages.ALE_NOT_CREATE_LINKS_GIT_LAB);
            ScreenService.hideLoader();
        }
    };

    var validateTaskBranch = function (typeRelationship, taskGenerator, branchName) {
        var taskId;
        var infoTaskRow = getInfoTaskWidget().currentRow;
        var directoriesValidation = infoTaskRow.DIRECTORIES_VALIDATION;
        if((typeRelationship == TYPE_RELATIONSHIP_MERGE_REQUEST && infoTaskRow.MR_GENERATED_BY_CONFLICT == 'Y') ||
           typeRelationship == TYPE_RELATIONSHIP_REPLICATION) {
            taskId = infoTaskRow.BRANCH_INFO.BRANCH_TASK;
        } else if (typeRelationship == TYPE_RELATIONSHIP_CONFLICT        ||
                   typeRelationship == TYPE_RELATIONSHIP_CONFLICT_DEVOPS ||
                   typeRelationship == TYPE_RELATIONSHIP_MERGE_REQUEST   ||
                   typeRelationship == TYPE_RELATIONSHIP_RELATED_TASK) {
            taskId = taskGenerator;
        } else if(typeRelationship == TYPE_RELATIONSHIP_ERROR_MR && directoriesValidation.IS_RELATED_TASK) {
            taskId = directoriesValidation.MAIN_TASK;
        } else {
            taskId = getCurrentTaskId();
        }

        var filter = [ {
            "operator": "=",
            "name": "TASK",
            "value": taskId
        } ];
        return requestDataSourceEngine.getDataSource('/taskBranches', filter).then(function (data) {
            var taskBranches = data.dataset && data.dataset.taskBranches;
            var taskBranchName = typeRelationship == TYPE_RELATIONSHIP_CONFLICT_DEVOPS && taskBranches.length > 0 ? taskBranches[0].NAME : branchName;
            var row = {
                "ID": taskBranches.length > 0 ? taskBranches[0].ID : null,
                "TASK": taskId,
                "NAME": taskBranchName,
                "DESCRIPTION": null,
                "ORGANIZATION": Utilities.localVar.getOrganization(),
                "STATUS": null,
                "changed": true,
                "isMessage": false,
                "__is_new": taskBranches.length <= 0
            };
            return requestDataSourceEngine.setDataSource('/taskBranches', [row]);
        });
    };

    var validatePlayConcludeMergeRequestTask = function(task) {
        var filter = [{
            "operator": "=",
            "name": "TASK",
            "value": getInfoTaskWidget().currentRow.TASK_ID
        }];
        return requestDataSourceEngine.getDataSource('/findTasksGeneratedNotConcluded', filter).then(function (data) {
            var tasksGenerated = data.dataset.tasksGeneratedNotConcluded[0];
            return tasksGenerated.COUNT_TASKS <= 0;
        });
    };
    var validateAllChangedFilesHaveLocalConnection = function(taskId) {
        var taskListWidget = getListTasksWidget();
        if(taskListWidget.currentRow.USEGITAUTOMATICALLY !== 'Y'){
            return ZHPromise.when();
        }
        var defer = ZHPromise.defer();
        var taskInfo = getInfoTaskWidget().currentRow;
        if (taskId || (taskInfo.TYPE_RELATIONSHIP == 'T')) {
            defer.resolve();
        } else {
            var filter = [
                {
                    "operator": "=",
                    "name": "TASK",
                    "value": taskInfo.BRANCH_INFO ? taskInfo.BRANCH_INFO.BRANCH_TASK : taskInfo.TASK_ID
                },
                {
                    "operator": "=",
                    "name": "TYPE_RELATIONSHIP",
                    "value": taskInfo.TYPE_RELATIONSHIP
                }
            ];

            requestDataSourceEngine.getDataSource('/checkAllChangedFilesHaveLocalConnection',filter).then(function (data) {
                var repositories = data.dataset.repositories;
                if (repositories.length > 0) {
                    var repositoriesMessage = '"' + repositories.join('"<br>"') + '"';
                    ScreenService.showMessage(Utilities.messages.ERR_REPOSITORY_CHANGED + repositoriesMessage);
                    defer.reject(repositories);
                    ScreenService.restoreDefaultLoadingMessage();
                    ScreenService.hideLoader();
                } else {
                    defer.resolve();
                }
            }).catch(function (e) {
                if (typeof e === 'object' && e.connectionError) {
                    ScreenService.hideLoader();
                }else if(e.data.errorCode == 1){
                    ScreenService.showMessage(e.data.error);
                } else if (e.data.hasOwnProperty('error')) {
                    defaultError(e.data.error);
                }
                ScreenService.hideLoader();
                ScreenService.restoreDefaultLoadingMessage();
                defer.reject();
            });

        }

        return defer.promise;
    };

    var clearGlobalVariablesForGit = function(){
        stash = [];
        reset = [];
        commit = [];
        masterFilesToCommit = [];
    };

    this.listTaskActionEventPlay = function (args) {
        ScreenService.restoreDefaultLoadingMessage();
        if(args.row.TASK_STATUS !== 'D') {
            getWidgetNewAppropriation().oldDescriptionFieldAppropriation = '';
            this.listTasksWidgetAfterMoveRow(args, 'S').then(function () {
                self.infoTaskActionEventPlay(args);
                ScreenService.restoreDefaultLoadingMessage();
            });
        }
    };

    this.infoTaskActionEventPlay = function(args) {
        var widget = getInfoTaskWidget();
        if(widget.currentRow.ALLOW_PLAY_TASK == 'N') {
            ScreenService.closeSwipe();
            getListTasksWidget().activate();
            ScreenService.showMessage(Utilities.messages.ERR_PLAY_ALLOW_PLAY_TASK);
        } else {
            clearGlobalVariablesForGit();
            ScreenService.showLoader();
            TaskService.validateTaskToBeStarted(widget.currentRow.ID).then(function(response) {
                ScreenService.hideLoader();
                if(response.status == OK_STATUS){
                    self.gitPlay(args.owner.widget);
                } else {
                    ScreenService.showMessage(response.msg);
                }
            }).catch(Utilities.showMessageBackEndTrue);
        }
    };

    this.gitPlay = function (widget, openNewTask) {
        ScreenService.showLoader();
        AppropriationService.gitBranchResult = {};
        getTaskInfo().then(function (taskInfo) {
            validateTwoStartedTasks(openNewTask,taskInfo.trueTaskId).then(function () {
                validateAllChangedFilesHaveLocalConnection().then(function () {
                    if (taskInfo.typeRelationship === TYPE_RELATIONSHIP_MERGE_REQUEST) {
                        validatePlayConcludeMergeRequestTask().then(function (validateMR) {
                            if (validateMR) {
                                doGitPlay(taskInfo, openNewTask, widget);
                            } else {
                                ScreenService.hideLoader();
                                ScreenService.showMessage(Messages.ALE_NOT_PLAY_MERGE_REQUEST_TASK);
                            }
                        }).catch(function (e) {
                            defaultError(e.data.error);
                        });
                    } else {
                        if(taskInfo.typeRelationship === TYPE_RELATIONSHIP_TEST && widget.currentRow.TEST_BLOCKED == 'Y') {
                            ScreenService.hideLoader();
                            ScreenService.showMessage(Messages.ALE_NOT_PLAY_TEST_BLOCKED);
                        } else {
                            doGitPlay(taskInfo, openNewTask, widget);
                        }
                    }
                }).catch(function (e) {
                    if(e){
                        if(e.data){
                            if(e.data.error){
                                defaultError(e.data.error);
                            }
                        }
                    }
                });
            }).catch(function (tasks) {
                var tasksAndProjects = [];
                tasks.filter(function (task) {
                    var taskAndProjectName = 'Tarefa: "' + task.TASK + '" (Projeto: "' + task.PROJECT + '").';
                    tasksAndProjects.push(taskAndProjectName);
                });
                tasksAndProjects = tasksAndProjects.join('<br/>');
                ScreenService.hideLoader();
                ScreenService.showMessage(Messages.ERR_START_TASKS + '<br/>' + tasksAndProjects);
            });
        }).catch(function (e) {
            defaultError(e.data.error);
        });
    };

    var generateConflictPopup = function (e, task, typeRelationship, openNewTask) {
        if (typeof e === 'object' && e.connectionError) {
            ScreenService.closePopup(true);
            ScreenService.showMessage(Messages.ALE_PROJECT_SERVICES_DISCONNECTED);
            ScreenService.hideLoader();
            ScreenService.restoreDefaultLoadingMessage();
        } else {
            AppropriationService.gitModifiedFiles(factoryRepositoryPromise(task.PATHS)).then(function (directoriesStatus) {
                AppropriationService.saveMasterFiles(directoriesStatus, getCurrentTaskId(), task.PATHS).then(function () {
                    showConflictsInPlay(typeRelationship, openNewTask);
                }).catch(function (e) {
                    showConflictsInPlay(typeRelationship, openNewTask);
                });
            }).catch(function (e) {
                showConflictsInPlay(typeRelationship, openNewTask);
            });
        }
    };

    var getLogFileName = function() {
        var task = getInfoTaskWidget().currentRow;
        var taskId = task.ID;
        if(task.DIRECTORIES_VALIDATION.IS_RELATED_TASK) {
            taskId = task.DIRECTORIES_VALIDATION.MAIN_TASK;
        }
        return 'LOG_TASK_' + taskId + '.txt';
    };

    var getLogFileContents = function(typeLog) {
        var task = getInfoTaskWidget().currentRow;
        var logFileContents = '-----> Task: ' + task.ID + ' - ' + task.TASK_NAME;
        logFileContents += ' | Project: ' + task.PROJECT_ID + ' - ' + task.PROJECT_NAME;
        logFileContents += ' | Date: ' + Utilities.getCurrentDateAndHour();
        logFileContents += ' | ' + typeLog + ' <-----\n\n';
        logFileContents += getLogWidget().currentRow.LOG_FIELD_SAVE + '\n\n';
        return logFileContents;
    };

    var defaultLoaderAndCloseAllPopups = function() {
        ScreenService.closePopup(true);
        ScreenService.hideLoader();
        ScreenService.restoreDefaultLoadingMessage();
    };

    var dirtyDirectoryError = function (openNewTask, backAction, logFileName, e, logWidget) {
        var typeLog = openNewTask ? 'Iniciar Replicação' : 'Iniciar';
        var logFileContents = getLogFileContents(typeLog);
        backAction.isVisible = true;
        createLogFile(logFileName, logFileContents).then(function () {
            if (e.hasOwnProperty('DIRECTORIES')) {
                var directoriesStatus = e.DIRECTORIES;
                var gitPopupWidget = getGitPopupWidget();
                removeMasterFilesFromData(directoriesStatus).then(function (directoriesStatus) {
                    saveUnmodifiedDirectories(directoriesStatus);
                    gitPopupWidget.label = 'Arquivos modificados';
                    gitPopupWidget.actions[2].isVisible = false;
                    localStorageEngine.setLocalVar('DIRTY_DIRECTORY', true);
                    setTimeout(function () {
                        var data = directoryStatusToTreeDataSource(directoriesStatus);
                        data = arrayUnique(data);
                        localStorageEngine.setDataSource('/git', data).then(function () {
                            gitPopupWidget.reload().then(function () {
                                ScreenService.showMessage(Messages.ALE_DIRTY_DIRECTORY_WITH_PLAY);
                                ScreenService.closePopup(logWidget);
                                ScreenService.openPopup(gitPopupWidget);
                                ScreenService.hideLoader();
                            });
                        });
                    }, 1000);
                });
            } else if (typeof e === 'object' && e.connectionError) {
                ScreenService.hideLoader();
            } else {
                ScreenService.hideLoader();
                ScreenService.showMessage(Messages.ALE_DIRTY_DIRECTORY);
            }
            ScreenService.restoreDefaultLoadingMessage();
        }).catch(defaultError);
    };

    var gitPlayError = function (backAction, openNewTask, task, e, typeRelationship) {
        backAction.isVisible = true;
        if (openNewTask) {
            openNewTaskSwipe(task).then(function () {
                if(e && e.data && !e.connectionError && (e.data.includes('CONFLICT') || e.data.includes('CONFLITO') || e.data.includes('have unmerged files'))) {
                    generateConflictPopup(e, task, typeRelationship, openNewTask);
                } else {
                    ScreenService.closePopup(true);
                    defaultError(e);
                }
            }).catch(function () {
                ScreenService.hideLoader();
                ScreenService.restoreDefaultLoadingMessage();
                ScreenService.showMessage(Messages.ALE_NEW_TASK_CREATED_ERROR);
            });
        } else {
            if(e && e.data && !e.connectionError && (e.data.includes('CONFLICT') || e.data.includes('CONFLITO') || e.data.includes('have unmerged files'))) {
                generateConflictPopup(e, task, typeRelationship, openNewTask);
            } else {
                ScreenService.closePopup(true);
                defaultError(e);
            }
        }
    };

    var gitPlaySuccess = function (backAction, openNewTask, logFileName, task, typeRelationship, taskInfo) {
        backAction.isVisible = true;
        var typeLog = openNewTask ? 'Iniciar Replicação' : 'Iniciar';
        var logFileContents = getLogFileContents(typeLog);
        createLogFile(logFileName, logFileContents).then(function () {
            changeToStart(task).then(function () {
                if (openNewTask) {
                    openNewTaskSwipe(task).then(function () {
                        defaultLoaderAndCloseAllPopups();
                        ScreenService.showMessage(Messages.ALE_NEW_TASK_CREATED);
                    }).catch(function () {
                        defaultLoaderAndCloseAllPopups();
                        ScreenService.showMessage(Messages.ERR_NEW_TASK_CREATED_ERROR);
                    });
                } else if (typeRelationship == TYPE_RELATIONSHIP_MERGE_REQUEST) {
                    ScreenService.showLoader();
                    ScreenService.changeLoadingMessage(Messages.LOAD_CREATING_LINKS);
                    createLinksDiffGitLab(taskInfo).then(function (links) {
                        if (links.length > 0) {
                            var message = createMessageDiffGitLab(links);
                            ScreenService.showMessage(message);
                        } else {
                            ScreenService.showMessage(Messages.ALE_BRANCH_NOT_FOUND_REPOSITORY.replace('%1', taskInfo.branchName));
                        }
                        defaultLoaderAndCloseAllPopups();
                    }).catch(function () {
                        defaultLoaderAndCloseAllPopups();
                        ScreenService.showMessage(Messages.ERR_NOT_GENERATE_LINKS_MERGE_REQUEST);
                    });
                } else {
                    defaultLoaderAndCloseAllPopups();
                }
            });
        }).catch(defaultError);
    };

    var doGitPlay = function(taskInfo, openNewTask, widget) {
        var defer = ZHPromise.defer();
        localStorageEngine.setLocalVar('DIRTY_DIRECTORY', false);
        var task = widget.currentRow;
        var infoTaskWidget = getWidgetInfoTask();
        var taskListWidget = getListTasksWidget();
        if (taskInfo.typeRelationship === TYPE_RELATIONSHIP_TEST) {
            var urlToTest = infoTaskWidget.currentRow.URL_TO_TEST;
            changeToStart(task).then(function () {
                var baseHtml = Messages.DES_TASK_TEST_LINK;
                if(urlToTest.indexOf("http") < 0){
                    urlToTest = "//" + urlToTest;
                }else{
                    var temp = urlToTest.split(':');
                    urlToTest = temp[0] + "://" + temp[1];
                }

                var linkHtml = '<a href="' + urlToTest + '" style="color: #4D76A2" target="_blank"><u>aqui</u></a>';
                baseHtml = baseHtml.replace('%1', linkHtml);
                ScreenService.showMessage(baseHtml);
            });
        } else if (infoTaskWidget.currentRow.EXTERNALTYPE === 'S' ||
                   infoTaskWidget.currentRow.CLASSIFICATION_CONTROL === CLASSIFICATION_SPECIFICATION || 
                  (taskListWidget.currentRow && taskListWidget.currentRow.USEGITAUTOMATICALLY !== 'Y')) {
            changeToStart(task);
        } else {
            Utilities.validateExecuteInWindows().then(function (isWindows) {
                task.PATHS = infoTaskWidget.currentRow.PATHS;
                task.PATHS.forEach(function (path) {
                    path.dir = isWindows ? path.LOCAL_DIRECTORY : path.LINUX_DIRECTORY;
                    path.isWindows = isWindows;
                });
                Utilities.localVar.setTaskPaths(Utilities.clone(task.PATHS));
                var typeRelationship;
                currentTaskStatus = 'START';
                if (validateRepositoryAndDirectory(task.PATHS, task.DIRECTORIES_VALIDATION, isWindows)) {
                    var filter = [ {
                        "operator": "=",
                        "name": "TASK",
                        "value": task.BRANCH_INFO ? task.BRANCH_INFO.BRANCH_TASK : task.TASK_ID
                    }, {
                        "operator": "=",
                        "name": "TYPE_RELATIONSHIP",
                        "value": task.TYPE_RELATIONSHIP
                    }, {
                            "operator": "=",
                            "name": "IS_WINDOWS",
                            "value": isWindows
                    } ];
                    requestDataSourceEngine.getDataSource('/checkSameDirectoryFromDifferentRepositories',filter).then(function (data) {
                        typeRelationship  = taskInfo.typeRelationship;
                        var branchName    = taskInfo.branchName;
                        var taskGenerator = taskInfo.taskGenerator;

                        var logWidget   = getLogWidget();
                        var logFileName = getLogFileName();
                        var backAction  = getBackActionFromLogWidget();
                        ScreenService.hideLoader();
                        backAction.isVisible = false;
                        logWidget.newRow();
                        ScreenService.openPopup(logWidget);
                        verifyModifiedFilesBeforeInit().then(function () {
                            AppropriationService.gitPlay(branchName, factoryRepositoryPromise(task.PATHS), taskInfo).then(function () {
                                ScreenService.changeLoadingMessage(Messages.LOAD_ENDING_PROCESS);
                                ScreenService.showLoader();
                                return validateTaskBranch(typeRelationship, taskGenerator, branchName);
                            }).then(function () {
                                gitPlaySuccess(backAction, openNewTask, logFileName, task, typeRelationship, taskInfo);
                            }).catch(function (e) {
                                gitPlayError(backAction, openNewTask, task, e, typeRelationship);
                            });
                        }).catch(function (e) {
                            dirtyDirectoryError(openNewTask, backAction, logFileName, e, logWidget);
                        });
                    }).catch(function (e) {
                        ScreenService.showMessage(e.data.error);
                        ScreenService.hideLoader();
                        ScreenService.restoreDefaultLoadingMessage();
                        defer.reject();
                    });
                }
            });
        }
    };

    var resetAll = function (task) {
        var defer = ZHPromise.defer();
        AppropriationService.gitResetPullMaster(factoryRepositoryPromise(task.PATHS))
            .then(function () { defer.resolve(); })
            .catch(function (e) { defer.reject(e); });
        return defer.promise;
    };

    var startTask = function (task) {
        var openNewTask = true;
        getTaskInfo().then(function (taskInfo) {
        var defer = ZHPromise.defer();
        localStorageEngine.setLocalVar('DIRTY_DIRECTORY', false);
        var infoTaskWidget = getWidgetInfoTask();
        var taskListWidget = getListTasksWidget();

         Utilities.validateExecuteInWindows().then(function (isWindows) {
                task.PATHS = infoTaskWidget.currentRow.PATHS;
                task.PATHS.forEach(function (path) {
                    path.dir = isWindows ? path.LOCAL_DIRECTORY : path.LINUX_DIRECTORY;
                    path.isWindows = isWindows;
                });
                Utilities.localVar.setTaskPaths(Utilities.clone(task.PATHS));
                var typeRelationship;
                currentTaskStatus = 'START';
                if (validateRepositoryAndDirectory(task.PATHS, task.DIRECTORIES_VALIDATION, isWindows)) {
                    var filter = [ {
                        "operator": "=",
                        "name": "TASK",
                        "value": task.BRANCH_INFO ? task.BRANCH_INFO.BRANCH_TASK : task.TASK_ID
                    }, {
                        "operator": "=",
                        "name": "TYPE_RELATIONSHIP",
                        "value": task.TYPE_RELATIONSHIP
                    }, {
                            "operator": "=",
                            "name": "IS_WINDOWS",
                            "value": isWindows
                    } ];
                    requestDataSourceEngine.getDataSource('/checkSameDirectoryFromDifferentRepositories',filter).then(function (data) {
                        typeRelationship  = taskInfo.typeRelationship;
                        var branchName    = taskInfo.branchName;
                        var taskGenerator = taskInfo.taskGenerator;

                        var logWidget   = getLogWidget();
                        var logFileName = getLogFileName();
                        var backAction  = getBackActionFromLogWidget();
                        ScreenService.hideLoader();
                        backAction.isVisible = false;
                        logWidget.newRow();
                        ScreenService.openPopup(logWidget);
                        verifyModifiedFilesBeforeInit().then(function () {
                            AppropriationService.gitPlay(branchName, factoryRepositoryPromise(task.PATHS), taskInfo).then(function () {
                                ScreenService.changeLoadingMessage(Messages.LOAD_ENDING_PROCESS);
                                ScreenService.showLoader();
                                return validateTaskBranch(typeRelationship, taskGenerator, branchName);
                            }).then(function () {
                                gitPlaySuccess(backAction, openNewTask, logFileName, task, typeRelationship, taskInfo);
                            }).catch(function (e) {
                                gitPlayError(backAction, openNewTask, task, e, typeRelationship);
                            });
                        }).catch(function (e) {
                            dirtyDirectoryError(openNewTask, backAction, logFileName, e, logWidget);
                        });
                    }).catch(function (e) {
                        ScreenService.showMessage(e.data.error);
                        ScreenService.hideLoader();
                        ScreenService.restoreDefaultLoadingMessage();
                        defer.reject();
                    });
                }
            });
            }).catch(function (e) {
                defaultError(e.data.error);
            });

    };

    var showConflictsInPlay = function(typeRelationship, openNewTask) {
        var task = getInfoTaskWidget().currentRow;
        var logFileName = getLogFileName();
        if (typeRelationship === TYPE_RELATIONSHIP_MERGE_REQUEST) {
            resetAll(task).then(function() {
                var typeLog = openNewTask ? 'Iniciar Replicação' : 'Iniciar';
                var logFileContents = getLogFileContents(typeLog);
                createLogFile(logFileName, logFileContents).then(function() {
                    ScreenService.closePopup(true);
                    ScreenService.hideLoader();
                    ScreenService.restoreDefaultLoadingMessage();
                    ScreenService.showMessage(Messages.ALE_MERGE_TASK_WITH_CONFLICT);
                    infoTaskActionEventGenerateTask(true);
                }).catch(defaultError);
            });
        } else {
            var typeLog = openNewTask ? 'Iniciar Replicação' : 'Iniciar';
            var logFileContents = getLogFileContents(typeLog);
            createLogFile(logFileName, logFileContents).then(function() {
                ScreenService.closePopup(true);
                callConflictMessage(openNewTask);
                TaskService.initTask(task);
                changeToStart(task);
            }).catch(defaultError);
        }
    };

    this.infoTaskActionEventSearch = function(){
        clearGlobalVariablesForGit();
        self.gitCommit(getWidgetInfoTask());
        Utilities.closeSideMenu();
    };

    this.listTaskActionEventPause = function (args) {
        ScreenService.restoreDefaultLoadingMessage();
        getWidgetNewAppropriation().oldDescriptionFieldAppropriation = '';
        this.listTasksWidgetAfterMoveRow(args, 'S').then(function () {
            self.infoTaskActionEventPause(args);
            ScreenService.restoreDefaultLoadingMessage();
        });
    };

    this.infoTaskActionEventPause = function(args) {
        returnToInfoTaskWidget = true;
        showGitPopupActions();
        clearGlobalVariablesForGit();
        var widget = getWidgetNewAppropriation();
        widget.currentRow = {};
        widget.currentRow.__is_new = true;
        Utilities.localVar.setDescriptionControl(true);
        self.gitPause(args.owner.widget);
        Utilities.closeSideMenu();
    };

    this.gitCommit = function (widget) {
        if (ProjectManagementConfig.lockFinishTasks) {
            ScreenService.showMessage('Commit de tarefas bloqueada. Procure o setor Zeedhi para mais informações.');
            return;
        }
        if (widget.currentRow.TASK_STATUS == 'D') {
            showGitPopupActions();
        } else {
            hideGitPopupActions();
        }
        ScreenService.changeLoadingMessage(Messages.LOAD_SEARCHING_STATUS_TASK);
        ScreenService.showLoader();
        filesWithStatus = [];
        currentTaskStatus = 'COMMIT';
        validatePauseConcludeTaskNotGit().then(function (validate) {
            if (!validate) {
                self.gitStatus(widget);
            }
        });
    };

    this.gitPause = function (widget) {
        if (ProjectManagementConfig.lockFinishTasks) {
            ScreenService.showMessage('Pausa de tarefas bloqueada. Procure o setor Zeedhi para mais informações.');
            return;
        }
        ScreenService.changeLoadingMessage(Messages.LOAD_PAUSING_TASK);
        ScreenService.showLoader();
        filesWithStatus = [];
        AppropriationService.gitBranchResult = {};
        currentTaskStatus = 'PAUSE';

        validatePauseConcludeTaskNotGit().then(function(validate) {
            if(validate) {
                ScreenService.hideLoader();
                self.gitAddAppropriation(widget);
            } else {
                self.gitStatus(widget);
            }
        }).catch(Utilities.showMessageBackEndTrue);
    };

    var validatePauseConcludeTaskNotGit = function() {
        var filterRelationship = [{
            "operator": "=",
            "name": "TASK_RELATIONSHIP",
            "value": getWidgetInfoTask().currentRow.TASK_ID
        }, {
            "operator": "IN",
            "name": "TYPE",
            "value": Messages.TYPE_GENERATED_TASK_WITHOUT_ORIGIN_AND_RELATED
        }];
        return requestDataSourceEngine.getDataSource('/generatedTaskRelationship', filterRelationship).then(function (data) {
            var relationship = data.dataset.generatedTaskRelationship;
            var infoTaskWidget = getWidgetInfoTask();
            var taskListWidget = getListTasksWidget();
            return !!((relationship.length > 0 && relationship[0].TYPE === TYPE_RELATIONSHIP_TEST) ||
                      infoTaskWidget.currentRow.EXTERNALTYPE === 'S' ||
                      infoTaskWidget.currentRow.CLASSIFICATION_CONTROL === CLASSIFICATION_SPECIFICATION || 
                      (taskListWidget.currentRow && taskListWidget.currentRow.USEGITAUTOMATICALLY !== 'Y'));
        });
    };

    var hideGitPopupActions = function () {
        var gitPopup = getGitPopupWidget();
        gitPopup.actions[1].isVisible = false;
        gitPopup.actions[2].isVisible = false;
        gitPopup.actions[3].isVisible = false;
    };

    var getGitPopupWidget = function () {
        return templateManager.container.getWidget('GIT_POPUP');
    };

    var getStashNamePopupWidget = function () {
        return templateManager.container.getWidget('STASH_NAME_POPUP');
    };

    var saveUnmodifiedDirectories = function (directoriesStatus) {
        unmodifiedDirectories = [];
        directoriesStatus.forEach(function (status) {
            if (status.hasChanges === false) {
                unmodifiedDirectories.push({
                    dir: status.dir,
                    repository: status.repository
                });
            }
        });
    };

    var validateStatus = function (directoriesStatus) {
        var result = false;
        directoriesStatus.forEach(function (status) {
            if (status.hasChanges === true) {
                result = true;
            }
        });
        return result;
    };
    var buildRow = function (dir, fileName, fileStatus, fileRepository, parentDir, isDir, fileNameOrd, dirOrd, fileRepositoryIds) {
        if (parentDir === undefined)
            parentDir = null;

        return {
            DIR: dir,
            PARENT_DIR: parentDir,
            FILE_NAME: fileName.trim(),
            FILE_STATUS: fileStatus,
            FILE_REPOSITORY: fileRepository,
            FILE_REPOSITORY_IDS: fileRepositoryIds,
            IS_DIR: isDir,
            FILE_NAME_ORD: fileNameOrd,
            DIR_ORD: dirOrd
        };
    };

    var configureFiles = function (file, innerFiles, parentDir, projectDir) {
        var fileName = file.FILE_NAME.trim();
        if (fileName.indexOf('/') === -1) {
            innerFiles.push(buildRow(parentDir + "/" + fileName, fileName, file.FILE_STATUS, projectDir.repository, parentDir, false, fileName, parentDir, projectDir.repository_ids));
        } else {
            fileName = fileName.split('/');
            var dirName = fileName.shift().trim();
            _createdDirs.push(dirName);
            innerFiles.push(buildRow(parentDir + "/" + dirName, parentDir + "/" + dirName, "", projectDir.repository, parentDir, true, "", parentDir + "/" + dirName, projectDir.repository_ids));

            var newFile = {
                FILE_NAME: fileName.join('/'),
                FILE_STATUS: file.FILE_STATUS
            };
            configureFiles(newFile, innerFiles, parentDir + "/" + dirName, projectDir);
        }
    };

    var directoryStatusToTreeDataSource = function (files) {
        return files.filter(function (file) {
            return file.hasChanges;
        }).map(function (directory) {
            var innerFiles = [];
            innerFiles.push(buildRow(directory.dir, directory.dir, "", directory.repository, undefined, true, "", directory.dir, directory.repository_ids));
            _createdDirs = [];
            directory.files.forEach(function (file) {
                configureFiles(file, innerFiles, directory.dir, directory);
            });
            innerFiles = standardizeSlashes(innerFiles);
            return innerFiles;
        }).reduce(function (a, b) {
            return a.concat(b);
        }, []);
    };

    var standardizeSlashes = function(innerFiles){
        innerFiles.forEach(function(innerFile){
            var dirSlash = '\\';
            if(innerFile.DIR.indexOf('\\') === -1){
                dirSlash = '/';
            }

            innerFile.DIR = replaceSlashes(innerFile.DIR, dirSlash);
            innerFile.DIR_ORD = replaceSlashes(innerFile.DIR_ORD, dirSlash);
            innerFile.FILE_NAME = replaceSlashes(innerFile.FILE_NAME, dirSlash);
            innerFile.PARENT_DIR = replaceSlashes(innerFile.PARENT_DIR, dirSlash);
        });

        return innerFiles;
    };

    var replaceSlashes = function(text, dirSlash){
        if(text){
            return text.split('\\').join(dirSlash).split('/').join(dirSlash);
        }
        return text;
    };

    var arrayUnique = function (array) {
        var a = array.concat();
        a.sort(function (current, next) {
            if (current.DIR_ORD == next.DIR_ORD) {
                if (current.FILE_NAME_ORD < next.FILE_NAME_ORD) {
                    return -1;
                }
                if (current.FILE_NAME_ORD > next.FILE_NAME_ORD) {
                    return 1;
                }
                return 0;
            } else {
                if (current.DIR_ORD < next.DIR_ORD) {
                    return -1;
                } else {
                    return 1;
                }
            }
        });

        var i = 1;
        while (i < a.length) {
            if (JSON.stringify(a[i]) === JSON.stringify(a[i - 1])) {
                a.splice(i--, 1);
            } else if (a[i].PARENT_DIR === undefined) {
                a.splice(i--, 1);
            } else if (a[i].FILE_NAME === "") {
                a.splice(i--, 1);
            } else if (a[i].IS_DIR && a[i - 1].IS_DIR) {
                findEqualsParentDir(a, a[i - 1].DIR, a[i - 1].PARENT_DIR);
                a.splice(--i, 1);
            }
            i = ++i;
        }

        return a;
    };

    var findEqualsParentDir = function(array, dir, parentDir) {
        array.forEach(function(row) {
            if(row.PARENT_DIR == dir) {
                row.PARENT_DIR = parentDir;
            }
        });
    };

    var getAppropriationsWidget = function () {
        return templateManager.container.getWidget('TIME_BY_ACTIVITY');
    };

    var getNewAppropriationWidget = function () {
        return templateManager.container.getWidget('NEW_APPROPRIATION');
    };

    var getDescriptionFieldFromNewAppropriationWidget = function(){
        return getNewAppropriationWidget().getField('DESCRIPTION');
    };

    this.gitAddAppropriation = function () {
        var appropriations = getAppropriationsWidget();
        var length = appropriations.dataSource.data.length;
        var newAppropriation = getNewAppropriationWidget();

        newAppropriation.getField('STASH_DESCRIPTION').isVisible = stash.length > 0;

        if (length > 0) {
            newAppropriation.newRow();
            newAppropriation.currentRow.PERCENT_COMPLETED = appropriations.dataSource.data[length - 1].PERCENT_COMPLETED;
        }
        newAppropriation.edit();
        ScreenService.closePopup();
        _clearAppropriationFields();
        AppropriationService.setHourAppropriation(newAppropriation,getInfoTaskWidget().currentRow.USE_TIME_PLANNING);
        localStorageEngine.setLocalVar('CALL_APPR_WIDG_BY_TIME_BY_ACT', false);
        ScreenService.openSwipe(newAppropriation).then(function(){
            var percentCompletedField = getFieldPercentCompletedFromNewAppropriationWidget();
            percentCompletedField.maxValue = 100;
            if (currentTaskStatus === 'CONCLUDE'){
                Util.doAsync(function(){
                    percentCompletedField.value(100);
                });
            }else if (currentTaskStatus === 'PAUSE'){
                percentCompletedField.maxValue = 99;
                if(percentCompletedField.value() >= 100){
                    percentCompletedField.value(99);
                }
            }
        });
    };

    var removeMasterFilesFromData = function(directoriesStatus) {
        var paths = getInfoTaskWidget().currentRow.PATHS;
        var task = getInfoTaskWidget().currentRow.ID;
        var row = {};
        var dirWithoutConflict = [];
        var dirWithConflict = [];

        directoriesStatus.forEach(function(dir) {
            var status = dir.status.trim().split('\n');
            var arrayStatus = [];
            dir.branchInConflict = false;
            status.filter(function (file) {
                file = file.trim();
                arrayStatus.push(file.substr(0, file.indexOf(' ')));
            });
            arrayStatus.forEach(function (legend) {
                if (CONFLICT_TYPES[legend] !== undefined) {
                    dir.branchInConflict = true;
                }
            });
        });

        directoriesStatus.filter(function(directory) {
          if(directory.branchInConflict === true) {
            dirWithConflict.push(directory);
          } else {
            dirWithoutConflict.push(directory);
          }
        });
        if(dirWithConflict.length >0){
            var promises = dirWithConflict.map(function(dir) {
                paths.forEach(function(path) {
                    if (path.repository === dir.repository) {
                        row.REPOSITORY = path.ID;
                    }
                });
                row.FILES = dir.files;
                row.TASK = task.replace('T',"");
                row.changed = true;
                row.CONFLICT_ONLY = true;
                return requestDataSourceEngine.setDataSource('/bringChangedFilesByType', [row]).then(function(data) {
                    dir.files = data.dataset.bringChangedFilesByType.BRANCH_FILES;
                    dir.masterFiles = data.dataset.bringChangedFilesByType.MASTER_FILES;
                    masterFilesToCommit[dir.repository] = dir.masterFiles;
                    return dir;
                });
            }).concat(dirWithoutConflict);
            return ZHPromise.all(promises);
        } else {
           return ZHPromise.all(directoriesStatus);
        }
    };

    this.gitStatus = function (widget) {
        ScreenService.changeLoadingMessage(Messages.LOAD_SEARCHING_STATUS_TASK);
        ScreenService.showLoader();

        var task = widget.currentRow;
        var gitPopupWidget = getGitPopupWidget();
        var data;

        if (currentTaskStatus === 'STATUS') {
            hideGitPopupActions();
        }
        if(currentTaskStatus !== 'STATUS' && (currentTaskStatus !== 'COMMIT' && widget.currentRow  == 'D' )){
            gitPopupWidget.actions[2].isVisible = true;
        }

        AppropriationService.gitBranchResult = {};
        gitPopupWidget.dataSource.data = [];
        gitPopupWidget.dataSource.data.length = 0;
        Utilities.validateExecuteInWindows().then(function (isWindows) {
            task.PATHS.forEach(function (path) {
                path.dir = isWindows ? path.LOCAL_DIRECTORY : path.LINUX_DIRECTORY;
                path.isWindows = isWindows;
            });
            Utilities.localVar.setTaskPaths(Utilities.clone(task.PATHS));
            if (validateRepositoryAndDirectory(task.PATHS, task.DIRECTORIES_VALIDATION, isWindows)) {
                AppropriationService.loginBrowser(localStorageEngine.getLocalVar('login'));
                AppropriationService.gitModifiedFiles(factoryRepositoryPromise(task.PATHS))
                    .then(function (directoriesStatus) {
                        removeMasterFilesFromData(directoriesStatus).then(function (directoriesStatus) {
                            saveUnmodifiedDirectories(directoriesStatus);
                            if (currentTaskStatus && allCurrentTaskStatus.indexOf(currentTaskStatus) !== -1) {
                                if (validateStatus(directoriesStatus)) {

                                    ScreenService.hideLoader();
                                    ScreenService.openPopup(gitPopupWidget);
                                    setTimeout(function () {
                                        data = directoryStatusToTreeDataSource(directoriesStatus);
                                        data = arrayUnique(data);
                                        localStorageEngine.setDataSource('/git', data).then(function () {
                                            gitPopupWidget.reload();
                                            ScreenService.restoreDefaultLoadingMessage();
                                        });
                                    }, 1000);
                                } else {
                                    ScreenService.hideLoader();
                                    ScreenService.hideLoader();
                                    ScreenService.restoreDefaultLoadingMessage();
                                    if (currentTaskStatus !== 'STATUS' && currentTaskStatus !== 'COMMIT') {
                                        self.gitAddAppropriation(widget);
                                    } else {
                                        ScreenService.showMessage(Messages.ALE_NOT_GIT_STATUS_IN_BRANCH);
                                    }
                                }
                            } else {
                                data = directoryStatusToTreeDataSource(directoriesStatus);
                                ScreenService.openPopup(gitPopupWidget);
                                localStorageEngine.setDataSource('/git', data).then(function () {
                                    gitPopupWidget.reload();
                                    ScreenService.hideLoader();
                                    ScreenService.restoreDefaultLoadingMessage();
                                });
                            }
                        });
                    })
                    .catch(function (e) {
                        ScreenService.hideLoader();
                        ScreenService.hideLoader();
                        defaultError(e);
                        ScreenService.restoreDefaultLoadingMessage();
                    });
            }
        });
    };

    this.infoTaskActionEventStop = function(args) {
        returnToInfoTaskWidget = true;
        AppropriationService.gitBranchResult = {};
        var widget = getInfoTaskWidget();
        showGitPopupActions();
        ScreenService.showLoader();
        AppropriationService.validateMergeTaskConclude(widget.currentRow.ID).then(function (projects) {
            ScreenService.hideLoader();
            if (projects.length) {
                var messager = Utilities.messages.ERR_MERGE_PROJECT_PREVIOUS;
                projects.forEach(function(project){
                    messager+='<BR>"'+project.NAME+'"';
                });
                ScreenService.showMessage(messager);
            } else if (widget.currentRow.IN_HOMOLOGATION == 'Y') {
                getActionStopFromInfoTask().isVisible = false;
                ScreenService.showMessage(Utilities.messages.ERR_STOP_IN_HOMOLOGATION);
            } else {
                var widgetNewAppropriation = getWidgetNewAppropriation();
                widgetNewAppropriation.currentRow = {};
                widgetNewAppropriation.currentRow.__is_new = true;
                Utilities.localVar.setDescriptionControl(true);
                clearGlobalVariablesForGit();
                self.gitConclude(getWidgetInfoTask());
                if (ScreenService.isSideMenuOpen()) {
                    ScreenService.toggleSideMenu();
                }
            }
        }).catch(ScreenService.hideLoader);
    };

    this.gitConclude = function (widget) {

        if (ProjectManagementConfig.lockFinishTasks) {
            ScreenService.showMessage('Finalização de tarefas bloqueada. Procure o setor Zeedhi para mais informações.');
            return;
        }
        AppropriationService.gitBranchResult = {};
        filesWithStatus = [];
        ScreenService.changeLoadingMessage(Messages.LOAD_ENDING_TASK);
        ScreenService.showLoader();
        currentTaskStatus = 'CONCLUDE';

        if (getInfoTaskWidget().currentRow.TYPE_RELATIONSHIP === TYPE_RELATIONSHIP_MERGE_REQUEST) {
            validatePlayConcludeMergeRequestTask().then(function (validateMR) {
                if (validateMR) {
                    doGitConclude(widget);
                } else {
                    ScreenService.hideLoader();
                    ScreenService.restoreDefaultLoadingMessage();
                    ScreenService.showMessage(Messages.ALE_NOT_CONC_MERGE_REQUEST_TASK);
                }
            }).catch(function (e) {
                if (typeof e === 'object' && e.connectionError) {
                    ScreenService.hideLoader();
                } else if (e.data.hasOwnProperty('error')) {
                    defaultError(e.data.error);
                }
                ScreenService.hideLoader();
                ScreenService.restoreDefaultLoadingMessage();
            });
        } else {
            doGitConclude(widget);
        }
    };

    var showMessageErrorInSpecification = function(commentType){

        var validate = true;
        if (!commentType) {
            ScreenService.showMessage(Utilities.messages.ERR_TYPE_COMMENT_SPECIFICATION);
            validate= false;
        }else if (!commentType.CLASSIFICATION_ID) {
            ScreenService.showMessage(Utilities.messages.ERR_CLASSIFICATION_CUSTOMER_APPROVAL);
            validate= false;
        }else if (!commentType.TASK_STATUS_ID) {
            ScreenService.showMessage(Utilities.messages.ERR_TASK_STATUS_CUSTOMER_APPROVAL);
            validate= false;
        }
        if(!validate){
            getWidgetInfoTask().list();
        }
        return validate;
    };

    this.budgetWidgetAfterLoadDataSource = function(){
        var widget = getWidgetBudgetCustom();
        var isVisibleGenerateBudget = false;
        widget.dataSource.data.forEach(function(row){
            row.PROPOSAL_VALUE_inline = row.PROPOSAL_VALUE.replace('.',',');
            row.changed = true;
            isVisibleGenerateBudget = !!row.EXTERNAL_ID;
        });
        widget.list();

    };

    this.budgetActionSaveProductBudget = function(){
        var widgetCustom = getWidgetBudgetCustom();
        var widget = getWidgetBudget();
        var issueMain = getWidgetIssueMain();

        if(widget.isValid() && widget.currentRow.PRODUCT_ID) {
            IssueService.saveProductBudget(widget.currentRow,localStorageEngine.getLocalVar('issue')).then(function (result) {
                 getActionSaveProductFromBudgetTabbedWidget().isVisible = false;
            });
        }


    };

    this.budgetWidgetOnChange = function(){
        getActionSaveProductFromBudgetTabbedWidget().isVisible = true;
    };


     this.budgetOnChangeProposalQuantity = function(args){
        var row = args.row;
        var widget = getWidgetBudgetCustom();
        widget.inlineEdit();
        var setPercent = true;
        if(!(row.PROPOSAL_QUANTITY_inline && Number(row.PROPOSAL_QUANTITY_inline.replace(',','.')))){
            row.PROPOSAL_QUANTITY = 0;
            row.PROPOSAL_QUANTITY_inline = '0';
        }
        if(row.BUDGET_ITEM_ID == 'XXXX'){
            if(Number(row.PROPOSAL_QUANTITY_inline.replace(',','.')) > 100){
                row.PROPOSAL_QUANTITY = 100;
                row.PROPOSAL_QUANTITY_inline = '100';
            }
            var discountPercent = row.PROPOSAL_QUANTITY_inline.replace(',','.');
            var indexSubTotal = widget.groupedData.length-5;
            var subTotalProposalString = widget.groupedData[indexSubTotal].PROPOSAL_VALUE;
            var subTotalProposal = parseFloat(subTotalProposalString.replace(/[.]/g,'').replace(',','.'));
            var discount = (subTotalProposal * discountPercent/100).toFixed(2);
            row.PROPOSAL_VALUE = Number(discount);
            row.PROPOSAL_VALUE_inline = discount.replace('.',',');
            setPercent = false;
        }else{
            row.PROPOSAL_VALUE = row.PROPOSAL_QUANTITY_inline.replace(',','.') * row.ITEM_VALUE_TRUE;
        }
        widget.updateGroups();
        setDiscount(getRowDiscount(),setPercent);
        getActionSaveBudgetTabbedWidget().isVisible = true;
        getActionSaveProductFromBudgetTabbedWidget().isVisible = false;
        getWidgetBudget().reload();
    };

      var setDiscount = function(row,setPercent){
        var widget = getWidgetBudgetCustom();
        var discount = parseFloat(row.PROPOSAL_VALUE_inline.replace(/[.]/g,'').replace(',','.'));
        if(discount > 0){
            discount *= -1;
            row.PROPOSAL_VALUE_inline = '-'+row.PROPOSAL_VALUE_inline;
        }
        var indexSubTotal = widget.groupedData.length-5;
        var subTotalProposalString = widget.groupedData[indexSubTotal].PROPOSAL_VALUE;
        var subTotalProposal = parseFloat(subTotalProposalString.replace(/[.]/g,'').replace(',','.'));
        if(subTotalProposal + discount < 0){
            discount = subTotalProposal * -1;
            row.PROPOSAL_VALUE_inline = '-'+subTotalProposalString;
        }
        row.PROPOSAL_VALUE = Number( discount);
        if(setPercent){
            if(subTotalProposal){
                row.PROPOSAL_QUANTITY = Number((discount*100/subTotalProposal).toFixed(2))*-1;
            }else{

                row.PROPOSAL_QUANTITY = 0;
            }
        }
        widget.updateGroups();
        return discount;

    };

      var getRowDiscount = function(){
        var rowDiscount = null;
        getWidgetBudgetCustom().dataSource.data.some(function(row){
            if(row.BUDGET_ITEM_ID == "XXXX"){
                rowDiscount = row;
            }
        });

        return rowDiscount;
    };

       var budgetSave = function(){
        var widget = getWidgetBudgetCustom();
        widget.dataSource.save().then(function(){
            ScreenService.hideLoader();
            ScreenService.successNotification(Utilities.messages.SUC_BUDGETS_SAVE);
            widget.reload();
        }).catch(function(){
            ScreenService.hideLoader();
        });
    };


     this.budgetWidgetOnSaveInlineEdit = function(){
         getActionSaveBudgetTabbedWidget().isVisible = false;
        var widget = getWidgetBudget();
        if(widget.currentRow.changed){
            self.budgetActionSaveProductBudget();
        }
        ScreenService.showLoader();
        Util.doAsync(budgetSave);
        ScreenService.closePopup();

        var message = Utilities.messages.NOTIF_BUDGET_CREATED_CONTINUE_PROCESS;
        ScreenService.showCustomDialog(message, 'CONFIRMATION', null,
            [
                {
                    "label": "Sim",
                    "code": function () {
                        self.infoTaskActionEventStop();
                    }
                },
                {
                    "label": "Não",
                    "code": function () {}
                }
            ]
        );

    };

    var doGitConclude = function(widget) {
        var newAppropriation = getNewAppropriationWidget();
        if(newAppropriation.currentRow){
            newAppropriation.currentRow.SPECIFICATION_COMMENT = null;
        }
        validatePauseConcludeTaskNotGit().then(function(validate) {
            if(validate) {
                ScreenService.hideLoader();
                var infoTaskWidget = getWidgetInfoTask();
                if(infoTaskWidget.currentRow.CLASSIFICATION_CONTROL === CLASSIFICATION_SPECIFICATION) {
                    ScreenService.restoreDefaultLoadingMessage();
                    var specificationCommentWidget = getWidgetSpecificationCommentPopup();
                    specificationCommentWidget.list();
                    specificationCommentWidget.dataSource.data = [];
                    ScreenService.showLoader();
                    IssueService.validateFinishSpecificationTask(infoTaskWidget.currentRow).then(function(response) {
                        if(response.dataset.validateFinishSpecificationTask && response.dataset.validateFinishSpecificationTask.length > 0) {
                            specificationCommentWidget.newRow();
                            IssueService.validateSpecificationRequirements().then(function(commentType) {
                                ScreenService.hideLoader();
                                if (showMessageErrorInSpecification(commentType)) {
                                    var commentTypeDescription =  commentType.COMMENT_DESCRIPTION;
                                    var commentTypeId = commentType.ID;
                                    getFieldCommentTypeFromWidgetSpecificationCommentPopup().value(commentTypeId);
                                    getFieldCommentFromWidgetSpecificationCommentPopup().value(commentTypeDescription);
                                    var documentField = getFieldDocumentFromWidgetSpecificationCommentPopup();
                                    documentField.validations = commentType.ATTACHMENT_REQUIRED == 'Y' ? {
                                        "extensions": {
                                            "value": [
                                                ".pdf"
                                            ]
                                        },
                                        "minSize": {
                                            "value": 10
                                        },
                                        "required": {}
                                    } : {};
                                    loadSpecificationCommentPopupWidget().then(function(){
                                        ScreenService.openPopup(specificationCommentWidget);
                                    });
                                }
                            }).catch(Utilities.showMessageBackEndTrue);
                        } else {
                            ScreenService.hideLoader();
                            ScreenService.showMessage(Messages.ERR_FINISH_SPECIFICATION_TASK);
                            removeAllFieldsPmGeneration(getWidgetCreateNewTask());
                            getWidgetCreateNewTask().currentRow.ALL_PROJECTS = null;
                            getWidgetCreateNewTask().currentRow.ISSUES = null;
                            getWidgetCreateNewTask().currentRow.CLASSIFICATION = null;
                            getWidgetCreateNewTask().currentRow.CLASSIFICATION_NAME = null;
                            ScreenService.openPopup(getWidgetCreateNewTask());
                        }
                    }).catch(function (e) {
                         ScreenService.showMessage(e.error);
                        if(e.error.indexOf('Essa issue não possui orçamento cadastrado') > 1){
                            ScreenService.openPopup(getWidgetBudget());
                        }

                        ScreenService.hideLoader();
                    });



                } else {
                    self.gitAddAppropriation();
                    if (currentTaskStatus === 'CONCLUDE') {
                        Utilities.localVar.setDescriptionControl(false);
                        var response = widget.currentRow.RESPONSE;
                        if(response){
                            Utilities.localVar.setDescriptionControl(false);
                            getFieldDescriptionFromNewAppropriationWidget().value(response);
                        }
                    }
                }
            } else {
                self.gitStatus(widget);
            }
        }).catch(function (e) {
            if (typeof e === 'object' && e.connectionError) {
                ScreenService.hideLoader();
            } else if (e.data.hasOwnProperty('error')) {
                defaultError(e.data.error);
            }
            ScreenService.hideLoader();
            ScreenService.restoreDefaultLoadingMessage();
        });
    };

    var loadSpecificationCommentPopupWidget = function() {
        var widget = getWidgetSpecificationCommentPopup();
        var infoTaskWidget = getWidgetInfoTask();
        var field = getFieldCdItemtrabFromWidgetSpecificationCommentPopup();

        return TaskService.findItemtrabRelatedToIssuesByTaskId(infoTaskWidget.currentRow.TASK_ID).then(function(response){
            widget.currentRow.CDITEMTRAB = response.dataset.findItemtrabRelatedToIssuesByTaskId[0].CDITEMTRAB;
            return Utilities.bugPaginationOnSelectMultiplyOnModeView(field).then(function(){
                templateManager.updateTemplate();
                widget.redraw();
            });
        });
    };

    this.specificationCommentPopupActionEventSend = function(){
        var specificationCommentWidget = getWidgetSpecificationCommentPopup();
        if(specificationCommentWidget.currentRow.DOCUMENT[0].size > 0) {
            if(specificationCommentWidget.isValid()) {
                self.gitAddAppropriation();
                if (currentTaskStatus === 'CONCLUDE'){
                    Utilities.localVar.setDescriptionControl(false);
                }

                var newAppropriation = getNewAppropriationWidget();
                if(newAppropriation.currentRow){
                    newAppropriation.currentRow.SPECIFICATION_COMMENT = specificationCommentWidget.currentRow.COMMENT;
                    newAppropriation.currentRow.SPECIFICATION_COMMENT_TYPE = specificationCommentWidget.currentRow.COMMENT_TYPE;
                    newAppropriation.currentRow.SPECIFICATION_DOCUMENT = specificationCommentWidget.currentRow.DOCUMENT;
                    newAppropriation.currentRow.SPECIFICATION_CDITEMTRAB = specificationCommentWidget.currentRow.CDITEMTRAB;
                }
            } else {
                ScreenService.showMessage(Utilities.messages.ERR_REQUIRED_FIELDS);
            }
        } else {
            ScreenService.showMessage(Utilities.messages.ERR_UPLOAD_FILE_SIZE);
        }
    };

    this.specificationCommentPopupActionEventBack = function(){
        getListTasksWidget().activate();
        ScreenService.closePopup();
    };


    this.gitCallStatus = function (widget) {
        currentTaskStatus = 'STATUS';
        self.gitStatus(widget);
    };

    var showGitPopupActions = function () {
        var gitPopup = getGitPopupWidget();
        gitPopup.actions[1].isVisible = true;
        gitPopup.actions[2].isVisible = true;
        gitPopup.actions[3].isVisible = true;
    };

    this.backFromGitPopup = function () {
        showGitPopupActions();
        var gitPopupWidget = getGitPopupWidget();
        gitPopupWidget.label = 'Arquivos modificados não versionados';
        gitPopupWidget.showCheckbox = true;
        commit = [];
        reset = [];
        stash = [];
        getListTasksWidget().activate();
        gitPopupWidget.dataSource.clearCheckedRows();
        gitPopupWidget.updateCheckedRows();
        ScreenService.closePopup();
    };

    var getStartedTaskPaths = function (tasks) {
        var currentTask;
        tasks.forEach(function (task) {
            if (task.TASK_STATUS === 'D')
                currentTask = task;
        });
        return currentTask;
    };

    var createGenericBranchName = function (taskName, taskId) {
        taskId = getCurrentTaskId();
        return 'TASK_BKP_' + taskId + '_' + taskName;
    };

    var getCurrentTaskPaths = function () {
        var defer = ZHPromise.defer();
        var date = getStripeNavigatorWidget().currentRow.ESTIMATED_BEGIN_DATE;
        var filter = mountFilterByEstimatedBeginDate(date);
        var task = requestDataSourceEngine.getDataSource('/tasksFullDataByUser', filter).then(function (data) {
            var tasks = data.dataset.tasks;
            var currentTask;
            tasks.forEach(function (task) {
                if (task.TASK_STATUS === 'D') {
                    currentTask = task;
                }
            });
            return currentTask;
        });
        return ZHPromise.all(task);
    };

    var setDataSourcePendentStashesWidget = function(paths) {
        paths = paths.map(function (path) {
            return path.dir;
        });

        var userId = localStorageEngine.getLocalVar('idBusinessPartner');
        var taskStashRegExp = new RegExp("^TASK_BKP_STASH_" + userId + "_.*");

        return AppropriationService.listBranches(paths).then(function (branches) {
            branches = branches.filter(function (branchName) {
                return taskStashRegExp.test(branchName);
            });

            branches = branches.map(function (branchName) {
                return {
                    'STASH_BRANCH_NAME': branchName
                };
            });

            templateManager.container.getWidget('STASH_APPLY_POPUP').dataSource.data = branches;
            return branches;
        });
    };

    var setStashApplyActionVisibility = function(){
        var infoTaskWidget = getWidgetInfoTask();
        var taskListWidget = getListTasksWidget();
        if(infoTaskWidget.currentRow.EXTERNALTYPE === 'S' ||
            infoTaskWidget.currentRow.CLASSIFICATION_CONTROL === CLASSIFICATION_SPECIFICATION ||
            infoTaskWidget.currentRow.TYPE_RELATIONSHIP === TYPE_RELATIONSHIP_TEST || 
            (taskListWidget.currentRow && taskListWidget.currentRow.USEGITAUTOMATICALLY !== 'Y')) {
            infoTaskWidget.getAction('stash_apply').isVisible = false;
        } else {
            infoTaskWidget.getAction('stash_apply').isVisible = infoTaskWidget.currentRow.TASK_STATUS == TASK_STATUS.EM_DESENVOLVIMENTO;
        }
    };

    function mountFilterByEstimatedBeginDate(date) {
        return [{
            operator: '=',
            name: 'ESTIMATED_BEGIN_DATE',
            value: date
        }];
    }

    var validateNoTaskStarted = function (tasks) {
        var result = true;
        tasks.forEach(function (task) {
            if (task.TASK_STATUS === 'D') {
                result = false;
            }
        });
        return result;
    };

    this.stashApplyPopupActionEventRemoverStash = function(widget) {
        ScreenService.changeLoadingMessage(Messages.LOAD_REMOVING_STASHES_BRANCHES);
        ScreenService.showLoader();

        var pendentStash = widget.dataSource.data.length > widget.dataSource.checkedRows.length;
        var repoPaths = getListTasksWidget().currentRow.PATHS;
        var removeBranchesPromises = widget.dataSource.checkedRows.map(function (branch) {
            return AppropriationService.removeRemoteBranchesMR(repoPaths, branch.STASH_BRANCH_NAME);
        });

        ZHPromise.all(removeBranchesPromises).then(function () {
            Utilities.validateExecuteInWindows().then(function (isWindows) {
                var paths = getTaskPaths();
                paths.forEach(function (path) {
                    path.dir = isWindows ? path.LOCAL_DIRECTORY : path.LINUX_DIRECTORY;
                });
                localStorageEngine.setLocalVar('pendentStash', pendentStash);
                setStashApplyActionVisibility();
                setDataSourcePendentStashesWidget(paths).then(function () {
                    ScreenService.hideLoader();
                    ScreenService.restoreDefaultLoadingMessage();
                });
            }).catch(function (e) {
                setStashApplyActionVisibility();
                callGenericErrorMessage(e);
                ScreenService.hideLoader();
                ScreenService.restoreDefaultLoadingMessage();
            });
        });
    };

    var diffRepositoryForPath = function (paths, repository, urls) {
        if (!paths.some(function (path) {
                if (path.repository == repository.REPOSITORY_URL) {
                    return true;
                }
            })) {
            urls.push(repository.REPOSITORY_URL);
        }
        return urls;
    };
    var diffRepositoriesForStash = function (stashBranchName, paths) {
        var defer = ZHPromise.defer();
        var taskId = getTaskIdForStash(stashBranchName);
        if(getTaskId() != taskId){
            var filter = [
                {
                    "operator": "=",
                    "name": "TASK_ID",
                    "value": taskId
                }
            ];
            requestDataSourceEngine.getDataSource('/getRepositoriesByTaskId', filter).then(function (request) {
                var urls = [];
                if (request && request.dataset && request.dataset.getRepositoriesByTaskId) {
                    request.dataset.getRepositoriesByTaskId.forEach(function (repository) {
                        urls = diffRepositoryForPath(paths, repository, urls);
                    });
                }
                defer.resolve(urls);
            }).catch(defer.reject);
        }else{
            defer.resolve([]);
        }
        return defer.promise;
    };

    var compareRepositoryForStash = function(paths, stashBranchName) {
        var defer = ZHPromise.defer();
        diffRepositoriesForStash(stashBranchName, paths).then(function(urls){
            if(urls.length){
                var message = Utilities.messages.ALE_DIFF_REPOSITORY_FROM_STASH;
                urls.forEach(function(url){
                    message += '<BR>"' + url + '"';
                });
                message += '<BR><BR>Deseja continuar?';
                ScreenService.showCustomDialog(message, 'CONFIRMATION', null,
                    [
                        {
                            "label": "Sim",
                            "code": function () {
                                defer.resolve(urls);
                            }
                        },
                        {
                            "label": "Não",
                            "code": function () {
                                defer.reject();
                            }
                        }
                    ]
                );
            }else{
                defer.resolve(urls);
            }
        });
        return defer.promise;
    };

    this.stashApplyPopupActionEventStashApply = function(args) {
        ScreenService.changeLoadingMessage(Messages.LOAD_APPLYING_STASH);
        var stashApplyWidget = templateManager.container.getWidget('STASH_APPLY_POPUP');
        ScreenService.showLoader();

        var pendentStash = args.dataSource.data.length > 1;
        Utilities.validateExecuteInWindows().then(function (isWindows) {
            var repoPaths = getTaskPaths();
            var task = getWidgetInfoTask().currentRow;
            repoPaths.forEach(function (path) {
                path.dir = isWindows ? path.LOCAL_DIRECTORY : path.LINUX_DIRECTORY;
            });
            AppropriationService.gitModifiedFiles(factoryRepositoryPromise(task.PATHS))
                .then(function (directoriesStatus) {
                    var files = directoryStatusToTreeDataSource(directoriesStatus);
                    files = arrayUnique(files);
                    if (!files.length) {
                        compareRepositoryForStash(task.PATHS, args.row.STASH_BRANCH_NAME).then(function () {
                                AppropriationService.gitStashApplyWithBranch(repoPaths, args.row.STASH_BRANCH_NAME)
                                    .then(function () {
                                        setStashApplyActionVisibility();
                                        ScreenService.hideLoader();
                                        ScreenService.restoreDefaultLoadingMessage();
                                        ScreenService.successNotification(Messages.SUC_STASH_APPLY_SUCCEED, 7000);
                                        ScreenService.closePopup();
                                        localStorageEngine.setLocalVar('pendentStash', pendentStash);
                                    }).catch(function (e) {
                                        ScreenService.hideLoader();
                                        ScreenService.restoreDefaultLoadingMessage();
                                        if (hasConflictException(e)) {
                                            callConflictMessage();
                                            ScreenService.closePopup(stashApplyWidget);
                                            getListTasksWidget().activate();
                                            AppropriationService.removeRemoteBranchesMR(repoPaths, args.row.STASH_BRANCH_NAME)
                                                .then(function () {
                                                    setStashApplyActionVisibility();
                                                    localStorageEngine.setLocalVar('pendentStash', pendentStash);
                                                });
                                        } else {
                                            ScreenService.showMessage(Utilities.messages.ERR_STASH_APPLY);
                                        }
                                        setStashApplyActionVisibility();
                                    });
                        }).catch(function(){
                            ScreenService.hideLoader();
                        });
                    } else {
                        ScreenService.hideLoader();
                        var gitPopupWidget = getGitPopupWidget();
                        gitPopupWidget.label = 'Arquivos modificados';
                        gitPopupWidget.showCheckbox = false;
                        localStorageEngine.setLocalVar('DIRTY_DIRECTORY', true);
                        localStorageEngine.setDataSource('/git', files).then(function () {
                            gitPopupWidget.reload().then(function () {
                                ScreenService.showMessage(Messages.ALE_DIRTY_DIRECTORY_WITH_STASH);
                                ScreenService.closePopup(true);
                                ScreenService.openPopup(gitPopupWidget);
                                ScreenService.hideLoader();
                            });
                        });
                        ScreenService.restoreDefaultLoadingMessage();
                    }
                });
        });
    };

    var validateRepositoryForStash = function(paths,stashBranchName){
        var userId = localStorageEngine.getLocalVar('idBusinessPartner');
        stashBranchName.replace('TASK_BKP_STASH_'  + userId + '_','');
        var defer = ZHPromise.defer();
        defer.reject(paths);
    };

    var getTaskIdForStash = function(stashBranchName){
        var userId = localStorageEngine.getLocalVar('idBusinessPartner');
        return stashBranchName.replace('TASK_BKP_STASH_'  + userId + '_','').split("_")[0];
    };

    this.infoTaskActionEventStashApply = function(args) {
        self.stashApplyNotification();
    };

    this.stashApplyPopupActionEventBack = function(args) {
        ScreenService.closePopup(true);
        getInfoTaskWidget().activate();
    };

    this.stashApplyNotification = function () {
        ScreenService.showLoader();
        Utilities.validateExecuteInWindows().then(function (isWindows) {
            var paths = getTaskPaths();
            paths.forEach(function (path) {
                path.dir = isWindows ? path.LOCAL_DIRECTORY : path.LINUX_DIRECTORY;
            });
            setDataSourcePendentStashesWidget(paths).then(function (branches) {
                if (branches.length > 0) {
                    ScreenService.openPopup(templateManager.container.getWidget('STASH_APPLY_POPUP'));
                } else {
                    ScreenService.showMessage(Messages.ALE_NOT_PENDENT_STASH);
                }
                ScreenService.hideLoader();
            }).catch(function (e) {
                ScreenService.hideLoader();
                defaultError(e);
            });
        });
    };

    var getFilesToResolve = function () {
        var modifiedFiles = templateManager.container.getWidget('GIT_POPUP').dataSource.data;
        var checkedRows = templateManager.container.getWidget('GIT_POPUP').dataSource.checkedRows;
        var filesToResolve = [];
        checkedRows.forEach(function(row) {
                if(row._childCount === 0 ) {
                    filesToResolve.push(row);
                }
        });

        return uniques(filesToResolve);
    };

    var setDirProperty = function (modifiedFiles) {
        modifiedFiles.forEach(function (file) {
            file.isDir = file._childCount > 0;
        });
        return modifiedFiles;
    };

    var setModifiedFilesStatus = function (filesToResolve, modifiedFiles, fileStatus) {
        var children = [];
        filesToResolve.forEach(function (file) {
            if (file.isDir === true) {
                modifiedFiles.forEach(function (modifiedFile) {
                    if (modifiedFile.PARENT_DIR === file.DIR) {
                        modifiedFile.gitStatus = fileStatus;
                        filesWithStatus.push(modifiedFile);
                    }
                });
            } else {
                file.gitStatus = fileStatus;
                filesWithStatus.push(file);
            }

        });
    };

    var getFilesToStatusGrid = function (filesToResolve, modifiedFiles) {
        var children;
        for (var key in modifiedFiles) {
            for (var count in filesToResolve) {
                if (modifiedFiles[key] === filesToResolve[count]) {
                    if (modifiedFiles[key]._parent !== null) {
                        modifiedFiles[key]._parent._childCount--;
                    }
                    modifiedFiles.splice(key, 1);
                }
            }
        }
        return ZHPromise.all(modifiedFiles);
    };

    var verifyParentWithoutChildInGrid = function (notResolvedFiles) {
        var parentFiles = [];
        var defer = ZHPromise.defer();
        for (var key in notResolvedFiles) {
            for (var count in notResolvedFiles) {
                if (notResolvedFiles[key].DIR === notResolvedFiles[count].PARENT_DIR)
                    notResolvedFiles[key].hasChild = true;
            }
        }
        notResolvedFiles.reverse();
        for (var index = 0; index < notResolvedFiles.length; index++) {
            if ((notResolvedFiles[index]._childCount === 0 && notResolvedFiles[index].isDir === true) ||
                notResolvedFiles[index]._childCount === 0 && notResolvedFiles[index]._level === 1) {
                if (notResolvedFiles[index]._parent !== null)
                    notResolvedFiles[index]._parent._childCount--;
                notResolvedFiles.splice(index, 1);
                index--;
            } else {
                notResolvedFiles[index].hasChild = false;
            }
        }
        notResolvedFiles.reverse();
        return ZHPromise.all(notResolvedFiles);
    };

    var verifySelectAllfiles = function (notResolvedFiles, filesToCommit) {
        var defer = ZHPromise.defer();
        for (var key = 0; key < filesToCommit.length; key++) {
            for (var count = 0; count < notResolvedFiles.length; count++) {
                if (filesToCommit[key].DIR === notResolvedFiles[count].PARENT_DIR) {
                    filesToCommit.push(notResolvedFiles[count]);
                    notResolvedFiles.splice(count, 1);
                    count--;
                }
            }
        }
        if (notResolvedFiles.length > 0)
            defer.reject(notResolvedFiles);
        else
            defer.resolve();

        return defer.promise;
    };

    var verifyAllFiles = function (filesToResolve, modifiedFiles) {
        var defer = ZHPromise.defer();
        getFilesToStatusGrid(filesToResolve, modifiedFiles).then(function (resultFiles) {
            return verifyParentWithoutChildInGrid(resultFiles);
        }).then(function (resultFiles) {
            return verifySelectAllfiles(resultFiles, filesToResolve);
        }).then(function () {
            defer.resolve();
        }).catch(function (data) {
            defer.reject(data);
        });
        return defer.promise;
    };

    this.resetAndStashFiles = function() {
        ScreenService.showLoader();
        AppropriationService.gitResetAndStashFiles(factoryResetPromise, factoryStashPromise, getStashBranchName())
            .then(function () {
                ScreenService.hideLoader();
                ScreenService.restoreDefaultLoadingMessage();
                ScreenService.closePopup(true);
                getInfoTaskWidget().activate();
                self.gitPlay(getInfoTaskWidget());
            }).catch(function (e) {
                ScreenService.hideLoader();
                defaultError(e.data);
            });
    };

    var saveFilesToResolve = function (modifiedFiles, filesToResolve) {
        verifyAllFiles(filesToResolve, modifiedFiles).then(function () {
            if(localStorageEngine.getLocalVar('DIRTY_DIRECTORY')) {
                if(stash.length > 0) {
                    ScreenService.openPopup(getStashNamePopupWidget());
                } else {
                    self.resetAndStashFiles();
                }
            } else if (currentTaskStatus == 'COMMIT') {
                openPopupCommitComment();
            } else {

                self.gitAddAppropriation();
            }
        }, function (data) {
            localStorageEngine.setDataSource('/git', data).then(function () {
                getGitPopupWidget().reload();
                templateManager.updateTemplate();
            });
        });

    };

    var verifyRename = function(filesToReset){
        var temporaryName;
        var renameFlag = " -> ";
        filesToReset.forEach(function(fileToReset){
            if(fileToReset.FILE_STATUS == renamed_Status){
                var oldFile = Object.assign({}, fileToReset);
                temporaryName = fileToReset.FILE_NAME.split(renameFlag);
                fileToReset.FILE_NAME = temporaryName[1];
                oldFile.FILE_NAME = temporaryName[0];
                fileToReset.FILE_STATUS = untracked_Status;
                oldFile.FILE_STATUS = modified_Status;
                fileToReset.DIR = oldFile.DIR.split(oldFile.FILE_NAME.concat(renameFlag));
                fileToReset.DIR = fileToReset.DIR[0].concat(fileToReset.DIR[1]);
                oldFile.DIR = oldFile.DIR.split(renameFlag);
                oldFile.DIR = oldFile.DIR[0];
                filesToReset.push(oldFile);
            }
        });
        return filesToReset;
    };

    this.reset = function (widget) {
        var filesToReset = getFilesToResolve();
       filesToReset = verifyRename(filesToReset);
        var fileStatus = 'R';
        var modifiedFiles = widget.dataSource.data;
        modifiedFiles = setDirProperty(modifiedFiles);
        setModifiedFilesStatus(filesToReset, modifiedFiles, fileStatus);
        if (reset.length > 0)
            reset = reset.concat(filesToReset);
        else
            reset = filesToReset;
        saveFilesToResolve(modifiedFiles, filesToReset);
    };

    this.commit = function (widget) {
        var filesToCommit = getFilesToResolve();
        var fileStatus = 'C';
        var modifiedFiles = widget.dataSource.data;
        modifiedFiles = setDirProperty(modifiedFiles);
        setModifiedFilesStatus(filesToCommit, modifiedFiles, fileStatus);
        if (commit.length > 0)
            commit = commit.concat(filesToCommit);
        else
            commit = filesToCommit;
        saveFilesToResolve(modifiedFiles, filesToCommit);
    };

    this.stash = function (widget) {
        var filesToStash = getFilesToResolve();
        var fileStatus = 'S';
        var modifiedFiles = widget.dataSource.data;
        modifiedFiles = setDirProperty(modifiedFiles);
        setModifiedFilesStatus(filesToStash, modifiedFiles, fileStatus);
        if (stash.length > 0)
            stash = stash.concat(filesToStash);
        else
            stash = filesToStash;
        saveFilesToResolve(modifiedFiles, filesToStash);
    };

    this.infoTaskActionEventGenerateTask = function(args) {
        Utilities.localVar.setDescriptionControl(true);
        infoTaskActionEventGenerateTask(false);
    };

    var setDefaultValuesGenerateTaskWidget = function (widgetGenerate, widgetInfoTask, typeRelationship, projectId, conflict) {
        var resourceRating =  widgetGenerate.currentRow['RESOURCE_RATING_'+projectId];
        var typeRelationshipValue = '';
        var oldDescriptionFieldTaskGenerate = widgetGenerate.oldDescriptionFieldTaskGenerate || '';
        var typeRelationshipField = getFieldTypeRelationshipFromGenerateTask();

        if (typeRelationship === TYPE_RELATIONSHIP_TEST) {
            projectId = widgetInfoTask.currentRow.PROJECT_ID;
            typeRelationshipValue = TYPE_RELATIONSHIP_ERROR;
            if (widgetInfoTask.currentRow.ORIGIN_TEST_PROJECT_ID) {
                widgetGenerate.currentRow['PROJECT_' + projectId] = widgetInfoTask.currentRow.ORIGIN_TEST_PROJECT_ID;
                widgetGenerate.currentRow['PROJECT_NAME_' + projectId] = widgetInfoTask.currentRow.ORIGIN_TEST_PROJECT_NAME;
            } else {
                widgetGenerate.currentRow['PROJECT_' + projectId] = widgetInfoTask.currentRow.ORIGIN_PROJECT_ID;
                widgetGenerate.currentRow['PROJECT_NAME_' + projectId] = widgetInfoTask.currentRow.ORIGIN_PROJECT_NAME;
            }
        } else if (typeRelationship === TYPE_RELATIONSHIP_MERGE_REQUEST) {
            if(conflict){
                typeRelationshipValue = TYPE_RELATIONSHIP_CONFLICT;
            } else{
                typeRelationshipValue = TYPE_RELATIONSHIP_ERROR_MR;
            }

        }

        typeRelationshipField.value(typeRelationshipValue);
        widgetGenerate.currentRow.TASK_GENERATOR_NAME = widgetInfoTask.currentRow.TASK_NAME;
        widgetGenerate.currentRow.TASK_GENERATOR = widgetInfoTask.currentRow.TASK_ID;
        widgetGenerate.currentRow.NAME = widgetInfoTask.currentRow.TASK_NAME;
        widgetGenerate.currentRow.START = moment().format('DD/MM/YYYY');
        widgetGenerate.currentRow.END = moment().format('DD/MM/YYYY');
        widgetGenerate.currentRow.DESCRIPTION = oldDescriptionFieldTaskGenerate;
        widgetGenerate.currentRow.DOCUMENT = '';

        var filterRelationship = [{
            "operator": "=",
            "name": "TASK_RELATIONSHIP",
            "value": widgetInfoTask.currentRow.TASK_ID
        },
        {
            "operator": "IN",
            "name": "TYPE",
            "value": Messages.TYPE_GENERATED_TASK_WITHOUT_ORIGIN_AND_RELATED
        }];
        return requestDataSourceEngine.getDataSource('/generatedTaskRelationship', filterRelationship).then(function (data) {
            var dataTypeRelationship = Messages.DATA_TYPE_RELATIONSHIP_TASK;
            var relationship = data.dataset.generatedTaskRelationship;
            if (relationship.length > 0 && relationship[0].TYPE === TYPE_RELATIONSHIP_MERGE_REQUEST) {
                dataTypeRelationship = Messages.DATA_TYPE_RELATIONSHIP_TASK_MR;
            } else if (relationship.length > 0 && relationship[0].TYPE === TYPE_RELATIONSHIP_TEST) {
                dataTypeRelationship = Messages.DATA_TYPE_RELATIONSHIP_TASK_TEST;
            }
            var filterControl = dataTypeRelationship.map(function (taskRelationship) {
                return taskRelationship.VALUE;
            });
            var filterRequest = [{
                "name": "CONTROL",
                "value": filterControl,
                "operator": "IN"
            }];
            var estimatedTimeProportion = 1;
            return ProjectServiceList.getClassification(filterRequest).then(function (data) {
                dataTypeRelationship = data.dataset.classification.map(function (classification) {
                    classification.VALUE = classification.CONTROL;
                    classification.DESCRIPTION = classification.LABEL;
                    classification.ESTIMATED_TIME_PROPORTION = classification.ESTIMATED_TIME_PROPORTION ? classification.ESTIMATED_TIME_PROPORTION / 100 : 1;
                    if (typeRelationshipValue == classification.CONTROL) {
                        estimatedTimeProportion = classification.ESTIMATED_TIME_PROPORTION;
                    }
                    return classification;
                });

                typeRelationshipField.dataSource.data = dataTypeRelationship;

                var baseTimePlanned = widgetInfoTask.currentRow.FIRST_TIME_PLANNED || widgetInfoTask.currentRow.TIME_PLANNED;
                widgetGenerate.currentRow.GENE_TASK_TOTAL_TIME = baseTimePlanned;
                widgetGenerate.currentRow.TOTAL_TIME = Utilities.secondsToDurationHour((baseTimePlanned * estimatedTimeProportion) / resourceRating);

            });
        });
    };

    self.generateTaskFieldOnChangeType = function(){
        var generateTaskWidget = getWidgetGenerateTask();
        var baseTimePlanned = generateTaskWidget.currentRow.GENE_TASK_TOTAL_TIME;
        var typeRelationshipField = getFieldTypeRelationshipFromGenerateTaskidget();
        var classification = Utilities.findInDataSource(typeRelationshipField,[typeRelationshipField.value()],typeRelationshipField.valueField)[0];
        generateTaskWidget.currentRow.TOTAL_TIME = Utilities.secondsToDurationHour(baseTimePlanned * classification.ESTIMATED_TIME_PROPORTION,true);
    };

    this.taskListWidgetActionEventAddTask = function(){


        ScreenService.openPopup(getWidgetUnatendedTasks());
    };

    this.taskListActionEventBack = function(){
        ScreenService.closePopup(true);
        getListTasksWidget().activate();
    };

    this.taskListActionEventSave = function(){
        var checkedRows = getWidgetUnatendedTasks().getCheckedRows();
        if(checkedRows){
            AppropriationService.allocateMultipleTasks(checkedRows).then(function (data) {
                if(data.length == 1){
                    var msg = Utilities.messages.ALE_START_TASK.replace('__TASK_NAME__', data[0].TASK_NAME);
                    ScreenService.showCustomDialog(msg , 'CONFIRMATION', null,
                        [ {
                            "label": "Sim",
                            "code": function () {

                                checkedRows[0].ALLOCATION = data[0].ALLOCATION;
                                checkedRows[0].RESOURCE_T = data[0].RESOURCE;
                                validateTwoStartedTasks(null).then(function () {
                                    TaskService.validateTaskToBeStarted(data[0].TASK_ID).then(function(response) {
                                        ScreenService.hideLoader();
                                        if(response.status == OK_STATUS){
                                            getListTasksWidget().reload().then(function () {
                                                var widgetInfoTask = getWidgetInfoTask();
                                                var widgetTabbed = widgetInfoTask.container.getWidget('TABBED_APPROPRIATION');
                                                Utilities.localVar.setLocalVarTaskId(checkedRows[0].TASK_ID);
                                                localStorageEngine.setLocalVar('taskID', 'T' + checkedRows[0].TASK_ID);
                                                Utilities.localVar.setTaskAllocationId(checkedRows[0].ALLOCATION);
                                                Utilities.localVar.setClickedTaskName(checkedRows[0].TASK_NAME);
                                                ScreenService.showLoader();
                                                widgetTabbed.moveToFirst();
                                                ScreenService.openSwipe(widgetTabbed);
                                                ScreenService.hideLoader();

                                                if(checkedRows[0].USEGITAUTOMATICALLY != 'Y'){
                                                    setCurrentTaskId(checkedRows[0].TASK_ID);
                                                    checkedRows[0].ID = checkedRows[0].TASK_ID;
                                                    changeToStart(checkedRows[0]);
                                                }else{
                                                    AppropriationService.getInfoTask(checkedRows[0]).then(function (result) {
                                                        setCurrentTaskId(checkedRows[0].TASK_ID);
                                                        startTask(result);
                                                    });
                                                }
                                            }).catch(ScreenService.hideLoader);
                                        } else {
                                            ScreenService.showMessage(response.msg);
                                        }
                                    }).catch(Utilities.showMessageBackEndTrue);

                                }).catch(function (tasks) {
                                    var tasksAndProjects = [];
                                    tasks.filter(function (task) {
                                        var taskAndProjectName = 'Tarefa: "' + task.TASK + '" (Projeto: "' + task.PROJECT + '").';
                                        tasksAndProjects.push(taskAndProjectName);
                                    });
                                    tasksAndProjects = tasksAndProjects.join('<br/>');
                                    ScreenService.hideLoader();
                                    ScreenService.showMessage(Messages.ERR_START_TASKS + '<br/>' + tasksAndProjects);
                                });
                            }
                        }, {
                            "label": "Não",
                            "code": function () {}
                        } ]
                    );
                }
                ScreenService.closePopup(true);
                getListTasksWidget().reload();
                getListTasksWidget().activate();
            });
        }
    };

    this.listTasksWidgetOnEnter = function(){
        getWidgetUnatendedTasks().reload();
    };

    var infoTaskActionEventGenerateTask = function(conflict) {
        returnToInfoTaskWidget = true;
        returnToTimeByActivity = false;
        var widgetGenerate = getWidgetGenerateTask();
        Utilities.removeAllFieldsPmGeneration(widgetGenerate);
        var widgetInfoTask = getWidgetInfoTask();
        var typeRelationship = widgetInfoTask.currentRow.TYPE_RELATIONSHIP;
        var resource = widgetInfoTask.currentRow.RESOURCE_GENERATOR_TASK;
        var widgetListTask = getListTasksWidget();

        var fields = widgetGenerate.fields;
        var projects = widgetInfoTask.currentRow.DIRECTORIES_VALIDATION.PROJECTS;
        var allProjectIds = [];
        var projectId = projects[0];
        var promises = projects.map(function(project) {
            projectId = project.PROJECT_ID;
            var originProjectId = widgetInfoTask.currentRow.ORIGIN_TEST_PROJECT_ID;
            var originProjectName = widgetInfoTask.currentRow.ORIGIN_TEST_PROJECT_NAME;
            if(typeRelationship == TYPE_RELATIONSHIP_TEST && originProjectId) {
                projectId = originProjectId;
            }
            allProjectIds.push(projectId);
            if(validateFieldCreated(fields, projectId)) {
                var taskNameField = self.getTaskNameFieldMergeRequest(projectId, widgetGenerate);
                var resourceNameField = self.getResourceNameFieldMergeRequest(projectId, widgetGenerate);
                var projectField = self.getProjectFieldMergeRequest(projectId, widgetGenerate);

                widgetGenerate.fields.unshift(taskNameField);
                widgetGenerate.fields.unshift(resourceNameField);
                widgetGenerate.fields.unshift(projectField);
                if(typeRelationship == TYPE_RELATIONSHIP_MERGE_REQUEST) {
                    projectField.value(project.PROJECT_NAME);
                    getFieldErrorClassificationFromGenerateTask().isVisible = false;
                } else if(typeRelationship == TYPE_RELATIONSHIP_TEST && originProjectName) {
                    projectField.value(originProjectName);
                    getFieldErrorClassificationFromGenerateTask().isVisible = true;
                } else if(typeRelationship == TYPE_RELATIONSHIP_TEST) {
                    projectField.value(project.PROJECT_NAME);
                    getFieldErrorClassificationFromGenerateTask().isVisible = true;
                }

                return taskNameField.reload().then(function () {
                    return resourceNameField.reload();
                }).then(function() {
                    var task = widgetListTask.currentRow.PARENT;
                    if (Utilities.isNotEmptyArray(Utilities.findInDataSource(taskNameField, [task], 'ID'))) {
                        Utilities.setValueInSelectField(taskNameField, task);
                    }
                    if (Utilities.isNotEmptyArray(Utilities.findInDataSource(resourceNameField, [resource], 'ID'))) {
                        Utilities.setValueInSelectField(resourceNameField, resource);
                    }
                });
            }
        });

        ScreenService.showLoader();
        ZHPromise.all(promises).then(function() {
            getFieldTaskClassificationLabelFromGenerateTask().reload();
            getFieldTaskStatusNameFromGenerateTask().reload();
            getFieldErrorClassificationFromGenerateTask().reload();
            widgetGenerate.fields = pmGenerationProjectIdFilter(fields, allProjectIds);
            setDefaultValuesGenerateTaskWidget(widgetGenerate, widgetInfoTask, typeRelationship,projectId, conflict).then(function() {
                ScreenService.hideLoader();
                if(widgetInfoTask.currentRow.USE_TIME_PLANNING  == 'N'){
                    widgetGenerate.getField('TOTAL_TIME').isVisible = false;
                    widgetGenerate.getField('TOTAL_TIME').validations = {};
                    widgetGenerate.currentRow.TOTAL_VALUE = 1;
                } else {
                    widgetGenerate.getField('TOTAL_TIME').isVisible = true;
                    widgetGenerate.getField('TOTAL_TIME').validations.required = {};
                }
                ScreenService.openPopup(widgetGenerate);
            }).catch(ScreenService.hideLoader);
        }).catch(ScreenService.hideLoader);
    };

    this.generateTaskActionEventBack = function(args) {
        ScreenService.closePopup();
        getWidgetInfoTask().activate();
    };

    this.documentsActionEventBack = function(args) {
        ScreenService.closeSwipe();
        getListTasksWidget().activate();
    };

    this.documentsActionEventBackView = function(args) {
        ScreenService.closeSwipe();
    };

    this.documentsActionEventDownload = function (args) {
        var documentId = getDocumentsWidget().currentRow.ID;
        Utilities.downloadAttachment(documentId);
    };

    this.popupDiffActionEventBack = function(args) {
        ScreenService.showLoader();
        ScreenService.closePopup();
    };

    var getTaskClassificationRowByControl = function(control){
        return Utilities.getRowInDataSource(getFieldTaskClassificationLabelFromGenerateTask().dataSource,'CONTROL',control);
    };

    var getTaskStatusRowByControl = function(control){
        return Utilities.getRowInDataSource(getFieldTaskStatusNameFromGenerateTask().dataSource,'CONTROL',control);
    };

    var getDataNewTaskToGenerate = function(widgetGenerate) {
        var typeRelationship = widgetGenerate.currentRow.TYPE_RELATIONSHIP;
        var classificationRow = getTaskClassificationRowByControl(typeRelationship);
        var taskStatus = getInitialTaskStatus();

        return {
            DESCRIPTION: widgetGenerate.currentRow.DESCRIPTION,
            CLASSIFICATION_CONTROL: typeRelationship,
            TASK_STATUS: taskStatus,
            TYPE_RELATIONSHIP: typeRelationship,
            TASK_CLASSIFICATION : classificationRow ? classificationRow.ID : null,
            TASK_INFO: {
                mergeRequestStable : null,
                start              : widgetGenerate.currentRow.START,
                end                : widgetGenerate.currentRow.END,
                totalTime          : widgetGenerate.currentRow.TOTAL_TIME,
                parent             : widgetGenerate.currentRow.TASK,
                resource           : widgetGenerate.currentRow.RESOURCE[0]
            }
        };
    };

    var getDataNewTaskToGenerateMultiple = function(widgetGenerate, projects, relatedTask) {
        var typeRelationship = widgetGenerate.currentRow.TYPE_RELATIONSHIP;
        var classificationRow = getTaskClassificationRowByControl(typeRelationship);
        var taskStatus = getInitialTaskStatus();
        var infoTaskRow = getInfoTaskWidget().currentRow;

        var startDate = widgetGenerate.currentRow.START.split("/").reverse().join("-");
        var endDate = widgetGenerate.currentRow.END.split("/").reverse().join("-");

        var tasks = projects.map(function (project) {
            var projectId = project.PROJECT_ID;
            var originTestProject = getInfoTaskWidget().currentRow.ORIGIN_TEST_PROJECT_ID;
            if(typeRelationship == TYPE_RELATIONSHIP_ERROR && originTestProject) {
                projectId = originTestProject;
            }
            return {
                RESOURCE: [widgetGenerate.currentRow['RESOURCE_' + projectId]],
                PARENT: widgetGenerate.currentRow['TASK_' + projectId],
                TYPE_RELATIONSHIP: typeRelationship,
                DESCRIPTION: widgetGenerate.currentRow.DESCRIPTION,
                START: startDate,
                END: endDate,
                NAME: Utilities.includeTaskTypeInTaskName(widgetGenerate.currentRow.NAME, typeRelationship),
                PROJECT: projectId,
                TASK_STATUS: taskStatus,
                TOTAL_TIME: widgetGenerate.currentRow.TOTAL_TIME,
                TASK_CLASSIFICATION: classificationRow ? classificationRow.ID : null,
                PRODUCT_VERSION_ID: infoTaskRow.PRODUCT_VERSION_ID,
                ERROR_CLASSIFICATION_ID: widgetGenerate.currentRow.ERROR_CLASSIFICATION_ID,
                __is_new: true,
                changed: true
            };
        });

        return {
            TASKS: tasks,
            IS_RELATED_TASK: relatedTask,
            FINISHED_TASK: getCurrentTaskId(),
            NOT_SET_TOTAL_TIME: true,
            DOCUMENT: widgetGenerate.currentRow.DOCUMENT,
            changed: true
        };
    };

    this.generateTaskActionEventGenerate = function(args) {
        var widgetGenerate = getWidgetGenerateTask();
        var widgetInfoTask = getWidgetInfoTask();
        var widgetListTask = getListTasksWidget();
        var directoriesValidation = widgetInfoTask.currentRow.DIRECTORIES_VALIDATION;

        if (widgetGenerate.isValid()) {
            widgetGenerate.oldDescriptionFieldTaskGenerate = widgetGenerate.currentRow.DESCRIPTION;
            var rowToGenerate = getDataNewTaskToGenerateMultiple(widgetGenerate, directoriesValidation.PROJECTS, directoriesValidation.IS_RELATED_TASK);
            getWidgetNewAppropriation().currentRow.__is_new = true;
            if(widgetInfoTask.currentRow.TASK_STATUS == TASK_STATUS.EM_DESENVOLVIMENTO) {
                generateTask = true;
                ScreenService.closePopup(true);
                if(widgetInfoTask.currentRow.TYPE_RELATIONSHIP == TYPE_RELATIONSHIP_TEST) {
                    self.gitConclude(widgetInfoTask);
                } else {
                    self.gitPause(widgetInfoTask);
                }
            } else {
                generateTask = false;
                AppropriationService.saveMultipleTasks(rowToGenerate).then(function (data) {
                    var newTaskId = data.dataset.ID[0];
                    AppropriationService.duplicateChangedFilesForNewTask(widgetInfoTask.currentRow.TASK_ID, newTaskId, widgetInfoTask.currentRow.TYPE_RELATIONSHIP).then(function() {
                        ScreenService.closePopup(true);
                        ScreenService.closeSwipe();
                        widgetListTask.activate();
                        widgetListTask.reload();
                        widgetGenerate.oldDescriptionFieldTaskGenerate = '';
                        ScreenService.successNotification(Messages.SUC_TASK_SUCCESSFUL_GENERATED);
                    });
                }).catch(defaultError);
            }
        } else {
            ScreenService.showMessage(Messages.ERR_REQUIRED_FIELDS);
        }
    };

    /************************************************************
     * Called from action event
     * @param args
     ************************************************************/
    this.taskIssuesCommentsActionEventBack = function(args){
        closeTaskIssueInformation();
    };


    /************************************************************
     * Called from action event
     * @param args
     ************************************************************/
    this.taskIssuesAttachmentsActionEventBack = function(args){
        closeTaskIssueInformation();
    };


    /************************************************************
     * Called from action event
     * @param args
     ************************************************************/
    this.taskIssuesAttachmentsActionEventDownload = function(args){
        Utilities.downloadAttachment(args.row.ID);
    };


    /************************************************************
     * Called from action event
     * @param args
     ************************************************************/
    this.listTasksActionEventTimeActivity = function(args){
        saveInformationsAboutTaskInLocalStorage(getListTasksWidget());
        newAppropriation(args.owner.widget);
    };


    /************************************************************
     * Called by widget event
     * @param args
     ************************************************************/
    this.listTasksWidgetAfterMoveRow = function(args, isGridAction) {
        getTabbedAppropriationWidget().descriptionOrder = getListTasksWidget().descriptionOrder;
        localStorageEngine.setLocalVar('DIRTY_DIRECTORY', false);
        var widget = args.owner;
        if(isGridAction == 'S'){
            widget = args.owner.widget;
        }
        saveInformationsAboutTaskInLocalStorage(widget);
        var container     = widget.container;
        var widgetTasks   = container.getWidget('LIST_TASKS');
        currentTaskStatus = '';

        if (widgetTasks.currentRow.PROJECT_ID) {
            var task_projectId     = widgetTasks.currentRow.PROJECT_ID.replace(/\D/g, '');
            var widgetTabbed       = container.getWidget('TABBED_APPROPRIATION');
            var widgetTimeActivity = container.getWidget('TIME_BY_ACTIVITY');
            var widgetInfoTask     = container.getWidget('INFO_TASK');

            localStorageEngine.setLocalVar('taskID', widgetTasks.currentRow.ID);
            localStorageEngine.setLocalVar('taskId', widgetTasks.currentRow.ID.replace('T', ""));
            localStorageEngine.setLocalVar('taskAllocationID', widgetTasks.currentRow.ALLOCATION);
            localStorageEngine.setLocalVar('task_projectId', task_projectId);

            if(widgetInfoTask.isActive() || widgetTasks.isActive()) {
                ScreenService.showLoader();
            }
            var promisseTask =  widgetInfoTask.reload().then(function () {
               if(widgetInfoTask.isActive() || widgetTasks.isActive()) {
                    ScreenService.hideLoader();
                }
                widgetInfoTask.moveToFirst();
                return showActionsByTaskStatus(widgetInfoTask, widgetInfoTask.currentRow.TASK_STATUS, widgetInfoTask.currentRow.TASK_CAN_START).then(function () {
                    if(isGridAction != 'S'){
                        ScreenService.openSwipe(widgetTabbed);
                    }
                    //AppropriationService.addProgressInDataSource(widgetTasks.currentRow.DURATION, widgetTimeActivity.dataSource.data);
                    showActionsIncompleteTasks(widgetTasks.currentRow.PERCENT_COMPLETED, widgetTimeActivity);
                });
            }).catch(ScreenService.hideLoader);

            if(getTimeByActivityWidget().isActive()) {
                getTimeByActivityWidget().reload();
            }

            if(getWidgetTaskIssues().isActive()) {
                getWidgetTaskIssues().reload();
            }

            if(getDocumentsWidget().isActive()) {
                getDocumentsWidget().reload();
            }
            return promisseTask;
        }
    };

    /************************************************************
     * Called by widget event
     * @param args
     ************************************************************/
    this.stashApplyPopupWidgetOnEnter = function(args) {
        setStashApplyActionVisibility();
    };

    /************************************************************
     * Called by widget event
     * @param args
     ************************************************************/
    this.timeByActivityWidgetAfterLoadDataSource = function(args){
        AppropriationService.hideAppropriationColumnsByTimePlanning([getFieldEndHourFromTimeByActivityWidget()]);
        AppropriationService.changeLabelAppropriationBeginHourColumnByTimePlanning(getFieldBeginHourFromTimeByActivityWidget());
        AppropriationService.hideAppropriationColumnsByAllowEndTasks([getFieldPercentCompletedFromTimeByActivityWidget()]);
        getFieldPercentCompletedFromNewAppropriationWidget().maxValue = 100;
    };

    this.timeByActivityWidgetOnEnter = function (argument) {
        getTimeByActivityWidget().reload();
    };

    this.taskIssuesWidgetOnEnter = function (argument) {
        getWidgetTaskIssues().reload();
    };

    /************************************************************
     * Called by widget event
     * @param args
     ************************************************************/
    this.taskIssuesWidgetAfterMoveRow = function(args){
        var widget = args.owner;
        var taskIssueWidget = getWidgetTaskIssues();
        var issueCommentWidget = getIssueCommentWidget();
        var issueAttachmentsWidget = getIssueAttachmentsWidget();
        var issueTabbedWidget = getIssueTabbedWidget();
        var issueMainWidget = getWidgetIssueMain();
        issueTabbedWidget.descriptionOrder = taskIssueWidget.descriptionOrder;
        localStorageEngine.setLocalVar('issue', [widget.currentRow.ID]);
        ScreenService.openSwipe(issueTabbedWidget);

        ScreenService.showLoader();
        issueMainWidget.reload().then(ScreenService.hideLoader).catch(ScreenService.hideLoader);
        issueCommentWidget.reload();
        issueAttachmentsWidget.reload();
    };

    /************************************************************
     * Called by widget event
     * @param args
     ************************************************************/
    this.newAppropriationWidgetOnEnter = function (args) {
        AppropriationService.manipulateBeginHourFieldByUseTimePlanning(getFieldBeginHourFromNewAppropriationWidget(), true);
        AppropriationService.manipulateEndHourFieldByUseTimePlanning(getFieldEndHourFromNewAppropriationWidget());
        AppropriationService.manipulatePercentFieldByAllowEndTask(getFieldPercentCompletedFromNewAppropriationWidget());
        AppropriationService.applyProjectAndTaskInfoInNewAppropriationWidget(getFieldProjectIdFromNewAppropriationWidget(), getFieldProjectNameFromNewAppropriationWidget(), getFieldTaskNameFromNewAppropriationWidget());
        AppropriationService.manipulateMobileTotalField(getFieldTotalFromNewAppropriationWidget());
        if (isDescriptionControlled()) {
            descriptionMerge(args);
            setPercent();
            Utilities.localVar.setDescriptionControl(false);
        }

        if (returnToInfoTaskWidget) {
            getWidgetInfoTask().activate();
        } else if (returnToTimeByActivity) {
            getTimeByActivityWidget().activate();
        } else {
            getWidgetNewAppropriation().activate();
        }

    };

    var setPercent = function(){
        if(currentTaskStatus != 'CONCLUDE') {
            var percentTask = parseInt(getInfoTaskWidget().currentRow.PERCENT_COMPLETED);
            if(percentTask != 100) {
                percentTask = (percentTask === 0) ? 1 : percentTask;
                getNewAppropriationWidget().currentRow.PERCENT_COMPLETED = percentTask;
            }
        }
    };

    var isDescriptionControlled = function(){
        var descriptionControl = Utilities.localVar.getDescriptionControl();
        return descriptionControl ? true : false;
    };

    var descriptionMerge = function() {
        var infoTaskWidgetRow = getInfoTaskWidget().currentRow;
        var isSetEmptyDescription = true;
        var newAppropriationWidget = getNewAppropriationWidget();
        if (infoTaskWidgetRow.TYPE_RELATIONSHIP == TYPE_RELATIONSHIP_MERGE_REQUEST  && infoTaskWidgetRow.MR_GENERATED_BY_REPLICATION !== 'Y' &&  currentTaskStatus == 'CONCLUDE') {
            isSetEmptyDescription = false;
        }

        var branchName = infoTaskWidgetRow.BRANCH_INFO && infoTaskWidgetRow.BRANCH_INFO.BRANCH_NAME ? infoTaskWidgetRow.BRANCH_INFO.BRANCH_NAME : '';
        AppropriationService.setDefaultMergeRequestDescription(getFieldDescriptionFromNewAppropriationWidget(), branchName, isSetEmptyDescription, newAppropriationWidget, infoTaskWidgetRow.FIRST_TASK_RESPONSE);
    };

    /************************************************************
     * Called by widget event
     * @param args
     ************************************************************/
    this.infoTaskWidgetAfterMoveRow = function(args){
        setStashApplyActionVisibility();
    };

    var setVisibleTaskResponse = function () {
        var taskResponseField = getFieldTaskResponseFromInfoTaskWidget();
        var urlToTest = getFieldUrlToTestFromInfoTaskWidget();
        taskResponseField.isVisible = !!taskResponseField.value();
        urlToTest.isVisible = !!urlToTest.value();

    };

    this.infoTaskWidgetAfterLoadDataSource = function(){
        AppropriationService.manipulateBeginHourFieldByUseTimePlanning(getFieldEstimatedBeginDateFromInfoTaskWidget());
        AppropriationService.manipulateEndHourFieldByUseTimePlanning(getFieldEstimatedEndDateFromInfoTaskWidget());
        getInfoTaskWidget().moveToFirst();
        setVisibleTaskResponse();
        //Used in the function updateMasterRepositories
        localStorageEngine.setLocalVar('TASK_PATHS', getInfoTaskWidget().currentRow.PATHS_UNCHANGED);
        var widget = getWidgetInfoTask();

        if(widget.currentRow.USE_TIME_PLANNING == 'N'){
            widget.getField('DURATION').isVisible = false;
        } else {
            widget.getField('DURATION').isVisible = true;
        }

    };

    /************************************************************
     * Close that window which contains basic information about
     * an issue, such Attachments (Anexo) and Comments (Comentários).
     ************************************************************/
    var closeTaskIssueInformation = function(){
        var toBeActivated = getWidgetTaskIssues();
        Utilities.backToWidgetClosingSwipe(toBeActivated);
    };

    /************************************************************
     * Saves util information into Local Storage when user clicks
     * on a task.
     * @param widget
     ************************************************************/
    var saveInformationsAboutTaskInLocalStorage = function(widget){
        Utilities.localVar.setClickedProjectAllowEndTasks(widget.currentRow.ALLOWENDTASK);
        Utilities.localVar.setClickedProjectUseTimePlanning(widget.currentRow.USE_TIME_PLANNING);
        Utilities.localVar.setClickedTaskName(widget.currentRow.TASK_NAME);
        Utilities.localVar.setClickedProjectName(widget.currentRow.PROJECT_NAME);
        if(widget.currentRow.PROJECT_ID) {
            Utilities.localVar.setClickedProjectId(removeFirstLetterFromTaskAndProjectId(widget.currentRow.PROJECT_ID));
        }
    };

    /************************************************************
     * Sometimes, there is a letter (T or P) in task and project
     * ids. This function removes it and gets only the numbers.
     ************************************************************/
    var removeFirstLetterFromTaskAndProjectId = function(value){
        return value.slice(1);
    };

    /************************************************************
     * Checks if selected task has or not time planning.
     * @toDo: refactor this shit that looks horrible
     ************************************************************/
    var hasTaskTimePlanning = function () {
        var widget = templateManager.container.getWidget('INFO_TASK');
        var timePlanning = widget.currentRow.USE_TIME_PLANNING;
        return timePlanning === 'Y';
    };

    /************************************************************
     * Sets percent field visibility (hide/show) if clicked task
     * can or can not be finished.
     * @param: field
     ************************************************************/
    var setPercentFieldVisibilityByEndTask = function(percentField){
        var allowEndTasks = localStorageEngine.getLocalVar('clickedProjectAllowEndTasks') || 'Y';
        if(allowEndTasks === ALLOWENDTASK_NEGATIVE){
            percentField.isVisible = false;
            percentField.value('0');
            return false;
        } else {
            percentField.isVisible = true;
            return true;
        }
    };

    this.stashNamePopupActionEventVoltar = function(args) {
        ScreenService.closePopup(true);
        getInfoTaskWidget().activate();
    };

    this.infoTaskActionEventLog = function(args) {
        ScreenService.showLoader();
        getFullLogFileContents(getLogFileName()).then(function(logFileContents) {
            if(!logFileContents) {
                ScreenService.hideLoader();
                ScreenService.showMessage(Messages.ALE_NOT_EXISTS_LOG);
            } else {
                var logWidget = getLogWidget();
                logWidget.isVisible = true;
                getBackActionFromLogWidget().isVisible = true;
                logWidget.newRow();
                logWidget.currentRow.LOG_FIELD = logFileContents;
                ScreenService.hideLoader();
                ScreenService.openPopup(logWidget);
            }
        }).catch(defaultError);
    };

    this.logActionEventBack = function(args) {
        ScreenService.closePopup(true);
        if(ScreenService.isSwipeOpen()) {
            getInfoTaskWidget().activate();
        } else {
            getListTasksWidget().activate();
        }
    };

    this.issueMainWidgetAfterLoadDataSource = function(args){
        var widgetIssueMain = getWidgetIssueMain();
        if(widgetIssueMain.dataSource.data && widgetIssueMain.dataSource.data.length > 0){
            widgetIssueMain.moveToFirst();
            var fieldFollowers = getFieldFollowersFromWidgetIssueMain();
            Utilities.bugPaginationOnSelectMultiplyOnModeView(fieldFollowers);
        }
    };

    this.issueMainActionEventCancel = function(args){
        Utilities.genericBackEventIsNotMasterDetail(getWidgetIssueMain());
    };

    this.getProjectFieldMergeRequest = function(projectId, widget) {
        return metaDataFactory.factoryField(Utilities.fieldsMetaData.getProjectFromMergeRequestInAppropriation(projectId), widget);
    };

    this.stashNamePopupActionEventSave = function(args) {
        self.resetAndStashFiles();
    };

    this.documentsWidgetOnEnterTab = function(args) {
        getDocumentsWidget().reload();
    };

    this.getResourceNameFieldMergeRequest = function(projectId, widget) {
        return metaDataFactory.factoryField(Utilities.fieldsMetaData.getResourceNameFromMergeRequestInAppropriation(projectId), widget);
    };

    this.getTaskNameFieldMergeRequest = function(projectId, widget) {
        return metaDataFactory.factoryField(Utilities.fieldsMetaData.getTaskNameFromMergeRequestInAppropriation(projectId), widget);
    };

    this.fieldOnChangeEventResource = function(args) {
        var ownerField = Utilities.getOwnerFixBug(args);
        var widget = ownerField.widget;
        var resourceFields = widget.fields.filter(function (field) {
            return field.pmIsGenerated && Utilities.inString(field.name, 'RESOURCE_NAME_');
        });

        var ownerValue = Utilities.getValueInSelectField(ownerField);
        var isValueAllResource = resourceFields.length > 1 && ownerValue;

        if (isValueAllResource) {
            ScreenService.showCustomDialog(Utilities.messages.ALE_UPDATE_RESOURCE, 'CONFIRMATION', null,
                [ {
                    "label": "Sim",
                    "code": function () { updateResource(ownerValue, resourceFields); }
                }, {
                    "label": "Não",
                    "code": function () {}
                } ]
            );
        }
    };

    var updateResource = function (value, resourceFields) {
        resourceFields.forEach(function (resourceField) {
            if (Utilities.isNotEmptyArray(Utilities.findInDataSource(resourceField, [value], 'ID'))) {
                Utilities.setValueInSelectField(resourceField, value);
            }
        });
    };
}

Configuration(function(ContextRegister) {
  ContextRegister.register('AppropriationController', AppropriationController);
});


// FILE: assets/js/Controller/AppropriationManagement.js

function AppropriationManagementController(localStorageEngine,templateManager,FilterService,ScreenService,Utilities, ZhFilterPreferences) {

    var getFilterAppropriationGrid = function () {
        return getWidgetAppropriationGrid().appliedFilter;
    };

    var getWidgetAppropriationGrid = function () {
        return templateManager.container.getWidget('APPROPRIATION_GRID');
    };
    var getWidgetAppropriationGridDaily = function () {
        return templateManager.container.getWidget('APPROPRIATION_GRID_DAILY');
    };
    var getWidgetTabbedAppropriationGridDaily = function () {
        return templateManager.container.getWidget('TABBED_APPROPRIATION_GRID_DAILY');
    };
    var getFieldResponsibleFromWidgetAppropriationGrid = function(){
        return getWidgetAppropriationGrid().getField('RESPONSIBLE');
    };
    
    var getFieldNameFromWidgetAppropriationGrid = function(){
        return getWidgetAppropriationGrid().getField('NAME');
    };
    
    this.filterAppropriationGridActionEventFilter= function () {
        ScreenService.openPopup(getFilterAppropriationGrid());
    };

    this.filterAppropriationGridLastFiveDayPeriod= function () {
       return Utilities.getLastFiveDayPeriodButNotToday();
    };
    this.filterAppropriationGridCurrentMonthPeriod= function () {
       return Utilities.getLastCurrentMonthPeriodButNotToday();
    };
    this.filterAppropriationGridCurrentWeekPeriod= function () {
       return Utilities.getLastCurrentWeekPeriodButNotToday();
    };

    this.appropriationManagementWidgetOnEnter = function () {
        ScreenService.showLoader();
        Utilities.localVar.getLoginPromise().then(function(){
            ScreenService.hideLoader();
            var widget = getWidgetAppropriationGrid();
            if(Utilities.isAppliedFilter(widget)){
                widget.reload();
            } else {
                var currentRow = {};
                var userId = Utilities.localVar.getLocalVarIdBusinessPartner();
                var fieldResponsible = getFieldResponsibleFromWidgetAppropriationGrid();
                Utilities.localVar.setLocalVarResponsibleId('');
                var period = self.filterAppropriationGridLastFiveDayPeriod();
                currentRow.PERIOD_end = period.end;
                currentRow.PERIOD_start = period.start;
                currentRow.PERIOD_period_select = 'Últimos 5 dias';
                currentRow.STATUS = ['A'];
                currentRow.PERIOD = period;
                fieldResponsible.reload().then(function(){
                    var responsible = fieldResponsible.dataSource.data.filter(
                        function(responsible){ return responsible.ID == userId; }
                    );
                    if(responsible){
                        Utilities.localVar.setLocalVarResponsibleId([userId]);
                        currentRow.RESPONSIBLE = [userId];
                    }
                    widget.currentRow = currentRow;
                    ZhFilterPreferences.setOriginalFilter(widget.id, widget.currentRow);
                    Utilities.applyDefaultFilterOnEnter(widget);
                });
            }
        }).catch(ScreenService.hideLoader);
    };

    this.appropriationGridWidgetAfterMoveRow = function(args){
        if(getWidgetAppropriationGrid().currentRow._parent){
            getWidgetAppropriationGrid().descriptionOrder = getWidgetAppropriationGrid().currentRow._parent.NAME;
        }
        var day = args.row.DAY;
        if(day){
            var widgetForm =  getWidgetAppropriationGridDaily();
            var resource = args.row.RESOURCE_T;
            var dayWeek = args.row.DAY_FRONT;
            widgetForm.label = 'Apropriações do dia '+ dayWeek;
            ScreenService.openSwipe(getWidgetTabbedAppropriationGridDaily());
            Utilities.localVar.setLocalVarDay("'"+day+"'");
            Utilities.localVar.setLocalVarResource(resource);
            widgetForm.activate();
            widgetForm.reload();
        }
    };

    this.filterAppropriationGridActionEventCancel = function(){
        ScreenService.closePopup();
        getWidgetAppropriationGrid().activate();
    };
    
    this.filterAppropriationGridDailyActionEventCancel = function(){
        ScreenService.closeSwipe();
        getWidgetAppropriationGrid().activate();
    };

    this.filterAppropriationGridFieldOnChangeResponsible = function () {
        var widget = getFilterAppropriationGrid();
        var resourceIds = widget.getField('RESPONSIBLE').value();

        Utilities.localVar.setLocalVarResponsibleId(resourceIds);

        var structureField = widget.getField('STRUCTURE');
        structureField.reload().then(function () {
            structureField.value([]);
        });

    };
    
    this.appropriationManagementFilterAfterApply = function(){
        Utilities.setFilterInit(getWidgetAppropriationGrid());
    };
    var self = this;
}

Configuration(function(ContextRegister) {
    ContextRegister.register('AppropriationManagementController', AppropriationManagementController);
});


// FILE: assets/js/Controller/BoardIssues.js
function BoardIssuesController(templateManager, IssueService, ScreenService, Utilities, metaDataFactory,MessageService,
    ZHPromise, restEngine, ZhFilterPreferences, requestDataSourceEngine, TaskService, CommentService, ProjectServiceList, localStorageEngine, LocalStorage) {

    var self = this;

    var CONTROL_TASK_TYPE_HOMOLOGATED = 'H';
    var CONTROL_TASK_TYPE_BACKLOG = 'B';

    var getWidgetIssuesMain = function () {
        return templateManager.container.getWidget('ISSUES_MAIN');
    };

    var getWidgetGenerateBudget = function () {
        return templateManager.container.getWidget('GENERATE_BUDGET');
    };

    var getWidgetChangeProductComment = function (){
        return templateManager.container.getWidget('CHANGE_PRODUCT_COMMENT');
    };

    var getWidgetChangeDescription= function () {
        return templateManager.container.getWidget('CHANGE_DESCRIPTION');
    };

    var getFieldDocumentFromGenerateBudget = function () {
        return getWidgetGenerateBudget().getField('DOCUMENT');
    };

    var getFieldProductNameFromWidgetIssueMain = function(){
        return getWidgetIssueMain().getField('PRODUCT_NAME');
    };

    var getFieldLabelsFromWidgetIssuesMain = function(){
        return getWidgetIssuesMain().getField('LABELS');
    };

    var getWidgetNewIssueUpload = function(){
        return templateManager.container.getWidget('NEW_ISSUE_UPLOAD');
    };

    var getWidgetIssueLogUpload = function(){
        return templateManager.container.getWidget('ISSUE_LOG');
    };

    var getWidgetBudget = function(){
        return templateManager.container.getWidget('BUDGET');
    };

    var getWidgetBudgetTabbed = function(){
        return templateManager.container.getWidget('TABBED_BUDGET');
    };

    var getWidgetUpperBudgetTabbed = function(){
        return templateManager.container.getWidget('UPPER_TABBED_BUDGET');
    };

    var getWidgetDocumentsComment = function(){
        return templateManager.container.getWidget('DOCUMENTS_COMMENT');
    };

    var getCurrentWidgetTabbedBoardIssue= function(){
        return templateManager.container.getWidget('TABBED_BOARD_ISSUE').currentWidget;
    };

    var getFieldDocumentFromNewCommentWidget =  function(){
        return getWidgetNewComment().getField('DOCUMENT');
    };

    var getFieldDocumentFromNewCommentMailWidget =  function(){
        return getWidgetNewCommentMail().getField('DOCUMENT');
    };

    var getWidgetComments = function(){
        return templateManager.container.getWidget('COMMENTS');
    };

    var getWidgetOutComments = function(){
        return templateManager.container.getWidget('OUT_COMMENT');
    };

    var getWidgetIssueGrid = function () {
        return templateManager.container.getWidget('ISSUE_GRID');
    };

    var getWidgetTabbedPlots = function () {
        return templateManager.container.getWidget('TABBED_PLOTS');
    };
    var getWidgetPlots = function () {
        return templateManager.container.getWidget('PLOTS');
    };

    var getWidgetMaintenance = function () {
        return templateManager.container.getWidget('MAINTENANCE');
    };

    var getWidgetIssueUpload = function () {
        return templateManager.container.getWidget('ISSUE_UPLOAD');
    };

    var getWidgetNewTask = function(){
        return templateManager.container.getWidget('NEW_TASK');
    };


    var getWidgetNewIssueType = function () {
        return templateManager.container.getWidget('NEW_ISSUE_TYPE');
    };

    var getWidgetProductTasks = function () {
        return templateManager.container.getWidget('PRODUCT_TASKS');
    };

    var getWidgetNewComment = function(){
        return templateManager.container.getWidget('NEW_COMMENT');
    };

    var getFieldQuantityPlotsFromTabbedPlots = function(){
        return getWidgetTabbedPlots().getField('QUANTITY_PLOTS');
    };

    var getFieldTaskClassificationLabelFromNewTask = function(){
        return getWidgetNewTask().getField('TASK_CLASSIFICATION_LABEL');
    };

    var getFieldResourceFromNewTask = function(){
        return getWidgetCreateTaskIssue().getField('RESOURCE');
    };

    var getFieldDocumentFromOutComments = function(){
        return getWidgetOutComments().getField('DOCUMENT');
    };

    var getFieldEndFromNewTask = function(){
        return getWidgetNewTask().getField('END');
    };

    var getFieldStartFromNewTask = function(){
        return getWidgetNewTask().getField('START');
    };

    var getFieldDescriptionFromNewTask = function(){
        return getWidgetNewTask().getField('DESCRIPTION');
    };
    var getFieldNameFromNewTask = function(){
        return getWidgetNewTask().getField('NAME');
    };

    var getFieldIssueStatusNameFromBoardIssueFilter = function() {
        return getWidgetIssuesMain().getField('ISSUE_STATUS_NAME');
    };

    var getFieldValueDiscount = function() {
        return getWidgetMaintenance().getField('VALUE_DISCOUNT');
    };

    var getFieldPercentageDiscount = function() {
        return getWidgetMaintenance().getField('PERCENTAGE_DISCOUNT');
    };

    var getFieldFramingFromIssuesMainWidget = function() {
        return getWidgetIssuesMain().getField('FRAMING');
    };

    var getFieldProductFromIssuesMainWidget = function() {
        return getWidgetIssuesMain().getField('PRODUCT');
    };

    var getFieldProductFromIssueGridWidget = function() {
        return getWidgetIssueGrid().getField('PRODUCT');
    };

    var getFieldClassificationNameFromCreateTaskIssue = function() {
        return getWidgetCreateTaskIssue().getField('CLASSIFICATION_NAME');
    };

    var getFieldIssueStatusFromBoardIssueFilterGrid = function() {
        return getWidgetIssueGrid().getField('ISSUE_STATUS');
    };

    var getFieldTypeTaskfromissueGridWidget = function() {
        return getWidgetIssueGrid().getField('TYPE_TASK_NAME');
    };

    var getWidgetTabbedBoardIssue = function () {
        return templateManager.container.getWidget('TABBED_BOARD_ISSUE');
    };

    var getWidgetIssueRelationship = function () {
        return templateManager.container.getWidget('ISSUE_RELATIONSHIP');
    };
    var getNewLabelWidget = function () {
        return templateManager.container.getWidget('NEW_LABEL');
    };

    var getWidgetNewIssueStatus = function () {
        return templateManager.container.getWidget('NEW_ISSUE_STATUS');
    };

    var getWidgetNewIssue = function () {
        return templateManager.container.getWidget('NEW_ISSUE');
    };

    var getWidgetNewCommentMail = function () {
        return templateManager.container.getWidget('NEW_COMMENT_MAIL');
    };

    var getFieldLabelsFromNewIssueWidget = function () {
        return getWidgetNewIssue().getField('LABELS');
    };

    var getFieldProductNameFromNewIssueWidget = function () {
        return getWidgetNewIssue().getField('PRODUCT_NAME');
    };

    var getFieldVersionFromNewIssueWidget = function () {
        return getWidgetNewIssue().getField('VERSION');
    };

    var getFieldVersionDevFromNewIssueWidget = function () {
        return getWidgetNewIssue().getField('VERSION_DEV');
    };

    var getWidgetIssueMain = function () {
        return templateManager.container.getWidget('ISSUE_MAIN');
    };

    var getWidgetCreateTaskIssue = function () {
        return templateManager.container.getWidget('CREATE_TASK_ISSUE');
    };

    var getFieldLabelsFromIssueMainWidget = function () {
        return getWidgetIssueMain().getField('LABELS');
    };

    var getBudgetProductFromBudgetTabbedWidget = function () {
        return getWidgetBudgetTabbed().getField('BUDGET_PRODUCT');
    };

    var getActionSaveProductFromBudgetTabbedWidget = function () {
        return getWidgetBudget().getAction('SAVE_PRODUCT_BUDGET');
    };

    var getFieldResponseFromIssueMainWidget = function () {
        return getWidgetIssueMain().getField('RESPONSE');
    };

    var getFieldLabelsFromIssueGridWidget = function () {
        return getWidgetIssueGrid().getField('LABELS');
    };

    var getFieldLabelsFromWidgetNewIssue = function () {
        return getWidgetNewIssue().getField('LABELS');
    };

    var getFieldIssuesFromWidgetCreateTaskIssue = function(){
        return getWidgetCreateTaskIssue().getField('ISSUES');
    };

    var getFieldFollowersFromWidgetIssueMain = function(){
        return getWidgetIssueMain().getField('FOLLOWERS');
    };

    var getFieldCdItemtrabFromWidgetIssueMain = function(){
        return getWidgetIssueMain().getField('CDITEMTRAB');
    };

    var getIssueMainWidget = function() {
        return templateManager.container.getWidget('ISSUES_MAIN');
    };

    var getFieldAllProjectsFromWidgetCreateTaskIssue = function () {
        return getWidgetCreateTaskIssue().getField('ALL_PROJECTS');
    };

    var getFieldIssueStatusNameFromWidgetNewIssue = function() {
        return getWidgetNewIssue().getField('ISSUE_STATUS_NAME');
    };

    var getFieldReporterNameFromWidgetNewIssue = function() {
        return getWidgetNewIssue().getField('REPORTER_NAME');
    };

    var getFieldSponsorFromWidgetNewIssue = function() {
        return getWidgetNewIssue().getField('SPONSOR');
    };

    var getWidgetSelectedProjects = function () {
        return templateManager.container.getWidget('SELECTED_PROJECTS');
    };

    var getFieldProjectsFromSelectedProjectsWidget = function () {
        return getWidgetSelectedProjects().getField('PROJECTS');
    };

    var getFieldVersionFromIssueMainWidget = function () {
        return getWidgetIssueMain().getField('VERSION');
    };

    var getFieldVersionDevFromIssueMainWidget = function () {
        return getWidgetIssueMain().getField('VERSION_DEV');
    };

    var getWidgetRedoBudget = function(){
        return templateManager.container.getWidget('REDO_BUDGET');
    };

    var getActionRedoBudgetInIssueMain = function () {
        return getWidgetIssueMain().getAction('REDO_BUDGET');
    };

    var buildStripeSelectedProjectsWidget = function () {
        var issueMain = getWidgetIssuesMain();
        Utilities.reloadTaskTypes(issueMain);
        var widget = getWidgetSelectedProjects();
        var stringDefault = 'Projetos: ';
        widget.reload().then(function(){
            var projectNames = widget.dataSource.data.map(function(value){
                return value.NAME;
            });
            getFieldProjectsFromSelectedProjectsWidget().label = stringDefault + projectNames.toString().split(",").join(", ");
        });
    };

    var backToKanban = function () {
        var widget = getWidgetTabbedBoardIssue().currentWidget;
        ScreenService.goBack();
        widget.list();
        widget.activate();
    };

    this.issueGridActionEventBack = function(args){
       self.onBackBoards();
    };

    this.issuesMainActionEventBack = function(args){
       self.onBackBoards();
    };

    this.plotsActionEventBack = function(args){
        backToKanban();
    };

    this.budgetActionEventBack = function(args){
        backToKanban();
    };




    this.issueMainFieldOnChangeProduct = function () {
        var widget = getWidgetIssueMain();
        var versionDevField = getFieldVersionDevFromIssueMainWidget();
        var fieldValue = getFieldProductNameFromWidgetIssueMain().value();

        localStorageEngine.setLocalVar('PROJECT_ID', widget.currentRow.PRODUCT);
        widget.currentRow.VERSION = null;
        widget.currentRow.VERSION_DEV = null;
        widget.currentRow.PRODUCT_VERSION_DEV_ID = null;
        widget.currentRow.PRODUCT_VERSION_ID = null;
        versionDevField.reload();
        versionDevField.readOnly = widget.currentRow.PRODUCT ? false : true;

        if (fieldValue) {
            var productId = getWidgetIssueMain().currentRow.PRODUCT;
            localStorageEngine.setLocalVar('projectIdToLabelEdit', productId);
        } else {
            localStorageEngine.setLocalVar('projectIdToLabelEdit', null);
        }
    };

    this.issueMainFieldOnChangeSponsor = function(){
        var widget = getWidgetIssueMain();
        localStorageEngine.setLocalVar('clientId', widget.currentRow.SPONSOR_ID);
        getFieldVersionDevFromIssueMainWidget().reload();
    };

    this.budgetActionEventGenerateBudget = function(args){
        var widget = getWidgetGenerateBudget();
        var budgetWidget = getWidgetBudget();
        var documentField = getFieldDocumentFromGenerateBudget();
        var issueId = getLocalVar('issue')[0];
        var budgetId = budgetWidget.dataSource.data[0].ID;
        if(budgetId) {
            widget.dataSource.data = [];
            widget.newRow();
            widget.currentRow.ISSUE_ID = issueId;
            ScreenService.showLoader();
            documentField.reload().then(function() {
                ScreenService.hideLoader();
                var budgets = documentField.dataSource.data;
                if(!budgets.length) {
                    ScreenService.showMessage(Utilities.messages.ERR_NOT_MODEL_BUDGET_RESGISTERED);
                    budgetWidget.activate();
                    budgetWidget.list();
                } else if (budgets.length == 1){
                    IssueService.generateDocument(budgets[0].ID,issueId);
                    budgetWidget.activate();
                    budgetWidget.list();
                } else {
                    ScreenService.openPopup(widget);
                }
            }).catch(ScreenService.hideLoader);
        } else {
            ScreenService.showMessage(Utilities.messages.ERR_NOT_BUDGET_RESGISTERED);
        }
    };






    this.budgetActionEventSaveManut = function(){
        var widget = getWidgetMaintenance();
        widget.currentRow.ISSUE_ID = getWidgetIssueMain().currentRow.ID;
        widget.dataSource.save().then(function(){
            ScreenService.hideLoader();
            ScreenService.successNotification(Utilities.messages.SUC_BUDGETS_SAVE);
            widget.reload();
        }).catch(function(){
            ScreenService.hideLoader();
        });
    };

    var setDiscount = function(row,setPercent){
        var widget = getWidgetBudget();
        if (typeof row.PROPOSAL_VALUE_inline !== "string") {
            row.PROPOSAL_VALUE_inline = String(row.PROPOSAL_VALUE_inline);
        }
        var discount = parseFloat(row.PROPOSAL_VALUE_inline.replace(/[.]/g,'').replace(',','.'));
        if(discount > 0){
            discount *= -1;
            row.PROPOSAL_VALUE_inline = '-'+row.PROPOSAL_VALUE_inline;
        }
        var indexSubTotal = widget.groupedData.length-5;
        var subTotalProposalString = widget.groupedData[indexSubTotal].PROPOSAL_VALUE;
        var subTotalProposal = parseFloat(subTotalProposalString.replace(/[.]/g,'').replace(',','.'));
        if(subTotalProposal + discount < 0){
            discount = subTotalProposal * -1;
            row.PROPOSAL_VALUE_inline = '-'+subTotalProposalString;
        }
        row.PROPOSAL_VALUE = Number( discount);
        if(setPercent){
            if(subTotalProposal){
                row.PROPOSAL_QUANTITY = Number((discount*100/subTotalProposal).toFixed(2))*-1;
            }else{

                row.PROPOSAL_QUANTITY = 0;
            }
        }
        widget.updateGroups();
        return discount;

    };
    this.budgetWidgetAfterLoadDataSource = function(){
        var widget = getWidgetBudget();
        var isVisibleGenerateBudget = false;
        widget.dataSource.data.forEach(function(row){
            row.PROPOSAL_VALUE_inline = row.PROPOSAL_VALUE.replace('.',',');
            row.changed = true;
            isVisibleGenerateBudget = !!row.EXTERNAL_ID;
        });
        widget.list();
        getActionGenerateBudgetInBudget().isVisible = isVisibleGenerateBudget;

    };

    this.budgetOnChangeProposalValue = function(args){
        var row = args.row;
        if(!row.PROPOSAL_VALUE_inline){
            row.PROPOSAL_VALUE = 0;
            row.PROPOSAL_VALUE_inline = '0';
        }
        var discount = setDiscount(row,true);
        Util.doAsync(function(){
            row.PROPOSAL_VALUE = discount;
        });
    };

    var getRowDiscount = function(){
        var rowDiscount = null;
        getWidgetBudget().dataSource.data.some(function(row){
            if(row.BUDGET_ITEM_ID == "XXXX"){
                rowDiscount = row;
            }
        });

        return rowDiscount;
    };

    this.budgetOnChangeProposalQuantity = function(args){
        var row = args.row;
        var widget = getWidgetBudget();
        widget.inlineEdit();
        var setPercent = true;
        if(!(row.PROPOSAL_QUANTITY_inline && Number(row.PROPOSAL_QUANTITY_inline.replace(',','.')))){
            row.PROPOSAL_QUANTITY = 0;
            row.PROPOSAL_QUANTITY_inline = '0';
        }
        if(row.BUDGET_ITEM_ID == 'XXXX'){
            if(Number(row.PROPOSAL_QUANTITY_inline.replace(',','.')) > 100){
                row.PROPOSAL_QUANTITY = 100;
                row.PROPOSAL_QUANTITY_inline = '100';
            }
            var discountPercent = row.PROPOSAL_QUANTITY_inline.replace(',','.');
            var indexSubTotal = widget.groupedData.length-5;
            var subTotalProposalString = widget.groupedData[indexSubTotal].PROPOSAL_VALUE;
            var subTotalProposal = parseFloat(subTotalProposalString.replace(/[.]/g,'').replace(',','.'));
            var discount = (subTotalProposal * discountPercent/100).toFixed(2);
            row.PROPOSAL_VALUE = Number(discount);
            row.PROPOSAL_VALUE_inline = discount.replace('.',',');
            setPercent = false;
        }else{
            row.PROPOSAL_VALUE = row.PROPOSAL_QUANTITY_inline.replace(',','.') * row.ITEM_VALUE_TRUE;
        }
        widget.updateGroups();

        setDiscount(getRowDiscount(),setPercent);
    };

    this.budgetWidgetOnEnterTab = function(){
        var widget = getWidgetIssueMain();
        var budgetWidget = getWidgetBudget();
        budgetWidget.reload();
        if(widget.currentRow.ISSUE_STATUS != '32' && !widget.currentRow.ACTIONS_REDO_BUDGET ) {
            getBudgetProductFromBudgetTabbedWidget().readOnly = true;
            budgetWidget.fields.forEach(function (field){
                field.readOnlyOnEdit = true;
            });
            getFieldPercentageDiscount().readOnly = getFieldValueDiscount().readOnly = true;
            ScreenService.showMessage(Utilities.messages.ALE_TASK_EDITING_BUDGE_WIDGET);
        } else {
            getBudgetProductFromBudgetTabbedWidget().readOnly = false;
            getFieldPercentageDiscount().readOnly = getFieldValueDiscount().readOnly = false;
            budgetWidget.fields.forEach(function (field){
                field.readOnlyOnEdit = false;
            });
        }
    };

    this.budgetTabWidgetOnEnterTab = function(){
        var widget = getWidgetIssueMain();
        var widgetBudgetTabbed = getWidgetBudgetTabbed();
        IssueService.findBudgetProduct(widget.currentRow.ID).then(function (result) {
            if(result){
                getWidgetBudgetTabbed().currentRow = result[0];
                getWidgetBudgetTabbed().reload();
            }
        });

    };

    var budgetSave = function(){
        var widget = getWidgetBudget();
        widget.dataSource.save().then(function(){
            ScreenService.hideLoader();
            ScreenService.successNotification(Utilities.messages.SUC_BUDGETS_SAVE);
            widget.reload();
        }).catch(function(){
            ScreenService.hideLoader();
        });
    };

    this.budgetWidgetOnChange = function(){
        getActionSaveProductFromBudgetTabbedWidget().isVisible = true;
    };

    this.budgetWidgetOnSaveInlineEdit = function(){
        var tabbedWidget = getWidgetBudgetTabbed();
        if(tabbedWidget.currentRow.changed){
            self.budgetActionSaveProductBudget();
        }
        ScreenService.showLoader();
        Util.doAsync(budgetSave);
    };

     this.budgetActionSaveProductBudget = function(){
        var widget = getWidgetBudgetTabbed();
        var issueMain = getWidgetIssueMain();
        if(widget.isValid()) {
            IssueService.saveProductBudget(widget.currentRow, issueMain.currentRow.ID).then(function (result) {
                 getActionSaveProductFromBudgetTabbedWidget().isVisible = false;
            });
        }
    };

    this.changeProductCommentActionEventSave = function(){
          var widget = getWidgetIssueMain();
         if(widget.isValid()) {

            widget.currentRow.IS_BOARD_ISSUE = true;
            widget.saveRow().then(function(response) {
                if(response.dataset.issue[0].RELOAD) {
                    getWidgetIssueGrid().reload();

                    ScreenService.showLoader();
                    widget.reload().then(function () {
                        ScreenService.hideLoader();
                        setEnabledTabbedsIssue();
                    }).catch(ScreenService.hideLoader);

                    if(widget.id != getWidgetIssuesMain().id) {
                        getWidgetIssuesMain().reload();
                    }
                } else {
                    ScreenService.showLoader();
                    widget.reload().then(function () {
                        ScreenService.hideLoader();
                        setEnabledTabbedsIssue();
                    }).catch(ScreenService.hideLoader);
                }
            });
         }
    };

     this.onChangeProductOutCommentActionEventSaveNewComment = function(args) {
        var widget = getWidgetChangeProductComment();
        var widgetBudget = getWidgetBudgetTabbed();
        var issueMain = getWidgetIssueMain();
         ScreenService.showLoader();
         IssueService.findCommentTypeByControl("C").then(function(commentType){
            ScreenService.hideLoader();
            var commentTypeId = commentType ? commentType.ID : 0;

            widget.currentRow.COMMENT_TYPE_ID = commentTypeId;
            widget.currentRow.ISSUE_ID = issueMain.currentRow.ID;
            if(widget.isValid()){
            widget.currentRow.changed = true;
            IssueService.sendOutComment(widget.currentRow).then(function(response){
                ScreenService.closePopup(true);
                self.changeProductCommentActionEventSave();
                ScreenService.closeSwipe();
                widgetBudget.activate();
            }).catch(Utilities.showMessageBackEndTrue);
            } else {
                ScreenService.showMessage(Utilities.messages.ERR_REQUIRED_FIELDS, 'ERROR');
            }
        }).catch(ScreenService.hideLoader);

    };

    this.budgetActionEventCancel = function(args){
        var widget = getWidgetBudget();
        widget.reload();
        widget.list();
    };

    this.setInlineEditable = function(element, row){
        if( element.field && element.field.name == 'PROPOSAL_VALUE' && row.BUDGET_ITEM_ID != "XXXX"){
            if(element.context && element.context.children && element.context.children[1]){
                element.context.children[1].remove();
            }
        }
    };

    var getFieldResourcesNamesFromWidgetCreateIssueTask = function(){
        return getWidgetCreateTaskIssue().getField('RESOURCES_NAMES');
    };

    var getActionCloseIssueInIssueMain = function () {
        return getWidgetIssueMain().getAction('CLOSE_ISSUE');
    };

    var getActionGenerateBudgetInBudget= function () {
        return getWidgetBudget().getAction('GENERATE_BUDGET');
    };

    this.issuesMainActionEventMarkAsRead = function (args) {
        var widget = getWidgetIssuesMain();
        markAsRead(widget);
    };

    this.issueGridActionEventMarkAsRead = function (args) {
        var widget = getWidgetIssueGrid();
        markAsRead(widget);
    };

    this.tabbedPlotsTabWidgetOnEnterTab = function () {
        getWidgetPlots().reload();
    };


     this.maintenanceOnChangeValueDiscount = function () {
        var discountValue = getWidgetMaintenance().currentRow.VALUE_DISCOUNT;
        var total = getWidgetMaintenance().currentRow.MANUT_VALUE;
        discountValue = discountValue.replace("R$", "");
        discountValue = discountValue.replace(",", ".");
        if(parseFloat(discountValue) > parseFloat(total)){
            discountValue = total;
        }

        var percent = parseFloat(discountValue / total * 100).toFixed(2) ;
        getWidgetMaintenance().currentRow.TOTAL_VALUE = total - discountValue;

        getWidgetMaintenance().currentRow.PERCENTAGE_DISCOUNT = percent;
    };


    this.maintenanceOnChangePorcentDiscount = function () {
        var percentValue = getWidgetMaintenance().currentRow.PERCENTAGE_DISCOUNT;
        var total = getWidgetMaintenance().currentRow.MANUT_VALUE;
        if(percentValue > 100){
            percentValue = 100;
            getWidgetMaintenance().currentRow.PERCENTAGE_DISCOUNT = 100;
        }
        var discValue = percentValue * total / 100;
        getWidgetMaintenance().currentRow.TOTAL_VALUE = total - discValue;
        getWidgetMaintenance().currentRow.VALUE_DISCOUNT = discValue;
    };

    this.maintenanceTabWidgetOnEnterTab = function () {
        this.budgetWidgetOnEnterTab();
       getWidgetMaintenance().reload().then(function (result) {
                   getWidgetMaintenance().currentRow = result.dataset.MaintenanceCost[0];
                }).catch(Utilities.showErrorMessage);
    };


    this.budgetPlotsOnChangeValuePlots = function(args){
        var row = args.row;
        var widget = getWidgetPlots();
        Util.doAsync(function(){
            row.VALUE_PLOTS = parseFloat(row.VALUE_PLOTS_inline.replace(/[.]/g,'').replace(',','.'));
            widget.updateGroups();
        });
    };

    var setDayPaymentDown = function(row, widgetPlots, prevRowDaysPayment, daysPaymentAdd) {
        for (var x = parseInt(row.ORDER_PLOTS_NUM)-2; x >= 0; x--) {
            var nextRow = widgetPlots.dataSource.data[x];
            if (nextRow && nextRow.DAYS_PAYMENT >= prevRowDaysPayment) {
                nextRow.DAYS_PAYMENT = parseInt(nextRow.DAYS_PAYMENT) + parseInt(daysPaymentAdd);
                nextRow.DAYS_PAYMENT_COPY = nextRow.DAYS_PAYMENT;
                nextRow.DAYS_PAYMENT_inline = nextRow.DAYS_PAYMENT;
                nextRow.changed = true;
                prevRowDaysPayment = nextRow.DAYS_PAYMENT;
            }
        }
    };

    var setDayPaymentUp = function(row, widgetPlots, prevRowDaysPayment, daysPaymentAdd) {
        for (var x = parseInt(row.ORDER_PLOTS_NUM); x <= widgetPlots.dataSource.data.length; x++) {
            var nextRow = widgetPlots.dataSource.data[x];
            if (nextRow && nextRow.DAYS_PAYMENT <= prevRowDaysPayment) {
                nextRow.DAYS_PAYMENT = parseInt(nextRow.DAYS_PAYMENT) + parseInt(daysPaymentAdd);
                nextRow.DAYS_PAYMENT_COPY = nextRow.DAYS_PAYMENT;
                nextRow.DAYS_PAYMENT_inline = nextRow.DAYS_PAYMENT;
                nextRow.changed = true;
                prevRowDaysPayment = nextRow.DAYS_PAYMENT;
            }
        }
    };

    this.budgetPlotsOnChangeDaysPayment = function(args){
        Util.doAsync(function(){
            var row = args.row;
            var widgetPlots = getWidgetPlots();
            var daysPaymentAdd = row.DAYS_PAYMENT_inline - row.DAYS_PAYMENT_COPY;
            row.DAYS_PAYMENT_COPY = row.DAYS_PAYMENT_inline;
            var prevRowDaysPayment = row.DAYS_PAYMENT_inline;
            if(daysPaymentAdd > 0){
                setDayPaymentUp(row, widgetPlots, prevRowDaysPayment, daysPaymentAdd);
            }else{
                setDayPaymentDown(row, widgetPlots, prevRowDaysPayment, daysPaymentAdd);
            }
            widgetPlots.updateGroups();
        });
    };

    var setValuesAddParcel = function(diff, parcel, widgetPlots, valueTotal, value, rest) {
        diff = parseFloat(parcel) - (widgetPlots.dataSource.data.length) + 1;
        valueTotal = Math.trunc(widgetPlots.dataSource.data[widgetPlots.dataSource.data.length - 1].VALUE_PLOTS * 100) / 100;
        value = Math.trunc((valueTotal / diff) * 100) / 100;
        rest = valueTotal - (value * 100 * diff / 100);
        widgetPlots.dataSource.data[widgetPlots.dataSource.data.length - 1].VALUE_PLOTS = value;
        widgetPlots.dataSource.data[widgetPlots.dataSource.data.length - 1].changed = true;
        return {"value":value, "rest":rest};
    };

    var removeParcel = function (widgetPlots) {
        var row = widgetPlots.dataSource.data.pop();
        widgetPlots.dataSource.data[widgetPlots.dataSource.data.length - 1].VALUE_PLOTS =
            (parseFloat(widgetPlots.dataSource.data[widgetPlots.dataSource.data.length - 1].VALUE_PLOTS)*100 + parseFloat(row.VALUE_PLOTS)*100)/100;
        widgetPlots.dataSource.data[widgetPlots.dataSource.data.length - 1].changed = true;

    };

    var addParcel = function(widgetPlots, value, parcelLabel, parcel, rest) {
        widgetPlots.newRow();
        widgetPlots.currentRow.VALUE_PLOTS = parseFloat(value);
        widgetPlots.currentRow.changed = true;
        widgetPlots.currentRow.ORDER_PLOTS = widgetPlots.dataSource.data.length + '° ' + parcelLabel;
        widgetPlots.currentRow.ORDER_PLOTS_NUM = widgetPlots.dataSource.data.length;
        widgetPlots.currentRow.DAYS_PAYMENT = parseInt(widgetPlots.dataSource.data[widgetPlots.dataSource.data.length - 2].DAYS_PAYMENT) + 30;
        widgetPlots.currentRow.BUDGET_ID = widgetPlots.dataSource.data[widgetPlots.dataSource.data.length - 2].BUDGET_ID ;
        if (parcel == widgetPlots.dataSource.data.length) {
            widgetPlots.currentRow.VALUE_PLOTS += parseFloat(rest);
        }
    };

    this.plotsActionEventCancel = function(args){
        var widget = getWidgetPlots();
        widget.reload();
        widget.list();
    };

    var _saveActionClick = function (s) {
        var widget = this;
        widget.inlineEditing = false;
        if(widget.lastInlineEditingElement){
            var lastInlineinput = widget.lastInlineEditingElement.find('input');
            if (lastInlineinput.is(':focus')) {
                lastInlineinput.blur();
            }
        }


        if (widget.onSaveInlineEdit) {
            var changedRows = widget.dataSource.data.filter(function(row) {
                return row.changed;
            });
            widget.onSaveInlineEdit({
                data: {
                    changedRows: changedRows
                }
            });
        } else {
            widget.commitInlineEdit.apply(this);
        }
    };

    var validadetotalparcel = function (widgetPlots) {
        var total = 0;
        var proposalValue = widgetPlots.dataSource.data[0].PROPOSAL_VALUE;
        widgetPlots.dataSource.data.forEach(function (row) {
            if( typeof  row.VALUE_PLOTS === 'string'){
                row.VALUE_PLOTS = row.VALUE_PLOTS.replace(/[.]/g,'').replace(',','.');
            }
            total += row.VALUE_PLOTS * 100;
        });
        return total == proposalValue * 100;
    };

    var validateSaveWidgetPlots = function (widgetPlots) {
        var validate = true;
        if(!widgetPlots.dataSource.data.length){
            MessageService.showMessageByCode('ERR_EMPTY_PLOTS', null, { type: 'ERROR' });
            validate = false;
        }else{
            if(!validadetotalparcel(widgetPlots)){
                var params = {
                    TOTAL: widgetPlots.dataSource.data[0].PROPOSAL_VALUE_VIEW.trim()
                };
                MessageService.showMessageByCode('ERR_TOTAL_PLOTS', params, { type: 'ERROR' });
                validate = false;
            }
        }
        return validate;

    };

    this.plotsWidgetOnSaveInlineEdit = function () {
        Util.doAsync(function () {
            var widgetPlots = getWidgetPlots();
            if(validateSaveWidgetPlots(widgetPlots)){
                widgetPlots.dataSource.data[widgetPlots.dataSource.data.length - 1].changed = true;
                widgetPlots.dataSource.save().then(function () {
                    widgetPlots.reload();
                    widgetPlots.list();
                }).catch(Utilities.showErrorMessage);
            }
        },500);

    };
    var validateNumberParcel = function (parcel) {
        var validate = true;
        if(parcel >= 100){
            MessageService.showMessageByCode('ERR_MANY_PLOTS', null, { type: 'ERROR' });
            validate = false;
        }else if(parcel <= 0){
            MessageService.showMessageByCode('ERR_ZERO_NUM_PLOTS', null, { type: 'ERROR' });
            validate = false;
        }else if(!parcel){
            MessageService.showMessageByCode('ERR_INVALID_NUM_PLOTS', null, { type: 'ERROR' });
            validate = false;
        }
        return validate;
    };

    this.plotsOnChangeQuantityPlots = function () {
        var fieldQuantityPlots = getFieldQuantityPlotsFromTabbedPlots();
        var widgetPlots = getWidgetPlots();
        var parcel = parseInt(fieldQuantityPlots.value());
        var diff = null;
        var valueTotal = null;
        var value = null;
        var rest = null;
        var parcelLabel = ScreenService.i18n('Parcel');
        widgetPlots.saveActionClick = _saveActionClick;
        if(validateNumberParcel(parcel)){
            if(parcel == 1){
                widgetPlots.dataSource.data = [widgetPlots.dataSource.data[0]];
                widgetPlots.dataSource.data[0].VALUE_PLOTS = widgetPlots.dataSource.data[0].PROPOSAL_VALUE;
            }else {
                if (parcel > widgetPlots.dataSource.data.length) {
                    var __ret = setValuesAddParcel(diff, parcel, widgetPlots, valueTotal, value, rest);
                    value = __ret.value;
                    rest = __ret.rest;
                }
                while (parcel != widgetPlots.dataSource.data.length){
                    if(parcel < widgetPlots.dataSource.data.length){
                        removeParcel(widgetPlots);
                    }else{
                        addParcel(widgetPlots, value, parcelLabel, parcel, rest);
                    }
                }
            }
            widgetPlots.updateGroups();
            widgetPlots.templateToForm = widgetPlots.template;
            widgetPlots.inlineEdit();
        }

    };



    this.plotsWidgetAfterLoadDataSource = function () {
        var fieldQuantityPlots = getFieldQuantityPlotsFromTabbedPlots();
        var widgetPlots = getWidgetPlots();
        fieldQuantityPlots.value(widgetPlots.dataSource.data.length);
        fieldQuantityPlots.readOnly = !fieldQuantityPlots.value();

        var widget = getWidgetIssueMain();
        if(widget.currentRow.ISSUE_STATUS != '32' && !widget.currentRow.ACTIONS_REDO_BUDGET){
            fieldQuantityPlots.readOnly= true;
            widgetPlots.fields.forEach(function (field){
                field.readOnlyOnEdit = true;
                ScreenService.showMessage(Utilities.messages.ALE_TASK_EDITING_BUDGE_WIDGET);
            });
        }else{
            fieldQuantityPlots.readOnly = false;
            widgetPlots.fields.forEach(function (field){
                field.readOnlyOnEdit = false;
            });
        }
    };

    var markAsRead = function (widget) {
        if(widget.hasCheckedRows()) {
            ScreenService.showLoader();
            IssueService.markManyAsRead(widget.dataSource.checkedRows).then(function () {
                ScreenService.hideLoader();
                ScreenService.closePopup(true);
                Utilities.clearCheckedRowsAndReload(getWidgetTabbedBoardIssue().currentWidget);
            }).catch(ScreenService.hideLoader);
        } else {
            ScreenService.showMessage(Utilities.messages.NOT_CHECKED_ROW_TASK);
        }
    };

    this.issueMainActionEventBack = function (args) {
        backToKanban();
    };

    this.generateBudgetActionEventBack = function (args) {
        var widget = getWidgetGenerateBudget();
        ScreenService.closePopup();
        widget.activate();
    };

    this.generateBudgetActionEventUpload = function (args) {
        var widget = getWidgetGenerateBudget();
        IssueService.generateDocument(widget.currentRow.DOCUMENT_ID,widget.currentRow.ISSUE_ID).then(function (){
            widget.activate();
        });
    };

    this.issueUploadActionEventBack = function (args) {
        backToKanban();
    };

    this.issueUploadActionEventBackView = function (args) {
        ScreenService.closeSwipe();
    };


    this.issueRelationshipActionEventBack = function (args) {
        backToKanban();
    };

    this.issueMainWidgetAfterLoadDataSourceBoardIssues = function(widget){
        widget.moveToFirst();
        var budgetWidgetTabbed = getWidgetBudgetTabbed();
        var currentUserId = Utilities.localVar.getIdBusinessPartner();
        var taskParameters = Utilities.localVar.getTaskParameters();
        var finalTaskStatus = taskParameters.FINAL_TASK_STATUS_ID;
        var currentRow = widget.currentRow;
        var allowCloseIssue = currentRow.ALLOW_CLOSE_ISSUE;
        var taskStatus = currentRow.ISSUE_STATUS;
        var reporter = currentRow.REPORTER;
        var issueMainWidget = getWidgetIssueMain();
        getActionCloseIssueInIssueMain().isVisible = (allowCloseIssue === 'Y') && (taskStatus != finalTaskStatus) && (reporter == currentUserId);
        getActionRedoBudgetInIssueMain().isVisible = currentRow.ACTIONS_REDO_BUDGET;

        var fieldFollowers = getFieldFollowersFromWidgetIssueMain();
        Utilities.bugPaginationOnSelectMultiplyOnModeView(fieldFollowers);
        setActionsOfExits(widget.currentRow.ACTIONS_OF_EXITS,widget);

        var fieldCdItemtrab = getFieldCdItemtrabFromWidgetIssueMain();
        Utilities.bugPaginationOnSelectMultiplyOnModeView(fieldCdItemtrab);

        if (widget.currentRow.HAS_SPECIFICATION_COMMENT) {
            fieldCdItemtrab.validations = { required: {} };
        } else {
            fieldCdItemtrab.validations = {};
        }

        var mainWidget = getWidgetIssueMain();
        getWidgetUpperBudgetTabbed().enabled = !!mainWidget.currentRow.WITH_BUDGET;
        if(budgetWidgetTabbed.id == budgetWidgetTabbed.parent.parent.currentWidget.id && !budgetWidgetTabbed.enabled){
            widget.activate();
        }
        var activeContainer = templateManager.container.getActiveWidget();
        if(activeContainer == getWidgetBudget()){
           self.budgetWidgetOnEnterTab();
           self.budgetTabWidgetOnEnterTab();
        }else if(activeContainer.id == getWidgetPlots().id){
            self.tabbedPlotsTabWidgetOnEnterTab();
        }
        localStorageEngine.setLocalVar('PROJECT_ID', issueMainWidget.currentRow.PRODUCT);
        localStorageEngine.setLocalVar('clientId', issueMainWidget.currentRow.SPONSOR_ID);

        if (issueMainWidget.currentRow.GENERATED_TASK == 'Y') {
            if (issueMainWidget.currentRow.PRODUCT_VERSION_ID || issueMainWidget.currentRow.PRODUCT_VERSION_DEV_ID) {
                getFieldProductNameFromWidgetIssueMain().readOnly = true;
            } else {
                getFieldProductNameFromWidgetIssueMain().readOnly = false;
            }
            getFieldVersionDevFromIssueMainWidget().readOnly = true;
        } else {
            getFieldVersionDevFromIssueMainWidget().readOnly = false;
            getFieldProductNameFromWidgetIssueMain().readOnly = false;
        }
        var wdgissue = getWidgetIssueMain();
        var value = wdgissue.currentRow.PRODUCT;
        if(value){
            localStorageEngine.setLocalVar('projectIdToLabelEdit', value);
        }else {
            localStorageEngine.setLocalVar('projectIdToLabelEdit', null);
        }
    };

    this.issueRelationshipActionEventBackView = function (args) {
        var widget = getWidgetIssueRelationship();
        ScreenService.closeSwipe().then(function () {
            widget.activate();
        });
    };

    this.commentsActionEventBack = function (args) {
        backToKanban();
    };

    this.commentsActionEventBackView= function (args) {
        ScreenService.closeSwipe();
    };

    this.commentsWidgetAfterMoveRow = function(args){
        var currentRow = getWidgetComments().currentRow;
        Utilities.localVar.setComment(currentRow.ID);
        getWidgetDocumentsComment().reload();
    };


    this.issueLogActionEventBack = function (args) {
        backToKanban();
    };

    this.newLabelActionEventBack = function () {
        ScreenService.closePopup();
    };

    this.issuesLabelsRelationshipActionEventSave = function (args) {
        var widget = getWidgetIssuesLabelsRelationship();
        if (widget.isValid()) {
            sendIssuesAndLabelsToRelationship();
        }
    };

    this.issuesLabelsRelationshipActionEventCancel = function (args) {
        ScreenService.closePopup();
    };

    var sendIssuesAndLabelsToRelationship = function () {
        var selectedIssues = getIssuesFieldFromIssuesLabelsRelationshipWidget().value();
        var selectedLabels = getLabelsFieldFromIssuesLabelsRelationshipWidget().value();
        IssueService.sendIssuesAndLabelsToRelationship(selectedIssues, selectedLabels).then(function () {
            var tabbedBoardIssueWidget = getWidgetTabbedBoardIssue();
            var currentWidget = tabbedBoardIssueWidget.currentWidget;
            ScreenService.closePopup(true);
            if(currentWidget.pmNotReload){
                currentWidget.activate();
                currentWidget.dataSource.clearCheckedRows();
                currentWidget.dataSource.updateCheckedRows();
            } else {
                Utilities.clearCheckedRowsAndReload(currentWidget);
            }
        }).catch(function (response) {
            Utilities.showMessageErrorOfBackEnd(response);
        });
    };

    var getWidgetIssuesLabelsRelationship = function () {
        return templateManager.container.getWidget('ISSUES_LABELS_RELATIONSHIP');
    };


     var getWidgetIssuesPriorities = function () {
        return templateManager.container.getWidget('DEFINE_ISSUES_PRIORITIES');
    };

    var getLabelsFieldFromIssuesLabelsRelationshipWidget = function () {
        return getWidgetIssuesLabelsRelationship().getField('LABELS');
    };

    var getIssuesFieldFromIssuesLabelsRelationshipWidget = function () {
        return getWidgetIssuesLabelsRelationship().getField('ISSUES');
    };

    var applySelectedIssuesToIssuesField = function (widget) {
        var widgetPopup = getWidgetIssuesLabelsRelationship();
        widgetPopup.dataSource.data = [];
        widgetPopup.newRow();
        var field = getIssuesFieldFromIssuesLabelsRelationshipWidget();
        var selectedIssuesOnKanban = widget.getCheckedRows();
        field.dataSource.data = selectedIssuesOnKanban;
        getLabelsFieldFromIssuesLabelsRelationshipWidget().reload();
        field.value(Utilities.arrayFromPropertyOfObjectList(selectedIssuesOnKanban, "ID"));
    };

    this.redoBudgetActionEventBack = function(args) {
        ScreenService.closePopup(true);
        getWidgetIssueMain().activate();
    };

    this.redoBudgetActionEventSaveNewComment = function (args) {
        var widget = getWidgetRedoBudget();
        if (widget.isValid()) {
            widget.currentRow.changed = true;
            widget.currentRow.ISSUE = Utilities.localVar.getIssue()[0];
            ScreenService.confirmMessage(Utilities.messages.ALE_REDO_BUDGET, 'CONFIRMATION', function () {
                TaskService.redoBudget(widget.currentRow).then(function () {
                    ScreenService.showMessage(Utilities.messages.SUC_REDO_BUDGET);
                    ScreenService.closePopup(true);
                    backToKanban();
                    getWidgetTabbedBoardIssue().currentWidget.reload();
                }).catch(Utilities.showMessageBackEndTrue);
            });
        } else {
            ScreenService.showMessage(Utilities.messages.ERR_REQUIRED_FIELDS, 'ERROR');
        }
    };

    this.issueMainActionEventRedoBudget = function (args) {
        var widget = getWidgetRedoBudget();
        widget.dataSource.data = [];
        widget.newRow();
        ScreenService.openPopup(widget);
    };



    this.issuesMainActionEventApplyLabels = function(){
        var widget = getWidgetIssuesMain();
        var product = [];
        var checkedRows = widget.dataSource.checkedRows;
        checkedRows.forEach(function (issue) {
            product.push(issue.PROJECT);
        });
        if(Utilities.allValuesSameInArray(product)){
            Utilities.localVar.setCheckedBoardId(product[0]);
        } else {
            Utilities.localVar.setCheckedBoardId(null);
        }
        applyLabels(widget);
    };

    this.issueGridActionEventApplyLabels = function(){
        var widget = getWidgetIssueGrid();
        applyLabels(widget);
    };

    this.defineIssuePriorityActionEventCancel = function(){
        ScreenService.closePopup();
    };

    this.defineIssuePriorityActionEventSave = function(){
        var widget = getWidgetIssuesPriorities();
        var issuesIds = localStorageEngine.getLocalVar('SelectedIssuesKanban');
        IssueService.saveIssuePriorities(widget.currentRow.PRIORITY, issuesIds).then(function () {
            ScreenService.closePopup(true);
            getWidgetIssuesMain().reload();
            var tabbedBoardIssueWidget = getWidgetTabbedBoardIssue();
            var currentWidget = tabbedBoardIssueWidget.currentWidget;
            currentWidget.reload();
            currentWidget.dataSource.clearCheckedRows();
            currentWidget.dataSource.updateCheckedRows();
        }).catch(Utilities.showMessageBackEndTrue);
    };

    this.issueMainActionEventDefinePriority = function(){
        var widget = getWidgetIssuesMain();
        if(widget.hasCheckedRows()) {
            var widgetPopup = getWidgetIssuesPriorities();
            widgetPopup.dataSource.data = [];
            widgetPopup.newRow();

            var selectedIssuesOnKanban = widget.getCheckedRows();
            localStorageEngine.setLocalVar('SelectedIssuesKanban', selectedIssuesOnKanban);

            widgetPopup.getField('PRIORITY_NAME').reload();
            ScreenService.openPopup(widgetPopup);
        } else {
            ScreenService.showMessage(Utilities.messages.NOT_CHECKED_ROW_TASK);
        }
    };

    this.issueGridActionEventDefinePriority = function(){
        var widget = getWidgetIssueGrid();
        if(widget.hasCheckedRows()) {
            var widgetPopup = getWidgetIssuesPriorities();
            widgetPopup.dataSource.data = [];
            widgetPopup.newRow();

            var selectedIssuesOnKanban = widget.getCheckedRows();
            localStorageEngine.setLocalVar('SelectedIssuesKanban', selectedIssuesOnKanban);

            widgetPopup.getField('PRIORITY_NAME').reload();
            ScreenService.openPopup(widgetPopup);
        }else{
            ScreenService.showMessage(Utilities.messages.NOT_CHECKED_ROW_TASK);
        }
    };

    var applyLabels = function (widget) {
        if(widget.hasCheckedRows()) {
            applySelectedIssuesToIssuesField(widget);
            ScreenService.openPopup(getWidgetIssuesLabelsRelationship());
        }else{
            ScreenService.showMessage(Utilities.messages.NOT_CHECKED_ROW_TASK);
        }
    };

    this.newLabelActionEventSave = function (args) {
        var wdgIssueMain = getWidgetIssueMain();
        var wdgNewLabel = getNewLabelWidget();
        if(!wdgIssueMain.currentRow.PRODUCT && wdgNewLabel.currentRow.IS_PROJECT == "Y"){
            ScreenService.showMessage(Utilities.messages.ERR_PRODUCT_NOT_SELECTED);
            return false;
        }
        var widget = args.owner.widget;
        if (!widget.isValid()) {
            ScreenService(Utilities.messages.ERR_REQUIRED_FIELDS);
            return false;
        }else{
            wdgNewLabel.currentRow.BOARD = localStorageEngine.getLocalVar('projectIdToLabelEdit');
            createLabel();
        }
    };

    var createLabel = function () {
        var newLabelWidget = getNewLabelWidget();
        newLabelWidget.saveRow().then(function () {
            ScreenService.closePopup();
            getFieldLabelsFromNewIssueWidget().reload();
            getFieldLabelsFromIssueMainWidget().reload();
        });
    };

    var getWidgetInfoTask = function () {
        return templateManager.container.getWidget('INFO_TASK');
    };

    var getWidgetTabbedTask = function () {
        return templateManager.container.getWidget('TABBED_TASK');
    };

    this.issueRelationshipWidgetAfterMoveRow = function (args) {
        var taskId = getWidgetIssueRelationship().currentRow.ID;
        if (taskId) {
            var widgetForm = getWidgetInfoTask();
            ScreenService.openSwipe(getWidgetTabbedTask());
            Utilities.localVar.setLocalVarTaskId(taskId);
            widgetForm.activate();
            widgetForm.list();
            widgetForm.reload();
        }
    };

    this.onRemoveTaskRelationship = function () {
        var widget = getWidgetIssueRelationship();
        Utilities.localVar.setIssue(Utilities.localVar.getIssue()[0]);
        ScreenService.confirmMessage(Utilities.messages.ALE_DELETE_TASK_RELATIONSHIP, 'question', function () {
            widget.dataSource.remove([widget.currentRow]).then(function () {
                widget.reload();
                ScreenService.closeSwipe().then(function () {
                    getWidgetIssueRelationship().activate();
                    getWidgetIssuesMain().reload();
                });
            });
        });
    };

    this.infoTaskWidgetAfterLoadDataSource = function (args) {
        getWidgetInfoTask().moveToFirst();
        hideSomeFieldsWhenTaskNotTimeControlled();
    };

    this.infoTaskActionEventBack = function (args) {
        ScreenService.closeSwipe();
        getWidgetIssueRelationship().activate();
    };

    this.issueRelationshipActionEventAdd = function(args){
        this.onAddIssue();
        getWidgetInfoIssueDependent().lastSwipe = getWidgetIssueRelationship();
    };

    this.issueRelationshipWidgetOnEnterTab = function (args) {
        getWidgetIssueRelationship().reload();
    };

    var hideSomeFieldsWhenTaskNotTimeControlled = function () {
        var newTaskWidget = getWidgetInfoTask();
        newTaskWidget.fields.filter(function (field) {
            return !!field.useTimePlanning;
        }).forEach(function (field) {
            field.isVisible = field.useTimePlanning == newTaskWidget.currentRow.USETIMEPLANNING;
        });
    };

    this.issuesMainActionEventNew = function(args){
        self.openSwipeNewIssue(args);
        getFieldVersionFromNewIssueWidget().readOnly = true;
        getFieldVersionDevFromNewIssueWidget().readOnly = true;
    };

    this.onLoadDataSource = function(args){
	    var widget = getWidgetNewIssue();
        widget.list();
    };

	this.newIssueWidgetOnEnter = function(args){
        getWidgetNewIssue().reload();
	};

	this.newIssueTypeWidgetOnEnter = function(args){
	    getWidgetNewIssueType().reload();
	};

	this.documentWidgetOnEnterTab = function(args){
        getWidgetIssueUpload().reload();
	};

	this.issueRelationshipWidgetOnEnterTab = function(){
	    getWidgetIssueRelationship().reload();
	};

	this.newIssueStatusWidgetOnEnter = function(args){
	    getWidgetNewIssueStatus().reload();
	};

    this.issueGridActionEventNew = function(args){
        self.openSwipeNewIssue(args);
        getFieldSponsorFromWidgetNewIssue().reload();
    };

    var issuesHasSameClassification = function(issues,index) {
        var classification = issues[0][index];
        return !issues.some(function(issue){
            return issue[index] != classification;
        });
    };

    this.issueGridActionEventAdd = function(){
        var checkedRows = getWidgetIssueGrid().dataSource.getCheckedRows();
        if (!Utilities.isEmpty(checkedRows)) {
            var issuesIds = [];
            checkedRows.forEach(function (issue) {
                issuesIds.push(issue.ID);
            });
            var issueClassification = null;
            if (issuesHasSameClassification(checkedRows,'ISSUE_CLASSIFICATION')){
                issueClassification = checkedRows[0].ISSUE_CLASSIFICATION;
            }
            if(validateCreateTasks(checkedRows)){
                self.onAddTaskRelationship(issuesIds,issueClassification);
            }else{
                ScreenService.showMessage(Utilities.messages.ALE_NOT_DIFFERENT_ISSUE_RELATION);
            }
        }
    };

    this.projectTaskActionEventAdd = function(){
        onAddTask();
    };

    this.issuesMainActionEventAdd = function(){
        var checkedRows = getWidgetIssuesMain().dataSource.getCheckedRows();
        var productArray = [];
        localStorageEngine.setLocalVar('issuesInfoCreateTasksByIssue', checkedRows);
        if (!IssueService.isIssuesBelongingSameProduct(checkedRows, true)) {
            return false;
        }
        if (!Utilities.isEmpty(checkedRows)) {
            var issuesIds = [];
            checkedRows.forEach(function (issue) {
                issuesIds.push(issue.id);
                if(!productArray.includes(issue.PROJECT)){
                    productArray.push(issue.PROJECT);
                }

            });
            localStorageEngine.setLocalVar('productId',productArray);
            var issueClassification = null;
            if (issuesHasSameClassification(checkedRows,'issueClassification')){
                issueClassification = checkedRows[0].issueClassification;
            }
            if(validateCreateTasks(checkedRows)){
                self.onAddTaskRelationship(issuesIds,issueClassification);
            }else{
                ScreenService.showMessage(Utilities.messages.ALE_NOT_DIFFERENT_ISSUE_RELATION);
            }

        }
    };

    this.onAssociateTasks = function(){
        var checkedRows = getWidgetProductTasks().dataSource.getCheckedRows();
        var tabbedBoardIssueWidget = getWidgetTabbedBoardIssue();
        var issueId = Utilities.localVar.getIssue();
        var checkedIssues = localStorageEngine.getLocalVar('issuesInfoCreateTasksByIssue');
        var productVersiondIds = [];

        checkedRows.forEach(function(c){
            if (c.PRODUCT_VERSION_ID_DEV) {
                productVersiondIds.push(c.PRODUCT_VERSION_ID_DEV);
            } else {
                productVersiondIds.push('0');
            }
        });

        checkedIssues.forEach(function (c) {
            if (c.PRODUCT_VERSION_ID_DEV) {
                productVersiondIds.push(c.PRODUCT_VERSION_ID_DEV);
            } else {
                productVersiondIds.push('0');
            }
        });

        if(!Utilities.allValuesSameInArray(productVersiondIds)){
            ScreenService.showMessage(Utilities.messages.ISSUES_AND_TASKS_WITH_DIFFERENTS_VERSIONS);
            return false;
        }

        issueId = issueId instanceof Array ? issueId : [issueId];
        checkedRows.forEach(function(value, index, array){
            array[index].changed = true;
            array[index].ISSUE = issueId;
        });
        var issueClassification = Utilities.localVar.getIssueClassification();
        if(issueClassification){
            checkedRows.forEach(function(value, index, array){
                array[index].ISSUE_CLASSIFICATION_ID = issueClassification;
            });

            var updateClassificationPromises = checkedRows.map(function(row){
                return IssueService.saveTaskClassification([row]);
            });

            ZHPromise.all(updateClassificationPromises).then(function(){
                IssueService.saveTaskRelationship(checkedRows).then(function(){
                    ScreenService.closePopup(true);
                    Utilities.clearCheckedRowsAndReload(tabbedBoardIssueWidget.currentWidget);
                });
            });
        } else {
            IssueService.saveTaskRelationship(checkedRows).then(function(){
                ScreenService.closePopup(true);
                Utilities.clearCheckedRowsAndReload(tabbedBoardIssueWidget.currentWidget);
            });
        }
    };

    this.onAddTaskRelationship = function(issuesIds,issueClassification){
        if(issuesIds) {
            Utilities.localVar.setIssueClassification(issueClassification);
            Utilities.localVar.setIssueWithArray(issuesIds);
            var productTasksWidget = getWidgetProductTasks();
            productTasksWidget.dataSource.clearCheckedRows();
            productTasksWidget.dataSource.updateCheckedRows();
            ScreenService.openPopup(productTasksWidget);
            productTasksWidget.reload();
        }else{
            ScreenService.showMessage(Utilities.messages.NOT_CHECKED_ROW_TASK);
        }
    };

    this.issuesMainWidgetOnEnterOnce = function(args){
        Utilities.reloadTaskTypes(getWidgetIssuesMain());
    };

    var isThisColumn = function(column){
		return column.id === this.column && column.label == this.label;
	};

    this.afterLoadItems = function(widget, movable){
		var alreadyColumned;
		var filter;
		widget.dataSource.data.forEach(function(item, index, dataSource){
			filter = {
				'column': parseInt(item.column),
                'label' : item.columnLabel
			};
			alreadyColumned = widget.columns.filter(isThisColumn, filter);
			if(!alreadyColumned.length){
				widget.columns.push({
					'id': parseInt(item.column),
					'label': item.columnLabel
				});
			}
			dataSource[index].movable = movable;
		});

		Utilities.reloadTaskTypes(widget);
	};

	this.issuesMainFilterBeforeApply = function(args){
        var widget = getWidgetIssuesMain();
        var currentRow = '';
        Utilities.reloadTaskTypes(widget);
        if(args.e.preference.FILTER_ROW){
            currentRow = args.e.preference.FILTER_ROW;
        } else {
            currentRow = args.e.preference;
        }
        if(currentRow.PRODUCT) {
            LocalStorage.setItem('productBoardIssueFilter', currentRow.PRODUCT);
            Utilities.localVar.setBoardId(currentRow.PRODUCT);
        }
	};

	this.issuesMainFilterAfterApply = function (args) {
        localStorageEngine.setLocalVar('product', args.e.preference.FILTER_ROW.PRODUCT);
        buildStripeSelectedProjectsWidget();
        Utilities.setFilterInit(getWidgetIssuesMain());
	};

    this.issueGridFilterBeforeApply = function(args){
        var currentRow = '';
        if(args.e.preference.FILTER_ROW){
            currentRow = args.e.preference.FILTER_ROW;
        } else {
            currentRow = args.e.preference;
        }
        if(currentRow.PRODUCT) {
            LocalStorage.setItem('productBoardIssueFilter', currentRow.PRODUCT);
            Utilities.localVar.setBoardId(currentRow.PRODUCT);
        }
	};

	this.issueGridFilterAfterApply = function (args) {
        buildStripeSelectedProjectsWidget();
        Utilities.setFilterInit(getWidgetIssueGrid());
	};

    this.issuesMainWidgetAfterLoadDataSource = function(args){
        var widget = getWidgetIssuesMain();
		widget.list();
		this.afterLoadItems(widget, true);
		templateManager.updateTemplate();
    };

    this.issuesMainKanbanAfterMoveItem = function (args) {
        var e = args.e;
        var newIssueType = e.columns.to;
        var issueToMove = e.item;
        var issuesMainWidget = getWidgetIssuesMain();
        var typeTask = issuesMainWidget.PMTaskType.filter(function (taskType) {
            return taskType.column == newIssueType;
        });
        if (e.columns.to !== e.columns.from) {
            ScreenService.showLoader();
            IssueService.findEntranceComment(issueToMove.ISSUE_ID, typeTask[0].ID).then(function (entranceComment) {
                ScreenService.hideLoader();
                issueToMove.sendMail = !!entranceComment.length;
                moveIssue(issueToMove, typeTask, entranceComment[0]);
            }).catch(ScreenService.hideLoader);
        }
    };

    this.redirectWidgetOnEnterTab = function(){
        var lastWidget = localStorage.getItem('boardIssuesWidget');
        var tabbedBoardIssue = getWidgetTabbedBoardIssue();
        var widgetGrid = getWidgetIssueGrid();
        var widgetKanban = getWidgetIssuesMain();
        widgetGrid.dataSource.data = [];
        widgetKanban.dataSource.data = [];
        if(lastWidget == 'GRID') {
            tabbedBoardIssue.currentWidget = widgetGrid;
        } else {
            tabbedBoardIssue.currentWidget = widgetKanban;
        }
        tabbedBoardIssue.currentWidget.activate();
    };

    var moveIssue = function(issueToMove, typeTask,entranceComment){
        var issueId = issueToMove.id;
        var widgetIssuesMain = getWidgetIssuesMain();
        var newCommentMailWidget = getWidgetNewCommentMail();
        var newIssue = { "newIssueType": typeTask[0].ID, "issueId": issueId, "changed": true, "sendMail": issueToMove.sendMail };
        if(issueToMove.sendMail){
            ScreenService.showLoader();
            IssueService.findCommentTypeByTypeTaskId(newIssue.newIssueType ).then(function (commentType) {
                ScreenService.hideLoader();
                var commentTypeId = commentType ? commentType.ID : 0;
                var commentDescription = entranceComment.DESCRIPTION ? entranceComment.DESCRIPTION : commentType ? commentType.COMMENT_DESCRIPTION : null;
                getFieldDocumentFromNewCommentMailWidget().validations = commentType && commentType.ATTACHMENT_REQUIRED == 'Y' ? {"required": {}} : {};
                newCommentMailWidget.newIssue = newIssue;
                Utilities.localVar.setIssue(issueId);
                newCommentMailWidget.dataSource.data = [];
                newCommentMailWidget.newRow();
                newCommentMailWidget.currentRow.COMMENT_TYPE_ID = commentTypeId;
                newCommentMailWidget.currentRow.DESCRIPTION = commentDescription;
                ScreenService.openPopup(newCommentMailWidget);
            }).catch(function (e) {
                Utilities.showMessageBackEndTrue(e).then(function () {
                    widgetIssuesMain.reload();
                });
            });
        } else {
            IssueService.saveEditedIssueByIssues([newIssue]).then(function () {
                widgetIssuesMain.reload();
            }).catch(function (e) {
                Utilities.showMessageBackEndTrue(e).then(function () {
                    widgetIssuesMain.reload();
                });
            });
        }
    };

    this.issueMainActionEventSave = function(args) {
        var widget = getWidgetIssueMain();
        if(widget.isValid()) {
            var productId = localStorage.getItem('productId');
            if(productId && productId != widget.currentRow.PRODUCT){
                LocalStorage.setItem('ProductName', widget.currentRow.PRODUCT_NAME);
                var commentWidget = getWidgetChangeProductComment();
                commentWidget.currentRow.DESCRIPTION = "Produto alterado para o produto : " +  widget.currentRow.PRODUCT_NAME;
                ScreenService.openPopup(commentWidget);
            }else{
                widget.currentRow.IS_BOARD_ISSUE = true;
                widget.saveRow().then(function(response) {
                    if(response.dataset.issue[0].RELOAD) {
                        getWidgetIssueGrid().reload();

                        ScreenService.showLoader();
                        widget.reload().then(function () {
                            ScreenService.hideLoader();
                            setEnabledTabbedsIssue();
                        }).catch(ScreenService.hideLoader);

                        if(widget.id != getWidgetIssuesMain().id) {
                            getWidgetIssuesMain().reload();
                        }
                    } else {
                        ScreenService.showLoader();
                        widget.reload().then(function () {
                            ScreenService.hideLoader();
                            setEnabledTabbedsIssue();
                        }).catch(ScreenService.hideLoader);
                    }
                });
            }

        }
    };

    var setEnabledTabbedsIssue = function () {
        var widget = getWidgetIssueMain();
        var currentRow = widget.currentRow;
        Utilities.setStatusEnabledWidgets(getWidgetTabbedIssue().widgets, true);
        var budgetWidget = getWidgetBudget();
        budgetWidget.enabled = !!currentRow.WITH_BUDGET;
        widget.view();
    };

    this.newCommentMailActionEventSaveNewComment = function(args){
        saveCommentMail(args);
    };

    var saveCommentMail = function(){
        var widget = getWidgetNewCommentMail();
        var widgetIssuesMain = getWidgetIssuesMain();
        var newIssue = widget.newIssue;
        widget.currentRow.HOMOLOGATED = true;
        widget.currentRow.TASK = Utilities.localVar.getIssue()[0];
        newIssue.DESCRIPTION = widget.currentRow.DESCRIPTION;
        if(widget.isValid()) {
            widget.saveRow().then(function () {
                ScreenService.closePopup();
                return IssueService.saveEditedIssueByIssues([newIssue]).then(function(){
                    widgetIssuesMain.reload();
                    widgetIssuesMain.activate();
                }).catch(function(e){
                    Utilities.showMessageBackEndTrue(e).then(function(){
                        widgetIssuesMain.reload();
                        widgetIssuesMain.activate();
                    });
                });
            });
        } else {
            ScreenService.showMessage(Utilities.messages.ERR_REQUIRED_FIELDS, 'ERROR');
        }
    };

    this.newCommentMailActionEventBack = function(args){
        getWidgetIssuesMain().reload().then(function(){
            ScreenService.closePopup();
        });
    };

    this.commentsActionEventAddComments = function(args){
        widget = getWidgetIssueMain();
        if (widget.currentRow.FINISHED === 'Y') {
            ScreenService.showMessage(Utilities.messages.ERR_COMMENT_CLOSED);
        } else {
            ScreenService.showLoader();
            IssueService.findCommentTypeByControl("C").then(function(commentType){
                ScreenService.hideLoader();
                var commentTypeId = commentType ? commentType.ID : 0;
                var commentDescription = commentType ? commentType.COMMENT_DESCRIPTION : null;
                getFieldDocumentFromNewCommentWidget().validations = commentType && commentType.ATTACHMENT_REQUIRED == 'Y' ? {"required": {}} : {};
                var newCommentWidget = getWidgetNewComment();
                newCommentWidget.dataSource.data = [];
                newCommentWidget.newRow();
                newCommentWidget.currentRow.COMMENT_TYPE_ID = commentTypeId;
                newCommentWidget.currentRow.DESCRIPTION = commentDescription;
                newCommentWidget.list();
                newCommentWidget.currentRow.TASK = Utilities.localVar.getIssue()[0];
                ScreenService.openPopup(newCommentWidget);
            }).catch(ScreenService.hideLoader);
        }
    };

    this.openSwipeNewIssue = function(args) {
        var issueWidget = getWidgetNewIssue();

        issueWidget.getField('PRODUCT_NAME').reload();
        issueWidget.getField('SPONSOR').reload();
        issueWidget.getField('ISSUE_CLASSIFICATION_NAME').reload();
        issueWidget.getField('REPORTER_NAME').reload();
        issueWidget.getField('PRIORITY_NAME').reload();

        ScreenService.showLoader();
        var statusField = getFieldIssueStatusNameFromWidgetNewIssue();
        statusField.reload().then(function(){
            ScreenService.openSwipe(issueWidget);
            issueWidget.newRow();
            issueWidget.currentRow.PRIORITY = 0;
            issueWidget.currentRow.PERCENT_COMPLETED = 0;
            var status = statusField.dataSource.data.filter(Utilities.isStatusDefault);
            if(status.length <= 0){
                status = statusField.dataSource.data.filter(Utilities.isStatusInitial);
            }
            status = status[0];
            issueWidget.currentRow.ISSUE_STATUS_NAME = status.LABEL;
            issueWidget.currentRow.ISSUE_STATUS = status.ID;
            issueWidget.currentRow.DUE_DATE = Utilities.getCurrentDate();
            IssueService.findUserData().then(function(data){
                ScreenService.hideLoader();
                issueWidget.currentRow.REPORTER_NAME = data.NAME;
                issueWidget.currentRow.REPORTER = data.RESOURCE_ID;
                getFieldReporterNameFromWidgetNewIssue().dataSource.data.push({'ID': data.RESOURCE_ID, 'NAME': data.NAME});
                templateManager.updateTemplate();
            }).catch(Utilities.showMessageBackEndTruewithThrow);
        }).catch(ScreenService.hideLoader);
    };


    var getFieldIssueStatusNameFromInfoIssueDependentWidget = function () {
        return getWidgetInfoIssueDependent().getField('ISSUE_STATUS_NAME');
    };

    var getFieldReporterNameFromInfoIssueDependentWidget = function () {
        return getWidgetInfoIssueDependent().getField('REPORTER_NAME');
    };

    var getFieldFollowersFromWidgetIssueDependentWidget = function () {
        return getWidgetInfoIssueDependent().getField('FOLLOWERS');
    };

    var getFieldProductNameFromWidgetIssueDependentWidget = function () {
        return getWidgetInfoIssueDependent().getField('PRODUCT_NAME');
    };

    var getFieldSponsorFromWidgetIssueDependentWidget = function () {
        return getWidgetInfoIssueDependent().getField('SPONSOR');
    };

    var getFieldIssueClassificationNameFromWidgetIssueDependentWidget = function () {
        return getWidgetInfoIssueDependent().getField('ISSUE_CLASSIFICATION_NAME');
    };

    var getFieldPriorityNameFromWidgetIssueDependentWidget = function () {
        return getWidgetInfoIssueDependent().getField('PRIORITY_NAME');
    };

    var getWidgetIssueDependent = function () {
        return templateManager.container.getWidget('ISSUE_DEPENDENT');
    };

    var getWidgetInfoIssueDependent = function () {
        return templateManager.container.getWidget('INFO_ISSUE_DEPENDENT');
    };

    var getWidgetTabbedIssueDependent = function () {
        return templateManager.container.getWidget('TABBED_ISSUE_DEPENDENT');
    };

    var getWidgetTabbedIssue = function () {
        return templateManager.container.getWidget('TABBED_ISSUE');
    };


    var getWidgetProductIssueDependent = function () {
        return templateManager.container.getWidget('PRODUCT_ISSUE_DEPENDENT');
    };

    this.issueDependentActionEventBack = function () {
        backToKanban();
    };

    this.issueDependentActionEventBackView = function (args) {
        var widget = getWidgetIssueDependent();
        ScreenService.closeSwipe().then(function () {
            widget.activate();
        });
    };

    this.issueDependentActionEventAdd = function (args) {
        this.onAddIssue();
        getWidgetInfoIssueDependent().lastSwipe = getWidgetIssueRelationship();
        getFieldPriorityNameFromWidgetIssueDependentWidget().reload();
        getFieldIssueClassificationNameFromWidgetIssueDependentWidget().reload();
        getFieldSponsorFromWidgetIssueDependentWidget().reload();
        getFieldProductNameFromWidgetIssueDependentWidget().reload();
        getFieldFollowersFromWidgetIssueDependentWidget().reload();
        getFieldReporterNameFromInfoIssueDependentWidget().reload();
        getFieldIssueStatusNameFromInfoIssueDependentWidget().reload();
    };

    this.issueDependentWidgetAfterMoveRow = function (args) {
        var issueDependentId = getWidgetIssueDependent().currentRow.ID;
        if (issueDependentId) {
            var widgetForm = getWidgetInfoIssueDependent();
            ScreenService.openSwipe(getWidgetTabbedIssueDependent());
            Utilities.localVar.setLocalVarIssueDependentId(issueDependentId);
            widgetForm.activate();
            widgetForm.list();
            widgetForm.reload();
        }
    };

    this.issueDependentWidgetAfterLoadDataSource = function(){
        var widget = getWidgetInfoIssueDependent();
        widget.view();
        widget.template = widget.formTemplate;
        widget.moveToFirst();
        var fieldFollowers = getFieldFollowersFromWidgetIssueDependentWidget();
        Utilities.bugPaginationOnSelectMultiplyOnModeView(fieldFollowers);
    };

    this.issueDependentWidgetOnEnterTab = function (args) {
        getWidgetIssueDependent().reload();
    };

    this.issuesMainWidgetOnEnter = function() {
        ScreenService.showLoader();
        Utilities.localVar.getLoginPromise().then(function(){
            ScreenService.hideLoader();
            var widget = getWidgetIssuesMain();
            var issue = Utilities.localVar.getIssue() ? Utilities.localVar.getIssue() : null;
            localStorageEngine.setLocalVar('DOMINANT_WIDGET', 'MAIN');
            var tabbedWidget = getWidgetTabbedIssue();
            var lastWindow = Utilities.localVar.getLastWindow();
            var issueMainWidget = getWidgetIssueMain();
            widget.kanbanItemClosed = true;
            if (lastWindow === 'unreadComments' && issue){
                Utilities.localVar.setIssue(issue[0]);
                ScreenService.showLoader();
                issueMainWidget.list();
                issueMainWidget.reload().then(function() {
                    issueMainWidget.view();
                    ScreenService.hideLoader();
                    ScreenService.openSwipe(tabbedWidget).then(function(){
                        widget.currentRow.ISSUE_ID = issue[0];
                        widget.currentRow.PRODUCT = Utilities.localVar.getBoardId();
                        ZhFilterPreferences.setOriginalFilter(widget.id, widget.currentRow);
                        Utilities.startFilter(widget, widget.currentRow, true);
                    });
                }).catch(ScreenService.hideLoader);
            } else if (Utilities.isAppliedFilter(widget)) {
                widget.currentRow.PRODUCT = Utilities.localVar.getBoardId();
                ZhFilterPreferences.setOriginalFilter(widget.id, widget.currentRow);
                Utilities.startFilter(widget, widget.currentRow, true);
            } else if (lastWindow == 'dashboard') {
                setDefaultFilterIssuesByDashboard(false);
            } else {
                setDefaultFilterBoardIssuesKanban();
            }
            localStorage.setItem('boardIssuesWidget', 'KANBAN');
            Utilities.localVar.setLastWindow("boardIssues");
        }).catch(ScreenService.hideLoader);
    };

    var setDefaultFilterIssuesByDashboard = function(isIssuesList){
        var widget, issueStatusNameField, framingField;
        if(isIssuesList){
            widget = getWidgetIssueGrid();
            issueStatusNameField = getFieldIssueStatusFromBoardIssueFilterGrid();
            framingField = getFieldTypeTaskfromissueGridWidget();
        } else {
            widget = getWidgetIssuesMain();
            issueStatusNameField = getFieldIssueStatusNameFromBoardIssueFilter();
            framingField = getFieldFramingFromIssuesMainWidget();
        }

        ScreenService.showLoader();
        return issueStatusNameField.reload().then(function () {
            return Utilities.setDefaultValuesToSelectMultipleField(issueStatusNameField, [CONTROL_TASK_TYPE_BACKLOG], 'CONTROL');
        }).then(function () {
            return Utilities.setDefaultValueToSelectMultipleFieldFilteringData(
                framingField, Utilities.constants.CONTROL_TASK_TYPE_HOMOLOGATED, 'CONTROL', 'ID'
            );
        }).then(function () {
            ScreenService.hideLoader();
            framingField.widget.PMFramingValues = framingField.value();
            getFieldProductFromIssuesMainWidget().reload();

            widget.currentRow.PRODUCT = Utilities.localVar.getBoardId();
            widget.currentRow.ISSUE_STATUS_NAME = issueStatusNameField.value();
            widget.currentRow.LABEL_CHECK = 'N';
            widget.currentRow.LAST_DATE_VIEW = 'N';

            if(isIssuesList) {
                widget.currentRow.TYPE_TASK = framingField.value();
            } else {
                widget.currentRow.FRAMING = framingField.value();
            }

            ZhFilterPreferences.setOriginalFilter(widget.id, widget.currentRow);
            Utilities.startFilter(widget, widget.currentRow, true);
        }).catch(ScreenService.hideLoader);
    };

    this.issueGridWidgetAfterMoveRow = function(args){
        var currentRow = getWidgetIssueGrid().currentRow;
        getFieldResponseFromIssueMainWidget().isVisible = (currentRow.TASK_TYPE_CONTROL == 'H');
        self.onClickIssue(currentRow.ID,currentRow.ALLOW_CLOSE_ISSUE,currentRow.ISSUE_STATUS,currentRow.ISSUE_CLASSIFICATION,currentRow.RESOURCE_T);
    };

    this.issuesMainWidgetAfterMoveRow = function(args){
        var currentRow = args.e.item;
        getFieldResponseFromIssueMainWidget().isVisible = (currentRow.columnType == 'H');
        self.onClickIssue(currentRow.id,currentRow.ALLOW_CLOSE_ISSUE,currentRow.ISSUE_STATUS,currentRow.issueClassification,currentRow.REPORTER);
    };

    this.onClickIssue = function(id,allowCloseIssue,taskStatus,issueClassification, reporter) {
        var tabbedWidget = getWidgetTabbedIssue();
        var taskParameters = Utilities.localVar.getTaskParameters();
        var finalTaskStatus = taskParameters.FINAL_TASK_STATUS_ID;
        var currentUserId = Utilities.localVar.getIdBusinessPartner();
        Utilities.localVar.setIssue(id);
        tabbedWidget.currentWidget = tabbedWidget.currentWidget ? tabbedWidget.currentWidget : tabbedWidget.widgets[0];
        tabbedWidget.currentWidget.list();
        ScreenService.showLoader();
        tabbedWidget.currentWidget.reload().then(function(){
            ScreenService.hideLoader();
            var currentRow = tabbedWidget.currentWidget.currentRow;
            allowCloseIssue = currentRow.ALLOW_CLOSE_ISSUE;
            taskStatus = currentRow.ISSUE_STATUS;
            issueClassification = currentRow.ISSUE_CLASSIFICATION;
            reporter = currentRow.REPORTER;
            getActionCloseIssueInIssueMain().isVisible = (allowCloseIssue === 'Y') && (taskStatus != finalTaskStatus) && (reporter == currentUserId);
        }).catch(ScreenService.hideLoader);
        if(tabbedWidget.currentWidget.isComments){
            IssueService.viewComments();
        }
        var issueMainWidget = getWidgetIssueMain();
        if(issueMainWidget.id != tabbedWidget.currentWidget){
            issueMainWidget.reload();
        }
        var fieldLabels = getFieldLabelsFromIssueMainWidget();
        if(fieldLabels){
            fieldLabels.reload();
            fieldLabels.dataSource.clearCheckedRows();
        }
        var upperBudgetTabbedWidget = getWidgetUpperBudgetTabbed();
        if(upperBudgetTabbedWidget.id == tabbedWidget.currentWidget.id){
            getWidgetBudget().reload();
        }
        Utilities.localVar.setIssueClassification(issueClassification);
        getWidgetIssuesMain().descriptionOrder = getWidgetIssueGrid().descriptionOrder;
        if (!ScreenService.isSwipeOpen()) {
            ScreenService.openSwipe(tabbedWidget);
        }
    };

    this.issueGridWidgetOnEnterTab = function () {
        var widget = getWidgetIssueGrid();
        var issue = Utilities.localVar.getIssue() ? Utilities.localVar.getIssue() : null;
        localStorageEngine.setLocalVar('DOMINANT_WIDGET', 'GRID');
        var tabbedWidget = getWidgetTabbedIssue();
        var lastWindow = Utilities.localVar.getLastWindow();
        widget.filterRow = {};
        if (lastWindow === 'unreadComments' && issue){
            var issueMainWidget = getWidgetIssueMain();
            Utilities.localVar.setIssue(issue[0]);
            ScreenService.showLoader();
            issueMainWidget.list();
            issueMainWidget.reload().then(function() {
                issueMainWidget.view();
                ScreenService.hideLoader();
                ScreenService.openSwipe(tabbedWidget).then(function(){
                    widget.filterRow.ID = issue[0];
                    widget.filterRow.PRODUCT = Utilities.localVar.getBoardId();
                    ZhFilterPreferences.setOriginalFilter(widget.id, widget.filterRow);
                    Utilities.startFilter(widget, widget.filterRow, true);
                });
            }).catch(ScreenService.hideLoader);
        } else if (Utilities.isAppliedFilter(widget)) {
            widget.filterRow.PRODUCT = Utilities.localVar.getBoardId();
            ZhFilterPreferences.setOriginalFilter(widget.id, widget.filterRow);
            Utilities.startFilter(widget, widget.filterRow, true);
        } else if (lastWindow == 'dashboard') {
            setDefaultFilterIssuesByDashboard(true);
        } else {
            setDefaultFilterBoardIssuesGrid();
        }
        localStorage.setItem('boardIssuesWidget', 'GRID');
        Utilities.localVar.setLastWindow("product#boardIssues");
    };

    this.onBackBoards = function(){
        ScreenService.openWindow("product#boards");
    };

    this.boardIssuesContainerAfterinit = function(){
        getWidgetIssueGrid().unSelectAll();
        getWidgetIssuesMain().unSelectAll();
        buildStripeSelectedProjectsWidget();
    };

    this.initFilterBoardIssue = true;

    var setDefaultFilterBoardIssuesKanban = function () {
        var issueStatusNameField = getFieldIssueStatusNameFromBoardIssueFilter();
        var framingField = getFieldFramingFromIssuesMainWidget();
        var valueParameterFinal = null;
        var taskParameters = Utilities.localVar.getTaskParameters();
        var widget = getWidgetIssuesMain();

        if (taskParameters) {
            valueParameterFinal = taskParameters.FINAL_TASK_STATUS_ID;
        } else {
            valueParameterFinal = 0;
        }

        ScreenService.showLoader();
        Utilities.setDefaultValueToSelectMultipleFieldFilteringData(
            issueStatusNameField, [valueParameterFinal], 'ID', 'ID'
        ).then(function () {
            return Utilities.setDefaultValueToSelectMultipleFieldFilteringData(
                framingField, Utilities.constants.CONTROL_TASK_TYPE_HOMOLOGATED, 'CONTROL', 'ID'
            );
        }).then(function () {
            ScreenService.hideLoader();
            framingField.widget.PMFramingValues = framingField.value();
            getFieldProductFromIssuesMainWidget().reload();
            var productBoardIssueFilter = LocalStorage.getItem('productBoardIssueFilter');

            widget.currentRow.PRODUCT = Utilities.localVar.getBoardId() ? Utilities.localVar.getBoardId() : productBoardIssueFilter;
            widget.currentRow.FRAMING = framingField.value();
            widget.currentRow.ISSUE_STATUS_NAME = issueStatusNameField.value();
            widget.currentRow.LABEL_CHECK = 'N';
            widget.currentRow.LAST_DATE_VIEW = 'N';

            ZhFilterPreferences.setOriginalFilter(widget.id, widget.currentRow);
            Utilities.startFilter(widget, widget.currentRow, true);
        }).catch(ScreenService.hideLoader);
    };

    this.initFilterBoardIssueGrid = true;

    var setDefaultFilterBoardIssuesGrid = function(){
        var widget = getWidgetIssueGrid();
        var valueParameterFinal;
        var taskParameters = Utilities.localVar.getTaskParameters();
        var issueStatusNameField = getFieldIssueStatusFromBoardIssueFilterGrid();
        var typeTaskField = getFieldTypeTaskfromissueGridWidget();

        if (taskParameters) {
            valueParameterFinal = taskParameters.FINAL_TASK_STATUS_ID;
        } else {
            valueParameterFinal = 0;
        }

        ScreenService.showLoader();
        Utilities.setDefaultValueToSelectMultipleFieldFilteringData(
            issueStatusNameField, [valueParameterFinal], 'ID', 'ID'
        ).then(function () {
            return Utilities.setDefaultValueToSelectMultipleFieldFilteringData(
                typeTaskField, Utilities.constants.CONTROL_TASK_TYPE_HOMOLOGATED, 'CONTROL', 'ID'
            );
        }).then(function () {
            ScreenService.hideLoader();
            getFieldProductFromIssueGridWidget().reload();
            var productBoardIssueFilter = LocalStorage.getItem('productBoardIssueFilter');

            widget.currentRow.PRODUCT = Utilities.localVar.getBoardId() ? Utilities.localVar.getBoardId() : productBoardIssueFilter;
            widget.currentRow.TYPE_TASK = typeTaskField.value();
            widget.currentRow.ISSUE_STATUS_NAME = issueStatusNameField.value();
            widget.currentRow.LABEL_CHECK = 'N';
            widget.currentRow.LAST_DATE_VIEW = 'N';

            ZhFilterPreferences.setOriginalFilter(widget.id, widget.currentRow);
            Utilities.startFilter(widget, widget.currentRow, true);
        }).catch(ScreenService.hideLoader);
    };

    this.onAddIssue = function () {
        var infoIssueDependent = getWidgetInfoIssueDependent();
        var statusField = getFieldIssueStatusNameFromInfoIssueDependentWidget();
        infoIssueDependent.lastSwipe = templateManager.container.getActiveWidget().lastActiveWidget;
        ScreenService.closePopup();
        infoIssueDependent.newRow();
        infoIssueDependent.activate();
        Utilities.getUserData().then(function (userData) {
            Utilities.setValueInSelectField(getFieldReporterNameFromInfoIssueDependentWidget(), userData.RESOURCE_ID);
        });
        ScreenService.openSwipe(infoIssueDependent);
        statusField.reload().then(function() {
            var status = Utilities.getRowInDataSource(statusField.dataSource, statusField.controlValue, Utilities.constants.BEGIN_TASK_STATUS_ISSUE);
            Utilities.setOutData(statusField, status[statusField.valueField]);
        });
        infoIssueDependent.dataSource.data = [];
        infoIssueDependent.currentRow.DUE_DATE = Utilities.getCurrentDate();
    };

    this.issueDependentActionEventAddList = function () {
        var productTasksWidget = getWidgetProductIssueDependent();
        productTasksWidget.dataSource.clearCheckedRows();
        productTasksWidget.dataSource.updateCheckedRows();
        ScreenService.openPopup(productTasksWidget);
        productTasksWidget.reload();
    };

    this.productIssueDependentActionEventBack = function () {
        closePopupProductIssueDependent();
    };

    this.infoIssueDependentActionEventBack = function () {
        ScreenService.closeSwipe().then(function () {
            var widget = getWidgetIssueDependent();
            widget.reload();
            widget.list();
            widget.activate();
        });
    };

    this.newIssueActionEventSave = function(){
        self.saveIssue();
    };

    this.saveIssue = function() {
        var widget = getWidgetNewIssue();
        if(widget.isValid()) {
            widget.currentRow.IS_BOARD_ISSUE = true;
            IssueService.saveNewIssue([widget.currentRow]).then(function() {
                widget.setCurrentRow({});
                widget.dataSource.data = [];
                ScreenService.closeSwipe();
                var issuesWidget = localStorage.getItem('boardIssuesWidget') == 'GRID' ?
                    getWidgetIssueGrid() : getWidgetIssuesMain();
                issuesWidget.activate();
                ScreenService.showLoader();
                issuesWidget.reload().then(ScreenService.hideLoader).catch(ScreenService.hideLoader);
            }).catch(Utilities.showMessageBackEndTrue);
        }
    };

    this.newIssueFieldOnChangeProductName = function () {
        var widget = getWidgetNewIssue();
        var fieldValue = getFieldProductNameFromNewIssueWidget().value();
        var versionField = getFieldVersionFromNewIssueWidget();
        var versionDevField = getFieldVersionDevFromNewIssueWidget();
        if (fieldValue) {
            var productId = getWidgetNewIssue().currentRow.PRODUCT;
            localStorageEngine.setLocalVar('PROJECT_ID', productId);
            localStorageEngine.setLocalVar('projectIdToLabel', productId);
            versionField.readOnly = false;
            versionDevField.readOnly = false;
            versionField.reload();
            versionDevField.reload();
            widget.currentRow.VERSION = 'Última versão';
            widget.currentRow.VERSION_DEV = 'Última versão';
        } else {
            versionField.readOnly = true;
            versionDevField.readOnly = true;
            widget.currentRow.VERSION = '';
            widget.currentRow.VERSION_DEV = '';
            widget.currentRow.PRODUCT_VERSION_ID = '';
            widget.currentRow.PRODUCT_VERSION_DEV_ID = '';
            localStorageEngine.setLocalVar('projectIdToLabel', null);

        }
        getFieldLabelsFromWidgetNewIssue().reload();
    };

    this.newIssueFieldOnChangeSponsor = function (){
        var widget = getWidgetNewIssue();
        localStorageEngine.setLocalVar('clientId', widget.currentRow.SPONSOR_ID);
        getFieldVersionDevFromNewIssueWidget().reload();
    };

    this.infoIssueDependentActionEventSave = function(args) {
        var widget = getWidgetInfoIssueDependent();
        var parentWidget = getWidgetIssueDependent();
        widget.currentRow.ISSUE = Utilities.localVar.getIssue()[0];
        if (widget.isValid()) {
            widget.saveRow().then(function () {
                ScreenService.closeSwipe().then(function () {
                    parentWidget.reload();
                    parentWidget.activate();
                });
            }).catch(Utilities.showMessageBackEndTrue);
        }
    };

    this.infoIssueDependentActionEventDelete = function () {
        var widget = getWidgetIssueDependent();
        Utilities.localVar.setIssue(Utilities.localVar.getIssue()[0]);
        ScreenService.confirmMessage(Utilities.messages.ALE_DELETE_TASK_RELATIONSHIP, 'question', function () {
            widget.dataSource.remove([widget.currentRow]).then(function () {
                widget.reload();
                ScreenService.closeSwipe().then(function () {
                    widget.list();
                    widget.activate();
                });
            }).catch(Utilities.showMessageBackEndTrue);
        });
    };

    var closePopupProductIssueDependent = function (){
        ScreenService.closePopup();
        getWidgetIssueDependent().reload();
    };

    this.productIssueDependentActionEventAssociate = function () {
        var checkedRows = getWidgetProductIssueDependent().dataSource.getCheckedRows();
        var issueId = Utilities.localVar.getIssue();
        issueId = issueId instanceof Array ? issueId : [issueId];

        checkedRows = checkedRows.map(function (row) {
            row.changed = true;
            row.ISSUE = issueId;
            return row;
        });

        IssueService.saveIssueRelationship(checkedRows).then(function () {
            closePopupProductIssueDependent();
        }).catch(Utilities.showMessageBackEndTrue);

    };

    this.productIssueDependentActionEventAdd = function(){
        this.onAddIssue();
    };

    this.createTaskIssueFieldOnClickResourcesNames = function(args){
        getFieldResourcesNamesFromWidgetCreateIssueTask().reload();
    };

    this.issueUploadActionEventDeleteDocuments = function(args){
        var widget = getWidgetIssueUpload();
        ScreenService.confirmMessage(Utilities.messages.ALE_DELETE_ATTACHMENT, null,function() {
            deleteAttachment([widget.currentRow]).then(function (response) {
                ScreenService.successNotification(response.notifications[0].message);
                ScreenService.closeSwipe().then(function(){
                    widget.reload();
                });
            });
        });
    };

    var deleteAttachment = function(dataSet){
        return restEngine.post("/deleteAttachment",
            {
                requestType: "DataSet",
                dataset: dataSet
            }
        );
    };


    this.pmGenerationProjectIdFilter = function(array,projectIds){
        return array.filter(function (field) {
            return !field.pmIsGeneration || Utilities.inArray(field.pmProjectId, projectIds);
        });
    };

    this.fieldOnClickEventRemoveTaskGeneration = function (args) {
        var owner = Utilities.getOwnerFixBug(args);
        var projectId = owner.pmProjectId;
        var widget = getWidgetCreateTaskIssue();
        var fields = widget.fields;
        var allProjectsField = getFieldAllProjectsFromWidgetCreateTaskIssue();
        var allProjectsForTask = allProjectsField.value();
        allProjectsForTask = allProjectsForTask.filter(function(projectForTask){
            return projectId != projectForTask;
        });
        allProjectsField.value(allProjectsForTask);
        widget.fields = self.pmGenerationProjectIdFilter(fields,allProjectsForTask);
    };

    this.createTaskIssueActionEventCreate = function() {
        var widget = getWidgetCreateTaskIssue();
        var createTasksByIssues = function () {
            var row = Utilities.getWidgetCurrentRowAsChanged(getWidgetCreateTaskIssue());
            var issueVersionDev = widget.issueVersionDev;
            var projectVersionDev = widget.projectVersionDev;
            row.ALL_VERSION_DEV_ID = issueVersionDev ? issueVersionDev.PRODUCT_VERSION_ID_DEV : projectVersionDev ? projectVersionDev.productVersionId : null;
            row.ALL_VERSION_DEV = issueVersionDev ? issueVersionDev.VERSION_DEV : projectVersionDev ? projectVersionDev.productVersionLabel : null;
            row.PROJECT_PRODUCT_ISSUE_ID = row.ALL_VERSION_DEV ? widget.projectProductIssueId : null;

            var checkedRows = getFieldAllProjectsFromWidgetCreateTaskIssue().dataSource.getCheckedRows();
            var projectMsg = '';
            var project_not_allowed = false;
            
            checkedRows.forEach(function (project) {
                if(project.ALLOW_TASK == 'N'){
                    project_not_allowed = true;
                }
            });

            if(project_not_allowed){
                ScreenService.showMessage(Utilities.messages.ALE_PROJECT_NOT_ALLOW_TASK);
            }else{
                var data = checkedRows.filter(function (row) {
                    return row.EXTERNALTYPE == 'B' && row.CONTROL == 'D';
                }).map(function(row){
                    projectMsg += '<li>' + row.ID + ' - ' + row.NAME + '</li>';
                    return {ID: row.ID, NAME: row.NAME};
                });
    
                var msg = Utilities.messages.ALE_PROJECT_IN_PROGRESS_BY_BOARD_ISSUE.replace('%1', projectMsg);
    
                if(data.length) {
                    ScreenService.confirmMessage(msg, 'question', function(){
                        IssueService.saveCreateTasksByIssues([row]).then(function () {
                            var tabbedBoardIssueWidget = getWidgetTabbedBoardIssue();
                            ScreenService.closePopup(true);
                            Utilities.clearCheckedRowsAndReload(tabbedBoardIssueWidget.currentWidget);
                        }).catch(function (response) {
                            Utilities.showMessageErrorOfBackEnd(response, null, null, true);
                        });
                    });
                } else {
                    IssueService.saveCreateTasksByIssues([row]).then(function () {
                        var tabbedBoardIssueWidget = getWidgetTabbedBoardIssue();
                        ScreenService.closePopup(true);
                        Utilities.clearCheckedRowsAndReload(tabbedBoardIssueWidget.currentWidget);
                    }).catch(function (response) {
                        Utilities.showMessageErrorOfBackEnd(response, null, null, true);
                    });
                }
            }
            

        };

        if(widget.isValid()){
            var versions = [];
            ProjectServiceList.validateConcludedSubrelease(widget.currentRow.ALL_PROJECTS).then(function(response){
                if (response.SUBRELEASE_IS_CLOSED) {
                    ScreenService.showMessage(Utilities.messages.ERR_SUBRELEASE_FINISHED);
                } else {
                    widget.currentRow.ALL_PROJECTS.forEach(function (projectId) {
                
                        var versionDevField = self.getVersionDevField(projectId, widget);
                        if(versionDevField.value() > 0){
                            versions.push(versionDevField.value());
                            }
                        });
        
                        if (!Util.isBlank(widget.projectsWithoutVersion) || !Util.isBlank(widget.issuesWithoutVersion)) {
                            ScreenService.confirmMessage(createMsgProjectIssueWithoutVersion(), 'question', function () {
                            createTasksByIssues();
                        });
                        } else {
                            createTasksByIssues();
                        }
                }
            }).catch(Utilities.showMessageBackEndTrue);
            //undo changes

        }
    };

    this.createTasksByIssues = function() {
            var widget = getWidgetCreateTaskIssue();
            var row = Utilities.getWidgetCurrentRowAsChanged(getWidgetCreateTaskIssue());
            var issueVersionDev = widget.issueVersionDev;
            var projectVersionDev = widget.projectVersionDev;
            row.ALL_VERSION_DEV_ID = issueVersionDev ? issueVersionDev.PRODUCT_VERSION_ID_DEV : projectVersionDev ? projectVersionDev.productVersionId : null;
            row.ALL_VERSION_DEV = issueVersionDev ? issueVersionDev.VERSION_DEV : projectVersionDev ? projectVersionDev.productVersionLabel : null;
            row.PROJECT_PRODUCT_ISSUE_ID = row.ALL_VERSION_DEV ? widget.projectProductIssueId : null;

            var checkedRows = getFieldAllProjectsFromWidgetCreateTaskIssue().dataSource.getCheckedRows();
            var projectMsg = '';

            var data = checkedRows.filter(function (row) {
                return row.EXTERNALTYPE == 'B' && row.CONTROL == 'D';
            }).map(function(row){
                projectMsg += '<li>' + row.ID + ' - ' + row.NAME + '</li>';
                return {ID: row.ID, NAME: row.NAME};
            });

            var msg = Utilities.messages.ALE_PROJECT_IN_PROGRESS_BY_BOARD_ISSUE.replace('%1', projectMsg);

            if(data.length) {
                ScreenService.confirmMessage(msg, 'question', function(){
                    IssueService.saveCreateTasksByIssues([row]).then(function () {
                        var tabbedBoardIssueWidget = getWidgetTabbedBoardIssue();
                        ScreenService.closePopup(true);
                        Utilities.clearCheckedRowsAndReload(tabbedBoardIssueWidget.currentWidget);
                    }).catch(function (response) {
                        Utilities.showMessageErrorOfBackEnd(response, null, null, true);
                    });
                });
            } else {
                IssueService.saveCreateTasksByIssues([row]).then(function () {
                    var tabbedBoardIssueWidget = getWidgetTabbedBoardIssue();
                    ScreenService.closePopup(true);
                    Utilities.clearCheckedRowsAndReload(tabbedBoardIssueWidget.currentWidget);
                }).catch(function (response) {
                    Utilities.showMessageErrorOfBackEnd(response, null, null, true);
                });
            }
    };



    var createMsgProjectIssueWithoutVersion = function (){
        var widget = getWidgetCreateTaskIssue();
        var msg = Utilities.messages.ALE_PROJECT_ISSUE_WITHOUT_VERSION;
        return msg.replace('%versionDev%', widget.allVersionDev) + getMsgProductWithoutVersion() + getMsgIssueWithoutVersion();
    };

    var getMsgProductWithoutVersion = function(){
        var widget = getWidgetCreateTaskIssue();
        var projectList = '';
        if(!Util.isBlank(widget.projectsWithoutVersion)){
            projectList = '<p align="left"><strong>Projetos:</strong></p><br/>';
            var projects = Utilities.removeDuplicateValuesInArray(widget.projectsWithoutVersion);
            projects.forEach(function (project) {
                projectList += '<li align="left" fontsize="2"><font size="2">' + project + '</font></li>';
            });
            projectList += '<br/>';
        }
        return projectList;
    };

    var getMsgIssueWithoutVersion = function () {
        var widget = getWidgetCreateTaskIssue();
        var issueList = '';
        if (!Util.isBlank(widget.issuesWithoutVersion)) {
            issueList = '<p align="left"><strong>Issues:</strong></p><br/>';
            var issues = Utilities.removeDuplicateValuesInArray(widget.issuesWithoutVersion);
            issues.forEach(function (issue) {
                issueList += '<li align="left"><font size="2">' + issue + '</font></li>';
            });
        }
        return issueList;
    };

    this.issuesMainActionEventNewTasks = function(){
        removeAllFieldsPmGeneration(getWidgetCreateTaskIssue());
        issuesMainActionEventNewTasks(getWidgetIssuesMain());
    };
    this.issueGridActionEventNewTasks = function(){
        removeAllFieldsPmGeneration(getWidgetCreateTaskIssue());
        issuesMainActionEventNewTasks(getWidgetIssueGrid());
    };

    var validateCreateTasks = function(issues) {
        var validation = true;
        if (issues.length > 1) {
            var differentIssues = issues.filter(function (issue) {
                return issue.ISSUE_CLASSIFICATION != issues[0].ISSUE_CLASSIFICATION || issue.ISSUE_STATUS != issues[0].ISSUE_STATUS;
            });
            validation = !differentIssues.length;
        }
        return validation;
    };

    var setClassificationsInCreateTasks = function(taskClassifications, createTaskIssueWidget, issues) {
        var taskClassificationIds = taskClassifications.map(function (taskClassificationId) {
            return taskClassificationId.ID;
        });
        createTaskIssueWidget.currentRow.taskClassificationIds = taskClassificationIds;
        getFieldIssuesFromWidgetCreateTaskIssue().dataSource.data = issues;
        var fieldClassificationName = getFieldClassificationNameFromCreateTaskIssue();
        fieldClassificationName.reload().then(function () {
            if (taskClassificationIds.length == 1) {
                fieldClassificationName.readOnly = true;
                Utilities.setOutData(fieldClassificationName, taskClassificationIds[0]);
            } else if (!taskClassificationIds.length) {
                fieldClassificationName.readOnly = true;
                Utilities.setOutData(fieldClassificationName, issues[0].ISSUE_CLASSIFICATION);
            } else {
                fieldClassificationName.readOnly = false;
            }
        });
    };

    this.issueRelationshipActionEventAdd = function(args){
        var issueCurrent = getWidgetIssueMain().currentRow;
        onAddTask(issueCurrent);
        getWidgetNewTask().lastSwipe = getWidgetIssueRelationship();
    };

    var onAddTask = function(issueCurrent){
        Utilities.localVar.setIssueClassifications(null);
        var newTaskWidget = getWidgetNewTask();
        var issues = Utilities.localVar.getIssue();
        newTaskWidget.lastSwipe = templateManager.container.getActiveWidget().lastActiveWidget;
        ScreenService.closePopup(true);
        ScreenService.openSwipe(newTaskWidget);
        newTaskWidget.newRow();
        newTaskWidget.activate();
        Utilities.clearWidgetCacheFields(newTaskWidget);
        getFieldStartFromNewTask().value(Utilities.getCurrentDate());
        getFieldEndFromNewTask().value(Utilities.getCurrentDate());
        if(issueCurrent){
            getFieldNameFromNewTask().value(issueCurrent.LABEL);
            getFieldDescriptionFromNewTask().value(issueCurrent.DESCRIPTION);
        }
        setClassificationInNewTask(issues);
    };

    var setClassificationInNewTask = function (issues) {
        var issueClassification = Utilities.localVar.getIssueClassification();
        var classificationField = getFieldTaskClassificationLabelFromNewTask();
        ScreenService.showLoader();
        IssueService.getTaskClassificationByIssues(issues).then(function (classifications) {
            ScreenService.hideLoader();
            classificationField.reload();
            if (classifications.length > 1) {
                classificationField.readOnly = false;
                var classificationIds = [];
                classifications.forEach(function (classifications) {
                    classificationIds.push(classifications.ID);
                });
                Utilities.localVar.setIssueClassifications(classificationIds);
                classificationField.validations = {"required": {}};
            } else {
                if (classifications.length == 1) {
                    classificationField.readOnly = true;
                    classificationField.validations = false;
                    Utilities.setOutData(classificationField, classifications[0].ID);
                } else if (issueClassification) {
                    classificationField.readOnly = true;
                    Utilities.setOutData(classificationField, issueClassification);
                    classificationField.validations = false;
                } else {
                    classificationField.readOnly = false;
                    classificationField.validations = {"required": {}};
                }
            }
        }).catch(ScreenService.hideLoader);
    };

    this.projectNameFieldOnChange = function(args){
        Utilities.localVar.setSelectedProjectIssueId(getWidgetNewTask().currentRow.PROJECT);
        getFieldResourceFromNewTask().reload();
    };

    var issuesMainActionEventNewTasks = function(widget) {
        if(widget.hasCheckedRows()) {
            var createTaskIssueWidget = getWidgetCreateTaskIssue();
            createTaskIssueWidget.dataSource.data = [];
            createTaskIssueWidget.newRow();
            TaskService.setAsVisibleSingleComments(widget.getCheckedRows());
            Utilities.localVar.setProjectInIssue(0);
            var projectIssueId = Utilities.localVar.getProjectIssueId();
            getFieldAllProjectsFromWidgetCreateTaskIssue().value(projectIssueId);
            self.createTaskIssueFieldOnChangeAllProjects();
            var issues = widget.dataSource.checkedRows;
            if(!IssueService.isIssuesBelongingSameProduct(issues)){
                return false;
            }
            if (validateCreateTasks(issues)) {
                ScreenService.showLoader();
                IssueService.getTaskClassificationByIssue(issues[0].ID).then(function(taskClassifications){
                    ScreenService.hideLoader();
                    localStorageEngine.setLocalVar('issuesInfoCreateTasksByIssue', issues);
                    ScreenService.openPopup(createTaskIssueWidget);
                    setClassificationsInCreateTasks(taskClassifications, createTaskIssueWidget, issues);
                    var issuesCurrent = [];
                    issues.forEach(function (issue) {
                        issuesCurrent.push(issue.ID);
                    });
                    getFieldIssuesFromWidgetCreateTaskIssue().value(issuesCurrent);
                }).catch(Utilities.showMessageBackEndTrue);
            } else {
                ScreenService.showMessage(Utilities.messages.ALE_NOT_DIFFERENT_ISSUE);
            }

        } else {
            ScreenService.showMessage(Utilities.messages.NOT_CHECKED_ROW_TASK);
        }
    };

    var replicateResource = function (field,resourceFields) {
        var values = field.value();
        resourceFields.forEach(function(resourceField){
            Utilities.setValueInSelectMultiple(resourceField,values);
        });

    };

    this.getFilterForGenerationTaskClassification = function(){
        return getWidgetCreateTaskIssue().currentRow.taskClassificationIds;
    };

    this.getFilterForNewTaskClassification = function(){

        return getWidgetIssueMain().currentRow.TASK_CLASSIFICATION_IDS;
    };

    this.fieldOnChangeEventResource = function (args) {
        var ownerField = Utilities.getOwnerFixBug(args);
        var widget = getWidgetCreateTaskIssue();
        var resourceFields = widget.fields.filter(function (field) {
            return field.pmIsGeneration && Utilities.inString(field.name, 'RESOURCE_');
        });

        var ownerValue = ownerField.value();
        var isValueAllResource = true;
        if(resourceFields.length > 1 && ownerValue && ownerValue.length > 0) {
            isValueAllResource = resourceFields.some(function (resourceField) {
                var validate = false;
                if (resourceField.name != ownerField.name) {
                    var value = resourceField.value();
                    validate = !!value && value.length > 0;
                }
                return validate;
            });
        }

        if (!isValueAllResource) {
            ScreenService.showCustomDialog(Utilities.messages.ALE_REPLICATION_RESOURCE,
                'CONFIRMATION', null,
                [
                    {
                        "label": "Sim",
                        "code": function () {
                            replicateResource(ownerField, resourceFields);
                        }
                    },
                    {
                        "label": "Não",
                        "code": function () {
                        }
                    }
                ]);
        }

    };

    this.fieldOnClickEventDescription = function (args) {
        var changeDescWidget = getWidgetChangeDescription();
        var newTaskWIdget = getWidgetCreateTaskIssue();
        var owner = Utilities.getOwnerFixBug(args);
        var fields = changeDescWidget.fields;
        var fieldGroups = changeDescWidget.fieldGroups;
        var allIssuesField = getFieldIssuesFromWidgetCreateTaskIssue();
        var allIssuesForTask = allIssuesField.value();
        var projectId = owner.pmProjectId;
        var i = 0;
        changeDescWidget.currentRow = {};


        allIssuesForTask.forEach(function (issueId) {
                    if (validateFieldCreated(fields, issueId)) {
                        var currentDescription = null;
                        var name = allIssuesField.dataSource.data[i].NAME;
                        localStorageEngine.setLocalVar('ISSUE_ID', issueId);
                        var descriptionFieldGroup = self.getDesciptionFielGroup(issueId, name);
                        fieldGroups.push(descriptionFieldGroup);
                        var descriptionField = self.getDesciptionField(issueId, projectId, name, changeDescWidget);
                        fields.push(descriptionField);
                        if(newTaskWIdget.currentRow["DESCRIPTION_" + projectId] && newTaskWIdget.currentRow["DESCRIPTION_" + projectId]["description_" + issueId]){
                            currentDescription = newTaskWIdget.currentRow["DESCRIPTION_" + projectId]["description_" + issueId];
                        }
                        changeDescWidget.currentRow["DESCRIPTION_" + issueId + "_" + projectId] = currentDescription ? currentDescription : getFieldIssuesFromWidgetCreateTaskIssue().dataSource.data[i].description;
                        i++;
                    }
        });

        ScreenService.openPopup(changeDescWidget);
    };

    this.changeDescriptionSaveAction = function (args) {
       var changeDescWidget = getWidgetChangeDescription();
       var newTaskWidget = getWidgetCreateTaskIssue();
        var description = {};
        var i = 0;
        if(changeDescWidget.isValid()){
            var keys = Object.keys(changeDescWidget.currentRow);
            var value = Object.values(changeDescWidget.currentRow);
            getFieldIssuesFromWidgetCreateTaskIssue().dataSource.data.map(function(){
                var split = keys[i].split("_");
                description['description_' + split[1]] = value[i];
                newTaskWidget.currentRow['DESCRIPTION_' + split[2]] = description;
                i++;
            });
            self.changeDescriptionActionEventBack();
        }

    };

    this.changeDescriptionActionEventBack = function (args) {
        removeAllFieldsPmGeneration(getWidgetChangeDescription());
        removeAllFieldGroupsPmGeneration(getWidgetChangeDescription());
        localStorageEngine.setLocalVar('projectId', null);
        ScreenService.closePopup();
    };

    var validateFieldCreated = function(fields,projectId){
        var generationFields = fields.filter(function(field){
            return field.pmProjectId == projectId;
        });
        return generationFields.length === 0;
    };
    var removeAllFieldsPmGeneration = function(widget){
        widget.fields = widget.fields.filter(function(field){
            return !field.pmIsGeneration;
        });
    };
    var removeAllFieldGroupsPmGeneration = function(widget){
        widget.fieldGroups = [];
    };

    this.createTaskIssueFieldOnChangeAllProjects = function () {
        var widget = getWidgetCreateTaskIssue();
        var fields = widget.fields;
        var allProjectsField = getFieldAllProjectsFromWidgetCreateTaskIssue();
        var allProjectsForTask = allProjectsField.value();
        var issuesInfo = localStorageEngine.getLocalVar('issuesInfoCreateTasksByIssue');

        ScreenService.showLoader();
        TaskService.getProjectsInfoCreateTasksByIssue(allProjectsForTask).then(function (dataset) {
            ScreenService.hideLoader();
            if (IssueService.validateDevVersionBetweenProjectAndIssue(issuesInfo, dataset, widget)) {
                allProjectsForTask.forEach(function (projectId) {
                    if (validateFieldCreated(fields, projectId)) {
                        localStorageEngine.setLocalVar('PROJECT_ID', projectId);
                        var projectNameField = self.getProjectNameField(projectId, widget);
                        var versionDevField = self.getVersionDevField(projectId, widget);
                        var projectTypeNameField = self.getProjectTypeNameField(projectId, widget);
                        var taskTypeNameField = self.getTaskTypeNameField(projectId, widget);
                        var estimatedTime = self.getEstimatedTimeField(projectId, widget);
                        var parentNameField = self.getParentNameField(projectId, widget);
                        var resourceField = self.getResourceField(projectId, widget);
                        var descriptionAciton = self.getDesciptionAction(projectId, widget);
                        var removeField = self.getTrashRemoveField(projectId, widget);
                        fields.push(projectTypeNameField);
                        fields.push(versionDevField);
                        fields.push(taskTypeNameField);
                        fields.push(estimatedTime);
                        fields.push(parentNameField);
                        fields.push(resourceField);
                        fields.push(descriptionAciton);
                        fields.push(removeField);
                        versionDevField.reload();
                        projectNameField.value(Utilities.getDescriptionFieldByPrimaryValue(allProjectsField, projectId));
                        projectTypeNameField.label = 'Tipo - ' + Utilities.getRowInDataSource(allProjectsField.dataSource, allProjectsField.valueField, projectId)[allProjectsField.projectTypeName];
                        projectTypeNameField.value(projectNameField.value());
                        setOperationsFieldVersionDev(widget, dataset, projectId, versionDevField);
                    }
                });
                widget.fields = self.pmGenerationProjectIdFilter(fields, allProjectsForTask);
                widget.selectedProjectsInfo = dataset;
                widget.selectedIsuuesInfo = issuesInfo;
            } else {
                removeAllFieldsPmGeneration(getWidgetCreateTaskIssue());
            }
        }).catch(ScreenService.hideLoader);
    };

    var setOperationsFieldVersionDev = function (widget, dataset, projectId, versionDevField) {
        widget.currentRow['PRODUCT_VERSION_DEV_ID_' + projectId] = dataset[projectId].productVersionId;
        widget.currentRow['VERSION_DEV_' + projectId] = dataset[projectId].productVersionId ? dataset[projectId].productVersionLabel: 'Última versão';
        if(dataset[projectId].projectStatusControl === 'D' || dataset[projectId].isTasksNotIsParent){
            versionDevField.readOnly = true;
        } else {
            versionDevField.readOnly = false;
        }
    };



    this.getTrashRemoveField = function (projectId, widget) {
        return metaDataFactory.factoryField(this.getRemoveActionObj(projectId), widget);
    };


    this.getProjectNameField = function (projectId, widget) {
        return metaDataFactory.factoryField(this.getProjectNameObj(projectId), widget);
    };

    this.getVersionDevField = function (projectId, widget) {
        return metaDataFactory.factoryField(this.getVersionDevObj(projectId), widget);
    };

    this.getProjectTypeNameField = function (projectId, widget) {
        return metaDataFactory.factoryField(this.getProjectTypeNameObj(projectId), widget);
    };

    this.getTaskTypeNameField = function (projectId, widget) {
        return metaDataFactory.factoryField(this.getTaskTypeNameObj(projectId), widget);
    };

    this.getEstimatedTimeField = function (projectId, widget) {
        return metaDataFactory.factoryField(this.getEstimatedTimeObj(projectId), widget);
    };

    this.getParentNameField = function (projectId, widget) {
        return metaDataFactory.factoryField(this.getParentNameSelectObj(projectId), widget);
    };

    this.getResourceField = function (projectId, widget) {
        return metaDataFactory.factoryField(this.getResourceSelectMultipleObj(projectId), widget);
    };
    this.getDesciptionAction = function (projectId, widget) {
        return metaDataFactory.factoryField(this.getDesciptionActionSelectObj(projectId), widget);
    };
    this.getDesciptionField = function (issueId, projectId, name, widget) {
        return metaDataFactory.factoryField(this.getDesciptionFieldSelectObj(issueId, projectId), widget);
    };
    this.getDesciptionFielGroup = function (issueId, name, widget) {
        return metaDataFactory.factoryField(this.getDesciptionFieldGroupSelectObj(issueId, name), widget);
    };

    this.createTaskIssueFieldOnChangeVersionDev = function (args) {
        var field = args.owner.field;
        if(!field.value()){
            field.setValue('Última versão');
        }
    };

    this.getRemoveActionObj = function (projectId) {
        return {
            "name": "removeTaskGeneration_" + projectId,
            "label": null,
            "isVisible": true,
            "showOnForm": true,
            "showOnList": false,
            "showOnView": false,
            "pmProjectId": projectId,
            "pmIsGeneration": true,
            "tooltip": "Apagar",
            "fieldGroup": "TASKS",
            "template": "field/label-with-icon.html",
            "icon": "trash",
            "class": 1,
            "events": [
                {
                    "name": "FieldOnClick",
                    "code": "BoardIssuesController.fieldOnClickEventRemoveTaskGeneration(args);"
                }
            ]
        };
    };

    this.getProjectNameObj = function (projectId) {
        return {
            "name": "PROJECT_NAME_" + projectId,
            "label": "Projeto",
            "isVisible": true,
            "showOnForm": true,
            "showOnList": false,
            "showOnView": false,
            "pmProjectId": projectId,
            "readOnly": true,
            "pmIsGeneration": true,
            "fieldGroup": "TASKS",
            "template": "field/text-edit.html",
            "icon": "trash",
            "class": 3,
            "events": []
        };
    };

    this.getVersionDevObj = function (projectId) {
        return {
            "name": "VERSION_DEV_" + projectId,
            "label": "Versão",
            "isVisible": true,
            "showOnForm": true,
            "showOnList": false,
            "showOnView": false,
            "pmProjectId": projectId,
            "readOnly": false,
            "pmIsGeneration": true,
            "fieldGroup": "TASKS",
            "showSelectAs": "grid",
            "template": "zh-select-autocomplete#field/select-autocomplete.html",
            "class": 2,
            "descriptionField": "VERSION",
            "valueField": "ID",
            "searchableFields": [
                "VERSION",
                "IS_LTS"
            ],
            "displayedFields": [
                "VERSION",
                "IS_LTS"
            ],
            "fields": [
                {
                    "name": "ID",
                    "label": "ID",
                    "isVisible": true,
                    "showOnList": true
                },
                {
                    "name": "VERSION",
                    "label": "Versão",
                    "isVisible": true,
                    "showOnList": true
                },
                {
                    "name": "IS_LTS",
                    "label": "LTS",
                    "isVisible": true,
                    "showOnList": true
                }
            ],
            "outData": {
                "ID": "PRODUCT_VERSION_DEV_ID_" + projectId,
                "VERSION": "VERSION_DEV_" + projectId
            },
            "dataSource": {
                "name": "/findProductVersionLtsWithoutBuild",
                "rest": true,
                "localStorage": false,
                "data": [],
                "lazyLoad": true
            },
            "dataSourceFilter": [
                {
                    "name": "PROJECT_ID",
                    "operator": "=",
                    "value": "@getLocalVar('PROJECT_ID') ? getLocalVar('PROJECT_ID') : 0@"
                }
            ],
            "events": [
                {
                    "name": "FieldOnChange",
                    "code": "BoardIssuesController.createTaskIssueFieldOnChangeVersionDev(args)"
                }
            ]
        };
    };

    this.getProjectTypeNameObj = function (projectId) {
        return {
            "name": "PROJECT_TYPE_NAME_" + projectId,
            "label": "Tipo",
            "isVisible": true,
            "showOnForm": true,
            "showOnList": false,
            "showOnView": false,
            "pmProjectId": projectId,
            "readOnly": true,
            "pmIsGeneration": true,
            "fieldGroup": "TASKS",
            "template": "field/text-edit.html",
            "icon": "trash",
            "class": 2,
            "events": []
        };
    };
    this.getTaskTypeNameObj = function (projectId) {
        return {
            "name": "TASK_FEATURES_"+ projectId,
            "label": "Pontos Estimados",
            "class": 2,
            "sameLine": false,
            "isVisible": true,
            "showOnForm": true,
            "showOnList": false,
            "showOnView": false,
            "pmProjectId": projectId,
            "pmIsGeneration": true,
            "fieldGroup": "TASKS",
            "readOnly": false,
            "fields": [
                {
                    "name": "DESCRIPTION",
                    "label": "Nome",
                    "showOnList": true
                },
                {
                    "name": "TIME_BASE",
                    "label": "Tempo base",
                    "showOnList": true
                }
            ],
            "showSelectAs": "grid",
            "outData": {
                "TIME_BASE": "TIME_PLANNED_"+ projectId,
                "DESCRIPTION": "TASK_FEATURES_"+ projectId,
                "ID": "TASK_FEATURES_ID_"+ projectId
            },
            "template": "zh-select-autocomplete#field/select-autocomplete.html",
            "descriptionField": "DESCRIPTION",
            "searchableFields": ["DESCRIPTION"],
            "valueField": "ID",
            "showAddButton": false,
            "dataSource": {
                "name": "/taskFeatures",
                "rest": true,
                "localStorage": true,
                "data": []
            },
            "events": []
        };
    };
    this.getDesciptionActionSelectObj = function (projectId) {
        return {
            "name": "CHANGE_DESCRIPTION_" + projectId,
            "isVisible": true,
            "showOnForm": true,
            "showOnList": true,
            "showOnView": true,
            "label": "Editar descrição",
            "pmProjectId": projectId,
            "pmIsGeneration": true,
            "fieldGroup": "TASKS",
            "template": "field/button.html",
            "icon": "tasks",
            "class": "1 change_desc",
            "events": [
                {
                    "name": "FieldOnClick",
                    "code": "BoardIssuesController.fieldOnClickEventDescription(args);"
                }
            ]
        };
    };

    this.getDesciptionFieldSelectObj = function (issueId, projectId) {
        return {
            "name": "DESCRIPTION_" + issueId + "_" + projectId,
            "label": "Descrição",
            "template": "field/textarea.html",
            "maxWidth": "10%",
            "textRows": 5,
            "pmProjectId": projectId,
            "fieldGroup": "ISSUES_" +issueId,
            "pmIssueId": issueId,
            "pmIsGeneration": true,
            "isVisible": true,
            "showOnList": false,
            "showOnView": true,
            "validations": {
                "required": {}
            },
            "class": 12
        };
    };

    this.getDesciptionFieldGroupSelectObj = function (issueId, name) {
        return {
            "name": "ISSUES_" + issueId,
            "label": name,
            "collapsible": true,
            "opened": true
        };
    };

    this.getEstimatedTimeObj = function (projectId) {
        return {
            "name": "TIME_PLANNED_"+ projectId,
            "label": "Pontos estimados",
            "class": 1,
            "placeholder": "Pontos para um recurso experiente",
            "isVisible": false,
            "showOnForm": true,
            "showOnList": false,
            "showOnView": false,
            "pmProjectId": projectId,
            "mask": {
                "type": "number"
            },
            "pmIsGeneration": true,
            "fieldGroup": "TASKS",
            "template": "field/text-edit.html",
            "events": []
        };
    };

    this.getParentNameSelectObj = function (projectId) {
        return {
            "name": "PARENT_NAME_" + projectId,
            "label": "Tarefa superior",
            "showOnForm": true,
            "class": 2,
            "isVisible": true,
            "fieldGroup": "TASKS",
            "template": "zh-select-autocomplete#field/select-autocomplete.html",
            "descriptionField": "NAME",
            "searchableFields": ["NAME"],
            "pmIsGeneration": true,
            "pmProjectId": projectId,
            "hasPagination": false,
            "searchWithPagination": false,
            "valueField": "ID",
            "showSelectAs": "tree",
            "parentProperty": "PARENT",
            "primaryProperty": "ID",
            "expandingProperty": "NAME",
            "breadcrumbProperty": "NAME",
            "outData": {
                "ID": "PARENT_" + projectId,
                "NAME": "PARENT_NAME_" + projectId
            },
            "dataSource": {
                "name": "/findAllTaskByProject",
                "rest": true,
                "localStorage": false,
                "data": []
            },
            "dataSourceFilter": [
                {
                    "name": "projectInIssue",
                    "operator": "=",
                    "value": projectId
                }
            ]
        };
    };

    this.getResourceSelectMultipleObj = function (projectId) {
        return {
            "name": "RESOURCE_" + projectId,
            "label": "Recursos",
            "isVisible": true,
            "showOnForm": true,
            "showOnList": false,
            "showOnView": false,
            "pmProjectId": projectId,
            "pmIsGeneration": true,
            "fieldGroup": "TASKS",
            "template": "field/select-multiple.html",
            "class": 2,
            "events": [
                {
                    "name": "FieldOnChange",
                    "code": "BoardIssuesController.fieldOnChangeEventResource(args);"
                }
            ],
            "descriptionField": "NAME",
            "valueField": "ID",
            "hasPagination": false,
            "searchWithPagination": false,
            "dataSource": {
                "name": "/taskResource",
                "rest": true,
                "localStorage": false,
                "data": []
            },
            "dataSourceFilter": [
                {
                    "name": "PROJECT",
                    "value": projectId,
                    "operator": "="
                }
            ]
        };
    };



    var calcDurationByTimePlannedWidgetCreateTaskIssue = function (timePlannedField, timePlanned) {
        var totalRating = 0;
        if(timePlannedField){
            timePlannedField.value(timePlanned);
        }
        return timePlanned;
    };


    var onBack = function(widget){
        if(widget && widget.container.inEditMode()){
            widget.reload();
        }
        else if(ScreenService.isPopupOpen()){
            /*****************************************
             *Linhas para concertar o bug do framework*
             *****************************************/
            getWidgetIssueUpload().currentWidget = null;
            getWidgetIssueUpload().activate();
            /*************************************************
             *Fim das Linhas para concertar o bug do framework*
             *************************************************/
            ScreenService.closePopup();
        }
        else{
            if(ScreenService.lastSwipe){
                templateManager.container.restoreDefaultMode();
            }
            ScreenService.goBack();
        }
        templateManager.updateTemplate();
    };

    this.getActionOfExitsObj = function (id,actionLabel,taskTypeTarget,commentTypeId,attachmentRequired,
                                         commentDescription) {
        return {
            "name": "ACTIONS_OF_EXITS_"+id,
            "label": actionLabel,
            "showAsAction": "never_list|never_view",
            "pmIsGeneration": true,
            "events": [
                {
                    "name": "ActionEvent",
                    "code": "BoardIssuesController.issueMainActionEventActionOfExits("+taskTypeTarget+","+commentTypeId+',"'+attachmentRequired+'","'+commentDescription+'");'
                }
            ]
        };
    };

    var removeAllActionsGenerated = function(widget){
        widget.actions = widget.actions.filter(function(action){
            return !action.pmIsGeneration;
        });

        widget.container.actions = widget.container.actions.filter(function(action){
            return !action.pmIsGeneration;
        });
    };

    var getActionOfExit = function (exitAction, widget) {
        return metaDataFactory.actionFactory(self.getActionOfExitsObj(exitAction.ID,exitAction.ACTION_LABEL,
            exitAction.TASK_TYPE_TARGET,exitAction.COMMENT_TYPE_ID,exitAction.ATTACHMENT_REQUIRED,exitAction.COMMENT_DESCRIPTION),widget);
    };

    var setActionsOfExits = function(actionsOfExits,widget){

        removeAllActionsGenerated(widget);

        actionsOfExits.forEach(function(exitAction){
            widget.actions.push(getActionOfExit(exitAction, widget));
        });
    };

    this.issueMainActionEventActionOfExits = function(taskTypeTarget,commentTypeId,attachmentRequired,
                                                      commentDescription){
        var widget = getWidgetOutComments();
        widget.dataSource.data = [];
        widget.newRow();
        widget.currentRow.TASK_TYPE_TARGET = taskTypeTarget;
        widget.currentRow.COMMENT_TYPE_ID = commentTypeId;
        getFieldDocumentFromOutComments().validations = attachmentRequired == 'Y' ? {"required": {}} : {};
        widget.currentRow.DESCRIPTION = commentDescription;
        widget.currentRow.ISSUE_ID = getWidgetIssueMain().currentRow.ID;
        ScreenService.openPopup(widget);
    };

    this.outCommentActionEventSaveNewComment = function(args) {
        var widget = getWidgetOutComments();
        if(widget.isValid()){
            widget.currentRow.changed = true;
            IssueService.sendOutComment(widget.currentRow).then(function(response){
                var lastWidget = localStorage.getItem('boardIssuesWidget');
                var mainWidget = lastWidget == 'GRID' ? getWidgetIssueGrid() : getWidgetIssuesMain();
                ScreenService.closePopup(true);
                ScreenService.closeSwipe();
                mainWidget.reload();
                mainWidget.activate();
            }).catch(Utilities.showMessageBackEndTrue);
        } else {
            ScreenService.showMessage(Utilities.messages.ERR_REQUIRED_FIELDS, 'ERROR');
        }
    };

    this.issueMainActionEventCancel = function(args){
        var widget = getWidgetIssueMain();
        var currentRow = widget.currentRow;
        widget.list();
        ScreenService.showLoader();
        return widget.reload().then(function(){
            ScreenService.hideLoader();
            widget.view();
            Utilities.setStatusEnabledWidgets(getWidgetTabbedIssue().widgets, true);
            var budgetWidget = getWidgetBudget();
            budgetWidget.enabled = !!currentRow.WITH_BUDGET;
        }).catch(ScreenService.hideLoader);
    };

    this.outCommentActionEventBack = function(args) {
        ScreenService.closePopup();
        getWidgetIssueMain().activate();
    };

    this.documentsCommentActionEventBackList = function(args) {
        ScreenService.closeSwipe();
        getWidgetComments().activate();
    };

    this.documentsCommentActionEventBackView = function(args) {
        ScreenService.closeSwipe();
        getWidgetDocumentsComment().reload();
    };

    this.commentsActionEventBackView = function(args) {
        ScreenService.closeSwipe();
        getWidgetComments().reload();
    };

    this.documentsCommentActionEventDownload = function(args) {
        Utilities.downloadAttachment(getWidgetDocumentsComment().currentRow.ID);
    };

    this.newIssueActionEventBack = function(args){
        ScreenService.closeSwipe();
        if(localStorage.getItem('boardIssuesWidget') == 'GRID') {
            getWidgetIssueGrid().activate();
        } else {
            getWidgetIssuesMain().activate();
        }
    };

    this.newIssueFieldOnAddLabels = function(args){
        addLabel();
    };

    this.issueMainFieldOnAddLabels = function(args){
        addLabel();
    };

    this.infoIssueDependentFieldOnAddLabels = function(args){
        addLabel();
    };

    var addLabel = function(){
        var newLabelWidget = getNewLabelWidget();
        newLabelWidget.dataSource.data = [];
        newLabelWidget.newRow();
        newLabelWidget.currentRow.BOARD = Utilities.localVar.getBoardId();
        ScreenService.openPopup(newLabelWidget);
    };

    this.issueMainActionEventEdit = function(args){
        var widget = getWidgetIssueMain();
        localStorage.setItem('productId', widget.currentRow.PRODUCT);
        widget.edit();
        getFieldVersionFromIssueMainWidget().reload();
        getFieldVersionDevFromIssueMainWidget().reload();
        widget.getField('PRODUCT_NAME').reload();
        widget.getField('SPONSOR').reload();
        widget.getField('ISSUE_CLASSIFICATION_NAME').reload();
        widget.getField('REPORTER_NAME').reload();
        widget.getField('PRIORITY_NAME').reload();
        Utilities.setStatusEnabledWidgets(getWidgetTabbedIssue().widgets, false);
    };

    this.issueMainIssuesActionEventCloseIssue = function(args){
        var issues = Utilities.localVar.getIssue();
        ScreenService.confirmMessage(Utilities.messages.ALE_CLOSE_ISSUE, 'CONFIRMATION', function(){
            TaskService.closeIssue(issues).then(function(){
                var lastWidget = localStorage.getItem('boardIssuesWidget');
                var mainWidget = lastWidget == 'GRID' ? getWidgetIssueGrid() : getWidgetIssuesMain();
                ScreenService.closePopup(true);
                ScreenService.closeSwipe();
                mainWidget.reload();
                mainWidget.activate();
            });
        });
    };

    this.issueMainIssuesActionEventDelete = function(args){
        ScreenService.confirmMessage('Confirma exclusão da(s) Issue(s)?',null,function(){
            self.deleteIssue(getWidgetIssueMain(), getWidgetIssuesMain());
        });
    };

    this.issueMainFieldOnChangeStructure = function(args) {
        var filterWidget = args.owner.field.widget;
        var structureIds = args.owner.field.value();
        var productField = getFieldProductFromIssuesMainWidget();
        var productIds = filterWidget.currentRow.PRODUCT;
        localStorageEngine.setLocalVar('STRUCTURE_IDS', structureIds);
        filterWidget.currentRow.PRODUCT = [];
        productField.reload().then(function(response) {
            var data = response.dataset.findMyProducts;
            var newValues = [];
            productIds.forEach(function (id) {
                data.forEach(function (product) {
                    if (product.ID == id) {
                        newValues.push(id);
                    }
                });
            });
            filterWidget.currentRow.PRODUCT = newValues;
        });
    };

    this.issueMainFieldOnChangeProjectStatusId = function(args) {
        var filterWidget = args.owner.field.widget;
        var projectStatusIds = args.owner.field.value();
        var productIds = filterWidget.currentRow.PRODUCT;
        localStorageEngine.setLocalVar('PROJECT_STATUS_ID', projectStatusIds);
        filterWidget.currentRow.PRODUCT = [];
        getFieldProductFromIssuesMainWidget().reload().then(function(response){
            var data = response.dataset.findMyProducts;
            var newValues = [];
            productIds.forEach(function(id) {
                data.forEach(function (product) {
                    if (product.ID == id) {
                        newValues.push(id);
                    }
                });
            });
            filterWidget.currentRow.PRODUCT = newValues;
        });
    };

    this.issueGridFieldOnChangeStructure = function (args) {
        var filterWidget = args.owner.field.widget;
        var structureIds = args.owner.field.value();
        var productField = getFieldProductFromIssueGridWidget();
        var productIds = filterWidget.currentRow.PRODUCT;
        localStorageEngine.setLocalVar('STRUCTURE_IDS_GRID', structureIds);
        filterWidget.currentRow.PRODUCT = [];
        productField.reload().then(function(response) {
            var data = response.dataset.findMyProducts;
            var newValues = [];
            productIds.forEach(function (id) {
                data.forEach(function (product) {
                    if (product.ID == id) {
                        newValues.push(id);
                    }
                });
            });
            filterWidget.currentRow.PRODUCT = newValues;
        });
    };

    this.issueGridFieldOnChangeProjectStatusId = function (args) {
        var filterWidget = args.owner.field.widget;
        var projectStatusIds = args.owner.field.value();
        var productIds = filterWidget.currentRow.PRODUCT;
        localStorageEngine.setLocalVar('PROJECT_STATUS_ID_GRID', projectStatusIds);
        filterWidget.currentRow.PRODUCT = [];
        getFieldProductFromIssueGridWidget().reload().then(function(response){
            var data = response.dataset.findMyProducts;
            var newValues = [];
            productIds.forEach(function(id) {
                data.forEach(function (product) {
                    if (product.ID == id) {
                        newValues.push(id);
                    }
                });
            });
            filterWidget.currentRow.PRODUCT = newValues;
        });
    };

    this.deleteIssue = function(widget, parentWidget){
        var issue = widget.currentRow;
        var user = Utilities.localVar.getIdBusinessPartner();
        if(issue.REPORTER == user) {
            widget.removeRow(issue).then(function() {
                ScreenService.closeSwipe();
                parentWidget.reload();
                parentWidget.activate();
            });
        } else {
            ScreenService.showMessage(Utilities.messages.ERR_NOT_DELETE_ISSUE_USER_LOGADO);
        }
    };

    this.issueUploadActionEventAddDocument = function(args) {
        var widget =  getWidgetNewIssueUpload();
        ScreenService.openPopup(widget);
        widget.newRow();
    };

    this.issueUploadActionEventDownload = function(args){
        var row = getWidgetIssueUpload().currentRow;
        ProjectServiceList.downLoadAttachment(row);
    };

    this.newIssueUploadActionEventBack = function(args){
        onBack();
    };

    this.newIssueUploadActionEventUpload = function(){
        var widget = getWidgetNewIssueUpload();
        widget.currentRow.projectId = Utilities.localVar.getBoardId() ;
        widget.currentRow.taskId =  Utilities.localVar.getIssue()[0];
        ProjectServiceList.newUploadDocumentTask(widget.currentRow).then(function(){
            onBack();
            getWidgetIssueUpload().reload();
        });
    };

    this.issueRelationshipActionEventAddList = function(args){
        var productTasksWidget = getWidgetProductTasks();
        productTasksWidget.dataSource.clearCheckedRows();
        productTasksWidget.dataSource.updateCheckedRows();
        ScreenService.openPopup(productTasksWidget);
        productTasksWidget.reload();
    };

    this.productTasksActionEventCancel = function(args){
        onBack();
    };

    this.newTaskActionEventCancel = function(args){
        var lastSwipe = getWidgetNewTask().lastSwipe;
        onBack();
        lastSwipe.activate();
    };


    this.newTaskActionEventSave = function(args){
        var widget = getWidgetNewTask();
        var row = widget.currentRow;
        row.START   = Utilities.invertDateTimeToYearMonthDay(row.START, '/', '-');
        row.END     = Utilities.invertDateTimeToYearMonthDay(row.END, '/', '-');

        if(widget.isValid() && validateNewTask(widget.currentRow)){
            row.changed = true;
            var issueId = Utilities.localVar.getIssue();
            row.ISSUE = issueId instanceof Array ? issueId : [issueId];
            requestDataSourceEngine.setDataSource('/saveNewProjectTaskIssue', [row]).then(function(data){
                widget.list();
                try{
                    if(data.dataset){
                        ScreenService.closeSwipe().then(function(){
                            getWidgetIssueRelationship().reload().then(function(){
                                getIssueMainWidget().reload();
                                getWidgetIssueRelationship().activate();
                            });
                        });
                    }
                }catch(e){}
                self.newTaskActionEventCancel(args);
                Utilities.clearCheckedRowsAndReload(getWidgetTabbedBoardIssue().currentWidget);
            });
        }else{
            row.START   = Utilities.invertDateTimeToYearMonthDay(row.START, '-', '/');
            row.END     = Utilities.invertDateTimeToYearMonthDay(row.END, '-', '/');
            ScreenService.showMessage(Utilities.localVar.ERR_REQUIRED_FIELDS);
        }
    };

    var validateNewTask = function(row){
        var validation = true;
        var begin = moment(row.START, 'YYYY-MM-DD');
        var end = moment(row.END, 'YYYY-MM-DD');
        if(row.PARENT == row.PRECURSOR && !Utilities.isEmpty(row.PRECURSOR)){
            ScreenService.showMessage(Utilities.messages.ERR_SUPERIOR_TASK_SAME_PRECURSOR, null, "exclamation");
            validation = false;
        }else if(Utilities.isEmpty(row.NAME) || Utilities.isEmpty(row.START) || Utilities.isEmpty(row.END)){
            ScreenService.showMessage(Utilities.messages.ERR_REQUIRED_FIELDS, null, "exclamation");
            validation = false;
        }else if(begin > end){
            ScreenService.showMessage(Utilities.messages.ERR_START_DATE_AFTER_FINAL_DATE, null, "exclamation");
            validation = false;
        }
        return validation;
    };


    this.newTaskWidgetOnEnter = function(args){
        var widget = getWidgetNewTask();
        var initialName = Utilities.localVar.getTaskParameters().INITIAL_TASK_STATUS_NAME;
        var initialId = Utilities.localVar.getTaskParameters().INITIAL_TASK_STATUS_ID;
        widget.currentRow.TASK_STATUS_NAME = initialName;
        widget.currentRow.TASK_STATUS = initialId;
    };

    this.commentsWidgetOnEnterTab = function(args){
        getWidgetComments().reload();
        self.viewComments();
    };

    this.viewComments = function(){
        var row = {};
        var issue = Utilities.localVar.getIssue();
        row.ISSUE = Array.isArray(issue)? issue[0]:issue;
        row.changed = true;
        requestDataSourceEngine.setDataSource('/viewComments',[row], undefined, undefined, undefined, undefined, true).then(function(response){
            if(Array.isArray(response)){
                Utilities.localVar.setLastDateViewComments(null);
            }else{
                Utilities.localVar.setLastDateViewComments(response.dataset.lastDate[0]);
            }
        });
    };

    this.newCommentActionEventSaveNewComment = function(args){
        CommentService.saveComment(getWidgetNewComment(), closePopupAndReloadCommentWidgets, reopenIssue);
    };

    var closePopupAndReloadCommentWidgets = function() {
        ScreenService.closePopup(true);
        getWidgetComments().reload();
        getWidgetNewComment().reload();
    };

    var reopenIssue = function() {
        var issue = Utilities.localVar.getIssue();
        return TaskService.reopenIssue(issue).then(function (data) {
            var issueMainWidget = getIssueMainWidget();
            ScreenService.showLoader();
            return issueMainWidget.reload().then(function () {
                ScreenService.hideLoader();
                ScreenService.closeSwipe();
                issueMainWidget.activate();
                return data;
            }).catch(ScreenService.hideLoader);
        });
    };

    this.issueLogWidgetOnEnterTab = function(args){
        getWidgetIssueLogUpload().reload();
    };

    this.issueGridFieldBeforeSelectOpenLabels = function (){
        getFieldLabelsFromIssueGridWidget().reload();
    };

    this.issuesMainFieldBeforeSelectOpenLabels = function (){
        getFieldLabelsFromWidgetIssuesMain().reload();
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('BoardIssuesController', BoardIssuesController);
});


// FILE: assets/js/Controller/Boards.js
function Boards(ScreenService, localStorageEngine, requestDataSourceEngine, templateManager, Utilities, ZhFilterPreferences, ZhPreferences) {

    var getBoardsWidget = function(){
        return templateManager.container.getWidget('BOARDS');
    };

    var getFieldProjectStatusFromProjectListManagerWidget  = function(){
        return getBoardsWidget().getField('PROJECT_STATUS_ID');
    };

	this.openNewBoard = function(owner) {
		var newBoardWidget = owner.widget.container.getWidget("NEW_BOARD");
		ScreenService.openSwipe(newBoardWidget);
	};

    this.boardsWidgetOnEnter = function(args){
        ScreenService.showLoader();
        Utilities.localVar.getLoginPromise().then(function(){
            ScreenService.hideLoader();
            var widget = getBoardsWidget();
            if(Utilities.isAppliedFilter(widget)){
                widget.reload();
            } else {
                var fieldProjectStatus = getFieldProjectStatusFromProjectListManagerWidget();
                ScreenService.showLoader();
                fieldProjectStatus.reload().then(function () {
                    ScreenService.hideLoader();
                    widget.currentRow.PROJECT_STATUS_ID = Utilities.getDefaultValuesToSelectMultipleField(fieldProjectStatus, ['N', 'D', 'P'], 'CONTROL');
                    ZhFilterPreferences.setOriginalFilter(widget.id, widget.currentRow);
                    Utilities.applyDefaultFilterOnEnter(widget, true);
                }).catch(ScreenService.hideLoader);
            }
        }).catch(ScreenService.hideLoader);
    };

	this.saveNewBoard = function(owner) {
		if(owner.widget.isValid()) {
			requestDataSourceEngine.setDataSource("/saveNewBoard", [owner.widget.currentRow], function() {
				owner.widget.setCurrentRow({});
				ScreenService.closeSwipe();
				owner.widget.container.getWidget("BOARDS").reload();
			}); 
		}
	};
	
	this.onSelectBoard = function(row) {
		localStorageEngine.setLocalVar("boardId", [row.BOARD_ID]);
        localStorageEngine.setLocalVar("PROJECT_ISSUE_ID", [row.PROJECT_ISSUE_ID]);
		localStorageEngine.setLocalVar("product", [row.ID]);
		ScreenService.openWindow("product#boardIssues");
	};

    this.boardsActionEventShowIssues = function(args) {
        var rows = getBoardsWidget().getCheckedRows();
        var boardIds = [];
        var projectIssuesIds = [];
        var productIds = [];
        rows.forEach(function(item){
            boardIds.push(item.BOARD_ID);
            projectIssuesIds.push(item.PROJECT_ISSUE_ID);
            productIds.push(item.ID);
        });
		localStorageEngine.setLocalVar("boardId", boardIds);
        localStorageEngine.setLocalVar("PROJECT_ISSUE_ID", projectIssuesIds);
		localStorageEngine.setLocalVar("product", productIds);
		ScreenService.openWindow("product#boardIssues");
	};
	
	this.boardsFilterAfterApply = function(){
        Utilities.setFilterInit(getBoardsWidget());
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('Boards', Boards);
});


// FILE: assets/js/Controller/Calendar.js
/**
 * Created by tuliomagalhaes on 18/07/14.
 */


function CalendarControllerPM (ScreenService,Validation,requestDataSourceEngine,templateManager, Messages){

    this.onEnter = function (widget){

        widget.reload().then(function(){
            widget.moveToFirst();
        });
    };



    this.deleteExceptionList = function(exceptions,widgetException){
        var loginInfo = getLocalVar("login");
        var row = {};
        row.EXCEPTIONS = exceptions;
        row.ORGANIZATION = loginInfo[0].organization;
        row.USER = loginInfo[0].idBusinessPartner;
        row.changed = true;
        requestDataSourceEngine.setDataSource('/deleteException',[row]).then(function(data){
            widgetException.dataSource.data = data.dataset.Exception;
            widgetException.dataSource.checkedRows = [];
            widgetException.container.unSelectAll();
        });
    };

    this.moveRowExceptionList = function(widgetPopup,row){
        ScreenService.openPopup(widgetPopup);
        widgetPopup.currentRow = row;
    };

    this.addExceptionList = function(widgetPopup){
        ScreenService.openPopup(widgetPopup);
        widgetPopup.newRow();
        widgetPopup.currentRow.STATUS = 'A';
        widgetPopup.list();
    };
    function validate(row){
        var valid = true;
        if(Validation.isEmpty(row.END_DATE_LIST) || Validation.isEmpty(row.BEGIN_DATE_LIST) || Validation.isEmpty(row.NAME)|| Validation.isEmpty(row.TYPE)){
            valid = false;
            ScreenService.showMessage(Messages.ERR_REQUIRED_FIELDS, null, "exclamation");
        }
        var begin = moment(row.BEGIN_DATE);
        var end = moment(row.END_DATE);
        if(end.valueOf() < begin.valueOf()){
            valid = false;
            ScreenService.showMessage(Messages.ERR_START_DATE_AFTER_FINAL_DATE, null, "exclamation");
        }
        return valid;
    }
    this.saveException = function(row,widgetException,calendarEntityId){
        var loginInfo = getLocalVar("login");
        row.END_DATE = moment(row.END_DATE_LIST,'DD/MM/YYYY HH:mm' ).format('YYYY-MM-DD HH:mm');
        row.BEGIN_DATE = moment(row.BEGIN_DATE_LIST,'DD/MM/YYYY HH:mm' ).format('YYYY-MM-DD HH:mm');
        row.CALENDAR_ENTITY = calendarEntityId;
        row.ORGANIZATION = loginInfo[0].organization;
        row.USER = loginInfo[0].idBusinessPartner;
        row.changed = true;
        if(validate(row)){
            requestDataSourceEngine.setDataSource('/saveEditException',[row]).then(function(data){

                widgetException.dataSource.data = data.dataset.Exception;
                ScreenService.closePopup();
            });
        }
    };


}
Configuration(function (ContextRegister){
    ContextRegister.register('CalendarControllerPM',CalendarControllerPM);
});





// FILE: assets/js/Controller/Dashboard.js
function PMDashboardController(templateManager, PMDashboardService, ScreenService, localStorageEngine, metaDataFactory, 
                               Utilities,ZHPromise) {
    
    var TASK_STATUS_TO_FILTER = ['N', 'D', 'P'];
    var ISSUE_STATUS_HOMOLOGATED = 'H';
    var BR_WEEKDAYS = ["domingo", "segunda", "terça", "quarta", "quinta", "sexta", "sábado"];

    var self = this;

    /** Get Container */
    var getContainer = function(){
        return templateManager.container;
    };

    /***************************************************
    ************* GET WIDGETS *************************
    ***************************************************/

    /** Cards Information Widgets */

    var getWidgetNotifications = function () {
        return getContainer().getWidget('NOTIFICATIONS');
    };

    var getWidgetDelayedTasks = function () {
        return getContainer().getWidget('DELAYED_TASKS');
    };

    var getWidgetPendingTasks = function () {
        return getContainer().getWidget('PENDING_TASKS');
    };

    var getWidgetDaysWithAppropriation = function () {
        return getContainer().getWidget('DAYS_WITH_APPROPRIATION');
    };

    var getWidgetIssuesWithPendingConclusion = function () {
        return getContainer().getWidget('ISSUES_WITH_PENDING_CONCLUSION');
    };

    var getWidgetIssuesBacklog = function () {
        return getContainer().getWidget('ISSUES_BACKLOG');
    };
    
    /** Burndown Widgets */

    var getWidgetDashboardTabbed = function () {
        return templateManager.container.getWidget('DASHBOARD_TABBED');
    };

    /***************************************************
     ************* Events Container ********************
     ***************************************************/

    this.dashboardContainerAfterinit = function() {
        var container = getContainer();
        ScreenService.showLoader();
        Utilities.localVar.getLoginPromise().then(function() {
            if (!container.alreadyReloaded) {
                container.alreadyReloaded = true;
                PMDashboardService.getDashboardMetadata().then(function (response) {
                    PMDashboardService.findBiggerStructureInZmart().then(function (biggerStructure) {
                        createDashBoardTabbed();
                        ScreenService.hideLoader();
                        if (Object.keys(response).length > 0) {
                            var dashboardMetadata = response.dashboardMetadata;
                            var openSprintsOfUserStructures = response.openSprintsOfUserStructures;
                            localStorageEngine.setLocalVar('structureId', biggerStructure._id);

                            buildCardsInformation();
                            buildBurndown(openSprintsOfUserStructures, dashboardMetadata);
                            Utilities.fixBugTabbedNavigation();
                            enableFirstWidget();
                        } else {
                            buildCardsInformation();
                            buildBurndownWithoutData();
                        }
                    }).catch(ScreenService.hideLoader);
                }).catch(ScreenService.hideLoader);
            } else {
                ScreenService.hideLoader();
            }
        }).catch(ScreenService.hideLoader);
            
    };

    this.dashboardContainerBeforeClose = function () {
        var container = getContainer();
        container.alreadyReloaded = false;
    };

    /***************************************************
    ************* BURNDOWN METHODS  ********************
    ***************************************************/
   
   var createDashBoardTabbed = function(){
        var index;
        var metadataWidget = {
            "id": "250593535592506224864",
            "name": "DASHBOARD_TABBED",
            "isVisible": true,
            "color": 7,
            "height": 5.5,
            "width": 30,
            "template": "widget/tabbedWidget.html",
            "fields": [],
            "events": [],
            "actions": [],
            "widgets": [
                {
                    "name": "TAB_DEFAULT",
                    "label": "",
                    "isVisible": true,
                    "color": 7,
                    "height": 5.5,
                    "width": 30,
                    "fields": [],
                    "events": [],
                    "actions": [],
                    "widgets": []
                }
            ]
        };
        var buildedWidget = metaDataFactory.widgetFactory(metadataWidget, templateManager.container);
        templateManager.container.widgets.forEach(function (widget, i) {
            if (widget.name == 'DASHBOARD_TABBED') index = i;
        });
        templateManager.container.widgets[index] = buildedWidget;
    };

    var buildBurndown = function (openSprintsOfUserStructures, dashboardMetadata) {
        openSprintsOfUserStructures.forEach(function (sprint, index) {
            var metadataWidget = Util.clone(dashboardMetadata);
            metadataWidget.ID = sprint.ID;
            metadataWidget.dataSource.name = '/fetchWidgetDataInZmart';
            metadataWidget.dataSource.lazyLoad = true;
            metadataWidget.events.push(createWidgetEventsWidgetOnEnter());
            metadataWidget.dataSourceFilter = createDataSourceFilter(sprint);
            metadataWidget.name = sprint.STRUCTURE + '_' + sprint.MODEL;
            metadataWidget.label = sprint.STRUCTURE + '_' + sprint.MODEL;
            metadataWidget.floatingControl.position = 'bottom left';
            metadataWidget.floatingControl.customizationAction.layout = false;

            var widget = createWidget(metadataWidget);
            getWidgetDashboardTabbed().widgets.push(widget);
        });
    };

    var buildBurndownWithoutData = function () {
        var fakeFilters = {
            MODEL: "XXXXXXXXXXX",
            STRUCTURE: "XXXXXXXXXX"
        };
        ScreenService.showLoader();
        PMDashboardService.findbuildWidgetByViewIdInZmart(fakeFilters).then(function (response) {
            ScreenService.hideLoader();
            var dashboardMetadata = response.dataset.findbuildWidgetByViewIdInZmart[0];
            var widget = createWidget(dashboardMetadata);
            widget.label = '';
            widget.floatingControl = {
                "searchAction": false,
                "position": "bottom right",
                "customizationAction": {
                    "layout": false,
                    "filter": false,
                    "view": false
                }
            };
            getWidgetDashboardTabbed().widgets.push(widget);
            enableFirstWidget();
        }).catch(ScreenService.hideLoader);
    };

    var createWidget = function (metadataWidget) {
        return metaDataFactory.widgetFactory(metadataWidget, templateManager.container);
    };

    var createDataSourceFilter = function (openSprinter) {
        var structureId = localStorageEngine.getLocalVar('structureId');
        var value = {
            drillDownFilters: {
                MODEL_NAME: openSprinter.MODEL,
                NAME_EQUIPE: openSprinter.STRUCTURE
            },
            structureId: structureId,
            period: {
                start: openSprinter.BEGIN_DATE,
                end: openSprinter.END_DATE
            }
        };
        var filter = [{
            "name": "row",
            "operator": "=",
            "value": value
        }];
        return filter;
    };

    var createWidgetEventsWidgetOnEnter = function () {
        return {
            "name": "WidgetOnEnterTab",
            "code": "PMDashboardController.widgetOnEnterTab(args.owner)"
        };
    };

    var enableFirstWidget = function () {
        Util.doAsync(function(){
            var tabbedDashboard = getWidgetDashboardTabbed();
            tabbedDashboard.currentWidget = tabbedDashboard.widgets[1];
            tabbedDashboard.widgets[1].activate();
        }, 1000);
    };

    this.widgetOnEnterTab = function (widget) {
        templateManager.container.getActiveWidget().reload().then(function (){
           templateManager.container.getActiveWidget().updateChart();
        });
    };

    /***************************************************
     ************* CARDS INFORMATION  ******************
     ***************************************************/

     var buildCardsInformation = function(){
        var container = getContainer();
        saveTodayDateIntoLocalStorage();
        updateDashboard();
        getContainer().reload = function () {
            updateDashboard();
            container.alreadyReloaded = false;
            self.dashboardContainerAfterinit();
        };
     };

     var setColor = function () {
        var dashboard = getContainer();
        dashboard.widgets.forEach(function (widget) {
            if (widget.pmSetColor) {
                var color = widget.color;
                if (widget.notification && widget.notification !== '0') {
                    color = widget.pmColorIncoherence;
                } else {
                    color =  widget.pmColorCoherence;
                }
                $('#masonry-item-' + widget.id).css('background-color', color);
                widget.color = color;
            }
        });
     };

     var updateDashboard = function () {
         ZHPromise.all([
             updateNotificationWidgetPendingTasks(),
             updateNotificationWidgetDelayedTasks(),
             updateNotificationWidgetBacklogIssues(),
             updateNotificationWidgetNotifications(),
             updateNotificationWidgetIssuesWithPendingConclusion()
         ]).then(function () {
             setColor();
         });
     };

     var updateNotificationWidgetNotifications = function () {
         return PMDashboardService.getTotalIssuesWithCommentsUnread().then(function (total) {
             getWidgetNotifications().notification = total[0].VALUE;
         });
     };

     var updateNotificationWidgetDelayedTasks = function () {
         return PMDashboardService.getTotalDelayedTasks().then(function (total) {
             getWidgetDelayedTasks().notification = total[0].TOTAL;
         });
     };

     var updateNotificationWidgetPendingTasks = function () {
         return PMDashboardService.getTotalPendingTasks().then(function (total) {
             getWidgetPendingTasks().notification = total[0].TOTAL;
         });
     };
     var updateNotificationWidgetIssuesWithPendingConclusion = function () {
         return PMDashboardService.getTotalIssuesWithPendingConclusion().then(function (response) {
             getWidgetIssuesWithPendingConclusion().notification = response.TOTAL;
         });
     };

     var updateNotificationWidgetBacklogIssues = function () {
         return PMDashboardService.getTotalBacklogIssuesByCurrentUser().then(function (response) {
             var widget = getWidgetIssuesBacklog();
             widget.notification = response.TOTAL;
             widget.productIds = response.PRODUCT_IDS;
         });
     };

     this.issuesBacklogWidgetOnDashboardClick = function () {
         var widget = getWidgetIssuesBacklog();
         localStorageEngine.setLocalVar("boardId", widget.productIds);
         localStorageEngine.setLocalVar("PROJECT_ISSUE_ID", []);
         localStorageEngine.setLocalVar("product", widget.productIds);
         Utilities.localVar.setLastWindow("dashboard");
         ScreenService.openWindow("product#boardIssues");
     };

     this.daysWithAppropriationWidgetOnDashboardClick = function (args) {
         var widget = getWidgetDaysWithAppropriation();
         openTimeControlWindow(widget);
     };

     var openTimeControlWindow = function (widget) {
         var filter = {};
         var today = moment();
         var maxDate = today.format('DD/MM/YYYY');
         var minDate = today.subtract(6, 'days').format('DD/MM/YYYY');
         if (widget.notification > 0 && widget.firstDay && moment(widget.firstDay, 'DD/MM/YYYY').isBefore(moment(minDate, 'DD/MM/YYYY'))) {
             minDate = widget.firstDay;
         }

         filter.timeControl = {
             'MAX_DATE': maxDate,
             'MIN_DATE': minDate,
             'SHOW_WEEKEND': 'N'
         };
         Utilities.localVar.setFilterByDashboard(filter);
         ScreenService.openWindow('product#timeControl');
     };

     var statusTaskIdsToFilter = function () {
         var statusTaskIds = [];
         return PMDashboardService.getAllStatusTask().then(function (allStatusTask) {
             var statusTask = allStatusTask.filter(function (statusTask) {
                 return TASK_STATUS_TO_FILTER.indexOf(statusTask.CONTROL) > -1;
             });

             statusTask.forEach(function (status) {
                 statusTaskIds.push(status.ID);
             });

             return statusTaskIds;
         });
     };

     var getStatusIssueHomologatedId = function () {
         return PMDashboardService.getIssueStatus().then(function (allIssueStatus) {
             return allIssueStatus.filter(function (issueStatus) {
                 return issueStatus.CONTROL == ISSUE_STATUS_HOMOLOGATED;
             });

         });
     };

     this.delayedTasksWidgetOnDashboardClick = function (args) {
        var userId = Utilities.localVar.getLocalVarIdBusinessPartner();

        ScreenService.showLoader();
        statusTaskIdsToFilter().then(function (statusTaskIds) {
            ScreenService.hideLoader();
            var filter = {
                "taskTracking": {
                    'TASK_RESOURCE': [userId],
                    'TASK_STATUS': statusTaskIds,
                    'LATE': 'Y'
                }
            };
            localStorageEngine.setLocalVar('delayedFilter', true);
            Utilities.localVar.setFilterByDashboard(filter);
            ScreenService.openWindow('product#taskTracking');
        }).catch(ScreenService.hideLoader);
     };

     this.issuesWithPendingConclusionWidgetOnDashboardClick = function (args) {
        ScreenService.showLoader();
        getStatusIssueHomologatedId().then(function (issueStatusHomologated) {
            ScreenService.hideLoader();
            var filter = {
                'issues': [issueStatusHomologated[0].ID],
                'framing': [issueStatusHomologated[0].TASK_TYPE_ID]
            };
            Utilities.localVar.setFilterByDashboard(filter);
            ScreenService.openWindow('product#issues');
        }).catch(ScreenService.hideLoader);
     };

     var saveTodayDateIntoLocalStorage = function () {
         var today = new Date();
         var day = today.getDate();
         var month = today.getMonth() + 1;
         var year = today.getFullYear();
         var weekday = today.getDay();

         day = (day < 10) ? '0' + day : day;
         month = (month < 10) ? '0' + month : month;
         Utilities.localVar.setTodayWeekdayDate(BR_WEEKDAYS[weekday].capitalize());
         Utilities.localVar.setTodayDate(day + '/' + month + '/' + year);
     };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('PMDashboardController', PMDashboardController);
});

// FILE: assets/js/Controller/DemandManagement.js
function DemandManagementController(templateManager, Utilities){
    var getDemandManagementWidget = function() {
        return templateManager.container.getWidget('demandManagementWidget');
    };
    
    this.demandManagementContainerAfterinit = function () {
        getDemandManagementWidget().sourceUrl = Utilities.getUrlPmNext('gestao-de-demandas');
    };
}

Configuration(function(ContextRegister) {
	ContextRegister.register('DemandManagementController', DemandManagementController);
});

// FILE: assets/js/Controller/DocumentTemplate.js
function DocumentTemplateController(ScreenService, Utilities, templateManager) {

    var self = this;

    var getWidgetDocumentsTemplate = function(){
        return templateManager.container.getWidget('DOCUMENTS_TEMPLATE');
    };

    var getFieldDocument = function(){
        return getWidgetDocumentsTemplate().getField('DOCUMENT');
    };

    this.documentTemplateActionEventAdd = function(args){
        getWidgetDocumentsTemplate().newRow();
    };

    this.documentTemplateActionEventCancel = function(args){
        Utilities.cancelEditMasterDetail(getWidgetDocumentsTemplate());
    };

    this.documentTemplateActionEventDelete = function(args){
        ScreenService.confirmMessage(Utilities.messages.ALE_DELETE_DOCUMENT_TEMPLATE, "question", function() {
            Utilities.genericDeleteEvent(getWidgetDocumentsTemplate()).catch(Utilities.showMessageBackEndTrue);
        });
    };

    this.documentTemplateActionEventDownload = function(args){
        Utilities.downloadAttachment(getWidgetDocumentsTemplate().currentRow.ATTACHMENT_ID);
    };

    this.documentTemplateActionEventBack = function(args){
        ScreenService.closeSwipe();
    };

    this.documentTemplateActionEventSave = function(args){
        var widget = getWidgetDocumentsTemplate();
        if(widget.isValid() ){
            if((widget.currentRow.DOCUMENT && widget.currentRow.DOCUMENT.length) || widget.currentRow.ID){
                widget.saveRow().then(function(response){
                    Utilities.genericEventAfterSaveMasterDetail(response,widget);
                });
            }else{
                ScreenService.showMessage(Utilities.messages.ERR_NOT_DOCUMENT);
            }
        }
    };

    this.documentTemplateActionEventEdit = function (args) {
        var widget = getWidgetDocumentsTemplate();
        widget.edit();
        Util.doAsync(function(){
            getFieldDocument().fileList = [{"name": widget.currentRow.LABEL}];
            angular.element("#footer").scope().$digest();
        },500);

    };

    this.documentTemplateWidgetOnEnter = function (args) {
        Utilities.localVar.getLoginPromise().then(function () {
            var widget = getWidgetDocumentsTemplate();
            Utilities.applyDefaultFilterOnEnter(widget, true);
            widget.PmNotFilter = true;
        }).catch(ScreenService.hideLoader);
    };
    
    this.documentTemplateFilterAfterApply = function(){
        Utilities.setFilterInit(getWidgetDocumentsTemplate());
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register('DocumentTemplateController', DocumentTemplateController);
});


// FILE: assets/js/Controller/IssueLabels.js
function IssueLabelsController(localStorageEngine, ScreenService, templateManager, Messages, Utilities, ZhFilterPreferences) {

	var self = this;
	
	var getFieldProjectNameFromWidgetLabels = function(){
		return getLabelsWidget().getField('PROJECT_NAME');
	};

    var getLabelsWidget = function(){
        return templateManager.container.getWidget('LABELS');
    };

    this.onEnterIssueLabels = function(){
		localStorageEngine.setLocalVar('projectFilter', null);
	};

	this.onAddIssueLabel = function(args){
        getLabelsWidget().newRow();
        getFieldProjectNameFromWidgetLabels().reload();
	};

	this.onCancelIssueLabel = function(args){
        getLabelsWidget().reload();
		ScreenService.closeSwipe();
        getLabelsWidget().list();
	};

	this.labelsActionEventSave = function(args){
        var labelsWidget = getLabelsWidget();
		if(labelsWidget.isValid()){
            labelsWidget.saveRow().then(function(response){
            	labelsWidget.currentRow.ID = response.dataset.issueLabel.ID;
            	ScreenService.showLoader();
                labelsWidget.reload().then(function(){
                	ScreenService.hideLoader();
                	labelsWidget.view();
                	labelsWidget.activate();
					templateManager.updateTemplate();
					labelsWidget.setCurrentRow(labelsWidget.currentRow);
				}).catch(ScreenService.hideLoader);
			});
		}
	};

	this.onEditIssueLabel = function(args){
        getLabelsWidget().edit();
        getFieldProjectNameFromWidgetLabels().reload();
	};

	this.labelWidgetActionEventDelete = function(args){
        ScreenService.confirmMessage(Messages.ALE_DELETE_LABELS, null, function(){
            getLabelsWidget().removeRow();
            ScreenService.closeSwipe();
		});
	};

    this.labelsWidgetActionEventCancel = function(args){
        Utilities.genericCancelEvent(getLabelsWidget());
	};
	
	this.labelsWidgetOnEnter = function(args){
		var widget = getLabelsWidget();
		Utilities.applyDefaultFilterOnEnter(widget, true);
		widget.activate();
	};
	
	this.labelsFilterAfterApply = function(){
        Utilities.setFilterInit(getLabelsWidget());
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('IssueLabelsController', IssueLabelsController);
});


// FILE: assets/js/Controller/IssueLabelsNextController.js
function IssueLabelsNextController(templateManager, Utilities){
    var getIssueLabelsNextController = function() {
        return templateManager.container.getWidget('issueLabelsNextWidget');
    };
    
    this.issueLabelsNextContainerAfterinit = function () {
        getIssueLabelsNextController().sourceUrl = Utilities.getUrlPmNext('issue-Labels');
    };
}

Configuration(function(ContextRegister) {
	ContextRegister.register('IssueLabelsNextController', IssueLabelsNextController);
});

// FILE: assets/js/Controller/IssueTracker.js
function IssueTracker(ZhFilterPreferences,ScreenService, localStorageEngine, requestDataSourceEngine, ZHPromise, templateManager, Utilities, ProjectServiceList, Validation,FilterService,TaskService, Messages, CommentService) {

	/************************************************************
	 * Global variables
	 ************************************************************/
	var pilha = 0;

	/************************************************************
	 * Constants
	 ************************************************************/
	var DEFAULT_STATUS = 'B';
	var INITIAL_STATUS = 'N';
    var RESOURCE_STATUS_ACTIVE = 'A';
    var CONTROL_TASK_TYPE_HOMOLOGATED = 'H';
    var CONTROL_TASK_TYPE_BACKLOG = 'B';
	var self = this;

    var initFollower = false;

	/************************************************************
	 * Functions which returns widgets
	 ************************************************************/
    var getWidgetCommentsFilter = function(){
        return templateManager.container.getWidget('COMMENTS_FILTER');
    };

    var getWidgetResourceList = function(){
        return templateManager.container.getWidget('RESOURCE_LIST');
    };

    var getWidgetCommentsFilterGrid = function(){
        return templateManager.container.getWidget('COMMENTS_FILTER_GRID');
    };

    var getWidgetIssuesMain = function(){
        return templateManager.container.getWidget('ISSUES_MAIN');
    };

    var getWidgetFollowedIssues = function(){
        return templateManager.container.getWidget('FOLLOWED_ISSUES');
    };

    var getWidgetIssueMain = function(){
        return templateManager.container.getWidget('ISSUE_MAIN');
    };

    var getWidgetMyIssuesTabbed = function(){
        return templateManager.container.getWidget('MY_ISSUES_TABBED');
    };

    var getWidgetIssueUpload = function(){
        return templateManager.container.getWidget('ISSUE_UPLOAD');
    };

    var getWidgetNewTask = function(){
        return templateManager.container.getWidget('NEW_TASK');
    };

    var getWidgetIssueRelationship = function(){
        return templateManager.container.getWidget('ISSUE_RELATIONSHIP');
    };

    var getFieldTaskClassificationLabelFromNewTask = function(){
        return getWidgetNewTask().getField('TASK_CLASSIFICATION_LABEL');
    };

    var getWidgetTabbedBoardIssue= function(){
        return templateManager.container.getWidget('TABBED_BOARD_ISSUE');
    };

    var getCurrentWidgetTabbedBoardIssue= function(){
        return templateManager.container.getWidget('TABBED_BOARD_ISSUE').currentWidget;
    };
    
    var getFieldFromWidgetNewTask = function(){
        return getWidgetNewTask().getField('TASK_STATUS_NAME');
    };

    var getFieldFollowersFromWidgetIssueMain = function(){
        return getWidgetIssueMain().getField('FOLLOWERS');
    };

    var getFieldFollowerFromWidgetIssueMain = function(){
        return getWidgetIssuesMain().getField('FA--RESOURCE_T');
    };

    var getFieldFollowerFromFilterWidgetIssueMain = function(){
        return getWidgetIssuesMain().appliedFilter.getField('FA--RESOURCE_T');
    };

    var getFieldSponsorFromWidgetNewIssue = function(){
        return getWidgetNewIssue().getField('SPONSOR');
    };

    var getWidgetComments = function(){
        return templateManager.container.getWidget('COMMENTS');
    };

    var getWidgetCommentsGrid = function(){
        return templateManager.container.getWidget('COMMENTS_GRID');
    };
    var getWidgetNewIssue = function(){
        return templateManager.container.getWidget('NEW_ISSUE');
    };

    var getWidgetNewComment = function(){
        return templateManager.container.getWidget('NEW_COMMENT');
    };

    var getWidgetNewCommentGrid = function(){
        return templateManager.container.getWidget('NEW_COMMENT_GRID');
    };

    var getWidgetFollowedIssuesFilter= function(){
        return getWidgetFollowedIssues().appliedFilter;
    };

	/************************************************************
	 * Functions which returns fields
	 ************************************************************/
	var getFieldTaskStatusNameFromWidgetNewTask = function(){
		return getWidgetNewTask.getField('TASK_STATUS_NAME');
	};

    var getFieldCreatedAtFromWidgetBoardIssueFilter = function() {
        return getFilterWidget().getField('I--CREATED_AT');
    };

    var getFieldCreatedAtFromWidgetGridIssueFilter = function() {
        return getGridIssueFilterWidget().getField('I--CREATED_AT');
    };

    var getFieldResourceTFromWidgetBoardIssueFilter = function() {
        return getFilterWidget().getField('FA--RESOURCE_T');
    };

    var getFieldResourceTFromWidgetGridIssueFilter = function() {
        return getGridIssueFilterWidget().getField('FA--RESOURCE_T');
    };

    var getFieldTaskStatusFromWidgetIssuesMain = function() {
        return getWidgetIssuesMain().getField('I--TASK_STATUS');
    };

    var getFieldTaskStatusFromWidgetGridIssueFilter = function() {
        return getGridIssueFilterWidget().getField('I--TASK_STATUS');
    };

    var getFieldTaskStatusFromWidgetIssueFilter = function() {
        return getWidgetIssuesMain().getField('TASK_STATUS');
    };

    var getFieldTaskStatusFromWidgetFollowedIssueFilter = function() {
        return getWidgetFollowedIssues().getField('TASK_STATUS');
    };

    var getFieldIssueStatusNameFromFilterWidget = function() {
        return getFilterWidget().getField('ISSUE_STATUS_NAME');
    };

    var getFieldSponsorFromWidgetIssueMain = function(){
        return getWidgetIssueMain().getField('SPONSOR');
    };

    var getFieldResourceFromWidgetNewTask= function(){
        return getWidgetNewTask().getField('RESOURCE');
    };

    var getFieldResourcesNamesFromWidgetCreateIssueTask = function(){
        return getWidgetCreateTaskIssue().getField('RESOURCES_NAMES');
    };

	function reloadTaskTypes(widget){
		requestDataSourceEngine.getDataSource('/getTaskTypes').then(function(data){
            var actualColumns = {};
            widget.PMTaskType = data.dataset.taskTypes;
			data.dataset.taskTypes.forEach(function(taskType){
				var filter = {
					'column': parseInt(taskType.column),
                    'label': taskType.columnLabel
				};
				var alreadyColumned = widget.columns.filter(isThisColumn, filter);
				if(!alreadyColumned.length){
					widget.columns.push({
						'id': parseInt(taskType.column),
						'label': taskType.columnLabel
					});
				}
                actualColumns[taskType.column] = taskType.columnLabel;
			});

            // Update columns on label or on remove of it
            widget.columns = widget.columns.filter(function(column){
                return actualColumns.hasOwnProperty(column.id) && column.label == actualColumns[column.id];
            });

            templateManager.updateTemplate();
            //TODO não remover por causa do kanban
            Utilities.windowResizeKanban(300);
		});
	}

    this.initFilterIssue =true;
    
    this.issuesMainWidgetOnEnter = function(args){
        self.onEnterIssuesMain(getIssueMainWidget());
    };
    
	this.onEnterIssuesMain = function(widget){
		
        issueCurrent = null;
        if(self.initFilterIssue) {
            ZhFilterPreferences.setOriginalFilter(widget, widget.currentRow);
            Utilities.startFilter(widget, widget.currentRow);
        }else{
            ZhFilterPreferences.applyFilter(widget, widget.appliedFilter.FILTER_ROW);
        }
        if(!this.initFilterAccompanyingIssue){
            widget.reload();
        }
        var widgetMyIssuesTabbed = getWidgetMyIssuesTabbed();
        
        widgetMyIssuesTabbed.currentWidget.activate().then(function(){
            var issue = Utilities.localVar.getIssue() ? Utilities.localVar.getIssue() : null;
            var lastWindow = Utilities.localVar.getLastWindow() ? Utilities.localVar.getLastWindow() : null;
            if(lastWindow === 'unreadComments' && issue){
                var container = widget.container;
                var tabbedWidget = container.getWidget('TABBED_ISSUE');
                ScreenService.openSwipe(tabbedWidget).then(function(){});
            }
            Utilities.localVar.setLastWindow("issues");
        });
        
	};

    this.followedIssuesWidgetOnEnter = function(args){
        var issueFollowedWidget = getWidgetFollowedIssues();
        issueCurrent = null;
        if(initFollower) {
            ZhFilterPreferences.applyFilter(issueFollowedWidget, issueFollowedWidget.appliedFilter.FILTER_ROW);
        }else{
            var taskStatusFollowedField = getFieldTaskStatusFromWidgetFollowedIssueFilter();
            taskStatusFollowedField.reload();
            ZhFilterPreferences.setOriginalFilter(issueFollowedWidget, issueFollowedWidget.currentRow);
            Utilities.startFilter(issueFollowedWidget, issueFollowedWidget.currentRow);
            initFollower = true;
        }
	};

    this.setDefaultsFiltersIssue = function(container) {
        self.validateExistsBacklogControlTaskType();
        localStorageEngine.download('/findResourcesByOrganization');
        var filterByDashboard = Utilities.localVar.getFilterByDashboard();
        var taskStatusField   = getFieldTaskStatusFromWidgetIssueFilter();
        var issuesMainWidget  = getWidgetIssuesMain();
        if(self.initFilterIssue) {
            var valueFieldFilter = [];
            var taskParameters = Utilities.localVar.getTaskParameters();
            var valueParameterFinal = 0;
            if (taskParameters) {
                valueParameterFinal = taskParameters.FINAL_TASK_STATUS_ID;
            }
            taskStatusField.reload().then(function () {
                var allTaskStatus = taskStatusField.dataSource.data;
                if(!filterByDashboard || (filterByDashboard && !filterByDashboard.hasOwnProperty('issues'))){
                    allTaskStatus.forEach(function (data) {
                        if (data.ID != valueParameterFinal) {
                            valueFieldFilter.push(data.ID);
                        }
                    });
                    taskStatusField.value(valueFieldFilter);
                } else {
                    taskStatusField.value(filterByDashboard.issues);
                }
                self.initFilterIssue = false;
                setDefaultFilter(issuesMainWidget, issuesMainWidget.currentRow);
            });
        } else if (filterByDashboard && filterByDashboard.hasOwnProperty('issues')){
            taskStatusField.value(filterByDashboard.issues);
            setDefaultFilter(issuesMainWidget, issuesMainWidget.currentRow);
        }
        Utilities.recursiveReload(container);
    };
    
    var setDefaultFilter = function(widget, currentRow){
        var filterByDashboard =  Utilities.localVar.getFilterByDashboard();
        ZhFilterPreferences.setOriginalFilter(widget, currentRow);
        Utilities.startFilter(widget, currentRow);
        if(filterByDashboard && filterByDashboard.hasOwnProperty('issues')){
            delete filterByDashboard.issues;
        }
    };

    this.initFilterBoardIssue = true;

    this.reloadIssuesData = function(){
        Utilities.refreshWidgetActive();
    };

    this.validateExistsBacklogControlTaskType = function() {
        var filter =  [ {
            'name': 'CONTROL',
            'operator': '=',
            'value': CONTROL_TASK_TYPE_BACKLOG
        } ];

        requestDataSourceEngine.getDataSource('/taskType', filter).then(function(data) {
            if(data.dataset.taskType.length > 0) {
                localStorageEngine.setLocalVar('EXISTS_BACKLOG_CONTROL', true);
            } else {
                localStorageEngine.setLocalVar('EXISTS_BACKLOG_CONTROL', false);
            }
        });
    };

	this.afterMoveItem = function(e, args) {
        var newIssueType = e.columns.to;
        var issueToMove = e.item;
        var issuesMainWidget = getWidgetIssuesMain();
        var typeTask = issuesMainWidget.PMTaskType.filter(function(taskType){
            return taskType.column == newIssueType;
        });
        if(e.columns.to !== e.columns.from) {
            if (typeTask[0].CONTROL == "H") {
                ScreenService.showCustomDialog(Utilities.messages.ALE_SEND_MAIL_AVAILABLE_ISSUE, 'CONFIRMATION', null,
                    [
                        {
                            "label": "Sim",
                            "code": function () {
                                issueToMove.sendMail = true;
                                moveIssue(issueToMove, typeTask);
                            }
                        },
                        {
                            "label": "Não",
                            "code": function () {
                                issueToMove.sendMail = false;
                                moveIssue(issueToMove, typeTask);
                            }
                        },
                        {
                            "label": 'Cancelar',
                            "code": function () {
                                issuesMainWidget.reload();
                            }
                        }
                    ]);
            }
            else {
                issueToMove.sendMail = false;
                moveIssue(issueToMove, typeTask);
            }
        }
	};

    var moveIssue = function(issueToMove, typeTask){
        var issueId = issueToMove.id;
        var newIssue = { "newIssueType": typeTask[0].ID, "issueId": issueId, "changed": true, "sendMail": issueToMove.sendMail };
         requestDataSourceEngine.setDataSource("/saveEditedIssue", [newIssue]).then(function(){
             getWidgetIssuesMain().reload();
         }).catch(function(e){
             Utilities.showMessageBackEndTrue(e).then(function(){
                 getWidgetIssuesMain().reload();
             });
         });
    };

	function isStatusDefault(status){
		return status.CONTROL === DEFAULT_STATUS;
	}

    function isStatusInitial(status){
        return status.CONTROL === INITIAL_STATUS;
    }

    this.issuesMainActionEventNew = function(args){
        self.openSwipeNewIssue(args);
        getFieldSponsorFromWidgetNewIssue().reload();
    };

    this.openSwipeNewIssue = function(args) {
	    var issueWidget = args.owner.widget.container.getWidget("NEW_ISSUE");
		ScreenService.openSwipe(issueWidget);
		issueWidget.newRow();
		issueWidget.currentRow.PRIORITY = 0;
		issueWidget.currentRow.PERCENT_COMPLETED = 0;
		var statusField = issueWidget.getField('ISSUE_STATUS_NAME');
		var status = statusField.dataSource.data.filter(isStatusDefault);
        if(status.length <= 0){
            status = statusField.dataSource.data.filter(isStatusInitial);
        }
		status = status[0];
		issueWidget.currentRow.ISSUE_STATUS_NAME = status.LABEL;
		issueWidget.currentRow.ISSUE_STATUS = status.ID;
		requestDataSourceEngine.getDataSource('/findUserData').then(function(data){
			data = data.dataset.findUserData[0];
			issueWidget.currentRow.REPORTER_NAME = data.NAME;
			issueWidget.currentRow.REPORTER = data.RESOURCE_ID;
			issueWidget.getField('REPORTER_NAME').dataSource.data.push({'ID': data.RESOURCE_ID, 'NAME': data.NAME});
			issueWidget.currentRow.DUE_DATE = Utilities.getCurrentDate();
			templateManager.updateTemplate();
		});
	};

	this.openSwipeNewStatus = function(args) {
		var widget = args.owner.getParent().widget.container.getWidget("NEW_ISSUE_STATUS");
		ScreenService.openPopup(widget);
		widget.newRow();
	};

	this.openSwipeNewType = function(args) {
		var widget = args.owner.getParent().widget.container.getWidget("NEW_ISSUE_TYPE");
		ScreenService.openPopup(widget);
		widget.newRow();
	};

	this.saveIssue = function(owner) {
		var label = owner.widget.getField("LABEL").value();
		var issueStatus = owner.widget.getField("ISSUE_STATUS_NAME").value();

		if(owner.widget.isValid()) {
			if(!owner.widget.currentRow.BOARD){
				owner.widget.currentRow.BOARD = localStorageEngine.getLocalVar("boardId");
			}
			requestDataSourceEngine.setDataSource("/saveNewIssue", [owner.widget.currentRow], function(data) {
				owner.widget.setCurrentRow({});
				ScreenService.closeSwipe();
				var tasksWidget = owner.widget.container.getWidget("ISSUES_MAIN");
				tasksWidget.reload().then(function(){
					tasksWidget.activate();
					templateManager.updateTemplate();
				});
			});
		}

	};

	this.saveIssueStatus = function(owner) {
		var label = owner.widget.getField("LABEL").value();
		var issueType = owner.widget.getField("ISSUE_TYPE_NAME").value();

		if(label && issueType) {
			requestDataSourceEngine.setDataSource("/saveNewIssueStatus", [owner.widget.currentRow], function(data) {
				if(data.messages[0].message == "Issue status criado com sucesso") {
					owner.widget.setCurrentRow({});
					ScreenService.closePopup();
					templateManager.container.getWidget("NEW_ISSUE").getField("ISSUE_STATUS_NAME").reload();
				}
			});
		}
		else {
			ScreenService.showMessage("Nome inválido", "ALERT");
		}
	};

	this.saveIssueType = function(owner) {
		var label = owner.widget.getField("LABEL").value();

		owner.widget.currentRow.BOARD = localStorageEngine.getLocalVar("boardId");

		if(label) {
			requestDataSourceEngine.setDataSource("/saveNewIssueType", [owner.widget.currentRow], function(data) {
				if(data.messages[0].message == "Issue type criado com sucesso") {
					owner.widget.setCurrentRow({});
					ScreenService.closePopup();
					templateManager.container.getWidget("NEW_ISSUE_STATUS").getField("ISSUE_TYPE_NAME").reload();
					templateManager.container.getWidget("ISSUES_MAIN").reload();
				}
			});
		}
		else {
			ScreenService.showMessage("Nome inválido", "ALERT");
		}
	};

    var issueCurrent = null;

	this.onClickIssue = function(container, currentRow) {
        var issueMainWidget = container.getWidget('ISSUE_MAIN');
        var tabbedWidget = container.getWidget('TABBED_ISSUE');
        var uploadWidget = container.getWidget('ISSUE_UPLOAD');
        
        ScreenService.openSwipe(tabbedWidget);
        var permissiveActionsShowing = container.getActiveWidget().name !== 'FOLLOWED_ISSUES';
        var actionEdit = container.getWidget('ISSUE_MAIN').getAction('EDIT');
        if (actionEdit) {
            actionEdit.isVisible = permissiveActionsShowing;
            uploadWidget.getAction('ADD_DOCUMENTS').isVisible = permissiveActionsShowing;
            uploadWidget.getAction('DELETE_DOCUMENTS').isVisible = permissiveActionsShowing;
        }

        var taskParameters = localStorageEngine.getLocalVar('taskParameters');
        var finalTaskStatus = taskParameters.FINAL_TASK_STATUS_ID;
        var closeIssueAction = issueMainWidget.getAction('CLOSE_ISSUE');
        if (typeof closeIssueAction !== "undefined") {
            closeIssueAction.isVisible = (currentRow.ALLOW_CLOSE_ISSUE === 'Y') && (currentRow.TASK_STATUS != finalTaskStatus);
        }

        var reopenIssueAction = issueMainWidget.getAction('REOPEN_ISSUE');
        if (typeof reopenIssueAction !== "undefined") {
            reopenIssueAction.isVisible = (currentRow.CONTROL_TASK_TYPE == CONTROL_TASK_TYPE_HOMOLOGATED) &&
                                          (localStorageEngine.getLocalVar('EXISTS_BACKLOG_CONTROL')) &&
                                          (currentRow.TASK_STATUS != finalTaskStatus);
        }

		localStorageEngine.setLocalVar('issue', [currentRow.id]);
        issueCurrent = currentRow;
		if(tabbedWidget.currentWidget){
			tabbedWidget.currentWidget.reload();
            if(tabbedWidget.currentWidget.name == 'COMMENTS'){
                this.viewComments();
            }
		}
		else{
			tabbedWidget.widgets[0].reload();
		}

        var fieldLabels = container.getWidget('ISSUE_MAIN').getField('LABELS');

        if(fieldLabels){
            fieldLabels.reload();
            fieldLabels.dataSource.clearCheckedRows();
        }
        Utilities.localVar.setIssueClassification(currentRow.issueClassification);
	};

	this.onEditIssue = function(widget){
		var reporterField = widget.getField('REPORTER_NAME');
		reporterField.reload();
        getFieldSponsorFromWidgetIssueMain().reload();
		widget.edit();
		widget.template = widget.formTemplate;
	};

    this.issueMainActionEventEdit = function(args){
        self.onEditIssue(getWidgetIssueMain());
    };

    this.onBackBoards = function(){
        ScreenService.openWindow("product#boards");
    };

    this.resourceListActionEventBackView = function(args){
        var widget = getWidgetResourceList();
        ScreenService.closeSwipe().then(function(){
            widget.activate();
        });
    };

    this.goBackAccompanyingIssues = function(){
        ScreenService.goBack();
        templateManager.container.widgets[0].activate();
    };

    this.newIssueActionEventCancel = function(args){
        Utilities.genericBackEvent(getWidgetIssuesMain());
    };

	this.onBack = function(widget){
		if(widget && widget.container.inEditMode()){
			widget.reload();
		}
		else if(ScreenService.isPopupOpen()){
            /*****************************************
            *Linhas para concertar o bug do framework*
            *****************************************/
            getWidgetIssueUpload().currentWidget = null;
            getWidgetIssueUpload().activate();
            /*************************************************
            *Fim das Linhas para concertar o bug do framework*
            *************************************************/
			ScreenService.closePopup();
		}
		else{
			if(ScreenService.lastSwipe){
				templateManager.container.restoreDefaultMode();
			}
			ScreenService.goBack();
		}
		templateManager.updateTemplate();
	};

	this.backToKanban = function(widgetCurrent){
		ScreenService.closeSwipe();
		widgetCurrent.list();
		templateManager.container.getWidget('MY_ISSUES_TABBED').currentWidget.activate();

	};

    var hideConcludeActionIfResourceIsNotReporter = function(widget){
        var currLoggedUserId    = Number(Utilities.localVar.getLocalVarIdBusinessPartner());
        var issueReporterId     = Number(widget.currentRow.REPORTER);
        var issueReporterStatus = widget.currentRow.REPORTER_STATUS;
        var closeIssueAction = getWidgetIssueMain().getAction('CLOSE_ISSUE');
        if(typeof closeIssueAction !== "undefined")
            closeIssueAction.isVisible = closeIssueAction.isVisible && (currLoggedUserId === issueReporterId || issueReporterStatus !== RESOURCE_STATUS_ACTIVE);
    };

    var isCurrentUserIssueReporter = function(reporterId){
        var userId = Number(Utilities.localVar.getLocalVarIdBusinessPartner());
        reporterId = Number(reporterId);
        return userId == reporterId;
    };

    var isStatusActive = function(userStatus){
        return userStatus == RESOURCE_STATUS_ACTIVE;
    };

    var disableReporterFieldEditingIfResourceIsNotReporter = function(widget){
        var issueReporterId     = Number(widget.currentRow.REPORTER);
        var issueReporterStatus = widget.currentRow.REPORTER_STATUS;
        var reporterField       = getWidgetIssueMain().getField('REPORTER_NAME');
        reporterField.readOnly  = ( ! isCurrentUserIssueReporter(issueReporterId) && isStatusActive(issueReporterStatus));
    };

	this.onEnterBasicInformationTab = function(widget){
        reloadBasicIssueInformationWidget(widget);
		widget.list();
		widget.template = widget.formTemplate;
		widget.view();
	};

	var _saveIssue = function(widget, parentWidget){
        if(!widget.currentRow.BOARD){
            widget.currentRow.BOARD = getLocalVar('product');
        }
		if(widget.isValid()){
			widget.saveRow().then(function(){
                parentWidget.reload().then(function(){
                    widget.reload().then(function(){
                        widget.activate();
                    });
                });
			});
		}
	};

	this.newUploadDocument = function(widget){
		ScreenService.openPopup(widget);
		widget.newRow();
	};

	this.downLoadAttachment = function(row){
		ProjectServiceList.downLoadAttachment(row);
	};

	this.deleteAttachment = function(widget){
        var currentRow = [widget.currentRow];
		ScreenService.confirmMessage(Utilities.messages.ALE_DELETE_DOCUMENT, null, function(){
			ProjectServiceList.deleteAttachment(currentRow).then(function(data){
				widget.reload();
                ScreenService.closeSwipe();
			});
		}, null);
	};

	this.saveUploadDocument = function(widget){
        widget.currentRow.projectId = localStorageEngine.getLocalVar('boardId') ;
        widget.currentRow.taskId = localStorageEngine.getLocalVar('issue')[0];
        ProjectServiceList.newUploadDocumentTask(widget.currentRow).then(function(){
            self.onBack();
            widget.container.getWidget('ISSUE_UPLOAD').reload();
        });
	};

	this.onLoadDataSource = function(widget){
		widget.list();
	};
    this.issueMainWidgetAfterLoadDataSourceBoardIssues = function(widget){
		widget.list();
        widget.template = widget.formTemplate;
        widget.moveToFirst();
        var fieldFollowers = getFieldFollowersFromWidgetIssueMain();
        Utilities.bugPaginationOnSelectMultiplyOnModeView(fieldFollowers);
	};

	this.issueMainWidgetAfterLoadDataSource = function(args){
		if( ! isIssueMainCurrentWidget()){
			return false;
		}

		var issueMainWidget = args.owner;
		issueMainWidget.view();
		issueMainWidget.template = issueMainWidget.formTemplate;
		issueMainWidget.moveToFirst();
		hideConcludeActionIfResourceIsNotReporter(issueMainWidget);
		disableReporterFieldEditingIfResourceIsNotReporter(issueMainWidget);
		getFieldSponsorFromWidgetIssueMain().reload();
        var fieldFollowers = getFieldFollowersFromWidgetIssueMain();
        Utilities.bugPaginationOnSelectMultiplyOnModeView(fieldFollowers);
	};

	var isIssueMainCurrentWidget = function(){
		var currentActiveWidget = templateManager.container.getActiveWidget();
		var issueMainWidget = templateManager.container.getWidget('ISSUE_MAIN');
		return currentActiveWidget == issueMainWidget;
	};

	this.openNewClassification = function(owner){
		var widget = owner.getParent().widget.container.getWidget("NEW_CLASSIFICATION");
		ScreenService.openPopup(widget);
		widget.newRow();
	};

	this.saveIssueClassification = function(widget){
		requestDataSourceEngine.setDataSource('/taskClassification', [widget.currentRow]).then(function(){
			widget.container.getWidget('NEW_ISSUE').getField('ISSUE_CLASSIFICATION_NAME').reload();
			self.onBack();
		});
	};

	this.openPopUp = function(widget){
		ScreenService.openPopup(widget.widgets[0]);
	};
    
	this.editResourceDelete = function(widget){
		var row = {};
        ScreenService.confirmMessage(Utilities.messages.ALE_ARE_YOU_SURE_REMOVE_RESOURCE, 'question', function(){
            row.CHECKED_ROWS = [widget.currentRow];
            row.PROJECT = localStorageEngine.getLocalVar('boardId');
            row.changed = true;
            requestDataSourceEngine.setDataSource('/deleteProjectResource', [row]).then(function(){
                widget.reload();
                ScreenService.closeSwipe();
                widget.container.restoreDefaultMode();
            });
        });
	};

	this.resourceListClicked = function(checkedRows, widgetList){
		var row ={};
		row.RESOURCES = checkedRows;
		row.PROJECT = localStorageEngine.getLocalVar('boardId');
		row.changed = true;
		requestDataSourceEngine.setDataSource('/editProjectResource', [row]).then(function(data){
			widgetList.reload();
			widgetList.widgets[0].unSelectAll();
			widgetList.container.restoreDefaultMode();
			ScreenService.closePopup();
		});
	};

	this.afterLoadDataSource = function(widget) {
		if(widget.name === 'BOARD'){
			widget.view();
			widget.moveToFirst();
			widget.template = widget.formTemplate;
		}
		else{
			widget.list();
			if(widget.name === 'ISSUES_MAIN'){
				this.afterLoadItems(widget, true);
			}
		}
		templateManager.updateTemplate();
	};

	this.onEdit = function(widget){
		widget.edit();
		widget.template = widget.formTemplate;
	};

	this.saveBoard = function(widget) {
		if(widget.isValid()) {
			widget.saveRow().then(function(){
				widget.container.label = widget.currentRow.NAME;
				self.onBack(widget);
			});
		}
	};

	this.onChangeProject = function(boardId){
		localStorageEngine.setLocalVar('boardId', boardId);
		localStorageEngine.setLocalVar('PROJECT_ISSUE_ID', boardId);
	};

	function isThisColumn(column){
		return column.id === this.column && column.label == this.label;
	}

	this.afterLoadItems = function(widget, movable){
		var alreadyColumned;
		var filter;
		widget.dataSource.data.forEach(function(item, index, dataSource){
			filter = {
				'column': parseInt(item.column),
                'label' : item.columnLabel
			};
			alreadyColumned = widget.columns.filter(isThisColumn, filter);
			if(!alreadyColumned.length){
				widget.columns.push({
					'id': parseInt(item.column),
					'label': item.columnLabel
				});
			}
			dataSource[index].movable = movable;
		});
		reloadTaskTypes(widget);
	};

    this.issueMainIssuesActionEventDelete = function(args){
        ScreenService.confirmMessage('Confirma exclusão da(s) Issue(s)?',null,function(){
            self.deleteIssue(args.owner.widget, getWidgetIssuesMain());
        });
    };

    this.deleteIssue = function(widget, parentWidget){
        var issue = widget.currentRow;
        var user = localStorageEngine.getLocalVar('idBusinessPartner');
        var issueDelete = true;
        if(issue.REPORTER != user){
                issueDelete = false;
        }
        if(issueDelete){
            widget.removeRow(issue).then(function() {
                parentWidget.reload().then(function () {
                    widget.reload().then(function () {
                        ScreenService.closeSwipe().then(function(){
                            parentWidget.activate();
                        });
                    });
                });
            });
        }else{
            ScreenService.showMessage(Messages.ERR_NOT_DELETE_ISSUE_USER_LOGADO);
        }
    };

	this.onRemoveTaskRelationship = function(widget){
		localStorageEngine.setLocalVar('issue', [localStorageEngine.getLocalVar('issue')[0]]);
		widget.dataSource.checkedRows = [widget.currentRow];
        widget.removeCheckedRows();
        widget.unSelectAll();
        ScreenService.closeSwipe();
	};

	this.onAddTaskRelationship = function(widget){
        if(widget.hasCheckedRows()) {
            if (widget.name == 'ISSUES_MAIN') {
                issueCurrent = null;
            }
            var alreadyAssociated = Validation.isEmpty(widget.dataSource.getCheckedRows()) ? widget.dataSource.data : widget.dataSource.getCheckedRows();
            var issuesIds = [];
            if (!Validation.isEmpty(alreadyAssociated)) {
                alreadyAssociated.forEach(function (issue) {
                    if (Validation.isEmpty(issue.id)) {
                        issuesIds.push(issue.ID);
                    }
                    else {
                        issuesIds.push(issue.id);
                    }
                });
                if (issuesHasSameClassification(alreadyAssociated))
                    Utilities.localVar.setIssueClassification(alreadyAssociated[0].issueClassification);
                else
                    Utilities.localVar.setIssueClassification(null);
            }
            localStorageEngine.setLocalVar('issue', issuesIds);
            var productTasksWidget = widget.container.getWidget('PRODUCT_TASKS');
            productTasksWidget.dataSource.clearCheckedRows();
            productTasksWidget.dataSource.updateCheckedRows();
            ScreenService.openPopup(productTasksWidget);
            productTasksWidget.reload();
        }else{
            ScreenService.showMessage(Utilities.messages.NOT_CHECKED_ROW_TASK);
        }
	};

    this.onAddTaskRelationshipInIssueEdit = function(widget){
		var productTasksWidget = widget.container.getWidget('PRODUCT_TASKS');
		productTasksWidget.dataSource.clearCheckedRows();
		productTasksWidget.dataSource.updateCheckedRows();
		ScreenService.openPopup(productTasksWidget);
		productTasksWidget.reload();
	};

    var issuesHasSameClassification = function(issues) {
        var classification = issues[0].issueClassification;
        return !issues.some(function(issue){
            return issue.issueClassification != classification;
        });
    };
    this.onAssociateTasks = function(widget){
		var checkedRows = widget.dataSource.getCheckedRows();
		var issueId = localStorageEngine.getLocalVar('issue');
		issueId = issueId instanceof Array ? issueId : [issueId];

        var checkedIssues = getIssueMainWidget().dataSource.data.filter(function(row){
            return issueId.indexOf(row.id) >= 0;
        });

		checkedRows.forEach(function(value, index, array){
			array[index].changed = true;
			array[index].ISSUE = issueId;
		});

        if(issuesHasSameClassification(checkedIssues)){
            checkedRows.forEach(function(value, index, array){
                array[index].CLASSIFICATION_ID = checkedIssues[0].issueClassification;
            });

            var updateClassificationPromises = checkedRows.map(function(row){
                return requestDataSourceEngine.setDataSource('/taskClassification', [row]);
            });

            ZHPromise.all(updateClassificationPromises).then(function(){
                requestDataSourceEngine.setDataSource('/taskRelationship', checkedRows).then(function(){
                    self.onBack(widget);
                    if(widget.container.getWidget('ISSUE_RELATIONSHIP')){
                        widget.container.getWidget('ISSUE_RELATIONSHIP').reload();
                        getIssueMainWidget().reload();
                    }
                });
            });
        } else {
            requestDataSourceEngine.setDataSource('/taskRelationship', checkedRows).then(function(){
                self.onBack(widget);
                if(widget.container.getWidget('ISSUE_RELATIONSHIP')){
                    widget.container.getWidget('ISSUE_RELATIONSHIP').reload();
                    getIssueMainWidget().reload();
                }
            });
        }
	};

    this.projectTaskActionEventAdd = function(){
        this.onAddTask();
    };

	this.onAddTask = function(){
		var newTaskWidget = getWidgetNewTask();
		newTaskWidget.lastSwipe = templateManager.container.getActiveWidget().lastActiveWidget;
		ScreenService.closePopup(true);
		ScreenService.openSwipe(newTaskWidget);
		newTaskWidget.newRow();
		newTaskWidget.activate();
		Utilities.clearWidgetCacheFields(newTaskWidget);
		newTaskWidget.getField('START').value(Utilities.getCurrentDate());
		newTaskWidget.getField('END').value(Utilities.getCurrentDate());
		newTaskWidget.getField('TOTAL_TIME').value('1D');
        if(issueCurrent){
            newTaskWidget.getField('NAME').value(issueCurrent.label);
            newTaskWidget.getField('DESCRIPTION').value(issueCurrent.description);
        }
        __setClassificationInNewTask();
	};

	this.onCancelNewTask = function(widget){
		var lastSwipe = widget.lastSwipe;
		this.onBack();
        lastSwipe.activate();
	};

	this.addStatusTask = function(widget){
		widget = widget.container.getWidget('NEW_TASK_STATUS');
		ScreenService.openPopup(widget);
		widget.getField('TASK_TYPE_NAME').reload();
		widget.newRow();
	};

	this.setVisibleDateException = function(row, widget){
		var fieldDate = widget.getField('DATE_EXCEPTION');
		if(row.DATE_EXCEPTION_ABBREVIATION == 'MB' || row.DATE_EXCEPTION_ABBREVIATION == 'MT'){
			fieldDate.isVisible = false;
			row.DATE_EXCEPTION = null;
		} else{
			fieldDate.isVisible = true;
		}
	};

	this.onChangeStartTask = function(widget){
		var row = widget.currentRow;
		var beginTaskParent = null;
		var exceptions = [];
		var beginTask = row.START.split("/").reverse().join("-");
		var dateException = moment(row.DATE_EXCEPTION, 'DD/MM/YYYY');
		if(widget.currentRow.PARENT_NAME){
			var dataParent = widget.getField('PARENT_NAME').dataSource.data;
			dataParent.forEach(function(data){
					if(data.ID == row.PARENT){
						beginTaskParent = data.BEGIN_TASK;
					}
				}
			);
		}else{
			row.PARENT = null;
		}

		if(row.DATE_EXCEPTION_ABBREVIATION == 'MB' ){
			if((beginTask != beginTaskParent && beginTaskParent ) ||(beginTask != beginProject && !beginTaskParent)){
				row.DATE_EXCEPTION = row.START;
				var dataException = widget.getField('DATE_EXCEPTION_NAME').dataSource.data;
				dataException.forEach(function(data){
						if(data.ABBREVIATION == 'IA'){
							row.DATE_EXCEPTION_ABBREVIATION = data.ABBREVIATION;
							row.DATE_EXCEPTION_TYPE = data.ID ;
							row.DATE_EXCEPTION_NAME = data.NAME;
						}
					}
				);

			}
			this.setVisibleDateException(row, widget);
		} else if (row.DATE_EXCEPTION_ABBREVIATION == 'IA') {
			beginTask = moment(row.START, 'DD/MM/YYYY');
			dateException = moment(row.DATE_EXCEPTION, 'DD/MM/YYYY');
			if (beginTask < dateException || !dateException) {
				row.DATE_EXCEPTION = row.START;
			}
		} else if (row.DATE_EXCEPTION_ABBREVIATION == 'ID') {
			beginTask = moment(row.START, 'DD/MM/YYYY');
			dateException = moment(row.DATE_EXCEPTION, 'DD/MM/YYYY');
			if (beginTask > dateException || !dateException) {
				row.DATE_EXCEPTION = row.START;
			}
		} else if (row.DATE_EXCEPTION_ABBREVIATION == 'DI') {
			if (beginTask != dateException.format('YYYY-MM-DD') ) {
				row.DATE_EXCEPTION = row.START;
			}
		}
		if(moment(row.START, 'DD/MM/YYYY') > moment(row.END, 'DD/MM/YYYY')){
			row.END = row.START;
		}
		ProjectServiceList.parseDatesTask(row, exceptions);
	};

	this.onChangeEndTask = function(currentRow){
		var exceptions = [];
		ProjectServiceList.parseDates(currentRow, exceptions);
	};

	this.onChangeTimeTotal = function(widget){
		var exceptions = [];
		ProjectServiceList.parseTimeTypeTask(widget.currentRow, exceptions, widget.getField('RESOURCE'));
	};

	this.setDateByException = function(row, precursors, parents){
		var precursor = row.PRECURSOR;
		var parent = row.PARENT;
		var exceptions = [];
		var beginTaskPrecursor = null;
		var endTaskPrecursor = null;
		var beginTaskParent = null;
		var endTaskParent = null;
		var previousTime = null;
		if(row.PRECURSOR_NAME && row.TYPE){
			precursors.forEach(function(data){
					if(data.ID == precursor){
						row.__PRECURSOR_NAME = data;
						beginTaskPrecursor = data.BEGIN_TASK;
						endTaskPrecursor = data.END_TASK;
						previousTime = data.PREVIOUS_TIME;
					}
				}
			);
		}else{
			row.PRECURSOR = null;
		}
		if(row.PARENT_NAME){
			parents.forEach(function(data){
					if(data.ID == parent){
						beginTaskParent = data.BEGIN_TASK;
						endTaskParent = data.END_TASK;
					}
				}
			);
		}else{
			row.PARENT = null;
		}
		row.START = row.START.split("/").reverse().join("-");
		row.END = row.END.split("/").reverse().join("-");
		if(row.DATE_EXCEPTION){
			row.DATE_EXCEPTION = row.DATE_EXCEPTION.split("/").reverse().join("-");
		}
		ProjectServiceList.getDateBegin(row, beginTaskPrecursor, endTaskPrecursor, beginTaskParent, endTaskParent, exceptions, previousTime);
		row.START = row.START.split("-").reverse().join("/");
		row.END = row.END.split("-").reverse().join("/");
		if(row.DATE_EXCEPTION) {
			row.DATE_EXCEPTION = row.DATE_EXCEPTION.split("-").reverse().join("/");
		}
	};

	this.onChangePrecursor= function(widget) {
		row = widget.currentRow;
		if(row.PRECURSOR_NAME){
			if(!row.TYPE) {
				row.TYPE = 'TI';
			}
		} else{
			row.TYPE = null;
		}
		this.setDateByException(row, widget.getField('PRECURSOR_NAME').dataSource.data, widget.getField('PARENT_NAME').dataSource.data);
	};

	this.fixBugOnChangeSelectNative = function(row, field, value){
		var widget = field.widget;
		if(value){
			row[field.name] = field.dataSource.data[value][field.valueField];
		}
		this.setDateByException(row, widget.getField('PRECURSOR_NAME').dataSource.data, widget.getField('PARENT_NAME').dataSource.data);
	};

	this.validateNewTask = function(row){
		var validation = true;
		var begin = moment(row.START, 'YYYY-MM-DD');
		var end = moment(row.END, 'YYYY-MM-DD');
		if(row.PARENT == row.PRECURSOR && !Validation.isEmpty(row.PRECURSOR)){
			ScreenService.showMessage(Messages.ERR_SUPERIOR_TASK_SAME_PRECURSOR, null, "exclamation");
			validation = false;
		}else if(Validation.isEmpty(row.NAME) || Validation.isEmpty(row.START) || Validation.isEmpty(row.END)){
			ScreenService.showMessage(Messages.ERR_REQUIRED_FIELDS, null, "exclamation");
			validation = false;
		}else if(begin > end){
			ScreenService.showMessage(Messages.ERR_START_DATE_AFTER_FINAL_DATE, null, "exclamation");
			validation = false;
		}
		return validation;
	};

	this.onSaveNewTask = function(widget){
		var row = widget.currentRow;
        row.START   = Utilities.invertDateTimeToYearMonthDay(row.START, '/', '-');
        row.END     = Utilities.invertDateTimeToYearMonthDay(row.END, '/', '-');

		if(widget.isValid() && this.validateNewTask(widget.currentRow)){
			row.changed = true;
            var issueId = localStorageEngine.getLocalVar('issue');
            row.ISSUE = issueId instanceof Array ? issueId : [issueId];
			requestDataSourceEngine.setDataSource('/saveNewProjectTaskIssue', [row]).then(function(data){
				widget.list();
				try{
					if(data.dataset){
                        ScreenService.closeSwipe().then(function(){
                            getWidgetIssueRelationship().reload().then(function(){
                                getIssueMainWidget().reload();
                                getWidgetIssueRelationship().activate();
                            });
                        });
					}
				}catch(e){}
				self.onCancelNewTask(widget);
				Utilities.clearCheckedRowsAndReload(getWidgetTabbedBoardIssue().currentWidget);
			});
		}else{
            row.START   = Utilities.invertDateTimeToYearMonthDay(row.START, '-', '/');
            row.END     = Utilities.invertDateTimeToYearMonthDay(row.END, '-', '/');
			ScreenService.showMessage(Messages.ERR_REQUIRED_FIELDS);
		}
	};

	this.newTaskStatus = function(row, fieldTaskStatus){
		ProjectServiceList.newTaskStatus(row).then(function(){
			fieldTaskStatus.reload();
			self.onBack();
		});
	};

	this.addTypeTask = function(widget){
		ScreenService.openPopup(widget);
		widget.newRow();
	};

    this.viewComments = function(){
        var row = {};
        var issue = localStorageEngine.getLocalVar('issue');
        row.ISSUE = Array.isArray(issue)?issue[0]:issue;
        row.changed = true;
        requestDataSourceEngine.setDataSource('/viewComments',[row], undefined, undefined, undefined, undefined, true).then(function(response){
            if(Array.isArray(response)){
                localStorageEngine.setLocalVar('lastDateViewComments',null);
            }else{
                localStorageEngine.setLocalVar('lastDateViewComments',response.dataset.lastDate[0]);
            }
        });

    };

    this.viewCommentsBasicWidget = function(args){
        var row = {};
        var issue = localStorageEngine.getLocalVar('issue');
        row.ISSUE = Array.isArray(issue)?issue[0]:issue;
        row.BASIC_WIDGET = true;
        row.changed = true;
        requestDataSourceEngine.setDataSource('/viewComments',[row]).then(function(response){
            if(Array.isArray(response)){
                localStorageEngine.setLocalVar('lastDateViewComments',null);
            }else{
                localStorageEngine.setLocalVar('lastDateViewComments',response.dataset.lastDate[0]);
            }
        });

    };

    this.filterComments = function(){
        var widgetComments = getWidgetComments();
        var widget = getWidgetCommentsFilter();
        if(widget.currentRow && widget.currentRow.LAST_DATE_VIEW && widget.currentRow.LAST_DATE_VIEW == 'Y' ){
            var lastDateViewComments = localStorageEngine.getLocalVar('lastDateViewComments');
            if(lastDateViewComments){
                lastDateViewComments =  lastDateViewComments.split("/").reverse().join("-");
            }
            var filter =  {
                'name': 'CREATED_AT',
                'operator': '>',
                'value': lastDateViewComments
            };
            if(!widgetComments.dataSourceFilter){
                widgetComments.innerFilters = [];
            } else if(!widgetComments.innerFilters){
                widgetComments.innerFilters = widgetComments.dataSourceFilter || [];
            }
            widgetComments.dataSourceFilter = widgetComments.innerFilters.concat(filter);

        }else if(widgetComments.innerFilters){
            widgetComments.dataSourceFilter = widgetComments.innerFilters;
        }
        widgetComments.reload();
        ScreenService.closePopup();

    };

    this.filterCommentsGrid = function(){
        var widgetComments = getWidgetCommentsGrid();
        var widget = getWidgetCommentsFilterGrid();
        if(widget.currentRow && widget.currentRow.LAST_DATE_VIEW && widget.currentRow.LAST_DATE_VIEW == 'Y' ){
            var lastDateViewComments = localStorageEngine.getLocalVar('lastDateViewComments');
            if(lastDateViewComments){
                lastDateViewComments =  lastDateViewComments.split("/").reverse().join("-");
            }
            var filter =  {
                'name': 'CREATED_AT',
                'operator': '>',
                'value': lastDateViewComments
            };
            if(!widgetComments.dataSourceFilter){
                widgetComments.innerFilters = [];
            } else if(!widgetComments.innerFilters){
                widgetComments.innerFilters = widgetComments.dataSourceFilter || [];
            }
            widgetComments.dataSourceFilter = widgetComments.innerFilters.concat(filter);

        }else if(widgetComments.innerFilters){
            widgetComments.dataSourceFilter = widgetComments.innerFilters;
        }
        widgetComments.reload();
        ScreenService.closePopup();

    };

    this.openFilterComments = function(args){
        var filterWidget;
        if(args.owner.widget == getWidgetComments()) {
            filterWidget = getWidgetCommentsFilter();
        }else {
            filterWidget = getWidgetCommentsFilterGrid();
        }
       ScreenService.openPopup(filterWidget);

    };

	this.newTaskType = function(row, fieldTaskType){
		ProjectServiceList.newTaskType(row).then(function(){
			fieldTaskType.reload();
			self.onBack();
		});
	};

	this.saveEditType = function(widget) {
		widget.saveRow().then(function(){
			ScreenService.closeSwipe();
			widget.reload();
			widget.list();
		});
	};

    this.openIssueFilter = function(){
        var issueFilterWidget = templateManager.container.getWidget('ISSUE_FILTER');
        ScreenService.openPopup(issueFilterWidget);
        issueFilterWidget.edit();
    };

    this.openIssueFilterFollowed = function(){
        var issueFilterWidget = templateManager.container.getWidget('ISSUE_FILTER_FOLLOWED');
        ScreenService.openPopup(issueFilterWidget);
        issueFilterWidget.edit();
    };

    this.onFilter = function(widget){
        var parentWidget = templateManager.container.getWidget('MY_ISSUES_TABBED').currentWidget;
        FilterService.parentFilter(parentWidget, widget);
        ScreenService.closePopup();
        parentWidget.activate();
    };

    var getFilterWidget = function() {
        return getWidgetIssuesMain().appliedFilter;
    };

    var getGridIssueFilterWidget = function() {
        return getIssueMainGridWidget().appliedFilter;
    };

    var getFieldIssueStatusNameFromBoardIssueFilter = function() {
    	return getFilterWidget().getField('ISSUE_STATUS_NAME');
    };

    var getIssueMainWidget = function() {
    	return templateManager.container.getWidget('ISSUES_MAIN');
    };

    var getIssueMainGridWidget = function() {
    	return templateManager.container.getWidget('ISSUES_MAIN_GRID');
    };

    this.openPopUpFilter = function() {
        Utilities.reloadFields(getFilterWidget());
    	ScreenService.openPopup(getFilterWidget());
    };

    this.openPopUpFilterGrid = function() {
        Utilities.reloadFields(getGridIssueFilterWidget());
    	ScreenService.openPopup(getGridIssueFilterWidget());
    };

    this.setLabelsProduct = function(field) {
        localStorageEngine.setLocalVar('productFilter',field.value());
        field.widget.getField('TL--LABEL').reload();
        field.widget.getField('TL--LABEL').value([]);
    };


    this.closePopUpFilter = function() {
    	ScreenService.closePopup();
    	getIssueMainWidget().activate();
    };

    this.closePopUpFilterGrid = function() {
    	ScreenService.closePopup();
    	getIssueMainGridWidget().activate();
    };


    this.boardIssueFilterActionEventFilter = function(args) {
        var widget = getFilterWidget();
    	widget.currentRow.changed = true;
    	var parent = getIssueMainWidget();
        widget.applyFilter(widget).then(function(){
            ScreenService.closePopup();
            parent.activate();
        });
    };

    this.gridIssueFilterActionEventFilter = function(args) {
        var widget = getGridIssueFilterWidget();
    	widget.currentRow.changed = true;
    	var parent = getIssueMainGridWidget();
        widget.applyFilter(widget).then(function(){
            ScreenService.closePopup();
            parent.activate();
        });
    };

    this.closeIssue = function(issues){
        ScreenService.confirmMessage(Messages.ALE_CLOSE_ISSUE, 'CONFIRMATION',function(){
            TaskService.closeIssue(issues).then(function(){
                var issueMainWidget = getIssueMainWidget();
                ScreenService.closePopup(true);
                issueMainWidget.reload().then(function () {
                    ScreenService.closeSwipe();
                    issueMainWidget.activate();
                });
            });
        });
    };

    this.addLabel = function(args){
        var newLabelWidget = templateManager.container.getWidget('NEW_LABEL');
        newLabelWidget.newRow();
        newLabelWidget.currentRow.BOARD = getLocalVar('boardId');
        ScreenService.openPopup(templateManager.container.getWidget('NEW_LABEL'));
    };

    this.saveLabel = function(args){
        args.owner.widget.saveRow().then(function(){
            ScreenService.closePopup();
            args.owner.widget.parent.getField('LABELS').reload();
            templateManager.container.getWidget('NEW_LABEL').reload();
        });
    };

    /*************************************************************************
     * Called by action event
     * @param args
     *************************************************************************/
    this.newCommentActionEventSaveNewComment = function(args){
        saveComment(args);
    };

    this.newCommentActionEventSave = function(args){
        CommentService.saveComment(getWidgetNewComment(), closePopupAndReloadCommentWidgets, reopenIssue);
    };

    this.newCommentGridActionEventSave = function(args){
        CommentService.saveComment(getWidgetNewCommentGrid(), closePopupAndReloadCommentWidgetsForGrid, reopenIssueForGrid);

    };

    /*************************************************************************
     * Removes the current logged user from a resource list.
     *************************************************************************/
    var removeCurrentResourceFromResourceList = function(filtered, resourceList, currentUser, property){
        property = property || false;

        if(property){
            resourceList.forEach(function(res){
                if(Number(res[property]) !== currentUser){
                    filtered.push(Number(res[property]));
                }
            });
        } else {
            resourceList.forEach(function(res){
                if(Number(res) !== currentUser){
                    filtered.push(Number(res));
                }
            });
        }

        return filtered;
    };

    var closePopupAndReloadCommentWidgets = function() {
        ScreenService.closePopup(true);
        templateManager.container.getWidget('COMMENTS').reload();
        templateManager.container.getWidget('NEW_COMMENT').reload();
    };

    var closePopupAndReloadCommentWidgetsForGrid = function() {
        ScreenService.closePopup();
        getWidgetCommentsGrid().reload();
        getWidgetNewCommentGrid().reload();
    };

    /*************************************************************************
     * Saves a new issue comment
     * @param args
     *************************************************************************/
    var saveComment = function(args){
        if(args.owner.widget.isValid()) {
            args.owner.widget.saveRow().then(function () {
                if (args.owner.widget.currentRow.calledByReopenIssue) {
                    reopenIssue().then(function () {
                        closePopupAndReloadCommentWidgets();
                        getWidgetIssuesMain().activate();
                    });
                } else {
                    closePopupAndReloadCommentWidgets();
                }
                self.viewComments();
            });
        } else {
            ScreenService.showMessage(Messages.ERR_REQUIRED_FIELDS, 'ERROR');
        }
    };

    this.addComment = function(args, calledByReopenIssue){
        var newCommentWidget;
        if(args.owner.widget == getWidgetComments()) {
            newCommentWidget = getWidgetNewComment();
        }else {
            newCommentWidget = getWidgetNewCommentGrid();
        }
        newCommentWidget.dataSource.data = [];
        newCommentWidget.newRow();
        newCommentWidget.list();
        newCommentWidget.currentRow.TASK = getLocalVar('issue')[0];
        newCommentWidget.currentRow.calledByReopenIssue = calledByReopenIssue;
        ScreenService.openPopup(newCommentWidget);
    };

    this.styles = function(element,row){
        element.find(".kanban-task-ribbon").css("background-color", row.COLOR);
        element.find(".kanban-task-ribbon .before").css("border-top-color", row.COLOR);
        element.find(".kanban-task-ribbon .after").css("border-right-color", row.COLOR);
    };

    this.deleteIssueEdit = function(widget){
        ScreenService.confirmMessage('Deseja apagar essa issue?',null,function() {
            widget.dataSource.remove([widget.currentRow]).then(function(){
                widget.container.getWidget('MY_ISSUES_TABBED').currentWidget.reload().then(function(){
                    templateManager.updateTemplate();
                });
                ScreenService.notificationMessage('Issue apagada');
                ScreenService.closeSwipe();
            }).catch(function(erro){
                if(erro.data.error){
                    ScreenService.showMessage(erro.data.error.split(':')[1]);
                }
            });
        });
    };

    var getWidgetCreateTaskIssue = function(){
        return templateManager.container.getWidget('CREATE_TASK_ISSUE');
    };

    var getFieldIssuesFromWidgetCreateTaskIssue = function(){
        return getWidgetCreateTaskIssue().getField('ISSUES');
    };

    this.issuesMainActionEventNewTasks = function(args) {
        getWidgetCreateTaskIssue().newRow();
        Utilities.localVar.setProjectInIssue(0);

        ScreenService.openPopup(getWidgetCreateTaskIssue());
        var issues = getIssueMainWidget().dataSource.checkedRows;
        getFieldIssuesFromWidgetCreateTaskIssue().dataSource.data = issues;
        var issuesCurrent=[];
        issues.forEach(function(issue){
           issuesCurrent.push(issue.id);
        });
        getFieldIssuesFromWidgetCreateTaskIssue().value(issuesCurrent);

    };

    /**
     * Called by field event.
     * @param args
     */
    this.createTaskIssueFieldOnChangeProject = function(args) {
        var currentRow = getWidgetCreateTaskIssue().currentRow;
        Utilities.localVar.setProjectInIssue(currentRow.PROJECT);
        Utilities.clearCurrentRowProperties(currentRow, ['PARENT', 'PARENT_NAME', 'RESOURCES_NAMES']);
        Utilities.clearAndReloadWidgetFieldsValues(getWidgetCreateTaskIssue(), ['PARENT', 'PARENT_NAME', 'RESOURCES_NAMES']);
    };

    /**
     * Called by action event.
     */
    this.createTaskIssueActionEventCreate = function() {
        var widget = getWidgetCreateTaskIssue();
        if(widget.isValid()){
            var row = Utilities.getWidgetCurrentRowAsChanged(getWidgetCreateTaskIssue());
            requestDataSourceEngine.setDataSource('/createTasksByIssues',[row]).then(function(){
                getIssueMainWidget().reload();
                getIssueMainWidget().activate();
                ScreenService.closePopup(true);
            }).catch(function(response){
                Utilities.showMessageErrorOfBackEnd(response,null,null,true);
            });
        }
    };

    this.createTaskIssueActionEventBack = function() {
        ScreenService.closePopup(true);
        getIssueMainWidget().activate();
    };

    this.onSaveIssue = function(widget){
        if(!widget.currentRow.BOARD){
            widget.currentRow.BOARD = getLocalVar('product');
        }
        if(widget.isValid()){
            widget.saveRow().then(function(){
                widget.reload();
                widget.container.getWidget('ISSUES_MAIN').reload().then(function(){
                    self.onBack(widget);
                });
            });
        }
    };

    this.issuesMainKanbanOnTaskClick = function(args){};

    this.issueMainWidgetOnEnter = function(args){
        reloadBasicIssueInformationWidget(args.owner);
    };
    var __goBackInTabbedIssue = function(){
        ScreenService.closeSwipe().then(function(){
            getCurrentWidgetTabbedBoardIssue().activate();
        });
    };
    var reloadBasicIssueInformationWidget = function(widget){
        return widget.reload();
    };

	/************************************************************
	 * Called by widget event
	 * @param: args
	 ************************************************************/
	this.newTaskWidgetOnEnter = function(args){
		setTaskStatusFieldDefaultValue(args.owner);
	};

    /***********************************************************************
     * Called by widget event.
     ***********************************************************************/
    this.issueLogWidgetOnEnterTab = function(args){
        reloadField(args.owner);
    };

    /***********************************************************************
     * Reloads a field dataSource.
     ***********************************************************************/
    var reloadField = function(field){
        field.reload();
    };

	/************************************************************
	 * Called by field event
	 * @param: args
	 ************************************************************/
	this.newTaskFieldOnClickTaskStatusName = function(args){
		getFieldTaskStatusNameFromWidgetNewTask().reload();
	};

    /************************************************************
     * Called by action event
     * @param: args
     * This method is similar to issueMainIssuesActionEventSave(),
     * but called from boardIssues.json. Both containers have the same
     * structure and widgets with same name, so we can not maintain
     * the patterns to name their function calls.
     ************************************************************/
    this.issueMainActionEventSave = function(args){
        _saveIssue(args.owner.widget, getWidgetIssuesMain());
    };

    /************************************************************
     * Called by action event
     * @param: args
     * This method is similar to issueMainActionEventSave(), but
     * called from issues.json. Both containers have the same
     * structure and widgets with same name, so we can not maintain
     * the patterns to name their function calls.
     ************************************************************/
    this.issueMainIssuesActionEventSave = function(args){
        _saveIssue(args.owner.widget, getWidgetIssuesMain());
    };

    this.newIssueActionEventBack = function(args){
        __goBackInTabbedIssue();
	};

    /***********************************************************************
     * Called by action event.
     * @param args
     ***********************************************************************/
    this.issueUploadActionEventBack = function(args){
        var widget = getWidgetIssueUpload();
        ScreenService.closeSwipe().then(function(){
            widget.activate();
        });
	};

    this.issueUploadActionEventCancel = function(args){
        var widget = getWidgetIssueUpload();
        ScreenService.closeSwipe();
        widget.reload();
	};

    /***********************************************************************
     * Called by action event.
     * @param args
     ***********************************************************************/
    this.commentsActionEventBack = function(args){
        var widgetMyIssuesTabbed = getWidgetMyIssuesTabbed().currentWidget;
        ScreenService.closeSwipe().then(function () {
            widgetMyIssuesTabbed.activate();
        });
	};

    /***********************************************************************
     * Called by action event.
     * @param args
     ***********************************************************************/
    this.issueMainActionEventBack = function(args){
        localStorageEngine.setLocalVar('issue', undefined);
        var widget = getWidgetIssueMain();
        this.backToKanban(widget);
	};

    this.issueMainActionEventCancel = function(args){
        var widget = getWidgetIssueMain();
        Utilities.fixBugReloadWidgetInViewMode(widget);
	};

    /***********************************************************************
     * Called by action event.
     * @param args
     ***********************************************************************/
    this.issueRelationshipActionEventBack = function(args){
        __goBackInTabbedIssue();
	};

    /***********************************************************************
     * Called by action event.
     * @param args
     ***********************************************************************/
    this.issueLogActionEventBack = function(args){
        __goBackInTabbedIssue();
    };

    /***********************************************************************
     * Sets max frame order value to widget's current row.
     ***********************************************************************/
    var setMaxFrameOrderToCurrentRow = function(widget){
        var maxFrameOrder = args.owner.widget.dataSource.data.reduce(function(acc, taskType){
            return acc < parseInt(taskType.ORDER_TO_FRAME) ? parseInt(taskType.ORDER_TO_FRAME) : acc;
        }, 0);
        widget.currentRow.ORDER_TO_FRAME = maxFrameOrder + 10;
    };

    /***********************************************************************
     * Called by action event.
     * @param args
     ***********************************************************************/
    this.issueConfigurationTabStatusActionEventAdd = function(args){
        args.owner.widget.newRow();
        setMaxFrameOrderToCurrentRow(args.owner.widget);
    };

    /***********************************************************************
     * Sets the default classification that comes from issue in the new task
     * field.
     ***********************************************************************/
    var __setClassificationInNewTask = function() {
        var issueClassification = Utilities.localVar.getIssueClassification();
        var classificationField = getFieldTaskClassificationLabelFromNewTask();
        if (issueClassification) {
            classificationField.reload().then(function (){
                Utilities.setValueInSelectField(classificationField, issueClassification);
                classificationField.readOnly = true;
                classificationField.validations = false;
           });
        } else {
            Utilities.clearValueSelect(classificationField);
            classificationField.readOnly = false;
            classificationField.validations = {"required": {}};
        }
    };

    /***********************************************************************
     * Called by action event.
     * @param args
     ***********************************************************************/
    this.issueRelationshipActionEventAdd = function(args){
        this.onAddTask();
        getWidgetNewTask().lastSwipe = getWidgetIssueRelationship();
    };

	/************************************************************
     *
	 * When user tries to create a new task from relationships,
	 * the field Status (Situação) receives the initial task
	 * status (name and id).
	 * @param: widget
	 ************************************************************/
	var setTaskStatusFieldDefaultValue = function(widget){
		var initialName = localStorageEngine.getLocalVar('taskParameters').INITIAL_TASK_STATUS_NAME;
		var initialId = localStorageEngine.getLocalVar('taskParameters').INITIAL_TASK_STATUS_ID;
		widget.currentRow.TASK_STATUS_NAME = initialName;
		widget.currentRow.TASK_STATUS = initialId;
	};

    var reopenIssue = function() {
        var issue = localStorageEngine.getLocalVar('issue');
        return TaskService.reopenIssue(issue).then(function (data) {
            var issueMainWidget = getIssueMainWidget();
            return issueMainWidget.reload().then(function () {
                ScreenService.closeSwipe();
                issueMainWidget.activate();
                return data;
            });
        });
    };

    var reopenIssueForGrid = function() {
        var issue = localStorageEngine.getLocalVar('issue');
        return TaskService.reopenIssue(issue).then(function (data) {
            var issueMainWidget = getIssueMainGridWidget();
            return issueMainWidget.reload().then(function () {
                ScreenService.closeSwipe();
                issueMainWidget.activate();
                return data;
            });
        });
    };

    /**
     * Called by action event.
     * @param args
     */
    this.issueMainActionEventReopenIssue = function(args) {
        ScreenService.confirmMessage(Messages.ALE_REOPEN_ISSUE, 'CONFIRMATION', function () {
            self.addComment(null, true);
        });
    };

    /**
     * Saves selected project id in local storage.
     * @param field
     */
    var saveSelectedProjectIdInLocalStorage = function(field){
        Utilities.localVar.setProject(parseInt(field.value()));
    };

    /**
     * Called by field event.
     * @param args 
     */
    this.createTaskIssueFieldOnClickResourcesNames = function(args){
        reloadField(getFieldResourcesNamesFromWidgetCreateIssueTask());
    };


    this.newTaskResourceFieldBeforeSelectOpen = function(args){
        getFieldResourceFromWidgetNewTask().reload();
    };
}

Configuration(function(ContextRegister) {
	ContextRegister.register('IssueTracker', IssueTracker);
});


// FILE: assets/js/Controller/Issues.js
function IssuesController(ScreenService, templateManager, IssueService, Utilities, FilterService, ZhFilterPreferences,
                          localStorageEngine, requestDataSourceEngine, ProjectServiceList, TaskService, CommentService){

    var CONTROL_TASK_TYPE_HOMOLOGATED = 'H';
    var DEFAULT_STATUS = 'B';
    var INITIAL_STATUS = 'N';
    var CONTROL_TASK_TYPE_BACKLOG = 'B';

    var self = this;

    var RESOURCE_STATUS_ACTIVE = 'A';

    var getFieldProductNameFromWidgetIssueMain = function(){
        return getWidgetIssueMain().getField('PRODUCT_NAME');
    };

    var getFieldFollowersFromWidgetIssueMain = function(){
        return getWidgetIssueMain().getField('FOLLOWERS');
    };

    var getFieldVersionFromWidgetIssueMain = function(){
        return getWidgetIssueMain().getField('VERSION');
    };

    var getFieldResponseFromWidgetIssueMain = function () {
        return getWidgetIssueMain().getField('RESPONSE');
    };

    var getWidgetIssuesMain = function(){
        return templateManager.container.getWidget('ISSUES_MAIN');
    };

    var getWidgetIssueMain = function(){
        return templateManager.container.getWidget('ISSUE_MAIN');
    };

    var getFieldCdItemtrabFromWidgetIssueMain = function(){
        return getWidgetIssueMain().getField('CDITEMTRAB');
    };

    var getWidgetComments = function(){
        return templateManager.container.getWidget('COMMENTS');
    };

    var getWidgetDocumentsComment = function(){
        return templateManager.container.getWidget('DOCUMENTS_COMMENT');
    };

    var getWidgetIssueFilter = function(){
        return templateManager.container.getWidget('ISSUE_FILTER');
    };

    var getWidgetFollowedIssues = function(){
        return templateManager.container.getWidget('FOLLOWED_ISSUES');
    };

    var getWidgetIssueFilterFollowed = function(){
        return templateManager.container.getWidget('ISSUE_FILTER_FOLLOWED');
    };

    var getWidgetIssuesLabelsRelationship = function(){
        return templateManager.container.getWidget('ISSUES_LABELS_RELATIONSHIP');
    };

    var getFieldTaskStatusFromWidgetIssueFilter = function() {
        return getWidgetIssuesMain().getField('TASK_STATUS');
    };

    var getWidgetMyIssuesTabbed = function(){
        return templateManager.container.getWidget('MY_ISSUES_TABBED');
    };

    var getWidgetNewComment = function(){
        return templateManager.container.getWidget('NEW_COMMENT');
    };

    var getWidgetIssueUpload = function(){
        return templateManager.container.getWidget('ISSUE_UPLOAD');
    };

    var getWidgetClientAccept = function(){
        return templateManager.container.getWidget('CLIENT_ACCEPT');
    };

    var getWidgetClientRefuse = function(){
        return templateManager.container.getWidget('CLIENT_REFUSE');
    };

    var getWidgetNewIssue = function(){
        return templateManager.container.getWidget('NEW_ISSUE');
    };

    var getWidgetNewIssueUpload = function(){
        return templateManager.container.getWidget('NEW_ISSUE_UPLOAD');
    };

    var getFieldLabelsFromNewIssueWidget = function(){
        return getWidgetNewIssue().getField('LABELS');
    };

    var getFieldDocumentFromNewCommentWidget =  function(){
        return getWidgetNewComment().getField('DOCUMENT');
    };

    var getFieldReporterNameFromNewIssueWidget =  function(){
        return getWidgetNewIssue().getField('REPORTER_NAME');
    };

    var getFieldSponsorNameFromNewIssueWidget =  function(){
        return getWidgetNewIssue().getField('SPONSOR');
    };

    var getFieldProductNameFromNewIssueWidget =  function(){
        return getWidgetNewIssue().getField('PRODUCT_NAME');
    };

    var getFieldVersionFromNewIssueWidget = function () {
        return getWidgetNewIssue().getField('VERSION');
    };

    var getLabelsFieldFromIssuesLabelsRelationshipWidget = function(){
        return getWidgetIssuesLabelsRelationship().getField('LABELS');
    };

    var getFieldFramingFromIssueMainWidget = function(){
        return getWidgetIssuesMain().getField('FRAMING');
    };

    var getActionClientAcceptFromIssueMainWidget = function(){
        return getWidgetIssueMain().getAction('CLIENT_ACCEPT');
    };

    var getActionClientRefuseFromIssueMainWidget = function(){
        return getWidgetIssueMain().getAction('CLIENT_REFUSE');
    };

    var getFieldDocumentFromClientAccept = function(){
        return getWidgetClientAccept().getField('DOCUMENT');
    };

    var getFieldLabelsFromIssueMainWidget = function(){
        return getWidgetIssueMain().getField('LABELS');
    };

    var getIssuesFieldFromIssuesLabelsRelationshipWidget = function(){
        return getWidgetIssuesLabelsRelationship().getField('ISSUES');
    };

    var getIssueMainWidget = function() {
    	return templateManager.container.getWidget('ISSUES_MAIN');
    };

    var getFieldTaskStatusFromWidgetFollowedIssueFilter = function() {
        return getWidgetFollowedIssues().getField('TASK_STATUS');
    };

    this.initializeFieldFromWidgetNewIssue = function (fieldName) {
        var field = getWidgetNewIssue().getField(fieldName);
        field.initializeField();
    };

    this.issuesMainActionEventMarkAsRead = function(args){
        if(getWidgetIssuesMain().hasCheckedRows()) {
            markSelectedIssuesAsRead(getWidgetIssuesMain().dataSource.checkedRows);
        } else {
            ScreenService.showMessage(Utilities.messages.NOT_CHECKED_ROW_ISSUE);
        }
    };

    this.followedIssuesActionEventMarkAsRead = function(args){
        markSelectedIssuesAsRead(getWidgetFollowedIssues().dataSource.checkedRows);
    };

    this.issuesLabelsRelationshipActionEventCancel = function(args){
        backToWidgetClosingPopup(getWidgetIssuesMain());
    };

    var backToWidgetClosingPopup = function(widget){
        ScreenService.closePopup();
        widget.activate();
    };

    var getNewLabelWidget = function(){
        return templateManager.container.getWidget('NEW_LABEL');
    };

    this.newLabelActionEventSave = function(args){
        var widget = args.owner.widget;
        if( ! widget.isValid()){
            ScreenService(Utilities.messages.ERR_REQUIRED_FIELDS);
            return false;
        }
        createLabel();
    };

    var createLabel = function(){
        var newLabelWidget = getNewLabelWidget();
        newLabelWidget.IS_PROJECT = 'N';
        newLabelWidget.saveRow().then(function(){
            ScreenService.closePopup();
            getFieldLabelsFromNewIssueWidget().reload();
            getFieldLabelsFromIssueMainWidget().reload();
        });
    };

    this.issueMainFieldOnAddLabels = function(args){
        var widget = getNewLabelWidget();
        widget.newRow();
        ScreenService.openPopup(widget);
    };

    this.newLabelActionEventBack = function(){
        ScreenService.closePopup();
    };

    this.issueMainFieldOnClickLabels = function(args){
        var field = args.owner.field;
        field.reload();
    };

    this.issuesLabelsRelationshipActionEventSave = function(args){
        var widget = args.owner.widget;
        if(widget.isValid()) {
            sendIssuesAndLabelsToRelationship();
        }
    };

    this.issueMainFieldOnChangeProduct = function () {
        var versionField = getFieldVersionFromWidgetIssueMain();
        var widget = getWidgetIssueMain();
        widget.currentRow.VERSION = '';
        widget.currentRow. VERSION_DEV = '';
        widget.currentRow.PRODUCT_VERSION_ID = '';
        widget.currentRow. PRODUCT_VERSION_DEV_ID = '';
        localStorageEngine.setLocalVar('PROJECT_ID', widget.currentRow.PRODUCT);
        versionField.reload();

    };

    var sendIssuesAndLabelsToRelationship = function(){
        var selectedIssues = getIssuesFieldFromIssuesLabelsRelationshipWidget().value();
        var selectedLabels = getLabelsFieldFromIssuesLabelsRelationshipWidget().value();
        ScreenService.showLoader();
        IssueService.sendIssuesAndLabelsToRelationship(selectedIssues, selectedLabels).then(function(successful) {
            ScreenService.hideLoader();
            var issuesMainWidget = getWidgetIssuesMain();
            ScreenService.closePopup(true);
            issuesMainWidget.reload();
            issuesMainWidget.activate();
            issuesMainWidget.dataSource.updateCheckedRows();
        }).catch(ScreenService.hideLoader);
    };

    this.issuesMainActionEventApplyLabels = function(args){
        if(getWidgetIssuesMain().hasCheckedRows()) {
            applySelectedIssuesToIssuesField();
            ScreenService.openPopup(getWidgetIssuesLabelsRelationship());
        }else{
            ScreenService.showMessage(Utilities.messages.NOT_CHECKED_ROW_ISSUE);
        }
    };

    this.issuesMainWidgetAfterLoadDataSource = function(args){
        var widget = getIssueMainWidget();
        var movable = false;
		var alreadyColumned;
		var filter;
		widget.dataSource.data.forEach(function(item, index, dataSource){
			filter = {
				'column': parseInt(item.column),
                'label' : item.columnLabel
			};
			alreadyColumned = widget.columns.filter(isThisColumn, filter);
			if(!alreadyColumned.length){
				widget.columns.push({
					'id': parseInt(item.column),
					'label': item.columnLabel
				});
			}
			dataSource[index].movable = movable;
		});
		Utilities.reloadTaskTypes(widget);
	};

    this.issueFilterActionEventFilter = function(args){
        var widget = getWidgetIssueFilter();
        var parentWidget = getWidgetIssuesMain();
        FilterService.parentFilter(parentWidget, widget);
        ScreenService.closePopup();
        parentWidget.activate();
    };

    this.issueFilterFollowedActionEventFilter = function(args){
        var widget = getWidgetIssueFilterFollowed();
        var parentWidget = getWidgetFollowedIssues();
        FilterService.parentFilter(parentWidget, widget);
        ScreenService.closePopup();
        parentWidget.activate();
    };

    this.issueMainActionEventReopenIssue = function(args) {
        ScreenService.confirmMessage(Utilities.messages.ALE_REOPEN_ISSUE, 'CONFIRMATION', function () {
            ScreenService.showLoader();
            IssueService.findCommentTypeByControl("R").then(function(commentType) {
                ScreenService.hideLoader();
                var commentTypeId = commentType ? commentType.ID : 0;
                var commentDescription = commentType ? commentType.COMMENT_DESCRIPTION : null;
                self.addComment(null, true, commentTypeId, commentDescription);
            }).catch(ScreenService.hideLoader);
        });
    };

    this.commentsActionEventAddComments = function(args) {
        widget = getWidgetIssueMain();
        if (widget.currentRow.FINISHED === 'Y') {
            ScreenService.showMessage(Utilities.messages.ERR_COMMENT_CLOSED);
        } else {
            ScreenService.showLoader();
            IssueService.findCommentTypeByControl("C").then(function(commentType){
                ScreenService.hideLoader();
                var commentTypeId = commentType ? commentType.ID : 0;
                var commentDescription = commentType ? commentType.COMMENT_DESCRIPTION : null;
                getFieldDocumentFromNewCommentWidget().validations = commentType && commentType.ATTACHMENT_REQUIRED == 'Y' ? {"required": {}} : {};
                self.addComment(null, false, commentTypeId,commentDescription);
            }).catch(ScreenService.hideLoader);
        }
    };

	var isIssueMainCurrentWidget = function(){
		var currentActiveWidget = templateManager.container.getActiveWidget();
		var issueMainWidget = templateManager.container.getWidget('ISSUE_MAIN');
		return currentActiveWidget == issueMainWidget;
	};

	var hideConcludeActionIfResourceIsNotReporter = function(widget){
        var currLoggedUserId    = Number(Utilities.localVar.getLocalVarIdBusinessPartner());
        var issueReporterId     = Number(widget.currentRow.REPORTER);
        var issueReporterStatus = widget.currentRow.REPORTER_STATUS;
        var closeIssueAction = getWidgetIssueMain().getAction('CLOSE_ISSUE');
        if(typeof closeIssueAction !== "undefined")
            closeIssueAction.isVisible = closeIssueAction.isVisible && (currLoggedUserId === issueReporterId || issueReporterStatus !== RESOURCE_STATUS_ACTIVE);
    };

	var showActionClientAccept = function(widget){
        var currLoggedUserId    = Number(Utilities.localVar.getLocalVarIdBusinessPartner());
        var issueReporterId     = Number(widget.currentRow.REPORTER);
        var clientAccept = widget.currentRow.CLIENT_ACCEPT;
        var clientAcceptAction = getActionClientAcceptFromIssueMainWidget();
        var clientRefuseAction = getActionClientRefuseFromIssueMainWidget();
        if(typeof clientAcceptAction !== "undefined")
            clientAcceptAction.isVisible = currLoggedUserId === issueReporterId && clientAccept;
        if(typeof clientRefuseAction !== "undefined")
            clientRefuseAction.isVisible = currLoggedUserId === issueReporterId && clientAccept;
    };

    var isCurrentUserIssueReporter = function(reporterId){
        var userId = Number(Utilities.localVar.getLocalVarIdBusinessPartner());
        reporterId = Number(reporterId);
        return userId == reporterId;
    };

    var isStatusActive = function(userStatus){
        return userStatus == RESOURCE_STATUS_ACTIVE;
    };

    var disableReporterFieldEditingIfResourceIsNotReporter = function(widget){
        var issueReporterId     = Number(widget.currentRow.REPORTER);
        var issueReporterStatus = widget.currentRow.REPORTER_STATUS;
        var reporterField       = getWidgetIssueMain().getField('REPORTER_NAME');
        reporterField.readOnly  = ( ! isCurrentUserIssueReporter(issueReporterId) && isStatusActive(issueReporterStatus));
    };

    this.issueMainActionEventCancel = function(args){
        var widget = getWidgetIssueMain();
        Utilities.fixBugReloadWidgetInViewMode(widget);
	};

    this.issuesMainActionEventClientAccept = function(){
        ScreenService.showLoader();
        IssueService.findCommentTypeByControl("A").then(function(commentType) {
            ScreenService.hideLoader();
            var commentTypeId = commentType ? commentType.ID : 0;
            var commentDescription = commentType ? commentType.COMMENT_DESCRIPTION : null;
            if(commentTypeId) {
                var widget = getWidgetClientAccept();
                widget.dataSource.data = [];
                widget.newRow();
                widget.currentRow.COMMENT_TYPE_ID = commentTypeId;
                getFieldDocumentFromClientAccept().validations = commentType.ATTACHMENT_REQUIRED == 'Y' ? {"required": {}} : {};
                widget.currentRow.DESCRIPTION = commentDescription;
                widget.currentRow.ISSUE_ID = getWidgetIssueMain().currentRow.ID;
                ScreenService.openPopup(widget);
            } else {
                ScreenService.showMessage(Utilities.messages.ERR_TYPE_COMMENT_ACCEPT);
            }
        }).catch(ScreenService.hideLoader);
    };

    this.issuesMainActionEventClientRefuse = function(){
        ScreenService.showLoader();
        IssueService.findCommentTypeByControl("R").then(function(commentType) {
            ScreenService.hideLoader();
            var commentTypeId = commentType ? commentType.ID : 0;
            var commentDescription = commentType ? commentType.COMMENT_DESCRIPTION : null;
            if(commentTypeId){
                var widget = getWidgetClientRefuse();
                widget.dataSource.data = [];
                widget.newRow();
                widget.currentRow.COMMENT_TYPE_ID = commentTypeId;
                getFieldDocumentFromClientAccept().validations = commentType.ATTACHMENT_REQUIRED == 'Y' ? {"required": {}} : {};
                widget.currentRow.DESCRIPTION = commentDescription;
                widget.currentRow.ISSUE_ID = getWidgetIssueMain().currentRow.ID;
                ScreenService.openPopup(widget);
            }else{
                ScreenService.showMessage(Utilities.messages.ERR_TYPE_COMMENT_ACCEPT);
            }
        }).catch(ScreenService.hideLoader);
    };

    this.clientAcceptActionEventBack = function(){
        ScreenService.closePopup();
        getWidgetIssueMain().activate();
    };

    this.clientAcceptActionEventClientAccept = function(args){
        var widget = getWidgetClientAccept();
        if(widget.isValid()){
            ScreenService.confirmMessage(Utilities.messages.ALE_CLIENT_ACCEPT, 'CONFIRMATION',function(){
                IssueService.clientAccept(widget.currentRow).then(function(){
                    var issueMainWidget = getIssueMainWidget();
                    ScreenService.closePopup(true);
                    ScreenService.closeSwipe();
                    issueMainWidget.reload();
                    issueMainWidget.activate();
                });
            });
        }
	};

	this.clientAcceptActionEventClientRefuse = function(args){
        var widget = getWidgetClientRefuse();
        if(widget.isValid()){
            ScreenService.confirmMessage(Utilities.messages.ALE_CLIENT_REFUSE, 'CONFIRMATION',function(){
                IssueService.clientRefuse(widget.currentRow).then(function(){
                    var issueMainWidget = getIssueMainWidget();
                    ScreenService.closePopup(true);
                    ScreenService.closeSwipe();
                    issueMainWidget.reload();
                    issueMainWidget.activate();
                });
            });
        }
	};

    this.issueMainWidgetAfterLoadDataSource = function(args){
		if( ! isIssueMainCurrentWidget()){
			return false;
		}

		var issueMainWidget = args.owner;
		issueMainWidget.view();
		issueMainWidget.template = issueMainWidget.formTemplate;
		issueMainWidget.moveToFirst();
		hideConcludeActionIfResourceIsNotReporter(issueMainWidget);
		showActionClientAccept(issueMainWidget);
		disableReporterFieldEditingIfResourceIsNotReporter(issueMainWidget);
        var fieldFollowers = getFieldFollowersFromWidgetIssueMain();
        Utilities.bugPaginationOnSelectMultiplyOnModeView(fieldFollowers);
        Utilities.bugPaginationOnSelectMultiplyOnModeView(getFieldCdItemtrabFromWidgetIssueMain());

        var versionDev = issueMainWidget.currentRow.VERSION_DEV.split('.');
        localStorageEngine.setLocalVar('PROJECT_ID', issueMainWidget.currentRow.PRODUCT);
        localStorageEngine.setLocalVar('VERSION', versionDev[0]);
        localStorageEngine.setLocalVar('REVISION', versionDev[1]);

        if (issueMainWidget.currentRow.GENERATED_TASK == 'Y') {
            getFieldVersionFromWidgetIssueMain().readOnly = true;
            if (issueMainWidget.currentRow.PRODUCT_VERSION_ID || issueMainWidget.currentRow.PRODUCT_VERSION_DEV_ID) {
                getFieldProductNameFromWidgetIssueMain().readOnly = true;
            } else {
                getFieldProductNameFromWidgetIssueMain().readOnly = false;
            }
        } else {
            getFieldVersionFromWidgetIssueMain().readOnly = false;
            getFieldProductNameFromWidgetIssueMain().readOnly = false;
        }
	};

    var buildColumnsInWidget = function(widget){
        widget.columns = widget.columns || [];
		var alreadyColumned;
		var filter;
		widget.dataSource.data.forEach(function(item, index, dataSource){
			filter = {
				'column': parseInt(item.column),
                'label' : item.columnLabel
			};
			alreadyColumned = widget.columns.filter(isThisColumn, filter);
			if(!alreadyColumned.length){
				widget.columns.push({
					'id': parseInt(item.column),
					'label': item.columnLabel
				});
			}
			dataSource[index].movable = false;
		});
    };

    this.issuesMainGridFilterBeforeApply = function(args){
        Utilities.setFilterInit(getWidgetIssuesMain());
        Utilities.reloadTaskTypes(getWidgetIssuesMain());
    };

    this.followedIssuesGridFilterBeforeApply = function(args){
        Utilities.setFilterInit(getWidgetFollowedIssues());
        Utilities.reloadTaskTypes(getWidgetFollowedIssues());
    };

	var isThisColumn = function(column){
		return column.id === this.column && column.label == this.label;
	};

    this.followedIssuesWidgetOnEnter = function(args) {
        localStorageEngine.setLocalVar('ACTUAL_WIDGET', getWidgetFollowedIssues());
        ScreenService.showLoader();
        Utilities.localVar.getLoginPromise().then(function(){
            ScreenService.hideLoader();
            var issueFollowedWidget = getWidgetFollowedIssues();
            getWidgetMyIssuesTabbed().currentWidget.activate().then(function(){
                issueCurrent = null;
                if(Utilities.isAppliedFilter(issueFollowedWidget)) {
                    issueFollowedWidget.reload();
                } else {
                    var taskStatusFollowedField = getFieldTaskStatusFromWidgetFollowedIssueFilter();
                    taskStatusFollowedField.reload();
                    ZhFilterPreferences.setOriginalFilter(issueFollowedWidget.id, issueFollowedWidget.currentRow);
                    Utilities.applyDefaultFilterOnEnter(issueFollowedWidget);
                }
            });
        }).catch(ScreenService.hideLoader);
	};

    this.addComment = function(args, calledByReopenIssue,commentTypeId,commentDescription){
        commentTypeId = commentTypeId ? commentTypeId : 0;
        var newCommentWidget = getWidgetNewComment();
        newCommentWidget.dataSource.data = [];
        newCommentWidget.newRow();
        newCommentWidget.list();
        newCommentWidget.currentRow.COMMENT_TYPE_ID = commentTypeId;
        newCommentWidget.currentRow.TASK = getLocalVar('issue')[0];
        newCommentWidget.currentRow.calledByReopenIssue = calledByReopenIssue;
        newCommentWidget.currentRow.DESCRIPTION = commentDescription;
        ScreenService.openPopup(newCommentWidget);
    };

    this.issueUploadWidgetOnEnterTab = function(args){
        getWidgetIssueUpload().reload();
    };

    this.commentsWidgetOnEnterTab = function(args){
        getWidgetComments().reload();
        self.viewComments();
    };

    this.commentsWidgetAfterMoveRow = function(args){
        var currentRow = getWidgetComments().currentRow;
        Utilities.localVar.setComment(currentRow.ID);
        getWidgetDocumentsComment().reload();
    };

    this.viewComments = function(){
        var row = {};
        var issue = localStorageEngine.getLocalVar('issue');
        row.ISSUE = Array.isArray(issue)? issue[0]:issue;
        row.changed = true;
        requestDataSourceEngine.setDataSource('/viewComments', [row], undefined, undefined, undefined, undefined, true).then(function(response){
            if(Array.isArray(response)){
                localStorageEngine.setLocalVar('lastDateViewComments', null);
            }else{
                localStorageEngine.setLocalVar('lastDateViewComments', response.dataset.lastDate[0]);
            }
        });
    };

    this.issuesMainWidgetOnEnterOnce = function(){
        Utilities.reloadTaskTypes(getWidgetIssuesMain()).then(function(){
            buildColumnsInWidget(getWidgetIssuesMain());
		});
    };

    this.followedIssuesWidgetOnEnterOnce = function(args){
        Utilities.reloadTaskTypes(getWidgetFollowedIssues()).then(function(){
            buildColumnsInWidget(getWidgetFollowedIssues());
		});
    };

    this.issuesMainWidgetOnEnterTab = function(argsOwner){
        self.onEnterIssuesMain(argsOwner);
    };

    var issueCurrent = null;

    this.validateExistsBacklogControlTaskType = function() {
        var filter =  [ {
            'name': 'CONTROL',
            'operator': '=',
            'value': Utilities.constants.CONTROL_TASK_TYPE_BACKLOG
        } ];

        requestDataSourceEngine.getDataSource('/taskType', filter).then(function(data) {
            if(data.dataset.taskType.length > 0) {
                localStorageEngine.setLocalVar('EXISTS_BACKLOG_CONTROL', true);
            } else {
                localStorageEngine.setLocalVar('EXISTS_BACKLOG_CONTROL', false);
            }
        });
    };

    var setDefaultFilterWidgetIssuesMain = function(){
        var filterByDashboard   = Utilities.localVar.getFilterByDashboard();
        var taskStatusField     = getFieldTaskStatusFromWidgetIssueFilter();
        var framingField        = getFieldFramingFromIssueMainWidget();
        var taskParameters      = Utilities.localVar.getTaskParameters();
        var valueParameterFinal = taskParameters ? taskParameters.FINAL_TASK_STATUS_ID : 0;

        if(filterByDashboard && filterByDashboard.hasOwnProperty('issues')){
             return taskStatusField.reload().then(function(){
                 taskStatusField.value(filterByDashboard.issues);
                 framingField.value(filterByDashboard.framing);
             });
         } else {
             return Utilities.setDefaultValueToSelectMultipleFieldFilteringData(
                 taskStatusField, [valueParameterFinal], 'ID', 'ID'
             );
         }
    };

    this.onEnterIssuesMain = function(widget){
        localStorageEngine.setLocalVar('ACTUAL_WIDGET', getWidgetIssuesMain());
        getWidgetMyIssuesTabbed().currentWidget.activate().then(function(){
    		self.validateExistsBacklogControlTaskType();
            var filterByDashboard = Utilities.localVar.getFilterByDashboard();
            var taskStatusField   = getFieldTaskStatusFromWidgetIssueFilter();
            var framingField      = getFieldFramingFromIssueMainWidget();
            var issuesMainWidget  = getWidgetIssuesMain();
            var issue = Utilities.localVar.getIssue() ? Utilities.localVar.getIssue() : null;
            var lastWindow = Utilities.localVar.getLastWindow() ? Utilities.localVar.getLastWindow() : null;
            if(lastWindow === 'unreadComments' && issue){
                var tabbedWidget    = widget.container.getWidget('TABBED_ISSUE');
                var issueMainWidget = getWidgetIssueMain();
                Utilities.localVar.setIssue(issue[0]);
                ScreenService.showLoader();
                issueMainWidget.list();
                issueMainWidget.reload().then(function() {
                    issueMainWidget.moveToFirst();
                    issueMainWidget.view();
                    ScreenService.hideLoader();
                    ScreenService.openSwipe(tabbedWidget).then(function() {
                        widget.currentRow.ISSUE_ID    = issue[0];
                        widget.currentRow.TASK_STATUS = [];
                        ZhFilterPreferences.setOriginalFilter(widget.id, widget.currentRow);
                        Utilities.startFilter(widget, widget.currentRow, true);
                    }).catch(ScreenService.hideLoader);
                }).catch(ScreenService.hideLoader);
            } else if (filterByDashboard && filterByDashboard.hasOwnProperty('issues')){
                taskStatusField.value(filterByDashboard.issues);
                framingField.value(filterByDashboard.framing);
                ZhFilterPreferences.setOriginalFilter(issuesMainWidget.id, issuesMainWidget.currentRow);
                ZhFilterPreferences.applyOriginalFilter(issuesMainWidget);
            } else if(issuesMainWidget.appliedFilter) {
                issuesMainWidget.reload();
            } else {
                ScreenService.showLoader();
                Utilities.localVar.getLoginPromise().then(function () {
                    setDefaultFilterWidgetIssuesMain().then(function(){
                        ScreenService.hideLoader();
                        ZhFilterPreferences.setOriginalFilter(issuesMainWidget.id, issuesMainWidget.currentRow);
                        Utilities.applyDefaultFilterOnEnter(issuesMainWidget, true);
                    }).catch(ScreenService.hideLoader);
                }).catch(ScreenService.hideLoader);
            }
    		Utilities.localVar.setLastWindow("issues");
            issueCurrent = null;
        });
	};

	this.issueUploadActionEventDeleteDocuments = function(args){
	    var widget = getWidgetIssueUpload();
        var currentRow = [widget.currentRow];
		ScreenService.confirmMessage(Utilities.messages.ALE_DELETE_DOCUMENT, null, function(){
			ProjectServiceList.deleteAttachment(currentRow).then(function(data){
			    ScreenService.successNotification(data.notifications[0].message);
                ScreenService.closeSwipe().then(function(){
                    widget.list();
                    widget.reload();
                });
			});
		}, null);
	};

	this.followedIssuesKanbanOnTaskClick = function(args){
	    self.onClickIssue(args.owner.container, args.e.item);
	};

	this.issuesMainKanbanOnTaskClick = function(args){
	    self.onClickIssue(args.owner.container, args.e.item);
	};

	this.onClickIssue = function(container, currentRow) {
        var issueMainWidget = container.getWidget('ISSUE_MAIN');
        var tabbedWidget = container.getWidget('TABBED_ISSUE');
        var uploadWidget = container.getWidget('ISSUE_UPLOAD');

        getFieldResponseFromWidgetIssueMain().isVisible = (currentRow.CONTROL_TASK_TYPE == 'H' || currentRow.columnType == 'H');
        ScreenService.openSwipe(tabbedWidget);
        getWidgetIssuesMain().descriptionOrder = currentRow.ISSUE_ID +" - "+ currentRow.NAME;
        var permissiveActionsShowing = getWidgetMyIssuesTabbed().currentWidget.name !== 'FOLLOWED_ISSUES';
        var actionEdit = issueMainWidget.getAction('EDIT');
        if (actionEdit) {
            actionEdit.isVisible = permissiveActionsShowing;
            issueMainWidget.getAction('DELETE').isVisible = permissiveActionsShowing;
            uploadWidget.getAction('ADD_DOCUMENTS').isVisible = permissiveActionsShowing;
            uploadWidget.getAction('DELETE_DOCUMENTS').isVisible = permissiveActionsShowing;
        }

        var taskParameters = localStorageEngine.getLocalVar('taskParameters');
        var finalTaskStatus = taskParameters.FINAL_TASK_STATUS_ID;
        var closeIssueAction = issueMainWidget.getAction('CLOSE_ISSUE');
        if (typeof closeIssueAction !== "undefined") {
            closeIssueAction.isVisible = (currentRow.ALLOW_CLOSE_ISSUE === 'Y') && (currentRow.TASK_STATUS != finalTaskStatus);
        }

        var reopenIssueAction = issueMainWidget.getAction('REOPEN_ISSUE');
        if (typeof reopenIssueAction !== "undefined") {
            reopenIssueAction.isVisible = (currentRow.CONTROL_TASK_TYPE == CONTROL_TASK_TYPE_HOMOLOGATED) &&
                                          (localStorageEngine.getLocalVar('EXISTS_BACKLOG_CONTROL')) &&
                                          (currentRow.TASK_STATUS != finalTaskStatus);
        }

		localStorageEngine.setLocalVar('issue', [currentRow.id]);
        issueCurrent = currentRow;
		if(tabbedWidget.currentWidget){
	        Utilities.fixBugReloadWidgetInViewMode(issueMainWidget);
		    if (tabbedWidget.currentWidget != issueMainWidget) {
		        tabbedWidget.currentWidget.reload();
		        if(tabbedWidget.currentWidget.name == 'COMMENTS') {
                    this.viewComments();
                }
		    }
		} else {
		    ScreenService.showLoader();
			tabbedWidget.widgets[0].reload().then(function () {
			    ScreenService.hideLoader();
			}).catch(ScreenService.hideLoader);
		}

        var fieldLabels = issueMainWidget.getField('LABELS');

        if(fieldLabels) {
            fieldLabels.reload();
            fieldLabels.dataSource.clearCheckedRows();
        }
        Utilities.localVar.setIssueClassification(currentRow.issueClassification);
    };

    var applySelectedIssuesToIssuesField = function(){
        var field = getIssuesFieldFromIssuesLabelsRelationshipWidget();
        var selectedIssuesOnKanban = getWidgetIssuesMain().getCheckedRows();
        field.dataSource.data = selectedIssuesOnKanban;
        field.value(Utilities.arrayFromPropertyOfObjectList(selectedIssuesOnKanban, "id"));
    };

    var markSelectedIssuesAsRead = function(selectedIssues){
        ScreenService.showLoader();
        IssueService.markManyAsRead(selectedIssues).then(function(res){
            ScreenService.hideLoader();
            var issuesMainWidget = getWidgetIssuesMain();
            ScreenService.closePopup(true);
            issuesMainWidget.reload();
            issuesMainWidget.activate();
            issuesMainWidget.dataSource.updateCheckedRows();
        }).catch(ScreenService.hideLoader);
    };

    this.issueUploadActionEventBack = function(args) {
        ScreenService.closeSwipe().then(function () {
            getWidgetMyIssuesTabbed().currentWidget.activate();
        });
    };

    this.issueUploadActionEventCancel = function(args) {
        ScreenService.closeSwipe();
        getWidgetIssueUpload().reload();
    };

    this.issueUploadActionEventAddDocument = function(args) {
        var widget =  getWidgetNewIssueUpload();
        ScreenService.openPopup(widget);
        widget.newRow();
    };

    this.documentsCommentActionEventBackList = function(args) {
        ScreenService.closeSwipe();
        getWidgetComments().activate();
    };

    this.documentsCommentActionEventBackView = function(args) {
        ScreenService.closeSwipe();
        getWidgetDocumentsComment().reload();
    };

    this.commentsActionEventBackView = function(args) {
        ScreenService.closeSwipe();
        getWidgetComments().reload();
    };

    this.documentsCommentActionEventDownload = function(args) {
        Utilities.downloadAttachment(getWidgetDocumentsComment().currentRow.ID);
    };

    this.issueUploadActionEventDownload = function(args){
        var row = getWidgetIssueUpload().currentRow;
        ProjectServiceList.downLoadAttachment(row);
    };

    function isStatusDefault(status){
        return status.CONTROL === DEFAULT_STATUS;
    }

    function isStatusInitial(status){
        return status.CONTROL === INITIAL_STATUS;
    }

    this.issuesMainActionEventNewIssue = function(args) {
        var issueWidget = getWidgetNewIssue();
        ScreenService.openSwipe(issueWidget);
        issueWidget.newRow();
        issueWidget.currentRow.PRIORITY = 0;
        issueWidget.currentRow.PERCENT_COMPLETED = 0;

        issueWidget.getField('PRODUCT_NAME').reload();
        issueWidget.getField('SPONSOR').reload();
        issueWidget.getField('ISSUE_CLASSIFICATION_NAME').reload();
        issueWidget.getField('REPORTER_NAME').reload();

        var statusField = issueWidget.getField('ISSUE_STATUS_NAME');
        ScreenService.showLoader();
        statusField.reload().then(function() {
            var status = statusField.dataSource.data.filter(isStatusDefault);
            if(status.length <= 0){
                status = statusField.dataSource.data.filter(isStatusInitial);
            }
            status = status[0];
            issueWidget.currentRow.ISSUE_STATUS_NAME = status.LABEL;
            issueWidget.currentRow.ISSUE_STATUS = status.ID;
            requestDataSourceEngine.getDataSource('/findUserData').then(function(data) {
                ScreenService.hideLoader();
                data = data.dataset.findUserData[0];
                issueWidget.currentRow.REPORTER_NAME = data.NAME;
                issueWidget.currentRow.REPORTER = data.RESOURCE_ID;
                getFieldReporterNameFromNewIssueWidget().dataSource.data.push({'ID': data.RESOURCE_ID, 'NAME': data.NAME});
                if (data.SPONSOR_ID) {
                    issueWidget.currentRow.SPONSOR = data.SPONSOR;
                    issueWidget.currentRow.SPONSOR_ID = data.SPONSOR_ID;
                    getFieldSponsorNameFromNewIssueWidget().dataSource.data.push({'ID': data.SPONSOR_ID, 'NAME': data.SPONSOR});
                }
                issueWidget.currentRow.DUE_DATE = Utilities.getCurrentDate();
                templateManager.updateTemplate();
            }).catch(ScreenService.hideLoader);
        }).catch(ScreenService.hideLoader);
    };

    this.newIssueActionEventCancel = function(args){
        Utilities.genericBackEvent(getWidgetIssuesMain());
    };

    this.newIssueWidgetOnEnter = function(args){
        getWidgetNewIssue().reload();
    };

    this.newIssueActionEventSave = function(args) {
        var newIssueWidget = getWidgetNewIssue();

        if(newIssueWidget.isValid()) {
            if(!newIssueWidget.currentRow.BOARD){
                newIssueWidget.currentRow.BOARD = localStorageEngine.getLocalVar("boardId");
            }
            requestDataSourceEngine.setDataSource("/saveNewIssue", [newIssueWidget.currentRow], function() {
                newIssueWidget.setCurrentRow({});
                ScreenService.closeSwipe();
                var tasksWidget = getWidgetIssuesMain();
                tasksWidget.reload().then(function(){
                    tasksWidget.activate();
                    templateManager.updateTemplate();
                });
            });
        }

    };

    this.newIssueFieldOnChangeProductName = function () {
        var widget = getWidgetNewIssue();
        var fieldValue = getFieldProductNameFromNewIssueWidget().value();
        var versionField = getFieldVersionFromNewIssueWidget();
        if(fieldValue){
            var productId = getWidgetNewIssue().currentRow.PRODUCT;
            localStorageEngine.setLocalVar('PROJECT_ID', productId);
            versionField.readOnly = false;
            versionField.reload();
            widget.currentRow.VERSION = 'Última versão';
        } else {
            versionField.readOnly = true;
            widget.currentRow.VERSION = '';
            widget.currentRow.PRODUCT_VERSION_ID = '';
        }
    };

    this.issueMainActionEventEdit = function(args) {
        getFieldVersionFromWidgetIssueMain().reload();
        getFieldProductNameFromWidgetIssueMain().reload();
        getWidgetIssueMain().getField('SPONSOR').reload();
        getWidgetIssueMain().getField('ISSUE_CLASSIFICATION_NAME').reload();
        getWidgetIssueMain().getField('REPORTER_NAME').reload();
        getWidgetIssueMain().edit();
    };

    this.issueMainFieldOnChangeVersion = function () {
        var currentRow = getWidgetIssueMain().currentRow;
        var version = currentRow.VERSION.split('.');
        localStorageEngine.setLocalVar('VERSION', version[0]);
        localStorageEngine.setLocalVar('REVISION', version[1]);
    };

    this.issueMainActionEventSave = function(args){
        var widget = getWidgetIssueMain();
        var issuesMainWidget = getWidgetIssuesMain();
        if(!widget.currentRow.BOARD){
            widget.currentRow.BOARD = Utilities.localVar.getProduct();
        }
        if(widget.isValid()) {
            widget.saveRow().then(function() {
                ScreenService.showLoader();
                widget.reload().then(function() {
                    ScreenService.hideLoader();
                    widget.activate();
                }).catch(ScreenService.hideLoader);
                issuesMainWidget.reload();
            });
        }
    };

    this.issueMainIssuesActionEventDelete = function(args){
        ScreenService.confirmMessage('Confirma exclusão da(s) Issue(s)?',null,function(){
            self.deleteIssue(getWidgetIssueMain(), getWidgetIssuesMain());
        });
    };

    this.deleteIssue = function(widget, parentWidget){
        var issue = widget.currentRow;
        var user  = Utilities.localVar.getIdBusinessPartner();
        if(issue.REPORTER == user) {
            widget.removeRow(issue).then(function() {
                ScreenService.closeSwipe();
                parentWidget.activate();
                parentWidget.reload();
            });
        } else {
            ScreenService.showMessage(Utilities.messages.ERR_NOT_DELETE_ISSUE_USER_LOGADO);
        }
    };

    this.issueMainIssuesActionEventCloseIssue = function(args) {
        var issues = Utilities.localVar.getIssue();
        ScreenService.confirmMessage(Utilities.messages.ALE_CLOSE_ISSUE, 'CONFIRMATION', function() {
            TaskService.closeIssue(issues).then(function() {
                var issueMainWidget = getIssueMainWidget();
                ScreenService.closePopup(true);
                ScreenService.closeSwipe();
                issueMainWidget.activate();
                issueMainWidget.reload();
            });
        });
    };

    this.issueMainActionEventBack = function(args){
        Utilities.localVar.setIssue(undefined);
        var widget = localStorageEngine.getLocalVar('ACTUAL_WIDGET');
        ScreenService.closeSwipe();
        widget.list();
        widget.activate();
    };

    this.newIssueUploadActionEventBack = function(){
        onBack();
    };

    this.commentsActionEventBack = function(args){
        var widgetMyIssuesTabbed = getWidgetMyIssuesTabbed().currentWidget;
        ScreenService.closeSwipe().then(function () {
            widgetMyIssuesTabbed.activate();
        });
    };
    

    this.newIssueUploadActionEventUpload = function(){
        var widget = getWidgetNewIssueUpload();
        widget.currentRow.projectId = Utilities.localVar.getBoardId() ;
        widget.currentRow.taskId =  Utilities.localVar.getIssue()[0];
        ProjectServiceList.newUploadDocumentTask(widget.currentRow).then(function(){
            onBack();
            getWidgetIssueUpload().reload();
        });
    };

    var onBack = function(widget){
        if(widget && widget.container.inEditMode()){
            widget.reload();
        }
        else if(ScreenService.isPopupOpen()){
            /*****************************************
             *Linhas para concertar o bug do framework*
             *****************************************/
            getWidgetIssueUpload().currentWidget = null;
            getWidgetIssueUpload().activate();
            /*************************************************
             *Fim das Linhas para concertar o bug do framework*
             *************************************************/
            ScreenService.closePopup();
        }
        else{
            if(ScreenService.lastSwipe){
                templateManager.container.restoreDefaultMode();
            }
            ScreenService.goBack();
        }
        templateManager.updateTemplate();
    };

    this.newCommentActionEventSave = function(args){
        CommentService.saveComment(getWidgetNewComment(), closePopupAndReloadCommentWidgets, reopenIssue);
    };

    this.newCommentActionEventBack= function(args){
        ScreenService.closePopup();
    };

    var closePopupAndReloadCommentWidgets = function() {
        ScreenService.closePopup(true);
        getWidgetComments().reload();
        getWidgetNewComment().reload();
    };

    var reopenIssue = function() {
        var issue = Utilities.localVar.getIssue();
        return TaskService.reopenIssue(issue).then(function (data) {
            var issueMainWidget = getIssueMainWidget();
            return issueMainWidget.reload().then(function () {
                ScreenService.closeSwipe();
                issueMainWidget.activate();
                return data;
            });
        });
    };

}

Configuration(function(ContextRegister){
    ContextRegister.register('IssuesController', IssuesController);
});


// FILE: assets/js/Controller/MeetingPlanning.js
function MeetingPlanningController(ScreenService, Utilities, templateManager, MeetingPlanningService, ZHPromise, ZhFilterPreferences, ZhPreferences, localStorageEngine) {

    var self = this;
    var reloadScheduleList = false;
    var TASK_STATUS_CONTROL_UNSTARTED = 'N';
    var TASK_STATUS_CONTROL_IN_PROGRESS = 'D';
    var TASK_STATUS_CONTROL_BACKLOG = 'B';
    var wentOnCreateScheduleIssueWidgetAtLeastOnce = false; 

    var getWidgetListMeeting = function () {
        return templateManager.container.getWidget('LIST_MEETING');
    };

    var getWidgetTabbedMeeting = function () {
        return templateManager.container.getWidget('TABBED_MEETING');
    };

    var getWidgetInfoMeeting = function () {
        return templateManager.container.getWidget('INFO_MEETING');
    };

    var getWidgetScheduleListTabbed = function () {
        return templateManager.container.getWidget('SCHEDULE_LIST_TABBED');
    };

    var getWidgetScheduleForm = function () {
        return templateManager.container.getWidget('SCHEDULE_FORM');
    };

    var getWidgetScheduleTaskForm = function () {
        return templateManager.container.getWidget('SCHEDULE_TASK_FORM');
    };

    var getWidgetScheduleIssueForm = function () {
        return templateManager.container.getWidget('SCHEDULE_ISSUE_FORM');
    };

    var getWidgetIssueListSchedule = function () {
        return templateManager.container.getWidget('ISSUE_LIST_SCHEDULE');
    };

    var getWidgetTaskListSchedule = function () {
        return templateManager.container.getWidget('TASK_LIST_SCHEDULE');
    };

    var getWidgetTaskTabbedSchedule = function () {
        return templateManager.container.getWidget('TASK_TABBED_SCHEDULE');
    };

    var getWidgetTaskFormSchedule = function () {
        return templateManager.container.getWidget('TASK_FORM_SCHEDULE');
    };

    var getWidgetScheduleTabbed = function () {
        return templateManager.container.getWidget('SCHEDULE_TABBED');
    };

    var getWidgetScheduleTaskTabbed = function () {
        return templateManager.container.getWidget('SCHEDULE_TASK_TABBED');
    };

    var getWidgetScheduleIssueTabbed = function () {
        return templateManager.container.getWidget('SCHEDULE_ISSUE_TABBED');
    };

    var getWidgetComments = function () {
        return templateManager.container.getWidget('COMMENTS');
    };

    var getWidgetCommentSchedule = function () {
        return templateManager.container.getWidget('COMMENT_SCHEDULE');
    };

    var getWidgetDocuments = function () {
        return templateManager.container.getWidget('DOCUMENTS');
    };

    var getWidgetCreateTaskIssue = function () {
        return templateManager.container.getWidget('CREATE_TASK_ISSUE');
    };

    var getWidgetCreateSchedule = function () {
        return templateManager.container.getWidget('CREATE_SCHEDULE');
    };

    var getWidgetCreateScheduleTask = function () {
        return templateManager.container.getWidget('CREATE_SCHEDULE_TASK');
    };

    var getWidgetCreateScheduleIssue = function () {
        return templateManager.container.getWidget('CREATE_SCHEDULE_ISSUE');
    };

    var getWidgetCreateMeetingPlanning = function () {
        return templateManager.container.getWidget('CREATE_MEETING_PLANNING');
    };

    var getWidgetScheduleList = function () {
        return templateManager.container.getWidget('SCHEDULE_LIST');
    };

    var getWidgetTaskList = function () {
        return templateManager.container.getWidget('TASK_LIST');
    };

    var getWidgetIssueList = function () {
        return templateManager.container.getWidget('ISSUE_LIST');
    };

    var getWidgetNewComment = function () {
        return templateManager.container.getWidget('NEW_COMMENT');
    };

    var getWidgetNewDocument = function () {
        return templateManager.container.getWidget('NEW_DOCUMENT');
    };

    var getWidgetNewLabel = function () {
        return templateManager.container.getWidget('NEW_LABEL');
    };

    var getWidgetListIssueToSchedulel = function () {
        return templateManager.container.getWidget('LIST_ISSUE_TO_SCHEDULE');
    };

    var getFieldListIssueToSchedulel = function () {
        return getWidgetListIssueToSchedulel().getField('LIST_ISSUE_TO_SCHEDULE');
    };
    var getFieldProjectListIssueToSchedulel = function () {
        return getWidgetListIssueToSchedulel().getField('PRODUCT');
    };

    var getFieldNameFromInfoMeetingWidget = function () {
        return getWidgetInfoMeeting().getField('NAME');
    };

    var getFieldIdFromCommentsWidget = function () {
        return getWidgetComments().getField('Id');
    };

    var getFieldIssueLabelsFromInfoMeetingWidget = function () {
        return getWidgetInfoMeeting().getField('ISSUE_LABELS');
    };

    var getFieldTaskLabelsFromInfoMeetingWidget = function () {
        return getWidgetInfoMeeting().getField('TASK_LABELS');
    };

    var getFieldClassificationLabelFromScheduleFormWidget = function () {
        return getWidgetScheduleForm().getField('CLASSIFICATION_LABEL');
    };

    var getFieldTaskStatusNameFromScheduleFormWidget = function () {
        return getWidgetScheduleForm().getField('TASK_STATUS_NAME');
    };

    var getFieldResourcesFromScheduleFormWidget = function () {
        return getWidgetScheduleForm().getField('RESOURCES');
    };

    var getFieldParentNameFromScheduleFormWidget = function () {
        return getWidgetScheduleForm().getField('PARENT_NAME');
    };
    var getFieldClassificationLabelFromTaskFormScheduleWidget = function () {
        return getWidgetTaskFormSchedule().getField('CLASSIFICATION_LABEL');
    };
    
    var getFieldPriorityFromTaskFormScheduleWidget = function () {
        return getWidgetTaskFormSchedule().getField('PRIORITY_NAME');
    };
    
    var getFieldPriorityFromTaskFormCreateScheduleWidget = function () {
        return getWidgetCreateScheduleIssue().getField('PRIORITY_NAME');
    };

    var getFieldResourcesFromTaskFormScheduleWidget = function () {
        return getWidgetTaskFormSchedule().getField('RESOURCES');
    };

    var getFieldParentNameFromTaskFormScheduleWidget = function () {
        return getWidgetTaskFormSchedule().getField('PARENT_NAME');
    };

    var getFieldParentNameFromLabelsRelatedUserFormWidget = function () {
        return getWidgetScheduleForm().getField('LABELS_RELATED_USER');
    };
    var getFieldParentNameFromScheduleRelationshipUserFormWidget = function () {
        return getWidgetScheduleForm().getField('SCHEDULE_RELATIONSHIP');
    };
    
    var getFieldClassificationFromIssueListWidget = function () {
        return getWidgetIssueList().getField('CLASSIFICATION_LABEL');
    };

    var getFieldLabelFromIssueListWidget = function () {
        return getWidgetIssueList().getField('LABEL');
    };

    var getFieldManagerFromListMeeting = function(){
        return getWidgetListMeeting().getField('MANAGER');
    };

    var getFieldProjectStatusIdFromListMeeting = function(){
        return getWidgetListMeeting().getField('PROJECT_STATUS_ID');
    };

    var getFieldLabelsRelatedUserFromTaskFormScheduleWidget = function () {
        return getWidgetTaskFormSchedule().getField('LABELS_RELATED_USER');
    };
    var getFieldScheduleRelationshipFromTaskFormScheduleWidget = function () {
        return getWidgetTaskFormSchedule().getField('SCHEDULE_RELATIONSHIP');
    };
    var getFieldScheduleRelationshipIssueFromCreateTaskIssue = function () {
        return getWidgetCreateTaskIssue().getField('SCHEDULE_RELATIONSHIP_ISSUE');
    };
    var getFieldScheduleRelationshipTaskFromCreateTaskIssue = function () {
        return getWidgetCreateTaskIssue().getField('SCHEDULE_RELATIONSHIP_TASK');
    };
    var getFieldOrderIssueFromCreateTaskIssue = function () {
        return getWidgetCreateTaskIssue().getField('ORDER_ISSUE');
    };
    var getFieldOrderTaskFromCreateTaskIssue = function () {
        return getWidgetCreateTaskIssue().getField('ORDER_TASK');
    };

    var getActionDeleteFromScheduleFormWidget = function () {
        return getWidgetScheduleForm().getAction('DELETE');
    };

    var getActionAddFromScheduleListWidget = function () {
        return getWidgetScheduleList().getAction('ADD');
    };

    var getActionDeleteFromInfoMeetingWidget = function () {
        return getWidgetInfoMeeting().getAction('DELETE');
    };

    var getFieldManagerFromInfoMeetingWidget = function () {
        return getWidgetInfoMeeting().getField('MANAGER');
    };

    var getFieldProjectStatusFromInfoMeetingWidget = function () {
        return getWidgetInfoMeeting().getField('PROJECT_STATUS');
    };

    var getFieldTypeFromCreateTaskIssue = function () {
        return getWidgetCreateTaskIssue().getField('TYPE');
    };

    var getFieldTypeFromScheduleParentName = function () {
        return getWidgetCreateTaskIssue().getField('SCHEDULE_PARENT_NAME');
    };

    var getFieldLabelsRelatedUserTaskFromCreateTaskIssue= function () {
        return getWidgetCreateTaskIssue().getField('LABELS_RELATED_USER_TASK');
    };

    var getFieldLabelsRelatedUserIssueFromCreateTaskIssue = function () {
        return getWidgetCreateTaskIssue().getField('LABELS_RELATED_USER_ISSUE');
    };

    var getFieldReporterNameFromCreateTaskIssue = function () {
        return getWidgetCreateTaskIssue().getField('REPORTER_NAME');
    };

    var getFieldResourceFromCreateTaskIssue = function () {
        return getWidgetCreateTaskIssue().getField('RESOURCE');
    };

    var getFieldTaskClassificationLabelFromCreateTaskIssue = function () {
        return getWidgetCreateTaskIssue().getField('TASK_CLASSIFICATION_LABEL');
    };

    var getFieldFollowersFromCreateTaskIssue = function () {
        return getWidgetCreateTaskIssue().getField('FOLLOWERS');
    };

    var getFieldResourceFromScheduleForm = function () {
        return getWidgetScheduleForm().getField('RESOURCES');
    };

    var getFieldFollowersFromScheduleForm = function () {
        return getWidgetScheduleForm().getField('FOLLOWERS');
    };

    var getFieldResourceFromScheduleTaskForm = function () {
        return getWidgetScheduleTaskForm().getField('RESOURCES');
    };

    var getFieldFollowersFromScheduleIssueForm = function () {
        return getWidgetScheduleIssueForm().getField('FOLLOWERS');
    };

    var getFieldNameFromScheduleTaskForm = function () {
        return getWidgetScheduleTaskForm().getField('NAME');
    };

    var getFieldClassificationFromScheduleTaskForm = function () {
        return getWidgetScheduleTaskForm().getField('CLASSIFICATION_LABEL');
    };

    var getFieldTaskStatusFromScheduleTaskForm = function () {
        return getWidgetScheduleTaskForm().getField('TASK_STATUS_NAME');
    };

    var getFieldDescriptionFromScheduleTaskForm = function () {
        return getWidgetScheduleTaskForm().getField('DESCRIPTION');
    };

    var getFieldParentNameFromScheduleTaskForm = function () {
        return getWidgetScheduleTaskForm().getField('PARENT_NAME');
    };

    var getFieldLabelRelatedUserFromScheduleTaskForm = function () {
        return getWidgetScheduleTaskForm().getField('LABELS_RELATED_USER');
    };

    var getFieldCommitentDateFromScheduleTaskForm = function () {
        return getWidgetScheduleTaskForm().getField('COMMITMENT_DATE');
    };

    var getFieldScheduleRelationshipFromScheduleTaskForm = function () {
        return getWidgetScheduleTaskForm().getField('SCHEDULE_RELATIONSHIP');
    };

    /* === */

    var getFieldResourceFromTaskFormSchedule = function () {
        return getWidgetTaskFormSchedule().getField('RESOURCES');
    };

    var getFieldTaskStatusIdFromTaskListSchedule = function () {
        return getWidgetTaskListSchedule().getField('TASK_STATUS_ID');
    };

    var getFieldTaskStatusIdFromIssueListSchedule = function () {
        return getWidgetIssueListSchedule().getField('TASK_STATUS_ID');
    };

    var getFieldFollowersFromTaskFormSchedule = function () {
        return getWidgetTaskFormSchedule().getField('FOLLOWERS');
    };

    var getFieldProjectFromCreateTaskIssue = function () {
        return getWidgetCreateTaskIssue().getField('PROJECT');
    };

    var getFieldParentNameFromCreateTaskIssue = function () {
        return getWidgetCreateTaskIssue().getField('PARENT_NAME');
    };

    var getFieldScheduleResourceFromCreateTaskIssue = function () {
        return getWidgetCreateTaskIssue().getField('SCHEDULE_RESOURCE');
    };

    var getFieldProjectSprintFromInfoMeetingWidget = function () {
        return getWidgetInfoMeeting().getField('PROJECT_SPRINT');
    };

    var getFieldResourceFromInfoMeetingWidget = function () {
        return getWidgetInfoMeeting().getField('RESOURCE');
    };

    var getFieldManagerFromScheduleListWidget = function () {
        return getWidgetScheduleList().getField('MANAGER');
    };

    var getFieldClientFromInfoMeetingWidget = function () {
        return getWidgetInfoMeeting().getField('CLIENT');
    };

    var getFieldTaskStatusFromInfoMeetingWidget = function () {
        return getWidgetInfoMeeting().getField('TASK_STATUS');
    };

    var getFieldIssueStatusFromInfoMeetingWidget = function () {
        return getWidgetInfoMeeting().getField('ISSUE_STATUS');
    };

    var getFieldTaskPeriodFromInfoMeetingWidget = function () {
        return getWidgetInfoMeeting().getField('TASK_PERIOD');
    };

    var getFieldIssuePeriodFromInfoMeetingWidget = function () {
        return getWidgetInfoMeeting().getField('ISSUE_PERIOD');
    };

    /** Get Fields From Widget CREATE_SCHEDULE */
    
    var getFieldScheduleClassificationLabelfromCreateScheduleWidget = function (){
        return getWidgetCreateSchedule().getField('SCHEDULE_CLASSIFICATION_LABEL');
    };
    
    var getFieldScheduleResourcefromCreateScheduleWidget = function () {
        return getWidgetCreateSchedule().getField('SCHEDULE_RESOURCE');
    };
    
    var getFieldScheduleParentNamefromCreateScheduleWidget = function () {
        return getWidgetCreateSchedule().getField('SCHEDULE_PARENT_NAME');
    };
    
    var getFieldTaskStatusNamefromCreateScheduleWidget = function () {
        return getWidgetCreateSchedule().getField('TASK_STATUS_NAME');
    };
    
    /** Get Fields From Widget CREATE_SCHEDULE_TASK */

    var getFieldParentNameFromCreateScheduleTaskWidget = function () {
        return getWidgetCreateScheduleTask().getField('PARENT_NAME');
    };

    var getFieldResourceFromCreateScheduleTaskWidget = function () {
        return getWidgetCreateScheduleTask().getField('RESOURCE');
    };

    var getFieldTaskClassificationLabelFromCreateScheduleTaskWidget = function () {
        return getWidgetCreateScheduleTask().getField('TASK_CLASSIFICATION_LABEL');
    };

    var getFieldProjectFromCreateScheduleTaskWidget = function () {
        return getWidgetCreateScheduleTask().getField('PROJECT');
    };

    var getFieldLabelsRelatedUserTaskFromCreateScheduleTaskWidget = function () {
        return getWidgetCreateScheduleTask().getField('LABELS_RELATED_USER_TASK');
    };

    var getFieldScheduleRelationshipTaskFromCreateScheduleTaskWidget = function () {
        return getWidgetCreateScheduleTask().getField('SCHEDULE_RELATIONSHIP_TASK');
    };

    var getFieldTypeFromCreateScheduleTaskWidget = function () {
        return getWidgetCreateScheduleTask().getField('TYPE');
    };

    var getFieldOrderTaskFromCreateScheduleTaskWidget = function () {
        return getWidgetCreateScheduleTask().getField('ORDER_TASK');
    };

    /** Get Fields From Widget CREATE_SCHEDULE_ISSUE */

    var getFieldProductFromCreateScheduleIssueWidget = function () {
        return getWidgetCreateScheduleIssue().getField('PRODUCT');
    };

    var getFieldSponsorFromCreateScheduleIssueWidget = function () {
        return getWidgetCreateScheduleIssue().getField('SPONSOR');
    };

    var getFieldIssueClassificationNameFromCreateScheduleIssueWidget = function () {
        return getWidgetCreateScheduleIssue().getField('ISSUE_CLASSIFICATION_NAME');
    };

    var getFieldPriorityNameFromCreateScheduleIssueWidget = function () {
        return getWidgetCreateScheduleIssue().getField('PRIORITY_NAME');
    };

    var getFieldReporterNameFromCreateScheduleIssueWidget = function () {
        return getWidgetCreateScheduleIssue().getField('REPORTER_NAME');
    };

    var getFieldFollowersFromCreateScheduleIssueWidget = function () {
        return getWidgetCreateScheduleIssue().getField('FOLLOWERS');
    };

    var getFieldLabelsRelatedUserIssueFromCreateScheduleIssueWidget = function () {
        return getWidgetCreateScheduleIssue().getField('LABELS_RELATED_USER_ISSUE');
    };

    var getFieldScheduleRelationshipIssueFromCreateScheduleIssueWidget = function () {
        return getWidgetCreateScheduleIssue().getField('SCHEDULE_RELATIONSHIP_ISSUE');
    };

    var getFieldOrderIssueFromCreateScheduleIssueWidget = function () {
        return getWidgetCreateScheduleIssue().getField('ORDER_ISSUE');
    };

    var getFieldTypeFromCreateScheduleIssueWidget = function () {
        return getWidgetCreateScheduleIssue().getField('TYPE');
    };


    var getFieldScheduleRelationshipFromScheduleIssueFormWidget = function () {
        return getWidgetScheduleIssueForm().getField('SCHEDULE_RELATIONSHIP');
    };

    var getFieldCommitmentDateFromScheduleIssueFormWidget = function () {
        return getWidgetScheduleIssueForm().getField('COMMITMENT_DATE');
    };

    var getFieldLabelsRelatedUserFromScheduleIssueFormWidget = function () {
        return getWidgetScheduleIssueForm().getField('LABELS_RELATED_USER');
    };
    

    var getActionNewMeetingPlanningFromCreateMeetingPlanning = function () {
        return getWidgetInfoMeeting().getAction('NEW_MEETING_PLANNING');
    };

    var goBackToListMeeting = function () {
        var widgetListMeeting = getWidgetListMeeting();
        getWidgetTabbedMeeting().lastActiveWidget = widgetListMeeting;
        ScreenService.closeSwipe().then(function () {
            widgetListMeeting.list();
            widgetListMeeting.activate();
        });
    };

    var setEnableCreateMeetingRecurrent = function () {
        var newMeetingPlanningAction = getActionNewMeetingPlanningFromCreateMeetingPlanning();
        var infoMeetingWidget = getWidgetInfoMeeting();
        newMeetingPlanningAction.isVisible = !infoMeetingWidget.currentRow.PARENT;
    };

    var removeMeeting = function () {
        getWidgetInfoMeeting().removeRow().then(function () {
            goBackToListMeeting();
            getWidgetListMeeting().reload();
        }).catch(Utilities.showMessageBackEndTrue);
    };

    var removeScheduleForm = function () {
        getWidgetScheduleForm().removeRow().then(function () {
            scheduleFormBack();
            getWidgetScheduleList().reload();
            getWidgetListMeeting().reload();
        }).catch(function(response){
            Utilities.showMessageErrorOfBackEnd(response,Utilities.messages.ERR_CONTAINER_MEETING_PLANNING);
        });
    };

    var setVisibilityFieldsInfoMeetingWidget = function () {
        var infoMeetingWidget = getWidgetInfoMeeting();
        var fields = infoMeetingWidget.fields;
        var fieldGroups = infoMeetingWidget.fieldGroups;
        var control = infoMeetingWidget.currentRow.PROJECT_TYPE_CONTROL;
        fields.filter(function (field) {
            return !!field.meeting;
        }).forEach(function (field) {
            field.isVisible = (field.meetingControl == control);
        });

        fieldGroups.filter(function (fieldGroup) {
            return !!fieldGroup.meeting;
        }).forEach(function (fieldGroup) {
            fieldGroup.isVisible = (fieldGroup.meetingControl == control);
        });
    };

    var setReadOnlyFieldsInfoMeetingWidget = function (isNew) {
        var infoMeetingWidget = getWidgetInfoMeeting();
        var fields = infoMeetingWidget.fields;
        isNew = isNew ? 'Y' : 'N';
        fields.filter(function (field) {
            return !!field.PMReadOnNewRow;
        }).forEach(function (field) {
            field.readOnly = (field.PMReadOnNewRow == isNew);
        });

    };

    var setVisibilityActionsInfoMeetingWidget = function () {
        var infoMeetingWidget = getWidgetInfoMeeting();
        var actions = infoMeetingWidget.actions;
        var isManager = infoMeetingWidget.currentRow.IS_MANAGER;
        actions.filter(function (field) {
            return !!field.PMIsManager;
        }).forEach(function (field) {
            if(field.PMControl){
                if(field.isVisible){
                    field.isVisible = (field.PMIsManager == isManager);
                }
            }else{
                field.isVisible = (field.PMIsManager == isManager);
            }
        });
    };

    this.getValueFieldManagerWidgetInfoMeeting = function () {
        return Utilities.getValueInSelectField(getFieldManagerFromInfoMeetingWidget());
    };
    
    this.taskListScheduleWidgetOnEnter = function(args){
        ScreenService.showLoader();
        Utilities.localVar.getLoginPromise().then(function(){
            ScreenService.hideLoader();
            var widget = getWidgetTaskListSchedule();
            if (!Utilities.isAppliedFilter(widget)) {
                ScreenService.showLoader();
                getFieldTaskStatusIdFromTaskListSchedule().reload().then(function() {
                    ScreenService.hideLoader();
                    Utilities.setDefaultValuesToSelectMultipleField(getFieldTaskStatusIdFromTaskListSchedule(), ['N', 'P', 'D'], 'CONTROL');
                    ZhFilterPreferences.setOriginalFilter(widget.id, widget.currentRow);
                    ZhFilterPreferences.applyOriginalFilter(widget);
                }).catch(ScreenService.hideLoader);
            } else {
                widget.reload();
            }
        }).catch(ScreenService.hideLoader);
    };

    this.taskListScheduleFilterAfterApply = function () {
        Utilities.setFilterInit(getWidgetTaskListSchedule());
    };
    
    this.commentScheduleWidgetOnEnterTab = function(args){
        getWidgetCommentSchedule().reload();
    };

    this.listMeetingWidgetAfterMoveRow = function (args) {
        var infoMeetingWidget = getWidgetInfoMeeting();
        var tabbedMeetingWidget = getWidgetTabbedMeeting();
        var listMeetingWidget = getWidgetListMeeting();
        var id = listMeetingWidget.currentRow.ID;
        var projectStatusControl = listMeetingWidget.currentRow.PROJECT_STATUS_CONTROL;
        Utilities.localVar.setMeetingId(id);
        setReadOnlyByProjectStatusControl(projectStatusControl);
        if(!tabbedMeetingWidget.currentWidget){
            tabbedMeetingWidget.currentWidget = tabbedMeetingWidget.widgets[0];
        }
        reloadScheduleList = !tabbedMeetingWidget.currentWidget.isScheduleList;

        Utilities.fixBugReloadWidgetInViewMode(infoMeetingWidget).then(function () {
            var currentRow = infoMeetingWidget.currentRow;
            if (currentRow.PARENT) {
                ScreenService.showLoader();
                MeetingPlanningService.findInfoMeeting(currentRow.PARENT).then(function (response) {
                    ScreenService.hideLoader();
                    currentRow = response.dataset.Basic[0];
                    setTabsEnableFromScheduleTabbed(currentRow);
                }).catch(ScreenService.hideLoader);
            } else {
                setTabsEnableFromScheduleTabbed(currentRow);
            }
            
            ScreenService.showLoader();
            ZHPromise.all([
                getFieldProjectSprintFromInfoMeetingWidget().reload(),
                getFieldTaskStatusFromInfoMeetingWidget().reload(),
                getFieldIssueStatusFromInfoMeetingWidget().reload(),
                getFieldIssueLabelsFromInfoMeetingWidget().reload(),
                getFieldTaskLabelsFromInfoMeetingWidget().reload()
            ]).then(ScreenService.hideLoader).catch(ScreenService.hideLoader);
        }).catch(ScreenService.hideLoader);

        if (tabbedMeetingWidget.currentWidget == getWidgetScheduleListTabbed()) {
            tabbedMeetingWidget.currentWidget.currentWidget.reload();
            ScreenService.closeSwipe(1);
        } else if(tabbedMeetingWidget.currentWidget != infoMeetingWidget) {
            tabbedMeetingWidget.currentWidget.reload();
        }

        if (!ScreenService.isSwipeOpen()){
            ScreenService.openSwipe(tabbedMeetingWidget);
        }
        
        tabbedMeetingWidget.descriptionOrder = listMeetingWidget.descriptionOrder;
    };

    var setTabsEnableFromScheduleTabbed = function (currentRow) {
        var tabbedMeetingWidget = getWidgetTabbedMeeting();

        if (currentRow.ALLOW_SCHEDULE_FILTER === 'Y') {
            getWidgetTaskList().enabled = true;
        } else if (currentRow.TASK_STATUS.length === 0 && (!currentRow.TASK_PERIOD_start || !currentRow.TASK_PERIOD_end)) {
            getWidgetTaskList().enabled = false;
            if (tabbedMeetingWidget.currentWidget == getWidgetScheduleListTabbed()) {
                getWidgetScheduleList().activate();
            }
        } else {
            getWidgetTaskList().enabled = true;
        }

        if (currentRow.ALLOW_SCHEDULE_FILTER === 'Y') {
            getWidgetIssueList().enabled = true;
        } else if (currentRow.ISSUE_STATUS.length === 0 && (!currentRow.ISSUE_PERIOD_start || !currentRow.ISSUE_PERIOD_end)) {
            getWidgetIssueList().enabled = false;
            if (tabbedMeetingWidget.currentWidget == getWidgetScheduleListTabbed()) {
                getWidgetScheduleList().activate();
            }
        } else {
            getWidgetIssueList().enabled = true;
        }

    };

    this.listMeetingActionEventAdd = function (args) {
        var tabbedMeetingWidget = getWidgetTabbedMeeting();
        var infoMeetingWidget = getWidgetInfoMeeting();
        tabbedMeetingWidget.currentWidget = infoMeetingWidget;
        infoMeetingWidget.dataSource.data = [];
        infoMeetingWidget.newRow();
        infoMeetingWidget.template = infoMeetingWidget.templateToForm;
        infoMeetingWidget.currentRow.PROJECT_TYPE_CONTROL = 'M';
        ScreenService.openSwipe(tabbedMeetingWidget);
        setVisibilityFieldsInfoMeetingWidget();
        setReadOnlyFieldsInfoMeetingWidget(true);
        getFieldManagerFromInfoMeetingWidget().reload();
        getFieldProjectStatusFromInfoMeetingWidget().reload();
    };

    this.infoMeetingFieldOnAddIssueLabels = function (args) {
        newLabels();
    };

    this.infoMeetingFieldOnAddTaskLabels = function (args) {
        newLabels();
    };

    this.newLabelActionEventSave = function (args) {
        createLabel();
    };

    this.newLabelActionEventBack = function (args) {
        cancelLabel();
    };

    var cancelLabel = function(){
        ScreenService.closePopup();
        getFieldIssueLabelsFromInfoMeetingWidget().reload();
        getFieldTaskLabelsFromInfoMeetingWidget().reload();
    };

    var createLabel = function(){
        var widget = getWidgetNewLabel();
        widget.IS_PROJECT = 'N';
        if (widget.isValid()){
            widget.saveRow().then(function(){
                cancelLabel();
            });
        }
    };

    var newLabels = function (args) {
        var newLabelWidget = getWidgetNewLabel();
        newLabelWidget.dataSource.data = [];
        newLabelWidget.newRow();
        newLabelWidget.template = newLabelWidget.templateToForm;
        newLabelWidget.currentRow.BOARD = Utilities.localVar.getMeetingId();
        ScreenService.openPopup(newLabelWidget);
    };

    this.scheduleListWidgetAfterMoveRow = function (args) {
        var scheduleListWidget = getWidgetScheduleList();
        var scheduleID = scheduleListWidget.currentRow.ID;
        var scheduleWidget = getWidgetScheduleForm();
        var scheduleTabbed = getWidgetScheduleTabbed();
        if(scheduleID && Utilities.validateEditInLine(scheduleListWidget)){
            scheduleTabbed.descriptionOrder = scheduleListWidget.descriptionOrder;
            Utilities.localVar.setScheduleId(scheduleID);
            
            getFieldClassificationLabelFromScheduleFormWidget().reload();
            getFieldResourcesFromScheduleFormWidget().reload();

            scheduleWidget.currentRow.MEETING = Utilities.localVar.getMeetingId();
            ScreenService.openSwipe(scheduleTabbed).then(function(){
                scheduleWidget.list();
                ScreenService.showLoader();
                scheduleWidget.reload().then(function () {
                    ScreenService.hideLoader();
                    scheduleWidget.view();
                    scheduleWidget.activate();
                    Utilities.fixBugOpenSwipeTabbed(scheduleTabbed);
                }).catch(ScreenService.hideLoader);
            });
        }
    };

    this.taskListWidgetAfterMoveRow = function(){
        var taskListWidget = getWidgetTaskList();
        var taskId = taskListWidget.currentRow.ID;
        var scheduleTaskTabbed = getWidgetScheduleTaskTabbed();
        var scheduleTaskWidget = getWidgetScheduleTaskForm();
        scheduleTaskTabbed.descriptionOrder = taskListWidget.descriptionOrder;
        
        scheduleTaskWidget.getField('RESOURCES').reload();
        scheduleTaskWidget.getField('CLASSIFICATION_LABEL').reload();
        scheduleTaskWidget.getField('LABELS_RELATED_USER').reload();

        Utilities.localVar.setScheduleId(taskId);
        scheduleTaskWidget.currentRow.MEETING = Utilities.localVar.getMeetingId();

        ScreenService.openSwipe(scheduleTaskTabbed).then(function () {
            scheduleTaskWidget.list();
            ScreenService.showLoader();
            scheduleTaskWidget.reload().then(function () {
                ScreenService.hideLoader();
                scheduleTaskWidget.getField('PARENT_NAME').reload();
                scheduleTaskWidget.view();
                scheduleTaskWidget.activate();
                Utilities.fixBugOpenSwipeTabbed(scheduleTaskTabbed);
            }).catch(ScreenService.hideLoader);
        });
    };

    var setScheduleActionsVisible = function(actionIsVisible){
        setActionVisibilityByControl(getWidgetScheduleForm(), actionIsVisible);
        setActionVisibilityByControl(getWidgetCommentSchedule(), actionIsVisible);
        setActionVisibilityByControl(getWidgetTaskFormSchedule(), actionIsVisible);
        setActionVisibilityByControl(getWidgetTaskListSchedule(), actionIsVisible);
        setActionVisibilityByControl(getWidgetIssueListSchedule(), actionIsVisible);
    };

    var setActionVisibilityByControl = function(widget, actionIsVisible){
        widget.actions.forEach(function(item){
            if(item.pmNotIsVisibleConcluded){
                item.isVisible = actionIsVisible;
            }
        });
    };

    this.taskListScheduleListWidgetAfterMoveRow = function (args) {
        var taskFormScheduleWidget = getWidgetTaskFormSchedule();
        var scheduleID = getWidgetTaskListSchedule().currentRow.ID;
        if (scheduleID && Utilities.validateEditInLine(getWidgetTaskListSchedule())) {
            var scheduleTabbed = getWidgetTaskTabbedSchedule();
            reloadFieldsFromTaskFormScheduleWidget();
            Utilities.localVar.setTaskId(scheduleID);
            ScreenService.openSwipe(scheduleTabbed).then(function(){
                taskFormScheduleWidget.currentRow.TASK = Utilities.localVar.getScheduleId();
                taskFormScheduleWidget.currentRow.MEETING = Utilities.localVar.getMeetingId();
                Utilities.fixBugReloadWidgetInViewMode(taskFormScheduleWidget);
            });
        }
    };
    
    var reloadFieldsFromTaskFormScheduleWidget = function(){
        getFieldClassificationLabelFromTaskFormScheduleWidget().reload();
        getFieldResourcesFromTaskFormScheduleWidget().reload();
        getFieldPriorityFromTaskFormScheduleWidget().reload();
        getFieldParentNameFromTaskFormScheduleWidget().reload();
        getFieldLabelsRelatedUserFromTaskFormScheduleWidget().reload();
        getFieldScheduleRelationshipFromTaskFormScheduleWidget().reload();
    };

    this.issueListScheduleListWidgetAfterMoveRow = function (args) {
        var taskFormScheduleWidget = getWidgetTaskFormSchedule();
        var scheduleID = getWidgetIssueListSchedule().currentRow.ID;
        if (scheduleID && Utilities.validateEditInLine(getWidgetIssueListSchedule())) {
            var scheduleTabbed = getWidgetTaskTabbedSchedule();
            reloadFieldsFromTaskFormScheduleWidget();
            Utilities.localVar.setTaskId(scheduleID);
            ScreenService.openSwipe(scheduleTabbed).then(function () {
                taskFormScheduleWidget.list();
                ScreenService.showLoader();
                taskFormScheduleWidget.reload().then(function () {
                    ScreenService.hideLoader();
                    taskFormScheduleWidget.view();
                    Utilities.fixBugOpenSwipeTabbed(scheduleTabbed);
                }).catch(ScreenService.hideLoader);
            });
        }
    };

    this.scheduleListWidgetOnSaveInlineEdit = function(args){
        var scheduleListWidget = getWidgetScheduleList();
        var rows = args.e.data.changedRows;
        saveScheduleListOrder(rows, scheduleListWidget);
    };

    var setFieldTaskFormSchedule= function (IsSchedule,isIssue) {
        var taskFormSchedule = getWidgetTaskFormSchedule();
        setReadOnAndIsVisibleByScheduleOrIssueOrTask(taskFormSchedule,IsSchedule,isIssue);
    };

    var setReadOnAndIsVisibleByScheduleOrIssueOrTask = function(widgetScheduleForm,IsSchedule,isIssue,isTask){
        widgetScheduleForm.fields.filter(function (field) {
            return !!field.PMReadOnlyIsSchedule;
        }).forEach(function (field) {
            field.readOnly = (field.PMReadOnlyIsSchedule == IsSchedule);
        });

        widgetScheduleForm.fields.filter(function (field) {
            return !!field.PMVisibleIsSchedule;
        }).forEach(function (field) {
            field.isVisible = (field.PMVisibleIsSchedule == IsSchedule);
        });

        widgetScheduleForm.fields.filter(function (field) {
            return !!field.PMVisibleIsIssue;
        }).forEach(function (field) {
            field.isVisible = (field.PMVisibleIsIssue == isIssue);
        });
        
        widgetScheduleForm.fields.filter(function (field) {
            return !!field.PMVisibleIsTask;
        }).forEach(function (field) {
            field.isVisible = (field.PMVisibleIsTask == isTask);
        });

    };

    var setDataGridScheduleByEdit = function (row, scheduleWidget) {
        row.NAME = scheduleWidget.currentRow.NAME;
        row.TASK_STATUS = scheduleWidget.currentRow.TASK_STATUS_NAME;
        row.COMMITMENT_DATE = scheduleWidget.currentRow.COMMITMENT_DATE;
        row.MANAGER = scheduleWidget.currentRow.RESOURCES.map(function (resource) {return parseInt(resource);});
    };

    this.scheduleFormActionEventSave = function (args) {
        var scheduleWidget = getWidgetScheduleForm();
        if (scheduleWidget.isValid()) {
            scheduleWidget.saveRow().then(function (response) {
                var widgetScheduleList = getWidgetScheduleList();
                widgetScheduleList.dataSource.data.some(function (row) {
                    if (row.ID == widgetScheduleList.currentRow.ID) {
                        setDataGridScheduleByEdit(row, scheduleWidget);
                        return true;
                    }
                });
                scheduleWidget.view();
                scheduleWidget.template = scheduleWidget.templateToView;
                reloadInMeeting(response);
            }).catch(function(response){
                Utilities.showMessageErrorOfBackEnd(response,Utilities.messages.ERR_CONTAINER_MEETING_PLANNING);
            });
        }
    };

    this.taskFormScheduleActionEventSave = function (args) {
        var taskFormSchedule = getWidgetTaskFormSchedule();
        if (taskFormSchedule.isValid()) {
            taskFormSchedule.saveRow().then(function () {
                getWidgetTaskListSchedule().reload();
                taskFormSchedule.view();
                taskFormSchedule.template = taskFormSchedule.templateToView;
            }).catch(function(response){
                Utilities.showMessageErrorOfBackEnd(response,Utilities.messages.ERR_CONTAINER_MEETING_PLANNING);
            });
        }
    };

    this.scheduleFormActionEventEdit = function (args) {
        var scheduleWidget = getWidgetScheduleForm();
        scheduleWidget.edit();
        getFieldClassificationLabelFromScheduleFormWidget().reload();
        getFieldTaskStatusNameFromScheduleFormWidget().reload();
    };

    var validateEditSchedule = function () {
        var widgetScheduleForm = getWidgetScheduleForm();
        var scheduleProjectId = widgetScheduleForm.currentRow.PROJECT_ID;
        var currentProjectId = Utilities.localVar.getMeetingId();
        var pmActionIsVisible = widgetScheduleForm.pmActionIsVisible;
        return scheduleProjectId == currentProjectId && pmActionIsVisible;
    };

    this.scheduleListWidgetOnEnterTab = function () {
        var widget = getWidgetScheduleList();
        var currentRow = {};
        var taskStatusIds = [TASK_STATUS_CONTROL_UNSTARTED, TASK_STATUS_CONTROL_IN_PROGRESS,TASK_STATUS_CONTROL_BACKLOG];

        if (!Utilities.isAppliedFilter(widget)){
            ScreenService.showLoader();
            MeetingPlanningService.getTaskStatus().then(function(taskStatus){
                ScreenService.hideLoader();
                currentRow.TASK_STATUS_ID = taskStatus.filter(function(row){
                    return -1 != taskStatusIds.indexOf(row.CONTROL);
                }).map(function(row){
                    return row.ID;
                });
                widget.currentRow = currentRow;
                ZhFilterPreferences.setOriginalFilter(widget.id, widget.currentRow);
                ZhFilterPreferences.applyOriginalFilter(widget);
            }).catch(ScreenService.hideLoader);
        } else {
            widget.reload();
        }
    };

    this.taskListWidgetOnEnterTab = function () {
        var widget = getWidgetTaskList();
        var taskStatusControl = ['D', 'P', 'N'];
        var currentRow = widget.currentRow;

        if (!Utilities.isAppliedFilter(widget)) {
            ScreenService.showLoader();
            MeetingPlanningService.getAllStatusTask().then(function (taskStatus) {
                ScreenService.hideLoader();
                currentRow.TASK_STATUS = taskStatus.filter(function (row) {
                    return taskStatusControl.includes(row.CONTROL);
                }).map(function (row) {
                    return row.ID;
                });
                widget.currentRow = currentRow;
                ZhFilterPreferences.setOriginalFilter(widget.id, widget.currentRow);
                ZhFilterPreferences.applyOriginalFilter(widget);
             }).catch(ScreenService.hideLoader);
         } else {
             widget.reload();
         }
    };

    this.taskListWidgetAfterLoadDataSource = function() {
        var widget = getWidgetTaskList();
        Utilities.bugPaginationOnSelectMultiplyOnModeList(widget.getField('RESOURCE_ID'));
        Utilities.bugPaginationOnSelectMultiplyOnModeList(widget.getField('TASK_CLASSIFICATION'));
    };
    
    this.scheduleListWidgetFilterAfterApply = function () {
        Utilities.setFilterInit(getWidgetScheduleList());
    };

    this.issueListScheduleWidgetOnEnter = function(args){
        var widget = getWidgetIssueListSchedule();
        var idArray = [];
        if (!Utilities.isAppliedFilter(widget)) {
            widget.currentRow = {};
            ScreenService.showLoader();
            getFieldTaskStatusIdFromIssueListSchedule().reload().then(function(allIssueStatus) {
                ScreenService.hideLoader();
                allIssueStatus.dataset.findIssueStatus.filter(function(issueStatus){
                    if(issueStatus.TASK_TYPE_CONTROL != 'D' &&
                        issueStatus.TASK_TYPE_CONTROL != 'H' ) {
                        idArray.push(issueStatus.ID);
                    }
                });
                getFieldTaskStatusIdFromIssueListSchedule().value(idArray);
                ZhFilterPreferences.setOriginalFilter(widget.id, widget.currentRow);
                ZhFilterPreferences.applyOriginalFilter(widget);
                widget.PMfilterRow = widget.currentRow;
            }).catch(ScreenService.hideLoader);
        } else {
            widget.reload();
        }
    };

    this.issueListScheduleFilterAfterApply = function () {
        Utilities.setFilterInit(getWidgetIssueListSchedule());
    };

    this.issueListWidgetOnEnter = function () {
        var widget = getWidgetIssueList();
        var currentRow = {};
        var taskStatusControl = ['H', 'ACEITA'];
        widget.getField('LABEL').reload();

        if (!Utilities.isAppliedFilter(widget)) {
            ScreenService.showLoader();
            MeetingPlanningService.findIssueStatus().then(function (findIssueStatus) {
                ScreenService.hideLoader();
                currentRow.TASK_STATUS_ID = findIssueStatus.filter(function (row) {
                    return -1 == taskStatusControl.indexOf(row.CONTROL);
                }).map(function (row) {
                    return row.ID;
                });
                widget.currentRow = currentRow;
                ZhFilterPreferences.setOriginalFilter(widget.id, widget.currentRow);
                ZhFilterPreferences.applyOriginalFilter(widget);
            }).catch(ScreenService.hideLoader);
        } else {
            widget.reload();
        }
    };

    this.issueListFieldBeforeSelectOpen = function () {
        getFieldLabelFromIssueListWidget().reload();
    };

    this.issueListWidgetAfterMoveRow = function () {
        var issueListWidget = getWidgetIssueList();
        var issueId = issueListWidget.currentRow.ID;
        var scheduleIssueTabbed = getWidgetScheduleIssueTabbed();
        var scheduleIssueWidget = getWidgetScheduleIssueForm();
        scheduleIssueTabbed.descriptionOrder = issueListWidget.descriptionOrder;
        Utilities.localVar.setScheduleId(issueId);
        scheduleIssueWidget.currentRow.MEETING = Utilities.localVar.getMeetingId();
        scheduleIssueWidget.getField('LABELS_RELATED_USER').reload();
        ScreenService.openSwipe(scheduleIssueTabbed).then(function () {
            scheduleIssueWidget.list();
            ScreenService.showLoader();
            scheduleIssueWidget.reload().then(function () {
                ScreenService.hideLoader();
                scheduleIssueWidget.view();
                scheduleIssueWidget.activate();
                Utilities.fixBugOpenSwipeTabbed(scheduleIssueTabbed);
            }).catch(ScreenService.hideLoader);
        });
    };

    this.issueListActionEventAdd = function () {
        var createScheduleIssueWidget = getWidgetCreateScheduleIssue();
        var currentWidget = templateManager.container.getActiveWidget().name;
        localStorageEngine.setLocalVar('backWidgetAfterActionsCreateScheduleIssue', currentWidget);
        setParentFromCreateScheduleIssue(currentWidget);
        createScheduleIssueWidget.dataSource.data = [];
        createScheduleIssueWidget.newRow();
        ScreenService.openSwipe(createScheduleIssueWidget);
        if(!wentOnCreateScheduleIssueWidgetAtLeastOnce){
            getFieldFollowersFromCreateScheduleIssueWidget().reload();
            wentOnCreateScheduleIssueWidgetAtLeastOnce = true;
        }
        setValueInCreateScheduleIssue();

        getFieldProductFromCreateScheduleIssueWidget().reload();
        getFieldIssueClassificationNameFromCreateScheduleIssueWidget().reload();
        getFieldSponsorFromCreateScheduleIssueWidget().reload();
        getFieldReporterNameFromCreateScheduleIssueWidget().reload();
        getFieldPriorityNameFromCreateScheduleIssueWidget().reload();

        if (currentWidget == 'ISSUE_LIST_SCHEDULE') {
            var scheduleFormCurrentRow = getWidgetScheduleForm().currentRow;
            createScheduleIssueWidget.currentRow.SCHEDULE_RELATIONSHIP_ISSUE = [scheduleFormCurrentRow.TASK_ID];
            var type = getFieldTypeFromCreateScheduleIssueWidget().value();
            var scheduleId = getFieldScheduleRelationshipIssueFromCreateScheduleIssueWidget().value();
            getFieldScheduleRelationshipIssueFromCreateScheduleIssueWidget().reload();
            getOrderTask(type, scheduleId, getFieldOrderIssueFromCreateScheduleIssueWidget());
        }
    };

    var setParentFromCreateScheduleIssue = function (currentWidget) {
        if (currentWidget == 'TASK_LIST') {
            getWidgetCreateScheduleIssue().parent = getWidgetIssueList();
        } else {
            getWidgetCreateScheduleIssue().parent = getWidgetIssueListSchedule();
        }
    };

    var setValueInCreateScheduleIssue = function () {
        setValueLabel(getFieldLabelsRelatedUserIssueFromCreateScheduleIssueWidget());
        var fieldReporter = getFieldReporterNameFromCreateScheduleIssueWidget();
        var userId = Utilities.localVar.getIdBusinessPartner();
        var meetingId = Utilities.localVar.getMeetingId();
        Utilities.setValueInSelectField(fieldReporter, userId);
        ScreenService.showLoader();
        MeetingPlanningService.getAllFollowerInMeeting(meetingId).then(function (response) {
            ScreenService.hideLoader();
            var followers = response.dataset.followers.filter(function (follower) {
                return follower.ID != userId;
            }).map(function (follower) {
                return parseInt(follower.ID);
            });
            var followersField = getFieldFollowersFromCreateScheduleIssueWidget();
            followersField.value(followers);
            Utilities.setValueInSelectField(fieldReporter, userId);
            Utilities.bugPaginationOnSelectMultiplyOnModeView(followersField).then(function(){
                Utilities.windowResizeKanban(300);
            });
        }).catch(ScreenService.hideLoader);
    };

    this.scheduleIssueFormWidgetAfterLoadDataSource = function () {
        var scheduleIssueWidget = getWidgetScheduleIssueForm();
        var scheduleIssueTabbed = getWidgetScheduleIssueTabbed();
        scheduleIssueWidget.moveToFirst();
        scheduleIssueWidget.view();
        getActionDeleteFromScheduleFormWidget().isVisible = false;
        Utilities.bugPaginationOnSelectMultiplyOnModeView(getFieldResourceFromScheduleTaskForm());
        Utilities.bugPaginationOnSelectMultiplyOnModeView(getFieldFollowersFromScheduleIssueForm());
        if (scheduleIssueTabbed.currentWidget && !scheduleIssueTabbed.currentWidget.showAsTab) {
            scheduleIssueTabbed.currentWidget = scheduleIssueTabbed.widgets[0];
        } 
    };

    this.scheduleIssueFormActionEventBack = function () {
        ScreenService.closeSwipe();
        getWidgetIssueList().activate();
    };

    this.scheduleIssueFormActionEventBackEdit = function () {
        var scheduleIssueWidget = getWidgetScheduleIssueForm();
        scheduleIssueWidget.reload();
        scheduleIssueWidget.view();
        scheduleIssueWidget.activate();
    };

    this.scheduleIssueFormActionEventEdit = function () {
        getFieldScheduleRelationshipFromScheduleIssueFormWidget().reload();
        setReadOnlyFromEditScheduleIssueWidget();
        getWidgetScheduleIssueForm().edit();
    };

    var setReadOnlyFromEditScheduleIssueWidget = function () {
        var fieldValue = getFieldScheduleRelationshipFromScheduleIssueFormWidget().value();
        var value = fieldValue.length && fieldValue[0] !== "" ? false : true;
        getFieldLabelsRelatedUserFromScheduleIssueFormWidget().readOnly = value;
        getFieldCommitmentDateFromScheduleIssueFormWidget().readOnly = value;
    };

    this.scheduleRelationshipFieldOnChangeFromScheduleIssueForm = function () {
        setReadOnlyFromEditScheduleIssueWidget();
        var fieldValue = getFieldScheduleRelationshipFromScheduleIssueFormWidget().value();
        var value = fieldValue.length && fieldValue[0] !== "" ? false : true;
        if (value) {
            getFieldLabelsRelatedUserFromScheduleIssueFormWidget().value([]);
            getFieldCommitmentDateFromScheduleIssueFormWidget().value("");
        }
    };

    this.scheduleIssueFormActionEventSave = function () {
        var scheduleIssueWidget = getWidgetScheduleIssueForm();
        var scheduleRelationshipValue = scheduleIssueWidget.currentRow.SCHEDULE_RELATIONSHIP;
        if (scheduleIssueWidget.isValid() && scheduleRelationshipValue[0] !== "") {
            scheduleIssueWidget.saveRow().then(function (response) {
                var issueListWidget = getWidgetIssueList();
                issueListWidget.dataSource.data.some(function(row) {
                    if(row.ID == issueListWidget.currentRow.ID) {
                        setDataGridScheduleByEdit(row, scheduleIssueWidget);
                        return true;
                    }
                });
                scheduleIssueWidget.view();
                reloadInMeeting(response);
            }).catch(function(response){
                Utilities.showMessageErrorOfBackEnd(response, Utilities.messages.ERR_CONTAINER_MEETING_PLANNING);
            });
        }
    };

    this.commentsWidgetOnEnterTab = function (args) {
        getWidgetComments().reload();
    };

    this.documentsWidgetOnEnterTab = function (args) {
        getWidgetDocuments().reload();
    };

    this.newCommentActionEventSaveNewComment = function (args) {
        var newCommentWidget = getWidgetNewComment();
        if (newCommentWidget.isValid()) {
            newCommentWidget.saveRow().then(function () {
                getWidgetComments().reload();
                self.newCommentActionEventBackEditNewComment();
            }).catch(function(response){
                Utilities.showMessageErrorOfBackEnd(response,Utilities.messages.ERR_CONTAINER_MEETING_PLANNING);
            });
        }
    };

    this.commentScheduleActionEventSaveNewComment = function (args) {
        var newCommentWidget = getWidgetCommentSchedule();
        if (newCommentWidget.isValid()) {
            newCommentWidget.currentRow.COMMENT_TYPE_ID = 0;
            newCommentWidget.saveRow().then(function(response){
                reloadInMeeting(response);
                ScreenService.showLoader();
                newCommentWidget.reload().then(function() {
                    ScreenService.hideLoader();
                    newCommentWidget.view();
                    newCommentWidget.setCurrentRow(Utilities.getRowInDataSource(newCommentWidget.dataSource, 'ID', response.dataset.comments[0].ID));
                }).catch(ScreenService.hideLoader);
                
            }).catch(function(response){
                Utilities.showMessageErrorOfBackEnd(response,Utilities.messages.ERR_CONTAINER_MEETING_PLANNING);
            });
        }
    };

    this.documentsActionEventAddDocuments = function (args) {
        var newDocumentWidget = getWidgetNewDocument();
        newDocumentWidget.dataSource.data = [];
        newDocumentWidget.newRow();
        ScreenService.openPopup(newDocumentWidget);
    };

    this.newDocumentActionEventUpload = function (args) {
        var newDocumentWidget = getWidgetNewDocument();
        var documentsWidget = getWidgetDocuments();
        MeetingPlanningService.newUploadDocumentMeetingProject(newDocumentWidget.currentRow).then(function (response) {
            documentsWidget.reload();
            self.newDocumentsActionEventBack();
        });
    };

    this.newDocumentsActionEventBack = function () {
        ScreenService.closePopup();
        Utilities.fixBugMasterDetail(getWidgetDocuments());
    };

    var scheduleFormBack = function (notReload) {
        var scheduleListWidget = getWidgetScheduleList();
        if(!notReload){
            scheduleListWidget.reload();
        }
        ScreenService.closeSwipe();
        scheduleListWidget.activate();
    };

    this.scheduleFormActionEventBack = function (args) {
        scheduleFormBack(true);
    };

    this.scheduleFormActionEventBackEdit = function (args) {
        var scheduleFormWidget = getWidgetScheduleForm();
        scheduleFormWidget.reload();
        scheduleFormWidget.view();
        scheduleFormWidget.activate();
    };

    this.taskFormScheduleActionEventEdit = function (args) {
        var taskFormSchedule = getWidgetTaskFormSchedule();
        taskFormSchedule.edit();
        taskFormSchedule.template = taskFormSchedule.templateToForm;
    };

    this.taskFormScheduleActionEventBackEdit = function (args) {
        Utilities.fixBugReloadWidgetInViewMode(getWidgetTaskFormSchedule());
    };

    this.scheduleTaskFormWidgetAfterLoadDataSource = function () {
        var scheduleTaskWidget = getWidgetScheduleTaskForm();
        var scheduleTaskTabbed = getWidgetScheduleTaskTabbed();
        scheduleTaskWidget.moveToFirst();
        scheduleTaskWidget.view();
        getActionDeleteFromScheduleFormWidget().isVisible = false;
        Utilities.bugPaginationOnSelectMultiplyOnModeView(getFieldResourceFromScheduleTaskForm());
        if (scheduleTaskTabbed.currentWidget && !scheduleTaskTabbed.currentWidget.showAsTab) {
            scheduleTaskTabbed.currentWidget = scheduleTaskTabbed.widgets[0];
        } 
    }; 

    this.scheduleTaskFormActionEventSave = function (args) {
        var scheduleTaskWidget = getWidgetScheduleTaskForm();
        var scheduleRelationshipValue = scheduleTaskWidget.currentRow.SCHEDULE_RELATIONSHIP;
        if (scheduleTaskWidget.isValid() && scheduleRelationshipValue[0] !== "") {
            scheduleTaskWidget.saveRow().then(function (response) {
                var widgetTaskList = getWidgetTaskList();
                widgetTaskList.dataSource.data.some(function (row) {
                    if (row.ID == widgetTaskList.currentRow.ID) {
                        setDataGridScheduleByEdit(row, scheduleTaskWidget);
                        return true;
                    }
                });
                scheduleTaskWidget.view();
                reloadInMeeting(response);
            }).catch(function (response) {
                Utilities.showMessageErrorOfBackEnd(response, Utilities.messages.ERR_CONTAINER_MEETING_PLANNING);
            });
        }
    };
    

    this.scheduleTaskFormActionEventBack = function(){
        var taskListWidget = getWidgetTaskList();
        ScreenService.closeSwipe();
        taskListWidget.activate();
    };

    this.scheduleTaskFormActionEventEdit = function (){
        var scheduleTaskWidget = getWidgetScheduleTaskForm();
        getFieldNameFromScheduleTaskForm().readOnly = true;
        getFieldClassificationFromScheduleTaskForm().readOnly = true;
        getFieldResourceFromScheduleTaskForm().readOnly = true;
        getFieldTaskStatusFromScheduleTaskForm().readOnly = true;
        getFieldDescriptionFromScheduleTaskForm().readOnly = true;
        getFieldScheduleRelationshipFromScheduleTaskForm().reload();
        setReadOnlyFromCreateScheduleTaskWidget();
        scheduleTaskWidget.edit();

    };

    var setReadOnlyFromCreateScheduleTaskWidget = function () {
        var fieldValue = getFieldScheduleRelationshipFromScheduleTaskForm().value();
        var value = fieldValue.length && fieldValue[0] !== "" ? false : true;
        getFieldLabelRelatedUserFromScheduleTaskForm().readOnly = value;
        getFieldCommitentDateFromScheduleTaskForm().readOnly = value;
    };

    this.scheduleRelationshipFieldOnChangeFromScheduleTaskForm = function () {
        setReadOnlyFromCreateScheduleTaskWidget();
        var fieldValue = getFieldScheduleRelationshipFromScheduleTaskForm().value();
        var value = fieldValue.length && fieldValue[0] !== "" ? false : true;
        if (value) {
            getFieldLabelRelatedUserFromScheduleTaskForm().value([]);
            getFieldCommitentDateFromScheduleTaskForm().value("");
        }
    };

    this.scheduleTaskFormActionEventBackEdit = function () {
        var scheduleTaskWidget = getWidgetScheduleTaskForm();
        scheduleTaskWidget.reload();
        scheduleTaskWidget.view();
        scheduleTaskWidget.activate();
    };

    var backToTaskTabbedScheduleWithCloseSwipe = function () {
        var tabbedSchedule = getWidgetScheduleTabbed();
        var currentWidget = tabbedSchedule.currentWidget;
        ScreenService.closeSwipe();
        tabbedSchedule.currentWidget = currentWidget;
        currentWidget.reload();
        tabbedSchedule.activate();
    };

    this.taskFormScheduleActionEventBack = function (args) {
        backToTaskTabbedScheduleWithCloseSwipe();
    };

    this.taskListScheduleActionEventBack = function (args) {
        scheduleFormBack(true);
    };

    this.issueListScheduleActionEventBack = function (args) {
        scheduleFormBack(true);
    };

    this.documentsActionEventDownload = function (args) {
        Utilities.downloadAttachment(getWidgetDocuments().currentRow.ID);
    };

    this.commentsActionEventAddComments = function (args) {
        var newCommentWidget = getWidgetNewComment();
        newCommentWidget.dataSource.data = [];
        newCommentWidget.newRow();
        newCommentWidget.currentRow.PROJECT = Utilities.localVar.getMeetingId();
        ScreenService.openPopup(newCommentWidget);
    };

    this.commentScheduleActionEventAddComments = function (args) {
        var commentSchedule = getWidgetCommentSchedule();
        commentSchedule.newRow();
        commentSchedule.currentRow.TASK = Utilities.localVar.getScheduleId();
    };


    this.commentsActionEventBackView = function () {
        ScreenService.closeSwipe();
        Utilities.fixBugMasterDetail(getWidgetComments());
    };

    this.newCommentActionEventBackEditNewComment = function (args) {
        ScreenService.closePopup();
        Utilities.fixBugMasterDetail(getWidgetComments());
    };

    this.commentScheduleActionEventBackEdit = function (args) {
        Utilities.cancelEditMasterDetail(getWidgetCommentSchedule());
    };

    this.commentScheduleActionEventBackView = function (args) {
        Utilities.goBackViewMasterDetail(getWidgetCommentSchedule());
    };

    this.commentScheduleActionEventEdit = function (args) {
        getWidgetCommentSchedule().edit();
    };

    var addTaskIssueSchedule = function () {
        var createTaskIssueWidget = getWidgetCreateTaskIssue();
        createTaskIssueWidget.dataSource.data = [];
        createTaskIssueWidget.newRow();
        setVisibilityFieldGroupInCreateTaskIssue();
        createTaskIssueWidget.template = createTaskIssueWidget.templateToForm;
        ScreenService.openSwipe(createTaskIssueWidget);
    };

    this.scheduleListActionEventAdd = function(){
        var createScheduleWidget = getWidgetCreateSchedule();
        createScheduleWidget.dataSource.data = [];
        createScheduleWidget.newRow();
        ScreenService.openSwipe(createScheduleWidget);
        getFieldScheduleClassificationLabelfromCreateScheduleWidget().reload();
        getFieldScheduleResourcefromCreateScheduleWidget().reload();
        getFieldTaskStatusNamefromCreateScheduleWidget().reload();
        setPrimaryScheduleParent();
    };

    this.taskListActionEventAdd = function () {
        var createScheduleTaskWidget = getWidgetCreateScheduleTask();
        var currentWidget = templateManager.container.getActiveWidget().name;
        localStorageEngine.setLocalVar('backWidgetAfterActionsCreateScheduleTask', currentWidget);
        createScheduleTaskWidget.dataSource.data = [];
        setParentFromCreateScheduleTask(currentWidget);
        createScheduleTaskWidget.newRow();
        ScreenService.openSwipe(createScheduleTaskWidget);

        getFieldProjectFromCreateScheduleTaskWidget().reload();
        getFieldTaskClassificationLabelFromCreateScheduleTaskWidget().reload();
        getFieldResourceFromCreateScheduleTaskWidget().reload();
        getFieldParentNameFromCreateScheduleTaskWidget().reload();

        getFieldScheduleRelationshipTaskFromCreateScheduleTaskWidget().reload();
        if (currentWidget == 'TASK_LIST_SCHEDULE') {
            var scheduleFormCurrentRow = getWidgetScheduleForm().currentRow;
            createScheduleTaskWidget.currentRow.SCHEDULE_RELATIONSHIP_TASK = [scheduleFormCurrentRow.TASK_ID];
            var type = getFieldTypeFromCreateScheduleTaskWidget().value();
            var scheduleId = getFieldScheduleRelationshipTaskFromCreateScheduleTaskWidget().value();
            getOrderTask(type, scheduleId, getFieldOrderTaskFromCreateScheduleTaskWidget());
        }
        getFieldLabelsRelatedUserTaskFromCreateScheduleTaskWidget().reload().then(function(){
            setValueLabel(getFieldLabelsRelatedUserTaskFromCreateScheduleTaskWidget());
        });
    };

    var setParentFromCreateScheduleTask = function (currentWidget) {
        if (currentWidget == 'TASK_LIST') {
            getWidgetCreateScheduleTask().parent = getWidgetTaskList();
        } else {
            getWidgetCreateScheduleTask().parent = getWidgetTaskListSchedule();
        }
    };

    this.taskListScheduleActionEventAdd = function (args) {
        self.taskListActionEventAdd();
    };

    this.issueListScheduleActionEventAdd = function (args) {
        getFieldPriorityFromTaskFormCreateScheduleWidget().reload();
        getWidgetCreateScheduleIssue().parent = getWidgetIssueListSchedule();
        self.issueListActionEventAdd();
    };

    this.getValueFieldNameWidgetInfoMeeting = function () {
        return getFieldNameFromInfoMeetingWidget().value();
    };

    this.getValueFieldIdWidgetComments = function () {
        return getFieldIdFromCommentsWidget().value();
    };

    this.infoMeetingWidgetAfterLoadDataSource = function (args) {
        getWidgetInfoMeeting().moveToFirst();
        setEnableCreateMeetingRecurrent();
        
        ScreenService.showLoader();
        ZHPromise.all([
            Utilities.bugPaginationOnSelectMultiplyOnModeView(getFieldResourceFromInfoMeetingWidget()),
            Utilities.bugPaginationOnSelectMultiplyOnModeView(getFieldClientFromInfoMeetingWidget())
        ]).then(ScreenService.hideLoader).catch(ScreenService.hideLoader);
        
        setVisibilityFieldsInfoMeetingWidget();
        setVisibilityActionsInfoMeetingWidget();
    };

    var setReadOnlyByProjectStatusControl = function (control) {
        var actionIsVisible = true;
        if (control) {
            actionIsVisible = (control == 'N' || control == 'D');
        }
        getActionDeleteFromInfoMeetingWidget().isVisible = actionIsVisible;
        getActionAddFromScheduleListWidget().isVisible = actionIsVisible;
        setScheduleActionsVisible(actionIsVisible);
        getWidgetScheduleForm().pmActionIsVisible = actionIsVisible;
        var infoMeeting = getWidgetInfoMeeting();
        infoMeeting.fields.filter(function (field) {
            return field.PMReadOnlyConcluded == "Y";
        }).forEach(function (field) {
            field.readOnly = (control == 'C');
        });
    };

    this.infoMeetingActionEventBack = function (args) {
        goBackToListMeeting();
    };

    this.infoMeetingActionEventBackEdit = function (args) {
        var infoMeetingWidget = getWidgetInfoMeeting();
        if (infoMeetingWidget.currentRow.ID) {
            ScreenService.showLoader();
            infoMeetingWidget.reload().then(function() {
                ScreenService.hideLoader();
                setReadOnlyByProjectStatusControl(infoMeetingWidget.currentRow.PROJECT_STATUS_CONTROL);
                infoMeetingWidget.moveToFirst();
                infoMeetingWidget.view();
                infoMeetingWidget.formTemplate = infoMeetingWidget.templateToView;
                var listMeetingWidget = getWidgetListMeeting();
                listMeetingWidget.reload();
                templateManager.updateTemplate();
            }).catch(ScreenService.hideLoader);
        } else {
            goBackToListMeeting();
        }
    };

    this.scheduleListActionEventBack = function (args) {
        goBackToListMeeting();
    };

    this.commentsActionEventBackList = function (args) {
        goBackToListMeeting();
    };

    this.commentScheduleActionEventBackList = function (args) {
        scheduleFormBack(true);
    };

    this.documentsActionEventBackList = function (args) {
        goBackToListMeeting();
    };

    this.documentsActionEventBackView = function (args) {
        ScreenService.closeSwipe();
        Utilities.fixBugMasterDetail(getWidgetDocuments());
    };

    this.createMeetingPlanningActionEventBack = function (args) {
        ScreenService.closePopup();
        getWidgetInfoMeeting().activate();
    };

    this.taskListScheduleWidgetOnSaveInlineEdit = function (args) {
        var rows = args.e.data.changedRows;
        var taskListWidget = getWidgetTaskListSchedule();
        saveOrder(rows, taskListWidget);
    };
    var reloadInMeeting = function(response){
        if(response &&
            response.dataset &&
            response.dataset.reload &&
            response.dataset.reload.RELOAD){
            getWidgetListMeeting().reload();
        }
    };

    var saveOrder = function (rows, listWidget) {
        MeetingPlanningService.saveOrder(rows).then(function (response) {
            listWidget.reload();
            listWidget.activate();
            listWidget.list();
            reloadInMeeting(response);
            ScreenService.successNotification(Utilities.messages.SUC_ORDER_SAVE);
        }).catch(function (response) {
            Utilities.showMessageErrorOfBackEnd(response);
        });
    };

    this.issueListScheduleWidgetOnSaveInlineEdit = function (args) {
        var rows = args.e.data.changedRows;
        var issueListWidget = getWidgetIssueListSchedule();
        saveOrder(rows, issueListWidget);
    };

    var saveScheduleListOrder = function(rows, scheduleListWidget){
        MeetingPlanningService.saveScheduleListOrder(rows).then(function (response) {
            scheduleListWidget.reload();
            scheduleListWidget.activate();
            scheduleListWidget.list();
            reloadInMeeting(response);
            ScreenService.successNotification(Utilities.messages.SUC_ORDER_SAVE);
        }).catch(function (response) {
            Utilities.showMessageErrorOfBackEnd(response);
        });
    };

    this.createScheduleActionEventBack = function (args) {
        ScreenService.closeSwipe();
        getWidgetScheduleList().activate();
    };

    this.createScheduleActionEventSave = function () {
        var createScheduleWidget = getWidgetCreateSchedule();
        if (createScheduleWidget.isValid()){
            createScheduleWidget.saveRow().then(function(response){
                self.createScheduleActionEventBack();
                getWidgetScheduleList().reload();
            }).catch(function (response) {
                Utilities.showMessageErrorOfBackEnd(response, Utilities.messages.ERR_CONTAINER_MEETING_PLANNING);
            });
        }
    };

    this.createScheduleTaskFieldOnChangeProject = function (args) {
        var parentField = getFieldParentNameFromCreateScheduleTaskWidget();
        var resourceField = getFieldResourceFromCreateScheduleTaskWidget();
        var taskClassificationLabelField = getFieldTaskClassificationLabelFromCreateScheduleTaskWidget();
        var projectField = getFieldProjectFromCreateScheduleTaskWidget();
        var primaryValue = Utilities.getValueInSelectField(projectField);
        var projectRow = Utilities.getRowInDataSource(projectField.dataSource, projectField.valueField, primaryValue);
        Utilities.localVar.setProject(primaryValue);
        Utilities.localVar.setLocalVarProjectType(projectRow.PROJECT_TYPE);
        Utilities.localVar.setLocalVarProjectStatus(projectRow.PROJECT_STATUS);
        Utilities.clearValueSelect(parentField);
        Utilities.clearValueSelect(taskClassificationLabelField);
        parentField.reload();
        resourceField.reload();
        taskClassificationLabelField.reload();
    };

    this.createScheduleTaskFieldOnChangeScheduleRelationshipTask = function () {
        var type = getFieldTypeFromCreateScheduleTaskWidget().value();
        var scheduleId = getFieldScheduleRelationshipTaskFromCreateScheduleTaskWidget().value();
        var orderTaskField = getFieldOrderTaskFromCreateScheduleTaskWidget();
        MeetingPlanningService.getNextTaskOrderByTypeAndSchedule(scheduleId, type).then(function (nextTaskOrder) {
            orderTaskField.value(nextTaskOrder);
        });
    };

    this.createScheduleTaskActionEventBack = function () {
        var currentWidget = localStorageEngine.getLocalVar('backWidgetAfterActionsCreateScheduleTask');
        if(currentWidget == 'TASK_LIST'){
            ScreenService.closeSwipe();
            getWidgetTaskList().activate();
        } else {
            backToTaskTabbedScheduleWithCloseSwipe();
        }
    };

    this.createScheduleTaskActionEventSave = function () {
        var createScheduleTaskWidget = getWidgetCreateScheduleTask();
        if (createScheduleTaskWidget.isValid()){
            createScheduleTaskWidget.saveRow().then(function(response){
                self.createScheduleTaskActionEventBack();
                getWidgetTaskList().reload();
            }).catch(function (response) {
                Utilities.showMessageErrorOfBackEnd(response, Utilities.messages.ERR_CONTAINER_MEETING_PLANNING);
            });
        }
    };

    this.createScheduleIssueActionEventBack = function () {
        var currentWidget = localStorageEngine.getLocalVar('backWidgetAfterActionsCreateScheduleIssue');
        if(currentWidget == 'ISSUE_LIST'){
            ScreenService.closeSwipe();
            getWidgetIssueList().activate();
        } else {
            backToTaskTabbedScheduleWithCloseSwipe();
        }
    };

    this.createScheduleIssueActionEventSave = function () {
        var createScheduleIssueWidget = getWidgetCreateScheduleIssue();
        if (createScheduleIssueWidget.isValid()) {
            createScheduleIssueWidget.saveRow().then(function (response) {
                self.createScheduleIssueActionEventBack();
                getWidgetIssueList().reload();
            }).catch(function (response) {
                Utilities.showMessageErrorOfBackEnd(response, Utilities.messages.ERR_CONTAINER_MEETING_PLANNING);
            });
        }
    };

    this.createTaskIssuePlanningActionEventSave = function (args) {
        var createTaskIssueWidget = getWidgetCreateTaskIssue();
        if (createTaskIssueWidget.isValid()) {
            createTaskIssueWidget.saveRow().then(function (response) {
                goBackScheduleList();
                if(!(createTaskIssueWidget.currentRow.ORIGIN_TASK_LIST ||
                    createTaskIssueWidget.currentRow.ORIGIN_ISSUE_LIST)){
                    getWidgetScheduleList().reload();
                }
                if(response &&
                    response.dataset &&
                    response.dataset.createTaskIssueMeeting &&
                    response.dataset.createTaskIssueMeeting.RELOAD){
                    getWidgetListMeeting().reload();
                }
            }).catch(function(response){
                Utilities.showMessageErrorOfBackEnd(response,Utilities.messages.ERR_CONTAINER_MEETING_PLANNING);
            });
        }
    };
    
    var saveMeeting = function(){
        var infoMeetingWidget = getWidgetInfoMeeting();
        infoMeetingWidget.saveRow().then(function (response) {
            Utilities.localVar.setMeetingId(response.dataset.projects[0]);
            ScreenService.showLoader();
            infoMeetingWidget.reload().then(function () {
                ScreenService.hideLoader();
                setReadOnlyByProjectStatusControl(infoMeetingWidget.currentRow.PROJECT_STATUS_CONTROL);
                infoMeetingWidget.moveToFirst();
                infoMeetingWidget.view();
                infoMeetingWidget.formTemplate = infoMeetingWidget.templateToView;
                var listMeetingWidget = getWidgetListMeeting();
                listMeetingWidget.reload();
                reloadScheduleList = true;
                templateManager.updateTemplate();
            }).catch(ScreenService.hideLoader);
        }).catch(function (response) {
            Utilities.showMessageErrorOfBackEnd(response, Utilities.messages.ERR_CONTAINER_MEETING_PLANNING);
        });
    };

    this.infoMeetingActionEventSave = function (args) {
        var infoMeetingWidget = getWidgetInfoMeeting();
        if (infoMeetingWidget.isValid()) {
            var currentRow = infoMeetingWidget.currentRow;
            if (
                (currentRow.PROJECT_STATUS_CONTROL == 'C' ||
                currentRow.PROJECT_STATUS_CONTROL == 'X') &&
                currentRow.PROJECT_TYPE_CONTROL == 'M'
            ) {
                ScreenService.showCustomDialog(Utilities.messages.ALE_CHANGE_MEETING_STATUS,
                    'CONFIRMATION', null,
                    [
                        {
                            "label": "Sim",
                            "code": saveMeeting
                        },
                        {
                            "label": "Não",
                            "code": ''
                        }
                    ]
                );
            } else {
                saveMeeting();
            }
            setTabsEnableFromScheduleTabbed(currentRow);
        }

    };

    this.commentsActionEventDelete = function (args) {
        var widgetComments = getWidgetComments();
        ScreenService.confirmMessage(Utilities.messages.DES_DELETE_ATA_MEETING,null,function(){
            widgetComments.dataSource.remove([widgetComments.currentRow]).then(function(data){
                widgetComments.reload();
                self.commentsActionEventBackView();
            });
        }, null);
    };

    this.commentScheduleActionEventDelete = function (args) {
        var widgetComments = getWidgetCommentSchedule();
        ScreenService.confirmMessage(Utilities.messages.DES_DELETE_ATA_MEETING,null,function(){
            Utilities.deteleViewMasterDetail(widgetComments).then(function(){
                getWidgetListMeeting().reload();
            });
        }, null);
    };

    this.documentsActionEventDeleteDocuments = function (args) {
        var widgetDocuments = getWidgetDocuments();
        ScreenService.confirmMessage(Utilities.messages.DES_DELETE_ATA_DOCUMENTS,null,function(){
            widgetDocuments.dataSource.remove([widgetDocuments.currentRow]).then(function(){
                widgetDocuments.list();
                widgetDocuments.reload();
                self.documentsActionEventBackView(widgetDocuments);
            });
        }, null);
    };

    var goBackToInfoMeeting = function () {
        ScreenService.closePopup();
        getWidgetInfoMeeting().activate();
    };

    this.infoMeetingFieldOnChangeManager = function () {
        var projectSprintField = getFieldProjectSprintFromInfoMeetingWidget();
        projectSprintField.value([]);
        projectSprintField.reload();
    };

    var setValidationFieldsInCreateTaskIssue = function (createTaskIssueWidget, fieldGroup, validations) {
        createTaskIssueWidget.fields.filter(function (field) {
            return field.fieldGroup == fieldGroup.name;
        }).forEach(function (field) {
            if (field.PMValidations) {
                field.validations = validations;
            }
        });
    };
    var setVisibilityFieldGroupInCreateTaskIssue = function () {
        var createTaskIssueWidget = getWidgetCreateTaskIssue();
        var fieldGroups = createTaskIssueWidget.fieldGroups;
        var control = getFieldTypeFromCreateTaskIssue().value();

        fieldGroups.filter(function (fieldGroup) {
            return !!fieldGroup.PMType;
        }).forEach(function (fieldGroup) {
            if (fieldGroup.PMType == control) {
                fieldGroup.isVisible = true;
                setValidationFieldsInCreateTaskIssue(createTaskIssueWidget, fieldGroup, {"required": {}});
            } else {
                fieldGroup.isVisible = false;
                setValidationFieldsInCreateTaskIssue(createTaskIssueWidget, fieldGroup, null);
            }
        });
    };
    var reloadFieldInCreateTaskIssue = function () {
        var createTaskIssueWidget = getWidgetCreateTaskIssue();
        var fields = createTaskIssueWidget.fields;
        var control = getFieldTypeFromCreateTaskIssue().value();

        return ZHPromise.all(fields.filter(function (field) {
            return !!field.PMControl;
        }).map(function (field) {
            if (field.PMControl == control) {
                return field.reload();
            }
        }));
    };

    var setPrimaryScheduleParent = function () {
        var fieldScheduleParent = getFieldScheduleParentNamefromCreateScheduleWidget();
            var primarySchedule = fieldScheduleParent.dataSource.data.filter(function (row) {
                return !row.PARENT;
            })[0];
            if (primarySchedule) {
                Utilities.setOutData(fieldScheduleParent, primarySchedule[fieldScheduleParent.valueField]);
            }
    };

    var afterAllReloadFieldInCreateTaskIssue = function() {
        var control = getFieldTypeFromCreateTaskIssue().value();
        if (control == 'P') {
            setPrimaryScheduleParent();
        } else if (control == 'T') {
            setValueLabel(getFieldLabelsRelatedUserTaskFromCreateTaskIssue());
        } else if (control == 'I') {
            setValueInCreateIssue();
        }
        templateManager.updateTemplate();
    };
    var setValueLabel = function (fieldLabel) {
        getFieldLabelsRelatedUserIssueFromCreateScheduleIssueWidget().reload().then(function() {
            if (fieldLabel.dataSource.data.length >= 1) {
                var value = [];
                fieldLabel.dataSource.data.forEach(function(data){
                    value.push(data.ID);
                });
                fieldLabel.value(value);
            }
        });
    };

    var setValueInCreateIssue = function () {
        setValueLabel(getFieldLabelsRelatedUserIssueFromCreateTaskIssue());
        var fieldReporter = getFieldReporterNameFromCreateTaskIssue();
        var userId = Utilities.localVar.getIdBusinessPartner();
        var meetingId = Utilities.localVar.getMeetingId();
        Utilities.setValueInSelectField(fieldReporter, userId);
        MeetingPlanningService.getAllFollowerInMeeting(meetingId).then(function(response){
            var followers = response.dataset.followers.filter(function(follower){
                return follower.ID != userId;
            }).map(function(follower){
                return parseInt(follower.ID);
            });
            var followersField = getFieldFollowersFromCreateTaskIssue();
            followersField.value(followers);
            Utilities.setValueInSelectField(fieldReporter,userId);
            Utilities.bugPaginationOnSelectMultiplyOnModeView(followersField);
        });

    };

    this.createTaskIssueFieldOnChangeType = function () {
        setVisibilityFieldGroupInCreateTaskIssue();
        Utilities.localVar.setTaskLabelTypeId(getFieldTypeFromCreateTaskIssue().value());
        reloadFieldInCreateTaskIssue().then(function(){
            afterAllReloadFieldInCreateTaskIssue();
        });

    };

    var getOrderTask = function(type,scheduleId,fieldOrder){
        MeetingPlanningService.getNextTaskOrderByTypeAndSchedule(scheduleId,type).then(function(nextTaskOrder){
            fieldOrder.value(nextTaskOrder);
        });
    };
    var setOrderTaskInIssue = function(){
        var scheduleId = getFieldScheduleRelationshipIssueFromCreateTaskIssue().value();
        getOrderTask('T', scheduleId,getFieldOrderIssueFromCreateTaskIssue());
    };

    var setOrderTaskInTask = function(){
        var type = getFieldTypeFromCreateTaskIssue().value();

        var scheduleId = getFieldScheduleRelationshipTaskFromCreateTaskIssue().value();
        getOrderTask(type,scheduleId,getFieldOrderTaskFromCreateTaskIssue());
    };

    this.createTaskIssueFieldOnChangeScheduleRelationshipTask = function () {
        setOrderTaskInTask();
    };

    this.createTaskIssueFieldOnChangeScheduleParentName = function () {
        var fieldScheduleParent = getFieldTypeFromScheduleParentName();
        if(!fieldScheduleParent.value()) {
            setPrimaryScheduleParent();
        }
    };

    this.infoMeetingActionEventNewMeetingPlanning = function (args) {
        var createMeetingWidget = getWidgetCreateMeetingPlanning();
        MeetingPlanningService.createMeetingActionEventNew(createMeetingWidget);
        createMeetingWidget.currentRow.ID = Utilities.localVar.getMeetingId();
        createMeetingWidget.currentRow.PROJECT_TYPE_CONTROL = createMeetingWidget.PMBeginProjectTypeControl;
        setVisibilityFieldsInfoMeetingWidget();
    };

    this.createMeetingFieldOnChangeRecurrenceType = function (args) {
        MeetingPlanningService.createMeetingFieldOnChangeRecurrenceType(Utilities.getFieldByArgs(args), getWidgetCreateMeetingPlanning());
    };

    this.createMeetingPlanningFieldOnChangeBeginDate = function (args) {
        MeetingPlanningService.createMeetingPlanningFieldOnChangeBeginDate(getWidgetCreateMeetingPlanning());
    };

    this.createMeetingFieldOnChangeType = function (args) {
        MeetingPlanningService.createMeetingFieldOnChangeType(args.owner.value(), getWidgetCreateMeetingPlanning());
    };

    this.createMeetingFieldOnChangeYearDayExceptionMonth = function (args) {
        MeetingPlanningService.createMeetingFieldOnChangeYearDayExceptionMonth(args.owner.field, getWidgetCreateMeetingPlanning());
    };

    this.createMeetingFieldOnChangeYearDayExceptionYear = function (args) {
        MeetingPlanningService.createMeetingFieldOnChangeYearDayExceptionYear(args.owner.field, getWidgetCreateMeetingPlanning());
    };

    this.createMeetingFieldOnChangeWeekDayExceptionMonth = function (args) {
        MeetingPlanningService.createMeetingFieldOnChangeWeekDayExceptionMonth(args.owner.field, getWidgetCreateMeetingPlanning());

    };
    this.createMeetingFieldOnChangeWeekDayExceptionYear = function (args) {
        MeetingPlanningService.createMeetingFieldOnChangeWeekDayExceptionYear(args.owner.field, getWidgetCreateMeetingPlanning());

    };
    this.createMeetingFieldOnChangeExceptionQuantitative = function (args) {
        MeetingPlanningService.createMeetingFieldOnChangeExceptionQuantitative(getWidgetCreateMeetingPlanning());

    };
    this.createMeetingFieldOnChangeExceptionDataEnd = function (args) {
        MeetingPlanningService.createMeetingFieldOnChangeExceptionDataEnd(getWidgetCreateMeetingPlanning());

    };

    this.createMeetingWidgetAfterMoveRow = function (args) {
        MeetingPlanningService.createMeetingWidgetAfterMoveRow(args.row.ID, getWidgetTabbedMeeting(), getWidgetCreateMeetingPlanning());
    };

    this.createMeetingPlanningActionEventSave = function (args) {
        var createMeetingWidget = getWidgetCreateMeetingPlanning();
        var promise = MeetingPlanningService.createMeetingPlanningActionEventSave(createMeetingWidget, getWidgetInfoMeeting());
        if (promise) {
            promise.then(function () {
                ScreenService.closePopup();
                ScreenService.restoreDefaultLoadingMessage();
                goBackToListMeeting();
                getWidgetListMeeting().reload();
            }).catch(function (response) {
                ScreenService.restoreDefaultLoadingMessage();
                if(response && response.data && response.data.error && response.data.error.split("Code:").pop() == '33'){
                    response.data.error = response.data.error.split("Code:").shift();
                    Utilities.showMessageErrorOfBackEnd(response, Utilities.messages.ERR_CONTAINER_MEETING_PLANNING,null,true);
                }else{
                    Utilities.showMessageErrorOfBackEnd(response, Utilities.messages.ERR_CONTAINER_MEETING_PLANNING);
                }
            });
        }
    };

    this.initializeFieldFromWidgetCreateScheduleIsuue = function (fieldName, args) {
        var field = getWidgetCreateScheduleIssue().getField(fieldName);
        field.initializeField();
    };

    this.infoMeetingActionEventEdit = function (args) {
        var infoMeetingWidget = getWidgetInfoMeeting();
        infoMeetingWidget.edit();
        getFieldManagerFromInfoMeetingWidget().reload();
        getFieldProjectStatusFromInfoMeetingWidget().reload();
        setReadOnlyFieldsInfoMeetingWidget(false);
    };

    this.listMeetingWidgetOnEnter = function (args) {
        ScreenService.showLoader();
        Utilities.localVar.getLoginPromise().then(function(){
            var widget = getWidgetListMeeting();
            if(!Utilities.isAppliedFilter(widget)) {
                var projectStatusField = getFieldProjectStatusIdFromListMeeting();
                projectStatusField.reload().then(function() {
                    ScreenService.hideLoader();
                    widget.currentRow.PROJECT_STATUS_ID = Utilities.getDefaultValuesToSelectMultipleField(projectStatusField, ['N', 'P', 'D'], 'CONTROL');
                    widget.currentRow.MANAGER = [parseInt(Utilities.localVar.getIdBusinessPartner())];
                    ZhFilterPreferences.setOriginalFilter(widget.id, widget.currentRow);
                    Utilities.applyDefaultFilterOnEnter(widget, true);
                }).catch(ScreenService.hideLoader);
            } else {
                ScreenService.hideLoader();
            }
        }).catch(ScreenService.hideLoader);
    };

    this.scheduleListWidgetAfterLoadDataSource = function (args) {
        Utilities.bugPaginationOnSelectMultiplyOnModeList(getFieldManagerFromScheduleListWidget());
    };
    
    this.managerFieldAfterLoadDataSourceScheduleListWidget = function (args){
        Utilities.bugPaginationOnSelectMultiplyOnModeList(getFieldManagerFromScheduleListWidget());
    };
    this.productFieldFromListIssueToScheduleWidgetOnChange = function (){
        var widget = getWidgetListIssueToSchedulel();
        Utilities.localVar.setProjectId(widget.currentRow.PRODUCT);
        getFieldListIssueToSchedulel().reload();
    };

    this.scheduleFormWidgetAfterLoadDataSource = function (args) {
        var scheduleWidget = getWidgetScheduleForm();
        var scheduleTabbed = getWidgetScheduleTabbed();
        scheduleWidget.moveToFirst();
        scheduleWidget.view();
        getActionDeleteFromScheduleFormWidget().isVisible = validateEditSchedule();
        Utilities.localVar.setTaskLabelTypeId(scheduleWidget.currentRow.TYPE_LABEL);
        getFieldParentNameFromLabelsRelatedUserFormWidget().reload();
        Utilities.bugPaginationOnSelectMultiplyOnModeView(getFieldResourceFromScheduleForm());
        if (scheduleTabbed.currentWidget && !scheduleTabbed.currentWidget.showAsTab) {
            scheduleTabbed.currentWidget = scheduleTabbed.widgets[0];
        } 
    };

    this.taskScheduleFormWidgetAfterLoadDataSource = function (args) {
        var scheduleWidget = getWidgetTaskFormSchedule();
        var scheduleTabbed = getWidgetTaskTabbedSchedule();
        scheduleWidget.moveToFirst();
        scheduleWidget.view();
        scheduleWidget.template = scheduleWidget.templateToView;
        Utilities.localVar.setTaskLabelTypeId(scheduleWidget.currentRow.TYPE_LABEL);
        var isIssue = (scheduleWidget.currentRow.TYPE_LABEL == 'I') ? 'Y' : 'N';
        setFieldTaskFormSchedule(scheduleWidget.currentRow.IS_SCHEDULE, isIssue);
        Utilities.bugPaginationOnSelectMultiplyOnModeView(getFieldResourceFromTaskFormSchedule());
        Utilities.bugPaginationOnSelectMultiplyOnModeView(getFieldFollowersFromTaskFormSchedule());
        if (scheduleTabbed.currentWidget && !scheduleTabbed.currentWidget.showAsTab) {
            scheduleTabbed.currentWidget = scheduleTabbed.widgets[0];
        }
    };

    this.infoMeetingActionEventDelete = function (args) {
        ScreenService.showCustomDialog(Utilities.messages.ALE_REMOVE_MEETING,
            'CONFIRMATION', null,
            [
                {
                    "label": "Sim",
                    "code": removeMeeting
                },
                {
                    "label": "Não",
                    "code": ''
                }
            ]
        );
    };

    this.scheduleFormActionEventDelete = function (args) {
        ScreenService.showCustomDialog(Utilities.messages.ALE_REMOVE_SCHEDULE,
            'CONFIRMATION', null,
            [
                {
                    "label": "Sim",
                    "code": removeScheduleForm
                },
                {
                    "label": "Não",
                    "code": ''
                }
            ]
        );
    };

    this.createMeetingDelete = function () {
        MeetingPlanningService.createMeetingDeleteOnlyOneRow(getWidgetListMeeting(), getWidgetCreateMeetingPlanning());
        goBackToInfoMeeting();
    };
    
    this.issueListScheduleActionListIssueToSchedule = function () {
        var WidgetListIssueToSchedulel = getWidgetListIssueToSchedulel();
        getFieldProjectListIssueToSchedulel().reload();
        ScreenService.openPopup(WidgetListIssueToSchedulel); 
    };
    
    this.listIssueToScheduleWidgetOnEnter = function () {
        var FieldListIssueToSchedulel = getFieldListIssueToSchedulel();
        FieldListIssueToSchedulel.reload();
    };
    
    
    this.saveListIssueToScheduleActionSave = function (args) {
        var WidgetListIssueToSchedulel = getWidgetListIssueToSchedulel();
        var WidgetIssueListSchedule = getWidgetIssueListSchedule();
        var row = {};
        if(WidgetListIssueToSchedulel.isValid()){
            row.PAUTA_ID = getWidgetScheduleForm().currentRow.TASK_ID;
            row.LIST_ISSUE_TO_SCHEDULE = WidgetListIssueToSchedulel.currentRow.LIST_ISSUE_TO_SCHEDULE;
            row.changed = true;
            var labelsIds = [];
            ScreenService.showLoader();
            MeetingPlanningService.getLabelsByMeeting(getWidgetInfoMeeting().currentRow).then(function(labels){
                labels.forEach(function(labelId){
                    labelsIds.push(labelId);
                });
                row.LABELS = labelsIds;
                MeetingPlanningService.saveIssueListScheduleFromProject(row).then(function (response) {
                    ScreenService.hideLoader();
                    ScreenService.closePopup();
                    WidgetListIssueToSchedulel.currentRow.LIST_ISSUE_TO_SCHEDULE = [];
                    WidgetListIssueToSchedulel.reload();
                    WidgetIssueListSchedule.reload();
                }).catch(function (response) {
                    Utilities.showMessageErrorOfBackEnd(response);
                });
            }).catch(function (response) {
                Utilities.showMessageErrorOfBackEnd(response);
            });

        }
    };
    
    this.listMeetingFilterAfterApply = function(){
        Utilities.setFilterInit(getWidgetListMeeting());
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register('MeetingPlanningController', MeetingPlanningController);
});


// FILE: assets/js/Controller/ModelCalendar.js
function ModelCalendarControllerPM (ScreenService, templateManager, Utilities, CalendarService, ZhFilterPreferences) {

    var WEEK_TYPE_COPY_CALLED = 'WEEK';
    var getWidgetCalendar = function () {
        return templateManager.container.getWidget('CALENDAR');
    };

    var getWidgetCopyPopup = function () {
        return templateManager.container.getWidget('COPY_POPUP');
    };

    var getWidgetCalendarList = function () {
        return templateManager.container.getWidget('CALENDAR_LIST');
    };

    var getWidgetExceptionList = function () {
        return templateManager.container.getWidget('EXCEPTION_LIST');
    };
    var getWidgetNewException = function () {
        return templateManager.container.getWidget('NEW_EXCEPTION');
    };
    var getWidgetTabbedException = function () {
        return templateManager.container.getWidget('TABBED_EXCEPTION');
    };
    var getWidgetHourWeekList = function () {
        return templateManager.container.getWidget('HOUR_WEEK_LIST');
    };
    var getWidgetHourWeekTabbed = function () {
        return templateManager.container.getWidget('HOUR_WEEK_TABBED');
    };
    var getWidgetNewHourWeek = function () {
        return templateManager.container.getWidget('NEW_HOUR_WEEK');
    };

    var getFieldCalendarIds = function(){
        return getWidgetCopyPopup().getField('CALENDAR_IDS');
    };

    this.calendarStyles = function (element, row) {
    };

    this.calendarListActionEventNew = function (args) {
        CalendarService.calendarListActionEventNew(getWidgetCalendarList(),getWidgetCalendar(),getWidgetExceptionList());
    };

    this.calendarListActionEventDelete = function (args) {
        ScreenService.confirmMessage(Utilities.messages.ALO_DELETE_CALENDAR,'question',function(){
            CalendarService.calendarListActionEventDelete(getWidgetCalendarList());
        });
    };

    this.calendarListActionEventEdit = function (args) {
        CalendarService.calendarListActionEventEdit(getWidgetCalendarList(),getWidgetCalendar(),getWidgetExceptionList(),getWidgetHourWeekList());
    };

    this.calendarListActionEventCancel = function (args) {
        Utilities.genericCancelEvent(getWidgetCalendarList());
        getWidgetCalendar().isVisible = true;
        getWidgetExceptionList().isVisible = true;
        getWidgetHourWeekList().isVisible = true;
    };

    this.calendarListActionEventCancelForm = function (args) {
        Utilities.genericBackEvent(getWidgetCalendarList());

    };
    this.calendarListWidgetAfterMoveRow = function (args) {
        CalendarService.calendarListWidgetAfterMoveRow(getWidgetCalendarList(),getWidgetCalendar(),getWidgetExceptionList(),getWidgetHourWeekList());
    };

    this.calendarActionEventCancel = function (args) {
        CalendarService.calendarActionEventCancel(getWidgetCalendarList());
    };

    this.calendarListActionEventSave = function (args) {
        CalendarService.calendarListActionEventSave(getWidgetCalendarList(),getWidgetCalendar(),getWidgetExceptionList());
    };

    this.exceptionListActionEventCancel = function (args) {
        CalendarService.exceptionListActionEventCancel(getWidgetCalendarList());
    };

    this.exceptionListActionEventNew = function (args) {
        CalendarService.exceptionListActionEventNew(getWidgetTabbedException(),getWidgetNewException());
    };

    this.exceptionListFieldOnChangeRecurrenceType = function (args) {
        CalendarService.exceptionListFieldOnChangeRecurrenceType(Utilities.getFieldByArgs(args),getWidgetNewException());
    };
    this.newExceptionFieldOnChangeBeginDate = function (args) {
        CalendarService.newExceptionFieldOnChangeBeginDate(getWidgetNewException());
    };

    this.exceptionListFieldOnChangeType = function (args) {
        CalendarService.exceptionListFieldOnChangeType(args.owner.value(),getWidgetNewException());
    };
    this.newExceptionActionEventCancelForm = function (args) {
        CalendarService.newExceptionActionEventCancelForm(getWidgetExceptionList());
    };
    this.newExceptionActionEventCancel = function (args) {
        var newExceptionWidget = getWidgetNewException();
        Utilities.genericCancelEvent(newExceptionWidget);
        if(newExceptionWidget.currentRow.__is_new){
            getWidgetExceptionList().activate();
        }else {
            newExceptionWidget.template = newExceptionWidget.templateToView;
        }
    };
    this.exceptionListFieldOnChangeYearDayExceptionMonth = function (args) {
        CalendarService.exceptionListFieldOnChangeYearDayExceptionMonth(args.owner.field,getWidgetNewException());
    };
    this.exceptionListFieldOnChangeYearDayExceptionYear = function (args) {
        CalendarService.exceptionListFieldOnChangeYearDayExceptionYear(args.owner.field,getWidgetNewException());
    };
    this.exceptionListFieldOnChangeWeekDayExceptionMonth = function (args) {
        CalendarService.exceptionListFieldOnChangeWeekDayExceptionMonth(args.owner.field,getWidgetNewException());

    };
    this.exceptionListFieldOnChangeWeekDayExceptionYear = function (args) {
        CalendarService.exceptionListFieldOnChangeWeekDayExceptionYear(args.owner.field,getWidgetNewException());

    };
    this.exceptionListFieldOnChangeExceptionQuantitative = function (args) {
       CalendarService.exceptionListFieldOnChangeExceptionQuantitative(getWidgetNewException());

    };
    this.exceptionListFieldOnChangeExceptionDataEnd = function (args) {
        CalendarService.exceptionListFieldOnChangeExceptionDataEnd(getWidgetNewException());
    };

    this.exceptionListWidgetAfterMoveRow = function (args) {
        getWidgetNewException().currentRow.ID = getWidgetExceptionList().currentRow.ID;
        CalendarService.exceptionListWidgetAfterMoveRow(args.row.ID,getWidgetTabbedException(),getWidgetNewException());
        getWidgetTabbedException().descriptionOrder = getWidgetExceptionList().descriptionOrder;
    };

    this.exceptionListWidgetOnEnter = function (args) {
       getWidgetExceptionList().unSelectAll();
       getWidgetHourWeekList().unSelectAll();
    };

    this.hourWeekListWidgetOnEnter = function (args) {
       getWidgetExceptionList().unSelectAll();
       getWidgetHourWeekList().unSelectAll();
    };

    this.newExceptionActionEventSave = function (args) {
       CalendarService.newExceptionActionEventSave(getWidgetNewException(),getWidgetExceptionList());
    };
    this.newExceptionActionEventEdit = function (args) {
       CalendarService.newExceptionActionEventEdit(getWidgetNewException());
    };

    this.newExceptionActionEventDelete = function (args) {
       ScreenService.confirmMessage(Utilities.messages.ALO_DELETE_EXCEPTION,null, self.exceptionListDelete) ;
    };
    this.exceptionListDelete = function(){
        CalendarService.exceptionListDeleteOnlyOneRow(getWidgetExceptionList(), getWidgetNewException());
    };
    //week
    this.hourWeekListActionEventCancel = function (args) {
        CalendarService.hourWeekListActionEventCancel(getWidgetCalendarList());
    };

    this.newHourWeekActionEventCancelForm = function (args) {
        getWidgetNewHourWeek().getField("NAME").readOnly = false;
        CalendarService.newHourWeekActionEventCancelForm(getWidgetNewHourWeek(),getWidgetHourWeekList());
    };

    this.newHourWeekActionEventCancel = function (args) {
        var newHourWeekWidget = getWidgetNewHourWeek();
        Utilities.genericCancelEvent(newHourWeekWidget);
        if(newHourWeekWidget.currentRow.__is_new){
            getWidgetHourWeekList().activate();
        }else {
            newHourWeekWidget.template = newHourWeekWidget.templateToView;
        }
    };

    this.calendarListWidgetOnEnter = function(args){
        var widget = getWidgetCalendarList();
        Utilities.applyDefaultFilterOnEnter(widget, true);
        widget.activate();
    };
    
    this.calendarListFilterAfterApply = function(){
        Utilities.setFilterInit(getWidgetCalendarList());
    };

    this.newHourWeekActionEventEdit = function (args) {
       CalendarService.newHourWeekActionEventEdit(getWidgetNewHourWeek());
    };
    
    this.newHourWeekActionEventSave = function (args) {
        if(CalendarService.validateDefaultWeekInCurrentRow(getWidgetNewHourWeek(), true) ||
           CalendarService.validateExistsDefaultWeekInDataSource(getWidgetHourWeekList()) ) {
            getWidgetNewHourWeek().getField("NAME").readOnly = false;
            CalendarService.newHourWeekActionEventSave(getWidgetNewHourWeek(),getWidgetHourWeekList());
        } else {
            ScreenService.showMessage(Utilities.messages.ERRO_IN_SAVE_HOUR_WEEK, 'ERROR');
        }
    };

    this.hourWeekListWidgetAfterMoveRow = function (args) {
        getWidgetNewHourWeek().currentRow.CALENDAR = getWidgetCalendarList().currentRow.ID;
        getWidgetNewHourWeek().currentRow.ID = getWidgetHourWeekList().currentRow.ID;
        getWidgetNewHourWeek().getField("NAME").readOnly =  getWidgetHourWeekList().currentRow.NAME == "Padrão" ;
        CalendarService.hourWeekListWidgetAfterMoveRow(args.row, getWidgetHourWeekTabbed(), getWidgetNewHourWeek());
        getWidgetHourWeekTabbed().descriptionOrder = getWidgetHourWeekList().descriptionOrder;
    };
    
    this.hourWeekListActionEventNew = function (args) {
       CalendarService.hourWeekListActionEventNew(getWidgetHourWeekTabbed(),getWidgetNewHourWeek());
    };

    this.newHourWeekActionEventDelete = function (args) {
        if(CalendarService.validateDefaultWeekInCurrentRow(getWidgetNewHourWeek())) {
            ScreenService.confirmMessage(Utilities.messages.ALO_DELETE_HOUR_WEEK, null, self.hourWeekListDelete) ;
        } else {
            ScreenService.showMessage(Utilities.messages.ERRO_IN_DELETE_HOUR_WEEK, 'ERROR');
        }
    };
    this.hourWeekListDelete = function(){
        CalendarService.exceptionListDeleteOnlyOneRow(getWidgetHourWeekList(), getWidgetNewHourWeek());
    };
    this.newHourWeekFieldOnChangeTypeSunday = function (args) {
        var field = Utilities.getFieldByArgs(args);
        CalendarService.setFieldWorkTimeByTypeField(field);
    };

    this.newHourWeekFieldOnChangeTypeMonday = function (args) {
        var field = Utilities.getFieldByArgs(args);
         CalendarService.setFieldWorkTimeByTypeField(field);
    };

    this.newHourWeekFieldOnChangeTypeThuesday = function (args) {
        var field = Utilities.getFieldByArgs(args);
         CalendarService.setFieldWorkTimeByTypeField(field);
    };

    this.newHourWeekFieldOnChangeTypeWednesday = function (args) {
        var field = Utilities.getFieldByArgs(args);
         CalendarService.setFieldWorkTimeByTypeField(field);
    };

    this.newHourWeekFieldOnChangeTypeThursday = function (args) {
        var field = Utilities.getFieldByArgs(args);
         CalendarService.setFieldWorkTimeByTypeField(field);
    };

    this.newHourWeekFieldOnChangeTypeFriday = function (args) {
        var field = Utilities.getFieldByArgs(args);
         CalendarService.setFieldWorkTimeByTypeField(field);
    };

    this.exceptionListActionEventCopy = function(args){
        Utilities.localVar.setCopyCalled('EXCEPTION');
        ScreenService.openPopup(getWidgetCopyPopup());
    };

    this.hourWeekListActionEventCopy = function(args){
        Utilities.localVar.setCopyCalled('WEEK');
        ScreenService.openPopup(getWidgetCopyPopup());
    };

    this.copyPopupActionEventCancel = function (args){
        ScreenService.closePopup();
        if(Utilities.localVar.getCopyCalled() == WEEK_TYPE_COPY_CALLED) {
            getWidgetHourWeekList().activate();
        } else {
            getWidgetExceptionList().activate();
        }
    };

    this.copyPopuptWidgetOnEnter = function (args){
        getFieldCalendarIds().reload();
    };

    var closePopupAndSuccessNotificationSaveCopy = function () {
        ScreenService.closePopup();
        var message = Utilities.messages.SUC_COPY_CALENDAR_EXCEPTION;
        if (Utilities.localVar.getCopyCalled() == WEEK_TYPE_COPY_CALLED) {
            message = Utilities.messages.SUC_COPY_CALENDAR_WEEK;
        }
        ScreenService.successNotification(message);
    };

    this.copyPopuptActionEventSave = function (args) {
        var exceptionListWidget = getWidgetExceptionList();
        var copyPopupWidget = getWidgetCopyPopup();
        var checkedRows = exceptionListWidget.getCheckedRows();
        var calendarIds = copyPopupWidget.currentRow.CALENDAR_IDS;
        if (checkedRows.length !== 0) {
            if (copyPopupWidget.isValid()) {
                CalendarService.copyHolidayToNewCalendar(checkedRows, calendarIds).then(function () {
                    closePopupAndSuccessNotificationSaveCopy();
                    exceptionListWidget.unSelectAll();
                });
            }
        } else {
            var hourWeekListWidget = getWidgetHourWeekList();
            checkedRows = hourWeekListWidget.getCheckedRows();
            if (checkedRows.length !== 0) {
                if (copyPopupWidget.isValid()) {
                    CalendarService.copWorkWeekToNewCalendar(checkedRows, calendarIds).then(function () {
                        closePopupAndSuccessNotificationSaveCopy();
                        hourWeekListWidget.unSelectAll();
                    });
                }
            }
        }
    };

    this.newHourWeekFieldOnChangeTypeSaturday = function (args) {
        var field = Utilities.getFieldByArgs(args);
         CalendarService.setFieldWorkTimeByTypeField(field);
    };
    // calendar events

    this.calendarWidgetAfterMoveRow = function (args) {
        var dataPM = args.owner.dataSource.dataPM;
        var rowMove = args.row;
        CalendarService.calendarWidgetAfterMoveRow(dataPM,rowMove);
    };

    this.calendarWidgetOnMonthClick = function (args) {
        console.log(args);
    };

    this.calendarWidgetOnChangeMonth = function(args){
        getWidgetCalendar().reload();
    };

    this.getMonthFromWidgetCalendar = function(){
        return CalendarService.getMonthFromWidgetCalendar(getWidgetCalendar());
    };

    this.getYearFromWidgetCalendar = function(){
        return CalendarService.getYearFromWidgetCalendar(getWidgetCalendar());
    };

    this.calendarWidgetAfterLoadDataSource = function (args) {
       CalendarService.calendarWidgetAfterLoadDataSource(getWidgetCalendar());
    };
    var self = this;
}
Configuration(function (ContextRegister){
    ContextRegister.register('ModelCalendarControllerPM',ModelCalendarControllerPM);
});

// FILE: assets/js/Controller/Organization.js
function OrganizationController(ScreenService, templateManager, Utilities) {

    var self = this;
    
    var getWidgetOrganizationBasic = function () {
        return templateManager.container.getWidget('ORGANIZATION_BASIC');
    };
    
	this.afterLoadDataSource = function(widget){
		widget.moveToFirst();
	};

    this.containerAfterInit = function(args){
        Utilities.fixBugReloadWidgetInViewMode(getWidgetOrganizationBasic());
	};

    this.organizationBasicActionEventEdit = function(args){
        var widget = getWidgetOrganizationBasic();
        widget.edit();
        widget.template = widget.templateToForm;
	};

    this.organizationBasicActionEventSave =function(args){
        var widget = getWidgetOrganizationBasic();
        var timeSheetRequired = '';
        if(widget.currentRow.TIME_SHEET_REQUIRED != 'Y'){
            timeSheetRequired = 'não';
        }
        ScreenService.showCustomDialog('Replicar a obrigação de<br><strong> " '+timeSheetRequired+' apropriar diariamente " </strong><br>para as estruturas inferiores?',
            'CONFIRMATION',null,
            [
                {
                    "label": "Sim",
                    "code": function(){ self.onSaveOrganization(widget,true);}
                },
                {
                    "label": "Não",
                    "code": function(){ self.onSaveOrganization(widget,false);}
                }
            ]
        );
    };

	this.onSaveOrganization = function(widget,replicateTimeSheetRequired){
        if(widget.isValid()){
            widget.currentRow.REPLICATE_TIME_SHEET_REQUIRED = replicateTimeSheetRequired ;
            widget.saveRow().then(function(responseData){
                widget.view();
                widget.template = widget.templateToView;
            });
        }
	};

    this.organizationBasicActionEventCancel = function(args){
       Utilities.fixBugReloadWidgetInViewMode(getWidgetOrganizationBasic());
	};
}

Configuration(function(ContextRegister) {
    ContextRegister.register('OrganizationController', OrganizationController);
});

// FILE: assets/js/Controller/Project.js
function ProjectController(ScreenService, ProjectServiceList, FilterService, SponsorService,
                           templateManager, ZHPromise, localStorageEngine, requestDataSourceEngine,
                           Utilities, Messages,CalendarService, ZhFilterPreferences,metaDataFactory,
                           FieldsMetaData,PMConstants, IssueService) {

    this.projectMoveAndCopy = null;
    var ALLOWENDTASK_NEGATIVE = 'N';
    var ALLOWENDTASK_POSITIVE = 'Y';
    var USETIMEPLANNING_NEGATIVE = 'N';
    var USETIMEPLANNING_POSITIVE = 'Y';
    var AS_SOON_AS_POSSIBLE = 'MB';
    var PROJECT_STATUS_CONCLUDED = 'C';
    var PROJECT_STATUS_CANCELED  = 'X';
    var IS_PARENT_NEGATIVE = 'N';
    var IS_PARENT_POSITIVE = 'Y';
    var IS_PROJECT_POSITIVE = 'Y';
    var TASK_STATUS_CONCLUDED = 6;
    var TYPE_RELATIONSHIP_REPLICATION     = 'R';
    var TYPE_RELATIONSHIP_MERGE_REQUEST   = 'M';
    var TYPE_RELATIONSHIP_ERROR           = 'E';
    var TYPE_RELATIONSHIP_ERROR_MR        = 'G';
    var TYPE_RELATIONSHIP_CONFLICT        = 'C';
    var TYPE_RELATIONSHIP_CONFLICT_DEVOPS = 'D';
    var TYPE_RELATIONSHIP_TEST            = 'T';
    var TYPE_RELATIONSHIP_ORIGIN          = 'O';
    var alreadyFilteredManager            = false;
    var timeOutToKeyup                    = null;
    var modelProjectHasChildren           = false;

    var DATA_SET_EXCEPTION_LEAF = [
        {"ABBREVIATION" : "DI", "NAME" : "Deve Iniciar em","ID" : "DI"},
        {"ABBREVIATION" : "DT", "NAME" : "Deve Terminar em","ID" : "DT"},
        {"ABBREVIATION" : "IA", "NAME" : "Não Iniciar Antes de","ID" : "IA"},
        {"ABBREVIATION" : "ID", "NAME" : "Não Iniciar Depois de","ID" : "ID"},
        {"ABBREVIATION" : "TA", "NAME" : "Não Terminar Antes de","ID" : "TA"},
        {"ABBREVIATION" : "TD", "NAME" : "Não Terminar Depois de","ID" : "TD"},
        {"ABBREVIATION" : "MB", "NAME" : "O Mais Breve Possível","ID" : "MB"},
        {"ABBREVIATION" : "MT", "NAME" : "O Mais Tarde Possível","ID" : "MT"}
    ];

    var PROJECT_TYPE_COPY_IN_TIMELINE = ['E','R','S'];

    var DATA_SET_EXCEPTION_NODE = [
        {"ABBREVIATION" : "IA", "NAME" : "Não Iniciar Antes de","ID" : "IA"},
        {"ABBREVIATION" : "TD", "NAME" : "Não Terminar Depois de","ID" : "TD"},
        {"ABBREVIATION" : "MB", "NAME" : "O Mais Breve Possível","ID" : "MB"}
    ];

    var getPopUpFilterLog = function (){
        return templateManager.container.getWidget('PROJECT_FILTER_LOG');
    };

    var getNewPrintWidget = function (){
        return templateManager.container.getWidget('NEW_SPRINT_TAB');
    };

    var getMnemonicListWidget = function (){
        return templateManager.container.getWidget('MNEMONIC_LIST');
    };
    var getWidgetProjectLogs = function (){
        return templateManager.container.getWidget('PROJECT_LOGS');
    };
    var getWidgetAdvancedInformation = function(){
        return templateManager.container.getWidget('ADVANCED_INFORMATION');
    };
    var getWidgetBasicProjectInformation =function (){
        return templateManager.container.getWidget('BASIC');
    };
    var getWidgetBasicTaskInformation = function (){
        return templateManager.container.getWidget('NEW_TASK');
    };
    var getWidgetProjectGantt = function (){
        return templateManager.container.getWidget('PROJECT_GANTT');
    };

    var getWidgetTaskTab = function (){
        return templateManager.container.getWidget('TASK_TAB');
    };

    var getWidgetRepositorySelect = function (){
        return templateManager.container.getWidget('REPOSITORY_SELECT');
    };
    var getWidgetMnemonicName = function (){
        return templateManager.container.getWidget('MNEMONIC_NAME');
    };

    var getWidgetChangeMnemonicName = function (){
        return templateManager.container.getWidget('CHANGE_MNEMONIC_NAME');
    };
    var getWidgetGenerateTask = function (){
        return templateManager.container.getWidget('GENERATE_TASK');
    };
    var getWidgetGenerateTasks = function (){
        return templateManager.container.getWidget('GENERATED_TASKS');
    };
    var getWidgetProjectTaskList = function (){
        return templateManager.container.getWidget('PROJECTTASKS');
    };
    var getWidgetProjectCalendar = function (){
        return templateManager.container.getWidget('CALENDAR');
    };
    var getWidgetProjectListTabbed = function (){
        return templateManager.container.getWidget("TABBED_PROJECT_LISTS");
    };
    var getWidgetProjectListException = function (){
        return templateManager.container.getWidget('LIST_EXCEPTION');
    };
    var getWidgetProjectTasks = function (){
        return templateManager.container.getWidget('PROJECTTASKS');
    };
    var getWidgetMnemonicNameFromCopyTask = function (){
        return templateManager.container.getWidget('MNEMONIC_NAME_FROM_COPY');
    };
    var getWidgetRepositoryInformation = function (){
        return templateManager.container.getWidget('REPOSITORY_INFORMATION');
    };
    var getWidgetProjectTabbed = function (){
        return templateManager.container.getWidget('PROJECT_TABBED');
    };
    var getWidgetProjectListParticipating = function (){
        return templateManager.container.getWidget('PROJECT_LIST_PART');
    };
    var getWidgetProjectListManager = function (){
        return templateManager.container.getWidget('PROJECT_LIST_MANAGER');
    };
    var getWidgetNewResources = function (){
        return templateManager.container.getWidget('NEW_RESOURCES');
    };
    var getWidgetNewDocumentProject = function (){
        return templateManager.container.getWidget('NEW_DOCUMENT_PROJECT');
    };
    var getWidgetProjectDocumentsTask = function (){
        return templateManager.container.getWidget("DOCUMENTS");
    };
    var getWidgetNewDocument = function (){
        return templateManager.container.getWidget('NEW_DOCUMENT');
    };
    var getWidgetProjectResourceList = function (){
        return templateManager.container.getWidget('RESOURCE_LIST');
    };
    var getWidgetProjectDocumentsProject = function (){
        return templateManager.container.getWidget('DOCUMENTS_PROJECT');
    };
    var getWidgetTaskIssues = function (){
        return templateManager.container.getWidget('TASK_ISSUES');
    };
    var getIssueCommentWidget = function (){
        return templateManager.container.getWidget('TASK_ISSUES_COMMENTS');
    };
    var getIssueDescriptionWidget = function(){
        return templateManager.container.getWidget('TASK_ISSUES_DESCRIPTION');
    };
    var getIssueTabbedWidget = function (){
        return templateManager.container.getWidget('TASK_ISSUES_TABBED');
    };
    var getIssueAttachmentsWidget = function (){
        return templateManager.container.getWidget('TASK_ISSUES_ATTACHMENTS');
    };
    var getWidgetMoveTask = function(){
        return templateManager.container.getWidget('MOVE_TASK');
    };
    var getWidgetCopyTask = function(){
        return templateManager.container.getWidget('COPY_TASK');
    };
    var getNewTaskWidget = function (){
        return templateManager.container.getWidget('NEW_TASK');
    };

    var getWidgetTaskReplanningReason = function(){
        return templateManager.container.getWidget('TASK_REPLANNING_REASON');
    };

    var ProjectRepositoryPopUp = function(){
        return templateManager.container.getWidget('PROJECT_REPOSITORY_POPUP');
    };

    var ProjectIssuesResponse = function(){
        return templateManager.container.getWidget('ISSUES_RESPONSES');
    };

    var getWidgetResponseEdit = function() {
        return templateManager.container.getWidget('RESPONSE_EDIT');
    };
    var getWidgetViewResponses = function() {
        return templateManager.container.getWidget('VIEW_RESPONSES');
    };
    
    var getWidgetRemoveLts = function() {
        return templateManager.container.getWidget('VERSION_REMOVE_LTS');
    };
    
    var getWidgetRemoveLtsGrid = function() {
        return templateManager.container.getWidget('VERSION_REMOVE_LTS_GRID');
    };

    var getNameFieldFromResponseEdit = function () {
        return getWidgetResponseEdit().getField('NAME');
    };
    var getFieldRepositoryPopUpWidget = function(){
        return ProjectRepositoryPopUp().getField('REPOSITORY');
    };

    var getWidgetTotalTimePlannedStripe = function (){
        return templateManager.container.getWidget('TOTAL_TIME_PLANNED_STRIPE');
    };

    var getFieldResourceFromNewTaskWidget = function(){
        return getWidgetBasicTaskInformation().getField('RESOURCE');
    };
    var getFieldResourceFromGenerateTaskWidget = function(){
        return getWidgetGenerateTask().getField('RESOURCE');
    };
    var getFieldTaskNameFromGenerateTaskWidget = function(){
        return getWidgetGenerateTask().getField('TASK_NAME');
    };
    var getFieldTypeRelationshipFromGenerateTaskWidget = function(){
        return getWidgetGenerateTask().getField('TYPE_RELATIONSHIP');
    };
    var getFieldDescriptionFromGenerateTaskWidget = function(){
        return getWidgetGenerateTask().getField('DESCRIPTION');
    };
    var getFieldNameFromGenerateTaskWidget = function(){
        return getWidgetGenerateTask().getField('NAME');
    };
    var getFieldTaskGeneratorNameFromGenerateTaskWidget = function(){
        return getWidgetGenerateTask().getField('TASK_GENERATOR_NAME');
    };
    var getFieldUrlToTestFromGenerateTaskWidget = function(){
        return getWidgetGenerateTask().getField('URL_TO_TEST');
    };
    var getFieldTaskGeneratorFromGenerateTaskWidget = function(){
        return getWidgetGenerateTask().getField('TASK_GENERATOR');
    };
    var getFieldProjectNameFromGenerateTaskWidget = function(){
        return getWidgetGenerateTask().getField('PROJECT_NAME');
    };
    var getFieldProjectFromGenerateTaskWidget = function(){
        return getWidgetGenerateTask().getField('PROJECT');
    };
    var getFieldTaskFeaturesFromNewTaskWidget = function(){
        return getWidgetBasicTaskInformation().getField('TASK_FEATURES');
    };
    var getFieldProjectFromMoveTaskWidget = function(){
        return getWidgetMoveTask().getField('PROJECT');
    };
    var getFieldProjectNameFromMoveTaskWidget = function(){
        return getWidgetMoveTask().getField('PROJECT_NAME');
    };
    var getFieldProjectNameFromCopyTaskWidget = function(){
        return getWidgetCopyTask().getField('PROJECT_NAME');
    };
    var getFieldTaskNameFromMoveTaskWidget = function(){
        return getWidgetMoveTask().getField('TASK_NAME');
    };

    var getFieldTaskNameFromCopyTaskWidget = function(){
        return getWidgetCopyTask().getField('TASK_NAME');
    };
    var getFieldTaskFromMoveTaskWidget = function(){
        return getWidgetMoveTask().getField('TASK');
    };
    var getFieldResourcesFromProjectTasksWidget = function(){
        return getWidgetProjectTasks().getField('RESOURCES');
    };
    var getFieldTaskResponseFromNewTaskWidget = function(){
        return getWidgetBasicTaskInformation().getField('TASK_RESPONSE');
    };
    var getFieldCreatedByFromNewTaskWidget = function(){
        return getWidgetBasicTaskInformation().getField('CREATED_BY');
    };
    var getFieldCreatedAtFromNewTaskWidget = function(){
        return getWidgetBasicTaskInformation().getField('CREATED_AT');
    };
    var getFieldTaskGeneratorNameFromNewTaskWidget = function(){
        return getWidgetBasicTaskInformation().getField('TASK_GENERATOR_NAME');
    };
    var getFieldTypeRelationshipFromNewTaskWidget = function(){
        return getWidgetBasicTaskInformation().getField('TYPE_RELATIONSHIP');
    };
    var getFieldPercentCompletedFromNewTaskWidget = function (){
        return getWidgetBasicTaskInformation().getField('PERCENT_COMPLETED');
    };
    var getFieldIsParentFromNewTaskWidget = function (){
        return getWidgetBasicTaskInformation().getField('IS_PARENT');
    };
    var getFieldTimePlannedFromNewTaskWidget = function (){
        return getWidgetBasicTaskInformation().getField('TIME_PLANNED');
    };
    var getFieldTaskStatusNameFromNewTaskWidget = function (){
        return getWidgetBasicTaskInformation().getField('TASK_STATUS_NAME');
    };
    var getFieldTaskClassificationLabelFromNewTaskWidget = function (){
        return getWidgetBasicTaskInformation().getField('TASK_CLASSIFICATION_LABEL');
    };
    var getFieldStatusFromNewTaskWidget = function (){
        return getWidgetBasicTaskInformation().getField('STATUS');
    };

    var getFieldErrorClassificationFromNewTaskWidget = function (){
        return getNewTaskWidget().getField('ERROR_CLASSIFICATION');
    };

    var getFieldReplanningReasonFromMoveTaskWidget = function (){
        return getWidgetMoveTask().getField('REPLANNING_REASON');
    };
    var getValueTaskClassificationIssueFromNewTaskWidget = function () {
        var classification = null;
        if (getWidgetBasicTaskInformation().currentRow) {
            classification = getWidgetBasicTaskInformation().currentRow.TASK_CLASSIFICATION_ISSUE;
        }
        return classification;
    };
    var getValueIsUpperFromNewTaskWidget = function () {
        var isUpper = null;
        if (getWidgetBasicTaskInformation().currentRow) {
            isUpper = getWidgetBasicTaskInformation().currentRow.IS_UPPER;
        }
        return isUpper;
    };
    var getFieldBeginDateFromProjectTasksWidget = function (){
        return getWidgetProjectTaskList().getField('BEGIN_DATE');
    };
    var getFieldEstimatedDateFromProjectTasksWidget = function (){
        return getWidgetProjectTaskList().getField('ESTIMATED_DATE');
    };
    var getFieldPercentFromProjectTasksWidget = function (){
        return getWidgetProjectTaskList().getField('PERCENT');
    };
    var getFieldTimePlannedFromProjectTasksWidget = function (){
        return getWidgetProjectTaskList().getField('TIME_PLANNED');
    };
    var getFieldDurationFromProjectTasksWidget = function (){
        return getWidgetProjectTaskList().getField('DURATION');
    };

    var getFieldTaskStatusFromProjectTasksWidget = function () {
        return getWidgetProjectTaskList().getField('TASK_STATUS');
    };
    //form project

    var getFieldBeginDateFromProjectInformationWidget = function (){
        return getWidgetBasicProjectInformation().getField('START');
    };
    var getFieldModelsFromNewSprintWidget = function (){
        return getNewPrintWidget().getField('MODELS_NAME');
    };
    var getFieldModelsFromProjectInformationWidget = function (){
        return getWidgetBasicProjectInformation().getField('MODELS_NAME');
    };
    var getFieldEstimatedDateFromProjectInformationWidget = function (){
        return getWidgetBasicProjectInformation().getField('END');
    };
    var getFieldStatusFromBasicWidget = function (){
        return getWidgetBasicProjectInformation().getField('STATUS');
    };
    var getFieldProjectStatusFromBasicWidget = function (){
        return getWidgetBasicProjectInformation().getField('PROJECT_STATUS');
    };
    var getFieldProjectCategoriesFromBasicWidget = function (){
        return getWidgetBasicProjectInformation().getField('PROJECT_CATEGORIES');
    };
    var getFieldProjectTypeFromBasicWidget = function (){
        return getWidgetBasicProjectInformation().getField('PROJECT_TYPE');
    };
    var getFieldSponsorNameFromBasicWidget = function (){
        return getWidgetBasicProjectInformation().getField('SPONSOR_NAME');
    };
    var getFieldDurationFromProjectInformationWidget = function (){
        return getWidgetBasicProjectInformation().getField('TOTAL_TIME');
    };
    var getFieldParentNameFromProjectInformationWidget = function(){
        return getWidgetBasicProjectInformation().getField('UPPER_PROJECT_NAME');
    };
    var getFieldGroupNameFromProjectInformationWidget = function(){
        return getWidgetBasicProjectInformation().getField('GROUP_NAME');
    };
    var getFieldDateExceptionNameFromProjectInformationWidget = function(){
        return getWidgetBasicProjectInformation().getField('DATE_EXCEPTION_NAME');
    };
    var getFieldDateExceptionFromProjectInformationWidget = function(){
        return getWidgetBasicProjectInformation().getField('DATE_EXCEPTION');
    };
    var getFieldDateIdFromProjectInformationWidget = function(){
        return getWidgetBasicProjectInformation().getField('ID');
    };
    var getFieldManagerFromProjectInformationWidget = function(){
        return getWidgetBasicProjectInformation().getField('MANAGER');
    };
    var getFieldReleaseIdFromProjectInformationWidget = function(){
        return getWidgetBasicProjectInformation().getField('RELEASE_ID');
    };
    var getFieldProductIdFromProjectInformationWidget = function(){
        return getWidgetBasicProjectInformation().getField('PRODUCT_ID');
    };
    var getFieldSubReleaseIdFromProjectInformationWidget = function(){
        return getWidgetBasicProjectInformation().getField('SUBRELEASE_ID');
    };

    var getFieldVersionDevFromProjectInformationWidget = function () {
        return getWidgetBasicProjectInformation().getField('VERSION_DEV');
    };

    var getFieldIsLtsReplicationFromProjectInformationWidget = function () {
        return getWidgetBasicProjectInformation().getField('IS_LTS_REPLICATION');
    };

    //form task
    var getFieldStartFromNewTaskWidget = function(){
        return getNewTaskWidget().getField('START');
    };
    var getFieldEndFromNewTaskWidget = function(){
        return getNewTaskWidget().getField('END');
    };
    var getFieldDurationFromNewTaskWidget = function(){
        return getNewTaskWidget().getField('TOTAL_TIME');
    };
    var getFieldDurationFromGenerateTaskWidget = function(){
        return getWidgetGenerateTask().getField('TOTAL_TIME');
    };
    var getFieldPrecursorNameFromNewTaskWidget = function(){
        return getNewTaskWidget().getField('PRECURSOR_NAME');
    };
    var getFieldTypeFromNewTaskWidget = function(){
        return getNewTaskWidget().getField('TYPE');
    };
    var getFieldTypeFromNewException = function(){
        return getWidgetNewException().getField('TYPE');
    };
    var getFieldTypeFromNewExceptionResource = function(){
        return getWidgetNewExceptionResource().getField('TYPE');
    };
    var getFieldParentNameFromNewTaskWidget = function(){
        return getNewTaskWidget().getField('PARENT_NAME');
    };
    var getFieldDateExceptionNameFromNewTaskWidget = function(){
        return getNewTaskWidget().getField('DATE_EXCEPTION_NAME');
    };
    var getFieldResourceNameFromNewTaskWidget = function(){
        return getNewTaskWidget().getField('RESOURCE');
    };
    var getFieldLatencyFromNewTaskWidget = function(){
        return getNewTaskWidget().getField('LATENCY');
    };
    var getFieldDateExceptionFromNewTaskWidget = function(){
        return getNewTaskWidget().getField('DATE_EXCEPTION');
    };
    var getFieldIdFromNewTaskWidget = function(){
        return getNewTaskWidget().getField('ID');
    };
    var getFieldUrlToTestFromNewTaskWidget  = function(){
        return getNewTaskWidget().getField('URL_TO_TEST');
    };

    var getFieldTotalErrorFromStripeWidget = function (){
        return getWidgetTotalTimePlannedStripe().getField('TOTAL_ERROR_TIME_PLANNED');
    };
    //filter project

    var getFieldManagerFromProjectListManagerWidget  = function(){
        return getProjectListManagerWidget().getField('MANAGER');
    };

    var getFieldProjectStatusFromProjectListManagerWidget  = function(){
        return getProjectListManagerWidget().getField('PROJECT_STATUS');
    };

    var getFieldProjectStatusFromProjectPartWidget  = function(){
        return getWidgetProjectListParticipating().getField('PROJECT_STATUS');
    };

    var getFieldResourcesFromProjectFilterPartWidget  = function(){
        return getWidgetProjectTaskList().getField('RESOURCES');
    };

    var getFieldTaskClassificationLabelFromGenerateTask = function() {
        return getWidgetGenerateTask().getField('TASK_CLASSIFICATION_LABEL');
    };

    var getFieldTaskStatusNameFromGenerateTask = function() {
        return getWidgetGenerateTask().getField('TASK_STATUS_NAME');
    };

    var isParentInProjectsArray = function (project){
        if(project){
            return project.ID == this.parent;
        }
        return false;
    };

    var getActionAddGeneratedTaskFromNewTask = function(){
        return getNewTaskWidget().getAction('ADD_GENERATED_TASK');
    };


    var getActionOpenMnemonicWindowFromBasicWidget = function(){
        return getWidgetBasicProjectInformation().getAction('OPEN_MNEMONIC_WINDOW');
    };

     var getActionChangeViewCompletedTasksFromProjectGantt = function(){
        return getWidgetProjectGantt().getAction('CHANGE_VIEW_COMPLETED_TASKS');
    };

    var getActionReplicationFromNewTask = function(){
        return getNewTaskWidget().getAction('REPLICATION');
    };

    var getActionFinishPlanningFromBasicProjectInformation = function(){
        return getWidgetBasicProjectInformation().getAction('FINISH_PLANNING');
    };

    var getActionDeleteDocumentsFromDocumentsProject = function(){
        return getWidgetProjectDocumentsProject().getAction('DELETE_DOCUMENTS');
    };

    var getActionDeleteDocumentsFromDocumentsTask = function(){
        return getWidgetProjectDocumentsTask().getAction('DELETE_DOCUMENTS');
    };

    var getActionGenerateTaskMergeFromProjectTaskList = function(){
        return getWidgetProjectTaskList().getAction('GENERATE_TASK_MERGE');
    };

    var getWidgetIssueMain = function(){
        return templateManager.container.getWidget('ISSUE_MAIN');
    };

    var getFieldFollowersFromWidgetIssueMain = function(){
        return getWidgetIssueMain().getField('FOLLOWERS');
    };

	var showTargetTask = function(countTasksSelected, widgetTarget, copy, move) {
		if(countTasksSelected) {
			var promises = [];
			widgetTarget.currentRow = {};
			promises.push(ProjectServiceList.clearTaskList());
			promises.push(ProjectServiceList.loadProjectsWithSameManager(copy, [
                {
                    name: 'projectStatus',
                    operator: 'IN',
                    value: ['C']
                }
            ]));
            ScreenService.showLoader();
			ZHPromise.all(promises).then(function(data) {
			    ScreenService.hideLoader();
                var projects = data[1];
                widgetTarget.getField('TASK_NAME').dataSource.data = [];
                projects.forEach(function(project, index){
                    var parent = project.PARENT;
                    if(parent){
                        var param = {
                            'parent': parent
                        };
                        if(!(projects.filter(isParentInProjectsArray, param).length)){
                            projects[index].PARENT = null;
                        }
                    }
                });
                widgetTarget.getField('PROJECT_NAME').dataSource.data = projects;
                ScreenService.openPopup(widgetTarget);
                if(move) {
                    getFieldProjectNameFromMoveTaskWidget().value(Utilities.localVar.getProjectName());
                    getWidgetMoveTask().currentRow.PROJECT = Utilities.localVar.getProject();
                    getFieldTaskNameFromMoveTaskWidget().reload();
                } else if(copy) {
                    getFieldProjectNameFromCopyTaskWidget().value(Utilities.localVar.getProjectName());
                    getWidgetCopyTask().currentRow.PROJECT = Utilities.localVar.getProject();
                    getFieldTaskNameFromCopyTaskWidget().reload();
                }
			}).catch(ScreenService.hideLoader);
		} else {
			return ScreenService.showMessage('Não há nenhuma tarefa selecionada para ser movida.', null, 'error');
		}
	};

    this.generateSchedule = function(args) {
        var  widget = getWidgetProjectTasks();
        var reportTitle = "Cronograma - " + getWidgetProjectListTabbed().currentWidget.currentRow.NAME;

        var reportJSONFile = window.metadataUrl + "json/reports/generateScheduleToNewPdfZHReportSystem.json";

        $.get(reportJSONFile, function(reportMetadata){

            reportMetadata.name = reportTitle;
            reportMetadata.title = reportTitle;


            var dataset = widget.plainTreeData.map(function(obj){
                obj._hasChildrenReportMetadata = !!obj._childCount;
                obj._rowLevelReportMetadata = obj._level;
                return obj;
            });

            var projectInfo = getWidgetBasicProjectInformation().dataSource.data[0];
            projectInfo.BEGIN_DATE = projectInfo.START;
            projectInfo.ESTIMATED_DATE = projectInfo.END;
            projectInfo.RESOURCES_NAME = projectInfo.MANAGER_NAME + " (GERENTE)";
            projectInfo._hasChildrenReportMetadata = true;
            projectInfo._rowLevelReportMetadata = 0;

            dataset.unshift(projectInfo);

            var responseUrl = ProjectManagementConfig.zhReportServerUrl+ProjectManagementConfig.zhReportServerReportsPath;
            var responseCallback = function(response){
                response = JSON.parse(response);
                if(!response.error){
                    var page = response.messages[0].message;
                    var urlToRedirect = responseUrl+page;
                    console.log(urlToRedirect);

                    var win = window.open(urlToRedirect);
                    if(typeof win == "undefined")
                        ScreenService.showMessage(Messages.ERR_CANT_OPEN_GENERATED_SCHEDULE);
                }else{
                    console.warning(response.error);
                    ScreenService.showMessage(Messages.ERR_CANT_GENERATE_SCHEDULE);
                }
            };

            var urlToRequest = ProjectManagementConfig.zhReportServerUrl+ProjectManagementConfig.zhReportServerReportGenerationPath;

            $.ajax({
                type: "POST",
                url: urlToRequest,
                crossDomain: false,
                xhrFields: {
                    withCredentials: false
                },
                data: {
                    'requestType' : 'Row',
                    'row' : {
                        'dataSet': JSON.stringify(dataset),
                        'metaData' : JSON.stringify(reportMetadata)
                    }
                }
            }).done(responseCallback);
        });


    };

    /************************************************************
     * Gets a list of JS objects (which represents tasks) and
     * returns only their ids.
     * @param taskList    An array with tasks objects
     * @param property    The id object's property
     ************************************************************/
    var getOnlyIdsFromTaskObjectList = function(taskList, property){
        if(!taskList) return [];

        var ids = [];
        taskList.forEach(function(task){
            if(task.hasOwnProperty(property)) {
                ids.push(task[property]);
            }
        });

        return ids;
    };

    /************************************************************
     * Reloads field and update template using templateManager.
     ************************************************************/
    var reloadFieldAndUpdateTemplate = function(field){
        field.reload().then(function(){
            templateManager.updateTemplate();
        });
    };

    /************************************************************
     * Gets tasks by a project id.
     ************************************************************/
	var loadTasksByProject = function(owner, selectedTasksIds) {
        selectedTasksIds    = selectedTasksIds || null;
		var projectID       = owner.field.widget.currentRow.PROJECT;
        var taskNameField   = owner.field.widget.getField('TASK_NAME');
        var taskField       = owner.field.widget.getField('TASK');

        ProjectServiceList.clearTaskList().then(function(){
            taskNameField.setValue('');
            if(taskField){
                taskField.setValue(null);
            }

            if(projectID){

                taskNameField.dataSourceFilter = [{
                    "name": "PROJECT",
                    "value": projectID,
                    "operator": "="
                },{
                    "name": "selectedTasksIds",
                    "value": selectedTasksIds,
                    "operator": "="
                }
                ];

               // ProjectServiceList.loadTasksByProject(projectID, selectedTasksIds, taskNameField).then(function(teste){
                    reloadFieldAndUpdateTemplate(taskNameField);
               // });
            } else {
                reloadFieldAndUpdateTemplate(taskNameField);
            }
        });
	};

	var loadTasksByProjectOnEnter = function(selectedTasksIds) {
        selectedTasksIds    = selectedTasksIds || null;
		var projectID       = Utilities.localVar.getProject();
        var taskNameField   = getFieldTaskNameFromMoveTaskWidget();
        var taskField       = getFieldTaskNameFromCopyTaskWidget();

        ProjectServiceList.clearTaskList().then(function(){
            taskNameField.setValue('');
            if(taskField) {
                taskField.setValue(null);
            }

            if(projectID) {
                taskNameField.dataSourceFilter = [{
                    "name": "PROJECT",
                    "value": projectID,
                    "operator": "="
                },{
                    "name": "selectedTasksIds",
                    "value": selectedTasksIds,
                    "operator": "="
                }
                ];
               // ProjectServiceList.loadTasksByProject(projectID, selectedTasksIds).then(function(){
                    reloadFieldAndUpdateTemplate(taskNameField);
               // });
            } else {
                reloadFieldAndUpdateTemplate(taskNameField);
            }
        });
	};

    /************************************************************
     * Get the ids from a list of tasks object.
     * Temporally, because there is another similar function in
     * a branch that isn't accepted yet.
     ************************************************************/
    var getOnlyTasksIdsFromListOfTasksObjects = function(taskList){
        var ids = [];
        taskList.forEach(function(item){
            ids.push(parseInt(item.ID));
        });
        return ids;
    };

    /************************************************************
     * Gets an array of objects and returns another array with
     * only a specified property of these objects.
     ************************************************************/
    var getSpecifiedPropertyFromObjects = function(objects, property){
        var returned = [];
        if(!property) return false;

        objects.forEach(function(object){
            if(object.hasOwnProperty(property)){
                returned.push(object[property]);
            }
        });

        return returned;
    };

    /************************************************************
     * Gets an array of resources and creates a string with their
     * (resources) names. Also, inserts comma correctly.
     ************************************************************/
    var createMessageWithResourcesNames = function(arrayOfResources){
        var message = "";
        arrayOfResources.forEach(function(resource, index){
            if(resource.hasOwnProperty("RESOURCE_NAME")){
                message += resource.RESOURCE_NAME;
                if(index < arrayOfResources.length - 2){
                    message += ', ';
                } else if(index < arrayOfResources.length - 1){
                    message += ' e ';
                }
            }
        });
        return message;
    };

    /************************************************************
     * Check if there are different resources between a project
     * and a task and shows a message confirming if user wants to
     * move/copy these resources to new project or don't.
     ************************************************************/
    var areThereDifferentResourcesInThatProject = function(targetProject, targetTask, replanningReasonId, widgetTasks, callback) {
        var widget = (callback === moveTask) ? getWidgetMoveTask() : getWidgetCopyTask();
        if(!widget.isValid()){
            ScreenService.showMessage(Messages.ERR_REQUIRED_FIELDS);
            return false;
        }
        var tasksToManipulate = getOnlyTasksIdsFromListOfTasksObjects(widgetTasks.getCheckedRows());
        ScreenService.showLoader();
        ProjectServiceList.differentResourcesBetweenTargetProjectOriginTask(tasksToManipulate, targetProject).then(function(diff) {
            ScreenService.hideLoader();
            var diffResources = diff.dataset.differentResources;
            if(diffResources.length > 0) {
                var msgOne = Messages.ALE_DIFFERENT_RESOURCES_PT1;
                var msgTwo = Messages.ALE_DIFFERENT_RESOURCES_PT2;
                var message = msgOne + createMessageWithResourcesNames(diffResources) + msgTwo;
                return ScreenService.showCustomDialog(message, 'ALERT', null, [
                        {
                            "label": "Sim",
                            "code": function () {
                                return callback.call(callback, targetProject, targetTask, widgetTasks, true, getSpecifiedPropertyFromObjects(diffResources, "RESOURCE_ID"), replanningReasonId);
                            }
                        },
                        {
                            "label": "Não",
                            "code": function () {
                                return callback.call(callback, targetProject, targetTask, widgetTasks, false, null, replanningReasonId);
                            }
                        },
                        {
                            "label": "Cancelar",
                            "code": function () {}
                        }
                    ]
                );
            } else {
                return callback.call(callback, targetProject, targetTask, widgetTasks, false, null, replanningReasonId);
            }
        }).catch(function(responce){
            Utilities.showMessageErrorOfBackEnd(responce,null,null,true);
        });
    };

    /************************************************************
     * Back to Widget that contains the list of tasks, closing
     * swipe and reloading the widget.
     ************************************************************/
    var backToWidgetTasksList = function(widgetTasks){
        widgetTasks.reload();
        widgetTasks.dataSource.unSelectAll(); // needed for bug with checkboxes caused by framework
        ScreenService.closePopup(true);
        widgetTasks.activate();
    };

    /************************************************************
     * Moves a task.
     ************************************************************/

	var moveTask = function(targetProject, targetTask, widgetTasks, addDifferentResources, differentResourcesIds, replanningReasonId) {
        var tasks = widgetTasks.dataSource.checkedRows;
        var projectId = localStorageEngine.getLocalVar('project');
        var targetProjectId = targetProject;
        var moveTaskAfterValidation = function(taskIdsNotMoved) {
            ScreenService.showLoader();
            ProjectServiceList.taskHasBranch(tasks, targetProject, projectId).then(function (response) {
                ScreenService.hideLoader();
                var tasksWithBranch = response.dataset.taskHasBranch;
                if(tasksWithBranch.length > 0){
                    var taskMsg = '<br><br>';
                    tasksWithBranch.forEach(function(task){
                        taskMsg += '<li align="left">' + task.NAME + '</li>';
                    });
                    ScreenService.showMessage(Utilities.messages.ERR_NOT_MOVE_TASK_INITIALIZED + taskMsg);
                } else {
                    addDifferentResources = addDifferentResources || false;
                    differentResourcesIds = differentResourcesIds || [];

                    ProjectServiceList.moveTask(targetProject, targetTask, replanningReasonId, widgetTasks.dataSource.checkedRows, addDifferentResources, differentResourcesIds, taskIdsNotMoved)
                        .then(function (response) {
                            var message = response.notifications[0];
                            if (message.type === 'W') {
                                ScreenService.showMessage('Erro ao tentar mover a(s) tarefa(s). ' + message.message, null, 'error');
                            } else {
                                backToWidgetTasksList(widgetTasks);
                                ScreenService.showMessage(message.message);
                            }
                        })
                        .catch(function (responce) {
                            Utilities.showMessageErrorOfBackEnd(responce, null, null, true);
                        });
                }
            }).catch(Utilities.showMessageBackEndTrue);
        };

        ScreenService.showLoader();
        ProjectServiceList.validateConcludedTaskToMove(tasks, projectId, targetProjectId).then(function(response){
            ScreenService.hideLoader();
            if (response[0].ERROR) {
                var message = Messages.ALE_NOT_MOVE_CONCLUDED_TASKS.replace('%2', '"' + response[0].ERROR.join('"<br/>"') + '"');
                ScreenService.showMessage(message, 'INFORMATION');
            } else if (response[0].SUBRELEASE_IS_CLOSED) {
                ScreenService.showMessage(Utilities.messages.ERR_SUBRELEASE_FINISHED);
            } else if(response[0].CONCLUDED_TASK_CHILD){

            } else {
                moveTaskAfterValidation();
            }
        }).catch(Utilities.showMessageBackEndTrue);
	};

    var validateGeneratedTaskToCopy = function(tasks) {
        var generatedTasks = [];

        tasks.forEach(function(task) {
            if(Messages.TYPE_GENERATED_TASK.indexOf(task.TYPE_RELATIONSHIP) != -1) {
                generatedTasks.push(task.NAME);
            }
        });

        return generatedTasks;
    };

    this.taskWidgetOnSaveInlineEdit = function(args){
        var taskWidget = getWidgetProjectTasks();
        var rows = args.e.data.changedRows;
        var isValid = true;
        rows.forEach(function(row){
            if(row.PERCENT_COMPLETED == "100" || row.status === 'Concluída' || row.IS_PARENT == 'Y'){
                isValid = false;
            }
        });
        if(isValid){
            ScreenService.showLoader();
            ProjectServiceList.saveTaskEstimatedPointsInLine(rows).then(function () {
                ScreenService.hideLoader();
                taskWidget.reload();
                taskWidget.activate();
                taskWidget.list();
                ScreenService.successNotification(Utilities.messages.SUC_SUCCESSFUL_SAVED_POINTS);
            }).catch(function (response) {
                ScreenService.hideLoader();
                Utilities.showMessageErrorOfBackEnd(response);
            });
        } else {
            ScreenService.showMessage(Utilities.messages.ERR_TASK_CONCLUDED);
        }
        
    };

    /************************************************************
     * Copy a task.
     ************************************************************/
    var copyTask = function(targetProject, targetTask, widgetTasks, addDifferentResources, differentResourcesIds) {
        addDifferentResources = addDifferentResources || false;
        differentResourcesIds = differentResourcesIds || [];
        ScreenService.showLoader();
        ProjectServiceList.projectHasMnemonic(widgetTasks.dataSource.checkedRows, true).then(function (response) {
            ScreenService.hideLoader();
            if(response.length > 0) {
                localStorageEngine.setLocalVar('addDifferentResources', addDifferentResources);
                localStorageEngine.setLocalVar('differentResourcesIds', differentResourcesIds);
                return changeProjectNameMnemonic(response, getWidgetMnemonicNameFromCopyTask());
            }
            return ProjectServiceList.copyTask(targetProject, targetTask, widgetTasks.dataSource.checkedRows, addDifferentResources, differentResourcesIds).then(function (res) {
                if (res && res.notifications[0]) {
                    var message = res.notifications[0];
                    if (message.type === 'W') {
                        ScreenService.showMessage(Messages.ERR_CANT_COPY_TASKS + message.message, null, 'error');
                    } else {
                        backToWidgetTasksList(widgetTasks);
                        ScreenService.showMessage(message.message);
                    }
                }
            }).catch(function (responce) {
                Utilities.showMessageErrorOfBackEnd(responce, null, null, true);
            });
        }).catch(Utilities.showMessageBackEndTrue);
    };

    this.copyOldValuesTaskStatusAndPercentCompleted = function(row){
        row.TASK_STATUS_OLD = row.TASK_STATUS;
        row.PERCENT_COMPLETED_OLD = row.PERCENT_COMPLETED;
    };

    /***********************************************************************
     * Called by action event.
     ***********************************************************************/
    this.newTaskActionEventEdit = function(args) {
        var widget = args.owner.widget;
        enableAllWidgetFields(widget);
        widget.edit();
        widget.template = widget.formTemplate;

        self.setVisibleDateException(widget.currentRow,widget);
        setDataSourceException(widget,widget.currentRow.IS_UPPER);
        self.copyOldValuesTaskStatusAndPercentCompleted(widget.currentRow);
        self.projectTypeChangeTask(widget.currentRow,widget);
        changeFieldsVisibilityOnNewTaskWidgetWhenEditing();

        getNewTaskWidget().getField('TASK_FEATURES').reload();
        getNewTaskWidget().getField('TASK_CLASSIFICATION_LABEL').reload();
        getNewTaskWidget().getField('PARENT_NAME').reload();
        getNewTaskWidget().getField('TASK_STATUS_NAME').reload();

        var concludedStatusId = localStorageEngine.getLocalVar('taskParameters').CONCLUDED_TASK_STATUS_ID;
        var percentCompleted = widget.currentRow.PERCENT_COMPLETED;
        var taskStatus = widget.currentRow.TASK_STATUS;
        var taskConcluded = isTaskConcluded(taskStatus, concludedStatusId, percentCompleted);
        taskTabbedToggleVisibility(false);
        _setEnableLatency(getFieldLatencyFromNewTaskWidget(),getFieldPrecursorNameFromNewTaskWidget(), taskConcluded);
    };

    var setDataSourceException = function(widget,isParent){
        if(isParent){
            widget.getField('DATE_EXCEPTION_NAME').dataSource.data = DATA_SET_EXCEPTION_NODE;
        } else {
            widget.getField('DATE_EXCEPTION_NAME').dataSource.data = DATA_SET_EXCEPTION_LEAF;
        }
    };

    this.goBackTask = function(widget) {
        ScreenService.closeSwipe();
        widget.list();
        var widgetForm = getWidgetBasicTaskInformation();
        widgetForm.list();
        widgetForm.template = widgetForm.formTemplate;
        getWidgetProjectTabbed().currentWidget.activate();
	};

    this.newTaskActionEventCancel = function(args) {
        var widget = getNewTaskWidget();
        if(widget.currentRow.__is_new) {
            ScreenService.closeSwipe();
            widget.list();
            var widgetForm = getWidgetBasicTaskInformation();
            widgetForm.list();
            widgetForm.template = widgetForm.formTemplate;
            getWidgetProjectTabbed().currentWidget.activate();
        } else {
            Utilities.fixBugReloadWidgetInViewMode(widget);
        }
        taskTabbedToggleVisibility(true);
	};

    this.basicActionEventVoltar = function(args) {
        self.goBackProjectList(args.owner.widget);
    };

    this.basicActionEventBack = function(args) {
        ScreenService.closePopup();
    };

    this.basicActionEventCancel = function(args) {
        if(getWidgetBasicProjectInformation().currentRow.__is_new) {
            self.goBackProjectList(getWidgetBasicProjectInformation());
        }else{
            Utilities.fixBugReloadWidgetInViewMode(getWidgetBasicProjectInformation());
            setWidgetAsViewMode(getWidgetBasicProjectInformation());
        }
        setValueModelProjectHasChildren(false);
    };

    var setWidgetAsViewMode = function(widget){
        widget.view();
        widget.template = Utilities.defaultTemplates.formView;
        widget.reload();
    };

    this.issueMainActionEventBack = function(args){
        ScreenService.closeSwipe().then(function(){
            getWidgetTaskIssues().activate();
        });
    };

    this.goBackProjectList = function(widgetCurrent) {
        var tabbedCurrentWidget = getWidgetProjectListTabbed().currentWidget;
        ScreenService.closeSwipe();
        if(widgetCurrent){
            widgetCurrent.list();
        }
        tabbedCurrentWidget.activate();
        localStorageEngine.setLocalVar('project',null);
        var widgetForm = getWidgetBasicProjectInformation();
        widgetForm.list();
        widgetForm.template = widgetForm.formTemplate;

    };
    this.onChangeTimeTotal = function(args){
        var row = args.row;
        var exceptions = getWidgetProjectListException().dataSource.data;
        var fieldResource = args.owner.field.widget.getField('RESOURCE');
        if(!exceptions){
            exceptions = [];
        }
        ProjectServiceList.parseTimeTypeTask(row,exceptions,fieldResource);
    };

    this.basicWidgetAfterLoadDataSource = function() {
        var widget = getWidgetBasicProjectInformation();
        var fieldModel = getFieldModelsFromProjectInformationWidget();
        if( ! widget.isBeingCreated) {
            var projectId = Utilities.localVar.getProject();
            if (projectId && widget.id == getActiveWidget().id) {
                widget.view();
            }
            widget.moveToFirst();
            widget.template = widget.templateToView;
            validateEditProjectStatus(widget.currentRow.PROJECT_STATUS_ID,widget.currentRow.MODELS_IS_RESTRICTED, widget.currentRow.EXTERNALTYPE);
            setIsVisibleInViewModel(!!fieldModel.value());
        } else {
            widget.template = widget.templateToView;
        }
        setLocalVarProjectParent(false);
        reloadManagerProject(getFieldManagerFromProjectInformationWidget(), widget.currentRow.GROUP);
        self.projectTypeChangeProject();
        setDevOpsReadOnlyAndIsVisibleProject(false);
        var projectType = Utilities.getValueInSelectField(getFieldProjectTypeFromBasicWidget());
        Utilities.localVar.setLocalVarProjectType(projectType);
        Utilities.localVar.setClickedProjectUseTimePlanning(widget.currentRow.USETIMEPLANNING);
        Utilities.localVar.setProjectExternalType(widget.currentRow.EXTERNALTYPE);
        setActionsIsVisiblePMModelIsVisible();
        var currentRow = getWidgetBasicProjectInformation().currentRow;
        if(currentRow.UPPER_PROJECT) {
            ProjectServiceList.productProjectHasAllowReplicationLts(currentRow.UPPER_PROJECT).then(function (response) {
                var productProjectHasAllowReplicationLts = response.dataset.productProjectHasAllowReplicationLts[0];
                if(currentRow.EXTERNALTYPE === 'E' && productProjectHasAllowReplicationLts === 'Y') {
                    getFieldIsLtsReplicationFromProjectInformationWidget().isVisible = true;
                } else {
                    getFieldIsLtsReplicationFromProjectInformationWidget().isVisible = false;
                }
            });
        } else {
            getFieldIsLtsReplicationFromProjectInformationWidget().isVisible = false;
        }
        setReadOnlyIsLtsReplicationFromProjectInformationWidget(currentRow.PROJECT_STATUS_CONTROL, getFieldIsLtsReplicationFromProjectInformationWidget());
    };

    var setLocalVarProjectParent = function(reload) {
        Utilities.localVar.setLocalVarProjectParent(Utilities.getValueInSelectField(getFieldParentNameFromProjectInformationWidget()));
        if (reload) {
            getFieldProjectTypeFromBasicWidget().reload();
            var modelField = getFieldModelsFromProjectInformationWidget();
            modelField.reload().then(function () {
                if (modelField.value() &&
                    !getWidgetBasicProjectInformation().currentRow.ID &&
                    !Utilities.getCurrentRowInFieldSelect(modelField)) {
                    Utilities.clearValueSelect(modelField);
                }
            });
        }
    };


    var finishPlanning = function(projectWidget){
        ProjectServiceList.finishPlanning(projectWidget.currentRow.ID).then(function(){
            getWidgetProjectListManager().reload();
            ScreenService.closeSwipe().then(function(){
                getWidgetProjectListManager().activate();
            });
            ScreenService.successNotification('Planejamento finalizado com sucesso');
        }).catch(Utilities.showMessageBackEndTrue);
    };

    this.removeLtsActionEventBack = function() {
        ScreenService.closePopup();
    };

    this.versionRemoveLtsActionEventRemove = function() {
        var projectWidget = getWidgetBasicProjectInformation();
        var projectName = projectWidget.currentRow.NAME;
        var externalType = projectWidget.currentRow.EXTERNALTYPE;
        var useTimePlanning = projectWidget.currentRow.USETIMEPLANNING;
        //
        var versionRemoveLtsTabbedWidget = getWidgetRemoveLts();
        var versionRemoveLtsGridWidget   = getWidgetRemoveLtsGrid();
        if(versionRemoveLtsTabbedWidget.isValid()) {
            var checkedRows = versionRemoveLtsGridWidget.getCheckedRows();
            if(Util.isEmptyOrBlank(checkedRows)) {
                 ScreenService.confirmMessage(Utilities.messages.ALE_CONFIRM_PROCEED_WITHOUT_REMOVAL, 'ALERT',
                    function () {
                            buildMessageAndFinishTimePlanning(externalType, useTimePlanning, projectWidget, projectName);
                        }, function () { });
            } else {
                ScreenService.confirmMessage(Utilities.messages.ALE_CONFIRM_CHANGE_LTS_REMOVAL, 'ALERT',
                    function () {
                        ScreenService.showLoader();
                        IssueService.removeLTSFromVersions(checkedRows).then(function () {
                            ScreenService.hideLoader();
                            ScreenService.closePopup();
                            ScreenService.closePopup();
                            projectWidget.activate();
                            projectWidget.reload();
                            ScreenService.successNotification(Utilities.messages.ALE_LTS_UPDATED);
                            //continuação da finalização 
                            buildMessageAndFinishTimePlanning(externalType, useTimePlanning, projectWidget, projectName);
                        }).catch(function(response){
                            Utilities.showMessageErrorOfBackEnd(response, null, null, true);
                        });
                    }, function () { });
            }
        }
    };

    var buildMessageAndFinishTimePlanning = function(externalType, useTimePlanning, projectWidget, projectName){
        if(externalType && useTimePlanning &&
            (PROJECT_TYPE_COPY_IN_TIMELINE.indexOf(externalType) != -1 || useTimePlanning == 'Y')){
            message = Utilities.messages.ALE_PROJECT_FINISH_PLANNING + projectName + '" ?';
        } else {
            message = Utilities.messages.ALE_PROJECT_FINISH_PLANNING_ERROR + projectName + '" ?';
        }
        ScreenService.confirmMessage(message,
        null, finishPlanning.bind(self, projectWidget), null);
        ScreenService.closePopup();
    };

    this.basicActionEventFinishPlanning = function(){
        var projectWidget = getWidgetBasicProjectInformation();
        var projectName = projectWidget.currentRow.NAME;
        var externalType = projectWidget.currentRow.EXTERNALTYPE;
        var useTimePlanning = projectWidget.currentRow.USETIMEPLANNING;
        ScreenService.closePopup();
        if(projectWidget.currentRow.PRODUCT_VERSION_DEV_ID &&
           (externalType == TYPE_RELATIONSHIP_ERROR || externalType == TYPE_RELATIONSHIP_ERROR_MR)) {
            ScreenService.showLoader();
            IssueService.findLTSProductVersionToRemove(projectWidget.currentRow.ID).then(function (response) {
                ScreenService.hideLoader();
                if(response.lts.length > 0) {                        
                    ScreenService.showCustomDialog(Utilities.messages.ALE_CONFIRM_LTS_REMOVAL,
                    'CONFIRMATION', null,
                    [
                        {
                            "label": "Sim",
                            "code": function () {
                                getWidgetRemoveLts().currentRow = response.first_value;
                                getWidgetRemoveLtsGrid().dataSource.data = response.lts;
                                ScreenService.openPopup(getWidgetRemoveLts());
                            }
                        },
                        {
                            "label": "Não",
                            "code": function () {
                                buildMessageAndFinishTimePlanning(externalType, useTimePlanning, projectWidget, projectName);
                            }
                        }
                    ]);
                    
                }else{
                    buildMessageAndFinishTimePlanning(externalType, useTimePlanning, projectWidget, projectName);
                    }
            }).catch(function(response){
                Utilities.showMessageErrorOfBackEnd(response, null, null, true);
            });
        }else{     
            buildMessageAndFinishTimePlanning(externalType, useTimePlanning, projectWidget, projectName);
       }
    };

    this.newTaskWidgetAfterLoadDataSource = function(args){
        var newTaskWidget = getNewTaskWidget();
        newTaskWidget.moveToFirst();
        if(newTaskWidget.currentRow.ID) {
            self.AfterLoadDataSourceFormTask(args);
            self.projectTypeChangeTask(newTaskWidget.currentRow, newTaskWidget);
            enableAllWidgetFields(newTaskWidget);
            changeFieldsVisibilityOnNewTaskWidgetWhenEditing();
            Utilities.hideFieldsOnViewWhenNoContent(newTaskWidget);
        }
    };

    var hasErrorClassification = function(){
        return (getNewTaskWidget().currentRow.ERROR_CLASSIFICATION) ? true : false;
    };

    var setIsVisbleFalseOrReadOnlyTrueFieldErrorClassification = function (){
        if(hasErrorClassification()){
            getFieldErrorClassificationFromNewTaskWidget().readOnly = true;
        } else {
            getFieldErrorClassificationFromNewTaskWidget().isVisible = false;
        }
    };

    this.basicInformationResourceWidgetAfterLoadDataSource = function(args){
        getWidgetBasicInformationResource().moveToFirst();
    };

    this.basicInformationResourceWidgetActionEventRemove = function(args){
        ScreenService.confirmMessage(Messages.ALE_DELETE_RESOURCE_FROM_PROJECT, 'question', function(){
            ProjectServiceList.editResourceDelete(args);
        });
    };

    this.AfterLoadDataSourceFormTask = function(args) {
        var widget = getNewTaskWidget();
        var taskId = localStorageEngine.getLocalVar('taskid');
        if(taskId){
            widget.list();
        }
        if(!widget.currentRow.__is_new) {
            widget.moveToFirst();
        }
        widget.template = widget.formTemplate;

        var isParentField = widget.getField('IS_PARENT');
        var isParentValue = widget.currentRow.IS_PARENT;
        isParentField.checked = isParentValue === 'Y';
        isParentField.readOnly = widget.currentRow.IS_UPPER;
        widget.getField('TYPE_RELATIONSHIP').dataSource.data = Messages.FULL_DATA_TYPE_RELATIONSHIP_TASK;
    };

    var changeFieldsVisibilityOnNewTaskWidgetWhenCreating = function(){
        var taskTimePlanningSymbol = Utilities.localVar.getClickedProjectUseTimePlanning();
        var taskCanBeConcludedSymbol = Utilities.localVar.getClickedProjectAllowEndTasks();
        var latencyField = getFieldLatencyFromNewTaskWidget();
        latencyField.readOnly = true;

        var taskResponseField = getFieldTaskResponseFromNewTaskWidget();
        taskResponseField.isVisible = Utilities.localVar.getIsModel();

        var taskGeneratorField = getFieldTaskGeneratorNameFromNewTaskWidget();
        taskGeneratorField.showOnForm = false;

        var typeRelationshipField = getFieldTypeRelationshipFromNewTaskWidget();
        typeRelationshipField.isVisible = false;

        var percentCompletedField = getFieldPercentCompletedFromNewTaskWidget();
        percentCompletedField.showOnForm = true;

        var taskStatusField = getFieldTaskStatusNameFromNewTaskWidget();
        taskStatusField.validations = {required: {}};

        var taskClassificationLabel = getFieldTaskClassificationLabelFromNewTaskWidget();
        taskClassificationLabel.validations = {required: {}};

        var urlToTestField = getFieldUrlToTestFromNewTaskWidget();
        urlToTestField.isVisible = false;
        urlToTestField.showOnView = false;
        urlToTestField.showOnForm = false;

        if( ! isProjectTimeControlled(taskTimePlanningSymbol)){
            hideSomeFieldsOnNewTaskWidgetWhenTaskNotTimeControlled();
        }

         if( ! isTaskCanBeConcluded(taskCanBeConcludedSymbol)){
            hideSomeFieldsOnNewTaskWidgetWhenTaskCanNotBeConcluded();
        }

        setIsVisbleFalseOrReadOnlyTrueFieldErrorClassification();

        getFieldCreatedAtFromNewTaskWidget().readOnly = true;
        getFieldCreatedByFromNewTaskWidget().readOnly = true;
        var fieldId = getFieldIdFromNewTaskWidget();
        fieldId.readOnly = true;
        fieldId.isVisible = true;
    };

    var changeFieldsVisibilityOnNewTaskWidgetWhenEditing = function(){
        var newTaskWidget = getNewTaskWidget();
        var parameters = localStorageEngine.getLocalVar('taskParameters');
        var currentRow = newTaskWidget.currentRow;
        var taskStatusId = currentRow.TASK_STATUS;
        var concludedStatusId = parameters.CONCLUDED_TASK_STATUS_ID;
        var percentCompleted = currentRow.PERCENT_COMPLETED;
        var taskParentSymbol = currentRow.IS_PARENT;
        var taskTimePlanningSymbol = currentRow.USETIMEPLANNING;
        var taskCanBeConcludedSymbol = currentRow.ALLOWENDTASK;
        var taskClassificationIssue = currentRow.TASK_CLASSIFICATION_ISSUE;

        getFieldIdFromNewTaskWidget().readOnly = true;
        getFieldCreatedByFromNewTaskWidget().readOnly = true;
        getFieldCreatedAtFromNewTaskWidget().readOnly = true;
        var typeRelationshipField = getFieldTypeRelationshipFromNewTaskWidget();
        typeRelationshipField.readOnly = true;
        typeRelationshipField.showOnForm = false;

        var taskGeneratorField = getFieldTaskGeneratorNameFromNewTaskWidget();
        taskGeneratorField.readOnly = true;
        taskGeneratorField.showOnForm = false;

        var taskStatusField = getFieldTaskStatusNameFromNewTaskWidget();
        taskStatusField.validations = {required: {}};

        var taskClassificationLabelField = getFieldTaskClassificationLabelFromNewTaskWidget();
        taskClassificationLabelField.validations = {required: {}};

        getFieldDurationFromNewTaskWidget().validations = isTaskParent(taskParentSymbol) ? false : {required: {}};
        if(isTaskParent(taskParentSymbol)){
            disableSomeFieldsOnNewTaskWidgetWhenTaskIsParent();
            hideSomeFieldsOnNewTaskWidgetWhenTaskIsParent();
            removeSomeFieldsPropertiesWhenTaskIsParent();
        }

        if( ! isProjectTimeControlled(taskTimePlanningSymbol)){
            applyDefaultValuesToFieldsRelatedToTimeControl();
            hideSomeFieldsOnNewTaskWidgetWhenTaskNotTimeControlled();
        }

        if(isClassificationBasedOnIssues(taskClassificationIssue)){
            disableSomeFieldsOnNewTaskWidgetWhenClassificationIsBasedOnIssues();
        }

        if(isTaskConcluded(taskStatusId, concludedStatusId, percentCompleted)){
            disableSomeFieldsOnNewTaskWidgetWhenTaskIsConcluded();
        } else {
            hideNewTaskWidgetFieldsWhenNotConcludedTask();
        }

        if( ! isTaskCanBeConcluded(taskCanBeConcludedSymbol)){
            hideSomeFieldsOnNewTaskWidgetWhenTaskCanNotBeConcluded();
        }

        setIsVisbleFalseOrReadOnlyTrueFieldErrorClassification();
        setBacklog(true);
    };

    var setBacklog = function(keepPrevious){
        var widget = getWidgetBasicTaskInformation();
        var isBacklog = widget.currentRow.TASK_STATUS_CONTROL == PMConstants.CONTROL_TASK_STATUS_BACKLOG;
        widget.fields.filter(function(field){
            return field.PMReadOnlyBacklog;
        }).forEach(function(field){
            if(isBacklog){
                field.validations = null;
                field.readOnly = true;
                field.value(null);
            }else{
                if(field.isVisible){
                    field.validations = field.PMValidationsNotBacklog;
                    if(!keepPrevious){
                        field.readOnly = false;
                    }
                }
            }
        });
        if(!(isBacklog || widget.currentRow.START || widget.currentRow.END || keepPrevious)){
            widget.currentRow.START = widget.currentRow.END = widget.currentRow.BEGIN_PROJECT;
        }
    };

    this.newTaskFieldOnChangeTaskStatusName = function(){
        setBacklog();
    };

    var removeSomeFieldsPropertiesWhenTaskIsParent = function(){
        getFieldTaskStatusNameFromNewTaskWidget().validations = null;
        getFieldTaskClassificationLabelFromNewTaskWidget().validations = null;
    };

    var applyDefaultValuesToFieldsRelatedToTimeControl = function(){
        var startDateField = getFieldStartFromNewTaskWidget();
        var endDateField = getFieldEndFromNewTaskWidget();
        endDateField.value(startDateField.value());
    };

    var hideNewTaskWidgetFieldsWhenNotConcludedTask = function(){
        getNewTaskWidget().getField('TASK_RESPONSE').isVisible = Utilities.localVar.getIsModel();
    };

    var isTaskParent = function(taskStatus){
        return taskStatus == IS_PARENT_POSITIVE;
    };

    var isProjectTimeControlled = function(timePlanning){
        return timePlanning == USETIMEPLANNING_POSITIVE;
    };

    var isTaskCanBeConcluded = function(allowEndTask){
        return allowEndTask == ALLOWENDTASK_POSITIVE;
    };

    var isClassificationBasedOnIssues = function(taskClassificationIssue){
        return !!taskClassificationIssue;
    };

    var disableSomeFieldsOnNewTaskWidgetWhenTaskIsConcluded = function(){
        var newTaskWidget = getNewTaskWidget();
        newTaskWidget.getField('NAME').readOnly = true;
        newTaskWidget.getField('IS_PARENT').readOnly = true;
        newTaskWidget.getField('STATUS').readOnly = true;
        newTaskWidget.getField('RESOURCE').readOnly = true;
        newTaskWidget.getField('TASK_FEATURES').readOnly = true;
        newTaskWidget.getField('TASK_STATUS_NAME').readOnly = true;
        newTaskWidget.getField('TOTAL_TIME').readOnly = true;
        newTaskWidget.getField('START').readOnly = true;
        newTaskWidget.getField('END').readOnly = true;
        newTaskWidget.getField('TIME_PLANNED').readOnly = true;
        newTaskWidget.getField('LATENCY').readOnly = true;
        newTaskWidget.getField('PRECURSOR_NAME').readOnly = true;
        newTaskWidget.getField('TYPE').readOnly = true;
        newTaskWidget.getField('LATENCY').readOnly = true;
        newTaskWidget.getField('TASK_CLASSIFICATION_LABEL').readOnly = true;
        newTaskWidget.getField('PERCENT_COMPLETED').readOnly = true;
        newTaskWidget.getField('DATE_EXCEPTION_NAME').readOnly = true;
        newTaskWidget.getField('DATE_EXCEPTION').readOnly = true;
        newTaskWidget.getField('TASK_GENERATOR_NAME').readOnly = true;
        newTaskWidget.getField('TYPE_RELATIONSHIP').readOnly = true;
        newTaskWidget.getField('DESCRIPTION').readOnly = true;
        newTaskWidget.getField('URL_TO_TEST').readOnly = true;
        newTaskWidget.getField('PARENT').readOnly = true;
    };

    var hideSomeFieldsOnNewTaskWidgetWhenTaskCanNotBeConcluded = function(){
        var newTaskWidget = getNewTaskWidget();
        newTaskWidget.getField('TASK_STATUS_NAME').isVisible = false;
        newTaskWidget.getField('PERCENT_COMPLETED').isVisible = false;
    };

    var hideSomeFieldsOnNewTaskWidgetWhenTaskNotTimeControlled = function(){
        var newTaskWidget = getNewTaskWidget();
        newTaskWidget.getField('TOTAL_TIME').isVisible = false;
        newTaskWidget.getField('START').isVisible = false;
        newTaskWidget.getField('END').isVisible = false;
        newTaskWidget.getField('PRECURSOR_NAME').isVisible = false;
        newTaskWidget.getField('LATENCY').isVisible = false;
        newTaskWidget.getField('TYPE').isVisible = false;
        newTaskWidget.getField('DATE_EXCEPTION_NAME').isVisible = false;
        newTaskWidget.getField('DATE_EXCEPTION').isVisible = false;
    };

    var disableSomeFieldsOnNewTaskWidgetWhenTaskIsParent = function(){
        setReadOnlyInIsParent();
    };

    var hideSomeFieldsOnNewTaskWidgetWhenTaskIsParent = function(){
        var newTaskWidget = getNewTaskWidget();
        newTaskWidget.getField('TASK_CLASSIFICATION_LABEL').isVisible = false;
        newTaskWidget.getField('TASK_RESPONSE').isVisible = Utilities.localVar.getIsModel();
    };

    var disableSomeFieldsOnNewTaskWidgetWhenClassificationIsBasedOnIssues = function(){
        var newTaskWidget = getNewTaskWidget();
        newTaskWidget.getField('TASK_CLASSIFICATION_LABEL').readOnly = true;
    };

    var changeNewTaskWidgetFieldsWhenConcludedTask = function(){
        var newTaskWidget = getNewTaskWidget();
        newTaskWidget.fields.forEach(function(field){
            if(field.hasOwnProperty("pmReadOnlyOnConcludedTask")){
                field.readOnly = field.pmReadOnlyOnConcludedTask;
            }
            if(field.hasOwnProperty("pmVisibleOnConcludedTask")){
                field.isVisible = field.pmVisibleOnConcludedTask;
            }
        });
    };
    var setReadOnlyInIsParent = function(reverse) {
        var newTaskWidget = getNewTaskWidget();
        newTaskWidget.fields.forEach(function (field) {
            if (field.hasOwnProperty("pmReadOnlyOnParentTask")) {
                field.readOnly = reverse ? !field.pmReadOnlyOnParentTask : field.pmReadOnlyOnParentTask;
            }

        });
    };

    var enableAllWidgetFields = function(widget){
        if( ! widget.hasOwnProperty("fields")) return false;

        widget.fields.forEach(function(field){
            if (!field.pmReadOnlyTrue) {
                field.isVisible = true;
                field.readOnly = false;
            }
        });
    };


    this.goBackProject = function(widgetSwipe) {
        ScreenService.goBack();
        localStorageEngine.setLocalVar('project',null);

    };

    this.onChangeEndTask = function(args){

    };

    this.setDateBeginExcepition = function (row, beginTask, beginTaskParent, beginProject, widget, dateException) {
        if (row.DATE_EXCEPTION_ABBREVIATION == 'MB') {
            if ((beginTask != beginTaskParent && beginTaskParent ) || (beginTask != beginProject && !beginTaskParent)) {
                row.DATE_EXCEPTION = row.START;
                var dataException = widget.getField('DATE_EXCEPTION_NAME').dataSource.data;
                dataException.forEach(function (data) {
                        if (data.ABBREVIATION == 'IA') {
                            row.DATE_EXCEPTION_ABBREVIATION = data.ABBREVIATION;
                            row.DATE_EXCEPTION_TYPE = data.ID;
                            row.DATE_EXCEPTION_NAME = data.NAME;
                        }
                    }
                );

            }
            this.setVisibleDateException(row, widget);
        } else if (row.DATE_EXCEPTION_ABBREVIATION == 'IA') {
            beginTask = moment(row.START, 'DD/MM/YYYY');
            dateException = moment(row.DATE_EXCEPTION, 'DD/MM/YYYY');
            if (beginTask < dateException || !dateException) {
                row.DATE_EXCEPTION = row.START;
            }
        } else if (row.DATE_EXCEPTION_ABBREVIATION == 'ID') {
            beginTask = moment(row.START, 'DD/MM/YYYY');
            dateException = moment(row.DATE_EXCEPTION, 'DD/MM/YYYY');
            if (beginTask > dateException || !dateException) {
                row.DATE_EXCEPTION = row.START;
            }
        } else if (row.DATE_EXCEPTION_ABBREVIATION == 'DI') {
            if (beginTask != dateException.format('DD/MM/YYYY')) {
                row.DATE_EXCEPTION = row.START;
            }
        }
        return row;
    };

    this.setDurationSuperAllocation = function(task,hoursDay){
        var now = moment(Utilities.getCurrentDate(),'DD/MM/YYYY');
        var begin = moment(task.BEGIN_DATE,'DD/MM/YYYY');
        var end = moment(task.ESTIMATED_DATE,'DD/MM/YYYY');
        var duration = 0;

        if(now.diff(begin) === 0 && now.diff(end) === 0 ){
            duration = Utilities.fieldDurationToHour(task.DURATION,hoursDay);
        }

        Utilities.fieldDurationToHour(task.DURATION,hoursDay);

        return duration;
    };
    this.validadeMaxDurationDay = function(widgetListTask,resourceTask,taskId){
        var allTaskForResource = widgetListTask.dataSource.data.filter(function(task){
            return (task.RESOURCES.filter(function(resource){
                return resource == resourceTask;
            }).length > 0) && (taskId != task.ID);
        });
        var allDurationDay = 0;
        var hoursDay = ProjectServiceList.getHoursDay;
        allTaskForResource.forEach(function(task){
            allDurationDay += self.setDurationSuperAllocation(task,hoursDay);
        });
    };
    this.editProjectSaveTask = function(args){
        if(this.validException(args.owner.widget.currentRow)) {
            var widgetFromTask = getWidgetBasicTaskInformation();
            var widgetBasic = getWidgetBasicProjectInformation();
            var widgetListTask = getWidgetProjectTaskList();
            var currentWidgetListProject = getWidgetProjectListTabbed().currentWidget;
            var resourcesTask = args.row.RESOURCE  &&
                                args.row.TASK_STATUS_CONTROL != Utilities.constants.CONTROL_TASK_STATUS_BACKLOG ?
                                args.row.RESOURCE : [];
            var idTask = args.row.ID ? args.row.ID : 0;
            var begin = args.row.START;
            var end = args.row.END;
            var precursor = args.row.PRECURSOR? args.row.PRECURSOR : 0;
            if(!args.row.hasOwnProperty('PROJECT') && !args.row.PROJECT) {
                args.row.PROJECT = localStorageEngine.getLocalVar('project');
            }
            var duration = Utilities.fieldDurationToHour(args.row.TOTAL_TIME, ProjectServiceList.getHoursDay);
            duration = duration * 3600;
            var filter = [{
                "operator": "=",
                "name": "TASK",
                "value": idTask
            }, {
                "operator": "IN",
                "name": "RESOURCES",
                "value": resourcesTask
            }, {
                "operator": "BETWEEN",
                "name": "DAY",
                "value": [begin,end]
            }, {
                "operator": "=",
                "name": "DURATION",
                "value": duration
            }, {
                "operator": "=",
                "name": "PROJECT",
                "value": args.row.PROJECT
            }, {
                "operator": "=",
                "name": "PRECURSOR",
                "value": precursor
            } ];
            ScreenService.showLoader();
            return requestDataSourceEngine.getDataSource('/validateMaxDurationDay', filter).then(function(response) {
                ScreenService.hideLoader();
                if(response.dataset && response.dataset.validateMaxDurationDay.resource) {
                    var tasks = '"'+response.dataset.validateMaxDurationDay.task.join('"<br>"')+'"';
                    var resource = '"'+response.dataset.validateMaxDurationDay.resource.join('"<br>"')+'"';
                    return ScreenService.showCustomDialog('O(s) recurso(s) ficará(ão) super alocado(s) nas sequintes tarefas : <br><br><strong> Recurso </strong><br>'+resource+' <br><br><strong> Tarefa </strong><br>'+tasks+'.',
                        'CONFIRMATION',null,
                        [
                            {
                                "label": "Salvar",
                                "code": function (e, deferred){
                                    ProjectServiceList.editProjectSaveTask(widgetFromTask, widgetBasic, widgetListTask, false,currentWidgetListProject).then(function(){
                                         deferred.resolve(e);
                                    }).catch(function(e){
                                        deferred.reject(e);
                                    });
                                }
                            },
                            {
                                "label": "Não salvar",
                                "code": function(e, deferred) {
                                    deferred.reject(e);
                                }
                            }
                        ]
                    );
                } else {
                   return ProjectServiceList.editProjectSaveTask(widgetFromTask, widgetBasic, widgetListTask, false, null);
                }
            }).catch(Utilities.showMessageBackEndTrue);
        }
    };

    this.filterActionEventTkOpenSelection = function(args){
        var activeWidget = getActiveWidget();
        activeWidget.openFilterWidget(getActiveWidget());
    };

    this.reloadFields = function(widget){
        widget.getField('RESOURCE').reload();
    };

    this.setVisibleDateException = function(row,widget){
        ProjectServiceList.setVisibleDateException(row,widget);
    };
    var __setValidationsClassificationInWidgetNewTask = function() {
        var isParentField = getFieldIsParentFromNewTaskWidget();
        var taskClassificationLabelField = getFieldTaskClassificationLabelFromNewTaskWidget();
        var fieldTaskStatus = getFieldTaskStatusNameFromNewTaskWidget();
        var fieldPercentCompleted = getFieldPercentCompletedFromNewTaskWidget();
        var resourcesField = getFieldResourceFromNewTaskWidget();
        var classificationIssue = getValueTaskClassificationIssueFromNewTaskWidget();
        var totalTimeField = getFieldDurationFromNewTaskWidget();
        var parameters = localStorageEngine.getLocalVar('taskParameters');
        __setClassificationByIssueClassification();

        if (isParentField.checked || isParentField.value() == 'Y') {
            Utilities.clearValueSelect(fieldTaskStatus);
            fieldTaskStatus.validations = false;
            totalTimeField.validations = false;
            fieldPercentCompleted.value(0);
            taskClassificationLabelField.isVisible = false;
            resourcesField.value([]);
            taskClassificationLabelField.value('');
            getNewTaskWidget().currentRow.TASK_CLASSIFICATION = null;
            setReadOnlyInIsParent();
        } else {
            fieldTaskStatus.validations = {"required": {}};
            totalTimeField.validations = {"required": {}};
            taskClassificationLabelField.isVisible = true;
            setReadOnlyInIsParent(true);
            if (classificationIssue) {
                taskClassificationLabelField.validations = false;
                taskClassificationLabelField.readOnly = true;
                if(!classificationIssue &&
                    (fieldTaskStatus.value() == parameters.CONCLUDED_TASK_STATUS_ID || fieldPercentCompleted.value() == 100 ))
                {
                    Utilities.clearValueSelect(taskClassificationLabelField);
                }
            } else {
                taskClassificationLabelField.validations = {"required": {}};
                taskClassificationLabelField.readOnly = false;
            }
        }
    };

    this.newTaskFieldOnChangeIsParent = function(args){
        var widget = getWidgetBasicTaskInformation();
        setDataSourceException(widget,widget.currentRow.IS_PARENT == 'Y');
        var field = getFieldDateExceptionNameFromNewTaskWidget();
        var valid =  Utilities.getRowInDataSource(field.dataSource, field.valueField,
            Utilities.getValueInSelectField(field));
        if(!valid){
            Utilities.setValueInSelectField(field,"MB");
        }
        __setValidationsClassificationInWidgetNewTask();
        setBacklog();
        self.newTaskFieldOnChangeDateExceptionName(args);
    };

    this.initializeFieldFromWidgetProjectTask = function (fieldName) {
        var field = getNewTaskWidget().getField(fieldName);
        field.initializeField();
    };

    var applyDefaultValuesNewTaskCurrentRow = function(widget, dateProjectBegin, dateProjectEnd, parent, parentName, useTimePlanning, notParentDefault) {
        localStorageEngine.setLocalVar("taskid", 0);
        self.reloadFields(widget);
        widget.label = 'Nova tarefa';
        widget.getField('STATUS').value('A');
        if(useTimePlanning != 'Y'){
            widget.getField('TOTAL_TIME').value('1D');
        }
        widget.getField('START').value(dateProjectBegin);
        widget.getField('END').value(dateProjectBegin);
        widget.getField('PERCENT_COMPLETED').value('0');
        widget.getField('DATE_EXCEPTION_NAME').dataSource.data = DATA_SET_EXCEPTION_LEAF;
        widget.getField('DATE_EXCEPTION_NAME').value("MB");
        widget.getField('TASK_STATUS_NAME').value(getLocalVar('taskParameters').INITIAL_TASK_STATUS_ID);
        widget.currentRow.DATE_EXCEPTION_TYPE = 'MB';
        widget.currentRow.PRECURSOR = null;
        widget.currentRow.DATE_EXCEPTION_ABBREVIATION = 'MB';
        widget.currentRow.BEGIN_PROJECT = dateProjectBegin;
        widget.currentRow.END_PROJECT = dateProjectEnd;
        widget.currentRow.TASK_STATUS = parseInt(getLocalVar('taskParameters').INITIAL_TASK_STATUS_ID);
        widget.currentRow.VERSION_DEV = localStorageEngine.getLocalVar('projectVersionDev');
        widget.currentRow.VERSION_DEV_ID = localStorageEngine.getLocalVar('projectVersionDevId');
        widget.getField('ID').isVisible = false;
        widget.getField('DATE_EXCEPTION').isVisible = false;
        var isParentField = getFieldIsParentFromNewTaskWidget();
        isParentField.value('N');
        isParentField.readOnly = false;
        isParentField.checked = false;
        setParentWithLastTaskSave(widget.currentRow, parent, parentName, notParentDefault);
    };

    this.projectTasksActionEventAddTask = function(args){
        var newTaskWidget = getNewTaskWidget();
        var widgetTabbed = getWidgetTaskTab();
        var basicProject = getWidgetBasicProjectInformation();
        var projectBeginDate = basicProject.currentRow.START;
        var projectEndDate = basicProject.currentRow.END;
        var currentRow = basicProject.currentRow;

        if(currentRow.MODELS && currentRow.IS_PROJECT_TYPE_ALLOWED){
            ScreenService.showMessage(Utilities.messages.ERR_PROJECT_NOT_ALLOW_TASK);
        }else if(basicProject.currentRow.SUBRELEASE_IS_CLOSED){
            ScreenService.showMessage(Utilities.messages.ERR_SUBRELEASE_FINISHED);
        }else{
            taskTabbedToggleVisibility(false);
            ScreenService.openSwipe(widgetTabbed).then(function(){
                enableAllWidgetFields(newTaskWidget);
                newTaskWidget.newRow();
                getNewTaskWidget().getField('TASK_STATUS_NAME').reload().then(function (){
                    applyDefaultValuesNewTaskCurrentRow(newTaskWidget, projectBeginDate, projectEndDate,null,null,basicProject.currentRow.USETIMEPLANNING);
                    changeFieldsVisibilityOnNewTaskWidgetWhenCreating();
                });
                getNewTaskWidget().getField('TASK_FEATURES').reload();
                getNewTaskWidget().getField('TASK_CLASSIFICATION_LABEL').reload();
                getNewTaskWidget().getField('PARENT_NAME').reload();
            });
        }
        
    };

    var taskTabbedToggleVisibility = function(condition){
        var widgetTabbed =  getWidgetTaskTab();
        widgetTabbed.widgets.forEach(function (widget) {
            if(widget.pmShowOnEdit) {
                widget.isVisible = (widget.pmShowOnEdit == 'Y' || condition);
            }
        });
    };

    /***********************************************************************
     * Check if task is concluded by its "task status" property or its
     * percent property.
     ***********************************************************************/
    var isTaskConcluded = function(taskStatusId, concludedStatusId, taskPercentCompleted){
        taskStatusId            = parseInt(taskStatusId);
        concludedStatusId       = parseInt(concludedStatusId);
        taskPercentCompleted    = parseInt(taskPercentCompleted);
        return (taskStatusId == concludedStatusId || taskPercentCompleted == 100);
    };

    var __setReadOnlyIsParentInNewTask = function() {
        var fieldIsParent = getFieldIsParentFromNewTaskWidget();
        var isUpper = getValueIsUpperFromNewTaskWidget();
        if(isUpper){
            fieldIsParent.readOnly = true;
        }else{
            fieldIsParent.readOnly = false;
        }
    };

    var __setClassificationByIssueClassification = function() {
        var task = getWidgetBasicTaskInformation().currentRow;
        if (task.TASK_CLASSIFICATION_ISSUE) {
            task.TASK_CLASSIFICATION = task.TASK_CLASSIFICATION_ID_ISSUE;
            task.TASK_CLASSIFICATION_LABEL = task.TASK_CLASSIFICATION_LABEL_ISSUE;
        }
    };

    /************************************************************
     * Shows widget (swipe) which has basic task information.
     * @param args
     ************************************************************/
    var taskMoveRowList = function(args){
        var widgetTabbed = getWidgetTaskTab();
        var idTask = args.row.ID;
        var widgetTask = getWidgetBasicTaskInformation();
        var widgetProjectTasks = getWidgetProjectTaskList();
        localStorageEngine.setLocalVar("taskProject",idTask);
        widgetTabbed.formTemplate = "widget/tabbedWidget.html";
        localStorageEngine.setLocalVar('taskid',idTask);
        self.reloadFields(widgetTask);
        widgetTask.label= 'Informações básicas';
        var fieldUrlToTest = getFieldUrlToTestFromNewTaskWidget ();

        if(getWidgetProjectTaskList().currentRow.TYPE_RELATIONSHIP === 'T') {
            fieldUrlToTest.isVisible = true;
            fieldUrlToTest.showOnView = true;
            fieldUrlToTest.showOnForm = true;
        } else {
            fieldUrlToTest.isVisible = false;
            fieldUrlToTest.showOnView = false;
            fieldUrlToTest.showOnForm = false;
        }

        Utilities.fixBugReloadWidgetInViewMode(getWidgetBasicTaskInformation()).then(function () {
            self.setActionDocumentByIDTaskStatus(getWidgetBasicTaskInformation(), getWidgetProjectDocumentsTask());
        });

        ScreenService.openSwipe(widgetTabbed);
        var activeWidget = templateManager.container.getActiveWidget();
        if(activeWidget.id != widgetTask.id && activeWidget.id != widgetProjectTasks.id) {
            activeWidget.reload();
        }

        widgetTask.getField('DATE_EXCEPTION_NAME').dataSource.data = DATA_SET_EXCEPTION_LEAF;
        __setReadOnlyIsParentInNewTask();
    };

    this.setActionDocumentByIDTaskStatus = function(widgetTask, widgetDocument){
        var parameters = localStorageEngine.getLocalVar('taskParameters');
        if(widgetTask.currentRow.TASK_STATUS == parameters.CONCLUDED_TASK_STATUS_ID){
            widgetDocument.getAction('ADD_DOCUMENTS').isVisible = false;
            widgetDocument.getAction('DELETE_DOCUMENTS').isVisible = false;
        } else {
            widgetDocument.getAction('ADD_DOCUMENTS').isVisible = true;
            widgetDocument.getAction('DELETE_DOCUMENTS').isVisible = false;

        }
        widgetDocument.list();
    };

    this.setManagerAndGroup = function(){
        var groupField = getFieldGroupNameFromProjectInformationWidget();
        var manageField = getFieldManagerFromProjectInformationWidget();
        var manager = Utilities.localVar.getLocalVarIdBusinessPartner();
        reloadGroupProject(groupField,[manager]).then(function(){
            var userGroup = groupField.dataSource.data.filter(function(group){
                return group.USER_STRUCTURE;
            });
            if(!!userGroup.length){
                userGroup = userGroup[0];
                Utilities.setOutData(groupField,userGroup[groupField.valueField]);
                manageField.value([manager]);
            }
        });
    };
    this.projectListManagerActionEventAdd = function(){
        ScreenService.showCustomDialog(Utilities.messages.COM_MODEL_CREATE,Utilities.MESSAGE_TYPE_CONFIRMATION, null,
            [{
                "label": "Sim",
                "code":function() {
                    self.openNewProject();
                    setIsVisibleModel(true);
                }
            }, {
                "label": "Não",
                "code": function() {
                    self.openNewProject();
                    setIsVisibleModel(false);
                }
            }, {
                "label": "Cancelar",
                "code": function(){}
            }]
        );
    };

    var setIsVisibleModel = function(isVisible) {
        var fieldModel = getFieldModelsFromProjectInformationWidget();
        fieldModel.isVisible = isVisible;
        fieldModel.showOnForm = isVisible;
        fieldModel.readOnly = false;
        fieldModel.validations = isVisible ? {required: {}} : false;
        if(isVisible) {
            fieldModel.reload();
        }
    };

    var setIsVisibleInViewModel = function(isVisible) {
        var fieldModel = getFieldModelsFromProjectInformationWidget();
        fieldModel.isVisible = isVisible;
        fieldModel.showOnView = isVisible;
        fieldModel.showOnForm = isVisible;
        fieldModel.validations = false;
    };

    this.newTaskActionEventAddGeneratedTask = function(args) {
        self.openGenerateTask(args.owner.widget, getWidgetGenerateTask(), getWidgetBasicProjectInformation());
    };


    this.projectTasksActionEventCreateNewSprint = function(args) {
         var parameters = getLocalVar('taskParameters');
         var isValid = true;
        getWidgetProjectTasks().dataSource.checkedRows.forEach(function(data) {
            if(data.PERCENT_COMPLETED == 100 || data.TASK_STATUS == parameters.CONCLUDED_TASK_STATUS_ID || data.ACTIVE_STATUS != "A") {
                isValid = false;
            }
        });

        if(isValid) {
            getNewPrintWidget().currentRow.MODELS = null;
            getNewPrintWidget().currentRow.MODELS_NAME = null;
            localStorageEngine.setLocalVar('modelsId', null);
            getMnemonicListWidget().reload();
            getFieldModelsFromNewSprintWidget().reload();
            ScreenService.openPopup(getNewPrintWidget());
        } else {
            ScreenService.showMessage(Utilities.messages.ERR_TASK_FINISHED_OR_INACTIVATED);
        }
    };

    this.openNewProject = function() {
        Utilities.closeSideMenu();

        var widgetTabbed = getWidgetProjectTabbed();
        var basicWidget = getWidgetBasicProjectInformation();
        var projectStatusField = getFieldProjectStatusFromBasicWidget();

        basicWidget.isBeingCreated = true;
        ScreenService.openSwipe(widgetTabbed);
        Utilities.localVar.setProject(null);
        Utilities.localVar.setLocalVarProjectParent(null);
        setDevOpsReadOnlyAndIsVisibleProject(true);

        basicWidget.newRow();

        projectStatusField.dataSourceFilter = [];
        basicWidget.template = basicWidget.formTemplate;
        basicWidget.currentRow.STATUS = 'A';
        basicWidget.currentRow.START = moment().format('DD/MM/YYYY');
        basicWidget.currentRow.END = moment().format('DD/MM/YYYY');
        basicWidget.currentRow.TOTAL_TIME = "1D";
        basicWidget.currentRow.EXCEPTION = [];
        basicWidget.currentRow.DATE_EXCEPTION = '';
        basicWidget.currentRow.DATE_EXCEPTION_TYPE = 'MB';
        basicWidget.currentRow.DATE_EXCEPTION_ABBREVIATION = 'MB';
        basicWidget.currentRow.DATE_EXCEPTION_NAME = 'O Mais Breve Possível';
        basicWidget.getField('DATE_EXCEPTION_NAME').dataSource.data = DATA_SET_EXCEPTION_NODE;
        reloadManagerProject(basicWidget.getField('MANAGER'), 0);
        widgetTabbed.widgets.forEach(function (widget) {
            widget.isVisible = (widget.name == 'BASIC');
        });
        basicWidget.fields.filter(function(field){
           return !field.isNotChangeIsVisibleInNewRow;
        }).forEach(function (field) {
            field.isVisible = true;
        });
        ScreenService.showLoader();
        validateEditProjectStatus(false,false).then(function(){
            ScreenService.hideLoader();
            setsProjectTypeInNewProject();
        }).catch(ScreenService.hideLoader);
        self.setManagerAndGroup();
        _setReadOnlyProjectDate();
        setReadOnlyByChangeModel(false,true);
        setConcludedInProject('N');
        getFieldVersionDevFromProjectInformationWidget().isVisible = false;
        localStorageEngine.setLocalVar('clientId', null);
        localStorageEngine.setLocalVar('parentProjectId', null);

        getFieldParentNameFromProjectInformationWidget().reload();
        getFieldSponsorNameFromBasicWidget().reload();
        getFieldProjectCategoriesFromBasicWidget().reload();
        getWidgetBasicProjectInformation().reload();
        getFieldProjectTypeFromBasicWidget().reload();
    };

    this.onChangePrecursor= function(row) {
        if(row.PRECURSOR_NAME ){
            if(!row.TYPE) {
                row.TYPE = 'TI';
            }
        }else{
            row.TYPE = null;
        }
    };

    var _setEnableLatency = function(latencyField,precursorField,concluded) {
        if(!concluded){
            var precursor = Utilities.getValueInSelectField(precursorField);
            if(precursor){
                latencyField.readOnly = false;
            }else{
                latencyField.readOnly = true;
                latencyField.setValue(0);
            }
        }
    };

    var addManagerByParent = function(parentRow) {
        if(parentRow) {
            var managerField = getFieldManagerFromProjectInformationWidget();
            var managerProjects = managerField.value();
            var filter = [{
                "operator": "=",
                "name": "PROJECT",
                "value": parentRow.ID
            }];
            ScreenService.showLoader();
            requestDataSourceEngine.getDataSource("/findManagerByProject", filter).then(function (response) {
                ScreenService.hideLoader();
                if(response.dataset && response.dataset.findManagerByProject){
                    var managerParents = response.dataset.findManagerByProject.map(function(manager){
                        return manager.ID;
                    });

                    var managerDiff = Utilities.removeArrayInOtherArray(managerProjects, managerParents);
                    var managers = Utilities.findInDataSource(managerField, managerDiff, managerField.valueField);
                    if (managers.length) {
                        var managerNames = managers.map(function (manager) {
                            return '"' + manager.NAME + '"';
                        });
                        ScreenService.showCustomDialog("Deseja adicionar os seguintes gerentes do projeto superior? <BR>" + managerNames.join('<BR>') + "", Utilities.MESSAGE_TYPE_CONFIRMATION, null,
                            [
                                {
                                    "label": "Sim",
                                    "code": function () {
                                        var managerIds = managers.map(function (manager) {
                                            return manager.ID;
                                        });
                                        managerProjects = managerProjects.concat(managerIds);
                                        managerField.value(managerProjects);
                                        self.basicFieldOnChangeManagerName();
                                    }
                                },
                                {
                                    "label": "Não",
                                    "code": function () {
                                    }
                                }
                            ]
                        );
                    }
                }
            }).catch(ScreenService.hideLoader);
        }
    };


    var addSponsorByParent = function(parentRow) {
        if(parentRow){

            var sponsorField = getFieldSponsorNameFromBasicWidget();
            if(!sponsorField.value()){
                var filter = [{
                    "operator": "=",
                    "name": "PROJECT",
                    "value": parentRow.ID
                }];
                requestDataSourceEngine.getDataSource("/findSponsorByProject", filter).then(function (response) {
                    if(response.dataset && response.dataset.findSponsorByProject){
                        var sponsorParent = response.dataset.findSponsorByProject[0].ID;
                        Utilities.setValueInSelectField(sponsorField,sponsorParent);
                    }
                });

            }
        }
    };

    this.basicFieldOnChangeUpperProjectName = function(args) {
        var basicWidget = getWidgetBasicProjectInformation();
        var parentField = getFieldParentNameFromProjectInformationWidget();
        var parentRow = Utilities.getCurrentRowInFieldSelect(parentField);
        if (parentRow &&
            parentRow.IS_MODEL != 'N' &&
            parentRow.HAS_CHILDREN == 'Y' &&
            parentRow.IS_MODEL != basicWidget.currentRow.ID) {
            Utilities.clearValueSelect(parentField);
            ScreenService.showMessage(Utilities.messages.ALE_MODEL_PARENT_IS_NOT_VALIDADE);
        } else {
            self.projectExceptionVisibility(basicWidget);
            ProjectServiceList.setDateParentProject(parentField, basicWidget.currentRow);
            if(basicWidget.currentRow.BEGINPARENT){
                self.basicFieldOnChangeStart();
                _calendarCalcProject();
            }
        }
        ScreenService.showLoader();
        ProjectServiceList.validateParentProjectChoiceByUser(basicWidget.currentRow).then(function (response) {
            ScreenService.hideLoader();
            var validateParentProject = response.dataset.validateParentProjectChoiceByUser[0];
            var productProjectHasAllowReplicationLts = response.dataset.productProjectHasAllowReplicationLts[0];
            if(!validateParentProject.IS_MANAGER) {
                var message = Utilities.messages.ERR_CHOICE_PARENT_PROJECT.replace('__PARENT_PROJECT__', basicWidget.currentRow.UPPER_PROJECT_NAME);
                ScreenService.showMessage(message);
                basicWidget.currentRow.UPPER_PROJECT = null;
                basicWidget.currentRow.UPPER_PROJECT_NAME = null;
            } else if(validateParentProject.IS_CHILDREN) {
                var msg = Utilities.messages.ERR_CHOICE_PARENT_PROJECT_IS_CHILDREN.replace('__PARENT_PROJECT__', basicWidget.currentRow.UPPER_PROJECT_NAME);
                ScreenService.showMessage(msg);
                basicWidget.currentRow.UPPER_PROJECT = null;
                basicWidget.currentRow.UPPER_PROJECT_NAME = null;
            } else {
                if(basicWidget.currentRow.EXTERNALTYPE === 'E' || productProjectHasAllowReplicationLts === 'Y'){
                    getFieldIsLtsReplicationFromProjectInformationWidget().isVisible = true;
                    getFieldIsLtsReplicationFromProjectInformationWidget().readOnly = false;
                } else {
                    getFieldIsLtsReplicationFromProjectInformationWidget().isVisible = false;
                    getFieldIsLtsReplicationFromProjectInformationWidget().readOnly = true;
                }
                setLocalVarProjectParent(true);
                addManagerByParent(parentRow);
                setValueNullFieldProjectTypeFromBasicWidget(basicWidget.currentRow);
                setValueNullFieldVersionDevFromBasicWidget(basicWidget.currentRow);
                getFieldVersionDevFromProjectInformationWidget().isVisible = false;
                localStorageEngine.setLocalVar('parentProjectId', basicWidget.currentRow.UPPER_PROJECT);
                getFieldVersionDevFromProjectInformationWidget().reload();
            }
        }).catch(ScreenService.hideLoader);
    };

    var setValueNullFieldProjectTypeFromBasicWidget = function (currentRow) {
        currentRow.PROJECT_TYPE_ID = '';
        currentRow.USETIMEPLANNING = '';
        currentRow.PROJECT_TYPE = '';
        currentRow.PROJECT_APPROVAL = [];
        currentRow.EXTERNALTYPE = '';
    };

    this.basicActionEventAdd = function() {
        ScreenService.showCustomDialog(Utilities.messages.COM_MODEL_CREATE,Utilities.MESSAGE_TYPE_CONFIRMATION,null,
            [
                {
                    "label": "Sim",
                    "code":function(){
                        self.openNewSubProject();
                        setIsVisibleModel(true);
                    }
                },
                {
                    "label": "Não",
                    "code": function(){
                        self.openNewSubProject();
                        setIsVisibleModel(false);
                    }
                },
                {
                    "label": "Cancelar",
                    "code": function(){}
                }
            ]
        );
    };

    this.openNewSubProject = function(){
        var basicWidget = getWidgetBasicProjectInformation();
        var projectStatusField = getFieldProjectStatusFromBasicWidget();
        var row = basicWidget.currentRow;
        Utilities.localVar.setProject(null);
        Utilities.localVar.setLocalVarProjectParent(row.ID);
        projectStatusField.dataSourceFilter = [];
        row.END = row.START;
        row.TOTAL_TIME = '1D';
        row.UPPER_PROJECT = row.ID;
        row.UPPER_PROJECT_NAME = row.NAME;
        row.NAME = '';
        row.dateBeginMax = null;
        row.dateEndMin = null;
        row.PROJECT_TYPE = null;
        row.MODELS = null;
        row.MODELS_NAME = null;
        delete row.ID;
        row.RESOURCES = getWidgetProjectResourceList().dataSource.data;
        basicWidget.edit();
        basicWidget.template = basicWidget.formTemplate;
        basicWidget.currentRow.DATE_EXCEPTION='';
        basicWidget.currentRow.CREATED_BY='';
        basicWidget.currentRow.CREATED_AT='';
        basicWidget.currentRow.TIME_PLANNED='';
        basicWidget.currentRow.__is_new = true;
        basicWidget.currentRow.DATE_EXCEPTION_TYPE='MB';
        basicWidget.currentRow.DATE_EXCEPTION_ABBREVIATION = 'MB';
        basicWidget.currentRow.DATE_EXCEPTION_NAME ='O Mais Breve Possível';
        basicWidget.fields.filter(function(field){
            return !field.isNotChangeIsVisibleInNewRow;
        }).forEach(function (field) {
            field.isVisible = true;
        });
        getWidgetProjectTabbed().widgets.forEach(function(widget){
            widget.isVisible = (widget.name == 'BASIC');
        });
        ScreenService.showLoader();
        validateEditProjectStatus(false,false).then(function(){
            ScreenService.hideLoader();
            setsProjectTypeInNewProject();
        }).catch(ScreenService.hideLoader);
        _setReadOnlyProjectDate();
        setDevOpsReadOnlyAndIsVisibleProject(true);
        setReadOnlyByChangeModel(false,true);
        setConcludedInProject('N');
        getFieldVersionDevFromProjectInformationWidget().isVisible = false;
        localStorageEngine.setLocalVar('clientId', basicWidget.currentRow.SPONSOR);
        localStorageEngine.setLocalVar('parentProjectId', basicWidget.currentRow.UPPER_PROJECT);
        self.basicFieldOnChangeManagerName();
        ProjectServiceList.productProjectHasAllowReplicationLts(row.UPPER_PROJECT).then(function(response){
            var productProjectHasAllowReplicationLts = response.dataset.productProjectHasAllowReplicationLts[0];
            if(basicWidget.currentRow.EXTERNALTYPE === 'E' && productProjectHasAllowReplicationLts === 'Y'){
                getFieldIsLtsReplicationFromProjectInformationWidget().isVisible = true;
                getFieldIsLtsReplicationFromProjectInformationWidget().readOnly = false;
            } else {
                getFieldIsLtsReplicationFromProjectInformationWidget().readOnly = true;
                getFieldIsLtsReplicationFromProjectInformationWidget().isVisible = false;
            }
        });

        getFieldSponsorNameFromBasicWidget().reload();
        getFieldParentNameFromProjectInformationWidget().reload();
        getFieldProjectCategoriesFromBasicWidget().reload();
        getFieldProjectTypeFromBasicWidget().reload();
    };

    var setDefaultValueInProjectStatus = function () {
        var fieldProjectStatus = getFieldProjectStatusFromBasicWidget();
        var defaultValue = Utilities.findInDataSource(fieldProjectStatus, ['N'], fieldProjectStatus.PMControl)[0];
        Utilities.setOutData(fieldProjectStatus, defaultValue[fieldProjectStatus.valueField]);
        fieldProjectStatus.readOnly = true;
    };

    var setsProjectTypeInNewProject = function(){
        self.projectTypeChangeProject();
        setDefaultValueInProjectStatus();
    };

    var setsProjectTypeInNewProjectInLine = function(){
        var fieldProjectStatus = getFieldProjectStatusFromBasicWidget();
        var defaultValue = Utilities.findInDataSource(fieldProjectStatus, ['N'], fieldProjectStatus.PMControl)[0];
        return Utilities.setOutData(fieldProjectStatus, defaultValue[fieldProjectStatus.valueField]);
    };

    this.onEnterProjectListManager = function(args) {
        ScreenService.showLoader();
        Utilities.localVar.getLoginPromise().then(function(){
            ScreenService.hideLoader();
            var projectListManagerWidget = getWidgetProjectListManager();
            getProfileByCurrentUser();

            var managerId = Utilities.localVar.getLocalVarIdBusinessPartner();
            var fieldManager = getFieldManagerFromProjectListManagerWidget();
            var fieldProjectStatus = getFieldProjectStatusFromProjectListManagerWidget();

            ScreenService.showLoader();
            fieldManager.reload().then(function() {
                if(fieldManager.dataSource.data.some(function(item){return item.ID == managerId;})){
                    fieldManager.value([managerId]);
                }
                fieldProjectStatus.reload().then(function () {
                    ScreenService.hideLoader();
                    Utilities.setDefaultValuesToSelectMultipleField(fieldProjectStatus, ['N', 'D', 'O'], 'CONTROL');
                    ZhFilterPreferences.setOriginalFilter(projectListManagerWidget.id, projectListManagerWidget.currentRow);
                    Utilities.applyDefaultFilterOnEnter(projectListManagerWidget, true);
                    projectListManagerWidget.PMDefaultCurrentRow = projectListManagerWidget.currentRow;
                    alreadyFilteredManager = true;
                }).catch(ScreenService.hideLoader);
            }).catch(ScreenService.hideLoader);
        }).catch(ScreenService.hideLoader);
    };

    this.advancedInformationWidgetOnEnterTab = function(args) {
        var widget = getWidgetAdvancedInformation();
        widget.reload();
        widget.list();
        widget.template = "widget/grid.html";
    };

    this.onEnterProjectListPart = function(args) {
        var widget = getWidgetProjectListParticipating();
        // ProjectServiceList.onEnterProjectList(args, self.initFilterProjects);
        if(Utilities.isAppliedFilter(widget)) {
            widget.reload();
        } else {
            var fieldProjectStatusPart = getFieldProjectStatusFromProjectPartWidget();
            ScreenService.showLoader();
            fieldProjectStatusPart.reload().then(function() {
                ScreenService.hideLoader();
                Utilities.setDefaultValuesToSelectMultipleField(fieldProjectStatusPart, ['N', 'D', 'O'], 'CONTROL');
                ZhFilterPreferences.setOriginalFilter(widget.id, widget.currentRow);
                Utilities.applyDefaultFilterOnEnter(widget, true);
                widget.PMDefaultCurrentRow = widget.currentRow;
            }).catch(ScreenService.hideLoader);
        }
    };

    this.resourceListMoveRowProjectLocal = function(args) {
        getWidgetProjectResourceList().dataSource.data.push(args.row);
        args.dataSource.splice(args.dataSource.indexOf(args.row),1);
    };
    this.deleteExceptionLocal = function(args) {
        args.dataSource.checkedRows.forEach(function(data){
            args.dataSource.data.splice(args.dataSource.data.indexOf(data),1);
        });
    };
    this.addExceptionLocal = function(widget){
        ScreenService.openPopup(widget);
        widget.newRow();
        widget.currentRow.STATUS = 'A';
    };
    this.onEnterTest = function(widget){
        widget.view();
    };

    this.editBasicInformation = function(action){
        action.widget.edit();
        action.widget.template = action.widget.formTemplate;

    };
    this.maximumPercentageCompletion = function(row){
        if(row.PERCENT_COMPLETED !== ''){
            var percent = parseInt(row.PERCENT_COMPLETED);
            if(percent>100)
                row.PERCENT_COMPLETED = 100;
        }
    };
    this.fixBugOnChangeSelectNative = function(args){
        if(args.owner[0] && args.owner[0].value){
            args.row[args.owner.field.name] = args.owner.field.dataSource.data[args.owner[0].value][args.owner.field.valueField];
        }
        if(args.owner.field){
            args.owner = args.owner.field;
        }
    };
    this.setDateException = function(args,paramenter){
        var exceptions = getWidgetProjectListException().dataSource.data;
        if(!exceptions){
            exceptions = [];
        }
        ProjectServiceList.setDateException(args.row,args.owner.field.widget,paramenter,exceptions);
    };

    var getBeginParentTask = function (parent) {
        var beginTask = null;
        var data = getFieldParentNameFromNewTaskWidget().dataSource.data;
        data.forEach(function (data) {
                if (data.ID == parent) {
                    beginTask = data.BEGIN_TASK;
                }
            }
        );
        return beginTask;
    };


    this.newTaskFieldChangeTimePlannedAutomatic = function(args){
        var currentRow = getNewTaskWidget().currentRow;
        var tecla = window.event.keyCode;
        var arrayKeyCodeDenied = new Array(9, 13, 16, 17, 20, 37, 38, 39, 40, 106, 107, 109, 111);
        var arrayKeyCodeAllow = new Array(8, 9, 13, 16, 17, 20, 37, 38, 39, 40, 46, 106, 107, 109, 111, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 68, 72, 77, 83, 96, 97, 98, 99, 100, 101, 102, 103, 104, 105);
        if (arrayKeyCodeAllow.indexOf(tecla) > -1) {
            if (arrayKeyCodeDenied.indexOf(tecla) == -1) {
                clearTimeout(timeOutToKeyup);
            }
        }else{
            var value = currentRow.TIME_PLANNED.replace(currentRow.TIME_PLANNED.slice(-1), '');
            currentRow.TIME_PLANNED = value;
        }
    };

    this.newTaskFieldChangeTimeTotalAutomatic = function(args){
        var currentRow = getNewTaskWidget().currentRow;
        var tecla = window.event.keyCode;
        var arrayKeyCodeDenied = new Array(9, 13, 16, 17, 20, 37, 38, 39, 40, 106, 107, 109, 111);
        var arrayKeyCodeAllow = new Array(8, 9, 13, 16, 17, 20, 37, 38, 39, 40, 46, 106, 107, 109, 111, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 68, 72, 77, 83, 96, 97, 98, 99, 100, 101, 102, 103, 104, 105);
        if (arrayKeyCodeAllow.indexOf(tecla) > -1) {
            if (arrayKeyCodeDenied.indexOf(tecla) == -1) {
                clearTimeout(timeOutToKeyup);
                timeOutToKeyup = setTimeout(this.newTaskFieldOnChangeTimeTotal, 1500);
            }
        }else{
            var value = currentRow.TOTAL_TIME.replace(currentRow.TOTAL_TIME.slice(-1), '');
            currentRow.TOTAL_TIME = value;
        }
    };

    // new calendar
    var _calendarCalcTask = function(){
        var row = getNewTaskWidget().currentRow;
        var dateBeginProject = row.BEGIN_PROJECT;
        var taskId = getFieldIdFromNewTaskWidget().value();
        var startField = getFieldStartFromNewTaskWidget();
        var endField = getFieldEndFromNewTaskWidget();
        var durationField = getFieldDurationFromNewTaskWidget();
        var precursorField = getFieldPrecursorNameFromNewTaskWidget();
        var precursorType = getFieldTypeFromNewTaskWidget().value();
        var parentField = getFieldParentNameFromNewTaskWidget();
        var exceptionField = getFieldDateExceptionNameFromNewTaskWidget();
        var exceptionDateField = getFieldDateExceptionFromNewTaskWidget();
        var resources = getFieldResourceNameFromNewTaskWidget().value();
        var latency = getFieldLatencyFromNewTaskWidget().value();
        var project = Utilities.localVar.getProject();
        if(row.USETIMEPLANNING == 'N'){
            if(!dateBeginProject){
                dateBeginProject = Utilities.getCurrentDate();
            }
            if(!row.START){
                row.START = dateBeginProject;
            }
            if(!row.END){
                row.END = dateBeginProject;
            }
        }else{
            ProjectServiceList.setDateByExceptionTask(taskId,startField, endField, durationField, precursorField, precursorType,
                parentField, exceptionField, exceptionDateField,dateBeginProject,resources,project,latency);
        }
    };
    this.newTaskFieldOnChangeStart = function(args){
        var row = getNewTaskWidget().currentRow;
        var dateBeginProject = row.BEGIN_PROJECT;
        var taskId = getFieldIdFromNewTaskWidget().value();
        var startField = getFieldStartFromNewTaskWidget();
        var endField = getFieldEndFromNewTaskWidget();
        var durationField = getFieldDurationFromNewTaskWidget();
        var precursorField = getFieldPrecursorNameFromNewTaskWidget();
        var precursorType = getFieldTypeFromNewTaskWidget().value();
        var exceptionField = getFieldDateExceptionNameFromNewTaskWidget();
        var exceptionDateField = getFieldDateExceptionFromNewTaskWidget();
        var parentField = getFieldParentNameFromNewTaskWidget();
        var resources = getFieldResourceNameFromNewTaskWidget().value();
        var latency = getFieldLatencyFromNewTaskWidget().value();
        var project = Utilities.localVar.getProject();
        ProjectServiceList.newTaskFieldOnChangeStart(taskId,startField, endField, durationField, precursorField, precursorType,
            parentField, exceptionField, exceptionDateField,dateBeginProject,resources,project,latency);
        _calendarCalcTask();
    };

    this.newTaskFieldOnChangeEnd = function(args){
        var task = getFieldIdFromNewTaskWidget().value();
        var startField = getFieldStartFromNewTaskWidget();
        var endField = getFieldEndFromNewTaskWidget();
        var durationField = getFieldDurationFromNewTaskWidget();
        var precursor = Utilities.getValueInSelectField(getFieldPrecursorNameFromNewTaskWidget());
        var precursorType = getFieldTypeFromNewTaskWidget().value();
        var parent = Utilities.getValueInSelectField(getFieldParentNameFromNewTaskWidget());
        var exceptionField = getFieldDateExceptionNameFromNewTaskWidget();
        var exceptionDateField = getFieldDateExceptionFromNewTaskWidget();
        var resources = getFieldResourceNameFromNewTaskWidget().value();
        var latency = getFieldLatencyFromNewTaskWidget().value();
        var project = Utilities.localVar.getProject();
        ProjectServiceList.newTaskFieldOnChangeEnd(task,startField, endField, durationField, precursor, precursorType, parent,
            exceptionField, exceptionDateField,resources,project,latency);
        _calendarCalcTask();
    };

    this.newTaskFieldOnChangeTimeTotal = function(args){
        calcTaskFeaturesInverse();
    };

    this.newTaskFieldOnChangePrecursorName = function(args) {
        var row = getNewTaskWidget().currentRow;
        if(row.TASK_STATUS_CONTROL != PMConstants.CONTROL_TASK_STATUS_BACKLOG){
            var dateBeginProject = row.BEGIN_PROJECT;
            var taskId = getFieldIdFromNewTaskWidget().value();
            var startField = getFieldStartFromNewTaskWidget();
            var endField = getFieldEndFromNewTaskWidget();
            var durationField = getFieldDurationFromNewTaskWidget();
            var precursorField = getFieldPrecursorNameFromNewTaskWidget();
            var precursorType = getFieldTypeFromNewTaskWidget().value();
            var exceptionField = getFieldDateExceptionNameFromNewTaskWidget();
            var exceptionDateField = getFieldDateExceptionFromNewTaskWidget();
            var parentField = getFieldParentNameFromNewTaskWidget();
            var resources = getFieldResourceNameFromNewTaskWidget().value();
            var latency = getFieldLatencyFromNewTaskWidget().value();
            var project = Utilities.localVar.getProject();
            var precursor =  Utilities.getValueInSelectField(getFieldPrecursorNameFromNewTaskWidget());
            if(!precursor ){
                ProjectServiceList.setBeginDateByParent(taskId,startField, endField, durationField, precursorField, precursorType,
                    parentField, exceptionField, exceptionDateField,dateBeginProject,resources,project,latency);
            }
            self.onChangePrecursor(row);
            _setEnableLatency(getFieldLatencyFromNewTaskWidget(),precursorField);
            _calendarCalcTask();
        }

    };

    this.newTaskFieldOnChangeDateExceptionName = function(args) {
        var row = getNewTaskWidget().currentRow;
        if(row.TASK_STATUS_CONTROL != PMConstants.CONTROL_TASK_STATUS_BACKLOG) {
            var dateBeginProject = row.BEGIN_PROJECT;
            var taskId = getFieldIdFromNewTaskWidget().value();
            var startField = getFieldStartFromNewTaskWidget();
            var endField = getFieldEndFromNewTaskWidget();
            var durationField = getFieldDurationFromNewTaskWidget();
            var precursorField = getFieldPrecursorNameFromNewTaskWidget();
            var precursorType = getFieldTypeFromNewTaskWidget().value();
            var exceptionField = getFieldDateExceptionNameFromNewTaskWidget();
            var exceptionDateField = getFieldDateExceptionFromNewTaskWidget();
            var parentField = getFieldParentNameFromNewTaskWidget();
            var resources = getFieldResourceNameFromNewTaskWidget().value();
            var latency = getFieldLatencyFromNewTaskWidget().value();
            var project = Utilities.localVar.getProject();
            ProjectServiceList.setDateExceptionTask(taskId, startField, endField, durationField, precursorField, precursorType,
                parentField, exceptionField, exceptionDateField, dateBeginProject, resources, project, latency);
            ProjectServiceList.setVisibleDateException(args.row, args.owner.field.widget);
        }
    };
    this.newTaskFieldOnChangeDateException = function(args) {
        var row = getNewTaskWidget().currentRow;
        if(row.TASK_STATUS_CONTROL != PMConstants.CONTROL_TASK_STATUS_BACKLOG) {
            var dateBeginProject = row.BEGIN_PROJECT;
            var taskId = getFieldIdFromNewTaskWidget().value();
            var startField = getFieldStartFromNewTaskWidget();
            var endField = getFieldEndFromNewTaskWidget();
            var durationField = getFieldDurationFromNewTaskWidget();
            var precursorField = getFieldPrecursorNameFromNewTaskWidget();
            var precursorType = getFieldTypeFromNewTaskWidget().value();
            var exceptionField = getFieldDateExceptionNameFromNewTaskWidget();
            var exceptionDateField = getFieldDateExceptionFromNewTaskWidget();
            var parentField = getFieldParentNameFromNewTaskWidget();
            var resources = getFieldResourceNameFromNewTaskWidget().value();
            var latency = getFieldLatencyFromNewTaskWidget().value();
            var project = Utilities.localVar.getProject();
            ProjectServiceList.setDateExceptionTask(taskId, startField, endField, durationField, precursorField, precursorType,
                parentField, exceptionField, exceptionDateField, dateBeginProject, resources, project, latency);
        }
    };

    this.newTaskFieldOnChangeType = function(args) {
        self.fixBugOnChangeSelectNative(args);
        _calendarCalcTask();
    };

    this.newTaskFieldOnChangeParentName = function(args) {
        var row = getNewTaskWidget().currentRow;
        if(row.TASK_STATUS_CONTROL != PMConstants.CONTROL_TASK_STATUS_BACKLOG) {
            row.PARENT_CHANGE = true;
            var dateBeginProject = row.BEGIN_PROJECT;
            var taskId = getFieldIdFromNewTaskWidget().value();
            var startField = getFieldStartFromNewTaskWidget();
            var endField = getFieldEndFromNewTaskWidget();
            var durationField = getFieldDurationFromNewTaskWidget();
            var precursorField = getFieldPrecursorNameFromNewTaskWidget();
            var precursorType = getFieldTypeFromNewTaskWidget().value();
            var exceptionField = getFieldDateExceptionNameFromNewTaskWidget();
            var exceptionDateField = getFieldDateExceptionFromNewTaskWidget();
            var parentField = getFieldParentNameFromNewTaskWidget();
            var resources = getFieldResourceNameFromNewTaskWidget().value();
            var latency = getFieldLatencyFromNewTaskWidget().value();
            var project = Utilities.localVar.getProject();
            var precursor = Utilities.getValueInSelectField(getFieldPrecursorNameFromNewTaskWidget());
            if (!precursor) {
                ProjectServiceList.setBeginDateByParent(taskId, startField, endField, durationField, precursorField, precursorType,
                    parentField, exceptionField, exceptionDateField, dateBeginProject, resources, project, latency);
            }
            _calendarCalcTask();
        }
    };
    this.newTaskFieldOnChangeLatency = function(args) {
        var row = getNewTaskWidget().currentRow;
        var dateBeginProject = row.BEGIN_PROJECT;
        var taskId = getFieldIdFromNewTaskWidget().value();
        var startField = getFieldStartFromNewTaskWidget();
        var endField = getFieldEndFromNewTaskWidget();
        var durationField = getFieldDurationFromNewTaskWidget();
        var precursorField = getFieldPrecursorNameFromNewTaskWidget();
        var precursorType = getFieldTypeFromNewTaskWidget().value();
        var exceptionField = getFieldDateExceptionNameFromNewTaskWidget();
        var exceptionDateField = getFieldDateExceptionFromNewTaskWidget();
        var parentField = getFieldParentNameFromNewTaskWidget();
        var resources = getFieldResourceNameFromNewTaskWidget().value();
        var latency = getFieldLatencyFromNewTaskWidget().value();
        var project = Utilities.localVar.getProject();
        var precursor =  Utilities.getValueInSelectField(getFieldPrecursorNameFromNewTaskWidget());
        if(!precursor ){
            ProjectServiceList.setDateExceptionTask(taskId,startField, endField, durationField, precursorField, precursorType,
                parentField, exceptionField, exceptionDateField,dateBeginProject,resources,project,latency);
        }
        _calendarCalcTask();
    };

    //calc calendar project
    var _calendarCalcProject = function(){
        var projectId = getFieldDateIdFromProjectInformationWidget().value();
        projectId = projectId ? projectId : null;
        var startField = getFieldBeginDateFromProjectInformationWidget();
        var endField = getFieldEstimatedDateFromProjectInformationWidget();
        var durationField = getFieldDurationFromProjectInformationWidget();
        var exceptionField = getFieldDateExceptionNameFromProjectInformationWidget();
        var exceptionDateField = getFieldDateExceptionFromProjectInformationWidget();
        var parentField = getFieldParentNameFromProjectInformationWidget();
        var group = Utilities.getValueInSelectField(getFieldGroupNameFromProjectInformationWidget());
        ProjectServiceList.setDateByExceptionProject(projectId,startField, endField, durationField,
            parentField, exceptionField, exceptionDateField,group);
    };

    this.basicFieldOnChangeStart = function(args) {
        var projectId = getFieldDateIdFromProjectInformationWidget().value();
        var startField = getFieldBeginDateFromProjectInformationWidget();
        var endField = getFieldEstimatedDateFromProjectInformationWidget();
        var durationField = getFieldDurationFromProjectInformationWidget();
        var exceptionField = getFieldDateExceptionNameFromProjectInformationWidget();
        var exceptionDateField = getFieldDateExceptionFromProjectInformationWidget();
        var parentField = getFieldParentNameFromProjectInformationWidget();
        ProjectServiceList.basicProjectFieldOnChangeStart(projectId,startField, endField, durationField,
            parentField, exceptionField, exceptionDateField);
        _calendarCalcProject();
    };

    this.basicFieldOnChangeTotalTime = function(args) {
        var durationField = getFieldDurationFromProjectInformationWidget();
        var value = durationField.value();
        if(Utilities.isNumber(value)){
            durationField.value(value+'H');
        }
        _calendarCalcProject();
    };

    this.basicFieldOnChangeEnd = function(args) {
        var projectId = getFieldDateIdFromProjectInformationWidget().value();
        var startField = getFieldBeginDateFromProjectInformationWidget();
        var endField = getFieldEstimatedDateFromProjectInformationWidget();
        var durationField = getFieldDurationFromProjectInformationWidget();
        var exceptionField = getFieldDateExceptionNameFromProjectInformationWidget();
        var exceptionDateField = getFieldDateExceptionFromProjectInformationWidget();
        var parentField = getFieldParentNameFromProjectInformationWidget();
        ProjectServiceList.basicProjectFieldOnChangeEnd(projectId,startField, endField, durationField,
            parentField, exceptionField, exceptionDateField);
        _calendarCalcProject();
    };
    this.basicFieldOnChangeParentName = function(args) {
        var projectId = getFieldDateIdFromProjectInformationWidget().value();
        var startField = getFieldBeginDateFromProjectInformationWidget();
        var endField = getFieldEstimatedDateFromProjectInformationWidget();
        var durationField = getFieldDurationFromProjectInformationWidget();
        var exceptionField = getFieldDateExceptionNameFromProjectInformationWidget();
        var exceptionDateField = getFieldDateExceptionFromProjectInformationWidget();
        var parentField = getFieldParentNameFromProjectInformationWidget();
        ProjectServiceList.setBeginDateByParent(projectId,startField, endField, durationField, null, null,
            parentField, exceptionField, exceptionDateField,startField.value());
        _calendarCalcProject();
    };

    this.basicFieldOnChangeDateExceptionName = function(args) {
        this.projectExceptionVisibility(getWidgetBasicProjectInformation());
        var projectId = getFieldDateIdFromProjectInformationWidget().value();
        var startField = getFieldBeginDateFromProjectInformationWidget();
        var endField = getFieldEstimatedDateFromProjectInformationWidget();
        var durationField = getFieldDurationFromProjectInformationWidget();
        var exceptionField = getFieldDateExceptionNameFromProjectInformationWidget();
        var exceptionDateField = getFieldDateExceptionFromProjectInformationWidget();
        var parentField = getFieldParentNameFromProjectInformationWidget();
        ProjectServiceList.setBeginDateByParent(projectId,startField, endField, durationField, null, null,
            parentField, exceptionField, exceptionDateField,startField.value());
        _calendarCalcProject();
    };

    this.setDateByExceptionProject = function(widget,exceptions){
        var projectId = getFieldDateIdFromProjectInformationWidget().value();
        var startField = getFieldBeginDateFromProjectInformationWidget();
        var endField = getFieldEstimatedDateFromProjectInformationWidget();
        var durationField = getFieldDurationFromProjectInformationWidget();
        var exceptionField = getFieldDateExceptionNameFromProjectInformationWidget();
        var exceptionDateField = getFieldDateExceptionFromProjectInformationWidget();
        var parentField = getFieldParentNameFromProjectInformationWidget();
        ProjectServiceList.setBeginDateByParent(projectId,startField, endField, durationField, null, null,
            parentField, exceptionField, exceptionDateField,startField.value());
        _calendarCalcProject();
    };

    this.addStatusTask = function(widget){
        ScreenService.openPopup(widget);
        widget.getField('TASK_TYPE_NAME').reload();
        widget.newRow();
    };

    this.openNewProjectSponsorPopup = function(widget){
        ScreenService.openPopup(widget);
        widget.newRow();
    };

    this.addTypeTask = function(widget){
        ScreenService.openPopup(widget);
        widget.newRow();
    };

    this.newTaskStatus = function(row,fieldTaskStatus){
        ProjectServiceList.newTaskStatus(row).then(function(){
            fieldTaskStatus.reload();
            ScreenService.closePopup();
        });
    };

    this.newTaskType = function(row,fieldTaskType,args){
        ProjectServiceList.newTaskType(row).then(function(){
            fieldTaskType.reload();
            ScreenService.closePopup();
        });
    };

    this.saveNewProjectSponsorFromPopup = function(row, fieldListOfSponsors, args){
        SponsorService.saveNewProjectSponsorFromPopup(row).then(function(){
            fieldListOfSponsors.reload();
            ScreenService.closePopup();
        });
    };

    this.reloadFieldsProject = function () {
        getFieldSponsorNameFromBasicWidget().reload();
        self.basicFieldOnChangeManagerName();
        getWidgetBasicProjectInformation().getField('DATE_EXCEPTION_NAME').dataSource.data = DATA_SET_EXCEPTION_NODE;
    };

    this.projectExceptionVisibility = function(widget){
        var row =  widget.currentRow;
        this.setVisibleDateException(row,widget);
    };

    this.newDocumentProjectActionEventBack = function(args){
        ScreenService.closePopup();
    };

    this.newUploadDocument = function(widget){
        ScreenService.openPopup(widget);
        widget.newRow();
    };

    this.newDocumentActionEventUpload = function(args){
        if(getWidgetNewDocument().isValid()){
            self.saveUploadDocument(args);
        } else {
            ScreenService.showMessage(Utilities.messages.ERR_UPLOAD_FILE_EXTENSION_OR_SIZE);
        }
    };

    this.saveUploadDocument = function(args){
        ProjectServiceList.newUploadDocumentTask(args.row).then(function(response){
            getWidgetProjectDocumentsTask().reload();
            args.owner.widget.list();
            ScreenService.closePopup();
            getWidgetProjectDocumentsTask().activate();
        });
    };

    this.newDocumentProjectActionEventUpload = function(args){
        self.saveUploadDocumentProject(args);
    };

    this.saveUploadDocumentProject = function(args){
        var documentProjectWidget = getWidgetNewDocumentProject();
        ProjectServiceList.newUploadDocumentProject(documentProjectWidget.currentRow).then(function(response){
            getWidgetProjectDocumentsProject().reload();
            documentProjectWidget.list();
            ScreenService.closePopup();
        });

    };
    this.downLoadAttachment = function(args){
        ProjectServiceList.downLoadAttachment(args.row);
    };

    var deleteAttachment = function(widget){
        return ScreenService.confirmMessage(Utilities.messages.ALE_DELETE_ATTACHMENT, null,function(){
            ScreenService.showLoader();
            ProjectServiceList.checkIfRelatedTasksHasSameAttachment(widget.currentRow.ID).then(function(response) {
                ScreenService.hideLoader();
                if(response.length > 1){
                    ScreenService.showCustomDialog(Utilities.messages.ALE_DELETE_ATTACHMENT_ALL_RELATED_TASK,
                        'QUESTION', null,
                        [
                            {
                                "label": "Sim",
                                "code": function () {
                                    removeAttachment(widget, getArrayAttachmentIds(response));
                                }
                            },
                            {
                                "label": "Não",
                                "code": function () {
                                    removeAttachment(widget, [widget.currentRow]);
                                }
                            },
                            {
                                "label": "Cancelar",
                                "code": ""
                            }
                        ]);
                    } else {
                        removeAttachment(widget, [widget.currentRow]);
                    }
                }).catch(ScreenService.hideLoader);
            }, null);
    };

    var getArrayAttachmentIds = function(response){
        return response.map(function(id) {
            return {ID: id};
        });
    };

    var removeAttachment = function(widget, data){
        ProjectServiceList.deleteAttachment(data).then(function(response) {
            ScreenService.closeSwipe();
            widget.reload();
            ScreenService.successNotification(response.notifications[0].message);
        });
    };

    this.onCancelMoveTask = function(tasksTab){
        tasksTab.activate();
        setStatusDisableFieldReplanningReason(getFieldReplanningReasonFromMoveTaskWidget());
    };

    this.validadeDateMaxAndMin = function(row){
        if(row.USETIMEPLANNING == 'Y' ) {
            if (row.dateEndMin && moment(row.dateEndMin, 'DD/MM/YYYY') > moment(row.END, 'DD/MM/YYYY')) {
                ScreenService.showMessage('A data de fim do projeto tem que ser depois de ' + row.dateEndMin);
                return false;
            } else if (row.dateBeginMax && moment(row.dateBeginMax, 'DD/MM/YYYY') < moment(row.START, 'DD/MM/YYYY')) {
                ScreenService.showMessage('A data de inicio do projeto tem que ser antes de ' + row.dateBeginMax);
                return false;
            }
        }
        return true;
    };

    this.validateChangeDates = function(row) {
        if (row.USETIMEPLANNING == 'Y') {
            if ((row.OLD_END != row.END) || (row.OLD_START != row.START )) {
                return true;
            }
        }
        return false;
    };

    this.validException = function(row){
        if(row.USETIMEPLANNING == 'Y' ) {
            if (row.DATE_EXCEPTION_ABBREVIATION != 'MB' && row.DATE_EXCEPTION_ABBREVIATION != 'MT' && !row.DATE_EXCEPTION ) {
                ScreenService.showMessage('A exceção selecionada precisa de uma data.');
                return false;
            }
        }
        return true;
    };

    var validatePlayedTask = function(taskId, percentCompleted, status) {
     var defer = ZHPromise.defer();
     if(percentCompleted === 100 || status === 'Concluída') {
          taskId = parseInt(taskId);
         var filter =[ {
            "operator": "=",
            "name": "TASK",
            "value": taskId
          }];
          requestDataSourceEngine.getDataSource("/hasBranch", filter).then(function(data) {
              if (data.dataset.hasBranch.length > 0) {
                  ScreenService.showMessage(Messages.ALE_PLAYED_TASK);
                  defer.reject('hasBranch');
              } else {
                  defer.resolve();
              }
          }).catch(function(e){
             defer.reject(e);
          });
      } else {
        defer.resolve();
      }
     return defer.promise;
    };

    var saveProjectTask = function (args) {
        var taskId = args.owner.widget.currentRow.ID;
        var widgetTask = args.owner.widget;
        var percentCompleted = args.owner.widget.currentRow.PERCENT_COMPLETED;
        var status = args.owner.widget.currentRow.TASK_STATUS_NAME;
        ScreenService.showLoader();
        return ProjectServiceList.getAllResourcesAllowedToConcludeTask(widgetTask.currentRow).then(function (isAllowed) {
            if (!isAllowed) {
                ScreenService.hideLoader();
                ScreenService.showMessage(Utilities.messages.ERR_RESOURCE_NOT_ALLOWED_CONCLUDE);
            } else {
                return validatePlayedTask(taskId, percentCompleted, status).then(function () {
                    ScreenService.hideLoader();
                    var parameters = getLocalVar('taskParameters');
                    if (!(widgetTask.currentRow.TASK_STATUS_OLD == parameters.CONCLUDED_TASK_STATUS_ID || widgetTask.currentRow.PERCENT_COMPLETED_OLD == 100) && (widgetTask.currentRow.TASK_STATUS == parameters.CONCLUDED_TASK_STATUS_ID || widgetTask.currentRow.PERCENT_COMPLETED >= 100)) {
                            return ScreenService.showCustomDialog('Quando uma tarefa atinge os 100% ou tem o status de concluída, a tarefa não poderá ser alterada. Deseja continuar?',
                                'CONFIRMATION', null,
                                [
                                    {
                                        "label": "Salvar",
                                        "code": function (e, deferred) {
                                            widgetTask.currentRow.PERCENT_COMPLETED = 100;
                                            widgetTask.currentRow.TASK_STATUS = parameters.CONCLUDED_TASK_STATUS_ID;
                                            widgetTask.currentRow.TASK_STATUS_NAME = parameters.CONCLUDED_TASK_STATUS_NAME;
                                            widgetTask.redraw();
                                            self.editProjectSaveTask(args).then(function () {
                                                deferred.resolve(e);
                                            }).catch(function (e, deferred) {
                                                deferred.reject(e);
                                            });
                                        }
                                    },
                                    {
                                        "label": "Não salvar",
                                        "code": function (e, deferred) {
                                            ScreenService.showMessage('Para salvar a tarefa, por favor alterar o campo de conclusão para menor que 100% e/ou Situação diferente de ' + parameters.CONCLUDED_TASK_STATUS_NAME + '.');
                                            deferred.reject(e);
                                        }
                                    }
                                ]
                            );

                    } else {
                        return self.editProjectSaveTask(args);
                    }
                }).catch(Utilities.showMessageBackEndTrue);
            }
        }).catch(Utilities.showMessageBackEndTrue);
    };

    this.newTaskActionEventSave = function(args) {
        var widget = getNewTaskWidget();
        var basicProjectInformationWidget = getWidgetBasicProjectInformation();
        if(widget.isValid()) {
            if(basicProjectInformationWidget.currentRow.PROJECT_STATUS_CONTROL == 'D' &&
            basicProjectInformationWidget.currentRow.EXTERNALTYPE == 'B') {
             ScreenService.showCustomDialog(Utilities.messages.ALE_PROJECT_IN_PROGRESS, 'CONFIRMATION', null,
                [
                    {
                        "label": "Sim",
                        "code": function () {
                            doSaveProjectTask(args);
                        }
                    },
                    {
                        "label": "Não",
                        "code": function () {}
                    }
                ]
                );
            } else {
                doSaveProjectTask(args);
            }
        } else {
            ScreenService.showMessage(Messages.ERR_REQUIRED_FIELDS);
        }
       
    };

    var doSaveProjectTask = function(args) {
        saveProjectTask(args).then(function(e) {
            self.projectTasksWidgetAfterMoveRow(args);
        });
    };

    var addResourceInProject = function (args) {
        var checkedRows = args.owner.widget.getCheckedRows();
        var resourceListWidget = getWidgetProjectResourceList();
        ProjectServiceList.resourceListClicked(checkedRows, resourceListWidget);
    };

    this.newResourcesActionEventAdd = function(args) {
        addResourceInProject(args);
    };

    this.newSprintFieldOnChangeModels = function(args) {
        var widget = getNewPrintWidget();
        var exceptionWidget = getMnemonicListWidget();
        ScreenService.showLoader();
        ProjectServiceList.getBasicModelProject(widget.currentRow.MODELS).then(function (projectRow) {
            ScreenService.hideLoader();
            localStorageEngine.setLocalVar('modelsId', widget.currentRow.MODELS);
            localStorageEngine.setLocalVar('basicModel', projectRow);
            exceptionWidget.reload();
        }).catch(ScreenService.hideLoader);
    };

    this.newSprintEventSaveInLineEdit = function() {
        if(getNewPrintWidget().isValid()) {
            ScreenService.showLoader();
            ProjectServiceList.getHeadSprintProject(getWidgetBasicProjectInformation().currentRow.ID).then(function (result) {
                ProjectServiceList.getBasicProjectInfo(result.ID).then(function (projectRow) {
                    var basicWidget = getWidgetBasicProjectInformation();
                    basicWidget.currentRow = projectRow;
                    basicWidget.currentRow.ID = null;
                    basicWidget.currentRow.NAME = localStorageEngine.getLocalVar('basicModel').NAME;
                    basicWidget.currentRow.EXTERNALTYPE = localStorageEngine.getLocalVar('basicModel').EXTERNALTYPE;
                    basicWidget.currentRow.PROJECT_STATUS_ID = localStorageEngine.getLocalVar('basicModel').PROJECT_STATUS_ID;
                    basicWidget.currentRow.PROJECT_TYPE_ID = localStorageEngine.getLocalVar('basicModel').PROJECT_TYPE_ID;
                    basicWidget.currentRow.MNEMONIC_NAME = [getMnemonicListWidget().currentRow];
                    basicWidget.currentRow.MODELS = getNewPrintWidget().currentRow.MODELS;
                    basicWidget.currentRow.MODELS_NAME = getNewPrintWidget().currentRow.MODELS_NAME;

                    ProjectServiceList.saveBasic(basicWidget, getWidgetProjectListTabbed().currentWidget).then(function(result) {
                        ScreenService.closePopup();
                        var projectId = localStorageEngine.getLocalVar('NewSprrintProject');
                        ProjectServiceList.getTailSprintProject(projectId).then(function (result) {
                            var tasks = getWidgetProjectTasks().dataSource.checkedRows;
                            ProjectServiceList.moveTask(result.ID, null, null, tasks, false);
                            ScreenService.hideLoader();
                            ScreenService.closePopup();
                            ScreenService.closeSwipe();
                            getWidgetProjectListManager().activate();
                        }).catch(Utilities.showMessageBackEndTrue);
                    }).catch(Utilities.showMessageBackEndTrue);
                }).catch(Utilities.showMessageBackEndTrue);
            }).catch(ScreenService.hideLoader);
        }
    };

    this.basicFieldOnChangeModels = function(args) {
        var modelsField = getFieldModelsFromProjectInformationWidget();
        var basicWidget = getWidgetBasicProjectInformation();
        var projectModelId = Utilities.getValueInSelectField(modelsField);
        if (projectModelId) {
            var modelRow = Utilities.getCurrentRowInFieldSelect(modelsField);
            var isRestricted = modelRow.IS_RESTRICTED == 'Y';
            ScreenService.showLoader();
            ProjectServiceList.getBasicModelProject(projectModelId).then(function (projectRow) {
                var currentRow = basicWidget.currentRow;
                projectRow.MANAGER = currentRow.MANAGER;
                projectRow.GROUP = currentRow.GROUP;
                projectRow.GROUP_NAME = currentRow.GROUP_NAME;
                projectRow.UPPER_PROJECT_NAME = currentRow.UPPER_PROJECT_NAME;
                projectRow.UPPER_PROJECT = currentRow.UPPER_PROJECT;
                projectRow.__is_new = currentRow.__is_new;
                if(currentRow.SPONSOR_NAME){
                    projectRow.SPONSOR_NAME = currentRow.SPONSOR_NAME;
                    projectRow.SPONSOR = currentRow.SPONSOR;
                }
                basicWidget.currentRow = projectRow;

                Utilities.setValueInSelectField(modelsField, projectModelId);
                self.projectTypeChangeProject();
                getFieldProjectStatusFromBasicWidget().reload().then(function(){
                    Utilities.setValueInSelectField(getFieldProjectStatusFromBasicWidget(), projectRow.PROJECT_STATUS_ID);
                });
                setReadOnlyByChangeModel(isRestricted,false,true);
                ScreenService.hideLoader();
                ProjectServiceList.hasErrorTypeChildrenProjects(basicWidget.currentRow.MODELS).then(function (response) {
                    var hasErrorTypeProjectChildren = response.dataset.hasErrorTypeChildrenProjects[0];
                    modelProjectHasChildren = hasErrorTypeProjectChildren ? true : false;
                    setValueModelProjectHasChildren(modelProjectHasChildren);
                    if(basicWidget.currentRow.UPPER_PROJECT){
                        var filter = [{
                            "operator": "=",
                            "name": "PROJECT_ID",
                            "value": basicWidget.currentRow.UPPER_PROJECT
                        }];
                        requestDataSourceEngine.getDataSource('/checkProjectHasTemplateParentRecursive', filter).then(function(response){
                            var productProjectHasAllowReplicationLts = response.dataset.productProjectHasAllowReplicationLts[0];
                            if(modelProjectHasChildren && productProjectHasAllowReplicationLts === 'Y') {
                                getFieldIsLtsReplicationFromProjectInformationWidget().isVisible = true;
                                getFieldIsLtsReplicationFromProjectInformationWidget().readOnly = false;
                            } else {
                                getFieldIsLtsReplicationFromProjectInformationWidget().isVisible = false;
                                getFieldIsLtsReplicationFromProjectInformationWidget().readOnly = true;
                            }
                            var hasTemplateParent = response.dataset.checkProjectHasTemplateParentRecursive[0];
                            if ((basicWidget.currentRow.EXTERNALTYPE == 'E' || modelProjectHasChildren) && !hasTemplateParent){
                                localStorageEngine.setLocalVar('projectId', basicWidget.currentRow.UPPER_PROJECT);
                                getFieldVersionDevFromProjectInformationWidget().isVisible = true;
                                getFieldVersionDevFromProjectInformationWidget().reload();
                            } else if (basicWidget.currentRow.EXTERNALTYPE != 'E' || !hasErrorTypeProjectChildren){
                                setValueNullFieldVersionDevFromBasicWidget(basicWidget.currentRow);
                                getFieldVersionDevFromProjectInformationWidget().isVisible = false;
                            }
                        });
                    }
                }).catch(ScreenService.hideLoader);
            }).catch(ScreenService.hideLoader);
        } else {
            setReadOnlyByChangeModel(false);
            setValueNullFieldProjectTypeFromBasicWidget(basicWidget.currentRow);
            setValueNullFieldVersionDevFromBasicWidget(basicWidget.currentRow);
            getFieldVersionDevFromProjectInformationWidget().isVisible = false;
            setValueModelProjectHasChildren(false);
        }
    };

    this.basicFieldOnChangeSponsorName = function () {
        var widget = getWidgetBasicProjectInformation();
        localStorageEngine.setLocalVar('clientId', widget.currentRow.SPONSOR);
        getFieldVersionDevFromProjectInformationWidget().reload();
    };

    var setValueModelProjectHasChildren = function (value) {
        modelProjectHasChildren = value;
    };

    var setReadOnlyByChangeModel = function(isRestricted,notChange,isFirst) {
        var basicWidget = getWidgetBasicProjectInformation();
        basicWidget.fields.filter(function (field) {
            return !!field.PMReadOnlyModel;
        }).forEach(function (field) {
            field.readOnly = isRestricted;
        });
        basicWidget.fields.filter(function (field) {
            return !!field.PMConditionReadOnlyModel;
        }).forEach(function (field) {
            if (notChange) {
                field.readOnly = ( !isRestricted && field.readOnly) ? field.readOnly : isRestricted;
            } else {
                field.readOnly = isRestricted;
            }

        });
        if(!isFirst){
            basicWidget.fields.filter(function (field) {
                return !!field.PMConditionReadOnlyModelFirst;
            }).forEach(function (field) {
                if (notChange) {
                    field.readOnly = ( !isRestricted && field.readOnly) ? field.readOnly : isRestricted;
                } else {
                    field.readOnly = isRestricted;
                }
            });
        }

    };
    this.closeSwipeAction = function () {
         ScreenService.closePopup();
        // getWidgetBasicProjectInformation().view();
    };


    this.responseEditActionEventEdit = function () {
        var responseEditWidget = getWidgetResponseEdit();
        if(!responseEditWidget.isValid()) {
             ScreenService.showMessage(Messages.ERR_REQUIRED_FIELDS);
        } else if(responseEditWidget.currentRow.RESPONSE.length < 50) {
            ScreenService.showMessage(Messages.ERR_NOT_ENOUGH_WORDS, 'ERROR', 'error', {});
        } else {
            ScreenService.closePopup();
        }
    };


    this.issuesResponsesActionEventSave = function () {
        var widget = ProjectIssuesResponse();
        var data = widget.dataSource.data;
        var erroData = data.filter(function (row){
            return !row.RESPONSE || row.RESPONSE.length < 50;
        });
        if (erroData.length) {
            var erroMsg = "";
            erroData.forEach(function (row) {
                erroMsg += '<li align="left">' + row.NAME + '</li>';
            });
            ScreenService.showMessage(Messages.ERR_ISSUE_RESPONSE + erroMsg, 'ERROR', 'error', {});
        } else {
            data.forEach(function (row) {
                row.changed = true;
            });
            var args = localStorageEngine.getLocalVar('doSaveBasicArgs');
            ScreenService.showLoader();
            ProjectServiceList.sendMailConcludedProject(data).then(function (response) {
                 doSaveBasicProject(args);
                 ScreenService.hideLoader();
            }).catch(ScreenService.hideLoader);
        }
    };



     this.viewResponsesFieldOnClick = function () {
        var viewResponsesWidget = getWidgetViewResponses();
        var responseEditWidget = getWidgetResponseEdit();
        ProjectServiceList.findTaskResponsesRelatedSameIssue(responseEditWidget.currentRow.ID).then(function (response) {
            var data = localStorageEngine.getLocalVar('projectIssues');
            var newRow = viewResponsesWidget.currentRow;
            viewResponsesWidget.fields = [];
            viewResponsesWidget.fieldGroups = [];
            data.forEach(function (row) {
                newRow['ID_' + row.ID] = row.ID;
                newRow['NAME_' + row.ID] = row.NAME;
                newRow['RESPONSE_' + row.ID] = row.RESPONSE;

                viewResponsesWidget.fieldGroups.push({
                    name: 'FIELD_GROUP_NAME_' + row.ID,
                    label: 'Task: ' + row.ID + ' - ' + row.NAME,
                    isVisible: true,
                    collapsible: true,
                    opened: true
                });


                viewResponsesWidget.fields.push(self.getIdFieldFromViewResponseWidget(row, viewResponsesWidget));
                viewResponsesWidget.fields.push(self.getNameFieldFromViewResponseWidget(row, viewResponsesWidget));
                viewResponsesWidget.fields.push(self.getResponseFieldFromViewResponseWidget(row, viewResponsesWidget));
            });
        });
            ScreenService.openPopup(viewResponsesWidget);
    };

    this.getIdFieldFromViewResponseWidget = function (row, widget) {
        return metaDataFactory.factoryField(FieldsMetaData.getIdObjFromViewResponseWidget(row), widget);
    };

    this.getNameFieldFromViewResponseWidget = function (row, widget) {
        return metaDataFactory.factoryField(FieldsMetaData.getNameObjFromViewResponseWidget(row), widget);
    };

    this.getResponseFieldFromViewResponseWidget = function (row, widget) {
        return metaDataFactory.factoryField(FieldsMetaData.getResponseObjFromViewResponseWidget(row), widget);
    };
    /************************************************************
     * Called by action event
     * @param args
     ************************************************************/
    this.basicActionEventSave = function(args){
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (widget.currentRow.PROJECT_STATUS_CONTROL == 'X') {
                ScreenService.showLoader();
                if (widget.currentRow.EXTERNALTYPE == 'E') {
                    ProjectServiceList.hasProjectWithLtsSubReleaseFinalized(projectId).then(function (response) {
                        ScreenService.hideLoader();
                        if(response){
                            ScreenService.showMessage(Utilities.messages.ERR_PROJECT_SUBRELEASE_FINALIZED);
                        } else {
                            doSaveBasicProject(args);
                        }
                    }).catch(ScreenService.hideLoader);
                } else {
                    ProjectServiceList.hasErrorTypeChildrenProjectsAndHasProjectWithLtsSubReleaseFinalized(projectId).then(function (response) {
                        ScreenService.hideLoader();
                        if (response) {
                            ScreenService.showMessage(Utilities.messages.ERR_PROJECT_SUBRELEASE_FINALIZED);
                        } else {
                            doSaveBasicProject(args);
                        }
                    }).catch(ScreenService.hideLoader);
                }
            } else if(widget.currentRow.PROJECT_STATUS_CONTROL == 'C') {
                 ScreenService.showLoader();
                ProjectServiceList.findTaskResponsesRelatedSameProject(localStorageEngine.getLocalVar('project')).then(function (response) {
                if(response.dataset.findTaskResponsesRelatedSameProject){
            
                     localStorageEngine.setLocalVar('projectIssues', response.dataset.findTaskResponsesRelatedSameProject);
                     localStorageEngine.setLocalVar('doSaveBasicArgs', args);
                     var widgetPopResponse = ProjectIssuesResponse();
                     widgetPopResponse.dataset =  response.dataset.findTaskResponsesRelatedSameProject;
                     widgetPopResponse.currentRow =  response.dataset.findTaskResponsesRelatedSameProject;
                     widgetPopResponse.currentRow.ID = widget.currentRow.ID;
                     //aaaaaaaaaaaaaaaaaa
                     ScreenService.openPopup(widgetPopResponse);
                      ScreenService.hideLoader();
                     ProjectIssuesResponse().reload();
                }else{
                     doSaveBasicProject(args);
                }

                }).catch(ScreenService.hideLoader);
            }
            else {
                doSaveBasicProject(args);
            }
        }
    };

    var doSaveBasicProject = function (args) {
        var widgetProjectListTabbed = getWidgetProjectListTabbed();
        var widget = args.owner.widget;

        ScreenService.showLoader();
        ProjectServiceList.projectHasMnemonic(args.row.MODELS, false).then(function (response) {
            if (self.validException(widget.currentRow)) {
                if (self.validateChangeDates(widget.currentRow)) {
                    return ProjectServiceList.getDatesRestrictionsMinAndMax(widget.currentRow.ID).then(function (dateMinAndMax) {
                        widget.currentRow.dateBeginMax = dateMinAndMax.dateBeginMax;
                        widget.currentRow.dateEndMin = dateMinAndMax.dateEndMin;
                        if (self.validadeDateMaxAndMin(widget.currentRow)) {
                            callProjectMnemonicOrSaveProject (args, response, widgetProjectListTabbed);
                        } else {
                            ScreenService.hideLoader();
                        }
                    }).catch(Utilities.showMessageBackEndTrue);
                } else {
                    callProjectMnemonicOrSaveProject (args, response, widgetProjectListTabbed);
                }
            } else {
                ScreenService.hideLoader();
            }
        }).catch(Utilities.showMessageBackEndTrue);
    };

    this.basicActionEventOpenMnemonicWindow = function() {
        var widget = getWidgetBasicProjectInformation();
        ScreenService.showLoader();
        ProjectServiceList.projectHasMnemonic(widget.currentRow.MODELS, false).then(function (response) {
            ScreenService.hideLoader();
            changeProjectNameMnemonic(response, getWidgetChangeMnemonicName());
        }).catch(Utilities.showMessageBackEndTrue);
    };

    this.mnemonicNameActionEventChange = function(){
        var widget = getWidgetChangeMnemonicName();
        var widgetParent = widget.parent;
        if(widget.isValid()) {
            ProjectServiceList.changeMnemonicName(widget.currentRow, widgetParent.currentRow).then(function () {
                ScreenService.closePopup();
                ScreenService.closeSwipe();
                getWidgetProjectListManager().reload();
                getWidgetProjectListManager().activate();
                ScreenService.closePopup();
                self.goBackProjectList();
            }).catch(Utilities.showMessageBackEndTrue);
        }else {
             ScreenService.showMessage(Messages.ERR_REQUIRED_FIELDS);
        }


    };

    var callProjectMnemonicOrSaveProject = function(args, response, widgetProjectListTabbed) {
        var widget = args.owner.widget;
        ScreenService.hideLoader();
        if (response.length > 0 && !widget.currentRow.ID) {
            changeProjectNameMnemonic(response,  getWidgetMnemonicName());
        } else {
            ProjectServiceList.saveBasic(widget, widgetProjectListTabbed.currentWidget).then(function() {
                setValueModelProjectHasChildren(false);
                Utilities.localVar.setLocalVarNewTaskParent(null);
                projectOnListClicked(args, true);
                ScreenService.hideLoader();
            }).catch(Utilities.showMessageBackEndTrue);
        }
    };

    var changeProjectNameMnemonic = function(response, mnemonicWidget) {
        mnemonicWidget.dataSource.data = response;
        mnemonicWidget.reload();
        ScreenService.openPopup(mnemonicWidget);
    };

    this.mnemonicTabBackAction = function () {
        ScreenService.closePopup();
        getWidgetBasicProjectInformation().activate();
    };

    this.mnemonicNameActionEventSave = function () {
        var widget = getWidgetMnemonicName();
        var widgetProjectListTabbed = getWidgetProjectListTabbed();
        var widgetParent = widget.parent;

        widgetParent.currentRow.MNEMONIC_NAME = widget.dataSource.data;

        if(!widget.dataSource.data.every(checkChangedRow)) {
            ScreenService.showCustomDialog(Utilities.messages.ALE_EMPTY_MNEMONICS,
                'CONFIRMATION', null,
                [{
                    "label": "Sim",
                    "code": function () {
                        ProjectServiceList.saveBasic(widgetParent, widgetProjectListTabbed.currentWidget).then(function () {
                            ScreenService.closePopup();
                            ScreenService.closeSwipe();
                            getWidgetProjectListManager().reload();
                            getWidgetProjectListManager().activate();
                        }).catch(Utilities.showMessageBackEndTrue);
                    }
                }, {
                    "label": "Não",
                    "code": function () {}
                }]
            );
        } else {
            ProjectServiceList.saveBasic(widgetParent, widgetProjectListTabbed.currentWidget).then(function () {
                ScreenService.closePopup();
                ScreenService.closeSwipe();
                getWidgetProjectListManager().reload();
                getWidgetProjectListManager().activate();
            }).catch(Utilities.showMessageBackEndTrue);
        }
    };

    this.beforeCopyTask = function(projects, tasks, checkedRows, addDiferentResources, diferentResourcesIds, useMnemonic ){
        return ProjectServiceList.copyTask(projects, tasks, checkedRows, addDiferentResources, diferentResourcesIds, useMnemonic ).then(function (res) {
            if (res && res.notifications[0]) {
                var message = res.notifications[0];
                if (message.type === 'W') {
                    ScreenService.showMessage(Messages.ERR_CANT_COPY_TASKS + message.message, null, 'error');
                } else {
                    backToWidgetTasksList(getWidgetProjectTaskList());
                    ScreenService.showMessage(message.message);
                }
            }
        }).catch(function (responce) {
            Utilities.showMessageErrorOfBackEnd(responce, null, null, true);
        });
    };

    this.mnemonicNameFromCopyTaskWidgetOnSaveInlineEdit = function () {
        var widget = getWidgetMnemonicNameFromCopyTask();
        var widgetCopyTask = getWidgetCopyTask();
        var widgetTaskList = getWidgetProjectTaskList();

        var useMnemonic = widget.dataSource.data;
        var projects = widgetCopyTask.currentRow.PROJECT;
        var tasks =  widgetCopyTask.currentRow.TASK;
        var checkedRows = widgetTaskList.dataSource.checkedRows;
        var addDiferentResources = localStorageEngine.getLocalVar('addDifferentResources');
        var diferentResourcesIds = localStorageEngine.getLocalVar('differentResourcesIds');

        if(!widget.dataSource.data.every(checkChangedRow)) {
            ScreenService.showCustomDialog(Utilities.messages.ALE_EMPTY_MNEMONICS, 'CONFIRMATION', null,
            [
                {
                    "label": "Sim",
                    "code": function () {
                        self.beforeCopyTask(projects, tasks, checkedRows, addDiferentResources, diferentResourcesIds, useMnemonic);
                    }
                },
                {
                    "label": "Não",
                    "code": function () {
                    }
                }
            ]);
        } else {
            self.beforeCopyTask(projects, tasks, checkedRows, addDiferentResources, diferentResourcesIds, useMnemonic );
        }
    };

    var checkChangedRow = function (args) {
        return args.changed;
    };
    var setValueProjectType = function () {
        var fieldProjectType = getFieldProjectTypeFromBasicWidget();
        var valueProjectType = Utilities.getValueInSelectField(fieldProjectType);
        Utilities.setOutData(fieldProjectType, valueProjectType);
    };

    this.editProjectBasic = function(args){
        var row = args.row;
        var widget = getWidgetBasicProjectInformation();
        var currentRow = widget.currentRow;

        ProjectServiceList.projectHasTaskNotIsParent(widget.currentRow.ID).then(function (response){
            if (response || (currentRow.EXTERNALTYPE == 'E' && currentRow.PROJECT_STATUS_CONTROL == 'D')){
                getFieldVersionDevFromProjectInformationWidget().readOnly = true;
            } else {
                getFieldVersionDevFromProjectInformationWidget().readOnly = false;
            }
        });

        ProjectServiceList.editProjectBasic(args);
        _setReadOnlyProjectDate(row.GROUP);
        self.basicFieldOnChangeManagerName(args);
        setValueProjectType();
        self.projectTypeChangeProject();
        setConcludedInProject();
        setReadOnlyByChangeModel(row.MODELS_IS_RESTRICTED,true,row.MODELS_IS_FIRST);

        if(row.MODELS_HAS_RELATIONSHIP){
            getFieldProjectTypeFromBasicWidget().readOnly = true;
        }
        setCanceledInProject();

        getFieldSponsorNameFromBasicWidget().reload();
        getFieldParentNameFromProjectInformationWidget().reload();
        getFieldProjectCategoriesFromBasicWidget().reload();
        getFieldProjectTypeFromBasicWidget().reload();
    };

    var setCanceledInProject = function(){
        var widget = getWidgetBasicProjectInformation();
        var fieldProjectStatus = getFieldProjectStatusFromBasicWidget();
        fieldProjectStatus.readOnly = widget.currentRow.PROJECT_STATUS_CONTROL == 'X' ? true : fieldProjectStatus.readOnly;
    };

    var setConcludedInProject = function(control) {
        var widget = getWidgetBasicProjectInformation();
        var concluded = control ? control == 'C' : widget.currentRow.PROJECT_STATUS_CONTROL == 'C' || widget.currentRow.PROJECT_STATUS_CONTROL == 'X';
        widget.fields.filter(function (field) {
            return !!field.PMTrueReadOnlyConcluded;
        }).forEach(function (field) {
            field.readOnly = concluded;
        });
        widget.fields.filter(function (field) {
            return !!field.PMConditionReadOnlyConcluded;
        }).forEach(function (field) {
            field.readOnly = concluded ? concluded : field.readOnly;
        });
    };

    var setDevOpsReadOnlyAndIsVisibleProject = function(newRow){
        var widgetProject = getWidgetBasicProjectInformation();
        var subReleaseId = getFieldSubReleaseIdFromProjectInformationWidget().value();
        var releaseId = getFieldReleaseIdFromProjectInformationWidget().value();
        var productId = getFieldProductIdFromProjectInformationWidget().value();
        if(subReleaseId || releaseId || productId){
            widgetProject.fields.forEach(function(field){
                if(field.devOpsReadOnly){
                    field.readOnly = !newRow;
                }else if(field.devOpsIsVisible){
                    field.isVisible = !newRow && field.value();
                }
            });
        }else{
            widgetProject.fields.forEach(function(field){
                if(field.devOpsReadOnly){
                    field.readOnly = false;
                }else if(field.devOpsIsVisible){
                    field.isVisible = false;
                }
            });
        }

    };

    this.resourceListWidgetOnEnterTab = function(args){
        self.setButtons(args);
        var widget = getWidgetProjectResourceList();
        widget.template = "/widget/grid.html";
        widget.list();
        widget.reload();
    };

    this.setButtons = function(args){
        var widget = args.owner;
        if(widget.name != 'BASIC' && widget.container.mode == 'edit') {
            getWidgetBasicProjectInformation().list();
            getWidgetBasicProjectInformation().template = "widget/form-view.html";
        } else {
            var projectId = localStorageEngine.getLocalVar('project');
            if(!projectId){
                args.e.stopPropagation();
            }
        }
    };

    this.saveCalendarProject = function(widget){
        widget.currentRow.PROJECT_ID = localStorageEngine.getLocalVar('project');
        widget.saveRow().then(function(){
            widget.list();
            widget.template = widget.formTemplate;
            ProjectServiceList.setCalendar(getWidgetProjectCalendar());
        });
    };

    this.editCalendarProject = function(widget){
        if(widget.currentRow){
            widget.edit();
        } else{
            widget.newRow();
        }


        widget.template = widget.formTemplate;
    };

    var getAllocationTypeWidget = function() {
        return templateManager.container.getWidget('ALLOCATION_TYPE');
    };

    var getAllocationAddWidget = function() {
        return templateManager.container.getWidget('ALLOCATION_ADD');
    };

    this.projectTasksActionEventAllocate = function(args){
        var widget = getWidgetProjectTaskList();
        var allocationAddWidget = getAllocationAddWidget();
        if(widget.hasCheckedRows()) {
            var rows = widget.getCheckedRows();
            var isTestTask = false;
            rows.some(function(row){
                if(row.TASK_CLASSIFICATION_CONTROL === 'T') {
                    isTestTask = row.TASK_CLASSIFICATION_CONTROL;
                }
            });
            if(isTestTask) {
                localStorageEngine.setLocalVar('taskClassificationControl', 'T');
            } else {
                localStorageEngine.setLocalVar('taskClassificationControl', null);
            }
            ScreenService.openPopup(allocationAddWidget);
            allocationAddWidget.reload();
        } else {
            ScreenService.showMessage(Utilities.messages.NOT_CHECKED_ROW_TASK);
        }
    };

    function isThisResource(resource){
        return resource === this.resourceId;
    }

    function isResourceAllocated(task){
        var resourcesMatched = task.RESOURCES.filter(isThisResource, this);
        return !!(resourcesMatched.length);
    }

    this.onLoadAllocationAdd = function(widget) {
        var tasks = widget.container.getWidget('PROJECTTASKS').dataSource.getCheckedRows();
        var filter = {};
        var allocatedTasks;
        var resources = widget.dataSource.data;
        var length = resources.length;
        for(var i = length - 1; i >= 0; i--) {
            filter.resourceId = resources[i].ID;
            allocatedTasks = tasks.filter(isResourceAllocated, filter);
            resources[i].TASK = tasks;
            resources[i].changed = true;
            if(tasks.length === allocatedTasks.length) {
                resources.splice(i, 1);
            }
        }
        widget.dataSource.data = resources;
        widget.dataSource.clearCheckedRows();
    };

    var showAllocationType = function () {
        var resourceList = [];
        var taskConcluded = '';
        var rows = getAllocationAddWidget().dataSource.checkedRows;
        var taskParameters = localStorageEngine.getLocalVar('taskParameters');

        rows[0].TASK.forEach(function(task){
            if (task.TASK_STATUS == taskParameters.CONCLUDED_TASK_STATUS_ID){
                taskConcluded += '<li>' + task.NAME + '</li>';
            }
        });

        if(taskConcluded){
            ScreenService.showMessage(Messages.ERR_ALOC_TASK_CONCLUEND + '<br/>' + taskConcluded);
            ScreenService.closePopup();
            return true;
        }

        rows.forEach(function(row){
            var resource  = {};
            resource.ID   = row.ID;
            resource.NAME = row.NAME;
            resourceList.push(row.ID);
        });

        ScreenService.closePopup();
        ScreenService.openPopup(getAllocationTypeWidget());
        var resourceField = getAllocationTypeWidget().getField('RESOURCES');
        resourceField.reload().then(function(){
            getAllocationTypeWidget().currentRow.RESOURCES = resourceList;
            resourceField.valueOf = resourceList;
            resourceField.defaultValue = resourceList;
            resourceField.applyDefaultValue();
        });
    };

    var validateAllocatedResource = function (allocationType) {
        var checkedRows = getAllocationAddWidget().dataSource.checkedRows;
        var project = localStorageEngine.getLocalVar('project');
        var newResourcesNotAllocated = [];
        var checkedIds = [];
        var filter = [{
                "name": "project",
                "operator": "=",
                "value": project
            }];
        checkedIds = checkedRows.map(function(row){
            return row.ID;
        });
        ScreenService.showLoader();
        requestDataSourceEngine.getDataSource("/projectResource", filter).then(function(response) {
            ScreenService.hideLoader();
            var data = response.dataset.projectResource;
            var allocatedResources = data.map(function(resource) {
                return resource.ID;
            });
            var resource = [];
            var resourceNames = [];
            newResourcesNotAllocated = checkedIds.filter(function(id){
                return allocatedResources.indexOf(id) === -1;
            });
            if(newResourcesNotAllocated.length > 0) {
                templateManager.container.getWidget('ALLOCATION_ADD').dataSource.checkedRows.forEach(function(row) {
                    if(newResourcesNotAllocated.indexOf(row.ID)!== -1) {
                        resource.push(row);
                        resourceNames.push(row.NAME);
                    }
                });
            }
            var checkedRows  = getAllocationAddWidget().dataSource.checkedRows;
            var newResourcesAllocated = checkedRows.filter(function(id){
              return newResourcesNotAllocated.indexOf(id.ID) === -1;
            });
            if(resource.length > 0) {
                var message = Messages.ALE_RESOURCE_NOT_FOUND.replace('%1', resourceNames.join(", "));
                ScreenService.confirmMessage(message, 'ALERT',
                   function() {
                    addResourceToProject(allocationType, newResourcesNotAllocated);
                }, function() {
                    notAddResourceToProject(allocationType, newResourcesAllocated);
                });
            } else {
                notAddResourceToProject(allocationType, newResourcesAllocated);
            }
            getWidgetProjectTasks().dataSource.updateCheckedRows();
        }).catch(Utilities.showMessageBackEndTrue);
    };

    this.allocationTypeAddFieldOnClick = function (args) {
        var type = 'ADD';
        validateAllocatedResource(type);
    };

    var deleteAllocations = function(widget){
        var row = {};
        var selectedTasks = widget.parent.parent.dataSource.checkedRows;
        var tasks = selectedTasks.filter(function(task){
            return task.ID;
        });
        row.TASK = tasks;
        row.changed = true;
        requestDataSourceEngine.setDataSource('/deleteTaskAllocation',[row]).then(function(){
            ScreenService.closePopup(0);
            getWidgetProjectTasks().reload();
            getWidgetProjectTasks().activate();
            getFieldResourcesFromProjectTasksWidget().reload();
        });
    };

    this.onReplaceResource = function (widget) {
        if(widget.parent.dataSource.checkedRows.length === 0) {
            ScreenService.confirmMessage(Messages.ALE_DELETE_ALLOCATION, 'ALERT',
                function() {
                    deleteAllocations(widget);
                }, function() {
                    ScreenService.closePopup(0);
                    widget.container.getWidget('PROJECTTASKS').reload();
                    getWidgetProjectTasks().activate();
                }
            );

        } else {
            var type = 'REPLACE';
            validateAllocatedResource(type);
        }
    };

    this.newTaskActionEventDelete = function(args){
        var widget = getNewTaskWidget();
        ProjectServiceList.editProjectDeleteTask(widget);
    };

    var getFieldAllProjectsFromWidgetCreateTaskIssue = function () {
        return getWidgetCreateTaskIssue().getField('ALL_PROJECTS');
    };
    var getFieldTasksFromWidgetCreateTaskIssue = function () {
        return getWidgetCreateTaskIssue().getField('TASKS');
    };

    this.createTaskIssueActionEventCreate = function() {
        var widget = getWidgetCreateTaskIssue();
        if(widget.isValid()) {
            var row = Utilities.getWidgetCurrentRowAsChanged(getWidgetCreateTaskIssue());
            var basicWidget = getWidgetBasicProjectInformation().currentRow;
            var showAlert = "";
            row.PROJECT_TYPE_ID.forEach(function(element,i) {
                if(element !== basicWidget.PROJECT_TYPE_ID) {
                    showAlert += "<li>" + row["PROJECT_NAME_" + row.ALL_PROJECTS[i]] + "</li>";
                }
            });
            if(showAlert !== "") {
                ScreenService.showCustomDialog(Utilities.messages.ALE_UNRELATED_TASK_WARNING.replace("%1",showAlert),
                    'CONFIRMATION', null,
                    [
                        {
                            "label": "Sim",
                            "code": function () {
                                createTasksByTask(row);
                            }
                        },
                        {
                            "label": "Não",
                            "code": function () {
                            }
                        }
                    ]);
            } else {
                createTasksByTask(row);
            }
        }
    };

    var createTasksByTask = function(row){
        requestDataSourceEngine.setDataSource('/createTasksByTask',[row]).then(function(){
            ScreenService.closePopup(true);
            ScreenService.closeSwipe();
            getWidgetProjectTaskList().reload();
        }).catch(function(response){
            Utilities.showMessageErrorOfBackEnd(response,null,null,true);
        });
    };

    this.createTaskIssueActionEventBack = function() {
        ScreenService.closePopup(true);
        getNewTaskWidget().activate();
    };

    this.pmGenerationProjectIdFilter = function(array,projectIds){
        return array.filter(function (field) {
            return !field.pmIsGeneration || Utilities.inArray(field.pmProjectId, projectIds);
        });
    };

    this.fieldOnClickEventRemoveTaskGeneration = function (args) {
        var owner = Utilities.getOwnerFixBug(args);
        var projectId = owner.pmProjectId;
        var widget = getWidgetCreateTaskIssue();
        var fields = widget.fields;
        var allProjectsField = getFieldAllProjectsFromWidgetCreateTaskIssue();
        var allProjectsForTask = allProjectsField.value();
        widget.currentRow.PROJECT_TYPE_ID.splice(allProjectsForTask.indexOf(projectId),1);
        allProjectsForTask = allProjectsForTask.filter(function(projectForTask){
            return projectId != projectForTask;
        });
        allProjectsField.value(allProjectsForTask);
        widget.fields = self.pmGenerationProjectIdFilter(fields,allProjectsForTask);
        self.createTaskIssueFieldOnChangeAllProjects();
    };

    var getWidgetCreateTaskIssue = function () {
        return templateManager.container.getWidget('CREATE_TASK_ISSUE');
    };

    var validationTaskStatusNotInitializedOrPaused = function(){
        var taskStatusNameField = getFieldTaskStatusNameFromNewTaskWidget();
        return taskStatusNameField.reload().then(function() {
            var taskStatus = Utilities.getCurrentRowInFieldSelect(taskStatusNameField);
            return (taskStatus.CONTROL  == 'P' || taskStatus.CONTROL  == 'N');
        });
    };

    var validationRelationship = function(typeRelationship){
        return !(typeRelationship && typeRelationship != 'E');
    };

    this.newTaskActionEventReplication = function(args){
        if (localStorageEngine.getLocalVar('projectVersionDevId')) {
            ScreenService.showMessage(Utilities.messages.ERR_REPLICATION_IS_VERSION_DEV);
            return false;
        }
        ScreenService.showLoader();
        validationTaskStatusNotInitializedOrPaused().then(function(validate) {
            ScreenService.hideLoader();
            if(validate) {
                var task = getNewTaskWidget().currentRow;
                var typeRelationship = task.TYPE_RELATIONSHIP;
                if(validationRelationship(typeRelationship)) {
                    var createTaskIssueWidget = getWidgetCreateTaskIssue();
                    createTaskIssueWidget.dataSource.data = [];
                    createTaskIssueWidget.newRow();
                    self.createTaskIssueFieldOnChangeAllProjects();
                    ScreenService.openPopup(getWidgetCreateTaskIssue());
                    var createTaskIssueField = getFieldTasksFromWidgetCreateTaskIssue();
                    createTaskIssueField.dataSource.data = [task];
                    createTaskIssueField.value([task.ID]);
                    getFieldAllProjectsFromWidgetCreateTaskIssue().reload();
                } else {
                    ScreenService.showMessage(Utilities.messages.ERR_REPLICATION_GENERATED);
                }
            } else {
                ScreenService.showMessage(Utilities.messages.ERR_REPLICATION_STATUS);
            }
        }).catch(Utilities.showMessageBackEndTrue);
    };

    var replicateResource = function (field,resourceFields) {
        var values = field.value();
        resourceFields.forEach(function(resourceField){
            Utilities.setValueInSelectMultiple(resourceField,values);
        });

    };

    var replicateResourceInNewProject = function (field,resourceFields) {
        var values = field.value();
        resourceFields.forEach(function (resourceField) {
            var resources = resourceField.value();
            if(!resources){
                resourceField.reload().then(function () {
                    Utilities.setValueInSelectMultiple(resourceField, values);
                });
            }
        });

    };

    this.fieldOnChangeEventResource = function (args) {
        var ownerField = Utilities.getOwnerFixBug(args);
        var widget = getWidgetCreateTaskIssue();
        var resourceFields = widget.fields.filter(function (field) {
            return field.pmIsGeneration && Utilities.inString(field.name, 'RESOURCE_');
        });

        var ownerValue = ownerField.value();
        var isValueAllResource = true;
        if(resourceFields.length > 1 && ownerValue && ownerValue.length > 0) {
            isValueAllResource = resourceFields.some(function (resourceField) {
                var validate = false;
                if (resourceField.name != ownerField.name) {
                    var value = resourceField.value();
                    validate = !!value && value.length > 0;
                }
                return validate;
            });
        }

        if (!isValueAllResource) {
            ScreenService.showCustomDialog(Utilities.messages.ALE_REPLICATION_RESOURCE,
                'CONFIRMATION', null,
                [
                    {
                        "label": "Sim",
                        "code": function () {
                            replicateResource(ownerField, resourceFields);
                        }
                    },
                    {
                        "label": "Não",
                        "code": function () {
                        }
                    }
                ]);
        }

    };

    this.fieldOnChangeEventParentName = function (args) {
        var ownerField = Utilities.getOwnerFixBug(args);
        var widget = ownerField.widget;
        var resourceFields = widget.fields.filter(function (field) {
            return field.pmIsGeneration && Utilities.inString(field.name, 'PARENT_NAME_');
        });

        var ownerValue = ownerField.value();
        var isValueAllResource = true;
        if(resourceFields.length > 1 && ownerValue && ownerValue.length > 0) {
            isValueAllResource = resourceFields.some(function (resourceField) {
                var validate = false;
                if (resourceField.name != ownerField.name) {
                    var value =  Utilities.getValueInSelectField(resourceField);
                    validate = !!value;
                }
                return validate;
            });
        }

        if (!isValueAllResource) {
            ScreenService.showCustomDialog(Utilities.messages.ALE_REPLICATION_TASK_PARENT,
                'CONFIRMATION', null,
                [
                    {
                        "label": "Sim",
                        "code": function () {
                            replicateTaskParent(ownerField, resourceFields);
                        }
                    },
                    {
                        "label": "Não",
                        "code": function () {
                        }
                    }
                ]);
        }

    };

    var replicateTaskParent = function (field,resourceFields) {
        var values =  Utilities.getValueInSelectField(field);
        resourceFields.forEach(function(resourceField){
            Utilities.setValueInSelectField(resourceField,values);
        });

    };

    this.fieldOnChangeEventTaskResource = function (args) {
        var ownerField = Utilities.getOwnerFixBug(args);
        var widget = ownerField.widget;
        var resourceFields = widget.fields.filter(function (field) {
            return field.pmIsGeneration && Utilities.inString(field.name, 'RESOURCE_');
        });

        var ownerValue = ownerField.value();
        var isValueAllResource = true;
        if(resourceFields.length > 1 && ownerValue && ownerValue.length > 0) {
            isValueAllResource = resourceFields.some(function (resourceField) {
                var validate = false;
                if (resourceField.name != ownerField.name) {
                    var value = resourceField.value();
                    validate = !!value && value.length > 0;
                }
                return validate;
            });
        }

        if (!isValueAllResource) {
            ScreenService.showCustomDialog(Utilities.messages.ALE_REPLICATION_RESOURCE,
                'CONFIRMATION', null,
                [
                    {
                        "label": "Sim",
                        "code": function () {
                            replicateResource(ownerField, resourceFields);
                        }
                    },
                    {
                        "label": "Não",
                        "code": function () {
                        }
                    }
                ]);
        }

    };
    var calcDurationByTimePlanned = function (timePlannedField, timePlanned, resourcesIds, resourceField, timePlannedSeg,
                                              durationField, notCalendar,divideDuration) {
        var totalRating = 0;
        if(timePlannedField){
            timePlannedField.value(timePlanned);
        }
        if (divideDuration != 'N' && resourcesIds && Utilities.isNotEmptyArray(resourcesIds)) {
            var selectedResources = Utilities.findInDataSource(resourceField, resourcesIds, resourceField.valueField);
            selectedResources.forEach(function (resource) {
                if (resource.RATING) {
                    totalRating += parseFloat(resource.RATING);
                } else {
                    totalRating += 1;
                }
            });
            timePlannedSeg = timePlannedSeg / totalRating;
            timePlanned = Utilities.secondsToDurationHour(timePlannedSeg, true);
        }
        if (timePlanned && timePlanned !== 0) {
            if(!notCalendar){
                _calendarCalcTask();
            }
        }
        return timePlanned;
    };

    var calcTaskFeaturesInverse = function(changeTaskFeatures){
        var resourceField = getFieldResourceFromNewTaskWidget();
        var duration = getFieldDurationFromNewTaskWidget().value();
        var durationSeg = Utilities.durationToSeconds(duration, true);
        var timePlannedField = getFieldTimePlannedFromNewTaskWidget();
        var resourcesIds = resourceField.value();

        calcTimePlannedByDuration(timePlannedField, duration, resourcesIds, resourceField, durationSeg);
    };

    var calcTimePlannedByDuration = function (timePlannedField, duration, resourcesIds, resourceField, durationSeg, estimatedTimeProportion) {
        var totalRating = 0;
        estimatedTimeProportion = estimatedTimeProportion ? estimatedTimeProportion : 1;
        if (resourcesIds && Utilities.isNotEmptyArray(resourcesIds)) {
            var selectedResources = Utilities.findInDataSource(resourceField, resourcesIds, resourceField.valueField);
            selectedResources.forEach(function (resource) {
                if (resource.RATING) {
                    totalRating += parseFloat(resource.RATING);
                } else {
                    totalRating += 1;
                }
            });
            durationSeg = durationSeg * totalRating * estimatedTimeProportion;
            duration = Utilities.secondsToDurationHour(durationSeg, true);
        }else{
            durationSeg = durationSeg * estimatedTimeProportion;
            duration = Utilities.secondsToDurationHour(durationSeg, true);
        }
        if (timePlannedField && (duration && duration !== 0)) {
            _calendarCalcTask();
        }
        return duration;
    };

    var calcTaskFeatures = function(changeTaskFeatures){
        var taskFeaturesRow = Utilities.getCurrentRowInFieldSelect(getFieldTaskFeaturesFromNewTaskWidget());
        var resourceField = getFieldResourceFromNewTaskWidget();
        var durationField = getFieldDurationFromNewTaskWidget();
        var timePlannedField = getFieldTimePlannedFromNewTaskWidget();
        var resourcesIds = resourceField.value();
        var timePlanned = timePlannedField.value();
        var timePlannedSeg =  Utilities.durationToSeconds(timePlanned);
        var divideDuration =  getWidgetBasicTaskInformation().currentRow.DIVIDE_DURATION;
        var usetimeplanning = getWidgetBasicProjectInformation().currentRow.USETIMEPLANNING;

        if(changeTaskFeatures && taskFeaturesRow) {
            timePlanned = taskFeaturesRow.TIME_BASE;
            timePlannedSeg = taskFeaturesRow.TIME_BASE_SEG;
        }
        calcDurationByTimePlanned(timePlannedField, timePlanned, resourcesIds, resourceField, timePlannedSeg,
            durationField,usetimeplanning != 'Y',divideDuration);
    };

    this.taskFeaturesFieldOnChange = function(args) {
        calcTaskFeatures(true);
    };

    var validateFieldCreated = function(fields,projectId){
        var generationFields = fields.filter(function(field){
            return field.pmProjectId == projectId;
        });
        return generationFields.length === 0;
    };

    this.createTaskIssueFieldOnChangeAllProjects = function (args) {
        var widget = getWidgetCreateTaskIssue();
        var fields = widget.fields;
        var allProjectsField = getFieldAllProjectsFromWidgetCreateTaskIssue();
        var allProjectsForTask = allProjectsField.value();
        allProjectsForTask.forEach(function (projectId) {
            if (validateFieldCreated(fields, projectId)) {
                var projectNameField = self.getProjectNameField(projectId, widget);
                var projectTypeNameField = self.getProjectTypeNameField(projectId, widget);
                var parentNameField = self.getParentNameField(projectId, widget);
                var resourceField = self.getResourceField(projectId, widget);
                var removeField = self.getTrashRemoveField(projectId, widget);
                fields.push(projectNameField);
                fields.push(projectTypeNameField);
                fields.push(parentNameField);
                fields.push(resourceField);
                fields.push(removeField);
                projectNameField.value(Utilities.getDescriptionFieldByPrimaryValue(allProjectsField, projectId));
                projectTypeNameField.value(Utilities.getRowInDataSource(allProjectsField.dataSource, allProjectsField.valueField, projectId)[allProjectsField.projectTypeName]);
            }
        });

        widget.fields = self.pmGenerationProjectIdFilter(fields, allProjectsForTask);
        var resourceFields = widget.fields.filter(function (field) {
            return field.pmIsGeneration && Utilities.inString(field.name, 'RESOURCE_');
        });
        replicateResourceInNewProject(getFieldResourceFromNewTaskWidget(),resourceFields);
    };

    this.getTrashRemoveField = function (projectId, widget) {
        return metaDataFactory.factoryField(this.getRemoveActionObj(projectId), widget);
    };

    this.getProjectNameField = function (projectId, widget) {
        return metaDataFactory.factoryField(this.getProjectNameObj(projectId), widget);
    };

    this.getProjectTypeNameField = function (projectId, widget) {
        return metaDataFactory.factoryField(this.getProjectTypeNameObj(projectId), widget);
    };

    this.getParentNameField = function (projectId, widget) {
        return metaDataFactory.factoryField(this.getParentNameSelectObj(projectId), widget);
    };

    this.getResourceField = function (projectId, widget) {
        return metaDataFactory.factoryField(this.getResourceSelectMultipleObj(projectId), widget);
    };

    this.getRemoveActionObj = function (projectId) {
        return {
            "name": "removeTaskGeneration_" + projectId,
            "label": null,
            "isVisible": true,
            "showOnForm": true,
            "showOnList": false,
            "showOnView": false,
            "pmProjectId": projectId,
            "pmIsGeneration": true,
            "tooltip": "Apagar",
            "fieldGroup": "TASKS",
            "template": "field/label-with-icon.html",
            "icon": "trash",
            "class": 1,
            "events": [
                {
                    "name": "FieldOnClick",
                    "code": "ProjectController.fieldOnClickEventRemoveTaskGeneration(args);"
                }
            ]
        };
    };

    this.getProjectNameObj = function (projectId) {
        return {
            "name": "PROJECT_NAME_" + projectId,
            "label": "Projeto",
            "isVisible": true,
            "showOnForm": true,
            "showOnList": false,
            "showOnView": false,
            "pmProjectId": projectId,
            "readOnly": true,
            "pmIsGeneration": true,
            "fieldGroup": "TASKS",
            "template": "field/text-edit.html",
            "icon": "trash",
            "class": 3,
            "events": []
        };
    };

    this.getProjectTypeNameObj = function (projectId) {
        return {
            "name": "PROJECT_TYPE_NAME_" + projectId,
            "label": "Tipo",
            "isVisible": true,
            "showOnForm": true,
            "showOnList": false,
            "showOnView": false,
            "pmProjectId": projectId,
            "readOnly": true,
            "pmIsGeneration": true,
            "fieldGroup": "TASKS",
            "template": "field/text-edit.html",
            "icon": "trash",
            "class": 2,
            "events": []
        };
    };

    this.getParentNameSelectObj = function (projectId) {
        return {
            "name": "PARENT_NAME_" + projectId,
            "label": "Tarefa superior",
            "showOnForm": true,
            "class": 3,
            "isVisible": true,
            "fieldGroup": "TASKS",
            "template": "field/select.html",
            "descriptionField": "NAME",
            "pmIsGeneration": true,
            "pmProjectId": projectId,
            "hasPagination": false,
            "searchWithPagination": false,
            "valueField": "ID",
            "showSelectAs": "tree",
            "parentProperty": "PARENT",
            "primaryProperty": "ID",
            "expandingProperty": "NAME",
            "breadcrumbProperty": "NAME",
            "outData": {
                "ID": "PARENT_" + projectId,
                "NAME": "PARENT_NAME_" + projectId
            },
            "dataSource": {
                "name": "/findAllTaskByProject",
                "rest": true,
                "localStorage": false,
                "data": []
            },
            "dataSourceFilter": [
                {
                    "name": "projectInIssue",
                    "operator": "=",
                    "value": projectId
                }
            ]
        };
    };

    this.getResourceSelectMultipleObj = function (projectId) {
        return {
            "name": "RESOURCE_" + projectId,
            "label": "Recursos",
            "isVisible": true,
            "showOnForm": true,
            "showOnList": false,
            "showOnView": false,
            "pmProjectId": projectId,
            "pmIsGeneration": true,
            "fieldGroup": "TASKS",
            "template": "field/select-multiple.html",
            "class": 3,
            "events": [
                {
                    "name": "FieldOnChange",
                    "code": "ProjectController.fieldOnChangeEventResource(args);"
                }
            ],
            "descriptionField": "NAME",
            "valueField": "ID",
            "dataSource": {
                "name": "/taskResource",
                "rest": true,
                "localStorage": false,
                "data": []
            },
            "dataSourceFilter": [
                {
                    "name": "PROJECT",
                    "value": projectId,
                    "operator": "="
                }
            ]
        };
    };

    this.getTaskParentNameField = function (taskId, projectId, widget) {
        return metaDataFactory.factoryField(this.getTaskParentNameSelectObj(taskId, projectId), widget);
    };

    this.getTaskParentNameSelectObj = function (taskId, projectId) {
        return FieldsMetaData.getParentNameFromGenerateTaskInProject(taskId,projectId);
    };

    this.getTaskTimePlannedField = function (taskId, widget) {
        return metaDataFactory.factoryField(this.getTaskTimePlannedObj(taskId), widget);
    };

    this.getTaskTimePlannedObj = function (taskId) {
        return FieldsMetaData.getTimePLannedFromGenerateTaskInProject(taskId);
    };

    this.getTaskNameField = function (taskId, widget) {
        return metaDataFactory.factoryField(this.getTaskNameObj(taskId), widget);
    };

    this.getTaskNameObj = function (taskId) {
        return FieldsMetaData.getTaskNameFromGenerateTaskInProject(taskId);
    };
    this.getTaskProjectField = function (taskId, widget) {
        return metaDataFactory.factoryField(this.getTaskProjectObj(taskId), widget);
    };

    this.getTaskProjectObj = function (taskId) {
        return FieldsMetaData.getProjectNameFromGenerateTaskInProject(taskId);
    };

    this.getTaskResourceField = function (taskId, projectId, widget) {
        return metaDataFactory.factoryField(this.getTaskResourceSelectMultipleObj(taskId, projectId), widget);
    };

    this.getTaskResourceSelectMultipleObj = function (taskId,projectId) {
        return FieldsMetaData.getTaskResourceFromGenerateTaskInProject(taskId,projectId);
    };


    this.getTaskTrashRemoveField = function (taskId, widget) {
        return metaDataFactory.factoryField(this.getTaskRemoveActionObj(taskId), widget);
    };

    this.getTaskRemoveActionObj = function (taskId) {
        return FieldsMetaData.getTaskRemoveFromGenerateTaskInProject(taskId);
    };

    var addResourceToProject = function (allocationType, resourcesToProject ) {
        var row = {};
        row.RESOURCES_ID = resourcesToProject;
        row.PROJECT = localStorageEngine.getLocalVar('project');
        row.changed = true;
        requestDataSourceEngine.setDataSource('/allocateResourceProject', [row]).then(function(){
            var checkedRows = getAllocationAddWidget().dataSource.checkedRows;
            var widget = getAllocationTypeWidget();
            var type = {};
            widget.container.getWidget('PROJECTTASKS').reload();
            type.ALLOCATION_TYPE = allocationType;
            type.changed = true;
            checkedRows.splice(0, 0, type);
            onAllocate(widget, checkedRows);
        });
    };

    var notAddResourceToProject = function (allocationType, newResourcesAllocated) {
        var checkedRows = newResourcesAllocated;
        var widget = getAllocationTypeWidget();
        var type = {};
        type.ALLOCATION_TYPE = allocationType;
        type.changed = true;
        checkedRows.splice(0, 0, type);
        onAllocate(widget, checkedRows);
    };

    this.closeTypeAllocation = function () {
        ScreenService.closePopup();
        getWidgetProjectTaskList().activate();
        getAllocationAddWidget().dataSource.unSelectAll();
    };

    var onAllocate = function(widget, checkedRows) {
        var typeAdd = checkedRows[0].ALLOCATION_TYPE;
        var tasks = checkedRows[1].TASK;
        var resources = checkedRows.filter(function(data){return data.ID;});
        var row = {};
        row.changed = true;
        row.RESOURCES = resources.map(function(data){return data.ID;});
        row.TASK = tasks.map(function(data){return data.ID;});
        row.TYPE_ADD = typeAdd;

        requestDataSourceEngine.setDataSource('/allocation', [row]).then(function(){
            ScreenService.closePopup(true);
            getWidgetProjectTasks().activate();
            getWidgetProjectTasks().reload();
            getAllocationAddWidget().dataSource.unSelectAll();
            getFieldResourcesFromProjectTasksWidget().reload();
        });
    };

    this.AfterLoadDataSourceCalendar = function(widget){
        if(widget.dataSource.data.length > 0){
            widget.moveToFirst();
        }else{
            widget.newRow();
            widget.list();
        }
    };

    this.newTaskActionEventAddSubTask = function(args){
        var basicProjectWidget = getWidgetBasicProjectInformation();
        self.addSubTask(getNewTaskWidget(), basicProjectWidget.currentRow.START, basicProjectWidget.currentRow.END);
    };

    this.newTaskActionEventDelete = function(args){
        var widget = getNewTaskWidget();
        ProjectServiceList.editProjectDeleteTask(widget);
    };

    this.repositoryFieldOnAdd = function(args){
        ScreenService.openPopup(getWidgetRepositorySelect());
        getWidgetRepositorySelect().newRow();
    };

    this.repositorySelectActionEventSave = function (args){
            var widget = getWidgetRepositorySelect();
            var advancedInformationWidget = getWidgetAdvancedInformation();
            if(widget.isValid()) {
                var row = {};
                row.changed = true;
                row.REPOSITORY_ID = widget.currentRow.REPOSITORY_ID;
                row.REPOSITORY = widget.currentRow.NAME;
                row.STATUS = 'A';
                row.URL = widget.currentRow.URL;
                row.DESCRIPTION = widget.currentRow.DESCRIPTION;
                row.PROJECT = localStorageEngine.getLocalVar('project');
                requestDataSourceEngine.setDataSource('/saveNewRepository', [row]);
                ScreenService.closePopup(true);
                ScreenService.closeSwipe().then(function(){
                    advancedInformationWidget.reload().then(function(){
                        advancedInformationWidget.activate();
                    });
                });
            }
    };

    this.repositorySelectActionEventBack = function(){
        var widget = ProjectRepositoryPopUp();
        ScreenService.closePopup();
        widget.parent.list();
        widget.parent.activate();
    };

    var setParentWithLastTaskSave = function (row, parent, parentName, notParentDefault) {
        parent = parent ? parent : '';
        parentName = parentName ? parentName : '';
        var taskParent = Utilities.localVar.getLocalVarNewTaskParent();
        if (taskParent && !notParentDefault) {
            row.PARENT = taskParent.PARENT;
            row.PARENT_NAME = taskParent.PARENT_NAME;
        } else {
            row.PARENT = parent;
            row.PARENT_NAME = parentName;
        }
    };

    this.addSubTask = function(widget, dateProjectBegin, dateProjectEnd) {
        var row = widget.currentRow;
        enableAllWidgetFields(getNewTaskWidget());
        getNewTaskWidget().newRow();
        getNewTaskWidget().getField('TASK_STATUS_NAME').reload().then(function () {
            applyDefaultValuesNewTaskCurrentRow(widget, dateProjectBegin, dateProjectEnd, null, null, row.USETIMEPLANNING);
        });
        getNewTaskWidget().getField('TASK_FEATURES').reload();
        getNewTaskWidget().getField('TASK_CLASSIFICATION_LABEL').reload();
        getNewTaskWidget().getField('PARENT_NAME').reload();
        widget.template = widget.formTemplate;
        changeFieldsVisibilityOnNewTaskWidgetWhenCreating();
        taskTabbedToggleVisibility(false);
        _setEnableLatency(getFieldLatencyFromNewTaskWidget(), getFieldPrecursorNameFromNewTaskWidget(), false);
    };


    /****************************************************
     * Saves a row using Zeedhi Defaults
     * @param widget
     ****************************************************/
    var saveItemUsingZeedhiRow = function(widget){
        if(!widget.isValid()){
            ScreenService.showMessage(Messages.ERR_REQUIRED_FIELDS);
            return;
        }
        widget.saveRow().then(function(){
            widget.reload().then(function(){
                ScreenService.goBack();
                widget.list();
            });
        });
    };


    this.closeSwipeInList = function(args){
        if(ScreenService.isSwipeOpen()&& args.owner.name !== args.owner.lastActiveWidget.name){
            ScreenService.closeSwipe().then(function(){
                args.owner.list();
                args.owner.activate();
            });
        }
    };

    this.setCurrentRowInFormGrid = function(args){
        if(args.owner.currentRow){
            var data = args.owner.dataSource.data;
            var currentRow = args.owner.currentRow;
            data.forEach(function(row){
                if(currentRow.ID == row.ID ) {
                    args.owner.currentRow = row;
                }
            });
        }
    };

    function setVisiblityFieldsProjectType(widget, visible) {
        widget.getField('START').isVisible = visible;
        widget.getField('END').isVisible = visible;
        widget.getField('TOTAL_TIME').isVisible = visible;
        widget.getField('TIME_PLANNED').isVisible = visible;
        widget.getField('DATE_EXCEPTION_NAME').isVisible = visible;
        if(widget.currentRow.DATE_EXCEPTION_ABBREVIATION == 'MB' ){
            widget.getField('DATE_EXCEPTION').isVisible = false;
        }else{
            widget.getField('DATE_EXCEPTION').isVisible = visible;
        }
    }

    var setVisiblityFieldsTaskType = function (widget, visible) {
        widget.fields.forEach(function(field){
            if(field.PMUseTimePlanning){
                field.isVisible = visible;
            }
        });
        if(widget.currentRow.DATE_EXCEPTION_ABBREVIATION == AS_SOON_AS_POSSIBLE) {
            getFieldDateExceptionFromNewTaskWidget().isVisible = false;
        }
    };

    this.basicFieldOnChangeProjectType = function(args){
        var widget = getWidgetBasicProjectInformation();
        var filter = [{
            "operator": "=",
            "name": "PROJECT_ID",
            "value": widget.currentRow.UPPER_PROJECT
        }];
        ScreenService.showLoader();
        requestDataSourceEngine.getDataSource('/checkProjectHasTemplateParentRecursive', filter).then(function(response) {
            ScreenService.hideLoader();
            var hasTemplateParent = response.dataset.checkProjectHasTemplateParentRecursive[0];
            var productProjectHasAllowReplicationLts = response.dataset.productProjectHasAllowReplicationLts[0];

            if(widget.currentRow.EXTERNALTYPE === 'E' && productProjectHasAllowReplicationLts === 'Y') {
                getFieldIsLtsReplicationFromProjectInformationWidget().isVisible = true;
                getFieldIsLtsReplicationFromProjectInformationWidget().readOnly = false;
            } else {
                getFieldIsLtsReplicationFromProjectInformationWidget().isVisible = false;
                getFieldIsLtsReplicationFromProjectInformationWidget().readOnly = true;
            }

            if ((widget.currentRow.EXTERNALTYPE == 'E' || modelProjectHasChildren) && !hasTemplateParent){
                getFieldVersionDevFromProjectInformationWidget().isVisible = true;
                localStorageEngine.setLocalVar('projectId', widget.currentRow.UPPER_PROJECT);
                getFieldVersionDevFromProjectInformationWidget().reload();
                setValueNullFieldVersionDevFromBasicWidget(widget.currentRow);
                getFieldVersionDevFromProjectInformationWidget().readOnly = false;
            } else {
                setValueNullFieldVersionDevFromBasicWidget(widget.currentRow);
                getFieldVersionDevFromProjectInformationWidget().isVisible = false;
            }
            setDefaultValueInProjectStatus();
            self.projectTypeChangeProject();
            setDataSourceFilterOnProjectCategories();
            getFieldProjectStatusFromBasicWidget().reload();
        }).catch(ScreenService.hideLoader);
    };

    var setValueNullFieldVersionDevFromBasicWidget = function (currentRow) {
        currentRow.PRODUCT_VERSION_DEV_ID = '';
        currentRow.VERSION_DEV = '';
    };

    var setDataSourceFilterOnProjectCategories = function(){
        var projectCategoriesField = getFieldProjectCategoriesFromBasicWidget();
        var valueToFilter = Utilities.getValueInSelectField(getFieldProjectTypeFromBasicWidget());
        var oldValue = Utilities.getValueInSelectField(projectCategoriesField);
        var resetFieldValue = true;
        Utilities.localVar.setLocalVarProjectType(valueToFilter);
        projectCategoriesField.reload().then(function(){
            projectCategoriesField.dataSource.data.some(function(item){
                if(oldValue == item.ID){
                    resetFieldValue = false;
                    return true;
                }
            });
            if(resetFieldValue) {
                Utilities.clearValueSelect(projectCategoriesField);
            }
        });
    };

    this.projectTypeChangeProject = function(){
        var widget = getWidgetBasicProjectInformation();
        var row = widget.currentRow;
        var projectApprovalProfiles = row.PROJECT_APPROVAL;
        var userProfiles = Utilities.localVar.getUserCurrentProfile();
        var fieldProjectStatus = getFieldProjectStatusFromBasicWidget();
        var projectStatus = Utilities.findInDataSource(fieldProjectStatus,[Utilities.getValueInSelectField(fieldProjectStatus)],fieldProjectStatus.valueField)[0];
        Utilities.localVar.setClickedProjectUseTimePlanning(row.USETIMEPLANNING);
        var visible = true;
        if(row.USETIMEPLANNING == 'N'){
            visible = false;
        }
        setVisiblityFieldsProjectType(widget, visible);
        if(projectStatus && projectStatus[fieldProjectStatus.PMControl] == 'N'){
            setFieldsApproval(userProfiles,projectApprovalProfiles);
        }
        if(!getFieldProjectTypeFromBasicWidget().value()){
            fieldProjectStatus.readOnly = true;
        }
    };

    var setFieldsApproval = function(userProfiles,projectApprovalProfiles) {
        var fieldProjectStatus = getFieldProjectStatusFromBasicWidget();
        if (projectApprovalProfiles && projectApprovalProfiles.length > 0) {
            var validate = userProfiles.filter(function (profileId) {
                return (-1 != projectApprovalProfiles.indexOf(profileId) || -1 != projectApprovalProfiles.indexOf(parseInt(profileId)));
            });
            fieldProjectStatus.readOnly = validate.length === 0;
        } else {
            fieldProjectStatus.readOnly = false;
        }
    };

    this.projectTypeChangeTask = function(row,widget){
        var visible = true;
        if(row.USETIMEPLANNING == 'N'){
            visible = false;
        }
        setVisiblityFieldsTaskType(widget, visible);
    };

    this.generateTaskFieldOnChangeResource = function() {
        var resourceField = getFieldResourceFromNewTaskWidget();
        var durationField = getFieldDurationFromGenerateTaskWidget();
        var widgetGenerate = getWidgetGenerateTask();
        var resourcesIds = getFieldResourceFromGenerateTaskWidget().value();
        var timePlannedSeg = widgetGenerate.currentRow.GENE_TASK_TOTAL_TIME;
        if(widgetGenerate.currentRow. ESTIMATED_TIME_PROPORTION){
            timePlannedSeg = timePlannedSeg*widgetGenerate.currentRow.ESTIMATED_TIME_PROPORTION;
        }
        var timePlanned = Utilities.secondsToDurationHour(timePlannedSeg);

        calcDurationByTimePlanned(null, timePlanned, resourcesIds, resourceField, timePlannedSeg,
            durationField,true);
    };

    this.durationWithResource = function(args){
        calcTaskFeatures();
    };

    this.newTaskFieldOnChangeTaskClassificationLabel = function(args){
        var newTaskWidget = getWidgetBasicTaskInformation();
        calcTaskFeatures();
        if(newTaskWidget.currentRow.TASK_CLASSIFICATION_CONTROL === 'T'){
            localStorageEngine.setLocalVar('taskClassificationControl', 'T');
        } else {
            localStorageEngine.setLocalVar('taskClassificationControl', null);
        }
        newTaskWidget.currentRow.RESOURCE = '';
        newTaskWidget.getField('RESOURCE').reload();
    };

    this.changeStructureProject = function(args){
        var managerField = args.owner.field.widget.getField('MANAGER');
        var row = args.row;
        reloadManagerProject(managerField,row.GROUP);
        row.MANAGER = '';
        row.MANAGER_NAME = '';
    };

    this.openPopUpFilterLog = function() {
        var currentWidget = templateManager.container.getActiveWidget();
        getPopUpFilterLog().parentWidget = currentWidget;
        ScreenService.openPopup(getPopUpFilterLog());
    };

    this.closePopUpFilter = function(widget){
        var parent = widget.parentWidget;
        ScreenService.closePopup();
        parent.activate();
    };

    function reloadManagerProject(managerField,structure) {
        localStorageEngine.setLocalVar('structureProject', structure);
        managerField.reload();
    }

    var reloadGroupProject =  function reloadManagerProject(groupField, manager) {
        groupField.dataSourceFilter = [{
            "name": "PROJECT_MANAGER",
            "value": manager,
            "operator": "="
        }];
        return groupField.reload();
    };
    var _setReadOnlyProjectDate = function (group) {
        var widget = getWidgetBasicProjectInformation();
        if (group) {
            widget.fields.forEach(function (field) {
                if (field.PMSubGroup == 'Date') {
                    field.readOnly = false;
                }
            });
        } else {
            widget.fields.forEach(function (field) {
                if (field.PMSubGroup == 'Date') {
                    field.readOnly = true;
                }
            });
        }
    };

    this.basicFieldOnChangeGroupName = function(args){
        var managerField = getFieldManagerFromProjectInformationWidget();
        var row = getWidgetBasicProjectInformation().currentRow;
        reloadManagerProject(managerField,row.GROUP);
        row.MANAGER = [];
        row.MANAGER_NAME = '';
        var group = row.GROUP;
        _setReadOnlyProjectDate(group);
    };

    this.basicFieldOnChangeManagerName = function(args){
        var groupField = getFieldGroupNameFromProjectInformationWidget();
        var row = getWidgetBasicProjectInformation().currentRow;
        reloadGroupProject(groupField,row.MANAGER).then(function(error){
            if(!error.messages){
                var filteredValue = groupField.dataSource.data.filter(function(value){
                return value.ID == row.GROUP;
                });

                if(groupField.dataSource.data.length === 0){
                        ScreenService.showMessage(Messages.ALE_MENAGER_NOT_RELATED_STRUCTURES, 'information');
                        row.GROUP = '';
                        row.GROUP_NAME = '';
                }else if(filteredValue.length === 0){
                    if(row.GROUP){
                       ScreenService.showMessage(Messages.ALE_RELATED_STRUCTURE_NO_LONGER_USABLE, 'information');
                    }

                    row.GROUP = '';
                    row.GROUP_NAME = '';
                }


            }else{
                row.GROUP = '';
                row.GROUP_NAME = '';
            }


        });
    };

    var getActiveWidget = function(){
        return templateManager.container.getActiveWidget();
    };

    var getProjectListManagerWidget = function() {
        return templateManager.container.getWidget('PROJECT_LIST_MANAGER');
    };

    this.upperProjectNameFromBasicWidgetFieldAfterSelectOpen = function(args) {
        getFieldParentNameFromProjectInformationWidget().reload();
    };

    var validateMergeRequestFinished = function(task) {
        var validate = true;
        var filterRelationship = [{
            "operator": "=",
            "name": "TASK",
            "value": task
        }, {
            "operator": "IN",
            "name": "TYPE",
            "value": Messages.TYPE_GENERATED_TASK_WITHOUT_ORIGIN
        }];
        return requestDataSourceEngine.getDataSource('/generatedTaskRelationship', filterRelationship).then(function (data) {
            var relationship = data.dataset.generatedTaskRelationship;
            if (relationship.length > 0) {
                var filterTask = [{
                    "operator": "=",
                    "name": "ID",
                    "value": relationship[0].TASK_RELATIONSHIP
                }];
                return requestDataSourceEngine.getDataSource('/taskCrud', filterTask).then(function (data) {
                    var task = data.dataset.task;
                    if(task[0].TASK_STATUS == getLocalVar('taskParameters').CONCLUDED_TASK_STATUS_ID) {
                        validate = false;
                    }
                    return validate;
                });
            } else {
                return validate;
            }
        });
    };

    var validateRelationshipTask = function(task) {
        var validation = {
            validate: true,
            typeRelationship: null
        };
        var filterRelationship = [{
            "operator": "=",
            "name": "TASK_RELATIONSHIP",
            "value": task
        }, {
            "operator": "IN",
            "name": "TYPE",
            "value": Messages.TYPE_GENERATED_TASK_WITHOUT_ORIGIN
        }];
        return requestDataSourceEngine.getDataSource('/generatedTaskRelationship', filterRelationship).then(function (data) {
            var relationship = data.dataset.generatedTaskRelationship;
            if (relationship.length > 0) {
                validation.typeRelationship = relationship[0].TYPE;
                if(relationship[0].TYPE === 'G') {
                    return validateMergeRequestFinished(task).then(function(validateMR) {
                        validation.validate = validateMR;
                        return validation;
                    });
                } else if(relationship[0].TYPE === 'M' || relationship[0].TYPE === 'R' || relationship[0].TYPE === 'T') {
                    validation.validate = false;
                    return validation;
                } else {
                    return validation;
                }
            } else {
                return validation;
            }
        });
    };

    var setFieldsGenerateWidget = function(widgetGenerate, widgetProject, widgetTask) {
        widgetGenerate.getField('PROJECT_NAME').setValue(widgetProject.currentRow.NAME);
        widgetGenerate.getField('PROJECT').setValue(widgetProject.currentRow.ID);
        widgetGenerate.getField('TASK_NAME').setValue(widgetTask.getField('PARENT_NAME').value());
        widgetGenerate.getField('TASK').setValue(widgetTask.getField('PARENT').value());
        widgetGenerate.getField('START').setValue(moment().format('DD/MM/YYYY'));
        widgetGenerate.getField('END').setValue(moment().format('DD/MM/YYYY'));
        var totalTime = widgetTask.currentRow.FIRST_TIME_PLANNED||Utilities.durationToSeconds(widgetTask.currentRow.TOTAL_TIME);
        widgetGenerate.currentRow.GENE_TASK_TOTAL_TIME = totalTime;
        widgetGenerate.currentRow.ESTIMATED_TIME_PROPORTION = 1;
        widgetGenerate.getField('TOTAL_TIME').setValue(Utilities.secondsToDurationHour(totalTime));
        widgetGenerate.getField('TASK_GENERATOR_NAME').setValue(widgetTask.getField('NAME').value());
        widgetGenerate.getField('TASK_GENERATOR_NAME').validations = {required: {}};
        widgetGenerate.getField('TASK_GENERATOR_NAME').placeholder = '';
        widgetGenerate.getField('TASK_GENERATOR').setValue(widgetTask.getField('ID').value());
        widgetGenerate.getField('NAME').setValue(widgetTask.getField('NAME').value());
        widgetGenerate.getField('NAME').validations = {"required": {}};
        widgetGenerate.getField('NAME').placeholder = '';
        widgetGenerate.getField('URL_TO_TEST').isVisible = false;
        widgetGenerate.getField('URL_TO_TEST').validations = false;
        widgetGenerate.getField('URL_TO_TEST').setValue('');
        widgetGenerate.getField('TYPE_RELATIONSHIP').setValue('');
        widgetGenerate.getField('TYPE_RELATIONSHIP').readOnly = false;
        widgetGenerate.getField('DESCRIPTION').setValue('');
        widgetGenerate.getField('RESOURCE').setValue(widgetTask.getField('RESOURCE').value());
        widgetGenerate.getField('RESOURCE').defaultValue = widgetTask.getField('RESOURCE').value();
        widgetGenerate.currentRow.VERSION_DEV = widgetTask.currentRow.VERSION_DEV;
        widgetGenerate.currentRow.VERSION_DEV_ID = widgetTask.currentRow.VERSION_DEV_ID;
        self.generateTaskFieldOnChangeResource();

        if (widgetTask.currentRow.USETIMEPLANNING == 'N') {
            widgetGenerate.getField('TOTAL_TIME').setValue(1);
            widgetGenerate.getField('TOTAL_TIME').isVisible = false;
            widgetGenerate.currentRow.TOTAL_TIME = 1;
            widgetGenerate.currentRow.TIME_PLANNED = 1;
        } else {
            widgetGenerate.getField('TOTAL_TIME').isVisible = true;
        }
    };

    this.openGenerateTask = function(widgetTask, widgetGenerate, widgetProject) {
        widgetGenerate.fields = self.pmGenerationTaskIdFilter(widgetGenerate.fields, []);
        widgetGenerate.fields.forEach(function(field){
            field.isVisible = !field.notIsVisible;
        });

        if(widgetTask.currentRow.TASK_GENERATE_ORIGIN === 'Y') {
            ScreenService.showMessage(Messages.ALE_NOT_GENERATE_TASK_ORIGIN, 'information');
        } else if(widgetTask.currentRow.TYPE_RELATIONSHIP == 'G'){
            ScreenService.showMessage(Messages.ALE_NOT_GENERATE_TASK_ERR_MERGE_REQUEST, 'information');
        } else {
            localStorageEngine.setLocalVar('calledGenerateTask', 'ACTION');
            localStorageEngine.setLocalVar('taskClassificationControl', null);
            ScreenService.showLoader();
            validateRelationshipTask(widgetTask.getField('ID').value()).then(function (validation) {
                ScreenService.hideLoader();
                if (validation.validate) {
                    if (widgetTask.currentRow.TASK_STATUS !== getLocalVar('taskParameters').CONCLUDED_TASK_STATUS_ID) {
                        ScreenService.showMessage(Messages.ALE_TASK_NOT_CONCLUDE);
                    } else {
                        widgetGenerate.getField('RESOURCE').reload();
                        var taskNameField = widgetGenerate.getField('TASK_NAME');
                        taskNameField.dataSourceFilter = [ {
                            name: "projectId",
                            operator: '=',
                            value: widgetProject.currentRow.ID
                        }, {
                            name: "allTasks",
                            operator: '=',
                            value: 0
                        } ];
                        taskNameField.reload();
                        widgetTask.currentRow.VERSION_DEV_ID = widgetProject.currentRow.VERSION_DEV_ID;
                        widgetTask.currentRow.VERSION_DEV = widgetProject.currentRow.VERSION_DEV;
                        setFieldsGenerateWidget(widgetGenerate, widgetProject, widgetTask);
                        ScreenService.openPopup(widgetGenerate);
                    }
                } else {
                    if (validation.typeRelationship === TYPE_RELATIONSHIP_MERGE_REQUEST) {
                        ScreenService.showMessage(Messages.ALE_NOT_GENERATE_TASK_MERGE_REQUEST);
                    } else if (validation.typeRelationship === TYPE_RELATIONSHIP_REPLICATION) {
                        ScreenService.showMessage(Messages.ALE_NOT_GENERATE_TASK_REPLICATION);
                    } else if (validation.typeRelationship === TYPE_RELATIONSHIP_ERROR_MR) {
                        ScreenService.showMessage(Messages.ALE_NOT_GENERATE_TASK_ERRO_MR);
                    } else if (validation.typeRelationship === TYPE_RELATIONSHIP_TEST) {
                        ScreenService.showMessage(Messages.ALE_NOT_GENERATE_TASK_TEST);
                    }
                }
            }).catch(Utilities.showMessageBackEndTrue);
        }
    };

    this.closeGenerateTask = function(args) {
        ScreenService.closePopup(true);
        var calledGenerateTask = localStorageEngine.getLocalVar('calledGenerateTask');

        if(calledGenerateTask === 'ACTION') {
            getWidgetBasicTaskInformation().activate();
        }  else if(calledGenerateTask === 'ACTION_CHECKED_ROWS') {
            getWidgetProjectTaskList().activate();
        }
    };

    var getTaskClassificationRowByControl = function(control){
        return Utilities.getRowInDataSource(getFieldTaskClassificationLabelFromGenerateTask().dataSource,'CONTROL',control);
    };

    var getTaskStatusRowByControl = function(control){
        return Utilities.getRowInDataSource(getFieldTaskStatusNameFromNewTaskWidget().dataSource,'CONTROL',control);
    };


    var getGenerateTaskRow = function(widgetTask, widgetGenerate, estimatedTimeProportion) {
        var generateCurrentRow = widgetGenerate.currentRow;
        var generatedTaskName = generateCurrentRow.NAME;
        var typeRelationship  = generateCurrentRow.TYPE_RELATIONSHIP;
        var description       = generateCurrentRow.DESCRIPTION;
        var resourceField = getFieldResourceFromGenerateTaskWidget();
        var resourcesIds = resourceField.value();
        var durationSeg = Utilities.durationToSeconds(generateCurrentRow.TOTAL_TIME, true);

        var classificationRow = getTaskClassificationRowByControl(typeRelationship);
        var taskClassification = widgetTask.currentRow.TASK_CLASSIFICATION;
        var taskClassificationLabel = widgetTask.currentRow.TASK_CLASSIFICATION_LABEL;

        if(classificationRow){
            taskClassification = classificationRow.ID;
            taskClassificationLabel =classificationRow.LABEL;
        }
        var taskParameters = Utilities.localVar.getTaskParameters();
        var taskStatus = 3;
        var taskStatusName = "Jump Validation!";
        if(taskParameters && taskParameters.INITIAL_TASK_STATUS_ID ) {
            taskStatus = taskParameters.INITIAL_TASK_STATUS_ID;
            taskStatusName = taskParameters.INITIAL_TASK_STATUS_NAME;
        }else{
            var taskStatusRow = getTaskStatusRowByControl('N');
            taskStatus = taskStatusRow.ID;
            taskStatusName = taskStatusRow.LABEL;
        }

        generatedTaskName = Utilities.includeTaskTypeInTaskName(generatedTaskName, typeRelationship);

        return  {
            DATE_EXCEPTION: null,
            DATE_EXCEPTION_TYPE: "MB",
            DESCRIPTION: description,
            END: generateCurrentRow.END,
            PROJECT: generateCurrentRow.PROJECT,
            NAME: generatedTaskName,
            PARENT: generateCurrentRow.TASK,
            RESOURCE: generateCurrentRow.RESOURCE,
            START: generateCurrentRow.START,
            URL_TO_TEST: generateCurrentRow.URL_TO_TEST,
            STATUS: "A",
            TASK_STATUS: taskStatus,
            TASK_STATUS_NAME: taskStatusName,
            TASK_CLASSIFICATION: taskClassification,
            TASK_CLASSIFICATION_LABEL: taskClassificationLabel,
            TOTAL_TIME: generateCurrentRow.TOTAL_TIME,
            TIME_PLANNED: calcTimePlannedByDuration(null, generateCurrentRow.TOTAL_TIME, resourcesIds, resourceField, durationSeg, estimatedTimeProportion),
            VERSION_DEV: generateCurrentRow.VERSION_DEV,
            VERSION_DEV_ID: generateCurrentRow.VERSION_DEV_ID,
            __createdLocal: true,
            __is_new: true,
            changed: true
        };

    };

    var getRowTaskRelationship = function(widgetGenerate) {
        var filterRelationship = [
            {
                "operator": "=",
                "name": "TASK_RELATIONSHIP",
                "value": widgetGenerate.getField('TASK_GENERATOR').value()
            },
            {
                "operator": "IN",
                "name": "TYPE",
                "value": ["C", "M"]
            }
        ];
        return requestDataSourceEngine.getDataSource('/generatedTaskRelationship', filterRelationship).then(function(data) {
            var taskGenerator;
            if(data.dataset.generatedTaskRelationship.length > 0) {
                taskGenerator = data.dataset.generatedTaskRelationship[0].TASK;
            } else {
                taskGenerator = widgetGenerate.getField('TASK_GENERATOR').value();
            }

            var row = {
                ID: "",
                TASK: taskGenerator,
                TASK_RELATIONSHIP: "",
                TYPE_PRECURSOR: "",
                TYPE: widgetGenerate.getField('TYPE_RELATIONSHIP').value(),
                isMessage: false,
                __is_new: true,
                changed: true
            };

            return row;
        });
    };

    this.generateTaskActionEventGenerate = function() {
        if(getWidgetGenerateTask().isValid()){
            var generateTaskWidget = getWidgetGenerateTask();
            generateTaskWidget.currentRow.VERSION_DEV = localStorageEngine.getLocalVar('');
            generateTaskWidget.currentRow.VERSION_DEV_ID = localStorageEngine.getLocalVar('projectVersionDevId');
            self.generateTask(getWidgetGenerateTask(), getWidgetGenerateTasks());
            ScreenService.closePopup(true);
            localStorageEngine.setLocalVar('taskClassificationControl', null);
            getWidgetProjectTasks().activate();
        }
    };

    this.generateTask = function(widgetGenerate, widgetGeneratedTasks) {
        var widgetBasic    = getWidgetBasicProjectInformation();//BASIC
        var widgetFromTask = getWidgetBasicTaskInformation();   //NEW_TASK
        var widgetListTask = getWidgetProjectTaskList();        //PROJECTTASK

        var calledGenerateTask = localStorageEngine.getLocalVar('calledGenerateTask');

        if(calledGenerateTask === 'ACTION') {
            ScreenService.showLoader();
            getRowTaskRelationship(widgetGenerate).then(function (rowTaskRelationship) {
                var filterRequest = [{
                    "name": "CONTROL",
                    "value": widgetGenerate.currentRow.TYPE_RELATIONSHIP,
                    "operator": "="
                }];
                ProjectServiceList.getClassification(filterRequest).then(function(data) {
                    ScreenService.hideLoader();
                    var backupRow = widgetFromTask.currentRow;
                    widgetFromTask.currentRow = getGenerateTaskRow(widgetFromTask, widgetGenerate, 1);
                    if (backupRow.USETIMEPLANNING == 'N') {
                        widgetFromTask.currentRow.TIME_PLANNED = 1;
                    }
                    widgetFromTask.taskGeneratedRow = rowTaskRelationship;
                    widgetFromTask.widgetGenerate = widgetGenerate;
                    widgetFromTask.widgetGeneratedTasks = widgetGeneratedTasks;
                        ProjectServiceList.editProjectSaveTask(widgetFromTask, widgetBasic, widgetListTask, true).then(function () {
                            widgetListTask.activate();
                        });
                }).catch(Utilities.showMessageBackEndTrue);
            }).catch(Utilities.showMessageBackEndTrue);
        } else if(calledGenerateTask === 'ACTION_CHECKED_ROWS'){
            if(widgetGenerate.currentRow &&
                widgetGenerate.currentRow.TYPE_RELATIONSHIP == TYPE_RELATIONSHIP_MERGE_REQUEST &&
                !widgetGenerate.currentRow.DESCRIPTION){
                widgetGenerate.currentRow.DESCRIPTION = Utilities.messages.DES_TASK_MERGE_REQUEST;
            }
            ProjectServiceList.generateTasksFromProjectTask(getRowNewTasksFromProjectTask(widgetGenerate.currentRow, widgetListTask.getCheckedRows())).then(function () {
                ScreenService.closePopup(true);
                widgetBasic.reload();
                widgetListTask.dataSource.checkedRows = [];
                widgetListTask.dataSource.unSelectAll();
                widgetListTask.reload();
                widgetListTask.activate();
                ScreenService.successNotification(Messages.SUC_TASK_SUCCESSFUL_GENERATED);
            });
        }
    };
    var getInitialTaskStatus = function () {
        var taskStatus = 3;
        var taskParameters = Utilities.localVar.getTaskParameters();
        if (taskParameters && taskParameters.INITIAL_TASK_STATUS_ID) {
            taskStatus = taskParameters.INITIAL_TASK_STATUS_ID;
        }
        return taskStatus;
    };

    var getRowNewTasksFromProjectTask = function(currentRow, checkedRows) {

        var typeRelationship = currentRow.TYPE_RELATIONSHIP;
        var taskStatus = getInitialTaskStatus();

        var tasks = currentRow.TASK_GENERATOR_NAME.map(function (taskId) {
            return {
                RESOURCE: currentRow['RESOURCE_' + taskId],
                PARENT: currentRow['PARENT_' + taskId],
                TYPE_RELATIONSHIP: typeRelationship,
                DESCRIPTION: currentRow.DESCRIPTION,
                TASK_ID: taskId,
                NAME: Utilities.includeTaskTypeInTaskName( currentRow['TASK_NAME_' + taskId], typeRelationship),
                TASK_STATUS: taskStatus,
                TIME_PLANNED: currentRow['TIME_PLANNED_'+ taskId],
                __is_new: true,
                changed: true
            };
        });
        return {
            TASKS: tasks,
            TASK_IDS: currentRow.TASK_GENERATOR_NAME,
            CLASSIFICATION_ID: currentRow.CLASSIFICATION_ID,
            NOT_SET_TOTAL_TIME: true,
            VERSION_DEV: currentRow.VERSION_DEV,
            VERSION_DEV_ID: currentRow.VERSION_DEV_ID,
            changed: true
        };
    };

    var getRowsGenerateForInsert = function(widgetGenerate, checkedRowsWidgetProjectTasks) {
        var rows = [];

        var filterRequest = [
            {
                "name": "CONTROL",
                "value": ['M'],
                "operator": "IN"
            }
        ];
        return ProjectServiceList.getClassification(filterRequest).then(function (data) {
            var mergeRequestClassificationId = data.dataset.classification[0].ID;
            checkedRowsWidgetProjectTasks.forEach(function (checkedRow) {
                var name = widgetGenerate.getField('NAME').value();
                var description = widgetGenerate.getField('DESCRIPTION').value();

                if (!name || name.trim() === '') {
                    name = checkedRow.NAME;
                }

                var relationship = {
                    ID: "",
                    TASK: checkedRow.ID,
                    TASK_RELATIONSHIP: "",
                    TYPE_PRECURSOR: "",
                    TYPE: widgetGenerate.getField('TYPE_RELATIONSHIP').value(),
                    isMessage: false,
                    __is_new: true,
                    changed: true
                };

                if(relationship.TYPE == 'M') {
                    checkedRow.TASK_CLASSIFICATION = mergeRequestClassificationId;
                }

                var row = {
                    DATE_EXCEPTION: null,
                    DATE_EXCEPTION_TYPE: "MB",
                    DESCRIPTION: description,
                    END: widgetGenerate.getField('END').value(),
                    PROJECT: widgetGenerate.getField('PROJECT').value().split("/").reverse().join("-"),
                    NAME: Utilities.includeTaskTypeInTaskName(name, relationship.TYPE),
                    PARENT: widgetGenerate.getField('TASK').value(),
                    RESOURCE: widgetGenerate.getField('RESOURCE').value(),
                    START: widgetGenerate.getField('START').value(),
                    TOTAL_TIME: widgetGenerate.getField('TOTAL_TIME').value(),
                    URL_TO_TEST: widgetGenerate.getField('URL_TO_TEST').value(),
                    STATUS: "A",
                    TASK_STATUS: 3,
                    RELATIONSHIP: relationship,
                    TASK_CLASSIFICATION: checkedRow.TASK_CLASSIFICATION,
                    __is_new: true,
                    changed: true
                };

                var durationSeg = Utilities.durationToSeconds(row.TOTAL_TIME);
                row.TIME_PLANNED = calcTimePlannedByDuration(null, row.TOTAL_TIME, row.RESOURCE, widgetGenerate.getField('RESOURCE'), durationSeg);
                rows.push(row);
            });
            return rows;
        });
    };

    this.filterManager = function(widget) {
        var parent = widget.parentWidget;
        FilterService.parentFilter(parent, widget).then(function(){
            ScreenService.closePopup();
            parent.activate();
        });
    };
    this.filterLog = function(widget) {
        var parent = widget.parentWidget;
        FilterService.parentFilter(parent, widget).then(function(){
            ScreenService.closePopup();
            parent.activate();
        });
    };
    this.filterPart = function(widget) {
        var parent = widget.parentWidget;
        FilterService.parentFilter(parent, widget).then(function(){
            ScreenService.closePopup();
            parent.activate();
        });
    };
    this.initFilterProjects = true;

    this.filterDataSourceById = function(field,id){
        return field.reload().then(function(){
            return field.dataSource.data.filter(function(row){
                return row.ID == id;
            });
        });
    };

   this.projectTasksBeforeGenerateReport = function (args) {
       if(event && event.currentTarget && event.currentTarget.className === "zh-report-xls"){
           var nameFields = Object.keys(args.e.metadata.columns);
           var newColumn = {
               align: "left",
               description: "Rownum",
               expression: undefined,
               format: undefined,
               sequence: -1,
               size: "20%",
               xlsType: undefined
           };
           var columns = {};
           columns.ROWNUM = newColumn;
           nameFields.forEach(function (name) {
               columns[name] = args.e.metadata.columns[name];
           });
           args.e.metadata.columns = columns;
       }
    };

    this.projectTasksActionEventRecalculate = function(){
        ScreenService.showCustomDialog(Utilities.messages.ALE_RECALCULATE_DATES_PROJECT,'CONFIRMATION',null,
            [
                {
                    "label": "Continuar",
                    "code":function(){
                        recalculateTasks();
                    }
                },
                {
                    "label": "Cancelar",
                    "code": ''
                }
            ]
        );
    };

    var recalculateTasks = function(){
        var functions = [];
        var widgetProjectTaskList = getWidgetProjectTaskList();
        var max = widgetProjectTaskList.dataSource.data.length+1;
        widgetProjectTaskList.dataSource.data.forEach(function(task,index) {
            functions.push(ProjectServiceList.recalculateTasks.bind(ProjectServiceList, task.ID,index+1,max));
        });
        var callBack = function() {
            ScreenService.restoreDefaultLoadingMessage();
            ScreenService.closePopup();
            widgetProjectTaskList.activate();
            widgetProjectTaskList.reload();
        };
        functions.push(ProjectServiceList.recalculateProject.bind(ProjectServiceList, max, callBack));
        Utilities.doSyncPm(functions);
    };

    var getProfileByCurrentUser = function(){
        ProjectServiceList.getProfileByCurrentUser().then(function(response){
            if(response.dataset.userProfile){
                Utilities.localVar.setUserCurrentProfile(response.dataset.userProfile);
            } else {
                Utilities.localVar.setUserCurrentProfile([]);
            }
        });
    };

    this.applyValueToManagerFieldFromFilterPopup = function(row, field, value){
        if(row.length){
            field.value(value);
            return true;
        }
        field.value([]);
    };

    this.onEnterWidgetGenerateTask = function(widget, widgetTask) {
        validateRelationshipTask(widgetTask.getField('ID').value()).then(function(validation) {
            if(validation.validate && validation.typeRelationship === 'G') {
                widget.getField('TYPE_RELATIONSHIP').dataSource.data = Messages.DATA_TYPE_RELATIONSHIP_TASK_MR;
            } else {
                widget.getField('TYPE_RELATIONSHIP').dataSource.data = Messages.DATA_TYPE_RELATIONSHIP_TASK;
            }
            getNewTaskWidget().getField('TYPE').readOnly = false;
        });
    };

    this.generatedTasksWidgetonEnter = function (widget) {
        widget.getField('TYPE').dataSource.data = Messages.FULL_DATA_TYPE_RELATIONSHIP_TASK;
        if (Utilities.isAppliedFilter(widget)) {
            widget.reload();
        } else {
            widget.currentRow.TYPE = Messages.TYPE_GENERATED_TASK;
            ZhFilterPreferences.setOriginalFilter(widget.id, widget.currentRow);
            ZhFilterPreferences.applyOriginalFilter(widget);
        }
    };

    ProjectServiceList.setProjectController(this);
    var self = this;


    this.saveProjectStatus = function(widget){
        var row = widget.currentRow;
        var control = row.CONTROL;
        if(control == PROJECT_STATUS_CONCLUDED) {
            findProjectStatusConcluded().then(function(data) {
                var status = data.dataset.projectStatus;
                if(status.length > 0 && status[0].ID != row.ID) {
                    var message = Messages.ALE_NOT_ASSOCIATE_TWO_CONCLUDED_ST.replace('%1', status[0].LABEL);
                    ScreenService.showMessage(message, 'ALERT');
                } else {
                    ProjectServiceList.doSaveProjectStatus(row, widget);
                }
            });
        } else {
            ProjectServiceList.doSaveProjectStatus(row, widget);
        }
    };


    /************************************************************
     * Removes a project status.
     * @param widget
     ************************************************************/
    this.removeProjectStatus = function(widget){
        var row = widget.currentRow;
            row.CHECKED_ROWS = widget.getCheckedRows();
            row.changed = true;
        ProjectServiceList.removeProjectStatus(row).then(function(data){
            widget.reload();
            widget.dataSource.unSelectAll();
        });
    };

    /************************************************************
     * Called by action event
     * @param args
     ************************************************************/
    this.taskIssuesAttachmentsActionEventBack = function(args){
        closeTaskIssueInformation();
    };


    /************************************************************
     * Called by action event
     * @param args
     ************************************************************/
    this.taskIssuesCommentsActionEventBack = function(args){
        closeTaskIssueInformation();
    };

    this.allocationAddActionEventBack = function(args){
        getAllocationAddWidget().dataSource.unSelectAll();
        ScreenService.closePopup();
    };

    /************************************************************
     * Called by action event
     * @param args
     ************************************************************/
    this.allocationAddActionEventSave = function(args){
        var widgetProjectTaskList = getWidgetProjectTaskList();
        if(projectTasksHasResources(widgetProjectTaskList)){
            showAllocationType(getAllocationAddWidget());
        } else {
            self.allocationTypeAddFieldOnClick(args);
        }
    };

    /************************************************************
     * Called by action event
     * @param args
     ************************************************************/
    this.taskIssuesAttachmentsActionEventDownload = function(args){
        Utilities.downloadAttachment(args.row.ID);
    };

    /************************************************************
     * Called by widget event
     * @param args
     ************************************************************/
    this.taskIssuesWidgetAfterMoveRow = function(args){
        openTaskIssuesTabbedWidget(args.owner);
    };

    /************************************************************
     * Called by action event
     * @param args
     ************************************************************/
    this.tabCategoriesActionEventSave = function(args){
        saveItemUsingZeedhiRow(args.owner.widget);
    };


    /************************************************************
     * Called by action event
     * @param args
     ************************************************************/
    this.typeProjectActionEventSave = function(args){
        saveItemUsingZeedhiRow(args.owner.widget);
    };


    /************************************************************
     * Called by widget event
     * @param args
     ************************************************************/
    this.projectListPublicWidgetAfterMoveRow = function(args){
        projectOnListClicked(args);
    };

    var setIsVisiblePMManagerIsVisible = function (widget,validate) {
        widget.actions.filter(function (action) {
            return !!action.PMManagerIsVisible;
        }).forEach(function (action) {
            action.isVisible = action.PMManagerIsVisible == validate;
        });
    };

    var isVisibleFinishPlanningAction = function(isFinish){
        var actions = getActionFinishPlanningFromBasicProjectInformation();
        if(actions.isVisible){
            actions.isVisible = isFinish;
        }
    };

    var setIsVisibleAndReadOnlyTabbedProject = function (isMyProjects,isFinish) {
        var validate = isMyProjects ? 'Y' : 'N';
        setIsVisiblePMManagerIsVisible(getWidgetBasicProjectInformation(),validate);
        setIsVisiblePMManagerIsVisible(getWidgetAdvancedInformation(),validate);
        setIsVisiblePMManagerIsVisible(getWidgetProjectResourceList(),validate);
        setIsVisiblePMManagerIsVisible(getNewTaskWidget(),validate);
        setIsVisiblePMManagerIsVisible(getWidgetBasicInformationResource(),validate);
        setIsVisiblePMManagerIsVisible(getWidgetProjectDocumentsTask(),validate);
        setIsVisiblePMManagerIsVisible(getWidgetProjectTasks(),validate);
        setIsVisiblePMManagerIsVisible(getWidgetRepositoryInformation(),validate);

        isVisibleFinishPlanningAction(isFinish);

        getFieldBaseCalendarFromWidgetBasicCalendar().readOnly = !isMyProjects;
    };

    var setActionsIsVisible = function(widget,property,isVisible){
        widget.actions.filter(function(action){
            return !!action[property];
        }).forEach(function(action){
            action.isVisible = !action.isVisible ? action.isVisible : isVisible;
        });
    };

    var setActionsIsVisiblePMModelIsVisible = function(){
        var property = 'PMConditionReadOnlyModel';
        var basicProjectWidget = getWidgetBasicProjectInformation();
        var modelsIsRestricted = basicProjectWidget.currentRow.MODELS_IS_RESTRICTED;
        setActionsIsVisible(basicProjectWidget,property,!modelsIsRestricted);

        var modelsIsFirst = basicProjectWidget.currentRow.MODELS_IS_FIRST;
        if(modelsIsRestricted && !modelsIsFirst){
            var propertyIsFist = 'PMConditionReadOnlyModelFirst';
            setActionsIsVisible(basicProjectWidget,propertyIsFist,!modelsIsRestricted);
        }


    };
    /************************************************************
     * Called by widget event
     * @param args
     ************************************************************/
    this.projectListPartWidgetAfterMoveRow = function(args){
        saveLocalStorageInformationAfterMoveProjectRow(args.owner);
        projectOnListClicked(args);
        setIsVisibleAndReadOnlyTabbedProject(false,false);
        Utilities.localVar.setLocalVarNewTaskParent(null);
    };

    var setIsVisibleInActionInHomologation = function(widget,validate){
        widget.actions.filter(function (action) {
            return !!action.PMHomologationIsVisible;
        }).forEach(function (action) {
            action.isVisible = (!action.isVisible) ? action.isVisible : (action.PMHomologationIsVisible == validate);
        });
    };

    var setInHomologation = function(inHomologated){
        var validate = inHomologated ? 'Y' : 'N';
        setIsVisibleInActionInHomologation(getWidgetProjectTasks(),validate);
        setIsVisibleInActionInHomologation(getNewTaskWidget(),validate);
    };

    /************************************************************
     * Called by widget event
     * @param args
     ************************************************************/
    this.projectListManagerWidgetAfterMoveRow = function(args){
        setIsVisibleInViewModel(false);
        var projectListManagerWidget = getProjectListManagerWidget();
        var basicProjectInformationWidget = getWidgetBasicProjectInformation();
        var projectStatusField = getFieldProjectStatusFromBasicWidget();
        var currentRow = projectListManagerWidget.currentRow;
        if(currentRow.MODEL){
            getActionOpenMnemonicWindowFromBasicWidget().isVisible = true;
        }else{
                getActionOpenMnemonicWindowFromBasicWidget().isVisible = false;
        }
        var filter = [{
            "operator": "=",
            "name": "PROJECT_ID",
            "value": currentRow.ID
        }];
        ScreenService.showLoader();
        requestDataSourceEngine.getDataSource('/checkProjectHasTemplateParentRecursive', filter).then(function(response){
            ScreenService.hideLoader();
            var hasTemplateParent = response.dataset.checkProjectHasTemplateParentRecursive[0];
            var productProjectHasAllowReplicationLts = response.dataset.productProjectHasAllowReplicationLts[0];

            if ((currentRow.EXTERNALTYPE == 'E' || modelProjectHasChildren) && !hasTemplateParent) {
                getFieldVersionDevFromProjectInformationWidget().isVisible = true;
            } else {
                getFieldVersionDevFromProjectInformationWidget().isVisible = false;
            }

            if(currentRow.EXTERNALTYPE === 'E' && productProjectHasAllowReplicationLts === 'Y'){
                getFieldIsLtsReplicationFromProjectInformationWidget().isVisible = true;
                getFieldIsLtsReplicationFromProjectInformationWidget().readOnly = false;
            } else {
                getFieldIsLtsReplicationFromProjectInformationWidget().isVisible = false;
                getFieldIsLtsReplicationFromProjectInformationWidget().readOnly = true;
            }

            if(currentRow.IN_HOMOLOGATED){
                if(currentRow.EXTERNALTYPE === 'E' || currentRow.EXTERNALTYPE === 'R' || currentRow.EXTERNALTYPE === 'B'){
                    projectStatusField.dataSourceFilter = [{
                        "name": "CONTROL",
                        "operator": "IN",
                        "value": "('X')"
                    }];
                } else {
                    projectStatusField.dataSourceFilter = [{
                        "name": "CONTROL",
                        "operator": "IN",
                        "value": "('X', 'C')"
                    }];
                }
            } else if(currentRow.EXTERNALTYPE === 'F' || currentRow.EXTERNALTYPE === 'Q'){
                projectStatusField.dataSourceFilter = [{
                    "name": "CONTROL",
                    "operator": "IN",
                    "value": "('O', 'X')"
                }];
            } else if(currentRow.EXTERNALTYPE === 'E' || currentRow.EXTERNALTYPE === 'R' || currentRow.EXTERNALTYPE === 'B' || currentRow.PROJECT_STATUS_CONTROL === 'N') {
                projectStatusField.dataSourceFilter = [{
                    "name": "CONTROL",
                    "operator": "NOT IN",
                    "value": "@getLocalVar('projectStatusControl') ? getLocalVar('projectStatusControl') : [0] @",
                    "pmChangeable": true
                }, {
                    "name": "CONTROL",
                    "operator": "NOT IN",
                    "value": "@getLocalVar('clickedProjectUseTimePlanning') == 'Y' ? ['D']: [0] @"
                }];
            } else {
                projectStatusField.dataSourceFilter = [{
                    "name": "CONTROL",
                    "operator": "NOT IN",
                    "value": "'N'"
                }];
            }

            saveLocalStorageInformationAfterMoveProjectRow(projectListManagerWidget);
            projectOnListClicked(args, true);
            setProjectUsesMergeRequest(projectListManagerWidget.currentRow.ID);
            var isFinish = (currentRow.PROJECT_STATUS_CONTROL == 'N');
            setIsVisibleAndReadOnlyTabbedProject(true,isFinish);
            setInHomologation(projectListManagerWidget.currentRow.IN_HOMOLOGATED);
            Utilities.localVar.setLocalVarNewTaskParent(null);
            localStorageEngine.setLocalVar('projectId', projectListManagerWidget.currentRow.ID);
            localStorageEngine.setLocalVar('projectVersionDev', projectListManagerWidget.currentRow.VERSION_DEV);
            localStorageEngine.setLocalVar('projectVersionDevId', projectListManagerWidget.currentRow.VERSION_DEV_ID);
            localStorageEngine.setLocalVar('clientId', basicProjectInformationWidget.currentRow.SPONSOR);
            localStorageEngine.setLocalVar('parentProjectId', basicProjectInformationWidget.currentRow.UPPER_PROJECT);
        }).catch(ScreenService.hideLoader);
    };

    var setReadOnlyIsLtsReplicationFromProjectInformationWidget = function (projectStatusControl, isLtsReplicationField) {
        isLtsReplicationField.readOnly = projectStatusControl !== 'N';
    };

    this.projectTasksWidgetAfterMoveRow = function(args){
        var projectTasksWidget = getWidgetProjectTasks();
        if(Utilities.validateEditInLine(projectTasksWidget) && projectTasksWidget.mode !== 'inline_edit'){
            var actionAddGeneratedTaskFromNewTask = getActionAddGeneratedTaskFromNewTask();
            var actionReplicationFromNewTask = getActionReplicationFromNewTask();
            var externalType = Utilities.localVar.getProjectExternalType();
            hidePercentFieldWhenTaskEndNotAllowed();
            taskTabbedToggleVisibility(true);
            if(projectTasksWidget.currentRow.TASK_CLASSIFICATION_CONTROL === 'T'){
                localStorageEngine.setLocalVar('taskClassificationControl', 'T');
            } else {
                localStorageEngine.setLocalVar('taskClassificationControl', null);
            }
            if(externalType == 'T'){
                actionAddGeneratedTaskFromNewTask.isVisible = false;
                actionReplicationFromNewTask.isVisible = false;
            }else{
                actionAddGeneratedTaskFromNewTask.isVisible = true;
                actionReplicationFromNewTask.isVisible = true;
            }
            taskMoveRowList(args);
        }
    };

    this.calendarWidgetOnChangeMonth = function(args){
        getWidgetProjectCalendar().reload();
    };

    this.getMonthFromWidgetCalendar = function(){
        if(templateManager.container){
            return CalendarService.getMonthFromWidgetCalendar(getWidgetProjectCalendar());
        }else{
            return 1;
        }
    };

    this.getYearFromWidgetCalendar = function(){
        if(templateManager.container){
            return CalendarService.getYearFromWidgetCalendar(getWidgetProjectCalendar());
        }else{
            return 1;
        }
    };

    this.calendarResourceWidgetOnChangeMonth = function(args){
        getWidgetCalendarResource().reload();
    };

    this.getMonthFromWidgetCalendarResource = function(){
        if(templateManager.container){
            return CalendarService.getMonthFromWidgetCalendar(getWidgetCalendarResource());
        } else {
            return 1;
        }
    };

    this.getYearFromWidgetCalendarResource = function(){
        if(templateManager.container){
            return CalendarService.getYearFromWidgetCalendar(getWidgetCalendarResource());
        }else{
            return 1;
        }
    };

    this.projectTasksActionEventCopy = function(args) {
        var validationGeneratedTasks = validateGeneratedTaskToCopy(args.owner.widget.dataSource.checkedRows);
        if(validationGeneratedTasks.length > 0) {
            var message = Messages.ALE_NOT_COPY_GENERATED_TASKS.replace('%2', '"' + validationGeneratedTasks.join('"<br/>"') + '"');
            ScreenService.showMessage(message, 'INFORMATION');
        } else {
            showTargetTask(args.owner.widget.dataSource.checkedRows.length, getWidgetCopyTask(), true);
        }
    };

    /************************************************************
     * Called by action event
     * @param args
     ************************************************************/
    this.projectTasksActionEventMove = function(args){
        showTargetTask(args.owner.widget.dataSource.checkedRows.length, getWidgetMoveTask(), true, true);
        loadTasksByProjectOnEnter(getOnlyIdsFromTaskObjectList(getWidgetProjectTaskList().getCheckedRows(), 'ID'));
    };

    /************************************************************
     * Called by action event
     * @param args
     ************************************************************/
    this.basicWidgetActionEventRemove = function(args) {
        if(!checkIfProjectHasAppropriationsOrCanBeRemoved()) {
            ProjectServiceList.deleteProjectBasic(args);
        } else {
            ScreenService.showMessage(Messages.ERR_CANT_DEL_APPROPRIATED_PROJECT);
        }
    };

    /************************************************************
     * Called by widget event
     * @param args
     ************************************************************/
    this.basicWidgetOnEnterTab = function(args){
        deactivateStatusFieldIfHasAppropriatedTasks();
    };

    /************************************************************
     * Called by field event
     * @param args
     ************************************************************/
    this.moveTaskFieldOnChangeProjectName = function(args){
        loadTasksByProject(args.owner, getOnlyIdsFromTaskObjectList(getWidgetProjectTaskList().getCheckedRows(), 'ID'));
        needTaskReplanningReason();
        getFieldReplanningReasonFromMoveTaskWidget().reload();
    };

    /************************************************************
     * Called by field event
     * @param args
     ************************************************************/
    this.generateTaskFieldOnChangeProjectName = function(args){
        loadTasksByProject(args.owner);
    };

    /************************************************************
     * Called by field event
     * @param args
     ************************************************************/
    this.copyTaskFieldOnChangeProjectName = function(args){
        loadTasksByProject(args.owner);
    };

    /************************************************************
     * Called by field event
     * @param args
     ************************************************************/
    this.basicWidgetFieldOnClickStatus = function(args){
        showMessageWhenClickOnDeactivatedStatusCheckbox(args.owner.field, Messages.ERR_CANT_DEACTIVATE_APPROPRIATED_PROJECT);
    };

    var unselectCheckboxes = function(dataSource){
        dataSource.unSelectAll();
    };

    var setLocalVarsForCategory = function(projectType,projectStatus){
        Utilities.localVar.setLocalVarProjectType(projectType);
        Utilities.localVar.setLocalVarProjectStatus(projectStatus);
    };

    var projectTasksHasResources = function(widgetProjectTaskList){
        var tasks = widgetProjectTaskList.getCheckedRows();
        var hasResource = false;
        tasks.forEach(function(task){
            if (Utilities.isEmpty(task.RESOURCES) === false){
                hasResource = true;
                return;
            }
        });
        return hasResource;
    };

    var needTaskReplanningReason = function(){
        var moveTaskWidget = getWidgetMoveTask();
        var originProject = localStorageEngine.getLocalVar('project');
        var destinyProject = moveTaskWidget.currentRow.PROJECT;
        var replanningReasonField = getFieldReplanningReasonFromMoveTaskWidget();
        if(moveTaskWidget.currentRow.PROJECT_NAME === ''){
            setStatusDisableFieldReplanningReason(replanningReasonField);
        } else {
            ProjectServiceList.needTaskReplanningReason(originProject).then(function(response){
                var needTaskReplanningReason = response.dataset.needTaskReplanningReason[0].needTaskReplanningReason;
                if(originProject != destinyProject && needTaskReplanningReason){
                    replanningReasonField.isVisible = true;
                    replanningReasonField.validations.required = true;
                } else {
                    setStatusDisableFieldReplanningReason(replanningReasonField);
                }
            });
        }
    };

    var setStatusDisableFieldReplanningReason = function(replanningReasonField){
        replanningReasonField.isVisible = false;
        replanningReasonField.value('');
        replanningReasonField.validations.required = false;
        getWidgetMoveTask().currentRow.ID = null;
    };

    /************************************************************
     * Called by widget event
     * @param args
     ************************************************************/
    this.projectTasksWidgetAfterLoadDataSource = function(args){
        if(args){
            unselectCheckboxes(args.owner.dataSource);
        }
        //validar if is paretn , erro, merge, teste,
        var widget = getWidgetProjectTaskList();
        var stripeWidget = getWidgetTotalTimePlannedStripe();
        var totalPoints = 0;
        var totalErrorPoints = 0;
        var field = getFieldTotalErrorFromStripeWidget();
        widget.dataSource.data.forEach(function (data) {
            if(!data.TYPE_RELATIONSHIP && data.IS_PARENT == 'N'){
                totalPoints += parseInt(data.TIME_PLANNED);
            }else if(data.TYPE_RELATIONSHIP == 'E' || data.TYPE_RELATIONSHIP == 'G') {
                totalErrorPoints++;
            }
        });
        
        stripeWidget.currentRow.TOTAL_TIME_PLANNED = totalPoints;
        if(totalErrorPoints > 0){
            field.isVisible = true;
            stripeWidget.currentRow.TOTAL_ERROR_TIME_PLANNED = totalErrorPoints;
        }else{
            field.isVisible = false;
        }
        ProjectServiceList.hideProjectTasksColumnsByAllowEndTasks([getFieldPercentFromProjectTasksWidget()]);
        ProjectServiceList.hideProjectTasksColumnsByTimePlanning([
            getFieldDurationFromProjectTasksWidget(),
            getFieldBeginDateFromProjectTasksWidget(),
            getFieldEstimatedDateFromProjectTasksWidget()
        ]);
        widget.redraw();

    };

    /************************************************************
     * Called by widget event
     * @param args
     ************************************************************/
    this.documentsWidgetOnEnterTab = function(args){
        getWidgetProjectDocumentsTask().reload();
    };

    /************************************************************
     * Called by widget event
     * @param args
     ************************************************************/
    this.documentsWidgetAfterLoadDataSource = function(args){
        Utilities.markOffWidgetCheckedRows(args.owner);
    };

    /************************************************************
     * Called by action event
     * @param args
     ************************************************************/
    this.documentsActionEventDeleteDocuments = function(args){
        deleteAttachment(getWidgetProjectDocumentsTask());
    };

    /************************************************************
     * Called by action event
     * @param args
     ************************************************************/
    this.documentsProjectActionEventDeleteDocuments = function(args){
        deleteAttachment(getWidgetProjectDocumentsProject());
    };

    /************************************************************
     * Called when user tries to click on the status checkbox and
     * it is deactivated due the fact that projects which has
     * appropriated tasks can not be inactive.
     * @param field
     * @param message
     ************************************************************/
    var showMessageWhenClickOnDeactivatedStatusCheckbox = function(field, message){
        if(field.readOnly || field.readOnlyOnEdit){
            ScreenService.showMessages(message);
        }
    };

    /************************************************************
     * If project has appropriated tasks, we deactivate the
     * status checkbox because the project can not be inactive.
     *************************************************************/
    var deactivateStatusFieldIfHasAppropriatedTasks = function(){
        getFieldStatusFromBasicWidget().readOnly = checkIfProjectHasAppropriationsOrCanBeRemoved();
        getFieldStatusFromBasicWidget().readOnlyOnEdit = checkIfProjectHasAppropriationsOrCanBeRemoved();
    };

    /************************************************************
     * Check if project has tasks appropriated or, otherwise, it
     * can be removed.
     *************************************************************/
    var checkIfProjectHasAppropriationsOrCanBeRemoved = function(){
        var currentProjectHasAppropriatedTask = Utilities.localVar.getLocalVarClickedProjectHasAppropriatedTask();
        return currentProjectHasAppropriatedTask == 'Y';
    };

    /************************************************************
     * Hides percent field if task can not be concluded.
     ************************************************************/
    var hidePercentFieldWhenTaskEndNotAllowed = function(){
        var allowEndTasks = localStorageEngine.getLocalVar('clickedProjectAllowEndTasks');
        var field = getFieldPercentCompletedFromNewTaskWidget();
        Utilities.hidePercentFieldWhenTaskEndNotAllowed(allowEndTasks, field);
    };

    /**********************************************
     * Open issue tabbed widget.
     * @param widget
     *********************************************/
    var openTaskIssuesTabbedWidget = function(widget){
        var issueTabbedWidget = getIssueTabbedWidget();
        var issueMainWidget = getWidgetIssueMain();
        localStorageEngine.setLocalVar('issue', [widget.currentRow.ID]);
        ScreenService.openSwipe(issueTabbedWidget);
        ScreenService.showLoader();
        issueMainWidget.reload()
            .then(ScreenService.hideLoader).catch(ScreenService.hideLoader);
    };

    /************************************************************
     * Close that window which contains basic information about
     * an issue, such Attachments (Anexo) and Comments (Comentários),
     * located in Project (Projeto) > Tasks (Tarefas) > Issues.
     ************************************************************/
    var closeTaskIssueInformation = function(){
        var toBeActivated = getWidgetTaskIssues();
        Utilities.backToWidgetClosingSwipe(toBeActivated);
    };

    var closeSwipeAndBackToProjectTasks = function(){
        Utilities.backToWidgetClosingSwipe(getWidgetProjectTaskList());
    };

    var setVisibleTabbedProject = function (widgetTabbed) {
        widgetTabbed.widgets.forEach(function (widget) {
            widget.isVisible = !widget.PMNeverIsVisible;
        });
    };

    var setReadOnlyGantt = function () {
        var widgetBasic = getWidgetBasicProjectInformation();
        var enabled = widgetBasic.currentRow.USETIMEPLANNING == 'Y';
        var widgetGantt = getWidgetProjectGantt();
        widgetGantt.enabled = enabled;
        if(widgetGantt.parent.currentWidget.id == widgetGantt.id){
            widgetBasic.activate();
        }
    };
    var scaleGantt = function(widgetGantt,days){
        if(widgetGantt.parent.currentWidget.id == widgetGantt.id){
            var scale = 'year';
            if(days < 45){
                scale = 'day';
            }else if(days < 300) {
                scale = 'week';
            }else if(days < 1360) {
                scale = 'month';
            }else if(days < 4100) {
                scale = 'quarter';
            }
            var ganttChart = widgetGantt.getGanttChart();
            if(ganttChart){
                ganttChart.ganttTimeScale(scale).updateSeries();
            }
            widgetGantt.ganttTimeScale = scale;
        }
    };

    this.projectGanttWidgetAfterLoadDataSource = function(args){
        var widgetGantt = getWidgetProjectGantt();
        if(widgetGantt.dataSource.data && widgetGantt.dataSource.data[0]){
            var days = widgetGantt.dataSource.data[0].SCALE;
            Util.doAsync(scaleGantt.bind(self,widgetGantt,days));
        }
    };

    this.projectGanttActionEventChangeViewCompletedTasks = function(args){
        var widgetGantt = getWidgetProjectGantt();
        var action = getActionChangeViewCompletedTasksFromProjectGantt();
        widgetGantt.showCompletedTasksFilter = !widgetGantt.showCompletedTasks;
        widgetGantt.reload().then(function () {
            widgetGantt.showCompletedTasks = !widgetGantt.showCompletedTasks;
            action.label = widgetGantt.showCompletedTasks ? action.labelTaskCompleted : action.labelTaskNotCompleted;
        });
    };

    this.getViewCompletedTasks = function(){
        var showCompletedTasks = true;
        if(templateManager.container && getWidgetProjectGantt()){
            showCompletedTasks = getWidgetProjectGantt().showCompletedTasksFilter;
        }
        return showCompletedTasks;
    };

    this.projectGanttWidgetOnEnterTab = function(){
        getWidgetProjectGantt().reload();
    };
    /************************************************************
     * Opens a swipe containing informations about the clicked
     * task.
     * @param args
     ************************************************************/
    var projectOnListClicked = function(args, dontValidateProjectStatus) {
        var row = args.row;
        row.PROJECT_STATUS = isNaN(row.PROJECT_STATUS) ? row.PROJECT_STATUS_ID : row.PROJECT_STATUS;
        setLocalVarsForCategory(row.PROJECT_TYPE,row.PROJECT_STATUS);
        var widgetForm = getWidgetProjectTabbed();
        var widgetProjectInformation = getWidgetBasicProjectInformation();
        widgetProjectInformation.isBeingCreated = false;
        widgetProjectInformation.getField('DATE_EXCEPTION_NAME').dataSource.data = DATA_SET_EXCEPTION_NODE;
        widgetForm.showForm = true;
        widgetForm.formTemplate = "widget/tabbedWidget.html";

        if (!ScreenService.isWidgetAsSwipe(widgetForm)){
            ScreenService.openSwipe(widgetForm);
        }

        setVisibleTabbedProject(widgetForm);
        Utilities.localVar.setProject(args.row.ID);
        this.projectId = args.row.ID;
        var activeWidget = widgetForm.currentWidget ? widgetForm.currentWidget : widgetForm.widgets[0];

        Utilities.fixBugReloadWidgetInViewMode(widgetProjectInformation).then(function() {
            _setLabelRelease(getFieldReleaseIdFromProjectInformationWidget(),getFieldProductIdFromProjectInformationWidget());
            Utilities.localVar.setIsModel(widgetProjectInformation.currentRow.IS_MODEL);
        });

        if(activeWidget.name != widgetProjectInformation.name && activeWidget.name != getWidgetCalendar().name){
            activeWidget.reload();
        }
        if(!dontValidateProjectStatus) {
            validateEditProjectStatus(false, false);
        }

        // Reloads task list when change project
        getWidgetProjectTabbed().descriptionOrder = getProjectListManagerWidget().descriptionOrder;
    };

    var _setLabelRelease = function(fieldRelease,fieldProduct){
        if(fieldProduct.value()){
            fieldRelease.label = 'ID da Fix Release';
        }else{
            fieldRelease.label = 'ID da Release';
        }
    };

    var setProjectUsesMergeRequest = function(projectId){
        var row = {
            "PROJECT": projectId,
            "changed": true
        };
        requestDataSourceEngine.setDataSource('/isMergeRequestProject', [row]).then(function(data){
            var useMergeRequest = data.dataset.isMergeRequestProject[0];
            getActionGenerateTaskMergeFromProjectTaskList().isVisible = useMergeRequest != 'N';
        });
    };

    /************************************************************
     * Stores in LocalStorage a value that identifies if the last
     * clicked project allows or does not allow his tasks to be
     * ended.
     ************************************************************/
    var storesAllowEndTaskInLocalStorage = function(widget){
        localStorageEngine.setLocalVar('clickedProjectAllowEndTasks', widget.currentRow.ALLOWENDTASK);
    };

    /************************************************************
     * Stores in LocalStorage a value that identifies if the last
     * clicked project has or haven't time planning.
     ************************************************************/
    var storesUseTimePlanningInLocalStorage = function(widget){
        localStorageEngine.setLocalVar('clickedProjectUseTimePlanning', widget.currentRow.USETIMEPLANNING);
    };

    /************************************************************
     * Saves informations that are necessary into local storage
     * when user clicks on a project in the list.
     ************************************************************/
    var storesProjectHasAppropriatedTaskInLocalStorage = function(widget){
        Utilities.localVar.setLocalVarClickedProjectHasAppropriatedTask(widget.currentRow.HAS_APPROPRIATION);
    };

    /************************************************************
     * Saves informations that are necessary into local storage
     * when user clicks on a project in the list.
     * These informations contains things about, example, the
     * project has or does not have appropriated tasks, if the
     * project allows finish tasks, and more...
     ************************************************************/
    var saveLocalStorageInformationAfterMoveProjectRow = function(widget){
        storesAllowEndTaskInLocalStorage(widget);
        storesUseTimePlanningInLocalStorage(widget);
        storesProjectHasAppropriatedTaskInLocalStorage(widget);
        Utilities.localVar.setProjectName(widget.getField('NAME').value());
    };

    /************************************************************
     * Called by action event
     * @param args
     ************************************************************/
    this.moveTaskActionEventMoveTask = function(args){
        areThereDifferentResourcesInThatProject(
            args.owner.widget.currentRow.PROJECT, args.owner.widget.currentRow.TASK, args.owner.widget.currentRow.ID,
            args.owner.widget.parent, moveTask
        );
    };

    this.moveTaskActionEventCancel = function(args){
        ScreenService.closePopup(true);
        getWidgetProjectTasks().activate();
    };

    this.inlinetaskActionEventCancel = function(args){
        var widget = getWidgetProjectTasks();
        widget.reload();
        widget.list();
    };

    /************************************************************
     * Called by action event
     * @param args
     ************************************************************/
    this.copyTaskActionEventCopyTask = function(args){
        areThereDifferentResourcesInThatProject(args.owner.widget.currentRow.PROJECT, args.owner.widget.currentRow.TASK, null, args.owner.widget.parent, copyTask);
    };

    var setFieldGenerateWidgetTaskTest = function(widgetGenerate, widgetProject,checkedRows, estimatedTimeProportion) {

        widgetGenerate.dataSource.data = [];
        widgetGenerate.newRow();
        widgetGenerate.currentRow.changed = true;
        getFieldTypeRelationshipFromGenerateTaskWidget().dataSource.data = Messages.DATA_TYPE_RELATIONSHIP_TASK;
        getFieldProjectNameFromGenerateTaskWidget().setValue(widgetProject.currentRow.NAME);
        getFieldProjectFromGenerateTaskWidget().setValue(widgetProject.currentRow.ID);
        getFieldTaskNameFromGenerateTaskWidget().setValue([]);
        widgetGenerate.currentRow.TASK = '';
        var allTasks = [];
        var fields = widgetGenerate.fields;

        fields = self.pmGenerationTaskIdFilter(fields, []);

        fields.forEach(function(field){
            field.isVisible = !!field.isVisibleInGerMergeTask;
        });
        var projectId = Utilities.localVar.getProject();
        checkedRows.forEach(function(row){
            var timePlanned = 0;
            if(row.TIME_PLANNED){
                timePlanned = Utilities.secondsToDurationHour(Utilities.durationToSeconds(row.TIME_PLANNED)*estimatedTimeProportion);
            }
            setFieldsByTaskInMerge(allTasks, row, widgetGenerate, fields, widgetProject, timePlanned,projectId);

        });
        widgetGenerate.fields = self.pmGenerationTaskIdFilter(fields, allTasks);

        widgetGenerate.currentRow.DESCRIPTION = '';
        widgetGenerate.currentRow.VERSION_DEV = localStorageEngine.getLocalVar('projectVersionDev');
        widgetGenerate.currentRow.VERSION_DEV_ID = localStorageEngine.getLocalVar('projectVersionDevId');
        var typeRelationshipField = getFieldTypeRelationshipFromGenerateTaskWidget();
        typeRelationshipField.value('T');
        typeRelationshipField.readOnly = true;
        var nameField = getFieldNameFromGenerateTaskWidget();
        nameField.validations = false;
        var taskGeneratorNameField = getFieldTaskGeneratorNameFromGenerateTaskWidget();
        taskGeneratorNameField.setValue(allTasks);
        taskGeneratorNameField.validations = false;
        getFieldTaskGeneratorFromGenerateTaskWidget().setValue('');
        var urlToTestField = getFieldUrlToTestFromGenerateTaskWidget();
        urlToTestField.isVisible = true;
        urlToTestField.validations = {required: {}};
        urlToTestField.setValue('');
        widgetGenerate.getField('VERSION_DEV').isVisible = true;
    };

    this.pmGenerationTaskIdFilter = function(array,allTasks){
        return array.filter(function (field) {
            return !field.pmIsGeneration || Utilities.inArray(field.pmTaskId, allTasks);
        });
    };

    var setFieldsByTaskInMerge = function(allTasks, row, widgetGenerate, fields, widgetProject, timePlanned,projectId) {
        allTasks.push(row.ID);
        var resourceField = self.getTaskResourceField(row.ID, projectId, widgetGenerate);
        var taskNameField = self.getTaskNameField(row.ID, widgetGenerate);
        var taskProjectField = self.getTaskProjectField(row.ID, widgetGenerate);
        var parentName = self.getTaskParentNameField(row.ID, projectId, widgetGenerate);
        var fieldTimePlanned = self.getTaskTimePlannedField(row.ID, widgetGenerate);
        fields.push(taskProjectField);
        fields.push(taskNameField);
        fields.push(parentName);
        fields.push(resourceField);
        fields.push(fieldTimePlanned);
        taskNameField.value(row.NAME);

        if(row.PROJECT_NAME){
            taskProjectField.value(row.PROJECT_NAME);
        }else{
            taskProjectField.value(widgetProject.currentRow.NAME);
        }
        if(timePlanned){
            fieldTimePlanned.value(timePlanned);
        }

    };

    var setFieldGenerateWidgetTaskMerge = function(widgetGenerate, widgetProject, checkedRows, estimatedTimeProportion) {
        widgetGenerate.dataSource.data = [];
        widgetGenerate.newRow();
        widgetGenerate.currentRow.changed = true;
        getFieldTypeRelationshipFromGenerateTaskWidget().dataSource.data = Messages.DATA_TYPE_RELATIONSHIP_TASK;
        getFieldProjectNameFromGenerateTaskWidget().setValue(widgetProject.currentRow.NAME);
        getFieldProjectFromGenerateTaskWidget().setValue(widgetProject.currentRow.ID);
        getFieldTaskNameFromGenerateTaskWidget().setValue([]);
        widgetGenerate.currentRow.TASK = '';
        var allTasks = [];
        var fields = widgetGenerate.fields;

        fields = self.pmGenerationTaskIdFilter(fields, []);
        fields.forEach(function(field){
            field.isVisible = !!field.isVisibleInGerMergeTask;
        });
        var projectId = Utilities.localVar.getProject();
        checkedRows.forEach(function(row){
            var timePlanned = 0;
            if(row.TIME_PLANNED){
                timePlanned = Utilities.secondsToDurationHour(Utilities.durationToSeconds(row.TIME_PLANNED)*estimatedTimeProportion);
            }
            if(row.RELATED_TASKS && row.RELATED_TASKS.length){
                row.RELATED_TASKS.forEach(function(relatedTask){
                    setFieldsByTaskInMerge(allTasks, relatedTask, widgetGenerate, fields, widgetProject, timePlanned, relatedTask.PROJECT);
                });
            }else{
                setFieldsByTaskInMerge(allTasks, row, widgetGenerate, fields, widgetProject, timePlanned,projectId );
            }
        });
        widgetGenerate.fields = self.pmGenerationTaskIdFilter(fields, allTasks);

        widgetGenerate.currentRow.DESCRIPTION = '';
        var typeRelationshipField = getFieldTypeRelationshipFromGenerateTaskWidget();
        typeRelationshipField.value('M');
        typeRelationshipField.readOnly = true;
        var nameField = getFieldNameFromGenerateTaskWidget();
        nameField.validations = false;
        var taskGeneratorNameField = getFieldTaskGeneratorNameFromGenerateTaskWidget();
        taskGeneratorNameField.setValue(allTasks);
        taskGeneratorNameField.validations = false;
        getFieldTaskGeneratorFromGenerateTaskWidget().setValue('');
        widgetGenerate.currentRow.VERSION_DEV = localStorageEngine.getLocalVar('projectVersionDev');
        widgetGenerate.currentRow.VERSION_DEV_ID = localStorageEngine.getLocalVar('projectVersionDevId');
    };

    var showMessageNotGenerateTaskTest = function(validation) {
        var message = Messages.ALE_NOT_GENERATE_TEST_TASKS;
        var mergeRequestTasks = validation.mergeRequestTasks.join(', ');
        var replicationTasks = validation.replicationTasks.join(', ');
        var testTasks = validation.testTasks.join(', ');
        var notResourceTasks = validation.notResourceTasks.join(', ');
        var notConcluded = validation.notConcluded.join(', ');
        var genErrorTasks = validation.genErrorTasks.join(', ');

        if (mergeRequestTasks) {
            message += '<br/><br/><strong>Merge Request:</strong><br/>' + mergeRequestTasks + ';';
        }
        if (replicationTasks) {
            message += '<br/><br/><strong>Replicação de Código:</strong><br/>' + replicationTasks + ';';
        }
        if (testTasks) {
            message += '<br/><br/><strong>Teste:</strong><br/>' + testTasks + ';';
        }
        if (notResourceTasks) {
            message += '<br/><br/><strong>Tarefas sem recurso:</strong><br/>' + notResourceTasks + ';';
        }
        if (notConcluded) {
            message += '<br/><br/><strong>Tarefas não concluídas:</strong><br/>' + notConcluded + ';';
        }
        if (genErrorTasks) {
            message += '<br/><br/><strong>Tarefas que possuem tarefas de ERRO geradas:</strong><br/>' + genErrorTasks + ';';
        }

        ScreenService.showMessage(message);
    };

    function deleteRepositoryAndReloadData(widget) {
        var advancedInformationWidget = getWidgetAdvancedInformation();
        widget.remove().then(function () {
            ScreenService.closeSwipe();
            advancedInformationWidget.reload();
            advancedInformationWidget.activate();
        });
    }

    this.repositoryInformationActionEventDelete = function(args){
        var widget = getWidgetRepositoryInformation();
        ScreenService.confirmMessage(Utilities.messages.ALE_DELETE_ACCESS_REPOSITORY, 'question', function(){
            if(widget.currentRow.childProjects){
                ScreenService.confirmMessage(Utilities.messages.ALE_DELETE_ACCESS_CHILD_REPOSITORY, 'CONFIRMATION', function(){
                    widget.currentRow.PROJECT = Utilities.localVar.getProject();
                    deleteRepositoryAndReloadData(widget);
                }, function(){
                    deleteRepositoryAndReloadData(widget);
                });
            }else{
                deleteRepositoryAndReloadData(widget);
            }
        });
    };

    var compareVersionDev = function(rows){
        var versionDevId = rows[0].VERSION_DEV_ID;
        var sameVersionDevId = true;

        rows.forEach(function(row){
            if(row.VERSION_DEV_ID != versionDevId){
                sameVersionDevId = false;
            }
        });

        return sameVersionDevId;
    };

    this.projectTasksActionEventGenerateTaskTest = function(args){
        var widgetProjectTasks = getWidgetProjectTaskList();
        if(widgetProjectTasks.hasCheckedRows()) {
            var widgetGenerate = getWidgetGenerateTask();
            var widgetProject = getWidgetBasicProjectInformation();
            var checkedRows = widgetProjectTasks.getCheckedRows();
            var validation = validateGenerateTaskTest(checkedRows);
            var validateVersion = compareVersionDev(checkedRows);
            Utilities.localVar.setCalledGenerateTask('ACTION_CHECKED_ROWS');

            if(!validateVersion){
                ScreenService.showMessage(Utilities.messages.ALE_DIFFERENT_VERSIONS);
            } else{
                if (validation.isError) {
                    showMessageNotGenerateTaskTest(validation);
                } else {
                    var filterRequest = [{
                        "name": "CONTROL",
                        "value": ['T'],
                        "operator": "IN"
                    }];
                    localStorageEngine.setLocalVar('projectVersionDev', checkedRows[0].VERSION_DEV);
                    localStorageEngine.setLocalVar('projectVersionDevId', checkedRows[0].VERSION_DEV_ID);
                    localStorageEngine.setLocalVar('taskClassificationControl', 'T');
                    ScreenService.showLoader();
                    ProjectServiceList.getClassification(filterRequest).then(function (response) {
                        ScreenService.hideLoader();
                        var estimatedTimeProportion = 1;
                        response.dataset.classification.forEach(function (classification) {
                            estimatedTimeProportion = classification.ESTIMATED_TIME_PROPORTION ? classification.ESTIMATED_TIME_PROPORTION / 100 : 1;
                        });

                        setFieldGenerateWidgetTaskTest(widgetGenerate, widgetProject, checkedRows, estimatedTimeProportion);
                        ScreenService.openPopup(widgetGenerate);
                    }).catch(Utilities.showMessageBackEndTrue);
                }
            }
        } else {
            ScreenService.showMessage(Utilities.messages.NOT_CHECKED_ROW_TASK);
        }
    };

    this.projectTasksActionEventGenerateTaskMerge = function(args){
        var widgetProjectTasks = getWidgetProjectTaskList();
        if(widgetProjectTasks.hasCheckedRows()) {
            var checkedRows = widgetProjectTasks.getCheckedRows();
            var taskIds = [];
            var blockedTaskNames  = '';
            checkedRows.forEach(function (item) {
                taskIds.push(item.ID);
                if (item.TYPE_RELATIONSHIP || item.IS_PARENT == 'Y' ) {
                    blockedTaskNames = blockedTaskNames+'<br/>'+item.NAME;
                }
            });

            if (!blockedTaskNames.length) {
                ScreenService.showLoader();
                ProjectServiceList.findMergeRequestTasks(taskIds).then(function (response) {
                    var mergeRequestTasks = response.dataset.findMergeRequestByTask;
                    if (!mergeRequestTasks.length) {
                        var filterRequest = [{
                            "name": "CONTROL",
                            "value": ['M'],
                            "operator": "IN"
                        }];
                        ProjectServiceList.getClassification(filterRequest).then(function (response) {
                            var estimatedTimeProportion = 1;
                            var classificationId = '';
                             response.dataset.classification.forEach(function (classification) {
                                 estimatedTimeProportion = classification.ESTIMATED_TIME_PROPORTION ? classification.ESTIMATED_TIME_PROPORTION / 100 : 1;
                                 classificationId = classification.ID;
                            });
                            var widgetGenerate = getWidgetGenerateTask();
                            var widgetProject = getWidgetBasicProjectInformation();
                            Utilities.localVar.setCalledGenerateTask('ACTION_CHECKED_ROWS');
                            var allTaskIds = checkedRows.map(function(row){return row.ID;});
                            ProjectServiceList.setRelatedTasks(allTaskIds).then(function(relatedTasks) {
                                ScreenService.hideLoader();
                                checkedRows.forEach(function(task){
                                   relatedTasks.some(function(relatedTask){
                                       if(relatedTask.TASK == task.ID){
                                           task.RELATED_TASKS = relatedTask.RELATED_TASKS;
                                       }
                                   });
                                });
                                getFieldResourceFromGenerateTaskWidget().reload();
                                getFieldTaskNameFromGenerateTaskWidget().reload();
                                setFieldGenerateWidgetTaskMerge(widgetGenerate, widgetProject, checkedRows, estimatedTimeProportion);
                                widgetGenerate.currentRow.CLASSIFICATION_ID = classificationId;
                                ScreenService.openPopup(widgetGenerate);
                            }).catch(Utilities.showMessageBackEndTrue);
                        }).catch(Utilities.showMessageBackEndTrue);
                    } else {
                        ScreenService.hideLoader();
                        mergeRequestTasks.forEach(function(item){
                            blockedTaskNames = blockedTaskNames+'<br/>'+item.NAME;

                        });
                        ScreenService.showMessage(Utilities.messages.ALE_NOT_GENERATE_MERGE_HAS_MERGE+blockedTaskNames);
                    }
                }).catch(Utilities.showMessageBackEndTrue);
            } else {
                ScreenService.showMessage(Utilities.messages.ALE_NOT_GENERATE_MERGE+blockedTaskNames);
            }
        }
    };

    var validateGenerateTaskTest = function(tasks) {
        var taskErrors = {
            mergeRequestTasks: [],
            replicationTasks : [],
            testTasks        : [],
            notResourceTasks : [],
            notConcluded     : [],
            genErrorTasks    : [],
            isError          : false
        };

        tasks.forEach(function(task) {
            if(task.TYPE_RELATIONSHIP === 'M') {
                taskErrors.mergeRequestTasks.push('"' + task.NAME + '"');
                taskErrors.isError = true;
            } else if(task.TYPE_RELATIONSHIP === 'R') {
                taskErrors.replicationTasks.push('"' + task.NAME + '"');
                taskErrors.isError = true;
            } else if(task.TYPE_RELATIONSHIP === 'T') {
                taskErrors.testTasks.push('"' + task.NAME + '"');
                taskErrors.isError = true;
            } else if(task.RESOURCES[0] === '') {
                taskErrors.notResourceTasks.push('"' + task.NAME + '"');
                taskErrors.isError = true;
            } else if(task.TASK_STATUS !== getLocalVar('taskParameters').CONCLUDED_TASK_STATUS_ID) {
                taskErrors.notConcluded.push('"' + task.NAME + '"');
                taskErrors.isError = true;
            } else if(task.GENERATED_TASKS_ERROR > 0) {
                taskErrors.genErrorTasks.push('"' + task.NAME + '"');
                taskErrors.isError = true;
            }
        });

        return taskErrors;
    };

    this.generateTaskFieldOnChangeTypeRelationship = function(args) {
        var widgetGenerate = getWidgetGenerateTask();
        var widgetNewTask  = getWidgetBasicTaskInformation();
        var typeRelationship = widgetGenerate.currentRow.TYPE_RELATIONSHIP;
        var numberTasksErro  = widgetNewTask.currentRow.GENERATED_TASKS_ERROR;

        if(typeRelationship === 'T') {
            if(numberTasksErro > 0) {
                widgetGenerate.currentRow.TYPE_RELATIONSHIP = '';
                ScreenService.showMessage(Messages.ALE_NOT_GEN_TEST_BEC_ERROR_TASK);
            } else {
                widgetGenerate.getField('URL_TO_TEST').isVisible = true;
                widgetGenerate.getField('URL_TO_TEST').validations = { required: {} };
            }
            widgetGenerate.currentRow.RESOURCE = [];
            localStorageEngine.setLocalVar('taskClassificationControl', 'T');
            getFieldResourceFromGenerateTaskWidget().reload();
        } else {
            widgetGenerate.getField('URL_TO_TEST').isVisible = false;
            widgetGenerate.getField('URL_TO_TEST').validations = false;
            localStorageEngine.setLocalVar('taskClassificationControl', null);
            getFieldResourceFromGenerateTaskWidget().reload();
        }
        var filterRequest = [
            {
                "name": "CONTROL",
                "value": [typeRelationship],
                "operator": "IN"
            }
        ];
        ProjectServiceList.getClassification(filterRequest).then(function (response) {
            var widgetGenerate = getWidgetGenerateTask();
            response.dataset.classification.some(function (classification) {
                widgetGenerate.currentRow.ESTIMATED_TIME_PROPORTION = classification.ESTIMATED_TIME_PROPORTION ? classification.ESTIMATED_TIME_PROPORTION / 100 : 1;
                return true;
            });
            var resourceField = getFieldResourceFromNewTaskWidget();
            var durationField = getFieldDurationFromGenerateTaskWidget();
            var resourcesIds = getFieldResourceFromGenerateTaskWidget().value();
            var timePlannedSeg = widgetGenerate.currentRow.GENE_TASK_TOTAL_TIME;
            if(widgetGenerate.currentRow. ESTIMATED_TIME_PROPORTION){
                timePlannedSeg = timePlannedSeg*widgetGenerate.currentRow.ESTIMATED_TIME_PROPORTION;
            }
            var timePlanned = Utilities.secondsToDurationHour(timePlannedSeg);

            calcDurationByTimePlanned(null, timePlanned, resourcesIds, resourceField, timePlannedSeg,
                durationField,true);

        });


    };


    //calendar do projeto
    var getWidgetBasicCalendar = function () {
        return templateManager.container.getWidget('BASIC_CALENDAR');
    };
    var getFieldBaseCalendarFromWidgetBasicCalendar = function () {
        return getWidgetBasicCalendar().getField('BASE_CALENDAR');
    };

    this.saveCalendar = function (widgetBasicCalendar) {
        widgetBasicCalendar.currentRow.STRUCTURE = Utilities.localVar.getStructureId();
        ScreenService.showCustomDialog(Utilities.messages.ALE_IS_APPLY_CALENDAR_CHILDREN_PROJECT, 'CONFIRMATION', null,
            [
                {
                    "label": "Sim",
                    "code": function () {
                        widgetBasicCalendar.currentRow.IS_APPLY_CHILDREN_PROJECT = true;
                        return widgetBasicCalendar.saveRow().then(function(){
                            return getWidgetBasicCalendar().reload();
                        });
                    }
                },
                {
                    "label": "Não",
                    "code": function () {
                        widgetBasicCalendar.currentRow.IS_APPLY_CHILDREN_PROJECT = false;
                        return widgetBasicCalendar.saveRow().then(function(){
                            return getWidgetBasicCalendar().reload();
                        });
                    }
                }
            ]
        );

    };
    this.basicCalendarWidgetAfterLoadDataSource = function (args) {
        var widget = args.owner;
        if (widget.dataSource.data.length) {
            widget.currentRow = widget.dataSource.data[0];
        } else {
            widget.newRow();
            widget.list();
        }
        Utilities.localVar.setCalendarId(widget.currentRow.ID);
        var baseCalendarField = getFieldBaseCalendarFromWidgetBasicCalendar();
        baseCalendarField.reload().then(function () {
            Utilities.setAllFieldsSelectByValueInCurrentRow(widget);
        });
        widget.widgets.forEach(function (childWidget) {
            childWidget.list();
            childWidget.reload();
        });
    };

    this.basicCalendarWidgetOnEnter = function(){
        getWidgetBasicCalendar().reload();
    };

    var calendarListOnChangeBaseCalendar = function (args) {
        var calendarBaseName = args.row.BASE_CALENDAR;
        var widgetBasicCalendar = getWidgetBasicCalendar();
        var message = '';
        if (calendarBaseName) {
            message = 'Deseja salvar o calendário "' + calendarBaseName + '" como a base para este projeto?';
        } else {
            message = 'Deseja excluir o calendário desse projeto?';
        }
        ScreenService.showCustomDialog(message, 'CONFIRMATION', null,
            [
                {
                    "label": "Continuar",
                    "code": function () {
                        self.saveCalendar(widgetBasicCalendar);
                    }
                },
                {
                    "label": "Cancelar",
                    "code": function () {
                        getWidgetBasicCalendar().reload();
                    }
                }
            ]
        );
    };
    this.calendarListOnChangeBaseCalendar = function (args) {
        calendarListOnChangeBaseCalendar(args);
    };

    this.calendarActionEventCancel = function (args) {
        this.goBackProjectList();
    };
    this.exceptionListActionEventCancel = function (args) {
        this.goBackProjectList();
    };
    this.hourWeekListActionEventCancel = function (args) {
        this.goBackProjectList();
    };

    var getWidgetCalendar = function () {
        return templateManager.container.getWidget('CALENDAR');
    };

    var getWidgetBasicInformationResource = function () {
        return templateManager.container.getWidget('BASIC_INFORMATION_RESOURCE');
    };

    var getWidgetCalendarList = function () {
        return templateManager.container.getWidget('CALENDAR_LIST');
    };

    var getWidgetExceptionList = function () {
        return templateManager.container.getWidget('EXCEPTION_LIST');
    };
    var getWidgetNewException = function () {
        return templateManager.container.getWidget('NEW_EXCEPTION');
    };
    var getWidgetTabbedException = function () {
        return templateManager.container.getWidget('TABBED_EXCEPTION');
    };
    var getWidgetHourWeekList = function () {
        return templateManager.container.getWidget('HOUR_WEEK_LIST');
    };
    var getWidgetHourWeekTabbed = function () {
        return templateManager.container.getWidget('HOUR_WEEK_TABBED');
    };
    var getWidgetNewHourWeek = function () {
        return templateManager.container.getWidget('NEW_HOUR_WEEK');
    };

    this.newHourWeekActionEventCancelForm = function (args) {
        CalendarService.newHourWeekActionEventCancelForm(getWidgetNewHourWeek(),getWidgetHourWeekList());
    };

    this.issueResponsesWidgetAfterMoveRow = function () {
        var issuesResponsesWidget = ProjectIssuesResponse();
        localStorageEngine.setLocalVar('ISSUE_ID_RESPONSE', issuesResponsesWidget.currentRow.ID);
        issuesResponsesWidget.backupData = Util.clone(issuesResponsesWidget.dataSource.data);
            ScreenService.openPopup(getWidgetResponseEdit());
    };

     this.responseEditWidgetOnEnter = function () {
        var responseEditWidget = getWidgetResponseEdit();
        var issuesResponsesWidget = ProjectIssuesResponse();
        var viewResponsesField = getWidgetViewResponses();
        var nameField = getNameFieldFromResponseEdit();
        responseEditWidget.currentRow = issuesResponsesWidget.currentRow;
    };

    this.newHourWeekActionEventSave = function (args) {
        var widgetNewHourWeek = getWidgetNewHourWeek();
        var widgetHourWeekList = getWidgetHourWeekList();

        var newHourWeekSave = function(widgetNewHourWeek, widgetHourWeekList){
            CalendarService.newHourWeekActionEventSave(widgetNewHourWeek, widgetHourWeekList);
        };

        widgetNewHourWeek.currentRow.PROJECT_ID = localStorageEngine.getLocalVar('projectId');

        if(!widgetNewHourWeek.currentRow.ID){
            ScreenService.showCustomDialog(Utilities.messages.ALE_SAVE_WORKWEEK_CHILDREN_PROJECT, 'CONFIRMATION', null,
                [
                    {
                        "label": "Sim",
                        "code": function () {
                            widgetNewHourWeek.currentRow.IS_APPLY_CHILDREN_PROJECT = true;
                            newHourWeekSave(widgetNewHourWeek, widgetHourWeekList);
                        }
                    },
                    {
                        "label": "Não",
                        "code": function () {
                            widgetNewHourWeek.currentRow.IS_APPLY_CHILDREN_PROJECT = false;
                            newHourWeekSave(widgetNewHourWeek, widgetHourWeekList);
                        }
                    }
                ]
            );
        } else {
            newHourWeekSave(widgetNewHourWeek, widgetHourWeekList);
        }

    };

    this.hourWeekListWidgetAfterMoveRow = function (args) {
        CalendarService.hourWeekListWidgetAfterMoveRow(args.row,getWidgetHourWeekTabbed(),getWidgetNewHourWeek());
    };
    this.hourWeekListActionEventDelete = function (args) {
        ScreenService.confirmMessage(Utilities.messages.ALO_DELETE_HOUR_WEEK, null, self.hourWeekListDelete).then(function(){
            getWidgetHourWeekList().activate();
        });
    };
    this.hourWeekListDelete = function(){
        CalendarService.exceptionListActionEventDelete(getWidgetHourWeekList());
    };
    this.hourWeekListActionEventNew = function (args) {
        if(Utilities.localVar.getCalendarId()){
            CalendarService.hourWeekListActionEventNew(getWidgetHourWeekTabbed(),getWidgetNewHourWeek());
        }else{
            var message = Utilities.messages.ALO_IS_NOT_POSSIBLE_ADD_HOUR_WEEK_PART_1+'projeto'+
                Utilities.messages.ALO_IS_NOT_POSSIBLE_ADD_HOUR_WEEK_PART_2;
            ScreenService.showMessage(message);
        }
    };
    this.exceptionListFieldOnChangeWeekDayExceptionMonth = function (args) {
        CalendarService.exceptionListFieldOnChangeWeekDayExceptionMonth(args.owner.field,getWidgetNewException());
    };
    this.exceptionListFieldOnChangeWeekDayExceptionYear = function (args) {
        CalendarService.exceptionListFieldOnChangeWeekDayExceptionYear(args.owner.field,getWidgetNewException());
    };
    this.exceptionListFieldOnChangeYearDayExceptionMonth = function (args) {
        CalendarService.exceptionListFieldOnChangeYearDayExceptionMonth(args.owner.field,getWidgetNewException());
    };
    this.exceptionListFieldOnChangeYearDayExceptionYear = function (args) {
        CalendarService.exceptionListFieldOnChangeYearDayExceptionYear(args.owner.field,getWidgetNewException());
    };
    this.exceptionListFieldOnChangeRecurrenceType = function (args) {
        CalendarService.exceptionListFieldOnChangeRecurrenceType(Utilities.getFieldByArgs(args),getWidgetNewException());
    };
    this.exceptionListFieldOnChangeExceptionDataEnd = function (args) {
        CalendarService.exceptionListFieldOnChangeExceptionDataEnd(getWidgetNewException());
    };
    this.exceptionListFieldOnChangeExceptionQuantitative = function (args) {
        CalendarService.exceptionListFieldOnChangeExceptionQuantitative(getWidgetNewException());
    };
    this.exceptionListFieldOnChangeType = function (args) {
        CalendarService.exceptionListFieldOnChangeType(getFieldTypeFromNewException().value(), getWidgetNewException());
    };
    this.exceptionListResourceFieldOnChangeType = function (args) {
        CalendarService.exceptionListFieldOnChangeType(getFieldTypeFromNewExceptionResource().value(), getWidgetNewExceptionResource());
    };
    this.newExceptionActionEventEdit = function (args) {
        CalendarService.newExceptionActionEventEdit(getWidgetNewException());
    };

    this.newExceptionActionEventCancelForm = function (args) {
        CalendarService.newExceptionActionEventCancelForm(getWidgetExceptionList());
    };

    this.newExceptionActionEventSave = function (args) {
        var widgetNewException = getWidgetNewException();
        var widgetExceptionList = getWidgetExceptionList();

        var newExceptionSave = function(widgetNewException, widgetExceptionList){
            CalendarService.newExceptionActionEventSave(widgetNewException, widgetExceptionList);
        };

        widgetNewException.currentRow.PROJECT_ID = localStorageEngine.getLocalVar('projectId');

        if(!widgetNewException.currentRow.ID){
            ScreenService.showCustomDialog(Utilities.messages.ALE_SAVE_EXCEPTION_CHILDREN_PROJECT, 'CONFIRMATION', null,
                [
                    {
                        "label": "Sim",
                        "code": function () {
                            widgetNewException.currentRow.IS_APPLY_CHILDREN_PROJECT = true;
                            newExceptionSave(widgetNewException, widgetExceptionList);
                        }
                    },
                    {
                        "label": "Não",
                        "code": function () {
                            widgetNewException.currentRow.IS_APPLY_CHILDREN_PROJECT = false;
                            newExceptionSave(widgetNewException, widgetExceptionList);
                        }
                    }
                ]
            );
        } else {
            newExceptionSave(widgetNewException, widgetExceptionList);
        }
    };

    this.exceptionListWidgetAfterMoveRow = function (args) {
        CalendarService.exceptionListWidgetAfterMoveRow(args.row.ID,getWidgetTabbedException(),getWidgetNewException());
    };
    this.exceptionListActionEventDelete = function (args) {
        ScreenService.confirmMessage(Utilities.messages.ALO_DELETE_EXCEPTION,null, self.exceptionListDelete).then(function(){
            getWidgetExceptionList().activate();
        });
    };
    this.exceptionListDelete = function(){
        CalendarService.exceptionListActionEventDelete(getWidgetExceptionList());
    };
    this.exceptionListActionEventNew = function (args) {
        if(Utilities.localVar.getCalendarId()){
            CalendarService.exceptionListActionEventNew(getWidgetTabbedException(),getWidgetNewException());
        }else{
            var message = Utilities.messages.ALO_IS_NOT_POSSIBLE_ADD_EXCEPTION_PART_1+'projeto'+
                Utilities.messages.ALO_IS_NOT_POSSIBLE_ADD_EXCEPTION_PART_2;
            ScreenService.showMessage(message);
        }
    };
    this.calendarWidgetAfterLoadDataSource = function (args) {
        CalendarService.calendarWidgetAfterLoadDataSource(getWidgetCalendar());
    };
    this.newHourWeekFieldOnChangeTypeSunday = function (args) {
        var field = Utilities.getFieldByArgs(args);
        CalendarService.setFieldWorkTimeByTypeField(field);
    };

    this.newHourWeekFieldOnChangeTypeMonday = function (args) {
        var field = Utilities.getFieldByArgs(args);
        CalendarService.setFieldWorkTimeByTypeField(field);
    };

    this.newHourWeekFieldOnChangeTypeThuesday = function (args) {
        var field = Utilities.getFieldByArgs(args);
        CalendarService.setFieldWorkTimeByTypeField(field);
    };

    this.newHourWeekFieldOnChangeTypeWednesday = function (args) {
        var field = Utilities.getFieldByArgs(args);
        CalendarService.setFieldWorkTimeByTypeField(field);
    };

    this.newHourWeekFieldOnChangeTypeThursday = function (args) {
        var field = Utilities.getFieldByArgs(args);
        CalendarService.setFieldWorkTimeByTypeField(field);
    };

    this.newHourWeekFieldOnChangeTypeFriday = function (args) {
        var field = Utilities.getFieldByArgs(args);
        CalendarService.setFieldWorkTimeByTypeField(field);
    };

    this.newHourWeekFieldOnChangeTypeSaturday = function (args) {
        var field = Utilities.getFieldByArgs(args);
        CalendarService.setFieldWorkTimeByTypeField(field);
    };

    this.newHourWeekActionEventEdit = function (args) {
        CalendarService.newHourWeekActionEventEdit(getWidgetNewHourWeek());
    };
    this.calendarWidgetAfterMoveRow = function (args) {
        var dataPM = args.owner.dataSource.dataPM;
        var rowMove = args.row;
        CalendarService.calendarWidgetAfterMoveRow(dataPM,rowMove);
    };
    //end calendar do recurso

    var getWidgetProjectResourceTabbed = function() {
        return templateManager.container.getWidget('PROJECT_RESOURCE_TABBED');
    };

    this.resourceListWidgetAfterMoveRow = function(args){
        Utilities.localVar.setProjectResource(args.row.ID_BASE);
        Utilities.localVar.setProjectResourceId(args.row.ID);
        getWidgetBasicCalendarResource().reload();

        ScreenService.showLoader();
        getWidgetBasicInformationResource().reload()
            .then(ScreenService.hideLoader).catch(ScreenService.hideLoader);

        getWidgetProjectResourceTabbed().descriptionOrder = getWidgetProjectResourceList().descriptionOrder;
        ScreenService.openSwipe(getWidgetProjectResourceTabbed());
    };

    //calendar do projeto
    var getWidgetBasicCalendarResource = function () {
        return templateManager.container.getWidget('BASIC_CALENDAR_RESOURCE');
    };
    var getFieldBaseCalendarFromWidgetBasicCalendarResource = function () {
        return getWidgetBasicCalendar().getField('BASE_CALENDAR');
    };

    this.saveCalendarResource = function (widgetBasicCalendar) {
        widgetBasicCalendar.currentRow.STRUCTURE = Utilities.localVar.getStructureId();
        widgetBasicCalendar.saveRow().then(function(){
            getWidgetBasicCalendar().reload();
        });
    };
    this.basicCalendarResourceWidgetAfterLoadDataSource = function (args) {
        var widget = args.owner;
        if (widget.dataSource.data.length) {
            widget.currentRow = widget.dataSource.data[0];
        } else {
            widget.newRow();
            widget.list();
        }
        Utilities.localVar.setCalendarId(widget.currentRow.ID);
        var baseCalendarField = getFieldBaseCalendarFromWidgetBasicCalendarResource();
        baseCalendarField.reload().then(function () {
            Utilities.setAllFieldsSelectByValueInCurrentRow(widget);
        });
        widget.widgets.forEach(function (childWidget) {
            childWidget.reload();
        });
    };

    var saveCalendarResourceProject = function (args) {
        var calendarBaseName = args.row.BASE_CALENDAR;
        var widgetBasicCalendar = getWidgetBasicCalendarResource();
        var message = '';
        if (calendarBaseName) {
            message = 'Deseja salvar o calendário "' + calendarBaseName + '" como a base para este recurso nesse projeto?';
        } else {
            message = 'Deseja excluir o calendário desse recurso nesse projeto?';
        }
        ScreenService.showCustomDialog(message, 'CONFIRMATION', null,
            [
                {
                    "label": "Continuar",
                    "code": function () {
                        self.saveCalendar(widgetBasicCalendar).then(function(){
                            widgetBasicCalendar.reload();
                        });
                    }
                },
                {
                    "label": "Cancelar",
                    "code": function () {
                        widgetBasicCalendar.reload();
                    }
                }
            ]
        );
    };
    this.calendarListResourceOnChangeBaseCalendar = function (args) {
        saveCalendarResourceProject(args);
    };

    var __goBackSwipeLevel1Resource = function () {
        ScreenService.closeSwipe();
        getWidgetProjectTabbed().currentWidget.activate();
    };
    this.calendarResourceActionEventCancel = function (args) {
        __goBackSwipeLevel1Resource();
    };
    this.exceptionListResourceActionEventCancel = function (args) {
        __goBackSwipeLevel1Resource();
    };
    this.hourWeekListResourceActionEventCancel = function (args) {
        __goBackSwipeLevel1Resource();
    };

    var getWidgetCalendarResource = function () {
        return templateManager.container.getWidget('CALENDAR_RESOURCE');
    };

    var getWidgetExceptionListResource = function () {
        return templateManager.container.getWidget('EXCEPTION_LIST_RESOURCE');
    };
    var getWidgetNewExceptionResource = function () {
        return templateManager.container.getWidget('NEW_EXCEPTION_RESOURCE');
    };
    var getWidgetTabbedExceptionResource = function () {
        return templateManager.container.getWidget('TABBED_EXCEPTION_RESOURCE');
    };
    var getWidgetHourWeekListResource = function () {
        return templateManager.container.getWidget('HOUR_WEEK_LIST_RESOURCE');
    };
    var getWidgetHourWeekTabbedResource = function () {
        return templateManager.container.getWidget('HOUR_WEEK_TABBED_RESOURCE');
    };
    var getWidgetNewHourWeekResource = function () {
        return templateManager.container.getWidget('NEW_HOUR_WEEK_RESOURCE');
    };

    this.newHourWeekResourceActionEventCancelForm = function (args) {
        CalendarService.newHourWeekActionEventCancelForm(getWidgetNewHourWeekResource(),getWidgetHourWeekListResource());
    };

    this.newHourWeekActionEventCancel = function (args) {
        var newHourWeekWidget = getWidgetNewHourWeek();
        Utilities.genericCancelEvent(newHourWeekWidget);
        if(newHourWeekWidget.currentRow.__is_new){
            getWidgetHourWeekList().activate();
        }else {
            newHourWeekWidget.template = newHourWeekWidget.templateToView;
        }
    };

    var saveHourWeekResource = function(args){
        CalendarService.newHourWeekActionEventSave(getWidgetNewHourWeekResource(),getWidgetHourWeekListResource());
    };

    this.calendarWidgetOnEnter = function(args){
        getWidgetCalendar().reload();
    };

    this.newHourWeekResourceActionEventSave = function (args) {
        saveHourWeekResource(args);
    };

    this.hourWeekListResourceWidgetAfterMoveRow = function (args) {
        CalendarService.hourWeekListWidgetAfterMoveRow(args.row,getWidgetHourWeekTabbedResource(),getWidgetNewHourWeekResource());
    };
    this.hourWeekListResourceActionEventDelete = function (args) {
        ScreenService.confirmMessage(Utilities.messages.ALO_DELETE_HOUR_WEEK, null, self.hourWeekListDeleteResource);
    };
    this.hourWeekListDeleteResource = function(){
        CalendarService.hourWeekListActionEventDelete(getWidgetHourWeekListResource());
    };
    this.hourWeekListResourceActionEventNew = function (args) {
        if(Utilities.localVar.getCalendarId()){
            CalendarService.hourWeekListActionEventNew(getWidgetHourWeekTabbedResource(),getWidgetNewHourWeekResource());
        }else{
            var message = Utilities.messages.ALO_IS_NOT_POSSIBLE_ADD_HOUR_WEEK_PART_1+'recurso no projeto'+
                Utilities.messages.ALO_IS_NOT_POSSIBLE_ADD_HOUR_WEEK_PART_2;
            ScreenService.showMessage(message);
        }
    };
    this.exceptionListResourceFieldOnChangeWeekDayExceptionMonth = function (args) {
        CalendarService.exceptionListFieldOnChangeWeekDayExceptionMonth(args.owner.field,getWidgetNewException());
    };
    this.exceptionListResourceFieldOnChangeWeekDayExceptionYear = function (args) {
        CalendarService.exceptionListFieldOnChangeWeekDayExceptionYear(args.owner.field,getWidgetNewException());
    };
    this.exceptionListResourceFieldOnChangeYearDayExceptionMonth = function (args) {
        CalendarService.exceptionListFieldOnChangeYearDayExceptionMonth(args.owner.field,getWidgetNewException());
    };
    this.exceptionListResourceFieldOnChangeYearDayExceptionYear = function (args) {
        CalendarService.exceptionListFieldOnChangeYearDayExceptionYear(args.owner.field,getWidgetNewException());
    };
    this.exceptionListResourceFieldOnChangeRecurrenceType = function (args) {
        CalendarService.exceptionListFieldOnChangeRecurrenceType(Utilities.getFieldByArgs(args),getWidgetNewExceptionResource());
    };
    this.exceptionListResourceFieldOnChangeExceptionDataEnd = function (args) {
        CalendarService.exceptionListFieldOnChangeExceptionDataEnd(getWidgetNewException());
    };
    this.exceptionListResourceFieldOnChangeExceptionQuantitative = function (args) {
        CalendarService.exceptionListFieldOnChangeExceptionQuantitative(getWidgetNewExceptionResource());
    };
    this.newExceptionResourceActionEventEdit = function (args) {
        CalendarService.newExceptionActionEventEdit(getWidgetNewExceptionResource());
    };
    this.newExceptionResourceActionEventCancelForm = function (args) {
        CalendarService.newExceptionActionEventCancelForm(getWidgetExceptionListResource());
    };

    this.newExceptionActionEventCancel = function (args) {
        CalendarService.newExceptionActionEventCancel(getWidgetNewException(), getWidgetExceptionList());
    };

    var saveExceptionResource = function(){
        CalendarService.newExceptionActionEventSave(getWidgetNewExceptionResource(),getWidgetExceptionListResource());
    };

    this.newExceptionResourceActionEventSave = function (args) {
        saveExceptionResource(args);
    };

    this.projectTaskWidgetOnEnterTab = function(args){
        self.setButtons(args);
        var widget = getWidgetProjectTasks();
        widget.list();
        widget.template = "/widget/tree/grid.html";
        widget.reload();
        getFieldResourcesFromProjectTasksWidget().reload();
    };

    this.exceptionListResourceWidgetAfterMoveRow = function (args) {
        CalendarService.exceptionListWidgetAfterMoveRow(args.row.ID,getWidgetTabbedExceptionResource(),getWidgetNewExceptionResource());
    };

    this.exceptionListWidgetOnEnterTab = function (args) {
        getWidgetExceptionList().reload();
    };

    this.exceptionListResourceActionEventDelete = function (args) {
        ScreenService.confirmMessage(Utilities.messages.ALO_DELETE_EXCEPTION, null, self.exceptionListResourceDelete) ;
    };

    this.exceptionListResourceDelete = function(){
        CalendarService.exceptionListActionEventDelete(getWidgetExceptionListResource());
        getWidgetExceptionList().activate();
    };

    this.exceptionListResourceActionEventNew = function (args) {
        if(Utilities.localVar.getCalendarId()){
            CalendarService.exceptionListActionEventNew(getWidgetTabbedExceptionResource(),getWidgetNewExceptionResource());
        }else{
            var message = Utilities.messages.ALO_IS_NOT_POSSIBLE_ADD_EXCEPTION_PART_1+'recurso no projeto'+
                Utilities.messages.ALO_IS_NOT_POSSIBLE_ADD_EXCEPTION_PART_2;
            ScreenService.showMessage(message);
        }
    };

    this.calendarResourceWidgetAfterLoadDataSource = function (args) {
        CalendarService.calendarWidgetAfterLoadDataSource(getWidgetCalendarResource());
    };

    this.newHourWeekResourceFieldOnChangeTypeSunday = function (args) {
        var field = Utilities.getFieldByArgs(args);
        CalendarService.setFieldWorkTimeByTypeField(field);
    };

    this.newHourWeekResourceFieldOnChangeTypeMonday = function (args) {
        var field = Utilities.getFieldByArgs(args);
        CalendarService.setFieldWorkTimeByTypeField(field);
    };

    this.newHourWeekResourceFieldOnChangeTypeThuesday = function (args) {
        var field = Utilities.getFieldByArgs(args);
        CalendarService.setFieldWorkTimeByTypeField(field);
    };

    this.newHourWeekResourceFieldOnChangeTypeWednesday = function (args) {
        var field = Utilities.getFieldByArgs(args);
        CalendarService.setFieldWorkTimeByTypeField(field);
    };

    this.newHourWeekResourceFieldOnChangeTypeThursday = function (args) {
        var field = Utilities.getFieldByArgs(args);
        CalendarService.setFieldWorkTimeByTypeField(field);
    };

    this.newHourWeekResourceFieldOnChangeTypeFriday = function (args) {
        var field = Utilities.getFieldByArgs(args);
        CalendarService.setFieldWorkTimeByTypeField(field);
    };

    this.newHourWeekResourceFieldOnChangeTypeSaturday = function (args) {
        var field = Utilities.getFieldByArgs(args);
        CalendarService.setFieldWorkTimeByTypeField(field);
    };

    this.newHourWeekResourceActionEventEdit = function (args) {
        CalendarService.newHourWeekActionEventEdit(getWidgetNewHourWeekResource());
    };
    this.calendarResourceWidgetAfterMoveRow = function (args) {
        var dataPM = args.owner.dataSource.dataPM;
        var rowMove = args.row;
        CalendarService.calendarWidgetAfterMoveRow(dataPM,rowMove);
    };
    //end calendar do recurso

    /************************************************************
     * Called by action event
     * @param args
     ************************************************************/
    this.taskIssuesDescriptionActionEventBack = function(args){
        closeTaskIssueInformation();
    };

    /************************************************************
     * Called by action event
     * @param args
     ************************************************************/
    this.taskIssuesActionEventBack = function(args){
        closeSwipeAndBackToProjectTasks();
    };

    /************************************************************
     * Called by action event
     * @param args
     ************************************************************/
    this.generatedTasksActionEventBack = function(args){
        closeSwipeAndBackToProjectTasks();
    };

    /************************************************************
     * Called by action event
     * @param args
     ************************************************************/
    this.documentsActionEventBack = function(args){
        closeSwipeAndBackToProjectTasks();
    };

    this.documentsActionEventBackView = function(args){
        ScreenService.closeSwipe();
    };

    var validateEditProjectStatus = function(status, isRestricted, externalType) {
        var currentRow = getProjectListManagerWidget().currentRow;
        var projectStatus = getFieldProjectStatusFromBasicWidget();
        var subReleaseId = getFieldSubReleaseIdFromProjectInformationWidget().value();
        var releaseId = getFieldReleaseIdFromProjectInformationWidget().value();
        var productId = getFieldProductIdFromProjectInformationWidget().value();

        if (subReleaseId || releaseId || productId || isRestricted || externalType == 'E' || currentRow.PROJECT_STATUS_CONTROL === 'N') {
            if (isRestricted || externalType == 'E' || currentRow.PROJECT_STATUS_CONTROL === 'N'){
                Utilities.localVar.setProjectStatusControl([PROJECT_STATUS_CANCELED]);
                projectStatus.dataSourceFilter = projectStatus.dataSourceFilter.map(function(filter){
                    if(filter.pmChangeable){
                        filter.operator = 'IN';
                    }
                    return filter;
                });
            }else{
                Utilities.localVar.setProjectStatusControl([PROJECT_STATUS_CONCLUDED]);
                projectStatus.dataSourceFilter = projectStatus.dataSourceFilter.map(function(filter){
                    if(filter.pmChangeable){
                        filter.operator = 'NOT IN';
                    }
                    return filter;
                });
            }
            projectStatus.readOnly = status == PROJECT_STATUS_CONCLUDED;
        } else {
            projectStatus.readOnly = false;
            Utilities.localVar.setProjectStatusControl([0]);
            projectStatus.dataSourceFilter = projectStatus.dataSourceFilter.map(function(filter){
                if(filter.pmChangeable) {
                    filter.operator = 'NOT IN';
                }
                return filter;
            });
        }
        return projectStatus.reload();
    };

    var findProjectStatusConcluded = function() {
        var filter = [ {
            "name": "CONTROL",
            "operator": "=",
            "value": PROJECT_STATUS_CONCLUDED
        } ];
        return requestDataSourceEngine.getDataSource('/projectStatusByControl', filter);
    };
    this.ActionEventBackVoltarTab = function(){
        this.goBackProjectList();
    };
    this.repositoryInformationActionEventBack = function(){
        ScreenService.closeSwipe();
        var widget = getWidgetAdvancedInformation();
        widget.list();
        widget.activate();
    };

    this.editProjectRepository = function(args){
        var widget = getWidgetRepositoryInformation();
        widget.edit();
        widget.template = widget.templateToForm;
    };

    this.repositoryInformationActionEventSave = function(args){
        var widget = getWidgetRepositoryInformation();
        if(widget.isValid()) {
            self.saveNewRepository(widget);
            widget.reload().then(function () {
                self.repositoryInformationActionEventCancel();
            });
        }
    };



    this.saveNewRepository = function(widget){
        var lastActiveWidget = widget.lastActiveWidget;
        var row = {};
        row.changed = true;
        row.REPOSITORY_ID = widget.currentRow.REPOSITORY_ID;
        row.REPOSITORY = widget.currentRow.NAME;
        row.STATUS = 'A';
        row.URL = widget.currentRow.URL;
        row.DESCRIPTION = widget.currentRow.DESCRIPTION;
        row.PROJECT = localStorageEngine.getLocalVar('project');
        requestDataSourceEngine.setDataSource('/saveNewRepository', [row]);
    };

    this.repositoryInformationActionEventCancel = function(){
        Utilities.genericCancelEvent(getWidgetRepositoryInformation());
        getWidgetRepositoryInformation().template = getWidgetRepositoryInformation().templateToView;
        getWidgetAdvancedInformation().reload();
    };


    this.advancedInformationActionEventVoltar = function(){
        this.ActionEventBackVoltarTab();
    };

    this.documentsProjectActionEventBack = function(){
        this.ActionEventBackVoltarTab();
    };

    this.documentsProjectActionEventBackView = function(){
        ScreenService.closeSwipe();
        getWidgetProjectDocumentsProject().activate();
    };

    this.documentsProjectWidgetOnEnter = function(){
        getWidgetProjectDocumentsProject().reload();
    };

    this.documentsProjectWidgetAfterMoveRow = function(){
        var deleteAction = getActionDeleteDocumentsFromDocumentsProject();
        var fileName = getWidgetProjectDocumentsProject().currentRow.FILE_NAME;
        deleteAction.isVisible = fileName.search("TaskLog") <= -1;
    };

    this.documentsTaskWidgetAfterMoveRow = function(){
        var widget = getWidgetProjectDocumentsTask();
        var deleteAction = getActionDeleteDocumentsFromDocumentsTask();
        var fileName = getWidgetProjectDocumentsTask().currentRow.FILE_NAME;
        deleteAction.isVisible = fileName.search("TaskLog") <= -1;
        widget.getAction('DOWNLOAD').isVisible = true;
    };

    this.projectLogsActionEventBack = function(){
        this.ActionEventBackVoltarTab();
    };

    this.issueMainWidgetAfterLoadDataSource = function(args){
        var widgetIssueMain = getWidgetIssueMain();
        if(widgetIssueMain.dataSource.data && widgetIssueMain.dataSource.data.length > 0) {
            var issueCommentWidget = getIssueCommentWidget();
            var issueAttachmentsWidget = getIssueAttachmentsWidget();
            var fieldFollowers = getFieldFollowersFromWidgetIssueMain();

            widgetIssueMain.moveToFirst();
            issueCommentWidget.reload();
            issueAttachmentsWidget.reload();
            Utilities.bugPaginationOnSelectMultiplyOnModeView(fieldFollowers);
        }
    };

    this.issueMainActionEventCancel = function(args){
        Utilities.genericBackEventIsNotMasterDetail(getWidgetIssueMain());
    };

    this.taskReplanningReasonActionEventBack = function(){
        var replanningReasonWidget = getWidgetTaskReplanningReason();
        if(replanningReasonWidget.mode == 'view'){
            ScreenService.goBack();
            replanningReasonWidget.list();
        } else{
            ScreenService.goBack();
            getWidgetProjectTasks().activate();
        }
    };

    this.repositoryFieldOnClick = function(){
        var fieldRepository = getFieldRepositoryPopUpWidget();
        if (fieldRepository.selectWidget && !fieldRepository.selectWidget.onAdd) {
            fieldRepository.selectWidget.onAdd = fieldRepository.onAdd;
        }

    };

    this.projectListManagerFilterAfterApply = function(){
        Utilities.setFilterInit(getWidgetProjectListManager());
    };

    this.projectListPartFilterAfterApply = function(){
        Utilities.setFilterInit(getWidgetProjectListParticipating());
    };

    this.moveTaskWidgetOnEnter = function(){
        getFieldReplanningReasonFromMoveTaskWidget().reload();
    };

    this.taskIssuesWidgetOnEnter = function(){
        getWidgetTaskIssues().reload();
    };

    this.taskReplanningReasonWidgetOnEnter = function(){
        getWidgetTaskReplanningReason().reload();
    };

    this.projectLogskWidgetOnEnter = function(args) {
        getWidgetProjectLogs().reload();
        self.setButtons(args);
    };
}

Configuration(function(ContextRegister) {
	ContextRegister.register('ProjectController',ProjectController);
});


// FILE: assets/js/Controller/ProjectAgile.js
function ProjectAgileController(ScreenService, ProjectServiceListAgile, templateManager, ZHPromise,localStorageEngine, requestDataSourceEngine, Utilities) {

    function isParentInProjectsArray(project){
        if(project){
            return project.ID == this.parent;
        }
        return false;
    }

    this.showTargetTask = function(countTasksSelected, widgetTarget,copy) {
		if(countTasksSelected) {
			var promises = [];
			widgetTarget.currentRow = {};
			promises.push(ProjectServiceListAgile.clearTaskList());
			promises.push(ProjectServiceListAgile.loadProjectsWithSameManager(copy));
			ZHPromise.all(promises).then(function() {
                widgetTarget.getField('TASK').dataSource.data = [];
				widgetTarget.getField('PROJECT_NAME').reload().then(function(projects) {
                    projects.forEach(function(project, index){
                        var parent = project.PARENT;
                        if(parent){
                            var param = {
                                'parent': parent
                            };
                            if(!(projects.filter(isParentInProjectsArray, param).length)){
                                projects[index].PARENT = null;
                            }
                        }
                    });
                    widgetTarget.getField('PROJECT_NAME').dataSource.data = projects;
                    ScreenService.openPopup(widgetTarget);
				});
			});
		} else {
			return ScreenService.showMessage('Não há nenhuma tarefa selecionada para ser movida.', null, 'error');
		}
	};

	this.loadTasksByProject = function(owner) {
        var projectID = owner.field.widget.currentRow.PROJECT;
        if(projectID) {
            ProjectServiceListAgile.loadTasksByProject(projectID).then(function() {
                owner.field.widget.getField('TASK_NAME').reload().then(function() {
                    templateManager.updateTemplate();
                });
            });
        }
	};

    this.repositoryOnListClicked = function(widget){
        var repositoryTabbed = widget.widgets[0];
        var repositoryInformation = repositoryTabbed.widgets[0];
        repositoryInformation.setCurrentRow(widget.currentRow);
        repositoryInformation.view();
        repositoryTabbed.showForm = true;
        ScreenService.openSwipe(repositoryTabbed);
        repositoryInformation.activate();
    };

	this.moveTask = function(targetProject, targetTask, widgetTasks) {
		if(targetProject) {
			ProjectServiceListAgile.moveTask(targetProject, targetTask, widgetTasks.dataSource.checkedRows).then(function(response) {
                var message = response.messages[0];
				if(message.type === 'W') {
				    ScreenService.showMessage('Erro ao tentar mover a(s) tarefa(s). ' + message.message, null, 'error');
                } else {
                    widgetTasks.dataSource.data = response.dataset.tasks;
                    ScreenService.closePopup(true);
                    ScreenService.showMessage(message.message, null, 'success');
                }
			});
		} else {
			ScreenService.showMessage('Para mover tarefa(s), é necessário selecionar um projeto.', null, 'error');
		}
	};
    this.copyTask = function(targetProject, targetTask, widgetTasks) {
		if(targetProject) {
			ProjectServiceListAgile.copyTask(targetProject, targetTask, widgetTasks.dataSource.checkedRows).then(function(response) {
                var message = response.messages[0];
				if(message.type === 'W') {
				    ScreenService.showMessage('Erro ao tentar Copiar a(s) tarefa(s). ' + message.message, null, 'error');
                } else {
                    widgetTasks.dataSource.data = response.dataset.tasks;
                    ScreenService.closePopup(true);
                    ScreenService.showMessage(message.message, null, 'success');
                }
			});
		} else {
			ScreenService.showMessage('Para copiar tarefa(s), é necessário selecionar um projeto.', null, 'error');
		}
	};

    this.enableEditTask = function(widget) {
        widget.edit();
        widget.actions[0].showAsAction = 'never';
        widget.fields.forEach(function(field){
            field.isVisible = true;
        });
        self.setVisibleDateException( widget.currentRow,widget);
        widget.getField('ID').isVisible = false;
        widget.template = widget.formTemplate;

        var resources = [];
        var filter = [{
            'name': 'TASK',
            'value': widget.currentRow.ID,
            'operator': '='
        }];
        localStorageEngine.download('/resourcesInTask', filter).then(function(data){
            data.forEach(function(resource){
                resources.push(resource.ID);
            });
            widget.reload().then(function(){
                widget.currentRow.RESOURCES_NAME = widget.currentRow.RESOURCE;
                widget.currentRow.RESOURCE = resources;
                templateManager.updateTemplate();
            });
        });
	};
    this.goBackTask = function(widget) {
        if(widget.editing === true && widget.currentRow.ID){
            widget.list();
            widget.fields.forEach(function(field){
                field.isVisible = (!!field.value());
                if(Array.isArray(field.value())){
                    field.isVisible = field.value().length > 0;
                }
            });
            widget.template = widget.formTemplate;
            widget.getAction('SAVE_TASK').showAsAction = "";
            widget.reload().then(function(){
                widget.currentRow.RESOURCE = widget.currentRow.RESOURCES_NAME;
                templateManager.updateTemplate();
            });
        }else{
            ScreenService.closeSwipe();
            widget.container.getWidget('PROJECTTASKS').activate();
            templateManager.updateTemplate();
            widget.list();
        }

	};
    this.goBackProjectList = function(widgetSwipe) {
        ScreenService.goBack();
        widgetSwipe.currentWidget = widgetSwipe.widgets[0];
        localStorageEngine.setLocalVar('project',null);
        widgetSwipe.container.getWidget('PROJECT_LIST').activate();

    };

    this.onChangeStartTask = function(widget,exceptions){
        var row = widget.currentRow;
        var beginTaskParent = null;
        var beginTask = row.START.split("/").reverse().join("-");
        var beginProject = row.BEGIN_PROJECT;
        var dateException = moment(row.DATE_EXCEPTION, 'DD/MM/YYYY');
        if(widget.currentRow.PARENT_NAME){
            var dataParent = widget.getField('PARENT_NAME').dataSource.data;
            dataParent.forEach(function(data){
                    if(data.ID == row.PARENT){
                        beginTaskParent = data.BEGIN_TASK;
                    }
                }
            );
        }else{
            row.PARENT = null;
        }

        if(row.DATE_EXCEPTION_ABBREVIATION == 'MB' ){
            if((beginTask != beginTaskParent && beginTaskParent ) ||(beginTask != beginProject && !beginTaskParent)){
                row.DATE_EXCEPTION = row.START;
                var dataException = widget.getField('DATE_EXCEPTION_NAME').dataSource.data;
                dataException.forEach(function(data){
                        if(data.ABBREVIATION == 'IA'){
                            row.DATE_EXCEPTION_ABBREVIATION = data.ABBREVIATION;
                            row.DATE_EXCEPTION_TYPE = data.ID ;
                            row.DATE_EXCEPTION_NAME = data.NAME;
                        }
                    }
                );

            }
            this.setVisibleDateException(row,widget);
        }else if (row.DATE_EXCEPTION_ABBREVIATION == 'IA') {
            beginTask = moment(row.START, 'DD/MM/YYYY');
            dateException = moment(row.DATE_EXCEPTION, 'DD/MM/YYYY');
            if (beginTask < dateException || !dateException) {
                row.DATE_EXCEPTION = row.START;
            }
        }else if (row.DATE_EXCEPTION_ABBREVIATION == 'ID') {
            beginTask = moment(row.START, 'DD/MM/YYYY');
            dateException = moment(row.DATE_EXCEPTION, 'DD/MM/YYYY');
            if (beginTask > dateException || !dateException) {
                row.DATE_EXCEPTION = row.START;
            }
        }else if (row.DATE_EXCEPTION_ABBREVIATION == 'DI') {
            if (beginTask != dateException.format('YYYY-MM-DD') ) {
                row.DATE_EXCEPTION = row.START;
            }
        }
        if(moment(row.START, 'DD/MM/YYYY') > moment(row.END, 'DD/MM/YYYY')){
            row.END = row.START;
        }
        ProjectServiceListAgile.parseDatesTask(row,exceptions);
    };
    this.reloadFields = function(widget){
        widget.getField('RESOURCE').reload();
        widget.getField('PARENT_NAME').reload();
        widget.getField('PRECURSOR_NAME').reload();
        widget.getField('TASK_STATUS_NAME').reload();
        widget.getField('DATE_EXCEPTION_NAME').reload();
    };

    this.setVisibleDateException = function(row,widget){
        var fieldDate = widget.getField('DATE_EXCEPTION');
        if(row.DATE_EXCEPTION_TYPE == 7 || row.DATE_EXCEPTION_TYPE == 8){
            fieldDate.isVisible = false;
            row.DATE_EXCEPTION = null;
        }else{
            fieldDate.isVisible = true;
        }
    };

    this.openNewTask = function(widget,dateProjectBegin, dateProjectEnd){
        ScreenService.openSwipe(widget);
        localStorageEngine.setLocalVar("taskProject",0);
        this.reloadFields(widget);
        widget.label = 'Nova tarefa';
        widget.newRow();
        widget.getField('STATUS').value('A');
        widget.getField('START').value(dateProjectBegin);
        widget.getField('END').value(dateProjectBegin);
        widget.getField('TOTAL_TIME').value("1D");
        widget.getField('PERCENT_COMPLETED').value("0");
        widget.getField('DATE_EXCEPTION_NAME').value("O Mais Breve Possível");
        widget.currentRow.DATE_EXCEPTION_TYPE = 7;
        widget.currentRow.PRECURSOR = null;
        widget.currentRow.DATE_EXCEPTION_ABBREVIATION = 'MB';
        widget.currentRow.BEGIN_PROJECT = dateProjectBegin.split("/").reverse().join("-");
        widget.currentRow.END_PROJECT = dateProjectEnd.split("/").reverse().join("-");
        widget.actions[0].showAsAction = 'never';
        widget.fields.forEach(function(field){
            field.isVisible = true;
        });
        widget.getField('ID').isVisible = false;
        widget.getField('DATE_EXCEPTION').isVisible = false;

    };
    this.taskMoveRowList = function(widgetTabbed,idTask,resourcesName,widgetTask){
        localStorageEngine.setLocalVar("taskProject",idTask);
        widgetTabbed.formTemplate = "widget/tabbedWidget.html";
        this.reloadFields(widgetTask);
        widgetTask.label= 'Informações básicas';
        ProjectServiceListAgile.taskForEditById(idTask).then(function(data){
            widgetTask.newRow();
            ScreenService.openSwipe(widgetTabbed);
            widgetTask.currentRow = data.dataset.taskData;
            widgetTask.fields.forEach(function(field){
                field.isVisible = (!!field.value());
            });
            widgetTask.list();
            widgetTask.template = widgetTask.formTemplate;
            widgetTask.actions[0].showAsAction = ' ';
            self.setVisibleDateException( widgetTask.currentRow,widgetTask);
            widgetTask.reload().then(function(){
                widgetTask.currentRow.RESOURCE = resourcesName.split(", ");
                templateManager.updateTemplate();
            });
        });
    };

    this.openNewProject = function(){
        ScreenService.openWindow('product#new_project');
    };

    this.onChangePrecursor= function(row) {
        if(row.PRECURSOR_NAME ){
            if(!row.TYPE) {
                row.TYPE = 'TI';
            }
        }else{
            row.TYPE = null;
        }
    };

    this.openNewSubProject = function(row,args){
        var calendar = args.owner.widget.container.getWidget('CALENDAR').currentRow;
        if(calendar){
            delete calendar.ID;
        }
        var listExceptions = args.owner.widget.container.getWidget('LIST_EXCEPTION').dataSource.data;
        var listResources = args.owner.widget.container.getWidget('RESOURCE_LIST').dataSource.data;
        listResources.forEach(function(resource){
            resource.ID = resource.RESOURCE_ID;
        });
        listExceptions.forEach(function(exception){
            delete exception.ID ;
        });
        ProjectServiceListAgile.openNewSubProject(row,calendar,listExceptions,listResources);
        ScreenService.openWindow('product#new_project');
    };

    this.onEnterProjectList = function(args) {
        ProjectServiceListAgile.onEnterProjectList(args);
    };
    this.resourceListMoveRowProjectLocal = function(args) {
        args.owner.container.getWidget('RESOURCE_LIST').dataSource.data.push(args.row);
        args.dataSource.splice(args.dataSource.indexOf(args.row),1);
    };
    this.deleteExceptionLocal = function(args) {
        args.dataSource.checkedRows.forEach(function(data){
            args.dataSource.data.splice(args.dataSource.data.indexOf(data),1);
        });
    };
    this.addExceptionLocal = function(widget){
        ScreenService.openPopup(widget);
        widget.newRow();
        widget.currentRow.STATUS = 'A';
    };
    this.onEnterTest = function(widget){
        widget.view();
    };

    this.editBasicInformation = function(action){
        action.widget.edit();
        action.widget.template = action.widget.formTemplate;

    };
    this.maximumPercentageCompletion = function(row){
        if(row.PERCENT_COMPLETED !== ''){
            var percent = parseInt(row.PERCENT_COMPLETED);
            if(percent>100)
                row.PERCENT_COMPLETED = 100;
        }
    };

    this.fixBugOnChangeSelectNative = function(args){
        if(args.owner[0].value){
            args.row[args.owner.field.name] = args.owner.field.dataSource.data[args.owner[0].value][args.owner.field.valueField];
        }
    };
    this.setDateException = function(args,paramenter){
        ProjectServiceListAgile.setDateException(args.row,args.owner.field.widget,paramenter);
    };
    this.setDateByException = function(widget,exceptions){
        var row = widget.currentRow;
        var precursor = widget.currentRow.PRECURSOR;
        var parent = widget.currentRow.PARENT;
        var beginTaskPrecursor = null;
        var endTaskPrecursor = null;
        var beginTaskParent = null;
        var endTaskParent = null;
        if(widget.currentRow.PRECURSOR_NAME && widget.currentRow.TYPE ){
            var dataPrecursor = widget.getField('PRECURSOR_NAME').dataSource.data;
            dataPrecursor.forEach(function(data){
                    if(data.ID == precursor){
                        row.__PRECURSOR_NAME = data;
                        beginTaskPrecursor = data.BEGIN_TASK;
                        endTaskPrecursor = data.END_TASK;
                    }
                }
            );
        }else{
            row.PRECURSOR = null;
        }
        if(widget.currentRow.PARENT_NAME){
            var dataParent = widget.getField('PARENT_NAME').dataSource.data;
            dataParent.forEach(function(data){
                    if(data.ID == parent){
                        beginTaskParent = data.BEGIN_TASK;
                        endTaskParent = data.END_TASK;
                    }
                }
            );
        }else{
            row.PARENT = null;
        }
        row.START = row.START.split("/").reverse().join("-");
        row.END = row.END.split("/").reverse().join("-");
        if(row.DATE_EXCEPTION){
            row.DATE_EXCEPTION = row.DATE_EXCEPTION.split("/").reverse().join("-");
        }
        ProjectServiceListAgile.getDateBegin(row,beginTaskPrecursor,endTaskPrecursor,beginTaskParent,endTaskParent,exceptions);
        row.START = row.START.split("-").reverse().join("/");
        row.END = row.END.split("-").reverse().join("/");
        if(row.DATE_EXCEPTION) {
            row.DATE_EXCEPTION = row.DATE_EXCEPTION.split("-").reverse().join("/");
        }
    };
    this.setDateByExceptionProject = function(widget,exceptions){
        var row = widget.currentRow;
        var parent = widget.currentRow.UPPER_PROJECT;
        var beginTaskPrecursor = null;
        var endTaskPrecursor = null;
        var beginTaskParent = null;
        var endTaskParent = null;

        if(widget.currentRow.UPPER_PROJECT_NAME){
            var dataParent = widget.getField('UPPER_PROJECT_NAME').dataSource.data;
            dataParent.forEach(function(data){
                    if(data.ID == parent){
                        beginTaskParent = data.BEGIN_DATE.split("/").reverse().join("-");
                        endTaskParent = data.END_DATE.split("/").reverse().join("-");
                    }
                }
            );
        }else{
            row.UPPER_PROJECT = null;
        }
        row.START = row.START.split("/").reverse().join("-");
        row.END = row.END.split("/").reverse().join("-");
        if(row.DATE_EXCEPTION){
            row.DATE_EXCEPTION = row.DATE_EXCEPTION.split("/").reverse().join("-");
        }
        ProjectServiceListAgile.getDateBegin(row,beginTaskPrecursor,endTaskPrecursor,beginTaskParent,endTaskParent,exceptions);
        row.START = row.START.split("-").reverse().join("/");
        row.END = row.END.split("-").reverse().join("/");
        if(row.DATE_EXCEPTION) {
            row.DATE_EXCEPTION = row.DATE_EXCEPTION.split("-").reverse().join("/");
        }
    };
    this.addStatusTask = function(widget){
        ScreenService.openPopup(widget);
        widget.getField('TASK_TYPE').reload();
        widget.newRow();
    };
    this.addTypeTask = function(widget){
        ScreenService.openPopup(widget);
        widget.newRow();
    };
    this.newTaskStatus = function(row,fieldTaskStatus){
        ProjectServiceListAgile.newTaskStatus(row).then(function(){
            fieldTaskStatus.reload();
            ScreenService.closePopup();
        });
    };
    this.newTaskType = function(row,fieldTaskType,args){
        ProjectServiceListAgile.newTaskType(row).then(function(){
            fieldTaskType.reload();
            ScreenService.closePopup();
        });
    };
    this.reloadFieldsProject = function (widget) {
        widget.getField('SPONSOR_NAME').reload();
        widget.getField('GROUP_NAME').reload();
        widget.getField('MANAGER_NAME').reload();
        widget.getField('UPPER_PROJECT_NAME').reload();
    };



    this.projectExceptionVisibility = function(widget){
        var row =  widget.currentRow;
        var fieldDateException = widget.getField('DATE_EXCEPTION_NAME');
        if(widget.getField('UPPER_PROJECT_NAME').value()){
            fieldDateException.isVisible = true;
        }else{
            fieldDateException.isVisible = false;
            fieldDateException.dataSource.data.forEach(function(data){
                if(data.ABBREVIATION == 'MB'){
                    row.DATE_EXCEPTION_NAME = data.NAME;
                    row.DATE_EXCEPTION_TYPE = data.ID;
                    row.DATE_EXCEPTION_ABBREVIATION = data.ABBREVIATION;
                }
            });
        }
        this.setVisibleDateException(row,widget);
    };

    this.openRepositoryPopup = function(widget){
      ScreenService.openSwipe(widget.widgets[1]);
      widget.widgets[1].newRow();
    };



    this.saveRepository = function(widget) {
        var projectId = localStorageEngine.getLocalVar('project');
        var row = {};
        row.changed = true;
        row.REPOSITORY = widget.currentRow.REPOSITORY;
        row.URL = widget.currentRow.REPOSITORY_URL;
        row.REPOSITORY_ID = widget.currentRow.REPOSITORY_ID;
        row.STATUS = 'A';
        row.PROJECT = projectId;
        requestDataSourceEngine.setDataSource('/saveRepository', [row]).then(function(response) {
            ScreenService.closeSwipe();
            getRepositoryGrid().reload();
            getRepositoryGrid().list();
            getRepositoryGrid().activate();

        });
    };

    this.projectRepositoryPopupnActionEventSave = function(args){
        self.saveRepository(args.owner.widget);
    };

    this.associateProjectToRepository = function(repository, project, status, widget){
        var row = {};
        row.PROJECT = project;
        row.REPOSITORY = repository;
        row.STATUS = status;
        requestDataSourceEngine.setDataSource('/associateProjectToRepository', [row]).then(function(response) {
            widget.reload();
        });
    };

    function isChildOf(project){
        return project.PARENT === this.parentId;
    }

    this.backToRepositoryGrid = function(widget){
        ScreenService.closeSwipe();
        widget.parent.list();
        widget.parent.activate();
    };

    var getNewRepositoryPopup = function(){
      return templateManager.container.getWidget('REPOSITORY_SELECT');
    };

    var getRepositoryPopup = function(){
      return templateManager.container.getWidget('PROJECT_REPOSITORY_POPUP');
    };

    var getRepositoryGrid = function(){
      return templateManager.container.getWidget('ADVANCED_INFORMATION');
    };

    var getRepositoryInformationWidget = function(){
        return templateManager.container.getWidget('REPOSITORY_INFORMATION');
    };




    ProjectServiceListAgile.setProjectController(this);
    var self = this;

}

Configuration(function(ContextRegister) {
	ContextRegister.register('ProjectAgileController',ProjectAgileController);
});


// FILE: assets/js/Controller/ProjectConfiguration.js
function ProjectConfigurationController(ScreenService, templateManager, requestDataSourceEngine, ProjectServiceList, Utilities, ZhFilterPreferences) {

    var self = this;
    var EXTERNALTYPE_MEETING = 'M';
    var EXTERNALTYPE_OCCURRENCE_MEETING = 'O';
    var PROJECT_STATUS_CONCLUDED = 'C';

    var getWidgetTypeProject = function () {
        return templateManager.container.getWidget('TYPE_PROJECT');
    };
    
    var getWidgetTabCategories = function () {
        return templateManager.container.getWidget('tabCategories');
    };

    var getWidgetStatusProject = function () {
        return templateManager.container.getWidget('STATUS_PROJECT');
    };

    var getWidgetProducts = function () {
        return templateManager.container.getWidget('PRODUCTS');
    };
    
    var getFieldProfileFromTypeProjectWidget = function () {
        return getWidgetTypeProject().getField('PROFILE');
    };

    var getFieldProjectStatusFromProductWidget  = function(){
        return getWidgetProducts().getField('PROJECT_STATUS_ID');
    };

    var getFieldAllowedProjectTypeFromTabCategoriesWidget = function(){
        return getWidgetTabCategories().getField('ALLOWED_PROJECT_TYPE');
    };

    var getFieldNotAllowedProjectTypeFromTabCategoriesWidget = function(){
        return getWidgetTabCategories().getField('NOT_ALLOWED_PROJECT_TYPE');
    };

    var getFieldProfileUseFromTypeProjectWidget = function () {
        return getWidgetTypeProject().getField('PROFILE_USE');
    };

    var getFieldRequiresApprovalFromTypeProjectWidget = function () {
        return getWidgetTypeProject().getField('REQUIRES_APPROVAL');
    };

    var getFieldUseTimePlanningFromTypeProjectWidget = function () {
        return getWidgetTypeProject().getField('USETIMEPLANNING');
    };

    var getFieldExternalTypeFromTypeProjectWidget = function () {
        return getWidgetTypeProject().getField('EXTERNALTYPE');
    };

    var getFieldUseMergeRequestFromTypeProjectWidget = function () {
        return getWidgetTypeProject().getField('USEMERGEREQUEST');
    };

    var getFieldAllowEndTaskFromTypeProjectWidget = function () {
        return getWidgetTypeProject().getField('ALLOWENDTASK');
    };
    
    var getFieldStatusFromTypeProjectWidget = function () {
        return getWidgetTypeProject().getField('STATUS');
    };

    this.typeProjectWidgetAfterMoveRow = function (args) {
        setsRequiresApproval();
        this.typeProjectFieldOnChangeExternalType();
    };

    var setsRequiresApproval = function () {
        var requiresApprovalField = getFieldRequiresApprovalFromTypeProjectWidget();
        var profileField = getFieldProfileFromTypeProjectWidget();
        setReadOnlyProfile(requiresApprovalField, profileField);
    };

    this.typeProjectFieldOnChangeRequiresApproval = function (args) {
        setsRequiresApproval();
    };

    this.tabCategoriesWidgetOnEnter = function(args){
        Utilities.applyDefaultFilterOnEnter(getWidgetTabCategories(), true);
    };
    
     this.tabCategoriesFilterAfterApply = function(){
        Utilities.setFilterInit(getWidgetTabCategories());
    };

    this.typeProjectWidgetOnEnterTab = function(args){
        var widget = getWidgetTypeProject();
        ZhFilterPreferences.setOriginalFilter(widget.id, widget.currentRow);
        Utilities.applyDefaultFilterOnEnter(getWidgetTypeProject(), true);
    };
    
    this.typeProjectPartFilterAfterApply = function(){
        Utilities.setFilterInit(getWidgetTypeProject());
    };
    
    var setDefaultFilterWidgetProducts = function(){
        var fieldProjectStatus = getFieldProjectStatusFromProductWidget();
        var data = Utilities.findInDataSource(fieldProjectStatus,['N', 'D', 'P'],'CONTROL');
        fieldProjectStatus.value(Utilities.createArrayByDataSetAndIndex(data,fieldProjectStatus.valueField));
    };
    
    var setDefaultFilterWidgetTypeProject = function(){
        getFieldStatusFromTypeProjectWidget().value(Utilities.constants.ACTIVE);
    };
    
    this.projectConfigurationContainerAfterinit = function(args){
        setDefaultFilterWidgetProducts();
        setDefaultFilterWidgetTypeProject();
    };

    this.productsWidgetOnEnter = function(args){
        Utilities.applyDefaultFilterOnEnter(getWidgetProducts(), true);
    };
    
    this.productsManagerFilterAfterApply = function(){
        Utilities.setFilterInit(getWidgetProducts());
    };

    this.statusProjectWidgetOnEnter = function(args){
        Utilities.applyDefaultFilterOnEnter(getWidgetStatusProject(), true);
    };
    
    this.statusProjectFilterAfterApply = function(){
        Utilities.setFilterInit(getWidgetStatusProject());
    };

    this.statusProjectActionEventAdd = function(args){
        getWidgetStatusProject().newRow();
    };

    this.statusProjectActionEventEdit = function(args){
        getWidgetStatusProject().edit();
    };

    this.productProjectActionEventEdit = function(args){
        getWidgetProducts().edit();
    };

    this.statusProjectActionEventBack = function(args){
        ScreenService.goBack();
        getWidgetStatusProject().list();
        getWidgetStatusProject().reload();
    };

    this.productsActionEventBack = function(args){
        ScreenService.goBack();
        getWidgetProducts().list();
    };

    this.statusProjectActionEventSave = function(args){
        var widget = getWidgetStatusProject();
        if(widget.isValid()) {
            var row = widget.currentRow;
            var control = row.CONTROL;
            if (control == PROJECT_STATUS_CONCLUDED) {
                ScreenService.showLoader();
                findProjectStatusConcluded().then(function (data) {
                    ScreenService.hideLoader();
                    var status = data.dataset.projectStatus;
                    if (status.length > 0 && status[0].ID != row.ID) {
                        ScreenService.showMessage(Utilities.messages.ALE_NOT_ASSOCIATE_TWO_CONCLUDED_ST.replace('%1', status[0].LABEL), 'ALERT');
                    } else {
                        ProjectServiceList.doSaveProjectStatus(row, widget);
                    }
                }).catch(ScreenService.hideLoader);
            } else {
                ProjectServiceList.doSaveProjectStatus(row, widget);
            }
        }
    };

    var findProjectStatusConcluded = function() {
        var filter = [ {
            "name": "CONTROL",
            "operator": "=",
            "value": PROJECT_STATUS_CONCLUDED
        } ];
        return requestDataSourceEngine.getDataSource('/projectStatusByControl', filter);
    };

    this.typeProjectFieldOnChangeProfileUse = function (args) {
        var profileUseField = getFieldProfileUseFromTypeProjectWidget();
        var profileField = getFieldProfileFromTypeProjectWidget();
        if(profileUseField.value().length === 0){
            profileField.dataSourceFilter = profileField.dataSourceFilter.filter(function(data){
                return !data.PMonEdit;
            });
        }else{
            var filteredValue = checkProfileValues(profileUseField.value(), profileField.value());
            profileField.value(filteredValue);
            getFieldRequiresApprovalFromTypeProjectWidget().readOnly = false;
            Utilities.localVar.setProfiles(profileUseField.value());
            profileField.dataSourceFilter.push({
                "name": "NRPERFILACESSO",
                "operator": "IN",
                "value": "@Utilities.localVar.getProfiles() ? Utilities.localVar.getProfiles() : 0@",
                "PMonEdit": true
            });
        }
        profileField.reload();
    };

    var checkProfileValues = function(profileUseFields, profileFields){
        if(profileFields){
            profileFields = profileFields.filter(function(profileField){
                return profileUseFields.indexOf(profileField) != -1;
            });
        }
        return profileFields;
    };

    var setReadOnlyProfile = function (requiresApprovalField, profileField) {
        if (requiresApprovalField.value() == requiresApprovalField.valueToTrue){
            profileField.readOnly = false;
            profileField.validations = {"required": {}};
        } else {
            profileField.readOnly = true;
            profileField.validations = false;
            profileField.value([]);
        }
    };

    var setControl = function (typeProjectWidget, control) {
        var controlMeeting = (control == Utilities.constants.TYPE_PROJECT_MEETING_OCCURRENCES ||
                              control == Utilities.constants.TYPE_PROJECT_MEETING ||
                              control == Utilities.constants.TYPE_PROJECT_CONTROL_TIME_LINE );
        typeProjectWidget.fields.forEach(function(field){
            if(field.PMReadOnlyMeeting){
                field.readOnly = controlMeeting;
            }
        });

        if(controlMeeting){
            var requiresApprovalField = getFieldRequiresApprovalFromTypeProjectWidget();
            var userTimePlanningField = getFieldUseTimePlanningFromTypeProjectWidget();
            var useMergeRequestField  = getFieldUseMergeRequestFromTypeProjectWidget();
            var allowEndTaskField     = getFieldAllowEndTaskFromTypeProjectWidget();
            useMergeRequestField.value(useMergeRequestField.valueToFalse);
            allowEndTaskField.value(allowEndTaskField.valueToTrue);
            requiresApprovalField.value(requiresApprovalField.valueToFalse);
            userTimePlanningField.value(userTimePlanningField.valueToFalse);
            setsRequiresApproval();
        }
    };

    this.tabCategoriesFieldOnChangeAllowedProjectType = function(args) {
        var widgetAllowed = getFieldAllowedProjectTypeFromTabCategoriesWidget();
        var widgetNotAllowed = getFieldNotAllowedProjectTypeFromTabCategoriesWidget();
        var allowedValue = widgetAllowed.value();
        if (allowedValue && allowedValue.length === 0) {
            widgetNotAllowed.value([]);
        } else {
            var dataSetIds = widgetNotAllowed.dataSource.data.map(function(row){
                return row.ID;
            });
            widgetNotAllowed.value(Utilities.removeArrayInOtherArray(widgetAllowed.value(), dataSetIds));
        }
    };

    this.tabCategoriesFieldOnChangeNotAllowedProjectType = function(args){
        var widgetAllowed = getFieldAllowedProjectTypeFromTabCategoriesWidget();
        var widgetNotAllowed = getFieldNotAllowedProjectTypeFromTabCategoriesWidget();
        var notAllowedValue = widgetNotAllowed.value();
        if(notAllowedValue && notAllowedValue.length === 0){
            widgetAllowed.value([]);
        } else {
            var dataSetIds = widgetAllowed.dataSource.data.map(function(row){
                return row.ID;
            });
            widgetAllowed.value(Utilities.removeArrayInOtherArray(widgetNotAllowed.value(), dataSetIds));
        }
    };

    this.tabCategoriesActionEventSave = function(args){
        var widget = getWidgetTabCategories();
        if(!widget.isValid()) {
            ScreenService.showMessage(Utilities.messages.ERR_REQUIRED_FIELDS);
        } else {
            widget.saveRow().then(function (response) {
                widget.currentRow.ID = response.dataset.projectClassification.ID;
                ScreenService.showLoader();
                widget.reload().then(function () {
                    ScreenService.hideLoader();
                    widget.view();
                }).catch(ScreenService.hideLoader);
            }).catch(Utilities.showMessageBackEndTrue);
        }
    };

    this.productsActionEventSave = function(args){
        var widget = getWidgetProducts();
        if(!widget.isValid()) {
            ScreenService.showMessage(Utilities.messages.ERR_REQUIRED_FIELDS);
        } else {
            widget.saveRow().then(function () {
                ScreenService.showLoader();
                widget.reload().then(function () {
                    ScreenService.hideLoader();
                    widget.view();
                }).catch(ScreenService.hideLoader);
            }).catch(Utilities.showMessageBackEndTrue);
        }
    };

    this.typeProjectActionEventSave = function(args){
        var typeProjectWidget = getWidgetTypeProject();
        if(typeProjectWidget.isValid()) {
            typeProjectWidget.saveRow().then(function(response) {
                typeProjectWidget.currentRow.ID = response.dataset.ProjectType[0].ID;
                ScreenService.showLoader();
                typeProjectWidget.reload().then(function() {
                    var profileField = getFieldProfileFromTypeProjectWidget();
                    profileField.dataSourceFilter = profileField.dataSourceFilter.filter(function(data){
                        return !data.PMonEdit;
                    });
                    profileField.reload().then(function(){
                        typeProjectWidget.reload();
                    });
                    ScreenService.hideLoader();
                    typeProjectWidget.view();
                    typeProjectWidget.setCurrentRow(typeProjectWidget.currentRow);
                }).catch(ScreenService.hideLoader);
            }).catch(function(error){
                ScreenService.hideLoader();
                var backEndError = error.data.error;
                if(backEndError.indexOf("Zeedhi\\Framework\\Log\\Exception:") != -1){
                    var message = backEndError.replace("Zeedhi\\Framework\\Log\\Exception: ",'');
                    ScreenService.showMessage(message);
                }else{
                    ScreenService.showMessage(backEndError);
                }

            });
        }
    };

    this.typeProjectActionEventDelete = function(args) {
        var typeProjectWidget = getWidgetTypeProject();
        ScreenService.confirmMessage(Utilities.messages.ALE_DELETE_TYPE_PROJECT, "CONFIRMATION", function () {
            typeProjectWidget.dataSource.remove([typeProjectWidget.currentRow]).then(function () {
                ScreenService.closeSwipe();
                typeProjectWidget.reload();
            }).catch(function (response) {
                Utilities.showMessageErrorOfBackEnd(response, null, null, true);
            });
        }, function () {
            typeProjectWidget.activate();
        });
    };

    this.tabCategoriesActionEventDelete = function(args){
        var tabCategoriesWidget = getWidgetTabCategories();
        ScreenService.confirmMessage(Utilities.messages.ALE_DELETE_CATEGORY, "CONFIRMATION", function(){
                tabCategoriesWidget.dataSource.checkedRows = [tabCategoriesWidget.currentRow];
                tabCategoriesWidget.removeCheckedRows();
                tabCategoriesWidget.unSelectAll();
                ScreenService.closeSwipe();
        }, function(){
            tabCategoriesWidget.activate();
        });
    };

    this.tabCategoriesActionEventEdit = function(args){
        var tabCategoriesWidget = getWidgetTabCategories();
        tabCategoriesWidget.edit();
    };

    this.tabCategoriesActionEventNew = function(args){
        var tabCategoriesWidget = getWidgetTabCategories();
        tabCategoriesWidget.newRow();
    };
    
    this.statusProjectActionEventDelete = function(args){
        var statusProjectWidget = getWidgetStatusProject();
        ScreenService.confirmMessage(Utilities.messages.ALE_DELETE_STATUS, "CONFIRMATION", function(){
                statusProjectWidget.dataSource.checkedRows = [statusProjectWidget.currentRow];
                statusProjectWidget.removeCheckedRows(statusProjectWidget);
                statusProjectWidget.unSelectAll();
                ScreenService.closeSwipe();
        }, function(){
            statusProjectWidget.activate();
        });
    };

    this.typeProjectActionEventEdit = function(args){
        var typeProject = getWidgetTypeProject();
        typeProject.edit();
        this.typeProjectFieldOnChangeProfileUse(args);
        this.typeProjectFieldOnChangeRequiresApproval(args);
    };

    this.typeProjectActionEventCancel = function(args){
        var typeProjectWidget = getWidgetTypeProject();
        Utilities.genericCancelEvent(typeProjectWidget);
        var profileField = getFieldProfileFromTypeProjectWidget();
        profileField.dataSourceFilter = profileField.dataSourceFilter.filter(function(data){
            return !data.PMonEdit;
        });
        profileField.reload().then(function(){
            typeProjectWidget.reload();
        });
    };

    this.statusProjectActionEventCancel = function(args){
        var statusProjectWidget = getWidgetStatusProject();
        Utilities.genericCancelEvent(statusProjectWidget);
        statusProjectWidget.reload();
    };

    this.productProjectActionEventCancel = function(args){
        var productsWidget = getWidgetProducts();
        Utilities.genericCancelEvent(productsWidget);
        productsWidget.reload();
    };
    
    this.tabCategoriesActionEventCancel = function(args){
        var tabCategories = getWidgetTabCategories();
        Utilities.genericCancelEvent(tabCategories);
        tabCategories.reload();
    };
    
    this.tabCategoriesActionEventBack = function(args){
        ScreenService.goBack();
        getWidgetTabCategories().list();
    };

    this.typeProjectFieldOnChangeExternalType = function (args) {
        var externalTypeField = getFieldExternalTypeFromTypeProjectWidget();
        var typeProjectWidget = getWidgetTypeProject();
        setControl(typeProjectWidget,externalTypeField.value());
    };
}
Configuration(function(ContextRegister) {
    ContextRegister.register('ProjectConfigurationController', ProjectConfigurationController);
});


// FILE: assets/js/Controller/Resource.js
function ResourceController(ZhFilterPreferences, ResourceService, templateManager, localStorageEngine, ScreenService, ZHPromise, Validation,
                            CalendarService, Messages, FilterService,Utilities) {

	var self = this;
	var editingResource;
    var RESOURCE_TYPE_WORK  = 'W';
    var RESOURCE_TYPE_ASSET = 'A';
    var RESOURCE_TYPE_COST  = 'D';

    var getWidgetFilterResource = function(){
        return getWidgetResourceList().appliedFilter;
    };
    
    var getWidgetMainResourceTab = function(){
        return templateManager.container.getWidget('MAIN_RESOURCE_TAB');
    };
    
    var getWidgetResourceList = function(){
        return templateManager.container.getWidget('RESOURCE_LIST');
    };
    
    var getWidgetResourceTabbedWidget = function(){
        return templateManager.container.getWidget('RESOURCE_TABBED_WIDGET');
    };
    
    var getWidgetProfilesTab = function(){
        return templateManager.container.getWidget('PROFILES_TAB');
    };
    
    var getWidgetNewProfile = function(){
        return templateManager.container.getWidget('NEW_PROFILE');
    };

    var getWidgetWgChangePassword = function(){
        return templateManager.container.getWidget('WG_CHANGE_PASSWORD');
    };

    var getFieldResponsibleFromWidgetResourceList = function(){
        return getWidgetResourceList().getField('RESPONSIBLE');
    };

    var getFieldStructureFromWidgetResourceList = function(){
        return getWidgetResourceList().getField('STRUCTURE');
    };

    this.resourceListActionEventAdd = function(args){
    	editingResource = false;
    	var tabbedWidget = getWidgetResourceTabbedWidget();
    	var formResourceWidget = getWidgetMainResourceTab();
        tabbedWidget.widgets.forEach(function(widget){
           widget.isVisible = !!widget.PMOnEdit;
        });
        formResourceWidget.dataSource.data = [];
        formResourceWidget.newRow();
        ScreenService.openSwipe(tabbedWidget);
        tabbedWidget.descriptionOrder = "";
        formResourceWidget.template = formResourceWidget.formTemplate;
    };

    this.removeResource = function(args){
        var mainResourceTab = getWidgetMainResourceTab();
        ScreenService.confirmMessage(Utilities.messages.ALE_ARE_YOU_SURE_DELETE_RESOURCE , null, function(){
            mainResourceTab.currentRow = getIdentityData(mainResourceTab.currentRow);
            mainResourceTab.removeRow().then(function(){
                ScreenService.closeSwipe().then(function(){
                    getWidgetResourceList().activate();
                    getWidgetResourceList().reload();
                });
            }).catch(function(response){
                var message = response.data.error.replace('Zeedhi\\Framework\\Log\\Exception:', '').trim();
                ScreenService.showMessage(message);
                mainResourceTab.reload();
            });
        }, function() {
            getWidgetMainResourceTab().reload();

        });
    };

	this.initFilterResource = true;

    this.resourceListWidgetOnEnter = function(args){
        ScreenService.showLoader();
        Utilities.localVar.getLoginPromise().then(function(){
            ScreenService.hideLoader();
            var widget = getWidgetResourceList();
            widget.activate();
            localStorageEngine.setLocalVar('/resource', null);

            getFieldResponsibleFromWidgetResourceList();
            setResponsibleFieldValue(localStorageEngine.getLocalVar('idBusinessPartner'));
            widget.currentRow.STATUS_RESOURCE = "A";
            ZhFilterPreferences.setOriginalFilter(widget.id, widget.currentRow);
            Utilities.applyDefaultFilterOnEnter(widget, true);
        }).catch(ScreenService.hideLoader);
    };
    
    this.resourceListPartFilterAfterApply = function(){
        Utilities.setFilterInit(getWidgetResourceList());
    };

    var changeVisibilityWidgetsFromResourceTabbed = function(){
        var tabbedWidget = getWidgetResourceTabbedWidget();
        var widgetsToHide = ["AVAILABILITY_TAB", "COST_TAB"];
        tabbedWidget.widgets.forEach(function (widget) {
            widget.isVisible = widgetsToHide.indexOf(widget.name) == -1;
        });
    };
    
    var reloadWidgetMainResourceTab = function(toActivate){
        var widget = getWidgetMainResourceTab();
        widget.list();
        ScreenService.showLoader();
        widget.reload().then(function(response){
            ScreenService.hideLoader();
            widget.setCurrentRow(response.dataset.ResourceInfo[0]);
        }).catch(ScreenService.hideLoader);
        widget.view();
        if (toActivate){
            widget.activate();
        }
    };

    var setTabbedResource = function (id,externalId) {
        var tabbedWidget = getWidgetResourceTabbedWidget();
        editingResource = true;
        localStorageEngine.setLocalVar('/resource', id);
        tabbedWidget.descriptionOrder = getWidgetResourceList().descriptionOrder;
        changeVisibilityWidgetsFromResourceTabbed();
        Utilities.localVar.setResourceExternalId(externalId);
        ScreenService.openSwipe(tabbedWidget).then(function () {
            if (tabbedWidget.currentWidget == getWidgetMainResourceTab()) {
                reloadWidgetMainResourceTab(true);
            } else {
                tabbedWidget.currentWidget.reload().then(function(){
                    reloadWidgetMainResourceTab(false);
                });
            }
        });
    };

    this.resourceListWidgetAfterMoveRow = function(args) {
        editingResource = true;
        var widget = getWidgetResourceList();
        var currentRow = widget.currentRow;
        setTabbedResource(currentRow.ID,currentRow.EXTERNAL_ID);
    };

    this.onEditResource = function(widget){
        widget.edit();
        widget.template = widget.formTemplate;
    };

    function goListActivating(widget){
		if(ScreenService.isSwipeOpen(1)){
            if(Validation.isEmpty(widget.container.getActiveWidget().currentRow.ID)){
    			widget.container.getActiveWidget().dataSource.data.pop();
            }
		}
		else{
			widget.activate();
        	localStorageEngine.setLocalVar('/resource', null);
		}
		widget.list(true);
        ScreenService.closePopup();
    }

	this.goList = function(reload){
		var mainWidget = templateManager.container.widgets[0];
		if(reload){
			mainWidget.reload().then(function(){
				goListActivating(mainWidget);
				templateManager.updateTemplate();
			});
		}
		else{
			goListActivating(mainWidget);
		}
	};

    this.refreshType = function(typeName, widget){
        var profileTab = getWidgetProfilesTab();
    	widget.fields.forEach(function(field){
			field.isVisible = true;
    	});
    	if(typeName !== RESOURCE_TYPE_ASSET){
    		widget.getField('ASSET_TYPE_NAME').isVisible = false;
    	}
    	if(typeName !== RESOURCE_TYPE_WORK){
            profileTab.isVisible = false;
    		widget.getField('EMAIL').isVisible = false;
    		widget.getField('STRUCTURE_NAME').isVisible = false;
            widget.getField('PROFILE_NAME').isVisible = false;
            widget.getField('RATING').isVisible = false;
    	}
    	if(typeName !== RESOURCE_TYPE_WORK || editingResource){
    		widget.getField('PASSWORD').isVisible = false;
    		widget.getField('CONFIRM_PASSWORD').isVisible = false;
    	}
    };

    this.mainResourceTabActionEventSave = function (args) {
        var widget = getWidgetMainResourceTab();
        var currentRow = widget.currentRow;

        if (widget.isValid()) {
            currentRow.changed = true;
            saveResource(currentRow);
        }
    };

    var saveResource = function(currentRow){
        ResourceService.saveResource(currentRow).then(function(response) {
            if(response.dataset.ResourceInfo[0]) {
                var id = response.dataset.ResourceInfo[0];
                var externalId = currentRow.EXTERNAL_ID;
                var widget = getWidgetResourceList();
                ScreenService.showLoader();
                widget.reload().then(function() {
                    ScreenService.hideLoader();
                    getWidgetResourceList().setCurrentRow(Utilities.getRowInDataSource(widget.dataSource, 'ID', id));
                    setTabbedResource(id,externalId);
                    var mainResourceTabWidget = getWidgetMainResourceTab();
                    mainResourceTabWidget.reload();
                    mainResourceTabWidget.view();
                    mainResourceTabWidget.template = mainResourceTabWidget.templateToView;
                }).catch(ScreenService.hideLoader);
            }
        }).catch(function (error) {
			ScreenService.showMessage(getErrorMessage(error));
        });
    };

	var getErrorMessage = function (error) {
		var message = error.data.error;
		if(error.data.error.indexOf('USER_EMAIL_UK') != -1) {
			message = Messages.ERR_SAVE_IDENTITY_USER_EMAIL_UK;
		} else if(error.data.error.indexOf('RESOURCE_T_EMAIL_UK') != -1) {
			message = Messages.ERR_SAVE_RESOURCE_T_EMAIL_UK;
		}

		return message;
	};

    var getIdentityData  = function(currentRow){
        var row          = {};
        row.NAME         = currentRow.NAME;
        if(currentRow.ID === undefined){
            currentRow.ID = null;
        }
        row.ID           = currentRow.ID;
        var name         = currentRow.NAME.split(" ");
        row.FIRSTNAME    = name[0];
        row.LASTNAME     = name[name.length - 1];
        row.PASSWORD     = currentRow.PASSWORD;
        row.STATUS       = currentRow.STATUS;
        row.EMAIL        = currentRow.EMAIL;
        row.TOKEN        = localStorageEngine.getLocalVar('token');
        return row;
    };

    this.onAddTabRow = function(widget){
    	widget.newRow();
    	ScreenService.openSwipe(widget);
    };

    var reloadTab = function(widget){
        self.goList();
        widget.reload().then(function(){
            templateManager.updateTemplate();
        });
    };

    this.onSaveTabRow = function(widget){
    	var row = widget.currentRow;
    	row.RESOURCE = localStorageEngine.getLocalVar('/resource');
        var widgetName = widget.name;
        if(widgetName === 'AVAILABILITY_TAB'){
            ResourceService.saveAvailability(row).then(function(){
                reloadTab(widget);
            });
        }
        if(widgetName === 'COST_TAB'){
            ResourceService.saveCost(row).then(function(){
                reloadTab(widget);
            });
        }
    };

    this.onRemoveTabRow = function(widget){
    	widget.removeCheckedRows();
    };

    this.onTabRowClicked = function(widget){
    	widget.edit();
    	ScreenService.openSwipe(widget);
    };

    function isParentInArray(structure){
    	return structure.ID === this.parent;
    }

    this.onClickStructureSelect = function(field){
    	field.dataSource.data.forEach(function(structure, index, structures){
    		var filter = {
    			'parent': structure.PARENT
    		};
    		if(Validation.isEmpty(structures.filter(isParentInArray, filter))){
    			structures[index].PARENT = null;
    		}
    	});
    	templateManager.updateTemplate();
    };

    this.afterLoadTab = function(widget){
        if(!Validation.isEmpty(widget.dataSource.data)){
        	widget.moveToFirst();
        }
        if(widget.name === 'MAIN_RESOURCE_TAB' && widget.currentRow){
            this.refreshType(widget.currentRow.TYPE_CONTROL, widget);
        }
    };

    this.editCalendar = function(widget){
        ScreenService.openWindow('product#edit_calendar');
        CalendarService.windowBack = 'resources';
        CalendarService.businessPartner = widget.container.widgets[1].widgets[0].currentRow.BP_ID;
        CalendarService.asset = widget.container.widgets[1].widgets[0].currentRow.ASSET_ID;
        CalendarService.cost = widget.container.widgets[1].widgets[0].currentRow.COST_ID;
        CalendarService.entity = widget.container.widgets[1].widgets[0].currentRow.NAME_ENTITY;
        CalendarService.editRow = widget.currentRow;
    };

    this.toggleEffectiveDate = function(effectiveDateField){
        effectiveDateField.isVisible = !effectiveDateField.isVisible;
    };

    this.profilesTabActionEventAdd = function(){
        var userProfiles =  getWidgetProfilesTab().dataSource.data.map(function(row){
           return row.ID;
        });
        Utilities.localVar.setUserProfiles(userProfiles);
        var newProfileWidget = getWidgetNewProfile();
        newProfileWidget.reload().then(function(){
            ScreenService.openPopup(newProfileWidget);
        });
    };

    this.onRemoveProfile = function(widget){
        ScreenService.confirmMessage(Messages.ALE_DELETE_ACCESS_PROFILES, 'CONFIRMATION', removeProfileCheckedRows);
    };

    var removeProfileCheckedRows = function() {
        var widget = getWidgetProfilesTab();
        widget.dataSource.remove([widget.currentRow]).then(function(){
            Utilities.genericBackEvent(widget);
        });
    };

    this.filterPopUpActionEventCancel = function() {
        Utilities.genericBackEventIsNotMasterDetail(getWidgetResourceList(), true);
    };

    this.onBackNewProfile = function(){
        var profilesWidget = getWidgetProfilesTab();
        profilesWidget.list();
        ScreenService.closePopup();
    };

    this.newProfileWidgetActionEventBack = function(args){
        ScreenService.closePopup();
        getWidgetProfilesTab().reload();
        getWidgetProfilesTab().activate();
    };

    this.profilesTabActionEventBackView = function(args){
        Utilities.genericBackEventIsNotMasterDetail(getWidgetProfilesTab());
    };

    this.wgChangePasswordTabActionEventSave = function(args){
        var changePasswordWidget = getWidgetWgChangePassword();
        ResourceService.editResourcePassword(changePasswordWidget.currentRow);
    };

    this.mainResourceTabActionEventAcChangePassword = function(args){
        var changePasswordWidget = getWidgetWgChangePassword();
        var email = getWidgetMainResourceTab().currentRow.EMAIL;
        if(email){
            ResourceService.openPopupResetResourcePassword(changePasswordWidget,email);
        }else{
            ScreenService.showMessage('Para alterar a senha o recurso deve possuir email');
        }

    };

    var setProfileTabFields = function(profilesWidget, widget) {
        profilesWidget.currentRow = {};
        profilesWidget.currentRow.changed = true;
        profilesWidget.currentRow.NRPERFILACESSO = widget.currentRow.NRPERFILACESSO;
        profilesWidget.currentRow.RESOURCE_ID = localStorageEngine.getLocalVar('/resource');
    };

    this.newProfilesWidgetAfterMoveRow = function() {
        var profilesWidget = getWidgetProfilesTab();
        var widget = getWidgetNewProfile();
        setProfileTabFields(profilesWidget, widget);
        profilesWidget.saveRow().then(function () {
            ScreenService.showLoader();
            profilesWidget.reload().then(function () {
                ScreenService.hideLoader();
                ScreenService.closePopup();
                profilesWidget.list();
                ScreenService.successNotification(Utilities.messages.SUC_PERFIL_RESOURCE_ADD);
            }).catch(ScreenService.hideLoader);
        }).catch(Utilities.showMessageBackEndTrue);
    };

    var isResourceTypeWork =function(resourceType){
        return resourceType.CONTROL === RESOURCE_TYPE_WORK;
    };

    this.onEnterNewResource = function(widget){
        if(Validation.isEmpty(widget.currentRow.TYPE_CONTROL)){
            var firstResourceType = widget.getField('TYPE_NAME').dataSource.data.filter(isResourceTypeWork);
            firstResourceType = firstResourceType[0];
            widget.currentRow.TYPE = firstResourceType.ID;
            widget.currentRow.TYPE_NAME = firstResourceType.LABEL;
            widget.currentRow.TYPE_CONTROL = firstResourceType.CONTROL;
        }
        this.refreshType(widget.currentRow.TYPE_CONTROL, widget);
        templateManager.updateTemplate();
    };

    this.openFilterPopup = function(widget) {
        var filterWidget = getWidgetFilterResource();
        ScreenService.openPopup(filterWidget);
    };

    this.filterResource = function(widget){
        var parent = getWidgetResourceList();
        FilterService.parentFilter(parent, widget).then(function(){
            ScreenService.closePopup();
            parent.activate();
        });
    };

    this.responsibleFieldFieldOnChange = function(args){
        var filterRowIdProperty =  getFieldResponsibleFromWidgetResourceList().valueField;
        var resourceIds = getWidgetFilterResource().currentRow[filterRowIdProperty];
        reloadStructureField(resourceIds);
    };

    var setResponsibleFieldValue = function(resourceId){
        var responsibleField = getFieldResponsibleFromWidgetResourceList();
        responsibleField.value([resourceId]);
        reloadStructureField([resourceId]);
    };

    var reloadStructureField = function(resourceIds){
        localStorageEngine.setLocalVar('responsibleId',resourceIds);
        var structureField = getFieldStructureFromWidgetResourceList();
        structureField.reload().then(function(){
            structureField.value([]);
        });
    };

    var getWidgetBasicCalendar = function () {
        return templateManager.container.getWidget('BASIC_CALENDAR');
    };
    var getFieldBaseCalendarFromWidgetBasicCalendar = function () {
        return getWidgetBasicCalendar().getField('BASE_CALENDAR');
    };

    this.saveCalendar = function (widgetBasicCalendar) {
        widgetBasicCalendar.currentRow.STRUCTURE = Utilities.localVar.getStructureId();
        widgetBasicCalendar.saveRow().then(function(){
            getWidgetBasicCalendar().reload();
        });
    };
    this.basicCalendarWidgetAfterLoadDataSource = function (args) {
        var widget = args.owner;
        if (widget.dataSource.data.length) {
            widget.currentRow = widget.dataSource.data[0];
        } else {
            widget.newRow();
            widget.list();
        }
        Utilities.localVar.setCalendarId(widget.currentRow.ID);
        var baseCalendarField = getFieldBaseCalendarFromWidgetBasicCalendar();
        baseCalendarField.reload().then(function () {
            Utilities.setAllFieldsSelectByValueInCurrentRow(widget);
        });
        widget.widgets.forEach(function (childWidget) {
            childWidget.reload();
        });
    };

    this.calendarListOnChangeBaseCalendar = function (args) {
        var calendarBaseName = args.row.BASE_CALENDAR;
        var widgetBasicCalendar = getWidgetBasicCalendar();
        var message = '';
        if (calendarBaseName) {
            message = 'Deseja salvar o calendário "' + calendarBaseName + '" como a base para este recurso';
        } else {
            message = 'Deseja excluir o calendário desse recurso?';
        }
        ScreenService.showCustomDialog(message, 'CONFIRMATION', null,
            [
                {
                    "label": "Continuar",
                    "code": function () {
                        self.saveCalendar(widgetBasicCalendar);
                    }
                },
                {
                    "label": "Cancelar",
                    "code": function () {
                        getWidgetBasicCalendar().reload();
                    }
                }
            ]
        );
    };

    var __goBackSwipeLevel1 = function () {
        ScreenService.closeSwipe();
        getWidgetResourceList().activate();
    };

    this.calendarActionEventCancel = function (args) {
        Utilities.genericBackEventIsNotMasterDetail(getWidgetResourceList());
    };
    this.exceptionListActionEventCancel = function (args) {
        Utilities.genericBackEventIsNotMasterDetail(getWidgetResourceList());
    };

    this.hourWeekListActionEventCancel = function (args) {
        Utilities.genericBackEventIsNotMasterDetail(getWidgetResourceList());
    };

    this.mainResourceTabActionEventCancel = function (args) {
        Utilities.genericCancelEventIsNotMasterDetail(getWidgetMainResourceTab(),getWidgetResourceList());
    };

    this.mainResourceTabActionEventBack = function (args) {
        Utilities.genericBackEventIsNotMasterDetail(getWidgetResourceList());
    };

    this.profilesTabActionEventBack = function (args) {
        Utilities.genericBackEventIsNotMasterDetail(getWidgetResourceList());
    };

    var getWidgetCalendar = function () {
        return templateManager.container.getWidget('CALENDAR');
    };

    var getWidgetExceptionList = function () {
        return templateManager.container.getWidget('EXCEPTION_LIST');
    };
    var getWidgetNewException = function () {
        return templateManager.container.getWidget('NEW_EXCEPTION');
    };
    var getWidgetTabbedException = function () {
        return templateManager.container.getWidget('TABBED_EXCEPTION');
    };
    var getWidgetHourWeekList = function () {
        return templateManager.container.getWidget('HOUR_WEEK_LIST');
    };
    var getWidgetHourWeekTabbed = function () {
        return templateManager.container.getWidget('HOUR_WEEK_TABBED');
    };
    var getWidgetNewHourWeek = function () {
        return templateManager.container.getWidget('NEW_HOUR_WEEK');
    };

    this.newHourWeekActionEventCancelForm = function (args) {
        CalendarService.newHourWeekActionEventCancelForm(getWidgetNewHourWeek(),getWidgetHourWeekList());
    };

    this.newHourWeekActionEventCancel = function (args) {
        var newHourWeekWidget = getWidgetNewHourWeek();
        Utilities.genericCancelEvent(newHourWeekWidget);
        if(newHourWeekWidget.currentRow.__is_new){
            getWidgetHourWeekList().activate();
        }else {
            newHourWeekWidget.template = newHourWeekWidget.templateToView;
        }
    };

    this.newHourWeekActionEventSave = function (args) {
        CalendarService.newHourWeekActionEventSave(getWidgetNewHourWeek(),getWidgetHourWeekList());
    };
    this.hourWeekListWidgetAfterMoveRow = function (args) {
        CalendarService.hourWeekListWidgetAfterMoveRow(args.row,getWidgetHourWeekTabbed(),getWidgetNewHourWeek());
        getWidgetHourWeekTabbed().descriptionOrder = getWidgetHourWeekList().descriptionOrder;
    };
    this.hourWeekListActionEventDelete = function (args) {
        ScreenService.confirmMessage(Utilities.messages.ALO_DELETE_HOUR_WEEK, null, self.hourWeekListDelete) ;
    };
    this.hourWeekListDelete = function(){
        CalendarService.exceptionListActionEventDelete(getWidgetHourWeekList());
    };
    this.hourWeekListActionEventNew = function (args) {
        if(Utilities.localVar.getCalendarId()){
            getWidgetHourWeekTabbed().descriptionOrder = "";
            CalendarService.hourWeekListActionEventNew(getWidgetHourWeekTabbed(),getWidgetNewHourWeek());
        }else{
            var message = Utilities.messages.ALO_IS_NOT_POSSIBLE_ADD_HOUR_WEEK_PART_1+'recurso'+
                Utilities.messages.ALO_IS_NOT_POSSIBLE_ADD_HOUR_WEEK_PART_2;
            ScreenService.showMessage(message);
        }
    };
    this.exceptionListFieldOnChangeWeekDayExceptionMonth = function (args) {
        CalendarService.exceptionListFieldOnChangeWeekDayExceptionMonth(args.owner.field,getWidgetNewException());
    };
    this.exceptionListFieldOnChangeWeekDayExceptionYear = function (args) {
        CalendarService.exceptionListFieldOnChangeWeekDayExceptionYear(args.owner.field,getWidgetNewException());
    };
    this.exceptionListFieldOnChangeYearDayExceptionMonth = function (args) {
        CalendarService.exceptionListFieldOnChangeYearDayExceptionMonth(args.owner.field,getWidgetNewException());
    };
    this.exceptionListFieldOnChangeYearDayExceptionYear = function (args) {
        CalendarService.exceptionListFieldOnChangeYearDayExceptionYear(args.owner.field,getWidgetNewException());
    };
    this.exceptionListFieldOnChangeRecurrenceType = function (args) {
        CalendarService.exceptionListFieldOnChangeRecurrenceType(Utilities.getFieldByArgs(args),getWidgetNewException());
    };
    this.exceptionListFieldOnChangeExceptionDataEnd = function (args) {
        CalendarService.exceptionListFieldOnChangeExceptionDataEnd(getWidgetNewException());
    };
    this.exceptionListFieldOnChangeExceptionQuantitative = function (args) {
        CalendarService.exceptionListFieldOnChangeExceptionQuantitative(getWidgetNewException());
    };
    this.exceptionListFieldOnChangeType = function (args) {
        CalendarService.exceptionListFieldOnChangeType(args.owner.value(),getWidgetNewException());
    };
    this.newExceptionActionEventEdit = function (args) {
        CalendarService.newExceptionActionEventEdit(getWidgetNewException());
    };
    this.newExceptionActionEventCancelForm = function (args) {
        CalendarService.newExceptionActionEventCancelForm(getWidgetExceptionList());
    };
    this.newExceptionActionEventCancel = function (args) {
        CalendarService.newExceptionActionEventCancel(getWidgetNewException(), getWidgetExceptionList());
    };
    this.newExceptionActionEventSave = function (args) {
        CalendarService.newExceptionActionEventSave(getWidgetNewException(),getWidgetExceptionList());
    };
    this.exceptionListWidgetAfterMoveRow = function (args) {
        CalendarService.exceptionListWidgetAfterMoveRow(args.row.ID,getWidgetTabbedException(),getWidgetNewException());
        getWidgetTabbedException().descriptionOrder = getWidgetExceptionList().descriptionOrder;
    };
    this.exceptionListActionEventDelete = function (args) {
        ScreenService.confirmMessage(Utilities.messages.ALO_DELETE_EXCEPTION,null, self.exceptionListDelete) ;
    };
    this.exceptionListDelete = function(){
        CalendarService.exceptionListActionEventDelete(getWidgetExceptionList());
    };
    this.exceptionListActionEventNew = function (args) {
        if(Utilities.localVar.getCalendarId()){
            CalendarService.exceptionListActionEventNew(getWidgetTabbedException(),getWidgetNewException());
            getWidgetTabbedException().descriptionOrder = "";
        }else{
            var message = Utilities.messages.ALO_IS_NOT_POSSIBLE_ADD_EXCEPTION_PART_1+'recurso'+
                Utilities.messages.ALO_IS_NOT_POSSIBLE_ADD_EXCEPTION_PART_2;
            ScreenService.showMessage(message);
        }
    };
    this.calendarWidgetAfterLoadDataSource = function (args) {
        CalendarService.calendarWidgetAfterLoadDataSource(getWidgetCalendar());
    };
    this.newHourWeekFieldOnChangeTypeSunday = function (args) {
        var field = Utilities.getFieldByArgs(args);
        CalendarService.setFieldWorkTimeByTypeField(field);
    };

    this.newHourWeekFieldOnChangeTypeMonday = function (args) {
        var field = Utilities.getFieldByArgs(args);
        CalendarService.setFieldWorkTimeByTypeField(field);
    };

    this.newHourWeekFieldOnChangeTypeThuesday = function (args) {
        var field = Utilities.getFieldByArgs(args);
        CalendarService.setFieldWorkTimeByTypeField(field);
    };

    this.newHourWeekFieldOnChangeTypeWednesday = function (args) {
        var field = Utilities.getFieldByArgs(args);
        CalendarService.setFieldWorkTimeByTypeField(field);
    };

    this.newHourWeekFieldOnChangeTypeThursday = function (args) {
        var field = Utilities.getFieldByArgs(args);
        CalendarService.setFieldWorkTimeByTypeField(field);
    };

    this.newHourWeekFieldOnChangeTypeFriday = function (args) {
        var field = Utilities.getFieldByArgs(args);
        CalendarService.setFieldWorkTimeByTypeField(field);
    };

    this.newHourWeekFieldOnChangeTypeSaturday = function (args) {
        var field = Utilities.getFieldByArgs(args);
        CalendarService.setFieldWorkTimeByTypeField(field);
    };

    this.newHourWeekActionEventEdit = function (args) {
        CalendarService.newHourWeekActionEventEdit(getWidgetNewHourWeek());
    };

    this.calendarWidgetOnChangeMonth = function(args){
        getWidgetCalendar().reload();
    };

    this.getMonthFromWidgetCalendar = function(){
        if(templateManager.container){
            return CalendarService.getMonthFromWidgetCalendar(getWidgetCalendar());
        }else{
            return 1;
        }
    };

    this.getYearFromWidgetCalendar = function() {
        if(templateManager.container){
            return CalendarService.getYearFromWidgetCalendar(getWidgetCalendar());
        }else{
            return 1;
        }
    };

    this.calendarWidgetAfterMoveRow = function (args) {
        var dataPM = args.owner.dataSource.dataPM;
        var rowMove = args.row;
        CalendarService.calendarWidgetAfterMoveRow(dataPM,rowMove);
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('ResourceController', ResourceController);
});


// FILE: assets/js/Controller/Sponsor.js
function SponsorController(SponsorService, ScreenService, localStorageEngine, templateManager, Utilities, Messages, ZhFilterPreferences) {

    var self = this;
    
    var getListWidget = function(){
        return templateManager.container.getWidget('LIST');
    };
    
    var getListProjectWidget = function(){
        return templateManager.container.getWidget('LIST_PROJECT');
    };

    var getContactWidget = function(){
        return templateManager.container.getWidget('CONTACT');
    };
    
    var getDataSponsorWidget = function(){
        return templateManager.container.getWidget('DATA_SPONSOR');
    };
    
    var getBasicWidget = function(){
        return templateManager.container.getWidget('BASIC');
    };

    var getFieldPhoneContactWidget = function(){
        return getContactWidget().getField("PHONE");
    };
    
    var getFieldProjectStatusFromListProjectWidget = function(){
        return getListProjectWidget().getField('PROJECT_STATUS');
    };

    this.saveExceptionLocal = function (widget, widgetList) {
        SponsorService.saveExceptionLocal(widget, widgetList);
    };
    
    this.contactActionEventDelete = function(args){
        var widget = getContactWidget();
        ScreenService.confirmMessage(Utilities.messages.ALE_DELETE_CONTACT, 'question', function(){
            widget.dataSource.checkedRows = [widget.currentRow];
            widget.removeCheckedRows();
            widget.unSelectAll();
            ScreenService.closeSwipe();
        });
    };
    
    this.saveContactLocal = function (widget, widgetList) {
        SponsorService.createContactLocal(widget, widgetList);
    };
    
    this.addExceptionCalendar = function (owner) {
        var widget = owner.widget;
        ScreenService.openPopup(widget.widgets[0]);
        widget.widgets[0].newRow();
        widget.widgets[0].getField('STATUS').value(true);
    };

    this.listActionEventAdd = function(args){
        changeTemplates();
        Utilities.localVar.setSponsor(null);
        newSponsor(args.owner);
    };

    this.contactActionEventEdit = function(args){
        changeTemplates(true);
        SponsorService.moveRowContactList(args, false);
    };

    this.contactActionEventAdd = function(args){
        var widget = getContactWidget();
        ScreenService.openSwipe(widget);
        widget.newRow();
        widget.edit();
        Utilities.localVar.setLocalVarState(null);
        Utilities.localVar.setLocalVarCountry(null);

    };
    
    var newSponsor = function(widget){
        var basicWidget  = getBasicWidget();
        var tabbedWidget = getDataSponsorWidget();
        ScreenService.openSwipe(tabbedWidget).then(function(){
            tabbedWidget.descriptionOrder = "";
            getListWidget().descriptionOrder = "";
            basicWidget.newRow();
            basicWidget.template = basicWidget.formTemplate;
            setVisibleAllWidgetFields(basicWidget);
            setVisibleDataSponsorBasicTab();
        });
    };
    
    var setVisibleAllWidgetFields = function(widget){
        widget.fields.forEach(function(field){
            field.isVisible = true;
        });
    };
    
    var setVisibleAllDataSponsorTabs = function(){
        getDataSponsorWidget().widgets.forEach(function(tab){
            tab.isVisible = true;
        });
    };
    
    var setVisibleDataSponsorBasicTab = function(){
        getDataSponsorWidget().widgets.forEach(function(tab){
            tab.isVisible = (tab.name === "BASIC");
        });
    };
   
    this.listWidgetOnEnter = function(args){
        var widget = getListWidget();
        if (widget.appliedFilter){
            widget.reload();
        } else {
            var currentRow = {"STATUS": "A"};
            Utilities.startFilter(widget, currentRow);
        }
        Utilities.localVar.setSponsor('/sponsor', null);
        widget.list();
        widget.activate();
    };
    
    this.moveRowContactLocal = function (widget, row) {
        ScreenService.openPopup(widget);
        SponsorService.moveRowContactLocal(widget, row);
    };
    
    var clearRowValues = function(row, properties){
        properties.forEach(function(property){
            if (row.hasOwnProperty(property)){
                row[property] = null;
            }
        });
    };

    this.countryOnChange = function (args) {
        SponsorService.reloadStateByCountry(args.row.COUNTRY, args.owner.field.widget.getField('STATE_NAME'));
        clearRowValues(args.row, ["CITY", "CITY_NAME", "STATE", "STATE_NAME"]);
    };

    this.stateOnChange = function (args) {
        SponsorService.reloadCityByState(args.row.STATE, args.owner.field.widget.getField('CITY_NAME'));
        clearRowValues(args.row, ["CITY", "CITY_NAME"]);
    };
    
    var changeWidgetToEditingMode = function(widget){
        widget.edit();
        widget.template = widget.formTemplate;
        widget.fields.forEach(function(field){
            field.isVisible = true;
        });
    };
    
    var backToWidget = function(widget){
        ScreenService.goBack().then(function(){
            widget.activate();
        });
    };
    
    this.listProjectActionEventBack = function(args){
        backToList();
    };
    
    this.contactActionEventBackView = function(args){
        ScreenService.closeSwipe();
    };

    this.contactActionEventBack = function(args){
        backToList();
    };

    this.contactActionEventBackEdit = function(args){
        var contactWidget = getContactWidget();
        Utilities.genericCancelEvent(contactWidget, "CONTACT");
        changeTemplates();
    };

    this.contactActionEventSave = function(args){
        var widget = getContactWidget();
        var fieldsToValidate = widget.fields.filter(function (field) {
            return field.pmValidate;
        });
        var hasValue = fieldsToValidate.some(function (field) {
            return !!field.value();
        });
        if (fieldsToValidate.length > 0 && !hasValue){
            ScreenService.showMessage(Utilities.messages.ERR_IS_VALIDATE_CONTACT);
        } else {
            widget.currentRow.SPONSOR = getLocalVar('/sponsor');
            widget.saveRow().then(function(response){
                widget.reload().then(function(){
                    widget.view();
                    widget.setCurrentRow(Utilities.getRowInDataSource(widget.dataSource, 'CONTACT',  response.dataset.contact.ID));
                    changeTemplates();
                });
            }).catch(Utilities.showMessageBackEndTrue);
        }
    };

    this.basicActionEventEdit = function(args){
        changeWidgetToEditingMode(args.owner.widget);
    };

    this.basicActionEventSave = function(args){
        var widget = getBasicWidget();
        saveSponsor(widget);
    };
   
    this.basicActionEventBack = function(args){
        backToList();
    };

    var backToList = function(){
        ScreenService.closeSwipe().then(function(){
            getListWidget().activate();
        });
    };

    this.basicActionEventCancel = function(args){
        if(getBasicWidget().currentRow.__is_new){
            backToList();
        }else {
            Utilities.fixBugReloadWidgetInViewMode(getBasicWidget());
        }
    };

    var saveSponsor = function(widget){
        if (widget.isValid()){
            SponsorService.saveEditSponsor(Utilities.getWidgetCurrentRowAsChanged(widget)).then(function(response){
                var resourceId = response.dataset.ResourceInfo[0];
                var listWidget = getListWidget();
                widget.view();
                var filter = [{
                   "name": "ID",
                   "value": resourceId,
                   "operator": "="
                }];
                
                Utilities.setDataSourceAfterSave(listWidget, filter, "ID").then(function(){
                    widget.template = widget.templateToView;
                    listWidget.setCurrentRow(Utilities.getRowInDataSource(listWidget.dataSource, 'ID', resourceId));
                });
            }).catch(Utilities.showMessageBackEndTrue);
        }
    };

    this.basicActionEventRemove = function(args){
        deleteSponsor(args.owner.widget);
    };

    var deleteSponsor = function(widget){
        ScreenService.confirmMessage(Messages.ALE_ARE_YOU_SURE_DELETE_SPONSORS, null, function(){
            widget.removeRow().then(function(){
                var listWidget = getListWidget();
                listWidget.reload();
                backToWidget(listWidget);
            });
        });
    };

    var changeTemplates = function(isEdit){
        getFieldPhoneContactWidget().template = isEdit ? "field/phone.html" : "field/text-edit.html";
    };
    
    this.listWidgetAfterMoveRow = function(args){
        getDataSponsorWidget().descriptionOrder = getListWidget().descriptionOrder;
        saveClickedSponsorInLocalStorage(getListWidget().currentRow.ID);
        openSponsorInformationSwipe();
        setVisibleAllDataSponsorTabs();
    };
    
    var saveClickedSponsorInLocalStorage = function(sponsorId){
        Utilities.localVar.setSponsor(sponsorId);
    };
    
    this.basicWidgetOnEnterTab = function(args){
        var widget = getBasicWidget();
        if (!widget.isNewRow()){
            widget.reload();
        }
    };
    
    var activateWidgetTab = function(widget, defaultWidget){
        var toActivate = widget.currentWidget || defaultWidget;
        if(toActivate.mode == 'list'){
            toActivate.reload();
        }else {
            Utilities.fixBugReloadWidgetInViewMode(toActivate);
        }
    };
    
    var openSponsorInformationSwipe = function() {
        var tabbedWidget = getDataSponsorWidget();
        ScreenService.openSwipe(tabbedWidget).then(function(){
            activateWidgetTab(tabbedWidget, getBasicWidget());
        });
    };

    this.basicWidgetAfterLoadDataSource = function(args){
        var widget = args.owner;
        widget.moveToFirst();
        widget.list();
        widget.template = widget.formTemplate;
    };
    
    this.listProjectWidgetOnEnterTab = function(args){
        var listProductWidget = getListProjectWidget();
        if(listProductWidget.filterApplied) {
            listProductWidget.reload();
        } else {
            setDefaultFilterValuesFromListProductWidget();
        }
    };
    
    var setDefaultFilterValuesFromListProductWidget = function(){
        var listProductWidget = getListProjectWidget();
        var projectStatusField = getFieldProjectStatusFromListProjectWidget();
        projectStatusField.reload().then(function(){
            Utilities.setDefaultValuesToSelectMultipleField(projectStatusField, ['N', 'D', 'O', 'P'], 'CONTROL');
            ZhFilterPreferences.setOriginalFilter(listProductWidget, listProductWidget.currentRow);
        });
    };

    this.contactWidgetOnEnterTab = function(args){
        var contactWidget = getContactWidget();
        if(contactWidget.filterApplied) {
            contactWidget.reload();
        } else {
            setDefaultFilterValuesFromContactWidget();
        }
    };
    
    var setDefaultFilterValuesFromContactWidget = function(){
        var contactWidget = getContactWidget();
        contactWidget.currentRow.STATUS = 'A';
        ZhFilterPreferences.setOriginalFilter(contactWidget, contactWidget.currentRow);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('SponsorController', SponsorController);
});





// FILE: assets/js/Controller/Structure.js
function StructureController(ScreenService, StructureService, Utilities, Validation, templateManager,CalendarService, ZhFilterPreferences) {

    var ADMINISTRATOR_PROFILE = 'A';
    var STATUS_ACTIVE = 'A';

    var container;


    var getWidgetTabbedStructure = function () {
        return templateManager.container.getWidget('TABBED_STRUCTURE');
    };

    var getWidgetStructureList = function () {
        return templateManager.container.getWidget('STRUCTURE_LIST');
    };

    var getWidgetBasicStructure = function () {
        return templateManager.container.getWidget('BASIC_STRUCTURE');
    };

    var getFieldParentNameFromBasicStructure = function () {
        return getWidgetBasicStructure().getField('PARENT_NAME');
    };

    var getFieldNameFromBasicStructure = function () {
        return getWidgetBasicStructure().getField('NAME');
    };

    this.basicStructureActionEventEdit = function (args) {
        var container = args.owner.widget.container;
        var widgetBasic = container.getWidget("BASIC_STRUCTURE");
        widgetBasic.edit();
        widgetBasic.template = widgetBasic.formTemplate;
        widgetBasic.fields.forEach(function (field) {
            field.isVisible = true;
        });
        widgetBasic.currentRow.OLD_PARENT = widgetBasic.currentRow.PARENT;
        widgetBasic.currentRow.OLD_PARENT_NAME = widgetBasic.currentRow.PARENT_NAME;
    };

    var validationTimeSheetRequired = function (widget) {
        return widget.currentRow.TIME_SHEET_REQUIRED_OLD && widget.currentRow.IS_PARENT;
    };

    this.parentNameFieldOnChange = function(args){
        var parentField = getFieldParentNameFromBasicStructure();
        var widget = getWidgetBasicStructure();
        if(widget.currentRow.CHILD == 'Y'){
            ScreenService.showMessage(Utilities.messages.ALE_SAVE_SAME_STRUCTURE_AS_PARENT, "ALERT");
            parentField.value(widget.currentRow.OLD_PARENT_NAME);
            widget.currentRow.PARENT = widget.currentRow.OLD_PARENT;
            widget.currentRow.PARENT_NAME = widget.currentRow.OLD_PARENT_NAME;
        }
    };

    var saveStructureInMessageTimeSheetRequired = function (widget, args, replicateTimeSheetRequired) {
        var row = widget.currentRow;
        row.REPLICATE_TIME_SHEET_REQUIRED = replicateTimeSheetRequired;
        StructureService.saveStructure(widget.currentRow).then(function (response) {
            var structureId = response.dataset.structure.ID;
            var widgetList = getWidgetStructureList();
            Utilities.keepOpenList(widgetList).then(function(){
                var basicStructureWidget = getWidgetBasicStructure();
                basicStructureWidget.currentRow.ID = structureId;
                Utilities.fixWidgetToViewAfterSaveRow(basicStructureWidget);
                widgetList.setCurrentRow(Utilities.getRowInDataSource(widgetList.dataSource, 'ID', structureId));
            });
        });
    };

    this.basicStructureActionEventSave = function (args) {
        var widget = getWidgetBasicStructure();
        if (widget.isValid()) {
            if (validationTimeSheetRequired(widget)) {
                var timeSheetRequired = '';
                if (widget.currentRow.TIME_SHEET_REQUIRED != 'Y') {
                    timeSheetRequired = 'não';
                }
                ScreenService.showCustomDialog('Replicar a obrigação de<br><strong> " ' + timeSheetRequired + ' apropriar diariamente " </strong><br>para as estruturas inferiores?',
                    'CONFIRMATION', null,
                    [
                        {
                            "label": "Sim",
                            "code": function () {
                                saveStructureInMessageTimeSheetRequired(widget, args, true);
                            }
                        },
                        {
                            "label": "Não",
                            "code": function () {
                                saveStructureInMessageTimeSheetRequired(widget, args, false);
                            }
                        }
                    ]
                );
            } else {
                saveStructureInMessageTimeSheetRequired(widget, args, false);
            }
        }
    };


    this.structureListAfterMoveRow = function (args) {
        Utilities.localVar.setStructureId(args.row.ID);
        container = args.owner.container;
        var widgetOld = container.getActiveWidget();
        ScreenService.openSwipe(getWidgetTabbedStructure());
        widgetOld.activate();
        StructureService.openSwipeInfoStructure(args);
        var widgetBasic = getWidgetBasicStructure();
        widgetBasic.list();
        widgetBasic.template = widgetBasic.formTemplate;
        widgetBasic.getField('PARENT_NAME').reload();
        widgetBasic.getField('BUSINESS_PARTNER').reload();
        getWidgetBasicCalendar().reload();
        getWidgetTabbedStructure().descriptionOrder = getWidgetStructureList().descriptionOrder;
    };
    this.goBackStructure = function (args) {
        args.owner.widget.list();
        ScreenService.goBack();
        getWidgetStructureList().activate();
    };
    this.setDataViewStructure = function (data) {
        container.getWidget("BASIC_STRUCTURE").currentRow = data[0];
        container.getWidget("BASIC_STRUCTURE").fields.forEach(function (field) {
            field.isVisible = (!!field.value());
        });
    };

    function isBusinessPartnerAdministrator(businessPartner) {
        return businessPartner.CONTROL === ADMINISTRATOR_PROFILE;
    }

    this.openSwipeNewStructure = function (args) {
        container = args.owner.widget.container;
        var widgetBasic = container.getWidget("BASIC_STRUCTURE");
        var parentName = getFieldNameFromBasicStructure().value();
        var parent = widgetBasic.currentRow.ID;
        var parentNameField = getFieldParentNameFromBasicStructure();
        ScreenService.openSwipe(container.getWidget("TABBED_STRUCTURE"));
        widgetBasic.newRow();
        Utilities.localVar.setStructureId(0);
        widgetBasic.template = widgetBasic.formTemplate;
        widgetBasic.currentRow.PARENT = parent;
        parentNameField.value(parentName);
        parentNameField.reload();
        widgetBasic.currentRow.STATUS = STATUS_ACTIVE;
        widgetBasic.getField('BUSINESS_PARTNER').reload().then(function (data) {
            var administrator = data.dataset.businessPartnerEdit.filter(isBusinessPartnerAdministrator);
            administrator = administrator[0];
            if (administrator) {
                widgetBasic.currentRow.BUSINESS_PARTNER = [administrator.ID];
            }
        });
        container.getWidget("BASIC_STRUCTURE").fields.forEach(function (field) {
            field.isVisible = true;
        });
    };

    this.structureListActionEventAdd = function(args){
        container = args.owner.widget.container;
        ScreenService.openSwipe(container.getWidget("TABBED_STRUCTURE"));
        var widgetBasic = getWidgetBasicStructure();
        var parentNameField = getFieldParentNameFromBasicStructure();
        widgetBasic.newRow();
        Utilities.localVar.setStructureId(0);
        widgetBasic.template = widgetBasic.formTemplate;
        widgetBasic.currentRow.STATUS = STATUS_ACTIVE;
        parentNameField.reload();
        widgetBasic.getField('BUSINESS_PARTNER').reload().then(function (data) {
            var administrator = data.dataset.businessPartnerEdit.filter(isBusinessPartnerAdministrator);
            administrator = administrator[0];
            if (administrator) {
                widgetBasic.currentRow.BUSINESS_PARTNER = [administrator.ID];
            }
        });
        container.getWidget("BASIC_STRUCTURE").fields.forEach(function (field) {
            field.isVisible = true;
        });
        getWidgetStructureList().descriptionOrder = "";
    };

    this.structureListWidgetOnEnter = function (args) {
        var widget = getWidgetStructureList();
        Utilities.applyDefaultFilterOnEnter(widget, true);
    };
    
    this.structureListPartFilterAfterApply = function(){
        Utilities.setFilterInit(getWidgetStructureList());
    };

    this.basicStructureActionEventCancel = function(args){
        var basicStructure = getWidgetBasicStructure();
        Utilities.genericCancelEvent(basicStructure);
        if(basicStructure.currentRow.__is_new){
            getWidgetStructureList().activate();
        } else {
            StructureService.openSwipeInfoStructure(args);
        }
        basicStructure.template = basicStructure.templateToView;
    };

    this.deleteStructure = function (args) {
        ScreenService.confirmMessage('Deseja apagar esta estrutura?', null, function () {
            var widget = args.owner.widget;
            if (widget.name == 'BASIC_STRUCTURE') {
                var widgetData = widget.container.getWidget('STRUCTURE_LIST');
                widgetData.remove().then(function () {
                    Utilities.keepOpenList(widgetData);
                    self.goBackStructure(args);
                }).catch(function(response) {
                    ScreenService.showMessage(response.data.error.replace('Exception: ', ''), 'ERROR');
                });
            } else {
                widget.removeCheckedRows().then(function () {
                    Utilities.keepOpenList(widget);
                });
            }
        }, null);
    };

    function filterStructureForParent(structure) {
        return structure.ID === this.parent;
    }

    this.onLoadStructures = function (dataSource) {
        var structures = dataSource.data;
        structures.forEach(function (structure, structureIndex) {
            var param = {
                'parent': structure.PARENTID
            };
            var possibleParents = structures.filter(filterStructureForParent, param);
            if (Validation.isEmpty(possibleParents)) {
                dataSource.data[structureIndex].PARENTID = null;
            }
        });
    };

    this.onAddStructureType = function (widget) {
        ScreenService.openPopup(widget);
        if (Validation.isEmpty(widget.dataSource.data)) {
            widget.newRow();
        }
    };

    this.onSaveNewStructureType = function (widget) {
        var structureTypeField = templateManager.container.getWidget('BASIC_STRUCTURE').getField('STRUCTURE_TYPE_LABEL');
        widget.saveRow().then(function () {
            structureTypeField.reload().then(function () {
                templateManager.updateTemplate();
                ScreenService.closePopup();
            });
        });
    };

    // calendar

    var getWidgetBasicCalendar = function () {
        return templateManager.container.getWidget('BASIC_CALENDAR');
    };
    var getFieldBaseCalendarFromWidgetBasicCalendar = function () {
        return getWidgetBasicCalendar().getField('BASE_CALENDAR');
    };

    this.saveCalendar = function (widgetBasicCalendar) {
        widgetBasicCalendar.currentRow.STRUCTURE = Utilities.localVar.getStructureId();
        widgetBasicCalendar.saveRow().then(function(){
            getWidgetBasicCalendar().reload();
        });
    };
    this.basicCalendarWidgetAfterLoadDataSource = function (args) {
        var widget = args.owner;
        if (widget.dataSource.data.length) {
            widget.currentRow = widget.dataSource.data[0];
        } else {
            widget.newRow();
            widget.list();
        }
        Utilities.localVar.setCalendarId(widget.currentRow.ID);
        var baseCalendarField = getFieldBaseCalendarFromWidgetBasicCalendar();
        baseCalendarField.reload().then(function () {
            Utilities.setAllFieldsSelectByValueInCurrentRow(widget);
        });
        widget.widgets.forEach(function (childWidget) {
            childWidget.reload();
        });
    };

    this.calendarListOnChangeBaseCalendar = function (args) {
        var calendarBaseName = args.row.BASE_CALENDAR;
        var widgetBasicCalendar = getWidgetBasicCalendar();
        var message = '';
        if (calendarBaseName) {
            message = 'Deseja salvar o calendário "' + calendarBaseName + '" como a base para esta estrutura?';
        } else {
            message = 'Deseja excluir o calendário dessa estrutura?';
        }
        ScreenService.showCustomDialog(message, 'CONFIRMATION', null,
            [
                {
                    "label": "Continuar",
                    "code": function () {
                        self.saveCalendar(widgetBasicCalendar);
                    }
                },
                {
                    "label": "Cancelar",
                    "code": function () {
                        getWidgetBasicCalendar().reload();
                    }
                }
            ]
        );
    };

    var __goBackSwipeLevel1 = function () {
        ScreenService.closeSwipe();
        getWidgetStructureList().activate();
    };
    this.calendarActionEventCancel = function (args) {
        __goBackSwipeLevel1();
    };
    this.exceptionListActionEventCancel = function (args) {
        __goBackSwipeLevel1();
    };
    this.hourWeekListActionEventCancel = function (args) {
        __goBackSwipeLevel1();
    };

    var getWidgetCalendar = function () {
        return templateManager.container.getWidget('CALENDAR');
    };

    var getWidgetCalendarList = function () {
        return templateManager.container.getWidget('CALENDAR_LIST');
    };

    var getWidgetExceptionList = function () {
        return templateManager.container.getWidget('EXCEPTION_LIST');
    };
    var getWidgetNewException = function () {
        return templateManager.container.getWidget('NEW_EXCEPTION');
    };
    var getWidgetTabbedException = function () {
        return templateManager.container.getWidget('TABBED_EXCEPTION');
    };
    var getWidgetHourWeekList = function () {
        return templateManager.container.getWidget('HOUR_WEEK_LIST');
    };
    var getWidgetHourWeekTabbed = function () {
        return templateManager.container.getWidget('HOUR_WEEK_TABBED');
    };
    var getWidgetNewHourWeek = function () {
        return templateManager.container.getWidget('NEW_HOUR_WEEK');
    };

    this.newHourWeekActionEventCancelForm = function (args) {
        CalendarService.newHourWeekActionEventCancelForm(getWidgetNewHourWeek(),getWidgetHourWeekList());
    };
    this.newHourWeekActionEventSave = function (args) {
        CalendarService.newHourWeekActionEventSave(getWidgetNewHourWeek(),getWidgetHourWeekList());
    };
    this.hourWeekListWidgetAfterMoveRow = function (args) {
        getWidgetNewHourWeek().currentRow.ID = getWidgetHourWeekList().currentRow.ID;
        getWidgetNewHourWeek().currentRow.STRUCTURE = getWidgetStructureList().currentRow.ID;
        CalendarService.hourWeekListWidgetAfterMoveRow(args.row,getWidgetHourWeekTabbed(),getWidgetNewHourWeek());
    };
    this.hourWeekListActionEventDelete = function (args) {
        ScreenService.confirmMessage(Utilities.messages.ALO_DELETE_HOUR_WEEK, null, function(){
            CalendarService.exceptionListActionEventDelete(getWidgetHourWeekList());
            getWidgetHourWeekList().activate();
        }) ;
    };
    this.hourWeekListDelete = function(){
        CalendarService.exceptionListActionEventDelete(getWidgetHourWeekList());
        getWidgetExceptionList().activate();
    };
    this.hourWeekListActionEventNew = function (args) {
        if(Utilities.localVar.getCalendarId()){
            CalendarService.hourWeekListActionEventNew(getWidgetHourWeekTabbed(),getWidgetNewHourWeek());
        }else{
            var message = Utilities.messages.ALO_IS_NOT_POSSIBLE_ADD_HOUR_WEEK_PART_1+'estrutura'+
                Utilities.messages.ALO_IS_NOT_POSSIBLE_ADD_HOUR_WEEK_PART_2;
            ScreenService.showMessage(message);
        }
    };
    this.exceptionListFieldOnChangeWeekDayExceptionMonth = function (args) {
        CalendarService.exceptionListFieldOnChangeWeekDayExceptionMonth(args.owner.field,getWidgetNewException());
    };
    this.exceptionListFieldOnChangeWeekDayExceptionYear = function (args) {
        CalendarService.exceptionListFieldOnChangeWeekDayExceptionYear(args.owner.field,getWidgetNewException());
    };
    this.exceptionListFieldOnChangeYearDayExceptionMonth = function (args) {
        CalendarService.exceptionListFieldOnChangeYearDayExceptionMonth(args.owner.field,getWidgetNewException());
    };
    this.exceptionListFieldOnChangeYearDayExceptionYear = function (args) {
        CalendarService.exceptionListFieldOnChangeYearDayExceptionYear(args.owner.field,getWidgetNewException());
    };
    this.exceptionListFieldOnChangeRecurrenceType = function (args) {
        CalendarService.exceptionListFieldOnChangeRecurrenceType(Utilities.getFieldByArgs(args),getWidgetNewException());
    };
    this.exceptionListFieldOnChangeExceptionDataEnd = function (args) {
        CalendarService.exceptionListFieldOnChangeExceptionDataEnd(getWidgetNewException());
    };
    this.exceptionListFieldOnChangeExceptionQuantitative = function (args) {
        CalendarService.exceptionListFieldOnChangeExceptionQuantitative(getWidgetNewException());
    };
    this.exceptionListFieldOnChangeType = function (args) {
        CalendarService.exceptionListFieldOnChangeType(args.owner.value(),getWidgetNewException());
    };
    this.newExceptionActionEventEdit = function (args) {
        CalendarService.newExceptionActionEventEdit(getWidgetNewException());
    };
    this.newExceptionActionEventCancelForm = function (args) {
        CalendarService.newExceptionActionEventCancelForm(getWidgetExceptionList());
    };
    this.newExceptionActionEventCancel = function (args) {
        var newException = getWidgetNewException();
        Utilities.genericCancelEvent(newException);
        if(newException.currentRow.__is_new) {
            getWidgetExceptionList().activate();
        }else{
            newException.template = newException.templateToView;
        }
    };

    this.newHourWeekActionEventCancel = function (args) {
        var hourWeek = getWidgetNewHourWeek();
        Utilities.genericCancelEvent(hourWeek);
        if(hourWeek.currentRow.__is_new) {
            getWidgetHourWeekList().activate();
        }else{
            hourWeek.template = hourWeek.templateToView;
        }
    };
    
    this.newExceptionActionEventSave = function (args) {
        CalendarService.newExceptionActionEventSave(getWidgetNewException(),getWidgetExceptionList());
    };
    
    this.exceptionListWidgetAfterMoveRow = function (args) {
        var tabbedExceptionWidget = getWidgetTabbedException();
        var newExceptionWidget = getWidgetNewException();
        newExceptionWidget.currentRow.STRUCTURE = getWidgetStructureList().currentRow.ID;
        newExceptionWidget.currentRow.ID = getWidgetExceptionList().currentRow.ID;
        CalendarService.exceptionListWidgetAfterMoveRow(args.row.ID, tabbedExceptionWidget, newExceptionWidget);
        tabbedExceptionWidget.descriptionOrder = getWidgetExceptionList().descriptionOrder;
    };
    
    this.exceptionListActionEventDelete = function (args) {
        ScreenService.confirmMessage(Utilities.messages.ALO_DELETE_EXCEPTION, null, self.exceptionListDelete) ;
    };
    
    this.exceptionListDelete = function(){
        CalendarService.exceptionListActionEventDelete(getWidgetExceptionList());
    };
    
    this.exceptionListActionEventNew = function (args) {
        if(Utilities.localVar.getCalendarId()){
            CalendarService.exceptionListActionEventNew(getWidgetTabbedException(),getWidgetNewException());
        }else{
            var message = Utilities.messages.ALO_IS_NOT_POSSIBLE_ADD_EXCEPTION_PART_1+'estrutura'+
                Utilities.messages.ALO_IS_NOT_POSSIBLE_ADD_EXCEPTION_PART_2;
            ScreenService.showMessage(message);
        }
    };
    this.calendarWidgetAfterLoadDataSource = function (args) {
        CalendarService.calendarWidgetAfterLoadDataSource(getWidgetCalendar());
    };
    this.newHourWeekFieldOnChangeTypeSunday = function (args) {
        var field = Utilities.getFieldByArgs(args);
        CalendarService.setFieldWorkTimeByTypeField(field);
    };

    this.newHourWeekFieldOnChangeTypeMonday = function (args) {
        var field = Utilities.getFieldByArgs(args);
        CalendarService.setFieldWorkTimeByTypeField(field);
    };

    this.newHourWeekFieldOnChangeTypeThuesday = function (args) {
        var field = Utilities.getFieldByArgs(args);
        CalendarService.setFieldWorkTimeByTypeField(field);
    };

    this.newHourWeekFieldOnChangeTypeWednesday = function (args) {
        var field = Utilities.getFieldByArgs(args);
        CalendarService.setFieldWorkTimeByTypeField(field);
    };

    this.newHourWeekFieldOnChangeTypeThursday = function (args) {
        var field = Utilities.getFieldByArgs(args);
        CalendarService.setFieldWorkTimeByTypeField(field);
    };

    this.newHourWeekFieldOnChangeTypeFriday = function (args) {
        var field = Utilities.getFieldByArgs(args);
        CalendarService.setFieldWorkTimeByTypeField(field);
    };

    this.newHourWeekFieldOnChangeTypeSaturday = function (args) {
        var field = Utilities.getFieldByArgs(args);
        CalendarService.setFieldWorkTimeByTypeField(field);
    };

    this.newHourWeekActionEventEdit = function (args) {
        CalendarService.newHourWeekActionEventEdit(getWidgetNewHourWeek());
    };
    this.calendarWidgetAfterMoveRow = function (args) {
        var dataPM = args.owner.dataSource.dataPM;
        var rowMove = args.row;
        CalendarService.calendarWidgetAfterMoveRow(dataPM,rowMove);
    };

    this.calendarWidgetOnChangeMonth = function(){
        getWidgetCalendar().reload();
    };

    this.getMonthFromWidgetCalendar = function(){
        return CalendarService.getMonthFromWidgetCalendar(getWidgetCalendar());
    };

    this.getYearFromWidgetCalendar = function() {
        return CalendarService.getYearFromWidgetCalendar(getWidgetCalendar());
    };

//end calendar

    StructureService.setStructureController(this);
    var self = this;
}

Configuration(function(ContextRegister){
		ContextRegister.register('StructureController',StructureController);
});

// FILE: assets/js/Controller/Task.js
function TaskController(TaskService,ScreenService, localStorageEngine, Query, Utilities, Messages, templateManager) {

    var getIssueCommentWidget = function (){
        return templateManager.container.getWidget('TASK_ISSUES_COMMENTS');
    };

    var getIssueTabbedWidget = function (){
        return templateManager.container.getWidget('TASK_ISSUES_TABBED');
    };

    var getIssueAttachmentsWidget = function (){
        return templateManager.container.getWidget('TASK_ISSUES_ATTACHMENTS');
    };

    var getTabStatusWidget = function (){
        return templateManager.container.getWidget('tabStatus');
    };

    var getTabCategoriesWidget = function (){
        return templateManager.container.getWidget('tabCategories');
    };

    var getTabParametersWidget = function (){
        return templateManager.container.getWidget('TAB_PARAMETERS');
    };

    var getFieldAllowedProjectTypeFromTabCategoriesWidget = function(){
      return getTabCategoriesWidget().getField('ALLOWED_PROJECT_TYPE');
    };

    var getFieldNotAllowedProjectTypeFromTabCategoriesWidget = function(){
      return getTabCategoriesWidget().getField('NOT_ALLOWED_PROJECT_TYPE');
    };

    var getFieldAllowedProjectStatusFromTabCategoriesWidget = function(){
      return getTabCategoriesWidget().getField('ALLOWED_PROJECT_STATUS');
    };

    var getFieldNotAllowedProjectStatusFromTabCategoriesWidget = function(){
      return getTabCategoriesWidget().getField('NOT_ALLOWED_PROJECT_STATUS');
    };

    this.cancel = function (args){
        openWindow('product#task');
        localStorageEngine.setLocalVar('project',1);
    };

    this.saveTask = function() {
        TaskService.saveTask();
    };
    
    this.addSubTask=function(args){
        var widget = args.owner.widget;
        ScreenService.openPopup(widget.widgets[0]);
        widget.widgets[0].newRow();

        TaskService.addSubTask();
    };

    this.setButtons = function(args,add) {
        if(add){
            args.owner.container.getWidget('SUBTASKS').actions[0].showAsAction = "edit";
        }else{
            args.owner.container.getWidget('SUBTASKS').actions[0].showAsAction = " ";
        }
    };

    this.tabCategoriesActionEventSave = function(args){
        var widget = getTabCategoriesWidget();
        if(!widget.isValid()){
            ScreenService.showMessage(Messages.ERR_REQUIRED_FIELDS);
            return;
        }
        widget.saveRow().then(function(){
            widget.reload().then(function(){
                widget.view();
                var newCurrentRow = Utilities.getRowInDataSource(widget.dataSource,'ID', widget.currentRow.ID);
                if(newCurrentRow){
                    widget.currentRow = newCurrentRow;
                }
            });
        });
    };
    var saveTaskStatus = function(widget,control,id){
        TaskService.findTaskStatusByControl(control,id).then(function(valid){
            if(valid){
                widget.saveRow().then(function(){
                    widget.reload().then(function(){
                        widget.view();
                        var newCurrentRow = Utilities.getRowInDataSource(widget.dataSource,'ID', widget.currentRow.ID);
                        if(newCurrentRow){
                            widget.currentRow = newCurrentRow;
                        }
                    });
                });
            }
        });
    };


    this.tabCategoriesFieldOnChangeNotAllowedProjectType = function(args){
        var widgetAllowed = getFieldAllowedProjectTypeFromTabCategoriesWidget();
        var widgetNotAllowed = getFieldNotAllowedProjectTypeFromTabCategoriesWidget();
        var notAllowedValue = widgetNotAllowed.value();
        if(notAllowedValue && notAllowedValue.length === 0){
            widgetAllowed.value([]);
        }else {
            var dataSetIds = widgetAllowed.dataSource.data.map(function(row){
                return row.ID;
            });
            widgetAllowed.value(Utilities.removeArrayInOtherArray(widgetNotAllowed.value(), dataSetIds));
        }
    };

    this.tabCategoriesFieldOnChangeAllowedProjectStatus = function(args){
        var widgetAllowed = getFieldAllowedProjectStatusFromTabCategoriesWidget();
        var widgetNotAllowed = getFieldNotAllowedProjectStatusFromTabCategoriesWidget();
        var allowedValue = widgetAllowed.value();
        if(allowedValue && allowedValue.length === 0){
            widgetNotAllowed.value([]);
        }else{
            var dataSetIds = widgetNotAllowed.dataSource.data.map(function(row){
                return row.ID;
            });
            widgetNotAllowed.value(Utilities.removeArrayInOtherArray(widgetAllowed.value(),dataSetIds));
        }
    };

    this.tabCategoriesFieldOnChangeNotAllowedProjectStatus = function(args){
        var widgetAllowed = getFieldAllowedProjectStatusFromTabCategoriesWidget();
        var widgetNotAllowed = getFieldNotAllowedProjectStatusFromTabCategoriesWidget();
        var notAllowedValue = widgetNotAllowed.value();
        if(notAllowedValue && notAllowedValue.length === 0){
            widgetAllowed.value([]);
        }else {
            var dataSetIds = widgetAllowed.dataSource.data.map(function(row){
                return row.ID;
            });
            widgetAllowed.value(Utilities.removeArrayInOtherArray(widgetNotAllowed.value(), dataSetIds));
        }
    };

    this.saveTaskStatus = function(widget){
        if(!widget.isValid()){
            ScreenService.showMessage(Messages.ERR_REQUIRED_FIELDS);
        }else{
            var control = widget.getField('CONTROL').value();
            var oldControl = widget.currentRow.OLD_CONTROL;
            var id = widget.getField('ID').value();
            if(oldControl && control != oldControl){
                ScreenService.confirmMessage(Utilities.messages.ALE_CHANGE_CONTROL_TASK_STATUS+' '+Utilities.messages.ALE_CONTINUE,null,function(){saveTaskStatus(widget,control,id);},null);
            }else{
                saveTaskStatus(widget,control,id);
            }
        }
    };

    /*  Called from 'Status' tab, on task_configuration.json,
        and is called every time user changes the context
        select (TASK_TYPE).
     */
    this.onChangeContextSelect = function(args){
        var widget = args.owner.widget || args.owner.field.widget;
        var chboxIsInitial  = widget.getField('IS_INITIAL');
        var valueTaskType   = widget.getField('TASK_TYPE').value();
        var valueInitialTask = widget.currentRow.INITIAL_TASK_STATUS;

        if(valueTaskType === null || valueTaskType === 0){
            chboxIsInitial.checked = false;
            chboxIsInitial.value('N');
            chboxIsInitial.isVisible = false;
        } else {
            chboxIsInitial.isVisible = true;
            if(valueInitialTask === widget.currentRow.ID){
                chboxIsInitial.checked = true;
                chboxIsInitial.value('Y');
            } else {
                chboxIsInitial.checked = false;
                chboxIsInitial.value('N');
            }
        }

    };

    this.delete = function(widget) {
        widget.removeCheckedRows();
    };

    /*  Called from 'Parameters' tab, and is called
        when user changes selected row.
     */
    this.afterMoveParameterRow = function(widget){
        reloadParametersFields(widget);
    };

    /*  Reloads dataSource of fields */
    var reloadParametersFields = function(widget){
        widget.getField('INITIAL_TASK_STATUS_NAME').reload();
        widget.getField('FINAL_TASK_STATUS_NAME').reload();
    };

    /*  Called from 'Parameters' tab, and defines
        a default status for new tasks. Is called
        when you update a parameter or creates
        a new one.
     */
    this.updateTaskOptionsParameters = function(widget){
        var infoToLocalStorage = {};
            infoToLocalStorage.PROPERTY_ID              = parseInt(widget.currentRow.PROPERTY_ID);
            infoToLocalStorage.INITIAL_TASK_STATUS_NAME = widget.currentRow.INITIAL_TASK_STATUS_NAME;
            infoToLocalStorage.INITIAL_TASK_STATUS_ID   = parseInt(widget.currentRow.INITIAL_TASK_STATUS_ID);
            infoToLocalStorage.FINAL_TASK_STATUS_NAME   = widget.currentRow.FINAL_TASK_STATUS_NAME;
            infoToLocalStorage.FINAL_TASK_STATUS_ID     = parseInt(widget.currentRow.FINAL_TASK_STATUS_ID);
        localStorageEngine.setLocalVar('taskParameters', infoToLocalStorage);
        TaskService.updateTaskOptionsParameters(widget).then(function(data){
            ScreenService.goBack();
            widget.reload();
            widget.list();
        });
    };

    /**********************************************
     * Update or create a new priority for issues.
     * @from issueConfiguration.json
     **********************************************/
    this.updateIssuePriorities = function(widget){
        if (widget.isValid()) {
            TaskService.updateIssuePriorities(widget.currentRow).then(function(data){
                ScreenService.goBack();
                widget.reload();
                widget.list();
            });
        } else {
            ScreenService.showMessage(Messages.ERR_REQUIRED_FIELDS);
        }
    };

    this.styleColorsList = function(element, row){
        setTimeout(function(){
            if(row.COLOR){
                var bolado = element.find("td span").css("color", row.COLOR);
            }
        }, 250);
    };

    this.tabCategoriesActionEventCancel = function(args) {
        Utilities.genericCancelEvent(getTabCategoriesWidget());
    };
    this.tabCategoriesActionEventDelete = function (args) {
        ScreenService.confirmMessage(Utilities.messages.ALE_DELETE_TASK_CATEGORY, 'question', function () {
            Utilities.genericDeleteEvent(getTabCategoriesWidget()).then(function () {
                ScreenService.notificationMessage(Utilities.messages.SUC_CATEGORY_DELETE);
            }).catch(function (response) {
                Utilities.showMessageErrorOfBackEnd(response,Utilities.messages.ERR_CONTAINER_TASK_CONFIGURATION);
            });
        });
    };

    this.tabParametersActionEventCancel = function(args) {
        Utilities.genericCancelEvent(getTabParametersWidget());
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('TaskController',TaskController);
});


// FILE: assets/js/Controller/TaskBranches.js
function TaskBranchesController(ScreenService, requestDataSourceEngine) {
	this.saveTaskBranch = function(args) {
		ScreenService.showLoader();
		args.row.isMessage = false;
		args.row.ORGANIZATION = Utilities.localVar.getOrganization();

		requestDataSourceEngine.setDataSource('/taskBranches',[args.row]).then(function() {
	        args.owner.widget.list(true);
	        ScreenService.goBack();
	        ScreenService.hideLoader();
	        ScreenService.successNotification('Salvo com sucesso!');
        }).catch(function (e) {
	        ScreenService.hideLoader();
	        ScreenService.showMessage('Occoreu um erro inesperado.<br/>"'+ e.data.error +'"');                      
        });
	};
}

Configuration(function(ContextRegister) {
    ContextRegister.register('TaskBranchesController', TaskBranchesController);
});



// FILE: assets/js/Controller/TaskTracking.js
function TaskTrackingController(ScreenService, FilterService, Utilities, templateManager, IssueService, Messages, ZhFilterPreferences) {

    var self = this;
    
    var getWidgetFilterTask = function () {
        return getWidgetListTasks().appliedFilter;
    };

    var getWidgetListTasks = function () {
        return templateManager.container.getWidget('LIST_TASKS');
    };

    var getWidgetInfoTask = function () {
        return templateManager.container.getWidget('INFO_TASK');
    };

    var getWidgetDocuments = function () {
        return templateManager.container.getWidget('DOCUMENTS');
    };

    var getWidgetTabbedTask = function () {
        return templateManager.container.getWidget('TABBED_TASK');
    };

    var getWidgetIssuesLabelsRelationship = function () {
        return templateManager.container.getWidget('ISSUES_LABELS_RELATIONSHIP');
    };

    var getWidgetNewLabel = function () {
        return templateManager.container.getWidget('NEW_LABEL');
    };

    var getIssuesFieldFromIssuesLabelsRelationshipWidget = function () {
        return getWidgetIssuesLabelsRelationship().getField('ISSUES');
    };

    var getFieldTaskLabelFromInfoTaskWidget = function () {
        return getWidgetInfoTask().getField('TASK_LABEL');
    };

    var getFieldTaskResponseFromInfoTaskWidget = function () {
        return getWidgetInfoTask().getField('TASK_RESPONSE');
    };
    
    var getFieldErrorClassificationFromInfoTaskWidget = function (){
        return getWidgetInfoTask().getField('ERROR_CLASSIFICATION');  
    };

    var getLabelsFieldFromIssuesLabelsRelationshipWidget = function () {
        return getWidgetIssuesLabelsRelationship().getField('LABELS');
    };

    var getLogWidget = function () {
        return templateManager.container.getWidget('LOG');
    };

    var getBackActionFromLogWidget = function(){
        return getLogWidget().getAction('back');
    };

    this.taskFilterFieldOnChangeResponsible = function () {
        var widget = getWidgetFilterTask();
        var resourceIds = widget.getField('RESPONSIBLE').value();

        Utilities.localVar.setLocalVarResponsibleId(resourceIds);

        var structureField = widget.getField('STRUCTURE');
        structureField.reload().then(function () {
            structureField.value([]);
        });

    };

    this.taskFilterFieldOnChangeStructure = function () {
        var widget = getWidgetFilterTask();
        var structureIds = widget.getField('STRUCTURE').value();

        Utilities.localVar.setLocalVarStructureIds(structureIds);

        var taskResourceField = widget.getField('TASK_RESOURCE');
        var managerResourceField = widget.getField('MANAGER_RESOURCE');

        taskResourceField.reload().then(function () {
            taskResourceField.value([]);
        });

        managerResourceField.reload().then(function () {
            managerResourceField.value([]);
        });

    };

    this.taskTrackingWidgetOnEnter = function (args) {
        ScreenService.showLoader();
        Utilities.localVar.getLoginPromise().then(function(){
            ScreenService.hideLoader();
            var widgetListTasks = getWidgetListTasks();
            var currentRow = {};
            var filterByDashboard = Utilities.localVar.getFilterByDashboard();
            if (filterByDashboard && filterByDashboard.hasOwnProperty('taskTracking') && filterByDashboard.taskTracking){
                currentRow.FILTER_ROW = Utilities.clone(filterByDashboard.taskTracking);
                Utilities.localVar.setFilterByDashboard(null);
                ZhFilterPreferences.setOriginalFilter(widgetListTasks.id, currentRow);
                Utilities.applyFilter(widgetListTasks, currentRow, true);
            } else if (Utilities.isAppliedFilter(widgetListTasks)) {
                widgetListTasks.reload();
            } else {
                var fieldTypeInfoTask = getWidgetInfoTask().getField('TYPE_RELATIONSHIP');
                fieldTypeInfoTask.dataSource.data = Utilities.messages.FULL_DATA_TYPE_RELATIONSHIP_TASK;
                var userId = Utilities.localVar.getLocalVarIdBusinessPartner();
                Utilities.localVar.setLocalVarResponsibleId('');
                Utilities.localVar.setLocalVarStructureIds([]);
                
                var today = moment();
                currentRow.PERIOD_end           = today.format('DD/MM/YYYY');
                currentRow.PERIOD_start         = today.subtract(6, 'days').format('DD/MM/YYYY');
                currentRow.PERIOD_period_select = 'Últimos 5 dias';
                currentRow.PERIOD               = self.filterAppropriationGridLastFiveDayPeriod();
                currentRow.STATUS               = 'A';
                currentRow.STATUS_RESOURCE      = 'A';
                
                widgetListTasks.currentRow = currentRow;
                ZhFilterPreferences.setOriginalFilter(widgetListTasks.id, widgetListTasks.currentRow);
                Utilities.applyDefaultFilterOnEnter(widgetListTasks, true);
            }
            ScreenService.updateTemplate();
        }).catch(ScreenService.hideLoader);
    };
    
    this.listTasksFilterAfterApply = function(){
        Utilities.setFilterInit(getWidgetListTasks());
    };

    this.listTaskWidgetAfterMoveRow = function (args) {
        var taskId = args.row.TASK_ID;
        var resourceId = args.row.RESOURCE_T;
        if (taskId) {
            var widgetForm = getWidgetInfoTask();
            widgetForm.list();
            Utilities.localVar.setLocalVarTaskId(taskId);
            Utilities.localVar.setResourceT(resourceId);
            
            if(getWidgetDocuments().isActive()) {
                getWidgetDocuments().reload();
                widgetForm.reload();
            } else {
                ScreenService.openSwipe(getWidgetTabbedTask());
                widgetForm.activate();
                widgetForm.template = widgetForm.formTemplate;
                
                ScreenService.showLoader();
                widgetForm.reload()
                    .then(ScreenService.hideLoader)
                    .catch(ScreenService.hideLoader);
                    
                getFieldTaskLabelFromInfoTaskWidget().reload();
            }
        }
    };

    this.infoTaskWidgetAfterLoadDataSource = function (args) {
        getWidgetInfoTask().moveToFirst();
        setIsVisbleFalseOrReadOnlyTrueFieldErrorClassification();
    };
    
    var hasErrorClassification = function(){
        return (getWidgetInfoTask().currentRow.ERROR_CLASSIFICATION) ? true : false;
    };
    
    var setIsVisbleFalseOrReadOnlyTrueFieldErrorClassification = function (){
        if(hasErrorClassification()){
            getFieldErrorClassificationFromInfoTaskWidget().readOnly = true;
            getFieldErrorClassificationFromInfoTaskWidget().isVisible = true;
        } else {
            getFieldErrorClassificationFromInfoTaskWidget().isVisible = false;
        }
    };

    var goBackListTask = function () {
        ScreenService.closeSwipe();
        getWidgetListTasks().activate();
    };

    this.infoTaskActionEventBack = function (args) {
        goBackListTask();
    };

    this.newLabelActionEventSaveNewLabel = function(args){
        args.owner.widget.saveRow().then(function(){
            ScreenService.closePopup();
            getLabelsFieldFromIssuesLabelsRelationshipWidget().reload();
            getWidgetNewLabel().reload();
        });
    };

    this.issuesLabelsRelationshipOnChangeLabels = function (args) {
        var widget = getWidgetNewLabel();
        widget.newRow();
        ScreenService.openPopup(widget);
    };

    this.documentsActionEventBack = function (args) {
        ScreenService.closeSwipe();
        getWidgetListTasks().activate();
    };

    this.documentsActionEventBackView = function (args) {
        ScreenService.closeSwipe();
    };

    this.documentsActionEventDownload = function (args) {
        Utilities.downloadAttachment(args.row.ID);
    };

    this.infoTaskActionEventCancel = function () {
        var infoTask = getWidgetInfoTask();
        Utilities.genericCancelEvent(infoTask);
        infoTask.template = infoTask.templateToView;
    };

    this.filterAppropriationGridLastFiveDayPeriod = function () {
        var today = moment();
        var period = {};
        period.end = today.format('DD/MM/YYYY');
        period.start = today.subtract(6, 'days').format('DD/MM/YYYY');
        return period;
    };

    var openPopupForLabelsRelationship = function () {
        ScreenService.openPopup(getWidgetIssuesLabelsRelationship());
    };

    this.listTaskActionEventApplyLabels = function (args) {
        var widgetLabelRelationship = getWidgetIssuesLabelsRelationship();
        if(getWidgetListTasks().hasCheckedRows()) {
            widgetLabelRelationship.newRow();
            applySelectedIssuesToIssuesField(getWidgetListTasks().getCheckedRows());
            openPopupForLabelsRelationship();
        } else {
            ScreenService.showMessage(Utilities.messages.NOT_CHECKED_ROW_TASK);
        }
    };

    this.infoTaskActionEventApplyEdit = function (args) {
        var infoTaskWidget = getWidgetInfoTask();
        setTaskResponseFieldReadOnly();
        setIsVisbleFalseOrReadOnlyTrueFieldErrorClassification();
        infoTaskWidget.edit();
    };

    var setTaskResponseFieldReadOnly = function(){
        var taskResponseField = getFieldTaskResponseFromInfoTaskWidget();
        var resourceArray = getWidgetInfoTask().currentRow.RESOURCE;
        var userId = Utilities.localVar.getIdBusinessPartner();
        taskResponseField.readOnly = resourceArray.indexOf(userId) < 0;
    };
    
    this.infoTaskActionEventSave = function (args) {
        var widget = getWidgetInfoTask();
        widget.currentRow.IS_SAVING_ONLY_RELATED = true;
        widget.currentRow.changed = true;
        widget.saveRow().then(function() {
            ScreenService.showLoader();
            widget.reload().then(function() {
                ScreenService.hideLoader();
                widget.list();
                widget.activate();
            }).catch(ScreenService.hideLoader);
        });
    };

    var applySelectedIssuesToIssuesField = function (tasks) {
        var field = getIssuesFieldFromIssuesLabelsRelationshipWidget();
        var selectedIssuesOnKanban = tasks.filter(function (data) {
            return !!data[field.valueField];
        });
        field.dataSource.data = selectedIssuesOnKanban;
        field.value(Utilities.arrayFromPropertyOfObjectList(selectedIssuesOnKanban, field.valueField));
    };

    var goBackLabelsRelationship = function () {
        ScreenService.closePopup();
        goBackListTask();

    };
    this.issuesLabelsRelationshipActionEventCancel = function (args) {
        goBackLabelsRelationship();
    };

    this.issuesLabelsRelationshipActionEventSave = function (args) {
        var widget = args.owner.widget;
        if(widget.isValid()) {
            sendIssuesAndLabelsToRelationship();
        }
    };

    var sendIssuesAndLabelsToRelationship = function () {
        var widget = getWidgetIssuesLabelsRelationship();
        if (widget.isValid()) {
            var selectedIssues = getIssuesFieldFromIssuesLabelsRelationshipWidget().value();
            var selectedLabels = getLabelsFieldFromIssuesLabelsRelationshipWidget().value();
            IssueService.sendIssuesAndLabelsToRelationship(selectedIssues, selectedLabels).then(function (successful) {
                goBackLabelsRelationship();
            });
        }
    };

    this.infoTaskActionEventLog = function(args) {
        ScreenService.showLoader();
        IssueService.getFullLogFileContents(getLogFileName()).then(function(logFileContents) {
            ScreenService.hideLoader();
            if(!logFileContents) {
                ScreenService.showMessage(Messages.ALE_NOT_EXISTS_LOG);
            } else {
                var logWidget = getLogWidget();
                logWidget.isVisible = true;
                getBackActionFromLogWidget().isVisible = true;
                logWidget.newRow();
                logWidget.currentRow.LOG_FIELD = logFileContents;
                ScreenService.openPopup(logWidget);
            }
        }).catch(defaultError);
    };

    this.logActionEventBack = function(args) {
        ScreenService.closePopup(true);
        getWidgetInfoTask().activate();
    };

    var getLogFileName = function() {
        var task = getWidgetInfoTask().currentRow;
        var taskId = task.ID;
        if(task.IS_RELATED_TASK) {
            taskId = task.MAIN_TASK;
        }
        return 'LOG_TASK_' + taskId + '.txt';
    };

    var defaultError = function (error) {
        ScreenService.hideLoader();
        ScreenService.restoreDefaultLoadingMessage();
        if(error) {
            if(typeof error == 'object') {
                ScreenService.showMessage(Utilities.messages.UNEXPECTED_ERROR_SIMPLE +'<br/>"' + error.data + '"');
            } else {
                ScreenService.showMessage(Utilities.messages.UNEXPECTED_ERROR_SIMPLE +'<br/>"' + error + '"');
            }
        } else {
            ScreenService.showMessage(Utilities.messages.UNEXPECTED_ERROR_SIMPLE);
        }
    };
    
    this.documentsWidgetOnEnter = function() {
        getWidgetDocuments().reload();
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register('TaskTrackingController', TaskTrackingController);
});


// FILE: assets/js/Controller/TimeControl.js
function TimeControl(ZhFilterPreferences,ScreenService, localStorageEngine, templateManager, Utilities,TaskService, Validation, requestDataSourceEngine, ZHPromise,DateManager, Messages, AppropriationService) {

	var self = this;
	var ALLOWENDTASK_NEGATIVE = 'N';
	var USETIMEPLANNING_NEGATIVE = 'N';
    var BEGIN_HOUR_LABEL_NOT_DATED = "Data da apropriação";
    var BEGIN_HOUR_LABEL_DATED = "Início";

    /************************************************************
     * Widget getters
     ************************************************************/

	var getAppropriationsWidget = function(){
		return templateManager.container.getWidget('APPROPRIATIONS');
	};
    var getAppropriationWidget = function(){
        return templateManager.container.getWidget('APPROPRIATION');
    };
    var getTimeControlWidget = function(){
        return templateManager.container.getWidget('TIME_CONTROL');
    };
    var getNewTaskWidget = function(){
        return templateManager.container.getWidget('NEW_TASK');
    };
    
    var getTabbedAppropriationWidget = function(){
        return templateManager.container.getWidget('TABBED_APPROPRIATION');
    };
    /************************************************************
     * Field getters
     ************************************************************/
    
    var getFieldDateIntervalFromRangeFilterWidget = function () {
        return getTimeControlWidget().getField('DATE_INTERVAL');
    };
    
    var getFieldBeginHourFromAppropriationsWidget = function(){
        return getAppropriationsWidget().getField('BEGIN_HOUR');
    };
    var getFieldEndHourFromAppropriationsWidget = function(){
        return getAppropriationsWidget().getField('END_HOUR');
    };
    var getFieldPercentCompletedFromAppropriationsWidget = function(){
        return getAppropriationsWidget().getField('PERCENT_COMPLETED');
    };
    var getFieldTaskNameFromAppropriationWidget = function(){
        return getAppropriationWidget().getField('TASK_NAME');
    };
    var getFieldProjectNameFromAppropriationWidget = function(){
        return getAppropriationWidget().getField('PROJECT_NAME');
    };
    var getFieldProjectIdFromAppropriationWidget = function(){
        return getAppropriationWidget().getField('PROJECT_ID');
    };
    var getFieldBeginHourFromAppropriationWidget = function(){
        return getAppropriationWidget().getField('BEGIN_HOUR');
    };
    var getFieldEndHourFromAppropriationWidget = function(){
        return getAppropriationWidget().getField('END_HOUR');
    };
    var getFieldPercentCompletedFromAppropriationWidget = function(){
        return getAppropriationWidget().getField('PERCENT_COMPLETED');
    };
    var getFieldDescriptionFromAppropriationWidget = function(){
        return getAppropriationWidget().getField('DESCRIPTION');
    };
    var getFieldTotalFromAppropriationWidget = function(){
        return getAppropriationWidget().getField('TOTAL');
    };

	/**
     * This global variable stores a boolean value
     * that specifies if add appropriation swipe
     * was open from Time Control or Appropriations swipe.
     * @type {boolean}
     */

    var initFilter = true;
    
    var descriptionOrderTextWidgettimeControl;

    var isTaskDefaultCell = function(id){
        return id < 1;
    };

    var getBeginHourLabelByTaskDated = function(isDated){
        if(isDated){
            return BEGIN_HOUR_LABEL_DATED;
        }
        return BEGIN_HOUR_LABEL_NOT_DATED;
    };

	var onClickTask = function(widget) {
		var tabbedWidget            = getTabbedAppropriationWidget();
		var currentRow              = widget.currentRow;
		var beginHourField          = getFieldBeginHourFromAppropriationsWidget;
        var clickedTaskName         = currentRow.label ? currentRow.label : currentRow.TASK_NAME;
        var clickedTaskCell         = widget.dataSource.data.filter(function(cell){
            return cell.TASK_NAME == this;
        }, clickedTaskName);
        var clickedTaskId           = clickedTaskCell[0].ID;

        localStorageEngine.setLocalVar('taskId', clickedTaskId);

		if(!isTaskDefaultCell(clickedTaskId)){
            requestDataSourceEngine.getDataSource('/isTaskDated', [{
				'name': 'taskId',
				'operator': '=',
				'value': clickedTaskId
			}]).then(function(data){
                var isTaskDated = data.dataset.isTaskDated[0].DATED;
                Utilities.localVar.setIsTaskDated(isTaskDated);
                getFieldPercentCompletedFromAppropriationsWidget().isVisible = isTaskDated;
				beginHourField.label = getBeginHourLabelByTaskDated(isTaskDated);
                getFieldEndHourFromAppropriationsWidget().isVisible = isTaskDated;
			});

			ScreenService.openSwipe(tabbedWidget).then(function(){
                var currentWidget = currentRow.label ? tabbedWidget.container.getWidget('TASK_INFO') : tabbedWidget.container.getWidget('APPROPRIATIONS');
                ScreenService.showLoader();
                currentWidget.reload().then(function(){
                    ScreenService.hideLoader();
                    currentWidget.activate();
                    tabbedWidget.currentWidget = currentWidget;
                    templateManager.updateTemplate();

                    if(currentWidget.name === 'TASK_INFO'){
                        Utilities.hideFieldsWhenNoContent(currentWidget);
                    }

                    if(currentWidget.name === 'APPROPRIATIONS' && widget.currentRow.HOURS == '0'){
                        var appropriationWidget = getAppropriationWidget();
                        self.onAddApropriation();
                        var desiredDateTime = moment(currentRow.DAY.substr(4), 'DD/MM/YYYY').format('DD/MM/YYYY HH:mm');
                        appropriationWidget.currentRow.BEGIN_HOUR = desiredDateTime;
                        appropriationWidget.currentRow.END_HOUR = desiredDateTime;
                    }
                }).catch(ScreenService.hideLoader);
            });
		}
	};
    this.afterLoadTaskInfo = function(args){
        var widgetInfoTask = args.owner;
        widgetInfoTask.moveToFirst();
        var timePlanning = true;
        if(widgetInfoTask.currentRow.USE_TIME_PLANNING == 'N'){
            timePlanning = false;
        }
        widgetInfoTask.getField('ESTIMATED_BEGIN_DATE').isVisible = timePlanning ;
        widgetInfoTask.getField('ESTIMATED_END_DATE').isVisible = timePlanning ;
        widgetInfoTask.getField('DURATION').isVisible = timePlanning ;
    };

    /************************************************************
     * Opens a swipe for add a new appropriation
     ************************************************************/
	this.onAddApropriation = function(isFromCrossGrid) {
		var appropriationWidget = getAppropriationWidget();
		var isTaskDated = localStorageEngine.getLocalVar('isTaskDated');
		var beginHourField = appropriationWidget.getField('BEGIN_HOUR');
		setPercentFieldVisibilityByEndTask(appropriationWidget.getField('PERCENT_COMPLETED'));
		if(isTaskDated){
			beginHourField.label = 'Início';
            beginHourField.template = 'field/datetime.html';
            beginHourField['datetime-preset'] = 'datetime';
            beginHourField.displayFormat = "DD/MM/YYYY hh:mm";
		}
		else{
			beginHourField.label = 'Data da apropriação';
            beginHourField.template = 'field/calendar.html';
            beginHourField['datetime-preset'] = 'date';
            beginHourField.displayFormat = "DD/MM/YYYY";
		}
		appropriationWidget.getField('END_HOUR').isVisible = isTaskDated;
		appropriationWidget.currentRow = {};
		appropriationWidget.dataSource.data = [];
        appropriationWidget.newRow();
        ScreenService.openSwipe(appropriationWidget);
        ScreenService.showLoader();
        requestDataSourceEngine.getDataSource('/findTaskAllocationForCurrentUser', [{
			'name': 'taskId',
			'operator': '=',
			'value': localStorageEngine.getLocalVar('taskId') ? localStorageEngine.getLocalVar('taskId') : 0
		}]).then(function(data){
		    ScreenService.hideLoader();
            if(isFromCrossGrid){
                appropriationWidget.currentRow.isFromCrossGrid = true;
            }
            var allocation = data.dataset.findTaskAllocationForCurrentUser[0];
			appropriationWidget.currentRow.ALLOCATION = allocation.ID;
			appropriationWidget.currentRow.TASK_END_DATE = allocation.TASK_END_DATE;
			appropriationWidget.currentRow.INT_TASK_END_DATE = allocation.INT_TASK_END_DATE;
			appropriationWidget.currentRow.ALLOWENDTASK = allocation.ALLOWENDTASK;
		}).catch(ScreenService.hideLoader);
	};

	this.timeControlWidgetOnEnter = function(args){
        var widget = getTimeControlWidget();
        var currentRow = {};
        var range;
        var filterByDashboardTimeControl = getFilterToTimeControl();
        
        if (filterByDashboardTimeControl){
            setRangeFilterFields(widget);
            widget.currentRow.DATE_INTERVAL.start = filterByDashboardTimeControl.MIN_DATE;
            widget.currentRow.DATE_INTERVAL.end = filterByDashboardTimeControl.MAX_DATE;
            widget.currentRow.SHOW_WEEKEND = "N";
            range = {
                'name': "range",
                'operator': "BETWEEN",
                'value': [currentRow.MIN_DATE, currentRow.MAX_DATE, currentRow.SHOW_WEEKEND]
            };
            localStorageEngine.setLocalVar('range', range);
            ZhFilterPreferences.setOriginalFilter(widget.id, widget.currentRow);
            ZhFilterPreferences.applyOriginalFilter(widget);
        } else if (!initFilter){
            widget.reload();
        } else {
            widget.currentRow.SHOW_WEEKEND = "N";
            setRangeFilterFields(widget);
            range = {
                'name': "range",
                'operator': "BETWEEN",
                'value': [widget.currentRow.DATE_INTERVAL.start, widget.currentRow.DATE_INTERVAL.end, widget.currentRow.SHOW_WEEKEND]
            };
            localStorageEngine.setLocalVar('range', range);
            var maxDate = localStorageEngine.getLocalVar('maxDate');
            if (Validation.isEmpty(maxDate)) {
                var week = DateManager.getweekBrLabelByWeekNumber(parseInt(new moment().format('e')));
                localStorageEngine.setLocalVar('maxDate', week + ' ' + (new moment()).format('DD/MM/YYYY'));
            }
            ZhFilterPreferences.setOriginalFilter(widget.id, widget.currentRow);
            ZhFilterPreferences.applyOriginalFilter(widget);
        }
        
    };
    
	this.onAddTask = function(){
		var newTaskWidget = getNewTaskWidget();
		ScreenService.openPopup(newTaskWidget);
	};

	var addAppropriationForNewTask = function(currentRow){
		if(currentRow._level >= 2){
			localStorageEngine.setLocalVar('taskId', currentRow.ID);
			ScreenService.closePopup();
			ScreenService.showLoader();
			requestDataSourceEngine.getDataSource('/isTaskDated', [{
				'name': 'taskId',
				'operator': '=',
				'value': localStorageEngine.getLocalVar('taskId') ? localStorageEngine.getLocalVar('taskId') : 0
			}]).then(function(data){
			    ScreenService.hideLoader();
				localStorageEngine.setLocalVar('isTaskDated' , data.dataset.isTaskDated[0].DATED);
				self.onAddApropriation(true);
			}).catch(ScreenService.hideLoader);
		}
	};

	var onEnterAppropriation = function(widget){
        var dateLastAppropriation;
        ScreenService.showLoader();
        requestDataSourceEngine.getDataSource("/findDateLastAppropriation").then(function(data) {
            ScreenService.hideLoader();
            dateLastAppropriation = data.dataset.dateLastAppropriation[0].BEGIN_HOUR;
            if(!widget.currentRow.ID){
                var percentCompletedField = widget.getField('PERCENT_COMPLETED');
                var beginHourField = widget.getField('BEGIN_HOUR');
                var endHourField = widget.getField('END_HOUR');
                percentCompletedField.defaultValue = percentCompletedField.minValue;
                percentCompletedField.value(percentCompletedField.value() ? percentCompletedField.value() : percentCompletedField.defaultValue);
                beginHourField.value(beginHourField.value() ? beginHourField.value() :  moment(dateLastAppropriation, 'DD/MM/YYYY').format('DD/MM/YYYY HH:mm'));
                endHourField.value(endHourField.value() ? endHourField.value() : moment(dateLastAppropriation, 'DD/MM/YYYY').format('DD/MM/YYYY HH:mm'));
                widget.activate();
                templateManager.updateTemplate();
            }
        }).catch(Utilities.showMessageBackEndTrue);

	};

	this.onChangeTime = function(endHourField, beginHourField, totalField){
		var endHour = endHourField.value();
		var beginHour = beginHourField.value();
		var total = totalField.value();
		if(!Validation.isEmpty(total) && !Validation.isEmpty(beginHour)){
			total = total.split(':');
			endHourField.value(
				moment(beginHour, 'DD/MM/YYYY HH:mm').add(total[0], 'hours').add(total[1], 'minutes').format('DD/MM/YYYY HH:mm'));
			this.onChangeEndHour(endHourField.widget);
			return;
		}
		if(!Validation.isEmpty(beginHour) && !Validation.isEmpty(endHour)){
			totalField.value(moment(
				moment(endHour, 'DD/MM/YYYY HH:mm').diff(moment(beginHour, 'DD/MM/YYYY HH:mm'))).subtract(moment(0)).format('HH:mm'));
			return;
		}
		if(!Validation.isEmpty(total) && !Validation.isEmpty(endHour)){
			total = total.split(':');
			beginHourField.value(
				moment(endHour, 'DD/MM/YYYY HH:mm').subtract(total[0], 'hours').subtract(total[1], 'minutes').format('DD/MM/YYYY HH:mm'));
		}
	};

    this.appropriationFieldOnChangeTotal = function(args){
        calculatePeriodByTotal(getAppropriationWidget());
        getAppropriationWidget().activate();
    };

    this.appropriationFieldOnChangeBeginHour = function(args){
        calculatePeriodByBeginHour(getAppropriationWidget());
        getAppropriationWidget().activate();
    };
    
    this.appropriationFieldOnChangeEndHour = function(args){
        calculatePeriodByEndHour(getAppropriationWidget());
        getAppropriationWidget().activate();
    };

    this.appropriationsFieldOnChangeTotal = function(args){
        calculatePeriodByTotal(getAppropriationsWidget());
    };

    this.appropriationsFieldOnChangeBeginHour = function(args){
        calculatePeriodByBeginHour(getAppropriationsWidget());
    };

    this.appropriationsFieldOnChangeEndHour = function(args){
        calculatePeriodByEndHour(getAppropriationsWidget());
    };

    var calculatePeriodByEndHour = function (widget) {
        var row = widget.currentRow;
        if (row.BEGIN_HOUR !== '') {
            var data = Utilities.calculateTotalTime(row.BEGIN_HOUR, row.END_HOUR);
            row.TOTAL = data.period;
            if (data.hour !== null) {
                row.END_HOUR = data.hour;
                row.BEGIN_HOUR = data.hour;
            }
        } else {
            if (row.TOTAL !== '') {
                row.BEGIN_HOUR = Utilities.calculateBeginTime(row.END_HOUR, row.TOTAL);
            }
        }
    };

    var calculatePeriodByTotal = function (widget) {
        var row = widget.currentRow;
        if (row.BEGIN_HOUR !== '') {
            row.END_HOUR = Utilities.calculateEndTime(row.BEGIN_HOUR, row.TOTAL);
        } else {
            if (row.END_HOUR !== '') {
                row.BEGIN_HOUR = Utilities.calculateBeginTime(row.END_HOUR, row.TOTAL);
            }
        }

    };

    var calculatePeriodByBeginHour = function (widget) {
        var row = widget.currentRow;
        if (row.TOTAL !== '') {
            row.END_HOUR = Utilities.calculateEndTime(row.BEGIN_HOUR, row.TOTAL);
        }

    };


	this.onChangeEndHour = function(widget){
		if(!Validation.isEmpty(widget.getField('BEGIN_HOUR').value)){
			widget.getField('TOTAL').value(null);
		}
		this.onChangeTime(widget.getField('END_HOUR'), widget.getField('BEGIN_HOUR'), widget.getField('TOTAL'));
	};

	function dateToBackend(date){
		date = date.split('/');
		var day = date[0];
		var month = date[1];
		date.splice(0, 1, month);
		date.splice(1, 1, day);
		if(date.length === 10){
			date += ' 00:00';
		}
		return date.join('/');
	}

	function timeToSeconds(time){
		time = time.split(':');
		return '' + (time[0] * 3600 + time[1] * 60);
	}

	function secondsToTime(seconds){
		var time = '';
		var hours = parseFloat(seconds)/3600;
		if(hours >= 1){
			time += Math.floor(hours) + ':';
		}
		else{
			time += '00:';
		}
		var minutes = (hours - Math.floor(hours)) * 60;
		if(minutes >= 1){
			time += Math.floor(minutes);
		}
		else{
			time += '00';
		}
		return time;
	}

    var validatePlayedTask = function(taskId, percentCompleted, status) {
        var defer = ZHPromise.defer();
        if(percentCompleted === 100 || status === 'Concluída') {
            taskId = parseInt(taskId);
            var filter =[ {
                "operator": "=",
                "name": "TASK",
                "value": taskId
            }];
            requestDataSourceEngine.getDataSource("/hasBranch", filter).then(function(data){
                if(data.dataset.hasBranch.length > 0){
                    defer.reject('hasBranch');
                } else {
                    defer.resolve();
                }
            }).catch(function(e){
                defer.reject(e);
            });
        } else {
            defer.resolve();
        }
        return defer.promise;
    };
    this.percentValid = function(currentRow){
        var valid = true;
       if(currentRow.OLD_PERCENT_COMPLETED && currentRow.OLD_PERCENT_COMPLETED == 100+'%' ){
           if(currentRow.PERCENT_COMPLETED != 100){
               valid = false;
               ScreenService.showMessage('Apropriação que já foi 100% não pode ser salva com outra porcentagem');
           }
       }
        return valid;
    };
    var validateEndTask = function(widget){
        var validate = true;
        var currentRow = widget.currentRow;
        var taskEndDate = currentRow.TASK_END_DATE;
        var intTaskEndDate = currentRow.INT_TASK_END_DATE;
        if(currentRow.ALLOWENDTASK == 'Y' && intTaskEndDate){
            var intBeginHour = currentRow.BEGIN_HOUR.split(' ')[0].split('/').reverse().join("");
            if(intBeginHour > intTaskEndDate){
                validate = false;
                ScreenService.showMessage(Utilities.messages.ERR_APPR_AFTER_CONCLUSION + taskEndDate + ")");
            }
        }
        return validate;
    };

	this.appropriationActionEventSave = function(args) {
        var widget = getAppropriationWidget();
        var timeControlWidget = getTimeControlWidget();
        var appropriationsWidget = getAppropriationsWidget();
        if(widget.isValid() && validateEndTask(widget)) {
            var taskId = getInfoTaskWidget().currentRow.ID;
            var percentCompleted = widget.currentRow.PERCENT_COMPLETED;
            var backupTime = widget.currentRow.TOTAL;
            var backupBeginHour = widget.currentRow.BEGIN_HOUR;
            var backupEndHour = widget.currentRow.END_HOUR;

            ScreenService.showLoader();
            validatePlayedTask(taskId, percentCompleted).then(function () {
                ScreenService.hideLoader();
                widget.currentRow.BEGIN_HOUR =  widget.currentRow.BEGIN_HOUR === null ? null : dateToBackend(widget.currentRow.BEGIN_HOUR);
                widget.currentRow.END_HOUR = widget.currentRow.END_HOUR === null ? null : dateToBackend(widget.currentRow.END_HOUR);
                widget.currentRow.TOTAL = timeToSeconds(widget.currentRow.TOTAL);

                if (widget.isValid() && self.percentValid(widget.currentRow)) {
                    widget.saveRow().then(function (reponse) {
                        widget.currentRow.ID = reponse.dataset.appropriation[0].ID;
                        widget.currentRow.__is_new = false;
                        percentCompleted = widget.currentRow.PERCENT_COMPLETED;
                        if (percentCompleted === 100) {
                            var row = getInfoTaskWidget().currentRow;
                            row.TASK_RESPONSE = getFieldDescriptionFromAppropriationWidget().value();
                            TaskService.concludeTask(row);
                        }
                        if (widget.currentRow.isFromCrossGrid) {
                            ScreenService.closeSwipe();
                            timeControlWidget.activate();
                            timeControlWidget.reload();
                        } else {
                            widget.template = 'widget/form-view.html';
                            widget.view();
                            templateManager.updateTemplate();
                            ScreenService.showLoader();
                            appropriationsWidget.reload().then(function () {
                                ScreenService.hideLoader();
                                widget.currentRow.TOTAL = backupTime;
                                widget.currentRow.BEGIN_HOUR = backupBeginHour;
                                widget.currentRow.END_HOUR = backupEndHour;
                                timeControlWidget.reload();
                            }).catch(ScreenService.hideLoader);
                        }
                    });
                } else {
                    widget.currentRow.BEGIN_HOUR =  widget.currentRow.BEGIN_HOUR === null ? null : dateToBackend(widget.currentRow.BEGIN_HOUR);
                    widget.currentRow.END_HOUR = widget.currentRow.END_HOUR === null ? null : dateToBackend(widget.currentRow.END_HOUR);
                    widget.currentRow.TOTAL = secondsToTime(widget.currentRow.TOTAL);
                }
            }).catch(function (e) {
                ScreenService.hideLoader();
                ScreenService.closeSwipe();
                if (e === 'hasBranch') {
                    ScreenService.showMessage(Messages.ALE_PLAYED_TASK);
                }
                appropriationsWidget.activate();
            });
        }
    };

    var getInfoTaskWidget = function(){
    	return templateManager.container.getWidget('TASK_INFO');
    };

    this.goBackToCrossTab = function() {
        ScreenService.goBack();
        getTimeControlWidget().activate();
    };


	this.appropriationsWidgetAfterMoveRow = function(args){
        var appropriationId = getAppropriationsWidget().currentRow.ID;
		var appropriationWidget = getAppropriationWidget();
		var isTaskDated = localStorageEngine.getLocalVar('isTaskDated');
		var beginHourField = appropriationWidget.getField('BEGIN_HOUR');
		localStorageEngine.setLocalVar('appropriationId', appropriationId);
		appropriationWidget.list();
		ScreenService.showLoader();
		appropriationWidget.reload().then(function(){
		    ScreenService.hideLoader();
            appropriationWidget.moveToFirst();
			appropriationWidget.getField('PERCENT_COMPLETED').isVisible = isTaskDated;
            appropriationWidget.currentRow.OLD_PERCENT_COMPLETED = appropriationWidget.getField('PERCENT_COMPLETED').value();
			setPercentFieldVisibilityByEndTask(appropriationWidget.getField('PERCENT_COMPLETED'));
			if(isTaskDated){
				beginHourField.label = 'Início';
                beginHourField.template = 'field/datetime.html';
                beginHourField['datetime-preset'] = 'datetime';
                beginHourField.displayFormat = "DD/MM/YYYY hh:mm";
			}
			else{
                beginHourField.label = 'Data da apropriação';
                beginHourField.template = 'field/calendar.html';
				beginHourField['datetime-preset'] = 'date';
                beginHourField.displayFormat = "DD/MM/YYYY";
			}
			appropriationWidget.getField('END_HOUR').isVisible = isTaskDated;
			ScreenService.openSwipe(appropriationWidget).then(function(){
                appropriationWidget.view();
            });
		}).catch(ScreenService.hideLoader);
	};

	this.onEditAppropriation = function(widget){
		widget.edit();
	};

    this.appropriationActionEventBack = function(args) {
        ScreenService.closeSwipe();
        getAppropriationsWidget().activate();
    };

    this.appropriationActionEventCancel = function(args) {
        var widget = getAppropriationWidget();
        Utilities.genericCancelEvent(widget).then(function(){
            if(widget.currentRow.__is_new){
                if(widget.currentRow.isFromCrossGrid){
                    getTimeControlWidget().activate();
                }else{
                    widget.view();
                    getAppropriationsWidget().activate();
                }
            } else {
                self.appropriationsWidgetAfterMoveRow();
            }
        });
    };

    this.appropriationActionEventEdit = function(args) {
        var widget = getAppropriationWidget();
        widget.edit();
    };

	this.goBackToAppropriationsOrNewTask = function(widget){
		var container = widget.container;
		var lastWidget;
		if(ScreenService.getSwipeLevel(widget)){
			lastWidget = container.getWidget('APPROPRIATIONS');
			container.getWidget('TABBED_APPROPRIATION').currentWidget = lastWidget;

		}else{
			lastWidget = getNewTaskWidget();
			ScreenService.closeSwipe(0);
			ScreenService.openPopup(lastWidget);
		}
        getAppropriationsWidget().activate();
		templateManager.updateTemplate();
	};

	this.appropriationActionEventDelete = function(args) {
        var widget = getAppropriationWidget();
		ScreenService.confirmMessage(Messages.ALE_DELETE_APROPRIATION, null, function() {
			var appropriationsWidget = templateManager.container.getWidget('APPROPRIATIONS');
			widget.dataSource.remove([widget.currentRow]).then(function() {
				ScreenService.closeSwipe().then(function() {
                    appropriationsWidget.activate();
                    appropriationsWidget.reload();
                    getTimeControlWidget().reload();
                });
			});
        }, null);

	};

    this.timeControlContainerAfterInit = function(args){
        getTimeControlWidget().activate();
        localStorageEngine.setLocalVar('maxDate', null);
    };

	var onLoadAppropriations = function(){
		var timeControlWidget = templateManager.container.getWidget('TIME_CONTROL');
		var currentDay;
		var currentHeadIndex = 0;
		var currentWidget = templateManager.container.getWidget('APPROPRIATIONS');
		currentDay = timeControlWidget.currentRow.DAY;
		if(currentDay){
			currentWidget.dataSource.data.forEach(function(appropriation, index, appropriations){
				if(appropriation.BEGIN_HOUR && appropriation.END_HOUR) {
					if (appropriation.BEGIN_HOUR.search(currentDay) >= 0 || appropriation.END_HOUR.search(currentDay) >= 0) {
						if (index >= currentHeadIndex + 1) {
							Utilities.arraySwap(appropriations, index, currentHeadIndex);
						}
						appropriations[currentHeadIndex].important = true;
						currentHeadIndex++;
						currentWidget.dataSource.data = appropriations;
					}
				}
			});
		}
	};

    var setRangeFilterFields = function (timeControlWidget) {
        var today = moment();
        var dateIntervalField = getFieldDateIntervalFromRangeFilterWidget();
        maxDate = today.format('DD/MM/YYYY');
        minDate = today.subtract(6, 'days').format('DD/MM/YYYY');
        dateIntervalField.defaultValue = {start: minDate, end: maxDate, period: undefined};
        if (Validation.isEmpty(timeControlWidget.currentRow) || Validation.isEmpty(timeControlWidget.currentRow.MAX_DATE)) {
            dateIntervalField.applyDefaultValue();
        }
    };

	/**
	 * Called when user clicks on 'Filtrar', filtering
	 * appropriations.
	 * @param widget
	 */
	this.onUpdateRange = function(widget){
	    if(widget.DATE_INTERVAL){
	        widget.MIN_DATE = widget.DATE_INTERVAL.start;
            widget.MAX_DATE = widget.DATE_INTERVAL.end;
	    }
        var range = {
            'name' : "range",
            'operator' : "BETWEEN",
            'value' : [widget.MIN_DATE, widget.MAX_DATE, widget.SHOW_WEEKEND]
        };
		localStorageEngine.setLocalVar('range', range);
		onLoadAppropriations();
	};
	
	var getFilterToTimeControl = function(){
	    var filterByDashboard = Utilities.localVar.getFilterByDashboard();
	    if (filterByDashboard && filterByDashboard.hasOwnProperty('timeControl') && filterByDashboard.timeControl){
	        return filterByDashboard.timeControl;
	    } else {
	        return null;
	    }
	};

    this.timeControlGridFilterBeforeApply = function(args){
        var filterToTimeControl = getFilterToTimeControl();
        Utilities.setFilterInit(getTimeControlWidget());
        if(initFilter && !filterToTimeControl){
            self.onUpdateRange(getTimeControlWidget().currentRow);
        } else  if (filterToTimeControl) {
            self.onUpdateRange(getTimeControlWidget().currentRow);
            Utilities.localVar.setFilterByDashboard(null);
        } else {
            self.onUpdateRange(args.e.preference.FILTER_ROW);
        }
        initFilter = false;
        self.timeControlWidgetAfterLoadDataSource(args);
    };

	this.onCancelPopupOnMain = function(){
		var timeControlWidget = templateManager.container.getWidget('TIME_CONTROL');
		timeControlWidget.restoreDefaultMode();
		ScreenService.closePopup();
		timeControlWidget.activate();
	};

	this.afterLoadAppropriation = function(widget){
		widget.moveToFirst();
		var appropriationWidget = getAppropriationWidget();
		appropriationWidget.activate();
		appropriationWidget.edit();
	};
	
	/************************************************************
	 * Called by widget event
	 ************************************************************/
	this.timeControlWidgetAfterMoveRow = function(args) {
        var timeControlWidget = getTimeControlWidget();
        onClickTask(timeControlWidget);
        ScreenService.showLoader();
        getInfoTaskWidget().reload().then(function() {
            ScreenService.hideLoader();
            var descriptionOrderText = (timeControlWidget.currentRow.label) ? timeControlWidget.currentRow.label : timeControlWidget.currentRow.TASK_NAME;
            if(descriptionOrderText === 'Total apropriado' || descriptionOrderText === 'Diferença de Apropriação') {
                timeControlWidget.descriptionOrder = descriptionOrderTextWidgettimeControl;
            } else {
                descriptionOrderTextWidgettimeControl = descriptionOrderText;
                timeControlWidget.descriptionOrder = descriptionOrderText;
            }
        }).catch(ScreenService.hideLoader);
	};

	/************************************************************
	 * Called by widget event
	 ************************************************************/
	this.appropriationsWidgetOnEnterTab = function(args){
		saveInLocalStorageLastWidgetOpen(args.owner);
	};

	/************************************************************
	 * Called by widget event
	 ************************************************************/
	this.taskInfoWidgetAfterLoadDataSource = function(args){
		saveLocalStorageInformationWhenClickOnTask(args.owner);
	};

	/************************************************************
	 * Called by widget event
     * @param args
	 ************************************************************/
	this.newTaskWidgetAfterMoveRow = function(args){
		saveLocalStorageInformationWhenClickOnTask(args.owner);
		addAppropriationForNewTask(args.row);
	};

	/************************************************************
	 * Called by widget event
	 ************************************************************/
	this.newTaskWidgetOnEnter = function(args){
		saveInLocalStorageLastWidgetOpen(args.owner);
        getNewTaskWidget().reload();
	};

    /************************************************************
     * Called by widget event
     * @param args
     ************************************************************/
    this.timeControlWidgetAfterLoadDataSource = function(args){
        args.owner.dataSource.data.forEach(function(data){
            if(data.DAY === Utilities.getCurrentDateWithShortWeekday()){
                data.DAY_LABEL = data.DAY_LABEL + ' (*)';
            }
        });
        Utilities.windowResizeKanban();
    };



    /************************************************************
     * Called by widget event
     ************************************************************/
	this.appropriationsWidgetAfterLoadDataSource = function(args){
		AppropriationService.hideAppropriationColumnsByTimePlanning([getFieldEndHourFromAppropriationsWidget()]);
		AppropriationService.changeLabelAppropriationBeginHourColumnByTimePlanning(getFieldBeginHourFromAppropriationsWidget());
		AppropriationService.hideAppropriationColumnsByAllowEndTasks([getFieldPercentCompletedFromAppropriationsWidget()]);
		onLoadAppropriations();
	};

	/************************************************************
	 * Called by widget event
	 ************************************************************/
	this.appropriationWidgetOnEnter = function(args){
        onEnterAppropriation(args.owner);
        AppropriationService.manipulateBeginHourFieldByUseTimePlanning(getFieldBeginHourFromAppropriationWidget(), true);
        AppropriationService.manipulateEndHourFieldByUseTimePlanning(getFieldEndHourFromAppropriationWidget());
        AppropriationService.manipulatePercentFieldByAllowEndTask(getFieldPercentCompletedFromAppropriationWidget());
        AppropriationService.applyProjectAndTaskInfoInNewAppropriationWidget(getFieldProjectIdFromAppropriationWidget(), getFieldProjectNameFromAppropriationWidget(), getFieldTaskNameFromAppropriationWidget());
        AppropriationService.manipulateMobileTotalField(getFieldTotalFromAppropriationWidget());
	};

	/************************************************************
	 * Saves into Local Storage the last widget open, useful for
	 * make an .activate() method after save an appropriation.
	 ************************************************************/
	var saveInLocalStorageLastWidgetOpen = function(widget){
		localStorageEngine.setLocalVar('timeControlScreenLastWidgetOpen', widget.name);
	};

	/************************************************************
	 * Saves util informations into Local Storage when user clicks
	 * on a task.
	 * @param widget
	 ************************************************************/
	var saveLocalStorageInformationWhenClickOnTask = function(widget){
		Utilities.localVar.setClickedProjectAllowEndTasks(widget.currentRow.ALLOWENDTASK);
		Utilities.localVar.setClickedProjectUseTimePlanning(widget.currentRow.USE_TIME_PLANNING);
		Utilities.localVar.setClickedTaskName(widget.currentRow.ID + ' ' + widget.currentRow.TASK_NAME);
        Utilities.localVar.setClickedProjectName(widget.currentRow.PROJECT_NAME);
        Utilities.localVar.setClickedProjectId(widget.currentRow.PROJECT_ID);
	};

	/************************************************************
	 * Sets percent field visibility (hide/show) if clicked task
	 * can or can not be finished.
	 * @param: field
	 ************************************************************/
	var setPercentFieldVisibilityByEndTask = function(percentField){
		var allowEndTasks = localStorageEngine.getLocalVar('clickedProjectAllowEndTasks') || 'Y';
		if(allowEndTasks === ALLOWENDTASK_NEGATIVE){
			percentField.isVisible = false;
			percentField.value('0');
			return false;
		} else {
			percentField.isVisible = true;
			return true;
		}
	};


}


Configuration(function(ContextRegister) {
    ContextRegister.register('TimeControl', TimeControl);
});


// FILE: assets/js/Controller/UnreadComments.js
function UnreadCommentsController(ScreenService, Utilities, templateManager, UnreadCommentsService, ZhFilterPreferences, ZhPreferences) {

    var self = this;
    
    var getWidgetIssuesMyProducts = function(){
        return templateManager.container.getWidget('ISSUES_MY_PRODUCTS');
    };
    
    var getWidgetMyIssues = function(){
        return templateManager.container.getWidget('MY_ISSUES');
    };
    
    this.commentsUnreadAfterinit = function(args){
        Utilities.localVar.setLastWidget(null);
    };
    
    this.myIssuesWidgetOnEnterTab = function(args){
        var widgetMyIssues = getWidgetMyIssues();
        var widgetIssuesMyProducts = getWidgetIssuesMyProducts();
        var lastWidget = Utilities.localVar.getLastWidget() ? Utilities.localVar.getLastWidget() : null;
        ZhPreferences.getDefaultWidgetPreferences(widgetMyIssues.id).then(function(result){
            if(result) {
                if(!lastWidget){
                    widgetMyIssues.reload().then(function(){
                        if (widgetMyIssues.dataSource.data.length === 0){
                            widgetIssuesMyProducts.reload().then(function(){
                                if (widgetIssuesMyProducts.dataSource.data.length > 0){
                                    widgetIssuesMyProducts.activate();
                                }
                            });
                        }
                    });
                } else {
                    widgetMyIssues.reload(); 
                }
            }
        });
        Utilities.localVar.setLastWidget('myIssues');
    };
    
    this.issuesMyProductsWidgetOnEnterTab = function(args){
        var widget = getWidgetIssuesMyProducts();
         ZhPreferences.getDefaultWidgetPreferences(widget.id).then(function(result){
            if(result) {
                widget.reload();
            }
        });
        Utilities.localVar.setLastWidget('issuesMyProducts');
    };
    
    this.issuesMyProductsWidgetAfterMoveRow = function (args) {
        var issue = getWidgetIssuesMyProducts().currentRow;
        Utilities.localVar.setIssue(issue.ISSUE_ID);
        Utilities.localVar.setLastWindow('unreadComments');
        Utilities.localVar.setBoardId([issue.PROJECT_ID]);
        Utilities.localVar.setBoardName(issue.PROJECT_NAME);
        ScreenService.openWindow('product#boardIssues');
    };
    
    this.issueMyProductsActionEventBack = function (args) {
        ScreenService.goBack();
    };
    
    this.myIssuesActionEventBack = function (args) {
        ScreenService.goBack();
    };
    
    this.myIssuesWidgetAfterMoveRow = function(args){
        var issue = getWidgetMyIssues().currentRow;
        Utilities.localVar.setIssue(issue.ISSUE_ID);
        Utilities.localVar.setLastWindow('unreadComments');
        ScreenService.openWindow('product#issues');
    };
    
    this.issueMyProductsActionEventMarkAsRead = function(args){
        markSelectedIssuesAsRead(getWidgetIssuesMyProducts());
    };
    
    this.myIssuesActionEventMarkAsRead = function(args){
        markSelectedIssuesAsRead(getWidgetMyIssues());
    };
    
    var markSelectedIssuesAsRead = function(widget){
        if(!widget.hasCheckedRows()) {
            return ScreenService.showMessage(Utilities.messages.NOT_CHECKED_ROW_ISSUE);
        }
        var totalIssuesMarked = widget.dataSource.checkedRows.length;
        ScreenService.confirmMessage(Utilities.messages.ALE_CONFIRM_MARK_AS_READ.replace('{{totalIssuesMarked}}', totalIssuesMarked), 'CONFIRMATION', function(){
            var selectedIssues = widget.dataSource.checkedRows;
            ScreenService.showLoader();
            UnreadCommentsService.markManyAsRead(selectedIssues).then(function() {
                widget.reload().then(function() {
                    ScreenService.hideLoader();
                    widget.activate();
                    ScreenService.closePopup(true);
                    widget.dataSource.updateCheckedRows();
                }).catch(ScreenService.hideLoader);
            }).catch(ScreenService.hideLoader);
        });
    };
}

Configuration(function(ContextRegister) {
	ContextRegister.register('UnreadCommentsController', UnreadCommentsController);
});

// FILE: assets/js/Controller/UserData.js
function UserDataController(ScreenService, requestDataSourceEngine, Utilities, UserDataService, localStorageEngine,
                            Validation, Messages, templateManager, ZHPromise, GitQueue) {

    var self = this;

    var getContainer = function(){
        return templateManager.container;
    };

    var getFieldProjectLocalConnectionPopupWidget = function(){
        return getLocalConnectionPopupWidget().getField('PROJECT');
    };

    var getFieldRepositoryLocalConnectionPopupWidget = function(){
        return getLocalConnectionPopupWidget().getField('REPOSITORY');
    };

    var getFieldPathLocalConnectionPopupWidget = function(){
        return getLocalConnectionPopupWidget().getField('PATH');
    };

    var getFieldLinuxDirectoryLocalConnectionPopupWidget = function(){
        return getLocalConnectionPopupWidget().getField('LINUX_DIRECTORY');
    };

    var getDirectoriesWidget = function(){
        return templateManager.container.getWidget('DIRECTORIES');
    };

    var getTabbedLocalConnectionWidget = function(){
        return templateManager.container.getWidget('TABBED_LOCAL_CONNECTION');
    };

    var getLocalConnectionWidget = function(){
        return templateManager.container.getWidget('LOCAL_CONNECTION');
    };

    var getLocalConnectionPopupWidget = function(){
        return templateManager.container.getWidget('LOCAL_CONNECTION_POPUP');
    };
    
    var getLocalConnectionPopupTabbedWidget = function(){
        return templateManager.container.getWidget('LOCAL_CONNECTION_POPUP_TABBED');
    };

    var getCopyPopupWidget = function(){
        return templateManager.container.getWidget('COPY_POPUP');
    };

    var getWidgetBasicInfo = function(){
        return getContainer().getWidget('basic_info');
    };

    var getFieldPhotoViewFromBasicInfoWidget = function(){
        getWidgetBasicInfo().getField('PHOTO_VIEW');
    };
    
    this.userDataContainerAfterinit = function() {
	if(localStorageEngine.getLocalVar('IS_IN_DEVOPS')){
		getLocalConnectionWidget().isVisible = false;
	}
};

    this.addLocalConnection = function(args){
        getFieldProjectLocalConnectionPopupWidget().readOnly = false;
        var widget = getLocalConnectionPopupWidget();
        widget.parent = getLocalConnectionWidget();
        ScreenService.openSwipe(widget);
        widget.newRow();
    };

    this.directoriesActionEventAdd = function(args){
        getFieldProjectLocalConnectionPopupWidget().readOnly = true;
        var widget = getLocalConnectionPopupWidget();
        var repositoryField =  getFieldRepositoryLocalConnectionPopupWidget();
        widget.parent = getDirectoriesWidget();
        repositoryField.reload().then(function() {
            setDataSourceFilterForRepositoriesField(widget.parent, repositoryField, true);
            ScreenService.openSwipe(widget);
            widget.newRow();
            Utilities.setOutData(getFieldProjectLocalConnectionPopupWidget(), Utilities.localVar.getLocalConnectionProject());
            getFieldRepositoryLocalConnectionPopupWidget().reload();
        });
    };

    this.directoriesWidgetAfterMoveRow = function(args, open) {
        var editPopupWidget = getLocalConnectionPopupWidget();
        var directoriesWidget = getDirectoriesWidget();
        var repositoryField =  getFieldRepositoryLocalConnectionPopupWidget();
        getFieldProjectLocalConnectionPopupWidget().readOnly = true;
        editPopupWidget.parent = directoriesWidget;
        if(!open) {
            ScreenService.openSwipe(getLocalConnectionPopupTabbedWidget());
        }
        Utilities.setOutData(getFieldProjectLocalConnectionPopupWidget(), Utilities.localVar.getLocalConnectionProject());
        setDataSourceFilterForRepositoriesField(directoriesWidget, repositoryField, false);
        repositoryField.reload().then(function() {
            Utilities.setOutData(repositoryField, directoriesWidget.currentRow.REPOSITORY_ID);
            getFieldPathLocalConnectionPopupWidget().value(directoriesWidget.currentRow.LOCAL_DIRECTORY);
            getFieldLinuxDirectoryLocalConnectionPopupWidget().value(directoriesWidget.currentRow.LINUX_DIRECTORY);
            editPopupWidget.currentRow.PATH_ID = directoriesWidget.currentRow.ID;
            editPopupWidget.view();
            editPopupWidget.template = editPopupWidget.templateToView;
            editPopupWidget.reload();
        });
    };

    var setDataSourceFilterForRepositoriesField  = function(directoriesWidget, repositoryField, newDirectory){
        var alreadySavedIds = [];
        directoriesWidget.dataSource.data.forEach(function(directory){
            if(newDirectory || directory.REPOSITORY_ID != directoriesWidget.currentRow.REPOSITORY_ID){
                alreadySavedIds.push(directory.REPOSITORY_ID);
            }
        });
        Utilities.localVar.setRepositoriesId(alreadySavedIds);
    };

    this.directoriesActionEventBack = function(){
        ScreenService.closeSwipe();
        getLocalConnectionWidget().reload();
        getLocalConnectionWidget().activate();
    };


    this.copyPopupActionEventBack = function(){
        var directoriesWidget = getDirectoriesWidget();
        ScreenService.closePopup();
        directoriesWidget.activate();
        directoriesWidget.unSelectAll();
    };

    this.copyPopupActionEventCopy = function(){
        var copyPopUpWidget = getCopyPopupWidget();
        var failedProjectPaths;
        var successfulProjectPaths;
        var failedProjectPathsString = '';
        var successfulProjectPathsString = '';
        var row = [{
            selectedPaths: copyPopUpWidget.rowsToSave,
            projectReceiver: copyPopUpWidget.currentRow.PROJECT_ID,
            changed: true
        }];
        if(copyPopUpWidget.isValid()) {
            requestDataSourceEngine.setDataSource("PM#/verifyProjectPaths", row).then(function (response) {
                failedProjectPaths = response.dataset.verifyProjectPaths.failedProjectPaths;
                successfulProjectPaths = response.dataset.verifyProjectPaths.successfulProjectPaths;
                if (Utilities.isNotEmptyArray(successfulProjectPaths)) {
                    successfulProjectPathsString = Utilities.createPathsForMessage(successfulProjectPaths, successfulProjectPathsString);
                    if (Utilities.isNotEmptyArray(failedProjectPaths)) {
                        failedProjectPathsString = Utilities.createPathsForMessage(failedProjectPaths, failedProjectPathsString);
                        ScreenService.confirmMessage(Utilities.messages.ALE_COPY_REPOSITORY_HEAD + failedProjectPathsString +
                            Utilities.messages.ALE_COPY_REPOSITORY_TAIL, 'question', function () {
                                copyProjectsPathsConfirmMessage(row, successfulProjectPathsString);
                        });
                    } else {
                        copyProjectsPathsConfirmMessage(row, successfulProjectPathsString);
                    }
                } else {
                    ScreenService.showMessage(Utilities.messages.ALE_EMPTY_COPY_REPOSITORY);
                }
            });
        }
    };

    var copyProjectsPathsConfirmMessage = function(row, successfulProjectPathsString){
        ScreenService.confirmMessage(Utilities.messages.ALE_CONFIRM_COPY_REPOSITORY_HEAD + successfulProjectPathsString +
            Utilities.messages.ALE_CONFIRM_COPY_REPOSITORY_TAIL, 'question',
            function(){copyProjectPaths(row);});
    };

    var copyProjectPaths = function(row){
        var directoriesWidget = getDirectoriesWidget();
        ScreenService.closePopup();
        directoriesWidget.activate();
        directoriesWidget.unSelectAll();
        return requestDataSourceEngine.setDataSource("PM#/copyProjectPaths", row);

    };

    this.directoriesListActionEventCopy = function(args){
        var copyPopupWidget = getCopyPopupWidget();
        var directoriesWidget = getDirectoriesWidget();
        if(directoriesWidget.hasCheckedRows()) {
            copyPopupWidget.rowsToSave = directoriesWidget.getCheckedRows();
            ScreenService.openPopup(copyPopupWidget);
        }else{
            ScreenService.showMessage(Utilities.messages.NOT_CHECKED_ROW_LOCAL_CONNECTION);
        }
    };

    var validatePathAndSaveLocal = function(widget) {
        var defer = ZHPromise.defer();
        GitQueue.loginBrowser(Utilities.localVar.getLocalVarLogin()).then(function () {
            return GitQueue.validateExecuteInWindows();
        }).then(function (isWindows) {
            var path = isWindows ? widget.currentRow.PATH : widget.currentRow.LINUX_DIRECTORY;
            if(!path){
                var message = '';
                if(isWindows){
                    message = Utilities.messages.ERR_CLIENTE_WINDOWS;
                }else{
                    message = Utilities.messages.ERR_CLIENTE_NOT_WINDOWS;
                }
                ScreenService.hideLoader();
                defer.reject(message);
            }
            UserDataService.validateRepositoryPath(path, widget.currentRow.URL_REPOSITORY)
                .then(function (validation) {
                    if (validation.VALIDATION) {
                        UserDataService.saveLocalConnection(widget).then(function (response) {
                            ScreenService.closePopup();
                            Utilities.fixWidgetToViewAfterSaveRow(widget);
                            widget.parent.reload();
                            ScreenService.hideLoader();
                            defer.resolve();
                        });
                    } else {
                        var message = '';
                        if (typeof validation.URL != 'object') {
                            message = Messages.ERR_PATH_USED_BY_OTHER_REPOSITORY.replace('%1', path).replace('%2', validation.URL);
                        } else if (validation.URL.data.indexOf('Not a git repository') != -1) {
                            message = Messages.ERR_PATH_USED_NOT_GIT_REPOSITORY.replace('%1', path);
                        }
                        
                        ScreenService.hideLoader();
                        defer.reject(message);
                    }
                }).catch(function (error) {
                    ScreenService.hideLoader();
                    if (!error.hasOwnProperty('connectionError')) {
                        var message = Messages.UNEXPECTED_ERROR;
                        if (error.data.indexOf('Could not read from remote repository') != -1) {
                            message = Messages.ERR_REMOTE_REPOSITORY_NOT_EXISTS.replace('%1', widget.currentRow.URL_REPOSITORY)
                                .replace('%2', widget.currentRow.REPOSITORY);
                        }
                        defer.reject(message);
                    }
                });
        }).catch(function(){
            ScreenService.hideLoader();
            ScreenService.restoreDefaultLoadingMessage();
            defer.reject(Utilities.messages.ERR_WEBSOCKET);
        });
        return defer.promise;
    };

    /*	Called when user changes project. */
    this.projectFieldOnChange = function(args){
        var project = getLocalConnectionPopupWidget().currentRow.PROJECT_ID;
        Utilities.localVar.setLocalConnectionProject(project);
        getLocalConnectionPopupWidget().getField('REPOSITORY').reload();
     };

    this.localConnectionPopupActionEventSave = function(args){
        var widget = getLocalConnectionPopupWidget();
        var windowsDirectory = widget.currentRow.PATH;

        var saveLocalConnection = function(){
            ScreenService.showLoader();
            if(!widget.currentRow.PATH_ID) {
                UserDataService.validateProjectInitializedTasks(widget.currentRow.PROJECT_ID)
                    .then(function (initializedTasks) {
                        if (!initializedTasks) {
                            return validatePathAndSaveLocal(widget);
                        } else {
                            ScreenService.showMessage(Messages.ALE_PROJECT_TASK_INITIALIZED.replace('%1', initializedTasks));
                            ScreenService.hideLoader();
                        }
                    }).catch(function (error) {
                        ScreenService.hideLoader();
                        ScreenService.showMessage(error);
                    });
            } else {
                validatePathAndSaveLocal(widget);
            }
        };

        if(widget.isValid()){
            if(!!windowsDirectory && windowsDirectory.search("/") > -1 ) {
                ScreenService.confirmMessage(Messages.ALE_WINDOWS_DIRECTORY_BAD_SLASH, 'question', function(){
                    widget.currentRow.PATH = windowsDirectory.replace(/\//g, "\\");
                    saveLocalConnection();
                });
            }else{
                saveLocalConnection();
            }

        } else {
            ScreenService.hideLoader();
            ScreenService.showMessage(Messages.ERR_REQUIRED_FIELDS);
        }
    };

    this.editLocalConnection = function(widget){
        UserDataService.onChangeProject();
    };

    this.localConnectionPopupActionEventDelete = function(args){
        ScreenService.confirmMessage(Utilities.messages.ALE_DELETE_LOCALCONNECTION, 'question', function(){
            UserDataService.validateProjectInitializedTasks(getLocalConnectionPopupWidget().currentRow.PROJECT_ID)
                .then(function (initializedTasks) {
                    if (!initializedTasks) {
                        deleteDirectorie();
                    } else {
                        ScreenService.showMessage(Messages.ALE_PROJECT_TASK_INITIALIZED.replace('%1', initializedTasks));
                        ScreenService.hideLoader();
                    }
                }).catch(function (error) {
                    ScreenService.hideLoader();
                    ScreenService.showMessage(error);
                });
           
        });
    };

    var deleteDirectorie = function(){
        var widget = getLocalConnectionPopupWidget();
        var directoriesWidget = getDirectoriesWidget();
        Utilities.genericDeleteEvent(widget).then(function(data){
            directoriesWidget.reload().then(function(){
                directoriesWidget.activate();
            });
        });
    };

    this.localConnectionPopupActionEventCancel = function(args){
        var localConnection = getLocalConnectionPopupWidget();
        if(localConnection.currentRow.__is_new) {
            self.backToDirectoryGrid(localConnection);
        }else{
            self.directoriesWidgetAfterMoveRow();
            Utilities.genericCancelEvent(localConnection);
            localConnection.template = localConnection.templateToView;
        }
    };

    this.localConnectionPopupActionEventEdit = function(args){
        var localConnection = getLocalConnectionPopupWidget();
        localConnection.edit();
        localConnection.currentRow.__is_new = false;
        localConnection.template = localConnection.templateToForm;
    };

    this.backToDirectoryGrid = function (widget) {
        ScreenService.closeSwipe();
        widget.parent.activate();
        widget.parent.reload();
    };

    this.onEnterTab = function(widget){
        widget.list();
    };

    this.localConnectionWidgetAfterMoveRow = function(args){
        var widget = getDirectoriesWidget();
        Utilities.localVar.setLocalConnectionProject(getLocalConnectionWidget().currentRow.ID);
        widget.reload();
        ScreenService.openSwipe(getTabbedLocalConnectionWidget());
        getTabbedLocalConnectionWidget().descriptionOrder = getLocalConnectionWidget().descriptionOrder;
    };

    this.directoriesWidgetOnEnter = function(args){
        var directoriesWidget = getDirectoriesWidget();
        directoriesWidget.activate();
        directoriesWidget.unSelectAll();
        directoriesWidget.reload();
    };

    this.onUploadPhoto = function(widget, photoUpload){
        setTimeout(function(){
            if(Validation.isEmpty(photoUpload)){
                self.onUploadPhoto(widget, photoUpload);
            }
            widget.currentRow.PHOTO_VIEW = photoUpload[0].b64File;
            templateManager.updateTemplate();
        }, 500);
    };

    this.localConnectionPopupWidgetOnEnter = function(args) {
        getFieldProjectLocalConnectionPopupWidget().reload();
        getLocalConnectionPopupWidget().activate();
    };

    this.basicInfoActionEventEdit = function(args){
        var basicInfoWidget = getWidgetBasicInfo();
        basicInfoWidget.edit();
        basicInfoWidget.getField("PHOTO_UPLOAD").isVisible = true;
    };

    this.basicInfoActionEventCancel = function(args){
        getWidgetBasicInfo().view();
        templateManager.updateTemplate();
        getWidgetBasicInfo().getField("PHOTO_UPLOAD").isVisible = false;
        getWidgetBasicInfo().reload();
    };

    this.basicInfoActionEventSave = function(args){
        saveUserProfile();
        getWidgetBasicInfo().getField("PHOTO_UPLOAD").isVisible = false;
    };

    var saveUserProfile = function(){
        var basicInfoWidget = getWidgetBasicInfo();
        var name = basicInfoWidget.currentRow.NAME;
        var email = basicInfoWidget.currentRow.EMAIL;
        var photoView = basicInfoWidget.currentRow.PHOTO_VIEW;
        var photoUpload = basicInfoWidget.currentRow.PHOTO_UPLOAD;
        var organizationName = localStorageEngine.getLocalVar('organizationName');
        var widgetPath = (localStorageEngine.setLocalVar('IS_IN_DEVOPS')) ? 'dc#userData' : 'userData';

        if( ! Validation.isValidName(name) || ! Validation.isValidMail(email)){
            ScreenService.showMessage('As informações inseridas não são válidas.');
            return false;
        }

        var identityData = UserDataService.buildIdentityData(basicInfoWidget);
        UserDataService.saveIdentityInformation(identityData).then(function(response){
            UserDataService.saveUserProfile(name, email, photoView, photoUpload).then(function(response){
                var profileImage = response.dataset.userData[0].PHOTO_VIEW;
                basicInfoWidget.view();
                basicInfoWidget.reload().then(function(){
                    ScreenService.buildUserData(name,
                        [organizationName], function() {
                        ScreenService.openWindow('dc#userData');
                    }, profileImage);
                });
            });
        });
    };

}
Configuration(function(ContextRegister) {
    ContextRegister.register('UserDataController', UserDataController);
});


// FILE: assets/js/Controller/ValoresOrcaCliController.js
function ValoresOrcaCliController(templateManager, Utilities){
    var getValoresOrcaCliController = function() {
        return templateManager.container.getWidget('valoresOrcaClieWidget');
    };
    
    this.valoresOrcaClieContainerAfterinit = function () {
        getValoresOrcaCliController().sourceUrl = Utilities.getUrlPmNext('valoresOrcaCli');
    };
}

Configuration(function(ContextRegister) {
	ContextRegister.register('ValoresOrcaCliController', ValoresOrcaCliController);
});

// FILE: assets/js/Controller/WorkItem.js
function WorkItemController(templateManager, Utilities){
    var getWorkItemWidget = function() {
        return templateManager.container.getWidget('workItemWidget');
    };
    
    this.workItemContainerAfterinit = function () {
        getWorkItemWidget().sourceUrl = Utilities.getUrlPmNext('item-de-trabalho');
    };
}

Configuration(function(ContextRegister) {
	ContextRegister.register('WorkItemController', WorkItemController);
});

// FILE: assets/js/Controller/accessProfileControl.js
function AccessProfileControlController(ScreenService, templateManager, requestDataSourceEngine, Utilities,AccessProfileControlService, localStorageEngine, Messages) {
    var getAccessProfileWidget = function() {
        return templateManager.container.getWidget('ACCESS_PROFILE_CONTROL');
    };

    this.accessProfileControlActionEventBack = function() {
        ScreenService.goBack();
    };

    this.accessProfileControlActionEventEdit = function() {
        getAccessProfileWidget().edit();
    };

    this.accessProfileControlActionEventCancel = function() {
        var widget = getAccessProfileWidget();
        reloadZiProfile().then(function(){
            Utilities.genericCancelEvent(widget, "LABEL");
        });
    };

    this.accessProfileControlActionEventSave = function() {
        var accessProWidget = getAccessProfileWidget();
        var row = accessProWidget.currentRow;

        requestDataSourceEngine.setDataSource('/saveAccessProfileControl', [row]).then(function() {
            accessProWidget.view();
            accessProWidget.activate();
            ScreenService.successNotification(Messages.SUC_ACCESS_PROFILE_CONTROL_SAVED);
        });
    };
    
    var reloadZiProfile = function() {
        ScreenService.showLoader();
        return requestDataSourceEngine.getDataSource('/accessProfile').then(function(identityProfiles) {
            localStorageEngine.setLocalVar('ZI_PROFILES', identityProfiles.dataset.profile);
            return requestDataSourceEngine.getDataSource('/findProfilesByOrganization').then(function(profiles) {
                ScreenService.hideLoader();
                getAccessProfileWidget().dataSource.data = AccessProfileControlService.getDataSourceData(profiles, identityProfiles);
            }).catch(ScreenService.hideLoader);
        }).catch(ScreenService.hideLoader);
    };

    this.accessProfileControlContainerAfterinit = function() {
        reloadZiProfile();
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('AccessProfileControlController', AccessProfileControlController);
});


// FILE: assets/js/Controller/issueConfiguration.js
function IssueConfigurationController(ScreenService, templateManager, Utilities, IssueConfigurationService) {
    var self = this;

    var getWidgetTabStatus = function(){
        return templateManager.container.getWidget('tabStatus');
    };

    var getWidgetTabAutomaticFraming = function(){
        return templateManager.container.getWidget('tabAutomaticFraming');
    };

    var getWidgetTabPriorities = function(){
        return templateManager.container.getWidget('tabPriorities');
    };
    var getWidgetTabCommentType = function(){
        return templateManager.container.getWidget('TAB_COMMENT_TYPE');
    };

    var getWidgetBudgetItems = function(){
        return templateManager.container.getWidget('BUDGET_ITEMS');
    };

    var getWidgetClassificationBudgetItems = function(){
        return templateManager.container.getWidget('CLASSIFICATION_BUDGET_ITEM');
    };


    var getWidgetBudgetItemFromAddItems = function(){
        return templateManager.container.getWidget('BUDGET_ITEM_FROM_ADD');
    };

    var getWidgetFraming = function(){
        return templateManager.container.getWidget('FRAMING');
    };

    var getWidgetTaskClassification = function(){
        return templateManager.container.getWidget('TASK_CLASSIFICATION');
    };

    var getWidgetClassification = function(){
        return templateManager.container.getWidget('CLASSIFICATION');
    };

    var getWidgetProjectType = function(){
        return templateManager.container.getWidget('PROJECT_TYPE');
    };

    var getWidgetAddTaskClassification = function(){
        return templateManager.container.getWidget('ADD_TASK_CLASSIFICATION');
    };

    var getWidgetAddProjectType = function(){
        return templateManager.container.getWidget('ADD_PROJECT_TYPE');
    };

    var getWidgetEntranceComment = function(){
        return templateManager.container.getWidget('ENTRANCE_COMMENT');
    };

    var getWidgetComment = function(){
        return templateManager.container.getWidget('COMMENT');
    };

    var getWidgetOutputComment = function(){
        return templateManager.container.getWidget('OUTPUT_COMMENT');
    };
    
    var getFieldTargetStatusNameFromOutputComment = function(){
        return getWidgetOutputComment().getField('TARGET_STATUS_NAME');
    };
    
    var getFieldAllowPlayTaskInFrameNameFromFraming = function(){
        return getWidgetFraming().getField('ALLOW_PLAY_TASK_IN_FRAME_NAME');
    };

    var getFieldTaskClassificationFromTabStatus = function(){
        return getWidgetTabStatus().getField('TASK_CLASSIFICATION');
    };

    var getFieldCommentTypeNameFromTabStatus = function(){
        return getWidgetEntranceComment().getField('COMMENT_TYPE_NAME');
    };

    var getFieldIssueClassificationFromTabStatus = function(){
        return getWidgetTabStatus().getField('ISSUE_CLASSIFICATION');
    };

    this.tabStatusWidgetAfterLoadDataSource = function (args) {
        var maxOrderToFrame = 1 + Math.max.apply(null,
            args.dataSource.map(function(data) {
                return data.ORDER_TO_FRAME;
            }));
        Utilities.localVar.setMaxOrderToFrame(maxOrderToFrame);

        var maxOrderToView = 1 + Math.max.apply(null,
            args.dataSource.map(function(data) {
                return data.ORDER_TO_VIEW;
            }));
        Utilities.localVar.setMaxOrderToView(maxOrderToView);
    };

    this.tabStatusWidgetAfterMoveRow = function (args) {
        var widget = getWidgetTabStatus();
        var issueStatusId = widget.currentRow.ID;
        Utilities.localVar.setIssueStatusId(issueStatusId);
        setEnabledWidget(widget,!widget.currentRow.__is_new);
    };

    this.framingWidgetOnEnterTab = function (args) {
        getWidgetFraming().reload();
        getWidgetTaskClassification().reload();
        getWidgetProjectType().reload();
    };

    this.budgetItemsWidgetOnEnterTab = function (args) {
        var widget = getWidgetBudgetItems();
        if(widget.mode == 'list'){
            Utilities.applyDefaultFilterOnEnter(widget, true);
            widget.PmNotFilter = false;
        }
    };
    
    this.budgetItemsFilterAfterApply = function(){
        Utilities.setFilterInit(getWidgetBudgetItems());
    };

    this.classificationWidgetOnEnterTab = function (args) {
        var widget = getWidgetClassification();
        if(widget.mode == 'list'){
            Utilities.applyDefaultFilterOnEnter(widget, true);
            widget.PmNotFilter = true;
        }
    };
    
    this.classificationFilterAfterApply = function(){
        Utilities.setFilterInit(getWidgetClassification());
    };

    this.budgetItemFromAddActionEventSave = function (args) {
        var widget = getWidgetBudgetItemFromAddItems();
        var dataSet = widget.getCheckedRows();
        var classificationId = Utilities.localVar.getIssueClassification();
        IssueConfigurationService.saveAddBudgetItemInClassification(dataSet,classificationId).then(function(){
            widget.dataSource.clearCheckedRows();
            getWidgetClassificationBudgetItems().reload();
            ScreenService.closePopup();
        });
    };

    this.budgetItemFromAddActionEventBack = function (args) {
        ScreenService.closePopup();

    };

    this.classificationBudgetItemActionEventBack = function (args) {
        ScreenService.closeSwipe();

    };

    this.classificationBudgetItemActionEventDelete = function (args) {
        ScreenService.confirmMessage(Utilities.messages.ALE_DELETE_CLAS_BUD_ITEM, "question", function() {
            Utilities.genericDeleteEvent(getWidgetClassificationBudgetItems()).catch(Utilities.showMessageBackEndTrue);
        });

    };

    this.classificationWidgetAfterMoveRow = function (args) {
        Utilities.localVar.setIssueClassification(getWidgetClassification().currentRow.ID);
    };

    this.framingWidgetAfterLoadDataSource = function (args) {
        var framingWidget = getWidgetFraming();
        framingWidget.moveToFirst();

        var allowPlayTaskInFrameField =  getFieldAllowPlayTaskInFrameNameFromFraming();
        Utilities.setValueInSelectField(allowPlayTaskInFrameField,Utilities.getValueInSelectField(allowPlayTaskInFrameField));

    };

    this.framingActionEventBack = function (args) {
        ScreenService.closeSwipe();
        if(getWidgetTaskClassification().mode == 'list'){
            goBackWidgetTabStatusNotFilter();
        }

    };

    var setReadOnlyIssueClassification = function(clearValues){
        var classifications = getFieldTaskClassificationFromTabStatus().value();
        var issueClassification = getFieldIssueClassificationFromTabStatus();
        if(classifications && classifications.length){
            issueClassification.readOnly = false;
        }else{
            issueClassification.readOnly = true;
            if(clearValues){
                issueClassification.value([]);
            }
        }
    };

    this.framingActionEventSave = function(){
        var framingWidget = getWidgetFraming();
        if(framingWidget.isValid()){
            framingWidget.currentRow.changed = true;
            framingWidget.saveRow();
        }
    };

    this.tabStatusActionEventAdd = function (args) {
        var widget = getWidgetTabStatus();
        setEnabledWidget(widget,false);
        widget.newRow();
        setReadOnlyIssueClassification();
        setReadOnlyTargetStatus();
        Utilities.windowResizeKanban(400);
    };

    this.tabAutomaticFramingActionEventAdd = function (args) {
        var widget = getWidgetTabAutomaticFraming();
        widget.newRow();
        Utilities.windowResizeKanban(400);
    };

    this.addTaskClassificationActionEventBack = function (args) {
        ScreenService.closePopup();
        getWidgetFraming().activate();
    };

    this.tabAutomaticFramingtatusActionEventBack = function (args) {
        ScreenService.closeSwipe();
        getWidgetTabAutomaticFraming().activate();
    };

    this.classificationBudgetItemWidgetOnEnterTab = function (args) {
        getWidgetClassificationBudgetItems().reload();
    };

    this.addTaskClassificationActionEventSave = function (args) {
        var addTaskClassificationWidget =getWidgetAddTaskClassification();
        var dataSet = getWidgetAddTaskClassification().getCheckedRows();
        var issueStatusId = Utilities.localVar.getIssueStatusId();
        IssueConfigurationService.saveAddTaskClassification(dataSet,issueStatusId).then(function(){
            addTaskClassificationWidget.dataSource.clearCheckedRows();
            getWidgetTaskClassification().reload();
            ScreenService.closePopup();
        });
    };

    this.addProjectTypeActionEventSave = function (args) {
        var addProjectTypeWidget = getWidgetAddProjectType();
        var dataSet = addProjectTypeWidget.getCheckedRows();
        var issueStatusId = Utilities.localVar.getIssueStatusId();
        IssueConfigurationService.saveAddProjectType(dataSet,issueStatusId).then(function(){
            addProjectTypeWidget.dataSource.clearCheckedRows();
            getWidgetProjectType().reload();
            ScreenService.closePopup();
        });
    };

    var validateAddTaskClassification = function(){
        return IssueConfigurationService.validateAddTaskClassification(Utilities.localVar.getIssueStatusId());
    };

    this.taskClassificationActionEventAdd = function (args) {
        validateAddTaskClassification().then(function(validate){
            if(validate){
                var widget = getWidgetAddTaskClassification();
                widget.reload();
                ScreenService.openPopup(widget);
            }else{
                ScreenService.showMessage(Utilities.messages.ERR_NOT_TASK_STATUS);
            }
        });

    };

    var validateAddProjectType = function(){
        return IssueConfigurationService.validateAddProjectType(Utilities.localVar.getIssueStatusId());
    };

    this.projectTypeActionEventAdd = function (args) {
        validateAddProjectType().then(function(validate){
            if(validate){
                var widget = getWidgetAddProjectType();
                widget.reload();
                ScreenService.openPopup(widget);
            }else{
                ScreenService.showMessage(Utilities.messages.ERR_NOT_TASK_STATUS_TYPE_PROJECT);
            }
        });

    };


    this.getFilterAddTaskClassification = function (args) {
        var filter = [0];
        if(templateManager.container){
            var widget = getWidgetTaskClassification();
            if(widget){
                filter = widget.dataSource.data.map(function(row){
                    return row.CLASSIFICATION_ID;
                });
            }
        }
        return filter;
    };



    this.getFilterAddProjectType = function (args) {
        var filter = [0];
        if(templateManager.container){
            var widget = getWidgetProjectType();
            if(widget){
                filter = widget.dataSource.data.map(function(row){
                    return row.PROJECT_TYPE_ID;
                });
            }
        }
        return filter;
    };

    this.framingActionEventDelete = function (args) {
        var taskClassificationWidget = getWidgetTaskClassification();
        ScreenService.confirmMessage(Utilities.messages.ALE_DELETE_CLASSIFICATION_ISSUE_STATUS, "question", function() {
            taskClassificationWidget.remove();
            ScreenService.closeSwipe();
        });
    };
    this.projectTypeActionEventDelete = function (args) {
        var projectTypeWidget = getWidgetProjectType();
        ScreenService.confirmMessage(Utilities.messages.ALE_DELETE_PROJECT_TYPE_ISSUE_STATUS, "question", function() {
            projectTypeWidget.remove();
            ScreenService.closeSwipe();
        });
    };

    this.entranceCommentActionEventEdit = function (args) {
        var entranceCommentWidget = getWidgetEntranceComment();
        var commentWidget =  getWidgetComment();
        commentWidget.edit();
        if(entranceCommentWidget.dataSource.data.length){
            entranceCommentWidget.edit();
        }else{
            entranceCommentWidget.newRow();
        }
        entranceCommentWidget.template = entranceCommentWidget.templateToForm;
    };

    this.entranceCommentActionEventSave = function (args) {
        getWidgetEntranceComment().saveRow().then(function(){
            self.commentWidgetOnEnterTab();
        });
    };

    this.entranceWidgetAfterLoadDataSource = function (args) {
        var entranceCommentWidget = getWidgetEntranceComment();
        if(entranceCommentWidget.dataSource.data.length){
            entranceCommentWidget.moveToFirst();
        }else{
            entranceCommentWidget.currentRow = {};
        }
        self.tabStatusOnChangeTaskCommentTypeName();
    };
    var goBackWidgetTabStatusNotFilter = function(){
        var widget = getWidgetTabStatus();
        widget.PmNotFilter = true;
        widget.activate();
    };

    this.entranceCommentActionEventBackList = function (args) {

        ScreenService.closeSwipe();
        goBackWidgetTabStatusNotFilter();
    };

    this.outputCommentActionEventBackList = function (args) {
        ScreenService.closeSwipe();
        goBackWidgetTabStatusNotFilter();
    };

    this.entranceCommentActionEventBackEdit = function (args) {
        this.commentWidgetOnEnterTab();
    };

    this.outputCommentActionEventAdd = function (args) {
        getWidgetOutputComment().newRow();
        getFieldTargetStatusNameFromOutputComment().reload();
    };

    this.outputCommentActionEventEdit = function (args) {
        getWidgetOutputComment().edit();
        getFieldTargetStatusNameFromOutputComment().reload();
    };

    this.outputActionEventDelete = function (args) {
        Utilities.deleteRowViewMasterDetail(getWidgetOutputComment());
    };

    this.outputActionEventCancel = function (args) {
        Utilities.cancelEditMasterDetail(getWidgetOutputComment());
    };

    this.outputCommentWidgetOnEnterTab = function (args) {
        getWidgetOutputComment().reload();
    };

    this.outputActionEventSave = function (args) {
        var widget = getWidgetOutputComment();
        if (widget.isValid()) {
            widget.saveRow().then(function(response){
                widget.currentRow.ID = response.dataset[widget.dataSource.name.split('/')[1]].ID;
                ScreenService.showLoader();
                widget.reload().then(function () {
                    ScreenService.hideLoader();
                    widget.view();
                    widget.activate();
                    widget.currentRow.__is_new = false;
                    widget.currentRow.changed = false;
                    widget.setCurrentRow(widget.currentRow);
                 }).catch(ScreenService.hideLoader);
            });
        } else {
            ScreenService.showMessage(Utilities.messages.ERR_REQUIRED_FIELDS);
        }
    };

    this.outputActionEventBack = function (args) {
        ScreenService.closeSwipe();
        goBackWidgetTabStatusNotFilter();
    };

    this.outputActionEventBacklist = function (args) {
        ScreenService.closeSwipe();
        goBackWidgetTabStatusNotFilter();
    };

    this.tabStatusOnChangeTaskCommentTypeName = function () {
        var widget = getWidgetEntranceComment();
        var notCommentType = !widget.currentRow.COMMENT_TYPE;
        widget.fields.filter(function (field) {
            return field.commentTypeValidation || field.commentTypeReadOnly;
        }).forEach(function (field) {
            field.readOnly = notCommentType;
                if (notCommentType) {
                    field.validations = null;
                    field.value(null);
                } else if(!field.commentTypeReadOnly) {
                    field.validations = { "required": {} };
                }

        });
    };

    this.commentWidgetOnEnterTab = function () {
        var entranceCommentWidget = getWidgetEntranceComment();
        var commentWidget =  getWidgetComment();
        entranceCommentWidget.template = entranceCommentWidget.templateToView;
        entranceCommentWidget.list();
        commentWidget.list();
        entranceCommentWidget.reload();
    };

    this.tabStatusOnChangeDayNumbers = function (args) {
        setReadOnlyTargetStatus(true);
    };

    var setEnabledWidget = function(widget,enable){
        widget.widgets.forEach(function(field){
            field.enabled = enable;
        });

    };

    this.tabStatusActionEventEdit = function (args) {
        var widget = getWidgetTabStatus();
        setEnabledWidget(widget,false);
        widget.edit();
        setReadOnlyIssueClassification();
        setReadOnlyTargetStatus();

    };

    this.tabAutomaticFramingActionEventEdit = function (args) {
        var widget = getWidgetTabAutomaticFraming();
        widget.edit();

    };

    this.automaticFramingActionEventSave = function(args){
        var widget = getWidgetTabAutomaticFraming();
        var widgetStatus = getWidgetTabStatus();
        widget.currentRow.TASK_TYPE_ID = widgetStatus.currentRow.ID;
        if(widget.isValid()){
            widget.saveRow().then(function(response){
                ScreenService.goBack();
                widget.reload();
                ScreenService.successNotification(Utilities.messages.SUC_BUDGET_ITEMS_SAVE);
            }).catch(Utilities.showMessageBackEndTrue);
        }
    };

    this.tabAutomaticFramingActionEventDelete = function (args) {
        var tabWidget = getWidgetTabAutomaticFraming();
        ScreenService.confirmMessage(Utilities.messages.ALE_DELETE_ISSUE_STATUS, "question", function() {
            tabWidget.remove().then(function(){
                ScreenService.closeSwipe();
            }).catch(Utilities.showMessageBackEndTrue);
        });
    };

    this.tabStatusOnChangeTaskClassification = function (args) {
        setReadOnlyIssueClassification(true);
    };

    this.tabStatusActionEventDelete = function (args) {
        var tabStatusWidget = getWidgetTabStatus();
        ScreenService.confirmMessage(Utilities.messages.ALE_DELETE_ISSUE_STATUS, "question", function() {
            tabStatusWidget.remove().then(function(){
                ScreenService.closeSwipe();
            }).catch(Utilities.showMessageBackEndTrue);
        });
    };

    this.tabCommentTypeActionEventDelete = function (args) {
        var tabCommentType = getWidgetTabCommentType();
        ScreenService.confirmMessage(Utilities.messages.ALE_DELETE_COMMENT_TYPE_ID, "question", function() {
            tabCommentType.removeRow().then(function(){
                ScreenService.closeSwipe();
            }).catch(function(response){
                Utilities.showMessageBackEndTrue(response);
            });
        });
    };

    this.tabPrioritiesActionEventDelete = function (args) {
        var tabPrioritiesWidget = getWidgetTabPriorities();
        ScreenService.confirmMessage(Utilities.messages.ALE_DELETE_ISSUE_STATUS, "question", function(){
            tabPrioritiesWidget.removeCheckedRows();
            tabPrioritiesWidget.unSelectAll();
            ScreenService.closeSwipe();
        } );
    };

    this.tabPrioritiesActionEventSave = function(args){
        var widget = getWidgetTabPriorities();
        if (widget.isValid()) {
            IssueConfigurationService.updateIssuePriorities(widget.currentRow).then(function(response){
                widget.currentRow.ID = response.dataset.issuePriorities.ID;
                ScreenService.showLoader();
                widget.reload().then(function(){
                    ScreenService.hideLoader();
                    widget.view();
                }).catch(ScreenService.hideLoader);
            });
        } else {
            ScreenService.showMessage(Utilities.messages.ERR_REQUIRED_FIELDS);
        }
    };

    this.tabStatusActionEventCancel = function (args) {
        var widget = getWidgetTabStatus();
        Utilities.genericCancelEvent(widget);
        setEnabledWidget(widget,true);
    };

    this.tabAutomaticFramingtatusActionEventCancel = function (args) {
        var widget = getWidgetTabAutomaticFraming();
        Utilities.genericCancelEvent(widget);
    };

    this.tabCommentTypeActionEventCancel = function (args) {
        Utilities.genericCancelEvent(getWidgetTabCommentType());
    };

    this.tabPrioritiesActionEventEdit = function(args){
        getWidgetTabPriorities().edit();
    };

    this.tabCommentTypeActionEventEdit = function(args){
        getWidgetTabCommentType().edit();
    };

    this.budgetItemsActionEventEdit = function(args){
        getWidgetBudgetItems().edit();
    };

    this.tabStatusWidgetOnEnterTab = function(args){
        var widget = getWidgetTabStatus();
        Utilities.applyDefaultFilterOnEnter(widget, true);
        widget.PmNotFilter = false;
    };

    this.tabAutomaticFramingWidgetOnEnterTab = function(args){
        var widget = getWidgetTabAutomaticFraming();
        Utilities.applyDefaultFilterOnEnter(widget, true);
        widget.PmNotFilter = false;
    };
    
    this.tabStatusFilterAfterApply = function(){
        Utilities.setFilterInit(getWidgetTabStatus());
    };

    this.tabAutomaticFramingFilterAfterApply = function(){
        Utilities.setFilterInit(getWidgetTabAutomaticFraming());
    };

    this.tabPrioritiesWidgetOnEnterTab = function(args){
        Utilities.applyDefaultFilterOnEnter(getWidgetTabPriorities(), true);
    };
    
    this.tabPrioritiesFilterAfterApply = function(){
        Utilities.setFilterInit(getWidgetTabPriorities());
    };

    this.tabCommentTypesWidgetOnEnterTab = function(args){
        Utilities.applyDefaultFilterOnEnter(getWidgetTabCommentType(), true);
    };
    
    this.tabCommentTypesFilterAfterApply = function(){
        Utilities.setFilterInit(getWidgetTabCommentType());
    };

    this.tabPrioritiesActionEventBack = function(args){
        ScreenService.goBack();
        getWidgetTabPriorities().list();
    };

    this.tabCommentTypesActionEventBack = function(args){
        ScreenService.goBack();
        getWidgetTabCommentType().list();
    };

    this.tabPrioritiesActionEventAdd = function(args){
        getWidgetTabPriorities().newRow();
    };

    this.tabCommentTypeActionEventAdd = function(args){
        getWidgetTabCommentType().newRow();
    };

    this.budgetItemsActionEventAdd = function(args){
        getWidgetBudgetItems().newRow();
    };

    this.budgetItemsActionEventSave = function(args){
        var widget = getWidgetBudgetItems();
        if(widget.isValid()){
            widget.saveRow().then(function(response){
                Utilities.genericEventAfterSaveMasterDetail(response,widget);
                ScreenService.successNotification(Utilities.messages.SUC_BUDGET_ITEMS_SAVE);
            }).catch(Utilities.showMessageBackEndTrue);
        }
    };

    this.budgetItemsActionEventCancel = function(args){
        Utilities.genericCancelEvent(getWidgetBudgetItems());
    };

    this.budgetItemsActionEventBack = function(args){
        ScreenService.closeSwipe();
    };

    this.classificationBudgetItemActionEventAdd = function(args){
        var widget = getWidgetBudgetItemFromAddItems();
        widget.reload().then(function(){
            ScreenService.openPopup(widget);
        });
    };

    this.budgetItemsActionEventDelete = function(args){

        var widget = getWidgetBudgetItems();

        var message = Utilities.messages.ALE_DELETE_BUDGET_ITEMS;
        var messageNotification = Utilities.messages.NOTIF_DELETE_BUDGET_ITEMS;
        if(widget.currentRow.NOT_DELETE){
            message = Utilities.messages.ALE_INATIVE_BUDGET_ITEMS;
            messageNotification = Utilities.messages.NOTIF_INATIVE_BUDGET_ITEMS;
        }
        ScreenService.confirmMessage(message, "question", function() {
            Utilities.genericDeleteEvent(widget).then(function(){
                ScreenService.successNotification(messageNotification);
            }).catch(Utilities.showMessageBackEndTrue);
        });
    };

    this.tabPrioritiesActionEventCancel = function (args) {
        Utilities.genericCancelEvent(getWidgetTabPriorities());
    };

    this.tabStatusActionEventSave = function(args) {
        var widget = getWidgetTabStatus();
        if(widget.isValid()){
            widget.saveRow().then(function (response) {
                widget.currentRow.ID = response.dataset.taskType.ID;
                ScreenService.showLoader();
                widget.reload().then(function() {
                    ScreenService.hideLoader();
                    widget.view();
                    setEnabledWidget(widget,true);
                }).catch(ScreenService.hideLoader);
            }).catch(function (response) {
                ScreenService.showMessage(response.data.error);
            });
        }
    };

    this.tabCommentTypesActionEventSave = function(args) {
        var widget = getWidgetTabCommentType();
        if(widget.isValid()){
            widget.saveRow().then(function (response) {
                widget.reload();
                widget.view();
            }).catch(function (response) {
                ScreenService.showMessage(response.data.error);
            });
        }
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('IssueConfigurationController', IssueConfigurationController);
});


// FILE: assets/js/Controller/meeting.js
function MeetingController(ScreenService, FilterService, Utilities, templateManager, MeetingService) {

    var self = this;
    this.listMeetingWidgetAfterMoveRow = function(args){
        
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register('MeetingController', MeetingController);
});


// FILE: assets/js/Controller/operationsLog.js
function OperationsLogController(templateManager, Utilities){
    var getOperationsLogWidget = function() {
        return templateManager.container.getWidget('operationsLogWidget');
    };
    
    this.operationsLogContainerAfterinit = function () {
        getOperationsLogWidget().sourceUrl = Utilities.getUrlPmNext('modules/acl/log-operacao-sistema');
    };
    
    var getControlOperationsLogWidget = function() {
        return templateManager.container.getWidget('controlOperationsLogWidget');
    };

    this.controlOperationsLogContainerAfterinit = function () {
        getControlOperationsLogWidget().sourceUrl = Utilities.getUrlPmNext('modules/acl/controle-log-sistema');
    };
}

Configuration(function(ContextRegister) {
	ContextRegister.register('OperationsLogController', OperationsLogController);
});

// FILE: assets/js/Controller/structureConfiguration.js
function StructureConfigurationController(templateManager, ScreenService, Utilities) {

    var getWidgetTypeList = function () {
        return templateManager.container.getWidget('TYPE_LIST');
    };

    this.typeListActionEventNewType = function(args){
        getWidgetTypeList().newRow();
    };

    this.typeListActionEventDeleteType = function(args){
        var typeList = getWidgetTypeList();
        ScreenService.confirmMessage(Utilities.messages.ALE_DELETE_STRUCUTRE_TYPE, 'question', function(){
            Utilities.genericDeleteEvent(typeList).then(function(){
                typeList.reload();
            });
        });
    };
    
    this.typeListWidgetOnEnterTab = function(args){
        var widget = getWidgetTypeList();
        Utilities.applyDefaultFilterOnEnter(getWidgetTypeList(), true);
        widget.activate();
    };
    
    this.typeListFilterAfterApply = function(){
        Utilities.setFilterInit(getWidgetTypeList());
    };

    this.typeListActionEventEditType = function(args){
        getWidgetTypeList().edit();
    };

    this.typeListActionEventCancel = function(args){
        Utilities.genericCancelEvent(getWidgetTypeList());
    };

    this.typeListActionEventCancelForm = function(args){
        ScreenService.goBack();
        getWidgetTypeList().list();
    };

    this.typeListActionEventSaveType = function(args){
        var widget = getWidgetTypeList();
        if(!widget.isValid()){
            ScreenService.showMessage(Utilities.messages.ERR_REQUIRED_FIELDS);
        } else {
            widget.saveRow().then(function(response){
                widget.currentRow.ID = response.dataset.structureType[0].ID;
                widget.currentRow.__is_new = false;
                widget.setCurrentRow(widget.currentRow);
                ScreenService.showLoader();
                widget.reload().then(function(){
                    ScreenService.hideLoader();
                    widget.view();
                    widget.activate();
                }).catch(ScreenService.hideLoader);
            });
        }
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('StructureConfigurationController', StructureConfigurationController);
});


// FILE: assets/js/Controller/taskConfiguration.js
function TaskConfigurationController(templateManager,TaskService, TaskConfigurationService, ScreenService,Utilities, Messages, localStorageEngine, ZhFilterPreferences) {

    /* Widgets */
    
    var getTabStatusWidget = function () {
        return templateManager.container.getWidget('tabStatus');
    };

    var getTabCategoriesWidget = function () {
        return templateManager.container.getWidget('tabCategories');
    };

    var getTabTypeWidget = function () {
        return templateManager.container.getWidget('tabType');
    };
    
    var getWidgetTabParameters = function(){
        return templateManager.container.getWidget('TAB_PARAMETERS');
    };
    
    var getWidgetTabErrorClassification = function(){
        return templateManager.container.getWidget('tabErrorClassification');  
    };
    
    var getWidgetTabReplanningReason = function() {
        return templateManager.container.getWidget('tabReplanningReason');
    };

    /* Fields */
    
    var getFieldAllowedProjectTypeFromTabCategoriesWidget = function(){
        return getTabCategoriesWidget().getField('ALLOWED_PROJECT_TYPE');
    };

    var getFieldNotAllowedProjectTypeFromTabCategoriesWidget = function(){
        return getTabCategoriesWidget().getField('NOT_ALLOWED_PROJECT_TYPE');
    };

    var getFieldAllowedProjectStatusFromTabCategoriesWidget = function(){
        return getTabCategoriesWidget().getField('ALLOWED_PROJECT_STATUS');
    };

    var getFieldEstimatedTimeProportionFromTabCategoriesWidget = function(){
        return getTabCategoriesWidget().getField('ESTIMATED_TIME_PROPORTION');
    };

    var getFieldNotAllowedProjectStatusFromTabCategoriesWidget = function(){
        return getTabCategoriesWidget().getField('NOT_ALLOWED_PROJECT_STATUS');
    };

    var getFieldDivideDurationFromTabCategoriesWidget = function(){
        return getTabCategoriesWidget().getField('DIVIDE_DURATION');
    };

    var getFieldNrPerfilacessoFromTabCategoriesWidget = function(){
        return getTabCategoriesWidget().getField('NRPERFILACESSO');
    };

    var getFieldTaskTypeFromTabStatusWidget = function () {
        return getTabStatusWidget().getField('TASK_TYPE');
    };

    var getFieldTimeBaseFromTabStatusWidget = function () {
        return getTabTypeWidget().getField('TIME_BASE');
    };

    this.tabStatusActionEventAdd = function(args){
        getTabStatusWidget().newRow();
    };

    this.tabCategoriesActionEventAdd = function(args){
        setVisibilityFromFieldTabCategories();
        getTabCategoriesWidget().newRow();
    };

    this.tabStatusActionEventEdit = function(args) {
        var widget =  getTabStatusWidget();
        widget.edit();
        getFieldTaskTypeFromTabStatusWidget().reload();
    };

    this.tabCategoriesActionEventCancel = function(args) {
        Utilities.genericCancelEvent(getTabCategoriesWidget());
    };

    this.tabCategoriesActionEventSave = function(args){
        var widget = getTabCategoriesWidget();
        if(!widget.isValid()){
            ScreenService.showMessage(Messages.ERR_REQUIRED_FIELDS);
        } else {
            widget.saveRow().then(function(response){
            	ScreenService.successNotification(Utilities.messages.SUC_CATEGORY_SAVE);
                var id = widget.currentRow.ID ? widget.currentRow.ID : response.dataset.classification.ID;
                widget.list();
                ScreenService.showLoader();
                widget.reload().then(function(){
                    ScreenService.hideLoader();
                    widget.view();
                    var newCurrentRow = Utilities.getRowInDataSource(widget.dataSource,'ID', id);
                    if(newCurrentRow){
                        widget.setCurrentRow(newCurrentRow);
                    }
                }).catch(ScreenService.hideLoader);
            });
        }
    };

    this.tabCategoriesActionEventEdit = function(args) {
        getTabCategoriesWidget().edit();
    };

    this.tabCategoriesActionEventDelete = function (args) {
        ScreenService.confirmMessage(Utilities.messages.ALE_DELETE_TASK_CATEGORY, 'question', function () {
            Utilities.genericDeleteEvent(getTabCategoriesWidget()).then(function () {
                ScreenService.successNotification(Utilities.messages.SUC_CATEGORY_DELETE);
            }).catch(function (response) {
                Utilities.showMessageErrorOfBackEnd(response,Utilities.messages.ERR_CONTAINER_TASK_CONFIGURATION);
            });
        });
    };

    this.tabCategoriesFieldOnChangeAllowedProjectType = function(args) {
        var widgetAllowed = getFieldAllowedProjectTypeFromTabCategoriesWidget();
        var widgetNotAllowed = getFieldNotAllowedProjectTypeFromTabCategoriesWidget();
        var allowedValue = widgetAllowed.value();
        if (allowedValue && allowedValue.length === 0) {
            widgetNotAllowed.value([]);
        } else {
            var dataSetIds = widgetNotAllowed.dataSource.data.map(function(row){
                return row.ID;
            });
            widgetNotAllowed.value(Utilities.removeArrayInOtherArray(widgetAllowed.value(), dataSetIds));
        }
    };

    this.tabCategoriesFieldOnChangeAllowedProjectStatus = function(args){
        var widgetAllowed = getFieldAllowedProjectStatusFromTabCategoriesWidget();
        var widgetNotAllowed = getFieldNotAllowedProjectStatusFromTabCategoriesWidget();
        var allowedValue = widgetAllowed.value();
        if(allowedValue && allowedValue.length === 0){
            widgetNotAllowed.value([]);
        }else{
            var dataSetIds = widgetNotAllowed.dataSource.data.map(function(row){
                return row.ID;
            });
            widgetNotAllowed.value(Utilities.removeArrayInOtherArray(widgetAllowed.value(),dataSetIds));
        }
    };

    this.tabCategoriesFieldOnChangeNotAllowedProjectStatus = function(args){
        var widgetAllowed = getFieldAllowedProjectStatusFromTabCategoriesWidget();
        var widgetNotAllowed = getFieldNotAllowedProjectStatusFromTabCategoriesWidget();
        var notAllowedValue = widgetNotAllowed.value();
        if(notAllowedValue && notAllowedValue.length === 0){
            widgetAllowed.value([]);
        }else {
            var dataSetIds = widgetAllowed.dataSource.data.map(function(row){
                return row.ID;
            });
            widgetAllowed.value(Utilities.removeArrayInOtherArray(widgetNotAllowed.value(), dataSetIds));
        }
    };

    this.tabCategoriesFieldOnChangeNotAllowedProjectType = function(args){
        var widgetAllowed = getFieldAllowedProjectTypeFromTabCategoriesWidget();
        var widgetNotAllowed = getFieldNotAllowedProjectTypeFromTabCategoriesWidget();
        var notAllowedValue = widgetNotAllowed.value();
        if(notAllowedValue && notAllowedValue.length === 0){
            widgetAllowed.value([]);
        }else {
            var dataSetIds = widgetAllowed.dataSource.data.map(function(row){
                return row.ID;
            });
            widgetAllowed.value(Utilities.removeArrayInOtherArray(widgetNotAllowed.value(), dataSetIds));
        }
    };


    this.tabStatusActionEventDelete = function (args) {
        ScreenService.confirmMessage(Utilities.messages.ALE_DELETE_TASK_STATUS, 'question', function () {
            Utilities.genericDeleteEvent(getTabStatusWidget());
        });
    };

    this.tabStatusActionEventCancel = function(args) {
        Utilities.genericCancelEvent(getTabStatusWidget());
    };

    this.tabStatusActionEventBack = function(args) {
        ScreenService.goBack();
        getTabStatusWidget().list();
    };

    this.tabCategoriesActionEventBack = function(args) {
        ScreenService.goBack();
        getTabCategoriesWidget().list();
    };

    this.tabCategoriesWidgetAfterMoveRow = function(args) {
        setVisibilityFromFieldTabCategories();
    };
    
    this.tabCategoriesWidgetOnEnterTab = function(args){
        Utilities.applyDefaultFilterOnEnter(getTabCategoriesWidget(), true);
        var divideDurationField = getFieldDivideDurationFromTabCategoriesWidget();
        Utilities.translateDataSource(divideDurationField);
    };
    
    this.tabCategoriesFilterAfterApply = function(){
        Utilities.setFilterInit(getTabCategoriesWidget());
    };

    this.tabCategoriesControlFieldOnChange = function(args){
        setVisibilityFromFieldTabCategories();
    };

    var setVisibilityFromFieldTabCategories = function(){
        var currentRow = getTabCategoriesWidget().currentRow;
        var controlIsNull = !currentRow.CONTROL;
        getFieldEstimatedTimeProportionFromTabCategoriesWidget().readOnly = controlIsNull;
        if(controlIsNull){
            getFieldEstimatedTimeProportionFromTabCategoriesWidget().value(null);
        }
        if(currentRow.CONTROL === 'T'){
            getFieldNrPerfilacessoFromTabCategoriesWidget().readOnly = false;
        } else {
            getFieldNrPerfilacessoFromTabCategoriesWidget().readOnly = true;
        }
    };
    
    this.tabTypeWidgetOnEnterTab = function(){
        Utilities.applyDefaultFilterOnEnter(getTabTypeWidget(), true);
    };
    
    this.tabTypeFilterAfterApply = function(){
        Utilities.setFilterInit(getTabTypeWidget());
    };

    this.tabTypeActionEventBack = function(args) {
        ScreenService.closeSwipe();
    };
    
    this.tabStatusWidgetOnEnterTab = function(args){
    	Utilities.applyDefaultFilterOnEnter(getTabStatusWidget(), true);	
    };
    
    this.tabStatusFilterAfterApply = function(){
        Utilities.setFilterInit(getTabStatusWidget());
    };

    this.tabStatusActionEventSave = function(args) {
        var widget =  getTabStatusWidget();
        if(!widget.isValid()) {
            ScreenService.showMessage(Messages.ERR_REQUIRED_FIELDS);
        } else {
            var control = widget.getField('CONTROL').value();
            var oldControl = widget.currentRow.OLD_CONTROL;
            var id = widget.getField('ID').value();
            if(oldControl && control != oldControl){
                ScreenService.confirmMessage(Utilities.messages.ALE_CHANGE_CONTROL_TASK_STATUS +' '+ Utilities.messages.ALE_CONTINUE,
                    null,
                    function() {
                        saveTaskStatus(widget,control,id);
                    }, 
                    null
                );
            } else {
                saveTaskStatus(widget,control,id);
            }
        }
    };
    
    this.tabParametersActionEventBack = function(args){
        ScreenService.goBack();
        getWidgetTabParameters().list();
    };
    
    this.tabParametersActionEventAdd = function(args){
        args.owner.widget.newRow();
    };
    
    this.tabParametersActionEventEdit = function(args){
        getWidgetTabParameters().edit();
    };

    var saveTaskStatus = function(widget,control,id){
        ScreenService.showLoader();
        TaskService.findTaskStatusByControl(control, id).then(function(valid) {
            if(valid){
                widget.saveRow().then(function(response){
                    var id = widget.currentRow.ID ? widget.currentRow.ID : response.dataset.taskstatus.ID;
                    widget.reload().then(function(){
                        ScreenService.hideLoader();
                        widget.view();
                        var newCurrentRow = Utilities.getRowInDataSource(widget.dataSource,'ID', id);
                        if(newCurrentRow){
                            widget.setCurrentRow(newCurrentRow);
                        }
                    }).catch(ScreenService.hideLoader);
                });
            } else {
                ScreenService.hideLoader();
            }
        }).catch(ScreenService.hideLoader);
    };
    
    this.tabParametersActionEventSave = function(widget){
        if(widget.isValid()){
            var infoToLocalStorage = {};
            infoToLocalStorage.PROPERTY_ID              = parseInt(widget.currentRow.PROPERTY_ID);
            infoToLocalStorage.INITIAL_TASK_STATUS_NAME = widget.currentRow.INITIAL_TASK_STATUS_NAME;
            infoToLocalStorage.INITIAL_TASK_STATUS_ID   = parseInt(widget.currentRow.INITIAL_TASK_STATUS_ID);
            infoToLocalStorage.FINAL_TASK_STATUS_NAME   = widget.currentRow.FINAL_TASK_STATUS_NAME;
            infoToLocalStorage.FINAL_TASK_STATUS_ID     = parseInt(widget.currentRow.FINAL_TASK_STATUS_ID);
            localStorageEngine.setLocalVar('taskParameters', infoToLocalStorage);
            TaskConfigurationService.updateTaskOptionsParameters(widget).then(function(data){
                ScreenService.showLoader();
                widget.reload().then(function(){
                    ScreenService.hideLoader();
                    widget.view();
                }).catch(ScreenService.hideLoader);
            });
        }
    };

    this.tabTypeActionEventAdd = function(args){
        getTabTypeWidget().newRow();
    };

    this.tabTypeActionEventEdit = function(args){
        getTabTypeWidget().edit();
    };

    this.tabTypeActionEventDelete = function (args) {
        ScreenService.confirmMessage(Utilities.messages.ALE_DELETE_TASK_TYPE , 'question', function () {
            Utilities.genericDeleteEvent(getTabTypeWidget()).then(function () {
            	ScreenService.successNotification(Utilities.messages.SUC_TASK_FEATURE_DELETE);
            }).catch(function (response) {
                Utilities.showMessageBackEndTrue(response);
            });
        });
    };

    this.tabTypeActionEventCancel = function(args) {
        Utilities.genericCancelEvent(getTabTypeWidget());
    };

    this.tabTypeActionEventSave = function(args){
        var widget = getTabTypeWidget();
        if(!widget.isValid()){
            ScreenService.showMessage(Utilities.messages.ERR_REQUIRED_FIELDS);
        } else {
            Utilities.fixMasterDetailSaveBug(widget);
            widget.saveRow().then(function(response){
                ScreenService.successNotification(Utilities.messages.SUC_TASK_FEATURE_SAVE);
                widget.currentRow.ID = response.dataset.taskFeatures[0].ID;
                ScreenService.showLoader();
                widget.reload().then(function(){
                    ScreenService.hideLoader();
                    widget.currentRow.__is_new = false;
                    widget.view();
                    var newCurrentRow = Utilities.getRowInDataSource(widget.dataSource,'ID', widget.currentRow.ID);
                    if(newCurrentRow){
                        widget.setCurrentRow(newCurrentRow);
                    }
                }).catch(ScreenService.hideLoader);
            }).catch(function(response){
                Utilities.showMessageErrorOfBackEnd(response,Utilities.messages.ERR_CONTAINER_TASK_CONFIGURATION);
            });
        }
    };
    
    /* Widget Error Classification */
    
    this.tabErrorClassificationWidgetOnEnterTab = function(){
        var widget = getWidgetTabErrorClassification();
        widget.currentRow.STATUS_FILTER = 'A';
        ZhFilterPreferences.setOriginalFilter(widget.id, widget.currentRow);
        Utilities.applyDefaultFilterOnEnter(widget, true);
    };
    
    this.tabErrorClassificationFilterAfterApply = function(){
        Utilities.setFilterInit(getWidgetTabErrorClassification());
    };
    
    this.tabErrorClassificationActionEventAdd = function (args){
        getWidgetTabErrorClassification().newRow();
    };
    
    this.tabErrorClassificationActionEventEdit = function (args) {
        getWidgetTabErrorClassification().edit();
    };
    
    this.tabErrorClassificationActionEventDelete = function (args) {
        ScreenService.confirmMessage(Utilities.messages.ALE_DELETE_ERROR_CLASSIFICATION , 'question', function () {
            Utilities.genericDeleteEvent(getWidgetTabErrorClassification()).then(function () {
            	ScreenService.successNotification(Utilities.messages.SUC_ERRO_CLASSIFICATION_DELETE);
            }).catch(function (response) {
                Utilities.showMessageBackEndTrue(response);
            });
        });
    };
    
    this.tabErrorClassificationActionEventCancel = function(){
        Utilities.genericCancelEvent(getWidgetTabErrorClassification());
    };
    
    this.tabErrorClassificationActionEventSave = function () {
        var widget = getWidgetTabErrorClassification();
        if(!widget.isValid()){
            ScreenService.showMessage(Utilities.messages.ERR_REQUIRED_FIELDS);
        } else {
            widget.saveRow().then(function(response){
            	ScreenService.successNotification(Utilities.messages.SUC_ERRO_CLASSIFICATION_SAVE);
                var id = widget.currentRow.ID ? widget.currentRow.ID : response.dataset.errorClassification[0].ID;
                widget.list();
                ScreenService.showLoader();
                widget.reload().then(function(){
                    ScreenService.hideLoader();
                    var rowInDataSource = Utilities.getRowInDataSource(widget.dataSource, 'ID', id);
                    if(rowInDataSource){
                        widget.view();
                        widget.setCurrentRow(rowInDataSource);
                    } else {
                        ScreenService.closeSwipe();
                        widget.list(true);
                    }
                }).catch(ScreenService.hideLoader);
            });
        }
    };
    
    this.tabErrorClassificationActionEventBack = function (){
        ScreenService.goBack();
        getWidgetTabErrorClassification().list();
    };
    
    /* Widget Replanning Reason */
    
    this.tabReplanningReasonWidgetOnEnterTab = function(){
        var widget = getWidgetTabReplanningReason();
        widget.currentRow.STATUS_FILTER = 'A';
        ZhFilterPreferences.setOriginalFilter(widget.id, widget.currentRow);
        Utilities.applyDefaultFilterOnEnter(widget, true);
    };
    
    this.tabReplanningReasonFilterAfterApply = function(){
        Utilities.setFilterInit(getWidgetTabReplanningReason());
    };
    
    this.tabReplanningReasonActionEventAdd = function (args){
        getWidgetTabReplanningReason().newRow();
    };
    
    this.tabReplanningReasonActionEventBack = function (){
        ScreenService.goBack();
        getWidgetTabReplanningReason().list();
    };
    
    this.tabReplanningReasonActionEventEdit = function (args) {
        getWidgetTabReplanningReason().edit();
    };
    
    this.tabReplanningReasonActionEventSave = function () {
        var widget = getWidgetTabReplanningReason();
        if(!widget.isValid()){
            ScreenService.showMessage(Utilities.messages.ERR_REQUIRED_FIELDS);
        } else {
            widget.saveRow().then(function(response){
            	ScreenService.successNotification(Utilities.messages.SUC_REPLANNING_REASON_SAVE);
                var id = widget.currentRow.ID ? widget.currentRow.ID : response.dataset.replanningReason[0].ID;
                widget.list();
                ScreenService.showLoader();
                widget.reload().then(function(){
                    ScreenService.hideLoader();
                    var rowInDataSource = Utilities.getRowInDataSource(widget.dataSource, 'ID', id);
                    if(rowInDataSource){
                        widget.view();
                        widget.setCurrentRow(rowInDataSource);
                    } else {
                        ScreenService.closeSwipe();
                        widget.list(true);
                    }
                }).catch(ScreenService.hideLoader);
            });
        }
    };
    
    this.tabReplanningReasonActionEventDelete = function (args) {
        ScreenService.confirmMessage(Utilities.messages.ALE_DELETE_ERROR_CLASSIFICATION , 'question', function () {
            Utilities.genericDeleteEvent(getWidgetTabReplanningReason()).then(function () {
            	ScreenService.successNotification(Utilities.messages.SUC_REPLANNING_REASON_DELETE);
            }).catch(function (response) {
                Utilities.showMessageBackEndTrue(response);
            });
        });
    };
    
    this.tabReplanningReasonActionEventCancel = function(){
        Utilities.genericCancelEvent(getWidgetTabReplanningReason());
    };
    
    
}

    
    
    
Configuration(function(ContextRegister) {
    ContextRegister.register('TaskConfigurationController', TaskConfigurationController);
});


// FILE: assets/js/Controller/taskTracking_next.js
function TaskTrackingNextController(templateManager, Utilities){
    var getTaskTrackingWidget = function() {
        return templateManager.container.getWidget('taskTrackingWidget');
    };
    
    this.taskTrackingContainerAfterinit = function () {
        getTaskTrackingWidget().sourceUrl = Utilities.getUrlPmNext('taskTracking');
    };
}

Configuration(function(ContextRegister) {
	ContextRegister.register('TaskTrackingNextController', TaskTrackingNextController);
});